/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","fs","os","vs/platform/product/common/productService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/extpath","vs/base/common/uuid","vs/platform/state/node/state","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/process","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/charCode","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/platform/window/common/window","vs/platform/window/electron-main/window","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/storage/common/storage","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminal","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/processes","vs/base/common/codicons","vs/base/common/severity","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/marshallingIds","crypto","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ports","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/native/electron-main/auth","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/uint","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/issue/electron-main/processMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","string_decoder","vs/base/common/jsonc","vs/code/electron-main/main"],ue=function(J){for(var e=[],n=0,r=J.length;n<r;n++)e[n]=le[J[n]];return e};define(le[138],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=n,e.$fb=r,e.$gb=P,e.$hb=R,e.$ib=T,e.$jb=I,e.$kb=w,e.$mb=g,e.$nb=h,e.$ob=m,e.$pb=b,e.$qb=f;function n(d,v){const p=r(d,v);if(p!==-1)return d[p]}function r(d,v,p=d.length-1){for(let $=p;$>=0;$--){const k=d[$];if(v(k))return $}return-1}function P(d,v){const p=R(d,v);return p===-1?void 0:d[p]}function R(d,v,p=0,$=d.length){let k=p,S=$;for(;k<S;){const t=Math.floor((k+S)/2);v(d[t])?k=t+1:S=t}return k-1}function T(d,v){const p=I(d,v);return p===d.length?void 0:d[p]}function I(d,v,p=0,$=d.length){let k=p,S=$;for(;k<S;){const t=Math.floor((k+S)/2);v(d[t])?S=t:k=t+1}return k}function w(d,v,p=0,$=d.length){const k=I(d,v,p,$);return k===d.length?-1:k}class c{static{this.assertInvariants=!1}constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(c.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!v($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const p=R(this.e,v,this.c);return this.c=p+1,p===-1?void 0:this.e[p]}}e.$lb=c;function g(d,v){if(d.length===0)return;let p=d[0];for(let $=1;$<d.length;$++){const k=d[$];v(k,p)>0&&(p=k)}return p}function h(d,v){if(d.length===0)return;let p=d[0];for(let $=1;$<d.length;$++){const k=d[$];v(k,p)>=0&&(p=k)}return p}function m(d,v){return g(d,(p,$)=>-v(p,$))}function b(d,v){if(d.length===0)return-1;let p=0;for(let $=1;$<d.length;$++){const k=d[$];v(k,d[p])>0&&(p=$)}return p}function f(d,v){for(const p of d){const $=v(p);if($!==void 0)return $}}}),define(le[39],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(le[139],ue([0,1]),function(J,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=r,e.$d=P,e.$e=R,e.$f=T;function r(w,c){const g=Object.create(null);for(const h of w){const m=c(h);let b=g[m];b||(b=g[m]=[]),b.push(h)}return g}function P(w,c){const g=[],h=[];for(const m of w)c.has(m)||g.push(m);for(const m of c)w.has(m)||h.push(m);return{removed:g,added:h}}function R(w,c){const g=[],h=[];for(const[m,b]of w)c.has(m)||g.push(b);for(const[m,b]of c)w.has(m)||h.push(b);return{removed:g,added:h}}function T(w,c){const g=new Set;for(const h of c)w.has(h)&&g.add(h);return g}class I{static{n=Symbol.toStringTag}constructor(c,g){this.b=g,this.a=new Map,this[n]="SetWithKey";for(const h of c)this.add(h)}get size(){return this.a.size}add(c){const g=this.b(c);return this.a.set(g,c),this}delete(c){return this.a.delete(this.b(c))}has(c){return this.a.has(this.b(c))}*entries(){for(const c of this.a.values())yield[c,c]}keys(){return this.values()}*values(){for(const c of this.a.values())yield c}clear(){this.a.clear()}forEach(c,g){this.a.forEach(h=>c.call(g,h,h,this))}[Symbol.iterator](){return this.values()}}e.$g=I}),define(le[140],ue([0,1,39]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lu=e.$ku=e.$ju=e.$iu=void 0;function r(w,c){const g=Math.pow(10,c);return Math.round(w*g)/g}class P{constructor(c,g,h,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=r(Math.max(Math.min(1,m),0),3)}static equals(c,g){return c.r===g.r&&c.g===g.g&&c.b===g.b&&c.a===g.a}}e.$iu=P;class R{constructor(c,g,h,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,g),0),3),this.l=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,m),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.l===g.l&&c.a===g.a}static fromRGBA(c){const g=c.r/255,h=c.g/255,m=c.b/255,b=c.a,f=Math.max(g,h,m),d=Math.min(g,h,m);let v=0,p=0;const $=(d+f)/2,k=f-d;if(k>0){switch(p=Math.min($<=.5?k/(2*$):k/(2-2*$),1),f){case g:v=(h-m)/k+(h<m?6:0);break;case h:v=(m-g)/k+2;break;case m:v=(g-h)/k+4;break}v*=60,v=Math.round(v)}return new R(v,p,$,b)}static i(c,g,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?c+(g-c)*6*h:h<1/2?g:h<2/3?c+(g-c)*(2/3-h)*6:c}static toRGBA(c){const g=c.h/360,{s:h,l:m,a:b}=c;let f,d,v;if(h===0)f=d=v=m;else{const p=m<.5?m*(1+h):m+h-m*h,$=2*m-p;f=R.i($,p,g+1/3),d=R.i($,p,g),v=R.i($,p,g-1/3)}return new P(Math.round(f*255),Math.round(d*255),Math.round(v*255),b)}}e.$ju=R;class T{constructor(c,g,h,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=r(Math.max(Math.min(1,g),0),3),this.v=r(Math.max(Math.min(1,h),0),3),this.a=r(Math.max(Math.min(1,m),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.v===g.v&&c.a===g.a}static fromRGBA(c){const g=c.r/255,h=c.g/255,m=c.b/255,b=Math.max(g,h,m),f=Math.min(g,h,m),d=b-f,v=b===0?0:d/b;let p;return d===0?p=0:b===g?p=((h-m)/d%6+6)%6:b===h?p=(m-g)/d+2:p=(g-h)/d+4,new T(Math.round(p*60),v,b,c.a)}static toRGBA(c){const{h:g,s:h,v:m,a:b}=c,f=m*h,d=f*(1-Math.abs(g/60%2-1)),v=m-f;let[p,$,k]=[0,0,0];return g<60?(p=f,$=d):g<120?(p=d,$=f):g<180?($=f,k=d):g<240?($=d,k=f):g<300?(p=d,k=f):g<=360&&(p=f,k=d),p=Math.round((p+v)*255),$=Math.round(($+v)*255),k=Math.round((k+v)*255),new P(p,$,k,b)}}e.$ku=T;class I{static fromHex(c){return I.Format.CSS.parseHex(c)||I.red}static equals(c,g){return!c&&!g?!0:!c||!g?!1:c.equals(g)}get hsla(){return this.i?this.i:R.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:T.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof P)this.rgba=c;else if(c instanceof R)this.i=c,this.rgba=R.toRGBA(c);else if(c instanceof T)this.j=c,this.rgba=T.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&P.equals(this.rgba,c.rgba)&&R.equals(this.hsla,c.hsla)&&T.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=I.k(this.rgba.r),g=I.k(this.rgba.g),h=I.k(this.rgba.b),m=.2126*c+.7152*g+.0722*h;return r(m,4)}static k(c){const g=c/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(c){const g=this.getRelativeLuminance(),h=c.getRelativeLuminance();return g>h?(g+.05)/(h+.05):(h+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const g=this.getRelativeLuminance(),h=c.getRelativeLuminance();return g>h}isDarkerThan(c){const g=this.getRelativeLuminance(),h=c.getRelativeLuminance();return g<h}lighten(c){return new I(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new I(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:g,g:h,b:m,a:b}=this.rgba;return new I(new P(g,h,m,b*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const g=c.rgba,h=this.rgba.a,m=g.a,b=h+m*(1-h);if(b<1e-6)return I.transparent;const f=this.rgba.r*h/b+g.r*m*(1-h)/b,d=this.rgba.g*h/b+g.g*m*(1-h)/b,v=this.rgba.b*h/b+g.b*m*(1-h)/b;return new I(new P(f,d,v,b))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:g,g:h,b:m,a:b}=this.rgba;return new I(new P(c.rgba.r-b*(c.rgba.r-g),c.rgba.g-b*(c.rgba.g-h),c.rgba.b-b*(c.rgba.b-m),1))}flatten(...c){const g=c.reduceRight((h,m)=>I.o(m,h));return I.o(this,g)}static o(c,g){const h=1-c.rgba.a;return new I(new P(h*g.rgba.r+c.rgba.a*c.rgba.r,h*g.rgba.g+c.rgba.a*c.rgba.g,h*g.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(c,g,h){if(c.isLighterThan(g))return c;h=h||.5;const m=c.getRelativeLuminance(),b=g.getRelativeLuminance();return h=h*(b-m)/b,c.lighten(h)}static getDarkerColor(c,g,h){if(c.isDarkerThan(g))return c;h=h||.5;const m=c.getRelativeLuminance(),b=g.getRelativeLuminance();return h=h*(m-b)/m,c.darken(h)}static{this.white=new I(new P(255,255,255,1))}static{this.black=new I(new P(0,0,0,1))}static{this.red=new I(new P(255,0,0,1))}static{this.blue=new I(new P(0,0,255,1))}static{this.green=new I(new P(0,255,0,1))}static{this.cyan=new I(new P(0,255,255,1))}static{this.lightgrey=new I(new P(211,211,211,1))}static{this.transparent=new I(new P(0,0,0,0))}}e.$lu=I,function(w){let c;(function(g){let h;(function(m){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:w.Format.CSS.formatRGBA(i)}m.formatRGB=b;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}m.formatRGBA=f;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(i)}m.formatHSL=d;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}m.formatHSLA=v;function p(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function $(i){return`#${p(i.rgba.r)}${p(i.rgba.g)}${p(i.rgba.b)}`}m.formatHex=$;function k(i,o=!1){return o&&i.rgba.a===1?w.Format.CSS.formatHex(i):`#${p(i.rgba.r)}${p(i.rgba.g)}${p(i.rgba.b)}${p(Math.round(i.rgba.a*255))}`}m.formatHexA=k;function S(i){return i.isOpaque()?w.Format.CSS.formatHex(i):w.Format.CSS.formatRGBA(i)}m.format=S;function t(i){const o=i.length;if(o===0||i.charCodeAt(0)!==n.CharCode.Hash)return null;if(o===7){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),a=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new w(new P(s,a,l,1))}if(o===9){const s=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),a=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),l=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),E=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new w(new P(s,a,l,E/255))}if(o===4){const s=u(i.charCodeAt(1)),a=u(i.charCodeAt(2)),l=u(i.charCodeAt(3));return new w(new P(16*s+s,16*a+a,16*l+l))}if(o===5){const s=u(i.charCodeAt(1)),a=u(i.charCodeAt(2)),l=u(i.charCodeAt(3)),E=u(i.charCodeAt(4));return new w(new P(16*s+s,16*a+a,16*l+l,(16*E+E)/255))}return null}m.parseHex=t;function u(i){switch(i){case n.CharCode.Digit0:return 0;case n.CharCode.Digit1:return 1;case n.CharCode.Digit2:return 2;case n.CharCode.Digit3:return 3;case n.CharCode.Digit4:return 4;case n.CharCode.Digit5:return 5;case n.CharCode.Digit6:return 6;case n.CharCode.Digit7:return 7;case n.CharCode.Digit8:return 8;case n.CharCode.Digit9:return 9;case n.CharCode.a:return 10;case n.CharCode.A:return 10;case n.CharCode.b:return 11;case n.CharCode.B:return 11;case n.CharCode.c:return 12;case n.CharCode.C:return 12;case n.CharCode.d:return 13;case n.CharCode.D:return 13;case n.CharCode.e:return 14;case n.CharCode.E:return 14;case n.CharCode.f:return 15;case n.CharCode.F:return 15}return 0}})(h=g.CSS||(g.CSS={}))})(c=w.Format||(w.Format={}))}(I||(e.$lu=I={}))}),define(le[53],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=r,e.$8h=P,e.$9h=R;function n(T){return(I,w,c)=>{let g=null,h=null;if(typeof c.value=="function"?(g="value",h=c.value):typeof c.get=="function"&&(g="get",h=c.get),!h)throw new Error("not supported");c[g]=T(h,w)}}function r(T,I,w){let c=null,g=null;if(typeof w.value=="function"?(c="value",g=w.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(c="get",g=w.get),!g)throw new Error("not supported");const h=`$memoize$${I}`;w[c]=function(...m){return this.hasOwnProperty(h)||Object.defineProperty(this,h,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,m)}),this[h]}}function P(T,I,w){return n((c,g)=>{const h=`$debounce$${g}`,m=`$debounce$result$${g}`;return function(...b){this[m]||(this[m]=w?w():void 0),clearTimeout(this[h]),I&&(this[m]=I(this[m],...b),b=[this[m]]),this[h]=setTimeout(()=>{c.apply(this,b),this[m]=w?w():void 0},T)}})}function R(T,I,w){return n((c,g)=>{const h=`$throttle$timer$${g}`,m=`$throttle$result$${g}`,b=`$throttle$lastRun$${g}`,f=`$throttle$pending$${g}`;return function(...d){if(this[m]||(this[m]=w?w():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...d)),this[f])return;const v=this[b]+T;v<=Date.now()?(this[b]=Date.now(),c.apply(this,[this[m]]),this[m]=w?w():void 0):(this[f]=!0,this[h]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),c.apply(this,[this[m]]),this[m]=w?w():void 0},v-Date.now()))}})}}),define(le[15],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=r,e.$X=P,e.$Y=R,e.$Z=T,e.$1=I,e.$2=w,e.$3=g,e.$5=m,e.$6=b,e.$7=f,e.$9=v;class n{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?S.isErrorNoTelemetry(i)?new S(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=n,e.$V=new n;function r(u){e.$V.setUnexpectedErrorHandler(u)}function P(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function R(u){g(u)||e.$V.onUnexpectedError(u)}function T(u){g(u)||e.$V.onUnexpectedExternalError(u)}function I(u){if(u instanceof Error){const{name:i,message:o}=u,s=u.stacktrace||u.stack;return{$isError:!0,name:i,message:o,stack:s,noTelemetry:S.isErrorNoTelemetry(u)}}return u}function w(u){let i;return u.noTelemetry?i=new S:(i=new Error,i.name=u.name),i.message=u.message,i.stack=u.stack,i}const c="Canceled";function g(u){return u instanceof h?!0:u instanceof Error&&u.name===c&&u.message===c}class h extends Error{constructor(){super(c),this.name=this.message}}e.$4=h;function m(){const u=new Error(c);return u.name=u.message,u}function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class d extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=d;function v(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class p extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=p;class $ extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=$;class k extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=k;class S extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof S)return i;const o=new S;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=S;class t extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,t.prototype)}}e.$bb=t}),define(le[20],ue([0,1,15,138]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=P,e.$sb=R,e.$tb=T,e.$ub=I,e.$vb=w,e.$wb=c,e.$xb=g,e.$yb=h,e.$zb=m,e.$Ab=b,e.$Bb=f,e.$Cb=d,e.$Db=v,e.top=p,e.$Fb=$,e.$Gb=S,e.$Hb=t,e.$Ib=u,e.$Jb=i,e.$Kb=o,e.$Lb=s,e.$Mb=a,e.$Nb=l,e.$Ob=E,e.$Pb=y,e.$Qb=D,e.$Rb=L,e.$Sb=A,e.$Tb=O,e.$Ub=W,e.$Vb=x,e.$Wb=H,e.$Xb=B,e.$Yb=X,e.$Zb=G,e.$1b=ae,e.$2b=K,e.$3b=te,e.$4b=U,e.$5b=Y,e.$6b=ie,e.$9b=oe;function P(C,z=0){return C[C.length-(1+z)]}function R(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}function T(C,z,Z=(Q,q)=>Q===q){if(C===z)return!0;if(!C||!z||C.length!==z.length)return!1;for(let Q=0,q=C.length;Q<q;Q++)if(!Z(C[Q],z[Q]))return!1;return!0}function I(C,z){const Z=C.length-1;z<Z&&(C[z]=C[Z]),C.pop()}function w(C,z,Z){return c(C.length,Q=>Z(C[Q],z))}function c(C,z){let Z=0,Q=C-1;for(;Z<=Q;){const q=(Z+Q)/2|0,se=z(q);if(se<0)Z=q+1;else if(se>0)Q=q-1;else return q}return-(Z+1)}function g(C,z,Z){if(C=C|0,C>=z.length)throw new TypeError("invalid index");const Q=z[Math.floor(z.length*Math.random())],q=[],se=[],de=[];for(const me of z){const we=Z(me,Q);we<0?q.push(me):we>0?se.push(me):de.push(me)}return C<q.length?g(C,q,Z):C<q.length+de.length?de[0]:g(C-(q.length+de.length),se,Z)}function h(C,z){const Z=[];let Q;for(const q of C.slice(0).sort(z))!Q||z(Q[0],q)!==0?(Q=[q],Z.push(Q)):Q.push(q);return Z}function*m(C,z){let Z,Q;for(const q of C)Q!==void 0&&z(Q,q)?Z.push(q):(Z&&(yield Z),Z=[q]),Q=q;Z&&(yield Z)}function b(C,z){for(let Z=0;Z<=C.length;Z++)z(Z===0?void 0:C[Z-1],Z===C.length?void 0:C[Z])}function f(C,z){for(let Z=0;Z<C.length;Z++)z(Z===0?void 0:C[Z-1],C[Z],Z+1===C.length?void 0:C[Z+1])}function d(C,z,Z){const Q=[];function q(me,we,De){if(we===0&&De.length===0)return;const ke=Q[Q.length-1];ke&&ke.start+ke.deleteCount===me?(ke.deleteCount+=we,ke.toInsert.push(...De)):Q.push({start:me,deleteCount:we,toInsert:De})}let se=0,de=0;for(;;){if(se===C.length){q(se,0,z.slice(de));break}if(de===z.length){q(se,C.length-se,[]);break}const me=C[se],we=z[de],De=Z(me,we);De===0?(se+=1,de+=1):De<0?(q(se,1,[]),se+=1):De>0&&(q(se,0,[we]),de+=1)}return Q}function v(C,z,Z){const Q=d(C,z,Z),q=[],se=[];for(const de of Q)q.push(...C.slice(de.start,de.start+de.deleteCount)),se.push(...de.toInsert);return{removed:q,added:se}}function p(C,z,Z){if(Z===0)return[];const Q=C.slice(0,Z).sort(z);return k(C,z,Q,Z,C.length),Q}function $(C,z,Z,Q,q){return Z===0?Promise.resolve([]):new Promise((se,de)=>{(async()=>{const me=C.length,we=C.slice(0,Z).sort(z);for(let De=Z,ke=Math.min(Z+Q,me);De<me;De=ke,ke=Math.min(ke+Q,me)){if(De>Z&&await new Promise(Pe=>setTimeout(Pe)),q&&q.isCancellationRequested)throw new n.$4;k(C,z,we,De,ke)}return we})().then(se,de)})}function k(C,z,Z,Q,q){for(const se=Z.length;Q<q;Q++){const de=C[Q];if(z(de,Z[se-1])<0){Z.pop();const me=(0,r.$jb)(Z,we=>z(de,we)<0);Z.splice(me,0,de)}}}function S(C){return C.filter(z=>!!z)}function t(C){let z=0;for(let Z=0;Z<C.length;Z++)C[Z]&&(C[z]=C[Z],z+=1);C.length=z}function u(C,z,Z){C.splice(Z,0,C.splice(z,1)[0])}function i(C){return!Array.isArray(C)||C.length===0}function o(C){return Array.isArray(C)&&C.length>0}function s(C,z=Z=>Z){const Z=new Set;return C.filter(Q=>{const q=z(Q);return Z.has(q)?!1:(Z.add(q),!0)})}function a(C){const z=new Set;return Z=>{const Q=C(Z);return z.has(Q)?!1:(z.add(Q),!0)}}function l(C,z){return C.length>0?C[0]:z}function E(C,z){return C.length>0?C[C.length-1]:z}function y(C,z,Z=(Q,q)=>Q===q){let Q=0;for(let q=0,se=Math.min(C.length,z.length);q<se&&Z(C[q],z[q]);q++)Q++;return Q}function D(C,z){let Z=typeof z=="number"?C:0;typeof z=="number"?Z=C:(Z=0,z=C);const Q=[];if(Z<=z)for(let q=Z;q<z;q++)Q.push(q);else for(let q=Z;q>z;q--)Q.push(q);return Q}function L(C,z,Z){return C.reduce((Q,q)=>(Q[z(q)]=Z?Z(q):q,Q),Object.create(null))}function A(C,z){return C.push(z),()=>O(C,z)}function O(C,z){const Z=C.indexOf(z);if(Z>-1)return C.splice(Z,1),z}function W(C,z,Z){const Q=C.slice(0,z),q=C.slice(z);return Q.concat(Z,q)}function x(C,z){let Z;if(typeof z=="number"){let Q=z;Z=()=>{const q=Math.sin(Q++)*179426549;return q-Math.floor(q)}}else Z=Math.random;for(let Q=C.length-1;Q>0;Q-=1){const q=Math.floor(Z()*(Q+1)),se=C[Q];C[Q]=C[q],C[q]=se}}function H(C,z){const Z=C.indexOf(z);Z>-1&&(C.splice(Z,1),C.unshift(z))}function B(C,z){const Z=C.indexOf(z);Z>-1&&(C.splice(Z,1),C.push(z))}function X(C,z){for(const Z of z)C.push(Z)}function G(C,z){return Array.isArray(C)?C.map(z):z(C)}function ae(C){return Array.isArray(C)?C:[C]}function K(C){return C[Math.floor(Math.random()*C.length)]}function te(C,z,Z){const Q=j(C,z),q=C.length,se=Z.length;C.length=q+se;for(let de=q-1;de>=Q;de--)C[de+se]=C[de];for(let de=0;de<se;de++)C[de+Q]=Z[de]}function U(C,z,Z,Q){const q=j(C,z);let se=C.splice(q,Z);return se===void 0&&(se=[]),te(C,q,Q),se}function j(C,z){return z<0?Math.max(z+C.length,0):Math.min(z,C.length)}var N;(function(C){function z(se){return se<0}C.isLessThan=z;function Z(se){return se<=0}C.isLessThanOrEqual=Z;function Q(se){return se>0}C.isGreaterThan=Q;function q(se){return se===0}C.isNeitherLessOrGreaterThan=q,C.greaterThan=1,C.lessThan=-1,C.neitherLessOrGreaterThan=0})(N||(e.CompareResult=N={}));function Y(C,z){return(Z,Q)=>z(C(Z),C(Q))}function ie(...C){return(z,Z)=>{for(const Q of C){const q=Q(z,Z);if(!N.isNeitherLessOrGreaterThan(q))return q}return N.neitherLessOrGreaterThan}}const V=(C,z)=>C-z;e.$7b=V;const he=(C,z)=>(0,e.$7b)(C?1:0,z?1:0);e.$8b=he;function oe(C){return(z,Z)=>-C(z,Z)}class ee{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let Z=this.c;for(;Z<this.g.length&&z(this.g[Z]);)Z++;const Q=Z===this.c?null:this.g.slice(this.c,Z);return this.c=Z,Q}takeFromEndWhile(z){let Z=this.d;for(;Z>=0&&z(this.g[Z]);)Z--;const Q=Z===this.d?null:this.g.slice(Z+1,this.d+1);return this.d=Z,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const Z=this.g.slice(this.c,this.c+z);return this.c+=z,Z}}e.$0b=ee;class M{static{this.empty=new M(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(Z=>(z(Z),!0))}toArray(){const z=[];return this.iterate(Z=>(z.push(Z),!0)),z}filter(z){return new M(Z=>this.iterate(Q=>z(Q)?Z(Q):!0))}map(z){return new M(Z=>this.iterate(Q=>Z(z(Q))))}some(z){let Z=!1;return this.iterate(Q=>(Z=z(Q),!Z)),Z}findFirst(z){let Z;return this.iterate(Q=>z(Q)?(Z=Q,!1):!0),Z}findLast(z){let Z;return this.iterate(Q=>(z(Q)&&(Z=Q),!0)),Z}findLastMaxBy(z){let Z,Q=!0;return this.iterate(q=>((Q||N.isGreaterThan(z(q,Z)))&&(Q=!1,Z=q),!0)),Z}}e.$$b=M;class F{constructor(z){this.c=z}static createSortPermutation(z,Z){const Q=Array.from(z.keys()).sort((q,se)=>Z(z[q],z[se]));return new F(Q)}apply(z){return z.map((Z,Q)=>z[this.c[Q]])}inverse(){const z=this.c.slice();for(let Z=0;Z<this.c.length;Z++)z[this.c[Z]]=Z;return new F(z)}}e.$_b=F}),define(le[141],ue([0,1,15]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$dd=P,e.$ed=R,e.$fd=T,e.$gd=I,e.$hd=w;function r(c,g){if(!c)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function P(c,g="Unreachable"){throw new Error(g)}function R(c,g="unexpected state"){if(!c)throw new n.$bb(`Assertion Failed: ${g}`)}function T(c){c||(0,n.$Y)(new n.$bb("Soft Assertion Failed"))}function I(c){if(!c()){debugger;c(),(0,n.$Y)(new n.$bb("Assertion Failed"))}}function w(c,g){let h=0;for(;h<c.length-1;){const m=c[h],b=c[h+1];if(!g(m,b))return!1;h++}return!0}}),define(le[89],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=n;function n(r,P){const R=this;let T=!1,I;return function(){if(T)return I;if(T=!0,P)try{I=r.apply(R,arguments)}finally{P()}else I=r.apply(R,arguments);return I}}}),define(le[77],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function P(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}r.is=P;const R=Object.freeze([]);function T(){return R}r.empty=T;function*I(i){yield i}r.single=I;function w(i){return P(i)?i:I(i)}r.wrap=w;function c(i){return i||R}r.from=c;function*g(i){for(let o=i.length-1;o>=0;o--)yield i[o]}r.reverse=g;function h(i){return!i||i[Symbol.iterator]().next().done===!0}r.isEmpty=h;function m(i){return i[Symbol.iterator]().next().value}r.first=m;function b(i,o){let s=0;for(const a of i)if(o(a,s++))return!0;return!1}r.some=b;function f(i,o){for(const s of i)if(o(s))return s}r.find=f;function*d(i,o){for(const s of i)o(s)&&(yield s)}r.filter=d;function*v(i,o){let s=0;for(const a of i)yield o(a,s++)}r.map=v;function*p(i,o){let s=0;for(const a of i)yield*o(a,s++)}r.flatMap=p;function*$(...i){for(const o of i)yield*o}r.concat=$;function k(i,o,s){let a=s;for(const l of i)a=o(a,l);return a}r.reduce=k;function*S(i,o,s=i.length){for(o<0&&(o+=i.length),s<0?s+=i.length:s>i.length&&(s=i.length);o<s;o++)yield i[o]}r.slice=S;function t(i,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,i];const a=i[Symbol.iterator]();for(let l=0;l<o;l++){const E=a.next();if(E.done)return[s,r.empty()];s.push(E.value)}return[s,{[Symbol.iterator](){return a}}]}r.consume=t;async function u(i){const o=[];for await(const s of i)o.push(s);return Promise.resolve(o)}r.asyncToArray=u})(n||(e.Iterable=n={}))}),define(le[43],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=T,e.$Un=h,e.$Vn=m,e.$Wn=b,e.$Xn=f,e.$Yn=d,e.$Zn=v,e.$1n=p,e.$2n=$,e.$3n=k,e.$4n=S;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function T(t,u=!1){let i=0;const o=t.length;let s="",a=0,l=r.Unknown,E=n.None;function y(H){let B=0,X=0;for(;B<H;){const G=t.charCodeAt(i);if(G>=g._0&&G<=g._9)X=X*16+G-g._0;else if(G>=g.A&&G<=g.F)X=X*16+G-g.A+10;else if(G>=g.a&&G<=g.f)X=X*16+G-g.a+10;else break;i++,B++}return B<H&&(X=-1),X}function D(H){i=H,s="",a=0,l=r.Unknown,E=n.None}function L(){const H=i;if(t.charCodeAt(i)===g._0)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===g.dot)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return E=n.UnexpectedEndOfNumber,t.substring(H,i);let B=i;if(i<t.length&&(t.charCodeAt(i)===g.E||t.charCodeAt(i)===g.e))if(i++,(i<t.length&&t.charCodeAt(i)===g.plus||t.charCodeAt(i)===g.minus)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;B=i}else E=n.UnexpectedEndOfNumber;return t.substring(H,B)}function A(){let H="",B=i;for(;;){if(i>=o){H+=t.substring(B,i),E=n.UnexpectedEndOfString;break}const X=t.charCodeAt(i);if(X===g.doubleQuote){H+=t.substring(B,i),i++;break}if(X===g.backslash){if(H+=t.substring(B,i),i++,i>=o){E=n.UnexpectedEndOfString;break}switch(t.charCodeAt(i++)){case g.doubleQuote:H+='"';break;case g.backslash:H+="\\";break;case g.slash:H+="/";break;case g.b:H+="\b";break;case g.f:H+="\f";break;case g.n:H+=`
`;break;case g.r:H+="\r";break;case g.t:H+="	";break;case g.u:{const ae=y(4);ae>=0?H+=String.fromCharCode(ae):E=n.InvalidUnicode;break}default:E=n.InvalidEscapeCharacter}B=i;continue}if(X>=0&&X<=31)if(w(X)){H+=t.substring(B,i),E=n.UnexpectedEndOfString;break}else E=n.InvalidCharacter;i++}return H}function O(){if(s="",E=n.None,a=i,i>=o)return a=o,l=r.EOF;let H=t.charCodeAt(i);if(I(H)){do i++,s+=String.fromCharCode(H),H=t.charCodeAt(i);while(I(H));return l=r.Trivia}if(w(H))return i++,s+=String.fromCharCode(H),H===g.carriageReturn&&t.charCodeAt(i)===g.lineFeed&&(i++,s+=`
`),l=r.LineBreakTrivia;switch(H){case g.openBrace:return i++,l=r.OpenBraceToken;case g.closeBrace:return i++,l=r.CloseBraceToken;case g.openBracket:return i++,l=r.OpenBracketToken;case g.closeBracket:return i++,l=r.CloseBracketToken;case g.colon:return i++,l=r.ColonToken;case g.comma:return i++,l=r.CommaToken;case g.doubleQuote:return i++,s=A(),l=r.StringLiteral;case g.slash:{const B=i-1;if(t.charCodeAt(i+1)===g.slash){for(i+=2;i<o&&!w(t.charCodeAt(i));)i++;return s=t.substring(B,i),l=r.LineCommentTrivia}if(t.charCodeAt(i+1)===g.asterisk){i+=2;const X=o-1;let G=!1;for(;i<X;){if(t.charCodeAt(i)===g.asterisk&&t.charCodeAt(i+1)===g.slash){i+=2,G=!0;break}i++}return G||(i++,E=n.UnexpectedEndOfComment),s=t.substring(B,i),l=r.BlockCommentTrivia}return s+=String.fromCharCode(H),i++,l=r.Unknown}case g.minus:if(s+=String.fromCharCode(H),i++,i===o||!c(t.charCodeAt(i)))return l=r.Unknown;case g._0:case g._1:case g._2:case g._3:case g._4:case g._5:case g._6:case g._7:case g._8:case g._9:return s+=L(),l=r.NumericLiteral;default:for(;i<o&&W(H);)i++,H=t.charCodeAt(i);if(a!==i){switch(s=t.substring(a,i),s){case"true":return l=r.TrueKeyword;case"false":return l=r.FalseKeyword;case"null":return l=r.NullKeyword}return l=r.Unknown}return s+=String.fromCharCode(H),i++,l=r.Unknown}}function W(H){if(I(H)||w(H))return!1;switch(H){case g.closeBrace:case g.closeBracket:case g.openBrace:case g.openBracket:case g.doubleQuote:case g.colon:case g.comma:case g.slash:return!1}return!0}function x(){let H;do H=O();while(H>=r.LineCommentTrivia&&H<=r.Trivia);return H}return{setPosition:D,getPosition:()=>i,scan:u?x:O,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>E}}function I(t){return t===g.space||t===g.tab||t===g.verticalTab||t===g.formFeed||t===g.nonBreakingSpace||t===g.ogham||t>=g.enQuad&&t<=g.zeroWidthSpace||t===g.narrowNoBreakSpace||t===g.mathematicalSpace||t===g.ideographicSpace||t===g.byteOrderMark}function w(t){return t===g.lineFeed||t===g.carriageReturn||t===g.lineSeparator||t===g.paragraphSeparator}function c(t){return t>=g._0&&t<=g._9}var g;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(g||(g={}));function h(t,u){const i=[],o=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function E(y,D,L,A){a.value=y,a.offset=D,a.length=L,a.type=A,a.colonOffset=void 0,s=a}try{k(t,{onObjectBegin:(y,D)=>{if(u<=y)throw o;s=void 0,l=u>y,i.push("")},onObjectProperty:(y,D,L)=>{if(u<D||(E(y,D,L,"property"),i[i.length-1]=y,u<=D+L))throw o},onObjectEnd:(y,D)=>{if(u<=y)throw o;s=void 0,i.pop()},onArrayBegin:(y,D)=>{if(u<=y)throw o;s=void 0,i.push(0)},onArrayEnd:(y,D)=>{if(u<=y)throw o;s=void 0,i.pop()},onLiteralValue:(y,D,L)=>{if(u<D||(E(y,D,L,S(y)),u<=D+L))throw o},onSeparator:(y,D,L)=>{if(u<=D)throw o;if(y===":"&&s&&s.type==="property")s.colonOffset=D,l=!1,s=void 0;else if(y===","){const A=i[i.length-1];typeof A=="number"?i[i.length-1]=A+1:(l=!0,i[i.length-1]=""),s=void 0}}})}catch(y){if(y!==o)throw y}return{path:i,previousNode:s,isAtPropertyKey:l,matches:y=>{let D=0;for(let L=0;D<y.length&&L<i.length;L++)if(y[D]===i[L]||y[D]==="*")D++;else if(y[D]!=="**")return!1;return D===y.length}}}function m(t,u=[],i=R.DEFAULT){let o=null,s=[];const a=[];function l(y){Array.isArray(s)?s.push(y):o!==null&&(s[o]=y)}return k(t,{onObjectBegin:()=>{const y={};l(y),a.push(s),s=y,o=null},onObjectProperty:y=>{o=y},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const y=[];l(y),a.push(s),s=y,o=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:l,onError:(y,D,L)=>{u.push({error:y,offset:D,length:L})}},i),s[0]}function b(t,u=[],i=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){o.type==="property"&&(o.length=y-o.offset,o=o.parent)}function a(y){return o.children.push(y),y}k(t,{onObjectBegin:y=>{o=a({type:"object",offset:y,length:-1,parent:o,children:[]})},onObjectProperty:(y,D,L)=>{o=a({type:"property",offset:D,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:y,offset:D,length:L,parent:o})},onObjectEnd:(y,D)=>{o.length=y+D-o.offset,o=o.parent,s(y+D)},onArrayBegin:(y,D)=>{o=a({type:"array",offset:y,length:-1,parent:o,children:[]})},onArrayEnd:(y,D)=>{o.length=y+D-o.offset,o=o.parent,s(y+D)},onLiteralValue:(y,D,L)=>{a({type:S(y),offset:D,length:L,parent:o,value:y}),s(D+L)},onSeparator:(y,D,L)=>{o.type==="property"&&(y===":"?o.colonOffset=D:y===","&&s(D))},onError:(y,D,L)=>{u.push({error:y,offset:D,length:L})}},i);const E=o.children[0];return E&&delete E.parent,E}function f(t,u){if(!t)return;let i=t;for(const o of u)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===o){i=a.children[1],s=!0;break}if(!s)return}else{const s=o;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function d(t){if(!t.parent||!t.parent.children)return[];const u=d(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}function v(t){switch(t.type){case"array":return t.children.map(v);case"object":{const u=Object.create(null);for(const i of t.children){const o=i.children[1];o&&(u[i.children[0].value]=v(o))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function p(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}function $(t,u,i=!1){if(p(t,u,i)){const o=t.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=u;s++){const a=$(o[s],u,i);if(a)return a}return t}}function k(t,u,i=R.DEFAULT){const o=T(t,!1);function s(Y){return Y?()=>Y(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(Y){return Y?ie=>Y(ie,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=s(u.onObjectBegin),E=a(u.onObjectProperty),y=s(u.onObjectEnd),D=s(u.onArrayBegin),L=s(u.onArrayEnd),A=a(u.onLiteralValue),O=a(u.onSeparator),W=s(u.onComment),x=a(u.onError),H=i&&i.disallowComments,B=i&&i.allowTrailingComma;function X(){for(;;){const Y=o.scan();switch(o.getTokenError()){case n.InvalidUnicode:G(P.InvalidUnicode);break;case n.InvalidEscapeCharacter:G(P.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:G(P.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:H||G(P.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:G(P.UnexpectedEndOfString);break;case n.InvalidCharacter:G(P.InvalidCharacter);break}switch(Y){case r.LineCommentTrivia:case r.BlockCommentTrivia:H?G(P.InvalidCommentToken):W();break;case r.Unknown:G(P.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return Y}}}function G(Y,ie=[],V=[]){if(x(Y),ie.length+V.length>0){let he=o.getToken();for(;he!==r.EOF;){if(ie.indexOf(he)!==-1){X();break}else if(V.indexOf(he)!==-1)break;he=X()}}}function ae(Y){const ie=o.getTokenValue();return Y?A(ie):E(ie),X(),!0}function K(){switch(o.getToken()){case r.NumericLiteral:{let Y=0;try{Y=JSON.parse(o.getTokenValue()),typeof Y!="number"&&(G(P.InvalidNumberFormat),Y=0)}catch{G(P.InvalidNumberFormat)}A(Y);break}case r.NullKeyword:A(null);break;case r.TrueKeyword:A(!0);break;case r.FalseKeyword:A(!1);break;default:return!1}return X(),!0}function te(){return o.getToken()!==r.StringLiteral?(G(P.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(ae(!1),o.getToken()===r.ColonToken?(O(":"),X(),N()||G(P.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):G(P.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function U(){l(),X();let Y=!1;for(;o.getToken()!==r.CloseBraceToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(Y||G(P.ValueExpected,[],[]),O(","),X(),o.getToken()===r.CloseBraceToken&&B)break}else Y&&G(P.CommaExpected,[],[]);te()||G(P.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),Y=!0}return y(),o.getToken()!==r.CloseBraceToken?G(P.CloseBraceExpected,[r.CloseBraceToken],[]):X(),!0}function j(){D(),X();let Y=!1;for(;o.getToken()!==r.CloseBracketToken&&o.getToken()!==r.EOF;){if(o.getToken()===r.CommaToken){if(Y||G(P.ValueExpected,[],[]),O(","),X(),o.getToken()===r.CloseBracketToken&&B)break}else Y&&G(P.CommaExpected,[],[]);N()||G(P.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),Y=!0}return L(),o.getToken()!==r.CloseBracketToken?G(P.CloseBracketExpected,[r.CloseBracketToken],[]):X(),!0}function N(){switch(o.getToken()){case r.OpenBracketToken:return j();case r.OpenBraceToken:return U();case r.StringLiteral:return ae(!0);default:return K()}}return X(),o.getToken()===r.EOF?i.allowEmptyContent?!0:(G(P.ValueExpected,[],[]),!1):N()?(o.getToken()!==r.EOF&&G(P.EndOfFileExpected,[],[]),!0):(G(P.ValueExpected,[],[]),!1)}function S(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[142],ue([0,1,43]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=r,e.$6n=P,e.$7n=I,e.$8n=w;function r(c,g,h){let m,b,f,d,v;if(g){for(d=g.offset,v=d+g.length,f=d;f>0&&!w(c,f-1);)f--;let E=v;for(;E<c.length&&!w(c,E);)E++;b=c.substring(f,E),m=T(b,h)}else b=c,m=0,f=0,d=0,v=c.length;const p=I(h,c);let $=!1,k=0,S;h.insertSpaces?S=R(" ",h.tabSize||4):S="	";const t=(0,n.$Tn)(b,!1);let u=!1;function i(){return p+R(S,m+k)}function o(){let E=t.scan();for($=!1;E===n.SyntaxKind.Trivia||E===n.SyntaxKind.LineBreakTrivia;)$=$||E===n.SyntaxKind.LineBreakTrivia,E=t.scan();return u=E===n.SyntaxKind.Unknown||t.getTokenError()!==n.ScanError.None,E}const s=[];function a(E,y,D){!u&&y<v&&D>d&&c.substring(y,D)!==E&&s.push({offset:y,length:D-y,content:E})}let l=o();if(l!==n.SyntaxKind.EOF){const E=t.getTokenOffset()+f,y=R(S,m);a(y,f,E)}for(;l!==n.SyntaxKind.EOF;){let E=t.getTokenOffset()+t.getTokenLength()+f,y=o(),D="";for(;!$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia);){const A=t.getTokenOffset()+f;a(" ",E,A),E=t.getTokenOffset()+t.getTokenLength()+f,D=y===n.SyntaxKind.LineCommentTrivia?i():"",y=o()}if(y===n.SyntaxKind.CloseBraceToken)l!==n.SyntaxKind.OpenBraceToken&&(k--,D=i());else if(y===n.SyntaxKind.CloseBracketToken)l!==n.SyntaxKind.OpenBracketToken&&(k--,D=i());else{switch(l){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:k++,D=i();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:D=i();break;case n.SyntaxKind.BlockCommentTrivia:$?D=i():D=" ";break;case n.SyntaxKind.ColonToken:D=" ";break;case n.SyntaxKind.StringLiteral:if(y===n.SyntaxKind.ColonToken){D="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia?D=" ":y!==n.SyntaxKind.CommaToken&&y!==n.SyntaxKind.EOF&&(u=!0);break;case n.SyntaxKind.Unknown:u=!0;break}$&&(y===n.SyntaxKind.LineCommentTrivia||y===n.SyntaxKind.BlockCommentTrivia)&&(D=i())}const L=t.getTokenOffset()+f;a(D,E,L),l=y}return s}function P(c,g){const h=JSON.stringify(c,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?h.replace(/\r\n|\r|\n/g,g.eol):h}function R(c,g){let h="";for(let m=0;m<g;m++)h+=c;return h}function T(c,g){let h=0,m=0;const b=g.tabSize||4;for(;h<c.length;){const f=c.charAt(h);if(f===" ")m++;else if(f==="	")m+=b;else break;h++}return Math.floor(m/b)}function I(c,g){for(let h=0;h<g.length;h++){const m=g.charAt(h);if(m==="\r")return h+1<g.length&&g.charAt(h+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return c&&c.eol||`
`}function w(c,g){return`\r
`.indexOf(c.charAt(g))!==-1}}),define(le[107],ue([0,1,43,142]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=P,e.$0n=R,e.$$n=T,e.$_n=I,e.$ao=w;function P(c,g,h){return R(c,g,void 0,h)}function R(c,g,h,m,b){const f=g.slice(),d=[],v=(0,n.$Wn)(c,d);let p,$;for(;f.length>0&&($=f.pop(),p=(0,n.$Xn)(v,f),p===void 0&&h!==void 0);)typeof $=="string"?h={[$]:h}:h=[h];if(p)if(p.type==="object"&&typeof $=="string"&&Array.isArray(p.children)){const k=(0,n.$Xn)(p,[$]);if(k!==void 0)if(h===void 0){if(!k.parent)throw new Error("Malformed AST");const S=p.children.indexOf(k.parent);let t,u=k.parent.offset+k.parent.length;if(S>0){const i=p.children[S-1];t=i.offset+i.length}else t=p.offset+1,p.children.length>1&&(u=p.children[1].offset);return T(c,{offset:t,length:u-t,content:""},m)}else return T(c,{offset:k.offset,length:k.length,content:JSON.stringify(h)},m);else{if(h===void 0)return[];const S=`${JSON.stringify($)}: ${JSON.stringify(h)}`,t=b?b(p.children.map(i=>i.children[0].value)):p.children.length;let u;if(t>0){const i=p.children[t-1];u={offset:i.offset+i.length,length:0,content:","+S}}else p.children.length===0?u={offset:p.offset+1,length:0,content:S}:u={offset:p.offset+1,length:0,content:S+","};return T(c,u,m)}}else if(p.type==="array"&&typeof $=="number"&&Array.isArray(p.children))if(h!==void 0){const k=`${JSON.stringify(h)}`;let S;if(p.children.length===0||$===0)S={offset:p.offset+1,length:0,content:p.children.length===0?k:k+","};else{const t=$===-1||$>p.children.length?p.children.length:$,u=p.children[t-1];S={offset:u.offset+u.length,length:0,content:","+k}}return T(c,S,m)}else{const k=$,S=p.children[k];let t;if(p.children.length===1)t={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===k){const u=p.children[k-1],i=u.offset+u.length,o=p.offset+p.length;t={offset:i,length:o-2-i,content:""}}else t={offset:S.offset,length:p.children[k+1].offset-S.offset,content:""};return T(c,t,m)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${p.type}`);else return h===void 0?[]:T(c,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(h)},m)}function T(c,g,h){let m=I(c,g),b=g.offset,f=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;b>0&&!(0,r.$8n)(m,b-1);)b--;for(;f<m.length&&!(0,r.$8n)(m,f);)f++}const d=(0,r.$5n)(m,{offset:b,length:f-b},h);for(let p=d.length-1;p>=0;p--){const $=d[p];m=I(m,$),b=Math.min(b,$.offset),f=Math.max(f,$.offset+$.length),f+=$.content.length-$.length}const v=c.length-(m.length-f)-b;return[{offset:b,length:v,content:m.substring(b,f)}]}function I(c,g){return c.substring(0,g.offset)+g.content+c.substring(g.offset+g.length)}function w(c,g){const h=g.slice(0).sort((b,f)=>{const d=b.offset-f.offset;return d===0?b.length-f.length:d});let m=c.length;for(let b=h.length-1;b>=0;b--){const f=h[b];if(f.offset+f.length<=m)c=I(c,f);else throw new Error("Overlapping edit");m=f.offset}return c}}),function(){function J(e,n,r,P){const R=/("[^"\\]*(?:\\.[^"\\]*)*")|('[^'\\]*(?:\\.[^'\\]*)*')|(\/\*[^\/\*]*(?:(?:\*|\/)[^\/\*]*)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))|(,\s*[}\]])/g;function T(w){return w.replace(R,function(c,g,h,m,b,f){if(m)return"";if(b){const d=b.length;return b[d-1]===`
`?b[d-2]==="\r"?`\r
`:`
`:""}else return f?c.substring(1):c})}function I(w){const c=T(w);try{return JSON.parse(c)}catch{const h=c.replace(/,\s*([}\]])/g,"$1");return JSON.parse(h)}}return{stripComments:T,parse:I}}typeof define=="function"?define("vs/base/common/jsonc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("jsonc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[65],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=n}),define(le[108],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(R){this.element=R,this.next=n.Undefined,this.prev=n.Undefined}}class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let R=this.a;for(;R!==n.Undefined;){const T=R.next;R.prev=n.Undefined,R.next=n.Undefined,R=T}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,T){const I=new n(R);if(this.a===n.Undefined)this.a=I,this.b=I;else if(T){const c=this.b;this.b=I,I.prev=c,c.next=I}else{const c=this.a;this.a=I,I.next=c,c.prev=I}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(I))}}shift(){if(this.a!==n.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==n.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==n.Undefined&&R.next!==n.Undefined){const T=R.prev;T.next=R.next,R.next.prev=T}else R.prev===n.Undefined&&R.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):R.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):R.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==n.Undefined;)yield R.element,R=R.next}}e.$4c=r}),define(le[31],ue([0,1]),function(J,e){"use strict";var n,r,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=R,e.$xc=T,e.$yc=I,e.$Hc=S;function R(t,u,i){let o=t.get(u);return o===void 0&&(o=i,t.set(u,o)),o}function T(t){const u=[];return t.forEach((i,o)=>{u.push(`${o} => ${i}`)}),`Map(${t.size}) {${u.join(", ")}}`}function I(t){const u=[];return t.forEach(i=>{u.push(i)}),`Set(${t.size}) {${u.join(", ")}}`}class w{constructor(u,i){this.uri=u,this.value=i}}function c(t){return Array.isArray(t)}class g{static{this.c=u=>u.toString()}constructor(u,i){if(this[n]="ResourceMap",u instanceof g)this.d=new Map(u.d),this.e=i??g.c;else if(c(u)){this.d=new Map,this.e=i??g.c;for(const[o,s]of u)this.set(o,s)}else this.d=new Map,this.e=u??g.c}set(u,i){return this.d.set(this.e(u),new w(u,i)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,i){typeof i<"u"&&(u=u.bind(i));for(const[o,s]of this.d)u(s.value,s.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}e.$zc=g;class h{constructor(u,i){this[r]="ResourceSet",!u||typeof u=="function"?this.c=new g(u):(this.c=new g(i),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,i){this.c.forEach((o,s)=>u.call(i,s,s,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=h;var m;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class b{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,i=m.None){const o=this.c.get(u);if(o)return i!==m.None&&this.m(o,i),o.value}set(u,i,o=m.None){let s=this.c.get(u);if(s)s.value=i,o!==m.None&&this.m(s,o);else{switch(s={key:u,value:i,next:void 0,previous:void 0},o){case m.None:this.k(s);break;case m.AsOld:this.j(s);break;case m.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(u,s),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const i=this.c.get(u);if(i)return this.c.delete(u),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,i){const o=this.g;let s=this.d;for(;s;){if(i?u.bind(i)(s.value,s.key,this):u(s.value,s.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.key,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}values(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:o.value,done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}entries(){const u=this,i=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(u.g!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const a={value:[o.key,o.value],done:!1};return o=o.next,a}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.d,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.next,o--;this.d=i,this.f=o,i&&(i.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let i=this.e,o=this.size;for(;i&&o>u;)this.c.delete(i.key),i=i.previous,o--;this.e=i,this.f=o,i&&(i.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const i=u.next,o=u.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}u.next=void 0,u.previous=void 0,this.g++}m(u,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==m.AsOld&&i!==m.AsNew)){if(i===m.AsOld){if(u===this.d)return;const o=u.next,s=u.previous;u===this.e?(s.next=void 0,this.e=s):(o.previous=s,s.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(i===m.AsNew){if(u===this.e)return;const o=u.next,s=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=s,s.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((i,o)=>{u.push([o,i])}),u}fromJSON(u){this.clear();for(const[i,o]of u)this.set(i,o)}}e.$Bc=b;class f extends b{constructor(u,i=1){super(),this.n=u,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,i=m.AsNew){return super.get(u,i)}peek(u){return super.get(u,m.None)}set(u,i){return super.set(u,i,m.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends f{constructor(u,i=1){super(u,i)}q(u){this.h(u)}set(u,i){return super.set(u,i),this.p(),this}}e.$Cc=d;class v extends f{constructor(u,i=1){super(u,i)}q(u){this.i(u)}set(u,i){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,i),this}}e.$Dc=v;class p{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let i=this.c.get(u)||0;return i===0?!1:(i--,i===0?this.c.delete(u):this.c.set(u,i),!0)}has(u){return this.c.has(u)}}e.$Ec=p;class ${constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[i,o]of u)this.set(i,o)}clear(){this.c.clear(),this.d.clear()}set(u,i){this.c.set(u,i),this.d.set(i,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const i=this.c.get(u);return i===void 0?!1:(this.c.delete(u),this.d.delete(i),!0)}forEach(u,i){this.c.forEach((o,s)=>{u.call(i,o,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=$;class k{constructor(){this.c=new Map}add(u,i){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(i)}delete(u,i){const o=this.c.get(u);o&&(o.delete(i),o.size===0&&this.c.delete(u))}forEach(u,i){const o=this.c.get(u);o&&o.forEach(i)}get(u){const i=this.c.get(u);return i||new Set}}e.$Gc=k;function S(t,u){if(t===u)return!0;if(t.size!==u.size)return!1;for(const[i,o]of t)if(!u.has(i)||u.get(i)!==o)return!1;for(const[i]of u)if(!t.has(i))return!1;return!0}}),define(le[2],ue([0,1,20,139,31,89,77]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=g,e.$Kc=h,e.$Lc=m,e.$Mc=d,e.$Nc=v,e.$Oc=p,e.$Pc=$,e.$Qc=k,e.$Rc=S,e.$2c=D;const I=!1;let w=null;class c{constructor(){this.b=new Map}static{this.a=0}c(O){let W=this.b.get(O);return W||(W={parent:null,source:null,isSingleton:!1,value:O,idx:c.a++},this.b.set(O,W)),W}trackDisposable(O){const W=this.c(O);W.source||(W.source=new Error().stack)}setParent(O,W){const x=this.c(O);x.parent=W}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,W){const x=W.get(O);if(x)return x;const H=O.parent?this.f(this.c(O.parent),W):O;return W.set(O,H),H}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,x])=>x.source!==null&&!this.f(x,O).isSingleton).flatMap(([x])=>x)}computeLeakingDisposables(O=10,W){let x;if(W)x=W;else{const ae=new Map,K=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,ae).isSingleton);if(K.length===0)return;const te=new Set(K.map(U=>U.value));if(x=K.filter(U=>!(U.parent&&te.has(U.parent))),x.length===0)throw new Error("There are cyclic diposable chains!")}if(!x)return;function H(ae){function K(U,j){for(;U.length>0&&j.some(N=>typeof N=="string"?N===U[0]:U[0].match(N));)U.shift()}const te=ae.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return K(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const B=new P.$Gc;for(const ae of x){const K=H(ae);for(let te=0;te<=K.length;te++)B.add(K.slice(0,te).join(`
`),ae)}x.sort((0,n.$5b)(ae=>ae.idx,n.$7b));let X="",G=0;for(const ae of x.slice(0,O)){G++;const K=H(ae),te=[];for(let U=0;U<K.length;U++){let j=K[U];j=`(shared with ${B.get(K.slice(0,U+1).join(`
`)).size}/${x.length} leaks) at ${j}`;const Y=B.get(K.slice(0,U).join(`
`)),ie=(0,r.$c)([...Y].map(V=>H(V)[U]),V=>V);delete ie[K[U]];for(const[V,he]of Object.entries(ie))te.unshift(`    - stacktraces of ${he.length} other leaks continue with ${V}`);te.unshift(j)}X+=`


==================== Leaking disposable ${G}/${x.length}: ${ae.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return x.length>O&&(X+=`


... and ${x.length-O} more leaking disposables

`),{leaks:x,details:X}}}e.$Ic=c;function g(A){w=A}if(I){const A="__is_disposable_tracked__";g(new class{trackDisposable(O){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[A]||console.log(W)},3e3)}setParent(O,W){if(O&&O!==u.None)try{O[A]=!0}catch{}}markAsDisposed(O){if(O&&O!==u.None)try{O[A]=!0}catch{}}markAsSingleton(O){}})}function h(A){return w?.trackDisposable(A),A}function m(A){w?.markAsDisposed(A)}function b(A,O){w?.setParent(A,O)}function f(A,O){if(w)for(const W of A)w.setParent(W,O)}function d(A){return w?.markAsSingleton(A),A}function v(A){return typeof A=="object"&&A!==null&&typeof A.dispose=="function"&&A.dispose.length===0}function p(A){if(T.Iterable.is(A)){const O=[];for(const W of A)if(W)try{W.dispose()}catch(x){O.push(x)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}function $(A){for(const O of A)v(O)&&O.dispose();return[]}function k(...A){const O=S(()=>p(A));return f(A,O),O}function S(A){const O=h({dispose:(0,R.$cb)(()=>{m(O),A()})});return O}class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,h(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{p(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return b(O,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),b(O,null))}}e.$Sc=t;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,h(this),b(this.q,this)}dispose(){m(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}e.$Tc=u;class i{constructor(){this.b=!1,h(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&b(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&b(O,null),O}}e.$Uc=i;class o{constructor(O){this.a=new i,this.b=!1,this.a.value=O}get value(){return this.a.value}set value(O){this.b||O===this.a.value||(this.a.value=O)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=o;class s{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(O){let W=O;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,m(this))},this}}e.$Xc=a;class l{constructor(){this.a=new Map}acquire(O,...W){let x=this.a.get(O);x||(x={counter:0,object:this.b(O,...W)},this.a.set(O,x));const{object:H}=x,B=(0,R.$cb)(()=>{--x.counter===0&&(this.c(O,x.object),this.a.delete(O))});return x.counter++,{object:H,dispose:B}}}e.$Yc=l;class E{constructor(O){this.a=O}async acquire(O,...W){const x=this.a.acquire(O,...W);try{return{object:await x.object,dispose:()=>x.dispose()}}catch(H){throw x.dispose(),H}}}e.$Zc=E;class y{constructor(O){this.object=O}dispose(){}}e.$1c=y;function D(A){const O=new t;try{A(O)}finally{O.dispose()}}class L{constructor(){this.a=new Map,this.b=!1,h(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,W,x=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),x||this.a.get(O)?.dispose(),this.a.set(O,W)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}deleteAndLeak(O){const W=this.a.get(O);return this.a.delete(O),W}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=L}),define(le[90],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(le[78],ue([0,1,31]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=void 0,e.$km=P,e.$lm=T;const r=new n.$Cc(1e4);function P(c){return w(c,"NFC",r)}const R=new n.$Cc(1e4);function T(c){return w(c,"NFD",R)}const I=/[^\u0000-\u0080]/;function w(c,g,h){if(!c)return c;const m=h.get(c);if(m)return m;let b;return I.test(c)?b=c.normalize(g):b=c,h.set(c,b),b}e.$mm=function(){const c=/[\u0300-\u036f]/g;return function(g){return T(g).replace(c,"")}}()}),define(le[143],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0,e.$Im=n,e.rot=r,e.$Nm=I;function n(w,c,g){return Math.min(Math.max(w,c),g)}function r(w,c){return(c+w%c)%c}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Km=P;class R{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Lm=R;class T{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const g=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Mm=T;function I(w,c,g,h,m,b,f,d){const v=f-g,p=d-h,$=m-g,k=b-h,S=w-g,t=c-h,u=v*v+p*p,i=v*$+p*k,o=v*S+p*t,s=$*$+k*k,a=$*S+k*t,l=1/(u*s-i*i),E=(s*o-i*a)*l,y=(u*a-i*o)*l;return E>=0&&y>=0&&E+y<1}}),function(){function J(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function T(w){R.push(w,Date.now())}function I(){const w=[];for(let c=0;c<R.length;c+=2)w.push({name:R[c],startTime:R[c+1]});return w}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(P+T.startTime)});return R}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(le[3],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=u,e.$E=E,e.$K=y,e.$h="en";let n=!1,r=!1,P=!1,R=!1,T=!1,I=!1,w=!1,c=!1,g=!1,h=!1,m,b=e.$h,f=e.$h,d,v;const p=globalThis;let $;typeof p.vscode<"u"&&typeof p.vscode.process<"u"?$=p.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const k=typeof $?.versions?.electron=="string",S=k&&$?.type==="renderer";if(typeof $=="object"){n=$.platform==="win32",r=$.platform==="darwin",P=$.platform==="linux",R=P&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,w=k,g=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$h,b=e.$h;const D=$.env.VSCODE_NLS_CONFIG;if(D)try{const L=JSON.parse(D);m=L.userLocale,f=L.osLocale,b=L.resolvedLanguage||e.$h,d=L.languagePack?.translationsConfigFile}catch{}T=!0}else typeof navigator=="object"&&!S?(v=navigator.userAgent,n=v.indexOf("Windows")>=0,r=v.indexOf("Macintosh")>=0,c=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=v.indexOf("Linux")>=0,h=v?.indexOf("Mobi")>=0,I=!0,b=globalThis._VSCODE_NLS_LANGUAGE||e.$h,m=navigator.language.toLowerCase(),f=m):console.error("Unable to resolve platform.");var t;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(D){switch(D){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let i=t.Web;r?i=t.Mac:n?i=t.Windows:P&&(i=t.Linux),e.$j=n,e.$k=r,e.$l=P,e.$m=R,e.$n=T,e.$o=w,e.$p=I,e.$q=I&&typeof p.importScripts=="function",e.$r=e.$q?p.origin:void 0,e.$s=c,e.$t=h,e.$u=g,e.$v=i,e.$w=v,e.$x=b;var o;(function(D){function L(){return e.$x}D.value=L;function A(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}D.isDefaultVariant=A;function O(){return e.$x==="en"}D.isDefault=O})(o||(e.Language=o={})),e.$y=m,e.$z=f,e.$A=d,e.$B=typeof p.postMessage=="function"&&!p.importScripts,e.$C=(()=>{if(e.$B){const D=[];p.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let O=0,W=D.length;O<W;O++){const x=D[O];if(x.id===A.data.vscodeScheduleAsyncWork){D.splice(O,1),x.callback();return}}});let L=0;return A=>{const O=++L;D.push({id:O,callback:A}),p.postMessage({vscodeScheduleAsyncWork:O},"*")}}return D=>setTimeout(D)})();var s;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=r||c?s.Macintosh:n?s.Windows:s.Linux;let a=!0,l=!1;function E(){if(!l){l=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,a=new Uint16Array(D.buffer)[0]===513}return a}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function y(D){return parseFloat(D)>=20}}),define(le[36],ue([0,1,3]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let r;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const R=P.process;r={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$j?"win32":n.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$cc=r.platform,e.$dc=r.arch});var Rt=this&&this.__createBinding||(Object.create?function(J,e,n,r){r===void 0&&(r=n);var P=Object.getOwnPropertyDescriptor(e,n);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[n]}}),Object.defineProperty(J,r,P)}:function(J,e,n,r){r===void 0&&(r=n),J[r]=e[n]}),At=this&&this.__setModuleDefault||(Object.create?function(J,e){Object.defineProperty(J,"default",{enumerable:!0,value:e})}:function(J,e){J.default=e}),Ie=this&&this.__importStar||function(J){if(J&&J.__esModule)return J;var e={};if(J!=null)for(var n in J)n!=="default"&&Object.prototype.hasOwnProperty.call(J,n)&&Rt(e,J,n);return At(e,J),e};define(le[9],ue([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,n=Ie(n);const r=65,P=97,R=90,T=122,I=46,w=47,c=92,g=58,h=63;class m extends Error{constructor(o,s,a){let l;typeof s=="string"&&s.indexOf("not ")===0?(l="must not be",s=s.replace(/^not /,"")):l="must be";const E=o.indexOf(".")!==-1?"property":"argument";let y=`The "${o}" ${E} ${l} of type ${s}`;y+=`. Received type ${typeof a}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function b(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function f(i,o){if(typeof i!="string")throw new m(o,"string",i)}const d=n.$cc==="win32";function v(i){return i===w||i===c}function p(i){return i===w}function $(i){return i>=r&&i<=R||i>=P&&i<=T}function k(i,o,s,a){let l="",E=0,y=-1,D=0,L=0;for(let A=0;A<=i.length;++A){if(A<i.length)L=i.charCodeAt(A);else{if(a(L))break;L=w}if(a(L)){if(!(y===A-1||D===1))if(D===2){if(l.length<2||E!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const O=l.lastIndexOf(s);O===-1?(l="",E=0):(l=l.slice(0,O),E=l.length-1-l.lastIndexOf(s)),y=A,D=0;continue}else if(l.length!==0){l="",E=0,y=A,D=0;continue}}o&&(l+=l.length>0?`${s}..`:"..",E=2)}else l.length>0?l+=`${s}${i.slice(y+1,A)}`:l=i.slice(y+1,A),E=A-y-1;y=A,D=0}else L===I&&D!==-1?++D:D=-1}return l}function S(i){return i?`${i[0]==="."?"":"."}${i}`:""}function t(i,o){b(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${S(o.ext)}`;return s?s===o.root?`${s}${a}`:`${s}${i}${a}`:a}e.$ec={resolve(...i){let o="",s="",a=!1;for(let l=i.length-1;l>=-1;l--){let E;if(l>=0){if(E=i[l],f(E,`paths[${l}]`),E.length===0)continue}else o.length===0?E=n.cwd():(E=n.env[`=${o}`]||n.cwd(),(E===void 0||E.slice(0,2).toLowerCase()!==o.toLowerCase()&&E.charCodeAt(2)===c)&&(E=`${o}\\`));const y=E.length;let D=0,L="",A=!1;const O=E.charCodeAt(0);if(y===1)v(O)&&(D=1,A=!0);else if(v(O))if(A=!0,v(E.charCodeAt(1))){let W=2,x=W;for(;W<y&&!v(E.charCodeAt(W));)W++;if(W<y&&W!==x){const H=E.slice(x,W);for(x=W;W<y&&v(E.charCodeAt(W));)W++;if(W<y&&W!==x){for(x=W;W<y&&!v(E.charCodeAt(W));)W++;(W===y||W!==x)&&(L=`\\\\${H}\\${E.slice(x,W)}`,D=W)}}}else D=1;else $(O)&&E.charCodeAt(1)===g&&(L=E.slice(0,2),D=2,y>2&&v(E.charCodeAt(2))&&(A=!0,D=3));if(L.length>0)if(o.length>0){if(L.toLowerCase()!==o.toLowerCase())continue}else o=L;if(a){if(o.length>0)break}else if(s=`${E.slice(D)}\\${s}`,a=A,A&&o.length>0)break}return s=k(s,!a,"\\",v),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){f(i,"path");const o=i.length;if(o===0)return".";let s=0,a,l=!1;const E=i.charCodeAt(0);if(o===1)return p(E)?"\\":i;if(v(E))if(l=!0,v(i.charCodeAt(1))){let D=2,L=D;for(;D<o&&!v(i.charCodeAt(D));)D++;if(D<o&&D!==L){const A=i.slice(L,D);for(L=D;D<o&&v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!v(i.charCodeAt(D));)D++;if(D===o)return`\\\\${A}\\${i.slice(L)}\\`;D!==L&&(a=`\\\\${A}\\${i.slice(L,D)}`,s=D)}}}else s=1;else $(E)&&i.charCodeAt(1)===g&&(a=i.slice(0,2),s=2,o>2&&v(i.charCodeAt(2))&&(l=!0,s=3));let y=s<o?k(i.slice(s),!l,"\\",v):"";return y.length===0&&!l&&(y="."),y.length>0&&v(i.charCodeAt(o-1))&&(y+="\\"),a===void 0?l?`\\${y}`:y:l?`${a}\\${y}`:`${a}${y}`},isAbsolute(i){f(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return v(s)||o>2&&$(s)&&i.charCodeAt(1)===g&&v(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let E=0;E<i.length;++E){const y=i[E];f(y,"path"),y.length>0&&(o===void 0?o=s=y:o+=`\\${y}`)}if(o===void 0)return".";let a=!0,l=0;if(typeof s=="string"&&v(s.charCodeAt(0))){++l;const E=s.length;E>1&&v(s.charCodeAt(1))&&(++l,E>2&&(v(s.charCodeAt(2))?++l:a=!1))}if(a){for(;l<o.length&&v(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.$ec.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o)return"";const s=e.$ec.resolve(i),a=e.$ec.resolve(o);if(s===a||(i=s.toLowerCase(),o=a.toLowerCase(),i===o))return"";let l=0;for(;l<i.length&&i.charCodeAt(l)===c;)l++;let E=i.length;for(;E-1>l&&i.charCodeAt(E-1)===c;)E--;const y=E-l;let D=0;for(;D<o.length&&o.charCodeAt(D)===c;)D++;let L=o.length;for(;L-1>D&&o.charCodeAt(L-1)===c;)L--;const A=L-D,O=y<A?y:A;let W=-1,x=0;for(;x<O;x++){const B=i.charCodeAt(l+x);if(B!==o.charCodeAt(D+x))break;B===c&&(W=x)}if(x!==O){if(W===-1)return a}else{if(A>O){if(o.charCodeAt(D+x)===c)return a.slice(D+x+1);if(x===2)return a.slice(D+x)}y>O&&(i.charCodeAt(l+x)===c?W=x:x===2&&(W=3)),W===-1&&(W=0)}let H="";for(x=l+W+1;x<=E;++x)(x===E||i.charCodeAt(x)===c)&&(H+=H.length===0?"..":"\\..");return D+=W,H.length>0?`${H}${a.slice(D,L)}`:(a.charCodeAt(D)===c&&++D,a.slice(D,L))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$ec.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const s=o.charCodeAt(2);if(s!==h&&s!==I)return`\\\\?\\UNC\\${o.slice(2)}`}}else if($(o.charCodeAt(0))&&o.charCodeAt(1)===g&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return i},dirname(i){f(i,"path");const o=i.length;if(o===0)return".";let s=-1,a=0;const l=i.charCodeAt(0);if(o===1)return v(l)?i:".";if(v(l)){if(s=a=1,v(i.charCodeAt(1))){let D=2,L=D;for(;D<o&&!v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&v(i.charCodeAt(D));)D++;if(D<o&&D!==L){for(L=D;D<o&&!v(i.charCodeAt(D));)D++;if(D===o)return i;D!==L&&(s=a=D+1)}}}}else $(l)&&i.charCodeAt(1)===g&&(s=o>2&&v(i.charCodeAt(2))?3:2,a=s);let E=-1,y=!0;for(let D=o-1;D>=a;--D)if(v(i.charCodeAt(D))){if(!y){E=D;break}}else y=!1;if(E===-1){if(s===-1)return".";E=s}return i.slice(0,E)},basename(i,o){o!==void 0&&f(o,"suffix"),f(i,"path");let s=0,a=-1,l=!0,E;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,D=-1;for(E=i.length-1;E>=s;--E){const L=i.charCodeAt(E);if(v(L)){if(!l){s=E+1;break}}else D===-1&&(l=!1,D=E+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=E):(y=-1,a=D))}return s===a?a=D:a===-1&&(a=i.length),i.slice(s,a)}for(E=i.length-1;E>=s;--E)if(v(i.charCodeAt(E))){if(!l){s=E+1;break}}else a===-1&&(l=!1,a=E+1);return a===-1?"":i.slice(s,a)},extname(i){f(i,"path");let o=0,s=-1,a=0,l=-1,E=!0,y=0;i.length>=2&&i.charCodeAt(1)===g&&$(i.charCodeAt(0))&&(o=a=2);for(let D=i.length-1;D>=o;--D){const L=i.charCodeAt(D);if(v(L)){if(!E){a=D+1;break}continue}l===-1&&(E=!1,l=D+1),L===I?s===-1?s=D:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||l===-1||y===0||y===1&&s===l-1&&s===a+1?"":i.slice(s,l)},format:t.bind(null,"\\"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let a=0,l=i.charCodeAt(0);if(s===1)return v(l)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(v(l)){if(a=1,v(i.charCodeAt(1))){let W=2,x=W;for(;W<s&&!v(i.charCodeAt(W));)W++;if(W<s&&W!==x){for(x=W;W<s&&v(i.charCodeAt(W));)W++;if(W<s&&W!==x){for(x=W;W<s&&!v(i.charCodeAt(W));)W++;W===s?a=W:W!==x&&(a=W+1)}}}}else if($(l)&&i.charCodeAt(1)===g){if(s<=2)return o.root=o.dir=i,o;if(a=2,v(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;a=3}}a>0&&(o.root=i.slice(0,a));let E=-1,y=a,D=-1,L=!0,A=i.length-1,O=0;for(;A>=a;--A){if(l=i.charCodeAt(A),v(l)){if(!L){y=A+1;break}continue}D===-1&&(L=!1,D=A+1),l===I?E===-1?E=A:O!==1&&(O=1):E!==-1&&(O=-1)}return D!==-1&&(E===-1||O===0||O===1&&E===D-1&&E===y+1?o.base=o.name=i.slice(y,D):(o.name=i.slice(y,E),o.base=i.slice(y,D),o.ext=i.slice(E,D))),y>0&&y!==a?o.dir=i.slice(0,y-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(d){const i=/\\/g;return()=>{const o=n.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$fc={resolve(...i){let o="",s=!1;for(let a=i.length-1;a>=-1&&!s;a--){const l=a>=0?i[a]:u();f(l,`paths[${a}]`),l.length!==0&&(o=`${l}/${o}`,s=l.charCodeAt(0)===w)}return o=k(o,!s,"/",p),s?`/${o}`:o.length>0?o:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===w,s=i.charCodeAt(i.length-1)===w;return i=k(i,!o,"/",p),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===w},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const a=i[s];f(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":e.$fc.normalize(o)},relative(i,o){if(f(i,"from"),f(o,"to"),i===o||(i=e.$fc.resolve(i),o=e.$fc.resolve(o),i===o))return"";const s=1,a=i.length,l=a-s,E=1,y=o.length-E,D=l<y?l:y;let L=-1,A=0;for(;A<D;A++){const W=i.charCodeAt(s+A);if(W!==o.charCodeAt(E+A))break;W===w&&(L=A)}if(A===D)if(y>D){if(o.charCodeAt(E+A)===w)return o.slice(E+A+1);if(A===0)return o.slice(E+A)}else l>D&&(i.charCodeAt(s+A)===w?L=A:A===0&&(L=0));let O="";for(A=s+L+1;A<=a;++A)(A===a||i.charCodeAt(A)===w)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(E+L)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===w;let s=-1,a=!0;for(let l=i.length-1;l>=1;--l)if(i.charCodeAt(l)===w){if(!a){s=l;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&f(o,"ext"),f(i,"path");let s=0,a=-1,l=!0,E;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let y=o.length-1,D=-1;for(E=i.length-1;E>=0;--E){const L=i.charCodeAt(E);if(L===w){if(!l){s=E+1;break}}else D===-1&&(l=!1,D=E+1),y>=0&&(L===o.charCodeAt(y)?--y===-1&&(a=E):(y=-1,a=D))}return s===a?a=D:a===-1&&(a=i.length),i.slice(s,a)}for(E=i.length-1;E>=0;--E)if(i.charCodeAt(E)===w){if(!l){s=E+1;break}}else a===-1&&(l=!1,a=E+1);return a===-1?"":i.slice(s,a)},extname(i){f(i,"path");let o=-1,s=0,a=-1,l=!0,E=0;for(let y=i.length-1;y>=0;--y){const D=i.charCodeAt(y);if(D===w){if(!l){s=y+1;break}continue}a===-1&&(l=!1,a=y+1),D===I?o===-1?o=y:E!==1&&(E=1):o!==-1&&(E=-1)}return o===-1||a===-1||E===0||E===1&&o===a-1&&o===s+1?"":i.slice(o,a)},format:t.bind(null,"/"),parse(i){f(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===w;let a;s?(o.root="/",a=1):a=0;let l=-1,E=0,y=-1,D=!0,L=i.length-1,A=0;for(;L>=a;--L){const O=i.charCodeAt(L);if(O===w){if(!D){E=L+1;break}continue}y===-1&&(D=!1,y=L+1),O===I?l===-1?l=L:A!==1&&(A=1):l!==-1&&(A=-1)}if(y!==-1){const O=E===0&&s?1:E;l===-1||A===0||A===1&&l===y-1&&l===E+1?o.base=o.name=i.slice(O,y):(o.name=i.slice(O,l),o.base=i.slice(O,y),o.ext=i.slice(l,y))}return E>0?o.dir=i.slice(0,E-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=d?e.$ec.normalize:e.$fc.normalize,e.$hc=d?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=d?e.$ec.join:e.$fc.join,e.$jc=d?e.$ec.resolve:e.$fc.resolve,e.$kc=d?e.$ec.relative:e.$fc.relative,e.$lc=d?e.$ec.dirname:e.$fc.dirname,e.$mc=d?e.$ec.basename:e.$fc.basename,e.$nc=d?e.$ec.extname:e.$fc.extname,e.$oc=d?e.$ec.format:e.$fc.format,e.$pc=d?e.$ec.parse:e.$fc.parse,e.$qc=d?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=d?e.$ec.sep:e.$fc.sep,e.$sc=d?e.$ec.delimiter:e.$fc.delimiter}),define(le[79],ue([0,1,3]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$im=R,e.$jm=T;var r;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(r||(e.Source=r={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function R(I,...w){const c=w.reduce((m,b)=>(m[b]=!0,m),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!c[m]).forEach(m=>{for(let b=0;b<g.length;b++)if(m.search(g[b])!==-1){delete I[m];break}})}function T(I){I&&(delete I.DEBUG,n.$l&&delete I.LD_PRELOAD)}}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:J)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function n(r){if(e[r])return e[r].exports;var P=e[r]={i:r,l:!1,exports:{}};return J[r].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=J,n.c=e,n.d=function(r,P,R){n.o(r,P)||Object.defineProperty(r,P,{enumerable:!0,get:R})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,P){if(1&P&&(r=n(r)),8&P||4&P&&typeof r=="object"&&r&&r.__esModule)return r;var R=Object.create(null);if(n.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:r}),2&P&&typeof r!="string")for(var T in r)n.d(R,T,function(I){return r[I]}.bind(null,T));return R},n.n=function(r){var P=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(P,"a",P),P},n.o=function(r,P){return Object.prototype.hasOwnProperty.call(r,P)},n.p="",n(n.s=0)}([function(J,e,n){(function(r){var P;e=J.exports=he,P=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],w=e.src=[],c=0,g=c++;w[g]="0|[1-9]\\d*";var h=c++;w[h]="[0-9]+";var m=c++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=c++;w[b]="("+w[g]+")\\.("+w[g]+")\\.("+w[g]+")";var f=c++;w[f]="("+w[h]+")\\.("+w[h]+")\\.("+w[h]+")";var d=c++;w[d]="(?:"+w[g]+"|"+w[m]+")";var v=c++;w[v]="(?:"+w[h]+"|"+w[m]+")";var p=c++;w[p]="(?:-("+w[d]+"(?:\\."+w[d]+")*))";var $=c++;w[$]="(?:-?("+w[v]+"(?:\\."+w[v]+")*))";var k=c++;w[k]="[0-9A-Za-z-]+";var S=c++;w[S]="(?:\\+("+w[k]+"(?:\\."+w[k]+")*))";var t=c++,u="v?"+w[b]+w[p]+"?"+w[S]+"?";w[t]="^"+u+"$";var i="[v=\\s]*"+w[f]+w[$]+"?"+w[S]+"?",o=c++;w[o]="^"+i+"$";var s=c++;w[s]="((?:<|>)?=?)";var a=c++;w[a]=w[h]+"|x|X|\\*";var l=c++;w[l]=w[g]+"|x|X|\\*";var E=c++;w[E]="[v=\\s]*("+w[l]+")(?:\\.("+w[l]+")(?:\\.("+w[l]+")(?:"+w[p]+")?"+w[S]+"?)?)?";var y=c++;w[y]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[$]+")?"+w[S]+"?)?)?";var D=c++;w[D]="^"+w[s]+"\\s*"+w[E]+"$";var L=c++;w[L]="^"+w[s]+"\\s*"+w[y]+"$";var A=c++;w[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=c++;w[O]="(?:~>?)";var W=c++;w[W]="(\\s*)"+w[O]+"\\s+",I[W]=new RegExp(w[W],"g");var x=c++;w[x]="^"+w[O]+w[E]+"$";var H=c++;w[H]="^"+w[O]+w[y]+"$";var B=c++;w[B]="(?:\\^)";var X=c++;w[X]="(\\s*)"+w[B]+"\\s+",I[X]=new RegExp(w[X],"g");var G=c++;w[G]="^"+w[B]+w[E]+"$";var ae=c++;w[ae]="^"+w[B]+w[y]+"$";var K=c++;w[K]="^"+w[s]+"\\s*("+i+")$|^$";var te=c++;w[te]="^"+w[s]+"\\s*("+u+")$|^$";var U=c++;w[U]="(\\s*)"+w[s]+"\\s*("+i+"|"+w[E]+")",I[U]=new RegExp(w[U],"g");var j=c++;w[j]="^\\s*("+w[E]+")\\s+-\\s+("+w[E]+")\\s*$";var N=c++;w[N]="^\\s*("+w[y]+")\\s+-\\s+("+w[y]+")\\s*$";var Y=c++;w[Y]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)P(ie,w[ie]),I[ie]||(I[ie]=new RegExp(w[ie]));function V(_,ce){if(_ instanceof he)return _;if(typeof _!="string"||_.length>R||!(ce?I[o]:I[t]).test(_))return null;try{return new he(_,ce)}catch{return null}}function he(_,ce){if(_ instanceof he){if(_.loose===ce)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof he))return new he(_,ce);P("SemVer",_,ce),this.loose=ce;var fe=_.trim().match(ce?I[o]:I[t]);if(!fe)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ae=+be;if(Ae>=0&&Ae<T)return Ae}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(_,ce){var fe=V(_,ce);return fe?fe.version:null},e.clean=function(_,ce){var fe=V(_.trim().replace(/^[=v]+/,""),ce);return fe?fe.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(_){return P("SemVer.compare",this.version,this.loose,_),_ instanceof he||(_=new he(_,this.loose)),this.compareMain(_)||this.comparePre(_)},he.prototype.compareMain=function(_){return _ instanceof he||(_=new he(_,this.loose)),ee(this.major,_.major)||ee(this.minor,_.minor)||ee(this.patch,_.patch)},he.prototype.comparePre=function(_){if(_ instanceof he||(_=new he(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ce=0;do{var fe=this.prerelease[ce],be=_.prerelease[ce];if(P("prerelease compare",ce,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return ee(fe,be)}while(++ce)},he.prototype.inc=function(_,ce){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ce,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new he(_,fe).inc(ce,be).version}catch{return null}},e.diff=function(_,ce){if(z(_,ce))return null;var fe=V(_),be=V(ce);if(fe.prerelease.length||be.prerelease.length){for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in fe)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&fe[Ae]!==be[Ae])return Ae},e.compareIdentifiers=ee;var oe=/^[0-9]+$/;function ee(_,ce){var fe=oe.test(_),be=oe.test(ce);return fe&&be&&(_=+_,ce=+ce),fe&&!be?-1:be&&!fe?1:_<ce?-1:_>ce?1:0}function M(_,ce,fe){return new he(_,fe).compare(new he(ce,fe))}function F(_,ce,fe){return M(_,ce,fe)>0}function C(_,ce,fe){return M(_,ce,fe)<0}function z(_,ce,fe){return M(_,ce,fe)===0}function Z(_,ce,fe){return M(_,ce,fe)!==0}function Q(_,ce,fe){return M(_,ce,fe)>=0}function q(_,ce,fe){return M(_,ce,fe)<=0}function se(_,ce,fe,be){var Ae;switch(ce){case"===":typeof _=="object"&&(_=_.version),typeof fe=="object"&&(fe=fe.version),Ae=_===fe;break;case"!==":typeof _=="object"&&(_=_.version),typeof fe=="object"&&(fe=fe.version),Ae=_!==fe;break;case"":case"=":case"==":Ae=z(_,fe,be);break;case"!=":Ae=Z(_,fe,be);break;case">":Ae=F(_,fe,be);break;case">=":Ae=Q(_,fe,be);break;case"<":Ae=C(_,fe,be);break;case"<=":Ae=q(_,fe,be);break;default:throw new TypeError("Invalid operator: "+ce)}return Ae}function de(_,ce){if(_ instanceof de){if(_.loose===ce)return _;_=_.value}if(!(this instanceof de))return new de(_,ce);P("comparator",_,ce),this.loose=ce,this.parse(_),this.semver===me?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(_,ce){return ee(ce,_)},e.major=function(_,ce){return new he(_,ce).major},e.minor=function(_,ce){return new he(_,ce).minor},e.patch=function(_,ce){return new he(_,ce).patch},e.compare=M,e.compareLoose=function(_,ce){return M(_,ce,!0)},e.rcompare=function(_,ce,fe){return M(ce,_,fe)},e.sort=function(_,ce){return _.sort(function(fe,be){return e.compare(fe,be,ce)})},e.rsort=function(_,ce){return _.sort(function(fe,be){return e.rcompare(fe,be,ce)})},e.gt=F,e.lt=C,e.eq=z,e.neq=Z,e.gte=Q,e.lte=q,e.cmp=se,e.Comparator=de;var me={};function we(_,ce){if(_ instanceof we)return _.loose===ce?_:new we(_.raw,ce);if(_ instanceof de)return new we(_.value,ce);if(!(this instanceof we))return new we(_,ce);if(this.loose=ce,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function De(_){return!_||_.toLowerCase()==="x"||_==="*"}function ke(_,ce,fe,be,Ae,Ce,Me,Oe,Be,Ge,Qe,qe,Je){return((ce=De(fe)?"":De(be)?">="+fe+".0.0":De(Ae)?">="+fe+"."+be+".0":">="+ce)+" "+(Oe=De(Be)?"":De(Ge)?"<"+(+Be+1)+".0.0":De(Qe)?"<"+Be+"."+(+Ge+1)+".0":qe?"<="+Be+"."+Ge+"."+Qe+"-"+qe:"<="+Oe)).trim()}function Pe(_,ce){for(var fe=0;fe<_.length;fe++)if(!_[fe].test(ce))return!1;if(ce.prerelease.length){for(fe=0;fe<_.length;fe++)if(P(_[fe].semver),_[fe].semver!==me&&_[fe].semver.prerelease.length>0){var be=_[fe].semver;if(be.major===ce.major&&be.minor===ce.minor&&be.patch===ce.patch)return!0}return!1}return!0}function Re(_,ce,fe){try{ce=new we(ce,fe)}catch{return!1}return ce.test(_)}function $e(_,ce,fe,be){var Ae,Ce,Me,Oe,Be;switch(_=new he(_,be),ce=new we(ce,be),fe){case">":Ae=F,Ce=q,Me=C,Oe=">",Be=">=";break;case"<":Ae=C,Ce=Q,Me=F,Oe="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(_,ce,be))return!1;for(var Ge=0;Ge<ce.set.length;++Ge){var Qe=ce.set[Ge],qe=null,Je=null;if(Qe.forEach(function(Xe){Xe.semver===me&&(Xe=new de(">=0.0.0")),qe=qe||Xe,Je=Je||Xe,Ae(Xe.semver,qe.semver,be)?qe=Xe:Me(Xe.semver,Je.semver,be)&&(Je=Xe)}),qe.operator===Oe||qe.operator===Be||(!Je.operator||Je.operator===Oe)&&Ce(_,Je.semver)||Je.operator===Be&&Me(_,Je.semver))return!1}return!0}de.prototype.parse=function(_){var ce=this.loose?I[K]:I[te],fe=_.match(ce);if(!fe)throw new TypeError("Invalid comparator: "+_);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new he(fe[2],this.loose):this.semver=me},de.prototype.toString=function(){return this.value},de.prototype.test=function(_){return P("Comparator.test",_,this.loose),this.semver===me||(typeof _=="string"&&(_=new he(_,this.loose)),se(_,this.operator,this.semver,this.loose))},de.prototype.intersects=function(_,ce){if(!(_ instanceof de))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new we(_.value,ce),Re(this.value,fe,ce);if(_.operator==="")return fe=new we(this.value,ce),Re(_.semver,fe,ce);var be=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Ce=this.semver.version===_.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),Oe=se(this.semver,"<",_.semver,ce)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),Be=se(this.semver,">",_.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return be||Ae||Ce&&Me||Oe||Be},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(_){var ce=this.loose;_=_.trim(),P("range",_,ce);var fe=ce?I[N]:I[j];_=_.replace(fe,ke),P("hyphen replace",_),_=_.replace(I[U],"$1$2$3"),P("comparator trim",_,I[U]),_=(_=(_=_.replace(I[W],"$1~")).replace(I[X],"$1^")).split(/\s+/).join(" ");var be=ce?I[K]:I[te],Ae=_.split(" ").map(function(Ce){return function(Me,Oe){return P("comp",Me),Me=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Qe){return function(qe,Je){P("caret",qe,Je);var Xe=Je?I[ae]:I[G];return qe.replace(Xe,function(Ye,Ne,ne,ge,pe){var ye;return P("caret",qe,Ye,Ne,ne,ge,pe),De(Ne)?ye="":De(ne)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":De(ge)?ye=Ne==="0"?">="+Ne+"."+ne+".0 <"+Ne+"."+(+ne+1)+".0":">="+Ne+"."+ne+".0 <"+(+Ne+1)+".0.0":pe?(P("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=Ne==="0"?ne==="0"?">="+Ne+"."+ne+"."+ge+pe+" <"+Ne+"."+ne+"."+(+ge+1):">="+Ne+"."+ne+"."+ge+pe+" <"+Ne+"."+(+ne+1)+".0":">="+Ne+"."+ne+"."+ge+pe+" <"+(+Ne+1)+".0.0"):(P("no pr"),ye=Ne==="0"?ne==="0"?">="+Ne+"."+ne+"."+ge+" <"+Ne+"."+ne+"."+(+ge+1):">="+Ne+"."+ne+"."+ge+" <"+Ne+"."+(+ne+1)+".0":">="+Ne+"."+ne+"."+ge+" <"+(+Ne+1)+".0.0"),P("caret return",ye),ye})}(Qe,Ge)}).join(" ")}(Me,Oe),P("caret",Me),Me=function(Be,Ge){return Be.trim().split(/\s+/).map(function(Qe){return function(qe,Je){var Xe=Je?I[H]:I[x];return qe.replace(Xe,function(Ye,Ne,ne,ge,pe){var ye;return P("tilde",qe,Ye,Ne,ne,ge,pe),De(Ne)?ye="":De(ne)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":De(ge)?ye=">="+Ne+"."+ne+".0 <"+Ne+"."+(+ne+1)+".0":pe?(P("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),ye=">="+Ne+"."+ne+"."+ge+pe+" <"+Ne+"."+(+ne+1)+".0"):ye=">="+Ne+"."+ne+"."+ge+" <"+Ne+"."+(+ne+1)+".0",P("tilde return",ye),ye})}(Qe,Ge)}).join(" ")}(Me,Oe),P("tildes",Me),Me=function(Be,Ge){return P("replaceXRanges",Be,Ge),Be.split(/\s+/).map(function(Qe){return function(qe,Je){qe=qe.trim();var Xe=Je?I[L]:I[D];return qe.replace(Xe,function(Ye,Ne,ne,ge,pe,ye){P("xRange",qe,Ye,Ne,ne,ge,pe,ye);var We=De(ne),Ue=We||De(ge),Ze=Ue||De(pe);return Ne==="="&&Ze&&(Ne=""),We?Ye=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Ze?(Ue&&(ge=0),Ze&&(pe=0),Ne===">"?(Ne=">=",Ue?(ne=+ne+1,ge=0,pe=0):Ze&&(ge=+ge+1,pe=0)):Ne==="<="&&(Ne="<",Ue?ne=+ne+1:ge=+ge+1),Ye=Ne+ne+"."+ge+"."+pe):Ue?Ye=">="+ne+".0.0 <"+(+ne+1)+".0.0":Ze&&(Ye=">="+ne+"."+ge+".0 <"+ne+"."+(+ge+1)+".0"),P("xRange return",Ye),Ye})}(Qe,Ge)}).join(" ")}(Me,Oe),P("xrange",Me),Me=function(Be,Ge){return P("replaceStars",Be,Ge),Be.trim().replace(I[Y],"")}(Me,Oe),P("stars",Me),Me}(Ce,ce)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Ce){return!!Ce.match(be)})),Ae=Ae.map(function(Ce){return new de(Ce,ce)})},we.prototype.intersects=function(_,ce){if(!(_ instanceof we))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return _.set.some(function(Ae){return Ae.every(function(Ce){return be.intersects(Ce,ce)})})})})},e.toComparators=function(_,ce){return new we(_,ce).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},we.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new he(_,this.loose));for(var ce=0;ce<this.set.length;ce++)if(Pe(this.set[ce],_))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(_,ce,fe){var be=null,Ae=null;try{var Ce=new we(ce,fe)}catch{return null}return _.forEach(function(Me){Ce.test(Me)&&(be&&Ae.compare(Me)!==-1||(Ae=new he(be=Me,fe)))}),be},e.minSatisfying=function(_,ce,fe){var be=null,Ae=null;try{var Ce=new we(ce,fe)}catch{return null}return _.forEach(function(Me){Ce.test(Me)&&(be&&Ae.compare(Me)!==1||(Ae=new he(be=Me,fe)))}),be},e.validRange=function(_,ce){try{return new we(_,ce).range||"*"}catch{return null}},e.ltr=function(_,ce,fe){return $e(_,ce,"<",fe)},e.gtr=function(_,ce,fe){return $e(_,ce,">",fe)},e.outside=$e,e.prerelease=function(_,ce){var fe=V(_,ce);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(_,ce,fe){return _=new we(_,fe),ce=new we(ce,fe),_.intersects(ce)},e.coerce=function(_){if(_ instanceof he)return _;if(typeof _!="string")return null;var ce=_.match(I[A]);return ce==null?null:V((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,n(1))},function(J,e){var n,r,P=J.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(v){if(n===setTimeout)return setTimeout(v,0);if((n===R||!n)&&setTimeout)return n=setTimeout,setTimeout(v,0);try{return n(v,0)}catch{try{return n.call(null,v,0)}catch{return n.call(this,v,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:R}catch{n=R}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var w,c=[],g=!1,h=-1;function m(){g&&w&&(g=!1,w.length?c=w.concat(c):h=-1,c.length&&b())}function b(){if(!g){var v=I(m);g=!0;for(var p=c.length;p;){for(w=c,c=[];++h<p;)w&&w[h].run();h=-1,p=c.length}w=null,g=!1,function($){if(r===clearTimeout)return clearTimeout($);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout($);try{r($)}catch{try{return r.call(null,$)}catch{return r.call(this,$)}}}(v)}}function f(v,p){this.fun=v,this.array=p}function d(){}P.nextTick=function(v){var p=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)p[$-1]=arguments[$];c.push(new f(v,p)),c.length!==1||g||I(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=d,P.addListener=d,P.once=d,P.off=d,P.removeListener=d,P.removeAllListeners=d,P.emit=d,P.prependListener=d,P.prependOnceListener=d,P.listeners=function(v){return[]},P.binding=function(v){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(v){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(le[144],ue([0,1]),function(J,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class r{constructor(I,w,c){this.level=I,this.key=w,this.value=c,this.forward=[]}}const P=void 0;class R{constructor(I,w=2**16){this.comparator=I,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new r(this.c,P,P)}get size(){return this.f}clear(){this.e=new r(this.c,P,P),this.f=0}has(I){return!!R.g(this,I,this.comparator)}get(I){return R.g(this,I,this.comparator)?.value}set(I,w){return R.h(this,I,w,this.comparator)&&(this.f+=1),this}delete(I){const w=R.k(this,I,this.comparator);return w&&(this.f-=1),w}forEach(I,w){let c=this.e.forward[0];for(;c;)I.call(w,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",w=this.e.forward[0];for(;w;)I+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return I}static g(I,w,c){let g=I.e;for(let h=I.d-1;h>=0;h--)for(;g.forward[h]&&c(g.forward[h].key,w)<0;)g=g.forward[h];if(g=g.forward[0],g&&c(g.key,w)===0)return g}static h(I,w,c,g){const h=[];let m=I.e;for(let b=I.d-1;b>=0;b--){for(;m.forward[b]&&g(m.forward[b].key,w)<0;)m=m.forward[b];h[b]=m}if(m=m.forward[0],m&&g(m.key,w)===0)return m.value=c,!1;{const b=R.j(I);if(b>I.d){for(let f=I.d;f<b;f++)h[f]=I.e;I.d=b}m=new r(b,w,c);for(let f=0;f<b;f++)m.forward[f]=h[f].forward[f],h[f].forward[f]=m;return!0}}static j(I,w=.5){let c=1;for(;Math.random()<w&&c<I.c;)c+=1;return c}static k(I,w,c){const g=[];let h=I.e;for(let m=I.d-1;m>=0;m--){for(;h.forward[m]&&c(h.forward[m].key,w)<0;)h=h.forward[m];g[m]=h}if(h=h.forward[0],!h||c(h.key,w)!==0)return!1;for(let m=0;m<I.d&&g[m].forward[m]===h;m++)g[m].forward[m]=h.forward[m];for(;I.d>0&&I.e.forward[I.d-1]===P;)I.d-=1;return!0}}e.$Qs=R}),define(le[66],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(R){return new r(R)}constructor(R){this.c=n&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=r}),define(le[4],ue([0,1,15,89,2,108,66]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=b;const I=!1,w=!1,c=!1;var g;(function(H){H.None=()=>P.$Tc.None;function B(ke){if(c){const{onDidAddListener:Pe}=ke,Re=d.create();let $e=0;ke.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),Pe?.()}}}function X(ke,Pe){return V(ke,()=>{},0,void 0,!0,void 0,Pe)}H.defer=X;function G(ke){return(Pe,Re=null,$e)=>{let _=!1,ce;return ce=ke(fe=>{if(!_)return ce?ce.dispose():_=!0,Pe.call(Re,fe)},null,$e),_&&ce.dispose(),ce}}H.once=G;function ae(ke,Pe,Re){return Y(($e,_=null,ce)=>ke(fe=>$e.call(_,Pe(fe)),null,ce),Re)}H.map=ae;function K(ke,Pe,Re){return Y(($e,_=null,ce)=>ke(fe=>{Pe(fe),$e.call(_,fe)},null,ce),Re)}H.forEach=K;function te(ke,Pe,Re){return Y(($e,_=null,ce)=>ke(fe=>Pe(fe)&&$e.call(_,fe),null,ce),Re)}H.filter=te;function U(ke){return ke}H.signal=U;function j(...ke){return(Pe,Re=null,$e)=>{const _=(0,P.$Qc)(...ke.map(ce=>ce(fe=>Pe.call(Re,fe))));return ie(_,$e)}}H.any=j;function N(ke,Pe,Re,$e){let _=Re;return ae(ke,ce=>(_=Pe(_,ce),_),$e)}H.reduce=N;function Y(ke,Pe){let Re;const $e={onWillAddFirstListener(){Re=ke(_.fire,_)},onDidRemoveLastListener(){Re?.dispose()}};Pe||B($e);const _=new i($e);return Pe?.add(_),_.event}function ie(ke,Pe){return Pe instanceof Array?Pe.push(ke):Pe&&Pe.add(ke),ke}function V(ke,Pe,Re=100,$e=!1,_=!1,ce,fe){let be,Ae,Ce,Me=0,Oe;const Be={leakWarningThreshold:ce,onWillAddFirstListener(){be=ke(Qe=>{Me++,Ae=Pe(Ae,Qe),$e&&!Ce&&(Ge.fire(Ae),Ae=void 0),Oe=()=>{const qe=Ae;Ae=void 0,Ce=void 0,(!$e||Me>1)&&Ge.fire(qe),Me=0},typeof Re=="number"?(clearTimeout(Ce),Ce=setTimeout(Oe,Re)):Ce===void 0&&(Ce=0,queueMicrotask(Oe))})},onWillRemoveListener(){_&&Me>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,be.dispose()}};fe||B(Be);const Ge=new i(Be);return fe?.add(Ge),Ge.event}H.debounce=V;function he(ke,Pe=0,Re){return H.debounce(ke,($e,_)=>$e?($e.push(_),$e):[_],Pe,void 0,!0,void 0,Re)}H.accumulate=he;function oe(ke,Pe=($e,_)=>$e===_,Re){let $e=!0,_;return te(ke,ce=>{const fe=$e||!Pe(ce,_);return $e=!1,_=ce,fe},Re)}H.latch=oe;function ee(ke,Pe,Re){return[H.filter(ke,Pe,Re),H.filter(ke,$e=>!Pe($e),Re)]}H.split=ee;function M(ke,Pe=!1,Re=[],$e){let _=Re.slice(),ce=ke(Ae=>{_?_.push(Ae):be.fire(Ae)});$e&&$e.add(ce);const fe=()=>{_?.forEach(Ae=>be.fire(Ae)),_=null},be=new i({onWillAddFirstListener(){ce||(ce=ke(Ae=>be.fire(Ae)),$e&&$e.add(ce))},onDidAddFirstListener(){_&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return $e&&$e.add(be),be.event}H.buffer=M;function F(ke,Pe){return($e,_,ce)=>{const fe=Pe(new z);return ke(function(be){const Ae=fe.evaluate(be);Ae!==C&&$e.call(_,Ae)},void 0,ce)}}H.chain=F;const C=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(Re=>(Pe(Re),Re)),this}filter(Pe){return this.f.push(Re=>Pe(Re)?Re:C),this}reduce(Pe,Re){let $e=Re;return this.f.push(_=>($e=Pe($e,_),$e)),this}latch(Pe=(Re,$e)=>Re===$e){let Re=!0,$e;return this.f.push(_=>{const ce=Re||!Pe(_,$e);return Re=!1,$e=_,ce?_:C}),this}evaluate(Pe){for(const Re of this.f)if(Pe=Re(Pe),Pe===C)break;return Pe}}function Z(ke,Pe,Re=$e=>$e){const $e=(...be)=>fe.fire(Re(...be)),_=()=>ke.on(Pe,$e),ce=()=>ke.removeListener(Pe,$e),fe=new i({onWillAddFirstListener:_,onDidRemoveLastListener:ce});return fe.event}H.fromNodeEventEmitter=Z;function Q(ke,Pe,Re=$e=>$e){const $e=(...be)=>fe.fire(Re(...be)),_=()=>ke.addEventListener(Pe,$e),ce=()=>ke.removeEventListener(Pe,$e),fe=new i({onWillAddFirstListener:_,onDidRemoveLastListener:ce});return fe.event}H.fromDOMEventEmitter=Q;function q(ke){return new Promise(Pe=>G(ke)(Pe))}H.toPromise=q;function se(ke){const Pe=new i;return ke.then(Re=>{Pe.fire(Re)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}H.fromPromise=se;function de(ke,Pe,Re){return Pe(Re),ke($e=>Pe($e))}H.runAndSubscribe=de;class me{constructor(Pe,Re){this._observable=Pe,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Re||B($e),this.emitter=new i($e),Re&&Re.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,Re){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(ke,Pe){return new me(ke,Pe).emitter.event}H.fromObservable=we;function De(ke){return(Pe,Re,$e)=>{let _=0,ce=!1;const fe={beginUpdate(){_++},endUpdate(){_--,_===0&&(ke.reportChanges(),ce&&(ce=!1,Pe.call(Re)))},handlePossibleChange(){},handleChange(){ce=!0}};ke.addObserver(fe),ke.reportChanges();const be={dispose(){ke.removeObserver(fe)}};return $e instanceof P.$Sc?$e.add(be):Array.isArray($e)&&$e.push(be),be}}H.fromObservableLight=De})(g||(e.Event=g={}));class h{static{this.all=new Set}static{this.f=0}constructor(B){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${B}_${h.f++}`,h.all.add(this)}start(B){this.g=new T.$de,this.listenerCount=B}stop(){if(this.g){const B=this.g.elapsed();this.durations.push(B),this.elapsedOverall+=B,this.invocationCount+=1,this.g=void 0}}}e.$fe=h;let m=-1;function b(H){const B=m;return m=H,{dispose(){m=B}}}class f{static{this.f=1}constructor(B,X,G=(f.f++).toString(16).padStart(3,"0")){this.j=B,this.threshold=X,this.name=G,this.h=0}dispose(){this.g?.clear()}check(B,X){const G=this.threshold;if(G<=0||X<G)return;this.g||(this.g=new Map);const ae=this.g.get(B.value)||0;if(this.g.set(B.value,ae+1),this.h-=1,this.h<=0){this.h=G*.5;const[K,te]=this.getMostFrequentStack(),U=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${te}):`;console.warn(U),console.warn(K);const j=new v(U,K);this.j(j)}return()=>{const K=this.g.get(B.value)||0;this.g.set(B.value,K-1)}}getMostFrequentStack(){if(!this.g)return;let B,X=0;for(const[G,ae]of this.g)(!B||X<ae)&&(B=[G,ae],X=ae);return B}}class d{static create(){const B=new Error;return new d(B.stack??"")}constructor(B){this.value=B}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(B,X){super(B),this.name="ListenerLeakError",this.stack=X}}e.$he=v;class p extends Error{constructor(B,X){super(B),this.name="ListenerRefusalError",this.stack=X}}e.$ie=p;let $=0;class k{constructor(B){this.value=B,this.id=$++}}const S=2,t=(H,B)=>{if(H instanceof k)B(H);else for(let X=0;X<H.length;X++){const G=H[X];G&&B(G)}};let u;if(I){const H=[];setInterval(()=>{H.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(H.join(`
`)),H.length=0)},3e3),u=new FinalizationRegistry(B=>{typeof B=="string"&&H.push(B)})}class i{constructor(B){this.z=0,this.f=B,this.g=m>0||this.f?.leakWarningThreshold?new f(B?.onListenerError??n.$Y,this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(w){const B=this.u;queueMicrotask(()=>{t(B,X=>X.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(B,X,G)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const N=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],Y=new p(`${j}. HINT: Stack shows most frequent listener (${N[1]}-times)`,N[0]);return(this.f?.onListenerError||n.$Y)(Y),P.$Tc.None}if(this.m)return P.$Tc.None;X&&(B=B.bind(X));const ae=new k(B);let K,te;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(ae.stack=d.create(),K=this.g.check(ae.stack,this.z+1)),w&&(ae.stack=te??d.create()),this.u?this.u instanceof k?(this.w??=new s,this.u=[this.u,ae]):this.u.push(ae):(this.f?.onWillAddFirstListener?.(this),this.u=ae,this.f?.onDidAddFirstListener?.(this)),this.z++;const U=(0,P.$Rc)(()=>{u?.unregister(U),K?.(),this.A(ae)});if(G instanceof P.$Sc?G.add(U):Array.isArray(G)&&G.push(U),u){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),N=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);u.register(U,N?.[2]??j,U)}return U},this.q}A(B){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const X=this.u,G=X.indexOf(B);if(G===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,X[G]=void 0;const ae=this.w.current===this;if(this.z*S<=X.length){let K=0;for(let te=0;te<X.length;te++)X[te]?X[K++]=X[te]:ae&&(this.w.end--,K<this.w.i&&this.w.i--);X.length=K}}B(B,X){if(!B)return;const G=this.f?.onListenerError||n.$Y;if(!G){B.value(X);return}try{B.value(X)}catch(ae){G(ae)}}C(B){const X=B.current.u;for(;B.i<B.end;)this.B(X[B.i++],B.value);B.reset()}fire(B){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof k)this.B(this.u,B);else{const X=this.w;X.enqueue(this,B,this.u.length),this.C(X)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=i;const o=()=>new s;e.$ke=o;class s{constructor(){this.i=-1,this.end=0}enqueue(B,X,G){this.i=0,this.end=G,this.current=B,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class a extends i{async fireAsync(B,X,G){if(this.u)for(this.h||(this.h=new R.$4c),t(this.u,ae=>this.h.push([ae.value,B]));this.h.size>0&&!X.isCancellationRequested;){const[ae,K]=this.h.shift(),te=[],U={...K,token:X,waitUntil:j=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");G&&(j=G(j,ae)),te.push(j)}};try{ae(U)}catch(j){(0,n.$Y)(j);continue}Object.freeze(te),await Promise.allSettled(te).then(j=>{for(const N of j)N.status==="rejected"&&(0,n.$Y)(N.reason)})}}}e.$le=a;class l extends i{get isPaused(){return this.h!==0}constructor(B){super(B),this.h=0,this.s=new R.$4c,this.t=B?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const B=Array.from(this.s);this.s.clear(),super.fire(this.t(B))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(B){this.z&&(this.h!==0?this.s.push(B):super.fire(B))}}e.$me=l;class E extends l{constructor(B){super(B),this.k=B.delay??100}fire(B){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(B)}}e.$ne=E;class y extends i{constructor(B){super(B),this.h=[],this.k=B?.merge}fire(B){this.hasListeners()&&(this.h.push(B),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(X=>super.fire(X)),this.h=[]}))}}e.$oe=y;class D{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(B){const X={event:B,listener:null};this.h.push(X),this.g&&this.m(X);const G=()=>{this.g&&this.o(X);const ae=this.h.indexOf(X);this.h.splice(ae,1)};return(0,P.$Rc)((0,r.$cb)(G))}j(){this.g=!0,this.h.forEach(B=>this.m(B))}k(){this.g=!1,this.h.forEach(B=>this.o(B))}m(B){B.listener=B.event(X=>this.f.fire(X))}o(B){B.listener?.dispose(),B.listener=null}dispose(){this.f.dispose();for(const B of this.h)B.listener?.dispose();this.h=[]}}e.$pe=D;class L{constructor(B,X,G,ae){this.f=new P.$Sc;const K=this.f.add(new D),te=this.f.add(new P.$3c);function U(j){te.set(j,K.add(ae(j)))}for(const j of B)U(j);this.f.add(X(j=>{U(j)})),this.f.add(G(j=>{te.deleteAndDispose(j)})),this.event=K.event}dispose(){this.f.dispose()}}e.$qe=L;class A{constructor(){this.f=[]}wrapEvent(B,X,G){return(ae,K,te)=>B(U=>{const j=this.f[this.f.length-1];if(!X){j?j.buffers.push(()=>ae.call(K,U)):ae.call(K,U);return}const N=j;if(!N){ae.call(K,X(G,U));return}N.items??=[],N.items.push(U),N.buffers.length===0&&j.buffers.push(()=>{N.reducedResult??=G?N.items.reduce(X,G):N.items.reduce(X),ae.call(K,N.reducedResult)})},void 0,te)}bufferEvents(B){const X={buffers:new Array};this.f.push(X);const G=B();return this.f.pop(),X.buffers.forEach(ae=>ae()),G}}e.$re=A;class O{constructor(){this.f=!1,this.g=g.None,this.h=P.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(B){this.g=B,this.f&&(this.h.dispose(),this.h=B(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=O;class W{static const(B){return new x(B)}constructor(B){this.g=B,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(B){B!==this.g&&(this.g=B,this.f.fire(void 0))}}e.$te=W;class x{constructor(B){this.value=B,this.onDidChange=g.None}}}),define(le[21],ue([0,1,4]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=I;const r=Object.freeze(function(w,c){const g=setTimeout(w.bind(c),0);return{dispose(){clearTimeout(g)}}});var P;(function(w){function c(g){return g===w.None||g===w.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}w.isCancellationToken=c,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(P||(e.CancellationToken=P={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=P.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=P.None}}e.$ue=T;function I(w){const c=new T;return w.add({dispose(){c.cancel()}}),c.token}}),define(le[145],ue([0,1,21]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=P;class r{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new n.$ue,c=this.b(w.token);return this.a={promise:c,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$7e=r;function P(I){return I}class R{constructor(w,c){this.a=void 0,this.b=void 0,typeof w=="function"?(this.c=w,this.d=P):(this.c=c,this.d=w.getCacheKey)}get(w){const c=this.d(w);return this.b!==c&&(this.b=c,this.a=this.c(w)),this.a}}e.$9e=R;class T{get cachedValues(){return this.a}constructor(w,c){this.a=new Map,this.b=new Map,typeof w=="function"?(this.c=w,this.d=P):(this.c=c,this.d=w.getCacheKey)}get(w){const c=this.d(w);if(this.b.has(c))return this.b.get(c);const g=this.c(w);return this.a.set(w,g),this.b.set(c,g),g}}e.$0e=T}),define(le[67],ue([0,1,15,2]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=P,e.$xe=R,e.$ye=T,e.$ze=I,e.$Ae=c,e.$Be=g,e.$Ce=h,e.$De=m,e.$Ee=b,e.$Fe=f,e.$Ge=d,e.$He=v,e.$Ie=p,e.$Je=$,e.$Ke=k;function P(S){const t=S;return t?typeof t.read=="function":!1}function R(S){const t=S;return t?[t.on,t.pause,t.resume,t.destroy].every(u=>typeof u=="function"):!1}function T(S){const t=S;return t?R(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function I(S,t){return new w(S,t)}class w{constructor(t,u){this.e=t,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(u=>u(t))}h(t){this.c.error.length===0?(0,n.$Y)(t):this.c.error.slice(0).forEach(u=>u(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,u){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(t,u){if(this.a.destroyed)return;let i;switch(t){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(u);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(S,t){const u=[];let i;for(;(i=S.read())!==null;)u.push(i);return t(u)}function g(S,t,u){const i=[];let o;for(;(o=S.read())!==null&&i.length<u;)i.push(o);return o===null&&i.length>0?t(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return S.read()}}}function h(S,t){return new Promise((u,i)=>{const o=[];m(S,{onData:s=>{t&&o.push(s)},onError:s=>{t?i(s):u(void 0)},onEnd:()=>{u(t?t(o):void 0)}})})}function m(S,t,u){S.on("error",i=>{u?.isCancellationRequested||t.onError(i)}),S.on("end",()=>{u?.isCancellationRequested||t.onEnd()}),S.on("data",i=>{u?.isCancellationRequested||t.onData(i)})}function b(S,t){return new Promise((u,i)=>{const o=new r.$Sc,s=[],a=y=>{if(s.push(y),s.length>t)return o.dispose(),S.pause(),u({stream:S,buffer:s,ended:!1})},l=y=>(o.dispose(),i(y)),E=()=>(o.dispose(),u({stream:S,buffer:s,ended:!0}));o.add((0,r.$Rc)(()=>S.removeListener("error",l))),S.on("error",l),o.add((0,r.$Rc)(()=>S.removeListener("end",E))),S.on("end",E),o.add((0,r.$Rc)(()=>S.removeListener("data",a))),S.on("data",a)})}function f(S,t){const u=I(t);return u.end(S),u}function d(){const S=I(()=>{throw new Error("not supported")});return S.end(),S}function v(S){let t=!1;return{read:()=>t?null:(t=!0,S)}}function p(S,t,u){const i=I(u);return m(S,{onData:o=>i.write(t.data(o)),onError:o=>i.error(t.error?t.error(o):o),onEnd:()=>i.end()}),i}function $(S,t,u){let i=!1;return{read:()=>{const o=t.read();return i?o:(i=!0,o!==null?u([S,o]):S)}}}function k(S,t,u){let i=!1;const o=I(u);return m(t,{onData:s=>i?o.write(s):(i=!0,o.write(u([S,s]))),onError:s=>o.error(s),onEnd:()=>{i||(i=!0,o.write(S)),o.end()}}),o}}),define(le[16],ue([0,1,65,67]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=c,e.$Ne=g,e.$Oe=h,e.$Pe=m,e.$Qe=b,e.$Re=f,e.$Se=d,e.$Te=v,e.$Ue=p,e.$Ve=$,e.$We=k,e.$Xe=S,e.$Ye=t,e.$Ze=u,e.$1e=i,e.$2e=o,e.$3e=s,e.$4e=a,e.$5e=l,e.$6e=D,r=Ie(r);const P=typeof Buffer<"u",R=new n.$T(()=>new Uint8Array(256));let T,I;class w{static alloc(A){return P?new w(Buffer.allocUnsafe(A)):new w(new Uint8Array(A))}static wrap(A){return P&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new w(A)}static fromString(A,O){return!(O?.dontUseNodeBuffer||!1)&&P?new w(Buffer.from(A)):(T||(T=new TextEncoder),new w(T.encode(A)))}static fromByteArray(A){const O=w.alloc(A.length);for(let W=0,x=A.length;W<x;W++)O.buffer[W]=A[W];return O}static concat(A,O){if(typeof O>"u"){O=0;for(let H=0,B=A.length;H<B;H++)O+=A[H].byteLength}const W=w.alloc(O);let x=0;for(let H=0,B=A.length;H<B;H++){const X=A[H];W.set(X,x),x+=X.byteLength}return W}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=w.alloc(this.byteLength);return A.set(this),A}toString(){return P?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(A,O){return new w(this.buffer.subarray(A,O))}set(A,O){if(A instanceof w)this.buffer.set(A.buffer,O);else if(A instanceof Uint8Array)this.buffer.set(A,O);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),O);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return m(this.buffer,A)}writeUInt32BE(A,O){b(this.buffer,A,O)}readUInt32LE(A){return f(this.buffer,A)}writeUInt32LE(A,O){d(this.buffer,A,O)}readUInt8(A){return v(this.buffer,A)}writeUInt8(A,O){p(this.buffer,A,O)}indexOf(A,O=0){return c(this.buffer,A instanceof w?A.buffer:A,O)}}e.$Le=w;function c(L,A,O=0){const W=A.byteLength,x=L.byteLength;if(W===0)return 0;if(W===1)return L.indexOf(A[0]);if(W>x-O)return-1;const H=R.value;H.fill(A.length);for(let ae=0;ae<A.length;ae++)H[A[ae]]=A.length-ae-1;let B=O+A.length-1,X=B,G=-1;for(;B<x;)if(L[B]===A[X]){if(X===0){G=B;break}B--,X--}else B+=Math.max(A.length-X,H[L[B]]),X=A.length-1;return G}function g(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0}function h(L,A,O){L[O+0]=A&255,A=A>>>8,L[O+1]=A&255}function m(L,A){return L[A]*2**24+L[A+1]*2**16+L[A+2]*2**8+L[A+3]}function b(L,A,O){L[O+3]=A,A=A>>>8,L[O+2]=A,A=A>>>8,L[O+1]=A,A=A>>>8,L[O]=A}function f(L,A){return L[A+0]<<0>>>0|L[A+1]<<8>>>0|L[A+2]<<16>>>0|L[A+3]<<24>>>0}function d(L,A,O){L[O+0]=A&255,A=A>>>8,L[O+1]=A&255,A=A>>>8,L[O+2]=A&255,A=A>>>8,L[O+3]=A&255}function v(L,A){return L[A]}function p(L,A,O){L[O]=A}function $(L){return r.$Ae(L,A=>w.concat(A))}function k(L){return r.$He(L)}function S(L){return r.$Ce(L,A=>w.concat(A))}async function t(L){return L.ended?w.concat(L.buffer):w.concat([...L.buffer,await S(L.stream)])}function u(L){return r.$Fe(L,A=>w.concat(A))}function i(L){return r.$Ie(L,{data:A=>typeof A=="string"?w.fromString(A):w.wrap(A)},A=>w.concat(A))}function o(L){return r.$ze(A=>w.concat(A),L)}function s(L,A){return r.$Je(L,A,O=>w.concat(O))}function a(L,A){return r.$Ke(L,A,O=>w.concat(O))}function l(L){let A=0,O=0,W=0;const x=new Uint8Array(Math.floor(L.length/4*3)),H=X=>{switch(O){case 3:x[W++]=A|X,O=0;break;case 2:x[W++]=A|X>>>2,A=X<<6,O=3;break;case 1:x[W++]=A|X>>>4,A=X<<4,O=2;break;default:A=X<<2,O=1}};for(let X=0;X<L.length;X++){const G=L.charCodeAt(X);if(G>=65&&G<=90)H(G-65);else if(G>=97&&G<=122)H(G-97+26);else if(G>=48&&G<=57)H(G-48+52);else if(G===43||G===45)H(62);else if(G===47||G===95)H(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${L[X]}`)}}const B=W;for(;O>0;)H(0);return w.wrap(x).slice(0,B)}const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:L},A=!0,O=!1){const W=O?y:E;let x="";const H=L.byteLength%3;let B=0;for(;B<L.byteLength-H;B+=3){const X=L[B+0],G=L[B+1],ae=L[B+2];x+=W[X>>>2],x+=W[(X<<4|G>>>4)&63],x+=W[(G<<2|ae>>>6)&63],x+=W[ae&63]}if(H===1){const X=L[B+0];x+=W[X>>>2],x+=W[X<<4&63],A&&(x+="==")}else if(H===2){const X=L[B+0],G=L[B+1];x+=W[X>>>2],x+=W[(X<<4|G>>>4)&63],x+=W[G<<2&63],A&&(x+="=")}return x}}),define(le[146],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(le[12],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=n,e.$dg=r,e.$eg=P,e.$fg=R,e.$gg=T,e.$hg=I,e.$ig=w,e.$jg=c,e.$kg=g,e.$lg=h,e.$mg=m,e.$ng=b,e.$og=f,e.$pg=v,e.$qg=p,e.$rg=$,e.$sg=k,e.$tg=S;function n(t){return typeof t=="string"}function r(t){return Array.isArray(t)&&t.every(u=>n(u))}function P(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}function R(t){const u=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof u}function T(t){return typeof t=="number"&&!isNaN(t)}function I(t){return!!t&&typeof t[Symbol.iterator]=="function"}function w(t){return t===!0||t===!1}function c(t){return typeof t>"u"}function g(t){return!h(t)}function h(t){return c(t)||t===null}function m(t,u){if(!t)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function b(t){if(h(t))throw new Error("Assertion Failed: argument is undefined or null");return t}function f(...t){const u=[];for(let i=0;i<t.length;i++){const o=t[i];if(h(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);u.push(o)}return u}const d=Object.prototype.hasOwnProperty;function v(t){if(!P(t))return!1;for(const u in t)if(d.call(t,u))return!1;return!0}function p(t){return typeof t=="function"}function $(...t){return t.length>0&&t.every(p)}function k(t,u){const i=Math.min(t.length,u.length);for(let o=0;o<i;o++)S(t[o],u[o])}function S(t,u){if(n(u)){if(typeof t!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(p(u)){try{if(t instanceof u)return}catch{}if(!h(t)&&t.constructor===u||u.length===1&&u.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[109],ue([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=P,e.$Xj=R;const r=Object.create(null);function P(T,I){if((0,n.$cg)(I)){const w=r[I];if(w===void 0)throw new Error(`${T} references an unknown codicon: ${I}`);I=w}return r[T]=I,{id:T}}function R(){return r}}),define(le[147],ue([0,1,109]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yj=void 0,e.$Yj={add:(0,n.$Wj)("add",6e4),plus:(0,n.$Wj)("plus",6e4),gistNew:(0,n.$Wj)("gist-new",6e4),repoCreate:(0,n.$Wj)("repo-create",6e4),lightbulb:(0,n.$Wj)("lightbulb",60001),lightBulb:(0,n.$Wj)("light-bulb",60001),repo:(0,n.$Wj)("repo",60002),repoDelete:(0,n.$Wj)("repo-delete",60002),gistFork:(0,n.$Wj)("gist-fork",60003),repoForked:(0,n.$Wj)("repo-forked",60003),gitPullRequest:(0,n.$Wj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Wj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Wj)("record-keys",60005),keyboard:(0,n.$Wj)("keyboard",60005),tag:(0,n.$Wj)("tag",60006),gitPullRequestLabel:(0,n.$Wj)("git-pull-request-label",60006),tagAdd:(0,n.$Wj)("tag-add",60006),tagRemove:(0,n.$Wj)("tag-remove",60006),person:(0,n.$Wj)("person",60007),personFollow:(0,n.$Wj)("person-follow",60007),personOutline:(0,n.$Wj)("person-outline",60007),personFilled:(0,n.$Wj)("person-filled",60007),gitBranch:(0,n.$Wj)("git-branch",60008),gitBranchCreate:(0,n.$Wj)("git-branch-create",60008),gitBranchDelete:(0,n.$Wj)("git-branch-delete",60008),sourceControl:(0,n.$Wj)("source-control",60008),mirror:(0,n.$Wj)("mirror",60009),mirrorPublic:(0,n.$Wj)("mirror-public",60009),star:(0,n.$Wj)("star",60010),starAdd:(0,n.$Wj)("star-add",60010),starDelete:(0,n.$Wj)("star-delete",60010),starEmpty:(0,n.$Wj)("star-empty",60010),comment:(0,n.$Wj)("comment",60011),commentAdd:(0,n.$Wj)("comment-add",60011),alert:(0,n.$Wj)("alert",60012),warning:(0,n.$Wj)("warning",60012),search:(0,n.$Wj)("search",60013),searchSave:(0,n.$Wj)("search-save",60013),logOut:(0,n.$Wj)("log-out",60014),signOut:(0,n.$Wj)("sign-out",60014),logIn:(0,n.$Wj)("log-in",60015),signIn:(0,n.$Wj)("sign-in",60015),eye:(0,n.$Wj)("eye",60016),eyeUnwatch:(0,n.$Wj)("eye-unwatch",60016),eyeWatch:(0,n.$Wj)("eye-watch",60016),circleFilled:(0,n.$Wj)("circle-filled",60017),primitiveDot:(0,n.$Wj)("primitive-dot",60017),closeDirty:(0,n.$Wj)("close-dirty",60017),debugBreakpoint:(0,n.$Wj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Wj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Wj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Wj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Wj)("primitive-square",60018),edit:(0,n.$Wj)("edit",60019),pencil:(0,n.$Wj)("pencil",60019),info:(0,n.$Wj)("info",60020),issueOpened:(0,n.$Wj)("issue-opened",60020),gistPrivate:(0,n.$Wj)("gist-private",60021),gitForkPrivate:(0,n.$Wj)("git-fork-private",60021),lock:(0,n.$Wj)("lock",60021),mirrorPrivate:(0,n.$Wj)("mirror-private",60021),close:(0,n.$Wj)("close",60022),removeClose:(0,n.$Wj)("remove-close",60022),x:(0,n.$Wj)("x",60022),repoSync:(0,n.$Wj)("repo-sync",60023),sync:(0,n.$Wj)("sync",60023),clone:(0,n.$Wj)("clone",60024),desktopDownload:(0,n.$Wj)("desktop-download",60024),beaker:(0,n.$Wj)("beaker",60025),microscope:(0,n.$Wj)("microscope",60025),vm:(0,n.$Wj)("vm",60026),deviceDesktop:(0,n.$Wj)("device-desktop",60026),file:(0,n.$Wj)("file",60027),fileText:(0,n.$Wj)("file-text",60027),more:(0,n.$Wj)("more",60028),ellipsis:(0,n.$Wj)("ellipsis",60028),kebabHorizontal:(0,n.$Wj)("kebab-horizontal",60028),mailReply:(0,n.$Wj)("mail-reply",60029),reply:(0,n.$Wj)("reply",60029),organization:(0,n.$Wj)("organization",60030),organizationFilled:(0,n.$Wj)("organization-filled",60030),organizationOutline:(0,n.$Wj)("organization-outline",60030),newFile:(0,n.$Wj)("new-file",60031),fileAdd:(0,n.$Wj)("file-add",60031),newFolder:(0,n.$Wj)("new-folder",60032),fileDirectoryCreate:(0,n.$Wj)("file-directory-create",60032),trash:(0,n.$Wj)("trash",60033),trashcan:(0,n.$Wj)("trashcan",60033),history:(0,n.$Wj)("history",60034),clock:(0,n.$Wj)("clock",60034),folder:(0,n.$Wj)("folder",60035),fileDirectory:(0,n.$Wj)("file-directory",60035),symbolFolder:(0,n.$Wj)("symbol-folder",60035),logoGithub:(0,n.$Wj)("logo-github",60036),markGithub:(0,n.$Wj)("mark-github",60036),github:(0,n.$Wj)("github",60036),terminal:(0,n.$Wj)("terminal",60037),console:(0,n.$Wj)("console",60037),repl:(0,n.$Wj)("repl",60037),zap:(0,n.$Wj)("zap",60038),symbolEvent:(0,n.$Wj)("symbol-event",60038),error:(0,n.$Wj)("error",60039),stop:(0,n.$Wj)("stop",60039),variable:(0,n.$Wj)("variable",60040),symbolVariable:(0,n.$Wj)("symbol-variable",60040),array:(0,n.$Wj)("array",60042),symbolArray:(0,n.$Wj)("symbol-array",60042),symbolModule:(0,n.$Wj)("symbol-module",60043),symbolPackage:(0,n.$Wj)("symbol-package",60043),symbolNamespace:(0,n.$Wj)("symbol-namespace",60043),symbolObject:(0,n.$Wj)("symbol-object",60043),symbolMethod:(0,n.$Wj)("symbol-method",60044),symbolFunction:(0,n.$Wj)("symbol-function",60044),symbolConstructor:(0,n.$Wj)("symbol-constructor",60044),symbolBoolean:(0,n.$Wj)("symbol-boolean",60047),symbolNull:(0,n.$Wj)("symbol-null",60047),symbolNumeric:(0,n.$Wj)("symbol-numeric",60048),symbolNumber:(0,n.$Wj)("symbol-number",60048),symbolStructure:(0,n.$Wj)("symbol-structure",60049),symbolStruct:(0,n.$Wj)("symbol-struct",60049),symbolParameter:(0,n.$Wj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Wj)("symbol-type-parameter",60050),symbolKey:(0,n.$Wj)("symbol-key",60051),symbolText:(0,n.$Wj)("symbol-text",60051),symbolReference:(0,n.$Wj)("symbol-reference",60052),goToFile:(0,n.$Wj)("go-to-file",60052),symbolEnum:(0,n.$Wj)("symbol-enum",60053),symbolValue:(0,n.$Wj)("symbol-value",60053),symbolRuler:(0,n.$Wj)("symbol-ruler",60054),symbolUnit:(0,n.$Wj)("symbol-unit",60054),activateBreakpoints:(0,n.$Wj)("activate-breakpoints",60055),archive:(0,n.$Wj)("archive",60056),arrowBoth:(0,n.$Wj)("arrow-both",60057),arrowDown:(0,n.$Wj)("arrow-down",60058),arrowLeft:(0,n.$Wj)("arrow-left",60059),arrowRight:(0,n.$Wj)("arrow-right",60060),arrowSmallDown:(0,n.$Wj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Wj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Wj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Wj)("arrow-small-up",60064),arrowUp:(0,n.$Wj)("arrow-up",60065),bell:(0,n.$Wj)("bell",60066),bold:(0,n.$Wj)("bold",60067),book:(0,n.$Wj)("book",60068),bookmark:(0,n.$Wj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Wj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Wj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Wj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Wj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Wj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Wj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Wj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Wj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Wj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Wj)("briefcase",60076),broadcast:(0,n.$Wj)("broadcast",60077),browser:(0,n.$Wj)("browser",60078),bug:(0,n.$Wj)("bug",60079),calendar:(0,n.$Wj)("calendar",60080),caseSensitive:(0,n.$Wj)("case-sensitive",60081),check:(0,n.$Wj)("check",60082),checklist:(0,n.$Wj)("checklist",60083),chevronDown:(0,n.$Wj)("chevron-down",60084),chevronLeft:(0,n.$Wj)("chevron-left",60085),chevronRight:(0,n.$Wj)("chevron-right",60086),chevronUp:(0,n.$Wj)("chevron-up",60087),chromeClose:(0,n.$Wj)("chrome-close",60088),chromeMaximize:(0,n.$Wj)("chrome-maximize",60089),chromeMinimize:(0,n.$Wj)("chrome-minimize",60090),chromeRestore:(0,n.$Wj)("chrome-restore",60091),circleOutline:(0,n.$Wj)("circle-outline",60092),circle:(0,n.$Wj)("circle",60092),debugBreakpointUnverified:(0,n.$Wj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Wj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Wj)("circle-slash",60093),circuitBoard:(0,n.$Wj)("circuit-board",60094),clearAll:(0,n.$Wj)("clear-all",60095),clippy:(0,n.$Wj)("clippy",60096),closeAll:(0,n.$Wj)("close-all",60097),cloudDownload:(0,n.$Wj)("cloud-download",60098),cloudUpload:(0,n.$Wj)("cloud-upload",60099),code:(0,n.$Wj)("code",60100),collapseAll:(0,n.$Wj)("collapse-all",60101),colorMode:(0,n.$Wj)("color-mode",60102),commentDiscussion:(0,n.$Wj)("comment-discussion",60103),creditCard:(0,n.$Wj)("credit-card",60105),dash:(0,n.$Wj)("dash",60108),dashboard:(0,n.$Wj)("dashboard",60109),database:(0,n.$Wj)("database",60110),debugContinue:(0,n.$Wj)("debug-continue",60111),debugDisconnect:(0,n.$Wj)("debug-disconnect",60112),debugPause:(0,n.$Wj)("debug-pause",60113),debugRestart:(0,n.$Wj)("debug-restart",60114),debugStart:(0,n.$Wj)("debug-start",60115),debugStepInto:(0,n.$Wj)("debug-step-into",60116),debugStepOut:(0,n.$Wj)("debug-step-out",60117),debugStepOver:(0,n.$Wj)("debug-step-over",60118),debugStop:(0,n.$Wj)("debug-stop",60119),debug:(0,n.$Wj)("debug",60120),deviceCameraVideo:(0,n.$Wj)("device-camera-video",60121),deviceCamera:(0,n.$Wj)("device-camera",60122),deviceMobile:(0,n.$Wj)("device-mobile",60123),diffAdded:(0,n.$Wj)("diff-added",60124),diffIgnored:(0,n.$Wj)("diff-ignored",60125),diffModified:(0,n.$Wj)("diff-modified",60126),diffRemoved:(0,n.$Wj)("diff-removed",60127),diffRenamed:(0,n.$Wj)("diff-renamed",60128),diff:(0,n.$Wj)("diff",60129),diffSidebyside:(0,n.$Wj)("diff-sidebyside",60129),discard:(0,n.$Wj)("discard",60130),editorLayout:(0,n.$Wj)("editor-layout",60131),emptyWindow:(0,n.$Wj)("empty-window",60132),exclude:(0,n.$Wj)("exclude",60133),extensions:(0,n.$Wj)("extensions",60134),eyeClosed:(0,n.$Wj)("eye-closed",60135),fileBinary:(0,n.$Wj)("file-binary",60136),fileCode:(0,n.$Wj)("file-code",60137),fileMedia:(0,n.$Wj)("file-media",60138),filePdf:(0,n.$Wj)("file-pdf",60139),fileSubmodule:(0,n.$Wj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Wj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Wj)("file-symlink-file",60142),fileZip:(0,n.$Wj)("file-zip",60143),files:(0,n.$Wj)("files",60144),filter:(0,n.$Wj)("filter",60145),flame:(0,n.$Wj)("flame",60146),foldDown:(0,n.$Wj)("fold-down",60147),foldUp:(0,n.$Wj)("fold-up",60148),fold:(0,n.$Wj)("fold",60149),folderActive:(0,n.$Wj)("folder-active",60150),folderOpened:(0,n.$Wj)("folder-opened",60151),gear:(0,n.$Wj)("gear",60152),gift:(0,n.$Wj)("gift",60153),gistSecret:(0,n.$Wj)("gist-secret",60154),gist:(0,n.$Wj)("gist",60155),gitCommit:(0,n.$Wj)("git-commit",60156),gitCompare:(0,n.$Wj)("git-compare",60157),compareChanges:(0,n.$Wj)("compare-changes",60157),gitMerge:(0,n.$Wj)("git-merge",60158),githubAction:(0,n.$Wj)("github-action",60159),githubAlt:(0,n.$Wj)("github-alt",60160),globe:(0,n.$Wj)("globe",60161),grabber:(0,n.$Wj)("grabber",60162),graph:(0,n.$Wj)("graph",60163),gripper:(0,n.$Wj)("gripper",60164),heart:(0,n.$Wj)("heart",60165),home:(0,n.$Wj)("home",60166),horizontalRule:(0,n.$Wj)("horizontal-rule",60167),hubot:(0,n.$Wj)("hubot",60168),inbox:(0,n.$Wj)("inbox",60169),issueReopened:(0,n.$Wj)("issue-reopened",60171),issues:(0,n.$Wj)("issues",60172),italic:(0,n.$Wj)("italic",60173),jersey:(0,n.$Wj)("jersey",60174),json:(0,n.$Wj)("json",60175),kebabVertical:(0,n.$Wj)("kebab-vertical",60176),key:(0,n.$Wj)("key",60177),law:(0,n.$Wj)("law",60178),lightbulbAutofix:(0,n.$Wj)("lightbulb-autofix",60179),linkExternal:(0,n.$Wj)("link-external",60180),link:(0,n.$Wj)("link",60181),listOrdered:(0,n.$Wj)("list-ordered",60182),listUnordered:(0,n.$Wj)("list-unordered",60183),liveShare:(0,n.$Wj)("live-share",60184),loading:(0,n.$Wj)("loading",60185),location:(0,n.$Wj)("location",60186),mailRead:(0,n.$Wj)("mail-read",60187),mail:(0,n.$Wj)("mail",60188),markdown:(0,n.$Wj)("markdown",60189),megaphone:(0,n.$Wj)("megaphone",60190),mention:(0,n.$Wj)("mention",60191),milestone:(0,n.$Wj)("milestone",60192),gitPullRequestMilestone:(0,n.$Wj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Wj)("mortar-board",60193),move:(0,n.$Wj)("move",60194),multipleWindows:(0,n.$Wj)("multiple-windows",60195),mute:(0,n.$Wj)("mute",60196),noNewline:(0,n.$Wj)("no-newline",60197),note:(0,n.$Wj)("note",60198),octoface:(0,n.$Wj)("octoface",60199),openPreview:(0,n.$Wj)("open-preview",60200),package:(0,n.$Wj)("package",60201),paintcan:(0,n.$Wj)("paintcan",60202),pin:(0,n.$Wj)("pin",60203),play:(0,n.$Wj)("play",60204),run:(0,n.$Wj)("run",60204),plug:(0,n.$Wj)("plug",60205),preserveCase:(0,n.$Wj)("preserve-case",60206),preview:(0,n.$Wj)("preview",60207),project:(0,n.$Wj)("project",60208),pulse:(0,n.$Wj)("pulse",60209),question:(0,n.$Wj)("question",60210),quote:(0,n.$Wj)("quote",60211),radioTower:(0,n.$Wj)("radio-tower",60212),reactions:(0,n.$Wj)("reactions",60213),references:(0,n.$Wj)("references",60214),refresh:(0,n.$Wj)("refresh",60215),regex:(0,n.$Wj)("regex",60216),remoteExplorer:(0,n.$Wj)("remote-explorer",60217),remote:(0,n.$Wj)("remote",60218),remove:(0,n.$Wj)("remove",60219),replaceAll:(0,n.$Wj)("replace-all",60220),replace:(0,n.$Wj)("replace",60221),repoClone:(0,n.$Wj)("repo-clone",60222),repoForcePush:(0,n.$Wj)("repo-force-push",60223),repoPull:(0,n.$Wj)("repo-pull",60224),repoPush:(0,n.$Wj)("repo-push",60225),report:(0,n.$Wj)("report",60226),requestChanges:(0,n.$Wj)("request-changes",60227),rocket:(0,n.$Wj)("rocket",60228),rootFolderOpened:(0,n.$Wj)("root-folder-opened",60229),rootFolder:(0,n.$Wj)("root-folder",60230),rss:(0,n.$Wj)("rss",60231),ruby:(0,n.$Wj)("ruby",60232),saveAll:(0,n.$Wj)("save-all",60233),saveAs:(0,n.$Wj)("save-as",60234),save:(0,n.$Wj)("save",60235),screenFull:(0,n.$Wj)("screen-full",60236),screenNormal:(0,n.$Wj)("screen-normal",60237),searchStop:(0,n.$Wj)("search-stop",60238),server:(0,n.$Wj)("server",60240),settingsGear:(0,n.$Wj)("settings-gear",60241),settings:(0,n.$Wj)("settings",60242),shield:(0,n.$Wj)("shield",60243),smiley:(0,n.$Wj)("smiley",60244),sortPrecedence:(0,n.$Wj)("sort-precedence",60245),splitHorizontal:(0,n.$Wj)("split-horizontal",60246),splitVertical:(0,n.$Wj)("split-vertical",60247),squirrel:(0,n.$Wj)("squirrel",60248),starFull:(0,n.$Wj)("star-full",60249),starHalf:(0,n.$Wj)("star-half",60250),symbolClass:(0,n.$Wj)("symbol-class",60251),symbolColor:(0,n.$Wj)("symbol-color",60252),symbolConstant:(0,n.$Wj)("symbol-constant",60253),symbolEnumMember:(0,n.$Wj)("symbol-enum-member",60254),symbolField:(0,n.$Wj)("symbol-field",60255),symbolFile:(0,n.$Wj)("symbol-file",60256),symbolInterface:(0,n.$Wj)("symbol-interface",60257),symbolKeyword:(0,n.$Wj)("symbol-keyword",60258),symbolMisc:(0,n.$Wj)("symbol-misc",60259),symbolOperator:(0,n.$Wj)("symbol-operator",60260),symbolProperty:(0,n.$Wj)("symbol-property",60261),wrench:(0,n.$Wj)("wrench",60261),wrenchSubaction:(0,n.$Wj)("wrench-subaction",60261),symbolSnippet:(0,n.$Wj)("symbol-snippet",60262),tasklist:(0,n.$Wj)("tasklist",60263),telescope:(0,n.$Wj)("telescope",60264),textSize:(0,n.$Wj)("text-size",60265),threeBars:(0,n.$Wj)("three-bars",60266),thumbsdown:(0,n.$Wj)("thumbsdown",60267),thumbsup:(0,n.$Wj)("thumbsup",60268),tools:(0,n.$Wj)("tools",60269),triangleDown:(0,n.$Wj)("triangle-down",60270),triangleLeft:(0,n.$Wj)("triangle-left",60271),triangleRight:(0,n.$Wj)("triangle-right",60272),triangleUp:(0,n.$Wj)("triangle-up",60273),twitter:(0,n.$Wj)("twitter",60274),unfold:(0,n.$Wj)("unfold",60275),unlock:(0,n.$Wj)("unlock",60276),unmute:(0,n.$Wj)("unmute",60277),unverified:(0,n.$Wj)("unverified",60278),verified:(0,n.$Wj)("verified",60279),versions:(0,n.$Wj)("versions",60280),vmActive:(0,n.$Wj)("vm-active",60281),vmOutline:(0,n.$Wj)("vm-outline",60282),vmRunning:(0,n.$Wj)("vm-running",60283),watch:(0,n.$Wj)("watch",60284),whitespace:(0,n.$Wj)("whitespace",60285),wholeWord:(0,n.$Wj)("whole-word",60286),window:(0,n.$Wj)("window",60287),wordWrap:(0,n.$Wj)("word-wrap",60288),zoomIn:(0,n.$Wj)("zoom-in",60289),zoomOut:(0,n.$Wj)("zoom-out",60290),listFilter:(0,n.$Wj)("list-filter",60291),listFlat:(0,n.$Wj)("list-flat",60292),listSelection:(0,n.$Wj)("list-selection",60293),selection:(0,n.$Wj)("selection",60293),listTree:(0,n.$Wj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Wj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Wj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Wj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Wj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Wj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Wj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Wj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Wj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Wj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Wj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Wj)("symbol-string",60301),debugReverseContinue:(0,n.$Wj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Wj)("debug-step-back",60303),debugRestartFrame:(0,n.$Wj)("debug-restart-frame",60304),debugAlt:(0,n.$Wj)("debug-alt",60305),callIncoming:(0,n.$Wj)("call-incoming",60306),callOutgoing:(0,n.$Wj)("call-outgoing",60307),menu:(0,n.$Wj)("menu",60308),expandAll:(0,n.$Wj)("expand-all",60309),feedback:(0,n.$Wj)("feedback",60310),gitPullRequestReviewer:(0,n.$Wj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Wj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Wj)("ungroup-by-ref-type",60312),account:(0,n.$Wj)("account",60313),gitPullRequestAssignee:(0,n.$Wj)("git-pull-request-assignee",60313),bellDot:(0,n.$Wj)("bell-dot",60314),debugConsole:(0,n.$Wj)("debug-console",60315),library:(0,n.$Wj)("library",60316),output:(0,n.$Wj)("output",60317),runAll:(0,n.$Wj)("run-all",60318),syncIgnored:(0,n.$Wj)("sync-ignored",60319),pinned:(0,n.$Wj)("pinned",60320),githubInverted:(0,n.$Wj)("github-inverted",60321),serverProcess:(0,n.$Wj)("server-process",60322),serverEnvironment:(0,n.$Wj)("server-environment",60323),pass:(0,n.$Wj)("pass",60324),issueClosed:(0,n.$Wj)("issue-closed",60324),stopCircle:(0,n.$Wj)("stop-circle",60325),playCircle:(0,n.$Wj)("play-circle",60326),record:(0,n.$Wj)("record",60327),debugAltSmall:(0,n.$Wj)("debug-alt-small",60328),vmConnect:(0,n.$Wj)("vm-connect",60329),cloud:(0,n.$Wj)("cloud",60330),merge:(0,n.$Wj)("merge",60331),export:(0,n.$Wj)("export",60332),graphLeft:(0,n.$Wj)("graph-left",60333),magnet:(0,n.$Wj)("magnet",60334),notebook:(0,n.$Wj)("notebook",60335),redo:(0,n.$Wj)("redo",60336),checkAll:(0,n.$Wj)("check-all",60337),pinnedDirty:(0,n.$Wj)("pinned-dirty",60338),passFilled:(0,n.$Wj)("pass-filled",60339),circleLargeFilled:(0,n.$Wj)("circle-large-filled",60340),circleLarge:(0,n.$Wj)("circle-large",60341),circleLargeOutline:(0,n.$Wj)("circle-large-outline",60341),combine:(0,n.$Wj)("combine",60342),gather:(0,n.$Wj)("gather",60342),table:(0,n.$Wj)("table",60343),variableGroup:(0,n.$Wj)("variable-group",60344),typeHierarchy:(0,n.$Wj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Wj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Wj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Wj)("git-pull-request-create",60348),runAbove:(0,n.$Wj)("run-above",60349),runBelow:(0,n.$Wj)("run-below",60350),notebookTemplate:(0,n.$Wj)("notebook-template",60351),debugRerun:(0,n.$Wj)("debug-rerun",60352),workspaceTrusted:(0,n.$Wj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Wj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Wj)("workspace-unknown",60355),terminalCmd:(0,n.$Wj)("terminal-cmd",60356),terminalDebian:(0,n.$Wj)("terminal-debian",60357),terminalLinux:(0,n.$Wj)("terminal-linux",60358),terminalPowershell:(0,n.$Wj)("terminal-powershell",60359),terminalTmux:(0,n.$Wj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Wj)("terminal-ubuntu",60361),terminalBash:(0,n.$Wj)("terminal-bash",60362),arrowSwap:(0,n.$Wj)("arrow-swap",60363),copy:(0,n.$Wj)("copy",60364),personAdd:(0,n.$Wj)("person-add",60365),filterFilled:(0,n.$Wj)("filter-filled",60366),wand:(0,n.$Wj)("wand",60367),debugLineByLine:(0,n.$Wj)("debug-line-by-line",60368),inspect:(0,n.$Wj)("inspect",60369),layers:(0,n.$Wj)("layers",60370),layersDot:(0,n.$Wj)("layers-dot",60371),layersActive:(0,n.$Wj)("layers-active",60372),compass:(0,n.$Wj)("compass",60373),compassDot:(0,n.$Wj)("compass-dot",60374),compassActive:(0,n.$Wj)("compass-active",60375),azure:(0,n.$Wj)("azure",60376),issueDraft:(0,n.$Wj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Wj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Wj)("git-pull-request-draft",60379),debugAll:(0,n.$Wj)("debug-all",60380),debugCoverage:(0,n.$Wj)("debug-coverage",60381),runErrors:(0,n.$Wj)("run-errors",60382),folderLibrary:(0,n.$Wj)("folder-library",60383),debugContinueSmall:(0,n.$Wj)("debug-continue-small",60384),beakerStop:(0,n.$Wj)("beaker-stop",60385),graphLine:(0,n.$Wj)("graph-line",60386),graphScatter:(0,n.$Wj)("graph-scatter",60387),pieChart:(0,n.$Wj)("pie-chart",60388),bracket:(0,n.$Wj)("bracket",60175),bracketDot:(0,n.$Wj)("bracket-dot",60389),bracketError:(0,n.$Wj)("bracket-error",60390),lockSmall:(0,n.$Wj)("lock-small",60391),azureDevops:(0,n.$Wj)("azure-devops",60392),verifiedFilled:(0,n.$Wj)("verified-filled",60393),newline:(0,n.$Wj)("newline",60394),layout:(0,n.$Wj)("layout",60395),layoutActivitybarLeft:(0,n.$Wj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Wj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Wj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Wj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Wj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Wj)("layout-panel-right",60401),layoutPanel:(0,n.$Wj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Wj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Wj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Wj)("layout-statusbar",60405),layoutMenubar:(0,n.$Wj)("layout-menubar",60406),layoutCentered:(0,n.$Wj)("layout-centered",60407),target:(0,n.$Wj)("target",60408),indent:(0,n.$Wj)("indent",60409),recordSmall:(0,n.$Wj)("record-small",60410),errorSmall:(0,n.$Wj)("error-small",60411),terminalDecorationError:(0,n.$Wj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Wj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Wj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Wj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Wj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Wj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Wj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Wj)("layout-sidebar-left-off",60418),blank:(0,n.$Wj)("blank",60419),heartFilled:(0,n.$Wj)("heart-filled",60420),map:(0,n.$Wj)("map",60421),mapHorizontal:(0,n.$Wj)("map-horizontal",60421),foldHorizontal:(0,n.$Wj)("fold-horizontal",60421),mapFilled:(0,n.$Wj)("map-filled",60422),mapHorizontalFilled:(0,n.$Wj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Wj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Wj)("circle-small",60423),bellSlash:(0,n.$Wj)("bell-slash",60424),bellSlashDot:(0,n.$Wj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Wj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Wj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Wj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Wj)("search-fuzzy",60429),commentDraft:(0,n.$Wj)("comment-draft",60430),send:(0,n.$Wj)("send",60431),sparkle:(0,n.$Wj)("sparkle",60432),insert:(0,n.$Wj)("insert",60433),mic:(0,n.$Wj)("mic",60434),thumbsdownFilled:(0,n.$Wj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Wj)("thumbsup-filled",60436),coffee:(0,n.$Wj)("coffee",60437),snake:(0,n.$Wj)("snake",60438),game:(0,n.$Wj)("game",60439),vr:(0,n.$Wj)("vr",60440),chip:(0,n.$Wj)("chip",60441),piano:(0,n.$Wj)("piano",60442),music:(0,n.$Wj)("music",60443),micFilled:(0,n.$Wj)("mic-filled",60444),repoFetch:(0,n.$Wj)("repo-fetch",60445),copilot:(0,n.$Wj)("copilot",60446),lightbulbSparkle:(0,n.$Wj)("lightbulb-sparkle",60447),robot:(0,n.$Wj)("robot",60448),sparkleFilled:(0,n.$Wj)("sparkle-filled",60449),diffSingle:(0,n.$Wj)("diff-single",60450),diffMultiple:(0,n.$Wj)("diff-multiple",60451),surroundWith:(0,n.$Wj)("surround-with",60452),share:(0,n.$Wj)("share",60453),gitStash:(0,n.$Wj)("git-stash",60454),gitStashApply:(0,n.$Wj)("git-stash-apply",60455),gitStashPop:(0,n.$Wj)("git-stash-pop",60456),vscode:(0,n.$Wj)("vscode",60457),vscodeInsiders:(0,n.$Wj)("vscode-insiders",60458),codeOss:(0,n.$Wj)("code-oss",60459),runCoverage:(0,n.$Wj)("run-coverage",60460),runAllCoverage:(0,n.$Wj)("run-all-coverage",60461),coverage:(0,n.$Wj)("coverage",60462),githubProject:(0,n.$Wj)("github-project",60463),mapVertical:(0,n.$Wj)("map-vertical",60464),foldVertical:(0,n.$Wj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Wj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Wj)("fold-vertical-filled",60465),goToSearch:(0,n.$Wj)("go-to-search",60466),percentage:(0,n.$Wj)("percentage",60467),sortPercentage:(0,n.$Wj)("sort-percentage",60467),attach:(0,n.$Wj)("attach",60468)}}),define(le[80],ue([0,1,109,147]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=void 0,e.$Zj=P;function P(){return Object.values(e.$2j)}e.$1j={dialogError:(0,n.$Wj)("dialog-error","error"),dialogWarning:(0,n.$Wj)("dialog-warning","warning"),dialogInfo:(0,n.$Wj)("dialog-info","info"),dialogClose:(0,n.$Wj)("dialog-close","close"),treeItemExpanded:(0,n.$Wj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Wj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Wj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Wj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Wj)("tree-item-loading","loading"),menuSelection:(0,n.$Wj)("menu-selection","check"),menuSubmenu:(0,n.$Wj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Wj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Wj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Wj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Wj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Wj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Wj)("toolbar-more","more"),quickInputBack:(0,n.$Wj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Wj)("drop-down-button",60084),symbolCustomColor:(0,n.$Wj)("symbol-customcolor",60252),exportIcon:(0,n.$Wj)("export",60332),workspaceUnspecified:(0,n.$Wj)("workspace-unspecified",60355),newLine:(0,n.$Wj)("newline",60394),thumbsDownFilled:(0,n.$Wj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Wj)("thumbsup-filled",60436),gitFetch:(0,n.$Wj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Wj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Wj)("debug-breakpoint-pending",60377)},e.$2j={...r.$Yj,...e.$1j}}),define(le[37],ue([0,1,12]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=r,e.$co=P,e.$do=T,e.$eo=w,e.$fo=c,e.$go=g,e.$ho=h,e.$io=m,e.$jo=b,e.$ko=f,e.$lo=d,e.$mo=v,e.$no=p;function r($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const k=Array.isArray($)?[]:{};return Object.entries($).forEach(([S,t])=>{k[S]=t&&typeof t=="object"?r(t):t}),k}function P($){if(!$||typeof $!="object")return $;const k=[$];for(;k.length>0;){const S=k.shift();Object.freeze(S);for(const t in S)if(R.call(S,t)){const u=S[t];typeof u=="object"&&!Object.isFrozen(u)&&!(0,n.$fg)(u)&&k.push(u)}}return $}const R=Object.prototype.hasOwnProperty;function T($,k){return I($,k,new Set)}function I($,k,S){if((0,n.$lg)($))return $;const t=k($);if(typeof t<"u")return t;if(Array.isArray($)){const u=[];for(const i of $)u.push(I(i,k,S));return u}if((0,n.$eg)($)){if(S.has($))throw new Error("Cannot clone recursive data-structure");S.add($);const u={};for(const i in $)R.call($,i)&&(u[i]=I($[i],k,S));return S.delete($),u}return $}function w($,k,S=!0){return(0,n.$eg)($)?((0,n.$eg)(k)&&Object.keys(k).forEach(t=>{t in $?S&&((0,n.$eg)($[t])&&(0,n.$eg)(k[t])?w($[t],k[t],S):$[t]=k[t]):$[t]=k[t]}),$):k}function c($,k){if($===k)return!0;if($==null||k===null||k===void 0||typeof $!=typeof k||typeof $!="object"||Array.isArray($)!==Array.isArray(k))return!1;let S,t;if(Array.isArray($)){if($.length!==k.length)return!1;for(S=0;S<$.length;S++)if(!c($[S],k[S]))return!1}else{const u=[];for(t in $)u.push(t);u.sort();const i=[];for(t in k)i.push(t);if(i.sort(),!c(u,i))return!1;for(S=0;S<u.length;S++)if(!c($[u[S]],k[u[S]]))return!1}return!0}function g($){const k=new Set;return JSON.stringify($,(S,t)=>{if((0,n.$eg)(t)||Array.isArray(t)){if(k.has(t))return"[Circular]";k.add(t)}return typeof t=="bigint"?`[BigInt ${t.toString()}]`:t})}function h($,k){const S=Object.create(null);return!$||!k||Object.keys(k).forEach(u=>{const i=$[u],o=k[u];c(i,o)||(S[u]=o)}),S}function m($,k){const S=k.toLowerCase(),t=Object.keys($).find(u=>u.toLowerCase()===S);return t?$[t]:$[k]}function b($,k){const S=Object.create(null);for(const[t,u]of Object.entries($))k(t,u)&&(S[t]=u);return S}function f($){let k=[];for(;Object.prototype!==$;)k=k.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return k}function d($){const k=[];for(const S of f($))typeof $[S]=="function"&&k.push(S);return k}function v($,k){const S=u=>function(){const i=Array.prototype.slice.call(arguments,0);return k(u,i)},t={};for(const u of $)t[u]=S(u);return t}function p($,k){const S={};for(const[t,u]of Object.entries($))S[t]=k(u,t);return S}}),define(le[110],ue([0,1,80]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$3j=P;var r;(function(T){function I(w){return w&&typeof w=="object"&&typeof w.id=="string"}T.isThemeColor=I})(r||(e.ThemeColor=r={}));function P(T){return{id:T}}var R;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function w($){const k=I.exec($.id);if(!k)return w(n.$2j.error);const[,S,t]=k,u=["codicon","codicon-"+S];return t&&u.push("codicon-modifier-"+t.substring(1)),u}T.asClassNameArray=w;function c($){return w($).join(" ")}T.asClassName=c;function g($){return"."+w($).join(".")}T.asCSSSelector=g;function h($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||r.isThemeColor($.color))}T.isThemeIcon=h;const m=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function b($){const k=m.exec($);if(!k)return;const[,S]=k;return{id:S}}T.fromString=b;function f($){return{id:$}}T.fromId=f;function d($,k){let S=$.id;const t=S.lastIndexOf("~");return t!==-1&&(S=S.substring(0,t)),k&&(S=`${S}~${k}`),{id:S}}T.modify=d;function v($){const k=$.id.lastIndexOf("~");if(k!==-1)return $.id.substring(k+1)}T.getModifier=v;function p($,k){return $.id===k.id&&$.color?.id===k.color?.id}T.isEqual=p})(R||(e.ThemeIcon=R={}))}),define(le[148],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=r,e.$_e=P;var n;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(R){return R<0?0:R>n.MAX_UINT_8?n.MAX_UINT_8:R|0}function P(R){return R<0?0:R>n.MAX_UINT_32?n.MAX_UINT_32:R|0}}),define(le[25],ue([0,1,145,39,65,148]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=T,e.$bf=w,e.$cf=g,e.$df=h,e.$ef=m,e.$ff=b,e.$gf=f,e.$hf=d,e.$if=v,e.$jf=p,e.$kf=$,e.$lf=k,e.$mf=S,e.$nf=t,e.$of=u,e.$pf=i,e.$qf=o,e.$rf=s,e.$sf=a,e.$tf=l,e.$uf=E,e.$vf=y,e.$wf=D,e.$xf=L,e.$yf=A,e.$zf=O,e.$Af=W,e.$Bf=x,e.$Cf=H,e.$Df=B,e.$Ef=X,e.$Ff=G,e.$Gf=ae,e.$Hf=K,e.$If=te,e.$Jf=U,e.$Kf=j,e.$Nf=V,e.$Of=he,e.$Pf=oe,e.$Qf=ee,e.$Rf=C,e.$Sf=Z,e.$Uf=Q,e.$Vf=q,e.$Wf=se,e.$Xf=de,e.$Yf=we,e.$Zf=De,e.$1f=Pe,e.$3f=Re,e.$4f=$e,e.$5f=_,e.$6f=ce,e.$7f=fe,e.$8f=be,e.$9f=Ae,e.$0f=Ce,e.$$f=Qe;function T(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const I=/{(\d+)}/g;function w(ne,...ge){return ge.length===0?ne:ne.replace(I,function(pe,ye){const We=parseInt(ye,10);return isNaN(We)||We<0||We>=ge.length?pe:ge[We]})}const c=/{([^}]+)}/g;function g(ne,ge){return Object.keys(ge).length===0?ne:ne.replace(c,(pe,ye)=>ge[ye]??pe)}function h(ne){return ne.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function m(ne){return ne.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function b(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ne,ge){let pe=0,ye=ne.indexOf(ge);for(;ye!==-1;)pe++,ye=ne.indexOf(ge,ye+ge.length);return pe}function d(ne,ge,pe="\u2026"){return ne.length<=ge?ne:`${ne.substr(0,ge)}${pe}`}function v(ne,ge,pe="\u2026"){if(ne.length<=ge)return ne;const ye=Math.ceil(ge/2)-pe.length/2,We=Math.floor(ge/2)-pe.length/2;return`${ne.substr(0,ye)}${pe}${ne.substr(ne.length-We)}`}function p(ne,ge=" "){const pe=$(ne,ge);return k(pe,ge)}function $(ne,ge){if(!ne||!ge)return ne;const pe=ge.length;if(pe===0||ne.length===0)return ne;let ye=0;for(;ne.indexOf(ge,ye)===ye;)ye=ye+pe;return ne.substring(ye)}function k(ne,ge){if(!ne||!ge)return ne;const pe=ge.length,ye=ne.length;if(pe===0||ye===0)return ne;let We=ye,Ue=-1;for(;Ue=ne.lastIndexOf(ge,We-1),!(Ue===-1||Ue+pe!==We);){if(Ue===0)return"";We=Ue}return ne.substring(0,We)}function S(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(ne){return ne.replace(/\*/g,"")}function u(ne,ge,pe={}){if(!ne)throw new Error("Cannot create regex from empty string");ge||(ne=b(ne)),pe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(ne,ye)}function i(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function o(ne){return ne.split(/\r\n|\r|\n/)}function s(ne){const ge=[],pe=ne.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)ge.push(pe[2*ye]+(pe[2*ye+1]??""));return ge}function a(ne){for(let ge=0,pe=ne.length;ge<pe;ge++){const ye=ne.charCodeAt(ge);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return ge}return-1}function l(ne,ge=0,pe=ne.length){for(let ye=ge;ye<pe;ye++){const We=ne.charCodeAt(ye);if(We!==r.CharCode.Space&&We!==r.CharCode.Tab)return ne.substring(ge,ye)}return ne.substring(ge,pe)}function E(ne,ge=ne.length-1){for(let pe=ge;pe>=0;pe--){const ye=ne.charCodeAt(pe);if(ye!==r.CharCode.Space&&ye!==r.CharCode.Tab)return pe}return-1}function y(ne,ge,pe){const ye=[];let We=0;for(const Ue of ne.matchAll(ge)){if(ye.push(ne.slice(We,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");We=Ue.index+Ue[0].length,ye.push(pe(Ue[0],...Ue.slice(1),Ue.index,ne,Ue.groups))}return ye.push(ne.slice(We)),Promise.all(ye).then(Ue=>Ue.join(""))}function D(ne,ge){return ne<ge?-1:ne>ge?1:0}function L(ne,ge,pe=0,ye=ne.length,We=0,Ue=ge.length){for(;pe<ye&&We<Ue;pe++,We++){const rt=ne.charCodeAt(pe),at=ge.charCodeAt(We);if(rt<at)return-1;if(rt>at)return 1}const Ze=ye-pe,lt=Ue-We;return Ze<lt?-1:Ze>lt?1:0}function A(ne,ge){return O(ne,ge,0,ne.length,0,ge.length)}function O(ne,ge,pe=0,ye=ne.length,We=0,Ue=ge.length){for(;pe<ye&&We<Ue;pe++,We++){let rt=ne.charCodeAt(pe),at=ge.charCodeAt(We);if(rt===at)continue;if(rt>=128||at>=128)return L(ne.toLowerCase(),ge.toLowerCase(),pe,ye,We,Ue);x(rt)&&(rt-=32),x(at)&&(at-=32);const tt=rt-at;if(tt!==0)return tt}const Ze=ye-pe,lt=Ue-We;return Ze<lt?-1:Ze>lt?1:0}function W(ne){return ne>=r.CharCode.Digit0&&ne<=r.CharCode.Digit9}function x(ne){return ne>=r.CharCode.a&&ne<=r.CharCode.z}function H(ne){return ne>=r.CharCode.A&&ne<=r.CharCode.Z}function B(ne,ge){return ne.length===ge.length&&O(ne,ge)===0}function X(ne,ge){const pe=ge.length;return ge.length>ne.length?!1:O(ne,ge,0,pe)===0}function G(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(ye)!==ge.charCodeAt(ye))return ye;return pe}function ae(ne,ge){const pe=Math.min(ne.length,ge.length);let ye;const We=ne.length-1,Ue=ge.length-1;for(ye=0;ye<pe;ye++)if(ne.charCodeAt(We-ye)!==ge.charCodeAt(Ue-ye))return ye;return pe}function K(ne){return 55296<=ne&&ne<=56319}function te(ne){return 56320<=ne&&ne<=57343}function U(ne,ge){return(ne-55296<<10)+(ge-56320)+65536}function j(ne,ge,pe){const ye=ne.charCodeAt(pe);if(K(ye)&&pe+1<ge){const We=ne.charCodeAt(pe+1);if(te(We))return U(ye,We)}return ye}function N(ne,ge){const pe=ne.charCodeAt(ge-1);if(te(pe)&&ge>1){const ye=ne.charCodeAt(ge-2);if(K(ye))return U(ye,pe)}return pe}class Y{get offset(){return this.e}constructor(ge,pe=0){this.c=ge,this.d=ge.length,this.e=pe}setOffset(ge){this.e=ge}prevCodePoint(){const ge=N(this.c,this.e);return this.e-=ge>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=j(this.c,this.d,this.e);return this.e+=ge>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Lf=Y;class ie{get offset(){return this.c.offset}constructor(ge,pe=0){this.c=new Y(ge,pe)}nextGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let We=ge.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Ue=pe.offset,Ze=ge.getGraphemeBreakType(pe.nextCodePoint());if(Me(We,Ze)){pe.setOffset(Ue);break}We=Ze}return pe.offset-ye}prevGraphemeLength(){const ge=Be.getInstance(),pe=this.c,ye=pe.offset;let We=ge.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Ue=pe.offset,Ze=ge.getGraphemeBreakType(pe.prevCodePoint());if(Me(Ze,We)){pe.setOffset(Ue);break}We=Ze}return ye-pe.offset}eol(){return this.c.eol()}}e.$Mf=ie;function V(ne,ge){return new ie(ne,ge).nextGraphemeLength()}function he(ne,ge){return new ie(ne,ge).prevGraphemeLength()}function oe(ne,ge){ge>0&&te(ne.charCodeAt(ge))&&ge--;const pe=ge+V(ne,ge);return[pe-he(ne,pe),pe]}function ee(ne){const ge=new ie(ne);let pe=0;for(;!ge.eol();)pe++,ge.nextGraphemeLength();return pe}let M;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(ne){return M||(M=F()),M.test(ne)}const z=/^[\t\n\r\x20-\x7E]*$/;function Z(ne){return z.test(ne)}e.$Tf=/[\u2028\u2029]/;function Q(ne){return e.$Tf.test(ne)}function q(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function se(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function de(ne,ge,pe=""){const ye=ne.trimStart();if(ye.length<ge)return ye;const We=/\b/g;let Ue=0;for(;We.test(ye)&&!(ye.length-We.lastIndex<ge);)Ue=We.lastIndex,We.lastIndex+=1;return Ue===0?ye:pe+ye.substring(Ue).trimStart()}const me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(ne){let ge=0;for(const pe of ne.matchAll(me))ge!==pe.index&&(yield{isCode:!1,str:ne.substring(ge,pe.index)}),yield{isCode:!0,str:pe[0]},ge=pe.index+pe[0].length;ge!==ne.length&&(yield{isCode:!1,str:ne.substring(ge)})}function De(ne){return ne&&(ne=ne.replace(me,"")),ne}const ke=/\\\[.*?\\\]/g;function Pe(ne){return De(ne).replace(ke,"")}e.$2f=String.fromCharCode(r.CharCode.UTF8_BOM);function Re(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===r.CharCode.UTF8_BOM)}function $e(ne){return Re(ne)?ne.substr(1):ne}function _(ne,ge){if(!ne||!ge||ne.length<ge.length)return!1;const pe=ge.length,ye=ne.toLowerCase();let We=0,Ue=-1;for(;We<pe;){const Ze=ye.indexOf(ge[We],Ue+1);if(Ze<0)return!1;Ue=Ze,We++}return!0}function ce(ne,ge=!1){return ne?(ge&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function fe(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function be(ne,ge=1){if(ge===0)return"";let pe=-1;do pe=ne.indexOf(`
`,pe+1),ge--;while(ge>0&&pe>=0);return pe===-1?ne:(ne[pe-1]==="\r"&&pe--,ne.substr(0,pe))}function Ae(ne){const ge=r.CharCode.Z-r.CharCode.A+1;return ne=ne%(2*ge),ne<ge?String.fromCharCode(r.CharCode.a+ne):String.fromCharCode(r.CharCode.A+ne-ge)}function Ce(ne){return Be.getInstance().getGraphemeBreakType(ne)}function Me(ne,ge){return ne===Oe.Other?ge!==Oe.Extend&&ge!==Oe.SpacingMark:ne===Oe.CR&&ge===Oe.LF?!1:ne===Oe.Control||ne===Oe.CR||ne===Oe.LF||ge===Oe.Control||ge===Oe.CR||ge===Oe.LF?!0:!(ne===Oe.L&&(ge===Oe.L||ge===Oe.V||ge===Oe.LV||ge===Oe.LVT)||(ne===Oe.LV||ne===Oe.V)&&(ge===Oe.V||ge===Oe.T)||(ne===Oe.LVT||ne===Oe.T)&&ge===Oe.T||ge===Oe.Extend||ge===Oe.ZWJ||ge===Oe.SpacingMark||ne===Oe.Prepend||ne===Oe.ZWJ&&ge===Oe.Extended_Pictographic||ne===Oe.Regional_Indicator&&ge===Oe.Regional_Indicator)}var Oe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class Be{static{this.c=null}static getInstance(){return Be.c||(Be.c=new Be),Be.c}constructor(){this.d=Ge()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?Oe.LF:ge===r.CharCode.CarriageReturn?Oe.CR:Oe.Control;if(ge<127)return Oe.Other;const pe=this.d,ye=pe.length/3;let We=1;for(;We<=ye;)if(ge<pe[3*We])We=2*We;else if(ge>pe[3*We+1])We=2*We+1;else return pe[3*We+2];return Oe.Other}}function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Qe(ne,ge){if(ne===0)return 0;const pe=qe(ne,ge);if(pe!==void 0)return pe;const ye=new Y(ge,ne);return ye.prevCodePoint(),ye.offset}function qe(ne,ge){const pe=new Y(ge,ne);let ye=pe.prevCodePoint();for(;Je(ye)||ye===Xe.emojiVariantSelector||ye===Xe.enclosingKeyCap;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!se(ye))return;let We=pe.offset;return We>0&&pe.prevCodePoint()===Xe.zwj&&(We=pe.offset),We}function Je(ne){return 127995<=ne&&ne<=127999}var Xe;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$_f="\xA0";class Ye{static{this.c=new P.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$9e({getCacheKey:JSON.stringify},ge=>{function pe(tt){const ut=new Map;for(let ct=0;ct<tt.length;ct+=2)ut.set(tt[ct],tt[ct+1]);return ut}function ye(tt,ut){const ct=new Map(tt);for(const[ft,gt]of ut)ct.set(ft,gt);return ct}function We(tt,ut){if(!tt)return ut;const ct=new Map;for(const[ft,gt]of tt)ut.has(ft)&&ct.set(ft,gt);return ct}const Ue=this.c.value;let Ze=ge.filter(tt=>!tt.startsWith("_")&&tt in Ue);Ze.length===0&&(Ze=["_default"]);let lt;for(const tt of Ze){const ut=pe(Ue[tt]);lt=We(lt,ut)}const rt=pe(Ue._common),at=ye(rt,lt);return new Ye(at)})}static getInstance(ge){return Ye.d.get(Array.from(ge))}static{this.e=new P.$T(()=>Object.keys(Ye.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=Ye;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(ge){return Ne.e().has(ge)}static containsInvisibleCharacter(ge){for(let pe=0;pe<ge.length;pe++){const ye=ge.codePointAt(pe);if(typeof ye=="number"&&Ne.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ne.e()}}e.$bg=Ne}),define(le[32],ue([0,1,39,9,3,25,12]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=I,e.$vg=w,e.$wg=c,e.$xg=g,e.$yg=h,e.$zg=d,e.$Ag=v,e.$Bg=p,e.$Cg=$,e.$Dg=k,e.$Eg=S,e.$Fg=t,e.$Gg=u,e.$Hg=i,e.$Ig=o,e.$Jg=s,e.$Kg=E;function I(y){return y===n.CharCode.Slash||y===n.CharCode.Backslash}function w(y){return y.replace(/[\\/]/g,r.$fc.sep)}function c(y){return y.indexOf("/")===-1&&(y=w(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function g(y,D=r.$fc.sep){if(!y)return"";const L=y.length,A=y.charCodeAt(0);if(I(A)){if(I(y.charCodeAt(1))&&!I(y.charCodeAt(2))){let W=3;const x=W;for(;W<L&&!I(y.charCodeAt(W));W++);if(x!==W&&!I(y.charCodeAt(W+1))){for(W+=1;W<L;W++)if(I(y.charCodeAt(W)))return y.slice(0,W+1).replace(/[\\/]/g,D)}}return D}else if($(A)&&y.charCodeAt(1)===n.CharCode.Colon)return I(y.charCodeAt(2))?y.slice(0,2)+D:y.slice(0,2);let O=y.indexOf("://");if(O!==-1){for(O+=3;O<L;O++)if(I(y.charCodeAt(O)))return y.slice(0,O+1)}return""}function h(y){if(!P.$j||!y||y.length<5)return!1;let D=y.charCodeAt(0);if(D!==n.CharCode.Backslash||(D=y.charCodeAt(1),D!==n.CharCode.Backslash))return!1;let L=2;const A=L;for(;L<y.length&&(D=y.charCodeAt(L),D!==n.CharCode.Backslash);L++);return!(A===L||(D=y.charCodeAt(L+1),isNaN(D)||D===n.CharCode.Backslash))}const m=/[\\/:\*\?"<>\|]/g,b=/[/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(y,D=P.$j){const L=D?m:b;return!(!y||y.length===0||/^\s+$/.test(y)||(L.lastIndex=0,L.test(y))||D&&f.test(y)||y==="."||y===".."||D&&y[y.length-1]==="."||D&&y.length!==y.trim().length||y.length>255)}function v(y,D,L){const A=y===D;return!L||A?A:!y||!D?!1:(0,R.$Df)(y,D)}function p(y,D,L,A=r.sep){if(y===D)return!0;if(!y||!D||D.length>y.length)return!1;if(L){if(!(0,R.$Ef)(y,D))return!1;if(D.length===y.length)return!0;let W=D.length;return D.charAt(D.length-1)===A&&W--,y.charAt(W)===A}return D.charAt(D.length-1)!==A&&(D+=A),y.indexOf(D)===0}function $(y){return y>=n.CharCode.A&&y<=n.CharCode.Z||y>=n.CharCode.a&&y<=n.CharCode.z}function k(y,D){return P.$j&&y.endsWith(":")&&(y+=r.sep),(0,r.$hc)(y)||(y=(0,r.$ic)(D,y)),y=(0,r.$gc)(y),S(y)}function S(y){return P.$j?(y=(0,R.$lf)(y,r.sep),y.endsWith(":")&&(y+=r.sep)):(y=(0,R.$lf)(y,r.sep),y||(y=r.sep)),y}function t(y){const D=(0,r.$gc)(y);return P.$j?y.length>3?!1:u(D)&&(y.length===2||D.charCodeAt(2)===n.CharCode.Backslash):D===r.$fc.sep}function u(y,D=P.$j){return D?$(y.charCodeAt(0))&&y.charCodeAt(1)===n.CharCode.Colon:!1}function i(y,D=P.$j){return u(y,D)?y[0]:void 0}function o(y,D,L){return D.length>y.length?-1:y===D?0:(L&&(y=y.toLowerCase(),D=D.toLowerCase()),y.indexOf(D))}function s(y){const D=y.split(":");let L,A,O;for(const W of D){const x=Number(W);(0,T.$gg)(x)?A===void 0?A=x:O===void 0&&(O=x):L=L?[L,W].join(":"):W}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:A!==void 0?A:void 0,column:O!==void 0?O:A!==void 0?1:void 0}}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(y,D,L=8){let A="";for(let W=0;W<L;W++){let x;W===0&&P.$j&&!D&&(L===3||L===4)?x=l:x=a,A+=x.charAt(Math.floor(Math.random()*x.length))}let O;return D?O=`${D}-${A}`:O=A,y?(0,r.$ic)(y,O):O}}),define(le[46],ue([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=r,e.$rj=P,e.$sj=R,e.$tj=I,e.$vj=d,n=Ie(n);function r(p){return P(p,0)}function P(p,$){switch(typeof p){case"object":return p===null?R(349,$):Array.isArray(p)?w(p,$):c(p,$);case"string":return I(p,$);case"boolean":return T(p,$);case"number":return R(p,$);case"undefined":return R(937,$);default:return R(617,$)}}function R(p,$){return($<<5)-$+p|0}function T(p,$){return R(p?433:863,$)}function I(p,$){$=R(149417,$);for(let k=0,S=p.length;k<S;k++)$=R(p.charCodeAt(k),$);return $}function w(p,$){return $=R(104579,$),p.reduce((k,S)=>P(S,k),$)}function c(p,$){return $=R(181387,$),Object.keys(p).sort().reduce((k,S)=>(k=I(S,k),P(p[S],k)),$)}class g{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=P($,this.g),this.g}}e.$uj=g;var h;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(h||(h={}));function m(p,$,k=32){const S=k-$,t=~((1<<S)-1);return(p<<$|(t&p)>>>S)>>>0}function b(p,$=0,k=p.byteLength,S=0){for(let t=0;t<k;t++)p[$+t]=S}function f(p,$,k="0"){for(;p.length<$;)p=k+p;return p}function d(p,$=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(k=>k.toString(16).padStart(2,"0")).join(""):f((p>>>0).toString(16),$/4)}class v{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(h.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const k=$.length;if(k===0)return;const S=this.p;let t=this.r,u=this.u,i,o;for(u!==0?(i=u,o=-1,u=0):(i=$.charCodeAt(0),o=0);;){let s=i;if(n.$Hf(i))if(o+1<k){const a=$.charCodeAt(o+1);n.$If(a)?(o++,s=n.$Jf(i,a)):s=h.UNICODE_REPLACEMENT}else{u=i;break}else n.$If(i)&&(s=h.UNICODE_REPLACEMENT);if(t=this.w(S,t,s),o++,o<k)i=$.charCodeAt(o);else break}this.r=t,this.u=u}w($,k,S){return S<128?$[k++]=S:S<2048?($[k++]=192|(S&1984)>>>6,$[k++]=128|(S&63)>>>0):S<65536?($[k++]=224|(S&61440)>>>12,$[k++]=128|(S&4032)>>>6,$[k++]=128|(S&63)>>>0):($[k++]=240|(S&1835008)>>>18,$[k++]=128|(S&258048)>>>12,$[k++]=128|(S&4032)>>>6,$[k++]=128|(S&63)>>>0),k>=h.BLOCK_SIZE&&(this.y(),k-=h.BLOCK_SIZE,this.t+=h.BLOCK_SIZE,$[0]=$[h.BLOCK_SIZE+0],$[1]=$[h.BLOCK_SIZE+1],$[2]=$[h.BLOCK_SIZE+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,h.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=v.g,k=this.q;for(let E=0;E<64;E+=4)$.setUint32(E,k.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)$.setUint32(E,m($.getUint32(E-12,!1)^$.getUint32(E-32,!1)^$.getUint32(E-56,!1)^$.getUint32(E-64,!1),1),!1);let S=this.h,t=this.l,u=this.m,i=this.n,o=this.o,s,a,l;for(let E=0;E<80;E++)E<20?(s=t&u|~t&i,a=1518500249):E<40?(s=t^u^i,a=1859775393):E<60?(s=t&u|t&i|u&i,a=2400959708):(s=t^u^i,a=3395469782),l=m(S,5)+s+o+a+$.getUint32(E*4,!1)&4294967295,o=i,i=u,u=m(t,30),t=S,S=l;this.h=this.h+S&4294967295,this.l=this.l+t&4294967295,this.m=this.m+u&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$wj=v}),define(le[81],ue([0,1,25]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n=Ie(n);var r;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(r||(r={})),function(P){const R="error",T="warning",I="warn",w="info",c="ignore";function g(m){return m?n.$Df(R,m)?P.Error:n.$Df(T,m)||n.$Df(I,m)?P.Warning:n.$Df(w,m)?P.Info:P.Ignore:P.Ignore}P.fromValue=g;function h(m){switch(m){case P.Error:return R;case P.Warning:return T;case P.Info:return w;default:return c}}P.toString=h}(r||(r={})),e.default=r}),define(le[60],ue([0,1,20,39,25]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class R{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const d=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.$Ei=R;class T{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,P.$xf)(f,this.b,0,f.length,this.c,this.d):(0,P.$zf)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=T;class I{constructor(f=!0,d=!0){this.f=f,this.g=d}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let d=f.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===r.CharCode.Slash||this.f&&v===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===r.CharCode.Slash||this.f&&d===r.CharCode.Backslash)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,P.$xf)(f,this.b,0,f.length,this.d,this.e):(0,P.$zf)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=I;var w;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(w||(w={}));class c{constructor(f,d){this.f=f,this.g=d,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(w.Scheme),this.c.authority&&this.d.push(w.Authority),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(w.Path)),this.g(f)||(this.c.query&&this.d.push(w.Query),this.c.fragment&&this.d.push(w.Fragment)),this.e=0,this}next(){return this.d[this.e]===w.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===w.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===w.Scheme)return(0,P.$yf)(f,this.c.scheme);if(this.d[this.e]===w.Authority)return(0,P.$yf)(f,this.c.authority);if(this.d[this.e]===w.Path)return this.b.cmp(f);if(this.d[this.e]===w.Query)return(0,P.$wf)(f,this.c.query);if(this.d[this.e]===w.Fragment)return(0,P.$wf)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===w.Scheme)return this.c.scheme;if(this.d[this.e]===w.Authority)return this.c.authority;if(this.d[this.e]===w.Path)return this.b.value();if(this.d[this.e]===w.Query)return this.c.query;if(this.d[this.e]===w.Fragment)return this.c.fragment;throw new Error}}e.$Hi=c;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(h||(h={}));class m{static forUris(f=()=>!1,d=()=>!1){return new m(new c(f,d))}static forPaths(f=!1){return new m(new I(void 0,!f))}static forStrings(){return new m(new R)}static forConfigKeys(){return new m(new T)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,d){if(d){const v=d.slice(0);(0,n.$Vb)(v);for(const p of v)this.set(p,f)}else{const v=f.slice(0);(0,n.$Vb)(v);for(const p of v)this.set(p[0],p[1])}}set(f,d){const v=this.b.reset(f);let p;this.c||(this.c=new g,this.c.segment=v.value());const $=[];for(p=this.c;;){const S=v.cmp(p.segment);if(S>0)p.left||(p.left=new g,p.left.segment=v.value()),$.push([h.Left,p]),p=p.left;else if(S<0)p.right||(p.right=new g,p.right.segment=v.value()),$.push([h.Right,p]),p=p.right;else if(v.hasNext())v.next(),p.mid||(p.mid=new g,p.mid.segment=v.value()),$.push([h.Mid,p]),p=p.mid;else break}const k=p.value;p.value=d,p.key=f;for(let S=$.length-1;S>=0;S--){const t=$[S][1];t.updateHeight();const u=t.balanceFactor();if(u<-1||u>1){const i=$[S][0],o=$[S+1][0];if(i===h.Right&&o===h.Right)$[S][1]=t.rotateLeft();else if(i===h.Left&&o===h.Left)$[S][1]=t.rotateRight();else if(i===h.Right&&o===h.Left)t.right=$[S+1][1]=$[S+1][1].rotateRight(),$[S][1]=t.rotateLeft();else if(i===h.Left&&o===h.Right)t.left=$[S+1][1]=$[S+1][1].rotateLeft(),$[S][1]=t.rotateRight();else throw new Error;if(S>0)switch($[S-1][0]){case h.Left:$[S-1][1].left=$[S][1];break;case h.Right:$[S-1][1].right=$[S][1];break;case h.Mid:$[S-1][1].mid=$[S][1];break}else this.c=$[0][1]}}return k}get(f){return this.d(f)?.value}d(f){const d=this.b.reset(f);let v=this.c;for(;v;){const p=d.cmp(v.segment);if(p>0)v=v.left;else if(p<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(f){const d=this.d(f);return!(d?.value===void 0&&d?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,d){const v=this.b.reset(f),p=[];let $=this.c;for(;$;){const k=v.cmp($.segment);if(k>0)p.push([h.Left,$]),$=$.left;else if(k<0)p.push([h.Right,$]),$=$.right;else if(v.hasNext())v.next(),p.push([h.Mid,$]),$=$.mid;else break}if($){if(d?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const k=this.f($.right);if(k.key){const{key:S,value:t,segment:u}=k;this.e(k.key,!1),$.key=S,$.value=t,$.segment=u}}else{const k=$.left??$.right;if(p.length>0){const[S,t]=p[p.length-1];switch(S){case h.Left:t.left=k;break;case h.Mid:t.mid=k;break;case h.Right:t.right=k;break}}else this.c=k}for(let k=p.length-1;k>=0;k--){const S=p[k][1];S.updateHeight();const t=S.balanceFactor();if(t>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),p[k][1]=S.rotateLeft()):t<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),p[k][1]=S.rotateRight()),k>0)switch(p[k-1][0]){case h.Left:p[k-1][1].left=p[k][1];break;case h.Right:p[k-1][1].right=p[k][1];break;case h.Mid:p[k-1][1].mid=p[k][1];break}else this.c=p[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const d=this.b.reset(f);let v=this.c,p;for(;v;){const $=d.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(d.hasNext())d.next(),p=v.value||p,v=v.mid;else break}return v&&v.value||p}findSuperstr(f){return this.g(f,!1)}g(f,d){const v=this.b.reset(f);let p=this.c;for(;p;){const $=v.cmp(p.segment);if($>0)p=p.left;else if($<0)p=p.right;else if(v.hasNext())v.next(),p=p.mid;else return p.mid?this.h(p.mid):d?p.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[d,v]of this)f(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const d=[];return this.j(f,d),d[Symbol.iterator]()}j(f,d){f&&(f.left&&this.j(f.left,d),f.value&&d.push([f.key,f.value]),f.mid&&this.j(f.mid,d),f.right&&this.j(f.right,d))}_isBalanced(){const f=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:f(d.left)&&f(d.right)};return f(this.c)}}e.$Ii=m}),define(le[7],ue([0,1,39,90,9,3]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=v,e.$vc=u,P=Ie(P);const T=/^\w[\w\d+.-]*$/,I=/^\//,w=/^\/\//;function c(l,E){if(!l.scheme&&E)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!T.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!I.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(l,E){return!l&&!E?"file":l}function h(l,E){switch(l){case"https":case"http":case"file":E?E[0]!==b&&(E=b+E):E=b;break}return E}const m="",b="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(E){return E instanceof d?!0:E?typeof E.authority=="string"&&typeof E.fragment=="string"&&typeof E.path=="string"&&typeof E.query=="string"&&typeof E.scheme=="string"&&typeof E.fsPath=="string"&&typeof E.with=="function"&&typeof E.toString=="function":!1}constructor(E,y,D,L,A,O=!1){typeof E=="object"?(this.scheme=E.scheme||m,this.authority=E.authority||m,this.path=E.path||m,this.query=E.query||m,this.fragment=E.fragment||m):(this.scheme=g(E,O),this.authority=y||m,this.path=h(this.scheme,D||m),this.query=L||m,this.fragment=A||m,c(this,O))}get fsPath(){return u(this,!1)}with(E){if(!E)return this;let{scheme:y,authority:D,path:L,query:A,fragment:O}=E;return y===void 0?y=this.scheme:y===null&&(y=m),D===void 0?D=this.authority:D===null&&(D=m),L===void 0?L=this.path:L===null&&(L=m),A===void 0?A=this.query:A===null&&(A=m),O===void 0?O=this.fragment:O===null&&(O=m),y===this.scheme&&D===this.authority&&L===this.path&&A===this.query&&O===this.fragment?this:new $(y,D,L,A,O)}static parse(E,y=!1){const D=f.exec(E);return D?new $(D[2]||m,a(D[4]||m),a(D[5]||m),a(D[7]||m),a(D[9]||m),y):new $(m,m,m,m,m)}static file(E){let y=m;if(R.$j&&(E=E.replace(/\\/g,b)),E[0]===b&&E[1]===b){const D=E.indexOf(b,2);D===-1?(y=E.substring(2),E=b):(y=E.substring(2,D),E=E.substring(D)||b)}return new $("file",y,E,m,m)}static from(E,y){return new $(E.scheme,E.authority,E.path,E.query,E.fragment,y)}static joinPath(E,...y){if(!E.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return R.$j&&E.scheme==="file"?D=d.file(P.$ec.join(u(E,!0),...y)).path:D=P.$fc.join(E.path,...y),E.with({path:D})}toString(E=!1){return i(this,E)}toJSON(){return this}static revive(E){if(E){if(E instanceof d)return E;{const y=new $(E);return y._formatted=E.external??null,y._fsPath=E._sep===p?E.fsPath??null:null,y}}else return E}}e.URI=d;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const p=R.$j?1:void 0;class $ extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(E=!1){return E?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const E={$mid:r.MarshalledId.Uri};return this._fsPath&&(E.fsPath=this._fsPath,E._sep=p),this._formatted&&(E.external=this._formatted),this.path&&(E.path=this.path),this.scheme&&(E.scheme=this.scheme),this.authority&&(E.authority=this.authority),this.query&&(E.query=this.query),this.fragment&&(E.fragment=this.fragment),E}}const k={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function S(l,E,y){let D,L=-1;for(let A=0;A<l.length;A++){const O=l.charCodeAt(A);if(O>=n.CharCode.a&&O<=n.CharCode.z||O>=n.CharCode.A&&O<=n.CharCode.Z||O>=n.CharCode.Digit0&&O<=n.CharCode.Digit9||O===n.CharCode.Dash||O===n.CharCode.Period||O===n.CharCode.Underline||O===n.CharCode.Tilde||E&&O===n.CharCode.Slash||y&&O===n.CharCode.OpenSquareBracket||y&&O===n.CharCode.CloseSquareBracket||y&&O===n.CharCode.Colon)L!==-1&&(D+=encodeURIComponent(l.substring(L,A)),L=-1),D!==void 0&&(D+=l.charAt(A));else{D===void 0&&(D=l.substr(0,A));const W=k[O];W!==void 0?(L!==-1&&(D+=encodeURIComponent(l.substring(L,A)),L=-1),D+=W):L===-1&&(L=A)}}return L!==-1&&(D+=encodeURIComponent(l.substring(L))),D!==void 0?D:l}function t(l){let E;for(let y=0;y<l.length;y++){const D=l.charCodeAt(y);D===n.CharCode.Hash||D===n.CharCode.QuestionMark?(E===void 0&&(E=l.substr(0,y)),E+=k[D]):E!==void 0&&(E+=l[y])}return E!==void 0?E:l}function u(l,E){let y;return l.authority&&l.path.length>1&&l.scheme==="file"?y=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===n.CharCode.Slash&&(l.path.charCodeAt(1)>=n.CharCode.A&&l.path.charCodeAt(1)<=n.CharCode.Z||l.path.charCodeAt(1)>=n.CharCode.a&&l.path.charCodeAt(1)<=n.CharCode.z)&&l.path.charCodeAt(2)===n.CharCode.Colon?E?y=l.path.substr(1):y=l.path[1].toLowerCase()+l.path.substr(2):y=l.path,R.$j&&(y=y.replace(/\//g,"\\")),y}function i(l,E){const y=E?t:S;let D="",{scheme:L,authority:A,path:O,query:W,fragment:x}=l;if(L&&(D+=L,D+=":"),(A||L==="file")&&(D+=b,D+=b),A){let H=A.indexOf("@");if(H!==-1){const B=A.substr(0,H);A=A.substr(H+1),H=B.lastIndexOf(":"),H===-1?D+=y(B,!1,!1):(D+=y(B.substr(0,H),!1,!1),D+=":",D+=y(B.substr(H+1),!1,!0)),D+="@"}A=A.toLowerCase(),H=A.lastIndexOf(":"),H===-1?D+=y(A,!1,!0):(D+=y(A.substr(0,H),!1,!0),D+=A.substr(H))}if(O){if(O.length>=3&&O.charCodeAt(0)===n.CharCode.Slash&&O.charCodeAt(2)===n.CharCode.Colon){const H=O.charCodeAt(1);H>=n.CharCode.A&&H<=n.CharCode.Z&&(O=`/${String.fromCharCode(H+32)}:${O.substr(3)}`)}else if(O.length>=2&&O.charCodeAt(1)===n.CharCode.Colon){const H=O.charCodeAt(0);H>=n.CharCode.A&&H<=n.CharCode.Z&&(O=`${String.fromCharCode(H+32)}:${O.substr(2)}`)}D+=y(O,!0,!1)}return W&&(D+="?",D+=y(W,!1,!1)),x&&(D+="#",D+=E?x:S(x,!1,!1)),D}function o(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+o(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(l){return l.match(s)?l.replace(s,E=>o(E)):l}}),define(le[149],ue([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=r,e.$br=P,e.$cr=R,e.log=I;function r(c){const g=c;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function P(c){const g=[];let h;try{const m=JSON.parse(c.arguments),b=m[m.length-1];b&&b.__$stack&&(m.pop(),h=b.__$stack),g.push(...m)}catch{g.push("Unable to log remote console arguments",c.arguments)}return{args:g,stack:h}}function R(c){if(typeof c!="string")return R(P(c).stack);const g=c;if(g){const h=T(g),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(m&&m.length===4)return{uri:n.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function T(c){if(!c)return c;const g=c.indexOf(`
`);return g===-1?c:c.substring(0,g)}function I(c,g){const{args:h,stack:m}=P(c),b=typeof h[0]=="string"&&h.length===1;let f=T(m);f&&(f=`(${f.trim()})`);let d=[];if(typeof h[0]=="string"?f&&b?d=[`%c[${g}] %c${h[0]} %c${f}`,w("blue"),w(""),w("grey")]:d=[`%c[${g}] %c${h[0]}`,w("blue"),w(""),...h.slice(1)]:d=[`%c[${g}]%`,w("blue"),...h],f&&!b&&d.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,d)}function w(c){return`color: ${c}`}}),define(le[82],ue([0,1,16,7,90]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=R,e.$$h=T,e.$_h=w;function R(c){return JSON.stringify(c,I)}function T(c){let g=JSON.parse(c);return g=w(g),g}function I(c,g){return g instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:g.source,flags:g.flags}:g}function w(c,g=0){if(!c||g>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return r.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof n.$Le||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let h=0;h<c.length;++h)c[h]=w(c[h],g+1);else for(const h in c)Object.hasOwnProperty.call(c,h)&&(c[h]=w(c[h],g+1))}return c}}),define(le[11],ue([0,1,15,3,25,7,9]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=w,e.$Mg=c,e.$Qg=h,n=Ie(n),r=Ie(r),T=Ie(T);var I;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(I||(e.Schemas=I={}));function w(f,d){return R.URI.isUri(f)?(0,P.$Df)(f.scheme,d):(0,P.$Ef)(f,d+":")}function c(f,...d){return d.some(v=>w(f,v))}e.$Ng="vscode-tkn",e.$Og="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,v){this.f=h(d,v)}getServerRootPath(){return this.f}get g(){return T.$fc.join(this.f,I.vscodeRemoteResource)}set(d,v,p){this.a[d]=v,this.b[d]=p}setConnectionToken(d,v){this.c[d]=v}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(t){return n.$Y(t),d}const v=d.authority;let p=this.a[v];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const $=this.b[v],k=this.c[v];let S=`path=${encodeURIComponent(d.path)}`;return typeof k=="string"&&(S+=`&${e.$Og}=${encodeURIComponent(k)}`),R.URI.from({scheme:r.$p?this.d:I.vscodeRemoteResource,authority:`${p}:${$}`,path:this.g,query:S})}}e.$Pg=new g;function h(f,d){return T.$fc.join(d??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class m{static{this.a=e.$Vg}asBrowserUri(d){const v=this.b(d,J);return this.uriToBrowserUri(v)}uriToBrowserUri(d){return d.scheme===I.vscodeRemote?e.$Pg.rewrite(d):d.scheme===I.file&&(r.$n||r.$r===`${I.vscodeFileResource}://${m.a}`)?d.with({scheme:I.vscodeFileResource,authority:d.authority||m.a,query:null,fragment:null}):d}asFileUri(d){const v=this.b(d,J);return this.uriToFileUri(v)}uriToFileUri(d){return d.scheme===I.vscodeFileResource?d.with({scheme:I.file,authority:d.authority!==m.a?d.authority:null,query:null,fragment:null}):d}b(d,v){return R.URI.isUri(d)?d:R.URI.parse(v.toUrl(d))}}e.$Wg=new m;var b;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const v="vscode-coi";function p(k){let S;typeof k=="string"?S=new URL(k).searchParams:k instanceof URL?S=k.searchParams:R.URI.isUri(k)&&(S=new URL(k.toString(!0)).searchParams);const t=S?.get(v);if(t)return d.get(t)}f.getHeadersFromQuery=p;function $(k,S,t){if(!globalThis.crossOriginIsolated)return;const u=S&&t?"3":t?"2":"1";k instanceof URLSearchParams?k.set(v,u):k[v]=u}f.addSearchParam=$})(b||(e.COI=b={}))}),define(le[18],ue([0,1,39,32,11,9,3,25,7]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=c,e.$mh=h,e.$nh=b,r=Ie(r),R=Ie(R);function c(f){return(0,w.$vc)(f,!0)}class g{constructor(d){this.a=d}compare(d,v,p=!1){return d===v?0:(0,I.$wf)(this.getComparisonKey(d,p),this.getComparisonKey(v,p))}isEqual(d,v,p=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,p)===this.getComparisonKey(v,p)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,p=!1){if(d.scheme===v.scheme){if(d.scheme===P.Schemas.file)return r.$Bg(c(d),c(v),this.a(d))&&d.query===v.query&&(p||d.fragment===v.fragment);if((0,e.$ih)(d.authority,v.authority))return r.$Bg(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(p||d.fragment===v.fragment)}return!1}joinPath(d,...v){return w.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.$ah)(d)||d.authority}basename(d){return R.$fc.basename(d.path)}extname(d){return R.$fc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===P.Schemas.file?v=w.URI.file(R.$lc(c(d))).path:(v=R.$fc.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===P.Schemas.file?v=w.URI.file(R.$gc(c(d))).path:v=R.$fc.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.$ih)(d.authority,v.authority))return;if(d.scheme===P.Schemas.file){const k=R.$kc(c(d),c(v));return T.$j?r.$vg(k):k}let p=d.path||"/";const $=v.path||"/";if(this.a(d)){let k=0;for(const S=Math.min(p.length,$.length);k<S&&!(p.charCodeAt(k)!==$.charCodeAt(k)&&p.charAt(k).toLowerCase()!==$.charAt(k).toLowerCase());k++);p=$.substr(0,k)+p.substr(k)}return R.$fc.relative(p,$)}resolvePath(d,v){if(d.scheme===P.Schemas.file){const p=w.URI.file(R.$jc(c(d),v));return d.with({authority:p.authority,path:p.path})}return v=r.$wg(v),d.with({path:R.$fc.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,I.$Df)(d,v)}hasTrailingPathSeparator(d,v=R.sep){if(d.scheme===P.Schemas.file){const p=c(d);return p.length>r.$xg(p).length&&p[p.length-1]===v}else{const p=d.path;return p.length>1&&p.charCodeAt(p.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=R.sep){return(0,e.$jh)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=R.sep){let p=!1;if(d.scheme===P.Schemas.file){const $=c(d);p=$!==void 0&&$.length===r.$xg($).length&&$[$.length-1]===v}else{v="/";const $=d.path;p=$.length===1&&$.charCodeAt($.length-1)===n.CharCode.Slash}return!p&&!(0,e.$jh)(d,v)?d.with({path:d.path+"/"}):d}}e.$5g=g,e.$6g=new g(()=>!1),e.$7g=new g(f=>f.scheme===P.Schemas.file?!T.$l:!0),e.$8g=new g(f=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function h(f,d){const v=[];for(let p=0;p<f.length;p++){const $=d(f[p]);f.some((k,S)=>S===p?!1:(0,e.$0g)($,d(k)))||v.push(f[p])}return v}var m;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(v){const p=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(S=>{const[t,u]=S.split(":");t&&u&&p.set(t,u)});const k=v.path.substring(0,v.path.indexOf(";"));return k&&p.set(f.META_DATA_MIME,k),p}f.parseMetaData=d})(m||(e.DataUri=m={}));function b(f,d,v){if(d){let p=f.path;return p&&p[0]!==R.$fc.sep&&(p=R.$fc.sep+p),f.with({scheme:v,authority:d,path:p})}return f.with({scheme:v})}}),define(le[8],ue([0,1,21,15,4,2,18,3,146,65]),function(J,e,n,r,P,R,T,I,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=g,e.$ph=h,e.$qh=m,e.$rh=b,e.$sh=f,e.$th=d,e.$uh=v,e.$vh=p,e.$Dh=l,e.$Eh=E,e.$Fh=y,e.$Gh=D,e.$Hh=L,e.$Wh=j,e.$5h=z;function g(Q){return!!Q&&typeof Q.then=="function"}function h(Q){const q=new n.$ue,se=Q(q.token),de=new Promise((me,we)=>{const De=q.token.onCancellationRequested(()=>{De.dispose(),we(new r.$4)});Promise.resolve(se).then(ke=>{De.dispose(),q.dispose(),me(ke)},ke=>{De.dispose(),q.dispose(),we(ke)})});return new class{cancel(){q.cancel(),q.dispose()}then(me,we){return de.then(me,we)}catch(me){return this.then(void 0,me)}finally(me){return de.finally(me)}}}function m(Q,q,se){return new Promise((de,me)=>{const we=q.onCancellationRequested(()=>{we.dispose(),de(se)});Q.then(de,me).finally(()=>we.dispose())})}function b(Q,q){return new Promise((se,de)=>{const me=q.onCancellationRequested(()=>{me.dispose(),de(new r.$4)});Q.then(se,de).finally(()=>me.dispose())})}async function f(Q){let q=-1;const se=Q.map((de,me)=>de.then(we=>(q=me,we)));try{return await Promise.race(se)}finally{Q.forEach((de,me)=>{me!==q&&de.cancel()})}}function d(Q,q,se){let de;const me=setTimeout(()=>{de?.(void 0),se?.()},q);return Promise.race([Q.finally(()=>clearTimeout(me)),new Promise(we=>de=we)])}function v(Q){return new Promise((q,se)=>{const de=Q();g(de)?de.then(q,se):q(de)})}function p(){let Q,q;return{promise:new Promise((de,me)=>{Q=de,q=me}),resolve:Q,reject:q}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const se=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(se,se).then(de)})}return new Promise((se,de)=>{this.b.then(se,de)})}return this.a=q(),new Promise((se,de)=>{this.a.then(me=>{this.a=null,se(me)},me=>{this.a=null,de(me)})})}dispose(){this.f=!0}}e.$wh=$;class k{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$xh=k;class S{constructor(){this.a=new Map}queue(q,se){const me=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(q)===me&&this.a.delete(q)});return this.a.set(q,me),me}}e.$yh=S;const t=(Q,q)=>{let se=!0;const de=setTimeout(()=>{se=!1,q()},Q);return{isTriggered:()=>se,dispose:()=>{clearTimeout(de),se=!1}}},u=Q=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,Q())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class i{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,se=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((me,we)=>{this.d=me,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=se===w.$ee?u(de):t(se,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=i;class o{constructor(q){this.a=new i(q),this.b=new $}trigger(q,se){return this.a.trigger(()=>this.b.queue(q),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=o;class s{constructor(){this.a=!1,this.b=new Promise((q,se)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=s;class a extends s{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Ch=a;function l(Q,q){return q?new Promise((se,de)=>{const me=setTimeout(()=>{we.dispose(),se()},Q),we=q.onCancellationRequested(()=>{clearTimeout(me),we.dispose(),de(new r.$4)})}):h(se=>l(Q,se))}function E(Q,q=0,se){const de=setTimeout(()=>{Q(),se&&me.dispose()},q),me=(0,R.$Rc)(()=>{clearTimeout(de),se?.deleteAndLeak(me)});return se?.add(me),me}function y(Q){const q=[];let se=0;const de=Q.length;function me(){return se<de?Q[se++]():null}function we(De){De!=null&&q.push(De);const ke=me();return ke?ke.then(we):Promise.resolve(q)}return Promise.resolve(null).then(we)}function D(Q,q=de=>!!de,se=null){let de=0;const me=Q.length,we=()=>{if(de>=me)return Promise.resolve(se);const De=Q[de++];return Promise.resolve(De()).then(Pe=>q(Pe)?Promise.resolve(Pe):we())};return we()}function L(Q,q=de=>!!de,se=null){if(Q.length===0)return Promise.resolve(se);let de=Q.length;const me=()=>{de=-1;for(const we of Q)we.cancel?.()};return new Promise((we,De)=>{for(const ke of Q)ke.then(Pe=>{--de>=0&&q(Pe)?(me(),we(Pe)):de===0&&we(se)}).catch(Pe=>{--de>=0&&(me(),De(Pe))})})}class A{constructor(q){this.a=0,this.b=!1,this.f=q,this.g=[],this.d=0,this.h=new P.$je}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,de)=>{this.g.push({factory:q,c:se,e:de}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const q=this.g.shift();this.d++;const se=q.factory();se.then(q.c,q.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=A;class O extends A{constructor(){super(1)}}e.$Jh=O;class W{constructor(){this.a=new N,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Kh=W;class x{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new V;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueSize(q,se=T.$6g){const de=se.getComparisonKey(q);return this.a.get(de)?.size??0}queueFor(q,se,de=T.$6g){const me=de.getComparisonKey(q);let we=this.a.get(me);if(!we){we=new O;const De=this.f++,ke=P.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$3c),this.d.set(De,ke),this.a.set(me,we)}return we.queue(se)}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=x;class H{constructor(q,se){this.b=!1,this.a=-1,typeof q=="function"&&typeof se=="number"&&this.setIfNotSet(q,se)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,se){if(this.b)throw new r.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},se)}setIfNotSet(q,se){if(this.b)throw new r.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},se))}}e.$Mh=H;class B{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(q,se,de=globalThis){if(this.f)throw new r.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const me=de.setInterval(()=>{q()},se);this.d=(0,R.$Rc)(()=>{de.clearInterval(me),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=B;class X{constructor(q,se){this.b=-1,this.a=q,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=X;class G{constructor(q,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=q,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=G;class ae extends X{constructor(q,se){super(q,se),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Qh=ae;class K extends R.$Tc{constructor(q,se){super(),this.g=q,this.h=se,this.a=[],this.b=this.B(new R.$Uc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of q)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(Q,q)=>{(0,I.$C)(()=>{if(se)return;const de=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Th=(Q,q,se)=>{const de=Q.requestIdleCallback(q,typeof se=="number"?{timeout:se}:void 0);let me=!1;return{dispose(){me||(me=!0,Q.cancelIdleCallback(de))}}},e.$Sh=Q=>(0,e.$Th)(globalThis,Q)}();class te{constructor(q,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(de){this.l=de}finally{this.g=!0}},this.f=(0,e.$Th)(q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=te;class U extends te{constructor(q){super(globalThis,q)}}e.$Vh=U;async function j(Q,q,se){let de;for(let me=0;me<se;me++)try{return await Q()}catch(we){de=we,await l(q)}throw de}class N{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,se,de){return this.a={taskId:q,cancel:()=>de?.(),promise:se},se.then(()=>this.d(q),()=>this.d(q)),se}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{const{promise:se,resolve:de,reject:me}=p();this.b={run:q,promise:se,promiseResolve:de,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=N;class Y{constructor(q,se=()=>Date.now()){this.d=q,this.f=se,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Yh=Y;var ie;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(ie||(ie={}));class V{get isRejected(){return this.d?.outcome===ie.Rejected}get isResolved(){return this.d?.outcome===ie.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ie.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((q,se)=>{this.a=q,this.b=se})}complete(q){return new Promise(se=>{this.a(q),this.d={outcome:ie.Resolved,value:q},se()})}error(q){return new Promise(se=>{this.b(q),this.d={outcome:ie.Rejected,value:q},se()})}cancel(){return this.error(new r.$4)}}e.$Zh=V;var he;(function(Q){async function q(de){let me;const we=await Promise.all(de.map(De=>De.then(ke=>ke,ke=>{me||(me=ke)})));if(typeof me<"u")throw me;return we}Q.settled=q;function se(de){return new Promise(async(me,we)=>{try{await de(me,we)}catch(De){we(De)}})}Q.withAsyncBody=se})(he||(e.Promises=he={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=q.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new r.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=oe;class ee{constructor(q){this.b=q,this.a=new c.$T(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=ee;var M;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(M||(M={}));class F{static fromArray(q){return new F(se=>{se.emitMany(q)})}static fromPromise(q){return new F(async se=>{se.emitMany(await q)})}static fromPromises(q){return new F(async se=>{await Promise.all(q.map(async de=>se.emitOne(await de)))})}static merge(q){return new F(async se=>{await Promise.all(q.map(async de=>{for await(const me of de)se.emitOne(me)}))})}static{this.EMPTY=F.fromArray([])}constructor(q,se){this.a=M.Initial,this.b=[],this.d=null,this.f=se,this.g=new P.$je,queueMicrotask(async()=>{const de={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(q(de)),this.k()}catch(me){this.l(me)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===M.DoneError)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===M.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(q,se){return new F(async de=>{for await(const me of q)de.emitOne(se(me))})}map(q){return F.map(this,q)}static filter(q,se){return new F(async de=>{for await(const me of q)se(me)&&de.emitOne(me)})}filter(q){return F.filter(this,q)}static coalesce(q){return F.filter(q,se=>!!se)}coalesce(){return F.coalesce(this)}static async toPromise(q){const se=[];for await(const de of q)se.push(de);return se}toPromise(){return F.toPromise(this)}h(q){this.a===M.Initial&&(this.b.push(q),this.g.fire())}j(q){this.a===M.Initial&&(this.b=this.b.concat(q),this.g.fire())}k(){this.a===M.Initial&&(this.a=M.DoneOK,this.g.fire())}l(q){this.a===M.Initial&&(this.a=M.DoneError,this.d=q,this.g.fire())}}e.$3h=F;class C extends F{constructor(q,se){super(se),this.m=q}cancel(){this.m.cancel()}}e.$4h=C;function z(Q){const q=new n.$ue,se=Q(q.token);return new C(q,async de=>{const me=q.token.onCancellationRequested(()=>{me.dispose(),q.dispose(),de.reject(new r.$4)});try{for await(const we of se){if(q.token.isCancellationRequested)return;de.emitOne(we)}me.dispose(),q.dispose()}catch(we){me.dispose(),q.dispose(),de.reject(we)}})}class Z{constructor(q){this.a=new V,this.b=new F(me=>{if(se){me.reject(se);return}return de&&me.emitMany(de),this.d=we=>me.reject(we),this.f=we=>me.emitOne(we),this.a.p},q);let se,de;this.f=me=>{de||(de=[]),de.push(me)},this.d=me=>{se||(se=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(q){this.d(q),this.a.complete()}emitOne(q){this.f(q)}}e.$6h=Z}),define(le[111],ue([0,1,20,8,39,32,31,9,3,25]),function(J,e,n,r,P,R,T,I,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$sk=g,e.$vk=d,e.$wk=W,e.$xk=x,e.$yk=H,e.$zk=B,e.$Ak=X,e.$Bk=te;function g(){return Object.create(null)}e.$tk="**",e.$uk="/";const h="[/\\\\]",m="[^/\\\\]",b=/\//g;function f(U,j){switch(U){case 0:return"";case 1:return`${m}*?`;default:return`(?:${h}|${m}+${h}${j?`|${h}${m}+`:""})*?`}}function d(U,j){if(!U)return[];const N=[];let Y=!1,ie=!1,V="";for(const he of U){switch(he){case j:if(!Y&&!ie){N.push(V),V="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}V+=he}return V&&N.push(V),N}function v(U){if(!U)return"";let j="";const N=d(U,e.$uk);if(N.every(Y=>Y===e.$tk))j=".*";else{let Y=!1;N.forEach((ie,V)=>{if(ie===e.$tk){if(Y)return;j+=f(2,V===N.length-1)}else{let he=!1,oe="",ee=!1,M="";for(const F of ie){if(F!=="}"&&he){oe+=F;continue}if(ee&&(F!=="]"||!M)){let C;F==="-"?C=F:(F==="^"||F==="!")&&!M?C="^":F===e.$uk?C="":C=(0,c.$ff)(F),M+=C;continue}switch(F){case"{":he=!0;continue;case"[":ee=!0;continue;case"}":{const z=`(?:${d(oe,",").map(Z=>v(Z)).join("|")})`;j+=z,he=!1,oe="";break}case"]":{j+="["+M+"]",ee=!1,M="";break}case"?":j+=m;continue;case"*":j+=f(1);continue;default:j+=(0,c.$ff)(F)}}V<N.length-1&&(N[V+1]!==e.$tk||V+2<N.length)&&(j+=h)}Y=ie===e.$tk})}return j}const p=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,k=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Cc(1e4),o=function(){return!1},s=function(){return null};function a(U,j){if(!U)return s;let N;typeof U!="string"?N=U.pattern:N=U,N=N.trim();const Y=`${N}_${!!j.trimForExclusions}`;let ie=i.get(Y);if(ie)return l(ie,U);let V;return p.test(N)?ie=y(N.substr(4),N):(V=$.exec(E(N,j)))?ie=D(V[1],N):(j.trimForExclusions?S:k).test(N)?ie=L(N,j):(V=t.exec(E(N,j)))?ie=A(V[1].substr(1),N,!0):(V=u.exec(E(N,j)))?ie=A(V[1],N,!1):ie=O(N),i.set(Y,ie),l(ie,U)}function l(U,j){if(typeof j=="string")return U;const N=function(Y,ie){return(0,R.$Bg)(Y,j.base,!w.$l)?U((0,c.$kf)(Y.substr(j.base.length),I.sep),ie):null};return N.allBasenames=U.allBasenames,N.allPaths=U.allPaths,N.basenames=U.basenames,N.patterns=U.patterns,N}function E(U,j){return j.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function y(U,j){return function(N,Y){return typeof N=="string"&&N.endsWith(U)?j:null}}function D(U,j){const N=`/${U}`,Y=`\\${U}`,ie=function(he,oe){return typeof he!="string"?null:oe?oe===U?j:null:he===U||he.endsWith(N)||he.endsWith(Y)?j:null},V=[U];return ie.basenames=V,ie.patterns=[j],ie.allBasenames=V,ie}function L(U,j){const N=K(U.slice(1,-1).split(",").map(oe=>a(oe,j)).filter(oe=>oe!==s),U),Y=N.length;if(!Y)return s;if(Y===1)return N[0];const ie=function(oe,ee){for(let M=0,F=N.length;M<F;M++)if(N[M](oe,ee))return U;return null},V=N.find(oe=>!!oe.allBasenames);V&&(ie.allBasenames=V.allBasenames);const he=N.reduce((oe,ee)=>ee.allPaths?oe.concat(ee.allPaths):oe,[]);return he.length&&(ie.allPaths=he),ie}function A(U,j,N){const Y=I.sep===I.$fc.sep,ie=Y?U:U.replace(b,I.sep),V=I.sep+ie,he=I.$fc.sep+U;let oe;return N?oe=function(ee,M){return typeof ee=="string"&&(ee===ie||ee.endsWith(V)||!Y&&(ee===U||ee.endsWith(he)))?j:null}:oe=function(ee,M){return typeof ee=="string"&&(ee===ie||!Y&&ee===U)?j:null},oe.allPaths=[(N?"*/":"./")+U],oe}function O(U){try{const j=new RegExp(`^${v(U)}$`);return function(N){return j.lastIndex=0,typeof N=="string"&&j.test(N)?U:null}}catch{return s}}function W(U,j,N){return!U||typeof j!="string"?!1:x(U)(j,void 0,N)}function x(U,j={}){if(!U)return o;if(typeof U=="string"||H(U)){const N=a(U,j);if(N===s)return o;const Y=function(ie,V){return!!N(ie,V)};return N.allBasenames&&(Y.allBasenames=N.allBasenames),N.allPaths&&(Y.allPaths=N.allPaths),Y}return G(U,j)}function H(U){const j=U;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}function B(U){return U.allBasenames||[]}function X(U){return U.allPaths||[]}function G(U,j){const N=K(Object.getOwnPropertyNames(U).map(oe=>ae(oe,U[oe],j)).filter(oe=>oe!==s)),Y=N.length;if(!Y)return s;if(!N.some(oe=>!!oe.requiresSiblings)){if(Y===1)return N[0];const oe=function(F,C){let z;for(let Z=0,Q=N.length;Z<Q;Z++){const q=N[Z](F,C);if(typeof q=="string")return q;(0,r.$oh)(q)&&(z||(z=[]),z.push(q))}return z?(async()=>{for(const Z of z){const Q=await Z;if(typeof Q=="string")return Q}return null})():null},ee=N.find(F=>!!F.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const M=N.reduce((F,C)=>C.allPaths?F.concat(C.allPaths):F,[]);return M.length&&(oe.allPaths=M),oe}const ie=function(oe,ee,M){let F,C;for(let z=0,Z=N.length;z<Z;z++){const Q=N[z];Q.requiresSiblings&&M&&(ee||(ee=(0,I.$mc)(oe)),F||(F=ee.substr(0,ee.length-(0,I.$nc)(oe).length)));const q=Q(oe,ee,F,M);if(typeof q=="string")return q;(0,r.$oh)(q)&&(C||(C=[]),C.push(q))}return C?(async()=>{for(const z of C){const Z=await z;if(typeof Z=="string")return Z}return null})():null},V=N.find(oe=>!!oe.allBasenames);V&&(ie.allBasenames=V.allBasenames);const he=N.reduce((oe,ee)=>ee.allPaths?oe.concat(ee.allPaths):oe,[]);return he.length&&(ie.allPaths=he),ie}function ae(U,j,N){if(j===!1)return s;const Y=a(U,N);if(Y===s)return s;if(typeof j=="boolean")return Y;if(j){const ie=j.when;if(typeof ie=="string"){const V=(he,oe,ee,M)=>{if(!M||!Y(he,oe))return null;const F=ie.replace("$(basename)",()=>ee),C=M(F);return(0,r.$oh)(C)?C.then(z=>z?U:null):C?U:null};return V.requiresSiblings=!0,V}}return Y}function K(U,j){const N=U.filter(oe=>!!oe.basenames);if(N.length<2)return U;const Y=N.reduce((oe,ee)=>{const M=ee.basenames;return M?oe.concat(M):oe},[]);let ie;if(j){ie=[];for(let oe=0,ee=Y.length;oe<ee;oe++)ie.push(j)}else ie=N.reduce((oe,ee)=>{const M=ee.patterns;return M?oe.concat(M):oe},[]);const V=function(oe,ee){if(typeof oe!="string")return null;if(!ee){let F;for(F=oe.length;F>0;F--){const C=oe.charCodeAt(F-1);if(C===P.CharCode.Slash||C===P.CharCode.Backslash)break}ee=oe.substr(F)}const M=Y.indexOf(ee);return M!==-1?ie[M]:null};V.basenames=Y,V.patterns=ie,V.allBasenames=Y;const he=U.filter(oe=>!oe.basenames);return he.push(V),he}function te(U,j){return(0,n.$tb)(U,j,(N,Y)=>typeof N=="string"&&typeof Y=="string"?N===Y:typeof N!="string"&&typeof Y!="string"?N.base===Y.base&&N.pattern===Y.pattern:!1)}}),define(le[47],ue([0,1,20,32,9,3,18,25]),function(J,e,n,r,P,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=w,e.$Xw=g,e.$Yw=m,e.$Zw=b,e.$1w=p,e.$2w=k,e.$3w=S,e.$4w=t,e.$5w=u,e.$6w=i;function w(s,a){const{os:l,tildify:E,relative:y}=a;if(y){const A=c(s,y,l);if(typeof A=="string")return A}let D=s.fsPath;if(l===R.OperatingSystem.Windows&&!R.$j?D=D.replace(/\//g,"\\"):l!==R.OperatingSystem.Windows&&R.$j&&(D=D.replace(/\\/g,"/")),l!==R.OperatingSystem.Windows&&E?.userHome){const A=E.userHome.fsPath;let O;s.scheme!==E.userHome.scheme&&s.path[0]===P.$fc.sep&&s.path[1]!==P.$fc.sep?O=E.userHome.with({path:s.path}).fsPath:O=D,D=m(O,A,l)}return(l===R.OperatingSystem.Windows?P.$ec:P.$fc).normalize(g(D,l===R.OperatingSystem.Windows))}function c(s,a,l){const E=l===R.OperatingSystem.Windows?P.$ec:P.$fc,y=l===R.OperatingSystem.Linux?T.$6g:T.$8g,D=a.getWorkspace(),L=(0,n.$Nb)(D.folders);if(!L)return;s.scheme!==L.uri.scheme&&s.path[0]===P.$fc.sep&&s.path[1]!==P.$fc.sep&&(s=L.uri.with({path:s.path}));const A=a.getWorkspaceFolder(s);if(!A)return;let O;if(y.isEqual(A.uri,s)?O="":O=y.relativePath(A.uri,s)??"",O&&(O=E.normalize(O)),D.folders.length>1&&!a.noPrefix){const W=A.name?A.name:y.basenameOrAuthority(A.uri);O=O?`${W} \u2022 ${O}`:W}return O}function g(s,a=R.$j){return(0,r.$Gg)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}let h=Object.create(null);function m(s,a,l=R.OS){if(l===R.OperatingSystem.Windows||!s||!a)return s;let E=h.original===a?h.normalized:void 0;E||(E=a,R.$j&&(E=(0,r.$vg)(E)),E=`${(0,I.$lf)(E,P.$fc.sep)}${P.$fc.sep}`,h={original:a,normalized:E});let y=s;return R.$j&&(y=(0,r.$vg)(y)),(l===R.OperatingSystem.Linux?y.startsWith(E):(0,I.$Ef)(y,E))?`~/${y.substr(E.length)}`:s}function b(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}const f="\u2026",d="\\\\",v="~";function p(s,a=P.sep){const l=new Array(s.length);let E=!1;for(let y=0;y<s.length;y++){const D=s[y];if(D===""){l[y]=`.${a}`;continue}if(!D){l[y]=D;continue}E=!0;let L="",A=D;A.indexOf(d)===0?(L=A.substr(0,A.indexOf(d)+d.length),A=A.substr(A.indexOf(d)+d.length)):A.indexOf(a)===0?(L=A.substr(0,A.indexOf(a)+a.length),A=A.substr(A.indexOf(a)+a.length)):A.indexOf(v)===0&&(L=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const O=A.split(a);for(let W=1;E&&W<=O.length;W++)for(let x=O.length-W;E&&x>=0;x--){E=!1;let H=O.slice(x,x+W).join(a);for(let B=0;!E&&B<s.length;B++)if(B!==y&&s[B]&&s[B].indexOf(H)>-1){const X=x+W===O.length,G=x>0&&s[B].indexOf(a)>-1?a+H:H,ae=s[B].endsWith(G);E=!X||ae}if(!E){let B="";(O[0].endsWith(":")||L!=="")&&(x===1&&(x=0,W++,H=O[0]+a+H),x>0&&(B=O[0]+a),B=L+B),x>0&&(B=B+f+a),B=B+H,x+W<O.length&&(B=B+a+f),l[y]=B}}E&&(l[y]=D)}return l}var $;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})($||($={}));function k(s,a=Object.create(null)){const l=[];let E=!1,y="";for(const D of s)if(D==="$"||E&&D==="{")y&&l.push({value:y,type:$.TEXT}),y="",E=!0;else if(D==="}"&&E){const L=a[y];if(typeof L=="string")L.length&&l.push({value:L,type:$.VARIABLE});else if(L){const A=l[l.length-1];(!A||A.type!==$.SEPARATOR)&&l.push({value:L.label,type:$.SEPARATOR})}y="",E=!1}else y+=D;return y&&!E&&l.push({value:y,type:$.TEXT}),l.filter((D,L)=>{if(D.type===$.SEPARATOR){const A=l[L-1],O=l[L+1];return[A,O].every(W=>W&&(W.type===$.VARIABLE||W.type===$.TEXT)&&W.value.length>0)}return!0}).map(D=>D.value).join("")}function S(s,a){return R.$k||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):s.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function t(s,a){return R.$k||a?s.replace(/\(&&\w\)|&&/g,""):R.$j?s.replace(/&&|&/g,l=>l==="&"?"&&":"&"):s.replace(/&&/g,"_")}function u(s){return s.replace(/&/g,"&&")}function i(s){if(s.endsWith("]")){const a=s.lastIndexOf(" [",s.length-2);if(a!==-1){const l=o(s.substring(0,a)),E=s.substring(a);return{name:l.name+E,parentPath:l.parentPath}}}return o(s)}function o(s){const a=s.indexOf("/")!==-1?P.$fc:P.$ec,l=a.basename(s),E=a.dirname(s);return l.length?{name:l,parentPath:E}:{name:E,parentPath:""}}}),define(le[150],ue([0,1,16,90,7]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=w,e.$Mn=g,e.$Nn=h;function R(m){return m.toJSON()}class T{constructor(b){this.a=b}transformIncoming(b){const f=this.a.transformIncoming(b);return f===b?b:R(P.URI.from(f))}transformOutgoing(b){const f=this.a.transformOutgoing(b);return f===b?b:R(P.URI.from(f))}transformOutgoingURI(b){const f=this.a.transformOutgoing(b);return f===b?b:P.URI.from(f)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Jn=T,e.$Kn=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function I(m,b,f){if(!m||f>200)return null;if(typeof m=="object"){if(m instanceof P.URI)return b.transformOutgoing(m);for(const d in m)if(Object.hasOwnProperty.call(m,d)){const v=I(m[d],b,f+1);v!==null&&(m[d]=v)}}return null}function w(m,b){const f=I(m,b,0);return f===null?m:f}function c(m,b,f,d){if(!m||d>200)return null;if(typeof m=="object"){if(m.$mid===r.MarshalledId.Uri)return f?P.URI.revive(b.transformIncoming(m)):b.transformIncoming(m);if(m instanceof n.$Le)return null;for(const v in m)if(Object.hasOwnProperty.call(m,v)){const p=c(m[v],b,f,d+1);p!==null&&(m[v]=p)}}return null}function g(m,b){const f=c(m,b,!1,0);return f===null?m:f}function h(m,b){const f=c(m,b,!0,0);return f===null?m:f}}),define(le[33],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(P){return n.test(P)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(I){for(let w=0;w<I.length;w++)I[w]=Math.floor(Math.random()*256);return I};const R=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let w=0,c="";return c+=T[R[w++]],c+=T[R[w++]],c+=T[R[w++]],c+=T[R[w++]],c+="-",c+=T[R[w++]],c+=T[R[w++]],c+="-",c+=T[R[w++]],c+=T[R[w++]],c+="-",c+=T[R[w++]],c+=T[R[w++]],c+="-",c+=T[R[w++]],c+=T[R[w++]],c+=T[R[w++]],c+=T[R[w++]],c+=T[R[w++]],c+=T[R[w++]],c}}()}),define(le[151],ue([0,1,91,26,89]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uX=R,n=Ie(n),r=Ie(r);async function R(T,I){if(await new Promise((g,h)=>{const m=r.createReadStream(T),b=n.createHash("sha256");m.pipe(b);const f=(0,P.$cb)((d,v)=>{m.removeAllListeners(),b.removeAllListeners(),d?h(d):g(v)});m.once("error",f),m.once("end",f),b.once("error",f),b.once("data",d=>f(void 0,d.toString("hex")))})!==I)throw new Error("Hash mismatch")}}),define(le[152],ue([0,1,27]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=R;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(T){const I=T.replace(/\-/g,":").toLowerCase();return!r.has(I)}function R(){const T=(0,n.networkInterfaces)();for(const I in T){const w=T[I];if(w){for(const{mac:c}of w)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[92],ue([0,1,27,60,33,152,3]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=w,e.$Rn=h,e.$Sn=m,P=Ie(P),e.$Pn=new class{c(b){return this.a||(this.a=r.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,f=0;const d=(0,n.networkInterfaces)();for(const v in d){const p=d[v];if(p)for(const{mac:$,internal:k}of p)k||(f+=1,this.c($.toUpperCase())&&(b+=1))}this.b=f>0?b/f:0}return this.b}};let I;async function w(b){return I||(I=(async()=>await c(b)||P.$Yg())()),I}async function c(b){try{const f=await new Promise((v,p)=>{J(["crypto"],v,p)}).then(Ie),d=(0,R.$On)();return f.createHash("sha256").update(d,"utf8").digest("hex")}catch(f){b(f);return}}const g="Software\\Microsoft\\SQMClient";async function h(b){if(T.$j){const f=await new Promise((d,v)=>{J(["@vscode/windows-registry"],d,v)}).then(Ie);try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(d){return b(d),""}}return""}async function m(b){try{return await(await new Promise((v,p)=>{J(["@vscode/deviceid"],v,p)}).then(Ie)).getDeviceId()}catch(f){return b(f),""}}}),define(le[23],ue([0,1,26,27,153,8,32,78,9,3,18,7]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=v,e.readdirSync=k,e.whenDeleted=u,e.configureFlushOnWrite=l,e.writeFileSync=y,n=Ie(n);var m;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function b(G,ae=m.UNLINK,K){if((0,T.$Fg)(G))throw new Error("rimraf - will refuse to recursively delete root");return ae===m.UNLINK?d(G):f(G,K)}async function f(G,ae=(0,T.$Kg)((0,r.tmpdir)())){try{try{await n.promises.rename(G,ae)}catch(K){return K.code==="ENOENT"?void 0:d(G)}d(ae).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function d(G){return n.promises.rm(G,{recursive:!0,force:!0,maxRetries:3})}function v(G){if((0,T.$Fg)(G))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function p(G,ae){return S(await(ae?$(G):n.promises.readdir(G)))}async function $(G){try{return await n.promises.readdir(G,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const ae=[],K=await p(G);for(const te of K){let U=!1,j=!1,N=!1;try{const Y=await n.promises.lstat((0,w.$ic)(G,te));U=Y.isFile(),j=Y.isDirectory(),N=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}ae.push({name:te,isFile:()=>U,isDirectory:()=>j,isSymbolicLink:()=>N})}return ae}function k(G){return S(n.readdirSync(G))}function S(G){return G.map(ae=>typeof ae=="string"?c.$k?(0,I.$km)(ae):ae:(ae.name=c.$k?(0,I.$km)(ae.name):ae.name,ae))}async function t(G){const ae=await p(G),K=[];for(const te of ae)await i.existsDirectory((0,w.$ic)(G,te))&&K.push(te);return K}function u(G,ae=1e3){return new Promise(K=>{let te=!1;const U=setInterval(()=>{te||(te=!0,n.access(G,j=>{te=!1,j&&(clearInterval(U),K(void 0))}))},ae)})}var i;(function(G){async function ae(U){let j;try{if(j=await n.promises.lstat(U),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await n.promises.stat(U),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(c.$j&&N.code==="EACCES")try{return{stat:await n.promises.stat(await n.promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw Y}throw N}}G.stat=ae;async function K(U){try{const{stat:j,symbolicLink:N}=await G.stat(U);return j.isFile()&&N?.dangling!==!0}catch{}return!1}G.existsFile=K;async function te(U){try{const{stat:j,symbolicLink:N}=await G.stat(U);return j.isDirectory()&&N?.dangling!==!0}catch{}return!1}G.existsDirectory=te})(i||(e.SymlinkSupport=i={}));const o=new R.$Lh;function s(G,ae,K){return o.queueFor(h.URI.file(G),()=>{const te=D(K);return new Promise((U,j)=>E(G,ae,te,N=>N?j(N):U()))},g.$7g)}let a=!0;function l(G){a=G}function E(G,ae,K,te){if(!a)return n.writeFile(G,ae,{mode:K.mode,flag:K.flag},te);n.open(G,K.flag,K.mode,(U,j)=>{if(U)return te(U);n.writeFile(j,ae,N=>{if(N)return n.close(j,()=>te(N));n.fdatasync(j,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),l(!1)),n.close(j,ie=>te(ie))))})})}function y(G,ae,K){const te=D(K);if(!a)return n.writeFileSync(G,ae,{mode:te.mode,flag:te.flag});const U=n.openSync(G,te.flag,te.mode);try{n.writeFileSync(U,ae);try{n.fdatasyncSync(U)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{n.closeSync(U)}}function D(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function L(G,ae,K=6e4){if(G!==ae)try{c.$j&&typeof K=="number"?await A(G,ae,Date.now(),K):await n.promises.rename(G,ae)}catch(te){if(G.toLowerCase()!==ae.toLowerCase()&&te.code==="EXDEV"||G.endsWith("."))await O(G,ae,{preserveSymlinks:!1}),await b(G,m.MOVE);else throw te}}async function A(G,ae,K,te,U=0){try{return await n.promises.rename(G,ae)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-K>=te)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${j}`),j;if(U===0){let N=!1;try{const{stat:Y}=await i.stat(ae);Y.isFile()||(N=!0)}catch{}if(N)throw j}return await(0,R.$Dh)(Math.min(100,U*10)),A(G,ae,K,te,U+1)}}async function O(G,ae,K){return x(G,ae,{root:{source:G,target:ae},options:K,handledSourcePaths:new Set})}const W=511;async function x(G,ae,K){if(K.handledSourcePaths.has(G))return;K.handledSourcePaths.add(G);const{stat:te,symbolicLink:U}=await i.stat(G);if(U){if(K.options.preserveSymlinks)try{return await X(G,ae,K)}catch{}if(U.dangling)return}return te.isDirectory()?H(G,ae,te.mode&W,K):B(G,ae,te.mode&W)}async function H(G,ae,K,te){await n.promises.mkdir(ae,{recursive:!0,mode:K});const U=await p(G);for(const j of U)await x((0,w.$ic)(G,j),(0,w.$ic)(ae,j),te)}async function B(G,ae,K){await n.promises.copyFile(G,ae),await n.promises.chmod(ae,K)}async function X(G,ae,K){let te=await n.promises.readlink(G);(0,T.$Bg)(te,K.root.source,!c.$l)&&(te=(0,w.$ic)(K.root.target,te.substr(K.root.source.length+1))),await n.promises.symlink(te,ae)}e.Promises=new class{get read(){return(G,ae,K,te,U)=>new Promise((j,N)=>{n.read(G,ae,K,te,U,(Y,ie,V)=>Y?N(Y):j({bytesRead:ie,buffer:V}))})}get write(){return(G,ae,K,te,U)=>new Promise((j,N)=>{n.write(G,ae,K,te,U,(Y,ie,V)=>Y?N(Y):j({bytesWritten:ie,buffer:V}))})}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(G){try{return await n.promises.access(G),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return b}get rename(){return L}get copy(){return O}}}),define(le[112],ue([0,1,26,9,3,25,23]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=I,e.$jr=w,e.$kr=c,e.$lr=g,n=Ie(n);function I(m){if(P.$l)return m;const b=(0,r.$lc)(m);if(m===b)return m;const f=((0,r.$mc)(m)||m).toLowerCase();try{const v=(0,T.readdirSync)(b).filter(p=>p.toLowerCase()===f);if(v.length===1){const p=I(b);if(p)return(0,r.$ic)(p,v[0])}else if(v.length>1){const p=v.indexOf(f);if(p>=0){const $=I(b);if($)return(0,r.$ic)($,v[p])}}}catch{}return null}async function w(m,b){if(P.$l)return m;const f=(0,r.$lc)(m);if(m===f)return m;const d=((0,r.$mc)(m)||m).toLowerCase();try{if(b?.isCancellationRequested)return null;const p=(await T.Promises.readdir(f)).filter($=>$.toLowerCase()===d);if(p.length===1){const $=await w(f,b);if($)return(0,r.$ic)($,p[0])}else if(p.length>1){const $=p.indexOf(d);if($>=0){const k=await w(f,b);if(k)return(0,r.$ic)(k,p[$])}}}catch{}return null}async function c(m){try{return await T.Promises.realpath(m)}catch{const f=h(m);return await n.promises.access(f,n.constants.R_OK),f}}function g(m){try{return n.realpathSync(m)}catch{const f=h(m);return n.accessSync(f,n.constants.R_OK),f}}function h(m){return(0,R.$lf)((0,r.$gc)(m),r.sep)}}),define(le[113],ue([0,1,93]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=r,e.$3g=R,n=Ie(n);function r(I,w,c,g=1){let h=!1;return new Promise(m=>{const b=setTimeout(()=>{if(!h)return h=!0,m(0)},c);P(I,w,g,f=>{if(!h)return h=!0,clearTimeout(b),m(f)})})}function P(I,w,c,g){if(w===0)return g(0);const h=new n.Socket;h.once("connect",()=>(T(h),P(I+c,w-1,c,g))),h.once("data",()=>{}),h.once("error",m=>(T(h),m.code!=="ECONNREFUSED"?P(I+c,w-1,c,g):g(I))),h.connect(I,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(I,w,c,g="127.0.0.1"){let h=!1,m,b=1;const f=n.createServer({pauseOnConnect:!0});function d(v,p){h||(h=!0,f.removeAllListeners(),f.close(),m&&clearTimeout(m),p(v))}return new Promise(v=>{m=setTimeout(()=>{d(0,v)},c),f.on("listening",()=>{d(I,v)}),f.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&b<w?(I++,b++,f.listen(I,g)):d(0,v)}),f.on("close",()=>{d(0,v)}),f.listen(I,g)})}function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(w){console.error(w)}}}),define(le[114],ue([0,1,27,9,23]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=$,e.$um=k,n=Ie(n),r=Ie(r),P=Ie(P);const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var w;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(w||(w={}));let c;switch(process.arch){case"ia32":c=w.x86;break;case"arm":case"arm64":c=w.ARM;break;default:c=w.x64;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?w.ARM:w.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=w.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=w.x86:g=w.x64;class h{constructor(t,u,i){this.exePath=t,this.displayName=u,this.a=i}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:S=!1}={}){return S?c===w.x64?process.env["ProgramFiles(x86)"]||null:g===w.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:S=!1,findPreview:t=!1}={}){const u=m({useAlternateBitness:S});if(!u)return null;const i=r.$ic(u,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const E of await P.Promises.readdir(i)){let y=-1;if(t){const L=E.indexOf("-");if(L<0)continue;const A=E.substring(0,L);if(!R.test(A)||E.substring(L+1)!=="preview")continue;y=parseInt(A,10)}else{if(!R.test(E))continue;y=parseInt(E,10)}if(y<=o)continue;const D=r.$ic(i,E,"pwsh.exe");await P.SymlinkSupport.existsFile(D)&&(s=D,o=y)}if(!s)return null;const a=u.includes("x86")?" (x86)":"",l=t?" Preview":"";return new h(s,`PowerShell${l}${a}`,!0)}async function f({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const t=r.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:u,pwshMsixName:i}=S?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const o of await P.Promises.readdir(t))if(u.test(o)){const s=r.$ic(t,o,"pwsh.exe");return new h(s,i)}return null}function d(){const S=r.$ic(n.homedir(),".dotnet","tools","pwsh.exe");return new h(S,".NET Core PowerShell Global Tool")}function v(){const S=r.$ic(process.env.windir,c===w.x86&&g!==w.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(S,"Windows PowerShell",!0)}async function*p(){let S=await b();S&&(yield S),S=await b({useAlternateBitness:!0}),S&&(yield S),S=await f(),S&&(yield S),S=d(),S&&(yield S),S=await b({findPreview:!0}),S&&(yield S),S=await f({findPreview:!0}),S&&(yield S),S=await b({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=v(),S&&(yield S)}async function*$(){for await(const S of p())await S.exists()&&(yield S)}async function k(){for await(const S of $())return S;return null}}),define(le[94],ue([0,1,26,9,3,36,79,12,23]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$vm=c,e.$wm=g,r=Ie(r),P=Ie(P),R=Ie(R),I=Ie(I),w=Ie(w),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function c(m=R.env){return m.comspec||"cmd.exe"}function g(m){let b=[],f=!1;const d=function(v){if(f){b.push(v);return}(!m.send(v,$=>{if($&&console.error($),f=!1,b.length>0){const k=b.slice(0);b=[],k.forEach(S=>d(S))}})||P.$j)&&(f=!0)};return{send:d}}var h;(function(m){async function b(f,d,v){if(r.$hc(f))return f;if(d===void 0&&(d=R.cwd()),r.$lc(f)!=="."||(v===void 0&&I.$cg(R.env.PATH)&&(v=R.env.PATH.split(r.$sc)),v===void 0||v.length===0))return r.$ic(d,f);async function $(k){if(await w.Promises.exists(k)){let S;try{S=await n.promises.stat(k)}catch(t){t.message.startsWith("EACCES")&&(S=await n.promises.lstat(k))}return S?!S.isDirectory():!1}return!1}for(const k of v){let S;if(r.$hc(k)?S=r.$ic(k,f):S=r.$ic(d,k,f),await $(S))return S;let t=S+".com";if(await $(t)||(t=S+".exe",await $(t)))return t}return r.$ic(d,f)}m.findExecutable=b})(h||(e.win32=h={}))}),define(le[115],ue([0,1,48,11]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=P;function P(T){return new Promise((I,w)=>{let c;const g=new Map;function h(b,f,d,v,p){const $=g.get(f);if(b===T||$){const k={name:m(d),cmd:d,pid:b,ppid:f,load:v,mem:p};g.set(b,k),b===T&&(c=k),$&&($.children||($.children=[]),$.children.push(k),$.children.length>1&&($.children=$.children.sort((S,t)=>S.pid-t.pid)))}}function m(b){const f=/--utility-sub-type=network/i,d=/--crashes-directory/i,v=/\\pipe\\winpty-control/i,p=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(b))return"electron-crash-reporter";if(v.exec(b))return"winpty-agent";if(p.exec(b))return"conpty-agent";let k=$.exec(b);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?f.exec(b)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const S=/[a-zA-Z-]+\.js/g;let t="";do k=S.exec(b),k&&(t+=k+" ");while(k);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron-nodejs (${t})`:b}if(process.platform==="win32"){const b=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,d)=>{J(["@vscode/windows-process-tree"],f,d)}).then(Ie).then(f=>{f.getProcessList(T,d=>{if(!d){w(new Error(`Root process ${T} not found`));return}f.getProcessCpuUsage(d,v=>{const p=new Map;v.forEach($=>{const k=b($.commandLine||"");p.set($.pid,{name:m(k),cmd:k,pid:$.pid,ppid:$.ppid,load:$.cpu||0,mem:$.memory||0})}),c=p.get(T),c?(p.forEach($=>{const k=p.get($.ppid);k&&(k.children||(k.children=[]),k.children.push($))}),p.forEach($=>{$.children&&($.children=$.children.sort((k,S)=>k.pid-S.pid))}),I(c)):w(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let b=function(){let f=[c];const d=[];for(;f.length;){const p=f.shift();p&&(d.push(p.pid),p.children&&(f=f.concat(p.children)))}let v=JSON.stringify(r.$Wg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+d.join(" "),(0,n.exec)(v,{},(p,$,k)=>{if(p||k)w(p||new Error(k.toString()));else{const S=$.toString().split(`
`);for(let t=0;t<d.length;t++){const u=g.get(d[t]);u.load=parseFloat(S[t])}if(!c){w(new Error(`Root process ${T} not found`));return}I(c)}})};(0,n.exec)("which ps",{},(f,d,v)=>{if(f||v)if(process.platform!=="linux")w(f||new Error(v.toString()));else{const p=JSON.stringify(r.$Wg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(p,{},($,k,S)=>{$||S?w($||new Error(S.toString())):(R(k,h),b())})}else{const p=d.toString().trim();(0,n.exec)(`${p} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,S,t)=>{k||t&&!t.includes("screen size is bogus")?w(k||new Error(t.toString())):(R(S,h),process.platform==="linux"?b():c?I(c):w(new Error(`Root process ${T} not found`)))})}})}})}function R(T,I){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=T.toString().split(`
`);for(const g of c){const h=w.exec(g.trim());h&&h.length===6&&I(parseInt(h[1]),parseInt(h[2]),h[5],parseFloat(h[3]),parseFloat(h[4]))}}}),define(le[116],ue([0,1,27,3,114,94]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=T,r=Ie(r),R=Ie(R);async function T(h,m){return h===r.OperatingSystem.Windows?r.$j?g():R.$vm(m):w(h,m)}let I=null;function w(h,m){if(r.$l&&h===r.OperatingSystem.Macintosh||r.$k&&h===r.OperatingSystem.Linux)return"/bin/bash";if(!I){let b;if(r.$j)b="/bin/bash";else{if(b=m.SHELL,!b)try{b=(0,n.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}I=b}return I}let c=null;async function g(){return c||(c=(await(0,P.$um)()).exePath),c}}),function(){function J(){function e(){return process.uncHostAllowlist}function n(w){const c=new Set;if(Array.isArray(w))for(const g of w)typeof g=="string"&&c.add(g);return Array.from(c)}function r(){const w=e();return w?Array.from(w):[]}function P(w){if(process.platform!=="win32")return;const c=e();if(c)if(typeof w=="string")c.add(w.toLowerCase());else for(const g of n(w))P(g)}function R(w){if(typeof w!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const h of c){if(w.indexOf(h)!==0)continue;const b=w.indexOf("\\",h.length);if(b===-1)continue;const f=w.substring(h.length,b);if(f){g=f;break}}return g}function T(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:P,getUNCHost:R,disableUNCAccessRestrictions:T,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(le[154],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AX=e.$zX=void 0,e.$zX="vscode:contextmenu",e.$AX="vscode:onCloseContextMenu"});var Ee=this&&this.__decorate||function(J,e,n,r){var P=arguments.length,R=P<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(J,e,n,r);else for(var I=J.length-1;I>=0;I--)(T=J[I])&&(R=(P<3?T(R):P>3?T(e,n,R):T(e,n))||R);return P>3&&R&&Object.defineProperty(e,n,R),R};define(le[44],ue([0,1,20,8,16,21,53,15,4,2,82,25,12]),function(J,e,n,r,P,R,T,I,w,c,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=l,e.$di=E,e.$ii=W,e.$ji=x,h=Ie(h);var b;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(b||(b={}));function f(U){switch(U){case b.Promise:return"req";case b.PromiseCancel:return"cancel";case b.EventListen:return"subscribe";case b.EventDispose:return"unsubscribe"}}var d;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(d||(d={}));function v(U){switch(U){case d.Initialize:return"init";case d.PromiseSuccess:return"reply:";case d.PromiseError:case d.PromiseErrorObj:return"replyErr:";case d.EventFire:return"event:"}}var p;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(p||(p={}));function $(U){let j=0;for(let N=0;;N+=7){const Y=U.read(1);if(j|=(Y.buffer[0]&127)<<N,!(Y.buffer[0]&128))return j}}const k=o(0);function S(U,j){if(j===0){U.write(k);return}let N=0;for(let ie=j;ie!==0;ie=ie>>>7)N++;const Y=P.$Le.alloc(N);for(let ie=0;j!==0;ie++)Y.buffer[ie]=j&127,j=j>>>7,j>0&&(Y.buffer[ie]|=128);U.write(Y)}class t{constructor(j){this.b=j,this.a=0}read(j){const N=this.b.slice(this.a,this.a+j);return this.a+=N.byteLength,N}}e.$ai=t;class u{constructor(){this.a=[]}get buffer(){return P.$Le.concat(this.a)}write(j){this.a.push(j)}}e.$bi=u;var i;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(i||(i={}));function o(U){const j=P.$Le.alloc(1);return j.writeUInt8(U,0),j}const s={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},a=typeof Buffer<"u";function l(U,j){if(typeof j>"u")U.write(s.Undefined);else if(typeof j=="string"){const N=P.$Le.fromString(j);U.write(s.String),S(U,N.byteLength),U.write(N)}else if(a&&Buffer.isBuffer(j)){const N=P.$Le.wrap(j);U.write(s.Buffer),S(U,N.byteLength),U.write(N)}else if(j instanceof P.$Le)U.write(s.VSBuffer),S(U,j.byteLength),U.write(j);else if(Array.isArray(j)){U.write(s.Array),S(U,j.length);for(const N of j)l(U,N)}else if(typeof j=="number"&&(j|0)===j)U.write(s.Uint),S(U,j);else{const N=P.$Le.fromString(JSON.stringify(j));U.write(s.Object),S(U,N.byteLength),U.write(N)}}function E(U){switch(U.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return U.read($(U)).toString();case i.Buffer:return U.read($(U)).buffer;case i.VSBuffer:return U.read($(U));case i.Array:{const N=$(U),Y=[];for(let ie=0;ie<N;ie++)Y.push(E(U));return Y}case i.Object:return JSON.parse(U.read($(U)).toString());case i.Int:return $(U)}}class y{constructor(j,N,Y=null,ie=1e3){this.h=j,this.j=N,this.k=Y,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(V=>this.q(V)),this.m({type:d.Initialize})}registerChannel(j,N){this.b.set(j,N),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case d.Initialize:{const N=this.o([j.type]);this.k?.logOutgoing(N,0,D.OtherSide,v(j.type));return}case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:{const N=this.o([j.type,j.id],j.data);this.k?.logOutgoing(N,j.id,D.OtherSide,v(j.type),j.data);return}}}o(j,N=void 0){const Y=new u;return l(Y,j),l(Y,N),this.p(Y.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const N=new t(j),Y=E(N),ie=E(N),V=Y[0];switch(V){case b.Promise:return this.k?.logIncoming(j.byteLength,Y[1],D.OtherSide,`${f(V)}: ${Y[2]}.${Y[3]}`,ie),this.s({type:V,id:Y[1],channelName:Y[2],name:Y[3],arg:ie});case b.EventListen:return this.k?.logIncoming(j.byteLength,Y[1],D.OtherSide,`${f(V)}: ${Y[2]}.${Y[3]}`,ie),this.t({type:V,id:Y[1],channelName:Y[2],name:Y[3],arg:ie});case b.PromiseCancel:return this.k?.logIncoming(j.byteLength,Y[1],D.OtherSide,`${f(V)}`),this.u({type:V,id:Y[1]});case b.EventDispose:return this.k?.logIncoming(j.byteLength,Y[1],D.OtherSide,`${f(V)}`),this.u({type:V,id:Y[1]})}}s(j){const N=this.b.get(j.channelName);if(!N){this.v(j);return}const Y=new R.$ue;let ie;try{ie=N.call(this.j,j.name,j.arg,Y.token)}catch(oe){ie=Promise.reject(oe)}const V=j.id;ie.then(oe=>{this.m({id:V,data:oe,type:d.PromiseSuccess})},oe=>{oe instanceof Error?this.m({id:V,data:{message:oe.message,name:oe.name,stack:oe.stack?oe.stack.split(`
`):void 0},type:d.PromiseError}):this.m({id:V,data:oe,type:d.PromiseErrorObj})}).finally(()=>{he.dispose(),this.d.delete(j.id)});const he=(0,c.$Rc)(()=>Y.cancel());this.d.set(j.id,he)}t(j){const N=this.b.get(j.channelName);if(!N){this.v(j);return}const Y=j.id,V=N.listen(this.j,j.name,j.arg)(he=>this.m({id:Y,data:he,type:d.EventFire}));this.d.set(j.id,V)}u(j){const N=this.d.get(j.id);N&&(N.dispose(),this.d.delete(j.id))}v(j){let N=this.g.get(j.channelName);N||(N=[],this.g.set(j.channelName,N));const Y=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===b.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:d.PromiseError})},this.l);N.push({request:j,timeoutTimer:Y})}w(j){const N=this.g.get(j);if(N){for(const Y of N)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case b.Promise:this.s(Y.request);break;case b.EventListen:this.t(Y.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$ei=y;var D;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class L{constructor(j,N=null){this.l=j,this.a=!1,this.b=p.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=N}getChannel(j){const N=this;return{call(Y,ie,V){return N.a?Promise.reject(new I.$4):N.m(j,Y,ie,V)},listen(Y,ie){return N.a?w.Event.None:N.o(j,Y,ie)}}}m(j,N,Y,ie=R.CancellationToken.None){const V=this.g++,he=b.Promise,oe={id:V,type:he,channelName:j,name:N,arg:Y};if(ie.isCancellationRequested)return Promise.reject(new I.$4);let ee;return new Promise((F,C)=>{if(ie.isCancellationRequested)return C(new I.$4);const z=()=>{const se=de=>{switch(de.type){case d.PromiseSuccess:this.f.delete(V),F(de.data);break;case d.PromiseError:{this.f.delete(V);const me=new Error(de.data.message);me.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,me.name=de.data.name,C(me);break}case d.PromiseErrorObj:this.f.delete(V),C(de.data);break}};this.f.set(V,se),this.p(oe)};let Z=null;this.b===p.Idle?z():(Z=(0,r.$ph)(se=>this.u()),Z.then(()=>{Z=null,z()}));const Q=()=>{Z?(Z.cancel(),Z=null):this.p({id:V,type:b.PromiseCancel}),C(new I.$4)},q=ie.onCancellationRequested(Q);ee=(0,c.$Qc)((0,c.$Rc)(Q),q),this.d.add(ee)}).finally(()=>{ee.dispose(),this.d.delete(ee)})}o(j,N,Y){const ie=this.g++,V=b.EventListen,he={id:ie,type:V,channelName:j,name:N,arg:Y};let oe=null;const ee=new w.$je({onWillAddFirstListener:()=>{oe=(0,r.$ph)(F=>this.u()),oe.then(()=>{oe=null,this.d.add(ee),this.p(he)})},onDidRemoveLastListener:()=>{oe?(oe.cancel(),oe=null):(this.d.delete(ee),this.p({id:ie,type:b.EventDispose}))}}),M=F=>ee.fire(F.data);return this.f.set(ie,M),ee.event}p(j){switch(j.type){case b.Promise:case b.EventListen:{const N=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(N,j.id,D.LocalSide,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case b.PromiseCancel:case b.EventDispose:{const N=this.q([j.type,j.id]);this.j?.logOutgoing(N,j.id,D.LocalSide,f(j.type));return}}}q(j,N=void 0){const Y=new u;return l(Y,j),l(Y,N),this.r(Y.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const N=new t(j),Y=E(N),ie=E(N),V=Y[0];switch(V){case d.Initialize:return this.j?.logIncoming(j.byteLength,0,D.LocalSide,v(V)),this.t({type:Y[0]});case d.PromiseSuccess:case d.PromiseError:case d.EventFire:case d.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,Y[1],D.LocalSide,v(V),ie),this.t({type:Y[0],id:Y[1],data:ie})}}t(j){if(j.type===d.Initialize){this.b=p.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$fi=L,Ee([T.$7h],L.prototype,"onDidInitializePromise",null);class A{get connections(){const j=[];return this.f.forEach(N=>j.push(N)),j}constructor(j,N,Y){this.a=new Map,this.f=new Set,this.g=new w.$je,this.onDidAddConnection=this.g.event,this.h=new w.$je,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(j(({protocol:ie,onDidClientDisconnect:V})=>{const he=w.Event.once(ie.onMessage);this.j.add(he(oe=>{const ee=new t(oe),M=E(ee),F=new y(ie,M,N,Y),C=new L(ie,N);this.a.forEach((Z,Q)=>F.registerChannel(Q,Z));const z={channelServer:F,channelClient:C,ctx:M};this.f.add(z),this.g.fire(z),this.j.add(V(()=>{F.dispose(),C.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(j,N){const Y=this;return{call(ie,V,he){let oe;if((0,m.$qg)(N)){const M=(0,n.$2b)(Y.connections.filter(N));oe=M?Promise.resolve(M):w.Event.toPromise(w.Event.filter(Y.onDidAddConnection,N))}else oe=N.routeCall(Y,ie,V);const ee=oe.then(M=>M.channelClient.getChannel(j));return W(ee).call(ie,V,he)},listen(ie,V){if((0,m.$qg)(N))return Y.k(j,N,ie,V);const he=N.routeEvent(Y,ie,V).then(oe=>oe.channelClient.getChannel(j));return W(he).listen(ie,V)}}}k(j,N,Y,ie){const V=this;let he;const oe=new w.$je({onWillAddFirstListener:()=>{he=new c.$Sc;const ee=new w.$pe,M=new Map,F=z=>{const Q=z.channelClient.getChannel(j).listen(Y,ie),q=ee.add(Q);M.set(z,q)},C=z=>{const Z=M.get(z);Z&&(Z.dispose(),M.delete(z))};V.connections.filter(N).forEach(F),w.Event.filter(V.onDidAddConnection,N)(F,void 0,he),V.onDidRemoveConnection(C,void 0,he),ee.event(oe.fire,oe,he),he.add(ee)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return oe.event}registerChannel(j,N){this.a.set(j,N);for(const Y of this.f)Y.channelServer.registerChannel(j,N)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=A;class O{constructor(j,N,Y=null){const ie=new u;l(ie,N),j.send(ie.buffer),this.a=new L(j,Y),this.d=new y(j,N,Y)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,N){this.d.registerChannel(j,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=O;function W(U){return{call(j,N,Y){return U.then(ie=>ie.call(j,N,Y))},listen(j,N){const Y=new w.$se;return U.then(ie=>Y.input=ie.listen(j,N)),Y.event}}}function x(U){let j=!1;return{call(N,Y,ie){return j?U.call(N,Y,ie):(0,r.$Dh)(0).then(()=>j=!0).then(()=>U.call(N,Y,ie))},listen(N,Y){if(j)return U.listen(N,Y);const ie=new w.$se;return(0,r.$Dh)(0).then(()=>j=!0).then(()=>ie.input=U.listen(N,Y)),ie.event}}}class H{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const N of j.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await w.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$ki=H;var B;(function(U){function j(V,he,oe){const ee=V,M=oe&&oe.disableMarshalling,F=new Map;for(const C in ee)Y(C)&&F.set(C,w.Event.buffer(ee[C],!0,void 0,he));return new class{listen(C,z,Z){const Q=F.get(z);if(Q)return Q;const q=ee[z];if(typeof q=="function"){if(ie(z))return q.call(ee,Z);if(Y(z))return F.set(z,w.Event.buffer(ee[z],!0,void 0,he)),F.get(z)}throw new I.$ab(`Event not found: ${z}`)}call(C,z,Z){const Q=ee[z];if(typeof Q=="function"){if(!M&&Array.isArray(Z))for(let se=0;se<Z.length;se++)Z[se]=(0,g.$_h)(Z[se]);let q=Q.apply(ee,Z);return q instanceof Promise||(q=Promise.resolve(q)),q}throw new I.$ab(`Method not found: ${z}`)}}}U.fromService=j;function N(V,he){const oe=he&&he.disableMarshalling;return new Proxy({},{get(ee,M){if(typeof M=="string")return he?.properties?.has(M)?he.properties.get(M):ie(M)?function(F){return V.listen(M,F)}:Y(M)?V.listen(M):async function(...F){let C;he&&!(0,m.$lg)(he.context)?C=[he.context,...F]:C=F;const z=await V.call(M,C);return oe?z:(0,g.$_h)(z)};throw new I.$ab(`Property not found: ${String(M)}`)}})}U.toService=N;function Y(V){return V[0]==="o"&&V[1]==="n"&&h.$Cf(V.charCodeAt(2))}function ie(V){return/^onDynamic/.test(V)&&h.$Cf(V.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const j=U.toString();if(j!=="[object Object]")return j}return U}function ae(U){return Array.isArray(U)?U.map(G):G(U)}function K(U,j,N,Y,ie,V,he){he=ae(he);const oe=X[ie],ee=oe[Y%oe.length];let M=[`%c[${U}]%c[${String(j).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(V)?(M=M.concat(he),M.push(")")):M.push(he),console.log.apply(console,M)}class te{constructor(j,N){this.d=j,this.f=N,this.a=0,this.b=0}logOutgoing(j,N,Y,ie,V){this.b+=j,K(this.d,this.b,j,N,Y,ie,V)}logIncoming(j,N,Y,ie,V){this.a+=j,K(this.f,this.a,j,N,Y,ie,V)}}e.$li=te}),define(le[155],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HX=void 0;class n{constructor(P,R){this.a=P,this.onMessage=R}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$HX=n}),define(le[156],ue([0,1,16,4,44]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=e.$EX=void 0;class R{constructor(w){this.a=w,this.onMessage=r.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$Le.wrap(c.data):n.$Le.alloc(0)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}e.$EX=R;class T extends P.$hi{constructor(w,c){const g=new R(w);super(g,c),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$FX=T}),define(le[117],ue([0,1,16,4,2,44]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let l=0;function E(D,L){if(!a.has(D)){const A=String(++l);a.set(D,A)}return a.get(D)}function y(D,L,A,O){if(!s.enableDiagnostics)return;const W=E(D,L);if(O instanceof n.$Le||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const x=n.$Le.alloc(O.byteLength);x.set(O),s.records.push({timestamp:Date.now(),id:W,label:L,type:A,buff:x})}else s.records.push({timestamp:Date.now(),id:W,label:L,type:A,data:O})}s.traceSocketEvent=y})(I||(e.SocketDiagnostics=I={}));var w;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let c=null;function g(){return c||(c=n.$Le.alloc(0)),c}class h{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,l){if(a===0)return g();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const L=this.a[0];return l&&(this.a.shift(),this.b-=a),L}if(this.a[0].byteLength>a){const L=this.a[0].slice(0,a);return l&&(this.a[0]=this.a[0].slice(a),this.b-=a),L}const E=n.$Le.alloc(a);let y=0,D=0;for(;a>0;){const L=this.a[D];if(L.byteLength>a){const A=L.slice(0,a);E.set(A,y),y+=a,l&&(this.a[D]=L.slice(a),this.b-=a),a-=a}else E.set(L,y),y+=L.byteLength,l?(this.a.shift(),this.b-=L.byteLength):D++,a-=L.byteLength}return E}}e.$mi=h;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function b(s){switch(s){case m.None:return"None";case m.Regular:return"Regular";case m.Control:return"Control";case m.Ack:return"Ack";case m.Disconnect:return"Disconnect";case m.ReplayRequest:return"ReplayRequest";case m.Pause:return"PauseWriting";case m.Resume:return"ResumeWriting";case m.KeepAlive:return"KeepAlive"}}var f;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class d{constructor(a,l,E,y){this.type=a,this.id=l,this.ack=E,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends P.$Tc{constructor(a){super(),this.f=this.B(new r.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:f.HeaderLength,messageType:m.None,id:0,ack:0},this.a=a,this.b=!1,this.c=new h,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:b(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const E=this.g.messageType,y=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=f.HeaderLength,this.g.messageType=m.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,l),this.f.fire(new d(E,y,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Le.alloc(f.HeaderLength);l.writeUInt8(a.type,0),l.writeUInt32BE(a.id,1),l.writeUInt32BE(a.ack,5),l.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:b(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,a.data),this.j(l,a.data)}g(a,l){const E=this.f===0;return this.d.push(a,l),this.f+=a.byteLength+l.byteLength,E}h(){const a=n.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,l){this.g(a,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:a.byteLength}),this.c.write(a)}}class $ extends P.$Tc{constructor(a){super(),this.f=new r.$je,this.onMessage=this.f.event,this.g=new r.$je,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new p(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(l=>{l.type===m.Regular&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new d(m.Regular,0,0,a))}}e.$ni=$;class k extends R.$hi{static fromSocket(a,l){return new k(new $(a),l)}get onDidDispose(){return this.b.onDidDispose}constructor(a,l,E=null){super(a,l,E),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$oi=k;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$pi=S;class t{constructor(a){this.data=a,this.next=null}}class u{constructor(){this.a=null,this.b=null}length(){let a=0,l=this.a;for(;l;)l=l.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let l=0,E=this.a;for(;E;)a[l++]=E.data,E=E.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const l=new t(a);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const a=Date.now();for(let l=0;l<i.a;l++)this.c[l]=a-1e3*l;setInterval(()=>{for(let l=i.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),l=(1+i.a)*1e3;let E=0;for(let y=0;y<i.a;y++)a-this.c[y]<=l&&E++;return 1-E/i.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.d-this.f}constructor(a){this.v=new S,this.onControlMessage=this.v.event,this.w=new S,this.onMessage=this.w.event,this.x=new S,this.onDidDispose=this.x.event,this.y=new S,this.onSocketClose=this.y.event,this.z=new S,this.onSocketTimeout=this.z.event,this.t=a.loadEstimator??i.getInstance(),this.u=a.sendKeepAlive??!0,this.a=!1,this.c=new u,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new P.$Sc,this.p=a.socket,this.q=this.s.add(new p(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(l=>this.A(l))),this.s.add(this.p.onClose(l=>this.y.fire(l))),a.initialChunk&&this.r.acceptChunk(a.initialChunk),this.u?this.m=setInterval(()=>{this.E()},f.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const a=new d(m.Disconnect,0,0,g());this.q.write(a),this.q.flush()}}sendPause(){const a=new d(m.Pause,0,0,g());this.q.write(a)}sendResume(){const a=new d(m.Resume,0,0,g());this.q.write(a)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(a,l){this.a=!0,this.s.dispose(),this.s=new P.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=a,this.q=this.s.add(new p(this.p)),this.r=this.s.add(new v(this.p)),this.s.add(this.r.onMessage(E=>this.A(E))),this.s.add(this.p.onClose(E=>this.y.fire(E))),this.r.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.j=this.h;const a=new d(m.Ack,0,this.j,g());this.q.write(a);const l=this.c.toArray();for(let E=0,y=l.length;E<y;E++)this.q.write(l[E]);this.C()}acceptDisconnect(){this.x.fire()}A(a){if(a.ack>this.f){this.f=a.ack;do{const l=this.c.peek();if(l&&l.id<=a.ack)this.c.pop();else break}while(!0)}switch(a.type){case m.None:break;case m.Regular:{if(a.id>this.h)if(a.id!==this.h+1){const l=Date.now();l-this.n>1e4&&(this.n=l,this.q.write(new d(m.ReplayRequest,0,0,g())))}else this.h=a.id,this.k=Date.now(),this.B(),this.w.fire(a.data);break}case m.Control:{this.v.fire(a.data);break}case m.Ack:break;case m.Disconnect:{this.x.fire();break}case m.ReplayRequest:{const l=this.c.toArray();for(let E=0,y=l.length;E<y;E++)this.q.write(l[E]);this.C();break}case m.Pause:{this.q.pause();break}case m.Resume:{this.q.resume();break}case m.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(a){const l=++this.d;this.j=this.h;const E=new d(m.Regular,l,this.j,a);this.c.push(E),this.a||(this.q.write(E),this.C())}sendControl(a){const l=new d(m.Control,0,0,a);this.q.write(l)}B(){if(this.h<=this.j||this.l)return;const a=Date.now()-this.k;if(a>=f.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},f.AcknowledgeTime-a+5)}C(){if(this.d<=this.f||this.g||this.a)return;const a=this.c.peek(),l=Date.now()-a.writtenTime,E=Date.now()-this.r.lastReadTime,y=Date.now()-this.o;if(l>=f.TimeoutTime&&E>=f.TimeoutTime&&y>=f.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:E});return}const D=Math.max(f.TimeoutTime-l,f.TimeoutTime-E,f.TimeoutTime-y,500);this.g=setTimeout(()=>{this.g=null,this.C()},D)}D(){if(this.h<=this.j)return;this.j=this.h;const a=new d(m.Ack,0,this.j,g());this.q.write(a)}E(){this.j=this.h;const a=new d(m.KeepAlive,0,this.j,g());this.q.write(a)}}e.$qi=o}),define(le[35],ue([0,1,13,15,11]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BX=void 0;class R{constructor(){this.a=new WeakMap}on(I,w){const c=(g,...h)=>{this.b(I,g)&&w(g,...h)};return this.a.set(w,c),n.ipcMain.on(I,c),this}once(I,w){return n.ipcMain.once(I,(c,...g)=>{this.b(I,c)&&w(c,...g)}),this}handle(I,w){return n.ipcMain.handle(I,(c,...g)=>this.b(I,c)?w(c,...g):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return n.ipcMain.removeHandler(I),this}removeListener(I,w){const c=this.a.get(w);return c&&(n.ipcMain.removeListener(I,c),this.a.delete(w)),this}b(I,w){if(!I||!I.startsWith("vscode:"))return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const c=w.senderFrame,g=c.url;if(!g||g==="about:blank")return!0;let h="unknown";try{h=new URL(g).host}catch{return(0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${g}'.`),!1}return h!==P.$Vg?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${h}'.`),!1):c.parent!==null?((0,r.$Y)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${h}' is not a main frame.`),!1):!0}}e.$BX=new R}),define(le[157],ue([0,1,13,35,154]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CX=R;function R(){r.$BX.on(P.$zX,(I,w,c,g,h)=>{const m=T(I,g,c);m.popup({x:h?h.x:void 0,y:h?h.y:void 0,positioningItem:h?h.positioningItem:void 0,callback:()=>{m&&I.sender.send(P.$AX,w)}})})}function T(I,w,c){const g=new n.Menu;return c.forEach(h=>{let m;h.type==="separator"?m=new n.MenuItem({type:h.type}):Array.isArray(h.submenu)?m=new n.MenuItem({submenu:T(I,w,h.submenu),label:h.label}):m=new n.MenuItem({label:h.label,type:h.type,accelerator:h.accelerator,checked:h.checked,enabled:h.enabled,visible:h.visible,click:(b,f,d)=>I.sender.send(w,h.id,d)}),g.append(m)}),g}}),define(le[158],ue([0,1,35,16,4,2,44,155]),function(J,e,n,r,P,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IX=void 0;function w(g,h){const m=P.Event.fromNodeEventEmitter(n.$BX,h,(f,d)=>({event:f,message:d})),b=P.Event.filter(m,({event:f})=>f.sender.id===g);return P.Event.map(b,({message:f})=>f&&r.$Le.wrap(f))}class c extends T.$gi{static{this.b=new Map}static d(){const h=P.Event.fromNodeEventEmitter(n.$BX,"vscode:hello",({sender:m})=>m);return P.Event.map(h,m=>{const b=m.id;c.b.get(b)?.dispose();const d=new P.$je;c.b.set(b,(0,R.$Rc)(()=>d.fire()));const v=w(b,"vscode:message"),p=P.Event.any(P.Event.signal(w(b,"vscode:disconnect")),d.event);return{protocol:new I.$HX(m,v),onDidClientDisconnect:p}})}constructor(){super(c.d())}}e.$IX=c}),define(le[118],ue([0,1,35,4,33,156]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JX=void 0,e.$KX=I;class T extends R.$FX{constructor(c,g){super({addEventListener:(h,m)=>c.addListener(h,m),removeEventListener:(h,m)=>c.removeListener(h,m),postMessage:h=>c.postMessage(h),start:()=>c.start(),close:()=>c.close()},g)}}e.$JX=T;async function I(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,P.$Yg)();w.webContents.send("vscode:createMessageChannel",c);const g=r.Event.fromNodeEventEmitter(n.$BX,"vscode:createMessageChannelResult",(m,b)=>({nonce:b,port:m.ports[0]})),{port:h}=await r.Event.toPromise(r.Event.once(r.Event.filter(g,m=>m.nonce===c)));return h}}),define(le[159],ue([0,1,48,8,16,21,149,15,4,2,37,94,79,44]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,I=Ie(I);class f extends b.$ei{constructor(p){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",$=>P.$Le.wrap(Buffer.from($,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.$er=f;class d{constructor(p,$){this.i=p,this.j=$,this.c=new Set,this.g=new Map,this.h=new w.$je,this.onDidProcessExit=this.h.event;const k=$&&$.timeout?$.timeout:6e4;this.b=new r.$zh(k),this.d=null,this.f=null}getChannel(p){const $=this;return{call(k,S,t){return $.k(p,k,S,t)},listen(k,S){return $.l(p,k,S)}}}k(p,$,k,S=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(I.$5());this.b.cancel();const t=this.n(p),u=(0,r.$ph)(s=>t.call($,k,s)),i=S.onCancellationRequested(()=>u.cancel()),o=(0,c.$Rc)(()=>u.cancel());return this.c.add(o),u.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),u}l(p,$,k){if(!this.b)return w.Event.None;this.b.cancel();let S;const t=new w.$je({onWillAddFirstListener:()=>{S=this.n(p).listen($,k)(t.fire,t),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const p=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,g.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,m.$jm)($.env),this.d=(0,n.fork)(this.i,p,$);const k=new w.$je,t=w.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,T.$ar)(l)){(0,T.log)(l,`IPC Library: ${this.j.serverName}`);return}k.fire(P.$Le.wrap(Buffer.from(l,"base64")))}),u=this.j.useQueue?(0,h.$wm)(this.d):this.d,i=l=>this.d&&this.d.connected&&u.send(l.buffer.toString("base64")),o=k.event,s={send:i,onMessage:o};this.f=new b.$fi(s);const a=()=>this.o();process.once("exit",a),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,E)=>{process.removeListener("exit",a),t.dispose(),this.c.forEach(y=>(0,c.$Oc)(y)),this.c.clear(),l!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+E),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:E})})}return this.f}n(p){let $=this.g.get(p);return $||($=this.m.getChannel(p),this.g.set(p,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=d}),define(le[119],ue([0,1,8,4,2,82,12]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=w;var I;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function w(m){const b=m;return b?.changed instanceof Map||b?.deleted instanceof Set}var c;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(c||(e.StorageState=c={}));class g extends P.$Tc{static{this.a=100}constructor(b,f=Object.create(null)){super(),this.r=b,this.s=f,this.b=this.B(new r.$me),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$Ah(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(b=>this.u(b)))}u(b){this.b.pause();try{b.changed?.forEach((f,d)=>this.w(d,f)),b.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(b,f){if(this.c===c.Closed)return;let d=!1;(0,T.$lg)(f)?d=this.f.delete(b):this.f.get(b)!==f&&(this.f.set(b,f),d=!0),d&&this.b.fire({key:b,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(b,f){const d=this.f.get(b);return(0,T.$lg)(d)?f:d}getBoolean(b,f){const d=this.get(b);return(0,T.$lg)(d)?f:d==="true"}getNumber(b,f){const d=this.get(b);return(0,T.$lg)(d)?f:parseInt(d,10)}getObject(b,f){const d=this.get(b);return(0,T.$lg)(d)?f:(0,R.$$h)(d)}async set(b,f,d=!1){if(this.c===c.Closed)return;if((0,T.$lg)(f))return this.delete(b,d);const v=(0,T.$eg)(f)||Array.isArray(f)?(0,R.$0h)(f):String(f);if(this.f.get(b)!==v)return this.f.set(b,v),this.j.set(b,v),this.h.delete(b),this.b.fire({key:b,external:d}),this.D()}async delete(b,f=!1){if(!(this.c===c.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire({key:b,external:f}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(b).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(b){if(!(this.c===c.Closed||this.m))return this.D(b)}async D(b){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),b)}async whenFlushed(){if(this.z)return new Promise(b=>this.n.push(b))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$bq=g;class h{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((f,d)=>this.a.set(d,f)),b.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$cq=h}),define(le[160],ue([0,1,26,8,4,31,9,23]),function(J,e,n,r,P,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7X=void 0,n=Ie(n);class w{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return P.Event.None}static{this.a=2e3}static{this.b=256}constructor(h,m=Object.create(null)){this.g=h,this.h=m,this.c=(0,T.$mc)(this.g),this.d=new c(this.h.logging),this.f=this.n(this.g)}async getItems(){const h=await this.f,m=new Map;return(await this.s(h,"SELECT * FROM ItemTable")).forEach(f=>m.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${m.size} rows`),m}async updateItems(h){const m=await this.f;return this.j(m,h)}j(h,m){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${m.insert?(0,R.$xc)(m.insert):"0"}), delete(${m.delete?(0,R.$yc)(m.delete):"0"})`),this.t(h,()=>{const b=m.insert,f=m.delete;if(b&&b.size>0){const d=[];d.push([]);let v=0;b.forEach((p,$)=>{let k=d[v];k.length>w.b&&(v++,k=[],d.push(k)),k.push($,p)}),d.forEach(p=>{this.u(h,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,$=>$.run(p),()=>{const $=[];let k=0;return b.forEach((S,t)=>{$.push(t),k+=S.length}),`Keys: ${$.join(", ")} Length: ${k}`})})}if(f&&f.size){const d=[];d.push([]);let v=0;f.forEach(p=>{let $=d[v];$.length>w.b&&(v++,$=[],d.push($)),$.push(p)}),d.forEach(p=>{this.u(h,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,$=>$.run(p),()=>{const $=[];return f.forEach(k=>{$.push(k)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const h=await this.f;return this.q(h,"VACUUM")}async close(h){this.d.trace(`[storage ${this.c}] close()`);const m=await this.f;return this.k(m,h)}k(h,m){return new Promise((b,f)=>{h.db.close(d=>(d&&this.o(h,`[storage ${this.c}] close(): ${d}`),this.g===w.IN_MEMORY_PATH?b():!h.isErroneous&&!h.isInMemory?this.l().then(b,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),b())):typeof m=="function"?n.promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const p=()=>this.k(v,void 0);return this.j(v,{insert:m()}).then(()=>p(),$=>(p(),Promise.reject($)))})).then(b,f):f(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const h=this.m(this.g);return I.Promises.copy(this.g,h,{preserveSymlinks:!1})}m(h){return`${h}.backup`}async checkIntegrity(h){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${h})`);const m=await this.f,b=await this.r(m,h?"PRAGMA integrity_check":"PRAGMA quick_check"),f=h?b.integrity_check:b.quick_check;return m.isErroneous?`${f} (last error: ${m.lastError})`:m.isInMemory?`${f} (in-memory!)`:f}async n(h,m=!0){this.d.trace(`[storage ${this.c}] open(${h}, retryOnBusy: ${m})`);try{return await this.p(h)}catch(b){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&m)return await(0,r.$Dh)(w.a),this.n(h,!1);try{await n.promises.unlink(h);try{await I.Promises.rename(this.m(h),h,!1)}catch{}return await this.p(h)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(w.IN_MEMORY_PATH)}}}o(h,m){h.isErroneous=!0,h.lastError=m,this.d.error(m)}p(h){return new Promise((m,b)=>{new Promise((f,d)=>{J(["@vscode/sqlite3"],f,d)}).then(Ie).then(f=>{const d={db:new(this.d.isTracing?f.verbose().Database:f.Database)(h,v=>v?d.db&&v.code!=="SQLITE_CANTOPEN"?d.db.close(()=>b(v)):b(v):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(d),p=>d.db.close(()=>b(p)))),isInMemory:h===w.IN_MEMORY_PATH};d.db.on("error",v=>this.o(d,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&d.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},b)})}q(h,m){return new Promise((b,f)=>{h.db.exec(m,d=>d?(this.o(h,`[storage ${this.c}] exec(): ${d}`),f(d)):b())})}r(h,m){return new Promise((b,f)=>{h.db.get(m,(d,v)=>d?(this.o(h,`[storage ${this.c}] get(): ${d}`),f(d)):b(v))})}s(h,m){return new Promise((b,f)=>{h.db.all(m,(d,v)=>d?(this.o(h,`[storage ${this.c}] all(): ${d}`),f(d)):b(v))})}t(h,m){return new Promise((b,f)=>{h.db.serialize(()=>{h.db.run("BEGIN TRANSACTION"),m(),h.db.run("END TRANSACTION",d=>d?(this.o(h,`[storage ${this.c}] transaction(): ${d}`),f(d)):b())})})}u(h,m,b,f){const d=h.db.prepare(m),v=p=>{this.o(h,`[storage ${this.c}] prepare(): ${p} (${m}). Details: ${f()}`)};d.on("error",v),b(d),d.finalize(p=>{p&&v(p),d.removeListener("error",v)})}}e.$7X=w;class c{static{this.a="VSCODE_TRACE_STORAGE"}constructor(h){h&&typeof h.logTrace=="function"&&process.env[c.a]&&(this.b=h.logTrace),h&&typeof h.logError=="function"&&(this.c=h.logError)}get isTracing(){return!!this.b}trace(h){this.b?.(h)}error(h){this.c?.(h)}}}),define(le[10],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=P,e.localize2=T;const n=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(I,w){let c;return w.length===0?c=I:c=I.replace(/\{(\d+)\}/g,(g,h)=>{const m=h[0],b=w[m];let f=g;return typeof b=="string"?f=b:(typeof b=="number"||typeof b=="boolean"||b===void 0||b===null)&&(f=String(b)),f}),n&&(c="\uFF3B"+c.replace(/[aouei]/g,"$&$&")+"\uFF3D"),c}function P(I,w,...c){return r(typeof I=="number"?R(I,w):w,c)}function R(I,w){const c=globalThis._VSCODE_NLS_MESSAGES?.[I];if(typeof c!="string"){if(typeof w=="string")return w;throw new Error(`!!! NLS MISSING: ${I} !!!`)}return c}function T(I,w,...c){let g;typeof I=="number"?g=R(I,w):g=w;const h=r(g,c);return{value:h,original:w===g?h:r(w,c)}}}),define(le[161],ue([0,1,10]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=c,e.$Zm=g,e.$1m=h;const r=60,P=r*60,R=P*24,T=R*7,I=R*30,w=R*365;function c(m,b,f,d){typeof m!="number"&&(m=m.getTime());const v=Math.round((new Date().getTime()-m)/1e3);if(v<-30)return(0,n.localize)(12817,null,c(new Date().getTime()+v*1e3,!1));if(!d&&v<30)return(0,n.localize)(12818,null);let p;return v<r?(p=v,b?p===1?f?(0,n.localize)(12819,null,p):(0,n.localize)(12820,null,p):f?(0,n.localize)(12821,null,p):(0,n.localize)(12822,null,p):p===1?f?(0,n.localize)(12823,null,p):(0,n.localize)(12824,null,p):f?(0,n.localize)(12825,null,p):(0,n.localize)(12826,null,p)):v<P?(p=Math.floor(v/r),b?p===1?f?(0,n.localize)(12827,null,p):(0,n.localize)(12828,null,p):f?(0,n.localize)(12829,null,p):(0,n.localize)(12830,null,p):p===1?f?(0,n.localize)(12831,null,p):(0,n.localize)(12832,null,p):f?(0,n.localize)(12833,null,p):(0,n.localize)(12834,null,p)):v<R?(p=Math.floor(v/P),b?p===1?f?(0,n.localize)(12835,null,p):(0,n.localize)(12836,null,p):f?(0,n.localize)(12837,null,p):(0,n.localize)(12838,null,p):p===1?f?(0,n.localize)(12839,null,p):(0,n.localize)(12840,null,p):f?(0,n.localize)(12841,null,p):(0,n.localize)(12842,null,p)):v<T?(p=Math.floor(v/R),b?p===1?(0,n.localize)(12843,null,p):(0,n.localize)(12844,null,p):p===1?(0,n.localize)(12845,null,p):(0,n.localize)(12846,null,p)):v<I?(p=Math.floor(v/T),b?p===1?f?(0,n.localize)(12847,null,p):(0,n.localize)(12848,null,p):f?(0,n.localize)(12849,null,p):(0,n.localize)(12850,null,p):p===1?f?(0,n.localize)(12851,null,p):(0,n.localize)(12852,null,p):f?(0,n.localize)(12853,null,p):(0,n.localize)(12854,null,p)):v<w?(p=Math.floor(v/I),b?p===1?f?(0,n.localize)(12855,null,p):(0,n.localize)(12856,null,p):f?(0,n.localize)(12857,null,p):(0,n.localize)(12858,null,p):p===1?f?(0,n.localize)(12859,null,p):(0,n.localize)(12860,null,p):f?(0,n.localize)(12861,null,p):(0,n.localize)(12862,null,p)):(p=Math.floor(v/w),b?p===1?f?(0,n.localize)(12863,null,p):(0,n.localize)(12864,null,p):f?(0,n.localize)(12865,null,p):(0,n.localize)(12866,null,p):p===1?f?(0,n.localize)(12867,null,p):(0,n.localize)(12868,null,p):f?(0,n.localize)(12869,null,p):(0,n.localize)(12870,null,p))}function g(m,b){const f=Math.abs(m/1e3);return f<1?b?(0,n.localize)(12871,null,m):(0,n.localize)(12872,null,m):f<r?b?(0,n.localize)(12873,null,Math.round(m)/1e3):(0,n.localize)(12874,null,Math.round(m)/1e3):f<P?b?(0,n.localize)(12875,null,Math.round(m/(1e3*r))):(0,n.localize)(12876,null,Math.round(m/(1e3*r))):f<R?b?(0,n.localize)(12877,null,Math.round(m/(1e3*P))):(0,n.localize)(12878,null,Math.round(m/(1e3*P))):(0,n.localize)(12879,null,Math.round(m/(1e3*R)))}function h(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[54],ue([0,1,20,12,10]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=w,e.$oj=c,e.$pj=g,n=Ie(n),r=Ie(r),P=Ie(P);function R(h,m){return m&&(h.stack||h.stacktrace)?P.localize(12811,null,I(h),T(h.stack)||T(h.stacktrace)):I(h)}function T(h){return Array.isArray(h)?h.join(`
`):h}function I(h){return h.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?P.localize(12812,null,h.message):h.message||P.localize(12813,null)}function w(h=null,m=!1){if(!h)return P.localize(12814,null);if(Array.isArray(h)){const b=n.$Gb(h),f=w(b[0],m);return b.length>1?P.localize(12815,null,f,b.length):f}if(r.$cg(h))return h;if(h.detail){const b=h.detail;if(b.error)return R(b.error,m);if(b.exception)return R(b.exception,m)}return h.stack?R(h,m):h.message?h.message:P.localize(12816,null)}function c(h){const m=h;return m instanceof Error&&Array.isArray(m.actions)}function g(h,m){let b;return typeof h=="string"?b=new Error(h):b=h,b.actions=m,b}}),define(le[162],ue([0,1,10,43]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=P;function P(R){switch(R){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(12802,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(12803,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(12804,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(12805,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(12806,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(12807,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(12808,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(12809,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(12810,null);default:return""}}}),define(le[163],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shb=n,e.$Thb=r;function n(P){return P&&P.hasOwnProperty("folderUri")}function r(P){return P&&P.hasOwnProperty("workspace")}}),define(le[164],ue([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=r,e.$Qec=P,e.$Rec=R;function r(T){return typeof T?.backupFolder=="string"}function P(T){let I=[];try{Array.isArray(T.workspaces)&&(I=T.workspaces.map(w=>({workspace:{id:w.id,configPath:n.URI.parse(w.configURIPath)},remoteAuthority:w.remoteAuthority})))}catch{}return I}function R(T){let I=[];try{Array.isArray(T.folders)&&(I=T.folders.map(w=>({folderUri:n.URI.parse(w.folderUri),remoteAuthority:w.remoteAuthority})))}catch{}return I}}),define(le[165],ue([0,1,39,15,10]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var R;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(R||(e.TokenType=R={}));function T(...g){switch(g.length){case 1:return(0,P.localize)(11418,null,g[0]);case 2:return(0,P.localize)(11419,null,g[0],g[1]);case 3:return(0,P.localize)(11420,null,g[0],g[1],g[2]);default:return}}const I=(0,P.localize)(11421,null),w=(0,P.localize)(11422,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return h.isTripleEq?"===":"==";case R.NotEq:return h.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return h.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return h.lexeme;case R.QuotedStr:return h.lexeme;case R.Error:return h.lexeme;case R.EOF:return"EOF";default:throw(0,r.$7)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(R.LParen);break;case n.CharCode.CloseParen:this.k(R.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const m=this.h(n.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:m})}else this.k(R.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const m=this.h(n.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:m})}else this.h(n.CharCode.Tilde)?this.k(R.RegexOp):this.l(T("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?R.LtEq:R.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?R.GtEq:R.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(R.And):this.l(T("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(R.Or):this.l(T("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const m=this.d,b=this.c.substring(this.d,this.e),f={type:R.Error,offset:this.d,lexeme:b};this.g.push({offset:m,lexeme:b,additionalInfo:h}),this.f.push(f)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const m=this.c.substring(this.d,this.e),b=c.b.get(m);b?this.k(b):this.f.push({type:R.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,m=!1,b=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(w);return}const d=this.c.charCodeAt(h);if(m)m=!1;else if(d===n.CharCode.Slash&&!b){h++;break}else d===n.CharCode.OpenSquareBracket?b=!0:d===n.CharCode.Backslash?m=!0:d===n.CharCode.CloseSquareBracket&&(b=!1);h++}for(;h<this.c.length&&c.a.has(this.c.charCodeAt(h));)h++;this.e=h;const f=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=c}),define(le[166],ue([0,1,4,2]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=void 0;class P{constructor(){this.a=new n.$je,this.b=new n.$je,this.c=new n.$je,this.d=new n.$je}static{this.ChannelName="extensionhostdebugservice"}call(I,w,c){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(I,w,c){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Wo=P;class R extends r.$Tc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,w,c){this.b.call("attach",[I,w,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,w){this.b.call("terminate",[I,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,w){return this.b.call("openExtensionDevelopmentHostWindow",[I,w])}}e.$Xo=R}),define(le[167],ue([0,1,161,53,11,9,36,18,7]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$4m=g,e.$5m=h,e.$2m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,R.$lc)(P.$Wg.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,R.$ic)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,I.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const b=(0,n.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$ic)(this.userDataPath,"logs",b)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$dh)(w.URI.file((0,R.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=T.env.VSCODE_PORTABLE;return b?w.URI.file((0,R.$ic)(b,"argv.json")):(0,I.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,R.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,R.$jc)(b):(0,R.$gc)((0,R.$ic)(P.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const b=this.args["extensions-download-dir"];return b?w.URI.file((0,R.$jc)(b)):w.URI.file((0,R.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,R.$jc)(b);const f=T.env.VSCODE_EXTENSIONS;if(f)return f;const d=T.env.VSCODE_PORTABLE;return d?(0,R.$ic)(d,"extensions"):(0,I.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(f=>/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,R.$gc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?w.URI.parse(b):w.URI.file((0,R.$gc)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(b=>!e.$2m.test(b))}get extensionLogLevel(){const b=[];for(const f of this.args.log||[]){const d=e.$2m.exec(f);d&&d[1]&&d[2]&&b.push([d[1],d[2]])}return b.length?b:void 0}get serviceMachineIdResource(){return(0,I.$dh)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const b=T.env.VSCODE_PORTABLE;return b?w.URI.file((0,R.$ic)(b,"policy.json")):(0,I.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(b){this.args.continueOn=b}get args(){return this.a}constructor(b,f,d){this.a=b,this.b=f,this.c=d,this.editSessionId=this.args.editSessionId}}e.$3m=c,Ee([r.$7h],c.prototype,"appRoot",null),Ee([r.$7h],c.prototype,"userHome",null),Ee([r.$7h],c.prototype,"userDataPath",null),Ee([r.$7h],c.prototype,"appSettingsHome",null),Ee([r.$7h],c.prototype,"tmpDir",null),Ee([r.$7h],c.prototype,"cacheHome",null),Ee([r.$7h],c.prototype,"stateResource",null),Ee([r.$7h],c.prototype,"userRoamingDataHome",null),Ee([r.$7h],c.prototype,"userDataSyncHome",null),Ee([r.$7h],c.prototype,"sync",null),Ee([r.$7h],c.prototype,"machineSettingsResource",null),Ee([r.$7h],c.prototype,"workspaceStorageHome",null),Ee([r.$7h],c.prototype,"localHistoryHome",null),Ee([r.$7h],c.prototype,"keyboardLayoutResource",null),Ee([r.$7h],c.prototype,"argvResource",null),Ee([r.$7h],c.prototype,"isExtensionDevelopment",null),Ee([r.$7h],c.prototype,"untitledWorkspacesHome",null),Ee([r.$7h],c.prototype,"builtinExtensionsPath",null),Ee([r.$7h],c.prototype,"extensionsPath",null),Ee([r.$7h],c.prototype,"extensionDevelopmentLocationURI",null),Ee([r.$7h],c.prototype,"extensionDevelopmentKind",null),Ee([r.$7h],c.prototype,"extensionTestsLocationURI",null),Ee([r.$7h],c.prototype,"debugExtensionHost",null),Ee([r.$7h],c.prototype,"logLevel",null),Ee([r.$7h],c.prototype,"extensionLogLevel",null),Ee([r.$7h],c.prototype,"serviceMachineIdResource",null),Ee([r.$7h],c.prototype,"disableTelemetry",null),Ee([r.$7h],c.prototype,"disableWorkspaceTrust",null),Ee([r.$7h],c.prototype,"useInMemorySecretStorage",null),Ee([r.$7h],c.prototype,"policyFile",null);function g(m,b){return h(m["inspect-extensions"],m["inspect-brk-extensions"],5870,b,m.debugId,m.extensionEnvironment)}function h(m,b,f,d,v,p){const k=Number(b||m)||(d?null:f),S=k?!!b:!1;let t;if(p)try{t=JSON.parse(p)}catch{}return{port:k,break:S,debugId:v,env:t}}});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[120],ue([0,1,279,3,10]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=void 0,e.$Am=I,e.$Bm=c,e.$Cm=b,e.$Dm=f,n=et(n);const R={o:(0,P.localize)(11355,null),e:(0,P.localize)(11356,null),t:(0,P.localize)(11357,null)};e.$ym=["tunnel","serve-web"],e.$zm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(11358,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(11359,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(11360,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(11361,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(11362,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(11363,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(11364,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(11365,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11366,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(11367,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(11368,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(11369,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(11370,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(11371,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(11372,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(11373,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(11374,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(11375,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(11376,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(11377,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(11378,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(11379,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(11380,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(11381,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(11382,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(11383,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(11384,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(11385,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(11386,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(11387,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(11388,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(11389,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,P.localize)(11390,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(11391,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(11392,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(11393,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(d,v,p=T){const $=d.find(l=>l.length>0&&l[0]!=="-"),k={},S=["_"],t=[],u={};let i;for(const l in v){const E=v[l];E.type==="subcommand"?l===$&&(i=E):(E.alias&&(k[l]=E.alias),E.type==="string"||E.type==="string[]"?(S.push(l),E.deprecates&&S.push(...E.deprecates)):E.type==="boolean"&&(t.push(l),E.deprecates&&t.push(...E.deprecates)),E.global&&(u[l]=E))}if(i&&$){const l=u;for(const L in i.options)l[L]=i.options[L];const E=d.filter(L=>L!==$),y=p.getSubcommandReporter?p.getSubcommandReporter($):void 0,D=I(E,l,y);return{[$]:D,_:[]}}const o=(0,n.default)(d,{string:S,boolean:t,alias:k}),s={},a=o;s._=o._.map(l=>String(l)).filter(l=>l.length>0),delete a._;for(const l in v){const E=v[l];if(E.type==="subcommand")continue;E.alias&&delete a[E.alias];let y=a[l];if(E.deprecates)for(const D of E.deprecates)a.hasOwnProperty(D)&&(y||(y=a[D],y&&p.onDeprecatedOption(D,E.deprecationMessage||(0,P.localize)(11394,null,l))),delete a[D]);if(typeof y<"u"){if(E.type==="string[]"){if(Array.isArray(y)||(y=[y]),!E.allowEmptyValue){const D=y.filter(L=>L.length>0);D.length!==y.length&&(p.onEmptyValue(l),y=D.length>0?D:void 0)}}else E.type==="string"&&(Array.isArray(y)?(y=y.pop(),p.onMultipleValues(l,y)):!y&&!E.allowEmptyValue&&(p.onEmptyValue(l),y=void 0));s[l]=y,E.deprecationMessage&&p.onDeprecatedOption(l,E.deprecationMessage)}delete a[l]}for(const l in a)p.onUnknownOption(l);return s}function w(d,v){let p="";return v.args&&(Array.isArray(v.args)?p=` <${v.args.join("> <")}>`:p=` <${v.args}>`),v.alias?`-${v.alias} --${d}${p}`:`--${d}${p}`}function c(d,v){const p=[];for(const $ in d){const k=d[$],S=w($,k);p.push([S,k.description])}return g(p,v)}function g(d,v){const $=d.reduce((t,u)=>Math.max(t,u[0].length),12)+2+1;if(v-$<25)return d.reduce((t,u)=>t.concat([`  ${u[0]}`,`      ${u[1]}`]),[]);const k=v-$-1,S=[];for(const t of d){const u=t[0],i=m(t[1],k),o=h($-u.length-2);S.push("  "+u+o+i[0]);for(let s=1;s<i.length;s++)S.push(h($)+i[s])}return S}function h(d){return" ".repeat(d)}function m(d,v){const p=[];for(;d.length;){const $=d.length<v?d.length:d.lastIndexOf(" ",v),k=d.slice(0,$).trim();d=d.slice($),p.push(k)}return p}function b(d,v,p,$,k){const S=process.stdout.isTTY&&process.stdout.columns||80,t=k?.noInputFiles!==!0?`[${(0,P.localize)(11395,null)}...]`:"",u=[`${d} ${p}`];u.push(""),u.push(`${(0,P.localize)(11396,null)}: ${v} [${(0,P.localize)(11397,null)}]${t}`),u.push(""),k?.noPipe!==!0&&(r.$j?u.push((0,P.localize)(11398,null,v)):u.push((0,P.localize)(11399,null,v)),u.push(""));const i={},o=[];for(const s in $){const a=$[s];if(a.type==="subcommand")a.description&&o.push({command:s,description:a.description});else if(a.description&&a.cat){let l=i[a.cat];l||(i[a.cat]=l={}),l[s]=a}}for(const s in i){const a=s,l=i[a];l&&(u.push(R[a]),u.push(...c(l,S)),u.push(""))}return o.length&&(u.push((0,P.localize)(11400,null)),u.push(...g(o.map(s=>[s.command,s.description]),S)),u.push("")),u.join(`
`)}function f(d,v){return`${d||(0,P.localize)(11401,null)}
${v||(0,P.localize)(11402,null)}
${process.arch}`}});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[68],ue([0,1,280,10,120]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=I,e.$Fm=w,e.$Gm=c,e.$Hm=g,n=et(n);function R(h,m){const b=(k,S)=>{console.warn((0,r.localize)(11349,null,k,S))},f=k=>{console.warn((0,r.localize)(11350,null,k))},d=(k,S)=>{console.warn((0,r.localize)(11351,null,k,S))},v=k=>({onUnknownOption:S=>{P.$ym.includes(k)||console.warn((0,r.localize)(11352,null,S,k))},onMultipleValues:b,onEmptyValue:f,onDeprecatedOption:d,getSubcommandReporter:P.$ym.includes(k)?v:void 0}),p={onUnknownOption:k=>{console.warn((0,r.localize)(11353,null,k))},onMultipleValues:b,onEmptyValue:f,onDeprecatedOption:d,getSubcommandReporter:v},$=(0,P.$Am)(h,P.$zm,m?p:void 0);return $.goto&&$._.forEach(k=>(0,n.default)(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(k),(0,r.localize)(11354,null))),$}function T(h){const m=h.findIndex(b=>!/^-/.test(b));if(m>-1)return[...h.slice(0,m),...h.slice(m+1)]}function I(h){let[,...m]=h;process.env.VSCODE_DEV&&(m=T(m)||[]);const b=!g(process.env);return R(m,b)}function w(h){let[,,...m]=h;return process.env.VSCODE_DEV&&(m=T(m)||[]),R(m,!0)}function c(h,...m){const b=h.indexOf("--");return b===-1?h.push(...m):h.splice(b,0,...m),h}function g(h){return h.VSCODE_CLI==="1"}}),function(){"use strict";function J(e,n,r){function P(T,I){const w=R(T,I),c=[w];return e.isAbsolute(w)||c.unshift(r),e.resolve(...c)}function R(T,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const g=T["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const h=process.env.USERPROFILE;if(typeof h!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(h,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:P}}if(typeof define=="function")define(le[168],ue([121,27,36]),function(e,n,r){return J(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=J(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[95],ue([0,1,27,167,168]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0,e.$7m=T,e.$8m=I;class R extends r.$3m{constructor(c,g){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,g.nameShort)},g)}}e.$6m=R;function T(w,c){return(0,r.$5m)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,c,w.extensionEnvironment)}function I(w,c){return(0,r.$5m)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,c,w.extensionEnvironment)}}),define(le[169],ue([0,1,26,27,32]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=R;function R(T){const I=(0,P.$Kg)((0,r.tmpdir)());try{return(0,n.writeFileSync)(I,""),T&&console.log(`Marker file for --wait created: ${I}`),I}catch(w){T&&console.error(`Failed to create marker file for --wait: ${w}`);return}}}),define(le[170],ue([0,1,12,10]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=P;function P(T,I,w,c){try{R(T,I,w,c)}catch(g){T.error(g?.message??g)}return I}function R(T,I,w,c){const g=(h,m,b)=>{const f=h[m];if((0,n.$cg)(f)){const d=f,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const p=d.substr(1,v-2);let $=w[p];$===void 0&&c&&($=c[p]);const k=typeof $=="string"?$:$?.message,S=c?.[p],t=typeof S=="string"?S:S?.message;if(!k){t||T.warn(`[${I.name}]: ${(0,r.localize)(11301,null,p)}`);return}if(b&&(m==="title"||m==="category")&&t&&t!==k){const u={value:k,original:t};h[m]=u}else h[m]=k}}else if((0,n.$eg)(f))for(const d in f)f.hasOwnProperty(d)&&(d==="commands"?g(f,d,!0):g(f,d,b));else if(Array.isArray(f))for(let d=0;d<f.length;d++)g(f,d,b)};for(const h in I)I.hasOwnProperty(h)&&g(I,h)}}),define(le[171],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const n={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(n)}),define(le[83],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class n{constructor(P,R=[],T=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=T}}e.$zi=n}),define(le[172],ue([0,1,83]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=R,e.$Ps=T;const r=[];var P;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function R(I,w,c){w instanceof n.$zi||(w=new n.$zi(w,[],!!c)),r.push([I,w])}function T(){return r}}),define(le[173],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class n{constructor(R,T){this.key=R,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$rr=n;class r{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const T of this.a.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const I=this.lookupOrInsertNode(R),w=this.lookupOrInsertNode(T);I.outgoing.set(w.key,w),w.incoming.set(I.key,I)}removeNode(R){const T=this.b(R);this.a.delete(T);for(const I of this.a.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(R){const T=this.b(R);let I=this.a.get(T);return I||(I=new n(T,R),this.a.set(T,I)),I}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[T,I]of this.a)R.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,T]of this.a){const I=new Set([R]),w=this.c(T,I);if(w)return w}}c(R,T){for(const[I,w]of R.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const c=this.c(w,T);if(c)return c;T.delete(I)}}}e.$sr=r}),define(le[6],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=P,e.$Di=R;var n;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(w){return w[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(n||(e._util=n={})),e.$Bi=P("instantiationService");function r(T,I,w){I[n.DI_TARGET]===I?I[n.DI_DEPENDENCIES].push({id:T,index:w}):(I[n.DI_DEPENDENCIES]=[{id:T,index:w}],I[n.DI_TARGET]=I)}function P(T){if(n.serviceIds.has(T))return n.serviceIds.get(T);const I=function(w,c,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,w,g)};return I.toString=()=>T,n.serviceIds.set(T,I),I}function R(T){return T}}),define(le[84],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0,e.$Kfc=(0,n.$Ci)("auxiliaryWindowsMainService")}),define(le[69],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0,e.$Sec=(0,n.$Ci)("backupMainService")}),define(le[17],ue([0,1,12,7,6]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=R,e.$$i=T,e.$_i=w,e.$aj=c,e.$bj=g,e.$cj=h,e.$dj=m,e.$ej=f,e.$fj=d,e.$gj=v,n=Ie(n),e.$9i=(0,P.$Ci)("configurationService");function R(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof r.URI)}function T(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof r.URI)}var I;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function w(p){switch(p){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function c(p){return p.applicationValue!==void 0||p.userValue!==void 0||p.userLocalValue!==void 0||p.userRemoteValue!==void 0||p.workspaceValue!==void 0||p.workspaceFolderValue!==void 0}function g(p,$){const k=Object.create(null);for(const S in p)h(k,S,p[S],$);return k}function h(p,$,k,S){const t=$.split("."),u=t.pop();let i=p;for(let o=0;o<t.length;o++){const s=t[o];let a=i[s];switch(typeof a){case"undefined":a=i[s]=Object.create(null);break;case"object":if(a===null){S(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is null`);return}break;default:S(`Ignoring ${$} as ${t.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}i=a}if(typeof i=="object"&&i!==null)try{i[u]=k}catch{S(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}else S(`Ignoring ${$} as ${t.join(".")} is ${JSON.stringify(i)}`)}function m(p,$){const k=$.split(".");b(p,k)}function b(p,$){const k=$.shift();if($.length===0){delete p[k];return}if(Object.keys(p).indexOf(k)!==-1){const S=p[k];typeof S=="object"&&!Array.isArray(S)&&(b(S,$),Object.keys(S).length===0&&delete p[k])}}function f(p,$,k){function S(i,o){let s=i;for(const a of o){if(typeof s!="object"||s===null)return;s=s[a]}return s}const t=$.split("."),u=S(p,t);return typeof u>"u"?k:u}function d(p,$,k){Object.keys($).forEach(S=>{S!=="__proto__"&&(S in p?n.$eg(p[S])&&n.$eg($[S])?d(p[S],$[S],k):k&&(p[S]=$[S]):p[S]=$[S])})}function v(p){return p.replace(/[\[\]]/g,"")}}),define(le[122],ue([0,1,39,3,25,165,6,10,15]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=g,e.$Bj=o,e.$Cj=s,e.$Vj=V;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",r.$k),c.set("isLinux",r.$l),c.set("isWindows",r.$j),c.set("isWeb",r.$p),c.set("isMacNative",r.$k&&!r.$p),c.set("isEdge",r.$I),c.set("isFirefox",r.$G),c.set("isChrome",r.$F),c.set("isSafari",r.$H);function g(ee,M){if(c.get(ee)!==void 0)throw(0,w.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(ee,M)}const h=Object.prototype.hasOwnProperty;var m;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const b={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(11432,null),d=(0,I.localize)(11433,null),v=(0,I.localize)(11434,null),p=(0,I.localize)(11435,null),$=(0,I.localize)(11436,null),k=(0,I.localize)(11437,null),S=(0,I.localize)(11438,null),t=(0,I.localize)(11439,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=b){this.k=M,this.d=new R.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const C=this.D(),z=C.type===R.TokenType.Str?k:void 0;throw this.h.push({message:$,offset:C.offset,lexeme:R.$xj.getLexeme(C),additionalInfo:z}),u.c}return F}catch(F){if(F!==u.c)throw F;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(R.TokenType.Or);){const F=this.o();M.push(F)}return M.length===1?M[0]:i.or(...M)}o(){const M=[this.s()];for(;this.y(R.TokenType.And);){const F=this.s();M.push(F)}return M.length===1?M[0]:i.and(...M)}s(){if(this.y(R.TokenType.Neg)){const M=this.D();switch(M.type){case R.TokenType.True:return this.z(),l.INSTANCE;case R.TokenType.False:return this.z(),E.INSTANCE;case R.TokenType.LParen:{this.z();const F=this.l();return this.A(R.TokenType.RParen,p),F?.negate()}case R.TokenType.Str:return this.z(),W.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case R.TokenType.True:return this.z(),i.true();case R.TokenType.False:return this.z(),i.false();case R.TokenType.LParen:{this.z();const F=this.l();return this.A(R.TokenType.RParen,p),F}case R.TokenType.Str:{const F=M.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==R.TokenType.RegexStr)throw this.B("REGEX",z);const Z=z.lexeme,Q=Z.lastIndexOf("/"),q=Q===Z.length-1?void 0:this.w(Z.substring(Q+1));let se;try{se=new RegExp(Z.substring(1,Q),q)}catch{throw this.B("REGEX",z)}return ae.create(F,se)}switch(z.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const Z=[z.lexeme];this.z();let Q=this.D(),q=0;for(let De=0;De<z.lexeme.length;De++)z.lexeme.charCodeAt(De)===n.CharCode.OpenParen?q++:z.lexeme.charCodeAt(De)===n.CharCode.CloseParen&&q--;for(;!this.E()&&Q.type!==R.TokenType.And&&Q.type!==R.TokenType.Or;){switch(Q.type){case R.TokenType.LParen:q++;break;case R.TokenType.RParen:q--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let De=0;De<Q.lexeme.length;De++)Q.lexeme.charCodeAt(De)===n.CharCode.OpenParen?q++:z.lexeme.charCodeAt(De)===n.CharCode.CloseParen&&q--}if(q<0)break;Z.push(R.$xj.getLexeme(Q)),this.z(),Q=this.D()}const se=Z.join(""),de=se.lastIndexOf("/"),me=de===se.length-1?void 0:this.w(se.substring(de+1));let we;try{we=new RegExp(se.substring(1,de),me)}catch{throw this.B("REGEX",z)}return i.regex(F,we)}case R.TokenType.QuotedStr:{const Z=z.lexeme;this.z();let Q=null;if(!(0,P.$af)(Z)){const q=Z.indexOf("/"),se=Z.lastIndexOf("/");if(q!==se&&q>=0){const de=Z.slice(q+1,se),me=Z[se+1]==="i"?"i":"";try{Q=new RegExp(de,me)}catch{throw this.B("REGEX",z)}}}if(Q===null)throw this.B("REGEX",z);return ae.create(F,Q)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,v);const z=this.u();return i.notIn(F,z)}switch(this.D().type){case R.TokenType.Eq:{this.z();const z=this.u();if(this.x().type===R.TokenType.QuotedStr)return i.equals(F,z);switch(z){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,z)}}case R.TokenType.NotEq:{this.z();const z=this.u();if(this.x().type===R.TokenType.QuotedStr)return i.notEquals(F,z);switch(z){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,z)}}case R.TokenType.Lt:return this.z(),X.create(F,this.u());case R.TokenType.LtEq:return this.z(),G.create(F,this.u());case R.TokenType.Gt:return this.z(),H.create(F,this.u());case R.TokenType.GtEq:return this.z(),B.create(F,this.u());case R.TokenType.In:return this.z(),i.in(F,this.u());default:return i.has(F)}}case R.TokenType.EOF:throw this.h.push({message:S,offset:M.offset,lexeme:"",additionalInfo:t}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),M.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,F){if(this.C(M))return this.z();throw this.B(F,this.D())}B(M,F,C){const z=(0,I.localize)(11440,null,M,R.$xj.getLexeme(F)),Z=F.offset,Q=R.$xj.getLexeme(F);return this.h.push({message:z,offset:Z,lexeme:Q,additionalInfo:C}),u.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$zj=u;class i{static false(){return l.INSTANCE}static true(){return E.INSTANCE}static has(M){return y.create(M)}static equals(M,F){return D.create(M,F)}static notEquals(M,F){return O.create(M,F)}static regex(M,F){return ae.create(M,F)}static in(M,F){return L.create(M,F)}static notIn(M,F){return A.create(M,F)}static not(M){return W.create(M)}static and(...M){return U.create(M,null,!0)}static or(...M){return j.create(M,null,!0)}static greater(M,F){return H.create(M,F)}static greaterEquals(M,F){return B.create(M,F)}static smaller(M,F){return X.create(M,F)}static smallerEquals(M,F){return G.create(M,F)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Aj=i;function o(ee){const M=new u({regexParsingWithErrorRecovery:!1});return ee.map(F=>(M.parse(F),M.lexingErrors.length>0?M.lexingErrors.map(C=>({errorMessage:C.additionalInfo?(0,I.localize)(11441,null,C.additionalInfo):(0,I.localize)(11442,null),offset:C.offset,length:C.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(C=>({errorMessage:C.additionalInfo?`${C.message}. ${C.additionalInfo}`:C.message,offset:C.offset,length:C.lexeme.length})):[]))}function s(ee,M){const F=ee?ee.substituteConstants():void 0,C=M?M.substituteConstants():void 0;return!F&&!C?!0:!F||!C?!1:F.equals(C)}function a(ee,M){return ee.cmp(M)}class l{static{this.INSTANCE=new l}constructor(){this.type=m.False}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return E.INSTANCE}}e.$Dj=l;class E{static{this.INSTANCE=new E}constructor(){this.type=m.True}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return l.INSTANCE}}e.$Ej=E;class y{static create(M,F=null){const C=c.get(M);return typeof C=="boolean"?C?E.INSTANCE:l.INSTANCE:new y(M,F)}constructor(M,F){this.key=M,this.c=F,this.type=m.Defined}cmp(M){return M.type!==this.type?this.type-M.type:Y(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=c.get(this.key);return typeof M=="boolean"?M?E.INSTANCE:l.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$Fj=y;class D{static create(M,F,C=null){if(typeof F=="boolean")return F?y.create(M,C):W.create(M,C);const z=c.get(M);return typeof z=="boolean"?F===(z?"true":"false")?E.INSTANCE:l.INSTANCE:new D(M,F,C)}constructor(M,F,C){this.c=M,this.d=F,this.f=C,this.type=m.Equals}cmp(M){return M.type!==this.type?this.type-M.type:ie(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=c.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?E.INSTANCE:l.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Gj=D;class L{static create(M,F){return new L(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.In,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:ie(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.f),C=M.getValue(this.d);return Array.isArray(F)?F.includes(C):typeof C=="string"&&typeof F=="object"&&F!==null?h.call(F,C):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Hj=L;class A{static create(M,F){return new A(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.NotIn,this.c=L.create(M,F)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=A;class O{static create(M,F,C=null){if(typeof F=="boolean")return F?W.create(M,C):y.create(M,C);const z=c.get(M);return typeof z=="boolean"?F===(z?"true":"false")?l.INSTANCE:E.INSTANCE:new O(M,F,C)}constructor(M,F,C){this.c=M,this.d=F,this.f=C,this.type=m.NotEquals}cmp(M){return M.type!==this.type?this.type-M.type:ie(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=c.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?l.INSTANCE:E.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Jj=O;class W{static create(M,F=null){const C=c.get(M);return typeof C=="boolean"?C?l.INSTANCE:E.INSTANCE:new W(M,F)}constructor(M,F){this.c=M,this.d=F,this.type=m.Not}cmp(M){return M.type!==this.type?this.type-M.type:Y(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=c.get(this.c);return typeof M=="boolean"?M?l.INSTANCE:E.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Kj=W;function x(ee,M){if(typeof ee=="string"){const F=parseFloat(ee);isNaN(F)||(ee=F)}return typeof ee=="string"||typeof ee=="number"?M(ee):l.INSTANCE}class H{static create(M,F,C=null){return x(F,z=>new H(M,z,C))}constructor(M,F,C){this.c=M,this.d=F,this.f=C,this.type=m.Greater}cmp(M){return M.type!==this.type?this.type-M.type:ie(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Lj=H;class B{static create(M,F,C=null){return x(F,z=>new B(M,z,C))}constructor(M,F,C){this.c=M,this.d=F,this.f=C,this.type=m.GreaterEquals}cmp(M){return M.type!==this.type?this.type-M.type:ie(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Mj=B;class X{static create(M,F,C=null){return x(F,z=>new X(M,z,C))}constructor(M,F,C){this.c=M,this.d=F,this.f=C,this.type=m.Smaller}cmp(M){return M.type!==this.type?this.type-M.type:ie(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Nj=X;class G{static create(M,F,C=null){return x(F,z=>new G(M,z,C))}constructor(M,F,C){this.c=M,this.d=F,this.f=C,this.type=m.SmallerEquals}cmp(M){return M.type!==this.type?this.type-M.type:ie(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$Oj=G;class ae{static create(M,F){return new ae(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=m.Regex,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const F=this.f?this.f.source:"",C=M.f?M.f.source:"";return F<C?-1:F>C?1:0}equals(M){if(M.type===this.type){const F=this.f?this.f.source:"",C=M.f?M.f.source:"";return this.d===M.d&&F===C}return!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Pj=ae;class K{static create(M){return new K(M)}constructor(M){this.c=M,this.type=m.NotRegex}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new K(this.c.map(M))}negate(){return this.c}}e.$Qj=K;function te(ee){let M=null;for(let F=0,C=ee.length;F<C;F++){const z=ee[F].substituteConstants();if(ee[F]!==z&&M===null){M=[];for(let Z=0;Z<F;Z++)M[Z]=ee[Z]}M!==null&&(M[F]=z)}return M===null?ee:M}class U{static create(M,F,C){return U.d(M,F,C)}constructor(M,F){this.expr=M,this.c=F,this.type=m.And}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,C=this.expr.length;F<C;F++){const z=a(this.expr[F],M.expr[F]);if(z!==0)return z}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,C=this.expr.length;F<C;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=te(this.expr);return M===this.expr?this:U.create(M,this.c,!1)}evaluate(M){for(let F=0,C=this.expr.length;F<C;F++)if(!this.expr[F].evaluate(M))return!1;return!0}static d(M,F,C){const z=[];let Z=!1;for(const Q of M)if(Q){if(Q.type===m.True){Z=!0;continue}if(Q.type===m.False)return l.INSTANCE;if(Q.type===m.And){z.push(...Q.expr);continue}z.push(Q)}if(z.length===0&&Z)return E.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(a);for(let Q=1;Q<z.length;Q++)z[Q-1].equals(z[Q])&&(z.splice(Q,1),Q--);if(z.length===1)return z[0];for(;z.length>1;){const Q=z[z.length-1];if(Q.type!==m.Or)break;z.pop();const q=z.pop(),se=z.length===0,de=j.create(Q.expr.map(me=>U.create([me,q],null,C)),null,se);de&&(z.push(de),z.sort(a))}if(z.length===1)return z[0];if(C){for(let Q=0;Q<z.length;Q++)for(let q=Q+1;q<z.length;q++)if(z[Q].negate().equals(z[q]))return l.INSTANCE;if(z.length===1)return z[0]}return new U(z,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new U(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());this.c=j.create(M,this,!0)}return this.c}}e.$Rj=U;class j{static create(M,F,C){return j.d(M,F,C)}constructor(M,F){this.expr=M,this.c=F,this.type=m.Or}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,C=this.expr.length;F<C;F++){const z=a(this.expr[F],M.expr[F]);if(z!==0)return z}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,C=this.expr.length;F<C;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=te(this.expr);return M===this.expr?this:j.create(M,this.c,!1)}evaluate(M){for(let F=0,C=this.expr.length;F<C;F++)if(this.expr[F].evaluate(M))return!0;return!1}static d(M,F,C){let z=[],Z=!1;if(M){for(let Q=0,q=M.length;Q<q;Q++){const se=M[Q];if(se){if(se.type===m.False){Z=!0;continue}if(se.type===m.True)return E.INSTANCE;if(se.type===m.Or){z=z.concat(se.expr);continue}z.push(se)}}if(z.length===0&&Z)return l.INSTANCE;z.sort(a)}if(z.length!==0){if(z.length===1)return z[0];for(let Q=1;Q<z.length;Q++)z[Q-1].equals(z[Q])&&(z.splice(Q,1),Q--);if(z.length===1)return z[0];if(C){for(let Q=0;Q<z.length;Q++)for(let q=Q+1;q<z.length;q++)if(z[Q].negate().equals(z[q]))return E.INSTANCE;if(z.length===1)return z[0]}return new j(z,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new j(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());for(;M.length>1;){const F=M.shift(),C=M.shift(),z=[];for(const Z of oe(F))for(const Q of oe(C))z.push(U.create([Z,Q],null,!1));M.unshift(j.create(z,null,!1))}this.c=j.create(M,this,!0)}return this.c}}e.$Sj=j;class N extends y{static{this.d=[]}static all(){return N.d.values()}constructor(M,F,C){super(M,null),this.f=F,typeof C=="object"?N.d.push({...C,key:M}):C!==!0&&N.d.push({key:M,description:C,type:F!=null?typeof F:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return D.create(this.key,M)}notEqualsTo(M){return O.create(this.key,M)}}e.$Tj=N,e.$Uj=(0,T.$Ci)("contextKeyService");function Y(ee,M){return ee<M?-1:ee>M?1:0}function ie(ee,M,F,C){return ee<F?-1:ee>F?1:M<C?-1:M>C?1:0}function V(ee,M){if(ee.type===m.False||M.type===m.True)return!0;if(ee.type===m.Or)return M.type===m.Or?he(ee.expr,M.expr):!1;if(M.type===m.Or){for(const F of M.expr)if(V(ee,F))return!0;return!1}if(ee.type===m.And){if(M.type===m.And)return he(M.expr,ee.expr);for(const F of ee.expr)if(V(F,M))return!0;return!1}return ee.equals(M)}function he(ee,M){let F=0,C=0;for(;F<ee.length&&C<M.length;){const z=ee[F].cmp(M[C]);if(z<0)return!1;z===0&&F++,C++}return F===ee.length}function oe(ee){return ee.type===m.Or?ee.expr:[ee]}}),define(le[96],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Qm=e.ID=void 0,e.$Rm=r,e.ID="diagnosticsService",e.$Qm=(0,n.$Ci)(e.ID);function r(R){return!!R.hostName&&!!R.errorMessage}class P{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Sm=P});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[123],ue([0,1,18,81,10,6,47,3,37]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$9w=e.$8w=e.$7w=void 0,e.$0w=b,e.$$w=f,r=et(r),e.$7w=(0,R.$Ci)("dialogService");var c;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(c||(c={}));class g{a(v){return this.d(v,c.Confirmation)}b(v){return this.d(v,c.Prompt)}c(v){return this.d(v,c.Input)}d(v,p){const $=[];switch(p){case c.Confirmation:{const k=v;k.primaryButton?$.push(k.primaryButton):$.push((0,P.localize)(11409,null)),k.cancelButton?$.push(k.cancelButton):$.push((0,P.localize)(11410,null));break}case c.Prompt:{const k=v;Array.isArray(k.buttons)&&k.buttons.length>0&&$.push(...k.buttons.map(S=>S.label)),k.cancelButton&&(k.cancelButton===!0?$.push((0,P.localize)(11411,null)):typeof k.cancelButton=="string"?$.push(k.cancelButton):k.cancelButton.label?$.push(k.cancelButton.label):$.push((0,P.localize)(11412,null))),$.length===0&&$.push((0,P.localize)(11413,null));break}case c.Input:{const k=v;k.primaryButton?$.push(k.primaryButton):$.push((0,P.localize)(11414,null)),k.cancelButton?$.push(k.cancelButton):$.push((0,P.localize)(11415,null));break}}return $}e(v){if(typeof v=="string")return v;if(typeof v=="number")return v===r.default.Info?"info":v===r.default.Error?"error":v===r.default.Warning?"warning":"none"}f(v,p,$){const k=[...v.buttons??[]];v.cancelButton&&typeof v.cancelButton!="string"&&typeof v.cancelButton!="boolean"&&k.push(v.cancelButton);let S=k[p]?.run({checkboxChecked:$});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:$}}}e.$8w=g,e.$9w=(0,R.$Ci)("fileDialogService");var h;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(h||(e.ConfirmResult=h={}));const m=10;function b(d){const v=[];return v.push(...d.slice(0,m).map(p=>typeof p=="string"?p:(0,n.$ah)(p))),d.length>m&&(d.length-m===1?v.push((0,P.localize)(11416,null)):v.push((0,P.localize)(11417,null,d.length-m))),v.push(""),v.join(`
`)}function f(d,v){const p=(0,w.$bo)(d);let $=(p.buttons??[]).map(u=>(0,T.$4w)(u)),k=(d.buttons||[]).map((u,i)=>i),S=0,t=p.cancelId??$.length-1;if($.length>1){const u=typeof t=="number"?$[t]:void 0;if(I.$l||I.$k){if(typeof u=="string"&&$.length>1&&t!==1){$.splice(t,1),$.splice(1,0,u);const i=k[t];k.splice(t,1),k.splice(1,0,i),t=1}I.$l&&$.length>1&&($=$.reverse(),k=k.reverse(),S=$.length-1,typeof u=="string"&&(t=S-1))}else if(I.$j&&typeof u=="string"&&$.length>1&&t!==$.length-1){$.splice(t,1),$.push(u);const i=k[t];k.splice(t,1),k.push(i),t=$.length-1}}return p.buttons=$,p.defaultId=S,p.cancelId=t,p.noLink=!0,p.title=p.title||v.nameLong,{options:p,buttonIndeces:k}}}),define(le[97],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$kY=e.$jY=void 0,e.$lY=R,e.$mY=T,e.$jY=(0,n.$Ci)("encryptionService"),e.$kY=(0,n.$Ci)("encryptionMainService");var r;(function(I){I.kwallet="kwallet",I.kwallet5="kwallet5",I.gnomeLibsecret="gnome-libsecret",I.basic="basic"})(r||(e.PasswordStoreCLIOption=r={}));var P;(function(I){I.unknown="unknown",I.basicText="basic_text",I.gnomeAny="gnome_any",I.gnomeLibsecret="gnome_libsecret",I.gnomeKeyring="gnome_keyring",I.kwallet="kwallet",I.kwallet5="kwallet5",I.kwallet6="kwallet6",I.dplib="dpapi",I.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function R(I){return I===P.kwallet||I===P.kwallet5||I===P.kwallet6}function T(I){return I===P.gnomeAny||I===P.gnomeLibsecret||I===P.gnomeKeyring}}),define(le[38],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,n.$Ci)("environmentService"),e.$Ki=(0,n.$Di)(e.$Ji)}),define(le[174],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0,e.$zfc=(0,n.$Ci)("extensionHostStarter"),e.$Afc="extensionHostStarter"}),define(le[175],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q9b=e.$P9b=void 0,e.$P9b=(0,n.$Ci)("externalTerminal"),e.$Q9b="Terminal.app"}),define(le[176],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0,e.$Cfc=(0,n.$Ci)("externalTerminal")}),define(le[177],ue([0,1,48,53,11,9,3,79,23,94,10,175]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=e.$Dfc=void 0,n=Ie(n),R=Ie(R),T=Ie(T),w=Ie(w),c=Ie(c),g=Ie(g);const m=g.localize(11260,null);class b{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends b{static{this.b="cmd.exe"}openTerminal(t,u){return this.spawnTerminal(n,t,c.$vm(),u)}spawnTerminal(t,u,i,o){const s=u.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const a=R.$mc(s,".exe").toLowerCase();if(a==="cmder")return t.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return s.indexOf(" ")>=0&&l.push('""'),l.push(s),a==="wt"&&l.push("-d ."),new Promise((E,y)=>{const D=p(process),L=t.spawn(i,l,{cwd:o,env:D,detached:!0});L.on("error",y),L.on("exit",()=>E())})}async runInTerminal(t,u,i,o,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:f.getDefaultTerminalWindows(),l=await f.f();return new Promise((E,y)=>{const D=`"${u} - ${m}"`,L=`"${i.join('" "')}" & pause`,A=Object.assign({},p(process),o);Object.keys(A).filter(B=>A[B]===null).forEach(B=>delete A[B]);const O={cwd:u,env:A,windowsVerbatimArguments:!0};let W,x;R.$mc(a,".exe")==="wt"?(W=a,x=["-d",".",f.b,"/c",L]):l?(W=l,x=["-d",".",a,"/c",L]):(W=f.b,x=["/c","start",D,"/wait",a,"/c",`"${L}"`]),n.spawn(W,x,O).on("error",B=>{y($(B))}),E(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const t=await c.win32.findExecutable("wt");return await w.Promises.exists(t)?t:void 0}catch{return}}}e.$Dfc=f,Ee([r.$7h],f,"f",null);class d extends b{static{this.b="/usr/bin/osascript"}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const a=s.osxExec||h.$Q9b;return new Promise((l,E)=>{if(a===h.$Q9b||a==="iTerm.app"){const y=a===h.$Q9b?"TerminalHelper":"iTermHelper",L=[P.$Wg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${y}.scpt`).fsPath,"-t",t||m,"-w",u];for(const W of i)L.push("-a"),L.push(W);if(o){const W=Object.assign({},p(process),o);for(const x in W){const H=W[x];H===null?(L.push("-u"),L.push(x)):(L.push("-e"),L.push(`${x}=${H}`))}}let A="";const O=n.spawn(d.b,L);O.on("error",W=>{E($(W))}),O.stderr.on("data",W=>{A+=W.toString()}),O.on("exit",W=>{if(W===0)l(void 0);else if(A){const x=A.split(`
`,1);E(new Error(x[0]))}else E(new Error(g.localize(11261,null,y,W)))})}else E(new Error(g.localize(11262,null,a)))})}spawnTerminal(t,u,i){const o=u.osxExec||h.$Q9b;return new Promise((s,a)=>{const l=["-a",o];i&&l.push(i);const E=p(process),y=t.spawn("/usr/bin/open",l,{cwd:i,env:E});y.on("error",a),y.on("exit",()=>s())})}}e.$Efc=d;class v extends b{static{this.b=g.localize(11263,null)}openTerminal(t,u){return this.spawnTerminal(n,t,u)}runInTerminal(t,u,i,o,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((l,E)=>{const y=[];a.then(D=>{D.indexOf("gnome-terminal")>=0?y.push("-x"):y.push("-e"),y.push("bash"),y.push("-c");const L=`${k(i)}; echo; read -p "${v.b}" -n1;`;y.push(`''${L}''`);const A=Object.assign({},p(process),o);Object.keys(A).filter(H=>A[H]===null).forEach(H=>delete A[H]);const O={cwd:u,env:A};let W="";const x=n.spawn(D,y,O);x.on("error",H=>{E($(H))}),x.stderr.on("data",H=>{W+=H.toString()}),x.on("exit",H=>{if(H===0)l(void 0);else if(W){const B=W.split(`
`,1);E(new Error(B[0]))}else E(new Error(g.localize(11264,null,D,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!T.$l)v.d=Promise.resolve("xterm");else{const t=await w.Promises.exists("/etc/debian_version");v.d=new Promise(u=>{t?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return v.d}spawnTerminal(t,u,i){const o=u.linuxExec?Promise.resolve(u.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{o.then(l=>{const E=p(process),y=t.spawn(l,[],{cwd:i,env:E});y.on("error",a),y.on("exit",()=>s())})})}}e.$Ffc=v;function p(S){const t={...S.env};return(0,I.$im)(t),t}function $(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(g.localize(11265,null,S.path)):S}function k(S){let t="";for(const u of S)u.indexOf(" ")>=0?t+='"'+u+'"':t+=u,t+=" ";return t}}),define(le[14],ue([0,1,60,9,25,12,7,10,6,3,11,65]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$Cl=e.FileKind=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.FileOperationResult=e.$ul=e.$tl=e.$sl=e.$ql=e.FileChangeType=e.$pl=e.FileOperation=e.$jl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$0k=void 0,e.$$k=m,e.$_k=v,e.$al=$,e.$bl=k,e.$cl=S,e.$dl=t,e.$el=u,e.$fl=i,e.$gl=o,e.$hl=s,e.$il=a,e.$kl=y,e.$ll=D,e.$ml=L,e.$nl=A,e.$ol=O,e.$rl=X,e.$Dl=j,e.$El=N,e.$Gl=ie,e.$0k=(0,w.$Ci)("fileService");function m(V){return V.create===!0}var b;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var f;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var d;(function(V){V[V.UPDATED=2]="UPDATED",V[V.ADDED=4]="ADDED",V[V.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function v(V){const he=V;return!!he&&typeof he.onDidChange=="function"}var p;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function $(V){return!!(V.capabilities&p.FileReadWrite)}function k(V){return!!(V.capabilities&p.FileFolderCopy)}function S(V){return!!(V.capabilities&p.FileClone)}function t(V){return!!(V.capabilities&p.FileOpenReadWriteClose)}function u(V){return!!(V.capabilities&p.FileReadStream)}function i(V){return $(V)?!!(V.capabilities&p.FileAtomicRead):!1}function o(V){return $(V)?!!(V.capabilities&p.FileAtomicWrite):!1}function s(V){return!!(V.capabilities&p.FileAtomicDelete)}function a(V){return!!(V.capabilities&p.Readonly)}var l;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class E extends Error{static create(he,oe){const ee=new E(he.toString(),oe);return L(ee,oe),ee}constructor(he,oe){super(he),this.code=oe}}e.$jl=E;function y(V,he){return E.create(V,he)}function D(V){return V||y((0,I.localize)(11219,null),l.Unknown)}function L(V,he){return V.name=he?`${he} (FileSystemError)`:"FileSystemError",V}function A(V){if(!V)return l.Unknown;if(V instanceof E)return V.code;const he=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!he)return l.Unknown;switch(he[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function O(V){if(V instanceof G)return V.fileOperationResult;switch(A(V)){case l.FileNotFound:return te.FILE_NOT_FOUND;case l.FileIsADirectory:return te.FILE_IS_DIRECTORY;case l.FileNotADirectory:return te.FILE_NOT_DIRECTORY;case l.FileWriteLocked:return te.FILE_WRITE_LOCKED;case l.NoPermissions:return te.FILE_PERMISSION_DENIED;case l.FileExists:return te.FILE_MOVE_CONFLICT;case l.FileTooLarge:return te.FILE_TOO_LARGE;default:return te.FILE_OTHER_ERROR}}var W;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class x{constructor(he,oe,ee){this.resource=he,this.operation=oe,this.target=ee}isOperation(he){return this.operation===he}}e.$pl=x;var H;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class B{static{this.a=null}constructor(he,oe){this.c=oe,this.b=void 0,this.d=new h.$T(()=>{const ee=n.$Ii.forUris(()=>this.c);return ee.fill(this.rawAdded.map(M=>[M,!0])),ee}),this.f=new h.$T(()=>{const ee=n.$Ii.forUris(()=>this.c);return ee.fill(this.rawUpdated.map(M=>[M,!0])),ee}),this.g=new h.$T(()=>{const ee=n.$Ii.forUris(()=>this.c);return ee.fill(this.rawDeleted.map(M=>[M,!0])),ee}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ee of he){switch(ee.type){case H.ADDED:this.rawAdded.push(ee.resource);break;case H.UPDATED:this.rawUpdated.push(ee.resource);break;case H.DELETED:this.rawDeleted.push(ee.resource);break}this.b!==B.a&&(typeof ee.cId=="number"?this.b===void 0?this.b=ee.cId:this.b!==ee.cId&&(this.b=B.a):this.b!==void 0&&(this.b=B.a))}}contains(he,...oe){return this.h(he,{includeChildren:!1},...oe)}affects(he,...oe){return this.h(he,{includeChildren:!0},...oe)}h(he,oe,...ee){if(!he)return!1;const M=ee.length>0;return!!((!M||ee.includes(H.ADDED))&&(this.d.value.get(he)||oe.includeChildren&&this.d.value.findSuperstr(he))||(!M||ee.includes(H.UPDATED))&&(this.f.value.get(he)||oe.includeChildren&&this.f.value.findSuperstr(he))||(!M||ee.includes(H.DELETED))&&(this.g.value.findSubstr(he)||oe.includeChildren&&this.g.value.findSuperstr(he)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(he){return this.b===he}hasCorrelation(){return typeof this.b=="number"}}e.$ql=B;function X(V,he,oe){return!V||!he||V===he||he.length>V.length?!1:(he.charAt(he.length-1)!==r.sep&&(he+=r.sep),oe?(0,P.$Ef)(V,he):V.indexOf(he)===0)}class G extends Error{constructor(he,oe,ee){super(he),this.fileOperationResult=oe,this.options=ee}}e.$sl=G;class ae extends G{constructor(he,oe,ee,M){super(he,oe,M),this.fileOperationResult=oe,this.size=ee}}e.$tl=ae;class K extends G{constructor(he,oe,ee){super(he,te.FILE_NOT_MODIFIED_SINCE,ee),this.stat=oe}}e.$ul=K;var te;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$vl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xl="files.associations",e.$yl="files.exclude",e.$zl="files.readonlyInclude",e.$Al="files.readonlyExclude",e.$Bl="files.readonlyFromPermissions";var U;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(U||(e.FileKind=U={})),e.$Cl="";function j(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}async function N(V,he){if(!he.hasProvider(T.URI.from({scheme:V.scheme})))return new Promise(oe=>{const ee=he.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===V.scheme&&M.added&&(ee.dispose(),oe())})})}class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(he){return(0,R.$gg)(he)||(he=0),he<Y.KB?(0,I.localize)(11220,null,he.toFixed(0)):he<Y.MB?(0,I.localize)(11221,null,(he/Y.KB).toFixed(2)):he<Y.GB?(0,I.localize)(11222,null,(he/Y.MB).toFixed(2)):he<Y.TB?(0,I.localize)(11223,null,(he/Y.GB).toFixed(2)):(0,I.localize)(11224,null,(he/Y.TB).toFixed(2))}}e.$Fl=Y;function ie(V){const he=typeof V=="string"||V?.scheme===g.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===g.Schemas.file?1024*Y.MB:he?10*Y.MB:c.$p?50*Y.MB:1024*Y.MB}}),define(le[124],ue([0,1,16,15,10,14]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=T;async function T(g,h,m,b,f,d){let v;try{await I(g,h,m,b,f,d)}catch(p){v=p}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&m.error(v),m.end()}}async function I(g,h,m,b,f,d){w(d);const v=await g.open(h,{create:!1});try{w(d);let p=0,$=0,k=f&&typeof f.length=="number"?f.length:void 0,S=n.$Le.alloc(Math.min(f.bufferSize,typeof k=="number"?k:f.bufferSize)),t=f&&typeof f.position=="number"?f.position:0,u=0;do $=await g.read(v,t,S.buffer,u,S.byteLength-u),t+=$,u+=$,p+=$,typeof k=="number"&&(k-=$),u===S.byteLength&&(await m.write(b(S)),S=n.$Le.alloc(Math.min(f.bufferSize,typeof k=="number"?k:f.bufferSize)),u=0);while($>0&&(typeof k!="number"||k>0)&&w(d)&&c(p,f));if(u>0){let i=u;typeof k=="number"&&(i=Math.min(u,k)),m.write(b(S.slice(0,i)))}}catch(p){throw(0,R.$ll)(p)}finally{await g.close(v)}}function w(g){if(g.isCancellationRequested)throw(0,r.$5)();return!0}function c(g,h){if(typeof h?.limits?.size=="number"&&g>h.limits.size)throw(0,R.$kl)((0,P.localize)(11218,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[61],ue([0,1,111,2,9,3,7,14]),function(J,e,n,r,P,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=w,e.$2q=c,e.$6q=b,e.$7q=f,e.$8q=d,e.$9q=v,e.$0q=$,e.$$q=k;function w(S){return typeof S.correlationId=="number"}function c(S){return S.recursive===!0}class g extends r.$Tc{static{this.a=5}constructor(t,u,i,o){super(),this.h=t,this.j=u,this.m=i,this.n=o,this.c=this.B(new r.$Uc),this.f=void 0,this.g=0}s(){const t=new r.$Sc;this.c.value=t,this.b=this.r(t),this.b.setVerboseLogging(this.m),t.add(this.b.onDidChangeFile(u=>this.h(u))),t.add(this.b.onDidLogMessage(u=>this.j(u))),t.add(this.b.onDidError(u=>this.t(u.error,u.request)))}t(t,u){this.u(t,u)?this.g<g.a&&this.f?(this.y(`restarting watcher after unexpected error: ${t}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${t}`):this.y(t)}u(t,u){return!(!this.n.restartOnError||u||t.indexOf("No space left on device")!==-1||t.indexOf("EMFILE")!==-1)}w(t){this.g++,this.s(),this.watch(t)}async watch(t){this.f=t,await this.b?.watch(t)}async setVerboseLogging(t){this.m=t,await this.b?.setVerboseLogging(t)}y(t){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${t}`})}z(t){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${t}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=g;class h extends g{constructor(t,u,i){super(t,u,i,{type:"node.js",restartOnError:!1})}}e.$4q=h;class m extends g{constructor(t,u,i){super(t,u,i,{type:"universal",restartOnError:!0})}}e.$5q=m;function b(S){return S.map(t=>({type:t.type,resource:T.URI.revive(t.resource),cId:t.cId}))}function f(S){const t=new p;for(const u of S)t.processEvent(u);return t.coalesce()}function d(S,t){return typeof t=="string"&&!t.startsWith(n.$tk)&&!(0,P.$hc)(t)?{base:S,pattern:t}:t}function v(S,t){const u=[];for(const i of t)u.push((0,n.$xk)(d(S,i)));return u}class p{constructor(){this.a=new Set,this.b=new Map}c(t){return R.$l?t.resource.fsPath:t.resource.fsPath.toLowerCase()}processEvent(t){const u=this.b.get(this.c(t));let i=!1;if(u){const o=u.type,s=t.type;u.resource.fsPath!==t.resource.fsPath&&(t.type===I.FileChangeType.DELETED||t.type===I.FileChangeType.ADDED)?i=!0:o===I.FileChangeType.ADDED&&s===I.FileChangeType.DELETED?(this.b.delete(this.c(t)),this.a.delete(u)):o===I.FileChangeType.DELETED&&s===I.FileChangeType.ADDED?u.type=I.FileChangeType.UPDATED:o===I.FileChangeType.ADDED&&s===I.FileChangeType.UPDATED||(u.type=s)}else i=!0;i&&(this.a.add(t),this.b.set(this.c(t),t))}coalesce(){const t=[],u=[];return Array.from(this.a).filter(i=>i.type!==I.FileChangeType.DELETED?(t.push(i),!1):!0).sort((i,o)=>i.resource.fsPath.length-o.resource.fsPath.length).filter(i=>u.some(o=>(0,I.$rl)(i.resource.fsPath,o,!R.$l))?!1:(u.push(i.resource.fsPath),!0)).concat(t)}}function $(S,t){if(typeof t=="number")switch(S.type){case I.FileChangeType.ADDED:return(t&I.FileChangeFilter.ADDED)===0;case I.FileChangeType.DELETED:return(t&I.FileChangeFilter.DELETED)===0;case I.FileChangeType.UPDATED:return(t&I.FileChangeFilter.UPDATED)===0}return!1}function k(S){if(typeof S=="number"){const t=[];return S&I.FileChangeFilter.ADDED&&t.push("Added"),S&I.FileChangeFilter.DELETED&&t.push("Deleted"),S&I.FileChangeFilter.UPDATED&&t.push("Updated"),t.length===0?"<all>":`[${t.join(", ")}]`}return"<none>"}}),define(le[178],ue([0,1,16,54,15,4,2,67,33,14,61]),function(J,e,n,r,P,R,T,I,w,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=e.$$Q=void 0,e.$$Q="localFilesystem";class h extends T.$Tc{constructor(b,f){super(),this.a=b,this.b=f,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$je),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$je),this.onDidWatchError=this.g.event,this.h=(0,w.$Yg)(),this.j()}get capabilities(){return this.c||(this.c=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=c.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=c.FileSystemProviderCapabilities.Trash)),this.c}stat(b){return this.a.call("stat",[b])}readdir(b){return this.a.call("readdir",[b])}async readFile(b,f){const{buffer:d}=await this.a.call("readFile",[b,f]);return d}readFileStream(b,f,d){const v=(0,I.$ze)($=>n.$Le.concat($.map(k=>n.$Le.wrap(k))).buffer),p=new T.$Sc;return p.add(this.a.listen("readFileStream",[b,f])($=>{if($ instanceof n.$Le)v.write($.buffer);else{if($==="end")v.end();else{let k;if($ instanceof Error)k=$;else{const S=$;k=(0,c.$kl)(S.message??(0,r.$nj)(S),S.code??c.FileSystemProviderErrorCode.Unknown)}v.error(k),v.end()}p.dispose()}})),p.add(d.onCancellationRequested(()=>{v.error((0,P.$5)()),v.end(),p.dispose()})),v}writeFile(b,f,d){return this.a.call("writeFile",[b,n.$Le.wrap(f),d])}open(b,f){return this.a.call("open",[b,f])}close(b){return this.a.call("close",[b])}async read(b,f,d,v,p){const[$,k]=await this.a.call("read",[b,f,p]);return d.set($.buffer.slice(0,k),v),k}write(b,f,d,v,p){return this.a.call("write",[b,f,n.$Le.wrap(d),v,p])}mkdir(b){return this.a.call("mkdir",[b])}delete(b,f){return this.a.call("delete",[b,f])}rename(b,f,d){return this.a.call("rename",[b,f,d])}copy(b,f,d){return this.a.call("copy",[b,f,d])}cloneFile(b,f){return this.a.call("cloneFile",[b,f])}j(){this.B(this.a.listen("fileChange",[this.h])(b=>{if(Array.isArray(b)){const f=b;this.f.fire((0,g.$6q)(f))}else{const f=b;this.g.fire(f)}}))}watch(b,f){const d=(0,w.$Yg)();return this.a.call("watch",[this.h,d,b,f]),(0,T.$Rc)(()=>this.a.call("unwatch",[this.h,d]))}}e.$_Q=h}),define(le[179],ue([0,1,26,2,61,4,14,7,8]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class c extends r.$Tc{constructor(){super(),this.a=this.B(new R.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$3c),this.m=new Set,this.n=this.B(new w.$Ah(this.y())),this.r=5007,this.s=new w.$Zh,this.R=!1,this.B(this.f(h=>this.t(h)))}t(h){this.u(h)&&this.z(h)}u(h){return(0,P.$1q)(h)}async watch(h){this.s.isSettled||this.s.complete(),this.s=new w.$Zh;try{this.h.clear(),this.g.clear();for(const m of h)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(h){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),h?this.y():0)}y(){return 800}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async z(h){if(this.j.has(h.correlationId))return;const m=new r.$Sc;this.j.set(h.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(h,m),this.w(!0))}C(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.w(!1)}D(h,m){this.F(h,m)?(this.P(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.G(h,m),this.m.add(h.correlationId))}F(h,m){const b=this.O?.subscribe(h.path,(f,d)=>{m.isDisposed||(f?this.D(h,m):d?.type===T.FileChangeType.ADDED&&this.H(h))});return b?(m.add(b),!0):!1}G(h,m){let b=!1;const f=(d,v)=>{if(m.isDisposed)return;const p=this.I(d),$=this.I(v),k=b;b=p,!p&&($||k)&&this.H(h)};this.P(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.watchFile)(h.path,{persistent:!1,interval:this.r},f)}catch(d){this.Q(`fs.watchFile() failed with error ${d} on path ${h.path} (correlationId: ${h.correlationId})`)}m.add((0,r.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,n.unwatchFile)(h.path,f)}catch(d){this.Q(`fs.unwatchFile() failed with error ${d} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}H(h){this.P(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const m={resource:I.URI.file(h.path),type:T.FileChangeType.ADDED,cId:h.correlationId};this.a.fire([m]),this.J(m,h),this.C(h)}I(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(h,m){if(this.R){const b=` >> normalized ${h.type===T.FileChangeType.ADDED?"[ADDED]":h.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.L(b,m)}}L(h,m){this.R&&this.P(`${h}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,P.$$q)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.R=h}}e.$hr=c}),define(le[180],ue([0,1,26,8,21,32,2,78,9,3,18,7,112,23,14,61]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=p;class v extends T.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(k,S,t,u,i,o){super(),this.s=k,this.t=S,this.u=t,this.w=u,this.y=i,this.z=o,this.c=this.B(new r.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new r.$Qh(s=>this.M(s),v.b)),this.g=(0,d.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,d.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,d.$1q)(this.s)?this.s.filter:void 0,this.m=new P.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const k=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const S=await n.promises.stat(k);if(this.m.token.isCancellationRequested)return;this.B(await this.G(k,S.isDirectory()))}catch(k){k.code!=="ENOENT"?this.O(k):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${k})`),this.D()}}D(){this.r=!0,this.w?.()}async F(k){let S=k.path;try{S=await b.Promises.realpath(k.path),k.path===S&&(S=await(0,m.$jr)(k.path,this.m.token)??k.path),k.path!==S&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${k.path}, real: ${S})`)}catch{}return S}async G(k,S){const t=new T.$Sc;return this.H(k,S,t)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(k,S,t)),t}H(k,S,t){if(S)return!1;const u=h.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(o,s)=>{if(!t.isDisposed)if(o){const a=await this.G(k,S);t.isDisposed?a.dispose():t.add(a)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:u,type:s.type,cId:this.s.correlationId},!0)});return i?(t.add(i),!0):!1}async I(k,S,t){if(c.$k&&(0,R.$Bg)(k,"/Volumes/",!0)){this.O(`Refusing to watch ${k} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const u=new P.$ue(this.m.token);t.add((0,T.$Rc)(()=>u.dispose(!0)));const i=new T.$Sc;t.add(i);try{const o=h.URI.file(this.s.path),s=(0,w.$mc)(k),a=(0,n.watch)(k);i.add((0,T.$Rc)(()=>{a.removeAllListeners(),a.close()})),this.Q(`Started watching: '${k}'`);const l=new Set;if(S)try{for(const y of await b.Promises.readdir(k))l.add(y)}catch(y){this.O(y)}if(u.token.isCancellationRequested)return;const E=new Map;i.add((0,T.$Rc)(()=>{for(const[,y]of E)y.dispose();E.clear()})),a.on("error",(y,D)=>{u.token.isCancellationRequested||(this.O(`Failed to watch ${k} for changes using fs.watch() (${y}, ${D})`),this.D())}),a.on("change",(y,D)=>{if(u.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${D}`);let L="";if(D&&(L=D.toString(),c.$k&&(L=(0,I.$km)(L))),!(!L||y!=="change"&&y!=="rename"))if(S)if(y==="rename"){E.get(L)?.dispose();const A=setTimeout(async()=>{if(E.delete(L),L===s&&!await b.Promises.exists(k)){this.J(o);return}if(u.token.isCancellationRequested)return;const O=await this.N((0,w.$ic)(k,L));if(u.token.isCancellationRequested)return;let W;O?l.has(L)?W=f.FileChangeType.UPDATED:(W=f.FileChangeType.ADDED,l.add(L)):(l.delete(L),W=f.FileChangeType.DELETED),this.L({resource:(0,g.$dh)(o,L),type:W,cId:this.s.correlationId})},v.a);E.set(L,(0,T.$Rc)(()=>clearTimeout(A)))}else{let A;l.has(L)?A=f.FileChangeType.UPDATED:(A=f.FileChangeType.ADDED,l.add(L)),this.L({resource:(0,g.$dh)(o,L),type:A,cId:this.s.correlationId})}else if(y==="rename"||L!==s){const A=setTimeout(async()=>{const O=await b.Promises.exists(k);u.token.isCancellationRequested||(O?(this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(k,!1))):this.J(o))},v.a);i.clear(),i.add((0,T.$Rc)(()=>clearTimeout(A)))}else this.L({resource:o,type:f.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(o){u.token.isCancellationRequested||this.O(`Failed to watch ${k} for changes using fs.watch() (${o.toString()})`),this.D()}}J(k){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:k,type:f.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(k,S=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${k.type===f.FileChangeType.ADDED?"[ADDED]":k.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${k.resource.fsPath}`),!S&&this.g.some(t=>t(k.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${k.resource.fsPath}`):!S&&this.h&&this.h.length>0&&!this.h.some(t=>t(k.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${k.resource.fsPath}`):this.f.work(k))}M(k){const S=(0,d.$7q)(k),t=[];for(const i of S){if((0,d.$0q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}t.push(i)}if(t.length===0)return;if(this.z)for(const i of t)this.R(` >> normalized ${i.type===f.FileChangeType.ADDED?"[ADDED]":i.type===f.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(t)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${t.length}, most recent change: ${t[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(k){if(c.$l)return b.Promises.exists(k);try{const S=(0,w.$mc)(k);return(await b.Promises.readdir((0,w.$lc)(k))).some(u=>u===S)}catch(S){return this.Q(S),!1}}setVerboseLogging(k){this.z=k}O(k){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${k}`})}P(k){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${k}`})}Q(k){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${k}`})}R(k){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${k}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=v;async function p($,k,S,t,u=512){const i=await b.Promises.open($,"r"),o=Buffer.allocUnsafe(u),s=new P.$ue(t);let a,l=!1;const E={path:$,excludes:[],recursive:!1},y=new v(E,void 0,D=>{(async()=>{for(const{type:L}of D)if(L===f.FileChangeType.UPDATED){if(l)return;l=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:A}=await b.Promises.read(i,o,0,u,null);if(!A||s.token.isCancellationRequested)break;k(o.slice(0,A))}}catch(A){a=new Error(A),s.dispose(!0)}finally{l=!1}}})()});return await y.ready,S(),new Promise((D,L)=>{s.token.onCancellationRequested(async()=>{y.dispose();try{await b.Promises.close(i)}catch(A){a=new Error(A)}a?L(a):D()})})}}),define(le[181],ue([0,1,4,111,179,3,180,32]),function(J,e,n,r,P,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class w extends P.$hr{constructor(g){super(),this.O=g,this.onDidError=n.Event.None,this.watchers=new Set}async N(g){g=this.Z(g);const h=[],m=new Set(Array.from(this.watchers));for(const b of g){const f=this.W(b);f&&(0,r.$Bk)(f.request.excludes,b.excludes)&&(0,r.$Bk)(f.request.includes,b.includes)?m.delete(f):h.push(b)}h.length&&this.P(`Request to start watching: ${h.map(b=>this.M(b)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(b=>this.M(b.request)).join(",")}`);for(const b of m)this.Y(b);for(const b of h)this.X(b)}W(g){for(const h of this.watchers)if(typeof g.correlationId=="number"||typeof h.request.correlationId=="number"){if(h.request.correlationId===g.correlationId)return h}else if((0,I.$Ag)(h.request.path,g.path,!R.$l))return h}X(g){const h=new T.$mr(g,this.O,b=>this.a.fire(b),()=>this.c.fire(g),b=>this.b.fire(b),this.R),m={request:g,instance:h};this.watchers.add(m)}async stop(){await super.stop();for(const g of this.watchers)this.Y(g)}Y(g){this.P("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}Z(g){const h=new Map;for(const m of g){const b=R.$l?m.path:m.path.toLowerCase();let f=h.get(m.correlationId);f||(f=new Map,h.set(m.correlationId,f)),f.has(b)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),f.set(b,m)}return Array.from(h.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(g){super.setVerboseLogging(g);for(const h of this.watchers)h.instance.setVerboseLogging(g)}P(g,h){this.R&&this.b.fire({type:"trace",message:this.bb(g,h)})}Q(g){this.b.fire({type:"warn",message:this.bb(g)})}bb(g,h){return h?`[File Watcher (node.js)] ${g} (${this.M(h.request)})`:`[File Watcher (node.js)] ${g}`}}e.$or=w}),define(le[182],ue([0,1,61,181]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class P extends n.$4q{constructor(T,I,w){super(T,I,w),this.s()}r(T){return T.add(new r.$or(void 0))}}e.$pr=P}),define(le[183],ue([0,1,11,44,159,61]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class T extends R.$5q{constructor(w,c,g){super(w,c,g),this.s()}r(w){const c=w.add(new P.$fr(n.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(c.onDidProcessExit(({code:g,signal:h})=>this.t(`terminated by itself with code ${g}, signal: ${h} (ETERM)`))),r.ProxyChannel.toService((0,r.$ji)(c.getChannel("watcher")))}}e.$gr=T}),define(le[98],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class n{constructor(...P){this.a=new Map;for(const[R,T]of P)this.set(R,T)}set(P,R){const T=this.a.get(P);return this.a.set(P,R),T}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ai=n}),define(le[184],ue([0,1,8,15,2,83,173,6,98,108]),function(J,e,n,r,P,R,T,I,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const g=!1;class h extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class m{constructor(v=new w.$Ai,p=!1,$,k=g){this.i=v,this.j=p,this.k=$,this.l=k,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Bi,this),this._globalGraph=k?$?._globalGraph??new T.$sr(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Oc)(this.h),this.h.clear();for(const v of this.g)(0,P.$Nc)(v)&&v.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(v,p){this.m();const $=this,k=new class extends m{dispose(){$.h.delete(k),super.dispose()}}(v,this.j,this,this.l);return this.h.add(k),p?.add(k),k}invokeFunction(v,...p){this.m();const $=f.traceInvocation(this.l,v);let k=!1;try{return v({get:t=>{if(k)throw(0,r.$7)("service accessor is only valid during the invocation of its target method");const u=this.s(t,$);if(!u)throw new Error(`[invokeFunction] unknown service '${t}'`);return u}},...p)}finally{k=!0,$.stop()}}createInstance(v,...p){this.m();let $,k;return v instanceof R.$zi?($=f.traceCreation(this.l,v.ctor),k=this.o(v.ctor,v.staticArguments.concat(p),$)):($=f.traceCreation(this.l,v),k=this.o(v,p,$)),$.stop(),k}o(v,p=[],$){const k=I._util.getServiceDependencies(v).sort((u,i)=>u.index-i.index),S=[];for(const u of k){const i=this.s(u.id,$);i||this.y(`[createInstance] ${v.name} depends on UNKNOWN service ${u.id}.`,!1),S.push(i)}const t=k.length>0?k[0].index:p.length;if(p.length!==t){console.trace(`[createInstance] First service dependency of ${v.name} at position ${t+1} conflicts with ${p.length} static arguments`);const u=t-p.length;u>0?p=p.concat(new Array(u)):p=p.slice(0,t)}return Reflect.construct(v,p.concat(S))}q(v,p){if(this.i.get(v)instanceof R.$zi)this.i.set(v,p);else if(this.k)this.k.q(v,p);else throw new Error("illegalState - setting UNKNOWN service instance")}r(v){const p=this.i.get(v);return!p&&this.k?this.k.r(v):p}s(v,p){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const $=this.r(v);return $ instanceof R.$zi?this.u(v,$,p.branch(v,!0)):(p.branch(v,!1),$)}u(v,p,$){if(this.t.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.t.add(v);try{return this.v(v,p,$)}finally{this.t.delete(v)}}v(v,p,$){const k=new T.$sr(i=>i.id.toString());let S=0;const t=[{id:v,desc:p,_trace:$}],u=new Set;for(;t.length;){const i=t.pop();if(!u.has(String(i.id))){if(u.add(String(i.id)),k.lookupOrInsertNode(i),S++>1e3)throw new h(k);for(const o of I._util.getServiceDependencies(i.desc.ctor)){const s=this.r(o.id);if(s||this.y(`[createInstance] ${v} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof R.$zi){const a={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};k.insertEdge(i,a),t.push(a)}}}}for(;;){const i=k.roots();if(i.length===0){if(!k.isEmpty())throw new h(k);break}for(const{data:o}of i){if(this.r(o.id)instanceof R.$zi){const a=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,a)}k.removeNode(o)}}return this.r(v)}w(v,p,$=[],k,S){if(this.i.get(v)instanceof R.$zi)return this.x(v,p,$,k,S,this.g);if(this.k)return this.k.w(v,p,$,k,S);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}x(v,p,$=[],k,S,t){if(k){const u=new m(void 0,this.j,this,this.l);u.c=String(v);const i=new Map,o=new n.$Vh(()=>{const s=u.o(p,$,S);for(const[a,l]of i){const E=s[a];if(typeof E=="function")for(const y of l)y.disposable=E.apply(s,y.listener)}return i.clear(),t.add(s),s});return new Proxy(Object.create(null),{get(s,a){if(!o.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let y=i.get(a);return y||(y=new c.$4c,i.set(a,y)),(L,A,O)=>{if(o.isInitialized)return o.value[a](L,A,O);{const W={listener:[L,A,O],disposable:void 0},x=y.push(W);return(0,P.$Rc)(()=>{x(),W.disposable?.dispose()})}}}if(a in s)return s[a];const l=o.value;let E=l[a];return typeof E!="function"||(E=E.bind(l),s[a]=E),E},set(s,a,l){return o.value[a]=l,!0},getPrototypeOf(s){return p.prototype}})}else{const u=this.o(p,$,S);return t.add(u),u}}y(v,p){if(p&&console.warn(v),this.j)throw new Error(v)}}e.$tr=m;var b;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(b||(b={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(b.None,null)}stop(){}branch(){return this}}}static traceInvocation(v,p){return v?new f(b.Invocation,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,p){return v?new f(b.Creation,p.name):f.c}static{this.f=0}constructor(v,p){this.type=v,this.name=p,this.g=Date.now(),this.h=[]}branch(v,p){const $=new f(b.Branch,v.toString());return this.h.push([v,p,$]),$}stop(){const v=Date.now()-this.g;f.f+=v;let p=!1;function $(S,t){const u=[],i=new Array(S+1).join("	");for(const[o,s,a]of t.h)if(s&&a){p=!0,u.push(`${i}CREATES -> ${o}`);const l=$(S+1,a);l&&u.push(l)}else u.push(`${i}uses -> ${o}`);return u.join(`
`)}const k=[`${this.type===b.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||p)&&f.all.add(k.join(`
`))}}e.$ur=f}),define(le[185],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=e.$j_b=e.IssueSource=e.IssueType=void 0;var r;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(r||(e.IssueType=r={}));var P;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.$j_b=(0,n.$Ci)("issueService"),e.$k_b=(0,n.$Ci)("processService")}),define(le[5],ue([0,1,10,54,4,46,2,31,3,18,12,7,122,6]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$ak=e.LogLevel=e.$$j=e.$0j=void 0,e.$_j=d,e.log=p,e.$lk=E,e.$mk=y,e.$nk=D,e.$ok=L,n=Ie(n),e.$0j=(0,b.$Ci)("logService"),e.$$j=(0,b.$Ci)("loggerService");function f(){return new Date().toISOString()}function d(A){return(0,g.$gg)(A)}var v;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$ak=v.Info;function p(A,O,W){switch(O){case v.Trace:A.trace(W);break;case v.Debug:A.debug(W);break;case v.Info:A.info(W);break;case v.Warning:A.warn(W);break;case v.Error:A.error(W);break;case v.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function $(A,O=!1){let W="";for(let x=0;x<A.length;x++){let H=A[x];if(H instanceof Error&&(H=(0,r.$nj)(H,O)),typeof H=="object")try{H=JSON.stringify(H)}catch{}W+=(x>0?" ":"")+H}return W}class k extends T.$Tc{constructor(){super(...arguments),this.b=e.$ak,this.c=this.B(new P.$je),this.onDidChangeLogLevel=this.c.event}setLevel(O){this.b!==O&&(this.b=O,this.c.fire(this.b))}getLevel(){return this.b}f(O){return this.b!==v.Off&&this.b<=O}}e.$ck=k;class S extends k{constructor(O){super(),this.h=O}f(O){return this.h||super.f(O)}trace(O,...W){this.f(v.Trace)&&this.g(v.Trace,$([O,...W],!0))}debug(O,...W){this.f(v.Debug)&&this.g(v.Debug,$([O,...W]))}info(O,...W){this.f(v.Info)&&this.g(v.Info,$([O,...W]))}warn(O,...W){this.f(v.Warning)&&this.g(v.Warning,$([O,...W]))}error(O,...W){if(this.f(v.Error))if(O instanceof Error){const x=Array.prototype.slice.call(arguments);x[0]=O.stack,this.g(v.Error,$(x))}else this.g(v.Error,$([O,...W]))}flush(){}}e.$dk=S;class t extends k{constructor(O=e.$ak){super(),this.setLevel(O),this.g=!w.$j}trace(O,...W){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}debug(O,...W){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}info(O,...W){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,O,...W):console.log(`[main ${f()}]`,O,...W))}warn(O,...W){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,O,...W):console.warn(`[main ${f()}]`,O,...W))}error(O,...W){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,O,...W):console.error(`[main ${f()}]`,O,...W))}flush(){}}e.$ek=t;class u extends k{constructor(O=e.$ak,W=!0){super(),this.g=W,this.setLevel(O)}trace(O,...W){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",O,...W):console.log(O,...W))}debug(O,...W){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",O,...W):console.log(O,...W))}info(O,...W){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",O,...W):console.log(O,...W))}warn(O,...W){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",O,...W):console.log(O,...W))}error(O,...W){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",O,...W):console.error(O,...W))}flush(){}}e.$fk=u;class i extends k{constructor(O,W=e.$ak){super(),this.g=O,this.setLevel(W)}trace(O,...W){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(O),...W])}debug(O,...W){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(O),...W])}info(O,...W){this.f(v.Info)&&this.g.log(v.Info,[this.h(O),...W])}warn(O,...W){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(O),...W])}error(O,...W){this.f(v.Error)&&this.g.log(v.Error,[this.h(O),...W])}h(O){return typeof O=="string"?O:(0,r.$nj)(O,this.f(v.Trace))}flush(){}}e.$gk=i;class o extends k{constructor(O){super(),this.g=O,O.length&&this.setLevel(O[0].getLevel())}setLevel(O){for(const W of this.g)W.setLevel(O);super.setLevel(O)}trace(O,...W){for(const x of this.g)x.trace(O,...W)}debug(O,...W){for(const x of this.g)x.debug(O,...W)}info(O,...W){for(const x of this.g)x.info(O,...W)}warn(O,...W){for(const x of this.g)x.warn(O,...W)}error(O,...W){for(const x of this.g)x.error(O,...W)}flush(){for(const O of this.g)O.flush()}dispose(){for(const O of this.g)O.dispose();super.dispose()}}e.$hk=o;class s extends T.$Tc{constructor(O,W,x){if(super(),this.h=O,this.j=W,this.b=new I.$zc,this.c=this.B(new P.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$je),this.onDidChangeVisibility=this.g.event,x)for(const H of x)this.b.set(H.resource,{logger:void 0,info:H})}m(O){return(0,g.$cg)(O)?[...this.b.values()].find(W=>W.info.id===O):this.b.get(O)}getLogger(O){return this.m(O)?.logger}createLogger(O,W){const x=this.n(O),H=(0,g.$cg)(O)?O:W?.id??(0,R.$qj)(x.toString()).toString(16);let B=this.b.get(x)?.logger;const X=W?.logLevel==="always"?v.Trace:W?.logLevel;B||(B=this.s(x,X??this.getLogLevel(x)??this.h,{...W,id:H}));const G={logger:B,info:{resource:x,id:H,logLevel:X,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(G.info),this.b.set(x,G),B}n(O){return(0,g.$cg)(O)?(0,c.$dh)(this.j,`${O}.log`):O}setLogLevel(O,W){if(h.URI.isUri(O)){const x=O,H=W,B=this.b.get(x);B&&H!==B.info.logLevel&&(B.info.logLevel=H===this.h?void 0:H,B.logger?.setLevel(H),this.b.set(B.info.resource,B),this.f.fire([x,H]))}else{this.h=O;for(const[x,H]of this.b.entries())this.b.get(x)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(O,W){const x=this.m(O);x&&W!==!x.info.hidden&&(x.info.hidden=!W,this.b.set(x.info.resource,x),this.g.fire([x.info.resource,W]))}getLogLevel(O){let W;return O&&(W=this.b.get(O)?.info.logLevel),W??this.h}registerLogger(O){const W=this.b.get(O.resource);W?W.info.hidden!==O.hidden&&this.setVisibility(O.resource,!O.hidden):(this.b.set(O.resource,{info:O,logger:void 0}),this.c.fire({added:[O],removed:[]}))}deregisterLogger(O){const W=this.b.get(O);W&&(W.logger&&W.logger.dispose(),this.b.delete(O),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const O of this.b.values())yield O.info}getRegisteredLogger(O){return this.b.get(O)?.info}dispose(){this.b.forEach(O=>O.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ik=s;class a{constructor(){this.onDidChangeLogLevel=new P.$je().event}setLevel(O){}getLevel(){return v.Info}trace(O,...W){}debug(O,...W){}info(O,...W){}warn(O,...W){}error(O,...W){}critical(O,...W){}dispose(){}flush(){}}e.$jk=a;class l extends a{}e.$kk=l;function E(A){if(A.verbose)return v.Trace;if(typeof A.logLevel=="string"){const O=L(A.logLevel.toLowerCase());if(O!==void 0)return O}return e.$ak}function y(A){switch(A){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}function D(A){switch(A){case v.Trace:return{original:"Trace",value:n.localize(11152,null)};case v.Debug:return{original:"Debug",value:n.localize(11153,null)};case v.Info:return{original:"Info",value:n.localize(11154,null)};case v.Warning:return{original:"Warning",value:n.localize(11155,null)};case v.Error:return{original:"Error",value:n.localize(11156,null)};case v.Off:return{original:"Off",value:n.localize(11157,null)}}}function L(A){switch(A){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$pk=new m.$Tj("logLevel",y(v.Info))});var re=this&&this.__param||function(J,e){return function(n,r){e(n,r,J)}};define(le[186],ue([0,1,13,3,97,5]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;const T=n.safeStorage;let I=class{constructor(c){this.a=c,n.app.commandLine.getSwitchValue("password-store")===P.PasswordStoreCLIOption.basic&&T.setUsePlainTextEncryption?.(!0)}async encrypt(c){this.a.trace("[EncryptionMainService] Encrypting value.");try{const g=JSON.stringify(T.encryptString(c));return this.a.trace("[EncryptionMainService] Encrypted value."),g}catch(g){throw this.a.error(g),g}}async decrypt(c){let g;try{if(g=JSON.parse(c),!g.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${c}`);const h=Buffer.from(g.data);this.a.trace("[EncryptionMainService] Decrypting value.");const m=T.decryptString(h);return this.a.trace("[EncryptionMainService] Decrypted value."),m}catch(h){throw this.a.error(h),h}}isEncryptionAvailable(){return Promise.resolve(T.isEncryptionAvailable())}getKeyStorageProvider(){if(r.$j)return Promise.resolve(P.KnownStorageProvider.dplib);if(r.$k)return Promise.resolve(P.KnownStorageProvider.keychainAccess);if(T.getSelectedStorageBackend)try{const c=T.getSelectedStorageBackend();return Promise.resolve(c)}catch(c){this.a.error(c)}return Promise.resolve(P.KnownStorageProvider.unknown)}async setUsePlainTextEncryption(){if(r.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(r.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!T.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");T.setUsePlainTextEncryption(!0)}};e.$yfc=I,e.$yfc=I=Ee([re(0,R.$0j)],I)}),define(le[187],ue([0,1,20,8,15,4,32,2,9,61,5]),function(J,e,n,r,P,R,T,I,w,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class h extends I.$Tc{constructor(b,f){super(),this.a=b,this.b=f,this.c=this.B(new R.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$Ah(0)),this.w=[],this.y=this.B(new r.$Ah(0))}watch(b,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(b,f):this.z(b,f)}n(b,f){const d={path:this.J(b),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.j,d);return this.r(),(0,I.$Rc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,P.$Y)(b))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,c.$6q)(f)),f=>this.G(f),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const f of this.j)(0,c.$2q)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const f of this.j)(0,c.$2q)(f)&&b.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,f){const d={path:this.J(b),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},v=(0,n.$Sb)(this.w,d);return this.C(),(0,I.$Rc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,P.$Y)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,c.$6q)(b)),b=>this.G(b),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.H(b)}H(b){this.a[b.type](b.message)}I(b){return(0,w.$gc)(b.fsPath)}J(b){const f=this.I(b);return(0,T.$Eg)(f)}}e.$_q=h}),define(le[188],ue([0,1,20,8,16,21,4,46,77,2,60,11,70,18,67,10,14,124,5,15]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let t=class extends c.$Tc{static{S=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$je),this.Y=this.B(new T.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Lh)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const s=new c.$Sc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),s.add(o.onDidChangeFile(a=>{const l=new v.$ql(a,!this.S(o));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(a=>this.Z.fire(new Error(a)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,c.$Rc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,c.$Oc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(s){o.push(s)}}),!this.h.has(i)&&await r.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return w.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,b.$hh)(i))throw new v.$sl((0,d.localize)(11225,null,this.sb(i)),v.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const s=new k.$ab;throw s.message=(0,d.localize)(11226,null,i.toString()),s}return o}async m(i){const o=await this.j(i);if((0,v.$dl)(o)||(0,v.$al)(o)||(0,v.$el)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,v.$dl)(o)||(0,v.$al)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(s){throw(0,v.$nl)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.$sl((0,d.localize)(11227,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND):(0,v.$ll)(s)}}async s(i,o){const s=await this.j(i),a=this.S(s),l=o?.resolveTo,E=o?.resolveSingleChildDescendants,y=o?.resolveMetadata,D=await s.stat(i);let L;return this.t(s,i,D,void 0,!!y,(A,O)=>(L||(L=g.$Ii.forUris(()=>!a),L.set(i,!0),l&&L.fill(!0,l)),L.get(A.resource)||L.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&E?O===1:!1))}async t(i,o,s,a,l,E){const{providerExtUri:y}=this.R(i),D={resource:o,name:y.basename(o),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&v.FilePermission.Readonly)||!!(i.capabilities&v.FileSystemProviderCapabilities.Readonly),locked:!!((s.permissions??0)&v.FilePermission.Locked),etag:(0,v.$Dl)({mtime:s.mtime,size:s.size}),children:void 0};if(D.isDirectory&&E(D,a)){try{const L=await i.readdir(o),A=await r.Promises.settled(L.map(async([O,W])=>{try{const x=y.joinPath(o,O),H=l?await i.stat(x):{type:W};return await this.t(i,x,H,L.length,l,E)}catch(x){return this.b.trace(x),null}}));D.children=(0,n.$Gb)(A)}catch(L){this.b.trace(L),D.children=[]}return D}return D}async resolveAll(i){return r.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),s=await o.stat(i);return this.t(o,i,s,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(s){return s}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new v.$sl((0,d.localize)(11228,null,this.sb(i)),v.FileOperationResult.FILE_MODIFIED_SINCE,o)}async createFile(i,o=P.$Le.fromString(""),s){await this.u(i,s);const a=await this.writeFile(i,o);return this.r.fire(new v.$pl(i,v.FileOperation.CREATE,a)),a}async writeFile(i,o,s){const a=this.qb(await this.n(i),i),{providerExtUri:l}=this.R(a);let E=s;if((0,v.$gl)(a)&&!E?.atomic){const y=a.enforceAtomicWriteFile?.(i);y&&(E={...s,atomic:y})}try{await this.w(a,i,E)||await this.U(a,l.dirname(i));let D;if((0,v.$al)(a)&&!(o instanceof P.$Le))if((0,f.$xe)(o)){const L=await(0,f.$Ee)(o,3);L.ended?D=P.$Le.concat(L.buffer):D=L}else D=(0,f.$Be)(o,L=>P.$Le.concat(L),3);else D=o;!(0,v.$dl)(a)||(0,v.$al)(a)&&D instanceof P.$Le||(0,v.$al)(a)&&(0,v.$gl)(a)&&E?.atomic?await this.hb(a,i,E,D):await this.db(a,i,E,D instanceof P.$Le?(0,P.$We)(D):D),this.r.fire(new v.$pl(i,v.FileOperation.WRITE))}catch(y){throw new v.$sl((0,d.localize)(11229,null,this.sb(i),(0,v.$ll)(y).toString()),(0,v.$ol)(y),E)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,s){const a=!!s?.unlock;if(a&&!(i.capabilities&v.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,d.localize)(11230,null,this.sb(o)));if(!!s?.atomic){if(!(i.capabilities&v.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,d.localize)(11231,null,this.sb(o)));if(!(i.capabilities&v.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,d.localize)(11232,null,this.sb(o)));if(a)throw new Error((0,d.localize)(11233,null,this.sb(o)))}let E;try{E=await i.stat(o)}catch{return}if(E.type&v.FileType.Directory)throw new v.$sl((0,d.localize)(11234,null,this.sb(o)),v.FileOperationResult.FILE_IS_DIRECTORY,s);if(this.rb(o,E),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.$Cl&&typeof E.mtime=="number"&&typeof E.size=="number"&&s.mtime<E.mtime&&s.etag!==(0,v.$Dl)({mtime:s.mtime,size:E.size}))throw new v.$sl((0,d.localize)(11235,null),v.FileOperationResult.FILE_MODIFIED_SINCE,s);return E}async readFile(i,o,s){const a=await this.m(i);return o?.atomic?this.z(a,i,o,s):this.C(a,i,o,s)}async z(i,o,s,a){return new Promise((l,E)=>{this.cb.queueFor(o,async()=>{try{const y=await this.C(i,o,s,a);l(y)}catch(y){E(y)}},this.R(i).providerExtUri)})}async C(i,o,s,a){const l=await this.D(i,o,{...s,preferUnbuffered:!0},a);return{...l,value:await(0,P.$Xe)(l.value)}}async readFileStream(i,o,s){const a=await this.m(i);return this.D(a,i,o,s)}async D(i,o,s,a){const l=new R.$ue(a);let E=s;(0,v.$fl)(i)&&i.enforceAtomicReadFile?.(o)&&(E={...s,atomic:!0});const y=this.J(o,E).then(L=>L,L=>{throw l.dispose(!0),L});let D;try{return typeof E?.etag=="string"&&E.etag!==v.$Cl&&await y,E?.atomic&&(0,v.$fl)(i)||!((0,v.$dl)(i)||(0,v.$el)(i))||(0,v.$al)(i)&&E?.preferUnbuffered?D=this.I(i,o,E):(0,v.$el)(i)?D=this.G(i,o,l.token,E):D=this.H(i,o,l.token,E),D.on("end",()=>l.dispose()),D.on("error",()=>l.dispose()),{...await y,value:D}}catch(L){throw D&&await(0,f.$Ce)(D),this.F(L,o,E)}}F(i,o,s){const a=(0,d.localize)(11236,null,this.sb(o),(0,v.$ll)(i).toString());return i instanceof v.$ul?new v.$ul(a,i.stat,s):i instanceof v.$tl?new v.$tl(a,i.fileOperationResult,i.size,i.options):new v.$sl(a,(0,v.$ol)(i),s)}G(i,o,s,a=Object.create(null)){const l=i.readFileStream(o,a,s);return(0,f.$Ie)(l,{data:E=>E instanceof P.$Le?E:P.$Le.wrap(E),error:E=>this.F(E,o,a)},E=>P.$Le.concat(E))}H(i,o,s,a=Object.create(null)){const l=(0,P.$2e)();return(0,p.$Yq)(i,o,l,E=>E,{...a,bufferSize:this.a,errorTransformer:E=>this.F(E,o,a)},s),l}I(i,o,s){const a=(0,f.$ze)(l=>P.$Le.concat(l));return(async()=>{try{let l;s?.atomic&&(0,v.$fl)(i)?l=await i.readFile(o,{atomic:!0}):l=await i.readFile(o),typeof s?.position=="number"&&(l=l.slice(s.position)),typeof s?.length=="number"&&(l=l.slice(0,s.length)),this.L(o,l.byteLength,s),a.end(P.$Le.wrap(l))}catch(l){a.error(l),a.end()}})(),a}async J(i,o){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new v.$sl((0,d.localize)(11237,null,this.sb(i)),v.FileOperationResult.FILE_IS_DIRECTORY,o);if(typeof o?.etag=="string"&&o.etag!==v.$Cl&&o.etag===s.etag)throw new v.$ul((0,d.localize)(11238,null),s,o);return this.L(i,s.size,o),s}L(i,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new v.$tl((0,d.localize)(11239,null,this.sb(i)),v.FileOperationResult.FILE_TOO_LARGE,o,s)}async canMove(i,o,s){return this.M(i,o,"move",s)}async canCopy(i,o,s){return this.M(i,o,"copy",s)}async M(i,o,s,a){if(i.toString()!==o.toString())try{const l=s==="move"?this.qb(await this.n(i),i):await this.m(i),E=this.qb(await this.n(o),o);await this.Q(l,i,E,o,s,a)}catch(l){return l}return!0}async move(i,o,s){const a=this.qb(await this.n(i),i),l=this.qb(await this.n(o),o),E=await this.N(a,i,l,o,"move",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$pl(i,E==="move"?v.FileOperation.MOVE:v.FileOperation.COPY,y)),y}async copy(i,o,s){const a=await this.m(i),l=this.qb(await this.n(o),o),E=await this.N(a,i,l,o,"copy",!!s),y=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new v.$pl(i,E==="copy"?v.FileOperation.COPY:v.FileOperation.MOVE,y)),y}async N(i,o,s,a,l,E){if(o.toString()===a.toString())return l;const{exists:y,isSameResourceWithDifferentPathCase:D}=await this.Q(i,o,s,a,l,E);if(y&&!D&&E&&await this.del(a,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(a)),l==="copy"){if(i===s&&(0,v.$bl)(i))await i.copy(o,a,{overwrite:E});else{const L=await this.resolve(o);L.isDirectory?await this.P(i,L,s,a):await this.O(i,o,s,a)}return l}else return i===s?(await i.rename(o,a,{overwrite:E}),l):(await this.N(i,o,s,a,"copy",E),await this.del(o,{recursive:!0}),"copy")}async O(i,o,s,a){if((0,v.$dl)(i)&&(0,v.$dl)(s))return this.jb(i,o,s,a);if((0,v.$dl)(i)&&(0,v.$al)(s))return this.pb(i,o,s,a);if((0,v.$al)(i)&&(0,v.$dl)(s))return this.nb(i,o,s,a);if((0,v.$al)(i)&&(0,v.$al)(s))return this.lb(i,o,s,a)}async P(i,o,s,a){await s.mkdir(a),Array.isArray(o.children)&&await r.Promises.settled(o.children.map(async l=>{const E=this.R(s).providerExtUri.joinPath(a,l.name);return l.isDirectory?this.P(i,await this.resolve(l.resource),s,E):this.O(i,l.resource,s,E)}))}async Q(i,o,s,a,l,E){let y=!1;if(i===s){const{providerExtUri:L,isPathCaseSensitive:A}=this.R(i);if(A||(y=L.isEqual(o,a)),y&&l==="copy")throw new Error((0,d.localize)(11240,null,this.sb(o),this.sb(a)));if(!y&&L.isEqualOrParent(a,o))throw new Error((0,d.localize)(11241,null,this.sb(o),this.sb(a)))}const D=await this.exists(a);if(D&&!y){if(!E)throw new v.$sl((0,d.localize)(11242,null,this.sb(o),this.sb(a)),v.FileOperationResult.FILE_MOVE_CONFLICT);if(i===s){const{providerExtUri:L}=this.R(i);if(L.isEqualOrParent(o,a))throw new Error((0,d.localize)(11243,null,this.sb(o),this.sb(a)))}}return{exists:D,isSameResourceWithDifferentPathCase:y}}R(i){const o=this.S(i);return{providerExtUri:o?b.$6g:b.$8g,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new v.$pl(i,v.FileOperation.CREATE,s)),s}async U(i,o){const s=[],{providerExtUri:a}=this.R(i);for(;!a.isEqual(o,a.dirname(o));)try{if(!((await i.stat(o)).type&v.FileType.Directory))throw new Error((0,d.localize)(11244,null,this.sb(o)));break}catch(l){if((0,v.$nl)(l)!==v.FileSystemProviderErrorCode.FileNotFound)throw l;s.push(a.basename(o)),o=a.dirname(o)}for(let l=s.length-1;l>=0;l--){o=a.joinPath(o,s[l]);try{await i.mkdir(o)}catch(E){if((0,v.$nl)(E)!==v.FileSystemProviderErrorCode.FileExists)throw E}}}async canDelete(i,o){try{await this.W(i,o)}catch(s){return s}return!0}async W(i,o){const s=this.qb(await this.j(i),i),a=!!o?.useTrash;if(a&&!(s.capabilities&v.FileSystemProviderCapabilities.Trash))throw new Error((0,d.localize)(11245,null,this.sb(i)));const l=o?.atomic;if(l&&!(s.capabilities&v.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,d.localize)(11246,null,this.sb(i)));if(a&&l)throw new Error((0,d.localize)(11247,null,this.sb(i)));let E;try{E=await s.stat(i)}catch{}if(E)this.rb(i,E);else throw new v.$sl((0,d.localize)(11248,null,this.sb(i)),v.FileOperationResult.FILE_NOT_FOUND);if(!!!o?.recursive){const D=await this.resolve(i);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,d.localize)(11249,null,this.sb(i)))}return s}async del(i,o){const s=await this.W(i,o);let a=o;if((0,v.$hl)(s)&&!a?.atomic){const D=s.enforceAtomicDelete?.(i);D&&(a={...o,atomic:D})}const l=!!a?.useTrash,E=!!a?.recursive,y=a?.atomic??!1;await s.delete(i,{recursive:E,useTrash:l,atomic:y}),this.r.fire(new v.$pl(i,v.FileOperation.DELETE))}async cloneFile(i,o){const s=await this.j(i),a=this.qb(await this.n(o),o);if(!(s===a&&this.R(s).providerExtUri.isEqual(i,o)))return s===a&&(0,v.$cl)(s)?s.cloneFile(i,o):(await this.U(a,this.R(a).providerExtUri.dirname(o)),s===a&&(0,v.$bl)(s)?this.cb.queueFor(i,()=>s.copy(i,o,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(i,()=>this.O(s,i,a,o),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(i,o){return this.watch(i,{...o,correlationId:S.ab++})}watch(i,o={recursive:!1,excludes:[]}){const s=new c.$Sc;let a=!1,l=()=>{a=!0};s.add((0,c.$Rc)(()=>l())),(async()=>{try{const y=await this.bb(i,o);a?(0,c.$Oc)(y):l=()=>(0,c.$Oc)(y)}catch(y){this.b.error(y)}})();const E=o.correlationId;if(typeof E=="number"){const y=s.add(new T.$je);return s.add(this.X.event(L=>{L.correlates(E)&&y.fire(L)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async bb(i,o){const s=await this.j(i),a=(0,I.$qj)([this.R(s).providerExtUri.getComparisonKey(i),o]);let l=this.$.get(a);return l||(l={count:0,disposable:s.watch(i,o)},this.$.set(a,l)),l.count+=1,(0,c.$Rc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Oc)(l.disposable),this.$.delete(a)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,c.$Oc)(i.disposable);this.$.clear()}async db(i,o,s,a){return this.cb.queueFor(o,async()=>{const l=await i.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,f.$xe)(a)||(0,f.$ye)(a)?await this.eb(i,l,a):await this.fb(i,l,a)}catch(E){throw(0,v.$ll)(E)}finally{await i.close(l)}},this.R(i).providerExtUri)}async eb(i,o,s){let a=0,l;if((0,f.$ye)(s)){if(s.buffer.length>0){const E=P.$Le.concat(s.buffer);await this.gb(i,o,E,E.byteLength,a,0),a+=E.byteLength}if(s.ended)return;l=s.stream}else l=s;return new Promise((E,y)=>{(0,f.$De)(l,{onData:async D=>{l.pause();try{await this.gb(i,o,D,D.byteLength,a,0)}catch(L){return y(L)}a+=D.byteLength,setTimeout(()=>l.resume())},onError:D=>y(D),onEnd:()=>E()})})}async fb(i,o,s){let a=0,l;for(;(l=s.read())!==null;)await this.gb(i,o,l,l.byteLength,a,0),a+=l.byteLength}async gb(i,o,s,a,l,E){let y=0;for(;y<a;){const D=await i.write(o,l+y,s.buffer,E+y,a-y);y+=D}}async hb(i,o,s,a){return this.cb.queueFor(o,()=>this.ib(i,o,s,a),this.R(i).providerExtUri)}async ib(i,o,s,a){let l;a instanceof P.$Le?l=a:(0,f.$xe)(a)?l=await(0,P.$Xe)(a):(0,f.$ye)(a)?l=await(0,P.$Ye)(a):l=(0,P.$Ve)(a),await i.writeFile(o,l.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,o,s,a){return this.cb.queueFor(a,()=>this.kb(i,o,s,a),this.R(s).providerExtUri)}async kb(i,o,s,a){let l,E;try{l=await i.open(o,{create:!1}),E=await s.open(a,{create:!0,unlock:!1});const y=P.$Le.alloc(this.a);let D=0,L=0,A=0;do A=await i.read(l,D,y.buffer,L,y.byteLength-L),await this.gb(s,E,y,A,D,L),D+=A,L+=A,L===y.byteLength&&(L=0);while(A>0)}catch(y){throw(0,v.$ll)(y)}finally{await r.Promises.settled([typeof l=="number"?i.close(l):Promise.resolve(),typeof E=="number"?s.close(E):Promise.resolve()])}}async lb(i,o,s,a){return this.cb.queueFor(a,()=>this.mb(i,o,s,a),this.R(s).providerExtUri)}async mb(i,o,s,a){return s.writeFile(a,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,s,a){return this.cb.queueFor(a,()=>this.ob(i,o,s,a),this.R(s).providerExtUri)}async ob(i,o,s,a){const l=await s.open(a,{create:!0,unlock:!1});try{const E=await i.readFile(o);await this.gb(s,l,P.$Le.wrap(E),E.byteLength,0,0)}catch(E){throw(0,v.$ll)(E)}finally{await s.close(l)}}async pb(i,o,s,a){const l=await(0,P.$Xe)(this.H(i,o,R.CancellationToken.None));await this.hb(s,a,void 0,l)}qb(i,o){if(i.capabilities&v.FileSystemProviderCapabilities.Readonly)throw new v.$sl((0,d.localize)(11250,null,this.sb(o)),v.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,o){if((o.permissions??0)&v.FilePermission.Readonly)throw new v.$sl((0,d.localize)(11251,null,this.sb(i)),v.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===h.Schemas.file?i.fsPath:i.toString(!0)}};e.$Zq=t,e.$Zq=t=S=Ee([re(0,$.$0j)],t)}),define(le[99],ue([0,1,26,8,31,16,4,32,2,9,3,18,67,23,10,14,124,187,183,182]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class S extends p.$_q{static{this.L=!1}constructor(u,i){super(u,i),this.onDidChangeCapabilities=T.Event.None,this.P=new P.$zc(o=>h.$7g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,g.$l&&(this.M|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:i,symbolicLink:o}=await b.SymlinkSupport.stat(this.I(u));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const i=await b.Promises.readdir(this.I(u),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async s=>{try{let a;s.isSymbolicLink()?a=(await this.stat((0,h.$dh)(u,s.name))).type:a=this.O(s),o.push([s.name,a])}catch(a){this.a.trace(a)}})),o}catch(i){throw this.hb(i)}}O(u,i){let o;return i?.dangling?o=d.FileType.Unknown:u.isFile()?o=d.FileType.File:u.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,i&&(o|=d.FileType.SymbolicLink),o}async Q(u){const i=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const s=new r.$Bh;return this.P.set(u,s),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(u)===s&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),s.open()})}async readFile(u,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),o=await this.Q(u));const s=this.I(u);return await n.promises.readFile(s)}catch(s){throw this.hb(s)}finally{o?.dispose()}}R(u){S.L&&this.a.trace(u)}readFileStream(u,i,o){const s=(0,m.$ze)(a=>R.$Le.concat(a.map(l=>R.$Le.wrap(l))).buffer);return(0,v.$Yq)(this,u,s,a=>a.buffer,{...i,bufferSize:256*1024},o),s}async writeFile(u,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(u)?this.U(u,(0,h.$dh)((0,h.$ch)(u),`${(0,h.$ah)(u)}${o.atomic.postfix}`),i,o):this.W(u,i,o)}async S(u){try{const i=this.I(u),{symbolicLink:o}=await b.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(u,i,o,s){const a=new w.$Sc;try{a.add(await this.Q(u)),a.add(await this.Q(i)),await this.W(i,o,s,!0);try{await this.rename(i,u,{overwrite:!0})}catch(l){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}finally{a.dispose()}}async W(u,i,o,s){let a;try{const l=this.I(u);if(!o.create||!o.overwrite){if(await b.Promises.exists(l)){if(!o.overwrite)throw(0,d.$kl)((0,f.localize)(11209,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.$kl)((0,f.localize)(11210,null),d.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(u,{create:!0,unlock:o.unlock},s),await this.write(a,0,i,0,i.byteLength)}catch(l){throw await this.ib(u,l)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(u){S.$=u}async open(u,i,o){const s=this.I(u);let a;(0,d.$$k)(i)&&!o&&(a=await this.Q(u));let l;try{if((0,d.$$k)(i)&&i.unlock)try{const{stat:y}=await b.SymlinkSupport.stat(s);y.mode&128||await n.promises.chmod(s,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let E;if((0,d.$$k)(i)){if(g.$j)try{await n.promises.truncate(s,0),E="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}E||(E="w")}else E="r";l=await b.Promises.open(s,E)}catch(E){throw a?.dispose(),(0,d.$$k)(i)?await this.ib(u,E):this.hb(E)}if(this.X.set(l,0),(0,d.$$k)(i)&&this.Z.set(l,u),a){const E=this.Y.get(l);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.Y.set(l,a),E&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),E.dispose())}return l}async close(u){const i=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&S.$)try{await b.Promises.fdatasync(u)}catch(o){S.configureFlushOnWrite(!1),this.a.error(o)}return await b.Promises.close(u)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(u)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),i.dispose())}}async read(u,i,o,s,a){const l=this.ab(u,i);let E=null;try{E=(await b.Promises.read(u,o,s,a,l)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(u,l,E)}return E}ab(u,i){return i===this.X.get(u)?null:i}bb(u,i,o){const s=this.X.get(u);typeof s=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(u,s+o):this.X.delete(u)))}async write(u,i,o,s,a){return(0,r.$Wh)(()=>this.cb(u,i,o,s,a),100,3)}async cb(u,i,o,s,a){const l=this.ab(u,i);let E=null;try{E=(await b.Promises.write(u,o,s,a,l)).bytesWritten}catch(y){throw await this.ib(this.Z.get(u),y)}finally{this.bb(u,l,E)}return E}async mkdir(u){try{await n.promises.mkdir(this.I(u))}catch(i){throw this.hb(i)}}async delete(u,i){try{const o=this.I(u);if(i.recursive){let s;i?.atomic!==!1&&i.atomic.postfix&&(s=(0,c.$ic)((0,c.$lc)(o),`${(0,c.$mc)(o)}${i.atomic.postfix}`)),await b.Promises.rm(o,b.RimRafMode.MOVE,s)}else try{await n.promises.unlink(o)}catch(s){if(s.code==="EPERM"||s.code==="EISDIR"){let a=!1;try{const{stat:l,symbolicLink:E}=await b.SymlinkSupport.stat(o);a=l.isDirectory()&&!E}catch{}if(a)await n.promises.rmdir(o);else throw s}else throw s}}catch(o){throw this.hb(o)}}async rename(u,i,o){const s=this.I(u),a=this.I(i);if(s!==a)try{await this.db(u,i,"move",o.overwrite),await b.Promises.rename(s,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11211,null,(0,c.$mc)(s),(0,c.$mc)((0,c.$lc)(a)),l.toString()))),this.hb(l)}}async copy(u,i,o){const s=this.I(u),a=this.I(i);if(s!==a)try{await this.db(u,i,"copy",o.overwrite),await b.Promises.copy(s,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,f.localize)(11212,null,(0,c.$mc)(s),(0,c.$mc)((0,c.$lc)(a)),l.toString()))),this.hb(l)}}async db(u,i,o,s){const a=this.I(u),l=this.I(i);let E=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(E=(0,I.$Ag)(a,l,!0)),E){if(o==="copy")throw(0,d.$kl)((0,f.localize)(11213,null),d.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const D=await this.N(u);if(!D)throw(0,d.$kl)((0,f.localize)(11214,null),d.FileSystemProviderErrorCode.FileNotFound);const L=await this.N(i);if(L){if(!s)throw(0,d.$kl)((0,f.localize)(11215,null),d.FileSystemProviderErrorCode.FileExists);D.type&d.FileType.File&&L.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,i){return this.eb(u,i,!1)}async eb(u,i,o){const s=this.I(u),a=this.I(i),l=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,I.$Ag)(s,a,!l))return;const E=new w.$Sc;try{E.add(await this.Q(u)),E.add(await this.Q(i)),o&&await n.promises.mkdir((0,c.$lc)(a),{recursive:!0}),await n.promises.copyFile(s,a)}catch(y){if(y.code==="ENOENT"&&!o)return this.eb(u,i,!0);throw this.hb(y)}finally{E.dispose()}}t(u,i,o){return new $.$gr(s=>u(s),s=>i(s),o)}F(u,i,o){return new k.$pr(s=>u(s),s=>i(s),o)}hb(u){if(u instanceof d.$jl)return u;let i=u,o;switch(u.code){case"ENOENT":o=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=d.FileSystemProviderErrorCode.Unknown;break;default:o=d.FileSystemProviderErrorCode.Unknown}return(0,d.$kl)(i,o)}async ib(u,i){let o=this.hb(i);if(u&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await b.SymlinkSupport.stat(this.I(u));s.mode&128||(o=(0,d.$kl)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.a.trace(s)}return o}}e.$qr=S}),define(le[189],ue([0,1,4,99,2,16,67,21]),function(J,e,n,r,P,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0;class w extends P.$Tc{constructor(h,m){super(),this.a=h,this.b=m,this.F=new Map,this.G=new Map}call(h,m,b){const f=this.c(h);switch(m){case"stat":return this.g(f,b[0]);case"readdir":return this.h(f,b[0]);case"open":return this.r(f,b[0],b[1]);case"close":return this.s(b[0]);case"read":return this.t(b[0],b[1],b[2]);case"readFile":return this.j(f,b[0],b[1]);case"write":return this.u(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.n(f,b[0],b[1],b[2]);case"rename":return this.z(f,b[0],b[1],b[2]);case"copy":return this.C(f,b[0],b[1],b[2]);case"cloneFile":return this.D(f,b[0],b[1]);case"mkdir":return this.w(f,b[0]);case"delete":return this.y(f,b[0],b[1]);case"watch":return this.I(f,b[0],b[1],b[2],b[3]);case"unwatch":return this.J(b[0],b[1])}throw new Error(`IPC Command ${m} not found`)}listen(h,m,b){const f=this.c(h);switch(m){case"fileChange":return this.H(f,b[0]);case"readFileStream":return this.m(f,b[0],b[1])}throw new Error(`Unknown event ${m}`)}g(h,m){const b=this.f(h,m,!0);return this.a.stat(b)}h(h,m){const b=this.f(h,m);return this.a.readdir(b)}async j(h,m,b){const f=this.f(h,m,!0),d=await this.a.readFile(f,b);return R.$Le.wrap(d)}m(h,m,b){const f=this.f(h,m,!0),d=new I.$ue,v=new n.$je({onDidRemoveLastListener:()=>{d.cancel()}}),p=this.a.readFileStream(f,b,d.token);return(0,T.$De)(p,{onData:$=>v.fire(R.$Le.wrap($)),onError:$=>v.fire($),onEnd:()=>{v.fire("end"),v.dispose(),d.dispose()}}),v.event}n(h,m,b,f){const d=this.f(h,m);return this.a.writeFile(d,b.buffer,f)}r(h,m,b){const f=this.f(h,m,!0);return this.a.open(f,b)}s(h){return this.a.close(h)}async t(h,m,b){const f=R.$Le.alloc(b),v=await this.a.read(h,m,f.buffer,0,b);return[f,v]}u(h,m,b,f,d){return this.a.write(h,m,b.buffer,f,d)}w(h,m){const b=this.f(h,m);return this.a.mkdir(b)}y(h,m,b){const f=this.f(h,m);return this.a.delete(f,b)}z(h,m,b,f){const d=this.f(h,m),v=this.f(h,b);return this.a.rename(d,v,f)}C(h,m,b,f){const d=this.f(h,m),v=this.f(h,b);return this.a.copy(d,v,f)}D(h,m,b){const f=this.f(h,m),d=this.f(h,b);return this.a.cloneFile(f,d)}H(h,m){const b=new n.$je({onWillAddFirstListener:()=>{this.F.set(m,this.L(h,b))},onDidRemoveLastListener:()=>{(0,P.$Oc)(this.F.get(m)),this.F.delete(m)}});return b.event}async I(h,m,b,f,d){const v=this.F.get(m);if(v){const p=this.f(h,f),$=v.watch(b,p,d);this.G.set(m+b,$)}}async J(h,m){const b=h+m,f=this.G.get(b);f&&((0,P.$Oc)(f),this.G.delete(b))}dispose(){super.dispose();for(const[,h]of this.G)h.dispose();this.G.clear();for(const[,h]of this.F)h.dispose();this.F.clear()}}e.$1s=w;class c extends P.$Tc{constructor(h,m,b,f){super(),this.c=h,this.f=b,this.g=f,this.a=new Map,this.b=this.B(new r.$qr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(m)}h(h){const m=this.B(new n.$je);this.B(m.event(b=>{h.fire(b.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(b=>m.fire(b))),this.B(this.b.onDidWatchError(b=>h.fire(b)))}j(h){}m(h){}watch(h,m,b){const f=this.m(this.g);return Array.isArray(f)&&(b.excludes=[...b.excludes,...f]),this.a.set(h,this.b.watch(m,b)),(0,P.$Rc)(()=>{(0,P.$Oc)(this.a.get(h)),this.a.delete(h)})}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),super.dispose()}}e.$2s=c}),define(le[190],ue([0,1,13,10,3,7,14,9,189,150,54]),function(J,e,n,r,P,R,T,I,w,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;class h extends w.$1s{constructor(f,d,v){super(f,d),this.M=v}c(f){return c.$Kn}f(f,d){return R.URI.revive(d)}async y(f,d,v){if(!v.useTrash)return super.y(f,d,v);const p=this.f(f,d),$=(0,I.$gc)(p.fsPath);try{await n.shell.trashItem($)}catch(k){throw(0,T.$kl)(P.$j?(0,r.localize)(11216,null,(0,I.$mc)($),(0,g.$nj)(k)):(0,r.localize)(11217,null,(0,I.$mc)($),(0,g.$nj)(k)),T.FileSystemProviderErrorCode.Unknown)}}L(f,d){return new m(f,d,this.b,this.M)}}e.$Gfc=h;class m extends w.$2s{watch(f,d,v){if(v.recursive)throw(0,T.$kl)("Recursive file watching is not supported from main process for performance reasons.",T.FileSystemProviderErrorCode.Unavailable);return super.watch(f,d,v)}}}),define(le[191],ue([0,1,5]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class r extends n.$dk{constructor(R=n.$ak){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(T=>{this.n?.setLevel(T)}))}set logger(R){this.n=R;for(const{level:T,message:I}of this.m)(0,n.log)(R,T,I);this.m=[]}g(R,T){this.n?(0,n.log)(this.n,R,T):this.getLevel()<=R&&this.m.push({level:R,message:T})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$mcc=r}),define(le[192],ue([0,1,7,4,5,2]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=void 0;class T extends P.$ik{constructor(h,m,b,f,d){super(m,b,f),this.r=h,this.t=d,this.B(d.listen("onDidChangeLogLevel",h)(v=>{(0,P.$_j)(v)?super.setLogLevel(v):super.setLogLevel(n.URI.revive(v[0]),v[1])})),this.B(d.listen("onDidChangeVisibility",h)(([v,p])=>super.setVisibility(n.URI.revive(v),p))),this.B(d.listen("onDidChangeLoggers",h)(({added:v,removed:p})=>{for(const $ of v)super.registerLogger({...$,resource:n.URI.revive($.resource)});for(const $ of p)super.deregisterLogger($.resource)}))}createConsoleMainLogger(){return new P.$gk({log:(h,m)=>{this.t.call("consoleLog",[h,m])}})}registerLogger(h){super.registerLogger(h),this.t.call("registerLogger",[h,this.r])}deregisterLogger(h){super.deregisterLogger(h),this.t.call("deregisterLogger",[h,this.r])}setLogLevel(h,m){super.setLogLevel(h,m),this.t.call("setLogLevel",[h,m])}setVisibility(h,m){super.setVisibility(h,m),this.t.call("setVisibility",[this.n(h),m])}s(h,m,b){return new I(this.t,h,m,b,this.r)}static setLogLevel(h,m,b){return h.call("setLogLevel",[m,b])}}e.$qs=T;class I extends P.$dk{constructor(h,m,b,f,d){super(f?.logLevel==="always"),this.r=h,this.s=m,this.m=!1,this.n=[],this.setLevel(b),this.r.call("createLogger",[m,f,d]).then(()=>{this.u(this.n),this.m=!0})}g(h,m){const b=[[h,m]];this.m?this.u(b):this.n.push(...b)}u(h){this.r.call("log",[this.s,h])}}class w{constructor(h,m){this.a=h,this.b=m}listen(h,m){const b=this.b(h);switch(m){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(d=>this.c(d,b)),removed:[...f.removed].map(d=>this.c(d,b))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,f=>[b.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,f=>(0,P.$_j)(f)?f:[b.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${m}`)}async call(h,m,b){const f=this.b(h);switch(m){case"setLogLevel":return(0,P.$_j)(b[0])?this.a.setLogLevel(b[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(b[0][0])),b[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(d=>this.c(d,f)))}throw new Error(`Call not found: ${m}`)}c(h,m){return{...h,resource:m.transformOutgoingURI(h.resource)}}}e.$rs=w;class c extends R.$Tc{constructor(h,m){super(),m.call("setLogLevel",[h.getLogLevel()]),this.B(h.onDidChangeLogLevel(b=>m.call("setLogLevel",[b]))),m.call("getRegisteredLoggers").then(b=>{for(const f of b)h.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(m.listen("onDidChangeVisibility")(([b,f])=>h.setVisibility(n.URI.revive(b),f))),this.B(m.listen("onDidChangeLoggers")(({added:b,removed:f})=>{for(const d of b)h.registerLogger({...d,resource:n.URI.revive(d.resource)});for(const d of f)h.deregisterLogger(d.resource)}))}}e.$ss=c}),define(le[193],ue([0,1,2,5]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=void 0;class P extends n.$Tc{constructor(T,I=[]){super(),this.a=new r.$hk([T,...I]),this.B(T.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...I){this.a.trace(T,...I)}debug(T,...I){this.a.debug(T,...I)}info(T,...I){this.a.info(T,...I)}warn(T,...I){this.a.warn(T,...I)}error(T,...I){this.a.error(T,...I)}flush(){this.a.flush()}}e.$qR=P}),define(le[194],ue([0,1,31,7,5]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class R{constructor(I){this.b=I,this.a=new n.$zc}listen(I,w,c){switch(w){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${w}`)}async call(I,w,c){switch(w){case"createLogger":this.c(r.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(r.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,P.$_j)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(r.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(r.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:r.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(r.URI.revive(c[0]))}throw new Error(`Call not found: ${w}`)}c(I,w,c){this.a.set(I,this.b.createLogger(I,w,c))}d(I,w){let c=console.log;switch(I){case P.LogLevel.Error:c=console.error;break;case P.LogLevel.Warning:c=console.warn;break;case P.LogLevel.Info:c=console.info;break}c.call(console,...w)}e(I,w){const c=this.a.get(I);if(!c)throw new Error("Create the logger before logging");for(const[g,h]of w)(0,P.log)(c,g,h)}}e.$Egc=R}),define(le[195],ue([0,1,14,5]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fR=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function R(c,g,h,m,b){try{const f=await new Promise((v,p)=>{J(["@vscode/spdlog"],v,p)}).then(Ie);f.setFlushOn(P.Trace);const d=await f.createAsyncRotatingLogger(c,g,h,m);return b?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(f){console.error(f)}return null}function T(c,g,h){switch(g){case r.LogLevel.Trace:c.trace(h);break;case r.LogLevel.Debug:c.debug(h);break;case r.LogLevel.Info:c.info(h);break;case r.LogLevel.Warning:c.warn(h);break;case r.LogLevel.Error:c.error(h);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function I(c,g){switch(g){case r.LogLevel.Trace:c.setLevel(P.Trace);break;case r.LogLevel.Debug:c.setLevel(P.Debug);break;case r.LogLevel.Info:c.setLevel(P.Info);break;case r.LogLevel.Warning:c.setLevel(P.Warning);break;case r.LogLevel.Error:c.setLevel(P.Error);break;case r.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class w extends r.$dk{constructor(g,h,m,b,f){super(),this.m=[],this.setLevel(f),this.n=this.s(g,h,m,b),this.B(this.onDidChangeLogLevel(d=>{this.r&&I(this.r,d)}))}async s(g,h,m,b){const f=m?6:1,d=30/f*n.$Fl.MB,v=await R(g,h,d,f,b);if(v){this.r=v,I(this.r,this.getLevel());for(const{level:p,message:$}of this.m)T(this.r,p,$);this.m=[]}}g(g,h){this.r?T(this.r,g,h):this.getLevel()<=g&&this.m.push({level:g,message:h})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$fR=w}),define(le[196],ue([0,1,33,5,195]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gR=void 0;class R extends r.$ik{s(I,w,c){return new P.$fR((0,n.$Yg)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,w)}}e.$gR=R}),define(le[71],ue([0,1,31,4,6,5,196]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0,e.$afc=(0,P.$Di)(R.$$j);class I extends T.$gR{constructor(){super(...arguments),this.u=new n.$zc}createLogger(c,g,h){h!==void 0&&this.u.set(this.n(c),h);try{return super.createLogger(c,g)}catch(m){throw this.u.delete(this.n(c)),m}}registerLogger(c,g){g!==void 0&&this.u.set(c.resource,g),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const g=[];for(const h of super.getRegisteredLoggers())c===this.u.get(h.resource)&&g.push(h);return g}getOnDidChangeLogLevelEvent(c){return r.Event.filter(this.onDidChangeLogLevel,g=>(0,R.$_j)(g)||this.w(g[0],c))}getOnDidChangeVisibilityEvent(c){return r.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,c))}getOnDidChangeLoggersEvent(c){return r.Event.filter(r.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(m=>this.w(m.resource,c)),removed:[...g.removed].filter(m=>this.w(m.resource,c))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(c){for(const[g,h]of this.u)h===c&&this.deregisterLogger(g)}w(c,g){const h=this.u.get(c);return h===void 0||h===g}dispose(){super.dispose(),this.u.clear()}}e.$bfc=I}),define(le[197],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=n,e.$Vfc=r,e.$Wfc=P,e.$Xfc=R;function n(T){return T.submenu!==void 0}function r(T){return T.id==="vscode.menubar.separator"}function P(T){return T.uri!==void 0}function R(T){return!n(T)&&!r(T)&&!P(T)}}),define(le[40],ue([0,1,4,77,2,6]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,R.$Ci)("policy");class T extends P.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const g=Object.keys(this.f).length;return this.f={...c,...this.f},g!==Object.keys(this.f).length&&await this.j(c),r.Iterable.reduce(this.g.entries(),(h,[m,b])=>({...h,[m]:b}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(c,[g,h])=>({...c,[g]:{definition:h,value:this.g.get(g)}}),{})}}e.$ro=T;class I{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=I}),define(le[198],ue([0,1,8,4,77,12,14,5,40]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;function c(h,m){const b=[];for(const f of new Set(P.Iterable.concat(h.keys(),m.keys())))h.get(f)!==m.get(f)&&b.push(f);return b}let g=class extends w.$ro{constructor(m,b,f){super(),this.m=m,this.n=b,this.s=f,this.c=this.B(new n.$Ah(500));const d=r.Event.filter(b.onDidFilesChange,v=>v.affects(m));this.B(b.watch(m)),this.B(d(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const b=await this.n.readFile(this.m),f=JSON.parse(b.value.toString());if(!(0,R.$eg)(f))throw new Error("Policy file isn't a JSON object");for(const d of Object.keys(f))this.f[d]&&m.set(d,f[d])}catch(b){b.fileOperationResult!==T.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",b)}return m}async w(){const m=await this.u(),b=c(this.g,m);this.g=m,b.length>0&&this.h.fire(b)}};e.$Xgc=g,e.$Xgc=g=Ee([re(1,T.$0k),re(2,I.$0j)],g)}),define(le[199],ue([0,1,4,2,40]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=e.$tgc=void 0;class R{constructor(w){this.b=w,this.a=new r.$Sc}listen(w,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,g=>g.reduce((h,m)=>({...h,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(w,c,g){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$tgc=R;class T extends P.$ro{constructor(w,c){super(),this.a=c;for(const g in w){const{definition:h,value:m}=w[g];this.f[g]=h,m!==void 0&&this.g.set(g,m)}this.a.listen("onDidChange")(g=>{for(const h in g){const m=g[h];m===null?this.g.delete(h):this.g.set(h,m)}this.h.fire(Object.keys(g))})}async j(w){const c=await this.a.call("updatePolicyDefinitions",w);for(const g in c)this.g.set(g,c[g])}}e.$ugc=T}),define(le[200],ue([0,1,40,8,2,5]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;let T=class extends n.$ro{constructor(w,c){super(),this.m=w,this.n=c,this.a=new r.$wh,this.b=this.B(new P.$Uc)}async j(w){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`);const{createWatcher:c}=await new Promise((g,h)=>{J(["@vscode/policy-watcher"],g,h)}).then(Ie);await this.a.queue(()=>new Promise((g,h)=>{try{this.b.value=c(this.n,w,m=>{this.t(m),g()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),h(m)}}))}t(w){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const c in w){const g=w[c];g===void 0?this.g.delete(c):this.g.set(c,g)}this.h.fire(Object.keys(w))}};e.$Wgc=T,e.$Wgc=T=Ee([re(0,R.$0j)],T)}),define(le[72],ue([0,1,36]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const R=P.context.configuration();if(R)r=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:R.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(le[28],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$qk=(0,n.$Ci)("productService"),e.$rk="vscode://schemas/vscode-product"}),define(le[201],ue([0,1,8,5]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;let P=class{constructor(T,I,w){this.a=T,this.b=I,this.c=w}async inspect(T){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Dh)(T);const w=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),w.profile}async d(){const T=this.a.webContents.debugger;T.attach(),await T.sendCommand("Profiler.enable")}async e(){const T=this.a.webContents.debugger;await T.sendCommand("Profiler.disable"),T.detach()}};e.$Jfc=P,e.$Jfc=P=Ee([re(2,r.$0j)],P)}),define(le[73],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0,e.$Vec=(0,n.$Ci)("protocolMainService")}),define(le[45],ue([0,1,141,12]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,n=Ie(n),r=Ie(r);class P{constructor(){this.a=new Map}add(T,I){n.ok(r.$cg(T)),n.ok(r.$eg(I)),n.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,I)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$oo=new P}),define(le[202],ue([0,1,4,45]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,r=Ie(r),e.$po={JSONContribution:"base.contributions.json"};function P(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class R{constructor(){this.b=new n.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,c){this.a[P(w)]=c,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const T=new R;r.$oo.add(e.$po.JSONContribution,T)}),define(le[55],ue([0,1,20,4,12,10,17,202,45]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=d,e.$Fo=v,e.$Go=p,e.$Ho=k,e.$Io=S,e.$Jo=t,e.$Ko=u,P=Ie(P),R=Ie(R);var c;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$to={Configuration:"base.contributions.configuration"};var g;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const h=w.$oo.as(I.$po.JSONContribution);class m{constructor(){this.a=[],this.i=new Set,this.j=new r.$je,this.onDidSchemaChange=this.j.event,this.k=new r.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:R.localize(11444,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},h.registerSchema(e.$Ao,this.h),this.z()}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const a=new Set;this.r(o,s,a),h.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:a})}deregisterConfigurations(o){const s=new Set;this.s(o,s),h.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:s})}updateConfigurations({add:o,remove:s}){const a=new Set;this.s(s,a),this.r(o,!1,a),h.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:a})}registerDefaultConfigurations(o){const s=new Set;this.l(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}l(o,s){this.a.push(...o);const a=[];for(const{overrides:l,source:E}of o)for(const y in l){s.add(y);const D=this.b.get(y)??this.b.set(y,{configurationDefaultOverrides:[]}).get(y),L=l[y];if(D.configurationDefaultOverrides.push({value:L,source:E}),e.$Do.test(y)){const A=this.o(y,L,E,D.configurationDefaultOverrideValue);if(!A)continue;D.configurationDefaultOverrideValue=A,this.n(y,A,E),a.push(...d(y))}else{const A=this.p(y,L,E,D.configurationDefaultOverrideValue);if(!A)continue;D.configurationDefaultOverrideValue=A;const O=this.e[y];O&&(this.A(y,O),this.w(y,O))}}this.q(a)}deregisterDefaultConfigurations(o){const s=new Set;this.m(o,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:!0})}m(o,s){for(const a of o){const l=this.a.indexOf(a);l!==-1&&this.a.splice(l,1)}for(const{overrides:a,source:l}of o)for(const E in a){const y=this.b.get(E);if(!y)continue;const D=y.configurationDefaultOverrides.findIndex(L=>l?L.source?.id===l.id:L.value===a[E]);if(D!==-1){if(y.configurationDefaultOverrides.splice(D,1),y.configurationDefaultOverrides.length===0&&this.b.delete(E),e.$Do.test(E)){let L;for(const A of y.configurationDefaultOverrides)L=this.o(E,A.value,A.source,L);L&&!P.$pg(L.value)?(y.configurationDefaultOverrideValue=L,this.n(E,L,l)):(this.b.delete(E),delete this.e[E],delete this.c.properties[E])}else{let L;for(const O of y.configurationDefaultOverrides)L=this.p(E,O.value,O.source,L);y.configurationDefaultOverrideValue=L;const A=this.e[E];A&&(this.A(E,A),this.w(E,A))}s.add(E)}}this.y()}n(o,s,a){const l={type:"object",default:s.value,description:R.localize(11445,null,(0,T.$gj)(o)),$ref:e.$Ao,defaultDefaultValue:s.value,source:a,defaultValueSource:a};this.e[o]=l,this.c.properties[o]=l}o(o,s,a,l){const E=l?.value||{},y=l?.source??new Map;if(!(y instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const D of Object.keys(s)){const L=s[D];if(P.$eg(L)&&(P.$jg(E[D])||P.$eg(E[D]))){if(E[D]={...E[D]??{},...L},a)for(const O in L)y.set(`${D}.${O}`,a)}else E[D]=L,a?y.set(D,a):y.delete(D)}return{value:E,source:y}}p(o,s,a,l){const E=this.e[o],y=l?.value??E?.defaultDefaultValue;let D=a;if(P.$eg(s)&&(E!==void 0&&E.type==="object"||E===void 0&&(P.$jg(y)||P.$eg(y)))){if(D=l?.source??new Map,!(D instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in s)a&&D.set(`${o}.${A}`,a);s={...P.$eg(y)?y:{},...s}}return{value:s,source:D}}deltaConfiguration(o){let s=!1;const a=new Set;o.removedDefaults&&(this.m(o.removedDefaults,a),s=!0),o.addedDefaults&&(this.l(o.addedDefaults,a),s=!0),o.removedConfigurations&&this.s(o.removedConfigurations,a),o.addedConfigurations&&this.r(o.addedConfigurations,!1,a),this.j.fire(),this.k.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...o){this.j.fire()}registerOverrideIdentifiers(o){this.q(o),this.j.fire()}q(o){for(const s of o)this.i.add(s);this.y()}r(o,s,a){o.forEach(l=>{this.u(l,s,l.extensionInfo,l.restrictedProperties,void 0,a),this.d.push(l),this.v(l)})}s(o,s){const a=l=>{if(l.properties)for(const E in l.properties){s.add(E);const y=this.e[E];y?.policy?.name&&this.f.delete(y.policy.name),delete this.e[E],this.x(E,l.properties[E])}l.allOf?.forEach(E=>a(E))};for(const l of o){a(l);const E=this.d.indexOf(l);E!==-1&&this.d.splice(E,1)}}u(o,s=!0,a,l,E=g.WINDOW,y){E=P.$lg(o.scope)?E:o.scope;const D=o.properties;if(D)for(const A in D){const O=D[A];if(s&&k(A,O)){delete D[A];continue}if(O.source=a,O.defaultDefaultValue=D[A].default,this.A(A,O),e.$Do.test(A)?O.scope=void 0:(O.scope=P.$lg(O.scope)?E:O.scope,O.restricted=P.$lg(O.restricted)?!!l?.includes(A):O.restricted),D[A].hasOwnProperty("included")&&!D[A].included){this.g[A]=D[A],delete D[A];continue}else this.e[A]=D[A],D[A].policy?.name&&this.f.set(D[A].policy.name,A);!D[A].deprecationMessage&&D[A].markdownDeprecationMessage&&(D[A].deprecationMessage=D[A].markdownDeprecationMessage),y.add(A)}const L=o.allOf;if(L)for(const A of L)this.u(A,s,a,l,E,y)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const o=new Map;for(const[s,a]of this.b)a.configurationDefaultOverrideValue&&o.set(s,a.configurationDefaultOverrideValue);return o}v(o){const s=a=>{const l=a.properties;if(l)for(const y in l)this.w(y,l[y]);a.allOf?.forEach(s)};s(o)}w(o,s){switch(e.$uo.properties[o]=s,s.scope){case g.APPLICATION:e.$vo.properties[o]=s;break;case g.MACHINE:e.$wo.properties[o]=s;break;case g.MACHINE_OVERRIDABLE:e.$xo.properties[o]=s;break;case g.WINDOW:e.$yo.properties[o]=s;break;case g.RESOURCE:e.$zo.properties[o]=s;break;case g.LANGUAGE_OVERRIDABLE:e.$zo.properties[o]=s,this.h.properties[o]=s;break}}x(o,s){switch(delete e.$uo.properties[o],s.scope){case g.APPLICATION:delete e.$vo.properties[o];break;case g.MACHINE:delete e.$wo.properties[o];break;case g.MACHINE_OVERRIDABLE:delete e.$xo.properties[o];break;case g.WINDOW:delete e.$yo.properties[o];break;case g.RESOURCE:case g.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[o],delete this.h.properties[o];break}}y(){for(const o of this.i.values()){const s=`[${o}]`,a={type:"object",description:R.localize(11446,null),errorMessage:R.localize(11447,null),$ref:e.$Ao};this.A(s,a),e.$uo.properties[s]=a,e.$vo.properties[s]=a,e.$wo.properties[s]=a,e.$xo.properties[s]=a,e.$yo.properties[s]=a,e.$zo.properties[s]=a}}z(){const o={type:"object",description:R.localize(11448,null),errorMessage:R.localize(11449,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=o,e.$vo.patternProperties[e.$Co]=o,e.$wo.patternProperties[e.$Co]=o,e.$xo.patternProperties[e.$Co]=o,e.$yo.patternProperties[e.$Co]=o,e.$zo.patternProperties[e.$Co]=o,this.j.fire()}A(o,s){const a=this.b.get(o)?.configurationDefaultOverrideValue;let l,E;a&&(!s.disallowConfigurationDefault||!a.source)&&(l=a.value,E=a.source),P.$jg(l)&&(l=s.defaultDefaultValue,E=void 0),P.$jg(l)&&(l=p(s.type)),s.default=l,s.defaultValueSource=E}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.$Co=`^(${b})+$`,e.$Do=new RegExp(e.$Co);function d(i){const o=[];if(e.$Do.test(i)){let s=f.exec(i);for(;s?.length;){const a=s[1].trim();a&&o.push(a),s=f.exec(i)}}return(0,n.$Lb)(o)}function v(i){return i.reduce((o,s)=>`${o}[${s}]`,"")}function p(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new m;w.$oo.add(e.$to.Configuration,$);function k(i,o){return i.trim()?e.$Do.test(i)?R.localize(11451,null,i):$.getConfigurationProperties()[i]!==void 0?R.localize(11452,null,i):o.policy?.name&&$.getPolicyConfigurations().get(o.policy?.name)!==void 0?R.localize(11453,null,i,o.policy?.name,$.getPolicyConfigurations().get(o.policy?.name)):null:R.localize(11450,null)}function S(){const i=[],o=$.getConfigurationProperties();for(const s of Object.keys(o))i.push([s,o[s].scope]);return i.push(["launch",g.RESOURCE]),i.push(["task",g.RESOURCE]),i}function t(i){const o={};for(const s of i){const a=s.properties;if(P.$eg(a))for(const l in a)o[l]=a[l];s.allOf&&Object.assign(o,t(s.allOf))}return o}function u(i){switch(i){case"application":return g.APPLICATION;case"machine":return g.MACHINE;case"resource":return g.RESOURCE;case"machine-overridable":return g.MACHINE_OVERRIDABLE;case"language-overridable":return g.LANGUAGE_OVERRIDABLE;default:return g.WINDOW}}}),define(le[125],ue([0,1,20,4,43,2,31,37,12,7,17,55,14,45]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=S,n=Ie(n),P=Ie(P),I=Ie(I),w=Ie(w);function f(o){return Object.isFrozen(o)?o:I.$co(o)}class d{static createEmptyModel(s){return new d({},[],[],void 0,s)}constructor(s,a,l,E,y){this.b=s,this.c=a,this.d=l,this.raw=E,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof d)return a;const l=new v("",this.f);return l.parseRaw(a),l.configurationModel});this.g=s.reduce((a,l)=>l===a?l:a.merge(l),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,g.$ej)(this.contents,s):this.contents}inspect(s,a){const l=this;return{get value(){return f(l.rawConfiguration.getValue(s))},get override(){return a?f(l.rawConfiguration.getOverrideValue(s,a)):void 0},get merged(){return f(a?l.rawConfiguration.override(a).getValue(s):l.rawConfiguration.getValue(s))},get overrides(){const E=[];for(const{contents:y,identifiers:D,keys:L}of l.rawConfiguration.overrides){const A=new d(y,L,[],void 0,l.f).getValue(s);A!==void 0&&E.push({identifiers:D,value:A})}return E.length?f(E):void 0}}}getOverrideValue(s,a){const l=this.j(a);return l?s?(0,g.$ej)(l,s):l:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const l of this.overrides)l.identifiers.includes(s)&&a.push(...l.keys);return n.$Lb(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return n.$Lb(s)}override(s){let a=this.a.get(s);return a||(a=this.h(s),this.a.set(s,a)),a}merge(...s){const a=I.$bo(this.contents),l=I.$bo(this.overrides),E=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const D of s)if(y.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(a,D.contents);for(const L of D.overrides){const[A]=l.filter(O=>n.$tb(O.identifiers,L.identifiers));A?(this.i(A.contents,L.contents),A.keys.push(...L.keys),A.keys=n.$Lb(A.keys)):l.push(I.$bo(L))}for(const L of D.keys)E.indexOf(L)===-1&&E.push(L)}return new d(a,E,l,y.every(D=>D instanceof d)?void 0:y,this.f)}h(s){const a=this.j(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const l={};for(const E of n.$Lb([...Object.keys(this.contents),...Object.keys(a)])){let y=this.contents[E];const D=a[E];D&&(typeof y=="object"&&typeof D=="object"?(y=I.$bo(y),this.i(y,D)):y=D),l[E]=y}return new d(l,this.keys,this.overrides,void 0,this.f)}i(s,a){for(const l of Object.keys(a)){if(l in s&&w.$eg(s[l])&&w.$eg(a[l])){this.i(s[l],a[l]);continue}s[l]=I.$bo(a[l])}}j(s){let a=null,l=null;const E=y=>{y&&(l?this.i(l,y):l=I.$bo(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===s?a=y.contents:y.identifiers.includes(s)&&E(y.contents);return E(a),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.k(s,a,!0)}setValue(s,a){this.k(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,g.$dj)(this.contents,s),h.$Do.test(s)&&this.overrides.splice(this.overrides.findIndex(l=>n.$tb(l.identifiers,(0,h.$Eo)(s))),1))}k(s,a,l){if((0,g.$cj)(this.contents,s,a,E=>this.f.error(E)),l=l||this.keys.indexOf(s)===-1,l&&this.keys.push(s),h.$Do.test(s)){const E=(0,h.$Eo)(s),y={identifiers:E,keys:Object.keys(this.contents[s]),contents:(0,g.$bj)(this.contents[s],L=>this.f.error(L))},D=this.overrides.findIndex(L=>n.$tb(L.identifiers,E));D!==-1?this.overrides[D]=y:this.overrides.push(y)}}}e.$Lo=d;class v{constructor(s,a){this.f=s,this.g=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!w.$lg(s)){const l=this.h(s);this.parseRaw(l,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:l,keys:E,overrides:y,restricted:D,hasExcludedProperties:L}=this.i(s,a);this.b=new d(l,E,y,L?[s]:void 0,this.g),this.c=D||[]}h(s){let a={},l=null,E=[];const y=[],D=[];function L(O){Array.isArray(E)?E.push(O):l!==null&&(E[l]=O)}const A={onObjectBegin:()=>{const O={};L(O),y.push(E),E=O,l=null},onObjectProperty:O=>{l=O},onObjectEnd:()=>{E=y.pop()},onArrayBegin:()=>{const O=[];L(O),y.push(E),E=O,l=null},onArrayEnd:()=>{E=y.pop()},onLiteralValue:L,onError:(O,W,x)=>{D.push({error:O,offset:W,length:x})}};if(s)try{P.$3n(s,A),a=E[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return a}i(s,a){const l=b.$oo.as(h.$to.Configuration).getConfigurationProperties(),E=this.j(s,l,!0,a);s=E.raw;const y=(0,g.$bj)(s,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),D=Object.keys(s),L=this.l(s,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:y,keys:D,overrides:L,restricted:E.restricted,hasExcludedProperties:E.hasExcludedProperties}}j(s,a,l,E){let y=!1;if(!E?.scopes&&!E?.skipRestricted&&!E?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:y};const D={},L=[];for(const A in s)if(h.$Do.test(A)&&l){const O=this.j(s[A],a,!1,E);D[A]=O.raw,y=y||O.hasExcludedProperties,L.push(...O.restricted)}else{const O=a[A],W=O?typeof O.scope<"u"?O.scope:h.ConfigurationScope.WINDOW:void 0;O?.restricted&&L.push(A),!E.exclude?.includes(A)&&(E.include?.includes(A)||(W===void 0||E.scopes===void 0||E.scopes.includes(W))&&!(E.skipRestricted&&O?.restricted))?D[A]=s[A]:y=!0}return{raw:D,restricted:L,hasExcludedProperties:y}}l(s,a){const l=[];for(const E of Object.keys(s))if(h.$Do.test(E)){const y={};for(const D in s[E])y[D]=s[E][D];l.push({identifiers:(0,h.$Eo)(E),keys:Object.keys(y),contents:(0,g.$bj)(y,a)})}return l}}e.$Mo=v;class p extends R.$Tc{constructor(s,a,l,E,y){super(),this.c=s,this.f=a,this.g=E,this.h=y,this.b=this.B(new r.$je),this.onDidChange=this.b.event,this.a=new v(this.c.toString(),y),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(m.FileOperation.CREATE)||D.isOperation(m.FileOperation.COPY)||D.isOperation(m.FileOperation.DELETE)||D.isOperation(m.FileOperation.WRITE))&&l.isEqual(D.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=p;class ${constructor(s,a,l,E,y,D,L,A,O,W,x,H,B){this.a=s,this.b=a,this.c=l,this.overrideIdentifiers=E,this.d=y,this.f=D,this.g=L,this.h=A,this.i=O,this.j=W,this.k=x,this.l=H,this.m=B}get value(){return f(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class k{constructor(s,a,l,E,y,D,L,A,O,W){this.j=s,this.l=a,this.m=l,this.n=E,this.p=y,this.q=D,this.r=L,this.s=A,this.t=O,this.u=W,this.h=null,this.i=new T.$zc,this.v=null}getValue(s,a,l){return this.w(s,a,l).getValue(s)}updateValue(s,a,l={}){let E;l.resource?(E=this.t.get(l.resource),E||(E=d.createEmptyModel(this.u),this.t.set(l.resource,E))):E=this.s,a===void 0?E.removeValue(s):E.setValue(s,a),l.resource||(this.h=null)}inspect(s,a,l){const E=this.w(s,a,l),y=this.A(a.resource,l),D=a.resource?this.t.get(a.resource)||this.s:this.s,L=new Set;for(const A of E.overrides)for(const O of A.identifiers)E.getOverrideValue(s,O)!==void 0&&L.add(O);return new $(s,a,E.getValue(s),L.size?[...L]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.q:void 0,y||void 0,D)}keys(s){const a=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,a){this.r.set(s,a),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const l=[];if(!a){const{added:E,updated:y,removed:D}=u(this.j,s);a=[...E,...y,...D]}for(const E of a)for(const y of(0,h.$Eo)(E)){const D=this.j.getKeysForOverrideIdentifier(y),L=s.getKeysForOverrideIdentifier(y),A=[...L.filter(O=>D.indexOf(O)===-1),...D.filter(O=>L.indexOf(O)===-1),...D.filter(O=>!I.$fo(this.j.override(y).getValue(O),s.override(y).getValue(O)))];l.push([y,A])}return this.updateDefaultConfiguration(s),{keys:a,overrides:l}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:l,removed:E}=u(this.l,s),y=[...a,...l,...E];return y.length&&this.updatePolicyConfiguration(s),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:l,removed:E,overrides:y}=u(this.applicationConfiguration,s),D=[...a,...l,...E];return D.length&&this.updateApplicationConfiguration(s),{keys:D,overrides:y}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:l,removed:E,overrides:y}=u(this.localUserConfiguration,s),D=[...a,...l,...E];return D.length&&this.updateLocalUserConfiguration(s),{keys:D,overrides:y}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:l,removed:E,overrides:y}=u(this.remoteUserConfiguration,s),D=[...a,...l,...E];return D.length&&this.updateRemoteUserConfiguration(s),{keys:D,overrides:y}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:l,removed:E,overrides:y}=u(this.workspaceConfiguration,s),D=[...a,...l,...E];return D.length&&this.updateWorkspaceConfiguration(s),{keys:D,overrides:y}}compareAndUpdateFolderConfiguration(s,a){const l=this.folderConfigurations.get(s),{added:E,updated:y,removed:D,overrides:L}=u(l,a),A=[...E,...y,...D];return(A.length||!l)&&this.updateFolderConfiguration(s,a),{keys:A,overrides:L}}compareAndDeleteFolderConfiguration(s){const a=this.folderConfigurations.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:l,updated:E,removed:y,overrides:D}=u(a,void 0);return{keys:[...l,...E,...y],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,a,l){let E=this.x(a,l);return a.overrideIdentifier&&(E=E.override(a.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(E=E.merge(this.l)),E}x({resource:s},a){let l=this.y();if(a&&s){const E=a.getFolder(s);E&&(l=this.z(E.uri)||l);const y=this.t.get(s);y&&(l=l.merge(y))}return l}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let a=this.i.get(s);if(!a){const l=this.y(),E=this.r.get(s);E?(a=l.merge(E),this.i.set(s,a)):a=l}return a}A(s,a){if(a&&s){const l=a.getFolder(s);if(l)return this.r.get(l.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,a)=>{const{contents:l,overrides:E,keys:y}=this.r.get(a);return s.push([a,{contents:l,overrides:E,keys:y}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.q.keys.forEach(a=>s.add(a)),this.r.forEach(a=>a.keys.forEach(l=>s.add(l))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.q.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.r.forEach(a=>a.getAllOverrideIdentifiers().forEach(l=>s.add(l))),[...s.values()]}D(s){const a=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.q.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l)),this.r.forEach(l=>l.getKeysForOverrideIdentifier(s).forEach(E=>a.add(E))),[...a.values()]}static parse(s,a){const l=this.E(s.defaults,a),E=this.E(s.policy,a),y=this.E(s.application,a),D=this.E(s.user,a),L=this.E(s.workspace,a),A=s.folders.reduce((O,W)=>(O.set(c.URI.revive(W[0]),this.E(W[1],a)),O),new T.$zc);return new k(l,E,y,D,d.createEmptyModel(a),L,A,d.createEmptyModel(a),new T.$zc,a)}static E(s,a){return new d(s.contents,s.keys,s.overrides,void 0,a)}}e.$Oo=k;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,a=new Map;for(const E of o)E.keys.forEach(y=>s.add(y)),E.overrides.forEach(([y,D])=>{const L=(0,T.$wc)(a,y,new Set);D.forEach(A=>L.add(A))});const l=[];return a.forEach((E,y)=>l.push([y,[...E.values()]])),{keys:[...s.values()],overrides:l}}class t{constructor(s,a,l,E,y){this.change=s,this.f=a,this.g=l,this.h=E,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of s.keys)this.affectedKeys.add(D);for(const[,D]of s.overrides)for(const L of D)this.affectedKeys.add(L);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=k.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,a){const l=this.a+s,E=this.d.indexOf(l);if(E<0)return!1;const y=E+l.length;if(y>=this.d.length)return!1;const D=this.d.charCodeAt(y);if(D!==this.b&&D!==this.c)return!1;if(a){const L=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,A=this.g.getValue(s,a,this.h);return!I.$fo(L,A)}return!0}}e.$Qo=t;function u(o,s){const{added:a,removed:l,updated:E}=i(s?.rawConfiguration,o?.rawConfiguration),y=[],D=o?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const A=L.filter(O=>!D.includes(O));for(const O of A)y.push([O,s.getKeysForOverrideIdentifier(O)])}if(o){const A=D.filter(O=>!L.includes(O));for(const O of A)y.push([O,o.getKeysForOverrideIdentifier(O)])}if(s&&o){for(const A of D)if(L.includes(A)){const O=i({contents:o.getOverrideValue(void 0,A)||{},keys:o.getKeysForOverrideIdentifier(A)},{contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)});y.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:a,removed:l,updated:E,overrides:y}}function i(o,s){const a=o?s?o.keys.filter(y=>s.keys.indexOf(y)===-1):[...o.keys]:[],l=s?o?s.keys.filter(y=>o.keys.indexOf(y)===-1):[...s.keys]:[],E=[];if(o&&s){for(const y of s.keys)if(o.keys.indexOf(y)!==-1){const D=(0,g.$ej)(s.contents,y),L=(0,g.$ej)(o.contents,y);I.$fo(D,L)||E.push(y)}}return{added:a,removed:l,updated:E}}}),define(le[203],ue([0,1,20,4,2,37,12,125,55,5,40,45]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=void 0;class m extends P.$Tc{get configurationModel(){return this.b}constructor(v){super(),this.c=v,this.a=this.B(new r.$je),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(h.$oo.as(w.$to.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:p})=>this.f(Array.from(v),p))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(v,p){this.j(v,h.$oo.as(w.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:v})}g(){return{}}h(){this.b=I.$Lo.createEmptyModel(this.c);const v=h.$oo.as(w.$to.Configuration).getConfigurationProperties();this.j(Object.keys(v),v)}j(v,p){const $=this.g();for(const k of v){const S=$[k],t=p[k];S!==void 0?this.b.setValue(k,S):t?this.b.setValue(k,t.default):this.b.removeValue(k)}}}e.$Ro=m;class b{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=I.$Lo.createEmptyModel(new c.$kk)}async initialize(){return this.configurationModel}}e.$So=b;let f=class extends P.$Tc{get configurationModel(){return this.b}constructor(v,p,$){super(),this.c=v,this.f=p,this.g=$,this.a=this.B(new r.$je),this.onDidChangeConfiguration=this.a.event,this.b=I.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(v=>this.j(v))),this.B(this.c.onDidChangeConfiguration(async({properties:v})=>this.m(await this.h(v),!0))),this.b}async h(v){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",v);const p={},$=[],k=h.$oo.as(w.$to.Configuration).getConfigurationProperties();for(const S of v){const t=k[S];if(!t){$.push(S);continue}if(t.policy){if(t.type!=="string"&&t.type!=="number"){this.g.warn(`Policy ${t.policy.name} has unsupported type ${t.type}`);continue}$.push(S),p[t.policy.name]={type:t.type}}}return(0,T.$pg)(p)||await this.f.updatePolicyDefinitions(p),$}j(v){this.g.trace("PolicyConfiguration#onDidChangePolicies",v);const p=h.$oo.as(w.$to.Configuration).getPolicyConfigurations(),$=(0,n.$Gb)(v.map(k=>p.get(k)));this.m($,!0)}m(v,p){this.g.trace("PolicyConfiguration#update",v);const $=h.$oo.as(w.$to.Configuration).getConfigurationProperties(),k=[],S=this.b.isEmpty();for(const t of v){const u=$[t]?.policy?.name;if(u){const i=this.f.getPolicyValue(u);(S?i!==void 0:!(0,R.$fo)(this.b.getValue(t),i))&&k.push([t,i])}else this.b.getValue(t)!==void 0&&k.push([t,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const t=this.b;this.b=I.$Lo.createEmptyModel(this.g);for(const u of t.keys)this.b.setValue(u,t.getValue(u));for(const[u,i]of k)i===void 0?this.b.removeValue(u):this.b.setValue(u,i);p&&this.a.fire(this.b)}}};e.$To=f,e.$To=f=Ee([re(1,g.$qo),re(2,c.$0j)],f)}),define(le[204],ue([0,1,20,8,16,4,43,107,2,31,37,3,18,17,125,55,203,14,40]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;class k extends w.$Tc{constructor(u,i,o,s){super(),this.m=u,this.n=s,this.h=this.B(new R.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$Ro(s)),this.c=o instanceof $.$so?new v.$So:this.B(new v.$To(this.b,o,s)),this.f=this.B(new f.$No(this.m,{},m.$7g,i,s)),this.a=new f.$Oo(this.b.configurationModel,this.c.configurationModel,f.$Lo.createEmptyModel(s),f.$Lo.createEmptyModel(s),f.$Lo.createEmptyModel(s),f.$Lo.createEmptyModel(s),new c.$zc,f.$Lo.createEmptyModel(s),new c.$zc,s),this.j=new S(u,i,this),this.g=this.B(new r.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:l})=>this.s(a,l))),this.B(this.c.onDidChangeConfiguration(a=>this.t(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,i,o]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Oo(u,i,f.$Lo.createEmptyModel(this.n),o,f.$Lo.createEmptyModel(this.n),f.$Lo.createEmptyModel(this.n),new c.$zc,f.$Lo.createEmptyModel(this.n),new c.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(u,i){const o=typeof u=="string"?u:void 0,s=(0,b.$0i)(u)?u:(0,b.$0i)(i)?i:{};return this.a.getValue(o,s,void 0)}async updateValue(u,i,o,s,a){const l=(0,b.$$i)(o)?o:(0,b.$0i)(o)?{resource:o.resource,overrideIdentifiers:o.overrideIdentifier?[o.overrideIdentifier]:void 0}:void 0,E=l?s:o;if(E!==void 0&&E!==b.ConfigurationTarget.USER_LOCAL&&E!==b.ConfigurationTarget.USER)throw new Error(`Unable to write ${u} to target ${E}.`);l?.overrideIdentifiers&&(l.overrideIdentifiers=(0,n.$Lb)(l.overrideIdentifiers),l.overrideIdentifiers=l.overrideIdentifiers.length?l.overrideIdentifiers:void 0);const y=this.inspect(u,{resource:l?.resource,overrideIdentifier:l?.overrideIdentifiers?l.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,g.$fo)(i,y.defaultValue)&&(i=void 0),l?.overrideIdentifiers?.length&&l.overrideIdentifiers.length>1){const L=l.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(O=>(0,n.$tb)([...O.identifiers].sort(),L));A&&(l.overrideIdentifiers=A.identifiers)}const D=l?.overrideIdentifiers?.length?[(0,d.$Fo)(l.overrideIdentifiers),u]:[u];await this.j.write(D,i),await this.reloadConfiguration()}inspect(u,i={}){return this.a.inspect(u,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.r(u)}r(u){const i=this.a.toData(),o=this.a.compareAndUpdateLocalUserConfiguration(u);this.u(o,i,b.ConfigurationTarget.USER)}s(u,i){const o=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(u,i);this.u(s,o,b.ConfigurationTarget.DEFAULT)}t(u){const i=this.a.toData(),o=this.a.compareAndUpdatePolicyConfiguration(u);this.u(o,i,b.ConfigurationTarget.DEFAULT)}u(u,i,o){const s=new f.$Qo(u,{data:i},this.a,void 0,this.n);s.source=o,this.h.fire(s)}}e.$Uo=k;class S{constructor(u,i,o){this.b=u,this.c=i,this.d=o,this.a=new r.$Jh}write(u,i){return this.a.queue(()=>this.e(u,i))}async e(u,i){let o;try{o=(await this.c.readFile(this.b)).value.toString()}catch(l){if(l.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND)o="{}";else throw l}const s=[];if((0,T.$Vn)(o,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const a=this.f(o,u,i);o=(0,I.$ao)(o,a),await this.c.writeFile(this.b,P.$Le.fromString(o))}f(u,i,o){const{tabSize:s,insertSpaces:a,eol:l}=this.h;if(!i.length){const E=JSON.stringify(o,null,a?" ".repeat(s):"	");return[{content:E,length:E.length,offset:0}]}return(0,I.$0n)(u,i,o,{tabSize:s,insertSpaces:a,eol:l})}get h(){if(!this.g){let u=h.OS===h.OperatingSystem.Linux||h.OS===h.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(u=i),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[205],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=e.$Jgc=void 0,e.$Jgc="request",e.$Kgc="remoteResourceHandler";class n{async routeCall(P,R,T){if(R!==e.$Jgc)throw new Error(`Call not found: ${R}`);const I=T[0];if(I?.authority){const w=P.connections.find(c=>c.ctx===I.authority);if(w)return w}throw new Error("Caller not found")}routeEvent(P,R){throw new Error(`Event not found: ${R}`)}}e.$Lgc=n}),define(le[206],ue([0,1,15,6]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.RemoteAuthorityResolverErrorCode=e.$Ql=e.$Pl=e.RemoteConnectionType=e.$Ol=void 0,e.$Sl=c,e.$Ol=(0,r.$Ci)("remoteAuthorityResolverService");var P;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class R{constructor(h){this.id=h,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Pl=R;class T{constructor(h,m){this.host=h,this.port=m,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ql=T;var I;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class w extends n.$ab{static isNotAvailable(h){return h instanceof w&&h._code===I.NotAvailable}static isTemporarilyNotAvailable(h){return h instanceof w&&h._code===I.TemporarilyNotAvailable}static isNoResolverFound(h){return h instanceof w&&h._code===I.NoResolverFound}static isInvalidAuthority(h){return h instanceof w&&h._code===I.InvalidAuthority}static isHandled(h){return h instanceof w&&h.isHandled}constructor(h,m=I.Unknown,b){super(h),this._message=h,this._code=m,this._detail=b,this.isHandled=m===I.NotAvailable&&b===!0,Object.setPrototypeOf(this,w.prototype)}}e.$Rl=w;function c(g){const h=g.indexOf("+");return h===-1?g:g.substring(0,h)}}),define(le[207],ue([0,1,8,16,21,15,4,2,11,70,66,33,117,206]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Xl=y,e.$Yl=D,e.$Zl=A,c=Ie(c);const f=30*1e3;var d;(function(oe){oe[oe.Management=1]="Management",oe[oe.ExtensionHost=2]="ExtensionHost",oe[oe.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function v(oe){switch(oe){case d.Management:return"Management";case d.ExtensionHost:return"ExtensionHost";case d.Tunnel:return"Tunnel"}}function p(oe){const ee=new P.$ue;return setTimeout(()=>ee.cancel(),oe),ee.token}function $(oe,ee){if(oe.isCancellationRequested||ee.isCancellationRequested)return P.CancellationToken.Cancelled;const M=new P.$ue;return oe.onCancellationRequested(()=>M.cancel()),ee.onCancellationRequested(()=>M.cancel()),M.token}class k{get didTimeout(){return this.c==="timedout"}constructor(ee){this.c="pending",this.d=new I.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$vh)(),ee.isCancellationRequested?this.h():this.d.add(ee.onCancellationRequested(()=>this.h()))}registerDisposable(ee){this.c==="pending"?this.d.add(ee):ee.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const ee=new Error("Time limit reached");return ee.code="ETIMEDOUT",ee.syscall="connect",ee}resolve(ee){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(ee))}reject(ee){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(ee))}}function S(oe,ee){const M=new k(ee);return M.registerDisposable(oe.onControlMessage(F=>{const C=JSON.parse(F.toString()),z=j(C);z?M.reject(z):M.resolve(C)})),M.promise}function t(oe,ee,M,F,C,z,Z,Q){const q=new k(Q),se=g.$de.create(!1);return oe.info(`Creating a socket (${Z})...`),c.mark(`code/willCreateSocket/${z}`),ee.connect(M,F,C,Z).then(de=>{q.didTimeout?(c.mark(`code/didCreateSocketError/${z}`),oe.info(`Creating a socket (${Z}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),de?.dispose()):(c.mark(`code/didCreateSocketOK/${z}`),oe.info(`Creating a socket (${Z}) was successful after ${se.elapsed()} ms.`),q.resolve(de))},de=>{c.mark(`code/didCreateSocketError/${z}`),oe.info(`Creating a socket (${Z}) returned an error after ${se.elapsed()} ms.`),oe.error(de),q.reject(de)}),q.promise}function u(oe,ee){const M=new k(ee);return oe.then(F=>{M.didTimeout||M.resolve(F)},F=>{M.didTimeout||M.reject(F)}),M.promise}async function i(oe,ee,M,F){const C=V(oe,ee);oe.logService.trace(`${C} 1/6. invoking socketFactory.connect().`);let z;try{z=await t(oe.logService,oe.remoteSocketFactoryService,oe.connectTo,w.$Pg.getServerRootPath(),`reconnectionToken=${oe.reconnectionToken}&reconnection=${oe.reconnectionProtocol?"true":"false"}`,v(ee),`renderer-${v(ee)}-${oe.reconnectionToken}`,F)}catch(de){throw oe.logService.error(`${C} socketFactory.connect() failed or timed out. Error:`),oe.logService.error(de),de}oe.logService.trace(`${C} 2/6. socketFactory.connect() was successful.`);let Z,Q;oe.reconnectionProtocol?(oe.reconnectionProtocol.beginAcceptReconnection(z,null),Z=oe.reconnectionProtocol,Q=!1):(Z=new m.$qi({socket:z}),Q=!0),oe.logService.trace(`${C} 3/6. sending AuthRequest control message.`);const q=await u(oe.signService.createNewMessage((0,h.$Yg)()),F),se={type:"auth",auth:oe.connectionToken||"00000000000000000000",data:q.data};Z.sendControl(r.$Le.fromString(JSON.stringify(se)));try{const de=await S(Z,$(F,p(1e4)));if(de.type!=="sign"||typeof de.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(oe.logService.trace(`${C} 4/6. received SignRequest control message.`),!await u(oe.signService.validate(q,de.signedData),F)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const we=await u(oe.signService.sign(de.data),F),De={type:"connectionType",commit:oe.commit,signedData:we,desiredConnectionType:ee};return M&&(De.args=M),oe.logService.trace(`${C} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(r.$Le.fromString(JSON.stringify(De))),{protocol:Z,ownsProtocol:Q}}catch(de){throw de&&de.code==="ETIMEDOUT"&&(oe.logService.error(`${C} the handshake timed out. Error:`),oe.logService.error(de)),de&&de.code==="VSCODE_CONNECTION_ERROR"&&(oe.logService.error(`${C} received error control message when negotiating connection. Error:`),oe.logService.error(de)),Q&&U(Z),de}}async function o(oe,ee,M,F){const C=Date.now(),z=V(oe,ee),{protocol:Z,ownsProtocol:Q}=await i(oe,ee,M,F),q=new k(F);return q.registerDisposable(Z.onControlMessage(se=>{const de=JSON.parse(se.toString()),me=j(de);me?(oe.logService.error(`${z} received error control message when negotiating connection. Error:`),oe.logService.error(me),Q&&U(Z),q.reject(me)):(oe.reconnectionProtocol?.endAcceptReconnection(),oe.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(C)}!`),q.resolve({protocol:Z,firstMessage:de}))})),q.promise}async function s(oe,ee){const{protocol:M}=await o(oe,d.Management,void 0,ee);return{protocol:M}}async function a(oe,ee,M){const{protocol:F,firstMessage:C}=await o(oe,d.ExtensionHost,ee,M),z=C&&C.debugPort;return{protocol:F,debugPort:z}}async function l(oe,ee,M){const F=Date.now(),C=V(oe,d.Tunnel),{protocol:z}=await i(oe,d.Tunnel,ee,M);return oe.logService.trace(`${C} 6/6. handshake finished, connection is up and running after ${he(F)}!`),z}async function E(oe,ee,M){const{connectTo:F,connectionToken:C}=await oe.addressProvider.getAddress();return{commit:oe.commit,quality:oe.quality,connectTo:F,connectionToken:C,reconnectionToken:ee,reconnectionProtocol:M,remoteSocketFactoryService:oe.remoteSocketFactoryService,signService:oe.signService,logService:oe.logService}}async function y(oe,ee,M){return L(oe,async F=>{const{protocol:C}=await s(F,P.CancellationToken.None);return new K(oe,ee,M,F.reconnectionToken,C)})}async function D(oe,ee){return L(oe,async M=>{const{protocol:F,debugPort:C}=await a(M,ee,P.CancellationToken.None);return new te(oe,ee,M.reconnectionToken,F,C)})}async function L(oe,ee){for(let F=1;;F++)try{const C=(0,h.$Yg)(),z=await E(oe,C,null);return await ee(z)}catch(C){if(F<5)oe.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),oe.logService.error(C);else throw oe.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),oe.logService.error(C),ae.triggerPermanentFailure(0,0,b.$Rl.isHandled(C)),C}}async function A(oe,ee,M){const F=await E(oe,(0,h.$Yg)(),null);return await l(F,{host:ee,port:M},P.CancellationToken.None)}function O(oe){return(0,n.$ph)(ee=>new Promise((M,F)=>{const C=setTimeout(M,oe*1e3);ee.onCancellationRequested(()=>{clearTimeout(C),M()})}))}var W;(function(oe){oe[oe.ConnectionLost=0]="ConnectionLost",oe[oe.ReconnectionWait=1]="ReconnectionWait",oe[oe.ReconnectionRunning=2]="ReconnectionRunning",oe[oe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",oe[oe.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class x{constructor(ee,M){this.reconnectionToken=ee,this.millisSinceLastIncomingData=M,this.type=W.ConnectionLost}}e.$1l=x;class H{constructor(ee,M,F,C){this.reconnectionToken=ee,this.millisSinceLastIncomingData=M,this.durationSeconds=F,this.c=C,this.type=W.ReconnectionWait}skipWait(){this.c.cancel()}}e.$2l=H;class B{constructor(ee,M,F){this.reconnectionToken=ee,this.millisSinceLastIncomingData=M,this.attempt=F,this.type=W.ReconnectionRunning}}e.$3l=B;class X{constructor(ee,M,F){this.reconnectionToken=ee,this.millisSinceLastIncomingData=M,this.attempt=F,this.type=W.ConnectionGain}}e.$4l=X;class G{constructor(ee,M,F,C){this.reconnectionToken=ee,this.millisSinceLastIncomingData=M,this.attempt=F,this.handled=C,this.type=W.ReconnectionPermanentFailure}}e.$5l=G;class ae extends I.$Tc{static triggerPermanentFailure(ee,M,F){this._permanentFailure=!0,this.f=ee,this.g=M,this.h=F,this.j.forEach(C=>C.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(ee=>ee.y())}static debugPauseSocketWriting(){this.j.forEach(ee=>ee.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ae._permanentFailure}constructor(ee,M,F,C,z){super(),this.t=ee,this.u=M,this.reconnectionToken=F,this.protocol=C,this.w=z,this.m=this.B(new T.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new X(this.reconnectionToken,0,0)),this.B(C.onSocketClose(Z=>{const Q=ie(this.t,this.reconnectionToken,!0);Z?Z.type===m.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${Q} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${Q} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${Q} received socket close event.`),this.y()})),this.B(C.onSocketTimeout(Z=>{const Q=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Q} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),ae.j.push(this),this.B((0,I.$Rc)(()=>{const Z=ae.j.indexOf(this);Z>=0&&ae.j.splice(Z,1)})),this.n&&this.D(ae.f,ae.g,ae.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const ee=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const C=F<M.length?M[F]:M[M.length-1];try{if(C>0){const Z=O(C);this.m.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),C,Z)),this.u.logService.info(`${ee} waiting for ${C} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${ee} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.u.logService.info(`${ee} resolving connection...`);const z=await E(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${ee} connecting to ${z.connectTo}...`),await this.G(z,p(f)),this.u.logService.info(`${ee} reconnected!`),this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${ee} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.u.logService.error(`${ee} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(b.$Rl.isTemporarilyNotAvailable(z)){this.u.logService.info(`${ee} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.u.logService.info(`${ee} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if((0,R.$3)(z)){this.u.logService.info(`${ee} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(z);continue}if(z instanceof b.$Rl){this.u.logService.error(`${ee} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,b.$Rl.isHandled(z));break}this.u.logService.error(`${ee} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(z),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.n&&!this.s)}C(ee,M,F){this.w?ae.triggerPermanentFailure(ee,M,F):this.D(ee,M,F)}D(ee,M,F){this.m.fire(new G(this.reconnectionToken,ee,M,F)),U(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6l=ae;class K extends ae{constructor(ee,M,F,C,z){super(d.Management,ee,C,z,!0),this.client=this.B(new m.$oi(z,{remoteAuthority:M,clientId:F},ee.ipcLogger))}async G(ee,M){await s(ee,M)}}e.$7l=K;class te extends ae{constructor(ee,M,F,C,z){super(d.ExtensionHost,ee,F,C,!1),this.H=M,this.debugPort=z}async G(ee,M){await a(ee,this.H,M)}}e.$8l=te;function U(oe){try{oe.acceptDisconnect();const ee=oe.getSocket();oe.dispose(),ee.dispose()}catch(ee){(0,R.$Y)(ee)}}function j(oe){if(oe&&oe.type==="error"){const ee=new Error(`Connection error: ${oe.reason}`);return ee.code="VSCODE_CONNECTION_ERROR",ee}return null}function N(oe,ee){for(;oe.length<ee;)oe+=" ";return oe}function Y(oe,ee){return`[remote-connection][${N(v(oe),13)}][${ee.substr(0,5)}\u2026]`}function ie(oe,ee,M){return`${Y(oe,ee)}[${M?"reconnect":"initial"}]`}function V(oe,ee){return`${ie(ee,oe.reconnectionToken,!!oe.reconnectionProtocol)}[${oe.connectTo}]`}function he(oe){return`${Date.now()-oe} ms`}}),define(le[74],ue([0,1,11]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=r,e.$fn=P,e.$gn=R,e.$hn=T;function r(w){return w.scheme===n.Schemas.vscodeRemote?w.authority:void 0}function P(w){if(!w)return;const c=w.indexOf("+");return c<0?w:w.substr(0,c)}function R(w){const{host:c,port:g}=I(w);if(typeof g>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:g}}function T(w,c){let{host:g,port:h}=I(w);return typeof h>"u"&&(h=c),{host:g,port:h}}function I(w){const c=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const g=w.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const h=w.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:w,port:void 0}}}),define(le[85],ue([0,1,25,6,74]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$qn=e.$pn=e.$on=e.TargetPlatform=e.ExtensionType=e.$nn=e.$ln=e.$kn=e.$jn=e.$in=void 0,e.$mn=R,e.$rn=h,e.$sn=m,e.$tn=b,e.$un=f,e.$vn=d,e.$wn=v,n=Ie(n),e.$in="extensions.user.cache",e.$jn="extensions.builtin.cache",e.$kn="undefined_publisher",e.$ln=["ui","workspace","web"];function R(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(T||(e.ExtensionType=T={}));var I;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class w{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,k){if(typeof $>"u"||$===null)return typeof k>"u"||k===null;if(typeof k>"u"||k===null)return!1;if(typeof $=="string"||typeof k=="string"){const S=typeof $=="string"?$:$.value,t=typeof k=="string"?k:k.value;return n.$Df(S,t)}return $._lower===k._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$on=w;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const k of $)this.add(k)}add($){this.c.add(w.toKey($))}delete($){return this.c.delete(w.toKey($))}has($){return this.c.has(w.toKey($))}}e.$pn=c;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(w.toKey($))}get($){return this.c.get(w.toKey($))}has($){return this.c.has(w.toKey($))}set($,k){this.c.set(w.toKey($),k)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qn=g;function h(p){return m(p)}function m(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function b(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function f(p,$){if($){const k=`onResolveRemoteAuthority:${(0,P.$fn)($)}`;return!!p.activationEvents?.includes(k)}return!1}function d(p){return p.map($=>{const[k,S]=$.split("@");return{proposalName:k,version:S?parseInt(S):void 0}})}function v(p){return p.map($=>$.split("@")[0])}e.$xn=(0,r.$Ci)("IBuiltinExtensionsScannerService")}),define(le[126],ue([0,1,3,10,85,6]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=I,e.$dp=w,e.$ep=c,e.$fp=g,e.$gp=h,e.$hp=m,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var T;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function I(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function w(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(t,u){switch(t){case n.Platform.Windows:return u==="x64"?P.TargetPlatform.WIN32_X64:u==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Linux:return u==="x64"?P.TargetPlatform.LINUX_X64:u==="arm64"?P.TargetPlatform.LINUX_ARM64:u==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return u==="x64"?P.TargetPlatform.ALPINE_X64:u==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Mac:return u==="x64"?P.TargetPlatform.DARWIN_X64:u==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case n.Platform.Web:return P.TargetPlatform.WEB}}function g(t,u){return u===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function h(t,u,i){return g(u,i)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===i}function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var b;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f||(e.SortOrder=f={}));var d;(function(t){t.Install="install",t.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var v;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$ip=(0,R.$Ci)("extensionGalleryService");var p;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(p||(e.ExtensionGalleryErrorCode=p={}));class $ extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$jp=$;var k;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateExistingMetadata="UpdateExistingMetadata",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));class S extends Error{constructor(u,i){super(u),this.code=i,this.name=i}}e.$kp=S,e.$lp=(0,R.$Ci)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,R.$Ci)("IGlobalExtensionEnablementService"),e.$pp=(0,R.$Ci)("IExtensionTipsService"),e.$qp=(0,r.localize2)(11334,"Extensions"),e.$rp=(0,r.localize2)(11335,"Preferences")});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[208],ue([0,1,18,81,10,209,85,171]),function(J,e,n,r,P,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=g,e.$Xp=h,e.$Yp=m,e.$Zp=b,e.$1p=f,e.$2p=d,e.$3p=v,e.$4p=p,r=et(r),P=Ie(P),R=Ie(R);const w=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function g(S){return S=S.trim(),S==="*"||w.test(S)}function h(S){if(!g(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=S.match(w);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function m(S){if(!S)return null;const t=S.majorBase,u=S.majorMustEqual,i=S.minorBase;let o=S.minorMustEqual;const s=S.patchBase;let a=S.patchMustEqual;S.hasCaret&&(t===0||(o=!1),a=!1);let l=0;if(S.preRelease){const E=c.exec(S.preRelease);if(E){const[,y,D,L]=E;l=Date.UTC(Number(y),Number(D)-1,Number(L))}}return{majorBase:t,majorMustEqual:u,minorBase:i,minorMustEqual:o,patchBase:s,patchMustEqual:a,isMinimum:S.hasGreaterEquals,notBefore:l}}function b(S,t,u){let i;typeof S=="string"?i=m(h(S)):i=S;let o;t instanceof Date?o=t.getTime():typeof t=="string"&&(o=new Date(t).getTime());let s;if(typeof u=="string"?s=m(h(u)):s=u,!i||!s)return!1;const a=i.majorBase,l=i.minorBase,E=i.patchBase;let y=s.majorBase,D=s.minorBase,L=s.patchBase;const A=s.notBefore;let O=s.majorMustEqual,W=s.minorMustEqual,x=s.patchMustEqual;return s.isMinimum?a>y?!0:a<y?!1:l>D?!0:l<D||o&&o<A?!1:E>=L:(a===1&&y===0&&(!O||!W||!x)&&(y=1,D=0,L=0,O=!0,W=!1,x=!1),a<y?!1:a>y?!O:l<D?!1:l>D?!W:E<L?!1:E>L?!x:!(o&&o<A))}function f(S,t,u,i,o,s){const a=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return a.push([r.default.Error,P.localize(11266,null)]),a;if(typeof i.name!="string")return a.push([r.default.Error,P.localize(11267,null,"name")]),a;if(typeof i.version!="string")return a.push([r.default.Error,P.localize(11268,null,"version")]),a;if(!i.engines)return a.push([r.default.Error,P.localize(11269,null,"engines")]),a;if(typeof i.engines.vscode!="string")return a.push([r.default.Error,P.localize(11270,null,"engines.vscode")]),a;if(typeof i.extensionDependencies<"u"&&!k(i.extensionDependencies))return a.push([r.default.Error,P.localize(11271,null,"extensionDependencies")]),a;if(typeof i.activationEvents<"u"){if(!k(i.activationEvents))return a.push([r.default.Error,P.localize(11272,null,"activationEvents")]),a;if(typeof i.main>"u"&&typeof i.browser>"u")return a.push([r.default.Error,P.localize(11273,null,"activationEvents","main","browser")]),a}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&a.push([r.default.Warning,P.localize(11274,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return a.push([r.default.Error,P.localize(11275,null,"main")]),a;{const y=(0,n.$dh)(u,i.main);(0,n.$0g)(y,u)||a.push([r.default.Warning,P.localize(11276,null,y.path,u.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return a.push([r.default.Error,P.localize(11277,null,"browser")]),a;{const y=(0,n.$dh)(u,i.browser);(0,n.$0g)(y,u)||a.push([r.default.Warning,P.localize(11278,null,y.path,u.path)])}}if(!R.valid(i.version))return a.push([r.default.Error,P.localize(11279,null)]),a;const l=[];if(!d(S,t,i,o,l))for(const y of l)a.push([r.default.Error,y]);if(s&&i.enabledApiProposals?.length){const y=[];if(!p([...i.enabledApiProposals],y))for(const D of y)a.push([r.default.Error,D])}return a}function d(S,t,u,i,o){return i||typeof u.main>"u"&&typeof u.browser>"u"?!0:$(S,t,u.engines.vscode,o)}function v(S,t,u){return S==="*"||$(t,u,S)}function p(S,t){if(S.length===0)return!0;const u=Array.isArray(t)?t:void 0,i=(u?void 0:t)??I.allApiProposals,o=[],s=(0,T.$vn)(S);for(const{proposalName:a,version:l}of s){const E=i[a];E&&l&&E.version!==l&&o.push(P.localize(11280,null,a))}return u?.push(...o),o.length===0}function $(S,t,u,i=[]){const o=m(h(u));if(!o)return i.push(P.localize(11281,null,u)),!1;if(o.majorBase===0){if(!o.majorMustEqual||!o.minorMustEqual)return i.push(P.localize(11282,null,u)),!1}else if(!o.majorMustEqual)return i.push(P.localize(11283,null,u)),!1;return b(S,t,o)?!0:(i.push(P.localize(11284,null,S,u)),!1)}function k(S){if(!Array.isArray(S))return!1;for(let t=0,u=S.length;t<u;t++)if(typeof S[t]!="string")return!1;return!0}}),define(le[210],ue([0,1,2,6]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=void 0,e.$Tl=(0,r.$Ci)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(T,I){return this.a[T]??=[],this.a[T].push(I),(0,n.$Rc)(()=>{const w=this.a[T]?.indexOf(I);typeof w=="number"&&w>=0&&this.a[T]?.splice(w,1)})}b(T){return(this.a[T.type]||[]).find(w=>w.supports(T))}connect(T,I,w,c){const g=this.b(T);if(!g)throw new Error(`No socket factory found for ${T}`);return g.connect(T,I,w,c)}}e.$Ul=P}),define(le[211],ue([0,1,26,27,48,121]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=I,n=Ie(n),r=Ie(r),P=Ie(P),R=Ie(R);let T;async function I(b=!1){return(T===void 0||b)&&(T=w()),T}async function w(){const b=c();if(b===void 0)return!1;if(b>=22e3){const f=h();if(f)return new Promise(d=>{P.execFile(f,["--status"],v=>d(!v))})}else{const f=m();if(f)try{if((await n.promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(r.release());if(b)return parseInt(b[3])}function g(b){const f=process.env.SystemRoot;if(f){const d=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,d?"Sysnative":"System32",b)}}function h(){return g("wsl.exe")}function m(){return g("lxss\\LxssManager.dll")}}),define(le[56],ue([0,1,16,15,2,10,55,6,5,45]),function(J,e,n,r,P,R,T,I,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=m,e.$8p=b,e.$9p=f,e.$0p=d,e.$$p=v,e.$_p=p,e.$5p=(0,I.$Ci)("requestService");class g{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const u in this.b)u.toLowerCase()==="authorization"||u.toLowerCase()==="proxy-authorization"?t[u]="*****":t[u]=this.b[u];this.a=t}return this.a}}class h extends P.$Tc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,R.localize)(11053,null),when:w.$pk.isEqualTo((0,w.$mk)(w.LogLevel.Trace)).serialize()})}async c(t,u,i){const o=`${t} #${++this.b}: ${u.url}`;this.a.trace(`${o} - begin`,u.type,new g(u.headers??{}));try{const s=await i();return this.a.trace(`${o} - end`,u.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,u.type,(0,r.$9)(s)),s}}}e.$6p=h;function m(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function b(S){return S.res.statusCode===204}async function f(S){return b(S)?null:(await(0,n.$Xe)(S.stream)).toString()}async function d(S){if(!m(S))throw new Error("Server returned "+S.res.statusCode);return f(S)}async function v(S){if(!m(S))throw new Error("Server returned "+S.res.statusCode);if(b(S))return null;const u=(await(0,n.$Xe)(S.stream)).toString();try{return JSON.parse(u)}catch(i){throw i.message+=`:
`+u,i}}function p(S){k(S)}let $;function k(S){const t=c.$oo.as(T.$to.Configuration),u=$;$={id:"http",order:15,title:(0,R.localize)(11054,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(11055,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(11056,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(11057,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,R.localize)(11058,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(11059,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(11060,null),(0,R.localize)(11061,null),(0,R.localize)(11062,null),(0,R.localize)(11063,null)],default:"override",description:(0,R.localize)(11064,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11065,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(11066,null),restricted:!0}}},t.updateConfigurations({add:[$],remove:u?[u]:[]})}k(T.ConfigurationScope.APPLICATION)}),define(le[212],ue([0,1,16,21]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0;class P{constructor(I){this.a=I}listen(I,w){throw new Error("Invalid listen")}call(I,w,c,g=r.CancellationToken.None){switch(w){case"request":return this.a.request(c[0],g).then(async({res:h,stream:m})=>{const b=await(0,n.$Xe)(m);return[{statusCode:h.statusCode,headers:h.headers},b]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"lookupAuthorization":return this.a.lookupAuthorization(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_r=P;class R{constructor(I){this.a=I}async request(I,w){const[c,g]=await this.a.call("request",[I],w);return{res:c,stream:(0,n.$Ze)(g)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async lookupAuthorization(I){return this.a.call("lookupAuthorization",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$as=R}),define(le[213],ue([0,1,214,12]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=R;function P(T,I){return T.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:T.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(T,I,w={}){const c=(0,n.parse)(T),g=w.proxyUrl||P(c,I);if(!g)return null;const h=(0,n.parse)(g);if(!/^https?:$/.test(h.protocol||""))return null;const m={host:h.hostname||"",port:(h.port?+h.port:0)||(h.protocol==="https"?443:80),auth:h.auth,rejectUnauthorized:(0,r.$ig)(w.strictSSL)?w.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((b,f)=>{J(["http-proxy-agent"],b,f)}).then(Ie)).HttpProxyAgent(g,m):new(await new Promise((b,f)=>{J(["https-proxy-agent"],b,f)}).then(Ie)).HttpsProxyAgent(g,m)}}),define(le[215],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=e.$4fc=void 0,e.$4fc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$5fc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$6fc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[100],ue([0,1,48,9,10,21,54,15,3,33,116,68,8,143]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=d;let f;async function d(p,$,k,S){return k["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$j?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,h.$Hm)(S)&&!k["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,h.$Hm)(S)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=m.Promises.withAsyncBody(async(t,u)=>{const i=new R.$ue;let o=1e4;const s=p.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,b.$Im)(s,1,120)*1e3);const a=setTimeout(()=>{i.dispose(!0),u(new Error((0,P.localize)(11050,null)))},o);try{t(await v($,i.token))}catch(l){!(0,I.$3)(l)&&!i.token.isCancellationRequested?u(new Error((0,P.localize)(11051,null,(0,T.$nj)(l)))):t({})}finally{clearTimeout(a),i.dispose()}})),f)}async function v(p,$){const k=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",k);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",S);const t=(0,c.$Yg)().replace(/-/g,"").substr(0,12),u=new RegExp(t+"({.*})"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};p.trace("getUnixShellEnvironment#env",i);const o=await(0,g.$xm)(w.OS,i);return p.trace("getUnixShellEnvironment#shell",o),new Promise((s,a)=>{if($.isCancellationRequested)return a(new I.$4);const l=(0,r.$mc)(o);let E,y;const D="";/^pwsh(-preview)?$/.test(l)?(E=`& '${process.execPath}' ${D} -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,y=["-Login","-Command"]):l==="nu"?(E=`^'${process.execPath}' ${D} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,y=["-i","-l","-c"]):l==="xonsh"?(E=`import os, json; print("${t}", json.dumps(dict(os.environ)), "${t}")`,y=["-i","-l","-c"]):(E=`'${process.execPath}' ${D} -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,l==="tcsh"||l==="csh"?y=["-ic"]:y=["-i","-l","-c"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),E);const L=(0,n.spawn)(o,[...y,E],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});$.onCancellationRequested(()=>(L.kill(),a(new I.$4))),L.on("error",W=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,T.$nj)(W)),a(W)});const A=[];L.stdout.on("data",W=>A.push(W));const O=[];L.stderr.on("data",W=>O.push(W)),L.on("close",(W,x)=>{const H=Buffer.concat(A).toString("utf8");p.trace("getUnixShellEnvironment#raw",H);const B=Buffer.concat(O).toString("utf8");if(B.trim()&&p.trace("getUnixShellEnvironment#stderr",B),W||x)return a(new Error((0,P.localize)(11052,null,W,x)));const X=u.exec(H),G=X?X[1]:"{}";try{const ae=JSON.parse(G);k?ae.ELECTRON_RUN_AS_NODE=k:delete ae.ELECTRON_RUN_AS_NODE,S?ae.ELECTRON_NO_ATTACH_CONSOLE=S:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",ae),s(ae)}catch(ae){p.error("getUnixShellEnvironment#errorCaught",(0,T.$nj)(ae)),a(ae)}})})}}),define(le[216],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const R=await this.c();if(R){const T=String(n.a++);return this.b.set(T,R),{id:T,data:R.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,R){if(!P.id)return!0;const T=this.b.get(P.id);if(!T)return!1;this.b.delete(P.id);try{return T.validate(R)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$Obc=n}),define(le[101],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl="signService",e.$Wl=(0,n.$Ci)(e.$Vl)}),define(le[217],ue([0,1,216]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class r extends n.$Obc{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(T=>new T.signer().sign(R))}h(){return new Promise((R,T)=>J(["vsda"],R,T))}}e.$Vgc=r}),define(le[34],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iR=e.$hR=void 0,e.$hR=(0,n.$Ci)("stateReadService"),e.$iR=(0,n.$Ci)("stateService")}),define(le[127],ue([0,1,8,16,2,12,38,14,5]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lR=e.$kR=e.$jR=e.SaveStrategy=void 0;var c;(function(b){b[b.IMMEDIATE=0]="IMMEDIATE",b[b.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class g extends P.$Tc{constructor(f,d,v,p){super(),this.h=f,this.j=d,this.m=v,this.n=p,this.a=Object.create(null),this.b="",this.c=this.B(new n.$Ah(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(f)}}getItem(f,d){const v=this.a[f];return(0,R.$lg)(v)?d:v}setItem(f,d){this.setItems([{key:f,data:d}])}setItems(f){let d=!1;for(const{key:v,data:p}of f)this.a[v]!==p&&((0,R.$lg)(p)?(0,R.$jg)(this.a[v])||(this.a[v]=void 0,d=!0):(this.a[v]=p,d=!0));d&&this.s()}removeItem(f){(0,R.$jg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,r.$Le.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(d){this.m.error(d)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$jR=g;let h=class extends P.$Tc{constructor(f,d,v,p){super(),this.a=this.B(new g(d.stateResource,f,v,p))}async init(){await this.a.init()}getItem(f,d){return this.a.getItem(f,d)}};e.$kR=h,e.$kR=h=Ee([re(1,T.$Ji),re(2,w.$0j),re(3,I.$0k)],h);class m extends h{setItem(f,d){this.a.setItem(f,d)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$lR=m}),define(le[128],ue([0,1,3,36,33]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=T,e.$tp=I;function R(w){if(n.$v===n.Platform.Linux&&/^penguin(\.|$)/i.test(w))return"chromebook"}function T(w,c,g,h,m,b,f,d,v,p){const $=Object.create(null);$["common.machineId"]=b,$["common.sqmId"]=f,$["common.devDeviceId"]=d,$.sessionID=(0,P.$Yg)()+Date.now(),$.commitHash=h,$.version=m,$["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$i)(n.$v),$["common.nodePlatform"]=r.$cc,$["common.nodeArch"]=g,$["common.product"]=p||"desktop",v&&($["common.msftInternal"]=v);let k=0;const S=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-S,enumerable:!0},"common.sequence":{get:()=>k++,enumerable:!0}}),n.$m&&($["common.snap"]="true");const t=R(c);return t&&($["common.platformDetail"]=t),$}function I(w){const c=r.env.USERDNSDOMAIN;if(!c)return!1;const g=c.toLowerCase();return w.some(h=>g===h)}}),define(le[24],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=(0,n.$Ci)("telemetryService"),e.$0l=(0,n.$Ci)("customEndpointTelemetryService"),e.$$l="telemetry.currentSessionDate",e.$_l="telemetry.firstSessionDate",e.$am="telemetry.lastSessionDate",e.$bm="telemetry.machineId",e.$cm="telemetry.sqmId",e.$dm="telemetry.devDeviceId",e.$em="telemetry",e.$fm="telemetry.telemetryLevel",e.$gm="telemetry.enableCrashReporter",e.$hm="telemetry.enableTelemetry";var r;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(le[218],ue([0,1,26,27,8,43,11,9,3,66,7,92,23,115,96,14,28,24]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Vs=k,e.$Ws=t,e.$Xs=u,n=Ie(n),r=Ie(r);const $=new Map;async function k(o,s){const a=`${o}::${s.join(":")}`,l=$.get(a);if(l)return l;const E=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],y=new Map,D=new Map,L=2e4;function A(W,x,H,B){const X=x.substring(W.length+1);return P.Promises.withAsyncBody(async G=>{let ae;B.readdirCount++;try{ae=await m.Promises.readdir(x,{withFileTypes:!0})}catch{G();return}if(B.count>=L){B.count+=ae.length,B.maxReached=!0,G();return}let K=ae.length;if(K===0){G();return}let te=ae;B.count+ae.length>L&&(B.maxReached=!0,K=L-B.count,te=ae.slice(0,K)),B.count+=ae.length;for(const U of te)if(U.isDirectory()){if(H.includes(U.name)||await A(W,(0,I.$ic)(x,U.name),H,B),--K===0){G();return}}else{const j=U.name.lastIndexOf(".");if(j>=0){const N=U.name.substring(j+1);N&&y.set(N,(y.get(N)??0)+1)}for(const N of E)N.relativePathPattern?.test(X)!==!1&&N.filePattern.test(U.name)&&D.set(N.tag,(D.get(N.tag)??0)+1);if(--K===0){G();return}}})}const O=P.Promises.withAsyncBody(async W=>{const x={count:0,maxReached:!1,readdirCount:0},H=new c.$de(!0);await A(o,o,s,x);const B=await u(o);W({configFiles:S(D),fileTypes:S(y),fileCount:x.count,maxFilesReached:x.maxReached,launchConfigFiles:B,totalScanTime:H.elapsed(),totalReaddirCount:x.readdirCount})});return $.set(a,O),O}function S(o){return Array.from(o.entries(),([s,a])=>({name:s,count:a})).sort((s,a)=>a.count-s.count)}function t(){const o={os:`${r.type()} ${r.arch()} ${r.release()}`,memory:`${(r.totalmem()/d.$Fl.GB).toFixed(2)}GB (${(r.freemem()/d.$Fl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(h.$Pn.value()*100)}%`},s=r.cpus();return s&&s.length>0&&(o.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),o}async function u(o){try{const s=new Map,a=(0,I.$ic)(o,".vscode","launch.json"),l=await n.promises.readFile(a),E=[],y=(0,R.$Vn)(l.toString(),E);if(E.length)return console.log(`Unable to parse ${a}`),[];if((0,R.$4n)(y)==="object"&&y.configurations)for(const D of y.configurations){const L=D.type;L&&(s.has(L)?s.set(L,s.get(L)+1):s.set(L,1))}return S(s)}catch{return[]}}let i=class{constructor(s,a){this.c=s,this.d=a}f(s){const a=[];return a.push(`OS Version:       ${s.os}`),a.push(`CPUs:             ${s.cpus}`),a.push(`Memory (System):  ${s.memory}`),a.push(`VM:               ${s.vmHint}`),a.join(`
`)}g(s){const a=[];a.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),a.push(`OS Version:       ${r.type()} ${r.arch()} ${r.release()}`);const l=r.cpus();return l&&l.length>0&&a.push(`CPUs:             ${l[0].model} (${l.length} x ${l[0].speed})`),a.push(`Memory (System):  ${(r.totalmem()/d.$Fl.GB).toFixed(2)}GB (${(r.freemem()/d.$Fl.GB).toFixed(2)}GB free)`),w.$j||a.push(`Load (avg):       ${r.loadavg().map(E=>Math.round(E)).join(", ")}`),a.push(`VM:               ${Math.round(h.$Pn.value()*100)}%`),a.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${s.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(s,a){return Promise.all([(0,b.$Us)(s.mainPID),this.k(s)]).then(async l=>{let[E,y]=l,D=this.m(s,E);return a.forEach(L=>{if((0,f.$Rm)(L))D+=`
${L.errorMessage}`,y+=`
${L.errorMessage}`;else if(D+=`

Remote: ${L.hostName}`,L.processes&&(D+=`
${this.m(s,L.processes)}`),L.workspaceMetadata){y+=`
|  Remote: ${L.hostName}`;for(const A of Object.keys(L.workspaceMetadata)){const O=L.workspaceMetadata[A];let W=`${O.fileCount} files`;O.maxFilesReached&&(W=`more than ${W}`),y+=`|    Folder (${A}): ${W}`,y+=this.h(O)}}}),{processInfo:D,workspaceInfo:y}})}async getSystemInfo(s,a){const{memory:l,vmHint:E,os:y,cpus:D}=t(),L={os:y,memory:l,cpus:D,vmHint:E,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:a};return w.$j||(L.load=`${r.loadavg().map(A=>Math.round(A)).join(", ")}`),w.$l&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(s,a){const l=[];return(0,b.$Us)(s.mainPID).then(async E=>(l.push(""),l.push(this.g(s)),l.push(""),l.push(this.m(s,E)),s.windows.some(y=>y.folderURIs&&y.folderURIs.length>0&&!y.remoteAuthority)&&(l.push(""),l.push("Workspace Stats: "),l.push(await this.k(s))),a.forEach(y=>{if((0,f.$Rm)(y))l.push(`
${y.errorMessage}`);else if(l.push(`

`),l.push(`Remote:           ${y.hostName}`),l.push(this.f(y.machineInfo)),y.processes&&l.push(this.m(s,y.processes)),y.workspaceMetadata)for(const D of Object.keys(y.workspaceMetadata)){const L=y.workspaceMetadata[D];let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),l.push(`Folder (${D}): ${A}`),l.push(this.h(L))}}),l.push(""),l.push(""),l.join(`
`)))}h(s){const a=[];let E=0;const y=(O,W)=>{const x=` ${O}(${W})`;E+x.length>60?(a.push(D),D="|                 ",E=D.length):E+=x.length,D+=x};let D="|      File types:";const L=10,A=s.fileTypes.length>L?L:s.fileTypes.length;for(let O=0;O<A;O++){const W=s.fileTypes[O];y(W.name,W.count)}if(a.push(D),s.configFiles.length>=0&&(D="|      Conf files:",E=0,s.configFiles.forEach(O=>{y(O.name,O.count)}),a.push(D)),s.launchConfigFiles.length>0){let O="|      Launch Configs:";s.launchConfigFiles.forEach(W=>{const x=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`;O+=x}),a.push(O)}return a.join(`
`)}j(s){const a=Math.max(...Object.keys(s).map(l=>l.length));return Object.keys(s).map(l=>`${l}:  ${" ".repeat(a-l.length)}  ${s[l]}`).join(`
                  `)}k(s){const a=[],l=[];return s.windows.forEach(E=>{E.folderURIs.length===0||E.remoteAuthority||(a.push(`|  Window (${E.title})`),E.folderURIs.forEach(y=>{const D=g.URI.revive(y);if(D.scheme===T.Schemas.file){const L=D.fsPath;l.push(k(L,["node_modules",".git"]).then(A=>{let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),a.push(`|    Folder (${(0,I.$mc)(L)}): ${O}`),a.push(this.h(A))}).catch(A=>{a.push(`|      Error: Unable to collect workspace stats for folder ${L} (${A.toString()})`)}))}else a.push(`|    Folder (${D.toString()}): Workspace stats not available.`)}))}),Promise.all(l).then(E=>a.join(`
`)).catch(E=>`Unable to collect workspace stats: ${E}`)}m(s,a){const l=new Map;s.windows.forEach(y=>l.set(y.pid,`window [${y.id}] (${y.title})`)),s.pidToNames.forEach(({pid:y,name:D})=>l.set(y,D));const E=[];return E.push("CPU %	Mem MB	   PID	Process"),a&&this.n(s.mainPID,l,E,a,0),E.join(`
`)}n(s,a,l,E,y){const D=y===0;let L;D?L=E.pid===s?`${this.d.applicationName} main`:"remote agent":a.has(E.pid)?L=a.get(E.pid):L=`${"  ".repeat(y)} ${E.name}`;const A=process.platform==="win32"?E.mem:r.totalmem()*(E.mem/100);l.push(`${E.load.toFixed(0).padStart(5," ")}	${(A/d.$Fl.MB).toFixed(0).padStart(6," ")}	${E.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(E.children)&&E.children.forEach(O=>this.n(s,a,l,O,y+1))}async getWorkspaceFileExtensions(s){const a=new Set;for(const{uri:l}of s.folders){const E=g.URI.revive(l);if(E.scheme!==T.Schemas.file)continue;const y=E.fsPath;try{(await k(y,["node_modules",".git"])).fileTypes.forEach(L=>a.add(L.name))}catch{}}return{extensions:[...a]}}async reportWorkspaceStats(s){for(const{uri:a}of s.folders){const l=g.URI.revive(a);if(l.scheme!==T.Schemas.file)continue;const E=l.fsPath;try{const y=await k(E,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),y.fileTypes.forEach(D=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),y.launchConfigFiles.forEach(D=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),y.configFiles.forEach(D=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:D.name,count:D.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:y.totalScanTime,reachedLimit:y.maxFilesReached,fileCount:y.fileCount,readdirCount:y.totalReaddirCount})}catch{}}}};e.$Ys=i,e.$Ys=i=Ee([re(0,p.$9l),re(1,v.$qk)],i)}),define(le[219],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0;class n{constructor(R){this.b=R}listen(R,T){throw new Error(`Event not found: ${T}`)}call(R,T,{eventName:I,data:w}){return this.b.forEach(c=>c.log(I,w)),Promise.resolve(null)}}e.$9fc=n;class r{constructor(R){this.b=R}log(R,T){return this.b.call("log",{eventName:R,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$0fc=r}),define(le[57],ue([0,1,37,12,74,128,24]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=g,e.$Cp=h,e.$Dp=m,e.$Ep=b,e.$Fp=d,e.$Gp=p,e.$Hp=$,e.$Ip=t;class I{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$up=I;class w{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=w,e.$wp=new w;class c{async publicLog(i,o,s){}async publicLogError(i,o,s){}}e.$xp=c,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function g(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry)}function h(u,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}function m(u){const i=u.getValue(T.$fm),o=u.getValue(T.$gm);if(u.getValue(T.$hm)===!1||o===!1)return T.TelemetryLevel.NONE;switch(i??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function b(u){const i={},o={},s={};v(u,s);for(let a in s){a=a.length>150?a.substr(a.length-149):a;const l=s[a];typeof l=="number"?o[a]=l:typeof l=="boolean"?o[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),i[a]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(i[a]=l)}return{properties:i,measurements:o}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(u){if(!u)return"none";const i=(0,P.$fn)(u);return f.has(i)?i:"other"}function v(u,i,o=0,s){if(u)for(const a of Object.getOwnPropertyNames(u)){const l=u[a],E=s?s+a:a;Array.isArray(l)?i[E]=(0,n.$go)(l):l instanceof Date?i[E]=l.toISOString():(0,r.$eg)(l)?o<2?v(l,i,o+1,E+"."):i[E]=(0,n.$go)(l):i[E]=l}}function p(u,i){const o=u.msftInternalDomains||[],s=i.getValue("telemetry.internalTesting");return(0,R.$tp)(o)||s}function $(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}function k(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let o=u;const s=[];for(const y of i)for(;;){const D=y.exec(u);if(!D)break;s.push([D.index,y.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(o="";;){const y=l.exec(u);if(!y)break;const D=s.some(([L,A])=>y.index<A&&L<l.lastIndex);!a.test(y[0])&&!D&&(o+=u.substring(E,y.index)+"<REDACTED: user-file-path>",E=l.lastIndex)}return E<u.length&&(o+=u.substr(E)),o}function S(u){if(!u)return u;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of i)if(o.regex.test(u))return`<REDACTED: ${o.label}>`;return u}function t(u,i){return(0,n.$do)(u,o=>{if(o instanceof I||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let s=o.replaceAll("%20"," ");s=k(s,i);for(const a of i)s=s.replace(a,"");return s=S(s),s}})}}),define(le[129],ue([0,1,25,126,85,3,7,15,36,57]),function(J,e,n,r,P,R,T,I,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=g,e.$Lp=f,e.$Mp=d,e.$Np=v,e.$Op=p,e.$Pp=$,e.$Qp=k,e.$Rp=S,e.$Tp=t,e.$Up=i;function g(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,n.$yf)(o.id,s.id)===0}const h=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const a=s.manifest?s.manifest.version:s.version,l=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,a,l)}static parse(s){const a=h.exec(s);return a&&a[1]&&a[2]?new m({id:a[1]},a[2],a[4]||void 0):null}constructor(s,a,l=P.TargetPlatform.UNDEFINED){this.identifier=s,this.version=a,this.targetPlatform=l,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?g(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Kp=m;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const s=b.exec(o);return s&&s[1]?[v(s[1]),s[2]]:[v(o),void 0]}function d(o,s){return`${o}.${s}`}function v(o){return o.toLowerCase()}function p(o,s){return v(d(o??P.$kn,s))}function $(o,s){const a=[],l=E=>{for(const y of a)if(y.some(D=>g(s(D),s(E))))return y;return null};for(const E of o){const y=l(E);y?y.push(E):a.push([E])}return a}function k(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function S(o){return{id:new c.$up(o.identifier.id),name:new c.$up(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Sp=new P.$on("pprice.better-merge");function t(o,s){const a=[],l=s.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const E=l.shift();if(E&&a.every(y=>!g(y.identifier,{id:E}))){const y=o.filter(D=>g(D.identifier,{id:E}));y.length===1&&(a.push(y[0]),l.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}async function u(o,s){if(!R.$l)return!1;let a;try{a=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){s.debug("Error while getting the os-release file.",(0,I.$9)(E))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,s){const a=await u(o,s),l=(0,r.$ep)(a?"alpine":R.$v,w.$dc);return s.debug("ComputeTargetPlatform:",l),l}});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[220],ue([0,1,2,37,3,25,10,17,55,72,28,45,24,57]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,c=et(c);let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(p,$,k){this.k=$,this.l=k,this.d={},this.i=new n.$Sc,this.j=[],this.b=p.appenders,this.c=p.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=p.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!p.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,R.$ff)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$ff)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(m.$fm)||S.affectsConfiguration(m.$hm)||S.affectsConfiguration(m.$gm))&&this.m()}))}setExperimentProperty(p,$){this.d[p]=$}m(){let p=(0,b.$Dp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const k=$.usage?m.TelemetryLevel.USAGE:$.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;p=Math.min(p,k)}this.g=p}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(p,$,k){this.g<$||(k=(0,r.$eo)(k,this.d),k=(0,b.$Ip)(k,this.j),k=(0,r.$eo)(k,this.c),this.b.forEach(S=>S.log(p,k)))}publicLog(p,$){this.n(p,m.TelemetryLevel.USAGE,$)}publicLog2(p,$){this.publicLog(p,$)}publicLogError(p,$){this.h&&this.n(p,m.TelemetryLevel.ERROR,$)}publicLogError2(p,$){this.publicLogError(p,$)}};e.$es=f,e.$es=f=Ee([re(1,I.$9i),re(2,g.$qk)],f);function d(){const v=(0,T.localize)(11031,null,c.default.nameLong),p=c.default.privacyStatementUrl?(0,T.localize)(11033,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,T.localize)(11032,null,"https://aka.ms/vscode-telemetry"),$=P.$p?"":(0,T.localize)(11034,null),k=(0,T.localize)(11035,null),S=(0,T.localize)(11036,null),t=(0,T.localize)(11037,null),u=(0,T.localize)(11038,null),i=`
|       | ${k} | ${S} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,T.localize)(11039,null);return`
${v} ${p} ${$}

&nbsp;

${u}
${i}

&nbsp;

${o}
`}h.$oo.as(w.$to.Configuration).registerConfiguration({id:m.$em,order:1,type:"object",title:(0,T.localize)(11040,null),properties:{[m.$fm]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(11041,null),(0,T.localize)(11042,null),(0,T.localize)(11043,null),(0,T.localize)(11044,null)],markdownDescription:d(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),h.$oo.as(w.$to.Configuration).registerConfiguration({id:m.$em,order:110,type:"object",title:(0,T.localize)(11045,null),properties:{[m.$hm]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,T.localize)(11047,null,c.default.nameLong,c.default.privacyStatementUrl):(0,T.localize)(11046,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(11048,null,`\`#${m.$fm}#\``),scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[221],ue([0,1,3,92,24]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=R,e.$zgc=T,e.$Agc=I;async function R(w,c){let g=w.getItem(P.$bm);return(typeof g!="string"||n.$k&&g==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(g=await(0,r.$Qn)(c.error.bind(c))),g}async function T(w,c){let g=w.getItem(P.$cm);return typeof g!="string"&&(g=await(0,r.$Rn)(c.error.bind(c))),g}async function I(w,c){let g=w.getItem(P.$dm);return typeof g!="string"&&(g=await(0,r.$Sn)(c.error.bind(c))),g}}),define(le[222],ue([0,1,24,221]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=P,e.$Cgc=R,e.$Dgc=T;async function P(I,w){const c=await(0,r.$ygc)(I,w);return I.setItem(n.$bm,c),c}async function R(I,w){const c=await(0,r.$zgc)(I,w);return I.setItem(n.$cm,c),c}async function T(I,w){const c=await(0,r.$Agc)(I,w);return I.setItem(n.$dm,c),c}}),define(le[130],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(le[223],ue([0,1,3,130]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;const P=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((h,m)=>{this.d(h,m);const b=h.map.entries();let f=b.next();for(;!f.done;){const d=f.value[1],v=f.value[0];let p=this.a.get(v);if(p||(p=[],this.a.set(v,p)),p.length>0&&p[0].type===r.EnvironmentVariableMutatorType.Replace){f=b.next();continue}const $={extensionIdentifier:m,value:d.value,type:d.type,scope:d.scope,variable:d.variable,options:d.options};$.scope||delete $.scope,p.unshift($),f=b.next()}})}async applyToProcessEnvironment(g,h,m){let b;n.$j&&(b={},Object.keys(g).forEach(f=>b[f.toLowerCase()]=f));for(const[f,d]of this.getVariableMap(h)){const v=n.$j&&b[f.toLowerCase()]||f;for(const p of d){const $=m?await m(p.value):p.value;if(p.options?.applyAtProcessCreation??!0)switch(p.type){case r.EnvironmentVariableMutatorType.Append:g[v]=(g[v]||"")+$;break;case r.EnvironmentVariableMutatorType.Prepend:g[v]=$+(g[v]||"");break;case r.EnvironmentVariableMutatorType.Replace:g[v]=$;break}if(p.options?.applyAtShellIntegration??!1){const k=`VSCODE_ENV_${P.get(p.type)}`;g[k]=(g[k]?g[k]+":":"")+f+"="+this.c($)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,h){const m=new Map,b=new Map,f=new Map;if(g.getVariableMap(h).forEach((d,v)=>{const p=this.getVariableMap(h).get(v),$=I(d,p);$&&m.set(v,$)}),this.getVariableMap(h).forEach((d,v)=>{const p=g.getVariableMap(h).get(v),$=I(d,p);$&&f.set(v,$)}),this.getVariableMap(h).forEach((d,v)=>{const p=g.getVariableMap(h).get(v),$=w(d,p);$&&b.set(v,$)}),!(m.size===0&&b.size===0&&f.size===0))return{added:m,changed:b,removed:f}}getVariableMap(g){const h=new Map;for(const m of this.a.values()){const b=m.filter(f=>T(f,g));b.length>0&&h.set(b[0].variable,b)}return h}getDescriptionMap(g){const h=new Map;for(const m of this.b.values()){const b=m.filter(f=>T(f,g,!0));for(const f of b)h.set(f.extensionIdentifier,f.description)}return h}d(g,h){if(!g.descriptionMap)return;const m=g.descriptionMap.entries();let b=m.next();for(;!b.done;){const f=b.value[1],d=b.value[0];let v=this.b.get(d);v||(v=[],this.b.set(d,v));const p={extensionIdentifier:h,scope:f.scope,description:f.description};p.scope||delete p.scope,v.push(p),b=m.next()}}}e.$Is=R;function T(c,g,h=!1){return c.scope?!!(c.scope.workspaceFolder&&g?.workspaceFolder&&c.scope.workspaceFolder.index===g.workspaceFolder.index):h?g===c.scope:!0}function I(c,g){if(!g)return c;const h=new Set;g.forEach(b=>h.add(b.extensionIdentifier));const m=[];return c.forEach(b=>{h.has(b.extensionIdentifier)||m.push(b)}),m.length===0?void 0:m}function w(c,g){if(!g)return;const h=new Map;g.forEach(b=>h.set(b.extensionIdentifier,b));const m=[];return c.forEach(b=>{const f=h.get(b.extensionIdentifier);f&&(b.type!==f.type||b.value!==f.value||b.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&m.push(f)}),m.length===0?void 0:m}}),define(le[224],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=n,e.$Ds=r,e.$Es=P,e.$Fs=R,e.$Gs=T,e.$Hs=I;function n(w){return[...w.entries()]}function r(w){return w?[...w.entries()]:[]}function P(w){return new Map(w)}function R(w){return new Map(w??[])}function T(w){return Array.from(w.entries()).map(c=>[c[0],n(c[1].map),r(c[1].descriptionMap)])}function I(w){return new Map(w.map(c=>[c[0],{map:P(c[1]),descriptionMap:R(c[2])}]))}}),define(le[225],ue([0,1,8,21,4,2,5]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;let I=class extends R.$Tc{constructor(c,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$je),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,R.$Rc)(()=>{for(const h of this.f.values())(0,R.$Oc)(h)}))}createRequest(c){return new Promise((g,h)=>{const m=++this.a;this.c.set(m,g),this.g.fire({requestId:m,...c});const b=new r.$ue;(0,n.$Dh)(this.b,b.token).then(()=>h(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,R.$Rc)(()=>b.cancel())])})}acceptReply(c,g){const h=this.c.get(c);h?(this.c.delete(c),(0,R.$Oc)(this.f.get(c)||[]),this.f.delete(c),h(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$ts=I,e.$ts=I=Ee([re(1,T.$0j)],I)}),define(le[75],ue([0,1,6,122,45]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ms=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ls=void 0,e.$ls=new r.$Tj("terminalTabFocusMode",!1,!0);var R;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var T;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var I;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(I||(e.PosixShellType=I={}));var w;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(w||(e.WindowsShellType=w={}));var c;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var g;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var h;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(h||(e.ProcessPropertyType=h={})),e.$ms=(0,n.$Ci)("ptyService");var m;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m||(e.HeartbeatConstants=m={}));var b;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(b||(e.TerminalLocation=b={}));var f;(function(t){t.TerminalView="view",t.Editor="editor"})(f||(e.TerminalLocationString=f={}));var d;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(d||(e.LocalReconnectConstants=d={}));var v;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(v||(e.FlowControlConstants=v={}));var p;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(p||(e.ProfileSource=p={}));var $;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var k;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(k||(e.TerminalExitReason=k={})),e.$ns={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(u){const i=this.b(u.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,u)}getTerminalBackend(u){return this.a.get(this.b(u))}b(u){return u?.toLowerCase()??""}}P.$oo.add(e.$ns.Backend,new S),e.$os=(0,n.$Ci)("localPtyService"),e.$ps=(0,n.$Ci)("terminalLogService")}),define(le[226],ue([0,1,80,7,10,110]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=T,e.$vs=c,e.$ws=g,e.$xs=h;function T(m,b){const f=[{name:null,description:(0,P.localize)(10998,null)}];return f.push(...m.map(d=>({name:d.profileName,description:I(d)}))),b&&f.push(...b.map(d=>({name:d.title,description:w(d)}))),{values:f.map(d=>d.name),markdownDescriptions:f.map(d=>d.description)}}function I(m){let b=`$(${R.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:n.$2j.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?b+=`
- args: "${m.args}"`:b+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(b+=`
- overrideName: ${m.overrideName}`),m.color&&(b+=`
- color: ${m.color}`),m.env&&(b+=`
- env: ${JSON.stringify(m.env)}`),b}function w(m){return`$(${R.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:n.$2j.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function c(m,b){if(!m&&!b)return!0;if(typeof m=="string"&&typeof b=="string")return m===b;if(Array.isArray(m)&&Array.isArray(b)){if(m.length!==b.length)return!1;for(let f=0;f<m.length;f++)if(m[f]!==b[f])return!1;return!0}return!1}function g(m,b){if(!m&&!b)return!0;if(!m||!b)return!1;if(R.ThemeIcon.isThemeIcon(m)&&R.ThemeIcon.isThemeIcon(b))return m.id===b.id&&m.color===b.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof b=="object"&&"light"in b&&"dark"in b){const f=m,d=b;if((r.URI.isUri(f.light)||h(f.light))&&(r.URI.isUri(f.dark)||h(f.dark))&&(r.URI.isUri(d.light)||h(d.light))&&(r.URI.isUri(d.dark)||h(d.dark)))return f.light.path===d.light.path&&f.dark.path===d.dark.path}if(r.URI.isUri(m)&&r.URI.isUri(b)||h(m)||h(b)){const f=m,d=b;return f.path===d.path&&f.scheme===d.scheme}return!1}function h(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}}),define(le[227],ue([0,1,80,3,10,55,45,75,226]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=e.$ys=void 0,e.$As=f,e.$Bs=v,e.$ys={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$zs={type:"string",enum:Array.from((0,n.$Zj)(),p=>p.id),markdownEnumDescriptions:Array.from((0,n.$Zj)(),p=>`$(${p.id})`)};const c={args:{description:(0,P.localize)(10999,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(11e3,null),type:"boolean"},icon:{description:(0,P.localize)(11001,null),...e.$zs},color:{description:(0,P.localize)(11002,null),...e.$ys},env:{markdownDescription:(0,P.localize)(11003,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},g={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(11004,null),type:["string","array"],items:{type:"string"}},...c}},h={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(11005,null),type:["string"],items:{type:"string"}},...c}};function m(p){const $=p===r.Platform.Linux?"linux":p===r.Platform.Mac?"osx":"windows";return(0,P.localize)(11006,null,(0,r.$i)(p),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,P.localize)(11007,null),type:"object",properties:{[I.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(11008,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(11009,null),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(11010,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},h],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[I.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:m(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(11011,null),enum:["PowerShell","Git Bash"]},...c}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11012,null),type:"string"},id:{description:(0,P.localize)(11013,null),type:"string"},title:{description:(0,P.localize)(11014,null),type:"string"},...c}},{type:"null"},g]}},[I.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:m(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11015,null),type:"string"},id:{description:(0,P.localize)(11016,null),type:"string"},title:{description:(0,P.localize)(11017,null),type:"string"},...c}},{type:"null"},g]}},[I.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:m(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(11018,null),type:"string"},id:{description:(0,P.localize)(11019,null),type:"string"},title:{description:(0,P.localize)(11020,null),type:"string"},...c}},{type:"null"},g]}},[I.TerminalSettingId.UseWslProfiles]:{description:(0,P.localize)(11021,null),type:"boolean",default:!0},[I.TerminalSettingId.InheritEnv]:{scope:R.ConfigurationScope.APPLICATION,description:(0,P.localize)(11022,null),type:"boolean",default:!0},[I.TerminalSettingId.PersistentSessionScrollback]:{scope:R.ConfigurationScope.APPLICATION,markdownDescription:(0,P.localize)(11023,null),type:"number",default:100},[I.TerminalSettingId.ShowLinkHover]:{scope:R.ConfigurationScope.APPLICATION,description:(0,P.localize)(11024,null),type:"boolean",default:!0},[I.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,P.localize)(11025,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){T.$oo.as(R.$to.Configuration).registerConfiguration(b),v()}let d;function v(p,$){const k=T.$oo.as(R.$to.Configuration);let S;p&&(S=(0,w.$us)(p?.profiles,$));const t=d;d={id:"terminal",order:100,title:(0,P.localize)(11026,null),type:"object",properties:{[I.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,P.localize)(11027,null),type:["string","null"],default:null,enum:p?.os===r.OperatingSystem.Linux?S?.values:void 0,markdownEnumDescriptions:p?.os===r.OperatingSystem.Linux?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,P.localize)(11028,null),type:["string","null"],default:null,enum:p?.os===r.OperatingSystem.Macintosh?S?.values:void 0,markdownEnumDescriptions:p?.os===r.OperatingSystem.Macintosh?S?.markdownDescriptions:void 0},[I.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,P.localize)(11029,null),type:["string","null"],default:null,enum:p?.os===r.OperatingSystem.Windows?S?.values:void 0,markdownEnumDescriptions:p?.os===r.OperatingSystem.Windows?S?.markdownDescriptions:void 0}}},k.updateConfigurations({add:[d],remove:t?[t]:[]})}}),define(le[228],ue([0,1,27,11,37,9,3,36,25,12,23,130,224,223]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=f,e.$Ks=d,e.$Ls=v,n=Ie(n),R=Ie(R),I=Ie(I),g=Ie(g);function f(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let E=0;return l&&l.length===4&&(E=parseInt(l[3])),E}async function d(l,E,y,D=I.env,L=g.Promises.exists){if(R.$hc(l))return await L(l)?l:void 0;if(E===void 0&&(E=I.cwd()),R.$lc(l)!=="."){const x=R.$ic(E,l);return await L(x)?x:void 0}const O=(0,P.$io)(D,"PATH");if(y===void 0&&(0,c.$cg)(O)&&(y=O.split(R.$sc)),y===void 0||y.length===0){const x=R.$ic(E,l);return await L(x)?x:void 0}for(const x of y){let H;if(R.$hc(x)?H=R.$ic(x,l):H=R.$ic(E,x,l),await L(H))return H;if(T.$j){let B=H+".com";if(await L(B)||(B=H+".exe",await L(B)))return B}}const W=R.$ic(E,l);return await L(W)?W:void 0}function v(l,E,y,D,L){const A=T.$j&&(!E.windowsEnableConpty||f()<18309);if(!E.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||A)return;const O=l.args,W=I.$cc==="win32"?R.$mc(l.executable).toLowerCase():R.$mc(l.executable),x=R.$lc(r.$Wg.asFileUri("").fsPath);let H;const B={VSCODE_INJECTION:"1"};if(E.shellIntegration.nonce&&(B.VSCODE_NONCE=E.shellIntegration.nonce),T.$j){if(W==="pwsh.exe"||W==="powershell.exe")return!O||s(O)?H=k.get($.WindowsPwsh):o(O)&&(H=k.get($.WindowsPwshLogin)),H?(H=[...H],H[H.length-1]=(0,w.$bf)(H[H.length-1],x,""),B.VSCODE_STABLE=L.quality==="stable"?"1":"0",E.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),{newArgs:H,envMixin:B}):void 0;if(W==="bash.exe")return!O||O.length===0?H=k.get($.Bash):a(O)&&(B.VSCODE_SHELL_LOGIN="1",p(E,B),H=k.get($.Bash)),H?(H=[...H],H[H.length-1]=(0,w.$bf)(H[H.length-1],x),B.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:B}):void 0;D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(W){case"bash":return!O||O.length===0?H=k.get($.Bash):a(O)&&(B.VSCODE_SHELL_LOGIN="1",p(E,B),H=k.get($.Bash)),H?(H=[...H],H[H.length-1]=(0,w.$bf)(H[H.length-1],x),B.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:B}):void 0;case"fish":{const X=y?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",G=R.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return B.XDG_DATA_DIRS=`${X}:${G}`,p(E,B),{newArgs:void 0,envMixin:B}}case"pwsh":return!O||s(O)?H=k.get($.Pwsh):o(O)&&(H=k.get($.PwshLogin)),H?(E.shellIntegration.suggestEnabled&&(B.VSCODE_SUGGEST="1"),H=[...H],H[H.length-1]=(0,w.$bf)(H[H.length-1],x,""),B.VSCODE_STABLE=L.quality==="stable"?"1":"0",{newArgs:H,envMixin:B}):void 0;case"zsh":{if(!O||O.length===0?H=k.get($.Zsh):a(O)?(H=k.get($.ZshLogin),p(E,B)):(O===k.get($.Zsh)||O===k.get($.ZshLogin))&&(H=O),!H)return;H=[...H],H[H.length-1]=(0,w.$bf)(H[H.length-1],x);let X;try{X=n.userInfo().username}catch{X="unknown"}const G=R.$ic(n.tmpdir(),`${X}-${L.applicationName}-zsh`);B.ZDOTDIR=G;const ae=y?.ZDOTDIR??n.homedir()??"~";B.USER_ZDOTDIR=ae;const K=[];return K.push({source:R.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$ic(G,".zshrc")}),K.push({source:R.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$ic(G,".zprofile")}),K.push({source:R.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$ic(G,".zshenv")}),K.push({source:R.$ic(x,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$ic(G,".zlogin")}),{newArgs:H,envMixin:B,filesToCopy:K}}}D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function p(l,E){if(T.$k&&l.environmentVariableCollections){const y=(0,m.$Hs)(l.environmentVariableCollections),L=new b.$Is(y).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),A=[];if(L)for(const O of L)O.type===h.EnvironmentVariableMutatorType.Prepend&&A.push(O.value);A.length>0&&(E.VSCODE_PATH_PREFIX=A.join(""))}}var $;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})($||($={}));const k=new Map;k.set($.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),k.set($.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),k.set($.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),k.set($.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),k.set($.Zsh,["-i"]),k.set($.ZshLogin,["-il"]),k.set($.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],t=["--login","-l"],u=["-i","--interactive"],i=["-nol","-nologo"];function o(l){return typeof l=="string"?S.includes(l.toLowerCase()):l.length===1&&S.includes(l[0].toLowerCase())||l.length===2&&(S.includes(l[0].toLowerCase())||S.includes(l[1].toLowerCase()))&&(i.includes(l[0].toLowerCase())||i.includes(l[1].toLowerCase()))}function s(l){return typeof l=="string"?i.includes(l.toLowerCase()):l.length===0||l?.length===1&&i.includes(l[0].toLowerCase())}function a(l){return typeof l!="string"&&(l=l.filter(E=>!u.includes(E.toLowerCase()))),l==="string"&&t.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&t.includes(l[0].toLowerCase())}}),define(le[229],ue([0,1,26,48,80,9,3,12,23,114,75,228,121]),function(J,e,n,r,P,R,T,I,w,c,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=v,n=Ie(n),r=Ie(r),w=Ie(w);var b;(function(y){y.UnixShellsPath="/etc/shells"})(b||(b={}));let f,d=!0;function v(y,D,L,A,O=process.env,W,x,H,B){return W=W||{existsFile:w.SymlinkSupport.existsFile,readFile:n.promises.readFile},T.$j?p(L,W,O,x,A.getValue(g.TerminalSettingId.UseWslProfiles)!==!1,y&&typeof y=="object"?{...y}:A.getValue(g.TerminalSettingId.ProfilesWindows),typeof D=="string"?D:A.getValue(g.TerminalSettingId.DefaultProfileWindows),B,H):a(W,x,L,y&&typeof y=="object"?{...y}:A.getValue(T.$l?g.TerminalSettingId.ProfilesLinux:g.TerminalSettingId.ProfilesMacOs),typeof D=="string"?D:A.getValue(T.$l?g.TerminalSettingId.DefaultProfileLinux:g.TerminalSettingId.DefaultProfileMacOs),B,H,O)}async function p(y,D,L,A,O,W,x,H,B){const X=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),G=`${process.env.windir}\\${X?"Sysnative":"System32"}`;let ae=!1;(0,h.$Js)()>=16299&&(ae=!0),await t(H);const K=new Map;if(y){K.set("PowerShell",{source:g.ProfileSource.Pwsh,icon:P.$2j.terminalPowershell,isAutoDetected:!0}),K.set("Windows PowerShell",{path:`${G}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.$2j.terminalPowershell,isAutoDetected:!0}),K.set("Git Bash",{source:g.ProfileSource.GitBash,isAutoDetected:!0}),K.set("Command Prompt",{path:`${G}\\cmd.exe`,icon:P.$2j.terminalCmd,isAutoDetected:!0}),K.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),K.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:P.$2j.terminalBash,isAutoDetected:!0});const U=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;K.set("Cmder",{path:`${G}\\cmd.exe`,args:["/K",U],requiresPath:process.env.CMDER_ROOT?U:{path:U,isUnsafe:!0},isAutoDetected:!0})}l(W,K);const te=await $(K.entries(),x,D,L,A,B);if(y&&O)try{const U=await o(`${G}\\${ae?"wsl":"bash"}.exe`,x);for(const j of U)(!W||!(j.profileName in W))&&te.push(j)}catch{d&&(A?.trace("WSL is not installed, so could not detect WSL profiles"),d=!1)}return te}async function $(y,D,L,A=process.env,O,W){const x=[];for(const[H,B]of y)x.push(k(H,B,D,L,A,O,W));return(await Promise.all(x)).filter(H=>!!H)}async function k(y,D,L,A,O=process.env,W,x){if(D===null)return;let H,B,X;if("source"in D&&!("path"in D)){const te=f?.get(D.source);if(!te)return;H=te.paths,B=D.args||te.args,D.icon?X=S(D.icon):te.icon&&(X=te.icon)}else H=Array.isArray(D.path)?D.path:[D.path],B=T.$j||Array.isArray(D.args)?D.args:void 0,X=S(D.icon);let G;if(x){const te=H.map(j=>typeof j=="string"?j:j.path),U=await x(te);G=new Array(H.length);for(let j=0;j<H.length;j++)typeof H[j]=="string"?G[j]=U[j]:G[j]={path:U[j],isUnsafe:!0}}else G=H.slice();let ae;if(D.requiresPath){let te;if((0,I.$cg)(D.requiresPath)?te=D.requiresPath:(te=D.requiresPath.path,D.requiresPath.isUnsafe&&(ae=te)),!await A.existsFile(te))return}const K=await E(y,L,G,A,O,B,D.env,D.overrideName,D.isAutoDetected,ae);if(!K){W?.debug("Terminal profile not validated",y,H);return}return K.isAutoDetected=D.isAutoDetected,K.icon=X,K.color=D.color,K}function S(y){return typeof y=="string"?{id:y}:y}async function t(y){if(f&&!y)return;const[D,L]=await Promise.all([u(),y||i()]);f=new Map,f.set(g.ProfileSource.GitBash,{profileName:"Git Bash",paths:D,args:["--login","-i"]}),f.set(g.ProfileSource.Pwsh,{profileName:"PowerShell",paths:L,icon:P.$2j.terminalPowershell})}async function u(){const y=new Set,D=await(0,h.$Ks)("git.exe");if(D){const O=(0,m.dirname)(D);y.add((0,m.resolve)(O,"../.."))}function L(O,W){W&&O.add(W)}L(y,process.env.ProgramW6432),L(y,process.env.ProgramFiles),L(y,process.env["ProgramFiles(X86)"]),L(y,`${process.env.LocalAppData}\\Program`);const A=[];for(const O of y)A.push(`${O}\\Git\\bin\\bash.exe`,`${O}\\Git\\usr\\bin\\bash.exe`,`${O}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function i(){const y=[];for await(const D of(0,c.$tm)())y.push(D.exePath);return y}async function o(y,D){const L=[],A=await new Promise((x,H)=>{r.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(B,X)=>{if(B)return H("Problem occurred when getting wsl distros");x(X)})});if(!A)return[];const O=new RegExp(/[\r?\n]/),W=A.split(O).filter(x=>x.trim().length>0&&x!=="");for(const x of W){if(x===""||x.startsWith("docker-desktop"))continue;const H=`${x} (WSL)`,B={profileName:H,path:y,args:["-d",`${x}`],isDefault:H===D,icon:s(x),isAutoDetected:!1};L.push(B)}return L}function s(y){return y.includes("Ubuntu")?P.$2j.terminalUbuntu:y.includes("Debian")?P.$2j.terminalDebian:P.$2j.terminalLinux}async function a(y,D,L,A,O,W,x,H){const B=new Map;if(L&&await y.existsFile(b.UnixShellsPath)){const X=(await y.readFile(b.UnixShellsPath)).toString(),G=(W||X.split(`
`)).map(K=>{const te=K.indexOf("#");return te===-1?K:K.substring(0,te)}).filter(K=>K.trim().length>0),ae=new Map;for(const K of G){let te=(0,R.$mc)(K),U=ae.get(te)||0;U++,U>1&&(te=`${te} (${U})`),ae.set(te,U),B.set(te,{path:K,isAutoDetected:!0})}}return l(A,B),await $(B.entries(),O,y,H,D,x)}function l(y,D){if(y)for(const[L,A]of Object.entries(y))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?D.delete(L):(A.icon=A.icon||D.get(L)?.icon,D.set(L,A))}async function E(y,D,L,A,O,W,x,H,B,X){if(L.length===0)return Promise.resolve(void 0);const G=L.shift();if(G==="")return E(y,D,L,A,O,W,x,H,B);const ae=typeof G!="string"&&G.isUnsafe,K=typeof G=="string"?G:G.path,te={profileName:y,path:K,args:W,env:x,overrideName:H,isAutoDetected:B,isDefault:y===D,isUnsafePath:ae,requiresUnsafePath:X};if((0,R.$mc)(K)===K){const j=O.PATH?O.PATH.split(R.$sc):void 0,N=await(0,h.$Ks)(K,void 0,j,void 0,A.existsFile);return N?(te.path=N,te.isFromPath=!0,te):E(y,D,L,A,O,W)}return await A.existsFile((0,R.$gc)(K))?te:E(y,D,L,A,O,W,x,H,B)}}),define(le[230],ue([0,1,4,2,3,44,17,5,192,100,225,75,227,229,116,66]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;var v;(function($){$[$.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let p=class extends r.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(k,S,t,u){super(),this.M=k,this.N=S,this.O=t,this.P=u,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$je),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$je),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$je),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$je),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$je),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$je),this.onProcessData=this.D.event,this.F=this.B(new n.$je),this.onProcessReady=this.F.event,this.G=this.B(new n.$je),this.onProcessReplay=this.G.event,this.H=this.B(new n.$je),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$je),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$je),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$je),this.onProcessExit=this.L.event,(0,m.$As)(),this.B(this.M),this.B((0,r.$Rc)(()=>this.W())),this.j=this.B(new g.$ts(void 0,this.O)),this.B(this.j.onCreateRequest(this.C.fire,this.C)),this.M.onRequestConnection&&this.B(n.Event.once(this.M.onRequestConnection)(()=>this.h())),this.M.onWillShutdown&&this.B(this.M.onWillShutdown(()=>this.m=!0))}get Q(){return this.N.getValue(h.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$j)return process.env;try{return await(0,c.$Om)(this.N,this.O,{_:[]},process.env)}catch(k){return this.O.error("ptyHost was unable to resolve shell environment",k),{}}}U(){const k=this.M.start(),S=k.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(S.getChannel(h.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(k.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=v.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const u=R.ProxyChannel.toService(S.getChannel(h.TerminalIpcChannels.PtyHost));return this.B(u.onProcessData(i=>this.D.fire(i))),this.B(u.onProcessReady(i=>this.F.fire(i))),this.B(u.onProcessExit(i=>this.L.fire(i))),this.B(u.onDidChangeProperty(i=>this.J.fire(i))),this.B(u.onProcessReplay(i=>this.G.fire(i))),this.B(u.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(u.onDidRequestDetach(i=>this.I.fire(i))),this.B(new w.$ss(this.P,S.getChannel(h.TerminalIpcChannels.Logger))),this.a=k,this.b=u,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration(h.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[k,u]}async createProcess(k,S,t,u,i,o,s,a,l,E,y){const D=setTimeout(()=>this.$(),h.HeartbeatConstants.CreateProcessTimeout),L=await this.f.createProcess(k,S,t,u,i,o,s,a,l,E,y);return clearTimeout(D),L}updateTitle(k,S,t){return this.f.updateTitle(k,S,t)}updateIcon(k,S,t,u){return this.f.updateIcon(k,S,t,u)}attachToProcess(k){return this.f.attachToProcess(k)}detachFromProcess(k,S){return this.f.detachFromProcess(k,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(k){return this.f.start(k)}shutdown(k,S){return this.f.shutdown(k,S)}input(k,S){return this.f.input(k,S)}processBinary(k,S){return this.f.processBinary(k,S)}resize(k,S,t){return this.f.resize(k,S,t)}clearBuffer(k){return this.f.clearBuffer(k)}acknowledgeDataEvent(k,S){return this.f.acknowledgeDataEvent(k,S)}setUnicodeVersion(k,S){return this.f.setUnicodeVersion(k,S)}getInitialCwd(k){return this.f.getInitialCwd(k)}getCwd(k){return this.f.getCwd(k)}async getLatency(){const k=new d.$de,S=await this.f.getLatency();return k.stop(),[{label:"ptyhostservice<->ptyhost",latency:k.elapsed()},...S]}orphanQuestionReply(k){return this.f.orphanQuestionReply(k)}installAutoReply(k,S){return this.f.installAutoReply(k,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(k){return this.f.uninstallAutoReply(k)}getDefaultSystemShell(k){return this.g?.getDefaultSystemShell(k)??(0,f.$xm)(k??P.OS,process.env)}async getProfiles(k,S,t,u=!1){const i=await this.S();return(0,b.$Ms)(S,t,u,this.N,i,void 0,this.O,this.bb.bind(this,k))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(k,S){return this.f.getWslPath(k,S)}getRevivedPtyNewId(k,S){return this.f.getRevivedPtyNewId(k,S)}setTerminalLayoutInfo(k){return this.f.setTerminalLayoutInfo(k)}async getTerminalLayoutInfo(k){return this.g?.getTerminalLayoutInfo(k)}async requestDetachInstance(k,S){return this.f.requestDetachInstance(k,S)}async acceptDetachInstanceReply(k,S){return this.f.acceptDetachInstanceReply(k,S)}async freePortKillProcess(k){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(k)}async serializeTerminalState(k){return this.f.serializeTerminalState(k)}async reviveTerminalProcesses(k,S,t){return this.f.reviveTerminalProcesses(k,S,t)}async refreshProperty(k,S){return this.f.refreshProperty(k,S)}async updateProperty(k,S,t){return this.f.updateProperty(k,S,t)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(k){this.ab(),this.s=setTimeout(()=>this.Y(),k?h.HeartbeatConstants.ConnectingBeatInterval:h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier+h.HeartbeatConstants.BeatInterval*h.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${h.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(k,S){return this.j.createRequest({workspaceId:k,originalText:S})}async acceptPtyHostResolvedVariables(k,S){this.j.acceptReply(k,S)}};e.$Ns=p,e.$Ns=p=Ee([re(1,T.$9i),re(2,I.$0j),re(3,I.$$j)],p)}),define(le[76],ue([0,1,13,4,2,3,17,6,34]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=void 0;const c="#FFFFFF",g="#1E1E1E",h="#000000",m="#FFFFFF",b="theme",f="themeBackground",d="windowSplash";var v;(function($){$.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",$.SYSTEM_COLOR_THEME="window.systemColorTheme"})(v||(v={})),e.$Wec=(0,I.$Ci)("themeMainService");let p=class extends P.$Tc{constructor(k,S){super(),this.b=k,this.c=S,this.a=this.B(new r.$je),this.onDidChangeColorScheme=this.a.event,R.$l||this.B(this.c.onDidChangeConfiguration(t=>{(t.affectsConfiguration(v.SYSTEM_COLOR_THEME)||t.affectsConfiguration(v.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(r.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(R.$l||this.c.getValue(v.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.c.getValue(v.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$j){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$k){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$l&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const k=this.getColorScheme();if(k.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return k.dark?h:m;let S=this.b.getItem(f,null);if(!S)switch(this.g()){case"vs":S=c;break;case"hc-black":S=h;break;case"hc-light":S=m;break;default:S=g}return R.$k&&S.toUpperCase()===g&&(S="#171717"),S}g(){switch(this.b.getItem(b,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(k,S){this.b.setItems([{key:b,data:S.baseTheme},{key:f,data:S.colorInfo.background},{key:d,data:S}]),typeof k=="number"&&this.h(k,S),this.f()}h(k,S){for(const t of n.BrowserWindow.getAllWindows())if(t.id===k){t.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(d)}};e.$Xec=p,e.$Xec=p=Ee([re(0,w.$iR),re(1,T.$9i)],p)}),define(le[131],ue([0,1,4,2,3,7,17,6,5]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=h,e.$Ew=b,e.$Fw=f,e.$Hw=d,e.$Jw=v,e.$Kw=p,e.$Bw=(0,I.$Ci)("tunnelService"),e.$Cw=(0,I.$Ci)("sharedTunnelsService");var c;(function(S){S.Http="http",S.Https="https"})(c||(e.TunnelProtocol=c={}));var g;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(g||(e.TunnelPrivacyId=g={}));function h(S){return!!S.forwardPort}var m;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(m||(e.ProvidedOnAutoForward=m={}));function b(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(t)return{address:t[1],port:+t[2]}}function f(S){if(S.scheme!=="http"&&S.scheme!=="https"||!S.query)return;const t=S.query.split("&");for(const u of t){const i=u.split("=")[1];if(/^https?:/.exec(i)){const o=b(R.URI.parse(i));if(o)return o}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(S){return e.$Gw.indexOf(S)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(S){return e.$Iw.indexOf(S)>=0}function p(S,t,u,i){if(u===P.OperatingSystem.Windows)return!1;if(u===P.OperatingSystem.Macintosh&&v(t)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(o?.length===4&&parseInt(o[1])>=18)return!1}return S<1024}class ${constructor(t,u,i){this.remoteAddress=t,this.localAddress=u,this.b=i,this.a=new n.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=$;let k=class extends r.$Tc{constructor(t,u){super(),this.r=t,this.s=u,this.a=new n.$je,this.onTunnelOpened=this.a.event,this.b=new n.$je,this.onTunnelClosed=this.b.event,this.c=new n.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],u=Array.from(this.f.values());for(const i of u){const o=Array.from(i.values());for(const s of o){const a=await s.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:u}of t.values())await u.then(i=>typeof i!="string"?i?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,u,i,o,s){this.z(t,u,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:u,localAddress:i,privacy:o,protocol:s,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,u){(v(t)||d(t))&&(t=e.$Gw[0]);const i=this.D(t,u);if(i)return++i.refcount,i.value}openTunnel(t,u,i,o,s,a=!1,l,E){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${i} on local port ${s}.`);const y=this.g??t;if(!y)return;if(u||(u="localhost"),o||(o=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const D=this.F(y,u,i,o,s,a,l,E);return D?D.then(L=>{if(L){if(typeof L=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(u,i),L}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(u,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const A=this.w(L);return(L.tunnelRemoteHost!==u||L.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&L.privacy!==l&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(A),A}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),D)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const u=this.f.get(t.tunnelRemoteHost);if(u){const i=u.get(t.tunnelRemotePort);i&&(i.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,i))}}}}async y(t,u,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${u}.`);const o=i.value.then(async s=>{s&&typeof s!="string"&&(await s.dispose(!0),this.b.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(u),o}}async closeTunnel(t,u){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${u} `);const i=this.f.get(t);if(i&&i.has(u)){const o=i.get(u);o.refcount=0,await this.y(t,u,o)}}z(t,u,i){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(u,{refcount:1,value:i})}async C(t,u){const i=this.f.get(t);if(i){const o=i.get(u),s=o?await o.value:void 0;(!s||typeof s=="string")&&i.delete(u),i.size===0&&this.f.delete(t)}}D(t,u){const i=[t];d(t)?(i.push(...e.$Gw),i.push(...e.$Iw)):v(t)&&i.push(...e.$Iw);const o=i.map(s=>this.f.get(s));for(const s of o){const a=s?.get(u);if(a)return a}}canTunnel(t){return!!b(t)}G(t,u,i,o,s,a,l){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${i} on local port ${o}.`);const E=i;this.n.add(E);const y=o===void 0?i:o,D={elevationRequired:s?this.isPortPrivileged(y):!1},L={remoteAddress:{host:u,port:i},localAddressPort:o,privacy:a,public:a?a!==g.Private:void 0,protocol:l},A=t.forwardPort(L,D);return A?(this.z(u,i,A),A.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(E)})):this.n.delete(E),A}};e.$Mw=k,e.$Mw=k=Ee([re(0,w.$0j),re(1,T.$9i)],k)}),define(le[49],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AY=e.$zY=e.DisablementReason=e.UpdateType=e.StateType=void 0;var r;(function(T){T.Uninitialized="uninitialized",T.Idle="idle",T.Disabled="disabled",T.CheckingForUpdates="checking for updates",T.AvailableForDownload="available for download",T.Downloading="downloading",T.Downloaded="downloaded",T.Updating="updating",T.Ready="ready"})(r||(e.StateType=r={}));var P;(function(T){T[T.Setup=0]="Setup",T[T.Archive=1]="Archive",T[T.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var R;(function(T){T[T.NotBuilt=0]="NotBuilt",T[T.DisabledByEnvironment=1]="DisabledByEnvironment",T[T.ManuallyDisabled=2]="ManuallyDisabled",T[T.MissingConfiguration=3]="MissingConfiguration",T[T.InvalidConfiguration=4]="InvalidConfiguration",T[T.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$zY={Uninitialized:{type:r.Uninitialized},Disabled:T=>({type:r.Disabled,reason:T}),Idle:(T,I)=>({type:r.Idle,updateType:T,error:I}),CheckingForUpdates:T=>({type:r.CheckingForUpdates,explicit:T}),AvailableForDownload:T=>({type:r.AvailableForDownload,update:T}),Downloading:{type:r.Downloading},Downloaded:T=>({type:r.Downloaded,update:T}),Updating:T=>({type:r.Updating,update:T}),Ready:T=>({type:r.Ready,update:T})},e.$AY=(0,n.$Ci)("updateService")}),define(le[231],ue([0,1,3,10,55,45]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$oo.as(P.$to.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(10912,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(10913,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(10914,null),(0,r.localize)(10915,null),(0,r.localize)(10916,null),(0,r.localize)(10917,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(10918,null),deprecationMessage:(0,r.localize)(10919,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,title:(0,r.localize)(10920,null),description:(0,r.localize)(10921,null),included:n.$j&&!n.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:P.ConfigurationScope.APPLICATION,description:(0,r.localize)(10922,null),tags:["usesOnlineServices"]}}})}),define(le[232],ue([0,1,4,49]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=e.$$fc=void 0;class P{constructor(I){this.a=I}listen(I,w){switch(w){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${w}`)}call(I,w,c){switch(w){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${w}`)}}e.$$fc=P;class R{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new n.$je,this.onStateChange=this.a.event,this.b=r.$zY.Uninitialized,this.c.listen("onStateChange")(w=>this.state=w),this.c.call("_getInitialState").then(w=>this.state=w)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.$_fc=R}),define(le[41],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0,e.$Hl=(0,n.$Ci)("IUriIdentityService")}),define(le[233],ue([0,1,41,172,14,18,144,4,2]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class c{static{this._clock=0}constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let g=class{constructor(m){this.g=m,this.c=new w.$Sc,this.f=2**16;const b=new Map,f=d=>{let v=b.get(d.scheme);return v===void 0&&(v=m.hasProvider(d)&&!this.g.hasCapability(d,P.FileSystemProviderCapabilities.PathCaseSensitive),b.set(d.scheme,v)),v};this.c.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(d=>{b.delete(d.scheme)})),this.extUri=new R.$5g(f),this.d=new T.$Qs((d,v)=>this.extUri.compare(d,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,R.$eh)(m));const b=this.d.get(m);return b?b.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new c(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((f,d)=>f[1].time<d[1].time?1:f[1].time>d[1].time?-1:0);c._clock=0,this.d.clear();const b=this.f*.5;for(let f=0;f<b;f++)this.d.set(m[f][0],m[f][1].touch())}};e.$Rs=g,e.$Rs=g=Ee([re(0,P.$0k)],g),(0,r.$Os)(n.$Hl,g,r.InstantiationType.Delayed)}),define(le[132],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qY=void 0,e.$qY=(0,n.$Ci)("urlService")}),define(le[234],ue([0,1,7]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=e.$hgc=e.$ggc=void 0;class r{constructor(I){this.a=I}listen(I,w){throw new Error(`Event not found: ${w}`)}call(I,w,c){switch(w){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${w}`)}}e.$ggc=r;class P{constructor(I){this.a=I}handleURL(I,w){return this.a.call("handleURL",[I.toJSON(),w])}}e.$hgc=P;class R{constructor(I,w){this.a=I,this.b=w}async routeCall(I,w,c,g){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(Array.isArray(c)&&c.length>0){const h=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",h.toString(!0)),h.query){const m=/\bwindowId=(\d+)/.exec(h.query);if(m){const b=m[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${b}"`,h.toString(!0));const f=new RegExp(`window:${b}`),d=I.connections.find(v=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",v.ctx),f.test(v.ctx)));if(d)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",h.toString(!0)),d;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",h.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",h.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(I,w,c,g)}routeEvent(I,w){throw new Error(`Event not found: ${w}`)}}e.$igc=R}),define(le[235],ue([0,1,8,2,7,28]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sY=e.$rY=void 0;class T extends r.$Tc{constructor(){super(...arguments),this.a=new Set}open(c,g){const h=[...this.a.values()];return(0,n.$Gh)(h.map(m=>()=>m.handleURL(c,g)),void 0,!1).then(m=>m||!1)}registerHandler(c){return this.a.add(c),(0,r.$Rc)(()=>this.a.delete(c))}}e.$rY=T;let I=class extends T{constructor(c){super(),this.b=c}create(c){let{authority:g,path:h,query:m,fragment:b}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&h&&h.indexOf("/")!==0&&(h=`/${h}`),P.URI.from({scheme:this.b.urlProtocol,authority:g,path:h,query:m,fragment:b})}};e.$sY=I,e.$sY=I=Ee([re(0,R.$qk)],I)}),define(le[236],ue([0,1,13,8,4,2,3,7]),function(J,e,n,r,P,R,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class w extends R.$Tc{constructor(g,h,m,b,f,d){if(super(),this.c=h,this.f=d,this.a=[],this.b=0,g&&(d.trace("ElectronURLListener initialUrisToHandle:",g.map($=>$.originalUrl)),this.a=g),T.$j){const $=b.isBuilt?[]:[`"${b.appRoot}"`];$.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,$)}const v=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",($,k)=>({event:$,url:k})),({event:$,url:k})=>($.preventDefault(),k));this.B(v($=>{const k=this.g($);k&&this.c.open(k,{originalUrl:$})})),m.getWindows().filter($=>$.isReady).length>0?(d.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(d.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(m.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return I.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const h of this.a)await this.c.open(h.uri,{originalUrl:h.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",h.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",h.originalUrl),g.push(h));g.length!==0&&(this.a=g,(0,r.$Eh)(()=>this.h(),500,this.q))}}e.$jgc=w}),define(le[237],ue([0,1,4,2,14,60,31]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class I extends r.$Tc{constructor(c,g,h,m,b,f){super(),this.f=c,this.g=g,this.h=h,this.j=m,this.m=b,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$je),this.onDidChangeFile=this.a.event,this.b=R.$Ii.forUris(()=>!(this.capabilities&P.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Ac(d=>this.m.extUri.getComparisonKey(this.t(d))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(d=>this.s(d)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,g){return this.g.open(this.t(c),g)}close(c){return this.g.close(c)}read(c,g,h,m,b){return this.g.read(c,g,h,m,b)}write(c,g,h,m,b){return this.g.write(c,g,h,m,b)}watch(c,g){this.b.set(c,c);const h=this.g.watch(this.t(c),g);return(0,r.$Rc)(()=>{this.b.delete(c),h.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,g,h){return this.g.rename(this.t(c),this.t(g),h)}readFile(c,g){return this.g.readFile(this.t(c),g)}readFileStream(c,g,h){return this.g.readFileStream(this.t(c),g,h)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,g,h){return this.g.writeFile(this.t(c),g,h)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,g){return this.g.delete(this.t(c),g)}copy(c,g,h){if((0,P.$bl)(this.g))return this.g.copy(this.t(c),this.t(g),h);throw new Error("copy not supported")}cloneFile(c,g){if((0,P.$cl)(this.g))return this.g.cloneFile(this.t(c),this.t(g));throw new Error("clone not supported")}s(c){const g=[];for(const h of c){if(h.resource.scheme!==this.f)continue;const m=this.u(h.resource);this.b.findSubstr(m)&&g.push({resource:m,type:h.type,cId:h.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Ygc=I}),define(le[238],ue([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0,e.$Fgc="utilityProcessWorker"}),define(le[239],ue([0,1,6]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0,e.$kgc=(0,n.$Ci)("webviewManagerService")}),define(le[240],ue([0,1,13,2,11,7]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class T extends r.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const w=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,w)}b(w,c){try{const g=R.URI.parse(w.url),h=T.a.get(g.path);if(typeof h=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${h}`,b=P.$Wg.asFileUri(m);return c({path:b.fsPath,headers:{...P.COI.getHeadersFromQuery(w.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$lgc=T}),define(le[50],ue([0,1,3]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7D=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$XD=void 0,e.$YD=r,e.$ZD=P,e.$1D=R,e.$2D=T,e.$3D=I,e.$4D=h,e.$5D=m,e.$6D=b,e.$8D=f,e.$9D=d,e.$0D=v,e.$XD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(p){return typeof p.parentId=="number"}function P(p){return!!p.workspaceUri}function R(p){return!!p.folderUri}function T(p){return!!p.fileUri}function I(p){const $=m(p),k=p.getValue("window.menuBarVisibility");return k==="default"||$&&k==="compact"||n.$k&&n.$n?"classic":k}var w;(function(p){p.TITLE_BAR_STYLE="window.titleBarStyle",p.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(w||(e.TitleBarSetting=w={}));var c;(function(p){p.NATIVE="native",p.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var g;(function(p){p.AUTO="auto",p.WINDOWED="windowed",p.NEVER="never"})(g||(e.CustomTitleBarVisibility=g={}));function h(p,$){return!0}function m(p,$){return $||($=b(p)),$===c.NATIVE}function b(p){if(n.$p)return c.CUSTOM;const $=p.getValue("window");if($){if(n.$k&&$.nativeTabs===!0||n.$k&&$.nativeFullScreen===!1)return c.NATIVE;const t=$.titleBarStyle;if(t===c.NATIVE||t===c.CUSTOM)return t}return n.$l?c.NATIVE:c.CUSTOM}e.$7D=35;function f(p){return!(!n.$j||n.$p||m(p))}function d(p){const $=p.getValue("window");return!$||typeof $.nativeFullScreen!="boolean"||$.nativeTabs?!0:$.nativeFullScreen!==!1}function v(p=0){return Math.pow(1.2,p)}}),define(le[51],ue([0,1,13]),function(J,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Mec=e.$Lec=e.UnloadReason=e.LoadReason=void 0;var r;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(r||(e.LoadReason=r={}));var P;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const R=function(c=I.Normal){return{width:1024,height:768,mode:c}};e.$Lec=R;const T=function(){const h=n.screen.getPrimaryDisplay().workArea,m=Math.max(h.x+h.width/2-800/2,0),b=Math.max(h.y+h.height/2-600/2,0);return{x:m,y:b,width:800,height:600,mode:I.Normal}};e.$Mec=T;var I;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(I||(e.WindowMode=I={}));var w;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(w||(e.WindowError=w={}))}),define(le[241],ue([0,1,8,4,2]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class R extends P.$Tc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:w,getActiveWindowId:c}){super(),this.a=this.B(new P.$Sc),r.Event.latch(r.Event.any(I,w))(this.f,this,this.a),this.b=(0,n.$ph)(()=>c()),(async()=>{try{const h=await this.b;this.c=typeof this.c=="number"?this.c:h}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$rgc=R}),define(le[30],ue([0,1,10,9,60,18,7,6,11]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=c,e.$Ni=g,e.$Qi=h,e.$Ri=m,e.$Si=b,e.$Ti=d,e.$Ui=v,e.$Xi=k,e.$3i=S,e.$4i=t,e.$6i=u,e.$7i=i,e.$8i=o,e.$Li=(0,I.$Ci)("contextService");function c(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.uri)}function g(s){return typeof s?.id=="string"&&!c(s)&&!m(s)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function h(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,r.$mc)(s)}:a?e.$Oi:e.$Pi;const l=s;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function m(s){const a=s;return typeof a?.id=="string"&&T.URI.isUri(a.configPath)}function b(s){const a=s;if(a?.uri)return{id:a.id,uri:T.URI.revive(a.uri)};const l=s;if(l?.configPath)return{id:l.id,configPath:T.URI.revive(l.configPath)};if(s?.id)return{id:s.id}}var f;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function d(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}function v(s){const a=s;return!!(a&&typeof a=="object"&&T.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}class p{constructor(a,l,E,y,D){this.h=a,this.j=E,this.k=y,this.l=D,this.c=P.$Ii.forUris(this.l,()=>!0),this.folders=l}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=P.$Ii.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=p;class ${constructor(a,l){this.raw=l,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.$dh)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=$;function k(s){return new $({uri:s,index:0,name:(0,R.$_g)(s)},{uri:s.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,n.localize)(10864,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function S(s,a){return R.$7g.isEqualOrParent(s,a.untitledWorkspacesHome)}function t(s){let a;return T.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===w.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function u(s){return s.id===e.$5i}function i(s,a){return!S(s,a)&&!t(s)}function o(s){return(typeof s=="string"?(0,r.$nc)(s):(0,R.$bh)(s))===e.$Zi}}),define(le[52],ue([0,1,13,8,46,47,2,78,3,23,10,123,6,5,28,30]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=void 0,e.$Tec=(0,m.$Ci)("dialogMainService");let v=class{constructor($,k){this.d=$,this.e=k,this.a=new Map,this.b=new Map,this.c=new r.$Jh}pickFileFolder($,k){return this.f({...$,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(11404,null)},k)}pickFolder($,k){return this.f({...$,pickFolders:!0,title:(0,g.localize)(11405,null)},k)}pickFile($,k){return this.f({...$,pickFiles:!0,title:(0,g.localize)(11406,null)},k)}pickWorkspace($,k){const S=(0,g.localize)(11407,null),t=(0,R.$4w)((0,g.localize)(11408,null)),u=d.$1i;return this.f({...$,pickFiles:!0,title:S,filters:u,buttonLabel:t},k)}async f($,k){const S={title:$.title,buttonLabel:$.buttonLabel,filters:$.filters,defaultPath:$.defaultPath};(typeof $.pickFiles=="boolean"||typeof $.pickFolders=="boolean")&&(S.properties=void 0,$.pickFiles&&$.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",$.pickFolders?"openDirectory":"openFile","createDirectory"]),w.$k&&S.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(S,(k||n.BrowserWindow.getFocusedWindow())??void 0);if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g($){if($){let k=this.b.get($.id);return k||(k=new r.$Jh,this.b.set($.id,k)),k}else return this.c}showMessageBox($,k){return this.g(k).queue(async()=>{const{options:S,buttonIndeces:t}=(0,h.$$w)($,this.e);let u;return k?u=await n.dialog.showMessageBox(k,S):u=await n.dialog.showMessageBox(S),{response:t[u.response],checkboxChecked:u.checkboxChecked}})}async showSaveDialog($,k){const S=this.j($,k);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePath:""};try{return await this.g(k).queue(async()=>{let t;return k?t=await n.dialog.showSaveDialog(k,$):t=await n.dialog.showSaveDialog($),t.filePath=this.h(t.filePath),t})}finally{(0,T.$Oc)(S)}}h($){return $&&w.$k&&($=(0,I.$km)($)),$}i($){return $.map(k=>this.h(k))}async showOpenDialog($,k){$.defaultPath&&(await c.Promises.exists($.defaultPath)||($.defaultPath=void 0));const S=this.j($,k);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(k).queue(async()=>{let t;return k?t=await n.dialog.showOpenDialog(k,$):t=await n.dialog.showOpenDialog($),t.filePaths=this.i(t.filePaths),t})}finally{(0,T.$Oc)(S)}}j($,k){if(!k)return T.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",$);let S=this.a.get(k.id);S||(S=new Set,this.a.set(k.id,S));const t=(0,P.$qj)($);if(!S.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",$),S.add(t),(0,T.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",$),S?.delete(t),S?.size===0&&this.a.delete(k.id)})}};e.$Uec=v,e.$Uec=v=Ee([re(0,b.$0j),re(1,f.$qk)],v)}),define(le[242],ue([0,1,4,2,82,30]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;class T extends r.$Tc{static{this.a=100}constructor(w,c){super(),this.f=w,this.g=c,this.b=this.B(new n.$je),this.c=new Map,this.h(c.applicationStorage,this.b)}h(w,c){this.B(n.Event.debounce(w.onDidChangeStorage,(g,h)=>(g?g.push(h):g=[h],g),T.a)(g=>{g.length&&c.fire(this.j(g,w))}))}j(w,c){const g=new Map,h=new Set;return w.forEach(m=>{const b=c.get(m.key);typeof b=="string"?g.set(m.key,b):h.add(m.key)}),{changed:Array.from(g.entries()),deleted:Array.from(h.values())}}listen(w,c,g){switch(c){case"onDidChangeStorage":{const h=g.profile?(0,P.$_h)(g.profile):void 0;if(!h)return this.b.event;let m=this.c.get(h.id);return m||(m=this.B(new n.$je),this.h(this.g.profileStorage(h),m),this.c.set(h.id,m)),m.event}}throw new Error(`Event not found: ${c}`)}async call(w,c,g){const h=g.profile?(0,P.$_h)(g.profile):void 0,m=(0,R.$Si)(g.workspace),b=await this.m(h,m);switch(c){case"getItems":return Array.from(b.items.entries());case"updateItems":{const f=g;if(f.insert)for(const[d,v]of f.insert)b.set(d,v);f.delete?.forEach(d=>b.delete(d));break}case"optimize":return b.optimize();case"isUsed":{const f=g.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async m(w,c){let g;c?g=this.g.workspaceStorage(c):w?g=this.g.profileStorage(w):g=this.g.applicationStorage;try{await g.init()}catch(h){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":w?"profile":"application"} storage due to ${h}`)}return g}}e.$8fc=T}),define(le[42],ue([0,1,46,4,2,18,7,10,38,14,6,5,30,31,41,8,33,25,12]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Jl=e.ProfileResourceType=void 0,e.$Il=S,e.$Kl=t,e.$Ll=u;var k;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(k||(e.ProfileResourceType=k={}));function S(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&T.URI.isUri(a.location)&&T.URI.isUri(a.globalStorageHome)&&T.URI.isUri(a.settingsResource)&&T.URI.isUri(a.keybindingsResource)&&T.URI.isUri(a.tasksResource)&&T.URI.isUri(a.snippetsHome)&&T.URI.isUri(a.extensionsResource))}e.$Jl=(0,g.$Ci)("IUserDataProfilesService");function t(s,a){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:T.URI.revive(s.location).with({scheme:a}),globalStorageHome:T.URI.revive(s.globalStorageHome).with({scheme:a}),settingsResource:T.URI.revive(s.settingsResource).with({scheme:a}),keybindingsResource:T.URI.revive(s.keybindingsResource).with({scheme:a}),tasksResource:T.URI.revive(s.tasksResource).with({scheme:a}),snippetsHome:T.URI.revive(s.snippetsHome).with({scheme:a}),extensionsResource:T.URI.revive(s.extensionsResource).with({scheme:a}),cacheHome:T.URI.revive(s.cacheHome).with({scheme:a}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function u(s,a,l,E,y,D){return{id:s,name:a,location:l,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:D&&y?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$dh)(l,"globalStorage"),settingsResource:D&&y?.useDefaultFlags?.settings?D.settingsResource:(0,R.$dh)(l,"settings.json"),keybindingsResource:D&&y?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$dh)(l,"keybindings.json"),tasksResource:D&&y?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$dh)(l,"tasks.json"),snippetsHome:D&&y?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$dh)(l,"snippets"),extensionsResource:D&&y?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$dh)(l,"extensions.json"),cacheHome:(0,R.$dh)(E,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let i=class extends P.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,l,E,y){super(),this.t=a,this.u=l,this.w=E,this.y=y,this.f=!0,this.h=this.B(new r.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new b.$zc,workspaces:new b.$zc,emptyWindows:new Map},this.profilesHome=(0,R.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),l=[a];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,$.$cg)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}l.push(u((0,R.$ah)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},a))}}catch(D){this.y.error(D)}const E=new b.$zc,y=new Map;if(l.length)try{const D=this.Q();if(D.workspaces)for(const[L,A]of Object.entries(D.workspaces)){const O=T.URI.parse(L),W=l.find(x=>x.id===A);W&&E.set(O,W)}if(D.emptyWindows)for(const[L,A]of Object.entries(D.emptyWindows)){const O=l.find(W=>W.id===A);O&&y.set(L,O)}}catch(D){this.y.error(D)}this.z={profiles:l,workspaces:E,emptyWindows:y}}return this.z}D(){const a=u("__default__profile__",(0,I.localize)(10911,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const l="Temp",E=new RegExp(`${(0,p.$ff)(l)}\\s(\\d+)`);let y=0;for(const L of this.profiles){const A=E.exec(L.name),O=A?parseInt(A[1]):0;y=O>y?O:y}const D=`${l} ${y+1}`;return this.createProfile((0,n.$qj)((0,v.$Yg)()).toString(16),D,{transient:!0},a)}async createNamedProfile(a,l,E){return this.createProfile((0,n.$qj)((0,v.$Yg)()).toString(16),a,l,E)}async createProfile(a,l,E,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(a,l,E);return y&&await this.setProfileForWorkspace(y,D),D}async F(a,l,E){if(!(0,$.$cg)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(l);return y||(y=(async()=>{try{if(this.profiles.find(O=>O.name===l||O.id===a))throw new Error(`Profile with ${l} name already exists`);const L=u(a,l,(0,R.$dh)(this.profilesHome,a),this.g,E,this.defaultProfile);await this.u.createFolder(L.location);const A=[];return this.j.fire({profile:L,join(O){A.push(O)}}),await d.Promises.settled(A),this.I([L],[],[]),L}finally{this.r.delete(l)}})(),this.r.set(l,y)),y}async updateProfile(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(y=>y.id===a.id);if(!E)throw new Error(`Profile '${a.name}' does not exist`);return E=u(E.id,l.name??E.name,E.location,this.g,{shortName:l.shortName??E.shortName,icon:l.icon===null?void 0:l.icon??E.icon,transient:l.transient??E.isTransient,useDefaultFlags:l.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(y=>y.id===a.id);if(!l)throw new Error(`Profile '${a.name}' does not exist`);const E=[];this.m.fire({profile:l,join(y){E.push(y)}});try{await Promise.allSettled(E)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(y){(0,c.$ol)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(y=>y.id===l.id);if(!E)throw new Error(`Profile '${l.name}' does not exist`);this.L(a,E)}unsetWorkspace(a,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,l)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(l=>l.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(a.map(l=>this.removeProfile(l)))}getProfileForWorkspace(a){const l=this.G(a),E=T.URI.isUri(l)?this.C.workspaces.get(l):this.C.emptyWindows.get(l);return E||((0,m.$Mi)(a)?this.s.folders.get(a.uri):(0,m.$Ri)(a)?this.s.workspaces.get(a.configPath):this.s.emptyWindows.get(a.id))}G(a){return(0,m.$Mi)(a)?a.uri:(0,m.$Ri)(a)?a.configPath:a.id}H(a){return!!([...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,a.location))||[...this.s.folders.values()].some(l=>this.w.extUri.isEqual(l.location,a.location)))}I(a,l,E){const y=[...this.profiles,...a],D=[],L=this.s.profiles;this.s.profiles=[];for(let A of y){if(A.isDefault||l.some(W=>A.id===W.id))continue;A=E.find(W=>A.id===W.id)??A;const O=L.find(W=>A.id===W.id);if(A.isTransient)this.s.profiles.push(A);else{if(O){for(const[W,x]of this.s.emptyWindows.entries())if(A.id===x.id){this.L({id:W},A);break}for(const[W,x]of this.s.workspaces.entries())if(A.id===x.id){this.L({id:"",configPath:W},A);break}for(const[W,x]of this.s.folders.entries())if(A.id===x.id){this.L({id:"",uri:W},A);break}}D.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(D),this.z=void 0,this.J(a,l,E)}J(a,l,E){this.h.fire({added:a,removed:l,updated:E,all:this.profiles})}L(a,l,E){if(E=l?.isTransient?!0:E,E)(0,m.$Mi)(a)?(this.s.folders.delete(a.uri),l&&this.s.folders.set(a.uri,l)):(0,m.$Ri)(a)?(this.s.workspaces.delete(a.configPath),l&&this.s.workspaces.set(a.configPath,l)):(this.s.emptyWindows.delete(a.id),l&&this.s.emptyWindows.set(a.id,l));else{this.L(a,void 0,!0);const y=this.G(a);T.URI.isUri(y)?(this.C.workspaces.delete(y),l&&this.C.workspaces.set(y,l)):(this.C.emptyWindows.delete(y),l&&this.C.emptyWindows.set(y,l)),this.M()}}M(){const a={};for(const[E,y]of this.C.workspaces.entries())a[E.toString()]=y.id;const l={};for(const[E,y]of this.C.emptyWindows.entries())l[E.toString()]=y.id;this.R({workspaces:a,emptyWindows:l}),this.z=void 0}N(a){const l={},E=this.D();if(a.workspaces)for(const[D,L]of Object.entries(a.workspaces)){const A=T.URI.parse(L);l[D]=this.w.extUri.isEqual(A,E.location)?E.id:this.w.extUri.basename(A)}const y={};if(a.emptyWindows)for(const[D,L]of Object.entries(a.emptyWindows)){const A=T.URI.parse(L);y[D]=this.w.extUri.isEqual(A,E.location)?E.id:this.w.extUri.basename(A)}return{workspaces:l,emptyWindows:y}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$Ml=i,e.$Ml=i=Ee([re(0,w.$Ji),re(1,c.$0k),re(2,f.$Hl),re(3,h.$0j)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$Nl=o}),define(le[86],ue([0,1,8,16,2,4,31,7,126,129,14,6,5,42,41,12,15,24]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class k extends Error{constructor(o,s){super(o),this.code=s}}e.$Fq=k,e.$Gq=(0,h.$Ci)("IExtensionsProfileScannerService");let S=class extends P.$Tc{constructor(o,s,a,l,E,y){super(),this.j=o,this.m=s,this.n=a,this.r=l,this.s=E,this.t=y,this.b=this.B(new R.$je),this.onAddExtensions=this.b.event,this.c=this.B(new R.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$je),this.onDidRemoveExtensions=this.g.event,this.h=new T.$zc}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s,a){const l=[],E=[];try{return await this.u(s,y=>{const D=[];if(a)D.push(...y);else for(const L of y)o.some(([A])=>(0,c.$Jp)(A.identifier,L.identifier)&&A.manifest.version!==L.version)?l.push(L):D.push(L);for(const[L,A]of o){const O=D.findIndex(x=>(0,c.$Jp)(x.identifier,L.identifier)&&x.version===L.manifest.version),W={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:A};O===-1?(E.push(W),D.push(W)):D.splice(O,1,W)}return E.length&&this.b.fire({extensions:E,profileLocation:s}),l.length&&this.f.fire({extensions:l,profileLocation:s}),D}),E.length&&this.c.fire({extensions:E,profileLocation:s}),l.length&&this.g.fire({extensions:l,profileLocation:s}),E}catch(y){throw E.length&&this.c.fire({extensions:E,error:y,profileLocation:s}),l.length&&this.g.fire({extensions:l,error:y,profileLocation:s}),y}}async updateMetadata(o,s){const a=[];return await this.u(s,l=>{const E=[];for(const y of l){const D=o.find(([L])=>(0,c.$Jp)(L.identifier,y.identifier)&&L.manifest.version===y.version);D&&(y.metadata={...y.metadata,...D[1]},a.push(y)),E.push(y)}return E}),a}async removeExtensionFromProfile(o,s){const a=[];try{await this.u(s,l=>{const E=[];for(const y of l)(0,c.$Jp)(y.identifier,o.identifier)?a.push(y):E.push(y);return a.length&&this.f.fire({extensions:a,profileLocation:s}),E}),a.length&&this.g.fire({extensions:a,profileLocation:s})}catch(l){throw a.length&&this.g.fire({extensions:a,error:l,profileLocation:s}),l}}async u(o,s,a){return this.F(o).queue(async()=>{let l=[],E;try{const y=await this.m.readFile(o);E=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,g.$ol)(y)!==g.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(E=await this.D()),!E&&a?.bailOutWhenFileNotFound)throw new k((0,v.$9)(y),$.ERROR_PROFILE_NOT_FOUND)}if(E){Array.isArray(E)||this.w(o);let y=!1;for(const D of E){t(D)||this.w(o);let L;if((0,d.$cg)(D.relativeLocation)&&D.relativeLocation)L=this.z(D.relativeLocation);else if((0,d.$cg)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{L=I.URI.revive(D.location);const A=this.y(L);A&&(y=!0,D.relativeLocation=A)}(0,d.$jg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(y=!0,D.metadata.hasPreReleaseVersion=!0),l.push({identifier:D.identifier,location:L,version:D.version,metadata:D.metadata})}y&&await this.m.writeFile(o,r.$Le.fromString(JSON.stringify(E)))}if(s){l=s(l);const y=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,r.$Le.fromString(JSON.stringify(y)))}return l})}w(o){const s=new k(`Invalid extensions content in ${o.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let a;try{a=(await this.m.readFile(o)).value.toString()}catch(E){if((0,g.$ol)(E)===g.FileOperationResult.FILE_NOT_FOUND)return;throw E}this.t.info("Migrating extensions from old default profile location",o.toString());let l;try{const E=JSON.parse(a);Array.isArray(E)&&E.every(y=>t(y))?l=E:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",E)}catch(E){this.t.error(E)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Le.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(E){if((0,g.$ol)(E)===g.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw E}try{await this.m.del(o)}catch(E){(0,g.$ol)(E)!==g.FileOperationResult.FILE_NOT_FOUND&&this.t.error(E)}try{await this.m.del(s)}catch(E){(0,g.$ol)(E)!==g.FileOperationResult.FILE_NOT_FOUND&&this.t.error(E)}return l})()),this.C}F(o){let s=this.h.get(o);return s||(s=new n.$Jh,this.h.set(o,s)),s}};e.$Hq=S,e.$Hq=S=Ee([re(1,g.$0k),re(2,b.$Jl),re(3,f.$Hl),re(4,p.$9l),re(5,m.$0j)],S);function t(i){return(0,d.$eg)(i)&&(0,w.$hp)(i.identifier)&&(u(i.location)||(0,d.$cg)(i.location)&&i.location)&&((0,d.$jg)(i.relativeLocation)||(0,d.$cg)(i.relativeLocation))&&i.version&&(0,d.$cg)(i.version)}function u(i){return i?(0,d.$cg)(i.path)&&(0,d.$cg)(i.scheme):!1}});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[133],ue([0,1,20,8,37,16,15,43,162,2,11,9,3,18,209,81,12,7,10,38,129,85,208,14,6,5,28,4,82,86,42,41,170]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i,o,s,a,l,E,y,D,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Mq=e.$Lq=e.$Kq=e.Translations=void 0,e.$Nq=X,P=Ie(P),h=Ie(h),m=Ie(m),f=Ie(f),d=et(d);var O;(function(ae){function K(te,U){if(te===U)return!0;const j=Object.keys(te),N=new Set;for(const Y of Object.keys(U))N.add(Y);if(j.length!==N.size)return!1;for(const Y of j){if(te[Y]!==U[Y])return!1;N.delete(Y)}return N.size===0}ae.equals=K})(O||(e.Translations=O={})),e.$Kq=(0,o.$Ci)("IExtensionsScannerService");let W=class extends c.$Tc{constructor(K,te,U,j,N,Y,ie,V,he,oe,ee,M){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=te,this.r=U,this.s=j,this.t=N,this.u=Y,this.w=ie,this.y=V,this.z=he,this.C=oe,this.D=ee,this.F=M,this.g=this.B(new l.$je),this.onDidChangeCache=this.g.event,this.h=(0,b.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(H,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(t.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(t.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Up)(this.w,this.y)),this.G}async scanAllExtensions(K,te,U){const[j,N]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(te)]),Y=U?await this.scanExtensionsUnderDevelopment(K,[...j,...N]):[];return this.L(j,N,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const te=[];te.push(this.M(!!K.useCache,K.language)),te.push(this.N(K.language,!!K.checkControlFile));const[U,j]=await Promise.all(te);return this.J([...U,...j],t.ExtensionType.System,K,!1)}async scanUserExtensions(K){const te=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const U=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.P(te,!!K.profileLocation,t.ExtensionType.User,!K.includeUninstalled,K.language,!0,U,K.productVersion??this.R()),N=K.useCache&&!j.devMode&&j.excludeObsolete?this.m:this.n;let Y;try{Y=await N.scanExtensions(j)}catch(ie){if(ie instanceof y.$Fq&&ie.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Y=await N.scanExtensions(j);else throw ie}return Y=await this.J(Y,t.ExtensionType.User,K,!0),this.y.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(K,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const U=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(j=>j.scheme===g.Schemas.file).map(async j=>{const N=await this.P(j,!1,t.ExtensionType.User,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(N)).map(ie=>(ie.type=te.find(V=>(0,S.$Jp)(V.identifier,ie.identifier))?.type??ie.type,this.n.validate(ie,N)))}))).flat();return this.J(U,"development",K,!0)}return[]}async scanExistingExtension(K,te,U){const j=await this.P(K,!1,te,!0,U.language,!0,void 0,U.productVersion??this.R()),N=await this.n.scanExtension(j);return!N||!U.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(K,te,U){const j=await this.P(K,!1,te,!0,U.language,!0,void 0,U.productVersion??this.R()),N=await this.n.scanOneOrMultipleExtensions(j);return this.J(N,te,U,!0)}async scanMultipleExtensions(K,te,U){const j=[];return await Promise.all(K.map(async N=>{const Y=await this.scanOneOrMultipleExtensions(N,te,U);j.push(...Y)})),this.J(j,te,U,!0)}async scanMetadata(K){const te=(0,b.$dh)(K,"package.json"),U=(await this.w.readFile(te)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(K,te){const U=(0,b.$dh)(K,"package.json"),j=(await this.w.readFile(U)).value.toString(),N=JSON.parse(j);te.isMachineScoped===!1&&delete te.isMachineScoped,te.isBuiltin===!1&&delete te.isBuiltin,N.__metadata={...N.__metadata,...te},await this.w.writeFile((0,b.$dh)(K,"package.json"),R.$Le.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof y.$Fq&&K.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$Le.fromString(JSON.stringify([])))}catch(te){(0,i.$ol)(te)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$9)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,te,U,j){return U.includeAllVersions||(K=this.L(te===t.ExtensionType.System?K:void 0,te===t.ExtensionType.User?K:void 0,te==="development"?K:void 0,await this.getTargetPlatform(),j)),U.includeInvalid||(K=K.filter(N=>N.isValid)),K.sort((N,Y)=>{const ie=h.$mc(N.location.fsPath),V=h.$mc(Y.location.fsPath);return ie<V?-1:ie>V?1:0})}L(K,te,U,j,N){const Y=(V,he,oe)=>{if(V.isValid&&!he.isValid)return!1;if(V.isValid===he.isValid){if(N&&f.gt(V.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(f.eq(V.manifest.version,he.manifest.version)){if(V.type===t.ExtensionType.System)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===j)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return oe?this.y.warn(`Overwriting user extension ${V.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${V.location.path} with ${he.location.path}.`),!0},ie=new t.$qn;return K?.forEach(V=>{const he=ie.get(V.identifier.id);(!he||Y(he,V,!1))&&ie.set(V.identifier.id,V)}),te?.forEach(V=>{const he=ie.get(V.identifier.id);if(!he&&K&&V.type===t.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!he||Y(he,V,!1))&&ie.set(V.identifier.id,V)}),U?.forEach(V=>{const he=ie.get(V.identifier.id);(!he||Y(he,V,!0))&&ie.set(V.identifier.id,V),ie.set(V.identifier.id,V)}),[...ie.values()]}async M(K,te){this.y.trace("Started scanning system extensions");const U=await this.P(this.systemExtensionsLocation,!1,t.ExtensionType.System,!0,te,!0,void 0,this.R()),N=await(K&&!U.devMode?this.j:this.n).scanExtensions(U);return this.y.trace("Scanned system extensions:",N.length),N}async N(K,te){const U=this.z.isBuilt?[]:this.C.builtInExtensions;if(!U?.length)return[];this.y.trace("Started scanning dev system extensions");const j=te?await this.O():{},N=[],Y=p.URI.file(h.$gc(h.$ic(g.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of U){const he=j[V.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":N.push((0,b.$dh)(Y,V.name));break;default:N.push(p.URI.file(he));break}}const ie=await Promise.all(N.map(async V=>this.n.scanExtension(await this.P(V,!1,t.ExtensionType.System,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ie.length),(0,n.$Gb)(ie)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,te,U,j,N,Y,ie,V){const he=await this.f(N??m.$x),oe=await this.Q(K),ee=te&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=ee?await this.Q(ee):void 0;return new x(K,oe,ee,M,te,ie,U,j,Y,V.version,V.date,this.C.commit,!this.z.isBuilt,N,he)}async Q(K){try{const te=await this.w.stat(K);if(typeof te.mtime=="number")return te.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Lq=W,e.$Lq=W=Ee([re(4,D.$Jl),re(5,y.$Gq),re(6,i.$0k),re(7,s.$0j),re(8,k.$Ji),re(9,a.$qk),re(10,L.$Hl),re(11,o.$Bi)],W);class x{constructor(K,te,U,j,N,Y,ie,V,he,oe,ee,M,F,C,z){this.location=K,this.mtime=te,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=j,this.profile=N,this.profileScanOptions=Y,this.type=ie,this.excludeObsolete=V,this.validate=he,this.productVersion=oe,this.productDate=ee,this.productCommit=M,this.devMode=F,this.language=C,this.translations=z}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,te){return(0,b.$9g)(K.location,te.location)&&K.mtime===te.mtime&&(0,b.$9g)(K.applicationExtensionslocation,te.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&K.profile===te.profile&&P.$fo(K.profileScanOptions,te.profileScanOptions)&&K.type===te.type&&K.excludeObsolete===te.excludeObsolete&&K.validate===te.validate&&K.productVersion===te.productVersion&&K.productDate===te.productDate&&K.productCommit===te.productCommit&&K.devMode===te.devMode&&K.language===te.language&&O.equals(K.translations,te.translations)}}e.$Mq=x;let H=class extends c.$Tc{constructor(K,te,U,j,N,Y,ie){super(),this.g=K,this.h=te,this.j=U,this.m=j,this.n=Y,this.r=ie,this.f=N.extensionsEnabledWithApiProposalVersion?.map(V=>V.toLowerCase())??[]}async scanExtensions(K){const te=K.profile?await this.t(K):await this.s(K);let U={};if(K.excludeObsolete&&K.type===t.ExtensionType.User)try{const j=(await this.m.readFile(this.g)).value.toString();U=JSON.parse(j)}catch{}return(0,v.$pg)(U)?te:te.filter(j=>!U[S.$Kp.create(j).toString()])}async s(K){const te=await this.m.resolve(K.location);if(!te.children?.length)return[];const U=await Promise.all(te.children.map(async j=>{if(!j.isDirectory||K.type===t.ExtensionType.User&&(0,b.$ah)(j.resource).indexOf(".")===0)return null;const N=new x(j.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(N)}));return(0,n.$Gb)(U).sort((j,N)=>j.location.path<N.location.path?-1:1)}async t(K){let te=await this.u(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.j.extUri.isEqual(K.location,K.applicationExtensionslocation)){te=te.filter(j=>!j.metadata?.isApplicationScoped);const U=await this.u(K.applicationExtensionslocation,j=>!!j.metadata?.isBuiltin||!!j.metadata?.isApplicationScoped,K);te.push(...U)}return te}async u(K,te,U){const j=await this.h.scanProfileExtensions(K,U.profileScanOptions);if(!j.length)return[];const N=await Promise.all(j.map(async Y=>{if(te(Y)){const ie=new x(Y.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(ie,Y.metadata)}return null}));return(0,n.$Gb)(N)}async scanOneOrMultipleExtensions(K){try{if(await this.m.exists((0,b.$dh)(K.location,"package.json"))){const te=await this.scanExtension(K);return te?[te]:[]}else return await this.scanExtensions(K)}catch(te){return this.r.error(`Error scanning extensions at ${K.location.path}:`,(0,T.$9)(te)),[]}}async scanExtension(K,te){try{let U=await this.w(K.location);if(U){U.publisher||(U.publisher=t.$kn),te=te??U.__metadata,delete U.__metadata;const j=(0,S.$Op)(U.publisher,U.name),N=te?.id?{id:j,uuid:te.id}:{id:j},Y=te?.isSystem?t.ExtensionType.System:K.type,ie=Y===t.ExtensionType.System||!!te?.isBuiltin;U=await this.y(K.location,U,x.createNlsConfiguration(K));let V={type:Y,identifier:N,manifest:U,location:K.location,isBuiltin:ie,targetPlatform:te?.targetPlatform??t.TargetPlatform.UNDEFINED,publisherDisplayName:te?.publisherDisplayName,metadata:te,isValid:!0,validations:[]};return K.validate&&(V=this.validate(V,K)),U.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(j.toLowerCase()))&&(U.originalEnabledApiProposals=U.enabledApiProposals,U.enabledApiProposals=(0,t.$wn)([...U.enabledApiProposals])),V}}catch(U){K.type!==t.ExtensionType.System&&this.r.error(U)}return null}validate(K,te){let U=!0;const j=this.n.isBuilt&&this.f.includes(K.identifier.id.toLowerCase()),N=(0,u.$1p)(te.productVersion,te.productDate,te.location,K.manifest,K.isBuiltin,j);for(const[Y,ie]of N)Y===d.default.Error&&(U=!1,this.r.error(this.F(te.location,ie)));return K.isValid=U,K.validations=N,K}async w(K){const te=(0,b.$dh)(K,"package.json");let U;try{U=(await this.m.readFile(te)).value.toString()}catch(N){return(0,i.$ol)(N)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(K,(0,$.localize)(11294,null,te.path,N.message))),null}let j;try{j=JSON.parse(U)}catch{const Y=[];(0,I.$Vn)(U,Y);for(const ie of Y)this.r.error(this.F(K,(0,$.localize)(11295,null,te.path,ie.offset,ie.length,(0,w.$Iq)(ie.error))));return null}return(0,I.$4n)(j)!=="object"?(this.r.error(this.F(K,(0,$.localize)(11296,null,te.path))),null):j}async y(K,te,U){const j=await this.z(K,te,U);if(j)try{const N=[],Y=await this.C(j.default,N);if(N.length>0)return N.forEach(V=>{this.r.error(this.F(K,(0,$.localize)(11297,null,j.default?.path,(0,w.$Iq)(V.error))))}),te;if((0,I.$4n)(j)!=="object")return this.r.error(this.F(K,(0,$.localize)(11298,null,j.default?.path))),te;const ie=j.values||Object.create(null);return(0,A.$Jq)(this.r,te,ie,Y)}catch{}return te}async z(K,te,U){const j=(0,b.$dh)(K,"package.nls.json"),N=(he,oe)=>{oe.forEach(ee=>{this.r.error(this.F(K,(0,$.localize)(11299,null,he?.path,(0,w.$Iq)(ee.error))))})},Y=he=>{this.r.error(this.F(K,(0,$.localize)(11300,null,he?.path)))},ie=`${te.publisher}.${te.name}`,V=U.translations[ie];if(V)try{const he=p.URI.file(V),oe=(await this.m.readFile(he)).value.toString(),ee=[],M=(0,I.$Vn)(oe,ee);return ee.length>0?(N(he,ee),{values:void 0,default:j}):(0,I.$4n)(M)!=="object"?(Y(he),{values:void 0,default:j}):{values:M.contents?M.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.m.exists(j))return;let oe;try{oe=await this.D(K,U)}catch{return}if(!oe.localized)return{values:void 0,default:oe.original};try{const ee=(await this.m.readFile(oe.localized)).value.toString(),M=[],F=(0,I.$Vn)(ee,M);return M.length>0?(N(oe.localized,M),{values:void 0,default:oe.original}):(0,I.$4n)(F)!=="object"?(Y(oe.localized),{values:void 0,default:oe.original}):{values:F,default:oe.original}}catch{return{values:void 0,default:oe.original}}}}async C(K,te){if(K)try{const U=(await this.m.readFile(K)).value.toString();return(0,I.$Vn)(U,te)}catch{}}D(K,te){return new Promise((U,j)=>{const N=Y=>{const ie=(0,b.$dh)(K,`package.nls.${Y}.json`);this.m.exists(ie).then(V=>{V&&U({localized:ie,original:(0,b.$dh)(K,"package.nls.json")});const he=Y.lastIndexOf("-");he===-1?U({localized:(0,b.$dh)(K,"package.nls.json"),original:null}):(Y=Y.substring(0,he),N(Y))})};if(te.devMode||te.pseudo||!te.language)return U({localized:(0,b.$dh)(K,"package.nls.json"),original:null});N(te.language)})}F(K,te){return`[${K.path}]: ${te}`}};H=Ee([re(1,y.$Gq),re(2,L.$Hl),re(3,i.$0k),re(4,a.$qk),re(5,k.$Ji),re(6,s.$0j)],H);let B=class extends H{constructor(K,te,U,j,N,Y,ie,V,he){super(te,j,N,Y,ie,V,he),this.J=K,this.L=U,this.H=this.B(new r.$Ah(3e3)),this.I=this.B(new l.$je),this.onDidChangeCache=this.I.event}async scanExtensions(K){const te=this.P(K),U=await this.M(te);if(this.G=K,U&&U.input&&x.equals(U.input,this.G))return this.r.debug("Using cached extensions scan result",K.type===t.ExtensionType.System?"system":"user",K.location.toString()),this.H.trigger(()=>this.O()),U.result.map(N=>(N.location=p.URI.revive(N.location),N));const j=await super.scanExtensions(K);return await this.N(te,{input:K,result:j}),j}async M(K){try{const te=await this.m.readFile(K),U=JSON.parse(te.value.toString());return{result:U.result,input:(0,E.$_h)(U.input)}}catch(te){this.r.debug("Error while reading the extension cache file:",K.path,(0,T.$9)(te))}return null}async N(K,te){try{await this.m.writeFile(K,R.$Le.fromString(JSON.stringify(te)))}catch(U){this.r.debug("Error while writing the extension cache file:",K.path,(0,T.$9)(U))}}async O(){if(!this.G)return;const K=this.P(this.G),te=await this.M(K);if(!te)return;const U=te.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!P.$fo(j,U))try{this.r.info("Invalidating Cache",U,j),await this.m.del(K),this.I.fire()}catch(N){this.r.error(N)}}P(K){const te=this.Q(K);return this.j.extUri.joinPath(te.cacheHome,K.type===t.ExtensionType.System?t.$jn:t.$in)}Q(K){return K.type===t.ExtensionType.System?this.L.defaultProfile:K.profile?this.j.extUri.isEqual(K.location,this.J.extensionsResource)?this.J:this.L.profiles.find(te=>this.j.extUri.isEqual(K.location,te.extensionsResource))??this.J:this.L.defaultProfile}};B=Ee([re(2,D.$Jl),re(3,y.$Gq),re(4,L.$Hl),re(5,i.$0k),re(6,a.$qk),re(7,k.$Ji),re(8,s.$0j)],B);function X(ae,K){const te=(0,S.$Mp)(ae.manifest.publisher,ae.manifest.name);return{id:te,identifier:new t.$on(te),isBuiltin:ae.type===t.ExtensionType.System,isUserBuiltin:ae.type===t.ExtensionType.User&&ae.isBuiltin,isUnderDevelopment:K,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,publisherDisplayName:ae.publisherDisplayName,...ae.manifest}}class G extends W{constructor(K,te,U,j,N,Y,ie,V,he,oe,ee,M){super(K,te,(0,b.$dh)(U,".vscode-oss-dev","extensions","control.json"),j,N,Y,ie,V,he,oe,ee,M),this.S=(async()=>{if(m.$A)try{const F=await this.w.readFile(p.URI.file(m.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Oq=G}),define(le[243],ue([0,1,5,42,41,24,86,14,38,7]),function(J,e,n,r,P,R,T,I,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pR=void 0;let g=class extends T.$Hq{constructor(m,b,f,d,v,p){super(c.URI.file(m.extensionsPath),b,f,d,v,p)}};e.$pR=g,e.$pR=g=Ee([re(0,w.$Ki),re(1,I.$0k),re(2,r.$Jl),re(3,P.$Hl),re(4,R.$9l),re(5,n.$0j)],g)}),define(le[244],ue([0,1,7,38,86,133,14,6,5,28,41,42]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;let m=class extends R.$Oq{constructor(f,d,v,p,$,k,S,t){super(n.URI.file($.builtinExtensionsPath),n.URI.file($.extensionsPath),$.userHome,f.defaultProfile,f,d,v,p,$,k,S,t)}};e.$vgc=m,e.$vgc=m=Ee([re(0,h.$Jl),re(1,P.$Gq),re(2,T.$0k),re(3,w.$0j),re(4,r.$Ki),re(5,c.$qk),re(6,g.$Hl),re(7,I.$Bi)],m)}),define(le[245],ue([0,1,13,2,11,9,3,60,7,33,35,38,5,42]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;let f=class extends r.$Tc{constructor(v,p,$){super(),this.c=v,this.f=$,this.a=I.$Ii.forPaths(!T.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(v.appRoot),this.addValidFileRoot(v.extensionsPath),this.addValidFileRoot(p.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(v.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:v}=n.session;v.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(p,$)=>this.j(p,$)),v.protocol.interceptFileProtocol(P.Schemas.file,(p,$)=>this.h(p,$)),this.B((0,r.$Rc)(()=>{v.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),v.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(v){const p=(0,R.$gc)(v);return this.a.get(p)?r.$Tc.None:(this.a.set(p,!0),(0,r.$Rc)(()=>this.a.delete(p)))}h(v,p){const $=w.URI.parse(v.url);return this.f.error(`Refused to load resource ${$.fsPath} from ${P.Schemas.file}: protocol (original URL: ${v.url})`),p({error:-3})}j(v,p){const $=this.m(v);let k;return this.c.crossOriginIsolated&&((0,R.$mc)($)==="workbench.html"||(0,R.$mc)($)==="workbench-dev.html"?k=P.COI.CoopAndCoep:k=P.COI.getHeadersFromQuery(v.url)),this.a.findSubstr($)?p({path:$,headers:k}):this.b.has((0,R.$nc)($).toLowerCase())?p({path:$}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${$} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${v.url})`),p({error:-3}))}m(v){const p=w.URI.parse(v.url),$=P.$Wg.uriToFileUri(p);return(0,R.$gc)($.fsPath)}createIPCObjectUrl(){let v;const p=w.URI.from({scheme:"vscode",path:(0,c.$Yg)()}),$=p.toString(),k=async()=>v;return g.$BX.handle($,k),this.f.trace(`IPC Object URL: Registered new channel ${$}.`),{resource:p,update:S=>v=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${$}.`),g.$BX.removeHandler($)}}}};e.$Pgc=f,e.$Pgc=f=Ee([re(0,h.$Ki),re(1,b.$Jl),re(2,m.$0j)],f)}),define(le[62],ue([0,1,8,4,2,70,12,119,6,42]),function(J,e,n,r,P,R,T,I,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=b,e.$iq=d,e.$kq=p,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,w.$Ci)("storageService");var g;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var h;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(h||(e.StorageScope=h={}));var m;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function b($){const k=$.get(e.$eq);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}class f extends P.$Tc{static{this.a=60*1e3}constructor(k={flushInterval:f.a}){super(),this.m=k,this.b=this.B(new r.$me),this.c=this.B(new r.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$je),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(k,S,t){return r.Event.filter(this.b.event,u=>u.scope===k&&(S===void 0||u.key===S),t)}n(){this.j.value=(0,n.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(k,S){const{key:t,external:u}=S;if(t===e.$eq){switch(k){case h.APPLICATION:this.H=void 0;break;case h.PROFILE:this.F=void 0;break;case h.WORKSPACE:this.C=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:t,target:this.J(k)[t],external:u})}w(k){this.f.fire({reason:k})}get(k,S,t){return this.P(S)?.get(k,t)}getBoolean(k,S,t){return this.P(S)?.getBoolean(k,t)}getNumber(k,S,t){return this.P(S)?.getNumber(k,t)}getObject(k,S,t){return this.P(S)?.getObject(k,t)}storeAll(k,S){this.y(()=>{for(const t of k)this.store(t.key,t.value,t.scope,t.target,S)})}store(k,S,t,u,i=!1){if((0,T.$lg)(S)){this.remove(k,t,i);return}this.y(()=>{this.z(k,t,u),this.P(t)?.set(k,S,i)})}remove(k,S,t=!1){this.y(()=>{this.z(k,S,void 0),this.P(S)?.delete(k,t)})}y(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,S){const t=[],u=this.J(k);for(const i of Object.keys(u))u[i]===S&&t.push(i);return t}z(k,S,t,u=!1){const i=this.J(S);typeof t=="number"?i[k]!==t&&(i[k]=t,this.P(S)?.set(e.$eq,JSON.stringify(i),u)):typeof i[k]=="number"&&(delete i[k],this.P(S)?.set(e.$eq,JSON.stringify(i),u))}get D(){return this.C||(this.C=this.L(h.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(h.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(h.APPLICATION)),this.H}J(k){switch(k){case h.APPLICATION:return this.I;case h.PROFILE:return this.G;default:return this.D}}L(k){const S=this.P(k);return S?b(S):Object.create(null)}isNew(k){return this.getBoolean(e.$dq,k)===!0}async flush(k=g.NONE){this.f.fire({reason:k});const S=this.P(h.APPLICATION),t=this.P(h.PROFILE),u=this.P(h.WORKSPACE);switch(k){case g.NONE:await n.Promises.settled([S?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await n.Promises.settled([S?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.P(h.APPLICATION)?.items??new Map,S=this.P(h.PROFILE)?.items??new Map,t=this.P(h.WORKSPACE)?.items??new Map;return p(k,S,t,this.Q(h.APPLICATION)??"",this.Q(h.PROFILE)??"",this.Q(h.WORKSPACE)??"")}async optimize(k){return await this.flush(),this.P(k)?.optimize()}async switch(k,S){return this.w(g.NONE),(0,c.$Il)(k)?this.R(k,S):this.S(k,S)}M(k,S){return!(k.id===S.id||d(S)&&d(k))}N(k,S,t){this.y(()=>{const u=new Set;for(const[i,o]of k)u.add(i),S.get(i)!==o&&this.u(t,{key:i,external:!0});for(const[i]of S.items)u.has(i)||this.u(t,{key:i,external:!0})})}}e.$hq=f;function d($){return $.isDefault||!!$.useDefaultFlags?.globalState}class v extends f{constructor(){super(),this.U=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$bq(new I.$cq,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(k=>this.u(h.WORKSPACE,k))),this.B(this.W.onDidChangeStorage(k=>this.u(h.PROFILE,k))),this.B(this.U.onDidChangeStorage(k=>this.u(h.APPLICATION,k)))}P(k){switch(k){case h.APPLICATION:return this.U;case h.PROFILE:return this.W;default:return this.X}}Q(k){switch(k){case h.APPLICATION:return"inMemory (application)";case h.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(k){return!1}}e.$jq=v;async function p($,k,S,t,u,i){const o=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,a=new Map;$.forEach((O,W)=>{s.set(W,O),a.set(W,o(O))});const l=new Map,E=new Map;k.forEach((O,W)=>{l.set(W,O),E.set(W,o(O))});const y=new Map,D=new Map;S.forEach((O,W)=>{y.set(W,O),D.set(W,o(O))}),console.group(t!==u?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const L=[];if(s.forEach((O,W)=>{L.push({key:W,value:O})}),console.table(L),console.groupEnd(),console.log(a),t!==u){console.group(`Storage: Profile (path: ${u}, profile specific)`);const O=[];l.forEach((W,x)=>{O.push({key:x,value:W})}),console.table(O),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${i})`);const A=[];y.forEach((O,W)=>{A.push({key:W,value:O})}),console.table(A),console.groupEnd(),console.log(D)}}),define(le[246],ue([0,1,16,33,62]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=R;async function R(T,I,w){let c=w&&w.get("storage.serviceMachineId",P.StorageScope.APPLICATION)||null;if(c)return c;try{const h=(await I.readFile(T.serviceMachineIdResource)).value.toString();c=(0,r.$Xg)(h)?h:null}catch{c=null}if(!c){c=(0,r.$Yg)();try{await I.writeFile(T.serviceMachineIdResource,n.$Le.fromString(c))}catch{}}return w?.store("storage.serviceMachineId",c,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),c}}),define(le[247],ue([0,1,246,24,57]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=R;async function R(T,I,w,c,g,h,m){const b={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${I.nameShort})`};if((0,P.$Bp)(I,w)&&(0,P.$Dp)(c)===r.TelemetryLevel.USAGE){const f=await(0,n.$lq)(w,g,h);b["X-Market-User-Id"]=f,b["VSCode-SessionId"]=m.machineId||f}return b}}),define(le[248],ue([0,1,26,20,8,4,2,9,66,7,23,119,160,5,62,24,30,11]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=e.$jfc=e.$ifc=e.$hfc=void 0,n=Ie(n);class $ extends T.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(s,a){super(),this.m=s,this.n=a,this.b=this.B(new R.$je),this.onDidChangeStorage=this.b.event,this.c=this.B(new R.$je),this.onDidCloseStorage=this.c.event,this.f=this.B(new h.$bq(new h.$cq,{hint:h.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new P.$Zh,this.whenInit=this.h.p,this.j=h.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===h.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(l=>this.b.fire(l))),await this.s(s);const a=s.getBoolean(f.$dq);a===void 0?s.set(f.$dq,!0):a&&s.set(f.$dq,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=h.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===b.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,a){return this.f.get(s,a)}set(s,a){return this.f.set(s,a)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new w.$de(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const a=(0,r.top)(Array.from(this.f.items.entries()).map(([E,y])=>({key:E,length:y.length})),(E,y)=>y.length-E.length,5).map(E=>`${E.key}:${E.length}`).join(", "),l=(await this.n.stat(c.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${l}b, Large Keys: ${a}`)}catch(a){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",a)}}async w(){this.g&&await this.g,this.j=h.StorageState.Closed,await this.f.close()}}class k extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$ic)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,k.y)}constructor(s,a,l,E){super(l,E),this.z=s,this.C=a}async t(){return new h.$bq(new m.$7X(this.path??m.$7X.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:h.StorageHint.STORAGE_IN_MEMORY})}}class S extends k{constructor(s,a,l,E){super(s,a,l,E)}}e.$hfc=S;class t extends k{constructor(s,a,l,E){super(a.defaultProfile,s,l,E)}async s(s){await super.s(s),this.G(s)}G(s){s.get(d.$_l,void 0)===void 0&&s.set(d.$_l,new Date().toUTCString());const l=s.get(d.$$l,void 0),E=new Date().toUTCString();s.set(d.$am,typeof l>"u"?null:l),s.set(d.$$l,E)}}e.$ifc=t;class u extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$ic)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,u.y)}constructor(s,a,l,E,y){super(l,y),this.C=s,this.D=a,this.F=E}async t(){const{storageFilePath:s,wasCreated:a}=await this.H();return new h.$bq(new m.$7X(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?h.StorageHint.STORAGE_IN_MEMORY:a?h.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:m.$7X.IN_MEMORY_PATH,wasCreated:!0};const s=(0,I.$ic)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),a=(0,I.$ic)(s,u.y);return await g.Promises.exists(s)?{storageFilePath:a,wasCreated:!1}:(await n.promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:a,wasCreated:!0})}async I(s){let a;if((0,v.$Mi)(this.C)?a={folder:this.C.uri.toString()}:(0,v.$Ri)(this.C)&&(a={workspace:this.C.configPath.toString()}),a)try{const l=(0,I.$ic)(s,u.z);await g.Promises.exists(l)||await g.Promises.writeFile(l,JSON.stringify(a,void 0,2))}catch(l){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.$jfc=u;class i extends ${get path(){}async t(){return new h.$bq(new h.$cq,{hint:h.StorageHint.STORAGE_IN_MEMORY})}}e.$kfc=i}),define(le[249],ue([0,1,4,2,62]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class R extends r.$Tc{constructor(I,w,c){super(),this.b=I,this.c=w,this.f=c;const g=this.B(new r.$Uc);this.a=this.B(new n.$je({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new r.$Sc;return I.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(w,c)=>(w?w.push(c.key):w=[c.key],w),100)(w=>this.h(w))),I.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(w,c)=>{w||(w=new Map);let g=w.get(c.profile.id);return g||w.set(c.profile.id,g={profile:c.profile,keys:[],storage:c.storage}),g.keys.push(c.key),w},100)(w=>this.j(w))),I}h(I){const w=I.includes(P.$eq)?[this.c.defaultProfile]:[],c=[];if(I=I.filter(g=>g!==P.$eq),I.length){const g=(0,P.$gq)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:I.map(h=>({key:h,scope:P.StorageScope.PROFILE,target:g[h]}))})}this.m(w,c)}j(I){const w=[],c=new Map;for(const[g,h]of I.entries()){h.keys.includes(P.$eq)&&w.push(h.profile);const m=h.keys.filter(b=>b!==P.$eq);if(m.length){const b=(0,P.$gq)(h.storage.storage);c.set(g,{profile:h.profile,changes:m.map(f=>({key:f,scope:P.StorageScope.PROFILE,target:b[f]}))})}}this.m(w,[...c.values()])}m(I,w){(I.length||w.length)&&this.a.fire({valueChanges:w,targetChanges:I})}listen(I,w,c){switch(w){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${w}`)}async call(I,w){throw new Error(`Call not found: ${w}`)}}e.$xgc=R}),define(le[250],ue([0,1,7,38,14,5,34,41,42,12,127]),function(J,e,n,r,P,R,T,I,w,c,g){"use strict";var h,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$oR=e.$nR=e.$mR=void 0;let b=class extends w.$Ml{static{h=this}static{this.a="profileAssociationsMigration"}constructor(p,$,k,S,t){super(k,S,$,t),this.U=p,this.W=k}O(){return this.U.getItem(h.b,[]).map($=>({...$,location:(0,c.$cg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):n.URI.revive($.location)}))}Q(){const p=this.U.getItem(h.c,{});return this.U.getItem(h.a,!1)?p:this.N(p)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$mR=b,e.$mR=b=h=Ee([re(0,T.$hR),re(1,I.$Hl),re(2,r.$Ki),re(3,P.$0k),re(4,R.$0j)],b);let f=m=class extends b{constructor(p,$,k,S,t){super(p,$,k,S,t),this.$=p}P(p){p.length?this.$.setItem(m.b,p.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(m.b)}O(){const p=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(p),this.$.setItem("userDataProfilesMigration",!0)),p}R(p){p.emptyWindows||p.workspaces?this.$.setItem(m.c,p):this.$.removeItem(m.c)}Q(){const p="workspaceAndProfileInfo",$=this.$.getItem(p,void 0);if($){this.$.removeItem(p);const S=$.reduce((t,{workspace:u,profile:i})=>(t[n.URI.revive(u).toString()]=n.URI.revive(i).toString(),t),{});this.$.setItem(m.c,{workspaces:S})}const k=super.Q();return this.$.getItem(m.a,!1)||(this.R(k),this.$.setItem(m.a,!0)),k}};e.$nR=f,e.$nR=f=m=Ee([re(0,T.$iR),re(1,I.$Hl),re(2,r.$Ki),re(3,P.$0k),re(4,R.$0j)],f);let d=class extends f{constructor(p,$,k,S){super(new g.$lR(g.SaveStrategy.IMMEDIATE,$,S,k),p,$,k,S)}async init(){return await this.$.init(),super.init()}};e.$oR=d,e.$oR=d=Ee([re(0,I.$Hl),re(1,r.$Ki),re(2,P.$0k),re(3,R.$0j)],d)}),define(le[58],ue([0,1,38,14,6,5,41,42,250,34]),function(J,e,n,r,P,R,T,I,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0,e.$2ec=(0,P.$Di)(I.$Jl);let g=class extends w.$nR{constructor(m,b,f,d,v){super(m,b,f,d,v)}getAssociatedEmptyWindows(){const m=[];for(const b of this.C.emptyWindows.keys())m.push({id:b});return m}};e.$3ec=g,e.$3ec=g=Ee([re(0,c.$iR),re(1,T.$Hl),re(2,n.$Ki),re(3,r.$0k),re(4,R.$0j)],g)}),define(le[134],ue([0,1,18,7,30]),function(J,e,n,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=R,e.$5ec=T,e.$6ec=I;async function R(w,c,g){for(const m of w){const b=m.openedWorkspace;if((0,P.$Ri)(b)){const f=await g(b);if(f){if(f.folders.some(d=>n.$7g.isEqualOrParent(c,d.uri)))return m}else if(n.$7g.isEqualOrParent(c,b.configPath))return m}}const h=w.filter(m=>(0,P.$Mi)(m.openedWorkspace)&&n.$7g.isEqualOrParent(c,m.openedWorkspace.uri));if(h.length)return h.sort((m,b)=>-(m.openedWorkspace.uri.path.length-b.openedWorkspace.uri.path.length))[0]}function T(w,c){for(const g of w)if((0,P.$Ri)(g.openedWorkspace)&&n.$7g.isEqual(g.openedWorkspace.configPath,c)||(0,P.$Mi)(g.openedWorkspace)&&n.$7g.isEqual(g.openedWorkspace.uri,c))return g}function I(w,c){const g=h=>c.some(m=>n.$7g.isEqual(r.URI.file(m),r.URI.file(h)));for(const h of w)if(h.config?.extensionDevelopmentPath?.some(m=>g(m)))return h}}),define(le[102],ue([0,1,32,43,107,47,11,9,3,18,7,6,74,30]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhb=void 0,e.$Vhb=f,e.$Whb=d,e.$Xhb=v,e.$Yhb=p,e.$Zhb=S,e.$1hb=u,e.$2hb=i,e.$3hb=E,e.$4hb=y,r=Ie(r),P=Ie(P),e.$Uhb=(0,h.$Ci)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}function d(D){return D.hasOwnProperty("folderUri")}function v(D){return D.hasOwnProperty("fileUri")}function p(D){return $(D)||k(D)}function $(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function k(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function S(D,L,A,O,W){if(D.scheme!==O.scheme)return{name:A,uri:D.toString(!0)};let x=L?void 0:W.relativePath(O,D);if(x!==void 0)x.length===0?x=".":w.$j&&(x=t(x));else if(D.scheme===T.Schemas.file)x=D.fsPath,w.$j&&(x=t(x));else if(W.isEqualAuthority(D.authority,O.authority))x=D.path;else return{name:A,uri:D.toString(!0)};return{name:A,path:x}}function t(D){return D=(0,R.$Xw)(D),(0,n.$yg)(D)||(D=(0,n.$vg)(D)),D}function u(D,L,A){const O=[],W=new Set,x=A.dirname(L);for(const H of D){let B;if($(H))H.path&&(B=A.resolvePath(x,H.path));else if(k(H))try{B=g.URI.parse(H.uri),B.path[0]!==I.$fc.sep&&(B=B.with({path:I.$fc.sep+B.path}))}catch(X){console.warn(X)}if(B){const X=A.getComparisonKey(B);if(!W.has(X)){W.add(X);const G=H.name||A.basenameOrAuthority(B);O.push(new b.$Wi({uri:B,name:G,index:O.length},H))}}}return O}function i(D,L,A,O,W){const x=o(L,D),H=W.dirname(L),B=W.dirname(O),X=[];for(const te of x.folders){const U=$(te)?W.resolvePath(H,te.path):g.URI.parse(te.uri);let j;A?j=!1:j=!$(te)||(0,I.$hc)(te.path),X.push(S(U,j,te.name,B,W))}const G={insertSpaces:!1,tabSize:4,eol:w.$l||w.$k?`
`:`\r
`},ae=P.$0n(D,["folders"],X,G);let K=P.$ao(D,ae);return(0,c.$ih)(x.remoteAuthority,(0,m.$en)(O))&&(K=P.$ao(K,P.$9n(K,["remoteAuthority"],G))),K}function o(D,L){const A=r.$Vn(L);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(O=>p(O));else throw new Error(`${D} looks like an invalid workspace file.`);return A}function s(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function a(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function E(D,L){const A={workspaces:[],files:[]};if(D){const O=function(x,H){for(let B=0;B<x.length;B++)try{H(x[B],B)}catch(X){L.warn(`Error restoring recent entry ${JSON.stringify(x[B])}: ${X.toString()}. Skip entry.`)}},W=D;Array.isArray(W.entries)&&O(W.entries,x=>{const H=x.label,B=x.remoteAuthority;s(x)?A.workspaces.push({label:H,remoteAuthority:B,workspace:{id:x.workspace.id,configPath:g.URI.parse(x.workspace.configPath)}}):a(x)?A.workspaces.push({label:H,remoteAuthority:B,folderUri:g.URI.parse(x.folderUri)}):l(x)&&A.files.push({label:H,remoteAuthority:B,fileUri:g.URI.parse(x.fileUri)})})}return A}function y(D){const L={entries:[]};for(const A of D.workspaces)d(A)?L.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):L.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of D.files)L.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return L}}),define(le[103],ue([0,1,91,11,3,18]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0,e.$8ec=T,e.$9ec=I,e.$0ec=w,e.$7ec=128/4;function T(c){function g(){let h=c.scheme===r.Schemas.file?(0,R.$4g)(c):c.toString();return P.$l||(h=h.toLowerCase()),(0,n.createHash)("md5").update(h).digest("hex")}return{id:g(),configPath:c}}function I(c,g){function h(){if(c.scheme!==r.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!g)return;let b;return P.$l?b=g.ino:P.$k?b=g.birthtime.getTime():P.$j&&(typeof g.birthtimeMs=="number"?b=Math.floor(g.birthtimeMs):b=g.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(b?String(b):"").digest("hex")}const m=h();if(typeof m=="string")return{id:m,uri:c}}function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[104],ue([0,1,91,93,27,251,16,15,4,2,9,3,33,44,117]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=s,e.$vi=a,e.$xi=y,e.$yi=D;const d=3e4;class v{traceSocketEvent(A,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,O)}constructor(A,O=""){this.f=!0,this.debugLabel=O,this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=x=>{if(this.traceSocketEvent(f.SocketDiagnosticsEventType.Error,{code:x?.code,message:x?.message}),x){if(x.code==="EPIPE")return;(0,I.$Y)(x)}},this.socket.on("error",this.a);let W;this.b=x=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Close,{hadError:x}),this.f=!1,W&&clearTimeout(W)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,W=setTimeout(()=>A.destroy(),d)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(A){const O=W=>{this.traceSocketEvent(f.SocketDiagnosticsEventType.Read,W),A(T.$Le.wrap(W))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(A){const O=W=>{A({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:W,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(A){const O=()=>{A()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(A){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(f.SocketDiagnosticsEventType.Write,A),this.socket.write(A.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,I.$Y)(O)}}end(){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((A,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A();return}const W=()=>{this.socket.off("close",W),this.socket.off("end",W),this.socket.off("error",W),this.socket.off("timeout",W),this.socket.off("drain",W),this.traceSocketEvent(f.SocketDiagnosticsEventType.NodeDrainEnd),A()};this.socket.on("close",W),this.socket.on("end",W),this.socket.on("error",W),this.socket.on("timeout",W),this.socket.on("drain",W)})}}e.$ri=v;var p;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize",L[L.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var $;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})($||($={}));class k extends c.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(A,O){this.socket.traceSocketEvent(A,O)}constructor(A,O,W,x){super(),this.f=this.B(new w.$je),this.g=this.B(new w.$je),this.h=!1,this.j={state:$.PeekHeader,readLen:p.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent(f.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:W?.byteLength||0,recordInflateBytes:x}),this.a=this.B(new S(this,O,W,x,this.f,(H,B)=>this.m(H,B))),this.B(this.a.onError(H=>{console.error(H),(0,I.$Y)(H),this.g.fire({type:f.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:H})})),this.b=new f.$mi,this.B(this.socket.onData(H=>this.n(H))),this.B(this.socket.onClose(async H=>{this.a.isProcessingReadQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(H)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this.f.event(A)}onClose(A){return this.g.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let O=0;for(;O<A.byteLength;)this.a.writeMessage(A.slice(O,Math.min(O+p.MaxWebSocketMessageLength,A.byteLength)),{compressed:!0,opcode:2}),O+=p.MaxWebSocketMessageLength}m(A,{compressed:O,opcode:W}){if(this.h)return;this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,A);let x=p.MinHeaderByteSize;A.byteLength<126?x+=0:A.byteLength<2**16?x+=2:x+=8;const H=T.$Le.alloc(x),B=O?64:0,X=W&15;if(H.writeUInt8(128|B|X,0),A.byteLength<126)H.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){H.writeUInt8(126,1);let G=1;H.writeUInt8(A.byteLength>>>8&255,++G),H.writeUInt8(A.byteLength>>>0&255,++G)}else{H.writeUInt8(127,1);let G=1;H.writeUInt8(0,++G),H.writeUInt8(0,++G),H.writeUInt8(0,++G),H.writeUInt8(0,++G),H.writeUInt8(A.byteLength>>>24&255,++G),H.writeUInt8(A.byteLength>>>16&255,++G),H.writeUInt8(A.byteLength>>>8&255,++G),H.writeUInt8(A.byteLength>>>0&255,++G)}this.socket.write(T.$Le.concat([H,A]))}end(){this.h=!0,this.socket.end()}n(A){if(A.byteLength!==0){for(this.b.acceptChunk(A);this.b.byteLength>=this.j.readLen;)if(this.j.state===$.PeekHeader){const O=this.b.peek(this.j.readLen),W=O.readUInt8(0),x=(W&128)>>>7,H=(W&64)>>>6,B=W&15,X=O.readUInt8(1),G=(X&128)>>>7,ae=X&127;this.j.state=$.ReadHeader,this.j.readLen=p.MinHeaderByteSize+(G?4:0)+(ae===126?2:0)+(ae===127?8:0),this.j.fin=x,this.j.firstFrameOfMessage&&(this.j.compressed=!!H),this.j.firstFrameOfMessage=!!x,this.j.mask=0,this.j.opcode=B,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===$.ReadHeader){const O=this.b.read(this.j.readLen),W=O.readUInt8(1),x=(W&128)>>>7;let H=W&127,B=1;H===126?H=O.readUInt8(++B)*2**8+O.readUInt8(++B):H===127&&(H=O.readUInt8(++B)*0+O.readUInt8(++B)*0+O.readUInt8(++B)*0+O.readUInt8(++B)*0+O.readUInt8(++B)*2**24+O.readUInt8(++B)*2**16+O.readUInt8(++B)*2**8+O.readUInt8(++B));let X=0;x&&(X=O.readUInt8(++B)*2**24+O.readUInt8(++B)*2**16+O.readUInt8(++B)*2**8+O.readUInt8(++B)),this.j.state=$.ReadBody,this.j.readLen=H,this.j.mask=X,this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===$.ReadBody){const O=this.b.read(this.j.readLen);this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,O),i(O,this.j.mask),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,O),this.j.state=$.PeekHeader,this.j.readLen=p.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(f.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=k;class S extends c.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Le.alloc(0)}constructor(A,O,W,x,H,B){super(),this.n=A,this.r=H,this.s=B,this.a=this.B(new w.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new w.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new w.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new t(this.n,x,W,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(A,O){this.g.push({data:A,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:A,options:O}=this.g.shift();if(this.f&&O.compressed){const W=await this.w(this.f,A);this.s(W,O)}else this.s(A,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(A,O){return new Promise((W,x)=>{A.write(O),A.flush(H=>W(H))})}acceptFrame(A,O,W){this.h.push({data:A,isCompressed:O,isLastFrameOfMessage:W}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const A=this.h.shift();if(this.b&&A.isCompressed){const O=await this.C(this.b,A.data,A.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(A.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(A,O,W){return new Promise((x,H)=>{A.write(O),W&&A.write(T.$Le.fromByteArray([0,0,255,255])),A.flush(B=>x(B))})}}class t extends c.$Tc{get recordedInflateBytes(){return this.j?T.$Le.concat(this.f):T.$Le.alloc(0)}constructor(A,O,W,x){super(),this.h=A,this.j=O,this.a=this.B(new w.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(x),this.b.on("error",H=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateError,{message:H?.message,code:H?.code}),this.a.fire(H)}),this.b.on("data",H=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateData,H),this.g.push(T.$Le.wrap(H))}),W&&(this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialWrite,W.buffer),this.b.write(W.buffer),this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(A){this.j&&this.f.push(A.clone()),this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateWrite,A),this.b.write(A.buffer)}flush(A){this.b.flush(()=>{this.h.traceSocketEvent(f.SocketDiagnosticsEventType.zlibInflateFlushFired);const O=T.$Le.concat(this.g);this.g.length=0,A(O)})}}class u extends c.$Tc{constructor(A,O){super(),this.g=A,this.a=this.B(new w.$je),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",W=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateError,{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateData,W),this.f.push(T.$Le.wrap(W))})}write(A){this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateWrite,A.buffer),this.b.write(A.buffer)}flush(A){this.b.flush(2,()=>{this.g.traceSocketEvent(f.SocketDiagnosticsEventType.zlibDeflateFlushFired);let O=T.$Le.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),A(O)})}}function i(L,A){if(A===0)return;const O=L.byteLength>>>2;for(let G=0;G<O;G++){const ae=L.readUInt32BE(G*4);L.writeUInt32BE(ae^A,G*4)}const W=O*4,x=L.byteLength-W,H=A>>>24&255,B=A>>>16&255,X=A>>>8&255;x>=1&&L.writeUInt8(L.readUInt8(W)^H,W),x>=2&&L.writeUInt8(L.readUInt8(W+1)^B,W+1),x>=3&&L.writeUInt8(L.readUInt8(W+2)^X,W+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const o={[h.Platform.Linux]:107,[h.Platform.Mac]:103};function s(){const L=(0,m.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;const A=process.platform!=="darwin"&&e.$ti?e.$ti:(0,P.tmpdir)(),O=(0,g.$ic)(A,`vscode-ipc-${L}.sock`);return l(O),O}function a(L,A,O){const x=(0,n.createHash)("sha256").update(L).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${x}-${O}-${A}-sock`;const H=O.substr(0,4),B=A.substr(0,6);let X;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?X=(0,g.$ic)(e.$ti,`vscode-${x}-${H}-${B}.sock`):X=(0,g.$ic)(L,`${H}-${B}.sock`),l(X),X}function l(L){const A=o[h.$v];typeof A=="number"&&L.length>=A&&console.warn(`WARNING: IPC handle "${L}" is longer than ${A} chars, try a shorter --user-data-dir`)}class E extends b.$gi{static b(A){const O=w.Event.fromNodeEventEmitter(A,"connection");return w.Event.map(O,W=>({protocol:new f.$ni(new v(W,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(W,"close"))}))}constructor(A){super(E.b(A)),this.d=A}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=E;function y(L){return new Promise((A,O)=>{const W=(0,r.createServer)();W.on("error",O),W.listen(L,()=>{W.removeListener("error",O),A(new E(W))})})}function D(L,A){return new Promise((O,W)=>{const x=(0,r.createConnection)(L,()=>{x.removeListener("error",W),O(f.$oi.fromSocket(new v(x,`ipc-client${A}`),A))});x.once("error",W)})}}),define(le[22],ue([0,1,53,9,3,104,38,95,6]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=e.$Nec=void 0,e.$Nec=(0,w.$Di)(T.$Ji);class c extends I.$6m{constructor(){super(...arguments),this.d={}}get backupHome(){return(0,r.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$vi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,r.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$l){for(const h in process.env)if(h.endsWith("_VSCODE_SNAP_ORIG")){const m=h.slice(0,-17);if(this.d[m])continue;process.env[m]&&(this.d[m]=process.env[m]),process.env[h]?process.env[m]=process.env[h]:delete process.env[m]}}}restoreSnapExportedVariables(){if(P.$l)for(const h in this.d)process.env[h]=this.d[h],delete this.d[h]}}e.$Oec=c,Ee([n.$7h],c.prototype,"backupHome",null),Ee([n.$7h],c.prototype,"mainIPCHandle",null),Ee([n.$7h],c.prototype,"mainLockfile",null),Ee([n.$7h],c.prototype,"disableUpdates",null),Ee([n.$7h],c.prototype,"crossOriginIsolated",null),Ee([n.$7h],c.prototype,"codeCachePath",null),Ee([n.$7h],c.prototype,"useCodeCache",null)}),define(le[252],ue([0,1,91,32,11,9,3,18,23,164,17,22,34,14,5,163,30,103]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;let k=class{static{$=this}static{this.a="backupWorkspaces"}constructor(t,u,i,o){this.j=t,this.k=u,this.l=i,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.$7g,this.i={isEqual:(s,a)=>(0,r.$Ag)(s,a,!T.$l)}}async initialize(){const t=this.m.getItem($.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(t.emptyWindows),this.d=await this.u((0,c.$Qec)(t)),this.e=await this.v((0,c.$Rec)(t)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==b.$wl.OFF}q(){return this.s()===b.$wl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||b.$wl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(t,u){this.d.some(o=>t.workspace.id===o.workspace.id)||(this.d.push(t),this.C());const i=(0,R.$ic)(this.c,t.workspace.id);return u?this.t(i,u).then(()=>i):i}async t(t,u){if(await w.Promises.exists(t)&&await this.z(t),await w.Promises.exists(u))try{await w.Promises.rename(u,t,!1)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(t){return this.e.some(u=>this.h.isEqual(t.folderUri,u.folderUri))||(this.e.push(t),this.C()),(0,R.$ic)(this.c,this.D(t))}registerEmptyWindowBackup(t){return this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.backupFolder))||(this.g.push(t),this.C()),(0,R.$ic)(this.c,t.backupFolder)}async u(t){if(!Array.isArray(t))return[];const u=new Set,i=[];for(const o of t){const s=o.workspace;if(!(0,v.$Ri)(s))return[];if(!u.has(s.id)){u.add(s.id);const a=(0,R.$ic)(this.c,s.id);await this.B(a)?s.configPath.scheme!==P.Schemas.file||await w.Promises.exists(s.configPath.fsPath)?i.push(o):await this.z(a):await this.x(a)}}return i}async v(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.folderUri,a=this.h.getComparisonKey(s);if(!i.has(a)){i.add(a);const l=(0,R.$ic)(this.c,this.D(o));await this.B(l)?s.scheme!==P.Schemas.file||await w.Promises.exists(s.fsPath)?u.push(o):await this.z(l):await this.x(l)}}return u}async w(t){if(!Array.isArray(t))return[];const u=[],i=new Set;for(const o of t){const s=o.backupFolder;if(typeof s!="string")return[];if(!i.has(s)){i.add(s);const a=(0,R.$ic)(this.c,s);await this.B(a)?u.push(o):await this.x(a)}}return u}async x(t){try{await w.Promises.rm(t,w.RimRafMode.MOVE)}catch(u){this.l.error(`Backup: Could not delete stale backup: ${u.toString()}`)}}y(){let t=(0,p.$0ec)();for(;this.g.some(u=>!!u.backupFolder&&this.i.isEqual(u.backupFolder,t.id));)t=(0,p.$0ec)();return{backupFolder:t.id}}async z(t){const u=this.y(),i=(0,R.$ic)(this.c,u.backupFolder);try{await w.Promises.rename(t,i,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(u),!0}async getDirtyWorkspaces(){const t=[];for(const u of this.d)await this.A(u)&&t.push(u);for(const u of this.e)await this.A(u)&&t.push(u);return t}A(t){let u;return(0,c.$Pec)(t)?u=(0,R.$ic)(this.c,t.backupFolder):(0,d.$Shb)(t)?u=(0,R.$ic)(this.c,this.D(t)):u=(0,R.$ic)(this.c,t.workspace.id),this.B(u)}async B(t){try{const u=await w.Promises.readdir(t);for(const i of u)try{if((await w.Promises.readdir((0,R.$ic)(t,i))).length>0)return!0}catch{}}catch{}return!1}C(){const t={workspaces:this.d.map(({workspace:u,remoteAuthority:i})=>{const o={id:u.id,configURIPath:u.configPath.toString()};return i&&(o.remoteAuthority=i),o}),folders:this.e.map(({folderUri:u,remoteAuthority:i})=>{const o={folderUri:u.toString()};return i&&(o.remoteAuthority=i),o}),emptyWindows:this.g.map(({backupFolder:u,remoteAuthority:i})=>{const o={backupFolder:u};return i&&(o.remoteAuthority=i),o})};this.m.setItem($.a,t)}D(t){const u=t.folderUri;let i;return u.scheme===P.Schemas.file?i=T.$l?u.fsPath:u.fsPath.toLowerCase():i=u.toString().toLowerCase(),(0,n.createHash)("md5").update(i).digest("hex")}};e.$rfc=k,e.$rfc=k=$=Ee([re(0,h.$Nec),re(1,g.$9i),re(2,f.$0j),re(3,m.$iR)],k)}),define(le[19],ue([0,1,13,35,8,4,2,3,36,12,6,5,34,51,22]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.LifecycleMainPhase=e.ShutdownReason=e.$ffc=void 0,e.$ffc=(0,g.$Ci)("lifecycleMainService");var v;(function(k){k[k.QUIT=1]="QUIT",k[k.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var p;(function(k){k[k.Starting=1]="Starting",k[k.Ready=2]="Ready",k[k.AfterWindowOpen=3]="AfterWindowOpen",k[k.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let $=class extends T.$Tc{static{d=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(S,t,u){super(),this.F=S,this.G=t,this.H=u,this.c=this.B(new R.$je),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$je),this.onWillShutdown=this.f.event,this.g=this.B(new R.$je),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$je),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=p.Starting,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(p.Ready).then(()=>this.J())}I(){this.m=!!this.G.getItem(d.b),this.m&&this.G.removeItem(d.b)}J(){const S=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.$k&&this.t===0&&this.L(v.QUIT))};n.app.addListener("before-quit",S);const t=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!I.$k)&&n.app.quit()};n.app.addListener("window-all-closed",t),n.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(v.QUIT).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",S),n.app.removeListener("window-all-closed",t),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(S){if(this.y)return this.y;const t=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:S,join(i,o){t.trace(`Lifecycle#onWillShutdown - begin '${i}'`),u.push(o.finally(()=>{t.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(u)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(S){if(S<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===S)return;this.S(`lifecycle (main): phase changed (value: ${S})`),this.n=S;const t=this.C.get(this.n);t&&(t.open(),this.C.delete(this.n))}async when(S){if(S<=this.n)return;let t=this.C.get(S);t||(t=new P.$Bh,this.C.set(S,t)),await t.wait()}registerWindow(S){const t=new T.$Sc;this.t++,t.add(S.onWillLoad(i=>this.g.fire({window:S,workspace:i.workspace,reason:i.reason})));const u=(0,c.$ng)(S.win);t.add(R.Event.fromNodeEventEmitter(u,"close")(i=>{const o=S.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${S.id}`),i.preventDefault(),this.unload(S,b.UnloadReason.CLOSE).then(s=>{if(s){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(S),S.close()})})),t.add(R.Event.fromNodeEventEmitter(u,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${S.id}`),this.t--,t.dispose(),this.t===0&&(!I.$k||this.j)&&this.L(v.QUIT)}))}registerAuxWindow(S){const t=(0,c.$ng)(S.win),u=new T.$Sc;u.add(R.Event.fromNodeEventEmitter(t,"close")(i=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${S.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),i.preventDefault())})),u.add(R.Event.fromNodeEventEmitter(t,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${S.id}`),u.dispose()}))}async reload(S,t){await this.unload(S,b.UnloadReason.RELOAD)||S.reload(t)}unload(S,t){const u=this.z.get(S.id);if(u)return u;const i=this.M(S,t).finally(()=>{this.z.delete(S.id)});return this.z.set(S.id,i),i}async M(S,t){if(!S.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${S.id}`);const u=this.j?b.UnloadReason.QUIT:t,i=await this.P(S,u);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${S.id})`),this.N(i)):(await this.Q(S,u),!1)}N(S){return S?(this.O(!0),this.j=!1,!0):!1}O(S){this.w&&(this.w(S),this.w=void 0,this.u=void 0)}P(S,t){return new Promise(u=>{const i=this.s++,o=`vscode:ok${i}`,s=`vscode:cancel${i}`;r.$BX.once(o,()=>{u(!1)}),r.$BX.once(s,()=>{u(!0)}),S.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:s,reason:t})})}Q(S,t){return new Promise(u=>{const o=`vscode:reply${this.s++}`;r.$BX.once(o,()=>u()),S.send("vscode:onWillUnload",{replyChannel:o,reason:t})})}quit(S){return this.R(S).then(t=>{if(!t&&S)try{if(I.$j){const u=(0,w.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return t})}R(S){return this.S(`Lifecycle#quit() - begin (willRestart: ${S})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(S&&this.G.setItem(d.b,!0),this.u=new Promise(t=>{this.w=t,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(S){this.H.args["enable-smoke-test-driver"]?this.F.info(S):this.F.trace(S)}setRelaunchHandler(S){this.D=S}async relaunch(S){this.S("Lifecycle#relaunch()");const t=process.argv.slice(1);if(S?.addArgs&&t.push(...S.addArgs),S?.removeArgs)for(const o of S.removeArgs){const s=t.indexOf(o);s>=0&&t.splice(s,1)}const u=()=>{this.D?.handleRelaunch(S)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:t}))};n.app.once("quit",u),await this.quit(!0)&&n.app.removeListener("quit",u)}async kill(S){this.S("Lifecycle#kill()"),await this.L(v.KILL),await Promise.race([(0,P.$Dh)(1e3),(async()=>{for(const t of n.BrowserWindow.getAllWindows())if(t&&!t.isDestroyed()){let u;t.webContents&&!t.webContents.isDestroyed()?u=new Promise(i=>t.once("closed",i)):u=Promise.resolve(),t.destroy(),await u}})()]),n.app.exit(S)}};e.$gfc=$,e.$gfc=$=d=Ee([re(0,h.$0j),re(1,m.$iR),re(2,f.$Nec)],$)}),define(le[253],ue([0,1,3,4,2,6,19]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=void 0,n=Ie(n),e.$Pfc=(0,R.$Ci)("keyboardLayoutMainService");let I=class extends P.$Tc{constructor(g){super(),this.a=this.B(new r.$je),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(T.LifecycleMainPhase.AfterWindowOpen).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((h,m)=>{J(["native-keymap"],h,m)}).then(Ie);this.c=w(g),n.$u||g.onDidChangeKeyboardLayout(()=>{this.c=w(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Qfc=I,e.$Qfc=I=Ee([re(0,T.$ffc)],I);function w(c){const g=c.getKeyMap(),h=c.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:h}}}),define(le[254],ue([0,1,214,8,16,15,12,17,38,100,5,56,213,251]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0,e.$ds=v;let f=class extends h.$6p{constructor($,k,S,t){super(t),this.m=$,this.n=k,this.r=S,this.s(),this.B($.onDidChangeConfiguration(u=>{u.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,k){const{f:S,g:t}=this;let u;try{u=await(0,c.$Om)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$9)(s)))}const i={...process.env,...u},o=$.agent?$.agent:await(0,m.$bs)($.url||"",i,{proxyUrl:S,strictSSL:t});return $.agent=o,$.strictSSL=t,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>v($,k))}async resolveProxy($){}async lookupAuthorization($){}async loadCertificates(){return(await new Promise((k,S)=>{J(["@vscode/proxy-agent"],k,S)}).then(Ie)).loadSystemCertificates({log:this.r})}};e.$cs=f,e.$cs=f=Ee([re(0,I.$9i),re(1,w.$Ki),re(2,g.$0j),re(3,g.$$j)],f);async function d(p){return((0,n.parse)(p.url).protocol==="https:"?await new Promise((S,t)=>{J(["https"],S,t)}).then(Ie):await new Promise((S,t)=>{J(["http"],S,t)}).then(Ie)).request}async function v(p,$){return r.Promises.withAsyncBody(async(k,S)=>{const t=(0,n.parse)(p.url),u=p.getRawRequest?p.getRawRequest(p):await d(p),i={hostname:t.hostname,port:t.port?parseInt(t.port):t.protocol==="https:"?443:80,protocol:t.protocol,path:t.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,T.$ig)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(i.auth=p.user+":"+p.password);const o=u(i,s=>{const a=(0,T.$gg)(p.followRedirects)?p.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&a>0&&s.headers.location)v({...p,url:s.headers.location,followRedirects:a-1},$).then(k,S);else{let l=s;!p.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(l=s.pipe((0,b.createGunzip)())),k({res:s,stream:(0,P.$1e)(l)})}});o.on("error",S),p.timeout&&o.setTimeout(p.timeout),p.isChromiumNetwork&&o.removeHeader("Content-Length"),p.data&&typeof p.data=="string"&&o.write(p.data),o.end(),$.onCancellationRequested(()=>{o.abort(),S(new R.$4)})})}}),define(le[255],ue([0,1,13,254]),function(J,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;function P(T){return n.net.request}class R extends r.$cs{request(I,w){return super.request({...I||{},getRawRequest:P,isChromiumNetwork:!0},w)}}e.$Ugc=R}),define(le[87],ue([0,1,7,4,2,38,14,6,19,5,62,248,42,58,41,11]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=e.$mfc=e.$lfc=void 0,e.$lfc=(0,I.$Ci)("storageMainService");let v=class extends P.$Tc{constructor(k,S,t,u,i,o){super(),this.c=k,this.f=S,this.g=t,this.h=u,this.j=i,this.m=o,this.a=void 0,this.b=this.B(new r.$je),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(w.LifecycleMainPhase.AfterWindowOpen),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)k.join("profileStorage",S.close());for(const[,S]of this.w)k.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.j.exists(k.profile.globalStorageHome)||await this.j.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const S=this.t.get(k.profile.id);S&&k.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const k=new h.$ifc(this.n(),this.g,this.c,this.j);return this.B(r.Event.once(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),k}profileStorage(k){if((0,g.$iq)(k))return this.applicationStorage;let S=this.t.get(k.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),S=this.B(this.u(k)),this.t.set(k.id,S);const t=this.B(S.onDidChangeStorage(u=>this.b.fire({...u,storage:S,profile:k})));this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.t.delete(k.id),t.dispose()}))}return S}u(k){return this.a===w.ShutdownReason.KILL?new h.$kfc(this.c,this.j):new h.$hfc(k,this.n(),this.c,this.j)}workspaceStorage(k){let S=this.w.get(k.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),S=this.B(this.y(k)),this.w.set(k.id,S),this.B(r.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.w.delete(k.id)}))),S}y(k){return this.a===w.ShutdownReason.KILL?new h.$kfc(this.c,this.j):new h.$jfc(k,this.n(),this.c,this.f,this.j)}isUsed(k){const S=n.URI.file(k);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(n.URI.file(t.path),S))return!0;return!1}};e.$mfc=v,e.$mfc=v=Ee([re(0,c.$0j),re(1,R.$Ji),re(2,b.$2ec),re(3,w.$ffc),re(4,T.$0k),re(5,f.$Hl)],v),e.$nfc=(0,I.$Ci)("applicationStorageMainService");let p=class extends g.$hq{constructor(k,S){super(),this.s=k,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(k){if(k===g.StorageScope.APPLICATION)return this.U.applicationStorage.storage}Q(k){if(k===g.StorageScope.APPLICATION)return this.s.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$ofc=p,e.$ofc=p=Ee([re(0,m.$Jl),re(1,e.$lfc)],p)}),define(le[256],ue([0,1,93,27,113,104,8,2,3,17,5,28,207,210,101,131,16]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0,n=Ie(n),r=Ie(r);async function p(u,i,o,s,a){let l;for(let E=3;E&&(l?.dispose(),l=await new $(u,i,o,s,a).waitForReady(),!(a&&P.$2g[a]||!P.$2g[l.tunnelLocalPort]));E--);return l}class $ extends I.$Tc{constructor(i,o,s,a,l){super(),this.m=o,this.n=l,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=n.createServer(),this.c=new T.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=E=>this.r(E),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,o=(0,d.$Jw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,P.$3g)(i,2,1e3,o),a=null;return this.b.listen(s,this.m),await this.c.wait(),a=this.b.address(),a||(s=0,this.b.listen(s,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(i){i.pause();const o=(0,d.$Hw)(this.tunnelRemoteHost)||(0,d.$Jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$Zl)(this.a,o,this.tunnelRemotePort),a=s.getSocket(),l=s.readEntireBuffer();s.dispose(),l.byteLength>0&&i.write(l.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),a.end()}),i.on("close",()=>a.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),a instanceof R.$ri?a.socket.destroy():a.end()}),a instanceof R.$ri?this.t(i,a):this.s(i,a),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),a.end()})}s(i,o){o.onClose(()=>i.destroy()),o.onEnd(()=>i.end()),o.onData(s=>i.write(s.buffer)),i.on("data",s=>o.write(v.$Le.wrap(s))),i.resume()}t(i,o){const s=o.socket;s.on("end",()=>i.end()),s.on("close",()=>i.end()),s.on("error",()=>{i.destroy()}),s.pipe(i),i.pipe(s)}}e.$Qgc=$;let k=class extends d.$Mw{constructor(i,o,s,a,l){super(o,l),this.H=i,this.I=s,this.J=a}isPortPrivileged(i){return(0,d.$Kw)(i,this.t,w.OS,r.release())}F(i,o,s,a,l,E,y,D){const L=this.D(o,s);if(L)return++L.refcount,L.value;if((0,d.$Dw)(i))return this.G(i,o,s,l,E,y,D);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${l}.`);const A={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},O=p(A,a,o,s,l);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(o,s,O),O}}};e.$Rgc=k,e.$Rgc=k=Ee([re(0,b.$Tl),re(1,g.$0j),re(2,f.$Wl),re(3,h.$qk),re(4,c.$9i)],k);let S=class extends k{constructor(i,o,s,a,l){super(i,o,s,a,l)}};e.$Sgc=S,e.$Sgc=S=Ee([re(0,b.$Tl),re(1,g.$0j),re(2,f.$Wl),re(3,h.$qk),re(4,c.$9i)],S);let t=class extends I.$Tc{constructor(i,o,s,a,l){super(),this.b=i,this.c=o,this.f=s,this.g=a,this.h=l,this.a=new Map}async openTunnel(i,o,s,a,l,E,y,D,L){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${a} on local port ${E}.`),!this.a.has(i)){const A=new S(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(i,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(o,s,a,l,E,y,D,L)}};e.$Tgc=t,e.$Tgc=t=Ee([re(0,b.$Tl),re(1,g.$0j),re(2,h.$qk),re(3,f.$Wl),re(4,c.$9i)],t)}),define(le[105],ue([0,1,8,21,4,17,22,19,5,28,56,49]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0,e.$agc=m;function m(f,d,v){return`${v.updateUrl}/api/update/${f}/${d}/${v.commit}`}let b=class{get state(){return this.b}d(d){this.j.info("update#setState",d.type),this.b=d,this.c.fire(d)}constructor(d,v,p,$,k,S){this.f=d,this.g=v,this.h=p,this.i=$,this.j=k,this.k=S,this.b=h.$zY.Uninitialized,this.c=new P.$je,this.onStateChange=this.c.event,d.when(I.LifecycleMainPhase.AfterWindowOpen).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(h.$zY.Disabled(h.DisablementReason.NotBuilt));return}if(this.h.disableUpdates){this.d(h.$zY.Disabled(h.DisablementReason.DisabledByEnvironment)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(h.$zY.Disabled(h.DisablementReason.MissingConfiguration)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.g.getValue("update.mode"),v=this.m(d);if(!v){this.d(h.$zY.Disabled(h.DisablementReason.ManuallyDisabled)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(v),!this.a){this.d(h.$zY.Disabled(h.DisablementReason.InvalidConfiguration)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const p=new URL(this.a);p.searchParams.set("prss","true"),this.a=p.toString()}if(this.d(h.$zY.Idle(this.q())),d==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,p=>this.j.error(p))}m(d){return d==="none"?void 0:this.k.quality}n(d=60*60*1e3){return(0,n.$Dh)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(d){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.t(d)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.o(this.state)}async o(d){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},r.CancellationToken.None)).res.statusCode===204}catch(v){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(v);return}}async _applySpecificUpdate(d){}q(){return h.UpdateType.Archive}r(){}};e.$bgc=b,e.$bgc=b=Ee([re(0,I.$ffc),re(1,R.$9i),re(2,T.$Nec),re(3,g.$5p),re(4,w.$0j),re(5,c.$qk)],b)}),define(le[257],ue([0,1,13,53,4,46,2,17,22,19,5,28,56,24,49,105]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0,n=Ie(n);let v=class extends d.$bgc{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",($,k)=>k)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",($,k,S,t)=>({version:S,productVersion:S,timestamp:t}))}constructor($,k,S,t,u,i,o){super($,k,t,u,i,o),this.z=S,this.u=new T.$Sc,$.setRelaunchHandler(this)}handleRelaunch($){return $?.addArgs||$?.removeArgs||this.state.type!==f.StateType.Ready?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B($){this.z.publicLog2("update:error",{messageHash:String((0,R.$qj)(String($)))}),this.j.error("UpdateService error:",$);const k=this.state.type===f.StateType.CheckingForUpdates&&this.state.explicit?$:void 0;this.d(f.$zY.Idle(f.UpdateType.Archive,k))}s($){let k;this.k.darwinUniversalAssetId?k=this.k.darwinUniversalAssetId:k=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,d.$agc)(k,$,this.k);try{n.autoUpdater.setFeedURL({url:S})}catch(t){this.j.error("Failed to set update feed URL",t);return}return S}t($){this.d(f.$zY.CheckingForUpdates($)),n.autoUpdater.checkForUpdates()}E(){this.state.type===f.StateType.CheckingForUpdates&&this.d(f.$zY.Downloading)}F($){this.state.type===f.StateType.Downloading&&(this.d(f.$zY.Downloaded($)),this.z.publicLog2("update:downloaded",{version:$.version}),this.d(f.$zY.Ready($)))}G(){this.state.type===f.StateType.CheckingForUpdates&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$zY.Idle(f.UpdateType.Archive)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$cgc=v,Ee([r.$7h],v.prototype,"v",null),Ee([r.$7h],v.prototype,"w",null),Ee([r.$7h],v.prototype,"x",null),Ee([r.$7h],v.prototype,"y",null),e.$cgc=v=Ee([re(0,c.$ffc),re(1,I.$9i),re(2,b.$9l),re(3,w.$Nec),re(4,m.$5p),re(5,g.$0j),re(6,h.$qk)],v)}),define(le[258],ue([0,1,48,26,8,4,9,22,19,5,24,49]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0,T=Ie(T);let m=class{get state(){return this.a}d(d){this.g.info("update#setState",d.type),this.a=d,this.b.fire(d)}constructor(d,v,p){if(this.f=d,this.g=p,this.a=h.$zY.Uninitialized,this.b=new R.$je,this.onStateChange=this.b.event,v.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(h.$zY.Idle(this.k())),this.h(30*1e3).then(void 0,$=>this.g.error($))}h(d=60*60*1e3){return(0,P.$Dh)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(d){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type===h.StateType.Idle&&this.m(d)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type===h.StateType.AvailableForDownload&&await this.i(this.state)}i(d){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type===h.StateType.Downloaded&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!==h.StateType.Ready||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(d=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return h.UpdateType.Snap}l(){}async _applySpecificUpdate(d){}};m=Ee([re(0,w.$ffc),re(1,I.$Nec),re(2,c.$0j)],m);let b=class extends m{constructor(d,v,p,$,k,S){super(p,$,k),this.o=d,this.p=v,this.q=S;const t=(0,r.watch)(T.$lc(this.o)),u=R.Event.fromNodeEventEmitter(t,"change",(a,l)=>l),i=R.Event.filter(u,a=>a==="current"),s=R.Event.debounce(i,(a,l)=>l,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{s.dispose(),t.close()})}m(){this.d(h.$zY.CheckingForUpdates(!1)),this.u().then(d=>{d?this.d(h.$zY.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$zY.Idle(h.UpdateType.Snap)))},d=>{this.g.error(d),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(h.$zY.Idle(h.UpdateType.Snap,d.message||d))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+T.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const d=await new Promise((p,$)=>(0,r.realpath)(`${T.$lc(this.o)}/current`,(k,S)=>k?$(k):p(S))),v=T.$mc(d);return this.p!==v}isLatestVersion(){return this.u().then(void 0,d=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$egc=b,e.$egc=b=Ee([re(2,w.$ffc),re(3,I.$Nec),re(4,c.$0j),re(5,g.$9l)],b)}),define(le[29],ue([0,1,13,3,6,51,50,76,28,17,22,9,140]),function(J,e,n,r,P,R,T,I,w,c,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Yec=void 0,e.$Zec=f,e.$1ec=d,e.$Yec=(0,P.$Ci)("windowsMainService");var b;(function(p){p[p.CLI=0]="CLI",p[p.DOCK=1]="DOCK",p[p.MENU=2]="MENU",p[p.DIALOG=3]="DIALOG",p[p.DESKTOP=4]="DESKTOP",p[p.API=5]="API"})(b||(e.OpenContext=b={}));function f(p,$,k){const S=p.get(I.$Wec),t=p.get(w.$qk),u=p.get(c.$9i),i=p.get(g.$Nec),o=u.getValue("window"),s={backgroundColor:S.getBackgroundColor(),minWidth:T.$XD.WIDTH,minHeight:T.$XD.HEIGHT,title:t.nameLong,show:$.mode!==R.WindowMode.Maximized&&$.mode!==R.WindowMode.Fullscreen,x:$.x,y:$.y,width:$.width,height:$.height,webPreferences:{...k,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,T.$0D)($.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(r.$l?s.icon=(0,h.$ic)(i.appRoot,"resources/linux/code.png"):r.$j&&!i.isBuilt&&(s.icon=(0,h.$ic)(i.appRoot,"resources/win32/code_150x150.png")),r.$k&&(s.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(s.acceptFirstMouse=!1)),r.$k&&!(0,T.$9D)(u)&&(s.fullscreenable=!1),r.$k&&o?.nativeTabs===!0&&(s.tabbingIdentifier=t.nameShort),!(0,T.$5D)(u)&&(s.titleBarStyle="hidden",r.$k||(s.frame=!1),(0,T.$8D)(u))){const E=S.getWindowSplash()?.colorInfo.titleBarBackground??S.getBackgroundColor(),y=m.$lu.fromHex(E).isDarker()?"#FFFFFF":"#000000";s.titleBarOverlay={height:29,color:E,symbolColor:y}}return s}function d(p){let $,k=Number.MIN_VALUE;for(const S of p)S.lastFocusTime>k&&(k=S.lastFocusTime,$=S);return $}var v;(function(p){function $(S,t,u=n.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${u.length} display(s)`,t),typeof t.x!="number"||typeof t.y!="number"||typeof t.width!="number"||typeof t.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(t.width<=0||t.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(u.length===1){const s=k(u[0]);if(S.trace("window#validateWindowState: single monitor working area",s),s){let a=function(){!t||typeof t.x!="number"||typeof t.y!="number"||!s||(t.x<s.x&&(t.x=s.x),t.y<s.y&&(t.y=s.y))};a(),t.width>s.width&&(t.width=s.width),t.height>s.height&&(t.height=s.height),t.x>s.x+s.width-128&&(t.x=s.x+s.width-t.width),t.y>s.y+s.height-128&&(t.y=s.y+s.height-t.height),a()}return t}if(t.display&&t.mode===R.WindowMode.Fullscreen){const s=u.find(a=>a.id===t.display);if(s&&typeof s.bounds?.x=="number"&&typeof s.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const a=(0,R.$Lec)(R.WindowMode.Fullscreen);return a.x=s.bounds.x,a.y=s.bounds.y,a}}let i,o;try{i=n.screen.getDisplayMatching({x:t.x,y:t.y,width:t.width,height:t.height}),o=k(i),S.trace("window#validateWindowState: multi-monitor working area",o)}catch(s){S.error("window#validateWindowState: error finding display for window state",s)}if(i&&o&&t.x+t.width>o.x&&t.y+t.height>o.y&&t.x<o.x+o.width&&t.y<o.y+o.height)return t;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}p.validateWindowState=$;function k(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(v||(e.WindowStateValidator=v={}))}),define(le[259],ue([0,1,93,166,120,29]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class T extends r.$Wo{constructor(w){super(),this.f=w}call(w,c,g){return c==="openExtensionDevelopmentHostWindow"?this.g(g[0],g[1]):super.call(w,c,g)}async g(w,c){const g=(0,P.$Am)(w,P.$zm);g.debugRenderer=c;const h=g.extensionDevelopmentPath;if(!h)return{success:!1};const[m]=await this.f.openExtensionDevelopmentHostWindow(h,{context:R.OpenContext.API,cli:g,forceProfile:g.profile,forceTempProfile:g["profile-temp"]});if(!c)return{success:!0};const b=m.win;if(!b)return{success:!0};const f=b.webContents.debugger;let d=f.isAttached()?1/0:0;const v=(0,n.createServer)(p=>{d++===0&&f.attach();let $=!1;const k=u=>{$||p.write(JSON.stringify(u)+"\0")},S=(u,i,o,s)=>k({method:i,params:o,sessionId:s});b.on("close",()=>{f.removeListener("message",S),p.end(),$=!0}),f.addListener("message",S);let t=Buffer.alloc(0);p.on("data",u=>{t=Buffer.concat([t,u]);for(let i=t.indexOf(0);i!==-1;i=t.indexOf(0)){let o;try{const s=t.slice(0,i).toString("utf8");t=t.slice(i+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}f.sendCommand(o.method,o.params,o.sessionId).then(s=>k({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>k({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),p.on("error",u=>{console.error("error on cdp pipe:",u)}),p.on("close",()=>{$=!0,--d===0&&f.detach()})});return await new Promise(p=>v.listen(0,p)),b.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$sfc=T}),define(le[260],ue([0,1,13,20,3,7,23,17,68,6,5,132,29]),function(J,e,n,r,P,R,T,I,w,c,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=e.$Sfc=e.ID=void 0,e.ID="launchMainService",e.$Sfc=(0,c.$Ci)(e.ID);let b=class{constructor(d,v,p,$){this.a=d,this.b=v,this.c=p,this.d=$}async start(d,v){this.a.trace("Received data from other instance: ",d,v),P.$k&&n.app.focus({steal:!0});const p=this.e(d);if(p.length){let $=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,r.$Nb)(await this.b.openEmptyWindow({context:m.OpenContext.DESKTOP}));k&&($=k.ready())}$.then(()=>{for(const{uri:k,originalUrl:S}of p)this.c.open(k,{originalUrl:S})})}else return this.f(d,v)}e(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,r.$Gb)(d._urls.map(v=>{try{return{uri:R.URI.parse(v),originalUrl:v}}catch{return null}})):[]}async f(d,v){const p=(0,w.$Hm)(v)?m.OpenContext.CLI:m.OpenContext.DESKTOP;let $=[];const k=d.wait&&d.waitMarkerFilePath?R.URI.file(d.waitMarkerFilePath):void 0,S=d.remote||void 0,t={context:p,cli:d,userEnv:d["preserve-env"]||p===m.OpenContext.CLI?v:void 0,waitMarkerFileURI:k,remoteAuthority:S,forceProfile:d.profile,forceTempProfile:d["profile-temp"]};if(d.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,t);else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let u=!1;if(d["new-window"]||t.forceProfile||t.forceTempProfile)u=!0;else if(d["reuse-window"])u=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!P.$k}if(u)$=await this.b.open({...t,forceNewWindow:!0,forceEmpty:!0});else{const i=this.b.getLastActiveWindow();i?(this.b.openExistingWindow(i,t),$=[i]):$=await this.b.open({...t,forceEmpty:!0})}}else $=await this.b.open({...t,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,mergeMode:d.merge,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],gotoLineMode:d.goto});if(k&&$.length===1&&$[0])return Promise.race([$[0].whenClosedOrLoaded,(0,T.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Tfc=b,e.$Tfc=b=Ee([re(0,g.$0j),re(1,m.$Yec),re(2,h.$qY),re(3,I.$9i)],b)}),define(le[135],ue([0,1,13,21,4,46,2,33,97,6,5,62,87,29]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0,e.$pfc=(0,c.$Ci)("proxyAuthService");let f=class extends T.$Tc{constructor(v,p,$,k){super(),this.h=v,this.j=p,this.m=$,this.n=k,this.a="proxy-credentials://",this.b=new Map,this.c=void 0,this.f=new Set,this.g=new Map,this.r()}r(){const v=P.Event.fromNodeEventEmitter(n.app,"login",(p,$,k,S,t)=>({event:p,authInfo:{...S,attempt:k.firstAuthAttempt?1:2},callback:t}));this.B(v(this.s,this))}async lookupAuthorization(v){return this.s({authInfo:v})}async s({event:v,authInfo:p,callback:$}){if(!p.isProxy)return;v?.preventDefault();const k=String((0,R.$qj)({scheme:p.scheme,host:p.host,port:p.port}));let S,t=this.b.get(k);if(t)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await t;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),t=this.t(p,k),this.b.set(k,t);try{S=await t}finally{this.b.delete(k)}}return $?.(S?.username,S?.password),S}async t(v,p){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.u(v,p);if($)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async u(v,p){if(this.h.trace("auth#doResolveProxyCredentials - enter",v),v.attempt===1&&this.g.has(p)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found session credentials to use");const{username:u,password:i}=this.g.get(p);return{username:u,password:i}}let $,k;try{const u=this.n.get(this.a+p,h.StorageScope.APPLICATION);if(u){const i=JSON.parse(await this.m.decrypt(u));$=i.username,k=i.password}}catch(u){this.h.error(u)}if(v.attempt===1&&typeof $=="string"&&typeof k=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.g.set(p,{username:$,password:k}),{username:$,password:k};const S=this.c,t=this.c=(async()=>{await S;const u=await this.w(v,p,$,k);return this.c===t&&(this.c=void 0),u})();return t}async w(v,p,$,k){if(this.f.has(p)){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - login dialog was cancelled before, not showing again");return}const S=this.j.getFocusedWindow()||this.j.getLastActiveWindow();if(!S){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const t=this.g.get(p),u={authInfo:v,username:t?.username??$,password:t?.password??k,replyChannel:`vscode:proxyAuthResponse:${(0,I.$Yg)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,u);const i=await new Promise(o=>{const s=async(a,l,E)=>{if(l===u.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",s),E){const y={username:E.username,password:E.password};try{if(E.remember){const D=await this.m.encrypt(JSON.stringify(y));this.n.store(this.a+p,D,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}else this.n.remove(this.a+p,h.StorageScope.APPLICATION)}catch(D){this.h.error(D)}o({username:y.username,password:y.password})}else this.f.add(p),o(void 0)};S.win?.webContents.on("ipc-message",s)});return this.g.set(p,i),i}};e.$qfc=f,e.$qfc=f=Ee([re(0,g.$0j),re(1,b.$Yec),re(2,w.$kY),re(3,m.$nfc)],f)}),define(le[261],ue([0,1,2,19,51,58,30,8,29]),function(J,e,n,r,P,R,T,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;let c=class extends n.$Tc{constructor(h,m,b){super(),this.a=m,this.b=b,this.B(h.onWillLoadWindow(f=>{f.reason===P.LoadReason.LOAD&&this.c(f.window)})),this.B(h.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Oh(()=>this.g(),30*1e3)).schedule()}async c(h){const m=this.f(h),b=this.a.getProfileForWorkspace(m);b?.isTransient&&(this.a.unsetWorkspace(m,b.isTransient),b.isTransient&&await this.a.cleanUpTransientProfiles())}f(h){return h.openedWorkspace??(0,T.$Qi)(h.backupPath,h.isExtensionDevelopmentHost)}g(){const h=this.a.getAssociatedEmptyWindows();if(h.length===0)return;const m=this.b.getWindows().map(b=>this.f(b));for(const b of h)m.some(f=>f.id===b.id)||this.a.unsetWorkspace(b,!1)}};e.$wgc=c,e.$wgc=c=Ee([re(0,r.$ffc),re(1,R.$2ec),re(2,w.$Yec)],c)});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[63],ue([0,1,13,2,4,5,281,8,11,29,81,24,19,79,37,3,106]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=e.$tfc=void 0,g=et(g);function $(t){return typeof t.responseWindowId=="number"}let k=class extends r.$Tc{static{p=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(p.b.values())}constructor(u,i,o){super(),this.w=u,this.y=i,this.z=o,this.c=String(++p.a),this.f=this.B(new P.$je),this.onStdout=this.f.event,this.g=this.B(new P.$je),this.onStderr=this.g.event,this.h=this.B(new P.$je),this.onMessage=this.h.event,this.j=this.B(new P.$je),this.onSpawn=this.j.event,this.m=this.B(new P.$je),this.onExit=this.m.event,this.n=this.B(new P.$je),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(u,i){let o;switch(this.t?.correlationId?o=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`:o=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${u}`,i){case g.default.Error:this.w.error(o);break;case g.default.Warning:this.w.warn(o);break;case g.default.Info:this.w.trace(o);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(u){const i=this.F(u);return i&&u.payload&&this.postMessage(u.payload)&&this.C("payload sent via postMessage()",g.default.Info),i}F(u){if(!this.D())return!1;this.t=u;const i=`${this.t.type}-${this.c}`,o=w.$Wg.asFileUri("bootstrap-fork.js").fsPath,s=this.t.args??[],a=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,E=this.t.forceAllocationsToV8Sandbox,y="pipe",D=this.G(u);return this.C("creating new...",g.default.Info),this.r=n.utilityProcess.fork(o,s,{serviceName:i,env:D,execArgv:a,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:E,stdio:y}),this.H(this.r,this.t,i),!0}G(u){const i=u.env?{...u.env}:{...(0,f.$bo)(process.env)};i.VSCODE_AMD_ENTRYPOINT=u.entryPoint,typeof u.parentLifecycleBound=="number"&&(i.VSCODE_PARENT_PID=String(u.parentLifecycleBound)),i.VSCODE_CRASH_REPORTER_PROCESS_TYPE=u.type,d.$j&&((0,v.isUNCAccessRestrictionsDisabled)()?i.NODE_DISABLE_UNC_ACCESS_CHECKS="1":i.NODE_UNC_HOST_ALLOWLIST=(0,v.getUNCHostAllowlist)().join("\\")),(0,b.$jm)(i);for(const o of Object.keys(i))i[o]=String(i[o]);return i}H(u,i,o){if(u.stdout){const s=new T.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(u.stdout,"data")(a=>this.f.fire(typeof a=="string"?a:s.write(a))))}if(u.stderr){const s=new T.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(u.stderr,"data")(a=>this.g.fire(typeof a=="string"?a:s.write(a))))}this.B(P.Event.fromNodeEventEmitter(u,"message")(s=>this.h.fire(s))),this.B(P.Event.fromNodeEventEmitter(u,"spawn")(()=>{this.s=u.pid,typeof u.pid=="number"&&p.b.set(u.pid,{pid:u.pid,name:$(i)?`${i.type} [${i.responseWindowId}]`:i.type}),this.C("successfully created",g.default.Info),this.j.fire(u.pid)})),this.B(P.Event.fromNodeEventEmitter(u,"exit")(s=>{const a=this.I(s)?0:s;this.C(`received exit event with code ${a}`,g.default.Info),this.m.fire({pid:this.s,code:a,signal:"unknown"}),this.J()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(s,a)=>({event:s,details:a}))(({details:s})=>{s.type==="Utility"&&s.name===o&&!this.I(s.exitCode)&&(this.C(`crashed with code ${s.exitCode} and reason '${s.reason}'`,g.default.Error),this.y.publicLog2("utilityprocesscrash",{type:i.type,reason:s.reason,code:s.exitCode}),this.n.fire({pid:this.s,code:s.exitCode,reason:s.reason}),this.J())}))}once(u,i){const o=this.B(this.h.event(s=>{s===u&&(o.dispose(),i())}))}postMessage(u,i){return this.r?(this.r.postMessage(u,i),!0):!1}connect(u){const{port1:i,port2:o}=new n.MessageChannelMain;return this.postMessage(u,[o]),i}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",g.default.Info);const u=process;return typeof u._debugProcess=="function"?(u._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",g.default.Info),this.r.kill()?(this.C("successfully killed the process",g.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",g.default.Warning)}I(u){return u===0?!0:this.u&&u===15}J(){typeof this.s=="number"&&p.b.delete(this.s),this.r=void 0}async waitForExit(u){this.r&&(this.C("waiting to exit...",g.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,I.$Dh)(u)]),this.r&&(this.C(`did not exit within ${u}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$tfc=k,e.$tfc=k=p=Ee([re(0,R.$0j),re(1,h.$9l),re(2,m.$ffc)],k);let S=class extends k{constructor(u,i,o,s){super(u,o,s),this.L=i}start(u){const i=this.L.getWindowById(u.responseWindowId);if(!i?.win||i.win.isDestroyed()||i.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.F(u))return!1;this.M(i.win,u);const s=this.connect(u.payload);return i.win.webContents.postMessage(u.responseChannel,u.responseNonce,[s]),!0}M(u,i){i.windowLifecycleBound&&(this.B(P.Event.filter(this.z.onWillLoadWindow,o=>o.window.win===u)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(u,"closed")(()=>this.kill())))}};e.$ufc=S,e.$ufc=S=Ee([re(0,R.$0j),re(1,c.$Yec),re(2,h.$9l),re(3,m.$ffc)],S)}),define(le[262],ue([0,1,8,15,4,2,19,5,24,63,29]),function(J,e,n,r,P,R,T,I,w,c,g){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;let m=class extends R.$Tc{static{h=this}static{this.a=0}constructor(f,d,v,p){super(),this.f=f,this.g=d,this.h=v,this.j=p,this.b=new Map,this.c=!1,this.B(this.g.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))}))}dispose(){super.dispose()}m(f){const d=this.b.get(f);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(f){return this.m(f).onStdout}onDynamicStderr(f){return this.m(f).onStderr}onDynamicMessage(f){return this.m(f).onMessage}onDynamicExit(f){return this.m(f).onExit}async createExtensionHost(){if(this.c)throw(0,r.$5)();const f=String(++h.a),d=new c.$ufc(this.f,this.h,this.j,this.g);this.b.set(f,d);const v=d.onExit(({pid:p,code:$,signal:k})=>{v.dispose(),this.f.info(`Extension host with pid ${p} exited with code: ${$}, signal: ${k}.`),setTimeout(()=>{d.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(p,0),this.f.error(`Extension host with pid ${p} still exists, forcefully killing it...`),process.kill(p)}catch{}},1e3)});return{id:f}}async start(f,d){if(this.c)throw(0,r.$5)();const v=this.m(f);return v.start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:f}),{pid:await P.Event.toPromise(v.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,r.$5)();const d=this.b.get(f);return d?d.enableInspectPort():!1}async kill(f){if(this.c)throw(0,r.$5)();const d=this.b.get(f);d&&d.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const d=[];for(const[,v]of this.b)d.push(v.waitForExit(f));return n.Promises.settled(d).then(()=>{})}};e.$Bfc=m,e.$Bfc=m=h=Ee([re(0,I.$0j),re(1,T.$ffc),re(2,g.$Yec),re(3,w.$9l)],m)}),define(le[263],ue([0,1,35,8,2,22,19,5,42,40,71,63,57,95,12,215,4]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;let p=class extends P.$Tc{constructor(k,S,t,u,i,o,s,a,l){super(),this.g=k,this.h=S,this.j=t,this.m=u,this.n=i,this.r=o,this.s=s,this.t=a,this.u=l,this.a=new r.$Bh,this.b=void 0,this.c=void 0,this.f=this.B(new v.$je),this.onDidCrash=this.f.event,this.C=void 0,this.D=void 0,this.w()}w(){n.$BX.on(d.$5fc.request,(k,S)=>this.y(k,S,d.$5fc.response)),n.$BX.on(d.$6fc.request,(k,S)=>this.y(k,S,d.$6fc.response)),this.B(this.r.onWillShutdown(()=>this.z()))}async y(k,S,t){this.s.trace(`[SharedProcess] onWindowConnection for: ${t}`),this.a.isOpen()||this.a.open(),await this.whenReady();const u=await this.connect(t);if(k.sender.isDestroyed())return u.close();k.sender.postMessage(t,S,[u])}z(){this.s.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(d.$4fc.exit),this.b=void 0}whenReady(){return this.C||(this.C=(async()=>{await this.F;const k=new r.$Zh;this.b?.once(d.$4fc.initDone,()=>k.complete()),await k.p,this.c?.dispose(),this.s.trace("[SharedProcess] Overall ready")})()),this.C}get F(){return this.D||(this.D=(async()=>{await this.a.wait(),this.G();const k=new r.$Zh;this.b?.once(d.$4fc.ipcReady,()=>k.complete()),await k.p,this.s.trace("[SharedProcess] IPC ready")})()),this.D}G(){this.b=this.B(new h.$tfc(this.s,m.$wp,this.r)),this.c=this.b.onMessage(t=>{typeof t.warning=="string"?this.s.warn(t.warning):typeof t.error=="string"&&this.s.error(t.error)});const k=(0,b.$8m)(this.m.args,this.m.isBuilt);let S;k.port&&(S=["--nolazy"],k.break?S.push(`--inspect-brk=${k.port}`):S.push(`--inspect=${k.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.H(),execArgv:S}),this.B(this.b.onCrash(()=>this.f.fire()))}H(){return{machineId:this.g,sqmId:this.h,devDeviceId:this.j,codeCachePath:this.m.codeCachePath,profiles:{home:this.n.profilesHome,all:this.n.profiles},args:this.m.args,logLevel:this.t.getLogLevel(),loggers:this.t.getRegisteredLoggers(),policiesData:this.u.serialize()}}async connect(k){return await this.F,(0,f.$ng)(this.b).connect(k)}};e.$7fc=p,e.$7fc=p=Ee([re(3,R.$Nec),re(4,w.$Jl),re(5,T.$ffc),re(6,I.$0j),re(7,g.$afc),re(8,c.$qo)],p)}),define(le[264],ue([0,1,22,95,19,5,57,75,63,118,35,2,4,37,17,11]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;let v=class extends h.$Tc{constructor($,k,S,t,u){super(),this.f=$,this.g=k,this.h=S,this.j=t,this.m=u,this.a=void 0,this.b=new m.$je,this.onRequestConnection=this.b.event,this.c=new m.$je,this.onWillShutdown=this.c.event,this.B(this.j.onWillShutdown(()=>this.c.fire())),g.$BX.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,h.$Rc)(()=>{g.$BX.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new w.$tfc(this.m,T.$wp,this.j);const $=(0,r.$7m)(this.h.args,this.h.isBuilt),k=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:k,args:["--logsPath",this.h.logsHome.with({scheme:d.Schemas.file}).fsPath],env:this.n()});const S=this.a.connect(),t=new c.$JX(S,"ptyHost"),u=new h.$Sc;return u.add(t),u.add((0,h.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:t,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,b.$bo)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},k=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostLatency);k&&typeof k=="number"&&($.VSCODE_LATENCY=String(k));const S=this.g.getValue(I.TerminalSettingId.DeveloperPtyHostStartupDelay);return S&&typeof S=="number"&&($.VSCODE_STARTUP_DELAY=String(S)),this.h.restoreSnapExportedVariables(),$}r($,k){this.b.fire();const S=this.a.connect();if($.sender.isDestroyed()){S.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",k,[S])}};e.$Igc=v,e.$Igc=v=Ee([re(1,f.$9i),re(2,n.$Nec),re(3,P.$ffc),re(4,R.$0j)],v)}),define(le[265],ue([0,1,2,6,5,29,63,24,46,4,8,19]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=void 0,e.$Ggc=(0,r.$Ci)("utilityProcessWorker");let m=class extends n.$Tc{constructor(d,v,p,$){super(),this.b=d,this.c=v,this.f=p,this.g=$,this.a=new Map}async createWorker(d){const v=`window: ${d.reply.windowId}, moduleId: ${d.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${v})`);const p=this.h(d);this.a.has(p)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${v})`),this.disposeWorker(d));const $=new b(this.b,this.c,this.f,this.g,d);if(!$.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(p,$);const k=new g.$Zh;return c.Event.once($.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(p),k.complete({reason:S})}),k.p}h(d){return(0,w.$qj)({moduleId:d.process.moduleId,windowId:d.reply.windowId})}async disposeWorker(d){const v=this.h(d),p=this.a.get(v);p&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${d.reply.windowId}, moduleId: ${d.process.moduleId})`),p.kill(),p.dispose(),this.a.delete(v))}};e.$Hgc=m,e.$Hgc=m=Ee([re(0,P.$0j),re(1,R.$Yec),re(2,I.$9l),re(3,h.$ffc)],m);let b=class extends n.$Tc{constructor(d,v,p,$,k){super(),this.c=d,this.f=v,this.g=p,this.h=$,this.j=k,this.a=this.B(new c.$je),this.onDidTerminate=this.a.event,this.b=this.B(new T.$ufc(this.c,this.f,this.g,this.h)),this.m()}m(){this.B(this.b.onExit(d=>this.a.fire({code:d.code,signal:d.signal}))),this.B(this.b.onCrash(d=>this.a.fire({code:d.code,signal:"ECRASH"})))}spawn(){const v=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:v,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};b=Ee([re(0,P.$0j),re(1,R.$Yec),re(2,I.$9l),re(3,h.$ffc)],b)}),define(le[266],ue([0,1,13,4,2,240,29]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;let I=class extends P.$Tc{constructor(c){super(),this.b=c,this.a=this.B(new r.$je),this.onFoundInFrame=this.a.event,this.B(new R.$lgc)}async setIgnoreMenuShortcuts(c,g){let h;if(typeof c.windowId=="number"){const{windowId:m}=c,b=this.b.getWindowById(m);if(!b?.win)throw new Error(`Invalid windowId: ${m}`);h=b.win.webContents}else{const{webContentsId:m}=c;if(h=n.webContents.fromId(m),!h)throw new Error(`Invalid webContentsId: ${m}`)}h.isDestroyed()||h.setIgnoreMenuShortcuts(g)}async findInFrame(c,g,h,m){const f=this.c(c,g);if(typeof f.findInFrame=="function"){f.findInFrame(h,{findNext:m.findNext,forward:m.forward});const d=(v,p)=>{p.finalUpdate&&(this.a.fire(p),f.removeListener("found-in-frame",d))};f.on("found-in-frame",d)}}async stopFindInFrame(c,g,h){const b=this.c(c,g);typeof b.stopFindInFrame=="function"&&b.stopFindInFrame(h.keepSelection?"keepSelection":"clearSelection")}c(c,g){const h=this.b.getWindowById(c.windowId);if(!h?.win)throw new Error(`Invalid windowId: ${c}`);const m=h.win.webContents.mainFrame.framesInSubtree.find(b=>b.name===g);if(!m)throw new Error(`Unknown frame: ${g}`);return m}};e.$mgc=I,e.$mgc=I=Ee([re(0,T.$Yec)],I)}),define(le[267],ue([0,1,13,2,3,18,7,17,19,5,34,29,51,30]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0,e.$ogc=v,e.$pgc=$;let d=class extends r.$Tc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(t,u,i,o,s){super(),this.g=t,this.h=u,this.j=i,this.m=o,this.n=s,this.b=v(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.B(this.j.onBeforeCloseWindow(t=>this.u(t))),this.B(this.j.onBeforeShutdown(()=>this.s())),this.B(this.g.onDidChangeWindowsCount(t=>{t.newCount-t.oldCount>0&&(this.c=void 0)})),this.B(this.g.onDidDestroyWindow(t=>this.u(t)))}s(){this.f=!0,this.t()}t(){const t=new Set,u={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!u.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),s&&(u.lastActiveWindow=this.w(s),u.lastActiveWindow.uiState.mode===m.WindowMode.Fullscreen&&t.add(u.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);i&&(u.lastPluginDevelopmentHostWindow=this.w(i),u.lastPluginDevelopmentHostWindow.uiState.mode===m.WindowMode.Fullscreen&&(t.has(u.lastPluginDevelopmentHostWindow.uiState.display)?P.$k&&!i.win?.isSimpleFullScreen()&&(u.lastPluginDevelopmentHostWindow.uiState.mode=m.WindowMode.Normal):t.add(u.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(u.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const a=this.w(s);return a.uiState.mode===m.WindowMode.Fullscreen&&(t.has(a.uiState.display)?P.$k&&a.windowId!==u.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(a.uiState.mode=m.WindowMode.Normal):t.add(a.uiState.display)),a}));const o=$(u);this.h.setItem(f.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(t){if(this.j.quitRequested)return;const u=this.w(t);t.isExtensionDevelopmentHost&&!t.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=u:!t.isExtensionDevelopmentHost&&t.openedWorkspace&&this.b.openedWindows.forEach(i=>{const o=(0,b.$Ri)(t.openedWorkspace)&&i.workspace?.id===t.openedWorkspace.id,s=(0,b.$Mi)(t.openedWorkspace)&&i.folderUri&&R.$7g.isEqual(i.folderUri,t.openedWorkspace.uri);(o||s)&&(i.uiState=u.uiState)}),this.g.getWindowCount()===1&&(this.c=u)}w(t){return{windowId:t.id,workspace:(0,b.$Ri)(t.openedWorkspace)?t.openedWorkspace:void 0,folderUri:(0,b.$Mi)(t.openedWorkspace)?t.openedWorkspace.uri:void 0,backupPath:t.backupPath,remoteAuthority:t.remoteAuthority,uiState:t.serializeWindowState()}}getNewWindowState(t){const u=this.z(t),i=this.n.getValue("window");if(u.mode===m.WindowMode.Fullscreen){let o;u.hasDefaultState?o=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||i?.restoreFullscreen),o||(u.mode=m.WindowMode.Normal)}return u}z(t){const u=this.g.getLastActiveWindow();if(!t.extensionTestsPath){if(t.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const E=t.workspace;if((0,b.$Ri)(E)){const D=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===E.id).map(L=>L.uiState);if(D.length)return D[0]}if((0,b.$Mi)(E)){const D=this.state.openedWindows.filter(L=>L.folderUri&&R.$7g.isEqual(L.folderUri,E.uri)).map(L=>L.uiState);if(D.length)return D[0]}else if(t.backupPath){const D=this.state.openedWindows.filter(L=>L.backupPath===t.backupPath).map(L=>L.uiState);if(D.length)return D[0]}const y=this.c||this.state.lastActiveWindow;if(!u&&y)return y.uiState}let i;const o=n.screen.getAllDisplays();if(o.length===1)i=o[0];else{if(P.$k){const E=n.screen.getCursorScreenPoint();i=n.screen.getDisplayNearestPoint(E)}!i&&u&&(i=n.screen.getDisplayMatching(u.getBounds())),i||(i=n.screen.getPrimaryDisplay()||o[0])}let s=(0,m.$Lec)();s.x=Math.round(i.bounds.x+i.bounds.width/2-s.width/2),s.y=Math.round(i.bounds.y+i.bounds.height/2-s.height/2);const a=this.n.getValue("window");let l=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")s.mode=m.WindowMode.Maximized,l=!1;else if(a.newWindowDimensions==="fullscreen")s.mode=m.WindowMode.Fullscreen,l=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&u){const E=u.serializeWindowState();E.mode===m.WindowMode.Fullscreen?s.mode=m.WindowMode.Fullscreen:s={...E,zoomLevel:void 0},l=s.mode!==m.WindowMode.Fullscreen&&a.newWindowDimensions==="offset"}}return l&&(s=this.C(s)),s.hasDefaultState=!0,s}C(t){if(this.g.getWindows().length===0)return t;t.x=typeof t.x=="number"?t.x:0,t.y=typeof t.y=="number"?t.y:0;const u=this.g.getWindows().map(i=>i.getBounds());for(;u.some(i=>i.x===t.x||i.y===t.y);)t.x+=30,t.y+=30;return t}};e.$ngc=d,e.$ngc=d=f=Ee([re(0,h.$Yec),re(1,g.$iR),re(2,w.$ffc),re(3,c.$0j),re(4,I.$9i)],d);function v(S){const t={openedWindows:[]},u=S||{openedWindows:[]};return u.lastActiveWindow&&(t.lastActiveWindow=p(u.lastActiveWindow)),u.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=p(u.lastPluginDevelopmentHostWindow)),Array.isArray(u.openedWindows)&&(t.openedWindows=u.openedWindows.map(i=>p(i))),t}function p(S){const t={uiState:S.uiState};return S.backupPath&&(t.backupPath=S.backupPath),S.remoteAuthority&&(t.remoteAuthority=S.remoteAuthority),S.folder&&(t.folderUri=T.URI.parse(S.folder)),S.workspaceIdentifier&&(t.workspace={id:S.workspaceIdentifier.id,configPath:T.URI.parse(S.workspaceIdentifier.configURIPath)}),t}function $(S){return{lastActiveWindow:S.lastActiveWindow&&k(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&k(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(t=>k(t))}}function k(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(le[59],ue([0,1,26,13,4,43,2,11,9,18,23,10,69,52,22,6,5,58,134,30,102,103]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=e.$$ec=void 0,n=Ie(n),e.$$ec=(0,d.$Ci)("workspacesManagementMainService");let u=class extends T.$Tc{constructor(o,s,a,l,E){super(),this.g=o,this.h=s,this.j=a,this.m=l,this.n=E,this.a=this.B(new P.$je),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new P.$je),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await g.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(s=>(0,c.$dh)(this.c,s,k.$2i));for(const s of o){const a=(0,t.$8ec)(s),l=await this.resolveLocalWorkspace(s);l?this.f.push({workspace:a,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(a)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,s=>n.promises.readFile(s,"utf8"))}r(o,s){if(this.s(o)&&o.scheme===I.Schemas.file)try{const a=s(o.fsPath);return a instanceof Promise?a.then(l=>this.t(o,l),l=>{}):this.t(o,a)}catch{return}}s(o){return(0,k.$3i)(o,this.g)||(0,k.$8i)(o)}t(o,s){try{const a=this.u(o,s),l=(0,t.$8ec)(o);return{id:l.id,configPath:l.configPath,folders:(0,S.$1hb)(a.folders,l.configPath,c.$7g),remoteAuthority:a.remoteAuthority,transient:a.transient}}catch(a){this.h.warn(a.toString())}}u(o,s){const a=(0,R.$Vn)(s);if(a&&Array.isArray(a.folders))a.folders=a.folders.filter(l=>(0,S.$Yhb)(l));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return a}async createUntitledWorkspace(o,s){const{workspace:a,storedWorkspace:l}=this.w(o,s),E=a.configPath.fsPath;return await n.promises.mkdir((0,w.$lc)(E),{recursive:!0}),await g.Promises.writeFile(E,JSON.stringify(l,null,"	")),this.f.push({workspace:a,remoteAuthority:s}),a}w(o=[],s){const a=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,c.$dh)(this.c,a),E=(0,c.$dh)(l,k.$2i),y=[];for(const D of o)y.push((0,S.$Zhb)(D.uri,!0,D.name,l,c.$7g));return{workspace:(0,t.$8ec)(E),storedWorkspace:{folders:y,remoteAuthority:s}}}async getWorkspaceIdentifier(o){return(0,t.$8ec)(o)}isUntitledWorkspace(o){return(0,k.$3i)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const s=(0,c.$4g)(o.configPath);try{await g.Promises.rm((0,w.$lc)(s));const a=(0,w.$ic)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,o.id);await g.Promises.exists(a)&&await g.Promises.writeFile((0,w.$ic)(a,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==o.id)}catch(a){this.h.warn(`Unable to delete untitled workspace ${s} (${a}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,s,a){if(!o||!o.win||!o.isReady||!await this.z(o,s,a))return;const E=await this.C(o,(0,t.$8ec)(a));if(E)return this.b.fire({window:o,workspace:E.workspace}),E}async z(o,s,a){return a?(0,k.$Ri)(o.openedWorkspace)&&c.$7g.isEqual(o.openedWorkspace.configPath,a)?!1:(0,$.$5ec)(s,a)?(await this.n.showMessageBox({type:"info",buttons:[(0,h.localize)(10851,null)],message:(0,h.localize)(10852,null,(0,c.$ah)(a)),detail:(0,h.localize)(10853,null)},r.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,s){if(!o.config)return;o.focus();let a;return o.config.extensionDevelopmentPath||(o.config.backupPath?a=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority},o.config.backupPath):a=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:o.remoteAuthority})),(0,k.$Ri)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=s,o.config.backupPath=a,{workspace:s,backupPath:a}}};e.$_ec=u,e.$_ec=u=Ee([re(0,f.$Nec),re(1,v.$0j),re(2,p.$2ec),re(3,m.$Sec),re(4,b.$Tec)],u)}),define(le[136],ue([0,1,13,35,21,6,29,30,59,12,5,63]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=e.ID=void 0,e.ID="diagnosticsMainService",e.$wfc=(0,R.$Ci)(e.ID);let m=class{constructor(f,d,v){this.a=f,this.b=d,this.c=v}async getRemoteDiagnostics(f){const d=this.a.getWindows();return(await Promise.all(d.map(async p=>{const $=p.remoteAuthority;if(!$)return;const k=`vscode:getDiagnosticInfoResponse${p.id}`,S={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(p):void 0};return new Promise(t=>{p.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:k,args:S}),r.$BX.once(k,(u,i)=>{i||t({hostName:$,errorMessage:`Unable to resolve connection to '${$}'.`}),t(i)}),setTimeout(()=>{t({hostName:$,errorMessage:`Connection to '${$}' could not be established`})},5e3)})}))).filter(p=>!!p)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const v of n.BrowserWindow.getAllWindows()){const p=this.a.getWindowById(v.id);p?f.push(await this.d(p)):f.push(this.e(v))}const d=[];for(const{pid:v,name:p}of h.$tfc.getAll())d.push({pid:v,name:p});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:d,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const d=await this.f(f),v=(0,c.$ng)(f.win);return this.e(v,d,f.remoteAuthority)}e(f,d=[],v){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:d,remoteAuthority:v}}async f(f){const d=[],v=f.openedWorkspace;if((0,I.$Mi)(v))d.push(v.uri);else if((0,I.$Ri)(v)){const p=await this.b.resolveLocalWorkspace(v.configPath);p&&p.folders.forEach(k=>{d.push(k.uri)})}return d}};e.$xfc=m,e.$xfc=m=Ee([re(0,T.$Yec),re(1,w.$$ec),re(2,g.$0j)],m)}),define(le[64],ue([0,1,26,48,13,27,153,53,4,2,11,9,3,7,112,92,23,113,10,52,22,6,19,5,28,76,29,30,59,16,211,201,84,15,135]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i,o,s,a,l,E,y,D,L,A,O,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=e.$Lfc=void 0,n=Ie(n),e.$Lfc=(0,t.$Ci)("nativeHostMainService");let x=class extends c.$Tc{constructor(B,X,G,ae,K,te,U,j,N,Y){super(),this.a=B,this.b=X,this.c=G,this.f=ae,this.g=K,this.h=te,this.j=U,this.m=j,this.n=N,this.r=Y,this.onDidOpenMainWindow=w.Event.map(this.a.onDidOpenWindow,ie=>ie.id),this.onDidTriggerWindowSystemContextMenu=w.Event.any(w.Event.map(this.a.onDidTriggerSystemContextMenu,({window:ie,x:V,y:he})=>({windowId:ie.id,x:V,y:he})),w.Event.map(this.b.onDidTriggerSystemContextMenu,({window:ie,x:V,y:he})=>({windowId:ie.id,x:V,y:he}))),this.onDidMaximizeWindow=w.Event.any(w.Event.map(this.a.onDidMaximizeWindow,ie=>ie.id),w.Event.map(this.b.onDidMaximizeWindow,ie=>ie.id)),this.onDidUnmaximizeWindow=w.Event.any(w.Event.map(this.a.onDidUnmaximizeWindow,ie=>ie.id),w.Event.map(this.b.onDidUnmaximizeWindow,ie=>ie.id)),this.onDidChangeWindowFullScreen=w.Event.any(w.Event.map(this.a.onDidChangeFullScreen,ie=>({windowId:ie.window.id,fullscreen:ie.fullscreen})),w.Event.map(this.b.onDidChangeFullScreen,ie=>({windowId:ie.window.id,fullscreen:ie.fullscreen}))),this.onDidBlurMainWindow=w.Event.filter(w.Event.fromNodeEventEmitter(P.app,"browser-window-blur",(ie,V)=>V.id),ie=>!!this.a.getWindowById(ie)),this.onDidFocusMainWindow=w.Event.any(w.Event.map(w.Event.filter(w.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),ie=>!!ie),ie=>ie.id),w.Event.filter(w.Event.fromNodeEventEmitter(P.app,"browser-window-focus",(ie,V)=>V.id),ie=>!!this.a.getWindowById(ie))),this.onDidBlurMainOrAuxiliaryWindow=w.Event.any(this.onDidBlurMainWindow,w.Event.map(w.Event.filter(w.Event.fromNodeEventEmitter(P.app,"browser-window-blur",(ie,V)=>this.b.getWindowByWebContents(V.webContents)),ie=>!!ie),ie=>ie.id)),this.onDidFocusMainOrAuxiliaryWindow=w.Event.any(this.onDidFocusMainWindow,w.Event.map(w.Event.filter(w.Event.fromNodeEventEmitter(P.app,"browser-window-focus",(ie,V)=>this.b.getWindowByWebContents(V.webContents)),ie=>!!ie),ie=>ie.id)),this.onDidResumeOS=w.Event.fromNodeEventEmitter(P.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new w.$je),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=w.Event.debounce(w.Event.any(w.Event.filter(w.Event.fromNodeEventEmitter(P.screen,"display-metrics-changed",(ie,V,he)=>he),ie=>!(Array.isArray(ie)&&ie.length===1&&ie[0]==="workArea")),w.Event.fromNodeEventEmitter(P.screen,"display-added"),w.Event.fromNodeEventEmitter(P.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(B,X){const G=this.a.getWindows().map(K=>({id:K.id,workspace:K.openedWorkspace??(0,l.$Qi)(K.backupPath,K.isExtensionDevelopmentHost),title:K.win?.getTitle()??"",filename:K.getRepresentedFilename(),dirty:K.isDocumentEdited()})),ae=[];return X.includeAuxiliaryWindows&&ae.push(...this.b.getWindows().map(K=>({id:K.id,parentId:K.parentId,title:K.win?.getTitle()??"",filename:K.getRepresentedFilename()}))),[...G,...ae]}async getWindowCount(B){return this.a.getWindowCount()}async getActiveWindowId(B){const X=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(X)return X.id}openWindow(B,X,G){return Array.isArray(X)?this.t(B,X,G):this.u(B,X)}async t(B,X,G=Object.create(null)){X.length>0&&await this.a.open({context:a.OpenContext.API,contextWindowId:B,urisToOpen:X,cli:this.g.args,forceNewWindow:G.forceNewWindow,forceReuseWindow:G.forceReuseWindow,preferNewWindow:G.preferNewWindow,diffMode:G.diffMode,mergeMode:G.mergeMode,addMode:G.addMode,gotoLineMode:G.gotoLineMode,noRecentEntry:G.noRecentEntry,waitMarkerFileURI:G.waitMarkerFileURI,remoteAuthority:G.remoteAuthority||void 0,forceProfile:G.forceProfile,forceTempProfile:G.forceTempProfile})}async u(B,X){await this.a.openEmptyWindow({context:a.OpenContext.API,contextWindowId:B},X)}async isFullScreen(B,X){return this.D(X?.targetWindowId,B)?.isFullScreen??!1}async toggleFullScreen(B,X){this.D(X?.targetWindowId,B)?.toggleFullScreen()}async handleTitleDoubleClick(B,X){this.D(X?.targetWindowId,B)?.handleTitleDoubleClick()}async getCursorScreenPoint(B){const X=P.screen.getCursorScreenPoint(),G=P.screen.getDisplayNearestPoint(X);return{point:X,display:G.bounds}}async isMaximized(B,X){return this.D(X?.targetWindowId,B)?.win?.isMaximized()??!1}async maximizeWindow(B,X){this.D(X?.targetWindowId,B)?.win?.maximize()}async unmaximizeWindow(B,X){this.D(X?.targetWindowId,B)?.win?.unmaximize()}async minimizeWindow(B,X){this.D(X?.targetWindowId,B)?.win?.minimize()}async moveWindowTop(B,X){this.D(X?.targetWindowId,B)?.win?.moveTop()}async positionWindow(B,X,G){const ae=this.D(G?.targetWindowId,B);if(ae?.win){if(ae.win.isFullScreen()){const K=w.Event.toPromise(w.Event.once(w.Event.fromNodeEventEmitter(ae.win,"leave-full-screen")));ae.win.setFullScreen(!1),await K}ae.win.setBounds(X)}}async updateWindowControls(B,X){this.D(X?.targetWindowId,B)?.updateWindowControls(X)}async focusWindow(B,X){this.D(X?.targetWindowId,B)?.focus({force:X?.force??!1})}async setMinimumSize(B,X,G){const ae=this.F(B);if(ae?.win){const[K,te]=ae.win.getSize(),[U,j]=ae.win.getMinimumSize(),[N,Y]=[X??U,G??j],[ie,V]=[Math.max(K,N),Math.max(te,Y)];(U!==N||j!==Y)&&ae.win.setMinimumSize(N,Y),(K!==ie||te!==V)&&ae.win.setSize(ie,V)}}async saveWindowSplash(B,X){this.m.saveWindowSplash(B,X)}async installShellCommand(B){const{source:X,target:G}=await this.w();try{const{symbolicLink:ae}=await v.SymlinkSupport.stat(X);if(ae&&!ae.dangling){const K=await(0,f.$kr)(X);if(G===K)return}await n.promises.unlink(X)}catch(ae){if(ae.code!=="ENOENT")throw ae}try{await n.promises.symlink(G,X)}catch(ae){if(ae.code!=="EACCES"&&ae.code!=="ENOENT")throw ae;const{response:K}=await this.showMessageBox(B,{type:"info",message:(0,$.localize)(11104,null,this.j.nameShort),buttons:[(0,$.localize)(11105,null),(0,$.localize)(11106,null)]});if(K===1)throw new O.$4;try{const te=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${G}' '${X}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(te)}catch{throw new Error((0,$.localize)(11107,null,X))}}}async uninstallShellCommand(B){const{source:X}=await this.w();try{await n.promises.unlink(X)}catch(G){switch(G.code){case"EACCES":{const{response:ae}=await this.showMessageBox(B,{type:"info",message:(0,$.localize)(11108,null,this.j.nameShort),buttons:[(0,$.localize)(11109,null),(0,$.localize)(11110,null)]});if(ae===1)throw new O.$4;try{const K=`osascript -e "do shell script \\"rm '${X}'\\" with administrator privileges"`;await(0,T.promisify)(r.exec)(K)}catch{throw new Error((0,$.localize)(11111,null,X))}break}case"ENOENT":break;default:throw G}}}async w(){const B=(0,h.$jc)(this.g.appRoot,"bin","code"),X=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(B))throw new Error((0,$.localize)(11112,null,B));return{source:X,target:B}}async showMessageBox(B,X){const G=this.D(X?.targetWindowId,B);return this.c.showMessageBox(X,G?.win??void 0)}async showSaveDialog(B,X){const G=this.D(X?.targetWindowId,B);return this.c.showSaveDialog(X,G?.win??void 0)}async showOpenDialog(B,X){const G=this.D(X?.targetWindowId,B);return this.c.showOpenDialog(X,G?.win??void 0)}async pickFileFolderAndOpen(B,X){const G=await this.c.pickFileFolder(X);G&&await this.z(await Promise.all(G.map(async ae=>await v.SymlinkSupport.existsDirectory(ae)?{folderUri:b.URI.file(ae)}:{fileUri:b.URI.file(ae)})),X,B)}async pickFolderAndOpen(B,X){const G=await this.c.pickFolder(X);G&&await this.z(G.map(ae=>({folderUri:b.URI.file(ae)})),X,B)}async pickFileAndOpen(B,X){const G=await this.c.pickFile(X);G&&await this.z(G.map(ae=>({fileUri:b.URI.file(ae)})),X,B)}async pickWorkspaceAndOpen(B,X){const G=await this.c.pickWorkspace(X);G&&await this.z(G.map(ae=>({workspaceUri:b.URI.file(ae)})),X,B)}async z(B,X,G){await this.a.open({context:a.OpenContext.DIALOG,contextWindowId:G,cli:this.g.args,urisToOpen:B,forceNewWindow:X.forceNewWindow})}async showItemInFolder(B,X){P.shell.showItemInFolder(X)}async setRepresentedFilename(B,X,G){this.D(G?.targetWindowId,B)?.setRepresentedFilename(X)}async setDocumentEdited(B,X,G){this.D(G?.targetWindowId,B)?.setDocumentEdited(X)}async openExternal(B,X){return this.g.unsetSnapExportedVariables(),P.shell.openExternal(X),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(B,X){return P.shell.trashItem(X)}async isAdmin(){let B;return m.$j?B=(await new Promise((X,G)=>{J(["native-is-elevated"],X,G)}).then(Ie)).default():B=process.getuid?.()===0,B}async writeElevated(B,X,G,ae){const K=await new Promise((te,U)=>{J(["@vscode/sudo-prompt"],te,U)}).then(Ie);return new Promise((te,U)=>{const j=[`"${this.C}"`];ae?.unlock&&j.push("--file-chmod"),j.push("--file-write",`"${X.fsPath}"`,`"${G.fsPath}"`);const N={name:this.j.nameLong.replace("-",""),icns:m.$k&&this.g.isBuilt?(0,h.$ic)((0,h.$lc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};K.exec(j.join(" "),N,(Y,ie,V)=>{ie&&this.h.trace(`[sudo-prompt] received stdout: ${ie}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),Y?U(Y):te(void 0)})})}async isRunningUnderARM64Translation(){return m.$l||m.$j?!1:P.app.runningUnderARM64Translation}get C(){return m.$j?this.g.isBuilt?(0,h.$ic)((0,h.$lc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.bat"):m.$l?this.g.isBuilt?(0,h.$ic)((0,h.$lc)(process.execPath),"bin",`${this.j.applicationName}`):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,h.$ic)(this.g.appRoot,"bin","code"):(0,h.$ic)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,R.totalmem)(),freemem:(0,R.freemem)(),loadavg:(0,R.loadavg)()}}async getOSProperties(){return{arch:(0,R.arch)(),platform:(0,R.platform)(),release:(0,R.release)(),type:(0,R.type)(),cpus:(0,R.cpus)()}}async getOSVirtualMachineHint(){return d.$Pn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return m.$j&&(0,D.$Ifc)()}async getProcessId(B){return this.D(void 0,B)?.win?.webContents.getOSProcessId()}async killProcess(B,X,G){process.kill(X,G)}async readClipboardText(B,X){return P.clipboard.readText(X)}async writeClipboardText(B,X,G){return P.clipboard.writeText(X,G)}async readClipboardFindText(B){return P.clipboard.readFindText()}async writeClipboardFindText(B,X){return P.clipboard.writeFindText(X)}async writeClipboardBuffer(B,X,G,ae){return P.clipboard.writeBuffer(X,Buffer.from(G.buffer),ae)}async readClipboardBuffer(B,X){return y.$Le.wrap(P.clipboard.readBuffer(X))}async hasClipboard(B,X,G){return P.clipboard.has(X,G)}async newWindowTab(){await this.a.open({context:a.OpenContext.API,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){P.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){P.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){P.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){P.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){P.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(B,X){this.F(B)?.updateTouchBar(X)}async notifyReady(B){this.F(B)?.setReady()}async relaunch(B,X){return this.f.relaunch(X)}async reload(B,X){const G=this.F(B);if(G){if((0,l.$Ri)(G.openedWorkspace)){const ae=G.openedWorkspace.configPath;if(ae.scheme===g.Schemas.file&&(await this.n.resolveLocalWorkspace(ae))?.transient)return this.openWindow(G.id,{forceReuseWindow:!0})}return this.f.reload(G,X?.disableExtensions!==void 0?{_:[],"disable-extensions":X.disableExtensions}:void 0)}}async closeWindow(B,X){return this.D(X?.targetWindowId,B)?.win?.close()}async quit(B){const X=this.a.getLastActiveWindow();X?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&X.win?X.win.close():this.f.quit()}async exit(B,X){await this.f.kill(X)}async resolveProxy(B,X){return this.F(B)?.win?.webContents?.session?.resolveProxy(X)}async lookupAuthorization(B,X){return this.r.lookupAuthorization(X)}async loadCertificates(B){return(await new Promise((G,ae)=>{J(["@vscode/proxy-agent"],G,ae)}).then(Ie)).loadSystemCertificates({log:this.h})}findFreePort(B,X,G,ae,K=1){return(0,p.$1g)(X,G,ae,K)}async openDevTools(B,X){this.D(X?.targetWindowId,B)?.win?.webContents.openDevTools(X?.mode?{mode:X.mode,activate:X.activate}:void 0)}async toggleDevTools(B,X){this.D(X?.targetWindowId,B)?.win?.webContents.toggleDevTools()}async profileRenderer(B,X,G){const ae=this.F(B);if(!ae||!ae.win)throw new Error;return await new L.$Jfc(ae.win,X,this.h).inspect(G)}async windowsGetStringRegKey(B,X,G,ae){if(!m.$j)return;const K=await new Promise((te,U)=>{J(["@vscode/windows-registry"],te,U)}).then(Ie);try{return K.GetStringRegKey(X,G,ae)}catch{return}}D(B,X){return this.F(B)??this.G(B)??this.F(X)}F(B){if(typeof B=="number")return this.a.getWindowById(B)}G(B){if(typeof B!="number")return;const X=P.webContents.fromId(B);if(X)return this.b.getWindowByWebContents(X)}};e.$Mfc=x,Ee([I.$7h],x.prototype,"C",null),e.$Mfc=x=Ee([re(0,a.$Yec),re(1,A.$Kfc),re(2,k.$Tec),re(3,u.$ffc),re(4,S.$Nec),re(5,i.$0j),re(6,o.$qk),re(7,s.$Wec),re(8,E.$$ec),re(9,W.$pfc)],x)});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[268],ue([0,1,13,27,8,21,2,11,3,35,10,52,22,5,64,72,73,50,29]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0,d=et(d);let S=class{static{k=this}static{this.a="#1E1E1E"}constructor(u,i,o,s,a,l,E){this.d=u,this.e=i,this.f=o,this.g=s,this.h=a,this.i=l,this.j=E,this.b=null,this.c=null}async openReporter(u){if(this.b)this.b&&this.k(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const i=new T.$Sc,o=i.add(this.i.createIPCObjectUrl()),s=this.m(this.c,700,800);this.b=this.l(s,o,{backgroundColor:u.styles.backgroundColor,title:(0,g.localize)(11201,null),zoomLevel:u.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.e.appRoot,windowId:this.b.id,userEnv:this.d,data:u,disableExtensions:!!this.e.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:d.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(I.$Wg.asBrowserUri(`vs/workbench/contrib/issue/electron-sandbox/issueReporter${this.e.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,i.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,i.dispose())})}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.h.reload(this.c.id,{disableExtensions:!0})}catch(u){this.f.error(u)}}async $showConfirmCloseDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,g.localize)(11202,null),buttons:[(0,g.localize)(11203,null),(0,g.localize)(11204,null)]},this.b);u===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:u}=await this.g.showMessageBox({type:"warning",message:(0,g.localize)(11205,null),buttons:[(0,g.localize)(11206,null),(0,g.localize)(11207,null)]},this.b);return u===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const u=this.j.getWindowById(this.c.id);if(!u)throw new Error("Window not found");return u}async $sendReporterMenu(u,i){const o=this.issueReporterWindowCheck(),s="vscode:triggerReporterMenu",a=new R.$ue;return o.sendWhenReady(s,a.token,{replyChannel:s,extensionId:u,extensionName:i}),await(0,P.$th)(new Promise(E=>c.$BX.once(`vscode:triggerReporterMenuResponse:${u}`,(y,D)=>E(D))),5e3,()=>{this.f.error(`Error: Extension ${u} timed out waiting for menu response`),a.cancel()})}async $closeReporter(){this.b?.close()}k(u){u.isMinimized()&&u.restore(),u.focus()}l(u,i,o,s){const a=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:o.title,backgroundColor:o.backgroundColor||k.a,webPreferences:{preload:I.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`],v8CacheOptions:this.e.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,p.$0D)(o.zoomLevel),sandbox:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return a.setMenuBarVisibility(!1),a}m(u,i,o){let s;const a=n.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(w.$k){const y=n.screen.getCursorScreenPoint();s=n.screen.getDisplayNearestPoint(y)}!s&&u&&(s=n.screen.getDisplayMatching(u.getBounds())),s||(s=n.screen.getPrimaryDisplay()||a[0])}const l=s.bounds,E={width:i,height:o,x:l.x+l.width/2-i/2,y:l.y+l.height/2-o/2};return l.width>0&&l.height>0&&(E.x<l.x&&(E.x=l.x),E.y<l.y&&(E.y=l.y),E.x>l.x+l.width&&(E.x=l.x),E.y>l.y+l.height&&(E.y=l.y),E.width>l.width&&(E.width=l.width),E.height>l.height&&(E.height=l.height)),E}};e.$Nfc=S,e.$Nfc=S=k=Ee([re(1,m.$Nec),re(2,b.$0j),re(3,h.$Tec),re(4,f.$Lfc),re(5,v.$Vec),re(6,$.$Yec)],S)});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[269],ue([0,1,13,32,2,11,3,115,35,10,96,136,52,22,5,64,72,28,73,34,63,50]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0,v=et(v);const i="issue.processExplorerWindowState";let o=class{static{u=this}static{this.a="#1E1E1E"}constructor(l,E,y,D,L,A,O,W,x,H){this.d=l,this.f=E,this.g=y,this.h=D,this.i=L,this.j=A,this.k=O,this.l=W,this.m=x,this.n=H,this.b=null,this.c=null,this.o()}o(){w.$BX.on("vscode:listProcesses",async l=>{const E=[];try{E.push({name:(0,c.localize)(11196,null),rootProcess:await(0,I.$Us)(process.pid)}),(await this.i.getRemoteDiagnostics({includeProcesses:!0})).forEach(D=>{(0,g.$Rm)(D)?E.push({name:D.hostName,rootProcess:D}):D.processes&&E.push({name:D.hostName,rootProcess:D.processes})})}catch(y){this.g.error(`Listing processes failed: ${y}`)}this.s(l,"vscode:listProcessesResponse",E)}),w.$BX.on("vscode:workbenchCommand",(l,E)=>{const{id:y,from:D,args:L}=E;let A;switch(D){case"processExplorer":A=this.c;break;default:throw new Error(`Unexpected command source: ${D}`)}A?.webContents.send("vscode:runAction",{id:y,from:D,args:L})}),w.$BX.on("vscode:closeProcessExplorer",l=>{this.b?.close()}),w.$BX.on("vscode:pidToNameRequest",async l=>{const E=await this.i.getMainDiagnostics(),y=[];for(const D of E.windows)y.push([D.pid,`window [${D.id}] (${D.title})`]);for(const{pid:D,name:L}of S.$tfc.getAll())y.push([D,L]);this.s(l,"vscode:pidToNameResponse",y)})}async openProcessExplorer(l){if(!this.b&&(this.c=n.BrowserWindow.getFocusedWindow(),this.c)){const E=new P.$Sc,y=E.add(this.l.createIPCObjectUrl()),D=this.n.getItem(i,void 0),L=s(D)?D:this.q(this.c,800,500);this.b=this.r(L,y,{backgroundColor:l.styles.backgroundColor,title:(0,c.localize)(11197,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),y.update({appRoot:this.f.appRoot,windowId:this.b.id,userEnv:this.d,data:l,product:v.default,nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE}}),this.b.loadURL(R.$Wg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.f.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,E.dispose()}),this.c.on("close",()=>{this.b&&(this.b.close(),this.b=null,E.dispose())});const A=()=>{if(!this.b)return;const O=this.b.getSize(),W=this.b.getPosition();if(!O||!W)return;const x={width:O[0],height:O[1],x:W[0],y:W[1]};this.n.setItem(i,x)};this.b.on("moved",A),this.b.on("resized",A)}this.b&&this.p(this.b)}p(l){l.isMinimized()&&l.restore(),l.focus()}q(l,E,y){let D;const L=n.screen.getAllDisplays();if(L.length===1)D=L[0];else{if(T.$k){const W=n.screen.getCursorScreenPoint();D=n.screen.getDisplayNearestPoint(W)}!D&&l&&(D=n.screen.getDisplayMatching(l.getBounds())),D||(D=n.screen.getPrimaryDisplay()||L[0])}const A=D.bounds,O={width:E,height:y,x:A.x+A.width/2-E/2,y:A.y+A.height/2-y/2};return A.width>0&&A.height>0&&(O.x<A.x&&(O.x=A.x),O.y<A.y&&(O.y=A.y),O.x>A.x+A.width&&(O.x=A.x),O.y>A.y+A.height&&(O.y=A.y),O.width>A.width&&(O.width=A.width),O.height>A.height&&(O.height=A.height)),O}async stopTracing(){if(!this.f.args.trace)return;const l=await n.contentTracing.stopRecording(`${(0,r.$Kg)(this.f.userHome.fsPath,this.m.applicationName)}.trace.txt`);await this.j.showMessageBox({type:"info",message:(0,c.localize)(11198,null),detail:(0,c.localize)(11199,null,l),buttons:[(0,c.localize)(11200,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.k.showItemInFolder(void 0,l)}async getSystemStatus(){const[l,E]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.h.getDiagnostics(l,E)}async $getSystemInfo(){const[l,E]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.h.getSystemInfo(l,E)}async $getPerformanceInfo(){try{const[l,E]=await Promise.all([this.i.getMainDiagnostics(),this.i.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.h.getPerformanceInfo(l,E)}catch(l){throw this.g.warn("issueService#getPerformanceInfo ",l.message),l}}r(l,E,y,D){const L=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:y.title,backgroundColor:y.backgroundColor||u.a,webPreferences:{preload:R.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${E.resource.toString()}`],v8CacheOptions:this.f.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$0D)(y.zoomLevel),sandbox:!0},alwaysOnTop:y.alwaysOnTop,experimentalDarkMode:!0});return L.setMenuBarVisibility(!1),L}s(l,E,...y){l.sender.isDestroyed()||l.sender.send(E,...y)}async closeProcessExplorer(){this.b?.close()}};e.$Ofc=o,e.$Ofc=o=u=Ee([re(1,b.$Nec),re(2,f.$0j),re(3,g.$Qm),re(4,h.$wfc),re(5,m.$Tec),re(6,d.$Lfc),re(7,$.$Vec),re(8,p.$qk),re(9,k.$iR)],o);function s(a){return typeof a!="object"||a===null?!1:"x"in a&&"y"in a&&"width"in a&&"height"in a}}),define(le[270],ue([0,1,21,17,22,19,5,64,28,56,24,49,105]),function(J,e,n,r,P,R,T,I,w,c,g,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;let b=class extends m.$bgc{constructor(d,v,p,$,k,S,t,u){super(d,v,$,k,S,u),this.e=p,this.u=t}s(d){return(0,m.$agc)(`linux-${process.arch}`,d,this.k)}t(d){this.a&&(this.d(h.$zY.CheckingForUpdates(d)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$$p).then(v=>{!v||!v.url||!v.version||!v.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!d}),this.d(h.$zY.Idle(h.UpdateType.Archive))):this.d(h.$zY.AvailableForDownload(v))}).then(void 0,v=>{this.j.error(v);const p=d?v.message||v:void 0;this.d(h.$zY.Idle(h.UpdateType.Archive,p))}))}async o(d){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):d.update.url&&this.u.openExternal(void 0,d.update.url),this.d(h.$zY.Idle(h.UpdateType.Archive))}};e.$dgc=b,e.$dgc=b=Ee([re(0,R.$ffc),re(1,r.$9i),re(2,g.$9l),re(3,P.$Nec),re(4,c.$5p),re(5,T.$0j),re(6,I.$Lfc),re(7,w.$qk)],b)}),define(le[271],ue([0,1,48,26,27,8,21,53,46,9,7,151,23,17,22,14,19,5,64,28,56,24,49,105]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0,r=Ie(r),c=Ie(c),m=Ie(m);async function o(E,y=1e3){for(;!E();)await(0,R.$Dh)(y)}let s;function a(){return typeof s>"u"&&(s=r.existsSync(c.$ic(c.$lc(process.execPath),"unins000.exe"))?u.UpdateType.Setup:u.UpdateType.Archive),s}let l=class extends i.$bgc{get cachePath(){const y=c.$ic((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return r.promises.mkdir(y,{recursive:!0}).then(()=>y)}constructor(y,D,L,A,O,W,x,H,B){super(y,D,A,O,W,B),this.u=L,this.v=x,this.w=H,y.setRelaunchHandler(this)}handleRelaunch(y){return y?.addArgs||y?.removeArgs||this.state.type!==u.StateType.Ready||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$zY.Disabled(u.DisablementReason.RunningAsAdmin)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(y){let D=`win32-${process.arch}`;return a()===u.UpdateType.Archive?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,i.$agc)(D,y,this.k)}t(y){this.a&&(this.d(u.$zY.CheckingForUpdates(y)),this.i.request({url:this.a},T.CancellationToken.None).then(S.$$p).then(D=>{const L=a();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!y}),this.d(u.$zY.Idle(L)),Promise.resolve(null)):L===u.UpdateType.Archive?(this.d(u.$zY.AvailableForDownload(D)),Promise.resolve(null)):(this.d(u.$zY.Downloading),this.C(D.version).then(()=>this.B(D.version).then(A=>m.Promises.exists(A).then(O=>{if(O)return Promise.resolve(A);const W=`${A}.tmp`;return this.i.request({url:D.url},T.CancellationToken.None).then(x=>this.v.writeFile(g.URI.file(W),x.stream)).then(D.sha256hash?()=>(0,h.$uX)(W,D.sha256hash):()=>{}).then(()=>m.Promises.rename(W,A,!1)).then(()=>A)})).then(A=>{this.e={packagePath:A},this.d(u.$zY.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(u.$zY.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,w.$qj)(String(D)))}),this.j.error(D);const L=y?D.message||D:void 0;this.d(u.$zY.Idle(a(),L))}))}async o(y){y.update.url&&this.w.openExternal(void 0,y.update.url),this.d(u.$zY.Idle(a()))}async B(y){const D=await this.cachePath;return c.$ic(D,`CodeSetup-${this.k.quality}-${y}.exe`)}async C(y=null){const D=y?W=>!new RegExp(`${this.k.quality}-${y}\\.exe$`).test(W):()=>!0,L=await this.cachePath,O=(await m.Promises.readdir(L)).filter(D).map(async W=>{try{await r.promises.unlink(c.$ic(L,W))}catch{}});await Promise.all(O)}async p(){if(this.state.type!==u.StateType.Downloaded||!this.e)return Promise.resolve(void 0);const y=this.state.update;this.d(u.$zY.Updating(y));const D=await this.cachePath;this.e.updateFilePath=c.$ic(D,`CodeSetup-${this.k.quality}-${y.version}.flag`),await m.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$zY.Idle(a()))});const A=`${this.k.win32MutexName}-ready`,O=await new Promise((W,x)=>{J(["@vscode/windows-mutex"],W,x)}).then(Ie);o(()=>O.isActive(A)).then(()=>this.d(u.$zY.Ready(y)))}r(){this.state.type!==u.StateType.Ready||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?r.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(y){if(this.state.type!==u.StateType.Idle)return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),L={version:"unknown",productVersion:"unknown"};this.d(u.$zY.Downloading),this.e={packagePath:y},this.d(u.$zY.Downloaded(L)),D?this.k.target==="user"&&this.p():this.d(u.$zY.Ready(L))}};e.$fgc=l,Ee([I.$7h],l.prototype,"cachePath",null),e.$fgc=l=Ee([re(0,v.$ffc),re(1,b.$9i),re(2,t.$9l),re(3,f.$Nec),re(4,S.$5p),re(5,p.$0j),re(6,d.$0k),re(7,$.$Lfc),re(8,k.$qk)],l)}),define(le[137],ue([0,1,13,8,21,54,4,2,11,70,3,7,10,27,69,17,52,22,68,14,19,5,28,73,247,87,24,110,76,50,29,30,59,51,40,34,58,71,20,6]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i,o,s,a,l,E,y,D,L,A,O,W,x,H,B,X,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=void 0;var ae;(function(U){U[U.NONE=0]="NONE",U[U.NAVIGATING=1]="NAVIGATING",U[U.READY=2]="READY"})(ae||(ae={}));class K extends I.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(j){this.m=j,this.B(T.Event.fromNodeEventEmitter(j,"maximize")(()=>this.b.fire())),this.B(T.Event.fromNodeEventEmitter(j,"unmaximize")(()=>this.c.fire())),this.B(T.Event.fromNodeEventEmitter(j,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(T.Event.fromNodeEventEmitter(j,"focus")(()=>{this.j=Date.now()})),this.B(T.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(T.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const N=!(0,y.$5D)(this.r);if(g.$k&&N&&j.setSheetOffset((0,g.$K)((0,b.release)())?28:22),N&&(g.$j&&(0,y.$8D)(this.r)||g.$k)){const Y=this.s.getItem(K.D);Y?this.updateWindowControls({height:Y}):this.updateWindowControls({height:y.$7D})}g.$j&&N&&j.hookWindowMessage(278,()=>{const[ie,V]=j.getPosition(),he=n.screen.getCursorScreenPoint(),oe=he.x-ie,ee=he.y-V;return!(oe>30&&ee>=0&&ee<=Math.max(j.getBounds().height*.15,35))||(j.setEnabled(!1),j.setEnabled(!0),this.f.fire({x:oe,y:ee})),0}),this.t.args["open-devtools"]===!0&&j.webContents.openDevTools(),g.$k&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(j,N,Y,ie){super(),this.r=j,this.s=N,this.t=Y,this.u=ie,this.a=this.B(new T.$je),this.onDidClose=this.a.event,this.b=this.B(new T.$je),this.onDidMaximize=this.b.event,this.c=this.B(new T.$je),this.onDidUnmaximize=this.c.event,this.f=this.B(new T.$je),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new T.$je),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new T.$je),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,y.$8D)(this.r),this.G=void 0,this.H=void 0}w(j,N=n.screen.getAllDisplays().length>0){const Y=this.r.getValue("window"),ie=g.$k&&Y?.nativeTabs===!0;(g.$k||g.$j)&&N&&(!ie||n.BrowserWindow.getAllWindows().length===1)&&[j.width,j.height,j.x,j.y].every(V=>typeof V=="number")&&this.m?.setBounds({width:j.width,height:j.height,x:j.x,y:j.y}),(j.mode===O.WindowMode.Maximized||j.mode===O.WindowMode.Fullscreen)&&(this.m?.maximize(),j.mode===O.WindowMode.Fullscreen&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(j){g.$k?this.win?.setRepresentedFilename(j):this.z=j}getRepresentedFilename(){return g.$k?this.win?.getRepresentedFilename():this.z}setDocumentEdited(j){g.$k&&this.win?.setDocumentEdited(j),this.C=j}isDocumentEdited(){return g.$k?!!this.win?.isDocumentEdited():!!this.C}focus(j){g.$k&&j?.force&&n.app.focus({steal:!0});const N=this.win;N&&(N.isMinimized()&&N.restore(),N.focus())}handleTitleDoubleClick(){const j=this.win;if(j)if(g.$k)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":j.minimize();break;case"None":break;case"Maximize":default:j.isMaximized()?j.unmaximize():j.maximize()}else j.isMaximized()?j.unmaximize():j.maximize()}static{this.D="windowControlHeight"}updateWindowControls(j){const N=this.win;if(N){if(j.height&&this.s.setItem(te.D,j.height),g.$j&&this.F)N.setTitleBarOverlay({color:j.backgroundColor?.trim()===""?void 0:j.backgroundColor,symbolColor:j.foregroundColor?.trim()===""?void 0:j.foregroundColor,height:j.height?j.height-1:void 0});else if(g.$k&&j.height!==void 0){const Y=(j.height-15)/2;Y?N.setWindowButtonPosition({x:Y,y:Y}):N.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(j,N){(0,y.$9D)(this.r)?this.J(j,N):this.M(j)}get isFullScreen(){if(g.$k&&typeof this.G=="boolean")return this.G;const j=this.win,N=j?.isFullScreen(),Y=j?.isSimpleFullScreen();return!!(N||Y)}J(j,N){const Y=this.win;Y?.isSimpleFullScreen()&&Y?.setSimpleFullScreen(!1),this.L(j,N)}L(j,N){if(g.$k){this.G=j;const ie=this.H=new r.$Zh;(async()=>{const V=await Promise.race([ie.p,(0,r.$Dh)(1e4).then(()=>!1)]);this.H===ie&&(this.G=void 0,this.H=void 0,!V&&j&&N&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(j)}M(j){const N=this.win;N?.isFullScreen()&&this.L(!1,!1),N?.setSimpleFullScreen(j),N?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$cfc=K;let te=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const j=this.hb.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&j?j:this.hb.getProfileForWorkspace(this.config.workspace??(0,L.$Qi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(j,N,Y,ie,V,he,oe,ee,M,F,C,z,Z,Q,q,se,de,me,we,De,ke){super(F,De,ie,N),this.fb=Y,this.gb=V,this.hb=he,this.ib=oe,this.jb=ee,this.kb=M,this.lb=C,this.mb=z,this.nb=Z,this.ob=Q,this.pb=q,this.qb=se,this.rb=de,this.sb=me,this.tb=we,this.N=this.B(new T.$je),this.onWillLoad=this.N.event,this.O=this.B(new T.$je),this.onDidSignalReady=this.O.event,this.P=this.B(new T.$je),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=ae.NONE;{const[Pe,Re]=this.Eb(j.state);this.U=Pe,this.u.trace("window#ctor: using window state",Pe);const $e=ke.invokeFunction(D.$Zec,this.U,{preload:w.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow($e),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Re),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=ae.READY;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(j=>{if(this.isReady)return j(this);this.X.push(j)})}get isReady(){return this.ub===ae.READY}get whenClosedOrLoaded(){return new Promise(j=>{function N(){Y.dispose(),ie.dispose(),j()}const Y=this.onDidClose(()=>N()),ie=this.onWillLoad(()=>N())})}vb(){this.B(T.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(O.WindowError.UNRESPONSIVE))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(N,Y)=>Y)(N=>this.yb(O.WindowError.PROCESS_GONE,{...N}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(N,Y,ie)=>({exitCode:Y,reason:ie}))(({exitCode:N,reason:Y})=>this.yb(O.WindowError.LOAD,{reason:Y,exitCode:N}))),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(N=>N.preventDefault())),this.B(T.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(N=>this.Bb(N))),this.B(this.mb.onDidDeleteUntitledWorkspace(N=>this.Ab(N)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(N,Y)=>{const ie=await this.xb();Y({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,ie)})})}xb(){return this.wb||(this.wb=(0,o.$mq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(j,N){switch(j){case O.WindowError.PROCESS_GONE:this.u.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case O.WindowError.UNRESPONSIVE:this.u.error("CodeWindow: detected unresponsive");break;case O.WindowError.LOAD:this.u.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:j,reason:N?.reason,code:N?.exitCode}),j){case O.WindowError.UNRESPONSIVE:case O.WindowError.PROCESS_GONE:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(j===O.WindowError.UNRESPONSIVE){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:Y,checkboxChecked:ie}=await this.pb.showMessageBox({type:"warning",buttons:[(0,m.localize)(10876,null),(0,m.localize)(10877,null),(0,m.localize)(10878,null)],message:(0,m.localize)(10879,null),detail:(0,m.localize)(10880,null),checkboxLabel:this.S?.workspace?(0,m.localize)(10881,null):void 0},this.m);if(Y!==2){const V=Y===0;await this.zb(V,ie)}}else if(j===O.WindowError.PROCESS_GONE){let Y;N?Y=(0,m.localize)(10883,null,N.reason,N.exitCode??"<unknown>"):Y=(0,m.localize)(10882,null);const{response:ie,checkboxChecked:V}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,m.localize)(10884,null):(0,m.localize)(10885,null),(0,m.localize)(10886,null)],message:Y,detail:this.S?.workspace?(0,m.localize)(10887,null):(0,m.localize)(10888,null),checkboxLabel:this.S?.workspace?(0,m.localize)(10889,null):void 0},this.m),he=ie===0;await this.zb(he,V)}break}}async zb(j,N){const Y=this.S?.workspace;if(N&&Y)try{const ie=this.kb.workspaceStorage(Y);await ie.init(),ie.delete("memento/workbench.parts.editor"),await ie.close()}catch(ie){this.u.error(ie)}this.P.fire();try{if(j&&this.S){let ie,V;(0,L.$Mi)(Y)?ie={folderUri:Y.uri}:(0,L.$Ri)(Y)?ie={workspaceUri:Y.configPath}:V=!0,(0,X.$Nb)(await this.tb.open({context:D.OpenContext.API,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ie?[ie]:void 0,forceEmpty:V,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(j){this.S?.workspace?.id===j.id&&(this.S.workspace=void 0)}Bb(j){if(!j||j.affectsConfiguration("window.menuBarVisibility")){const N=this.Gb();N!==this.W&&(this.W=N,this.Hb(N))}if(!j||j.affectsConfiguration("http.proxy")||j.affectsConfiguration("http.noProxy")){let N=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const Y=(this.r.getValue("http.noProxy")||[]).map(ie=>ie.trim()).join(",")||(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.Z||Y!==this.$)){this.Z=N,this.$=Y;const ie=N||"",V=Y?`${Y},<local>`:"<local>";this.u.trace(`Setting proxy to '${ie}', bypassing '${V}'`),this.m.webContents.session.setProxy({proxyRules:ie,proxyBypassRules:V,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:ie,proxyBypassRules:V,pacScript:""})}}}addTabbedWindow(j){g.$k&&j.win&&this.m.addTabbedWindow(j.win)}load(j,N=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!N.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(j,N),this.ub===ae.NONE?this.S=j:this.db=j,this.ub=ae.NAVIGATING,this.m.loadURL(w.$Wg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const Y=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new r.$Oh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:j.workspace,reason:N.isReload?O.LoadReason.RELOAD:Y?O.LoadReason.LOAD:O.LoadReason.INITIAL})}Cb(j,N){const Y=(this.S??this.db)?.userEnv;if(Y){const ie=(0,$.$Hm)(Y)&&!(0,$.$Hm)(j.userEnv),V=this.isExtensionDevelopmentHost;(ie||V)&&(j.userEnv={...Y,...j.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(j.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(j["disable-extensions"]=N.disableExtensions),j.fullscreen=this.isFullScreen,j.maximized=this.m.isMaximized(),j.partsSplash=this.lb.getWindowSplash(),j.zoomLevel=this.Jb(),j.isCustomZoomLevel=typeof this.ab=="number",j.isCustomZoomLevel&&j.partsSplash&&(j.partsSplash.zoomLevel=j.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),j.perfMarks=(0,c.getMarks)(),this.bb.update(j)}async reload(j){const N=Object.assign({},this.S);N.workspace=await this.Db(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&j&&(N.verbose=j.verbose,N.debugId=j.debugId,N.extensionEnvironment=j.extensionEnvironment,N["inspect-extensions"]=j["inspect-extensions"],N["inspect-brk-extensions"]=j["inspect-brk-extensions"],N["extensions-dir"]=j["extensions-dir"]),N.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.gb.serialize(),N.continueOn=this.t.continueOn,N.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},N.logLevel=this.fb.getLogLevel(),N.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:j?.["disable-extensions"]})}async Db(j){if((0,L.$Ri)(j.workspace)){const N=j.workspace.configPath;if(N.scheme===w.Schemas.file&&!await this.ib.exists(N))return}else if((0,L.$Mi)(j.workspace)){const N=j.workspace.uri;if(N.scheme===w.Schemas.file&&!await this.ib.exists(N))return}return j.workspace}serializeWindowState(){if(!this.m)return(0,O.$Lec)();if(this.isFullScreen){let Y;try{Y=n.screen.getDisplayMatching(this.getBounds())}catch{}const ie=(0,O.$Lec)();return{mode:O.WindowMode.Fullscreen,display:Y?Y.id:void 0,width:this.U.width||ie.width,height:this.U.height||ie.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const j=Object.create(null);let N;if(!g.$k&&this.m.isMaximized()?N=O.WindowMode.Maximized:N=O.WindowMode.Normal,N===O.WindowMode.Maximized?j.mode=O.WindowMode.Maximized:j.mode=O.WindowMode.Normal,N===O.WindowMode.Normal||N===O.WindowMode.Maximized){let Y;N===O.WindowMode.Normal?Y=this.getBounds():Y=this.m.getNormalBounds(),j.x=Y.x,j.y=Y.y,j.width=Y.width,j.height=Y.height}return j.zoomLevel=this.ab,j}Eb(j){(0,c.mark)("code/willRestoreCodeWindowState");let N=!1;if(j){this.ab=j.zoomLevel;try{const Y=n.screen.getAllDisplays();N=Y.length>1,j=D.WindowStateValidator.validateWindowState(this.u,j,Y)}catch(Y){this.u.warn(`Unexpected error validating window state: ${Y}
${Y.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[j||(0,O.$Lec)(),N]}getBounds(){const[j,N]=this.m.getPosition(),[Y,ie]=this.m.getSize();return{x:j,y:N,width:Y,height:ie}}I(j,N){super.I(j,N),this.sendWhenReady(j?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let j=(0,y.$3D)(this.r);return["visible","toggle","hidden"].indexOf(j)<0&&(j="classic"),j}Hb(j,N=!0){g.$k||(j==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,m.localize)(10890,null)),j==="hidden"?setTimeout(()=>{this.Ib(j)}):this.Ib(j))}Ib(j){const N=this.isFullScreen;switch(j){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(j){this.ab=j}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(j,N,...Y){this.isReady?this.send(j,...Y):this.ready().then(()=>{N.isCancellationRequested||this.send(j,...Y)})}send(j,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${j}' for window that is destroyed`);return}try{this.m.webContents.send(j,...N)}catch(Y){this.u.warn(`Error sending IPC message to channel '${j}' of window ${this.Q}: ${(0,R.$nj)(Y)}`)}}}updateTouchBar(j){g.$k&&this.Y.forEach((N,Y)=>{const ie=j[Y];N.segments=this.Mb(ie)})}Kb(){if(g.$k){for(let j=0;j<10;j++){const N=this.Lb();this.Y.push(N)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(j=[]){const N=this.Mb(j),Y=new n.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:ie=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:Y.segments[ie].id,from:"touchbar"})}});return Y}Mb(j=[]){return j.map(Y=>{let ie;Y.icon&&!l.ThemeIcon.isThemeIcon(Y.icon)&&Y.icon?.dark?.scheme===w.Schemas.file&&(ie=n.nativeImage.createFromPath(h.URI.revive(Y.icon.dark).fsPath),ie.isEmpty()&&(ie=void 0));let V;return typeof Y.title=="string"?V=Y.title:V=Y.title.value,{id:Y.id,label:ie?void 0:V,icon:ie}})}matches(j){return this.m?.webContents.id===j.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$dfc=te,e.$dfc=te=Ee([re(1,t.$0j),re(2,B.$afc),re(3,p.$Nec),re(4,W.$qo),re(5,H.$2ec),re(6,k.$0k),re(7,s.$nfc),re(8,s.$lfc),re(9,d.$9i),re(10,E.$Wec),re(11,A.$$ec),re(12,f.$Sec),re(13,a.$9l),re(14,v.$Tec),re(15,S.$ffc),re(16,u.$qk),re(17,i.$Vec),re(18,D.$Yec),re(19,x.$iR),re(20,G.$Bi)],te)}),define(le[272],ue([0,1,13,3,17,22,19,5,34,50,51,137]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;let m=class extends h.$cfc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(f,d,v,p,$,k){super(p,$,d,v),this.O=f,this.P=k,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(f){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),f&&!this.N&&(this.N=!0,this.w({x:f.x,y:f.y,width:f.width,height:f.height,mode:f.show===!1?g.WindowMode.Maximized:g.WindowMode.Normal})))}Q(){if(this.m)return;const f=n.BrowserWindow.fromWebContents(this.O);f&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(f),f.setMenu(null),(r.$j||r.$l)&&(0,c.$5D)(this.r)&&f.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(f){return this.O.id===f.id}};e.$efc=m,e.$efc=m=Ee([re(1,R.$Nec),re(2,I.$0j),re(3,P.$9i),re(4,w.$iR),re(5,T.$ffc)],m)}),define(le[273],ue([0,1,13,4,2,11,35,272,6,5,51,29]),function(J,e,n,r,P,R,T,I,w,c,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;let m=class extends P.$Tc{constructor(f,d){super(),this.h=f,this.j=d,this.a=this.B(new r.$je),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new r.$je),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new r.$je),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new r.$je),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,d)=>{const v=this.getWindowByWebContents(d.webContents);if(v)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),v.tryClaimWindow();else{const p=new P.$Sc;p.add(r.Event.fromNodeEventEmitter(d.webContents,"did-create-window",($,k)=>({browserWindow:$,details:k}))(({browserWindow:$,details:k})=>{const S=this.getWindowByWebContents($.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(k.options))})),p.add(r.Event.fromNodeEventEmitter(d,"closed")(()=>p.dispose()))}}),T.$BX.handle("vscode:registerAuxiliaryWindow",async(f,d)=>{const v=this.getWindowByWebContents(f.sender);return v&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),v.parentId=d),f.sender.id})}createWindow(f){return this.h.invokeFunction(h.$Zec,this.n(f),{preload:R.$Wg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const d={},v=f.features.split(",");for(const $ of v){const[k,S]=$.split("=");switch(k){case"width":d.width=parseInt(S,10);break;case"height":d.height=parseInt(S,10);break;case"left":d.x=parseInt(S,10);break;case"top":d.y=parseInt(S,10);break;case"window-maximized":d.mode=g.WindowMode.Maximized;break;case"window-fullscreen":d.mode=g.WindowMode.Fullscreen;break}}const p=h.WindowStateValidator.validateWindowState(this.j,d)??(0,g.$Mec)();return this.j.trace("[aux window] using window state",p),p}registerWindow(f){const d=new P.$Sc,v=this.h.createInstance(I.$efc,f);this.g.set(v.id,v),d.add((0,P.$Rc)(()=>this.g.delete(v.id))),d.add(v.onDidMaximize(()=>this.a.fire(v))),d.add(v.onDidUnmaximize(()=>this.b.fire(v))),d.add(v.onDidEnterFullScreen(()=>this.c.fire({window:v,fullscreen:!0}))),d.add(v.onDidLeaveFullScreen(()=>this.c.fire({window:v,fullscreen:!1}))),d.add(v.onDidTriggerSystemContextMenu(({x:p,y:$})=>this.f.fire({window:v,x:p,y:$}))),r.Event.once(v.onDidClose)(()=>d.dispose())}getWindowByWebContents(f){const d=this.g.get(f.id);return d?.matches(f)?d:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,h.$1ec)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Mgc=m,e.$Mgc=m=Ee([re(0,w.$Bi),re(1,c.$0j)],m)}),define(le[88],ue([0,1,13,20,8,4,47,2,11,3,18,7,23,10,6,19,5,62,87,102,30,59,31,52]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=void 0,e.$Yfc=(0,f.$Ci)("workspacesHistoryMainService");let s=class extends I.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(l,E,y,D,L){super(),this.f=l,this.g=E,this.h=y,this.j=D,this.m=L,this.c=this.B(new R.$je),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$Ah(800)),this.n()}n(){this.h.when(d.LifecycleMainPhase.Eventually).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(l=>this.addRecentlyOpened([{workspace:l.workspace,remoteAuthority:l.window.remoteAuthority}])))}async addRecentlyOpened(l){let E=[],y=[];for(const L of l)if((0,k.$Vhb)(L))!this.g.isUntitledWorkspace(L.workspace)&&!this.w(E,L.workspace)&&E.push(L);else if((0,k.$Whb)(L))this.y(E,L.folderUri)||E.push(L);else{const A=this.z(y,L.fileUri),O=L.fileUri.scheme===w.Schemas.file&&o.G.indexOf((0,g.$ah)(L.fileUri))>=0;!A&&!O&&(y.push(L),c.$j&&L.fileUri.scheme===w.Schemas.file&&n.app.addRecentDocument(L.fileUri.fsPath))}const D=await this.r({workspaces:E,files:y});E=D.workspaces,y=D.files,E.length>o.a&&(E.length=o.a),y.length>o.a&&(y.length=o.a),await this.t({workspaces:E,files:y}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(l){const E=A=>{const O=this.u(A);for(const W of l)if(g.$7g.isEqual(W,O))return!1;return!0},y=await this.getRecentlyOpened(),D=y.workspaces.filter(E),L=y.files.filter(E);(D.length!==y.workspaces.length||L.length!==y.files.length)&&(await this.t({files:L,workspaces:D}),this.c.fire(),c.$k&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(l){if(l?.confirm){const{response:E}=await this.m.showMessageBox({type:"warning",buttons:[(0,b.localize)(10854,null),(0,b.localize)(10855,null)],message:(0,b.localize)(10856,null),detail:(0,b.localize)(10857,null),cancelId:1});if(E!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(l){const E=new u.$zc(L=>g.$7g.getComparisonKey(L));if(l?.workspaces)for(const L of l.workspaces)E.set(this.u(L),L);const y=new u.$zc(L=>g.$7g.getComparisonKey(L));if(l?.files)for(const L of l.files)y.set(this.u(L),L);const D=await this.s();for(const L of D.workspaces){const A=E.get(this.u(L));A?A.label=A.label??L.label:E.set(this.u(L),L)}for(const L of D.files){const A=y.get(this.u(L));A?A.label=A.label??L.label:y.set(this.u(L),L)}return{workspaces:[...E.values()],files:[...y.values()]}}async s(){await this.j.whenReady;let l;const E=this.j.get(o.b,p.StorageScope.APPLICATION);if(typeof E=="string")try{l=JSON.parse(E)}catch(y){this.f.error("Unexpected error parsing opened paths list",y)}return(0,k.$3hb)(l,this.f)}async t(l){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,k.$4hb)(l)),p.StorageScope.APPLICATION,p.StorageTarget.MACHINE)}u(l){return(0,k.$Whb)(l)?l.folderUri:(0,k.$Xhb)(l)?l.fileUri:l.workspace.configPath}w(l,E){return!!l.find(y=>(0,k.$Vhb)(y)&&y.workspace.id===E.id)}y(l,E){return!!l.find(y=>(0,k.$Whb)(y)&&g.$7g.isEqual(y.folderUri,E))}z(l,E){return!!l.find(y=>g.$7g.isEqual(y.fileUri,E))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$j&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$j)return;const l=[];if(l.push({type:"tasks",items:[{type:"task",title:(0,b.localize)(10858,null),description:(0,b.localize)(10859,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const E=[];for(const L of n.app.getJumpListSettings().removedItems){const A=L.args;if(A){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(A);O&&E.push(h.URI.parse(O[2]))}}await this.removeRecentlyOpened(E);let y=!1;const D=(0,r.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(L=>{const A=(0,k.$Vhb)(L)?L.workspace:L.folderUri,{title:O,description:W}=this.L(A,L.label);let x;return h.URI.isUri(A)?x=`--folder-uri "${A.toString()}"`:(y=!0,x=`--file-uri "${A.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:W.substr(0,255),program:process.execPath,args:x,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&l.push({type:"custom",name:y?(0,b.localize)(10860,null):(0,b.localize)(10861,null),items:D})}l.push({type:"recent"});try{const E=n.app.setJumpList(l);E&&E!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${E}`)}catch(E){this.f.warn("updateWindowsJumpList#setJumpList",E)}}L(l,E){if(E)return{title:(0,T.$6w)(E).name,description:E};if(h.URI.isUri(l))return{title:(0,g.$ah)(l),description:this.M(l)};if(this.g.isUntitledWorkspace(l))return{title:(0,b.localize)(10862,null),description:""};let y=(0,g.$ah)(l.configPath);return y.endsWith(S.$Yi)&&(y=y.substr(0,y.length-S.$Yi.length-1)),{title:(0,b.localize)(10863,null,y),description:this.M(l.configPath)}}M(l){return l.scheme==="file"?(0,T.$Xw)(l.fsPath):l.toString()}async N(){if(!c.$k)return;n.app.clearRecentDocuments();const l=await this.getRecentlyOpened(),E=[];let y=0;for(let L=0;L<l.workspaces.length&&y<o.C;L++){const A=this.u(l.workspaces[L]);if(A.scheme===w.Schemas.file){const O=(0,g.$4g)(A);await m.Promises.exists(O)&&(E.push(O),y++)}}const D=[];for(let L=0;L<l.files.length&&y<o.D;L++){const A=this.u(l.files[L]);if(A.scheme===w.Schemas.file){const O=(0,g.$4g)(A);if(o.G.includes((0,g.$ah)(A))||E.includes(O))continue;await m.Promises.exists(O)&&(D.push(O),y++)}}D.reverse().forEach(L=>n.app.addRecentDocument(L)),E.reverse().forEach(L=>n.app.addRecentDocument(L))}};e.$Zfc=s,e.$Zfc=s=o=Ee([re(0,v.$0j),re(1,t.$$ec),re(2,d.$ffc),re(3,$.$nfc),re(4,i.$Tec)],s)}),define(le[274],ue([0,1,13,8,21,47,3,7,10,84,17,22,19,5,197,64,28,34,24,49,50,29,88,2]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0,w=Ie(w);const s="menu";let a=class extends i.$Tc{static{o=this}static{this.a="lastKnownMenubarData"}constructor(y,D,L,A,O,W,x,H,B,X,G,ae){super(),this.t=y,this.u=D,this.w=L,this.y=A,this.z=O,this.C=W,this.D=x,this.F=H,this.G=B,this.H=X,this.I=G,this.J=ae,this.s=Object.create(null),this.h=new r.$Oh(()=>this.R(),0),this.j=new r.$Oh(()=>{this.m=[]},1e4),this.n=Object.create(null),this.r=Object.create(null),(T.$k||(0,S.$5D)(D))&&this.L(),this.M(),this.f=!1,this.g=!1,this.m=[],this.W(),this.N()}L(){const y=this.D.getItem(o.a);y&&(y.menus&&(this.n=y.menus),y.keybindings&&(this.r=y.keybindings))}M(){this.s["workbench.action.files.newUntitledFile"]=(W,x,H)=>{this.lb({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:x?.id})},this.s["workbench.action.newWindow"]=(W,x,H)=>this.w.openEmptyWindow({context:t.OpenContext.MENU,contextWindowId:x?.id}),this.s["workbench.action.files.openFileFolder"]=(W,x,H)=>this.H.pickFileFolderAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.files.openFolder"]=(W,x,H)=>this.H.pickFolderAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.openWorkspace"]=(W,x,H)=>this.H.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.eb(H),telemetryExtraData:{from:s}}),this.s["workbench.action.clearRecentFiles"]=()=>this.C.clearRecentlyOpened({confirm:!0});const y=this.I.youTubeUrl;y&&(this.s["workbench.action.openYouTubeUrl"]=()=>this.ob(y,"openYouTubeUrl"));const D=this.I.requestFeatureUrl;D&&(this.s["workbench.action.openRequestFeatureUrl"]=()=>this.ob(D,"openUserVoiceUrl"));const L=this.I.reportIssueUrl;L&&(this.s["workbench.action.openIssueReporter"]=()=>this.ob(L,"openReportIssues"));const A=this.I.licenseUrl;A&&(this.s["workbench.action.openLicenseUrl"]=()=>{if(T.$x){const W=A.indexOf("?")>0?"&":"?";this.ob(`${A}${W}lang=${T.$x}`,"openLicenseUrl")}else this.ob(A,"openLicenseUrl")});const O=this.I.privacyStatementUrl;O&&A&&(this.s["workbench.action.openPrivacyStatementUrl"]=()=>{this.ob(O,"openPrivacyStatement")})}N(){this.B(this.F.onWillShutdown(()=>this.b=!0)),this.B(this.w.onDidChangeWindowsCount(y=>this.S(y))),this.B(this.H.onDidBlurMainWindow(()=>this.U())),this.B(this.H.onDidFocusMainWindow(()=>this.U()))}get O(){const y=this.u.getValue("window.enableMenuBarMnemonics");return typeof y!="boolean"?!0:y}get P(){if(!T.$k)return!1;const y=this.u.getValue("window.nativeTabs");return typeof y!="boolean"?!1:y}updateMenu(y,D){this.n=y.menus,this.r=y.keybindings,this.D.setItem(o.a,y),this.Q()}Q(){this.h.schedule()}R(){this.b||setTimeout(()=>{this.b||this.W()},10)}S(y){T.$k&&(y.oldCount===0&&y.newCount>0||y.oldCount>0&&y.newCount===0)&&(this.f=y.newCount===0,this.Q())}U(){if(!T.$k)return;const y=n.BrowserWindow.getFocusedWindow();this.g=!y||!!this.J.getWindowByWebContents(y.webContents),this.Q()}W(){const y=n.Menu.getApplicationMenu();if(y&&this.m.push(y),Object.keys(this.n).length===0){this.X(T.$k?new n.Menu:null);return}const D=new n.Menu;let L;if(T.$k){const O=new n.Menu;L=new n.MenuItem({label:this.I.nameShort,submenu:O}),this.Y(O),D.append(L)}if(T.$k&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.qb(w.localize(11113,null)),click:()=>this.w.openEmptyWindow({context:t.OpenContext.DOCK})})),n.app.dock.setMenu(O)}if(this.$("File")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(w.localize(11114,null)),submenu:O});this.bb(O,"File"),D.append(W)}if(this.$("Edit")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(w.localize(11115,null)),submenu:O});this.bb(O,"Edit"),D.append(W)}if(this.$("Selection")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(w.localize(11116,null)),submenu:O});this.bb(O,"Selection"),D.append(W)}if(this.$("View")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(w.localize(11117,null)),submenu:O});this.bb(O,"View"),D.append(W)}if(this.$("Go")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(w.localize(11118,null)),submenu:O});this.bb(O,"Go"),D.append(W)}if(this.$("Run")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(w.localize(11119,null)),submenu:O});this.bb(O,"Run"),D.append(W)}if(this.$("Terminal")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(w.localize(11120,null)),submenu:O});this.bb(O,"Terminal"),D.append(W)}let A;if(this.$("Window")){const O=new n.Menu;A=new n.MenuItem({label:this.qb(w.localize(11121,null)),submenu:O,role:"window"}),this.hb(O)}if(A&&D.append(A),this.$("Help")){const O=new n.Menu,W=new n.MenuItem({label:this.qb(w.localize(11122,null)),submenu:O,role:"help"});this.bb(O,"Help"),D.append(W)}D.items&&D.items.length>0?this.X(D):this.X(null),this.j.schedule()}X(y){if(n.Menu.setApplicationMenu(y),y)for(const D of this.J.getWindows())D.win?.setMenu(null)}Y(y){const D=this.jb(w.localize(11123,null,this.I.nameLong),"workbench.action.showAboutDialog"),L=this.ib();let A;if(this.$("Preferences")){const ae=new n.Menu;this.bb(ae,"Preferences"),A=new n.MenuItem({label:this.qb(w.localize(11124,null)),submenu:ae})}const O=new n.Menu,W=new n.MenuItem({label:w.localize(11125,null),role:"services",submenu:O}),x=new n.MenuItem({label:w.localize(11126,null,this.I.nameLong),role:"hide",accelerator:"Command+H"}),H=new n.MenuItem({label:w.localize(11127,null),role:"hideOthers",accelerator:"Command+Alt+H"}),B=new n.MenuItem({label:w.localize(11128,null),role:"unhide"}),X=new n.MenuItem(this.nb("workbench.action.quit",{label:w.localize(11129,null,this.I.nameLong),click:async(ae,K,te)=>{const U=this.w.getLastActiveWindow();(this.w.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||U?.win?.isMinimized())&&await this.Z(te)&&this.H.quit(void 0)}})),G=[D];G.push(...L),A&&G.push(l(),A),G.push(l(),W,l(),x,H,B,l(),X),G.forEach(ae=>y.append(ae))}async Z(y){if(this.w.getWindowCount()===0)return!0;const D=this.u.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.fb(y)){const{response:L}=await this.H.showMessageBox(this.w.getFocusedWindow()?.id,{type:"question",buttons:[w.localize(11130,null),w.localize(11131,null)],message:w.localize(11132,null)});return L===0}return!0}$(y){if(!T.$k&&!(0,S.$5D)(this.u))return!1;switch(y){case"File":case"Help":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n&&!!this.n[y];case"Window":if(T.$k)return this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g||!!this.n;default:return this.w.getWindowCount()>0&&!!this.n&&!!this.n[y]}}ab(y,D){D.forEach(L=>{if((0,f.$Vfc)(L))y.append(l());else if((0,f.$Ufc)(L)){const A=new n.Menu,O=new n.MenuItem({label:this.qb(L.label),submenu:A});this.ab(A,L.submenu.items),y.append(O)}else(0,f.$Wfc)(L)?y.append(this.db(L)):(0,f.$Xfc)(L)&&(L.id==="workbench.action.showAboutDialog"&&this.cb(y),T.$k?this.w.getWindowCount()===0&&this.f||this.w.getWindowCount()>0&&this.g?this.s[L.id]?y.append(new n.MenuItem(this.nb(L.id,{label:this.qb(L.label),click:this.s[L.id]}))):y.append(this.jb(L.label,L.id,!1,L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)):y.append(this.jb(L.label,L.id,L.enabled!==!1,!!L.checked)))})}bb(y,D){this.n&&this.n[D]&&this.ab(y,this.n[D].items)}cb(y){const D=this.ib();D.length&&(D.forEach(L=>y.append(L)),y.append(l()))}db(y){const D=I.URI.revive(y.uri),L=y.id,A=L==="openRecentFile"?{fileUri:D}:L==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new n.MenuItem(this.nb(L,{label:y.label,click:async(O,W,x)=>{const H=this.eb(x);(await this.w.open({context:t.OpenContext.MENU,cli:this.y.args,urisToOpen:[A],forceNewWindow:H,gotoLineMode:!1,remoteAuthority:y.remoteAuthority})).length>0||await this.C.removeRecentlyOpened([D])}},!1))}eb(y){return!!(y&&(!T.$k&&(y.ctrlKey||y.shiftKey)||T.$k&&(y.metaKey||y.altKey)))}fb(y){return!!(y.triggeredByAccelerator||y.altKey||y.ctrlKey||y.metaKey||y.shiftKey)}gb(y,D,L){const A={label:this.qb(y),role:L,enabled:!0};return new n.MenuItem(this.mb(D,A))}hb(y){const D=new n.MenuItem({label:w.localize(11133,null),role:"minimize",accelerator:"Command+M",enabled:this.w.getWindowCount()>0}),L=new n.MenuItem({label:w.localize(11134,null),role:"zoom",enabled:this.w.getWindowCount()>0}),A=new n.MenuItem({label:w.localize(11135,null),role:"front",enabled:this.w.getWindowCount()>0}),O=this.jb(w.localize(11136,null),"workbench.action.switchWindow"),W=[];this.P&&(W.push(l()),W.push(this.jb(w.localize(11137,null),"workbench.action.newWindowTab")),W.push(this.gb(w.localize(11138,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),W.push(this.gb(w.localize(11139,null),"workbench.action.showNextWindowTab","selectNextTab")),W.push(this.gb(w.localize(11140,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),W.push(this.gb(w.localize(11141,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,L,l(),O,...W,l(),A].forEach(x=>y.append(x))}ib(){switch(this.t.state.type){case k.StateType.Idle:return[new n.MenuItem({label:this.qb(w.localize(11142,null)),click:()=>setTimeout(()=>{this.pb("CheckForUpdate"),this.t.checkForUpdates(!0)},0)})];case k.StateType.CheckingForUpdates:return[new n.MenuItem({label:w.localize(11143,null),enabled:!1})];case k.StateType.AvailableForDownload:return[new n.MenuItem({label:this.qb(w.localize(11144,null)),click:()=>{this.t.downloadUpdate()}})];case k.StateType.Downloading:return[new n.MenuItem({label:w.localize(11145,null),enabled:!1})];case k.StateType.Downloaded:return T.$k?[]:[new n.MenuItem({label:this.qb(w.localize(11146,null)),click:()=>{this.pb("InstallUpdate"),this.t.applyUpdate()}})];case k.StateType.Updating:return[new n.MenuItem({label:w.localize(11147,null),enabled:!1})];case k.StateType.Ready:return[new n.MenuItem({label:this.qb(w.localize(11148,null)),click:()=>{this.pb("RestartToUpdate"),this.t.quitAndInstall()}})];default:return[]}}jb(y,D,L,A){const O=this.qb(y),W=typeof D=="function"?D:(G,ae,K)=>{const te=G?G.userSettingsLabel:null;let U=D;Array.isArray(D)&&(U=this.eb(K)?D[1]:D[0]),te&&K.triggeredByAccelerator?this.lb({type:"keybinding",userSettingsLabel:te}):this.lb({type:"commandId",commandId:U})},x=typeof L=="boolean"?L:this.w.getWindowCount()>0,H=typeof A=="boolean"?A:!1,B={label:O,click:W,enabled:x};H&&(B.type="checkbox",B.checked=H);let X;return typeof D=="string"?X=D:Array.isArray(D)&&(X=D[0]),T.$k&&(X==="editor.action.clipboardCutAction"?B.role="cut":X==="editor.action.clipboardCopyAction"?B.role="copy":X==="editor.action.clipboardPasteAction"&&(B.role="paste"),X==="undo"?B.click=this.kb(W,{inDevTools:G=>G.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):X==="redo"?B.click=this.kb(W,{inDevTools:G=>G.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):X==="editor.action.selectAll"&&(B.click=this.kb(W,{inDevTools:G=>G.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.mb(X,B))}kb(y,D){return(L,A,O)=>{const W=n.BrowserWindow.getFocusedWindow();if(!W)return D.inNoWindow();if(W.webContents.isDevToolsFocused()&&W.webContents.devToolsWebContents)return D.inDevTools(W.webContents.devToolsWebContents);y(L,A||W,O)}}lb(y){let D=n.BrowserWindow.getFocusedWindow();if(D){const A=this.J.getWindowByWebContents(D.webContents);A&&(D=this.w.getWindowById(A.parentId)?.win??null)}if(!D){const A=this.w.getLastActiveWindow();A?.win?.isMinimized()&&(D=A.win)}const L=D?this.w.getWindowById(D.id):void 0;if(L){if(this.G.trace("menubar#runActionInRenderer",y),T.$k&&!this.y.isBuilt&&!L.isReady&&(y.type==="commandId"&&y.commandId==="workbench.action.toggleDevTools"||y.type!=="commandId"&&y.userSettingsLabel==="alt+cmd+i"))return!1;if(y.type==="commandId"){const A={id:y.commandId,from:"menu"};L.sendWhenReady("vscode:runAction",P.CancellationToken.None,A)}else{const A={userSettingsLabel:y.userSettingsLabel};L.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,A)}return!0}else return this.G.trace("menubar#runActionInRenderer: no active window found",y),!1}mb(y,D){const L=typeof y=="string"?this.r[y]:void 0;if(L?.label){if(L.isNative!==!1)D.accelerator=L.label,D.userSettingsLabel=L.userSettingsLabel;else if(typeof D.label=="string"){const A=D.label.indexOf("[");A>=0?D.label=`${D.label.substr(0,A)} [${L.label}]`:D.label=`${D.label} [${L.label}]`}}else D.accelerator=void 0;return D}nb(y,D,L=!D.accelerator){L&&(D=this.mb(y,D));const A=D.click;return D.click=(O,W,x)=>{this.pb(y),A?.(O,W,x)},D}ob(y,D){this.H.openExternal(void 0,y),this.pb(D)}pb(y){this.z.publicLog2("workbenchActionExecuted",{id:y,from:s})}qb(y){return(0,R.$3w)(y,!this.O)}};e.$1fc=a,e.$1fc=a=o=Ee([re(0,k.$AY),re(1,g.$9i),re(2,t.$Yec),re(3,h.$Nec),re(4,$.$9l),re(5,u.$Yfc),re(6,p.$iR),re(7,m.$ffc),re(8,b.$0j),re(9,d.$Lfc),re(10,v.$qk),re(11,c.$Kfc)],a);function l(){return new n.MenuItem({type:"separator"})}}),define(le[275],ue([0,1,6,19,5,274,2]),function(J,e,n,r,P,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=void 0,e.$2fc=(0,n.$Ci)("menubarMainService");let I=class extends T.$Tc{constructor(c,g,h){super(),this.b=c,this.c=g,this.f=h,this.a=this.g()}async g(){return await this.c.when(r.LifecycleMainPhase.AfterWindowOpen),this.B(this.b.createInstance(R.$1fc))}async updateMenubar(c,g){this.f.trace("menubarService#updateMenubar",c),(await this.a).updateMenu(g,c)}};e.$3fc=I,e.$3fc=I=Ee([re(0,n.$Bi),re(1,r.$ffc),re(2,P.$0j)],I)});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[276],ue([0,1,26,13,106,27,20,21,39,4,32,47,2,11,9,70,3,36,18,12,7,10,69,17,52,22,14,6,19,5,72,73,74,34,50,137,29,134,267,30,103,88,59,51,76,40,58,71,84]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i,o,s,a,l,E,y,D,L,A,O,W,x,H,B,X,G,ae,K,te,U,j,N,Y,ie,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0,n=Ie(n),D=et(D);function he(M){return(0,G.$Ri)(M?.workspace)}function oe(M){return(0,G.$Mi)(M?.workspace)}let ee=class extends m.$Tc{constructor(F,C,z,Z,Q,q,se,de,me,we,De,ke,Pe,Re,$e,_,ce,fe,be,Ae,Ce){super(),this.s=F,this.t=C,this.u=z,this.w=Z,this.z=Q,this.C=q,this.D=se,this.F=de,this.G=me,this.H=we,this.I=De,this.J=ke,this.L=Pe,this.M=Re,this.N=$e,this.O=_,this.P=ce,this.Q=fe,this.R=be,this.S=Ae,this.U=Ce,this.a=this.B(new c.$je),this.onDidOpenWindow=this.a.event,this.b=this.B(new c.$je),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new c.$je),this.onDidDestroyWindow=this.c.event,this.f=this.B(new c.$je),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new c.$je),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new c.$je),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new c.$je),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new c.$je),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new X.$ngc(this,this.D,this.I,this.z,this.L)),this.W()}W(){this.B(this.N.onDidEnterWorkspace(F=>this.b.fire(F.window))),this.B(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const C=new m.$Sc;if(C.add(c.Event.any(F.onDidClose,F.onDidDestroy)(()=>C.dispose())),F.config.extensionDevelopmentPath)for(const z of F.config.extensionDevelopmentPath)C.add(this.R.addValidFileRoot(z));F.config.extensionTestsPath&&C.add(this.R.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,C){const z=this.G.args,Z=C?.remoteAuthority||void 0,Q=!0,q=C?.forceReuseWindow,se=!q;return this.open({...F,cli:z,forceEmpty:Q,forceNewWindow:se,forceReuseWindow:q,remoteAuthority:Z,forceTempProfile:C?.forceTempProfile,forceProfile:C?.forceProfile})}openExistingWindow(F,C){F.focus(),this.X(C,[F])}async open(F){this.z.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const C=[],z=[],Z=[],Q=[],q=[];let se,de=0;const me=await this.db(F);this.z.trace("windowsManager#open pathsToOpen",me);for(const Re of me)oe(Re)?F.addMode?C.push(Re):z.push(Re):he(Re)?Z.push(Re):Re.fileUri?(se||(se={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Re.remoteAuthority}),se.filesToOpenOrCreate.push(Re)):Re.backupPath?q.push({backupFolder:(0,f.$mc)(Re.backupPath),remoteAuthority:Re.remoteAuthority}):de++;F.diffMode&&se&&se.filesToOpenOrCreate.length>=2&&(se.filesToDiff=se.filesToOpenOrCreate.slice(0,2),se.filesToOpenOrCreate=[]),F.mergeMode&&se&&se.filesToOpenOrCreate.length===4&&(se.filesToMerge=se.filesToOpenOrCreate.slice(0,4),se.filesToOpenOrCreate=[],se.filesToDiff=[]),se&&F.waitMarkerFileURI&&(se.filesToWait={paths:(0,T.$Gb)([...se.filesToDiff,se.filesToMerge[3],...se.filesToOpenOrCreate]),waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(Q.push(...this.N.getUntitledWorkspaces()),Z.push(...Q),q.push(...this.J.getEmptyWindowBackups())):q.length=0;const{windows:we,filesOpenedInWindow:De}=await this.Y(F,Z,z,q,de,se,C);if(this.z.trace(`windowsManager#open used window count ${we.length} (workspacesToOpen: ${Z.length}, foldersToOpen: ${z.length}, emptyToRestore: ${q.length}, emptyToOpen: ${de})`),we.length>1)if(De)De.focus();else{const Re=this.r.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let $e=!0,_=!0;if(Re){const ce=we.filter(fe=>this.r.state.lastActiveWindow&&fe.backupPath===this.r.state.lastActiveWindow.backupPath);ce.length&&(ce[0].focus(),$e=!1,_=!1)}if($e)for(let ce=we.length-1;ce>=0;ce--){const fe=we[ce];if(!(fe.openedWorkspace&&Q.some(be=>fe.openedWorkspace&&be.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&q.some(be=>fe.backupPath&&be.backupFolder===(0,f.$mc)(fe.backupPath)))){fe.focus(),_=!1;break}}_&&we[we.length-1].focus()}const ke=se&&se.filesToDiff.length>0,Pe=se&&se.filesToMerge.length>0;if(!we.some(Re=>Re.isExtensionDevelopmentHost)&&!ke&&!Pe&&!F.noRecentEntry){const Re=[];for(const $e of me)he($e)&&!$e.transient?Re.push({label:$e.label,workspace:$e.workspace,remoteAuthority:$e.remoteAuthority}):oe($e)?Re.push({label:$e.label,folderUri:$e.workspace.uri,remoteAuthority:$e.remoteAuthority}):$e.fileUri&&Re.push({label:$e.label,fileUri:$e.fileUri,remoteAuthority:$e.remoteAuthority});this.M.addRecentlyOpened(Re)}return this.X(F,we),we}X(F,C){const z=F.waitMarkerFileURI;F.context===H.OpenContext.CLI&&z&&C.length===1&&C[0]&&(async()=>{await C[0].whenClosedOrLoaded;try{await this.Q.del(z)}catch{}})()}async Y(F,C,z,Z,Q,q,se){const de=[];let me;function we(ce,fe){de.push(ce),fe&&(me=ce,q=void 0)}let{openFolderInNewWindow:De,openFilesInNewWindow:ke}=this.pb(F);if(!F.initialStartup&&se.length>0){const ce=se[0].remoteAuthority,fe=this.vb(ce);fe&&we(this.ab(fe,se.map(be=>be.workspace.uri)))}const Pe=z.length+C.length+Z.length;if(q&&Pe===0){const ce=q.filesToOpenOrCreate[0]||q.filesToDiff[0]||q.filesToMerge[3],fe=this.getWindows().filter(Ae=>q&&(0,$.$ih)(Ae.remoteAuthority,q.remoteAuthority));let be;ce?.fileUri&&!ke&&((F.context===H.OpenContext.DESKTOP||F.context===H.OpenContext.CLI||F.context===H.OpenContext.DOCK)&&(be=await(0,B.$4ec)(fe,ce.fileUri,async Ae=>Ae.configPath.scheme===b.Schemas.file?this.N.resolveLocalWorkspace(Ae.configPath):void 0)),be||(be=this.wb(fe))),be?(0,G.$Ri)(be.openedWorkspace)?C.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,G.$Mi)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):we(this.Z(F,be,q),!0):we(await this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:q,forceNewWindow:!0,remoteAuthority:q.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile}),!0)}const Re=(0,T.$Lb)(C,ce=>ce.workspace.id);if(Re.length>0){const ce=(0,T.$Gb)(Re.map(fe=>(0,B.$5ec)(this.getWindows(),fe.workspace.configPath)));if(ce.length>0){const fe=ce[0],be=(0,$.$ih)(q?.remoteAuthority,fe.remoteAuthority)?q:void 0;we(this.Z(F,fe,be),!!be),De=!0}for(const fe of Re){if(ce.some(Ce=>Ce.openedWorkspace&&Ce.openedWorkspace.id===fe.workspace.id))continue;const be=fe.remoteAuthority,Ae=(0,$.$ih)(q?.remoteAuthority,be)?q:void 0;we(await this.cb(F,fe,De,Ae),!!Ae),De=!0}}const $e=(0,T.$Lb)(z,ce=>$.$7g.getComparisonKey(ce.workspace.uri));if($e.length>0){const ce=(0,T.$Gb)($e.map(fe=>(0,B.$5ec)(this.getWindows(),fe.workspace.uri)));if(ce.length>0){const fe=ce[0],be=(0,$.$ih)(q?.remoteAuthority,fe.remoteAuthority)?q:void 0;we(this.Z(F,fe,be),!!be),De=!0}for(const fe of $e){if(ce.some(Ce=>(0,G.$Mi)(Ce.openedWorkspace)&&$.$7g.isEqual(Ce.openedWorkspace.uri,fe.workspace.uri)))continue;const be=fe.remoteAuthority,Ae=(0,$.$ih)(q?.remoteAuthority,be)?q:void 0;we(await this.cb(F,fe,De,Ae),!!Ae),De=!0}}const _=(0,T.$Lb)(Z,ce=>ce.backupFolder);if(_.length>0)for(const ce of _){const fe=ce.remoteAuthority,be=(0,$.$ih)(q?.remoteAuthority,fe)?q:void 0;we(await this.bb(F,!0,fe,be,ce),!!be),De=!0}if(de.length===0||q){q&&!Q&&Q++;const ce=q?q.remoteAuthority:F.remoteAuthority;for(let fe=0;fe<Q;fe++)we(await this.bb(F,De,ce,q),!!q),De=!0}return{windows:(0,T.$Lb)(de),filesOpenedInWindow:me}}Z(F,C,z){this.z.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:z}),this.$(C);const Z={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToMerge:z?.filesToMerge,filesToWait:z?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return C.sendWhenReady("vscode:openFiles",I.CancellationToken.None,Z),C}$(F){let C=F;const z=r.BrowserWindow.getFocusedWindow();if(z&&z.id!==F.id){const Z=this.U.getWindowByWebContents(z.webContents);Z&&Z.parentId===F.id&&(C=Z)}C.focus()}ab(F,C){this.z.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:C}),F.focus();const z={foldersToAdd:C};return F.sendWhenReady("vscode:addFolders",I.CancellationToken.None,z),F}bb(F,C,z,Z,Q){this.z.trace("windowsManager#doOpenEmpty",{restore:!!Q,remoteAuthority:z,filesToOpen:Z,forceNewWindow:C});let q;return!C&&typeof F.contextWindowId=="number"&&(q=this.getWindowById(F.contextWindowId)),this.qb({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:z,forceNewWindow:C,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:Z,windowToUse:q,emptyWindowBackupInfo:Q,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}cb(F,C,z,Z,Q){return this.z.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:C,filesToOpen:Z}),!z&&!Q&&typeof F.contextWindowId=="number"&&(Q=this.getWindowById(F.contextWindowId)),this.qb({workspace:C.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:C.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:Z,windowToUse:Q,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile})}async db(F){let C,z=!1,Z=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(C=await this.eb(F),z=!0):F.forceEmpty?C=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(C=await this.fb(F.cli),C.length===0&&C.push(Object.create(null)),z=!0):(C=await this.hb(),C.length===0&&C.push(Object.create(null)),Z=!0),!F.addMode&&z){const Q=C.filter(q=>oe(q));if(Q.length>1){const q=Q[0].remoteAuthority;if(Q.every(se=>(0,$.$ih)(se.remoteAuthority,q))){const se=await this.N.createUntitledWorkspace(Q.map(de=>({uri:de.workspace.uri})));C.push({workspace:se,remoteAuthority:q}),C=C.filter(de=>!oe(de))}}}if(F.initialStartup&&!Z&&this.L.getValue("window")?.restoreWindows==="preserve"){const Q=await this.hb();C.unshift(...Q.filter(q=>he(q)||oe(q)||q.backupPath))}return C}async eb(F){const C={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority},z=await Promise.all((0,T.$Gb)(F.urisToOpen||[]).map(async Z=>{const Q=await this.jb(Z,C);if(Q)return Q.label=Z.label,Q;const q=this.lb(Z);this.P.showMessageBox({type:"info",buttons:[(0,t.localize)(10865,null)],message:q.scheme===b.Schemas.file?(0,t.localize)(10866,null):(0,t.localize)(10867,null),detail:q.scheme===b.Schemas.file?(0,t.localize)(10868,null,(0,h.$Ww)(q,{os:v.OS,tildify:this.G})):(0,t.localize)(10869,null,q.toString(!0))},r.BrowserWindow.getFocusedWindow()??void 0)}));return(0,T.$Gb)(z)}async fb(F){const C=[],z={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:F.diff&&F._.length===2||F.merge&&F._.length===4},Z=F["folder-uri"];if(Z){const se=await Promise.all(Z.map(de=>{const me=this.gb(de);if(me)return this.jb({folderUri:me},z)}));C.push(...(0,T.$Gb)(se))}const Q=F["file-uri"];if(Q){const se=await Promise.all(Q.map(de=>{const me=this.gb(de);if(me)return this.jb((0,G.$8i)(de)?{workspaceUri:me}:{fileUri:me},z)}));C.push(...(0,T.$Gb)(se))}const q=await Promise.all(F._.map(se=>z.remoteAuthority?this.ob(se,z):this.mb(se,z)));return C.push(...(0,T.$Gb)(q)),C}gb(F){try{const C=S.URI.parse(F);if(!C.scheme){this.z.error(`Invalid URI input string, scheme missing: ${F}`);return}return C.path?C:C.with({path:"/"})}catch(C){this.z.error(`Invalid URI input string: ${F}, ${C.message}`)}}async hb(){const F=this.ib();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const C=[];F!=="one"&&C.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&C.push(this.r.state.lastActiveWindow);const z=await Promise.all(C.map(async Z=>{if(Z.workspace){const Q=await this.jb({workspaceUri:Z.workspace.configPath},{remoteAuthority:Z.remoteAuthority,rejectTransientWorkspaces:!0});if(he(Q))return Q}else if(Z.folderUri){const Q=await this.jb({folderUri:Z.folderUri},{remoteAuthority:Z.remoteAuthority});if(oe(Q))return Q}else if(F!=="folders"&&Z.backupPath)return{backupPath:Z.backupPath,remoteAuthority:Z.remoteAuthority}}));return(0,T.$Gb)(z)}}}ib(){let F;return this.I.wasRestarted?F="all":(F=this.L.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}async jb(F,C=Object.create(null)){const z=this.lb(F);return z.scheme===b.Schemas.file?((0,W.$2D)(F)&&(C={...C,forceOpenWorkspaceAsFile:!0}),this.mb(z.fsPath,C)):this.kb(F,C)}kb(F,C){let z=this.lb(F);const Z=(0,A.$en)(z)||C.remoteAuthority;if(z=(0,$.$kh)((0,$.$eh)(z)),(0,W.$2D)(F)){if(C.gotoLineMode){const{path:Q,line:q,column:se}=(0,g.$Jg)(z.path);return{fileUri:z.with({path:Q}),options:{selection:q?{startLineNumber:q,startColumn:se||1}:void 0},remoteAuthority:Z}}return{fileUri:z,remoteAuthority:Z}}else if((0,W.$ZD)(F))return{workspace:(0,ae.$8ec)(z),remoteAuthority:Z};return{workspace:(0,ae.$9ec)(z),remoteAuthority:Z}}lb(F){return(0,W.$ZD)(F)?F.workspaceUri:(0,W.$1D)(F)?F.folderUri:F.fileUri}async mb(F,C,z){let Z,Q;C.gotoLineMode&&({path:F,line:Z,column:Q}=(0,g.$Jg)(F)),F=(0,g.$Dg)((0,f.$gc)(F),(0,p.cwd)());try{const q=await n.promises.stat(F);if(q.isFile()){if(!C.forceOpenWorkspaceAsFile){const se=await this.N.resolveLocalWorkspace(S.URI.file(F));if(se)return se.transient&&C.rejectTransientWorkspaces?void 0:{workspace:{id:se.id,configPath:se.configPath},type:a.FileType.File,exists:!0,remoteAuthority:se.remoteAuthority,transient:se.transient}}return{fileUri:S.URI.file(F),type:a.FileType.File,exists:!0,options:{selection:Z?{startLineNumber:Z,startColumn:Q||1}:void 0}}}else{if(q.isDirectory())return{workspace:(0,ae.$9ec)(S.URI.file(F),q),type:a.FileType.Directory,exists:!0};if(!v.$j&&F==="/dev/null")return{fileUri:S.URI.file(F),type:a.FileType.File,exists:!0}}}catch(q){if(q.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!z)return this.nb(F,C);const se=S.URI.file(F);if(this.M.removeRecentlyOpened([se]),C.ignoreFileNotFound)return{fileUri:se,type:a.FileType.File,exists:!1}}}async nb(F,C){const z=S.URI.file(F),{response:Z,checkboxChecked:Q}=await this.P.showMessageBox({type:"warning",buttons:[(0,t.localize)(10870,null),(0,t.localize)(10871,null),(0,t.localize)(10872,null)],message:(0,t.localize)(10873,null,z.authority),detail:(0,t.localize)(10874,null,(0,h.$Ww)(z,{os:v.OS,tildify:this.G})),checkboxLabel:(0,t.localize)(10875,null,z.authority),cancelId:1});if(Z===0){if((0,P.addUNCHostToAllowlist)(z.authority),Q){const q={channel:"vscode:configureAllowedUNCHost",args:z.authority};this.sendToFocused(q.channel,q.args),this.sendToOpeningWindow(q.channel,q.args)}return this.mb(F,C,!0)}if(Z===2)return r.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.nb(F,C)}ob(F,C){const z=F.charCodeAt(0),Z=C.remoteAuthority;let Q,q;C.gotoLineMode&&({path:F,line:Q,column:q}=(0,g.$Jg)(F)),z!==w.CharCode.Slash&&((0,g.$Cg)(z)&&F.charCodeAt(F.charCodeAt(1))===w.CharCode.Colon&&(F=(0,g.$vg)(F)),F=`/${F}`);const se=S.URI.from({scheme:b.Schemas.vscodeRemote,authority:Z,path:F});if(F.charCodeAt(F.length-1)!==w.CharCode.Slash){if((0,G.$8i)(F))return C.forceOpenWorkspaceAsFile?{fileUri:se,options:{selection:Q?{startLineNumber:Q,startColumn:q||1}:void 0},remoteAuthority:C.remoteAuthority}:{workspace:(0,ae.$8ec)(se),remoteAuthority:Z};if(C.gotoLineMode||f.$fc.basename(F).indexOf(".")!==-1)return{fileUri:se,options:{selection:Q?{startLineNumber:Q,startColumn:q||1}:void 0},remoteAuthority:Z}}return{workspace:(0,ae.$9ec)(se),remoteAuthority:Z}}pb(F){const C=this.L.getValue("window"),z=C?.openFoldersInNewWindow||"default",Z=C?.openFilesInNewWindow||"off";let Q=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(z==="on"||z==="off")&&(Q=z==="on");let q=!1;return F.forceNewWindow||F.forceReuseWindow?q=!!F.forceNewWindow&&!F.forceReuseWindow:(v.$k?F.context===H.OpenContext.DOCK&&(q=!0):F.context!==H.OpenContext.DIALOG&&F.context!==H.OpenContext.MENU&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(q=!0),!F.cli.extensionDevelopmentPath&&(Z==="on"||Z==="off")&&(q=Z==="on")),{openFolderInNewWindow:!!Q,openFilesInNewWindow:q}}async openExtensionDevelopmentHostWindow(F,C){const z=(0,B.$6ec)(this.getWindows(),F);if(z)return this.I.reload(z,C.cli),z.focus(),[z];let Z=C.cli["folder-uri"]||[],Q=C.cli["file-uri"]||[],q=C.cli._;if(!q.length&&!Z.length&&!Q.length&&!C.cli.extensionTestsPath){const me=this.r.state.lastPluginDevelopmentHostWindow,we=me?.workspace??me?.folderUri;we&&(S.URI.isUri(we)?we.scheme===b.Schemas.file?q=[we.fsPath]:Z=[we.toString()]:we.configPath.scheme===b.Schemas.file?q=[(0,$.$4g)(we.configPath)]:Q=[we.configPath.toString()])}let se=C.remoteAuthority;for(const me of F)if(me.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const we=S.URI.parse(me),De=(0,A.$en)(we);De&&(se?(0,$.$ih)(De,se)||this.z.error("more than one extension development path authority"):se=De)}q=q.filter(me=>{const we=S.URI.file(me);return(0,B.$5ec)(this.getWindows(),we)?!1:(0,$.$ih)((0,A.$en)(we),se)}),Z=Z.filter(me=>{const we=this.gb(me);return we&&(0,B.$5ec)(this.getWindows(),we)?!1:we?(0,$.$ih)((0,A.$en)(we),se):!1}),Q=Q.filter(me=>{const we=this.gb(me);return we&&(0,B.$5ec)(this.getWindows(),we)?!1:we?(0,$.$ih)((0,A.$en)(we),se):!1}),C.cli._=q,C.cli["folder-uri"]=Z,C.cli["file-uri"]=Q;const de={context:C.context,cli:C.cli,forceNewWindow:!0,forceEmpty:!q.length&&!Z.length&&!Q.length,userEnv:C.userEnv,noRecentEntry:!0,waitMarkerFileURI:C.waitMarkerFileURI,remoteAuthority:se,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile};return this.open(de)}async qb(F){const C=this.L.getValue("window"),z=this.getLastActiveWindow(),Q=(C?.newWindowProfile?this.H.profiles.find(de=>de.name===C.newWindowProfile):void 0)??z?.profile??this.H.defaultProfile;let q;!F.forceNewWindow&&!F.forceNewTabbedWindow&&(q=F.windowToUse||z,q&&q.focus());const se={...this.G.args,...F.cli,machineId:this.s,sqmId:this.t,devDeviceId:this.u,windowId:-1,mainPid:process.pid,appRoot:this.G.appRoot,execPath:process.execPath,codeCachePath:this.G.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,f.$ic)(this.G.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.H.profilesHome,all:this.H.profiles,profile:Q},homeDir:this.G.userHome.with({scheme:b.Schemas.file}).fsPath,tmpDir:this.G.tmpDir.with({scheme:b.Schemas.file}).fsPath,userDataDir:this.G.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.w,...F.userEnv},nls:{messages:globalThis._VSCODE_NLS_MESSAGES,language:globalThis._VSCODE_NLS_LANGUAGE},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToMerge:F.filesToOpen?.filesToMerge,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.C.getLogLevel(),loggers:{window:[],global:this.C.getRegisteredLoggers()},logsPath:this.G.logsHome.with({scheme:b.Schemas.file}).fsPath,product:D.default,isInitialStartup:F.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:C?.autoDetectHighContrast??!0,autoDetectColorScheme:C?.autoDetectColorScheme??!1,accessibilitySupport:r.app.accessibilitySupportEnabled,colorScheme:this.S.getColorScheme(),policiesData:this.F.serialize(),continueOn:this.G.continueOn};if(q){const de=q.config;!se.extensionDevelopmentPath&&de?.extensionDevelopmentPath&&(se.extensionDevelopmentPath=de.extensionDevelopmentPath,se.extensionDevelopmentKind=de.extensionDevelopmentKind,se["enable-proposed-api"]=de["enable-proposed-api"],se.verbose=de.verbose,se["inspect-extensions"]=de["inspect-extensions"],se["inspect-brk-extensions"]=de["inspect-brk-extensions"],se.debugId=de.debugId,se.extensionEnvironment=de.extensionEnvironment,se["extensions-dir"]=de["extensions-dir"],se["disable-extensions"]=de["disable-extensions"]),se.loggers={global:se.loggers.global,window:de?.loggers.window??se.loggers.window}}else{const de=this.r.getNewWindowState(se);(0,d.mark)("code/willCreateCodeWindow");const me=q=this.O.createInstance(x.$dfc,{state:de,extensionDevelopmentPath:se.extensionDevelopmentPath,isExtensionTestHost:!!se.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(me),this.n.set(me.id,me),this.a.fire(me),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const we=new m.$Sc;we.add(me.onDidSignalReady(()=>this.b.fire(me))),we.add(c.Event.once(me.onDidClose)(()=>this.tb(me,we))),we.add(c.Event.once(me.onDidDestroy)(()=>this.ub(me))),we.add(me.onDidMaximize(()=>this.g.fire(me))),we.add(me.onDidUnmaximize(()=>this.h.fire(me))),we.add(me.onDidEnterFullScreen(()=>this.j.fire({window:me,fullscreen:!0}))),we.add(me.onDidLeaveFullScreen(()=>this.j.fire({window:me,fullscreen:!1}))),we.add(me.onDidTriggerSystemContextMenu(({x:ke,y:Pe})=>this.m.fire({window:me,x:ke,y:Pe})));const De=(0,k.$ng)(me.win?.webContents);De.removeAllListeners("devtools-reload-page"),we.add(c.Event.fromNodeEventEmitter(De,"devtools-reload-page")(()=>this.I.reload(me))),this.I.registerWindow(me)}return se.windowId=q.id,q.isReady?this.I.unload(q,U.UnloadReason.LOAD).then(async de=>{de||await this.rb(q,se,F,Q)}):await this.rb(q,se,F,Q),q}async rb(F,C,z,Z){if(C.extensionDevelopmentPath||((0,G.$Ri)(C.workspace)?C.backupPath=this.J.registerWorkspaceBackup({workspace:C.workspace,remoteAuthority:C.remoteAuthority}):(0,G.$Mi)(C.workspace)?C.backupPath=this.J.registerFolderBackup({folderUri:C.workspace.uri,remoteAuthority:C.remoteAuthority}):C.backupPath=this.J.registerEmptyWindowBackup({backupFolder:z.emptyWindowBackupInfo?.backupFolder??(0,ae.$0ec)().id,remoteAuthority:C.remoteAuthority})),this.H.isEnabled()){const Q=C.workspace??(0,G.$Qi)(C.backupPath,!1),q=this.sb(z,Q,Z),se=q instanceof Promise?await q:q;C.profiles.profile=se,C.extensionDevelopmentPath||await this.H.setProfileForWorkspace(Q,se)}F.load(C)}sb(F,C,z){return F.forceProfile?this.H.profiles.find(Z=>Z.name===F.forceProfile)??this.H.createNamedProfile(F.forceProfile):F.forceTempProfile?this.H.createTransientProfile():this.H.getProfileForWorkspace(C)??z}tb(F,C){this.n.delete(F.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),C.dispose()}ub(F){this.n.delete(F.id),this.c.fire(F)}getFocusedWindow(){const F=r.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.wb(this.getWindows())}vb(F){return this.wb(this.getWindows().filter(C=>(0,$.$ih)(C.remoteAuthority,F)))}wb(F){return(0,H.$1ec)(F)}sendToFocused(F,...C){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(F,I.CancellationToken.None,...C)}sendToOpeningWindow(F,...C){this.B(c.Event.once(this.onDidSignalReadyWindow)(z=>{z.sendWhenReady(F,I.CancellationToken.None,...C)}))}sendToAll(F,C,z){for(const Z of this.getWindows())z&&z.indexOf(Z.id)>=0||Z.sendWhenReady(F,I.CancellationToken.None,C)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(F){return this.n.get(F)}getWindowByWebContents(F){const C=r.BrowserWindow.fromWebContents(F);if(!C)return;const z=this.getWindowById(C.id);return z?.matches(F)?z:void 0}};e.$qgc=ee,e.$qgc=ee=Ee([re(4,y.$0j),re(5,ie.$afc),re(6,O.$iR),re(7,N.$qo),re(8,s.$Nec),re(9,Y.$2ec),re(10,E.$ffc),re(11,u.$Sec),re(12,i.$9i),re(13,K.$Yfc),re(14,te.$$ec),re(15,l.$Bi),re(16,o.$Tec),re(17,a.$0k),re(18,L.$Vec),re(19,j.$Wec),re(20,V.$Kfc)],ee)}),define(le[277],ue([0,1,69,29,88,59]),function(J,e,n,r,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;let T=class{constructor(w,c,g,h){this.a=w,this.b=c,this.c=g,this.d=h,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(w,c){const g=this.b.getWindowById(w);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),c)}createUntitledWorkspace(w,c,g){return this.a.createUntitledWorkspace(c,g)}deleteUntitledWorkspace(w,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(w,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(w){return this.c.getRecentlyOpened()}addRecentlyOpened(w,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(w,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(w){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$sgc=T,e.$sgc=T=Ee([re(0,R.$$ec),re(1,r.$Yec),re(2,P.$Yfc),re(3,n.$Sec)],T)}),define(le[278],ue([0,1,13,106,35,27,16,54,15,4,282,47,2,11,9,3,12,7,33,157,44,158,118,135,10,69,252,17,259,96,136,52,97,186,22,68,100,174,262,176,177,178,14,190,99,83,6,98,185,268,269,253,260,19,5,275,64,28,74,263,101,34,242,87,128,24,219,220,57,49,232,257,270,258,271,132,234,235,236,239,266,50,29,276,241,30,102,88,277,59,40,199,58,212,56,86,133,244,261,249,8,222,243,194,71,265,238,20,75,264,230,205,65,84,273,78]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i,o,s,a,l,E,y,D,L,A,O,W,x,H,B,X,G,ae,K,te,U,j,N,Y,ie,V,he,oe,ee,M,F,C,z,Z,Q,q,se,de,me,we,De,ke,Pe,Re,$e,_,ce,fe,be,Ae,Ce,Me,Oe,Be,Ge,Qe,qe,Je,Xe,Ye,Ne,ne,ge,pe,ye,We,Ue,Ze,lt,rt,at,tt,ut,ct,ft,gt,Ot,mt,$t,Tt,Lt,jt,pt,Wt,Et,dt,Mt,Ft,wt,Nt,St,Ct,kt){"use strict";var bt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;let yt=class extends m.$Tc{static{bt=this}static{this.a={[b.Schemas.file]:"security.promptForLocalFileProtocolHandling",[b.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Te,Le,je,ve,Se,He,Ve,Ke,Fe,xe,ze,_e){super(),this.g=Te,this.h=Le,this.j=je,this.m=ve,this.n=Se,this.s=He,this.t=Ve,this.u=Ke,this.w=Fe,this.y=xe,this.z=ze,this.C=_e,this.D(),this.F()}D(){const Te=Fe=>Fe?.startsWith(`${b.Schemas.vscodeWebview}://`),Le=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((Fe,xe,ze,_e)=>Te(_e.requestingUrl)?ze(Le.has(xe)):ze(!1)),n.session.defaultSession.setPermissionCheckHandler((Fe,xe,ze,_e)=>Te(_e.requestingUrl)?Le.has(xe):!1);const je=new Set([b.Schemas.file,b.Schemas.vscodeFileResource,b.Schemas.vscodeRemoteResource,b.Schemas.vscodeManagedRemoteResource,"devtools"]),ve=Fe=>{for(let xe=Fe;xe;xe=xe.parent)if(xe.url.startsWith(`${b.Schemas.vscodeWebview}://`))return!0;return!1},Se=Fe=>Fe.resourceType==="xhr"||ve(Fe.frame),He=Fe=>{const xe=Fe.frame;if(!xe||!this.b)return!1;const ze=n.BrowserWindow.getAllWindows();for(const _e of ze)if(xe.processId===_e.webContents.mainFrame.processId)return!0;return!1},Ve=(Fe,xe)=>{if(Fe.path!=="/index.html")return!0;const ze=xe.frame;if(!ze||!this.b)return!1;for(const _e of this.b.getWindows())if(_e.win&&ze.processId===_e.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((Fe,xe)=>{const ze=p.URI.parse(Fe.url);return ze.scheme===b.Schemas.vscodeWebview&&!Ve(ze,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),xe({cancel:!0})):ze.scheme===b.Schemas.vscodeFileResource&&!He(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),xe({cancel:!0})):ze.path.endsWith(".svg")&&!je.has(ze.scheme)?xe({cancel:!Se(Fe)}):xe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{const ze=Fe.responseHeaders,_e=ze["content-type"]||ze["Content-Type"];if(_e&&Array.isArray(_e)){const it=p.URI.parse(Fe.url);if(it.path.endsWith(".svg")&&je.has(it.scheme))return ze["Content-Type"]=["image/svg+xml"],xe({cancel:!1,responseHeaders:ze});if(!it.path.endsWith(b.Schemas.vscodeRemoteResource)&&_e.some(ot=>ot.toLowerCase().includes("image/svg")))return xe({cancel:!Se(Fe)})}return xe({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((Fe,xe)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const ze=Fe.responseHeaders??Object.create(null);if(ze["Access-Control-Allow-Origin"]===void 0)return ze["Access-Control-Allow-Origin"]=["*"],xe({cancel:!1,responseHeaders:ze})}return xe({cancel:!1})});const Ke=n.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,f.$ic)(this.s.codeCachePath,"chrome")),d.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,r.disableUNCAccessRestrictions)():(0,r.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,w.setUnexpectedErrorHandler)(je=>this.G(je)),process.on("uncaughtException",je=>{(0,w.$X)(je)||(0,w.$Y)(je)}),process.on("unhandledRejection",je=>(0,w.$Y)(je)),c.Event.once(this.t.onWillShutdown)(()=>this.dispose()),(0,k.$CX)(),n.app.on("accessibility-support-changed",(je,ve)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",ve)}),n.app.on("activate",async(je,ve)=>{this.m.trace("app#activate"),ve||await this.b?.openEmptyWindow({context:Ye.OpenContext.DOCK})}),n.app.on("web-contents-created",(je,ve)=>{ve?.opener?.url.startsWith(`${b.Schemas.vscodeFileResource}://${b.$Vg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(ve)),ve.on("will-navigate",Se=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Se.preventDefault()}),ve.setWindowOpenHandler(Se=>Se.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Se)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Se.url}}`),this.f?.openExternal(void 0,Se.url),{action:"deny"}))});let Te=[],Le;n.app.on("open-file",(je,ve)=>{ve=(0,kt.$km)(ve),this.m.trace("app#open-file: ",ve),je.preventDefault(),Te.push((0,ge.$8i)(ve)?{workspaceUri:p.URI.file(ve)}:{fileUri:p.URI.file(ve)}),Le!==void 0&&(clearTimeout(Le),Le=void 0),Le=setTimeout(async()=>{await this.b?.open({context:Ye.OpenContext.DOCK,cli:this.s.args,urisToOpen:Te,gotoLineMode:!1,preferNewWindow:!0}),Te=[],Le=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:Ye.OpenContext.DESKTOP})}),P.$BX.handle("vscode:fetchShellEnv",je=>{const ve=this.b?.getWindowByWebContents(je.sender);let Se,He;return ve?.config?(Se=ve.config,He={...process.env,...ve.config.userEnv}):(Se=this.s.args,He=process.env),this.W(Se,He,!1)}),P.$BX.on("vscode:toggleDevTools",je=>je.sender.toggleDevTools()),P.$BX.on("vscode:openDevTools",je=>je.sender.openDevTools()),P.$BX.on("vscode:reloadWindow",je=>je.sender.reload()),P.$BX.handle("vscode:notifyZoomLevel",async(je,ve)=>{const Se=this.b?.getWindowByWebContents(je.sender);Se&&Se.notifyZoomLevel(ve)})}G(Te){if(Te){const Le={message:`[uncaught exception in main]: ${Te.message}`,stack:Te.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.m.error(`[uncaught exception in main]: ${Te}`),Te.stack&&this.m.error(Te.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Te=this.z.win32AppUserModelId;d.$j&&Te&&n.app.setAppUserModelId(Te);try{d.$k&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ze){this.m.error(ze)}const Le=new t.$IX;c.Event.once(this.t.onWillShutdown)(ze=>{ze.reason===F.ShutdownReason.KILL&&Le.dispose()}),this.m.trace("Resolving machine identifier...");const[je,ve,Se]=await Promise.all([(0,$t.$Bgc)(this.w,this.m),(0,$t.$Cgc)(this.w,this.m),(0,$t.$Dgc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${je}`);const{sharedProcessReady:He,sharedProcessClient:Ve}=this.O(je,ve,Se),Ke=await this.P(je,ve,Se,He);Ke.invokeFunction(ze=>ze.get(i.$pfc)),this.B(Ke.createInstance(gt.$wgc)),Ke.invokeFunction(ze=>this.Q(ze,Le,Ve));const Fe=await Ke.invokeFunction(ze=>this.H(ze,Le));this.I(Le),this.t.phase=F.LifecycleMainPhase.Ready,await Ke.invokeFunction(ze=>this.R(ze,Fe)),this.t.phase=F.LifecycleMainPhase.AfterWindowOpen,this.S(),this.B(new mt.$Oh(()=>{this.B((0,mt.$Sh)(()=>this.t.phase=F.LifecycleMainPhase.Eventually,2500))},2500)).schedule()}async H(Te,Le){const je=this.b=Te.get(Ye.$Yec),ve=Te.get(Oe.$qY),Se=this.f=Te.get(Z.$Lfc),He=Te.get(L.$Tec),Ve=this;ve.registerHandler({async handleURL(it,ot){return Ve.N(je,He,ve,it,ot)}});const Ke=this.B(new ne.$rgc({onDidOpenMainWindow:Se.onDidOpenMainWindow,onDidFocusMainWindow:Se.onDidFocusMainWindow,getActiveWindowId:()=>Se.getActiveWindowId(-1)})),Fe=new S.$ki(it=>Ke.getActiveClientId().then(ot=>it===ot)),xe=new Be.$igc(Fe,this.m),ze=Le.getChannel("urlHandler",xe);ve.registerHandler(new Be.$hgc(ze));const _e=await this.J(je,He);return this.B(new Qe.$jgc(_e?.urls,ve,je,this.s,this.z,this.m)),_e}I(Te){const Le=()=>({statusCode:404,data:"Not found"}),je=new Nt.$T(()=>Te.getChannel(wt.$Kgc,new wt.$Lgc));n.protocol.registerBufferProtocol(b.Schemas.vscodeManagedRemoteResource,(ve,Se)=>{const He=p.URI.parse(ve.url);if(!He.authority.startsWith("window:"))return Se(Le());je.value.call(wt.$Jgc,[He]).then(Ve=>Se({...Ve,data:Buffer.from(Ve.body,"base64")}),Ve=>{this.m.warn("error dispatching remote resource call",Ve),Se({statusCode:500,data:String(Ve)})})})}async J(Te,Le){const je=this.s.args["open-url"]?this.s.args._urls||[]:[];je.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",je);const ve=global.getOpenUrls()||[];if(ve.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ve),je.length+ve.length===0)return;const Se=[...je,...ve].map(Ke=>{try{return{uri:p.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),He=[],Ve=[];for(const Ke of Se){if(!Ke)continue;const Fe=this.M(Ke.uri);if(Fe)if(await this.L(Fe,Te,Le)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Fe),He.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),Ve.push(Ke)}return{urls:Ve,openables:He}}async L(Te,Le,je){let ve,Se;if((0,Xe.$ZD)(Te)?(ve=Te.workspaceUri,Se=(0,o.localize)(12771,null,ve.scheme===b.Schemas.file?(0,h.$Ww)(ve,{os:d.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(0,Xe.$1D)(Te)?(ve=Te.folderUri,Se=(0,o.localize)(12772,null,ve.scheme===b.Schemas.file?(0,h.$Ww)(ve,{os:d.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)):(ve=Te.fileUri,Se=(0,o.localize)(12773,null,ve.scheme===b.Schemas.file?(0,h.$Ww)(ve,{os:d.OS,tildify:this.s}):ve.toString(!0),this.z.nameShort)),ve.scheme!==b.Schemas.file&&ve.scheme!==b.Schemas.vscodeRemote||this.u.getValue(bt.a[ve.scheme])===!1)return!1;const{response:Ve,checkboxChecked:Ke}=await je.showMessageBox({type:"warning",buttons:[(0,o.localize)(12774,null),(0,o.localize)(12775,null)],message:Se,detail:(0,o.localize)(12776,null),checkboxLabel:ve.scheme===b.Schemas.file?(0,o.localize)(12777,null):(0,o.localize)(12778,null),cancelId:1});if(Ve!==0)return!0;if(Ke){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:ve.scheme===b.Schemas.file?"local":"remote"};Le.sendToFocused(Fe.channel,Fe.args),Le.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}M(Te){if(Te.path){if(Te.authority===b.Schemas.file){const Le=p.URI.file(Te.fsPath);return(0,ge.$8i)(Le)?{workspaceUri:Le}:{fileUri:Le}}else if(Te.authority===b.Schemas.vscodeRemote){const Le=Te.path.indexOf(f.$fc.sep,1);if(Le!==-1){const je=Te.path.substring(1,Le),ve=Te.path.substring(Le);let Se=Te.query;const He=new URLSearchParams(Te.query);He.get("windowId")==="_blank"&&(He.delete("windowId"),Se=He.toString());const Ve=p.URI.from({scheme:b.Schemas.vscodeRemote,authority:je,path:ve,query:Se,fragment:Te.fragment});return(0,ge.$8i)(ve)?{workspaceUri:Ve}:/:[\d]+$/.test(ve)?{fileUri:Ve}:{folderUri:Ve}}}}}async N(Te,Le,je,ve,Se){this.m.trace("app#handleProtocolUrl():",ve.toString(!0),Se),ve.scheme===this.z.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:p.URI.parse(ve.query).path,query:""}));let He=!1;const Ve=new URLSearchParams(ve.query);Ve.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Ve.delete("windowId"),ve=ve.with({query:Ve.toString()}),He=!0):d.$k&&Te.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),He=!0);const Ke=Ve.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),Ve.delete("continueOn"),ve=ve.with({query:Ve.toString()}),this.s.continueOn=Ke??void 0);const Fe=this.M(ve);return Fe?await this.L(Fe,Te,Le)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,ve.toString(!0)),(0,Et.$Nb)(await Te.open({context:Ye.OpenContext.API,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:He,gotoLineMode:!0}))?.focus(),!0):He?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0)),await(0,Et.$Nb)(await Te.open({context:Ye.OpenContext.API,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,q.$en)(ve)}))?.ready(),je.open(ve,Se)):(this.m.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Se),!1)}O(Te,Le,je){const ve=this.B(this.j.createInstance(se.$7fc,Te,Le,je));this.B(ve.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const Se=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ve=await ve.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new u.$JX(Ve,"main")})();return{sharedProcessReady:(async()=>(await ve.whenReady(),Se))(),sharedProcessClient:Se}}async P(Te,Le,je,ve){const Se=new ie.$Ai;switch(process.platform){case"win32":Se.set(ce.$AY,new N.$zi(Me.$fgc));break;case"linux":d.$m?Se.set(ce.$AY,new N.$zi(Ce.$egc,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(ce.$AY,new N.$zi(Ae.$dgc));break;case"darwin":Se.set(ce.$AY,new N.$zi(be.$cgc));break}Se.set(Ye.$Yec,new N.$zi(Ne.$qgc,[Te,Le,je,this.h],!1)),Se.set(St.$Kfc,new N.$zi(Ct.$Mgc,void 0,!1));const He=new L.$Uec(this.m,this.z);Se.set(L.$Tec,He),Se.set(M.$Sfc,new N.$zi(M.$Tfc,void 0,!1)),Se.set(D.$wfc,new N.$zi(D.$xfc,void 0,!1)),Se.set(y.$Qm,S.ProxyChannel.toService((0,S.$ii)(ve.then(ze=>ze.getChannel("diagnostics"))))),Se.set(V.$j_b,new N.$zi(he.$Nfc,[this.h])),Se.set(V.$k_b,new N.$zi(oe.$Ofc,[this.h])),Se.set(A.$kY,new N.$zi(O.$yfc)),Se.set(ee.$Pfc,new N.$zi(ee.$Qfc)),Se.set(Z.$Lfc,new N.$zi(Z.$Mfc,void 0,!1)),Se.set(qe.$kgc,new N.$zi(Je.$mgc)),Se.set(z.$2fc,new N.$zi(z.$3fc)),Se.set(B.$zfc,new N.$zi(X.$Bfc)),Se.set(De.$lfc,new N.$zi(De.$mfc)),Se.set(De.$nfc,new N.$zi(De.$ofc));const Ve=new Mt.$Igc({graceTime:dt.LocalReconnectConstants.GraceTime,shortGraceTime:dt.LocalReconnectConstants.ShortGraceTime,scrollback:this.u.getValue(dt.TerminalSettingId.PersistentSessionScrollback)??100},this.u,this.s,this.t,this.m),Ke=new Ft.$Ns(Ve,this.u,this.m,this.n);Se.set(dt.$os,Ke),d.$j?Se.set(G.$Cfc,new N.$zi(ae.$Dfc)):d.$k?Se.set(G.$Cfc,new N.$zi(ae.$Efc)):d.$l&&Se.set(G.$Cfc,new N.$zi(ae.$Ffc));const Fe=new a.$rfc(this.s,this.u,this.m,this.w);Se.set(s.$Sec,Fe);const xe=new Ue.$_ec(this.s,this.m,this.C,Fe,He);if(Se.set(Ue.$$ec,xe),Se.set(pe.$Uhb,new N.$zi(We.$sgc,void 0,!1)),Se.set(ye.$Yfc,new N.$zi(ye.$Zfc,void 0,!1)),Se.set(Oe.$qY,new N.$zi(Ge.$sY,void 0,!1)),(0,_.$Bp)(this.z,this.s)){const ze=(0,_.$Gp)(this.z,this.u),_e=(0,S.$ii)(ve.then(vt=>vt.getChannel("telemetryAppender"))),it=new Re.$0fc(_e),ot=(0,ke.$sp)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Te,Le,je,ze),nt=(0,_.$Hp)(this.s),ht={appenders:[it],commonProperties:ot,piiPaths:nt,sendErrorTelemetry:!0};Se.set(Pe.$9l,new N.$zi($e.$es,[ht],!1))}else Se.set(Pe.$9l,_.$wp);return Se.set(ut.$Gq,new N.$zi(Tt.$pR,void 0,!0)),Se.set(ct.$Kq,new N.$zi(ft.$vgc,void 0,!0)),Se.set(pt.$Ggc,new N.$zi(pt.$Hgc,void 0,!0)),Se.set(i.$pfc,new N.$zi(i.$qfc)),await mt.Promises.settled([Fe.initialize(),xe.initialize()]),this.j.createChild(Se)}Q(Te,Le,je){const ve=this.B(new m.$Sc),Se=S.ProxyChannel.fromService(Te.get(M.$Sfc),ve,{disableMarshalling:!0});this.g.registerChannel("launch",Se);const He=S.ProxyChannel.fromService(Te.get(D.$wfc),ve,{disableMarshalling:!0});this.g.registerChannel("diagnostics",He);const Ve=ve.add(new lt.$tgc(Te.get(Ze.$qo)));Le.registerChannel("policy",Ve),je.then(st=>st.registerChannel("policy",Ve));const Ke=this.y.getProvider(b.Schemas.file);(0,v.$mg)(Ke instanceof j.$qr);const Fe=ve.add(new U.$Gfc(Ke,this.m,this.s));Le.registerChannel(K.$$Q,Fe),je.then(st=>st.registerChannel(K.$$Q,Fe));const xe=S.ProxyChannel.fromService(Te.get(rt.$2ec),ve);Le.registerChannel("userDataProfiles",xe),je.then(st=>st.registerChannel("userDataProfiles",xe));const ze=new at.$_r(Te.get(tt.$5p));je.then(st=>st.registerChannel("request",ze));const _e=new fe.$$fc(Te.get(ce.$AY));Le.registerChannel("update",_e);const it=S.ProxyChannel.fromService(Te.get(V.$j_b),ve);Le.registerChannel("issue",it);const ot=S.ProxyChannel.fromService(Te.get(V.$k_b),ve);Le.registerChannel("process",ot);const nt=S.ProxyChannel.fromService(Te.get(A.$kY),ve);Le.registerChannel("encryption",nt);const ht=S.ProxyChannel.fromService(Te.get(de.$Wl),ve);Le.registerChannel("sign",ht);const vt=S.ProxyChannel.fromService(Te.get(ee.$Pfc),ve);Le.registerChannel("keyboardLayout",vt),this.f=Te.get(Z.$Lfc);const Pt=S.ProxyChannel.fromService(this.f,ve);Le.registerChannel("nativeHost",Pt),je.then(st=>st.registerChannel("nativeHost",Pt));const Bt=S.ProxyChannel.fromService(Te.get(pe.$Uhb),ve);Le.registerChannel("workspaces",Bt);const Ut=S.ProxyChannel.fromService(Te.get(z.$2fc),ve);Le.registerChannel("menubar",Ut);const zt=S.ProxyChannel.fromService(Te.get(Oe.$qY),ve);Le.registerChannel("url",zt);const qt=S.ProxyChannel.fromService(Te.get(qe.$kgc),ve);Le.registerChannel("webview",qt);const It=ve.add(new we.$8fc(this.m,Te.get(De.$lfc)));Le.registerChannel("storage",It),je.then(st=>st.registerChannel("storage",It));const Ht=ve.add(new Ot.$xgc(Te.get(De.$lfc),Te.get(rt.$2ec),this.m));je.then(st=>st.registerChannel("profileStorageListener",Ht));const xt=S.ProxyChannel.fromService(Te.get(dt.$os),ve);Le.registerChannel(dt.TerminalIpcChannels.LocalPty,xt);const Vt=S.ProxyChannel.fromService(Te.get(G.$Cfc),ve);Le.registerChannel("externalTerminal",Vt);const Dt=new Lt.$Egc(Te.get(jt.$afc));Le.registerChannel("logger",Dt),je.then(st=>st.registerChannel("logger",Dt));const Gt=new E.$sfc(Te.get(Ye.$Yec));Le.registerChannel("extensionhostdebugservice",Gt);const Kt=S.ProxyChannel.fromService(Te.get(B.$zfc),ve);Le.registerChannel(B.$Afc,Kt);const Yt=S.ProxyChannel.fromService(Te.get(pt.$Ggc),ve);Le.registerChannel(Wt.$Fgc,Yt)}async R(Te,Le){const je=this.b=Te.get(Ye.$Yec);this.c=Te.get(St.$Kfc);const ve=(0,x.$Hm)(process.env)?Ye.OpenContext.CLI:Ye.OpenContext.DESKTOP,Se=this.s.args;if(Le){if(Le.openables.length>0)return je.open({context:ve,cli:Se,urisToOpen:Le.openables,gotoLineMode:!0,initialStartup:!0});if(Le.urls.length>0)for(const nt of Le.urls){const ht=new URLSearchParams(nt.uri.query);if(ht.get("windowId")==="_blank")return ht.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ht.toString()}),je.open({context:ve,cli:Se,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const He=global.macOpenFiles,Ve=Se._.length,Ke=!!Se["folder-uri"],Fe=!!Se["file-uri"],xe=Se["skip-add-to-recently-opened"]===!0,ze=Se.wait&&Se.waitMarkerFilePath?p.URI.file(Se.waitMarkerFilePath):void 0,_e=Se.remote||void 0,it=Se.profile,ot=Se["profile-temp"];if(!Ve&&!Ke&&!Fe){if(Se["new-window"]||it||ot)return je.open({context:ve,cli:Se,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:xe,waitMarkerFileURI:ze,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot});if(He.length)return je.open({context:Ye.OpenContext.DOCK,cli:Se,urisToOpen:He.map(nt=>(nt=(0,kt.$km)(nt),(0,ge.$8i)(nt)?{workspaceUri:p.URI.file(nt)}:{fileUri:p.URI.file(nt)})),noRecentEntry:xe,waitMarkerFileURI:ze,initialStartup:!0})}return je.open({context:ve,cli:Se,forceNewWindow:Se["new-window"],diffMode:Se.diff,mergeMode:Se.merge,noRecentEntry:xe,waitMarkerFileURI:ze,gotoLineMode:Se.goto,initialStartup:!0,remoteAuthority:_e,forceProfile:it,forceTempProfile:ot})}S(){this.U(),n.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(Te,Le)=>{Le({url:Te.url.replace(/^vscode-remote-resource:/,"http:"),method:Te.method})}),this.W(this.s.args,process.env,!0),this.X(),d.$k&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async U(){const Te=this.z.win32MutexName;if(d.$j&&Te)try{const Le=await new Promise((ve,Se)=>{J(["@vscode/windows-mutex"],ve,Se)}).then(Ie),je=new Le.Mutex(Te);c.Event.once(this.t.onWillShutdown)(()=>je.release())}catch(Le){this.m.error(Le)}}async W(Te,Le,je){try{return await(0,H.$Om)(this.u,this.m,Te,Le)}catch(ve){const Se=(0,I.$nj)(ve);je?this.b?.sendToFocused("vscode:showResolveShellEnvError",Se):this.m.error(Se)}return{}}async X(){try{const Le=(await this.y.readFile(this.s.argvResource)).value.toString(),je=(0,g.parse)(Le),Se=(0,_.$Dp)(this.u)>=Pe.TelemetryLevel.CRASH;if(je["enable-crash-reporter"]===void 0){const He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Se},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$Yg)()}"`,"}"],Ve=Le.substring(0,Le.length-2).concat(`,
`,He.join(`
`));await this.y.writeFile(this.s.argvResource,T.$Le.fromString(Ve))}else{const He=Le.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Se},`);He!==Le&&await this.y.writeFile(this.s.argvResource,T.$Le.fromString(He))}}catch(Te){this.m.error(Te),this.b?.sendToFocused("vscode:showArgvParseWarning")}}};e.$Ngc=yt,e.$Ngc=yt=bt=Ee([re(2,Y.$Bi),re(3,C.$0j),re(4,C.$$j),re(5,W.$Nec),re(6,F.$ffc),re(7,l.$9i),re(8,me.$iR),re(9,te.$0k),re(10,Q.$qk),re(11,rt.$2ec)],yt)});var et=this&&this.__importDefault||function(J){return J&&J.__esModule?J:{default:J}};define(le[283],ue([0,1,13,26,7,20,8,54,15,32,4,47,11,9,70,3,36,25,23,44,104,278,10,17,204,218,22,68,169,14,188,99,83,184,98,19,191,5,72,28,73,245,131,256,56,255,101,217,34,57,76,58,40,200,198,2,41,233,71,193,123,127,237,106,231]),function(J,e,n,r,P,R,T,I,w,c,g,h,m,b,f,d,v,p,$,k,S,t,u,i,o,s,a,l,E,y,D,L,A,O,W,x,H,B,X,G,ae,K,te,U,j,N,Y,ie,V,he,oe,ee,M,F,C,z,Z,Q,q,se,de,me,we,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),X=et(X);class ke{main(){try{this.a()}catch($e){console.error($e.message),n.app.exit(1)}}async a(){(0,w.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[$e,_,ce,fe,be,Ae,Ce,Me]=this.b();try{try{await this.d(ce,Me,fe,be,Ce)}catch(Oe){throw this.g(ce,Ce,Oe),Oe}await $e.invokeFunction(async Oe=>{const Be=Oe.get(B.$0j),Ge=Oe.get(x.$ffc),Qe=Oe.get(y.$0k),qe=Oe.get(B.$$j),Je=await this.f(Be,ce,Ge,$e,Ce,!0);return $.Promises.writeFile(ce.mainLockfile,String(process.pid)).catch(Xe=>{Be.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),Ae.logger=qe.createLogger("main",{name:(0,u.localize)(12762,null)}),g.Event.once(Ge.onWillShutdown)(Xe=>{Qe.dispose(),fe.dispose(),Xe.join("instanceLockfile",r.promises.unlink(ce.mainLockfile).catch(()=>{}))}),$e.createInstance(t.$Ngc,Je,_).startup()})}catch(Oe){$e.invokeFunction(this.j,Oe)}}b(){const $e=new W.$Ai,_=new z.$Sc;process.once("exit",()=>_.dispose());const ce={_serviceBrand:void 0,...X.default};$e.set(G.$qk,ce);const fe=new a.$Oec(this.k(),ce),be=this.c(fe);$e.set(a.$Nec,fe);const Ae=new q.$bfc((0,B.$lk)(fe),fe.logsHome);$e.set(q.$afc,Ae);const Ce=new H.$mcc(Ae.getLogLevel()),Me=_.add(new se.$qR(Ce,[new B.$ek(Ae.getLogLevel())]));$e.set(B.$0j,Me);const Oe=new D.$Zq(Me);$e.set(y.$0k,Oe);const Be=new L.$qr(Me);Oe.registerProvider(m.Schemas.file,Be);const Ge=new Q.$Rs(Oe);$e.set(Z.$Hl,Ge);const Qe=new me.$lR(me.SaveStrategy.DELAYED,fe,Me,Oe);$e.set(V.$hR,Qe),$e.set(V.$iR,Qe);const qe=new ee.$3ec(Qe,Ge,fe,Oe,Me);$e.set(ee.$2ec,qe),Oe.registerProvider(m.Schemas.vscodeUserData,new we.$Ygc(m.Schemas.file,Be,m.Schemas.vscodeUserData,qe,Ge,Me));const Je=d.$j&&ce.win32RegValueName?_.add(new F.$Wgc(Me,ce.win32RegValueName)):fe.policyFile?_.add(new C.$Xgc(fe.policyFile,Oe,Me)):new M.$so;$e.set(M.$qo,Je);const Xe=new o.$Uo(qe.defaultProfile.settingsResource,Oe,Je,Me);return $e.set(i.$9i,Xe),$e.set(x.$ffc,new A.$zi(x.$gfc,void 0,!1)),$e.set(j.$5p,new A.$zi(N.$Ugc,void 0,!0)),$e.set(oe.$Wec,new A.$zi(oe.$Xec)),$e.set(Y.$Wl,new A.$zi(ie.$Vgc,void 0,!1)),$e.set(te.$Bw,new A.$zi(U.$Sgc)),$e.set(ae.$Vec,new K.$Pgc(fe,qe,Me)),[new O.$tr($e,!0),be,fe,Xe,Qe,Ce,ce,qe]}c($e){const _={VSCODE_IPC_HOOK:$e.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ce=>{const fe=process.env[ce];typeof fe=="string"&&(_[ce]=fe)}),Object.assign(process.env,_),_}async d($e,_,ce,fe,be){await T.Promises.settled([Promise.all([this.e($e.extensionsPath),$e.codeCachePath,$e.logsHome.with({scheme:m.Schemas.file}).fsPath,_.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath,$e.workspaceStorageHome.with({scheme:m.Schemas.file}).fsPath,$e.localHistoryHome.with({scheme:m.Schemas.file}).fsPath,$e.backupHome].map(Ae=>Ae?r.promises.mkdir(Ae,{recursive:!0}):void 0)),fe.init(),ce.initialize()]),_.init()}e($e){if(d.$j){const _=(0,De.getUNCHost)($e);_&&(0,De.addUNCHostToAllowlist)(_)}return $e}async f($e,_,ce,fe,be,Ae){let Ce;try{(0,f.mark)("code/willStartMainServer"),Ce=await(0,S.$xi)(_.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),g.Event.once(ce.onWillShutdown)(()=>Ce.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(_,be,Me),Me;let Oe;try{Oe=await(0,S.$yi)(_.mainIPCHandle,"main")}catch(qe){if(!Ae||d.$j||qe.code!=="ECONNREFUSED")throw qe.code==="EPERM"&&this.h((0,u.localize)(12763,null,be.nameShort),(0,u.localize)(12764,null),be),qe;try{(0,r.unlinkSync)(_.mainIPCHandle)}catch(Je){throw $e.warn("Could not delete obsolete instance handle",Je),Je}return this.f($e,_,ce,fe,be,!1)}if(_.extensionTestsLocationURI&&!_.debugExtensionHost.break){const qe=`Running extension tests from the command line is currently only supported if no other instance of ${be.nameShort} is running.`;throw $e.error(qe),Oe.dispose(),new Error(qe)}let Be;!_.args.wait&&!_.args.status&&(Be=setTimeout(()=>{this.h((0,u.localize)(12765,null,be.nameShort),(0,u.localize)(12766,null),be)},1e4));const Ge=k.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Qe=k.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(_.args.status)return fe.invokeFunction(async()=>{const qe=new s.$Ys(he.$wp,be),Je=await Qe.getMainDiagnostics(),Xe=await Qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ye=await qe.getDiagnostics(Je,Xe);throw console.log(Ye),new w.$_});throw d.$j&&await this.i(Ge,$e),$e.trace("Sending env to running instance..."),await Ge.start(_.args,process.env),Oe.dispose(),Be&&clearTimeout(Be),new w.$_("Sent env to running instance. Terminating...")}if(_.args.status)throw console.log((0,u.localize)(12767,null,be.nameShort)),new w.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}g($e,_,ce){if(ce.code==="EACCES"||ce.code==="EPERM"){const fe=(0,R.$Gb)([$e.userDataPath,$e.extensionsPath,S.$ti]).map(be=>(0,h.$Ww)(P.URI.file(be),{os:d.OS,tildify:$e}));this.h((0,u.localize)(12768,null),(0,u.localize)(12769,null,(0,I.$nj)(ce),fe.join(`
`)),_)}}h($e,_,ce){n.dialog.showMessageBoxSync((0,de.$$w)({type:"warning",buttons:[(0,u.localize)(12770,null)],message:$e,detail:_},ce).options)}async i($e,_){if(d.$j){const ce=await $e.getMainProcessId();_.trace("Sending some foreground love to the running instance:",ce);try{(await new Promise((fe,be)=>{J(["windows-foreground-love"],fe,be)}).then(Ie)).allowSetForegroundWindow(ce)}catch(fe){_.error(fe)}}}j($e,_){const ce=$e.get(B.$0j),fe=$e.get(x.$ffc);let be=0;_&&(_.isExpected?_.message&&ce.trace(_.message):(be=1,_.stack?ce.error(_.stack):ce.error(`Startup error: ${_.toString()}`))),fe.kill(be)}k(){const $e=this.l((0,l.$Em)(process.argv));if($e.wait&&!$e.waitMarkerFilePath){const _=(0,E.$Ogc)($e.verbose);_&&((0,l.$Gm)(process.argv,"--waitMarkerFilePath",_),$e.waitMarkerFilePath=_)}return $e}l($e){if($e["open-url"]&&($e._urls=$e._,$e._=[]),!$e.remote){const _=this.m($e._,$e.goto);$e._=_}return $e}m($e,_){const ce=(0,v.cwd)(),fe=$e.map(Ce=>{let Me=String(Ce),Oe;_&&(Oe=(0,c.$Jg)(Me),Me=Oe.path),Me&&(Me=this.n(ce,Me));const Be=(0,c.$Dg)(Me,ce),Ge=(0,b.$mc)(Be);return Ge&&!(0,c.$zg)(Ge)?null:_&&Oe?(Oe.path=Be,this.o(Oe)):Be}),be=d.$j||d.$k,Ae=(0,R.$Lb)(fe,Ce=>Ce&&be?Ce.toLowerCase():Ce||"");return(0,R.$Gb)(Ae)}n($e,_){return d.$j&&(_=(0,p.$lf)(_,'"')),_=(0,p.$jf)((0,p.$jf)(_," "),"	"),d.$j&&(_=(0,b.$jc)($e,_),_=(0,p.$lf)(_,".")),_}o($e){const _=[$e.path];return typeof $e.line=="number"&&_.push(String($e.line)),typeof $e.column=="number"&&_.push(String($e.column)),_.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/19fa52145f34c62a9b743d33279cfc8cc0552fea/core/vs/code/electron-main/main.js.map
