/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],le=function(Q){for(var t=[],S=0,P=Q.length;S<P;S++)t[S]=ce[Q[S]];return t};define(ce[74],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.LoaderEventType=t.$R=void 0,t.$R=!1;var S;(function(w){w[w.LoaderAvailable=1]="LoaderAvailable",w[w.BeginLoadingScript=10]="BeginLoadingScript",w[w.EndLoadingScriptOK=11]="EndLoadingScriptOK",w[w.EndLoadingScriptError=12]="EndLoadingScriptError",w[w.BeginInvokeFactory=21]="BeginInvokeFactory",w[w.EndInvokeFactory=22]="EndInvokeFactory",w[w.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",w[w.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",w[w.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",w[w.NodeEndNativeRequire=34]="NodeEndNativeRequire",w[w.CachedDataFound=60]="CachedDataFound",w[w.CachedDataMissed=61]="CachedDataMissed",w[w.CachedDataRejected=62]="CachedDataRejected",w[w.CachedDataCreated=63]="CachedDataCreated"})(S||(t.LoaderEventType=S={}));class P{static get(){const I=new Map,L=new Map,k=new Map,g=new Map;function a(v,O){v.has(O.detail)||v.set(O.detail,-O.timestamp)}function f(v,O){const E=v.get(O.detail);E&&(E>=0||v.set(O.detail,E+O.timestamp))}let c=[];typeof Q=="function"&&typeof Q.getStats=="function"&&(c=Q.getStats().slice(0).sort((v,O)=>v.timestamp-O.timestamp));for(const v of c)switch(v.type){case S.BeginLoadingScript:a(I,v);break;case S.EndLoadingScriptOK:case S.EndLoadingScriptError:f(I,v);break;case S.BeginInvokeFactory:a(L,v);break;case S.EndInvokeFactory:f(L,v);break;case S.NodeBeginNativeRequire:a(k,v);break;case S.NodeEndNativeRequire:f(k,v);break;case S.NodeBeginEvaluatingScript:a(g,v);break;case S.NodeEndEvaluatingScript:f(g,v);break}let h=0;k.forEach(v=>h+=v);function p(v){const O=[];return v.forEach((E,d)=>O.push([d,E])),O}return{amdLoad:p(I),amdInvoke:p(L),nodeRequire:p(k),nodeEval:p(g),nodeRequireTotal:h}}static toMarkdownTable(I,L){let k="";const g=[];return I.forEach((a,f)=>{g[f]=a.length}),L.forEach(a=>{a.forEach((f,c)=>{typeof f>"u"&&(f=a[c]="-");const h=f.toString().length;g[c]=Math.max(h,g[c])})}),I.forEach((a,f)=>{k+=`| ${a+" ".repeat(g[f]-a.toString().length)} `}),k+=`|
`,I.forEach((a,f)=>{k+=`| ${"-".repeat(g[f])} `}),k+=`|
`,L.forEach(a=>{a.forEach((f,c)=>{typeof f<"u"&&(k+=`| ${f+" ".repeat(g[c]-f.toString().length)} `)}),k+=`|
`}),k}}t.$S=P}),define(ce[55],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7h=P,t.$8h=w,t.$9h=I;function S(L){return(k,g,a)=>{let f=null,c=null;if(typeof a.value=="function"?(f="value",c=a.value):typeof a.get=="function"&&(f="get",c=a.get),!c)throw new Error("not supported");a[f]=L(c,g)}}function P(L,k,g){let a=null,f=null;if(typeof g.value=="function"?(a="value",f=g.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(a="get",f=g.get),!f)throw new Error("not supported");const c=`$memoize$${k}`;g[a]=function(...h){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,h)}),this[c]}}function w(L,k,g){return S((a,f)=>{const c=`$debounce$${f}`,h=`$debounce$result$${f}`;return function(...p){this[h]||(this[h]=g?g():void 0),clearTimeout(this[c]),k&&(this[h]=k(this[h],...p),p=[this[h]]),this[c]=setTimeout(()=>{a.apply(this,p),this[h]=g?g():void 0},L)}})}function I(L,k,g){return S((a,f)=>{const c=`$throttle$timer$${f}`,h=`$throttle$result$${f}`,p=`$throttle$lastRun$${f}`,v=`$throttle$pending$${f}`;return function(...O){if(this[h]||(this[h]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[h]=k(this[h],...O)),this[v])return;const E=this[p]+L;E<=Date.now()?(this[p]=Date.now(),a.apply(this,[this[h]]),this[h]=g?g():void 0):(this[v]=!0,this[c]=setTimeout(()=>{this[v]=!1,this[p]=Date.now(),a.apply(this,[this[h]]),this[h]=g?g():void 0},E-Date.now()))}})}}),define(ce[75],le([0,1,7]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=P,t.$dd=w,t.$ed=I,t.$fd=L,t.$gd=k,t.$hd=g;function P(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function w(a,f="Unreachable"){throw new Error(f)}function I(a,f="unexpected state"){if(!a)throw new S.$bb(`Assertion Failed: ${f}`)}function L(a){a||(0,S.$Y)(new S.$bb("Soft Assertion Failed"))}function k(a){if(!a()){debugger;a(),(0,S.$Y)(new S.$bb("Assertion Failed"))}}function g(a,f){let c=0;for(;c<a.length-1;){const h=a[c],p=a[c+1];if(!f(h,p))return!1;c++}return!0}}),define(ce[34],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,t.$Tn=L,t.$Un=c,t.$Vn=h,t.$Wn=p,t.$Xn=v,t.$Yn=O,t.$Zn=E,t.$1n=d,t.$2n=m,t.$3n=R,t.$4n=y;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(t.ScanError=S={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P||(t.SyntaxKind=P={}));var w;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(w||(t.ParseErrorCode=w={}));var I;(function(i){i.DEFAULT={allowTrailingComma:!0}})(I||(t.ParseOptions=I={}));function L(i,l=!1){let n=0;const r=i.length;let e="",s=0,o=P.Unknown,u=S.None;function $(J){let re=0,ae=0;for(;re<J;){const ue=i.charCodeAt(n);if(ue>=f._0&&ue<=f._9)ae=ae*16+ue-f._0;else if(ue>=f.A&&ue<=f.F)ae=ae*16+ue-f.A+10;else if(ue>=f.a&&ue<=f.f)ae=ae*16+ue-f.a+10;else break;n++,re++}return re<J&&(ae=-1),ae}function A(J){n=J,e="",s=0,o=P.Unknown,u=S.None}function T(){const J=n;if(i.charCodeAt(n)===f._0)n++;else for(n++;n<i.length&&a(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===f.dot)if(n++,n<i.length&&a(i.charCodeAt(n)))for(n++;n<i.length&&a(i.charCodeAt(n));)n++;else return u=S.UnexpectedEndOfNumber,i.substring(J,n);let re=n;if(n<i.length&&(i.charCodeAt(n)===f.E||i.charCodeAt(n)===f.e))if(n++,(n<i.length&&i.charCodeAt(n)===f.plus||i.charCodeAt(n)===f.minus)&&n++,n<i.length&&a(i.charCodeAt(n))){for(n++;n<i.length&&a(i.charCodeAt(n));)n++;re=n}else u=S.UnexpectedEndOfNumber;return i.substring(J,re)}function D(){let J="",re=n;for(;;){if(n>=r){J+=i.substring(re,n),u=S.UnexpectedEndOfString;break}const ae=i.charCodeAt(n);if(ae===f.doubleQuote){J+=i.substring(re,n),n++;break}if(ae===f.backslash){if(J+=i.substring(re,n),n++,n>=r){u=S.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case f.doubleQuote:J+='"';break;case f.backslash:J+="\\";break;case f.slash:J+="/";break;case f.b:J+="\b";break;case f.f:J+="\f";break;case f.n:J+=`
`;break;case f.r:J+="\r";break;case f.t:J+="	";break;case f.u:{const de=$(4);de>=0?J+=String.fromCharCode(de):u=S.InvalidUnicode;break}default:u=S.InvalidEscapeCharacter}re=n;continue}if(ae>=0&&ae<=31)if(g(ae)){J+=i.substring(re,n),u=S.UnexpectedEndOfString;break}else u=S.InvalidCharacter;n++}return J}function N(){if(e="",u=S.None,s=n,n>=r)return s=r,o=P.EOF;let J=i.charCodeAt(n);if(k(J)){do n++,e+=String.fromCharCode(J),J=i.charCodeAt(n);while(k(J));return o=P.Trivia}if(g(J))return n++,e+=String.fromCharCode(J),J===f.carriageReturn&&i.charCodeAt(n)===f.lineFeed&&(n++,e+=`
`),o=P.LineBreakTrivia;switch(J){case f.openBrace:return n++,o=P.OpenBraceToken;case f.closeBrace:return n++,o=P.CloseBraceToken;case f.openBracket:return n++,o=P.OpenBracketToken;case f.closeBracket:return n++,o=P.CloseBracketToken;case f.colon:return n++,o=P.ColonToken;case f.comma:return n++,o=P.CommaToken;case f.doubleQuote:return n++,e=D(),o=P.StringLiteral;case f.slash:{const re=n-1;if(i.charCodeAt(n+1)===f.slash){for(n+=2;n<r&&!g(i.charCodeAt(n));)n++;return e=i.substring(re,n),o=P.LineCommentTrivia}if(i.charCodeAt(n+1)===f.asterisk){n+=2;const ae=r-1;let ue=!1;for(;n<ae;){if(i.charCodeAt(n)===f.asterisk&&i.charCodeAt(n+1)===f.slash){n+=2,ue=!0;break}n++}return ue||(n++,u=S.UnexpectedEndOfComment),e=i.substring(re,n),o=P.BlockCommentTrivia}return e+=String.fromCharCode(J),n++,o=P.Unknown}case f.minus:if(e+=String.fromCharCode(J),n++,n===r||!a(i.charCodeAt(n)))return o=P.Unknown;case f._0:case f._1:case f._2:case f._3:case f._4:case f._5:case f._6:case f._7:case f._8:case f._9:return e+=T(),o=P.NumericLiteral;default:for(;n<r&&M(J);)n++,J=i.charCodeAt(n);if(s!==n){switch(e=i.substring(s,n),e){case"true":return o=P.TrueKeyword;case"false":return o=P.FalseKeyword;case"null":return o=P.NullKeyword}return o=P.Unknown}return e+=String.fromCharCode(J),n++,o=P.Unknown}}function M(J){if(k(J)||g(J))return!1;switch(J){case f.closeBrace:case f.closeBracket:case f.openBrace:case f.openBracket:case f.doubleQuote:case f.colon:case f.comma:case f.slash:return!1}return!0}function Y(){let J;do J=N();while(J>=P.LineCommentTrivia&&J<=P.Trivia);return J}return{setPosition:A,getPosition:()=>n,scan:l?Y:N,getToken:()=>o,getTokenValue:()=>e,getTokenOffset:()=>s,getTokenLength:()=>n-s,getTokenError:()=>u}}function k(i){return i===f.space||i===f.tab||i===f.verticalTab||i===f.formFeed||i===f.nonBreakingSpace||i===f.ogham||i>=f.enQuad&&i<=f.zeroWidthSpace||i===f.narrowNoBreakSpace||i===f.mathematicalSpace||i===f.ideographicSpace||i===f.byteOrderMark}function g(i){return i===f.lineFeed||i===f.carriageReturn||i===f.lineSeparator||i===f.paragraphSeparator}function a(i){return i>=f._0&&i<=f._9}var f;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(f||(f={}));function c(i,l){const n=[],r=new Object;let e;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u($,A,T,D){s.value=$,s.offset=A,s.length=T,s.type=D,s.colonOffset=void 0,e=s}try{R(i,{onObjectBegin:($,A)=>{if(l<=$)throw r;e=void 0,o=l>$,n.push("")},onObjectProperty:($,A,T)=>{if(l<A||(u($,A,T,"property"),n[n.length-1]=$,l<=A+T))throw r},onObjectEnd:($,A)=>{if(l<=$)throw r;e=void 0,n.pop()},onArrayBegin:($,A)=>{if(l<=$)throw r;e=void 0,n.push(0)},onArrayEnd:($,A)=>{if(l<=$)throw r;e=void 0,n.pop()},onLiteralValue:($,A,T)=>{if(l<A||(u($,A,T,y($)),l<=A+T))throw r},onSeparator:($,A,T)=>{if(l<=A)throw r;if($===":"&&e&&e.type==="property")e.colonOffset=A,o=!1,e=void 0;else if($===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(o=!0,n[n.length-1]=""),e=void 0}}})}catch($){if($!==r)throw $}return{path:n,previousNode:e,isAtPropertyKey:o,matches:$=>{let A=0;for(let T=0;A<$.length&&T<n.length;T++)if($[A]===n[T]||$[A]==="*")A++;else if($[A]!=="**")return!1;return A===$.length}}}function h(i,l=[],n=I.DEFAULT){let r=null,e=[];const s=[];function o($){Array.isArray(e)?e.push($):r!==null&&(e[r]=$)}return R(i,{onObjectBegin:()=>{const $={};o($),s.push(e),e=$,r=null},onObjectProperty:$=>{r=$},onObjectEnd:()=>{e=s.pop()},onArrayBegin:()=>{const $=[];o($),s.push(e),e=$,r=null},onArrayEnd:()=>{e=s.pop()},onLiteralValue:o,onError:($,A,T)=>{l.push({error:$,offset:A,length:T})}},n),e[0]}function p(i,l=[],n=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function e($){r.type==="property"&&(r.length=$-r.offset,r=r.parent)}function s($){return r.children.push($),$}R(i,{onObjectBegin:$=>{r=s({type:"object",offset:$,length:-1,parent:r,children:[]})},onObjectProperty:($,A,T)=>{r=s({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:$,offset:A,length:T,parent:r})},onObjectEnd:($,A)=>{r.length=$+A-r.offset,r=r.parent,e($+A)},onArrayBegin:($,A)=>{r=s({type:"array",offset:$,length:-1,parent:r,children:[]})},onArrayEnd:($,A)=>{r.length=$+A-r.offset,r=r.parent,e($+A)},onLiteralValue:($,A,T)=>{s({type:y($),offset:A,length:T,parent:r,value:$}),e(A+T)},onSeparator:($,A,T)=>{r.type==="property"&&($===":"?r.colonOffset=A:$===","&&e(A))},onError:($,A,T)=>{l.push({error:$,offset:A,length:T})}},n);const u=r.children[0];return u&&delete u.parent,u}function v(i,l){if(!i)return;let n=i;for(const r of l)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let e=!1;for(const s of n.children)if(Array.isArray(s.children)&&s.children[0].value===r){n=s.children[1],e=!0;break}if(!e)return}else{const e=r;if(n.type!=="array"||e<0||!Array.isArray(n.children)||e>=n.children.length)return;n=n.children[e]}return n}function O(i){if(!i.parent||!i.parent.children)return[];const l=O(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;l.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&l.push(n)}return l}function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const l=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(l[n.children[0].value]=E(r))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function d(i,l,n=!1){return l>=i.offset&&l<i.offset+i.length||n&&l===i.offset+i.length}function m(i,l,n=!1){if(d(i,l,n)){const r=i.children;if(Array.isArray(r))for(let e=0;e<r.length&&r[e].offset<=l;e++){const s=m(r[e],l,n);if(s)return s}return i}}function R(i,l,n=I.DEFAULT){const r=L(i,!1);function e(K){return K?()=>K(r.getTokenOffset(),r.getTokenLength()):()=>!0}function s(K){return K?te=>K(te,r.getTokenOffset(),r.getTokenLength()):()=>!0}const o=e(l.onObjectBegin),u=s(l.onObjectProperty),$=e(l.onObjectEnd),A=e(l.onArrayBegin),T=e(l.onArrayEnd),D=s(l.onLiteralValue),N=s(l.onSeparator),M=e(l.onComment),Y=s(l.onError),J=n&&n.disallowComments,re=n&&n.allowTrailingComma;function ae(){for(;;){const K=r.scan();switch(r.getTokenError()){case S.InvalidUnicode:ue(w.InvalidUnicode);break;case S.InvalidEscapeCharacter:ue(w.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:ue(w.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:J||ue(w.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:ue(w.UnexpectedEndOfString);break;case S.InvalidCharacter:ue(w.InvalidCharacter);break}switch(K){case P.LineCommentTrivia:case P.BlockCommentTrivia:J?ue(w.InvalidCommentToken):M();break;case P.Unknown:ue(w.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return K}}}function ue(K,te=[],ne=[]){if(Y(K),te.length+ne.length>0){let j=r.getToken();for(;j!==P.EOF;){if(te.indexOf(j)!==-1){ae();break}else if(ne.indexOf(j)!==-1)break;j=ae()}}}function de(K){const te=r.getTokenValue();return K?D(te):u(te),ae(),!0}function H(){switch(r.getToken()){case P.NumericLiteral:{let K=0;try{K=JSON.parse(r.getTokenValue()),typeof K!="number"&&(ue(w.InvalidNumberFormat),K=0)}catch{ue(w.InvalidNumberFormat)}D(K);break}case P.NullKeyword:D(null);break;case P.TrueKeyword:D(!0);break;case P.FalseKeyword:D(!1);break;default:return!1}return ae(),!0}function Z(){return r.getToken()!==P.StringLiteral?(ue(w.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(de(!1),r.getToken()===P.ColonToken?(N(":"),ae(),x()||ue(w.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):ue(w.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function B(){o(),ae();let K=!1;for(;r.getToken()!==P.CloseBraceToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(K||ue(w.ValueExpected,[],[]),N(","),ae(),r.getToken()===P.CloseBraceToken&&re)break}else K&&ue(w.CommaExpected,[],[]);Z()||ue(w.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),K=!0}return $(),r.getToken()!==P.CloseBraceToken?ue(w.CloseBraceExpected,[P.CloseBraceToken],[]):ae(),!0}function z(){A(),ae();let K=!1;for(;r.getToken()!==P.CloseBracketToken&&r.getToken()!==P.EOF;){if(r.getToken()===P.CommaToken){if(K||ue(w.ValueExpected,[],[]),N(","),ae(),r.getToken()===P.CloseBracketToken&&re)break}else K&&ue(w.CommaExpected,[],[]);x()||ue(w.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),K=!0}return T(),r.getToken()!==P.CloseBracketToken?ue(w.CloseBracketExpected,[P.CloseBracketToken],[]):ae(),!0}function x(){switch(r.getToken()){case P.OpenBracketToken:return z();case P.OpenBraceToken:return B();case P.StringLiteral:return de(!0);default:return H()}}return ae(),r.getToken()===P.EOF?n.allowEmptyContent?!0:(ue(w.ValueExpected,[],[]),!1):x()?(r.getToken()!==P.EOF&&ue(w.EndOfFileExpected,[],[]),!0):(ue(w.ValueExpected,[],[]),!1)}function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ce[76],le([0,1,34]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5n=P,t.$6n=w,t.$7n=k,t.$8n=g;function P(a,f,c){let h,p,v,O,E;if(f){for(O=f.offset,E=O+f.length,v=O;v>0&&!g(a,v-1);)v--;let u=E;for(;u<a.length&&!g(a,u);)u++;p=a.substring(v,u),h=L(p,c)}else p=a,h=0,v=0,O=0,E=a.length;const d=k(c,a);let m=!1,R=0,y;c.insertSpaces?y=I(" ",c.tabSize||4):y="	";const i=(0,S.$Tn)(p,!1);let l=!1;function n(){return d+I(y,h+R)}function r(){let u=i.scan();for(m=!1;u===S.SyntaxKind.Trivia||u===S.SyntaxKind.LineBreakTrivia;)m=m||u===S.SyntaxKind.LineBreakTrivia,u=i.scan();return l=u===S.SyntaxKind.Unknown||i.getTokenError()!==S.ScanError.None,u}const e=[];function s(u,$,A){!l&&$<E&&A>O&&a.substring($,A)!==u&&e.push({offset:$,length:A-$,content:u})}let o=r();if(o!==S.SyntaxKind.EOF){const u=i.getTokenOffset()+v,$=I(y,h);s($,v,u)}for(;o!==S.SyntaxKind.EOF;){let u=i.getTokenOffset()+i.getTokenLength()+v,$=r(),A="";for(;!m&&($===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia);){const D=i.getTokenOffset()+v;s(" ",u,D),u=i.getTokenOffset()+i.getTokenLength()+v,A=$===S.SyntaxKind.LineCommentTrivia?n():"",$=r()}if($===S.SyntaxKind.CloseBraceToken)o!==S.SyntaxKind.OpenBraceToken&&(R--,A=n());else if($===S.SyntaxKind.CloseBracketToken)o!==S.SyntaxKind.OpenBracketToken&&(R--,A=n());else{switch(o){case S.SyntaxKind.OpenBracketToken:case S.SyntaxKind.OpenBraceToken:R++,A=n();break;case S.SyntaxKind.CommaToken:case S.SyntaxKind.LineCommentTrivia:A=n();break;case S.SyntaxKind.BlockCommentTrivia:m?A=n():A=" ";break;case S.SyntaxKind.ColonToken:A=" ";break;case S.SyntaxKind.StringLiteral:if($===S.SyntaxKind.ColonToken){A="";break}case S.SyntaxKind.NullKeyword:case S.SyntaxKind.TrueKeyword:case S.SyntaxKind.FalseKeyword:case S.SyntaxKind.NumericLiteral:case S.SyntaxKind.CloseBraceToken:case S.SyntaxKind.CloseBracketToken:$===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia?A=" ":$!==S.SyntaxKind.CommaToken&&$!==S.SyntaxKind.EOF&&(l=!0);break;case S.SyntaxKind.Unknown:l=!0;break}m&&($===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia)&&(A=n())}const T=i.getTokenOffset()+v;s(A,u,T),o=$}return e}function w(a,f){const c=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?c.replace(/\r\n|\r|\n/g,f.eol):c}function I(a,f){let c="";for(let h=0;h<f;h++)c+=a;return c}function L(a,f){let c=0,h=0;const p=f.tabSize||4;for(;c<a.length;){const v=a.charAt(c);if(v===" ")h++;else if(v==="	")h+=p;else break;c++}return Math.floor(h/p)}function k(a,f){for(let c=0;c<f.length;c++){const h=f.charAt(c);if(h==="\r")return c+1<f.length&&f.charAt(c+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return a&&a.eol||`
`}function g(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(ce[77],le([0,1,34,76]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9n=w,t.$0n=I,t.$$n=L,t.$_n=k,t.$ao=g;function w(a,f,c){return I(a,f,void 0,c)}function I(a,f,c,h,p){const v=f.slice(),O=[],E=(0,S.$Wn)(a,O);let d,m;for(;v.length>0&&(m=v.pop(),d=(0,S.$Xn)(E,v),d===void 0&&c!==void 0);)typeof m=="string"?c={[m]:c}:c=[c];if(d)if(d.type==="object"&&typeof m=="string"&&Array.isArray(d.children)){const R=(0,S.$Xn)(d,[m]);if(R!==void 0)if(c===void 0){if(!R.parent)throw new Error("Malformed AST");const y=d.children.indexOf(R.parent);let i,l=R.parent.offset+R.parent.length;if(y>0){const n=d.children[y-1];i=n.offset+n.length}else i=d.offset+1,d.children.length>1&&(l=d.children[1].offset);return L(a,{offset:i,length:l-i,content:""},h)}else return L(a,{offset:R.offset,length:R.length,content:JSON.stringify(c)},h);else{if(c===void 0)return[];const y=`${JSON.stringify(m)}: ${JSON.stringify(c)}`,i=p?p(d.children.map(n=>n.children[0].value)):d.children.length;let l;if(i>0){const n=d.children[i-1];l={offset:n.offset+n.length,length:0,content:","+y}}else d.children.length===0?l={offset:d.offset+1,length:0,content:y}:l={offset:d.offset+1,length:0,content:y+","};return L(a,l,h)}}else if(d.type==="array"&&typeof m=="number"&&Array.isArray(d.children))if(c!==void 0){const R=`${JSON.stringify(c)}`;let y;if(d.children.length===0||m===0)y={offset:d.offset+1,length:0,content:d.children.length===0?R:R+","};else{const i=m===-1||m>d.children.length?d.children.length:m,l=d.children[i-1];y={offset:l.offset+l.length,length:0,content:","+R}}return L(a,y,h)}else{const R=m,y=d.children[R];let i;if(d.children.length===1)i={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===R){const l=d.children[R-1],n=l.offset+l.length,r=d.offset+d.length;i={offset:n,length:r-2-n,content:""}}else i={offset:y.offset,length:d.children[R+1].offset-y.offset,content:""};return L(a,i,h)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${d.type}`);else return c===void 0?[]:L(a,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(c)},h)}function L(a,f,c){let h=k(a,f),p=f.offset,v=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;p>0&&!(0,P.$8n)(h,p-1);)p--;for(;v<h.length&&!(0,P.$8n)(h,v);)v++}const O=(0,P.$5n)(h,{offset:p,length:v-p},c);for(let d=O.length-1;d>=0;d--){const m=O[d];h=k(h,m),p=Math.min(p,m.offset),v=Math.max(v,m.offset+m.length),v+=m.content.length-m.length}const E=a.length-(h.length-v)-p;return[{offset:p,length:E,content:h.substring(p,v)}]}function k(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function g(a,f){const c=f.slice(0).sort((p,v)=>{const O=p.offset-v.offset;return O===0?p.length-v.length:O});let h=a.length;for(let p=c.length-1;p>=0;p--){const v=c[p];if(v.offset+v.length<=h)a=k(a,v);else throw new Error("Overlapping edit");h=v.offset}return a}}),define(ce[78],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mm=t.$Lm=t.$Km=void 0,t.$Im=S,t.rot=P,t.$Nm=k;function S(g,a,f){return Math.min(Math.max(g,a),f)}function P(g,a){return(a+g%a)%a}class w{constructor(){this.a=0}getNext(){return this.a++}}t.$Km=w;class I{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Lm=I;class L{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const f=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Mm=L;function k(g,a,f,c,h,p,v,O){const E=v-f,d=O-c,m=h-f,R=p-c,y=g-f,i=a-c,l=E*E+d*d,n=E*m+d*R,r=E*y+d*i,e=m*m+R*R,s=m*y+R*i,o=1/(l*e-n*n),u=(e*r-n*s)*o,$=(l*s-n*r)*o;return u>=0&&$>=0&&u+$<1}}),function(){function Q(w){const I=[];typeof w=="number"&&I.push("code/timeOrigin",w);function L(g){I.push(g,Date.now())}function k(){const g=[];for(let a=0;a<I.length;a+=2)g.push({name:I[a],startTime:I[a+1]});return g}return{mark:L,getMarks:k}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const L of performance.getEntriesByType("mark"))I.push({name:L.name,startTime:Math.round(w+L.startTime)});return I}};if(typeof process=="object"){const w=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function S(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=S(P))}(),define(ce[56],le([0,1,12]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminateResponseCode=t.Source=void 0,t.$im=I,t.$jm=L;var P;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(P||(t.Source=P={}));var w;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(w||(t.TerminateResponseCode=w={}));function I(k,...g){const a=g.reduce((h,p)=>(h[p]=!0,h),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(h=>!a[h]).forEach(h=>{for(let p=0;p<f.length;p++)if(h.search(f[p])!==-1){delete k[h];break}})}function L(k){k&&(delete k.DEBUG,S.$l&&delete k.LD_PRELOAD)}}),function(Q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var S=t();for(var P in S)(typeof exports=="object"?exports:Q)[P]=S[P]}}(typeof self<"u"?self:this,function(){return function(Q){var t={};function S(P){if(t[P])return t[P].exports;var w=t[P]={i:P,l:!1,exports:{}};return Q[P].call(w.exports,w,w.exports,S),w.l=!0,w.exports}return S.m=Q,S.c=t,S.d=function(P,w,I){S.o(P,w)||Object.defineProperty(P,w,{enumerable:!0,get:I})},S.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},S.t=function(P,w){if(1&w&&(P=S(P)),8&w||4&w&&typeof P=="object"&&P&&P.__esModule)return P;var I=Object.create(null);if(S.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:P}),2&w&&typeof P!="string")for(var L in P)S.d(I,L,function(k){return P[k]}.bind(null,L));return I},S.n=function(P){var w=P&&P.__esModule?function(){return P.default}:function(){return P};return S.d(w,"a",w),w},S.o=function(P,w){return Object.prototype.hasOwnProperty.call(P,w)},S.p="",S(S.s=0)}([function(Q,t,S){(function(P){var w;t=Q.exports=j,w=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var I=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,k=t.re=[],g=t.src=[],a=0,f=a++;g[f]="0|[1-9]\\d*";var c=a++;g[c]="[0-9]+";var h=a++;g[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=a++;g[p]="("+g[f]+")\\.("+g[f]+")\\.("+g[f]+")";var v=a++;g[v]="("+g[c]+")\\.("+g[c]+")\\.("+g[c]+")";var O=a++;g[O]="(?:"+g[f]+"|"+g[h]+")";var E=a++;g[E]="(?:"+g[c]+"|"+g[h]+")";var d=a++;g[d]="(?:-("+g[O]+"(?:\\."+g[O]+")*))";var m=a++;g[m]="(?:-?("+g[E]+"(?:\\."+g[E]+")*))";var R=a++;g[R]="[0-9A-Za-z-]+";var y=a++;g[y]="(?:\\+("+g[R]+"(?:\\."+g[R]+")*))";var i=a++,l="v?"+g[p]+g[d]+"?"+g[y]+"?";g[i]="^"+l+"$";var n="[v=\\s]*"+g[v]+g[m]+"?"+g[y]+"?",r=a++;g[r]="^"+n+"$";var e=a++;g[e]="((?:<|>)?=?)";var s=a++;g[s]=g[c]+"|x|X|\\*";var o=a++;g[o]=g[f]+"|x|X|\\*";var u=a++;g[u]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[d]+")?"+g[y]+"?)?)?";var $=a++;g[$]="[v=\\s]*("+g[s]+")(?:\\.("+g[s]+")(?:\\.("+g[s]+")(?:"+g[m]+")?"+g[y]+"?)?)?";var A=a++;g[A]="^"+g[e]+"\\s*"+g[u]+"$";var T=a++;g[T]="^"+g[e]+"\\s*"+g[$]+"$";var D=a++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=a++;g[N]="(?:~>?)";var M=a++;g[M]="(\\s*)"+g[N]+"\\s+",k[M]=new RegExp(g[M],"g");var Y=a++;g[Y]="^"+g[N]+g[u]+"$";var J=a++;g[J]="^"+g[N]+g[$]+"$";var re=a++;g[re]="(?:\\^)";var ae=a++;g[ae]="(\\s*)"+g[re]+"\\s+",k[ae]=new RegExp(g[ae],"g");var ue=a++;g[ue]="^"+g[re]+g[u]+"$";var de=a++;g[de]="^"+g[re]+g[$]+"$";var H=a++;g[H]="^"+g[e]+"\\s*("+n+")$|^$";var Z=a++;g[Z]="^"+g[e]+"\\s*("+l+")$|^$";var B=a++;g[B]="(\\s*)"+g[e]+"\\s*("+n+"|"+g[u]+")",k[B]=new RegExp(g[B],"g");var z=a++;g[z]="^\\s*("+g[u]+")\\s+-\\s+("+g[u]+")\\s*$";var x=a++;g[x]="^\\s*("+g[$]+")\\s+-\\s+("+g[$]+")\\s*$";var K=a++;g[K]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)w(te,g[te]),k[te]||(k[te]=new RegExp(g[te]));function ne(V,_){if(V instanceof j)return V;if(typeof V!="string"||V.length>I||!(_?k[r]:k[i]).test(V))return null;try{return new j(V,_)}catch{return null}}function j(V,_){if(V instanceof j){if(V.loose===_)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof j))return new j(V,_);w("SemVer",V,_),this.loose=_;var ie=V.trim().match(_?k[r]:k[i]);if(!ie)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ee=+$e;if(Ee>=0&&Ee<L)return Ee}return $e}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}t.parse=ne,t.valid=function(V,_){var ie=ne(V,_);return ie?ie.version:null},t.clean=function(V,_){var ie=ne(V.trim().replace(/^[=v]+/,""),_);return ie?ie.version:null},t.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(V){return w("SemVer.compare",this.version,this.loose,V),V instanceof j||(V=new j(V,this.loose)),this.compareMain(V)||this.comparePre(V)},j.prototype.compareMain=function(V){return V instanceof j||(V=new j(V,this.loose)),q(this.major,V.major)||q(this.minor,V.minor)||q(this.patch,V.patch)},j.prototype.comparePre=function(V){if(V instanceof j||(V=new j(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var _=0;do{var ie=this.prerelease[_],$e=V.prerelease[_];if(w("prerelease compare",_,ie,$e),ie===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ie===void 0)return-1;if(ie!==$e)return q(ie,$e)}while(++_)},j.prototype.inc=function(V,_){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,_,ie,$e){typeof ie=="string"&&($e=ie,ie=void 0);try{return new j(V,ie).inc(_,$e).version}catch{return null}},t.diff=function(V,_){if(C(V,_))return null;var ie=ne(V),$e=ne(_);if(ie.prerelease.length||$e.prerelease.length){for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==$e[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in ie)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&ie[Ee]!==$e[Ee])return Ee},t.compareIdentifiers=q;var W=/^[0-9]+$/;function q(V,_){var ie=W.test(V),$e=W.test(_);return ie&&$e&&(V=+V,_=+_),ie&&!$e?-1:$e&&!ie?1:V<_?-1:V>_?1:0}function b(V,_,ie){return new j(V,ie).compare(new j(_,ie))}function F(V,_,ie){return b(V,_,ie)>0}function U(V,_,ie){return b(V,_,ie)<0}function C(V,_,ie){return b(V,_,ie)===0}function G(V,_,ie){return b(V,_,ie)!==0}function X(V,_,ie){return b(V,_,ie)>=0}function ee(V,_,ie){return b(V,_,ie)<=0}function oe(V,_,ie,$e){var Ee;switch(_){case"===":typeof V=="object"&&(V=V.version),typeof ie=="object"&&(ie=ie.version),Ee=V===ie;break;case"!==":typeof V=="object"&&(V=V.version),typeof ie=="object"&&(ie=ie.version),Ee=V!==ie;break;case"":case"=":case"==":Ee=C(V,ie,$e);break;case"!=":Ee=G(V,ie,$e);break;case">":Ee=F(V,ie,$e);break;case">=":Ee=X(V,ie,$e);break;case"<":Ee=U(V,ie,$e);break;case"<=":Ee=ee(V,ie,$e);break;default:throw new TypeError("Invalid operator: "+_)}return Ee}function fe(V,_){if(V instanceof fe){if(V.loose===_)return V;V=V.value}if(!(this instanceof fe))return new fe(V,_);w("comparator",V,_),this.loose=_,this.parse(V),this.semver===me?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(V,_){return q(_,V)},t.major=function(V,_){return new j(V,_).major},t.minor=function(V,_){return new j(V,_).minor},t.patch=function(V,_){return new j(V,_).patch},t.compare=b,t.compareLoose=function(V,_){return b(V,_,!0)},t.rcompare=function(V,_,ie){return b(_,V,ie)},t.sort=function(V,_){return V.sort(function(ie,$e){return t.compare(ie,$e,_)})},t.rsort=function(V,_){return V.sort(function(ie,$e){return t.rcompare(ie,$e,_)})},t.gt=F,t.lt=U,t.eq=C,t.neq=G,t.gte=X,t.lte=ee,t.cmp=oe,t.Comparator=fe;var me={};function ge(V,_){if(V instanceof ge)return V.loose===_?V:new ge(V.raw,_);if(V instanceof fe)return new ge(V.value,_);if(!(this instanceof ge))return new ge(V,_);if(this.loose=_,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function we(V){return!V||V.toLowerCase()==="x"||V==="*"}function he(V,_,ie,$e,Ee,Ne,ke,Ce,Re,Le,ze,Ae,Te){return((_=we(ie)?"":we($e)?">="+ie+".0.0":we(Ee)?">="+ie+"."+$e+".0":">="+_)+" "+(Ce=we(Re)?"":we(Le)?"<"+(+Re+1)+".0.0":we(ze)?"<"+Re+"."+(+Le+1)+".0":Ae?"<="+Re+"."+Le+"."+ze+"-"+Ae:"<="+Ce)).trim()}function pe(V,_){for(var ie=0;ie<V.length;ie++)if(!V[ie].test(_))return!1;if(_.prerelease.length){for(ie=0;ie<V.length;ie++)if(w(V[ie].semver),V[ie].semver!==me&&V[ie].semver.prerelease.length>0){var $e=V[ie].semver;if($e.major===_.major&&$e.minor===_.minor&&$e.patch===_.patch)return!0}return!1}return!0}function be(V,_,ie){try{_=new ge(_,ie)}catch{return!1}return _.test(V)}function Se(V,_,ie,$e){var Ee,Ne,ke,Ce,Re;switch(V=new j(V,$e),_=new ge(_,$e),ie){case">":Ee=F,Ne=ee,ke=U,Ce=">",Re=">=";break;case"<":Ee=U,Ne=X,ke=F,Ce="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(V,_,$e))return!1;for(var Le=0;Le<_.set.length;++Le){var ze=_.set[Le],Ae=null,Te=null;if(ze.forEach(function(je){je.semver===me&&(je=new fe(">=0.0.0")),Ae=Ae||je,Te=Te||je,Ee(je.semver,Ae.semver,$e)?Ae=je:ke(je.semver,Te.semver,$e)&&(Te=je)}),Ae.operator===Ce||Ae.operator===Re||(!Te.operator||Te.operator===Ce)&&Ne(V,Te.semver)||Te.operator===Re&&ke(V,Te.semver))return!1}return!0}fe.prototype.parse=function(V){var _=this.loose?k[H]:k[Z],ie=V.match(_);if(!ie)throw new TypeError("Invalid comparator: "+V);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new j(ie[2],this.loose):this.semver=me},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return w("Comparator.test",V,this.loose),this.semver===me||(typeof V=="string"&&(V=new j(V,this.loose)),oe(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,_){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new ge(V.value,_),be(this.value,ie,_);if(V.operator==="")return ie=new ge(this.value,_),be(V.semver,ie,_);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ne=this.semver.version===V.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ce=oe(this.semver,"<",V.semver,_)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Re=oe(this.semver,">",V.semver,_)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||Ee||Ne&&ke||Ce||Re},t.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(V){var _=this.loose;V=V.trim(),w("range",V,_);var ie=_?k[x]:k[z];V=V.replace(ie,he),w("hyphen replace",V),V=V.replace(k[B],"$1$2$3"),w("comparator trim",V,k[B]),V=(V=(V=V.replace(k[M],"$1~")).replace(k[ae],"$1^")).split(/\s+/).join(" ");var $e=_?k[H]:k[Z],Ee=V.split(" ").map(function(Ne){return function(ke,Ce){return w("comp",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(ze){return function(Ae,Te){w("caret",Ae,Te);var je=Te?k[de]:k[ue];return Ae.replace(je,function(Ue,Pe,Ie,Oe,De){var Fe;return w("caret",Ae,Ue,Pe,Ie,Oe,De),we(Pe)?Fe="":we(Ie)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Oe)?Fe=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":De?(w("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Fe=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+De+" <"+(+Pe+1)+".0.0"):(w("no pr"),Fe=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+" <"+(+Pe+1)+".0.0"),w("caret return",Fe),Fe})}(ze,Le)}).join(" ")}(ke,Ce),w("caret",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(ze){return function(Ae,Te){var je=Te?k[J]:k[Y];return Ae.replace(je,function(Ue,Pe,Ie,Oe,De){var Fe;return w("tilde",Ae,Ue,Pe,Ie,Oe,De),we(Pe)?Fe="":we(Ie)?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":we(Oe)?Fe=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":De?(w("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Fe=">="+Pe+"."+Ie+"."+Oe+De+" <"+Pe+"."+(+Ie+1)+".0"):Fe=">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0",w("tilde return",Fe),Fe})}(ze,Le)}).join(" ")}(ke,Ce),w("tildes",ke),ke=function(Re,Le){return w("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(ze){return function(Ae,Te){Ae=Ae.trim();var je=Te?k[T]:k[A];return Ae.replace(je,function(Ue,Pe,Ie,Oe,De,Fe){w("xRange",Ae,Ue,Pe,Ie,Oe,De,Fe);var Ve=we(Ie),Me=Ve||we(Oe),Be=Me||we(De);return Pe==="="&&Be&&(Pe=""),Ve?Ue=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(Me&&(Oe=0),Be&&(De=0),Pe===">"?(Pe=">=",Me?(Ie=+Ie+1,Oe=0,De=0):Be&&(Oe=+Oe+1,De=0)):Pe==="<="&&(Pe="<",Me?Ie=+Ie+1:Oe=+Oe+1),Ue=Pe+Ie+"."+Oe+"."+De):Me?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),w("xRange return",Ue),Ue})}(ze,Le)}).join(" ")}(ke,Ce),w("xrange",ke),ke=function(Re,Le){return w("replaceStars",Re,Le),Re.trim().replace(k[K],"")}(ke,Ce),w("stars",ke),ke}(Ne,_)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Ne){return!!Ne.match($e)})),Ee=Ee.map(function(Ne){return new fe(Ne,_)})},ge.prototype.intersects=function(V,_){if(!(V instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function($e){return V.set.some(function(Ee){return Ee.every(function(Ne){return $e.intersects(Ne,_)})})})})},t.toComparators=function(V,_){return new ge(V,_).set.map(function(ie){return ie.map(function($e){return $e.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new j(V,this.loose));for(var _=0;_<this.set.length;_++)if(pe(this.set[_],V))return!0;return!1},t.satisfies=be,t.maxSatisfying=function(V,_,ie){var $e=null,Ee=null;try{var Ne=new ge(_,ie)}catch{return null}return V.forEach(function(ke){Ne.test(ke)&&($e&&Ee.compare(ke)!==-1||(Ee=new j($e=ke,ie)))}),$e},t.minSatisfying=function(V,_,ie){var $e=null,Ee=null;try{var Ne=new ge(_,ie)}catch{return null}return V.forEach(function(ke){Ne.test(ke)&&($e&&Ee.compare(ke)!==1||(Ee=new j($e=ke,ie)))}),$e},t.validRange=function(V,_){try{return new ge(V,_).range||"*"}catch{return null}},t.ltr=function(V,_,ie){return Se(V,_,"<",ie)},t.gtr=function(V,_,ie){return Se(V,_,">",ie)},t.outside=Se,t.prerelease=function(V,_){var ie=ne(V,_);return ie&&ie.prerelease.length?ie.prerelease:null},t.intersects=function(V,_,ie){return V=new ge(V,ie),_=new ge(_,ie),V.intersects(_)},t.coerce=function(V){if(V instanceof j)return V;if(typeof V!="string")return null;var _=V.match(k[D]);return _==null?null:ne((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,S(1))},function(Q,t){var S,P,w=Q.exports={};function I(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function k(E){if(S===setTimeout)return setTimeout(E,0);if((S===I||!S)&&setTimeout)return S=setTimeout,setTimeout(E,0);try{return S(E,0)}catch{try{return S.call(null,E,0)}catch{return S.call(this,E,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:I}catch{S=I}try{P=typeof clearTimeout=="function"?clearTimeout:L}catch{P=L}})();var g,a=[],f=!1,c=-1;function h(){f&&g&&(f=!1,g.length?a=g.concat(a):c=-1,a.length&&p())}function p(){if(!f){var E=k(h);f=!0;for(var d=a.length;d;){for(g=a,a=[];++c<d;)g&&g[c].run();c=-1,d=a.length}g=null,f=!1,function(m){if(P===clearTimeout)return clearTimeout(m);if((P===L||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(m);try{P(m)}catch{try{return P.call(null,m)}catch{return P.call(this,m)}}}(E)}}function v(E,d){this.fun=E,this.array=d}function O(){}w.nextTick=function(E){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];a.push(new v(E,d)),a.length!==1||f||k(p)},v.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=O,w.addListener=O,w.once=O,w.off=O,w.removeListener=O,w.removeAllListeners=O,w.emit=O,w.prependListener=O,w.prependOnceListener=O,w.listeners=function(E){return[]},w.binding=function(E){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(E){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(ce[79],le([0,1]),function(Q,t){"use strict";var S;Object.defineProperty(t,"__esModule",{value:!0}),t.$Qs=void 0;class P{constructor(k,g,a){this.level=k,this.key=g,this.value=a,this.forward=[]}}const w=void 0;class I{constructor(k,g=2**16){this.comparator=k,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new P(this.c,w,w)}get size(){return this.f}clear(){this.e=new P(this.c,w,w),this.f=0}has(k){return!!I.g(this,k,this.comparator)}get(k){return I.g(this,k,this.comparator)?.value}set(k,g){return I.h(this,k,g,this.comparator)&&(this.f+=1),this}delete(k){const g=I.k(this,k,this.comparator);return g&&(this.f-=1),g}forEach(k,g){let a=this.e.forward[0];for(;a;)k.call(g,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",g=this.e.forward[0];for(;g;)k+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return k}static g(k,g,a){let f=k.e;for(let c=k.d-1;c>=0;c--)for(;f.forward[c]&&a(f.forward[c].key,g)<0;)f=f.forward[c];if(f=f.forward[0],f&&a(f.key,g)===0)return f}static h(k,g,a,f){const c=[];let h=k.e;for(let p=k.d-1;p>=0;p--){for(;h.forward[p]&&f(h.forward[p].key,g)<0;)h=h.forward[p];c[p]=h}if(h=h.forward[0],h&&f(h.key,g)===0)return h.value=a,!1;{const p=I.j(k);if(p>k.d){for(let v=k.d;v<p;v++)c[v]=k.e;k.d=p}h=new P(p,g,a);for(let v=0;v<p;v++)h.forward[v]=c[v].forward[v],c[v].forward[v]=h;return!0}}static j(k,g=.5){let a=1;for(;Math.random()<g&&a<k.c;)a+=1;return a}static k(k,g,a){const f=[];let c=k.e;for(let h=k.d-1;h>=0;h--){for(;c.forward[h]&&a(c.forward[h].key,g)<0;)c=c.forward[h];f[h]=c}if(c=c.forward[0],!c||a(c.key,g)!==0)return!1;for(let h=0;h<k.d&&f[h].forward[h]===c;h++)f[h].forward[h]=c.forward[h];for(;k.d>0&&k.e.forward[k.d-1]===w;)k.d-=1;return!0}}t.$Qs=I}),define(ce[47],le([0,1,7,2]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=w,t.$xe=I,t.$ye=L,t.$ze=k,t.$Ae=a,t.$Be=f,t.$Ce=c,t.$De=h,t.$Ee=p,t.$Fe=v,t.$Ge=O,t.$He=E,t.$Ie=d,t.$Je=m,t.$Ke=R;function w(y){const i=y;return i?typeof i.read=="function":!1}function I(y){const i=y;return i?[i.on,i.pause,i.resume,i.destroy].every(l=>typeof l=="function"):!1}function L(y){const i=y;return i?I(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function k(y,i){return new g(y,i)}class g{constructor(i,l){this.e=i,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(l=>l(i))}h(i){this.c.error.length===0?(0,S.$Y)(i):this.c.error.slice(0).forEach(l=>l(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,l){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(i,l){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const r=n.indexOf(l);r>=0&&n.splice(r,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(y,i){const l=[];let n;for(;(n=y.read())!==null;)l.push(n);return i(l)}function f(y,i,l){const n=[];let r;for(;(r=y.read())!==null&&n.length<l;)n.push(r);return r===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r<"u"){const e=r;return r=void 0,e}return y.read()}}}function c(y,i){return new Promise((l,n)=>{const r=[];h(y,{onData:e=>{i&&r.push(e)},onError:e=>{i?n(e):l(void 0)},onEnd:()=>{l(i?i(r):void 0)}})})}function h(y,i,l){y.on("error",n=>{l?.isCancellationRequested||i.onError(n)}),y.on("end",()=>{l?.isCancellationRequested||i.onEnd()}),y.on("data",n=>{l?.isCancellationRequested||i.onData(n)})}function p(y,i){return new Promise((l,n)=>{const r=new P.$Sc,e=[],s=$=>{if(e.push($),e.length>i)return r.dispose(),y.pause(),l({stream:y,buffer:e,ended:!1})},o=$=>(r.dispose(),n($)),u=()=>(r.dispose(),l({stream:y,buffer:e,ended:!0}));r.add((0,P.$Rc)(()=>y.removeListener("error",o))),y.on("error",o),r.add((0,P.$Rc)(()=>y.removeListener("end",u))),y.on("end",u),r.add((0,P.$Rc)(()=>y.removeListener("data",s))),y.on("data",s)})}function v(y,i){const l=k(i);return l.end(y),l}function O(){const y=k(()=>{throw new Error("not supported")});return y.end(),y}function E(y){let i=!1;return{read:()=>i?null:(i=!0,y)}}function d(y,i,l){const n=k(l);return h(y,{onData:r=>n.write(i.data(r)),onError:r=>n.error(i.error?i.error(r):r),onEnd:()=>n.end()}),n}function m(y,i,l){let n=!1;return{read:()=>{const r=i.read();return n?r:(n=!0,r!==null?l([y,r]):y)}}}function R(y,i,l){let n=!1;const r=k(l);return h(i,{onData:e=>n?r.write(e):(n=!0,r.write(l([y,e]))),onError:e=>r.error(e),onEnd:()=>{n||(n=!0,r.write(y)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(Q,t,S,P){P===void 0&&(P=S);var w=Object.getOwnPropertyDescriptor(t,S);(!w||("get"in w?!t.__esModule:w.writable||w.configurable))&&(w={enumerable:!0,get:function(){return t[S]}}),Object.defineProperty(Q,P,w)}:function(Q,t,S,P){P===void 0&&(P=S),Q[P]=t[S]}),He=this&&this.__setModuleDefault||(Object.create?function(Q,t){Object.defineProperty(Q,"default",{enumerable:!0,value:t})}:function(Q,t){Q.default=t}),ye=this&&this.__importStar||function(Q){if(Q&&Q.__esModule)return Q;var t={};if(Q!=null)for(var S in Q)S!=="default"&&Object.prototype.hasOwnProperty.call(Q,S)&&We(t,Q,S);return He(t,Q),t};define(ce[13],le([0,1,145,47]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Le=void 0,t.$Me=a,t.$Ne=f,t.$Oe=c,t.$Pe=h,t.$Qe=p,t.$Re=v,t.$Se=O,t.$Te=E,t.$Ue=d,t.$Ve=m,t.$We=R,t.$Xe=y,t.$Ye=i,t.$Ze=l,t.$1e=n,t.$2e=r,t.$3e=e,t.$4e=s,t.$5e=o,t.$6e=A,P=ye(P);const w=typeof Buffer<"u",I=new S.$T(()=>new Uint8Array(256));let L,k;class g{static alloc(D){return w?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return w&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,N){return!(N?.dontUseNodeBuffer||!1)&&w?new g(Buffer.from(D)):(L||(L=new TextEncoder),new g(L.encode(D)))}static fromByteArray(D){const N=g.alloc(D.length);for(let M=0,Y=D.length;M<Y;M++)N.buffer[M]=D[M];return N}static concat(D,N){if(typeof N>"u"){N=0;for(let J=0,re=D.length;J<re;J++)N+=D[J].byteLength}const M=g.alloc(N);let Y=0;for(let J=0,re=D.length;J<re;J++){const ae=D[J];M.set(ae,Y),Y+=ae.byteLength}return M}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return w?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(D,N){return new g(this.buffer.subarray(D,N))}set(D,N){if(D instanceof g)this.buffer.set(D.buffer,N);else if(D instanceof Uint8Array)this.buffer.set(D,N);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),N);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return h(this.buffer,D)}writeUInt32BE(D,N){p(this.buffer,D,N)}readUInt32LE(D){return v(this.buffer,D)}writeUInt32LE(D,N){O(this.buffer,D,N)}readUInt8(D){return E(this.buffer,D)}writeUInt8(D,N){d(this.buffer,D,N)}indexOf(D,N=0){return a(this.buffer,D instanceof g?D.buffer:D,N)}}t.$Le=g;function a(T,D,N=0){const M=D.byteLength,Y=T.byteLength;if(M===0)return 0;if(M===1)return T.indexOf(D[0]);if(M>Y-N)return-1;const J=I.value;J.fill(D.length);for(let de=0;de<D.length;de++)J[D[de]]=D.length-de-1;let re=N+D.length-1,ae=re,ue=-1;for(;re<Y;)if(T[re]===D[ae]){if(ae===0){ue=re;break}re--,ae--}else re+=Math.max(D.length-ae,J[T[re]]),ae=D.length-1;return ue}function f(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0}function c(T,D,N){T[N+0]=D&255,D=D>>>8,T[N+1]=D&255}function h(T,D){return T[D]*2**24+T[D+1]*2**16+T[D+2]*2**8+T[D+3]}function p(T,D,N){T[N+3]=D,D=D>>>8,T[N+2]=D,D=D>>>8,T[N+1]=D,D=D>>>8,T[N]=D}function v(T,D){return T[D+0]<<0>>>0|T[D+1]<<8>>>0|T[D+2]<<16>>>0|T[D+3]<<24>>>0}function O(T,D,N){T[N+0]=D&255,D=D>>>8,T[N+1]=D&255,D=D>>>8,T[N+2]=D&255,D=D>>>8,T[N+3]=D&255}function E(T,D){return T[D]}function d(T,D,N){T[N]=D}function m(T){return P.$Ae(T,D=>g.concat(D))}function R(T){return P.$He(T)}function y(T){return P.$Ce(T,D=>g.concat(D))}async function i(T){return T.ended?g.concat(T.buffer):g.concat([...T.buffer,await y(T.stream)])}function l(T){return P.$Fe(T,D=>g.concat(D))}function n(T){return P.$Ie(T,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}function r(T){return P.$ze(D=>g.concat(D),T)}function e(T,D){return P.$Je(T,D,N=>g.concat(N))}function s(T,D){return P.$Ke(T,D,N=>g.concat(N))}function o(T){let D=0,N=0,M=0;const Y=new Uint8Array(Math.floor(T.length/4*3)),J=ae=>{switch(N){case 3:Y[M++]=D|ae,N=0;break;case 2:Y[M++]=D|ae>>>2,D=ae<<6,N=3;break;case 1:Y[M++]=D|ae>>>4,D=ae<<4,N=2;break;default:D=ae<<2,N=1}};for(let ae=0;ae<T.length;ae++){const ue=T.charCodeAt(ae);if(ue>=65&&ue<=90)J(ue-65);else if(ue>=97&&ue<=122)J(ue-97+26);else if(ue>=48&&ue<=57)J(ue-48+52);else if(ue===43||ue===45)J(62);else if(ue===47||ue===95)J(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ae]}`)}}const re=M;for(;N>0;)J(0);return g.wrap(Y).slice(0,re)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",$="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function A({buffer:T},D=!0,N=!1){const M=N?$:u;let Y="";const J=T.byteLength%3;let re=0;for(;re<T.byteLength-J;re+=3){const ae=T[re+0],ue=T[re+1],de=T[re+2];Y+=M[ae>>>2],Y+=M[(ae<<4|ue>>>4)&63],Y+=M[(ue<<2|de>>>6)&63],Y+=M[de&63]}if(J===1){const ae=T[re+0];Y+=M[ae>>>2],Y+=M[ae<<4&63],D&&(Y+="==")}else if(J===2){const ae=T[re+0],ue=T[re+1];Y+=M[ae>>>2],Y+=M[(ae<<4|ue>>>4)&63],Y+=M[ue<<2&63],D&&(Y+="=")}return Y}}),define(ce[26],le([0,1,3]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bo=P,t.$co=w,t.$do=L,t.$eo=g,t.$fo=a,t.$go=f,t.$ho=c,t.$io=h,t.$jo=p,t.$ko=v,t.$lo=O,t.$mo=E,t.$no=d;function P(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const R=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([y,i])=>{R[y]=i&&typeof i=="object"?P(i):i}),R}function w(m){if(!m||typeof m!="object")return m;const R=[m];for(;R.length>0;){const y=R.shift();Object.freeze(y);for(const i in y)if(I.call(y,i)){const l=y[i];typeof l=="object"&&!Object.isFrozen(l)&&!(0,S.$fg)(l)&&R.push(l)}}return m}const I=Object.prototype.hasOwnProperty;function L(m,R){return k(m,R,new Set)}function k(m,R,y){if((0,S.$lg)(m))return m;const i=R(m);if(typeof i<"u")return i;if(Array.isArray(m)){const l=[];for(const n of m)l.push(k(n,R,y));return l}if((0,S.$eg)(m)){if(y.has(m))throw new Error("Cannot clone recursive data-structure");y.add(m);const l={};for(const n in m)I.call(m,n)&&(l[n]=k(m[n],R,y));return y.delete(m),l}return m}function g(m,R,y=!0){return(0,S.$eg)(m)?((0,S.$eg)(R)&&Object.keys(R).forEach(i=>{i in m?y&&((0,S.$eg)(m[i])&&(0,S.$eg)(R[i])?g(m[i],R[i],y):m[i]=R[i]):m[i]=R[i]}),m):R}function a(m,R){if(m===R)return!0;if(m==null||R===null||R===void 0||typeof m!=typeof R||typeof m!="object"||Array.isArray(m)!==Array.isArray(R))return!1;let y,i;if(Array.isArray(m)){if(m.length!==R.length)return!1;for(y=0;y<m.length;y++)if(!a(m[y],R[y]))return!1}else{const l=[];for(i in m)l.push(i);l.sort();const n=[];for(i in R)n.push(i);if(n.sort(),!a(l,n))return!1;for(y=0;y<l.length;y++)if(!a(m[l[y]],R[l[y]]))return!1}return!0}function f(m){const R=new Set;return JSON.stringify(m,(y,i)=>{if((0,S.$eg)(i)||Array.isArray(i)){if(R.has(i))return"[Circular]";R.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function c(m,R){const y=Object.create(null);return!m||!R||Object.keys(R).forEach(l=>{const n=m[l],r=R[l];a(n,r)||(y[l]=r)}),y}function h(m,R){const y=R.toLowerCase(),i=Object.keys(m).find(l=>l.toLowerCase()===y);return i?m[i]:m[R]}function p(m,R){const y=Object.create(null);for(const[i,l]of Object.entries(m))R(i,l)&&(y[i]=l);return y}function v(m){let R=[];for(;Object.prototype!==m;)R=R.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return R}function O(m){const R=[];for(const y of v(m))typeof m[y]=="function"&&R.push(y);return R}function E(m,R){const y=l=>function(){const n=Array.prototype.slice.call(arguments,0);return R(l,n)},i={};for(const l of m)i[l]=y(l);return i}function d(m,R){const y={};for(const[i,l]of Object.entries(m))y[i]=R(l,i);return y}}),define(ce[43],le([0,1,31]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wj=t.$uj=void 0,t.$qj=P,t.$rj=w,t.$sj=I,t.$tj=k,t.$vj=O,S=ye(S);function P(d){return w(d,0)}function w(d,m){switch(typeof d){case"object":return d===null?I(349,m):Array.isArray(d)?g(d,m):a(d,m);case"string":return k(d,m);case"boolean":return L(d,m);case"number":return I(d,m);case"undefined":return I(937,m);default:return I(617,m)}}function I(d,m){return(m<<5)-m+d|0}function L(d,m){return I(d?433:863,m)}function k(d,m){m=I(149417,m);for(let R=0,y=d.length;R<y;R++)m=I(d.charCodeAt(R),m);return m}function g(d,m){return m=I(104579,m),d.reduce((R,y)=>w(y,R),m)}function a(d,m){return m=I(181387,m),Object.keys(d).sort().reduce((R,y)=>(R=k(y,R),w(d[y],R)),m)}class f{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=w(m,this.g),this.g}}t.$uj=f;var c;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function h(d,m,R=32){const y=R-m,i=~((1<<y)-1);return(d<<m|(i&d)>>>y)>>>0}function p(d,m=0,R=d.byteLength,y=0){for(let i=0;i<R;i++)d[m+i]=y}function v(d,m,R="0"){for(;d.length<m;)d=R+d;return d}function O(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(R=>R.toString(16).padStart(2,"0")).join(""):v((d>>>0).toString(16),m/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(c.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const R=m.length;if(R===0)return;const y=this.p;let i=this.r,l=this.u,n,r;for(l!==0?(n=l,r=-1,l=0):(n=m.charCodeAt(0),r=0);;){let e=n;if(S.$Hf(n))if(r+1<R){const s=m.charCodeAt(r+1);S.$If(s)?(r++,e=S.$Jf(n,s)):e=c.UNICODE_REPLACEMENT}else{l=n;break}else S.$If(n)&&(e=c.UNICODE_REPLACEMENT);if(i=this.w(y,i,e),r++,r<R)n=m.charCodeAt(r);else break}this.r=i,this.u=l}w(m,R,y){return y<128?m[R++]=y:y<2048?(m[R++]=192|(y&1984)>>>6,m[R++]=128|(y&63)>>>0):y<65536?(m[R++]=224|(y&61440)>>>12,m[R++]=128|(y&4032)>>>6,m[R++]=128|(y&63)>>>0):(m[R++]=240|(y&1835008)>>>18,m[R++]=128|(y&258048)>>>12,m[R++]=128|(y&4032)>>>6,m[R++]=128|(y&63)>>>0),R>=c.BLOCK_SIZE&&(this.y(),R-=c.BLOCK_SIZE,this.t+=c.BLOCK_SIZE,m[0]=m[c.BLOCK_SIZE+0],m[1]=m[c.BLOCK_SIZE+1],m[2]=m[c.BLOCK_SIZE+2]),R}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,c.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),O(this.h)+O(this.l)+O(this.m)+O(this.n)+O(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=E.g,R=this.q;for(let u=0;u<64;u+=4)m.setUint32(u,R.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)m.setUint32(u,h(m.getUint32(u-12,!1)^m.getUint32(u-32,!1)^m.getUint32(u-56,!1)^m.getUint32(u-64,!1),1),!1);let y=this.h,i=this.l,l=this.m,n=this.n,r=this.o,e,s,o;for(let u=0;u<80;u++)u<20?(e=i&l|~i&n,s=1518500249):u<40?(e=i^l^n,s=1859775393):u<60?(e=i&l|i&n|l&n,s=2400959708):(e=i^l^n,s=3395469782),o=h(y,5)+e+r+s+m.getUint32(u*4,!1)&4294967295,r=n,n=l,l=h(i,30),i=y,y=o;this.h=this.h+y&4294967295,this.l=this.l+i&4294967295,this.m=this.m+l&4294967295,this.n=this.n+n&4294967295,this.o=this.o+r&4294967295}}t.$wj=E}),define(ce[57],le([0,1,31]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),S=ye(S);var P;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(P||(P={})),function(w){const I="error",L="warning",k="warn",g="info",a="ignore";function f(h){return h?S.$Df(I,h)?w.Error:S.$Df(L,h)||S.$Df(k,h)?w.Warning:S.$Df(g,h)?w.Info:w.Ignore:w.Ignore}w.fromValue=f;function c(h){switch(h){case w.Error:return I;case w.Warning:return L;case w.Info:return g;default:return a}}w.toString=c}(P||(P={})),t.default=P}),define(ce[80],le([0,1,11]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ar=P,t.$br=w,t.$cr=I,t.log=k;function P(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function w(a){const f=[];let c;try{const h=JSON.parse(a.arguments),p=h[h.length-1];p&&p.__$stack&&(h.pop(),c=p.__$stack),f.push(...h)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:c}}function I(a){if(typeof a!="string")return I(w(a).stack);const f=a;if(f){const c=L(f),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(h&&h.length===4)return{uri:S.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function L(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function k(a,f){const{args:c,stack:h}=w(a),p=typeof c[0]=="string"&&c.length===1;let v=L(h);v&&(v=`(${v.trim()})`);let O=[];if(typeof c[0]=="string"?v&&p?O=[`%c[${f}] %c${c[0]} %c${v}`,g("blue"),g(""),g("grey")]:O=[`%c[${f}] %c${c[0]}`,g("blue"),g(""),...c.slice(1)]:O=[`%c[${f}]%`,g("blue"),...c],v&&!p&&O.push(v),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,O)}function g(a){return`color: ${a}`}}),define(ce[48],le([0,1,13,11,146]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=I,t.$$h=L,t.$_h=g;function I(a){return JSON.stringify(a,k)}function L(a){let f=JSON.parse(a);return f=g(f),f}function k(a,f){return f instanceof RegExp?{$mid:w.MarshalledId.Regexp,source:f.source,flags:f.flags}:f}function g(a,f=0){if(!a||f>200)return a;if(typeof a=="object"){switch(a.$mid){case w.MarshalledId.Uri:return P.URI.revive(a);case w.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case w.MarshalledId.Date:return new Date(a.source)}if(a instanceof S.$Le||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let c=0;c<a.length;++c)a[c]=g(a[c],f+1);else for(const c in a)Object.hasOwnProperty.call(a,c)&&(a[c]=g(a[c],f+1))}return a}}),define(ce[81],le([0,1,74,14,12,11]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sE=f,w=ye(w);class L{constructor(h,p,v){this.id=h,this.dependencies=p,this.callback=v}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,p,v)=>{typeof h!="string"&&(v=p,p=h,h=null),(typeof p!="object"||!Array.isArray(p))&&(v=p,p=null),this.c.push(new L(h,p,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const p=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!p)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(h){return new Promise((p,v)=>{const O=document.createElement("script");O.setAttribute("async","async"),O.setAttribute("type","text/javascript");const E=()=>{O.removeEventListener("load",d),O.removeEventListener("error",m)},d=R=>{E(),p(this.c.pop())},m=R=>{E(),v(R)};O.addEventListener("load",d),O.addEventListener("error",m),this.f&&(h=this.f.createScriptURL(h)),O.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(O)})}i(h){return new Promise((p,v)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),p(this.c.pop())}catch(O){v(O)}})}async j(h){try{const p=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,O=globalThis._VSCODE_NODE_MODULES.module,E=I.URI.parse(h).fsPath,d=p.readFileSync(E).toString(),m=O.wrap(d.replace(/^#!.*/,""));return new v.Script(m).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const g=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function f(c,h,p){if(S.$R){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[c]&&(c=a[c]);const v=`${c}/${h}`;if(g.has(v))return g.get(v);let O;if(/^\w[\w\d+.-]*:\/\//.test(v))O=v;else{const R=`${p&&!w.$p?P.$Tg:P.$Sg}/${v}`;O=P.$Wg.asBrowserUri(R).toString(!0)}const E=k.INSTANCE.load(O);return g.set(v,E),E}else return await new Promise((v,O)=>{Q([c],v,O)}).then(ye)}}),define(ce[27],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yg=void 0,t.$Xg=P;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(w){return S.test(w)}t.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(k){for(let g=0;g<k.length;g++)k[g]=Math.floor(Math.random()*256);return k};const I=new Uint8Array(16),L=[];for(let k=0;k<256;k++)L.push(k.toString(16).padStart(2,"0"));return function(){w(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let g=0,a="";return a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+="-",a+=L[I[g++]],a+=L[I[g++]],a+="-",a+=L[I[g++]],a+=L[I[g++]],a+="-",a+=L[I[g++]],a+=L[I[g++]],a+="-",a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a+=L[I[g++]],a}}()}),define(ce[82],le([0,1,35]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$On=I;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function w(L){const k=L.replace(/\-/g,":").toLowerCase();return!P.has(k)}function I(){const L=(0,S.networkInterfaces)();for(const k in L){const g=L[k];if(g){for(const{mac:a}of g)if(w(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ce[83],le([0,1,35,49,27,82,12]),function(Q,t,S,P,w,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pn=void 0,t.$Qn=g,t.$Rn=c,t.$Sn=h,w=ye(w),t.$Pn=new class{c(p){return this.a||(this.a=P.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,v=0;const O=(0,S.networkInterfaces)();for(const E in O){const d=O[E];if(d)for(const{mac:m,internal:R}of d)R||(v+=1,this.c(m.toUpperCase())&&(p+=1))}this.b=v>0?p/v:0}return this.b}};let k;async function g(p){return k||(k=(async()=>await a(p)||w.$Yg())()),k}async function a(p){try{const v=await new Promise((E,d)=>{Q(["crypto"],E,d)}).then(ye),O=(0,I.$On)();return v.createHash("sha256").update(O,"utf8").digest("hex")}catch(v){p(v);return}}const f="Software\\Microsoft\\SQMClient";async function c(p){if(L.$j){const v=await new Promise((O,E)=>{Q(["@vscode/windows-registry"],O,E)}).then(ye);try{return v.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(O){return p(O),""}}return""}async function h(p){try{return await(await new Promise((E,d)=>{Q(["@vscode/deviceid"],E,d)}).then(ye)).getDeviceId()}catch(v){return p(v),""}}}),define(ce[84],le([0,1,35,15,28]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tm=m,t.$um=R,S=ye(S),P=ye(P),w=ye(w);const I=/^\d+$/,L=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var g;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(g||(g={}));let a;switch(process.arch){case"ia32":a=g.x86;break;case"arm":case"arm64":a=g.ARM;break;default:a=g.x64;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=g.x86:f=g.x64;class c{constructor(i,l,n){this.exePath=i,this.displayName=l,this.a=n}async exists(){return this.a===void 0&&(this.a=await w.SymlinkSupport.existsFile(this.exePath)),this.a}}function h({useAlternateBitness:y=!1}={}){return y?a===g.x64?process.env["ProgramFiles(x86)"]||null:f===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:y=!1,findPreview:i=!1}={}){const l=h({useAlternateBitness:y});if(!l)return null;const n=P.$ic(l,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(n))return null;let r=-1,e=null;for(const u of await w.Promises.readdir(n)){let $=-1;if(i){const T=u.indexOf("-");if(T<0)continue;const D=u.substring(0,T);if(!I.test(D)||u.substring(T+1)!=="preview")continue;$=parseInt(D,10)}else{if(!I.test(u))continue;$=parseInt(u,10)}if($<=r)continue;const A=P.$ic(n,u,"pwsh.exe");await w.SymlinkSupport.existsFile(A)&&(e=A,r=$)}if(!e)return null;const s=l.includes("x86")?" (x86)":"",o=i?" Preview":"";return new c(e,`PowerShell${o}${s}`,!0)}async function v({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const i=P.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=y?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await w.Promises.readdir(i))if(l.test(r)){const e=P.$ic(i,r,"pwsh.exe");return new c(e,n)}return null}function O(){const y=P.$ic(S.homedir(),".dotnet","tools","pwsh.exe");return new c(y,".NET Core PowerShell Global Tool")}function E(){const y=P.$ic(process.env.windir,a===g.x86&&f!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(y,"Windows PowerShell",!0)}async function*d(){let y=await p();y&&(yield y),y=await p({useAlternateBitness:!0}),y&&(yield y),y=await v(),y&&(yield y),y=O(),y&&(yield y),y=await p({findPreview:!0}),y&&(yield y),y=await v({findPreview:!0}),y&&(yield y),y=await p({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=E(),y&&(yield y)}async function*m(){for await(const y of d())await y.exists()&&(yield y)}async function R(){for await(const y of m())return y;return null}}),define(ce[58],le([0,1,32,15,12,36,56,3,28]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.TerminateResponseCode=t.Source=void 0,t.$vm=a,t.$wm=f,P=ye(P),w=ye(w),I=ye(I),k=ye(k),g=ye(g),Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function a(h=I.env){return h.comspec||"cmd.exe"}function f(h){let p=[],v=!1;const O=function(E){if(v){p.push(E);return}(!h.send(E,m=>{if(m&&console.error(m),v=!1,p.length>0){const R=p.slice(0);p=[],R.forEach(y=>O(y))}})||w.$j)&&(v=!0)};return{send:O}}var c;(function(h){async function p(v,O,E){if(P.$hc(v))return v;if(O===void 0&&(O=I.cwd()),P.$lc(v)!=="."||(E===void 0&&k.$cg(I.env.PATH)&&(E=I.env.PATH.split(P.$sc)),E===void 0||E.length===0))return P.$ic(O,v);async function m(R){if(await g.Promises.exists(R)){let y;try{y=await S.promises.stat(R)}catch(i){i.message.startsWith("EACCES")&&(y=await S.promises.lstat(R))}return y?!y.isDirectory():!1}return!1}for(const R of E){let y;if(P.$hc(R)?y=P.$ic(R,v):y=P.$ic(O,R,v),await m(y))return y;let i=y+".com";if(await m(i)||(i=y+".exe",await m(i)))return i}return P.$ic(O,v)}h.findExecutable=p})(c||(t.win32=c={}))}),define(ce[85],le([0,1,35,12,84,58]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xm=L,P=ye(P),I=ye(I);async function L(c,h){return c===P.OperatingSystem.Windows?P.$j?f():I.$vm(h):g(c,h)}let k=null;function g(c,h){if(P.$l&&c===P.OperatingSystem.Macintosh||P.$k&&c===P.OperatingSystem.Linux)return"/bin/bash";if(!k){let p;if(P.$j)p="/bin/bash";else{if(p=h.SHELL,!p)try{p=(0,S.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}k=p}return k}let a=null;async function f(){return a||(a=(await(0,w.$um)()).exePath),a}});var ve=this&&this.__decorate||function(Q,t,S,P){var w=arguments.length,I=w<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,S):P,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(Q,t,S,P);else for(var k=Q.length-1;k>=0;k--)(L=Q[k])&&(I=(w<3?L(I):w>3?L(t,S,I):L(t,S))||I);return w>3&&I&&Object.defineProperty(t,S,I),I};define(ce[59],le([0,1,19,8,13,21,55,7,4,2,48,31,3]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$li=t.ProxyChannel=t.$ki=t.$hi=t.$gi=t.$fi=t.RequestInitiator=t.$ei=t.$bi=t.$ai=void 0,t.$ci=o,t.$di=u,t.$ii=M,t.$ji=Y,c=ye(c);var p;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(p||(p={}));function v(B){switch(B){case p.Promise:return"req";case p.PromiseCancel:return"cancel";case p.EventListen:return"subscribe";case p.EventDispose:return"unsubscribe"}}var O;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(O||(O={}));function E(B){switch(B){case O.Initialize:return"init";case O.PromiseSuccess:return"reply:";case O.PromiseError:case O.PromiseErrorObj:return"replyErr:";case O.EventFire:return"event:"}}var d;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(d||(d={}));function m(B){let z=0;for(let x=0;;x+=7){const K=B.read(1);if(z|=(K.buffer[0]&127)<<x,!(K.buffer[0]&128))return z}}const R=r(0);function y(B,z){if(z===0){B.write(R);return}let x=0;for(let te=z;te!==0;te=te>>>7)x++;const K=w.$Le.alloc(x);for(let te=0;z!==0;te++)K.buffer[te]=z&127,z=z>>>7,z>0&&(K.buffer[te]|=128);B.write(K)}class i{constructor(z){this.b=z,this.a=0}read(z){const x=this.b.slice(this.a,this.a+z);return this.a+=x.byteLength,x}}t.$ai=i;class l{constructor(){this.a=[]}get buffer(){return w.$Le.concat(this.a)}write(z){this.a.push(z)}}t.$bi=l;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function r(B){const z=w.$Le.alloc(1);return z.writeUInt8(B,0),z}const e={Undefined:r(n.Undefined),String:r(n.String),Buffer:r(n.Buffer),VSBuffer:r(n.VSBuffer),Array:r(n.Array),Object:r(n.Object),Uint:r(n.Int)},s=typeof Buffer<"u";function o(B,z){if(typeof z>"u")B.write(e.Undefined);else if(typeof z=="string"){const x=w.$Le.fromString(z);B.write(e.String),y(B,x.byteLength),B.write(x)}else if(s&&Buffer.isBuffer(z)){const x=w.$Le.wrap(z);B.write(e.Buffer),y(B,x.byteLength),B.write(x)}else if(z instanceof w.$Le)B.write(e.VSBuffer),y(B,z.byteLength),B.write(z);else if(Array.isArray(z)){B.write(e.Array),y(B,z.length);for(const x of z)o(B,x)}else if(typeof z=="number"&&(z|0)===z)B.write(e.Uint),y(B,z);else{const x=w.$Le.fromString(JSON.stringify(z));B.write(e.Object),y(B,x.byteLength),B.write(x)}}function u(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(m(B)).toString();case n.Buffer:return B.read(m(B)).buffer;case n.VSBuffer:return B.read(m(B));case n.Array:{const x=m(B),K=[];for(let te=0;te<x;te++)K.push(u(B));return K}case n.Object:return JSON.parse(B.read(m(B)).toString());case n.Int:return m(B)}}class ${constructor(z,x,K=null,te=1e3){this.h=z,this.j=x,this.k=K,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:O.Initialize})}registerChannel(z,x){this.b.set(z,x),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case O.Initialize:{const x=this.o([z.type]);this.k?.logOutgoing(x,0,A.OtherSide,E(z.type));return}case O.PromiseSuccess:case O.PromiseError:case O.EventFire:case O.PromiseErrorObj:{const x=this.o([z.type,z.id],z.data);this.k?.logOutgoing(x,z.id,A.OtherSide,E(z.type),z.data);return}}}o(z,x=void 0){const K=new l;return o(K,z),o(K,x),this.p(K.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const x=new i(z),K=u(x),te=u(x),ne=K[0];switch(ne){case p.Promise:return this.k?.logIncoming(z.byteLength,K[1],A.OtherSide,`${v(ne)}: ${K[2]}.${K[3]}`,te),this.s({type:ne,id:K[1],channelName:K[2],name:K[3],arg:te});case p.EventListen:return this.k?.logIncoming(z.byteLength,K[1],A.OtherSide,`${v(ne)}: ${K[2]}.${K[3]}`,te),this.t({type:ne,id:K[1],channelName:K[2],name:K[3],arg:te});case p.PromiseCancel:return this.k?.logIncoming(z.byteLength,K[1],A.OtherSide,`${v(ne)}`),this.u({type:ne,id:K[1]});case p.EventDispose:return this.k?.logIncoming(z.byteLength,K[1],A.OtherSide,`${v(ne)}`),this.u({type:ne,id:K[1]})}}s(z){const x=this.b.get(z.channelName);if(!x){this.v(z);return}const K=new I.$ue;let te;try{te=x.call(this.j,z.name,z.arg,K.token)}catch(W){te=Promise.reject(W)}const ne=z.id;te.then(W=>{this.m({id:ne,data:W,type:O.PromiseSuccess})},W=>{W instanceof Error?this.m({id:ne,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split(`
`):void 0},type:O.PromiseError}):this.m({id:ne,data:W,type:O.PromiseErrorObj})}).finally(()=>{j.dispose(),this.d.delete(z.id)});const j=(0,a.$Rc)(()=>K.cancel());this.d.set(z.id,j)}t(z){const x=this.b.get(z.channelName);if(!x){this.v(z);return}const K=z.id,ne=x.listen(this.j,z.name,z.arg)(j=>this.m({id:K,data:j,type:O.EventFire}));this.d.set(z.id,ne)}u(z){const x=this.d.get(z.id);x&&(x.dispose(),this.d.delete(z.id))}v(z){let x=this.g.get(z.channelName);x||(x=[],this.g.set(z.channelName,x));const K=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===p.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:O.PromiseError})},this.l);x.push({request:z,timeoutTimer:K})}w(z){const x=this.g.get(z);if(x){for(const K of x)switch(clearTimeout(K.timeoutTimer),K.request.type){case p.Promise:this.s(K.request);break;case p.EventListen:this.t(K.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}t.$ei=$;var A;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(A||(t.RequestInitiator=A={}));class T{constructor(z,x=null){this.l=z,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=x}getChannel(z){const x=this;return{call(K,te,ne){return x.a?Promise.reject(new k.$4):x.m(z,K,te,ne)},listen(K,te){return x.a?g.Event.None:x.o(z,K,te)}}}m(z,x,K,te=I.CancellationToken.None){const ne=this.g++,j=p.Promise,W={id:ne,type:j,channelName:z,name:x,arg:K};if(te.isCancellationRequested)return Promise.reject(new k.$4);let q;return new Promise((F,U)=>{if(te.isCancellationRequested)return U(new k.$4);const C=()=>{const oe=fe=>{switch(fe.type){case O.PromiseSuccess:this.f.delete(ne),F(fe.data);break;case O.PromiseError:{this.f.delete(ne);const me=new Error(fe.data.message);me.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,me.name=fe.data.name,U(me);break}case O.PromiseErrorObj:this.f.delete(ne),U(fe.data);break}};this.f.set(ne,oe),this.p(W)};let G=null;this.b===d.Idle?C():(G=(0,P.$ph)(oe=>this.u()),G.then(()=>{G=null,C()}));const X=()=>{G?(G.cancel(),G=null):this.p({id:ne,type:p.PromiseCancel}),U(new k.$4)},ee=te.onCancellationRequested(X);q=(0,a.$Qc)((0,a.$Rc)(X),ee),this.d.add(q)}).finally(()=>{q.dispose(),this.d.delete(q)})}o(z,x,K){const te=this.g++,ne=p.EventListen,j={id:te,type:ne,channelName:z,name:x,arg:K};let W=null;const q=new g.$je({onWillAddFirstListener:()=>{W=(0,P.$ph)(F=>this.u()),W.then(()=>{W=null,this.d.add(q),this.p(j)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.d.delete(q),this.p({id:te,type:p.EventDispose}))}}),b=F=>q.fire(F.data);return this.f.set(te,b),q.event}p(z){switch(z.type){case p.Promise:case p.EventListen:{const x=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(x,z.id,A.LocalSide,`${v(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case p.PromiseCancel:case p.EventDispose:{const x=this.q([z.type,z.id]);this.j?.logOutgoing(x,z.id,A.LocalSide,v(z.type));return}}}q(z,x=void 0){const K=new l;return o(K,z),o(K,x),this.r(K.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const x=new i(z),K=u(x),te=u(x),ne=K[0];switch(ne){case O.Initialize:return this.j?.logIncoming(z.byteLength,0,A.LocalSide,E(ne)),this.t({type:K[0]});case O.PromiseSuccess:case O.PromiseError:case O.EventFire:case O.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,K[1],A.LocalSide,E(ne),te),this.t({type:K[0],id:K[1],data:te})}}t(z){if(z.type===O.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}t.$fi=T,ve([L.$7h],T.prototype,"onDidInitializePromise",null);class D{get connections(){const z=[];return this.f.forEach(x=>z.push(x)),z}constructor(z,x,K){this.a=new Map,this.f=new Set,this.g=new g.$je,this.onDidAddConnection=this.g.event,this.h=new g.$je,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(z(({protocol:te,onDidClientDisconnect:ne})=>{const j=g.Event.once(te.onMessage);this.j.add(j(W=>{const q=new i(W),b=u(q),F=new $(te,b,x,K),U=new T(te,x);this.a.forEach((G,X)=>F.registerChannel(X,G));const C={channelServer:F,channelClient:U,ctx:b};this.f.add(C),this.g.fire(C),this.j.add(ne(()=>{F.dispose(),U.dispose(),this.f.delete(C),this.h.fire(C)}))}))}))}getChannel(z,x){const K=this;return{call(te,ne,j){let W;if((0,h.$qg)(x)){const b=(0,S.$2b)(K.connections.filter(x));W=b?Promise.resolve(b):g.Event.toPromise(g.Event.filter(K.onDidAddConnection,x))}else W=x.routeCall(K,te,ne);const q=W.then(b=>b.channelClient.getChannel(z));return M(q).call(te,ne,j)},listen(te,ne){if((0,h.$qg)(x))return K.k(z,x,te,ne);const j=x.routeEvent(K,te,ne).then(W=>W.channelClient.getChannel(z));return M(j).listen(te,ne)}}}k(z,x,K,te){const ne=this;let j;const W=new g.$je({onWillAddFirstListener:()=>{j=new a.$Sc;const q=new g.$pe,b=new Map,F=C=>{const X=C.channelClient.getChannel(z).listen(K,te),ee=q.add(X);b.set(C,ee)},U=C=>{const G=b.get(C);G&&(G.dispose(),b.delete(C))};ne.connections.filter(x).forEach(F),g.Event.filter(ne.onDidAddConnection,x)(F,void 0,j),ne.onDidRemoveConnection(U,void 0,j),q.event(W.fire,W,j),j.add(q)},onDidRemoveLastListener:()=>{j?.dispose(),j=void 0}});return W.event}registerChannel(z,x){this.a.set(z,x);for(const K of this.f)K.channelServer.registerChannel(z,x)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$gi=D;class N{constructor(z,x,K=null){const te=new l;o(te,x),z.send(te.buffer),this.a=new T(z,K),this.d=new $(z,x,K)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,x){this.d.registerChannel(z,x)}dispose(){this.a.dispose(),this.d.dispose()}}t.$hi=N;function M(B){return{call(z,x,K){return B.then(te=>te.call(z,x,K))},listen(z,x){const K=new g.$se;return B.then(te=>K.input=te.listen(z,x)),K.event}}}function Y(B){let z=!1;return{call(x,K,te){return z?B.call(x,K,te):(0,P.$Dh)(0).then(()=>z=!0).then(()=>B.call(x,K,te))},listen(x,K){if(z)return B.listen(x,K);const te=new g.$se;return(0,P.$Dh)(0).then(()=>z=!0).then(()=>te.input=B.listen(x,K)),te.event}}}class J{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const x of z.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await g.Event.toPromise(z.onDidAddConnection),await this.b(z)}}t.$ki=J;var re;(function(B){function z(ne,j,W){const q=ne,b=W&&W.disableMarshalling,F=new Map;for(const U in q)K(U)&&F.set(U,g.Event.buffer(q[U],!0,void 0,j));return new class{listen(U,C,G){const X=F.get(C);if(X)return X;const ee=q[C];if(typeof ee=="function"){if(te(C))return ee.call(q,G);if(K(C))return F.set(C,g.Event.buffer(q[C],!0,void 0,j)),F.get(C)}throw new k.$ab(`Event not found: ${C}`)}call(U,C,G){const X=q[C];if(typeof X=="function"){if(!b&&Array.isArray(G))for(let oe=0;oe<G.length;oe++)G[oe]=(0,f.$_h)(G[oe]);let ee=X.apply(q,G);return ee instanceof Promise||(ee=Promise.resolve(ee)),ee}throw new k.$ab(`Method not found: ${C}`)}}}B.fromService=z;function x(ne,j){const W=j&&j.disableMarshalling;return new Proxy({},{get(q,b){if(typeof b=="string")return j?.properties?.has(b)?j.properties.get(b):te(b)?function(F){return ne.listen(b,F)}:K(b)?ne.listen(b):async function(...F){let U;j&&!(0,h.$lg)(j.context)?U=[j.context,...F]:U=F;const C=await ne.call(b,U);return W?C:(0,f.$_h)(C)};throw new k.$ab(`Property not found: ${String(b)}`)}})}B.toService=x;function K(ne){return ne[0]==="o"&&ne[1]==="n"&&c.$Cf(ne.charCodeAt(2))}function te(ne){return/^onDynamic/.test(ne)&&c.$Cf(ne.charCodeAt(9))}})(re||(t.ProxyChannel=re={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const z=B.toString();if(z!=="[object Object]")return z}return B}function de(B){return Array.isArray(B)?B.map(ue):ue(B)}function H(B,z,x,K,te,ne,j){j=de(j);const W=ae[te],q=W[K%W.length];let b=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(ne)?(b=b.concat(j),b.push(")")):b.push(j),console.log.apply(console,b)}class Z{constructor(z,x){this.d=z,this.f=x,this.a=0,this.b=0}logOutgoing(z,x,K,te,ne){this.b+=z,H(this.d,this.b,z,x,K,te,ne)}logIncoming(z,x,K,te,ne){this.a+=z,H(this.f,this.a,z,x,K,te,ne)}}t.$li=Z}),define(ce[86],le([0,1,60,8,13,21,80,7,4,2,26,58,56,59]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fr=t.$er=void 0,k=ye(k);class v extends p.$ei{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",m=>w.$Le.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}t.$er=v;class O{constructor(d,m){this.i=d,this.j=m,this.c=new Set,this.g=new Map,this.h=new g.$je,this.onDidProcessExit=this.h.event;const R=m&&m.timeout?m.timeout:6e4;this.b=new P.$zh(R),this.d=null,this.f=null}getChannel(d){const m=this;return{call(R,y,i){return m.k(d,R,y,i)},listen(R,y){return m.l(d,R,y)}}}k(d,m,R,y=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(k.$5());this.b.cancel();const i=this.n(d),l=(0,P.$ph)(e=>i.call(m,R,e)),n=y.onCancellationRequested(()=>l.cancel()),r=(0,a.$Rc)(()=>l.cancel());return this.c.add(r),l.finally(()=>{n.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l(d,m,R){if(!this.b)return g.Event.None;this.b.cancel();let y;const i=new g.$je({onWillAddFirstListener:()=>{y=this.n(d).listen(m,R)(i.fire,i),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,f.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,h.$jm)(m.env),this.d=(0,S.fork)(this.i,d,m);const R=new g.$je,i=g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,L.$ar)(o)){(0,L.log)(o,`IPC Library: ${this.j.serverName}`);return}R.fire(w.$Le.wrap(Buffer.from(o,"base64")))}),l=this.j.useQueue?(0,c.$wm)(this.d):this.d,n=o=>this.d&&this.d.connected&&l.send(o.buffer.toString("base64")),r=R.event,e={send:n,onMessage:r};this.f=new p.$fi(e);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",s),i.dispose(),this.c.forEach($=>(0,a.$Oc)($)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(d){let m=this.g.get(d);return m||(m=this.m.getChannel(d),this.g.set(d,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}t.$fr=O}),define(ce[87],le([0,1,8,4,2,48,3]),function(Q,t,S,P,w,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cq=t.$bq=t.StorageState=t.StorageHint=void 0,t.$aq=g;var k;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(t.StorageHint=k={}));function g(h){const p=h;return p?.changed instanceof Map||p?.deleted instanceof Set}var a;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(a||(t.StorageState=a={}));class f extends w.$Tc{static{this.a=100}constructor(p,v=Object.create(null)){super(),this.r=p,this.s=v,this.b=this.B(new P.$me),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Ah(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((v,O)=>this.w(O,v)),p.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(p,v){if(this.c===a.Closed)return;let O=!1;(0,L.$lg)(v)?O=this.f.delete(p):this.f.get(p)!==v&&(this.f.set(p,v),O=!0),O&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,v){const O=this.f.get(p);return(0,L.$lg)(O)?v:O}getBoolean(p,v){const O=this.get(p);return(0,L.$lg)(O)?v:O==="true"}getNumber(p,v){const O=this.get(p);return(0,L.$lg)(O)?v:parseInt(O,10)}getObject(p,v){const O=this.get(p);return(0,L.$lg)(O)?v:(0,I.$$h)(O)}async set(p,v,O=!1){if(this.c===a.Closed)return;if((0,L.$lg)(v))return this.delete(p,O);const E=(0,L.$eg)(v)||Array.isArray(v)?(0,I.$0h)(v):String(v);if(this.f.get(p)!==E)return this.f.set(p,E),this.j.set(p,E),this.h.delete(p),this.b.fire({key:p,external:O}),this.D()}async delete(p,v=!1){if(!(this.c===a.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:v}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(!(this.c===a.Closed||this.m))return this.D(p)}async D(p){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}t.$bq=f;class c{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((v,O)=>this.a.set(O,v)),p.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}t.$cq=c}),define(ce[88],le([0,1,5]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ym=a,t.$Zm=f,t.$1m=c;const P=60,w=P*60,I=w*24,L=I*7,k=I*30,g=I*365;function a(h,p,v,O){typeof h!="number"&&(h=h.getTime());const E=Math.round((new Date().getTime()-h)/1e3);if(E<-30)return(0,S.localize)(12817,null,a(new Date().getTime()+E*1e3,!1));if(!O&&E<30)return(0,S.localize)(12818,null);let d;return E<P?(d=E,p?d===1?v?(0,S.localize)(12819,null,d):(0,S.localize)(12820,null,d):v?(0,S.localize)(12821,null,d):(0,S.localize)(12822,null,d):d===1?v?(0,S.localize)(12823,null,d):(0,S.localize)(12824,null,d):v?(0,S.localize)(12825,null,d):(0,S.localize)(12826,null,d)):E<w?(d=Math.floor(E/P),p?d===1?v?(0,S.localize)(12827,null,d):(0,S.localize)(12828,null,d):v?(0,S.localize)(12829,null,d):(0,S.localize)(12830,null,d):d===1?v?(0,S.localize)(12831,null,d):(0,S.localize)(12832,null,d):v?(0,S.localize)(12833,null,d):(0,S.localize)(12834,null,d)):E<I?(d=Math.floor(E/w),p?d===1?v?(0,S.localize)(12835,null,d):(0,S.localize)(12836,null,d):v?(0,S.localize)(12837,null,d):(0,S.localize)(12838,null,d):d===1?v?(0,S.localize)(12839,null,d):(0,S.localize)(12840,null,d):v?(0,S.localize)(12841,null,d):(0,S.localize)(12842,null,d)):E<L?(d=Math.floor(E/I),p?d===1?(0,S.localize)(12843,null,d):(0,S.localize)(12844,null,d):d===1?(0,S.localize)(12845,null,d):(0,S.localize)(12846,null,d)):E<k?(d=Math.floor(E/L),p?d===1?v?(0,S.localize)(12847,null,d):(0,S.localize)(12848,null,d):v?(0,S.localize)(12849,null,d):(0,S.localize)(12850,null,d):d===1?v?(0,S.localize)(12851,null,d):(0,S.localize)(12852,null,d):v?(0,S.localize)(12853,null,d):(0,S.localize)(12854,null,d)):E<g?(d=Math.floor(E/k),p?d===1?v?(0,S.localize)(12855,null,d):(0,S.localize)(12856,null,d):v?(0,S.localize)(12857,null,d):(0,S.localize)(12858,null,d):d===1?v?(0,S.localize)(12859,null,d):(0,S.localize)(12860,null,d):v?(0,S.localize)(12861,null,d):(0,S.localize)(12862,null,d)):(d=Math.floor(E/g),p?d===1?v?(0,S.localize)(12863,null,d):(0,S.localize)(12864,null,d):v?(0,S.localize)(12865,null,d):(0,S.localize)(12866,null,d):d===1?v?(0,S.localize)(12867,null,d):(0,S.localize)(12868,null,d):v?(0,S.localize)(12869,null,d):(0,S.localize)(12870,null,d))}function f(h,p){const v=Math.abs(h/1e3);return v<1?p?(0,S.localize)(12871,null,h):(0,S.localize)(12872,null,h):v<P?p?(0,S.localize)(12873,null,Math.round(h)/1e3):(0,S.localize)(12874,null,Math.round(h)/1e3):v<w?p?(0,S.localize)(12875,null,Math.round(h/(1e3*P))):(0,S.localize)(12876,null,Math.round(h/(1e3*P))):v<I?p?(0,S.localize)(12877,null,Math.round(h/(1e3*w))):(0,S.localize)(12878,null,Math.round(h/(1e3*w))):(0,S.localize)(12879,null,Math.round(h/(1e3*I)))}function c(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ce[38],le([0,1,19,3,5]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nj=g,t.$oj=a,t.$pj=f,S=ye(S),P=ye(P),w=ye(w);function I(c,h){return h&&(c.stack||c.stacktrace)?w.localize(12811,null,k(c),L(c.stack)||L(c.stacktrace)):k(c)}function L(c){return Array.isArray(c)?c.join(`
`):c}function k(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?w.localize(12812,null,c.message):c.message||w.localize(12813,null)}function g(c=null,h=!1){if(!c)return w.localize(12814,null);if(Array.isArray(c)){const p=S.$Gb(c),v=g(p[0],h);return p.length>1?w.localize(12815,null,v,p.length):v}if(P.$cg(c))return c;if(c.detail){const p=c.detail;if(p.error)return I(p.error,h);if(p.exception)return I(p.exception,h)}return c.stack?I(c,h):c.message?c.message:w.localize(12816,null)}function a(c){const h=c;return h instanceof Error&&Array.isArray(h.actions)}function f(c,h){let p;return typeof c=="string"?p=new Error(c):p=c,p.actions=h,p}}),define(ce[89],le([0,1,5,34]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Iq=w;function w(I){switch(I){case P.ParseErrorCode.InvalidSymbol:return(0,S.localize)(12802,null);case P.ParseErrorCode.InvalidNumberFormat:return(0,S.localize)(12803,null);case P.ParseErrorCode.PropertyNameExpected:return(0,S.localize)(12804,null);case P.ParseErrorCode.ValueExpected:return(0,S.localize)(12805,null);case P.ParseErrorCode.ColonExpected:return(0,S.localize)(12806,null);case P.ParseErrorCode.CommaExpected:return(0,S.localize)(12807,null);case P.ParseErrorCode.CloseBraceExpected:return(0,S.localize)(12808,null);case P.ParseErrorCode.CloseBracketExpected:return(0,S.localize)(12809,null);case P.ParseErrorCode.EndOfFileExpected:return(0,S.localize)(12810,null);default:return""}}}),define(ce[50],le([0,1,32,8,15,3,28,5]),function(Q,t,S,P,w,I,L,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yq=t.$xq=void 0,t.zip=E,t.$Aq=d,t.$Bq=R,w=ye(w),k=ye(k),t.$xq="end of central directory record signature not found";const g=new RegExp(t.$xq);class a extends Error{constructor(i,l){let n=l.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=l}}t.$yq=a;function f(y){const i=y.externalFileAttributes>>16||33188;return[448,56,7].map(l=>i&l).reduce((l,n)=>l+n,i&61440)}function c(y){if(y instanceof a)return y;let i;return g.test(y.message)&&(i="CorruptZip"),new a(i,y)}function h(y,i,l,n,r,e){const s=w.$lc(i),o=w.$ic(n,s);if(!o.startsWith(n))return Promise.reject(new Error(k.localize(12779,null,i)));const u=w.$ic(n,i);let $;return e.onCancellationRequested(()=>{$?.destroy()}),Promise.resolve(S.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((A,T)=>{if(!e.isCancellationRequested)try{$=(0,S.createWriteStream)(u,{mode:l}),$.once("close",()=>A()),$.once("error",T),y.once("error",T),y.pipe($)}catch(D){T(D)}}))}function p(y,i,l,n){let r=(0,P.$ph)(()=>Promise.resolve()),e=0;const s=n.onCancellationRequested(()=>{r.cancel(),y.close()});return new Promise((o,u)=>{const $=new P.$xh,A=T=>{T.isCancellationRequested||(e++,y.readEntry())};y.once("error",u),y.once("close",()=>r.then(()=>{n.isCancellationRequested||y.entryCount===e?o():u(new a("Incomplete",new Error(k.localize(12780,null,e,y.entryCount))))},u)),y.readEntry(),y.on("entry",T=>{if(n.isCancellationRequested)return;if(!l.sourcePathRegex.test(T.fileName)){A(n);return}const D=T.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(D)){const Y=w.$ic(i,D);r=(0,P.$ph)(J=>S.promises.mkdir(Y,{recursive:!0}).then(()=>A(J)).then(void 0,u));return}const N=O(y,T),M=f(T);r=(0,P.$ph)(Y=>$.queue(()=>N.then(J=>h(J,D,M,i,l,Y).then(()=>A(Y)))).then(null,u))})}).finally(()=>s.dispose())}async function v(y,i=!1){const{open:l}=await new Promise((n,r)=>{Q(["yauzl"],n,r)}).then(ye);return new Promise((n,r)=>{l(y,i?{lazyEntries:!0}:void 0,(e,s)=>{e?r(c(e)):n((0,I.$ng)(s))})})}function O(y,i){return new Promise((l,n)=>{y.openReadStream(i,(r,e)=>{r?n(c(r)):l((0,I.$ng)(e))})})}async function E(y,i){const{ZipFile:l}=await new Promise((n,r)=>{Q(["yazl"],n,r)}).then(ye);return new Promise((n,r)=>{const e=new l;i.forEach(o=>{o.contents?e.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&e.addFile(o.localPath,o.path)}),e.end();const s=(0,S.createWriteStream)(y);e.outputStream.pipe(s),e.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(y))})}function d(y,i,l={},n){const r=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let e=v(y,!0);return l.overwrite&&(e=e.then(s=>L.Promises.rm(i).then(()=>s))),e.then(s=>p(s,i,{sourcePathRegex:r},n))}function m(y,i){return v(y).then(l=>new Promise((n,r)=>{l.on("entry",e=>{e.fileName===i&&O(l,e).then(s=>n(s),s=>r(s))}),l.once("close",()=>r(new Error(k.localize(12781,null,i))))}))}function R(y,i){return m(y,i).then(l=>new Promise((n,r)=>{const e=[];l.once("error",r),l.on("data",s=>e.push(s)),l.on("end",()=>n(Buffer.concat(e)))}))}}),define(ce[90],le([0,1,91,7,5]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xj=t.TokenType=void 0;var I;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(I||(t.TokenType=I={}));function L(...f){switch(f.length){case 1:return(0,w.localize)(11418,null,f[0]);case 2:return(0,w.localize)(11419,null,f[0],f[1]);case 3:return(0,w.localize)(11420,null,f[0],f[1],f[2]);default:return}}const k=(0,w.localize)(11421,null),g=(0,w.localize)(11422,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case I.LParen:return"(";case I.RParen:return")";case I.Neg:return"!";case I.Eq:return c.isTripleEq?"===":"==";case I.NotEq:return c.isTripleEq?"!==":"!=";case I.Lt:return"<";case I.LtEq:return"<=";case I.Gt:return">=";case I.GtEq:return">=";case I.RegexOp:return"=~";case I.RegexStr:return c.lexeme;case I.True:return"true";case I.False:return"false";case I.In:return"in";case I.Not:return"not";case I.And:return"&&";case I.Or:return"||";case I.Str:return c.lexeme;case I.QuotedStr:return c.lexeme;case I.Error:return c.lexeme;case I.EOF:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this.b=new Map([["not",I.Not],["in",I.In],["false",I.False],["true",I.True]])}get errors(){return this.g}reset(c){return this.c=c,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case S.CharCode.OpenParen:this.k(I.LParen);break;case S.CharCode.CloseParen:this.k(I.RParen);break;case S.CharCode.ExclamationMark:if(this.h(S.CharCode.Equals)){const h=this.h(S.CharCode.Equals);this.f.push({type:I.NotEq,offset:this.d,isTripleEq:h})}else this.k(I.Neg);break;case S.CharCode.SingleQuote:this.o();break;case S.CharCode.Slash:this.q();break;case S.CharCode.Equals:if(this.h(S.CharCode.Equals)){const h=this.h(S.CharCode.Equals);this.f.push({type:I.Eq,offset:this.d,isTripleEq:h})}else this.h(S.CharCode.Tilde)?this.k(I.RegexOp):this.l(L("==","=~"));break;case S.CharCode.LessThan:this.k(this.h(S.CharCode.Equals)?I.LtEq:I.Lt);break;case S.CharCode.GreaterThan:this.k(this.h(S.CharCode.Equals)?I.GtEq:I.Gt);break;case S.CharCode.Ampersand:this.h(S.CharCode.Ampersand)?this.k(I.And):this.l(L("&&"));break;case S.CharCode.Pipe:this.h(S.CharCode.Pipe)?this.k(I.Or):this.l(L("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(I.EOF),Array.from(this.f)}h(c){return this.r()||this.c.charCodeAt(this.e)!==c?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?S.CharCode.Null:this.c.charCodeAt(this.e)}k(c){this.f.push({type:c,offset:this.d})}l(c){const h=this.d,p=this.c.substring(this.d,this.e),v={type:I.Error,offset:this.d,lexeme:p};this.g.push({offset:h,lexeme:p,additionalInfo:c}),this.f.push(v)}n(){this.m.lastIndex=this.d;const c=this.m.exec(this.c);if(c){this.e=this.d+c[0].length;const h=this.c.substring(this.d,this.e),p=a.b.get(h);p?this.k(p):this.f.push({type:I.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==S.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(k);return}this.i(),this.f.push({type:I.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let c=this.e,h=!1,p=!1;for(;;){if(c>=this.c.length){this.e=c,this.l(g);return}const O=this.c.charCodeAt(c);if(h)h=!1;else if(O===S.CharCode.Slash&&!p){c++;break}else O===S.CharCode.OpenSquareBracket?p=!0:O===S.CharCode.Backslash?h=!0:O===S.CharCode.CloseSquareBracket&&(p=!1);c++}for(;c<this.c.length&&a.a.has(this.c.charCodeAt(c));)c++;this.e=c;const v=this.c.substring(this.d,this.e);this.f.push({type:I.RegexStr,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}t.$xj=a}),define(ce[92],le([0,1,88,55,14,15,36,16,11]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3m=t.$2m=void 0,t.$4m=f,t.$5m=c,t.$2m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,I.$lc)(w.$Wg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,I.$ic)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,k.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:w.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,S.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.$ic)(this.userDataPath,"logs",p)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$dh)(g.URI.file((0,I.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=L.env.VSCODE_PORTABLE;return p?g.URI.file((0,I.$ic)(p,"argv.json")):(0,k.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,I.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,I.$jc)(p):(0,I.$gc)((0,I.$ic)(w.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?g.URI.file((0,I.$jc)(p)):g.URI.file((0,I.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,I.$jc)(p);const v=L.env.VSCODE_EXTENSIONS;if(v)return v;const O=L.env.VSCODE_PORTABLE;return O?(0,I.$ic)(O,"extensions"):(0,k.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(v=>/^[^:/?#]+?:\/\//.test(v)?g.URI.parse(v):g.URI.file((0,I.$gc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,I.$gc)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!t.$2m.test(p))}get extensionLogLevel(){const p=[];for(const v of this.args.log||[]){const O=t.$2m.exec(v);O&&O[1]&&O[2]&&p.push([O[1],O[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,k.$dh)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=L.env.VSCODE_PORTABLE;return p?g.URI.file((0,I.$ic)(p,"policy.json")):(0,k.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,v,O){this.a=p,this.b=v,this.c=O,this.editSessionId=this.args.editSessionId}}t.$3m=a,ve([P.$7h],a.prototype,"appRoot",null),ve([P.$7h],a.prototype,"userHome",null),ve([P.$7h],a.prototype,"userDataPath",null),ve([P.$7h],a.prototype,"appSettingsHome",null),ve([P.$7h],a.prototype,"tmpDir",null),ve([P.$7h],a.prototype,"cacheHome",null),ve([P.$7h],a.prototype,"stateResource",null),ve([P.$7h],a.prototype,"userRoamingDataHome",null),ve([P.$7h],a.prototype,"userDataSyncHome",null),ve([P.$7h],a.prototype,"sync",null),ve([P.$7h],a.prototype,"machineSettingsResource",null),ve([P.$7h],a.prototype,"workspaceStorageHome",null),ve([P.$7h],a.prototype,"localHistoryHome",null),ve([P.$7h],a.prototype,"keyboardLayoutResource",null),ve([P.$7h],a.prototype,"argvResource",null),ve([P.$7h],a.prototype,"isExtensionDevelopment",null),ve([P.$7h],a.prototype,"untitledWorkspacesHome",null),ve([P.$7h],a.prototype,"builtinExtensionsPath",null),ve([P.$7h],a.prototype,"extensionsPath",null),ve([P.$7h],a.prototype,"extensionDevelopmentLocationURI",null),ve([P.$7h],a.prototype,"extensionDevelopmentKind",null),ve([P.$7h],a.prototype,"extensionTestsLocationURI",null),ve([P.$7h],a.prototype,"debugExtensionHost",null),ve([P.$7h],a.prototype,"logLevel",null),ve([P.$7h],a.prototype,"extensionLogLevel",null),ve([P.$7h],a.prototype,"serviceMachineIdResource",null),ve([P.$7h],a.prototype,"disableTelemetry",null),ve([P.$7h],a.prototype,"disableWorkspaceTrust",null),ve([P.$7h],a.prototype,"useInMemorySecretStorage",null),ve([P.$7h],a.prototype,"policyFile",null);function f(h,p){return c(h["inspect-extensions"],h["inspect-brk-extensions"],5870,p,h.debugId,h.extensionEnvironment)}function c(h,p,v,O,E,d){const R=Number(p||h)||(O?null:v),y=R?!!p:!1;let i;if(d)try{i=JSON.parse(d)}catch{}return{port:R,break:y,debugId:E,env:i}}}),function(){"use strict";function Q(t,S,P){function w(L,k){const g=I(L,k),a=[g];return t.isAbsolute(g)||a.unshift(P),t.resolve(...a)}function I(L,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return t.join(g,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return t.join(a,k);const f=L["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=t.join(c,"AppData","Roaming")}break;case"darwin":a=t.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||t.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(a,k)}return{getUserDataPath:w}}if(typeof define=="function")define(ce[93],le([147,35,36]),function(t,S,P){return Q(t,S,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("path"),S=require("os");module.exports=Q(t,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[94],le([0,1,35,92,93]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6m=void 0,t.$7m=L,t.$8m=k;class I extends P.$3m{constructor(a,f){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,w.getUserDataPath)(a,f.nameShort)},f)}}t.$6m=I;function L(g,a){return(0,P.$5m)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,a,g.extensionEnvironment)}function k(g,a){return(0,P.$5m)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,a,g.extensionEnvironment)}}),define(ce[95],le([0,1,3,5]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jq=w;function w(L,k,g,a){try{I(L,k,g,a)}catch(f){L.error(f?.message??f)}return k}function I(L,k,g,a){const f=(c,h,p)=>{const v=c[h];if((0,S.$cg)(v)){const O=v,E=O.length;if(E>1&&O[0]==="%"&&O[E-1]==="%"){const d=O.substr(1,E-2);let m=g[d];m===void 0&&a&&(m=a[d]);const R=typeof m=="string"?m:m?.message,y=a?.[d],i=typeof y=="string"?y:y?.message;if(!R){i||L.warn(`[${k.name}]: ${(0,P.localize)(11301,null,d)}`);return}if(p&&(h==="title"||h==="category")&&i&&i!==R){const l={value:R,original:i};c[h]=l}else c[h]=R}}else if((0,S.$eg)(v))for(const O in v)v.hasOwnProperty(O)&&(O==="commands"?f(v,O,!0):f(v,O,p));else if(Array.isArray(v))for(let O=0;O<v.length;O++)f(v,O,p)};for(const c in k)k.hasOwnProperty(c)&&f(k,c)}}),define(ce[96],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};t.allApiProposals=Object.freeze(S)}),define(ce[51],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zi=void 0;class S{constructor(w,I=[],L=!1){this.ctor=w,this.staticArguments=I,this.supportsDelayedInstantiation=L}}t.$zi=S}),define(ce[97],le([0,1,51]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationType=void 0,t.$Os=I,t.$Ps=L;const P=[];var w;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(w||(t.InstantiationType=w={}));function I(k,g,a){g instanceof S.$zi||(g=new S.$zi(g,[],!!a)),P.push([k,g])}function L(){return P}}),define(ce[98],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sr=t.$rr=void 0;class S{constructor(I,L){this.key=I,this.data=L,this.incoming=new Map,this.outgoing=new Map}}t.$rr=S;class P{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const L of this.a.values())L.outgoing.size===0&&I.push(L);return I}insertEdge(I,L){const k=this.lookupOrInsertNode(I),g=this.lookupOrInsertNode(L);k.outgoing.set(g.key,g),g.incoming.set(k.key,k)}removeNode(I){const L=this.b(I);this.a.delete(L);for(const k of this.a.values())k.outgoing.delete(L),k.incoming.delete(L)}lookupOrInsertNode(I){const L=this.b(I);let k=this.a.get(L);return k||(k=new S(L,I),this.a.set(L,k)),k}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[L,k]of this.a)I.push(`${L}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,L]of this.a){const k=new Set([I]),g=this.c(L,k);if(g)return g}}c(I,L){for(const[k,g]of I.outgoing){if(L.has(k))return[...L,k].join(" -> ");L.add(k);const a=this.c(g,L);if(a)return a;L.delete(k)}}}t.$sr=P}),define(ce[29],le([0,1,3,11,10]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationTarget=t.$9i=void 0,t.$0i=I,t.$$i=L,t.$_i=g,t.$aj=a,t.$bj=f,t.$cj=c,t.$dj=h,t.$ej=v,t.$fj=O,t.$gj=E,S=ye(S),t.$9i=(0,w.$Ci)("configurationService");function I(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof P.URI)}function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof P.URI)}var k;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(k||(t.ConfigurationTarget=k={}));function g(d){switch(d){case k.APPLICATION:return"APPLICATION";case k.USER:return"USER";case k.USER_LOCAL:return"USER_LOCAL";case k.USER_REMOTE:return"USER_REMOTE";case k.WORKSPACE:return"WORKSPACE";case k.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case k.DEFAULT:return"DEFAULT";case k.MEMORY:return"MEMORY"}}function a(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function f(d,m){const R=Object.create(null);for(const y in d)c(R,y,d[y],m);return R}function c(d,m,R,y){const i=m.split("."),l=i.pop();let n=d;for(let r=0;r<i.length;r++){const e=i[r];let s=n[e];switch(typeof s){case"undefined":s=n[e]=Object.create(null);break;case"object":if(s===null){y(`Ignoring ${m} as ${i.slice(0,r+1).join(".")} is null`);return}break;default:y(`Ignoring ${m} as ${i.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[l]=R}catch{y(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(n)}`)}else y(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(n)}`)}function h(d,m){const R=m.split(".");p(d,R)}function p(d,m){const R=m.shift();if(m.length===0){delete d[R];return}if(Object.keys(d).indexOf(R)!==-1){const y=d[R];typeof y=="object"&&!Array.isArray(y)&&(p(y,m),Object.keys(y).length===0&&delete d[R])}}function v(d,m,R){function y(n,r){let e=n;for(const s of r){if(typeof e!="object"||e===null)return;e=e[s]}return e}const i=m.split("."),l=y(d,i);return typeof l>"u"?R:l}function O(d,m,R){Object.keys(m).forEach(y=>{y!=="__proto__"&&(y in d?S.$eg(d[y])&&S.$eg(m[y])?O(d[y],m[y],R):R&&(d[y]=m[y]):d[y]=m[y])})}function E(d){return d.replace(/[\[\]]/g,"")}}),define(ce[99],le([0,1,91,12,31,90,10,5,7]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=t.$Tj=t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Aj=t.$zj=t.ContextKeyExprType=void 0,t.$yj=f,t.$Bj=r,t.$Cj=e,t.$Vj=ne;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",P.$k),a.set("isLinux",P.$l),a.set("isWindows",P.$j),a.set("isWeb",P.$p),a.set("isMacNative",P.$k&&!P.$p),a.set("isEdge",P.$I),a.set("isFirefox",P.$G),a.set("isChrome",P.$F),a.set("isSafari",P.$H);function f(q,b){if(a.get(q)!==void 0)throw(0,g.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(q,b)}const c=Object.prototype.hasOwnProperty;var h;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(h||(t.ContextKeyExprType=h={}));const p={regexParsingWithErrorRecovery:!0},v=(0,k.localize)(11432,null),O=(0,k.localize)(11433,null),E=(0,k.localize)(11434,null),d=(0,k.localize)(11435,null),m=(0,k.localize)(11436,null),R=(0,k.localize)(11437,null),y=(0,k.localize)(11438,null),i=(0,k.localize)(11439,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(b=p){this.k=b,this.d=new I.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(b){if(b===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:O});return}this.f=this.d.reset(b).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const U=this.D(),C=U.type===I.TokenType.Str?R:void 0;throw this.h.push({message:m,offset:U.offset,lexeme:I.$xj.getLexeme(U),additionalInfo:C}),l.c}return F}catch(F){if(F!==l.c)throw F;return}}l(){return this.m()}m(){const b=[this.o()];for(;this.y(I.TokenType.Or);){const F=this.o();b.push(F)}return b.length===1?b[0]:n.or(...b)}o(){const b=[this.s()];for(;this.y(I.TokenType.And);){const F=this.s();b.push(F)}return b.length===1?b[0]:n.and(...b)}s(){if(this.y(I.TokenType.Neg)){const b=this.D();switch(b.type){case I.TokenType.True:return this.z(),o.INSTANCE;case I.TokenType.False:return this.z(),u.INSTANCE;case I.TokenType.LParen:{this.z();const F=this.l();return this.A(I.TokenType.RParen,d),F?.negate()}case I.TokenType.Str:return this.z(),M.create(b.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",b)}}return this.t()}t(){const b=this.D();switch(b.type){case I.TokenType.True:return this.z(),n.true();case I.TokenType.False:return this.z(),n.false();case I.TokenType.LParen:{this.z();const F=this.l();return this.A(I.TokenType.RParen,d),F}case I.TokenType.Str:{const F=b.lexeme;if(this.z(),this.y(I.TokenType.RegexOp)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==I.TokenType.RegexStr)throw this.B("REGEX",C);const G=C.lexeme,X=G.lastIndexOf("/"),ee=X===G.length-1?void 0:this.w(G.substring(X+1));let oe;try{oe=new RegExp(G.substring(1,X),ee)}catch{throw this.B("REGEX",C)}return de.create(F,oe)}switch(C.type){case I.TokenType.RegexStr:case I.TokenType.Error:{const G=[C.lexeme];this.z();let X=this.D(),ee=0;for(let we=0;we<C.lexeme.length;we++)C.lexeme.charCodeAt(we)===S.CharCode.OpenParen?ee++:C.lexeme.charCodeAt(we)===S.CharCode.CloseParen&&ee--;for(;!this.E()&&X.type!==I.TokenType.And&&X.type!==I.TokenType.Or;){switch(X.type){case I.TokenType.LParen:ee++;break;case I.TokenType.RParen:ee--;break;case I.TokenType.RegexStr:case I.TokenType.QuotedStr:for(let we=0;we<X.lexeme.length;we++)X.lexeme.charCodeAt(we)===S.CharCode.OpenParen?ee++:C.lexeme.charCodeAt(we)===S.CharCode.CloseParen&&ee--}if(ee<0)break;G.push(I.$xj.getLexeme(X)),this.z(),X=this.D()}const oe=G.join(""),fe=oe.lastIndexOf("/"),me=fe===oe.length-1?void 0:this.w(oe.substring(fe+1));let ge;try{ge=new RegExp(oe.substring(1,fe),me)}catch{throw this.B("REGEX",C)}return n.regex(F,ge)}case I.TokenType.QuotedStr:{const G=C.lexeme;this.z();let X=null;if(!(0,w.$af)(G)){const ee=G.indexOf("/"),oe=G.lastIndexOf("/");if(ee!==oe&&ee>=0){const fe=G.slice(ee+1,oe),me=G[oe+1]==="i"?"i":"";try{X=new RegExp(fe,me)}catch{throw this.B("REGEX",C)}}}if(X===null)throw this.B("REGEX",C);return de.create(F,X)}default:throw this.B("REGEX",this.D())}}if(this.y(I.TokenType.Not)){this.A(I.TokenType.In,E);const C=this.u();return n.notIn(F,C)}switch(this.D().type){case I.TokenType.Eq:{this.z();const C=this.u();if(this.x().type===I.TokenType.QuotedStr)return n.equals(F,C);switch(C){case"true":return n.has(F);case"false":return n.not(F);default:return n.equals(F,C)}}case I.TokenType.NotEq:{this.z();const C=this.u();if(this.x().type===I.TokenType.QuotedStr)return n.notEquals(F,C);switch(C){case"true":return n.not(F);case"false":return n.has(F);default:return n.notEquals(F,C)}}case I.TokenType.Lt:return this.z(),ae.create(F,this.u());case I.TokenType.LtEq:return this.z(),ue.create(F,this.u());case I.TokenType.Gt:return this.z(),J.create(F,this.u());case I.TokenType.GtEq:return this.z(),re.create(F,this.u());case I.TokenType.In:return this.z(),n.in(F,this.u());default:return n.has(F)}}case I.TokenType.EOF:throw this.h.push({message:y,offset:b.offset,lexeme:"",additionalInfo:i}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const b=this.D();switch(b.type){case I.TokenType.Str:case I.TokenType.QuotedStr:return this.z(),b.lexeme;case I.TokenType.True:return this.z(),"true";case I.TokenType.False:return this.z(),"false";case I.TokenType.In:return this.z(),"in";default:return""}}w(b){return b.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(b){return this.C(b)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(b,F){if(this.C(b))return this.z();throw this.B(F,this.D())}B(b,F,U){const C=(0,k.localize)(11440,null,b,I.$xj.getLexeme(F)),G=F.offset,X=I.$xj.getLexeme(F);return this.h.push({message:C,offset:G,lexeme:X,additionalInfo:U}),l.c}C(b){return this.D().type===b}D(){return this.f[this.g]}E(){return this.D().type===I.TokenType.EOF}}t.$zj=l;class n{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(b){return $.create(b)}static equals(b,F){return A.create(b,F)}static notEquals(b,F){return N.create(b,F)}static regex(b,F){return de.create(b,F)}static in(b,F){return T.create(b,F)}static notIn(b,F){return D.create(b,F)}static not(b){return M.create(b)}static and(...b){return B.create(b,null,!0)}static or(...b){return z.create(b,null,!0)}static greater(b,F){return J.create(b,F)}static greaterEquals(b,F){return re.create(b,F)}static smaller(b,F){return ae.create(b,F)}static smallerEquals(b,F){return ue.create(b,F)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(b){return b==null?void 0:this.c.parse(b)}}t.$Aj=n;function r(q){const b=new l({regexParsingWithErrorRecovery:!1});return q.map(F=>(b.parse(F),b.lexingErrors.length>0?b.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,k.localize)(11441,null,U.additionalInfo):(0,k.localize)(11442,null),offset:U.offset,length:U.lexeme.length})):b.parsingErrors.length>0?b.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}function e(q,b){const F=q?q.substituteConstants():void 0,U=b?b.substituteConstants():void 0;return!F&&!U?!0:!F||!U?!1:F.equals(U)}function s(q,b){return q.cmp(b)}class o{static{this.INSTANCE=new o}constructor(){this.type=h.False}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return u.INSTANCE}}t.$Dj=o;class u{static{this.INSTANCE=new u}constructor(){this.type=h.True}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return o.INSTANCE}}t.$Ej=u;class ${static create(b,F=null){const U=a.get(b);return typeof U=="boolean"?U?u.INSTANCE:o.INSTANCE:new $(b,F)}constructor(b,F){this.key=b,this.c=F,this.type=h.Defined}cmp(b){return b.type!==this.type?this.type-b.type:K(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=a.get(this.key);return typeof b=="boolean"?b?u.INSTANCE:o.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}t.$Fj=$;class A{static create(b,F,U=null){if(typeof F=="boolean")return F?$.create(b,U):M.create(b,U);const C=a.get(b);return typeof C=="boolean"?F===(C?"true":"false")?u.INSTANCE:o.INSTANCE:new A(b,F,U)}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.Equals}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=a.get(this.c);if(typeof b=="boolean"){const F=b?"true":"false";return this.d===F?u.INSTANCE:o.INSTANCE}return this}evaluate(b){return b.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(b){return b.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}t.$Gj=A;class T{static create(b,F){return new T(b,F)}constructor(b,F){this.d=b,this.f=F,this.type=h.In,this.c=null}cmp(b){return b.type!==this.type?this.type-b.type:te(this.d,this.f,b.d,b.f)}equals(b){return b.type===this.type?this.d===b.d&&this.f===b.f:!1}substituteConstants(){return this}evaluate(b){const F=b.getValue(this.f),U=b.getValue(this.d);return Array.isArray(F)?F.includes(U):typeof U=="string"&&typeof F=="object"&&F!==null?c.call(F,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(b){return b.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}t.$Hj=T;class D{static create(b,F){return new D(b,F)}constructor(b,F){this.d=b,this.f=F,this.type=h.NotIn,this.c=T.create(b,F)}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(b){return b.mapNotIn(this.d,this.f)}negate(){return this.c}}t.$Ij=D;class N{static create(b,F,U=null){if(typeof F=="boolean")return F?M.create(b,U):$.create(b,U);const C=a.get(b);return typeof C=="boolean"?F===(C?"true":"false")?o.INSTANCE:u.INSTANCE:new N(b,F,U)}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.NotEquals}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=a.get(this.c);if(typeof b=="boolean"){const F=b?"true":"false";return this.d===F?o.INSTANCE:u.INSTANCE}return this}evaluate(b){return b.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(b){return b.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}t.$Jj=N;class M{static create(b,F=null){const U=a.get(b);return typeof U=="boolean"?U?o.INSTANCE:u.INSTANCE:new M(b,F)}constructor(b,F){this.c=b,this.d=F,this.type=h.Not}cmp(b){return b.type!==this.type?this.type-b.type:K(this.c,b.c)}equals(b){return b.type===this.type?this.c===b.c:!1}substituteConstants(){const b=a.get(this.c);return typeof b=="boolean"?b?o.INSTANCE:u.INSTANCE:this}evaluate(b){return!b.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(b){return b.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}t.$Kj=M;function Y(q,b){if(typeof q=="string"){const F=parseFloat(q);isNaN(F)||(q=F)}return typeof q=="string"||typeof q=="number"?b(q):o.INSTANCE}class J{static create(b,F,U=null){return Y(F,C=>new J(b,C,U))}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.Greater}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}t.$Lj=J;class re{static create(b,F,U=null){return Y(F,C=>new re(b,C,U))}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.GreaterEquals}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}t.$Mj=re;class ae{static create(b,F,U=null){return Y(F,C=>new ae(b,C,U))}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.Smaller}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}t.$Nj=ae;class ue{static create(b,F,U=null){return Y(F,C=>new ue(b,C,U))}constructor(b,F,U){this.c=b,this.d=F,this.f=U,this.type=h.SmallerEquals}cmp(b){return b.type!==this.type?this.type-b.type:te(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}t.$Oj=ue;class de{static create(b,F){return new de(b,F)}constructor(b,F){this.d=b,this.f=F,this.type=h.Regex,this.c=null}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.d<b.d)return-1;if(this.d>b.d)return 1;const F=this.f?this.f.source:"",U=b.f?b.f.source:"";return F<U?-1:F>U?1:0}equals(b){if(b.type===this.type){const F=this.f?this.f.source:"",U=b.f?b.f.source:"";return this.d===b.d&&F===U}return!1}substituteConstants(){return this}evaluate(b){const F=b.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const b=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${b}`}keys(){return[this.d]}map(b){return b.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}t.$Pj=de;class H{static create(b){return new H(b)}constructor(b){this.c=b,this.type=h.NotRegex}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(b){return new H(this.c.map(b))}negate(){return this.c}}t.$Qj=H;function Z(q){let b=null;for(let F=0,U=q.length;F<U;F++){const C=q[F].substituteConstants();if(q[F]!==C&&b===null){b=[];for(let G=0;G<F;G++)b[G]=q[G]}b!==null&&(b[F]=C)}return b===null?q:b}class B{static create(b,F,U){return B.d(b,F,U)}constructor(b,F){this.expr=b,this.c=F,this.type=h.And}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const C=s(this.expr[F],b.expr[F]);if(C!==0)return C}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}substituteConstants(){const b=Z(this.expr);return b===this.expr?this:B.create(b,this.c,!1)}evaluate(b){for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].evaluate(b))return!1;return!0}static d(b,F,U){const C=[];let G=!1;for(const X of b)if(X){if(X.type===h.True){G=!0;continue}if(X.type===h.False)return o.INSTANCE;if(X.type===h.And){C.push(...X.expr);continue}C.push(X)}if(C.length===0&&G)return u.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(s);for(let X=1;X<C.length;X++)C[X-1].equals(C[X])&&(C.splice(X,1),X--);if(C.length===1)return C[0];for(;C.length>1;){const X=C[C.length-1];if(X.type!==h.Or)break;C.pop();const ee=C.pop(),oe=C.length===0,fe=z.create(X.expr.map(me=>B.create([me,ee],null,U)),null,oe);fe&&(C.push(fe),C.sort(s))}if(C.length===1)return C[0];if(U){for(let X=0;X<C.length;X++)for(let ee=X+1;ee<C.length;ee++)if(C[X].negate().equals(C[ee]))return o.INSTANCE;if(C.length===1)return C[0]}return new B(C,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(const F of this.expr)b.push(...F.keys());return b}map(b){return new B(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.c){const b=[];for(const F of this.expr)b.push(F.negate());this.c=z.create(b,this,!0)}return this.c}}t.$Rj=B;class z{static create(b,F,U){return z.d(b,F,U)}constructor(b,F){this.expr=b,this.c=F,this.type=h.Or}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let F=0,U=this.expr.length;F<U;F++){const C=s(this.expr[F],b.expr[F]);if(C!==0)return C}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let F=0,U=this.expr.length;F<U;F++)if(!this.expr[F].equals(b.expr[F]))return!1;return!0}return!1}substituteConstants(){const b=Z(this.expr);return b===this.expr?this:z.create(b,this.c,!1)}evaluate(b){for(let F=0,U=this.expr.length;F<U;F++)if(this.expr[F].evaluate(b))return!0;return!1}static d(b,F,U){let C=[],G=!1;if(b){for(let X=0,ee=b.length;X<ee;X++){const oe=b[X];if(oe){if(oe.type===h.False){G=!0;continue}if(oe.type===h.True)return u.INSTANCE;if(oe.type===h.Or){C=C.concat(oe.expr);continue}C.push(oe)}}if(C.length===0&&G)return o.INSTANCE;C.sort(s)}if(C.length!==0){if(C.length===1)return C[0];for(let X=1;X<C.length;X++)C[X-1].equals(C[X])&&(C.splice(X,1),X--);if(C.length===1)return C[0];if(U){for(let X=0;X<C.length;X++)for(let ee=X+1;ee<C.length;ee++)if(C[X].negate().equals(C[ee]))return u.INSTANCE;if(C.length===1)return C[0]}return new z(C,F)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(const F of this.expr)b.push(...F.keys());return b}map(b){return new z(this.expr.map(F=>F.map(b)),null)}negate(){if(!this.c){const b=[];for(const F of this.expr)b.push(F.negate());for(;b.length>1;){const F=b.shift(),U=b.shift(),C=[];for(const G of W(F))for(const X of W(U))C.push(B.create([G,X],null,!1));b.unshift(z.create(C,null,!1))}this.c=z.create(b,this,!0)}return this.c}}t.$Sj=z;class x extends ${static{this.d=[]}static all(){return x.d.values()}constructor(b,F,U){super(b,null),this.f=F,typeof U=="object"?x.d.push({...U,key:b}):U!==!0&&x.d.push({key:b,description:U,type:F!=null?typeof F:void 0})}bindTo(b){return b.createKey(this.key,this.f)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return A.create(this.key,b)}notEqualsTo(b){return N.create(this.key,b)}}t.$Tj=x,t.$Uj=(0,L.$Ci)("contextKeyService");function K(q,b){return q<b?-1:q>b?1:0}function te(q,b,F,U){return q<F?-1:q>F?1:b<U?-1:b>U?1:0}function ne(q,b){if(q.type===h.False||b.type===h.True)return!0;if(q.type===h.Or)return b.type===h.Or?j(q.expr,b.expr):!1;if(b.type===h.Or){for(const F of b.expr)if(ne(q,F))return!0;return!1}if(q.type===h.And){if(b.type===h.And)return j(b.expr,q.expr);for(const F of q.expr)if(ne(F,b))return!0;return!1}return q.equals(b)}function j(q,b){let F=0,U=0;for(;F<q.length&&U<b.length;){const C=q[F].cmp(b[U]);if(C<0)return!1;C===0&&F++,U++}return F===q.length}function W(q){return q.type===h.Or?q.expr:[q]}}),define(ce[61],le([0,1,10]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yo=void 0,t.$Yo=(0,S.$Ci)("downloadService")}),define(ce[17],le([0,1,10]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ki=t.$Ji=void 0,t.$Ji=(0,S.$Ci)("environmentService"),t.$Ki=(0,S.$Di)(t.$Ji)}),define(ce[62],le([0,1,13,7,5,9]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yq=L;async function L(f,c,h,p,v,O){let E;try{await k(f,c,h,p,v,O)}catch(d){E=d}finally{E&&v.errorTransformer&&(E=v.errorTransformer(E)),typeof E<"u"&&h.error(E),h.end()}}async function k(f,c,h,p,v,O){g(O);const E=await f.open(c,{create:!1});try{g(O);let d=0,m=0,R=v&&typeof v.length=="number"?v.length:void 0,y=S.$Le.alloc(Math.min(v.bufferSize,typeof R=="number"?R:v.bufferSize)),i=v&&typeof v.position=="number"?v.position:0,l=0;do m=await f.read(E,i,y.buffer,l,y.byteLength-l),i+=m,l+=m,d+=m,typeof R=="number"&&(R-=m),l===y.byteLength&&(await h.write(p(y)),y=S.$Le.alloc(Math.min(v.bufferSize,typeof R=="number"?R:v.bufferSize)),l=0);while(m>0&&(typeof R!="number"||R>0)&&g(O)&&a(d,v));if(l>0){let n=l;typeof R=="number"&&(n=Math.min(l,R)),h.write(p(y.slice(0,n)))}}catch(d){throw(0,I.$ll)(d)}finally{await f.close(E)}}function g(f){if(f.isCancellationRequested)throw(0,P.$5)();return!0}function a(f,c){if(typeof c?.limits?.size=="number"&&f>c.limits.size)throw(0,I.$kl)((0,w.localize)(11218,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[100],le([0,1,32,2,52,4,9,11,8]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hr=void 0;class a extends P.$Tc{constructor(){super(),this.a=this.B(new I.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new I.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new P.$3c),this.m=new Set,this.n=this.B(new g.$Ah(this.y())),this.r=5007,this.s=new g.$Zh,this.R=!1,this.B(this.f(c=>this.t(c)))}t(c){this.u(c)&&this.z(c)}u(c){return(0,w.$1q)(c)}async watch(c){this.s.isSettled||this.s.complete(),this.s=new g.$Zh;try{this.h.clear(),this.g.clear();for(const h of c)this.u(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.w(!1)}finally{this.s.complete()}}w(c){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))]),c?this.y():0)}y(){return 800}isSuspended(c){return typeof c.correlationId!="number"?!1:this.m.has(c.correlationId)?"polling":this.j.has(c.correlationId)}async z(c){if(this.j.has(c.correlationId))return;const h=new P.$Sc;this.j.set(c.correlationId,h),await this.s.p,!h.isDisposed&&(this.D(c,h),this.w(!0))}C(c){this.j.deleteAndDispose(c.correlationId),this.m.delete(c.correlationId),this.w(!1)}D(c,h){this.F(c,h)?(this.P(`reusing an existing recursive watcher to monitor ${c.path}`),this.m.delete(c.correlationId)):(this.G(c,h),this.m.add(c.correlationId))}F(c,h){const p=this.O?.subscribe(c.path,(v,O)=>{h.isDisposed||(v?this.D(c,h):O?.type===L.FileChangeType.ADDED&&this.H(c))});return p?(h.add(p),!0):!1}G(c,h){let p=!1;const v=(O,E)=>{if(h.isDisposed)return;const d=this.I(O),m=this.I(E),R=p;p=d,!d&&(m||R)&&this.H(c)};this.P(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.watchFile)(c.path,{persistent:!1,interval:this.r},v)}catch(O){this.Q(`fs.watchFile() failed with error ${O} on path ${c.path} (correlationId: ${c.correlationId})`)}h.add((0,P.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.unwatchFile)(c.path,v)}catch(O){this.Q(`fs.unwatchFile() failed with error ${O} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}H(c){this.P(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const h={resource:k.URI.file(c.path),type:L.FileChangeType.ADDED,cId:c.correlationId};this.a.fire([h]),this.J(h,c),this.C(c)}I(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(c,h){if(this.R){const p=` >> normalized ${c.type===L.FileChangeType.ADDED?"[ADDED]":c.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.L(p,h)}}L(c,h){this.R&&this.P(`${c}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}M(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,w.$$q)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.R=c}}t.$hr=a}),define(ce[101],le([0,1,4,148,100,12,149,63]),function(Q,t,S,P,w,I,L,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$or=void 0;class g extends w.$hr{constructor(f){super(),this.O=f,this.onDidError=S.Event.None,this.watchers=new Set}async N(f){f=this.Z(f);const c=[],h=new Set(Array.from(this.watchers));for(const p of f){const v=this.W(p);v&&(0,P.$Bk)(v.request.excludes,p.excludes)&&(0,P.$Bk)(v.request.includes,p.includes)?h.delete(v):c.push(p)}c.length&&this.P(`Request to start watching: ${c.map(p=>this.M(p)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(p=>this.M(p.request)).join(",")}`);for(const p of h)this.Y(p);for(const p of c)this.X(p)}W(f){for(const c of this.watchers)if(typeof f.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===f.correlationId)return c}else if((0,k.$Ag)(c.request.path,f.path,!I.$l))return c}X(f){const c=new L.$mr(f,this.O,p=>this.a.fire(p),()=>this.c.fire(f),p=>this.b.fire(p),this.R),h={request:f,instance:c};this.watchers.add(h)}async stop(){await super.stop();for(const f of this.watchers)this.Y(f)}Y(f){this.P("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}Z(f){const c=new Map;for(const h of f){const p=I.$l?h.path:h.path.toLowerCase();let v=c.get(h.correlationId);v||(v=new Map,c.set(h.correlationId,v)),v.has(p)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),v.set(p,h)}return Array.from(c.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const c of this.watchers)c.instance.setVerboseLogging(f)}P(f,c){this.R&&this.b.fire({type:"trace",message:this.bb(f,c)})}Q(f){this.b.fire({type:"warn",message:this.bb(f)})}bb(f,c){return c?`[File Watcher (node.js)] ${f} (${this.M(c.request)})`:`[File Watcher (node.js)] ${f}`}}t.$or=g}),define(ce[102],le([0,1,52,101]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pr=void 0;class w extends S.$4q{constructor(L,k,g){super(L,k,g),this.s()}r(L){return L.add(new P.$or(void 0))}}t.$pr=w}),define(ce[103],le([0,1,14,59,86,52]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gr=void 0;class L extends I.$5q{constructor(g,a,f){super(g,a,f),this.s()}r(g){const a=g.add(new w.$fr(S.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(a.onDidProcessExit(({code:f,signal:c})=>this.t(`terminated by itself with code ${f}, signal: ${c} (ETERM)`))),P.ProxyChannel.toService((0,P.$ji)(a.getChannel("watcher")))}}t.$gr=L}),define(ce[64],le([0,1]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ai=void 0;class S{constructor(...w){this.a=new Map;for(const[I,L]of w)this.set(I,L)}set(w,I){const L=this.a.get(w);return this.a.set(w,I),L}has(w){return this.a.has(w)}get(w){return this.a.get(w)}}t.$Ai=S}),define(ce[104],le([0,1,8,7,2,51,98,10,64,150]),function(Q,t,S,P,w,I,L,k,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ur=t.$tr=void 0;const f=!1;class c extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class h{constructor(E=new g.$Ai,d=!1,m,R=f){this.i=E,this.j=d,this.k=m,this.l=R,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$Bi,this),this._globalGraph=R?m?._globalGraph??new L.$sr(y=>y):void 0}dispose(){if(!this.f){this.f=!0,(0,w.$Oc)(this.h),this.h.clear();for(const E of this.g)(0,w.$Nc)(E)&&E.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(E,d){this.m();const m=this,R=new class extends h{dispose(){m.h.delete(R),super.dispose()}}(E,this.j,this,this.l);return this.h.add(R),d?.add(R),R}invokeFunction(E,...d){this.m();const m=v.traceInvocation(this.l,E);let R=!1;try{return E({get:i=>{if(R)throw(0,P.$7)("service accessor is only valid during the invocation of its target method");const l=this.s(i,m);if(!l)throw new Error(`[invokeFunction] unknown service '${i}'`);return l}},...d)}finally{R=!0,m.stop()}}createInstance(E,...d){this.m();let m,R;return E instanceof I.$zi?(m=v.traceCreation(this.l,E.ctor),R=this.o(E.ctor,E.staticArguments.concat(d),m)):(m=v.traceCreation(this.l,E),R=this.o(E,d,m)),m.stop(),R}o(E,d=[],m){const R=k._util.getServiceDependencies(E).sort((l,n)=>l.index-n.index),y=[];for(const l of R){const n=this.s(l.id,m);n||this.y(`[createInstance] ${E.name} depends on UNKNOWN service ${l.id}.`,!1),y.push(n)}const i=R.length>0?R[0].index:d.length;if(d.length!==i){console.trace(`[createInstance] First service dependency of ${E.name} at position ${i+1} conflicts with ${d.length} static arguments`);const l=i-d.length;l>0?d=d.concat(new Array(l)):d=d.slice(0,i)}return Reflect.construct(E,d.concat(y))}q(E,d){if(this.i.get(E)instanceof I.$zi)this.i.set(E,d);else if(this.k)this.k.q(E,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(E){const d=this.i.get(E);return!d&&this.k?this.k.r(E):d}s(E,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const m=this.r(E);return m instanceof I.$zi?this.u(E,m,d.branch(E,!0)):(d.branch(E,!1),m)}u(E,d,m){if(this.t.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.t.add(E);try{return this.v(E,d,m)}finally{this.t.delete(E)}}v(E,d,m){const R=new L.$sr(n=>n.id.toString());let y=0;const i=[{id:E,desc:d,_trace:m}],l=new Set;for(;i.length;){const n=i.pop();if(!l.has(String(n.id))){if(l.add(String(n.id)),R.lookupOrInsertNode(n),y++>1e3)throw new c(R);for(const r of k._util.getServiceDependencies(n.desc.ctor)){const e=this.r(r.id);if(e||this.y(`[createInstance] ${E} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),e instanceof I.$zi){const s={id:r.id,desc:e,_trace:n._trace.branch(r.id,!0)};R.insertEdge(n,s),i.push(s)}}}}for(;;){const n=R.roots();if(n.length===0){if(!R.isEmpty())throw new c(R);break}for(const{data:r}of n){if(this.r(r.id)instanceof I.$zi){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}R.removeNode(r)}}return this.r(E)}w(E,d,m=[],R,y){if(this.i.get(E)instanceof I.$zi)return this.x(E,d,m,R,y,this.g);if(this.k)return this.k.w(E,d,m,R,y);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(E,d,m=[],R,y,i){if(R){const l=new h(void 0,this.j,this,this.l);l.c=String(E);const n=new Map,r=new S.$Vh(()=>{const e=l.o(d,m,y);for(const[s,o]of n){const u=e[s];if(typeof u=="function")for(const $ of o)$.disposable=u.apply(e,$.listener)}return n.clear(),i.add(e),e});return new Proxy(Object.create(null),{get(e,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let $=n.get(s);return $||($=new a.$4c,n.set(s,$)),(T,D,N)=>{if(r.isInitialized)return r.value[s](T,D,N);{const M={listener:[T,D,N],disposable:void 0},Y=$.push(M);return(0,w.$Rc)(()=>{Y(),M.disposable?.dispose()})}}}if(s in e)return e[s];const o=r.value;let u=o[s];return typeof u!="function"||(u=u.bind(o),e[s]=u),u},set(e,s,o){return r.value[s]=o,!0},getPrototypeOf(e){return d.prototype}})}else{const l=this.o(d,m,y);return i.add(l),l}}y(E,d){if(d&&console.warn(E),this.j)throw new Error(E)}}t.$tr=h;var p;(function(O){O[O.None=0]="None",O[O.Creation=1]="Creation",O[O.Invocation=2]="Invocation",O[O.Branch=3]="Branch"})(p||(p={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(p.None,null)}stop(){}branch(){return this}}}static traceInvocation(E,d){return E?new v(p.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(E,d){return E?new v(p.Creation,d.name):v.c}static{this.f=0}constructor(E,d){this.type=E,this.name=d,this.g=Date.now(),this.h=[]}branch(E,d){const m=new v(p.Branch,E.toString());return this.h.push([E,d,m]),m}stop(){const E=Date.now()-this.g;v.f+=E;let d=!1;function m(y,i){const l=[],n=new Array(y+1).join("	");for(const[r,e,s]of i.h)if(e&&s){d=!0,l.push(`${n}CREATES -> ${r}`);const o=m(y+1,s);o&&l.push(o)}else l.push(`${n}uses -> ${r}`);return l.join(`
`)}const R=[`${this.type===p.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(E>2||d)&&v.all.add(R.join(`
`))}}t.$ur=v}),define(ce[6],le([0,1,5,38,4,43,2,30,12,16,3,11,99,10]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$ak=t.LogLevel=t.$$j=t.$0j=void 0,t.$_j=O,t.log=d,t.$lk=u,t.$mk=$,t.$nk=A,t.$ok=T,S=ye(S),t.$0j=(0,p.$Ci)("logService"),t.$$j=(0,p.$Ci)("loggerService");function v(){return new Date().toISOString()}function O(D){return(0,f.$gg)(D)}var E;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(E||(t.LogLevel=E={})),t.$ak=E.Info;function d(D,N,M){switch(N){case E.Trace:D.trace(M);break;case E.Debug:D.debug(M);break;case E.Info:D.info(M);break;case E.Warning:D.warn(M);break;case E.Error:D.error(M);break;case E.Off:break;default:throw new Error(`Invalid log level ${N}`)}}function m(D,N=!1){let M="";for(let Y=0;Y<D.length;Y++){let J=D[Y];if(J instanceof Error&&(J=(0,P.$nj)(J,N)),typeof J=="object")try{J=JSON.stringify(J)}catch{}M+=(Y>0?" ":"")+J}return M}class R extends L.$Tc{constructor(){super(...arguments),this.b=t.$ak,this.c=this.B(new w.$je),this.onDidChangeLogLevel=this.c.event}setLevel(N){this.b!==N&&(this.b=N,this.c.fire(this.b))}getLevel(){return this.b}f(N){return this.b!==E.Off&&this.b<=N}}t.$ck=R;class y extends R{constructor(N){super(),this.h=N}f(N){return this.h||super.f(N)}trace(N,...M){this.f(E.Trace)&&this.g(E.Trace,m([N,...M],!0))}debug(N,...M){this.f(E.Debug)&&this.g(E.Debug,m([N,...M]))}info(N,...M){this.f(E.Info)&&this.g(E.Info,m([N,...M]))}warn(N,...M){this.f(E.Warning)&&this.g(E.Warning,m([N,...M]))}error(N,...M){if(this.f(E.Error))if(N instanceof Error){const Y=Array.prototype.slice.call(arguments);Y[0]=N.stack,this.g(E.Error,m(Y))}else this.g(E.Error,m([N,...M]))}flush(){}}t.$dk=y;class i extends R{constructor(N=t.$ak){super(),this.setLevel(N),this.g=!g.$j}trace(N,...M){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,N,...M):console.log(`[main ${v()}]`,N,...M))}debug(N,...M){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,N,...M):console.log(`[main ${v()}]`,N,...M))}info(N,...M){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,N,...M):console.log(`[main ${v()}]`,N,...M))}warn(N,...M){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,N,...M):console.warn(`[main ${v()}]`,N,...M))}error(N,...M){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,N,...M):console.error(`[main ${v()}]`,N,...M))}flush(){}}t.$ek=i;class l extends R{constructor(N=t.$ak,M=!0){super(),this.g=M,this.setLevel(N)}trace(N,...M){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",N,...M):console.log(N,...M))}debug(N,...M){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",N,...M):console.log(N,...M))}info(N,...M){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",N,...M):console.log(N,...M))}warn(N,...M){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",N,...M):console.log(N,...M))}error(N,...M){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",N,...M):console.error(N,...M))}flush(){}}t.$fk=l;class n extends R{constructor(N,M=t.$ak){super(),this.g=N,this.setLevel(M)}trace(N,...M){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(N),...M])}debug(N,...M){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(N),...M])}info(N,...M){this.f(E.Info)&&this.g.log(E.Info,[this.h(N),...M])}warn(N,...M){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(N),...M])}error(N,...M){this.f(E.Error)&&this.g.log(E.Error,[this.h(N),...M])}h(N){return typeof N=="string"?N:(0,P.$nj)(N,this.f(E.Trace))}flush(){}}t.$gk=n;class r extends R{constructor(N){super(),this.g=N,N.length&&this.setLevel(N[0].getLevel())}setLevel(N){for(const M of this.g)M.setLevel(N);super.setLevel(N)}trace(N,...M){for(const Y of this.g)Y.trace(N,...M)}debug(N,...M){for(const Y of this.g)Y.debug(N,...M)}info(N,...M){for(const Y of this.g)Y.info(N,...M)}warn(N,...M){for(const Y of this.g)Y.warn(N,...M)}error(N,...M){for(const Y of this.g)Y.error(N,...M)}flush(){for(const N of this.g)N.flush()}dispose(){for(const N of this.g)N.dispose();super.dispose()}}t.$hk=r;class e extends L.$Tc{constructor(N,M,Y){if(super(),this.h=N,this.j=M,this.b=new k.$zc,this.c=this.B(new w.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new w.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new w.$je),this.onDidChangeVisibility=this.g.event,Y)for(const J of Y)this.b.set(J.resource,{logger:void 0,info:J})}m(N){return(0,f.$cg)(N)?[...this.b.values()].find(M=>M.info.id===N):this.b.get(N)}getLogger(N){return this.m(N)?.logger}createLogger(N,M){const Y=this.n(N),J=(0,f.$cg)(N)?N:M?.id??(0,I.$qj)(Y.toString()).toString(16);let re=this.b.get(Y)?.logger;const ae=M?.logLevel==="always"?E.Trace:M?.logLevel;re||(re=this.s(Y,ae??this.getLogLevel(Y)??this.h,{...M,id:J}));const ue={logger:re,info:{resource:Y,id:J,logLevel:ae,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ue.info),this.b.set(Y,ue),re}n(N){return(0,f.$cg)(N)?(0,a.$dh)(this.j,`${N}.log`):N}setLogLevel(N,M){if(c.URI.isUri(N)){const Y=N,J=M,re=this.b.get(Y);re&&J!==re.info.logLevel&&(re.info.logLevel=J===this.h?void 0:J,re.logger?.setLevel(J),this.b.set(re.info.resource,re),this.f.fire([Y,J]))}else{this.h=N;for(const[Y,J]of this.b.entries())this.b.get(Y)?.info.logLevel===void 0&&J.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(N,M){const Y=this.m(N);Y&&M!==!Y.info.hidden&&(Y.info.hidden=!M,this.b.set(Y.info.resource,Y),this.g.fire([Y.info.resource,M]))}getLogLevel(N){let M;return N&&(M=this.b.get(N)?.info.logLevel),M??this.h}registerLogger(N){const M=this.b.get(N.resource);M?M.info.hidden!==N.hidden&&this.setVisibility(N.resource,!N.hidden):(this.b.set(N.resource,{info:N,logger:void 0}),this.c.fire({added:[N],removed:[]}))}deregisterLogger(N){const M=this.b.get(N);M&&(M.logger&&M.logger.dispose(),this.b.delete(N),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const N of this.b.values())yield N.info}getRegisteredLogger(N){return this.b.get(N)?.info}dispose(){this.b.forEach(N=>N.logger?.dispose()),this.b.clear(),super.dispose()}}t.$ik=e;class s{constructor(){this.onDidChangeLogLevel=new w.$je().event}setLevel(N){}getLevel(){return E.Info}trace(N,...M){}debug(N,...M){}info(N,...M){}warn(N,...M){}error(N,...M){}critical(N,...M){}dispose(){}flush(){}}t.$jk=s;class o extends s{}t.$kk=o;function u(D){if(D.verbose)return E.Trace;if(typeof D.logLevel=="string"){const N=T(D.logLevel.toLowerCase());if(N!==void 0)return N}return t.$ak}function $(D){switch(D){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}function A(D){switch(D){case E.Trace:return{original:"Trace",value:S.localize(11152,null)};case E.Debug:return{original:"Debug",value:S.localize(11153,null)};case E.Info:return{original:"Info",value:S.localize(11154,null)};case E.Warning:return{original:"Warning",value:S.localize(11155,null)};case E.Error:return{original:"Error",value:S.localize(11156,null)};case E.Off:return{original:"Off",value:S.localize(11157,null)}}}function T(D){switch(D){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}t.$pk=new h.$Tj("logLevel",$(E.Info))}),define(ce[105],le([0,1,19,8,7,4,63,2,15,52,6]),function(Q,t,S,P,w,I,L,k,g,a,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_q=void 0;class c extends k.$Tc{constructor(p,v){super(),this.a=p,this.b=v,this.c=this.B(new I.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new P.$Ah(0)),this.w=[],this.y=this.B(new P.$Ah(0))}watch(p,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(p,v):this.z(p,v)}n(p,v){const O={path:this.J(p),excludes:v.excludes,includes:v.includes,recursive:v.recursive,filter:v.filter,correlationId:v.correlationId},E=(0,S.$Sb)(this.j,O);return this.r(),(0,k.$Rc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,w.$Y)(p))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,a.$6q)(v)),v=>this.G(v),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const v of this.j)(0,a.$2q)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const v of this.j)(0,a.$2q)(v)&&p.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,v){const O={path:this.J(p),excludes:v.excludes,includes:v.includes,recursive:!1,filter:v.filter,correlationId:v.correlationId},E=(0,S.$Sb)(this.w,O);return this.C(),(0,k.$Rc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,w.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,a.$6q)(p)),p=>this.G(p),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.H(p)}H(p){this.a[p.type](p.message)}I(p){return(0,g.$gc)(p.fsPath)}J(p){const v=this.I(p);return(0,L.$Eg)(v)}}t.$_q=c});var se=this&&this.__param||function(Q,t){return function(S,P){t(S,P,Q)}};define(ce[106],le([0,1,19,8,13,21,4,43,65,2,49,14,107,16,47,5,9,62,6,7]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m,R){"use strict";var y;Object.defineProperty(t,"__esModule",{value:!0}),t.$Zq=void 0;let i=class extends a.$Tc{static{y=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new L.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$je),this.Y=this.B(new L.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new L.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new P.$Lh)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${n}`);const e=new a.$Sc;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),e.add(r.onDidChangeFile(s=>{const o=new E.$ql(s,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&e.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),e.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,a.$Oc)(e)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(e){r.push(e)}}),!this.h.has(n)&&await P.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const e=this.h.get(n.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,p.$hh)(n))throw new E.$sl((0,O.localize)(11225,null,this.sb(n)),E.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const e=new R.$ab;throw e.message=(0,O.localize)(11226,null,n.toString()),e}return r}async m(n){const r=await this.j(n);if((0,E.$dl)(r)||(0,E.$al)(r)||(0,E.$el)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const r=await this.j(n);if((0,E.$dl)(r)||(0,E.$al)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.s(n,r)}catch(e){throw(0,E.$nl)(e)===E.FileSystemProviderErrorCode.FileNotFound?new E.$sl((0,O.localize)(11227,null,this.sb(n)),E.FileOperationResult.FILE_NOT_FOUND):(0,E.$ll)(e)}}async s(n,r){const e=await this.j(n),s=this.S(e),o=r?.resolveTo,u=r?.resolveSingleChildDescendants,$=r?.resolveMetadata,A=await e.stat(n);let T;return this.t(e,n,A,void 0,!!$,(D,N)=>(T||(T=f.$Ii.forUris(()=>!s),T.set(n,!0),o&&T.fill(!0,o)),T.get(D.resource)||T.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&u?N===1:!1))}async t(n,r,e,s,o,u){const{providerExtUri:$}=this.R(n),A={resource:r,name:$.basename(r),isFile:(e.type&E.FileType.File)!==0,isDirectory:(e.type&E.FileType.Directory)!==0,isSymbolicLink:(e.type&E.FileType.SymbolicLink)!==0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:!!((e.permissions??0)&E.FilePermission.Readonly)||!!(n.capabilities&E.FileSystemProviderCapabilities.Readonly),locked:!!((e.permissions??0)&E.FilePermission.Locked),etag:(0,E.$Dl)({mtime:e.mtime,size:e.size}),children:void 0};if(A.isDirectory&&u(A,s)){try{const T=await n.readdir(r),D=await P.Promises.settled(T.map(async([N,M])=>{try{const Y=$.joinPath(r,N),J=o?await n.stat(Y):{type:M};return await this.t(n,Y,J,T.length,o,u)}catch(Y){return this.b.trace(Y),null}}));A.children=(0,S.$Gb)(D)}catch(T){this.b.trace(T),A.children=[]}return A}return A}async resolveAll(n){return P.Promises.settled(n.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(e){return this.b.trace(e),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),e=await r.stat(n);return this.t(r,n,e,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.u(n,r)}catch(e){return e}return!0}async u(n,r){if(!r?.overwrite&&await this.exists(n))throw new E.$sl((0,O.localize)(11228,null,this.sb(n)),E.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(n,r=w.$Le.fromString(""),e){await this.u(n,e);const s=await this.writeFile(n,r);return this.r.fire(new E.$pl(n,E.FileOperation.CREATE,s)),s}async writeFile(n,r,e){const s=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(s);let u=e;if((0,E.$gl)(s)&&!u?.atomic){const $=s.enforceAtomicWriteFile?.(n);$&&(u={...e,atomic:$})}try{await this.w(s,n,u)||await this.U(s,o.dirname(n));let A;if((0,E.$al)(s)&&!(r instanceof w.$Le))if((0,v.$xe)(r)){const T=await(0,v.$Ee)(r,3);T.ended?A=w.$Le.concat(T.buffer):A=T}else A=(0,v.$Be)(r,T=>w.$Le.concat(T),3);else A=r;!(0,E.$dl)(s)||(0,E.$al)(s)&&A instanceof w.$Le||(0,E.$al)(s)&&(0,E.$gl)(s)&&u?.atomic?await this.hb(s,n,u,A):await this.db(s,n,u,A instanceof w.$Le?(0,w.$We)(A):A),this.r.fire(new E.$pl(n,E.FileOperation.WRITE))}catch($){throw new E.$sl((0,O.localize)(11229,null,this.sb(n),(0,E.$ll)($).toString()),(0,E.$ol)($),u)}return this.resolve(n,{resolveMetadata:!0})}async w(n,r,e){const s=!!e?.unlock;if(s&&!(n.capabilities&E.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,O.localize)(11230,null,this.sb(r)));if(!!e?.atomic){if(!(n.capabilities&E.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,O.localize)(11231,null,this.sb(r)));if(!(n.capabilities&E.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,O.localize)(11232,null,this.sb(r)));if(s)throw new Error((0,O.localize)(11233,null,this.sb(r)))}let u;try{u=await n.stat(r)}catch{return}if(u.type&E.FileType.Directory)throw new E.$sl((0,O.localize)(11234,null,this.sb(r)),E.FileOperationResult.FILE_IS_DIRECTORY,e);if(this.rb(r,u),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==E.$Cl&&typeof u.mtime=="number"&&typeof u.size=="number"&&e.mtime<u.mtime&&e.etag!==(0,E.$Dl)({mtime:e.mtime,size:u.size}))throw new E.$sl((0,O.localize)(11235,null),E.FileOperationResult.FILE_MODIFIED_SINCE,e);return u}async readFile(n,r,e){const s=await this.m(n);return r?.atomic?this.z(s,n,r,e):this.C(s,n,r,e)}async z(n,r,e,s){return new Promise((o,u)=>{this.cb.queueFor(r,async()=>{try{const $=await this.C(n,r,e,s);o($)}catch($){u($)}},this.R(n).providerExtUri)})}async C(n,r,e,s){const o=await this.D(n,r,{...e,preferUnbuffered:!0},s);return{...o,value:await(0,w.$Xe)(o.value)}}async readFileStream(n,r,e){const s=await this.m(n);return this.D(s,n,r,e)}async D(n,r,e,s){const o=new I.$ue(s);let u=e;(0,E.$fl)(n)&&n.enforceAtomicReadFile?.(r)&&(u={...e,atomic:!0});const $=this.J(r,u).then(T=>T,T=>{throw o.dispose(!0),T});let A;try{return typeof u?.etag=="string"&&u.etag!==E.$Cl&&await $,u?.atomic&&(0,E.$fl)(n)||!((0,E.$dl)(n)||(0,E.$el)(n))||(0,E.$al)(n)&&u?.preferUnbuffered?A=this.I(n,r,u):(0,E.$el)(n)?A=this.G(n,r,o.token,u):A=this.H(n,r,o.token,u),A.on("end",()=>o.dispose()),A.on("error",()=>o.dispose()),{...await $,value:A}}catch(T){throw A&&await(0,v.$Ce)(A),this.F(T,r,u)}}F(n,r,e){const s=(0,O.localize)(11236,null,this.sb(r),(0,E.$ll)(n).toString());return n instanceof E.$ul?new E.$ul(s,n.stat,e):n instanceof E.$tl?new E.$tl(s,n.fileOperationResult,n.size,n.options):new E.$sl(s,(0,E.$ol)(n),e)}G(n,r,e,s=Object.create(null)){const o=n.readFileStream(r,s,e);return(0,v.$Ie)(o,{data:u=>u instanceof w.$Le?u:w.$Le.wrap(u),error:u=>this.F(u,r,s)},u=>w.$Le.concat(u))}H(n,r,e,s=Object.create(null)){const o=(0,w.$2e)();return(0,d.$Yq)(n,r,o,u=>u,{...s,bufferSize:this.a,errorTransformer:u=>this.F(u,r,s)},e),o}I(n,r,e){const s=(0,v.$ze)(o=>w.$Le.concat(o));return(async()=>{try{let o;e?.atomic&&(0,E.$fl)(n)?o=await n.readFile(r,{atomic:!0}):o=await n.readFile(r),typeof e?.position=="number"&&(o=o.slice(e.position)),typeof e?.length=="number"&&(o=o.slice(0,e.length)),this.L(r,o.byteLength,e),s.end(w.$Le.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(n,r){const e=await this.resolve(n,{resolveMetadata:!0});if(e.isDirectory)throw new E.$sl((0,O.localize)(11237,null,this.sb(n)),E.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==E.$Cl&&r.etag===e.etag)throw new E.$ul((0,O.localize)(11238,null),e,r);return this.L(n,e.size,r),e}L(n,r,e){if(typeof e?.limits?.size=="number"&&r>e.limits.size)throw new E.$tl((0,O.localize)(11239,null,this.sb(n)),E.FileOperationResult.FILE_TOO_LARGE,r,e)}async canMove(n,r,e){return this.M(n,r,"move",e)}async canCopy(n,r,e){return this.M(n,r,"copy",e)}async M(n,r,e,s){if(n.toString()!==r.toString())try{const o=e==="move"?this.qb(await this.n(n),n):await this.m(n),u=this.qb(await this.n(r),r);await this.Q(o,n,u,r,e,s)}catch(o){return o}return!0}async move(n,r,e){const s=this.qb(await this.n(n),n),o=this.qb(await this.n(r),r),u=await this.N(s,n,o,r,"move",!!e),$=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new E.$pl(n,u==="move"?E.FileOperation.MOVE:E.FileOperation.COPY,$)),$}async copy(n,r,e){const s=await this.m(n),o=this.qb(await this.n(r),r),u=await this.N(s,n,o,r,"copy",!!e),$=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new E.$pl(n,u==="copy"?E.FileOperation.COPY:E.FileOperation.MOVE,$)),$}async N(n,r,e,s,o,u){if(r.toString()===s.toString())return o;const{exists:$,isSameResourceWithDifferentPathCase:A}=await this.Q(n,r,e,s,o,u);if($&&!A&&u&&await this.del(s,{recursive:!0}),await this.U(e,this.R(e).providerExtUri.dirname(s)),o==="copy"){if(n===e&&(0,E.$bl)(n))await n.copy(r,s,{overwrite:u});else{const T=await this.resolve(r);T.isDirectory?await this.P(n,T,e,s):await this.O(n,r,e,s)}return o}else return n===e?(await n.rename(r,s,{overwrite:u}),o):(await this.N(n,r,e,s,"copy",u),await this.del(r,{recursive:!0}),"copy")}async O(n,r,e,s){if((0,E.$dl)(n)&&(0,E.$dl)(e))return this.jb(n,r,e,s);if((0,E.$dl)(n)&&(0,E.$al)(e))return this.pb(n,r,e,s);if((0,E.$al)(n)&&(0,E.$dl)(e))return this.nb(n,r,e,s);if((0,E.$al)(n)&&(0,E.$al)(e))return this.lb(n,r,e,s)}async P(n,r,e,s){await e.mkdir(s),Array.isArray(r.children)&&await P.Promises.settled(r.children.map(async o=>{const u=this.R(e).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),e,u):this.O(n,o.resource,e,u)}))}async Q(n,r,e,s,o,u){let $=!1;if(n===e){const{providerExtUri:T,isPathCaseSensitive:D}=this.R(n);if(D||($=T.isEqual(r,s)),$&&o==="copy")throw new Error((0,O.localize)(11240,null,this.sb(r),this.sb(s)));if(!$&&T.isEqualOrParent(s,r))throw new Error((0,O.localize)(11241,null,this.sb(r),this.sb(s)))}const A=await this.exists(s);if(A&&!$){if(!u)throw new E.$sl((0,O.localize)(11242,null,this.sb(r),this.sb(s)),E.FileOperationResult.FILE_MOVE_CONFLICT);if(n===e){const{providerExtUri:T}=this.R(n);if(T.isEqualOrParent(r,s))throw new Error((0,O.localize)(11243,null,this.sb(r),this.sb(s)))}}return{exists:A,isSameResourceWithDifferentPathCase:$}}R(n){const r=this.S(n);return{providerExtUri:r?p.$6g:p.$8g,isPathCaseSensitive:r}}S(n){return!!(n.capabilities&E.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const r=this.qb(await this.j(n),n);await this.U(r,n);const e=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$pl(n,E.FileOperation.CREATE,e)),e}async U(n,r){const e=[],{providerExtUri:s}=this.R(n);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await n.stat(r)).type&E.FileType.Directory))throw new Error((0,O.localize)(11244,null,this.sb(r)));break}catch(o){if((0,E.$nl)(o)!==E.FileSystemProviderErrorCode.FileNotFound)throw o;e.push(s.basename(r)),r=s.dirname(r)}for(let o=e.length-1;o>=0;o--){r=s.joinPath(r,e[o]);try{await n.mkdir(r)}catch(u){if((0,E.$nl)(u)!==E.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(n,r){try{await this.W(n,r)}catch(e){return e}return!0}async W(n,r){const e=this.qb(await this.j(n),n),s=!!r?.useTrash;if(s&&!(e.capabilities&E.FileSystemProviderCapabilities.Trash))throw new Error((0,O.localize)(11245,null,this.sb(n)));const o=r?.atomic;if(o&&!(e.capabilities&E.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,O.localize)(11246,null,this.sb(n)));if(s&&o)throw new Error((0,O.localize)(11247,null,this.sb(n)));let u;try{u=await e.stat(n)}catch{}if(u)this.rb(n,u);else throw new E.$sl((0,O.localize)(11248,null,this.sb(n)),E.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const A=await this.resolve(n);if(A.isDirectory&&Array.isArray(A.children)&&A.children.length>0)throw new Error((0,O.localize)(11249,null,this.sb(n)))}return e}async del(n,r){const e=await this.W(n,r);let s=r;if((0,E.$hl)(e)&&!s?.atomic){const A=e.enforceAtomicDelete?.(n);A&&(s={...r,atomic:A})}const o=!!s?.useTrash,u=!!s?.recursive,$=s?.atomic??!1;await e.delete(n,{recursive:u,useTrash:o,atomic:$}),this.r.fire(new E.$pl(n,E.FileOperation.DELETE))}async cloneFile(n,r){const e=await this.j(n),s=this.qb(await this.n(r),r);if(!(e===s&&this.R(e).providerExtUri.isEqual(n,r)))return e===s&&(0,E.$cl)(e)?e.cloneFile(n,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),e===s&&(0,E.$bl)(e)?this.cb.queueFor(n,()=>e.copy(n,r,{overwrite:!0}),this.R(e).providerExtUri):this.cb.queueFor(n,()=>this.O(e,n,s,r),this.R(e).providerExtUri))}static{this.ab=0}createWatcher(n,r){return this.watch(n,{...r,correlationId:y.ab++})}watch(n,r={recursive:!1,excludes:[]}){const e=new a.$Sc;let s=!1,o=()=>{s=!0};e.add((0,a.$Rc)(()=>o())),(async()=>{try{const $=await this.bb(n,r);s?(0,a.$Oc)($):o=()=>(0,a.$Oc)($)}catch($){this.b.error($)}})();const u=r.correlationId;if(typeof u=="number"){const $=e.add(new L.$je);return e.add(this.X.event(T=>{T.correlates(u)&&$.fire(T)})),{onDidChange:$.event,dispose:()=>e.dispose()}}return e}async bb(n,r){const e=await this.j(n),s=(0,k.$qj)([this.R(e).providerExtUri.getComparisonKey(n),r]);let o=this.$.get(s);return o||(o={count:0,disposable:e.watch(n,r)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,a.$Oc)(n.disposable);this.$.clear()}async db(n,r,e,s){return this.cb.queueFor(r,async()=>{const o=await n.open(r,{create:!0,unlock:e?.unlock??!1});try{(0,v.$xe)(s)||(0,v.$ye)(s)?await this.eb(n,o,s):await this.fb(n,o,s)}catch(u){throw(0,E.$ll)(u)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,r,e){let s=0,o;if((0,v.$ye)(e)){if(e.buffer.length>0){const u=w.$Le.concat(e.buffer);await this.gb(n,r,u,u.byteLength,s,0),s+=u.byteLength}if(e.ended)return;o=e.stream}else o=e;return new Promise((u,$)=>{(0,v.$De)(o,{onData:async A=>{o.pause();try{await this.gb(n,r,A,A.byteLength,s,0)}catch(T){return $(T)}s+=A.byteLength,setTimeout(()=>o.resume())},onError:A=>$(A),onEnd:()=>u()})})}async fb(n,r,e){let s=0,o;for(;(o=e.read())!==null;)await this.gb(n,r,o,o.byteLength,s,0),s+=o.byteLength}async gb(n,r,e,s,o,u){let $=0;for(;$<s;){const A=await n.write(r,o+$,e.buffer,u+$,s-$);$+=A}}async hb(n,r,e,s){return this.cb.queueFor(r,()=>this.ib(n,r,e,s),this.R(n).providerExtUri)}async ib(n,r,e,s){let o;s instanceof w.$Le?o=s:(0,v.$xe)(s)?o=await(0,w.$Xe)(s):(0,v.$ye)(s)?o=await(0,w.$Ye)(s):o=(0,w.$Ve)(s),await n.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1,atomic:e?.atomic??!1})}async jb(n,r,e,s){return this.cb.queueFor(s,()=>this.kb(n,r,e,s),this.R(e).providerExtUri)}async kb(n,r,e,s){let o,u;try{o=await n.open(r,{create:!1}),u=await e.open(s,{create:!0,unlock:!1});const $=w.$Le.alloc(this.a);let A=0,T=0,D=0;do D=await n.read(o,A,$.buffer,T,$.byteLength-T),await this.gb(e,u,$,D,A,T),A+=D,T+=D,T===$.byteLength&&(T=0);while(D>0)}catch($){throw(0,E.$ll)($)}finally{await P.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof u=="number"?e.close(u):Promise.resolve()])}}async lb(n,r,e,s){return this.cb.queueFor(s,()=>this.mb(n,r,e,s),this.R(e).providerExtUri)}async mb(n,r,e,s){return e.writeFile(s,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,r,e,s){return this.cb.queueFor(s,()=>this.ob(n,r,e,s),this.R(e).providerExtUri)}async ob(n,r,e,s){const o=await e.open(s,{create:!0,unlock:!1});try{const u=await n.readFile(r);await this.gb(e,o,w.$Le.wrap(u),u.byteLength,0,0)}catch(u){throw(0,E.$ll)(u)}finally{await e.close(o)}}async pb(n,r,e,s){const o=await(0,w.$Xe)(this.H(n,r,I.CancellationToken.None));await this.hb(e,s,void 0,o)}qb(n,r){if(n.capabilities&E.FileSystemProviderCapabilities.Readonly)throw new E.$sl((0,O.localize)(11250,null,this.sb(r)),E.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,r){if((r.permissions??0)&E.FilePermission.Readonly)throw new E.$sl((0,O.localize)(11251,null,this.sb(n)),E.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===c.Schemas.file?n.fsPath:n.toString(!0)}};t.$Zq=i,t.$Zq=i=y=ve([se(0,m.$0j)],i)}),define(ce[108],le([0,1,32,8,30,13,4,63,2,15,12,16,47,28,5,9,62,105,103,102]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qr=void 0;class y extends d.$_q{static{this.L=!1}constructor(l,n){super(l,n),this.onDidChangeCapabilities=L.Event.None,this.P=new w.$zc(r=>c.$7g.getComparisonKey(r)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=O.FileSystemProviderCapabilities.FileReadWrite|O.FileSystemProviderCapabilities.FileOpenReadWriteClose|O.FileSystemProviderCapabilities.FileReadStream|O.FileSystemProviderCapabilities.FileFolderCopy|O.FileSystemProviderCapabilities.FileWriteUnlock|O.FileSystemProviderCapabilities.FileAtomicRead|O.FileSystemProviderCapabilities.FileAtomicWrite|O.FileSystemProviderCapabilities.FileAtomicDelete|O.FileSystemProviderCapabilities.FileClone,f.$l&&(this.M|=O.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(l){try{const{stat:n,symbolicLink:r}=await p.SymlinkSupport.stat(this.I(l));return{type:this.O(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:O.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const n=await p.Promises.readdir(this.I(l),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async e=>{try{let s;e.isSymbolicLink()?s=(await this.stat((0,c.$dh)(l,e.name))).type:s=this.O(e),r.push([e.name,s])}catch(s){this.a.trace(s)}})),r}catch(n){throw this.hb(n)}}O(l,n){let r;return n?.dangling?r=O.FileType.Unknown:l.isFile()?r=O.FileType.File:l.isDirectory()?r=O.FileType.Directory:r=O.FileType.Unknown,n&&(r|=O.FileType.SymbolicLink),r}async Q(l){const n=this.I(l);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.P.get(l);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const e=new P.$Bh;return this.P.set(l,e),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,g.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(l)===e&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(l)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),e.open()})}async readFile(l,n){let r;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(l)})`),r=await this.Q(l));const e=this.I(l);return await S.promises.readFile(e)}catch(e){throw this.hb(e)}finally{r?.dispose()}}R(l){y.L&&this.a.trace(l)}readFileStream(l,n,r){const e=(0,h.$ze)(s=>I.$Le.concat(s.map(o=>I.$Le.wrap(o))).buffer);return(0,E.$Yq)(this,l,e,s=>s.buffer,{...n,bufferSize:256*1024},r),e}async writeFile(l,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.S(l)?this.U(l,(0,c.$dh)((0,c.$ch)(l),`${(0,c.$ah)(l)}${r.atomic.postfix}`),n,r):this.W(l,n,r)}async S(l){try{const n=this.I(l),{symbolicLink:r}=await p.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async U(l,n,r,e){const s=new g.$Sc;try{s.add(await this.Q(l)),s.add(await this.Q(n)),await this.W(n,r,e,!0);try{await this.rename(n,l,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{s.dispose()}}async W(l,n,r,e){let s;try{const o=this.I(l);if(!r.create||!r.overwrite){if(await p.Promises.exists(o)){if(!r.overwrite)throw(0,O.$kl)((0,v.localize)(11209,null),O.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,O.$kl)((0,v.localize)(11210,null),O.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(l,{create:!0,unlock:r.unlock},e),await this.write(s,0,n,0,n.byteLength)}catch(o){throw await this.ib(l,o)}finally{typeof s=="number"&&await this.close(s)}}static{this.$=!0}static configureFlushOnWrite(l){y.$=l}async open(l,n,r){const e=this.I(l);let s;(0,O.$$k)(n)&&!r&&(s=await this.Q(l));let o;try{if((0,O.$$k)(n)&&n.unlock)try{const{stat:$}=await p.SymlinkSupport.stat(e);$.mode&128||await S.promises.chmod(e,$.mode|128)}catch($){$.code!=="ENOENT"&&this.a.trace($)}let u;if((0,O.$$k)(n)){if(f.$j)try{await S.promises.truncate(e,0),u="r+"}catch($){$.code!=="ENOENT"&&this.a.trace($)}u||(u="w")}else u="r";o=await p.Promises.open(e,u)}catch(u){throw s?.dispose(),(0,O.$$k)(n)?await this.ib(l,u):this.hb(u)}if(this.X.set(o,0),(0,O.$$k)(n)&&this.Z.set(o,l),s){const u=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${e})`),this.Y.set(o,s),u&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${e})`),u.dispose())}return o}async close(l){const n=this.Y.get(l);try{if(this.X.delete(l),this.Z.delete(l)&&y.$)try{await p.Promises.fdatasync(l)}catch(r){y.configureFlushOnWrite(!1),this.a.error(r)}return await p.Promises.close(l)}catch(r){throw this.hb(r)}finally{n&&(this.Y.get(l)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.Y.delete(l)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),n.dispose())}}async read(l,n,r,e,s){const o=this.ab(l,n);let u=null;try{u=(await p.Promises.read(l,r,e,s,o)).bytesRead}catch($){throw this.hb($)}finally{this.bb(l,o,u)}return u}ab(l,n){return n===this.X.get(l)?null:n}bb(l,n,r){const e=this.X.get(l);typeof e=="number"&&(typeof n=="number"||(typeof r=="number"?this.X.set(l,e+r):this.X.delete(l)))}async write(l,n,r,e,s){return(0,P.$Wh)(()=>this.cb(l,n,r,e,s),100,3)}async cb(l,n,r,e,s){const o=this.ab(l,n);let u=null;try{u=(await p.Promises.write(l,r,e,s,o)).bytesWritten}catch($){throw await this.ib(this.Z.get(l),$)}finally{this.bb(l,o,u)}return u}async mkdir(l){try{await S.promises.mkdir(this.I(l))}catch(n){throw this.hb(n)}}async delete(l,n){try{const r=this.I(l);if(n.recursive){let e;n?.atomic!==!1&&n.atomic.postfix&&(e=(0,a.$ic)((0,a.$lc)(r),`${(0,a.$mc)(r)}${n.atomic.postfix}`)),await p.Promises.rm(r,p.RimRafMode.MOVE,e)}else try{await S.promises.unlink(r)}catch(e){if(e.code==="EPERM"||e.code==="EISDIR"){let s=!1;try{const{stat:o,symbolicLink:u}=await p.SymlinkSupport.stat(r);s=o.isDirectory()&&!u}catch{}if(s)await S.promises.rmdir(r);else throw e}else throw e}}catch(r){throw this.hb(r)}}async rename(l,n,r){const e=this.I(l),s=this.I(n);if(e!==s)try{await this.db(l,n,"move",r.overwrite),await p.Promises.rename(e,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,v.localize)(11211,null,(0,a.$mc)(e),(0,a.$mc)((0,a.$lc)(s)),o.toString()))),this.hb(o)}}async copy(l,n,r){const e=this.I(l),s=this.I(n);if(e!==s)try{await this.db(l,n,"copy",r.overwrite),await p.Promises.copy(e,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,v.localize)(11212,null,(0,a.$mc)(e),(0,a.$mc)((0,a.$lc)(s)),o.toString()))),this.hb(o)}}async db(l,n,r,e){const s=this.I(l),o=this.I(n);let u=!1;if(!!(this.capabilities&O.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,k.$Ag)(s,o,!0)),u){if(r==="copy")throw(0,O.$kl)((0,v.localize)(11213,null),O.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const A=await this.N(l);if(!A)throw(0,O.$kl)((0,v.localize)(11214,null),O.FileSystemProviderErrorCode.FileNotFound);const T=await this.N(n);if(T){if(!e)throw(0,O.$kl)((0,v.localize)(11215,null),O.FileSystemProviderErrorCode.FileExists);A.type&O.FileType.File&&T.type&O.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,n){return this.eb(l,n,!1)}async eb(l,n,r){const e=this.I(l),s=this.I(n),o=!!(this.capabilities&O.FileSystemProviderCapabilities.PathCaseSensitive);if((0,k.$Ag)(e,s,!o))return;const u=new g.$Sc;try{u.add(await this.Q(l)),u.add(await this.Q(n)),r&&await S.promises.mkdir((0,a.$lc)(s),{recursive:!0}),await S.promises.copyFile(e,s)}catch($){if($.code==="ENOENT"&&!r)return this.eb(l,n,!0);throw this.hb($)}finally{u.dispose()}}t(l,n,r){return new m.$gr(e=>l(e),e=>n(e),r)}F(l,n,r){return new R.$pr(e=>l(e),e=>n(e),r)}hb(l){if(l instanceof O.$jl)return l;let n=l,r;switch(l.code){case"ENOENT":r=O.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=O.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=O.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=O.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=O.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=O.FileSystemProviderErrorCode.Unknown;break;default:r=O.FileSystemProviderErrorCode.Unknown}return(0,O.$kl)(n,r)}async ib(l,n){let r=this.hb(n);if(l&&r.code===O.FileSystemProviderErrorCode.NoPermissions)try{const{stat:e}=await p.SymlinkSupport.stat(this.I(l));e.mode&128||(r=(0,O.$kl)(n,O.FileSystemProviderErrorCode.FileWriteLocked))}catch(e){this.a.trace(e)}return r}}t.$qr=y}),define(ce[109],le([0,1,2,6]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qR=void 0;class w extends S.$Tc{constructor(L,k=[]){super(),this.a=new P.$hk([L,...k]),this.B(L.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...k){this.a.trace(L,...k)}debug(L,...k){this.a.debug(L,...k)}info(L,...k){this.a.info(L,...k)}warn(L,...k){this.a.warn(L,...k)}error(L,...k){this.a.error(L,...k)}flush(){this.a.flush()}}t.$qR=w}),define(ce[110],le([0,1,9,6]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fR=void 0;var w;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(w||(w={}));async function I(a,f,c,h,p){try{const v=await new Promise((E,d)=>{Q(["@vscode/spdlog"],E,d)}).then(ye);v.setFlushOn(w.Trace);const O=await v.createAsyncRotatingLogger(a,f,c,h);return p?O.clearFormatters():O.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),O}catch(v){console.error(v)}return null}function L(a,f,c){switch(f){case P.LogLevel.Trace:a.trace(c);break;case P.LogLevel.Debug:a.debug(c);break;case P.LogLevel.Info:a.info(c);break;case P.LogLevel.Warning:a.warn(c);break;case P.LogLevel.Error:a.error(c);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function k(a,f){switch(f){case P.LogLevel.Trace:a.setLevel(w.Trace);break;case P.LogLevel.Debug:a.setLevel(w.Debug);break;case P.LogLevel.Info:a.setLevel(w.Info);break;case P.LogLevel.Warning:a.setLevel(w.Warning);break;case P.LogLevel.Error:a.setLevel(w.Error);break;case P.LogLevel.Off:a.setLevel(w.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class g extends P.$dk{constructor(f,c,h,p,v){super(),this.m=[],this.setLevel(v),this.n=this.s(f,c,h,p),this.B(this.onDidChangeLogLevel(O=>{this.r&&k(this.r,O)}))}async s(f,c,h,p){const v=h?6:1,O=30/v*S.$Fl.MB,E=await I(f,c,O,v,p);if(E){this.r=E,k(this.r,this.getLevel());for(const{level:d,message:m}of this.m)L(this.r,d,m);this.m=[]}}g(f,c){this.r?L(this.r,f,c):this.getLevel()<=f&&this.m.push({level:f,message:c})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}t.$fR=g}),define(ce[111],le([0,1,27,6,110]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=void 0;class I extends P.$ik{s(k,g,a){return new w.$fR((0,S.$Yg)(),k.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,g)}}t.$gR=I}),define(ce[39],le([0,1,4,65,2,10]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$so=t.$ro=t.$qo=void 0,t.$qo=(0,I.$Ci)("policy");class L extends w.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),P.Iterable.reduce(this.g.entries(),(c,[h,p])=>({...c,[h]:p}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return P.Iterable.reduce(Object.entries(this.f),(a,[f,c])=>({...a,[f]:{definition:c,value:this.g.get(f)}}),{})}}t.$ro=L;class k{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.$so=k}),define(ce[112],le([0,1,8,4,65,3,9,6,39]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xgc=void 0;function a(c,h){const p=[];for(const v of new Set(w.Iterable.concat(c.keys(),h.keys())))c.get(v)!==h.get(v)&&p.push(v);return p}let f=class extends g.$ro{constructor(h,p,v){super(),this.m=h,this.n=p,this.s=v,this.c=this.B(new S.$Ah(500));const O=P.Event.filter(p.onDidFilesChange,E=>E.affects(h));this.B(p.watch(h)),this.B(O(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const h=new Map;try{const p=await this.n.readFile(this.m),v=JSON.parse(p.value.toString());if(!(0,I.$eg)(v))throw new Error("Policy file isn't a JSON object");for(const O of Object.keys(v))this.f[O]&&h.set(O,v[O])}catch(p){p.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",p)}return h}async w(){const h=await this.u(),p=a(this.g,h);this.g=h,p.length>0&&this.h.fire(p)}};t.$Xgc=f,t.$Xgc=f=ve([se(1,L.$0k),se(2,k.$0j)],f)}),define(ce[113],le([0,1,39,8,2,6]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wgc=void 0;let L=class extends S.$ro{constructor(g,a){super(),this.m=g,this.n=a,this.a=new P.$wh,this.b=this.B(new w.$Uc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:a}=await new Promise((f,c)=>{Q(["@vscode/policy-watcher"],f,c)}).then(ye);await this.a.queue(()=>new Promise((f,c)=>{try{this.b.value=a(this.n,g,h=>{this.t(h),f()})}catch(h){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",h),c(h)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const a in g){const f=g[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(g))}};t.$Wgc=L,t.$Wgc=L=ve([se(0,I.$0j)],L)}),define(ce[33],le([0,1,10]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rk=t.$qk=void 0,t.$qk=(0,S.$Ci)("productService"),t.$rk="vscode://schemas/vscode-product"}),define(ce[37],le([0,1,75,3]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oo=void 0,S=ye(S),P=ye(P);class w{constructor(){this.a=new Map}add(L,k){S.ok(P.$cg(L)),S.ok(P.$eg(k)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,k)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}t.$oo=new w}),define(ce[114],le([0,1,4,37]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$po=void 0,P=ye(P),t.$po={JSONContribution:"base.contributions.json"};function w(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class I{constructor(){this.b=new S.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,a){this.a[w(g)]=a,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const L=new I;P.$oo.add(t.$po.JSONContribution,L)}),define(ce[40],le([0,1,19,4,3,5,29,114,37]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Do=t.$Co=t.$Bo=t.$Ao=t.$zo=t.$yo=t.$xo=t.$wo=t.$vo=t.$uo=t.ConfigurationScope=t.$to=t.EditPresentationTypes=void 0,t.$Eo=O,t.$Fo=E,t.$Go=d,t.$Ho=R,t.$Io=y,t.$Jo=i,t.$Ko=l,w=ye(w),I=ye(I);var a;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(a||(t.EditPresentationTypes=a={})),t.$to={Configuration:"base.contributions.configuration"};var f;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(t.ConfigurationScope=f={})),t.$uo={properties:{},patternProperties:{}},t.$vo={properties:{},patternProperties:{}},t.$wo={properties:{},patternProperties:{}},t.$xo={properties:{},patternProperties:{}},t.$yo={properties:{},patternProperties:{}},t.$zo={properties:{},patternProperties:{}},t.$Ao="vscode://schemas/settings/resourceLanguage",t.$Bo="vscode://schemas/settings/configurationDefaults";const c=g.$oo.as(k.$po.JSONContribution);class h{constructor(){this.a=[],this.i=new Set,this.j=new P.$je,this.onDidSchemaChange=this.j.event,this.k=new P.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:I.localize(11444,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},c.registerSchema(t.$Ao,this.h),this.z()}registerConfiguration(r,e=!0){this.registerConfigurations([r],e)}registerConfigurations(r,e=!0){const s=new Set;this.r(r,e,s),c.registerSchema(t.$Ao,this.h),this.j.fire(),this.k.fire({properties:s})}deregisterConfigurations(r){const e=new Set;this.s(r,e),c.registerSchema(t.$Ao,this.h),this.j.fire(),this.k.fire({properties:e})}updateConfigurations({add:r,remove:e}){const s=new Set;this.s(e,s),this.r(r,!1,s),c.registerSchema(t.$Ao,this.h),this.j.fire(),this.k.fire({properties:s})}registerDefaultConfigurations(r){const e=new Set;this.l(r,e),this.j.fire(),this.k.fire({properties:e,defaultsOverrides:!0})}l(r,e){this.a.push(...r);const s=[];for(const{overrides:o,source:u}of r)for(const $ in o){e.add($);const A=this.b.get($)??this.b.set($,{configurationDefaultOverrides:[]}).get($),T=o[$];if(A.configurationDefaultOverrides.push({value:T,source:u}),t.$Do.test($)){const D=this.o($,T,u,A.configurationDefaultOverrideValue);if(!D)continue;A.configurationDefaultOverrideValue=D,this.n($,D,u),s.push(...O($))}else{const D=this.p($,T,u,A.configurationDefaultOverrideValue);if(!D)continue;A.configurationDefaultOverrideValue=D;const N=this.e[$];N&&(this.A($,N),this.w($,N))}}this.q(s)}deregisterDefaultConfigurations(r){const e=new Set;this.m(r,e),this.j.fire(),this.k.fire({properties:e,defaultsOverrides:!0})}m(r,e){for(const s of r){const o=this.a.indexOf(s);o!==-1&&this.a.splice(o,1)}for(const{overrides:s,source:o}of r)for(const u in s){const $=this.b.get(u);if(!$)continue;const A=$.configurationDefaultOverrides.findIndex(T=>o?T.source?.id===o.id:T.value===s[u]);if(A!==-1){if($.configurationDefaultOverrides.splice(A,1),$.configurationDefaultOverrides.length===0&&this.b.delete(u),t.$Do.test(u)){let T;for(const D of $.configurationDefaultOverrides)T=this.o(u,D.value,D.source,T);T&&!w.$pg(T.value)?($.configurationDefaultOverrideValue=T,this.n(u,T,o)):(this.b.delete(u),delete this.e[u],delete this.c.properties[u])}else{let T;for(const N of $.configurationDefaultOverrides)T=this.p(u,N.value,N.source,T);$.configurationDefaultOverrideValue=T;const D=this.e[u];D&&(this.A(u,D),this.w(u,D))}e.add(u)}}this.y()}n(r,e,s){const o={type:"object",default:e.value,description:I.localize(11445,null,(0,L.$gj)(r)),$ref:t.$Ao,defaultDefaultValue:e.value,source:s,defaultValueSource:s};this.e[r]=o,this.c.properties[r]=o}o(r,e,s,o){const u=o?.value||{},$=o?.source??new Map;if(!($ instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const A of Object.keys(e)){const T=e[A];if(w.$eg(T)&&(w.$jg(u[A])||w.$eg(u[A]))){if(u[A]={...u[A]??{},...T},s)for(const N in T)$.set(`${A}.${N}`,s)}else u[A]=T,s?$.set(A,s):$.delete(A)}return{value:u,source:$}}p(r,e,s,o){const u=this.e[r],$=o?.value??u?.defaultDefaultValue;let A=s;if(w.$eg(e)&&(u!==void 0&&u.type==="object"||u===void 0&&(w.$jg($)||w.$eg($)))){if(A=o?.source??new Map,!(A instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const D in e)s&&A.set(`${r}.${D}`,s);e={...w.$eg($)?$:{},...e}}return{value:e,source:A}}deltaConfiguration(r){let e=!1;const s=new Set;r.removedDefaults&&(this.m(r.removedDefaults,s),e=!0),r.addedDefaults&&(this.l(r.addedDefaults,s),e=!0),r.removedConfigurations&&this.s(r.removedConfigurations,s),r.addedConfigurations&&this.r(r.addedConfigurations,!1,s),this.j.fire(),this.k.fire({properties:s,defaultsOverrides:e})}notifyConfigurationSchemaUpdated(...r){this.j.fire()}registerOverrideIdentifiers(r){this.q(r),this.j.fire()}q(r){for(const e of r)this.i.add(e);this.y()}r(r,e,s){r.forEach(o=>{this.u(o,e,o.extensionInfo,o.restrictedProperties,void 0,s),this.d.push(o),this.v(o)})}s(r,e){const s=o=>{if(o.properties)for(const u in o.properties){e.add(u);const $=this.e[u];$?.policy?.name&&this.f.delete($.policy.name),delete this.e[u],this.x(u,o.properties[u])}o.allOf?.forEach(u=>s(u))};for(const o of r){s(o);const u=this.d.indexOf(o);u!==-1&&this.d.splice(u,1)}}u(r,e=!0,s,o,u=f.WINDOW,$){u=w.$lg(r.scope)?u:r.scope;const A=r.properties;if(A)for(const D in A){const N=A[D];if(e&&R(D,N)){delete A[D];continue}if(N.source=s,N.defaultDefaultValue=A[D].default,this.A(D,N),t.$Do.test(D)?N.scope=void 0:(N.scope=w.$lg(N.scope)?u:N.scope,N.restricted=w.$lg(N.restricted)?!!o?.includes(D):N.restricted),A[D].hasOwnProperty("included")&&!A[D].included){this.g[D]=A[D],delete A[D];continue}else this.e[D]=A[D],A[D].policy?.name&&this.f.set(A[D].policy.name,D);!A[D].deprecationMessage&&A[D].markdownDeprecationMessage&&(A[D].deprecationMessage=A[D].markdownDeprecationMessage),$.add(D)}const T=r.allOf;if(T)for(const D of T)this.u(D,e,s,o,u,$)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const r=new Map;for(const[e,s]of this.b)s.configurationDefaultOverrideValue&&r.set(e,s.configurationDefaultOverrideValue);return r}v(r){const e=s=>{const o=s.properties;if(o)for(const $ in o)this.w($,o[$]);s.allOf?.forEach(e)};e(r)}w(r,e){switch(t.$uo.properties[r]=e,e.scope){case f.APPLICATION:t.$vo.properties[r]=e;break;case f.MACHINE:t.$wo.properties[r]=e;break;case f.MACHINE_OVERRIDABLE:t.$xo.properties[r]=e;break;case f.WINDOW:t.$yo.properties[r]=e;break;case f.RESOURCE:t.$zo.properties[r]=e;break;case f.LANGUAGE_OVERRIDABLE:t.$zo.properties[r]=e,this.h.properties[r]=e;break}}x(r,e){switch(delete t.$uo.properties[r],e.scope){case f.APPLICATION:delete t.$vo.properties[r];break;case f.MACHINE:delete t.$wo.properties[r];break;case f.MACHINE_OVERRIDABLE:delete t.$xo.properties[r];break;case f.WINDOW:delete t.$yo.properties[r];break;case f.RESOURCE:case f.LANGUAGE_OVERRIDABLE:delete t.$zo.properties[r],delete this.h.properties[r];break}}y(){for(const r of this.i.values()){const e=`[${r}]`,s={type:"object",description:I.localize(11446,null),errorMessage:I.localize(11447,null),$ref:t.$Ao};this.A(e,s),t.$uo.properties[e]=s,t.$vo.properties[e]=s,t.$wo.properties[e]=s,t.$xo.properties[e]=s,t.$yo.properties[e]=s,t.$zo.properties[e]=s}}z(){const r={type:"object",description:I.localize(11448,null),errorMessage:I.localize(11449,null),$ref:t.$Ao};t.$uo.patternProperties[t.$Co]=r,t.$vo.patternProperties[t.$Co]=r,t.$wo.patternProperties[t.$Co]=r,t.$xo.patternProperties[t.$Co]=r,t.$yo.patternProperties[t.$Co]=r,t.$zo.patternProperties[t.$Co]=r,this.j.fire()}A(r,e){const s=this.b.get(r)?.configurationDefaultOverrideValue;let o,u;s&&(!e.disallowConfigurationDefault||!s.source)&&(o=s.value,u=s.source),w.$jg(o)&&(o=e.defaultDefaultValue,u=void 0),w.$jg(o)&&(o=d(e.type)),e.default=o,e.defaultValueSource=u}}const p="\\[([^\\]]+)\\]",v=new RegExp(p,"g");t.$Co=`^(${p})+$`,t.$Do=new RegExp(t.$Co);function O(n){const r=[];if(t.$Do.test(n)){let e=v.exec(n);for(;e?.length;){const s=e[1].trim();s&&r.push(s),e=v.exec(n)}}return(0,S.$Lb)(r)}function E(n){return n.reduce((r,e)=>`${r}[${e}]`,"")}function d(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new h;g.$oo.add(t.$to.Configuration,m);function R(n,r){return n.trim()?t.$Do.test(n)?I.localize(11451,null,n):m.getConfigurationProperties()[n]!==void 0?I.localize(11452,null,n):r.policy?.name&&m.getPolicyConfigurations().get(r.policy?.name)!==void 0?I.localize(11453,null,n,r.policy?.name,m.getPolicyConfigurations().get(r.policy?.name)):null:I.localize(11450,null)}function y(){const n=[],r=m.getConfigurationProperties();for(const e of Object.keys(r))n.push([e,r[e].scope]);return n.push(["launch",f.RESOURCE]),n.push(["task",f.RESOURCE]),n}function i(n){const r={};for(const e of n){const s=e.properties;if(w.$eg(s))for(const o in s)r[o]=s[o];e.allOf&&Object.assign(r,i(e.allOf))}return r}function l(n){switch(n){case"application":return f.APPLICATION;case"machine":return f.MACHINE;case"resource":return f.RESOURCE;case"machine-overridable":return f.MACHINE_OVERRIDABLE;case"language-overridable":return f.LANGUAGE_OVERRIDABLE;default:return f.WINDOW}}}),define(ce[66],le([0,1,19,4,34,2,30,26,3,11,29,40,9,37]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qo=t.$Oo=t.$No=t.$Mo=t.$Lo=void 0,t.$Po=y,S=ye(S),w=ye(w),k=ye(k),g=ye(g);function v(r){return Object.isFrozen(r)?r:k.$co(r)}class O{static createEmptyModel(e){return new O({},[],[],void 0,e)}constructor(e,s,o,u,$){this.b=e,this.c=s,this.d=o,this.raw=u,this.f=$,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const e=this.raw.map(s=>{if(s instanceof O)return s;const o=new E("",this.f);return o.parseRaw(s),o.configurationModel});this.g=e.reduce((s,o)=>o===s?o:s.merge(o),e[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(e){return e?(0,f.$ej)(this.contents,e):this.contents}inspect(e,s){const o=this;return{get value(){return v(o.rawConfiguration.getValue(e))},get override(){return s?v(o.rawConfiguration.getOverrideValue(e,s)):void 0},get merged(){return v(s?o.rawConfiguration.override(s).getValue(e):o.rawConfiguration.getValue(e))},get overrides(){const u=[];for(const{contents:$,identifiers:A,keys:T}of o.rawConfiguration.overrides){const D=new O($,T,[],void 0,o.f).getValue(e);D!==void 0&&u.push({identifiers:A,value:D})}return u.length?v(u):void 0}}}getOverrideValue(e,s){const o=this.j(s);return o?e?(0,f.$ej)(o,e):o:void 0}getKeysForOverrideIdentifier(e){const s=[];for(const o of this.overrides)o.identifiers.includes(e)&&s.push(...o.keys);return S.$Lb(s)}getAllOverrideIdentifiers(){const e=[];for(const s of this.overrides)e.push(...s.identifiers);return S.$Lb(e)}override(e){let s=this.a.get(e);return s||(s=this.h(e),this.a.set(e,s)),s}merge(...e){const s=k.$bo(this.contents),o=k.$bo(this.overrides),u=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const A of e)if($.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.i(s,A.contents);for(const T of A.overrides){const[D]=o.filter(N=>S.$tb(N.identifiers,T.identifiers));D?(this.i(D.contents,T.contents),D.keys.push(...T.keys),D.keys=S.$Lb(D.keys)):o.push(k.$bo(T))}for(const T of A.keys)u.indexOf(T)===-1&&u.push(T)}return new O(s,u,o,$.every(A=>A instanceof O)?void 0:$,this.f)}h(e){const s=this.j(e);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const u of S.$Lb([...Object.keys(this.contents),...Object.keys(s)])){let $=this.contents[u];const A=s[u];A&&(typeof $=="object"&&typeof A=="object"?($=k.$bo($),this.i($,A)):$=A),o[u]=$}return new O(o,this.keys,this.overrides,void 0,this.f)}i(e,s){for(const o of Object.keys(s)){if(o in e&&g.$eg(e[o])&&g.$eg(s[o])){this.i(e[o],s[o]);continue}e[o]=k.$bo(s[o])}}j(e){let s=null,o=null;const u=$=>{$&&(o?this.i(o,$):o=k.$bo($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===e?s=$.contents:$.identifiers.includes(e)&&u($.contents);return u(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(e,s){this.k(e,s,!0)}setValue(e,s){this.k(e,s,!1)}removeValue(e){const s=this.keys.indexOf(e);s!==-1&&(this.keys.splice(s,1),(0,f.$dj)(this.contents,e),c.$Do.test(e)&&this.overrides.splice(this.overrides.findIndex(o=>S.$tb(o.identifiers,(0,c.$Eo)(e))),1))}k(e,s,o){if((0,f.$cj)(this.contents,e,s,u=>this.f.error(u)),o=o||this.keys.indexOf(e)===-1,o&&this.keys.push(e),c.$Do.test(e)){const u=(0,c.$Eo)(e),$={identifiers:u,keys:Object.keys(this.contents[e]),contents:(0,f.$bj)(this.contents[e],T=>this.f.error(T))},A=this.overrides.findIndex(T=>S.$tb(T.identifiers,u));A!==-1?this.overrides[A]=$:this.overrides.push($)}}}t.$Lo=O;class E{constructor(e,s){this.f=e,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||O.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(e,s){if(!g.$lg(e)){const o=this.h(e);this.parseRaw(o,s)}}reparse(e){this.a&&this.parseRaw(this.a,e)}parseRaw(e,s){this.a=e;const{contents:o,keys:u,overrides:$,restricted:A,hasExcludedProperties:T}=this.i(e,s);this.b=new O(o,u,$,T?[e]:void 0,this.g),this.c=A||[]}h(e){let s={},o=null,u=[];const $=[],A=[];function T(N){Array.isArray(u)?u.push(N):o!==null&&(u[o]=N)}const D={onObjectBegin:()=>{const N={};T(N),$.push(u),u=N,o=null},onObjectProperty:N=>{o=N},onObjectEnd:()=>{u=$.pop()},onArrayBegin:()=>{const N=[];T(N),$.push(u),u=N,o=null},onArrayEnd:()=>{u=$.pop()},onLiteralValue:T,onError:(N,M,Y)=>{A.push({error:N,offset:M,length:Y})}};if(e)try{w.$3n(e,D),s=u[0]||{}}catch(N){this.g.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return s}i(e,s){const o=p.$oo.as(c.$to.Configuration).getConfigurationProperties(),u=this.j(e,o,!0,s);e=u.raw;const $=(0,f.$bj)(e,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),A=Object.keys(e),T=this.l(e,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:$,keys:A,overrides:T,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}j(e,s,o,u){let $=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:e,restricted:[],hasExcludedProperties:$};const A={},T=[];for(const D in e)if(c.$Do.test(D)&&o){const N=this.j(e[D],s,!1,u);A[D]=N.raw,$=$||N.hasExcludedProperties,T.push(...N.restricted)}else{const N=s[D],M=N?typeof N.scope<"u"?N.scope:c.ConfigurationScope.WINDOW:void 0;N?.restricted&&T.push(D),!u.exclude?.includes(D)&&(u.include?.includes(D)||(M===void 0||u.scopes===void 0||u.scopes.includes(M))&&!(u.skipRestricted&&N?.restricted))?A[D]=e[D]:$=!0}return{raw:A,restricted:T,hasExcludedProperties:$}}l(e,s){const o=[];for(const u of Object.keys(e))if(c.$Do.test(u)){const $={};for(const A in e[u])$[A]=e[u][A];o.push({identifiers:(0,c.$Eo)(u),keys:Object.keys($),contents:(0,f.$bj)($,s)})}return o}}t.$Mo=E;class d extends I.$Tc{constructor(e,s,o,u,$){super(),this.c=e,this.f=s,this.g=u,this.h=$,this.b=this.B(new P.$je),this.onDidChange=this.b.event,this.a=new E(this.c.toString(),$),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,A=>A.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,A=>(A.isOperation(h.FileOperation.CREATE)||A.isOperation(h.FileOperation.COPY)||A.isOperation(h.FileOperation.DELETE)||A.isOperation(h.FileOperation.WRITE))&&o.isEqual(A.resource,e)))(()=>this.b.fire()))}async loadConfiguration(){try{const e=await this.g.readFile(this.c);return this.a.parse(e.value.toString()||"{}",this.f),this.a.configurationModel}catch{return O.createEmptyModel(this.h)}}reparse(e){return e&&(this.f=e),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}t.$No=d;class m{constructor(e,s,o,u,$,A,T,D,N,M,Y,J,re){this.a=e,this.b=s,this.c=o,this.overrideIdentifiers=u,this.d=$,this.f=A,this.g=T,this.h=D,this.i=N,this.j=M,this.k=Y,this.l=J,this.m=re}get value(){return v(this.c)}n(e){return e?.value!==void 0||e?.override!==void 0||e?.overrides!==void 0?e:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class R{constructor(e,s,o,u,$,A,T,D,N,M){this.j=e,this.l=s,this.m=o,this.n=u,this.p=$,this.q=A,this.r=T,this.s=D,this.t=N,this.u=M,this.h=null,this.i=new L.$zc,this.v=null}getValue(e,s,o){return this.w(e,s,o).getValue(e)}updateValue(e,s,o={}){let u;o.resource?(u=this.t.get(o.resource),u||(u=O.createEmptyModel(this.u),this.t.set(o.resource,u))):u=this.s,s===void 0?u.removeValue(e):u.setValue(e,s),o.resource||(this.h=null)}inspect(e,s,o){const u=this.w(e,s,o),$=this.A(s.resource,o),A=s.resource?this.t.get(s.resource)||this.s:this.s,T=new Set;for(const D of u.overrides)for(const N of D.identifiers)u.getOverrideValue(e,N)!==void 0&&T.add(N);return new m(e,s,u.getValue(e),T.size?[...T]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,$||void 0,A)}keys(e){const s=this.A(void 0,e);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(e){this.j=e,this.h=null,this.i.clear()}updatePolicyConfiguration(e){this.l=e}updateApplicationConfiguration(e){this.m=e,this.h=null,this.i.clear()}updateLocalUserConfiguration(e){this.n=e,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(e){this.p=e,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(e){this.q=e,this.h=null,this.i.clear()}updateFolderConfiguration(e,s){this.r.set(e,s),this.i.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this.i.delete(e)}compareAndUpdateDefaultConfiguration(e,s){const o=[];if(!s){const{added:u,updated:$,removed:A}=l(this.j,e);s=[...u,...$,...A]}for(const u of s)for(const $ of(0,c.$Eo)(u)){const A=this.j.getKeysForOverrideIdentifier($),T=e.getKeysForOverrideIdentifier($),D=[...T.filter(N=>A.indexOf(N)===-1),...A.filter(N=>T.indexOf(N)===-1),...A.filter(N=>!k.$fo(this.j.override($).getValue(N),e.override($).getValue(N)))];o.push([$,D])}return this.updateDefaultConfiguration(e),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(e){const{added:s,updated:o,removed:u}=l(this.l,e),$=[...s,...o,...u];return $.length&&this.updatePolicyConfiguration(e),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:s,updated:o,removed:u,overrides:$}=l(this.applicationConfiguration,e),A=[...s,...o,...u];return A.length&&this.updateApplicationConfiguration(e),{keys:A,overrides:$}}compareAndUpdateLocalUserConfiguration(e){const{added:s,updated:o,removed:u,overrides:$}=l(this.localUserConfiguration,e),A=[...s,...o,...u];return A.length&&this.updateLocalUserConfiguration(e),{keys:A,overrides:$}}compareAndUpdateRemoteUserConfiguration(e){const{added:s,updated:o,removed:u,overrides:$}=l(this.remoteUserConfiguration,e),A=[...s,...o,...u];return A.length&&this.updateRemoteUserConfiguration(e),{keys:A,overrides:$}}compareAndUpdateWorkspaceConfiguration(e){const{added:s,updated:o,removed:u,overrides:$}=l(this.workspaceConfiguration,e),A=[...s,...o,...u];return A.length&&this.updateWorkspaceConfiguration(e),{keys:A,overrides:$}}compareAndUpdateFolderConfiguration(e,s){const o=this.folderConfigurations.get(e),{added:u,updated:$,removed:A,overrides:T}=l(o,s),D=[...u,...$,...A];return(D.length||!o)&&this.updateFolderConfiguration(e,s),{keys:D,overrides:T}}compareAndDeleteFolderConfiguration(e){const s=this.folderConfigurations.get(e);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:o,updated:u,removed:$,overrides:A}=l(s,void 0);return{keys:[...o,...u,...$],overrides:A}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(e,s,o){let u=this.x(s,o);return s.overrideIdentifier&&(u=u.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(e)!==void 0&&(u=u.merge(this.l)),u}x({resource:e},s){let o=this.y();if(s&&e){const u=s.getFolder(e);u&&(o=this.z(u.uri)||o);const $=this.t.get(e);$&&(o=o.merge($))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(e){let s=this.i.get(e);if(!s){const o=this.y(),u=this.r.get(e);u?(s=o.merge(u),this.i.set(e,s)):s=o}return s}A(e,s){if(s&&e){const o=s.getFolder(e);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((e,s)=>{const{contents:o,overrides:u,keys:$}=this.r.get(s);return e.push([s,{contents:o,overrides:u,keys:$}]),e},[])}}allKeys(){const e=new Set;return this.j.keys.forEach(s=>e.add(s)),this.userConfiguration.keys.forEach(s=>e.add(s)),this.q.keys.forEach(s=>e.add(s)),this.r.forEach(s=>s.keys.forEach(o=>e.add(o))),[...e.values()]}B(){const e=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>e.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>e.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>e.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>e.add(o))),[...e.values()]}D(e){const s=new Set;return this.j.getKeysForOverrideIdentifier(e).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>s.add(o)),this.q.getKeysForOverrideIdentifier(e).forEach(o=>s.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(e).forEach(u=>s.add(u))),[...s.values()]}static parse(e,s){const o=this.E(e.defaults,s),u=this.E(e.policy,s),$=this.E(e.application,s),A=this.E(e.user,s),T=this.E(e.workspace,s),D=e.folders.reduce((N,M)=>(N.set(a.URI.revive(M[0]),this.E(M[1],s)),N),new L.$zc);return new R(o,u,$,A,O.createEmptyModel(s),T,D,O.createEmptyModel(s),new L.$zc,s)}static E(e,s){return new O(e.contents,e.keys,e.overrides,void 0,s)}}t.$Oo=R;function y(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,s=new Map;for(const u of r)u.keys.forEach($=>e.add($)),u.overrides.forEach(([$,A])=>{const T=(0,L.$wc)(s,$,new Set);A.forEach(D=>T.add(D))});const o=[];return s.forEach((u,$)=>o.push([$,[...u.values()]])),{keys:[...e.values()],overrides:o}}class i{constructor(e,s,o,u,$){this.change=e,this.f=s,this.g=o,this.h=u,this.i=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const A of e.keys)this.affectedKeys.add(A);for(const[,A]of e.overrides)for(const T of A)this.affectedKeys.add(T);this.d=this.a;for(const A of this.affectedKeys)this.d+=A+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=R.parse(this.f.data,this.i)),this.j}affectsConfiguration(e,s){const o=this.a+e,u=this.d.indexOf(o);if(u<0)return!1;const $=u+o.length;if($>=this.d.length)return!1;const A=this.d.charCodeAt($);if(A!==this.b&&A!==this.c)return!1;if(s){const T=this.previousConfiguration?this.previousConfiguration.getValue(e,s,this.f?.workspace):void 0,D=this.g.getValue(e,s,this.h);return!k.$fo(T,D)}return!0}}t.$Qo=i;function l(r,e){const{added:s,removed:o,updated:u}=n(e?.rawConfiguration,r?.rawConfiguration),$=[],A=r?.getAllOverrideIdentifiers()||[],T=e?.getAllOverrideIdentifiers()||[];if(e){const D=T.filter(N=>!A.includes(N));for(const N of D)$.push([N,e.getKeysForOverrideIdentifier(N)])}if(r){const D=A.filter(N=>!T.includes(N));for(const N of D)$.push([N,r.getKeysForOverrideIdentifier(N)])}if(e&&r){for(const D of A)if(T.includes(D)){const N=n({contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)},{contents:e.getOverrideValue(void 0,D)||{},keys:e.getKeysForOverrideIdentifier(D)});$.push([D,[...N.added,...N.removed,...N.updated]])}}return{added:s,removed:o,updated:u,overrides:$}}function n(r,e){const s=r?e?r.keys.filter($=>e.keys.indexOf($)===-1):[...r.keys]:[],o=e?r?e.keys.filter($=>r.keys.indexOf($)===-1):[...e.keys]:[],u=[];if(r&&e){for(const $ of e.keys)if(r.keys.indexOf($)!==-1){const A=(0,f.$ej)(e.contents,$),T=(0,f.$ej)(r.contents,$);k.$fo(A,T)||u.push($)}}return{added:s,removed:o,updated:u}}}),define(ce[115],le([0,1,19,4,2,26,3,66,40,6,39,37]),function(Q,t,S,P,w,I,L,k,g,a,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$To=t.$So=t.$Ro=void 0;class h extends w.$Tc{get configurationModel(){return this.b}constructor(E){super(),this.c=E,this.a=this.B(new P.$je),this.onDidChangeConfiguration=this.a.event,this.b=k.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(c.$oo.as(g.$to.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:d})=>this.f(Array.from(E),d))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(E,d){this.j(E,c.$oo.as(g.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}g(){return{}}h(){this.b=k.$Lo.createEmptyModel(this.c);const E=c.$oo.as(g.$to.Configuration).getConfigurationProperties();this.j(Object.keys(E),E)}j(E,d){const m=this.g();for(const R of E){const y=m[R],i=d[R];y!==void 0?this.b.setValue(R,y):i?this.b.setValue(R,i.default):this.b.removeValue(R)}}}t.$Ro=h;class p{constructor(){this.onDidChangeConfiguration=P.Event.None,this.configurationModel=k.$Lo.createEmptyModel(new a.$kk)}async initialize(){return this.configurationModel}}t.$So=p;let v=class extends w.$Tc{get configurationModel(){return this.b}constructor(E,d,m){super(),this.c=E,this.f=d,this.g=m,this.a=this.B(new P.$je),this.onDidChangeConfiguration=this.a.event,this.b=k.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const d={},m=[],R=c.$oo.as(g.$to.Configuration).getConfigurationProperties();for(const y of E){const i=R[y];if(!i){m.push(y);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}m.push(y),d[i.policy.name]={type:i.type}}}return(0,L.$pg)(d)||await this.f.updatePolicyDefinitions(d),m}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const d=c.$oo.as(g.$to.Configuration).getPolicyConfigurations(),m=(0,S.$Gb)(E.map(R=>d.get(R)));this.m(m,!0)}m(E,d){this.g.trace("PolicyConfiguration#update",E);const m=c.$oo.as(g.$to.Configuration).getConfigurationProperties(),R=[],y=this.b.isEmpty();for(const i of E){const l=m[i]?.policy?.name;if(l){const n=this.f.getPolicyValue(l);(y?n!==void 0:!(0,I.$fo)(this.b.getValue(i),n))&&R.push([i,n])}else this.b.getValue(i)!==void 0&&R.push([i,void 0])}if(R.length){this.g.trace("PolicyConfiguration#changed",R);const i=this.b;this.b=k.$Lo.createEmptyModel(this.g);for(const l of i.keys)this.b.setValue(l,i.getValue(l));for(const[l,n]of R)n===void 0?this.b.removeValue(l):this.b.setValue(l,n);d&&this.a.fire(this.b)}}};t.$To=v,t.$To=v=ve([se(1,f.$qo),se(2,a.$0j)],v)}),define(ce[116],le([0,1,19,8,13,4,34,77,2,30,26,12,16,29,66,40,115,9,39]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uo=void 0;class R extends g.$Tc{constructor(l,n,r,e){super(),this.m=l,this.n=e,this.h=this.B(new I.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new E.$Ro(e)),this.c=r instanceof m.$so?new E.$So:this.B(new E.$To(this.b,r,e)),this.f=this.B(new v.$No(this.m,{},h.$7g,n,e)),this.a=new v.$Oo(this.b.configurationModel,this.c.configurationModel,v.$Lo.createEmptyModel(e),v.$Lo.createEmptyModel(e),v.$Lo.createEmptyModel(e),v.$Lo.createEmptyModel(e),new a.$zc,v.$Lo.createEmptyModel(e),new a.$zc,e),this.j=new y(l,n,this),this.g=this.B(new P.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:o})=>this.s(s,o))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new v.$Oo(l,n,v.$Lo.createEmptyModel(this.n),r,v.$Lo.createEmptyModel(this.n),v.$Lo.createEmptyModel(this.n),new a.$zc,v.$Lo.createEmptyModel(this.n),new a.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,n){const r=typeof l=="string"?l:void 0,e=(0,p.$0i)(l)?l:(0,p.$0i)(n)?n:{};return this.a.getValue(r,e,void 0)}async updateValue(l,n,r,e,s){const o=(0,p.$$i)(r)?r:(0,p.$0i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,u=o?e:r;if(u!==void 0&&u!==p.ConfigurationTarget.USER_LOCAL&&u!==p.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,S.$Lb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const $=this.inspect(l,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if($.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,f.$fo)(n,$.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const T=o.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(N=>(0,S.$tb)([...N.identifiers].sort(),T));D&&(o.overrideIdentifiers=D.identifiers)}const A=o?.overrideIdentifiers?.length?[(0,O.$Fo)(o.overrideIdentifiers),l]:[l];await this.j.write(A,n),await this.reloadConfiguration()}inspect(l,n={}){return this.a.inspect(l,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(r,n,p.ConfigurationTarget.USER)}s(l,n){const r=this.a.toData(),e=this.a.compareAndUpdateDefaultConfiguration(l,n);this.u(e,r,p.ConfigurationTarget.DEFAULT)}t(l){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(l);this.u(r,n,p.ConfigurationTarget.DEFAULT)}u(l,n,r){const e=new v.$Qo(l,{data:n},this.a,void 0,this.n);e.source=r,this.h.fire(e)}}t.$Uo=R;class y{constructor(l,n,r){this.b=l,this.c=n,this.d=r,this.a=new P.$Jh}write(l,n){return this.a.queue(()=>this.e(l,n))}async e(l,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const e=[];if((0,L.$Vn)(r,e,{allowTrailingComma:!0,allowEmptyContent:!0}),e.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,l,n);r=(0,k.$ao)(r,s),await this.c.writeFile(this.b,w.$Le.fromString(r))}f(l,n,r){const{tabSize:e,insertSpaces:s,eol:o}=this.h;if(!n.length){const u=JSON.stringify(r,null,s?" ".repeat(e):"	");return[{content:u,length:u.length,offset:0}]}return(0,k.$0n)(l,n,r,{tabSize:e,insertSpaces:s,eol:o})}get h(){if(!this.g){let l=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(l=n),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ce[67],le([0,1,14]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$en=P,t.$fn=w,t.$gn=I,t.$hn=L;function P(g){return g.scheme===S.Schemas.vscodeRemote?g.authority:void 0}function w(g){if(!g)return;const a=g.indexOf("+");return a<0?g:g.substr(0,a)}function I(g){const{host:a,port:f}=k(g);if(typeof f>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function L(g,a){let{host:f,port:c}=k(g);return typeof c>"u"&&(c=a),{host:f,port:c}}function k(g){const a=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=g.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const c=g.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:g,port:void 0}}}),define(ce[22],le([0,1,31,10,67]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xn=t.$qn=t.$pn=t.$on=t.TargetPlatform=t.ExtensionType=t.$nn=t.$ln=t.$kn=t.$jn=t.$in=void 0,t.$mn=I,t.$rn=c,t.$sn=h,t.$tn=p,t.$un=v,t.$vn=O,t.$wn=E,S=ye(S),t.$in="extensions.user.cache",t.$jn="extensions.builtin.cache",t.$kn="undefined_publisher",t.$ln=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}t.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(L||(t.ExtensionType=L={}));var k;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(k||(t.TargetPlatform=k={}));class g{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,R){if(typeof m>"u"||m===null)return typeof R>"u"||R===null;if(typeof R>"u"||R===null)return!1;if(typeof m=="string"||typeof R=="string"){const y=typeof m=="string"?m:m.value,i=typeof R=="string"?R:R.value;return S.$Df(y,i)}return m._lower===R._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}t.$on=g;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const R of m)this.add(R)}add(m){this.c.add(g.toKey(m))}delete(m){return this.c.delete(g.toKey(m))}has(m){return this.c.has(g.toKey(m))}}t.$pn=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(g.toKey(m))}get(m){return this.c.get(g.toKey(m))}has(m){return this.c.has(g.toKey(m))}set(m,R){this.c.set(g.toKey(m),R)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}t.$qn=f;function c(d){return h(d)}function h(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function p(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function v(d,m){if(m){const R=`onResolveRemoteAuthority:${(0,w.$fn)(m)}`;return!!d.activationEvents?.includes(R)}return!1}function O(d){return d.map(m=>{const[R,y]=m.split("@");return{proposalName:R,version:y?parseInt(y):void 0}})}function E(d){return d.map(m=>m.split("@")[0])}t.$xn=(0,P.$Ci)("IBuiltinExtensionsScannerService")}),define(ce[20],le([0,1,12,5,22,10]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rp=t.$qp=t.$pp=t.$op=t.$np=t.$mp=t.$lp=t.$kp=t.ExtensionManagementErrorCode=t.$jp=t.ExtensionGalleryErrorCode=t.$ip=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.ExtensionInstallSource=t.$bp=t.$ap=t.$_o=t.$$o=t.$0o=t.$9o=t.$8o=void 0,t.$cp=k,t.$dp=g,t.$ep=a,t.$fp=f,t.$gp=c,t.$hp=h,t.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.$9o=new RegExp(t.$8o),t.$0o="__web_extension",t.$$o="skipWalkthrough",t.$_o="extensionInstallSource",t.$ap="dependecyOrPackExtensionInstall",t.$bp="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(t.ExtensionInstallSource=L={}));function k(i){switch(i){case w.TargetPlatform.WIN32_X64:return"Windows 64 bit";case w.TargetPlatform.WIN32_ARM64:return"Windows ARM";case w.TargetPlatform.LINUX_X64:return"Linux 64 bit";case w.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case w.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case w.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case w.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case w.TargetPlatform.DARWIN_X64:return"Mac";case w.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case w.TargetPlatform.WEB:return"Web";case w.TargetPlatform.UNIVERSAL:return w.TargetPlatform.UNIVERSAL;case w.TargetPlatform.UNKNOWN:return w.TargetPlatform.UNKNOWN;case w.TargetPlatform.UNDEFINED:return w.TargetPlatform.UNDEFINED}}function g(i){switch(i){case w.TargetPlatform.WIN32_X64:return w.TargetPlatform.WIN32_X64;case w.TargetPlatform.WIN32_ARM64:return w.TargetPlatform.WIN32_ARM64;case w.TargetPlatform.LINUX_X64:return w.TargetPlatform.LINUX_X64;case w.TargetPlatform.LINUX_ARM64:return w.TargetPlatform.LINUX_ARM64;case w.TargetPlatform.LINUX_ARMHF:return w.TargetPlatform.LINUX_ARMHF;case w.TargetPlatform.ALPINE_X64:return w.TargetPlatform.ALPINE_X64;case w.TargetPlatform.ALPINE_ARM64:return w.TargetPlatform.ALPINE_ARM64;case w.TargetPlatform.DARWIN_X64:return w.TargetPlatform.DARWIN_X64;case w.TargetPlatform.DARWIN_ARM64:return w.TargetPlatform.DARWIN_ARM64;case w.TargetPlatform.WEB:return w.TargetPlatform.WEB;case w.TargetPlatform.UNIVERSAL:return w.TargetPlatform.UNIVERSAL;default:return w.TargetPlatform.UNKNOWN}}function a(i,l){switch(i){case S.Platform.Windows:return l==="x64"?w.TargetPlatform.WIN32_X64:l==="arm64"?w.TargetPlatform.WIN32_ARM64:w.TargetPlatform.UNKNOWN;case S.Platform.Linux:return l==="x64"?w.TargetPlatform.LINUX_X64:l==="arm64"?w.TargetPlatform.LINUX_ARM64:l==="arm"?w.TargetPlatform.LINUX_ARMHF:w.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?w.TargetPlatform.ALPINE_X64:l==="arm64"?w.TargetPlatform.ALPINE_ARM64:w.TargetPlatform.UNKNOWN;case S.Platform.Mac:return l==="x64"?w.TargetPlatform.DARWIN_X64:l==="arm64"?w.TargetPlatform.DARWIN_ARM64:w.TargetPlatform.UNKNOWN;case S.Platform.Web:return w.TargetPlatform.WEB}}function f(i,l){return l===w.TargetPlatform.WEB&&!i.includes(w.TargetPlatform.WEB)}function c(i,l,n){return f(l,n)?!1:i===w.TargetPlatform.UNDEFINED||i===w.TargetPlatform.UNIVERSAL?!0:i===w.TargetPlatform.UNKNOWN?!1:i===n}function h(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var p;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(p||(t.SortBy=p={}));var v;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(v||(t.SortOrder=v={}));var O;(function(i){i.Install="install",i.Uninstall="uninstall"})(O||(t.StatisticType=O={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(t.InstallOperation=E={})),t.$ip=(0,I.$Ci)("extensionGalleryService");var d;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(d||(t.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}t.$jp=m;var R;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateExistingMetadata="UpdateExistingMetadata",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(R||(t.ExtensionManagementErrorCode=R={}));class y extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}t.$kp=y,t.$lp=(0,I.$Ci)("extensionManagementService"),t.$mp="extensionsIdentifiers/disabled",t.$np="extensionsIdentifiers/enabled",t.$op=(0,I.$Ci)("IGlobalExtensionEnablementService"),t.$pp=(0,I.$Ci)("IExtensionTipsService"),t.$qp=(0,P.localize2)(11334,"Extensions"),t.$rp=(0,P.localize2)(11335,"Preferences")}),define(ce[117],le([0,1,2,22,9]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tq=void 0;class I extends S.$Tc{constructor(k,g,a,f,c){super(),this.a=k,this.b=g,this.c=a,this.f=c,this.B(f.onDidInstallExtensions(h=>this.g(h))),this.B(f.onDidUninstallExtension(h=>this.h(h)))}g(k){for(const g of k)g.local&&this.invalidate(g.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const g of this.a.profiles)this.c.extUri.isEqual(g.extensionsResource,k)&&await this.j(g);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,P.$in))}catch(g){(0,w.$ol)(g)!==w.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g)}}}t.$Tq=I});var qe=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(ce[44],le([0,1,16,57,5,45,22,96]),function(Q,t,S,P,w,I,L,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wp=f,t.$Xp=c,t.$Yp=h,t.$Zp=p,t.$1p=v,t.$2p=O,t.$3p=E,t.$4p=d,P=qe(P),w=ye(w),I=ye(I);const g=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function f(y){return y=y.trim(),y==="*"||g.test(y)}function c(y){if(!f(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=y.match(g);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function h(y){if(!y)return null;const i=y.majorBase,l=y.majorMustEqual,n=y.minorBase;let r=y.minorMustEqual;const e=y.patchBase;let s=y.patchMustEqual;y.hasCaret&&(i===0||(r=!1),s=!1);let o=0;if(y.preRelease){const u=a.exec(y.preRelease);if(u){const[,$,A,T]=u;o=Date.UTC(Number($),Number(A)-1,Number(T))}}return{majorBase:i,majorMustEqual:l,minorBase:n,minorMustEqual:r,patchBase:e,patchMustEqual:s,isMinimum:y.hasGreaterEquals,notBefore:o}}function p(y,i,l){let n;typeof y=="string"?n=h(c(y)):n=y;let r;i instanceof Date?r=i.getTime():typeof i=="string"&&(r=new Date(i).getTime());let e;if(typeof l=="string"?e=h(c(l)):e=l,!n||!e)return!1;const s=n.majorBase,o=n.minorBase,u=n.patchBase;let $=e.majorBase,A=e.minorBase,T=e.patchBase;const D=e.notBefore;let N=e.majorMustEqual,M=e.minorMustEqual,Y=e.patchMustEqual;return e.isMinimum?s>$?!0:s<$?!1:o>A?!0:o<A||r&&r<D?!1:u>=T:(s===1&&$===0&&(!N||!M||!Y)&&($=1,A=0,T=0,N=!0,M=!1,Y=!1),s<$?!1:s>$?!N:o<A?!1:o>A?!M:u<T?!1:u>T?!Y:!(r&&r<D))}function v(y,i,l,n,r,e){const s=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return s.push([P.default.Error,w.localize(11266,null)]),s;if(typeof n.name!="string")return s.push([P.default.Error,w.localize(11267,null,"name")]),s;if(typeof n.version!="string")return s.push([P.default.Error,w.localize(11268,null,"version")]),s;if(!n.engines)return s.push([P.default.Error,w.localize(11269,null,"engines")]),s;if(typeof n.engines.vscode!="string")return s.push([P.default.Error,w.localize(11270,null,"engines.vscode")]),s;if(typeof n.extensionDependencies<"u"&&!R(n.extensionDependencies))return s.push([P.default.Error,w.localize(11271,null,"extensionDependencies")]),s;if(typeof n.activationEvents<"u"){if(!R(n.activationEvents))return s.push([P.default.Error,w.localize(11272,null,"activationEvents")]),s;if(typeof n.main>"u"&&typeof n.browser>"u")return s.push([P.default.Error,w.localize(11273,null,"activationEvents","main","browser")]),s}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&s.push([P.default.Warning,w.localize(11274,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return s.push([P.default.Error,w.localize(11275,null,"main")]),s;{const $=(0,S.$dh)(l,n.main);(0,S.$0g)($,l)||s.push([P.default.Warning,w.localize(11276,null,$.path,l.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return s.push([P.default.Error,w.localize(11277,null,"browser")]),s;{const $=(0,S.$dh)(l,n.browser);(0,S.$0g)($,l)||s.push([P.default.Warning,w.localize(11278,null,$.path,l.path)])}}if(!I.valid(n.version))return s.push([P.default.Error,w.localize(11279,null)]),s;const o=[];if(!O(y,i,n,r,o))for(const $ of o)s.push([P.default.Error,$]);if(e&&n.enabledApiProposals?.length){const $=[];if(!d([...n.enabledApiProposals],$))for(const A of $)s.push([P.default.Error,A])}return s}function O(y,i,l,n,r){return n||typeof l.main>"u"&&typeof l.browser>"u"?!0:m(y,i,l.engines.vscode,r)}function E(y,i,l){return y==="*"||m(i,l,y)}function d(y,i){if(y.length===0)return!0;const l=Array.isArray(i)?i:void 0,n=(l?void 0:i)??k.allApiProposals,r=[],e=(0,L.$vn)(y);for(const{proposalName:s,version:o}of e){const u=n[s];u&&o&&u.version!==o&&r.push(w.localize(11280,null,s))}return l?.push(...r),r.length===0}function m(y,i,l,n=[]){const r=h(c(l));if(!r)return n.push(w.localize(11281,null,l)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return n.push(w.localize(11282,null,l)),!1}else if(!r.majorMustEqual)return n.push(w.localize(11283,null,l)),!1;return p(y,i,r)?!0:(n.push(w.localize(11284,null,y,l)),!1)}function R(y){if(!Array.isArray(y))return!1;for(let i=0,l=y.length;i<l;i++)if(typeof y[i]!="string")return!1;return!0}}),define(ce[68],le([0,1,21,2,12,5,20,10]),function(Q,t,S,P,w,I,L,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0r=t.$9r=void 0,t.$8r=g;function g(f){return f.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}t.$9r=(0,k.$Ci)("languagePackService");let a=class extends P.$Tc{constructor(c){super(),this.c=c}async getAvailableLanguages(){const c=new S.$ue;setTimeout(()=>c.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const v=h.firstPage.filter(O=>O.properties.localizedLanguages?.length&&O.tags.some(E=>E.startsWith("lp-"))).map(O=>{const E=O.properties.localizedLanguages?.[0],d=g(O);return{...this.f(d,E,O),extensionId:O.identifier.id,galleryExtension:O}});return v.push(this.f("en","English")),v}f(c,h,p){const v=h??c;let O;if(v!==c&&(O=`(${c})`),c.toLowerCase()===w.$x.toLowerCase()&&(O??="",O+=(0,I.localize)(11188,null)),p?.installCount){O??="";const E=p.installCount;let d;E>1e6?d=`${Math.floor(E/1e5)/10}M`:E>1e3?d=`${Math.floor(E/1e3)}K`:d=String(E),O+=` $(cloud-download) ${d}`}return{id:c,label:v,description:O}}};t.$0r=a,t.$0r=a=ve([se(0,L.$ip)],a)}),define(ce[46],le([0,1,13,7,2,5,40,10,6,37]),function(Q,t,S,P,w,I,L,k,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6p=t.$5p=void 0,t.$7p=h,t.$8p=p,t.$9p=v,t.$0p=O,t.$$p=E,t.$_p=d,t.$5p=(0,k.$Ci)("requestService");class f{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?i[l]="*****":i[l]=this.b[l];this.a=i}return this.a}}class c extends w.$Tc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,I.localize)(11053,null),when:g.$pk.isEqualTo((0,g.$mk)(g.LogLevel.Trace)).serialize()})}async c(i,l,n){const r=`${i} #${++this.b}: ${l.url}`;this.a.trace(`${r} - begin`,l.type,new f(l.headers??{}));try{const e=await n();return this.a.trace(`${r} - end`,l.type,e.res.statusCode,e.res.headers),e}catch(e){throw this.a.error(`${r} - error`,l.type,(0,P.$9)(e)),e}}}t.$6p=c;function h(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function p(y){return y.res.statusCode===204}async function v(y){return p(y)?null:(await(0,S.$Xe)(y.stream)).toString()}async function O(y){if(!h(y))throw new Error("Server returned "+y.res.statusCode);return v(y)}async function E(y){if(!h(y))throw new Error("Server returned "+y.res.statusCode);if(p(y))return null;const l=(await(0,S.$Xe)(y.stream)).toString();try{return JSON.parse(l)}catch(n){throw n.message+=`:
`+l,n}}function d(y){R(y)}let m;function R(y){const i=a.$oo.as(L.$to.Configuration),l=m;m={id:"http",order:15,title:(0,I.localize)(11054,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(11055,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(11056,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,I.localize)(11057,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,I.localize)(11058,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(11059,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(11060,null),(0,I.localize)(11061,null),(0,I.localize)(11062,null),(0,I.localize)(11063,null)],default:"override",description:(0,I.localize)(11064,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(11065,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,I.localize)(11066,null),restricted:!0}}},i.updateConfigurations({add:[m],remove:l?[l]:[]})}R(L.ConfigurationScope.APPLICATION)}),define(ce[118],le([0,1,21,14,9,46]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FR=void 0;let L=class{constructor(g,a){this.a=g,this.b=a}async download(g,a,f=S.CancellationToken.None){if(g.scheme===P.Schemas.file||g.scheme===P.Schemas.vscodeRemote){await this.b.copy(g,a);return}const c={type:"GET",url:g.toString(!0)},h=await this.a.request(c,f);if(h.res.statusCode===200)await this.b.writeFile(a,h.stream);else{const p=await(0,I.$0p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${p}`)}}};t.$FR=L,t.$FR=L=ve([se(0,I.$5p),se(1,w.$0k)],L)}),define(ce[119],le([0,1,120,3]),function(Q,t,S,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bs=I;function w(L,k){return L.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:L.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function I(L,k,g={}){const a=(0,S.parse)(L),f=g.proxyUrl||w(a,k);if(!f)return null;const c=(0,S.parse)(f);if(!/^https?:$/.test(c.protocol||""))return null;const h={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,P.$ig)(g.strictSSL)?g.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((p,v)=>{Q(["http-proxy-agent"],p,v)}).then(ye)).HttpProxyAgent(f,h):new(await new Promise((p,v)=>{Q(["https-proxy-agent"],p,v)}).then(ye)).HttpsProxyAgent(f,h)}}),define(ce[121],le([0,1,60,15,5,21,38,7,12,27,85,151,8,78]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Om=O;let v;async function O(d,m,R,y){return R["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$j?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.$Hm)(y)&&!R["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.$Hm)(y)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=h.Promises.withAsyncBody(async(i,l)=>{const n=new I.$ue;let r=1e4;const e=d.getValue("application.shellEnvironmentResolutionTimeout");typeof e=="number"&&(r=(0,p.$Im)(e,1,120)*1e3);const s=setTimeout(()=>{n.dispose(!0),l(new Error((0,w.localize)(11050,null)))},r);try{i(await E(m,n.token))}catch(o){!(0,k.$3)(o)&&!n.token.isCancellationRequested?l(new Error((0,w.localize)(11051,null,(0,L.$nj)(o)))):i({})}finally{clearTimeout(s),n.dispose()}})),v)}async function E(d,m){const R=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",R);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",y);const i=(0,a.$Yg)().replace(/-/g,"").substr(0,12),l=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",n);const r=await(0,f.$xm)(g.OS,n);return d.trace("getUnixShellEnvironment#shell",r),new Promise((e,s)=>{if(m.isCancellationRequested)return s(new k.$4);const o=(0,P.$mc)(r);let u,$;const A="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${A} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,$=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${A} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,$=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,$=["-i","-l","-c"]):(u=`'${process.execPath}' ${A} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?$=["-ic"]:$=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify($),u);const T=(0,S.spawn)(r,[...$,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});m.onCancellationRequested(()=>(T.kill(),s(new k.$4))),T.on("error",M=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,L.$nj)(M)),s(M)});const D=[];T.stdout.on("data",M=>D.push(M));const N=[];T.stderr.on("data",M=>N.push(M)),T.on("close",(M,Y)=>{const J=Buffer.concat(D).toString("utf8");d.trace("getUnixShellEnvironment#raw",J);const re=Buffer.concat(N).toString("utf8");if(re.trim()&&d.trace("getUnixShellEnvironment#stderr",re),M||Y)return s(new Error((0,w.localize)(11052,null,M,Y)));const ae=l.exec(J),ue=ae?ae[1]:"{}";try{const de=JSON.parse(ue);R?de.ELECTRON_RUN_AS_NODE=R:delete de.ELECTRON_RUN_AS_NODE,y?de.ELECTRON_NO_ATTACH_CONSOLE=y:delete de.ELECTRON_NO_ATTACH_CONSOLE,delete de.VSCODE_RESOLVING_ENVIRONMENT,delete de.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",de),e(de)}catch(de){d.error("getUnixShellEnvironment#errorCaught",(0,L.$nj)(de)),s(de)}})})}}),define(ce[122],le([0,1,10]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=t.$hR=void 0,t.$hR=(0,S.$Ci)("stateReadService"),t.$iR=(0,S.$Ci)("stateService")}),define(ce[69],le([0,1,8,13,2,3,17,9,6]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=t.$jR=t.SaveStrategy=void 0;var a;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(a||(t.SaveStrategy=a={}));class f extends w.$Tc{constructor(v,O,E,d){super(),this.h=v,this.j=O,this.m=E,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Ah(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==k.FileOperationResult.FILE_NOT_FOUND&&this.m.error(v)}}getItem(v,O){const E=this.a[v];return(0,I.$lg)(E)?O:E}setItem(v,O){this.setItems([{key:v,data:O}])}setItems(v){let O=!1;for(const{key:E,data:d}of v)this.a[E]!==d&&((0,I.$lg)(d)?(0,I.$jg)(this.a[E])||(this.a[E]=void 0,O=!0):(this.a[E]=d,O=!0));O&&this.s()}removeItem(v){(0,I.$jg)(this.a[v])||(this.a[v]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.n.writeFile(this.h,P.$Le.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(O){this.m.error(O)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}t.$jR=f;let c=class extends w.$Tc{constructor(v,O,E,d){super(),this.a=this.B(new f(O.stateResource,v,E,d))}async init(){await this.a.init()}getItem(v,O){return this.a.getItem(v,O)}};t.$kR=c,t.$kR=c=ve([se(1,L.$Ji),se(2,g.$0j),se(3,k.$0k)],c);class h extends c{setItem(v,O){this.a.setItem(v,O)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}t.$lR=h}),define(ce[70],le([0,1,12,36,27]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sp=L,t.$tp=k;function I(g){if(S.$v===S.Platform.Linux&&/^penguin(\.|$)/i.test(g))return"chromebook"}function L(g,a,f,c,h,p,v,O,E,d){const m=Object.create(null);m["common.machineId"]=p,m["common.sqmId"]=v,m["common.devDeviceId"]=O,m.sessionID=(0,w.$Yg)()+Date.now(),m.commitHash=c,m.version=h,m["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,S.$i)(S.$v),m["common.nodePlatform"]=P.$cc,m["common.nodeArch"]=f,m["common.product"]=d||"desktop",E&&(m["common.msftInternal"]=E);let R=0;const y=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),S.$m&&(m["common.snap"]="true");const i=I(a);return i&&(m["common.platformDetail"]=i),m}function k(g){const a=P.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return g.some(c=>f===c)}}),define(ce[18],le([0,1,10]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.$hm=t.$gm=t.$fm=t.$em=t.$dm=t.$cm=t.$bm=t.$am=t.$_l=t.$$l=t.$0l=t.$9l=void 0,t.$9l=(0,S.$Ci)("telemetryService"),t.$0l=(0,S.$Ci)("customEndpointTelemetryService"),t.$$l="telemetry.currentSessionDate",t.$_l="telemetry.firstSessionDate",t.$am="telemetry.lastSessionDate",t.$bm="telemetry.machineId",t.$cm="telemetry.sqmId",t.$dm="telemetry.devDeviceId",t.$em="telemetry",t.$fm="telemetry.telemetryLevel",t.$gm="telemetry.enableCrashReporter",t.$hm="telemetry.enableTelemetry";var P;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(P||(t.TelemetryLevel=P={}));var w;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(w||(t.TelemetryConfiguration=w={}))}),define(ce[71],le([0,1,7,10,6,18]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sq=t.$rq=t.ExtensionSignatureVerificationCode=t.$qq=void 0,t.$qq=(0,P.$Ci)("IExtensionSignatureVerificationService");var L;(function(a){a.Success="Success",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(t.ExtensionSignatureVerificationCode=L={}));class k extends Error{constructor(f){super(f),this.code=f}}t.$rq=k;let g=class{constructor(f,c){this.b=f,this.c=c}d(){return this.a||(this.a=new Promise((f,c)=>Q(["@vscode/vsce-sign"],async h=>f(h),c))),this.a}async verify(f,c,h,p){let v;const O=f.identifier.id;try{v=await this.d()}catch(R){return this.b.error("Could not load vsce-sign module",(0,S.$9)(R)),this.b.info(`Extension signature verification is not done: ${O}`),!1}const E=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${O}...`),d=await v.verify(c,h,this.b.getLevel()===w.LogLevel.Trace)}catch(R){d={code:L.UnknownError,didExecute:!1,output:(0,S.$9)(R)}}const m=new Date().getTime()-E;if(this.b.info(`Extension signature verification result for ${O}: ${d.code}. Executed: ${d.didExecute}. Duration: ${m}ms.`),this.b.trace(`Extension signature verification output for ${O}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:O,extensionVersion:f.version,code:d.code,internalCode:d.internalCode,duration:m,didExecute:d.didExecute,clientTargetPlatform:p}),d.code===L.Success)return!0;throw new k(d.code)}};t.$sq=g,t.$sq=g=ve([se(0,w.$0j),se(1,I.$9l)],g)}),define(ce[41],le([0,1,26,3,67,70,18]),function(Q,t,S,P,w,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ap=t.$zp=t.$yp=t.$xp=t.$wp=t.$vp=t.$up=void 0,t.$Bp=f,t.$Cp=c,t.$Dp=h,t.$Ep=p,t.$Fp=O,t.$Gp=d,t.$Hp=m,t.$Ip=i;class k{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}t.$up=k;class g{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}t.$vp=g,t.$wp=new g;class a{async publicLog(n,r,e){}async publicLogError(n,r,e){}}t.$xp=a,t.$yp="telemetry",t.$zp="extensionTelemetryLog",t.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function f(l,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!l.enableTelemetry)}function c(l,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function h(l){const n=l.getValue(L.$fm),r=l.getValue(L.$gm);if(l.getValue(L.$hm)===!1||r===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function p(l){const n={},r={},e={};E(l,e);for(let s in e){s=s.length>150?s.substr(s.length-149):s;const o=e[s];typeof o=="number"?r[s]=o:typeof o=="boolean"?r[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),n[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[s]=o)}return{properties:n,measurements:r}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function O(l){if(!l)return"none";const n=(0,w.$fn)(l);return v.has(n)?n:"other"}function E(l,n,r=0,e){if(l)for(const s of Object.getOwnPropertyNames(l)){const o=l[s],u=e?e+s:s;Array.isArray(o)?n[u]=(0,S.$go)(o):o instanceof Date?n[u]=o.toISOString():(0,P.$eg)(o)?r<2?E(o,n,r+1,u+"."):n[u]=(0,S.$go)(o):n[u]=o}}function d(l,n){const r=l.msftInternalDomains||[],e=n.getValue("telemetry.internalTesting");return(0,I.$tp)(r)||e}function m(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function R(l,n){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let r=l;const e=[];for(const $ of n)for(;;){const A=$.exec(l);if(!A)break;e.push([A.index,$.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const $=o.exec(l);if(!$)break;const A=e.some(([T,D])=>$.index<D&&T<o.lastIndex);!s.test($[0])&&!A&&(r+=l.substring(u,$.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<l.length&&(r+=l.substr(u)),r}function y(l){if(!l)return l;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(l))return`<REDACTED: ${r.label}>`;return l}function i(l,n){return(0,S.$do)(l,r=>{if(r instanceof k||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let e=r.replaceAll("%20"," ");e=R(e,n);for(const s of n)e=e.replace(s,"");return e=y(e),e}})}}),define(ce[25],le([0,1,31,20,22,12,11,7,36,41]),function(Q,t,S,P,w,I,L,k,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sp=t.$Kp=void 0,t.$Jp=f,t.$Lp=v,t.$Mp=O,t.$Np=E,t.$Op=d,t.$Pp=m,t.$Qp=R,t.$Rp=y,t.$Tp=i,t.$Up=n;function f(r,e){return r.uuid&&e.uuid?r.uuid===e.uuid:r.id===e.id?!0:(0,S.$yf)(r.id,e.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(e){const s=e.manifest?e.manifest.version:e.version,o=e.manifest?e.targetPlatform:e.properties.targetPlatform;return new h(e.identifier,s,o)}static parse(e){const s=c.exec(e);return s&&s[1]&&s[2]?new h({id:s[1]},s[2],s[4]||void 0):null}constructor(e,s,o=w.TargetPlatform.UNDEFINED){this.identifier=e,this.version=s,this.targetPlatform=o,this.id=e.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==w.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(e){return e instanceof h?f(this,e)&&this.version===e.version&&this.targetPlatform===e.targetPlatform:!1}}t.$Kp=h;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(r){const e=p.exec(r);return e&&e[1]?[E(e[1]),e[2]]:[E(r),void 0]}function O(r,e){return`${r}.${e}`}function E(r){return r.toLowerCase()}function d(r,e){return E(O(r??w.$kn,e))}function m(r,e){const s=[],o=u=>{for(const $ of s)if($.some(A=>f(e(A),e(u))))return $;return null};for(const u of r){const $=o(u);$?$.push(u):s.push([u])}return s}function R(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function y(r){return{id:new a.$up(r.identifier.id),name:new a.$up(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}t.$Sp=new w.$on("pprice.better-merge");function i(r,e){const s=[],o=e.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&s.every($=>!f($.identifier,{id:u}))){const $=r.filter(A=>f(A.identifier,{id:u}));$.length===1&&(s.push($[0]),o.push(...$[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function l(r,e){if(!I.$l)return!1;let s;try{s=(await r.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){e.debug("Error while getting the os-release file.",(0,k.$9)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(r,e){const s=await l(r,e),o=(0,P.$ep)(s?"alpine":I.$v,g.$dc);return e.debug("ComputeTargetPlatform:",o),o}}),define(ce[123],le([0,1,21,7,14,16,45,11,5,20,25,22]),function(Q,t,S,P,w,I,L,k,g,a,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tq=void 0;const h=O=>(0,g.localize)(11302,null,O),p=(0,g.localize)(11303,null,"ms-dotnettools.csharp");let v=class{constructor(E,d,m){this.a=E,this.b=d,this.d=m}get f(){}async listExtensions(E,d,m){let R=await this.b.getInstalled(c.ExtensionType.User,m);const y=c.$nn.map(l=>l.toLowerCase());if(d&&d!==""){if(y.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}R=R.filter(l=>l.manifest.categories?l.manifest.categories.map(r=>r.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),y.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,g.localize)(11304,null,this.f)),R=R.sort((l,n)=>l.identifier.id.localeCompare(n.identifier.id));let i;for(const l of R)i!==l.identifier.id&&(i=l.identifier.id,this.a.info(E?`${i}@${l.manifest.version}`:i))}async installExtensions(E,d,m,R){const y=[];try{E.length&&this.a.info(this.f?(0,g.localize)(11305,null,this.f):(0,g.localize)(11306,null));const i=[],l=[],n=(e,s,o)=>{l.push({id:e,version:s!=="prerelease"?s:void 0,installOptions:{...m,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||m.installPreReleaseVersion}})};for(const e of E)if(e instanceof k.URI)i.push({vsix:e,installOptions:m});else{const[s,o]=(0,f.$Lp)(e);n(s,o,!1)}for(const e of d)if(e instanceof k.URI)i.push({vsix:e,installOptions:{...m,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,f.$Lp)(e);n(s,o,!0)}const r=await this.b.getInstalled(void 0,m.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:e,installOptions:s})=>{try{await this.h(e,s,R,r)}catch(o){this.a.error(o),y.push(e.toString())}})),l.length){const e=await this.g(l,r,R);y.push(...e)}}catch(i){throw this.a.error((0,g.localize)(11307,null,(0,P.$9)(i))),i}if(y.length)throw new Error((0,g.localize)(11308,null,y.join(", ")))}async updateExtensions(E){const d=await this.b.getInstalled(c.ExtensionType.User,E),m=[];for(const l of d)l.identifier.uuid&&m.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,g.localize)(11309,null,m.length));const R=await this.d.getExtensions(m,{compatible:!0},S.CancellationToken.None),y=[];for(const l of R)for(const n of d)(0,f.$Jp)(n.identifier,l.identifier)&&(0,L.gt)(l.version,n.manifest.version)&&y.push({extension:l,options:{operation:a.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:E,isApplicationScoped:n.isApplicationScoped}});if(!y.length){this.a.info((0,g.localize)(11310,null));return}this.a.info((0,g.localize)(11311,null,y.map(l=>l.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(y);for(const l of i)l.error?this.a.error((0,g.localize)(11312,null,l.identifier.id,(0,P.$9)(l.error))):this.a.info((0,g.localize)(11313,null,l.identifier.id,l.local?.manifest.version))}async g(E,d,m){if(E=E.filter(({id:l,version:n})=>{const r=d.find(e=>(0,f.$Jp)(e.identifier,{id:l}));if(r){if(!m&&(!n||n==="prerelease"&&r.preRelease))return this.a.info((0,g.localize)(11314,null,l,r.manifest.version,l)),!1;if(n&&r.manifest.version===n)return this.a.info((0,g.localize)(11315,null,`${l}@${n}`)),!1}return!0}),!E.length)return[];const R=[],y=[],i=await this.j(E);if(await Promise.all(E.map(async({id:l,version:n,installOptions:r})=>{const e=i.get(l.toLowerCase());if(!e){this.a.error(`${h(n?`${l}@${n}`:l)}
${p}`),R.push(l);return}try{const o=await this.d.getManifest(e,S.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),R.push(l);return}const s=d.find(o=>(0,f.$Jp)(o.identifier,e.identifier));if(s){if(e.version===s.manifest.version){this.a.info((0,g.localize)(11316,null,n?`${l}@${n}`:l));return}this.a.info((0,g.localize)(11317,null,l,e.version))}r.isBuiltin?this.a.info(n?(0,g.localize)(11318,null,l,n):(0,g.localize)(11319,null,l)):this.a.info(n?(0,g.localize)(11320,null,l,n):(0,g.localize)(11321,null,l)),y.push({extension:e,options:{...r,installGivenVersion:!!n,isApplicationScoped:s?.isApplicationScoped}})})),y.length){const l=await this.b.installGalleryExtensions(y);for(const n of l)n.error?(this.a.error((0,g.localize)(11322,null,n.identifier.id,(0,P.$9)(n.error))),R.push(n.identifier.id)):this.a.info((0,g.localize)(11323,null,n.identifier.id,n.local?.manifest.version))}return R}async h(E,d,m,R){const y=await this.b.getManifest(E);if(!y)throw new Error("Invalid vsix");if(await this.l(y,m,d.profileLocation,R))try{await this.b.install(E,{...d,installGivenVersion:!0}),this.a.info((0,g.localize)(11324,null,(0,I.$ah)(E)))}catch(l){if((0,P.$3)(l))this.a.info((0,g.localize)(11325,null,(0,I.$ah)(E)));else throw l}}async j(E){const d=new Map,m=E.some(i=>i.installOptions.installPreReleaseVersion),R=await this.b.getTargetPlatform(),y=[];for(const i of E)a.$9o.test(i.id)&&y.push({...i,preRelease:m});if(y.length){const i=await this.d.getExtensions(y,{targetPlatform:R},S.CancellationToken.None);for(const l of i)d.set(l.identifier.id.toLowerCase(),l)}return d}k(E){return!0}async l(E,d,m,R){if(!d){const y={id:(0,f.$Op)(E.publisher,E.name)},i=R.find(l=>(0,f.$Jp)(y,l.identifier)&&(0,L.gt)(l.manifest.version,E.version));if(i)return this.a.info((0,g.localize)(11326,null,i.identifier.id,i.manifest.version,E.version)),!1}return this.k(E)}async uninstallExtensions(E,d,m){const R=async i=>{if(i instanceof k.URI){const l=await this.b.getManifest(i);return(0,f.$Mp)(l.publisher,l.name)}return i},y=[];for(const i of E){const l=await R(i),r=(await this.b.getInstalled(void 0,m)).filter(e=>(0,f.$Jp)(e.identifier,{id:l}));if(!r.length)throw new Error(`${this.m(l)}
${p}`);if(r.some(e=>e.type===c.ExtensionType.System)){this.a.info((0,g.localize)(11327,null,l));return}if(!d&&r.some(e=>e.isBuiltin)){this.a.info((0,g.localize)(11328,null,l));return}this.a.info((0,g.localize)(11329,null,l));for(const e of r)await this.b.uninstall(e,{profileLocation:m}),y.push(e);this.f?this.a.info((0,g.localize)(11330,null,l,this.f)):this.a.info((0,g.localize)(11331,null,l))}}async locateExtension(E){const d=await this.b.getInstalled();E.forEach(m=>{d.forEach(R=>{if(R.identifier.id===m&&R.location.scheme===w.Schemas.file){this.a.info(R.location.fsPath);return}})})}m(E){return this.f?(0,g.localize)(11332,null,E,this.f):(0,g.localize)(11333,null,E)}};t.$tq=v,t.$tq=v=ve([se(1,a.$lp),se(2,a.$ip)],v)}),define(ce[124],le([0,1,7,4,2,30,25,22,9]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uq=void 0;class a extends w.$Tc{constructor(c,h,p,v,O,E,d){super(),this.f=c,this.g=h,this.h=p,this.j=v,this.m=O,this.n=E,this.r=d,this.a=this.B(new P.$je),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new w.$3c),this.s().then(null,m=>d.error("Error while initializing Extensions Watcher",(0,S.$9)(m)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(h=>(this.c.set(h.id,(0,w.$Qc)(this.n.watch(this.m.extUri.dirname(h.extensionsResource)),this.n.watch(h.extensionsResource))),this.G(h.extensionsResource))))}catch(h){throw this.r.error(h),h}}async w(c){for(const h of c.extensions)this.I(this.L(h.identifier,h.version),c.profileLocation)}async y(c){for(const h of c.extensions){const p=this.L(h.identifier,h.version);c.error?this.J(p,c.profileLocation):this.I(p,c.profileLocation)}}async z(c){for(const h of c.extensions)this.J(this.L(h.identifier,h.version),c.profileLocation)}async C(c){const h=[],p=[];for(const v of c.extensions){const O=this.L(v.identifier,v.version);c.error?this.I(O,c.profileLocation):(this.J(O,c.profileLocation),this.b.has(O)||(this.r.debug("Extension is removed from all profiles",v.identifier.id,v.version),p.push(this.f.scanInstalledExtensionAtLocation(v.location).then(E=>{E?h.push(E):this.r.info("Extension not found at the location",v.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(p),h.length&&await this.H(h)}catch(v){this.r.error(v)}}D(c){for(const h of this.h.profiles)c.contains(h.extensionsResource,g.FileChangeType.UPDATED,g.FileChangeType.ADDED)&&this.F(h.extensionsResource)}async F(c){const h=[],p=[],v=await this.j.scanProfileExtensions(c),O=new Set,E=new Set;for(const[d,m]of this.b)m.has(c)&&E.add(d);for(const d of v){const m=this.L(d.identifier,d.version);O.add(m),E.has(m)||(h.push(d.identifier),this.I(m,c))}for(const d of E)if(!O.has(d)){const m=this.M(d);m&&(p.push(m.identifier),this.J(d,c))}(h.length||p.length)&&this.a.fire({added:h.length?{extensions:h,profileLocation:c}:void 0,removed:p.length?{extensions:p,profileLocation:c}:void 0})}async G(c){const h=await this.j.scanProfileExtensions(c);for(const p of h)this.I(this.L(p.identifier,p.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(p=>!this.b.has(this.L(p.identifier,p.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,h){let p=this.b.get(c);p||this.b.set(c,p=new I.$Ac(v=>this.m.extUri.getComparisonKey(v))),p.add(h)}J(c,h){const p=this.b.get(c);p&&p.delete(h),p?.size||this.b.delete(c)}L(c,h){return`${k.$on.toKey(c.id)}@${h}`}M(c){const[h,p]=(0,L.$Lp)(c);return p?{identifier:{id:h},version:p}:void 0}}t.$Uq=a}),define(ce[125],le([0,1,32,152,19,8,2,14,15,28,17,20,25,6,68,11]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$r=void 0,S=ye(S);let E=class extends v.$0r{constructor(y,i,l,n){super(l),this.h=y,this.j=n,this.g=this.B(new d(i,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(y,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const r=n.translations[y];return r?O.URI.file(r):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),i=Object.keys(y).map(l=>{const n=y[l];return{...this.f(l,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((l,n)=>l.label.localeCompare(n.label)),i}async m(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",y.identifier.id),await this.update())}async n(y){const i=await this.g.getLanguagePacks();Object.keys(i).some(l=>i[l]&&i[l].extensions.some(n=>(0,h.$Jp)(n.extensionIdentifier,y.identifier)))&&(this.j.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(i);return!(0,w.$tb)(Object.keys(y),Object.keys(l))}};t.$$r=E,t.$$r=E=ve([se(0,c.$lp),se(1,f.$Ki),se(2,c.$ip),se(3,p.$0j)],E);let d=class extends L.$Tc{constructor(y,i){super(),this.j=i,this.c={},this.f=(0,g.$ic)(y.userDataPath,"languagepacks.json"),this.g=new I.$Jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.s(i=>{Object.keys(i).forEach(l=>delete i[l]),this.m(i,...y)}).then(()=>this.c)}m(y,...i){for(const l of i)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(y,l);Object.keys(y).forEach(l=>this.r(y[l]))}n(y,i){const l=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const r of n)if(i.location.scheme===k.Schemas.file&&m(r)){let e=y[r.languageId];e||(e={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},y[r.languageId]=e);const s=e.extensions.filter(o=>(0,h.$Jp)(o.extensionIdentifier,l))[0];s?s.version=i.manifest.version:e.extensions.push({extensionIdentifier:l,version:i.manifest.version});for(const o of r.translations)e.translations[o.id]=(0,g.$ic)(i.location.fsPath,o.path)}}r(y){if(y){const i=(0,P.createHash)("md5");for(const l of y.extensions)i.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);y.hash=i.digest("hex")}}s(y=()=>null){return this.g.queue(()=>{let i=null;return S.promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(i=y(l),l)).then(l=>{for(const r of Object.keys(l))l[r]||delete l[r];this.c=l,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),a.Promises.writeFile(this.f,n)}).then(()=>i,l=>this.j.error(l))})}};d=ve([se(0,f.$Ki),se(1,p.$0j)],d);function m(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const y of R.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}}),define(ce[126],le([0,1,81,7,26,41]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function g(f,c,h){const p=await(0,S.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),v=await(0,S.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),O=new p.AppInsightsCore,E=new v.PostChannel,d={instrumentationKey:f,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(h){d.extensionConfig={};const m={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};d.extensionConfig[E.identifier]=m}return O.initialize(d,[]),O.addTelemetryInitializer(m=>{m.ext=m.ext??{},m.ext.web=m.ext.web??{},m.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&(m.ext.utc=m.ext.utc??{},m.ext.utc.flags=8462029)}),O}class a{constructor(c,h,p,v,O){this.e=c,this.f=h,this.g=p,this.h=O,this.c=L,this.d=k,this.g||(this.g={}),typeof v=="function"?this.a=v():this.a=v,this.b=null}i(c){if(this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=g(this.a,this.e,this.h)),this.b.then(h=>{c(h)},h=>{(0,P.$Y)(h),console.error(h)})}}log(c,h){if(!this.a)return;h=(0,w.$eo)(h,this.g),h=(0,I.$Ep)(h);const p=this.f+"/"+c;try{this.i(v=>{v.pluginVersionString=h?.properties.version??"Unknown",v.track({name:p,baseData:{name:p,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}t.$dR=a});var qe=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(ce[127],le([0,1,2,26,12,31,5,29,40,128,33,37,18,41]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$es=void 0,a=qe(a);let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,m,R){this.k=m,this.l=R,this.d={},this.i=new S.$Sc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,I.$ff)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.$ff)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(h.$fm)||y.affectsConfiguration(h.$hm)||y.affectsConfiguration(h.$gm))&&this.m()}))}setExperimentProperty(d,m){this.d[d]=m}m(){let d=(0,p.$Dp)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const R=m.usage?h.TelemetryLevel.USAGE:m.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;d=Math.min(d,R)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,m,R){this.g<m||(R=(0,P.$eo)(R,this.d),R=(0,p.$Ip)(R,this.j),R=(0,P.$eo)(R,this.c),this.b.forEach(y=>y.log(d,R)))}publicLog(d,m){this.n(d,h.TelemetryLevel.USAGE,m)}publicLog2(d,m){this.publicLog(d,m)}publicLogError(d,m){this.h&&this.n(d,h.TelemetryLevel.ERROR,m)}publicLogError2(d,m){this.publicLogError(d,m)}};t.$es=v,t.$es=v=ve([se(1,k.$9i),se(2,f.$qk)],v);function O(){const E=(0,L.localize)(11031,null,a.default.nameLong),d=a.default.privacyStatementUrl?(0,L.localize)(11033,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,L.localize)(11032,null,"https://aka.ms/vscode-telemetry"),m=w.$p?"":(0,L.localize)(11034,null),R=(0,L.localize)(11035,null),y=(0,L.localize)(11036,null),i=(0,L.localize)(11037,null),l=(0,L.localize)(11038,null),n=`
|       | ${R} | ${y} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(11039,null);return`
${E} ${d} ${m}

&nbsp;

${l}
${n}

&nbsp;

${r}
`}c.$oo.as(g.$to.Configuration).registerConfiguration({id:h.$em,order:1,type:"object",title:(0,L.localize)(11040,null),properties:{[h.$fm]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(11041,null),(0,L.localize)(11042,null),(0,L.localize)(11043,null),(0,L.localize)(11044,null)],markdownDescription:O(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.$oo.as(g.$to.Configuration).registerConfiguration({id:h.$em,order:110,type:"object",title:(0,L.localize)(11045,null),properties:{[h.$hm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,L.localize)(11047,null,a.default.nameLong,a.default.privacyStatementUrl):(0,L.localize)(11046,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(11048,null,`\`#${h.$fm}#\``),scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[129],le([0,1,13,21,153,126]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=void 0,w=ye(w);async function L(f,c){const h=await c.request(f,P.CancellationToken.None),p=(await(0,S.$Xe)(h.stream)).toString(),v=h.res.statusCode??200;return{headers:h.res.headers,statusCode:v,responseData:p}}async function k(f){const c={method:f.type,headers:f.headers};return new Promise((p,v)=>{const O=w.request(f.url??"",c,E=>{E.on("data",function(d){p({headers:E.headers,statusCode:E.statusCode??200,responseData:d.toString()})}),E.on("error",function(d){v(d)})});O.write(f.data,E=>{E&&v(E)}),O.end()})}async function g(f,c,h){const p=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),v={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:p};try{const O=f?await L(v,f):await k(v);h(O.statusCode,O.headers,O.responseData)}catch{h(0,{})}}class a extends I.$dR{constructor(c,h,p,v,O){const E={sendPOST:(d,m)=>{g(c,d,m)}};super(h,p,v,O,E)}}t.$eR=a}),define(ce[130],le([0,1,32,15,28]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$chc=I,S=ye(S);async function I(L,k){const g=Object.create(null),a=(c,h)=>{const p=JSON.parse(c);g[h]=p};if(k){const c=[],h=await w.Promises.readdir(k);for(const v of h)try{(await S.promises.stat((0,P.$ic)(k,v))).isDirectory()&&c.push(v)}catch{}const p=[];for(const v of c)(await w.Promises.readdir((0,P.$ic)(k,v))).filter(E=>E==="telemetry.json").length===1&&p.push(v);for(const v of p){const O=(await S.promises.readFile((0,P.$ic)(k,v,"telemetry.json"))).toString();a(O,v)}}let f=(await S.promises.readFile((0,P.$ic)(L,"telemetry-core.json"))).toString();return a(f,"vscode-core"),f=(await S.promises.readFile((0,P.$ic)(L,"telemetry-extensions.json"))).toString(),a(f,"vscode-extensions"),JSON.stringify(g,null,4)}}),define(ce[131],le([0,1,12,83,18]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ygc=I,t.$zgc=L,t.$Agc=k;async function I(g,a){let f=g.getItem(w.$bm);return(typeof f!="string"||S.$k&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,P.$Qn)(a.error.bind(a))),f}async function L(g,a){let f=g.getItem(w.$cm);return typeof f!="string"&&(f=await(0,P.$Rn)(a.error.bind(a))),f}async function k(g,a){let f=g.getItem(w.$dm);return typeof f!="string"&&(f=await(0,P.$Sn)(a.error.bind(a))),f}}),define(ce[23],le([0,1,10]),function(Q,t,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hl=void 0,t.$Hl=(0,S.$Ci)("IUriIdentityService")}),define(ce[132],le([0,1,23,97,9,16,79,4,2]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rs=void 0;class a{static{this._clock=0}constructor(h){this.uri=h,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(h){this.g=h,this.c=new g.$Sc,this.f=2**16;const p=new Map,v=O=>{let E=p.get(O.scheme);return E===void 0&&(E=h.hasProvider(O)&&!this.g.hasCapability(O,w.FileSystemProviderCapabilities.PathCaseSensitive),p.set(O.scheme,E)),E};this.c.add(k.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(O=>{p.delete(O.scheme)})),this.extUri=new I.$5g(v),this.d=new L.$Qs((O,E)=>this.extUri.compare(O,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,I.$eh)(h));const p=this.d.get(h);return p?p.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new a(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((v,O)=>v[1].time<O[1].time?1:v[1].time>O[1].time?-1:0);a._clock=0,this.d.clear();const p=this.f*.5;for(let v=0;v<p;v++)this.d.set(h[v][0],h[v][1].touch())}};t.$Rs=f,t.$Rs=f=ve([se(0,w.$0k)],f),(0,P.$Os)(S.$Hl,f,P.InstantiationType.Delayed)}),define(ce[133],le([0,1,4,2,9,49,30]),function(Q,t,S,P,w,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ygc=void 0;class k extends P.$Tc{constructor(a,f,c,h,p,v){super(),this.f=a,this.g=f,this.h=c,this.j=h,this.m=p,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$je),this.onDidChangeFile=this.a.event,this.b=I.$Ii.forUris(()=>!(this.capabilities&w.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new L.$Ac(O=>this.m.extUri.getComparisonKey(this.t(O))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(O=>this.s(O)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,c,h,p){return this.g.read(a,f,c,h,p)}write(a,f,c,h,p){return this.g.write(a,f,c,h,p)}watch(a,f){this.b.set(a,a);const c=this.g.watch(this.t(a),f);return(0,P.$Rc)(()=>{this.b.delete(a),c.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,c){return this.g.rename(this.t(a),this.t(f),c)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,c){return this.g.readFileStream(this.t(a),f,c)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,c){return this.g.writeFile(this.t(a),f,c)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,c){if((0,w.$bl)(this.g))return this.g.copy(this.t(a),this.t(f),c);throw new Error("copy not supported")}cloneFile(a,f){if((0,w.$cl)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const c of a){if(c.resource.scheme!==this.f)continue;const h=this.u(c.resource);this.b.findSubstr(h)&&f.push({resource:h,type:c.type,cId:c.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}t.$Ygc=k}),define(ce[134],le([0,1,5,15,49,16,11,10,14]),function(Q,t,S,P,w,I,L,k,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5i=t.$2i=t.$1i=t.$Zi=t.$Yi=t.$Wi=t.$Vi=t.WorkbenchState=t.$Pi=t.$Oi=t.$Li=void 0,t.$Mi=a,t.$Ni=f,t.$Qi=c,t.$Ri=h,t.$Si=p,t.$Ti=O,t.$Ui=E,t.$Xi=R,t.$3i=y,t.$4i=i,t.$6i=l,t.$7i=n,t.$8i=r,t.$Li=(0,k.$Ci)("contextService");function a(e){const s=e;return typeof s?.id=="string"&&L.URI.isUri(s.uri)}function f(e){return typeof e?.id=="string"&&!a(e)&&!h(e)}t.$Oi={id:"ext-dev"},t.$Pi={id:"empty-window"};function c(e,s){if(typeof e=="string"||typeof e>"u")return typeof e=="string"?{id:(0,P.$mc)(e)}:s?t.$Oi:t.$Pi;const o=e;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function h(e){const s=e;return typeof s?.id=="string"&&L.URI.isUri(s.configPath)}function p(e){const s=e;if(s?.uri)return{id:s.id,uri:L.URI.revive(s.uri)};const o=e;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(e?.id)return{id:e.id}}var v;(function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"})(v||(t.WorkbenchState=v={}));function O(e){const s=e;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function E(e){const s=e;return!!(s&&typeof s=="object"&&L.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class d{constructor(s,o,u,$,A){this.h=s,this.j=u,this.k=$,this.l=A,this.c=w.$Ii.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=w.$Ii.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.$Vi=d;class m{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,I.$dh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.$Wi=m;function R(e){return new m({uri:e,index:0,name:(0,I.$_g)(e)},{uri:e.toString()})}t.$Yi="code-workspace",t.$Zi=`.${t.$Yi}`,t.$1i=[{name:(0,S.localize)(10864,null),extensions:[t.$Yi]}],t.$2i="workspace.json";function y(e,s){return I.$7g.isEqualOrParent(e,s.untitledWorkspacesHome)}function i(e){let s;return L.URI.isUri(e)?s=e:s=e.configuration,s?.scheme===g.Schemas.tmp}t.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(e){return e.id===t.$5i}function n(e,s){return!y(e,s)&&!i(e)}function r(e){return(typeof e=="string"?(0,P.$nc)(e):(0,I.$bh)(e))===t.$Zi}}),define(ce[24],le([0,1,43,4,2,16,11,5,17,9,10,6,134,30,23,8,27,31,3]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nl=t.$Ml=t.$Jl=t.ProfileResourceType=void 0,t.$Il=y,t.$Kl=i,t.$Ll=l;var R;(function(e){e.Settings="settings",e.Keybindings="keybindings",e.Snippets="snippets",e.Tasks="tasks",e.Extensions="extensions",e.GlobalState="globalState"})(R||(t.ProfileResourceType=R={}));function y(e){const s=e;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&L.URI.isUri(s.location)&&L.URI.isUri(s.globalStorageHome)&&L.URI.isUri(s.settingsResource)&&L.URI.isUri(s.keybindingsResource)&&L.URI.isUri(s.tasksResource)&&L.URI.isUri(s.snippetsHome)&&L.URI.isUri(s.extensionsResource))}t.$Jl=(0,f.$Ci)("IUserDataProfilesService");function i(e,s){return{id:e.id,isDefault:e.isDefault,name:e.name,shortName:e.shortName,icon:e.icon,location:L.URI.revive(e.location).with({scheme:s}),globalStorageHome:L.URI.revive(e.globalStorageHome).with({scheme:s}),settingsResource:L.URI.revive(e.settingsResource).with({scheme:s}),keybindingsResource:L.URI.revive(e.keybindingsResource).with({scheme:s}),tasksResource:L.URI.revive(e.tasksResource).with({scheme:s}),snippetsHome:L.URI.revive(e.snippetsHome).with({scheme:s}),extensionsResource:L.URI.revive(e.extensionsResource).with({scheme:s}),cacheHome:L.URI.revive(e.cacheHome).with({scheme:s}),useDefaultFlags:e.useDefaultFlags,isTransient:e.isTransient}}function l(e,s,o,u,$,A){return{id:e,name:s,location:o,isDefault:!1,shortName:$?.shortName,icon:$?.icon,globalStorageHome:A&&$?.useDefaultFlags?.globalState?A.globalStorageHome:(0,I.$dh)(o,"globalStorage"),settingsResource:A&&$?.useDefaultFlags?.settings?A.settingsResource:(0,I.$dh)(o,"settings.json"),keybindingsResource:A&&$?.useDefaultFlags?.keybindings?A.keybindingsResource:(0,I.$dh)(o,"keybindings.json"),tasksResource:A&&$?.useDefaultFlags?.tasks?A.tasksResource:(0,I.$dh)(o,"tasks.json"),snippetsHome:A&&$?.useDefaultFlags?.snippets?A.snippetsHome:(0,I.$dh)(o,"snippets"),extensionsResource:A&&$?.useDefaultFlags?.extensions?A.extensionsResource:(0,I.$dh)(o,"extensions.json"),cacheHome:(0,I.$dh)(u,e),useDefaultFlags:$?.useDefaultFlags,isTransient:$?.transient}}let n=class extends w.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,u,$){super(),this.t=s,this.u=o,this.w=u,this.y=$,this.f=!0,this.h=this.B(new P.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new p.$zc,workspaces:new p.$zc,emptyWindows:new Map},this.profilesHome=(0,I.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const A of this.O()){if(!A.name||!(0,m.$cg)(A.name)||!A.location){this.y.warn("Skipping the invalid stored profile",A.location||A.name);continue}o.push(l((0,I.$ah)(A.location),A.name,A.location,this.g,{shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags},s))}}catch(A){this.y.error(A)}const u=new p.$zc,$=new Map;if(o.length)try{const A=this.Q();if(A.workspaces)for(const[T,D]of Object.entries(A.workspaces)){const N=L.URI.parse(T),M=o.find(Y=>Y.id===D);M&&u.set(N,M)}if(A.emptyWindows)for(const[T,D]of Object.entries(A.emptyWindows)){const N=o.find(M=>M.id===D);N&&$.set(T,N)}}catch(A){this.y.error(A)}this.z={profiles:o,workspaces:u,emptyWindows:$}}return this.z}D(){const s=l("__default__profile__",(0,k.localize)(10911,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",u=new RegExp(`${(0,d.$ff)(o)}\\s(\\d+)`);let $=0;for(const T of this.profiles){const D=u.exec(T.name),N=D?parseInt(D[1]):0;$=N>$?N:$}const A=`${o} ${$+1}`;return this.createProfile((0,S.$qj)((0,E.$Yg)()).toString(16),A,{transient:!0},s)}async createNamedProfile(s,o,u){return this.createProfile((0,S.$qj)((0,E.$Yg)()).toString(16),s,o,u)}async createProfile(s,o,u,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const A=await this.F(s,o,u);return $&&await this.setProfileForWorkspace($,A),A}async F(s,o,u){if(!(0,m.$cg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let $=this.r.get(o);return $||($=(async()=>{try{if(this.profiles.find(N=>N.name===o||N.id===s))throw new Error(`Profile with ${o} name already exists`);const T=l(s,o,(0,I.$dh)(this.profilesHome,s),this.g,u,this.defaultProfile);await this.u.createFolder(T.location);const D=[];return this.j.fire({profile:T,join(N){D.push(N)}}),await O.Promises.settled(D),this.I([T],[],[]),T}finally{this.r.delete(o)}})(),this.r.set(o,$)),$}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find($=>$.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=l(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find($=>$.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this.m.fire({profile:o,join($){u.push($)}});try{await Promise.allSettled(u)}catch($){this.y.error($)}for(const $ of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get($)?.id&&this.C.emptyWindows.delete($);for(const $ of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get($)?.id&&this.C.workspaces.delete($);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch($){(0,a.$ol)($)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error($)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find($=>$.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,u)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s),u=L.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return u||((0,h.$Mi)(s)?this.s.folders.get(s.uri):(0,h.$Ri)(s)?this.s.workspaces.get(s.configPath):this.s.emptyWindows.get(s.id))}G(s){return(0,h.$Mi)(s)?s.uri:(0,h.$Ri)(s)?s.configPath:s.id}H(s){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,u){const $=[...this.profiles,...s],A=[],T=this.s.profiles;this.s.profiles=[];for(let D of $){if(D.isDefault||o.some(M=>D.id===M.id))continue;D=u.find(M=>D.id===M.id)??D;const N=T.find(M=>D.id===M.id);if(D.isTransient)this.s.profiles.push(D);else{if(N){for(const[M,Y]of this.s.emptyWindows.entries())if(D.id===Y.id){this.L({id:M},D);break}for(const[M,Y]of this.s.workspaces.entries())if(D.id===Y.id){this.L({id:"",configPath:M},D);break}for(const[M,Y]of this.s.folders.entries())if(D.id===Y.id){this.L({id:"",uri:M},D);break}}A.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags})}}this.P(A),this.z=void 0,this.J(s,o,u)}J(s,o,u){this.h.fire({added:s,removed:o,updated:u,all:this.profiles})}L(s,o,u){if(u=o?.isTransient?!0:u,u)(0,h.$Mi)(s)?(this.s.folders.delete(s.uri),o&&this.s.folders.set(s.uri,o)):(0,h.$Ri)(s)?(this.s.workspaces.delete(s.configPath),o&&this.s.workspaces.set(s.configPath,o)):(this.s.emptyWindows.delete(s.id),o&&this.s.emptyWindows.set(s.id,o));else{this.L(s,void 0,!0);const $=this.G(s);L.URI.isUri($)?(this.C.workspaces.delete($),o&&this.C.workspaces.set($,o)):(this.C.emptyWindows.delete($),o&&this.C.emptyWindows.set($,o)),this.M()}}M(){const s={};for(const[u,$]of this.C.workspaces.entries())s[u.toString()]=$.id;const o={};for(const[u,$]of this.C.emptyWindows.entries())o[u.toString()]=$.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},u=this.D();if(s.workspaces)for(const[A,T]of Object.entries(s.workspaces)){const D=L.URI.parse(T);o[A]=this.w.extUri.isEqual(D,u.location)?u.id:this.w.extUri.basename(D)}const $={};if(s.emptyWindows)for(const[A,T]of Object.entries(s.emptyWindows)){const D=L.URI.parse(T);$[A]=this.w.extUri.isEqual(D,u.location)?u.id:this.w.extUri.basename(D)}return{workspaces:o,emptyWindows:$}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};t.$Ml=n,t.$Ml=n=ve([se(0,g.$Ji),se(1,a.$0k),se(2,v.$Hl),se(3,c.$0j)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}t.$Nl=r}),define(ce[53],le([0,1,19,8,21,7,4,2,12,3,11,5,20,25,22,44,6,33,18,23,24]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m,R,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eq=t.$Cq=void 0,t.$Dq=l,c=ye(c);let i=class extends k.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,u,$,A,T){super(),this.z=s,this.C=o,this.D=u,this.F=$,this.G=A,this.H=T,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$je),this.s=this.B(new L.$je),this.t=this.B(new L.$je),this.u=this.B(new L.$je),this.w=this.B(new L.$je),this.y=[],this.B((0,k.$Rc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(u=>(0,h.$gp)(u,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const $=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:A})=>(0,p.$Jp)(A,s.identifier));if($?.local)return $?.local;throw $?.error?$.error:new h.$kp(`Unknown error while installing extension ${s.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(u){throw l(u)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new h.$kp(c.localize(11336,null),h.ExtensionManagementErrorCode.NotAllowed);const o=[],u=[];return await Promise.allSettled(s.map(async({extension:$,options:A})=>{try{const T=await this.N($,!!A?.installGivenVersion,!!A?.installPreReleaseVersion,A.productVersion??{version:this.G.version,date:this.G.date});u.push({...T,options:A})}catch(T){o.push({identifier:$.identifier,operation:h.InstallOperation.Install,source:$,error:T,profileLocation:A.profileLocation??this.X()})}})),u.length&&o.push(...await this.I(u)),o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,v.$rn)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let u=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(u=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const $ of this.H.profiles){const A=(await this.getInstalled(v.ExtensionType.User,$.extensionsResource)).find(T=>(0,p.$Jp)(T.identifier,s.identifier));A?this.w.fire({local:A,profileLocation:$.extensionsResource}):this.u.fire({identifier:s.identifier,profileLocation:$.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:h.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async resetPinnedStateForAllUserExtensions(s){try{await this.L(this.H.profiles.map(async o=>{const u=await this.getInstalled(v.ExtensionType.User,o.extensionsResource);await this.L(u.map(async $=>{$.pinned!==s&&await this.updateMetadata($,{pinned:s},o.extensionsResource)}))}))}catch(o){throw this.F.error("Error while resetting pinned state for all user extensions",(0,I.$9)(o)),o}}async I(s){const o=new Map,u=new Map,$=[],A=(D,N)=>`${p.$Kp.create(D).toString()}-${N.toString()}`,T=(D,N,M,Y)=>{const J=this.Y(D,N,M),re=`${(0,p.$Op)(D.publisher,D.name)}-${M.profileLocation.toString()}`;u.set(re,{task:J,root:Y}),this.n.fire({identifier:J.identifier,source:N,profileLocation:M.profileLocation}),this.F.info("Installing extension:",J.identifier.id,M),f.URI.isUri(N)||this.j.set(A(N,M.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:D,extension:N,options:M}of s){const Y=M.isApplicationScoped||M.isBuiltin||(0,v.$rn)(D),J={...M,installOnlyNewlyAddedFromExtensionPack:M.installOnlyNewlyAddedFromExtensionPack??!f.URI.isUri(N),isApplicationScoped:Y,profileLocation:Y?this.H.defaultProfile.extensionsResource:M.profileLocation??this.X(),productVersion:M.productVersion??{version:this.G.version,date:this.G.date}},re=f.URI.isUri(N)?void 0:this.j.get(A(N,J.profileLocation));re?(this.F.info("Extension is already requested to install",re.task.identifier.id,J.profileLocation.toString()),$.push(re.task.waitUntilTaskIsFinished())):T(D,N,J,void 0)}return await Promise.all([...u.values()].map(async({task:D})=>{if(D.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",D.identifier.id);else try{const N=await this.M(D.identifier,D.manifest,!!D.options.installOnlyNewlyAddedFromExtensionPack,!!D.options.installPreReleaseVersion,D.options.profileLocation,D.options.productVersion),M=await this.getInstalled(void 0,D.options.profileLocation,D.options.productVersion),Y={...D.options,context:{...D.options.context,[h.$ap]:!0}};for(const{gallery:J,manifest:re}of(0,S.$Lb)(N,({gallery:ae})=>ae.identifier.id)){if(u.has(`${J.identifier.id.toLowerCase()}-${Y.profileLocation.toString()}`))continue;const ae=this.j.get(A(J,Y.profileLocation));if(ae){if(this.J(D,ae.task)){const ue=ae.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,D.identifier.id,Y.profileLocation.toString()),ae.waitingTasks.push(D),$.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,de=>de.some(H=>(0,p.$Jp)(H.identifier,ue)))).then(de=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,D.identifier.id,Y.profileLocation.toString()),!de.find(Z=>(0,p.$Jp)(Z.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else M.some(({identifier:ue})=>(0,p.$Jp)(ue,J.identifier))||T(re,J,Y,D)}}catch(N){if(f.URI.isUri(D.source))(0,S.$Kb)(D.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",D.identifier.id,N.message),(0,S.$Kb)(D.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",D.identifier.id,N.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",D.identifier.id),N}})),await this.L([...u.entries()].map(async([D,{task:N}])=>{const M=new Date().getTime();let Y;try{Y=await N.run(),await this.L(this.y.map(J=>J.postInstall(Y,N.source,N.options,w.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(J){const re=l(J);throw f.URI.isUri(N.source)||n(this.C,N.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Rp)(N.source),error:re,source:N.options.context?.[h.$_o]}),o.set(D,{error:re,identifier:N.identifier,operation:N.operation,source:N.source,context:N.options.context,profileLocation:N.options.profileLocation,applicationScoped:N.options.isApplicationScoped}),this.F.error("Error while installing the extension",N.identifier.id,(0,I.$9)(re),N.options.profileLocation.toString()),re}if(!f.URI.isUri(N.source)){const J=N.operation===h.InstallOperation.Update,re=J?void 0:(new Date().getTime()-N.source.lastUpdated)/1e3;if(n(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Rp)(N.source),verificationStatus:N.verificationStatus,duration:new Date().getTime()-M,durationSinceUpdate:re,source:N.options.context?.[h.$_o]}),g.$p&&N.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,h.StatisticType.Install)}catch{}}o.set(D,{local:Y,identifier:N.identifier,operation:N.operation,source:N.source,context:N.options.context,profileLocation:N.options.profileLocation,applicationScoped:Y.isApplicationScoped})})),$.length&&await this.L($),[...o.values()]}catch(D){const N=(J,re,ae)=>{const ue=[];J.manifest.extensionDependencies?.length&&ue.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&ue.push(...J.manifest.extensionPack);for(const de of ue){if(ae.includes(de.toLowerCase()))continue;ae.push(de.toLowerCase());const H=o.get(`${de.toLowerCase()}-${re.toString()}`);H?.local&&(ae=N(H.local,re,ae))}return ae},M=J=>({identifier:J.identifier,operation:h.InstallOperation.Install,source:J.source,context:J.options.context,profileLocation:J.options.profileLocation,error:D}),Y=[];for(const[J,{task:re,root:ae}]of u){const ue=o.get(J);ue?ue.local&&ae&&!o.get(`${ae.identifier.id.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local&&(Y.push(this.Z(ue.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),o.set(J,M(re))):(re.cancel(),o.set(J,M(re)))}for(const[J,{task:re}]of u){const ae=o.get(J);if(!ae?.local||re.options.donotIncludePackAndDependencies)continue;N(ae.local,re.options.profileLocation,[ae.local.identifier.id.toLowerCase()]).slice(1).some(de=>u.has(`${de.toLowerCase()}-${re.options.profileLocation.toString()}`)&&!o.get(`${de.toLowerCase()}-${re.options.profileLocation.toString()}`)?.local)&&(Y.push(this.Z(ae.local,{versionOnly:!0,profileLocation:re.options.profileLocation})),o.set(J,M(re)))}throw Y.length&&await Promise.allSettled(Y.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(re){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,I.$9)(re))}})),D}finally{for(const{task:D}of u.values())D.source&&!f.URI.isUri(D.source)&&this.j.delete(A(D.source,D.options.profileLocation));if(o.size){const D=[...o.values()];for(const N of D)N.local&&this.F.info("Extension installed successfully:",N.identifier.id,N.profileLocation.toString());this.s.fire(D)}}}J(s,o){for(const[,{task:u,waitingTasks:$}]of this.j.entries())if(u===s&&($.includes(o)||$.some(A=>this.J(A,o)))||u===o&&$[0]&&!this.J(s,$[0]))return!1;return!0}async L(s,o){const u=[],$=[],A=await Promise.allSettled(s);for(const D of A)D.status==="fulfilled"?u.push(D.value):$.push(l(D.reason,o));if(!$.length)return u;if($.length===1)throw $[0];let T=new h.$kp("",h.ExtensionManagementErrorCode.Unknown);for(const D of $)T=new h.$kp(T.message?`${T.message}, ${D.message}`:D.message,D.code!==h.ExtensionManagementErrorCode.Unknown&&D.code!==h.ExtensionManagementErrorCode.Internal?D.code:T.code);throw T}async M(s,o,u,$,A,T){if(!this.z.isEnabled())return[];const D=await this.getInstalled(void 0,A,T),N=[],M=[],Y=async(J,re)=>{N.push(J);const ae=re.extensionDependencies||[],ue=[...ae];if(re.extensionPack){const de=u?D.find(H=>(0,p.$Jp)(H.identifier,J)):void 0;for(const H of re.extensionPack)de&&de.manifest.extensionPack&&de.manifest.extensionPack.some(Z=>(0,p.$Jp)({id:Z},{id:H}))||ue.every(Z=>!(0,p.$Jp)({id:Z},{id:H}))&&ue.push(H)}if(ue.length){const de=ue.filter(H=>N.every(Z=>!(0,p.$Jp)(Z,{id:H})));if(de.length){const H=await this.z.getExtensions(de.map(Z=>({id:Z,preRelease:$})),w.CancellationToken.None);for(const Z of H){if(N.find(x=>(0,p.$Jp)(x,Z.identifier)))continue;const B=ae.some(x=>(0,p.$Jp)({id:x},Z.identifier));let z;try{z=await this.N(Z,!1,$,T)}catch(x){if(B)throw x;this.F.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,I.$9)(x));continue}M.push({gallery:z.extension,manifest:z.manifest}),await Y(z.extension.identifier,z.manifest)}}}};return await Y(s,o),M}async N(s,o,u,$){let A;const T=await this.getExtensionsControlManifest();if(T.malicious.some(M=>(0,p.$Jp)(s.identifier,M)))throw new h.$kp(c.localize(11337,null,s.identifier.id),h.ExtensionManagementErrorCode.Malicious);const D=T.deprecated[s.identifier.id.toLowerCase()];if(D?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${D.extension.id}' extension instead.`),A=(await this.z.getExtensions([{id:D.extension.id,preRelease:D.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:$},w.CancellationToken.None))[0],!A)throw new h.$kp(c.localize(11338,null,s.identifier.id,D.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const M=await this.getTargetPlatform();throw new h.$kp(c.localize(11339,null,s.identifier.id,this.G.nameLong,(0,h.$cp)(M)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(A=await this.O(s,o,u,$),!A){const M=[];throw(0,O.$4p)(s.properties.enabledApiProposals??[],M)?!u&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],w.CancellationToken.None))[0]?new h.$kp(c.localize(11341,null,s.displayName??s.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$kp(c.localize(11342,null,s.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible):new h.$kp(c.localize(11340,null,s.displayName??s.identifier.id,M[0]),h.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",A.identifier.id);const N=await this.z.getManifest(A,w.CancellationToken.None);if(N===null)throw new h.$kp(`Missing manifest for extension ${A.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(N.version!==A.version)throw new h.$kp(`Cannot install '${A.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:A,manifest:N}}async O(s,o,u,$){const A=await this.getTargetPlatform();let T=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==u&&(T=(await this.z.getExtensions([{...s.identifier,preRelease:u}],{targetPlatform:A,compatible:!0,productVersion:$},w.CancellationToken.None))[0]||null),!T&&await this.z.isExtensionCompatible(s,u,A,$)&&(T=s),T||(o?T=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:A,compatible:!0,productVersion:$},w.CancellationToken.None))[0]||null:T=await this.z.getCompatibleExtension(s,u,A,$)),T}async P(s,o){const u={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},$=Y=>`${Y.id.toLowerCase()}${u.versionOnly?`-${s.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,A=this.m.get($(s.identifier));if(A)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),A.waitUntilTaskIsFinished();const T=Y=>{const J=this.Z(Y,u);return this.m.set($(J.extension.identifier),J),u.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,u.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.t.fire({identifier:Y.identifier,profileLocation:u.profileLocation,applicationScoped:Y.isApplicationScoped}),J},D=(Y,J)=>{J?u.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,u.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,J.message):u.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,u.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$Qp)(Y),error:J}),this.u.fire({identifier:Y.identifier,error:J?.code,profileLocation:u.profileLocation,applicationScoped:Y.isApplicationScoped})},N=[],M=[];try{N.push(T(s));const Y=await this.getInstalled(v.ExtensionType.User,u.profileLocation);if(u.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const J=this.S(s,Y);for(const re of J)this.m.has($(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):N.push(T(re))}u.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(N.map(J=>J.extension),Y,s),await this.L(N.map(async J=>{try{if(await J.run(),await this.L(this.y.map(re=>re.postUninstall(J.extension,u,w.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,h.StatisticType.Uninstall)}catch{}D(J.extension)}catch(re){const ae=l(re);throw D(J.extension,ae),ae}finally{M.push(J)}}))}catch(Y){const J=l(Y);for(const re of N){try{re.cancel()}catch{}M.includes(re)||D(re.extension,J)}throw J}finally{for(const Y of N)this.m.delete($(Y.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}Q(s,o,u){for(const $ of s){const A=this.U($,o);if(A.length){const T=A.filter(D=>!s.some(N=>(0,p.$Jp)(N.identifier,D.identifier)));if(T.length)throw new Error(this.R($,T,u))}}}R(s,o,u){return u===s?o.length===1?c.localize(11343,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?c.localize(11344,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):c.localize(11345,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?c.localize(11346,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?c.localize(11347,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):c.localize(11348,null,u.manifest.displayName||u.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,u=[]){if(u.indexOf(s)!==-1)return[];u.push(s);const $=s.manifest.extensionPack?s.manifest.extensionPack:[];if($.length){const A=o.filter(D=>!D.isBuiltin&&$.some(N=>(0,p.$Jp)({id:N},D.identifier))),T=[];for(const D of A)T.push(...this.S(D,o,u));return[...A,...T]}return[]}U(s,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some($=>(0,p.$Jp)({id:$},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,I.$9)(s)),{malicious:[],deprecated:{},search:[]}}}};t.$Cq=i,t.$Cq=i=ve([se(0,h.$ip),se(1,m.$9l),se(2,R.$Hl),se(3,E.$0j),se(4,d.$qk),se(5,y.$Jl)],i);function l(e,s){if(e instanceof h.$kp)return e;let o;return e instanceof h.$jp?o=new h.$kp(e.message,e.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):o=new h.$kp(e.message,(0,I.$3)(e)?h.ExtensionManagementErrorCode.Cancelled:s??h.ExtensionManagementErrorCode.Internal),o.stack=e.stack,o}function n(e,s,{extensionData:o,verificationStatus:u,duration:$,error:A,source:T,durationSinceUpdate:D}){let N,M;(0,a.$kg)(u)&&(u===!0?u="Verified":(u===!1||(N=h.ExtensionManagementErrorCode.Signature,M=u),u="Unverified")),A&&(N=A.code,A.code===h.ExtensionManagementErrorCode.Signature&&(M=A.message)),e.publicLog(s,{...o,verificationStatus:u,success:!A,duration:$,errorcode:N,errorcodeDetail:M,durationSinceUpdate:D,source:T})}class r{constructor(){this.d=new P.$Bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,P.$ph)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,P.$ph)(s=>new Promise((o,u)=>{const $=s.onCancellationRequested(()=>{$.dispose(),u(new I.$4)})})),this.d.open()),this.g.cancel()}}t.$Eq=r}),define(ce[42],le([0,1,8,13,2,4,30,11,20,25,9,10,6,24,23,3,7,18]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hq=t.$Gq=t.$Fq=t.ExtensionsProfileScanningErrorCode=void 0;var m;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m||(t.ExtensionsProfileScanningErrorCode=m={}));class R extends Error{constructor(r,e){super(r),this.code=e}}t.$Fq=R,t.$Gq=(0,c.$Ci)("IExtensionsProfileScannerService");let y=class extends w.$Tc{constructor(r,e,s,o,u,$){super(),this.j=r,this.m=e,this.n=s,this.r=o,this.s=u,this.t=$,this.b=this.B(new I.$je),this.onAddExtensions=this.b.event,this.c=this.B(new I.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.$je),this.onDidRemoveExtensions=this.g.event,this.h=new L.$zc}scanProfileExtensions(r,e){return this.u(r,void 0,e)}async addExtensionsToProfile(r,e,s){const o=[],u=[];try{return await this.u(e,$=>{const A=[];if(s)A.push(...$);else for(const T of $)r.some(([D])=>(0,a.$Jp)(D.identifier,T.identifier)&&D.manifest.version!==T.version)?o.push(T):A.push(T);for(const[T,D]of r){const N=A.findIndex(Y=>(0,a.$Jp)(Y.identifier,T.identifier)&&Y.version===T.manifest.version),M={identifier:T.identifier,version:T.manifest.version,location:T.location,metadata:D};N===-1?(u.push(M),A.push(M)):A.splice(N,1,M)}return u.length&&this.b.fire({extensions:u,profileLocation:e}),o.length&&this.f.fire({extensions:o,profileLocation:e}),A}),u.length&&this.c.fire({extensions:u,profileLocation:e}),o.length&&this.g.fire({extensions:o,profileLocation:e}),u}catch($){throw u.length&&this.c.fire({extensions:u,error:$,profileLocation:e}),o.length&&this.g.fire({extensions:o,error:$,profileLocation:e}),$}}async updateMetadata(r,e){const s=[];return await this.u(e,o=>{const u=[];for(const $ of o){const A=r.find(([T])=>(0,a.$Jp)(T.identifier,$.identifier)&&T.manifest.version===$.version);A&&($.metadata={...$.metadata,...A[1]},s.push($)),u.push($)}return u}),s}async removeExtensionFromProfile(r,e){const s=[];try{await this.u(e,o=>{const u=[];for(const $ of o)(0,a.$Jp)($.identifier,r.identifier)?s.push($):u.push($);return s.length&&this.f.fire({extensions:s,profileLocation:e}),u}),s.length&&this.g.fire({extensions:s,profileLocation:e})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:e}),o}}async u(r,e,s){return this.F(r).queue(async()=>{let o=[],u;try{const $=await this.m.readFile(r);u=JSON.parse($.value.toString().trim()||"[]")}catch($){if((0,f.$ol)($)!==f.FileOperationResult.FILE_NOT_FOUND)throw $;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&s?.bailOutWhenFileNotFound)throw new R((0,E.$9)($),m.ERROR_PROFILE_NOT_FOUND)}if(u){Array.isArray(u)||this.w(r);let $=!1;for(const A of u){i(A)||this.w(r);let T;if((0,O.$cg)(A.relativeLocation)&&A.relativeLocation)T=this.z(A.relativeLocation);else if((0,O.$cg)(A.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${A.location}`);continue}else{T=k.URI.revive(A.location);const D=this.y(T);D&&($=!0,A.relativeLocation=D)}(0,O.$jg)(A.metadata?.hasPreReleaseVersion)&&A.metadata?.preRelease&&($=!0,A.metadata.hasPreReleaseVersion=!0),o.push({identifier:A.identifier,location:T,version:A.version,metadata:A.metadata})}$&&await this.m.writeFile(r,P.$Le.fromString(JSON.stringify(u)))}if(e){o=e(o);const $=o.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.y(A.location),metadata:A.metadata}));await this.m.writeFile(r,P.$Le.fromString(JSON.stringify($)))}return o})}w(r){const e=new R(`Invalid extensions content in ${r.toString()}`,m.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:e.code}),e}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),e=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(u){if((0,f.$ol)(u)===f.FileOperationResult.FILE_NOT_FOUND)return;throw u}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const u=JSON.parse(s);Array.isArray(u)&&u.every($=>i($))?o=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,P.$Le.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,f.$ol)(u)===f.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(r)}catch(u){(0,f.$ol)(u)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}try{await this.m.del(e)}catch(u){(0,f.$ol)(u)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}return o})()),this.C}F(r){let e=this.h.get(r);return e||(e=new S.$Jh,this.h.set(r,e)),e}};t.$Hq=y,t.$Hq=y=ve([se(1,f.$0k),se(2,p.$Jl),se(3,v.$Hl),se(4,d.$9l),se(5,h.$0j)],y);function i(n){return(0,O.$eg)(n)&&(0,g.$hp)(n.identifier)&&(l(n.location)||(0,O.$cg)(n.location)&&n.location)&&((0,O.$jg)(n.relativeLocation)||(0,O.$cg)(n.relativeLocation))&&n.version&&(0,O.$cg)(n.version)}function l(n){return n?(0,O.$cg)(n.path)&&(0,O.$cg)(n.scheme):!1}});var qe=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(ce[54],le([0,1,19,8,26,13,7,34,89,2,14,15,12,16,45,57,3,11,5,17,25,22,44,9,10,6,33,4,48,42,24,23,95]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m,R,y,i,l,n,r,e,s,o,u,$,A,T,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oq=t.$Mq=t.$Lq=t.$Kq=t.Translations=void 0,t.$Nq=ae,w=ye(w),c=ye(c),h=ye(h),v=ye(v),O=qe(O);var N;(function(de){function H(Z,B){if(Z===B)return!0;const z=Object.keys(Z),x=new Set;for(const K of Object.keys(B))x.add(K);if(z.length!==x.size)return!1;for(const K of z){if(Z[K]!==B[K])return!1;x.delete(K)}return x.size===0}de.equals=H})(N||(t.Translations=N={})),t.$Kq=(0,r.$Ci)("IExtensionsScannerService");let M=class extends a.$Tc{constructor(H,Z,B,z,x,K,te,ne,j,W,q,b){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Z,this.r=B,this.s=z,this.t=x,this.u=K,this.w=te,this.y=ne,this.z=j,this.C=W,this.D=q,this.F=b,this.g=this.B(new o.$je),this.onDidChangeCache=this.g.event,this.h=(0,p.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(J,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Up)(this.w,this.y)),this.G}async scanAllExtensions(H,Z,B){const[z,x]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Z)]),K=B?await this.scanExtensionsUnderDevelopment(H,[...z,...x]):[];return this.L(z,x,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Z=[];Z.push(this.M(!!H.useCache,H.language)),Z.push(this.N(H.language,!!H.checkControlFile));const[B,z]=await Promise.all(Z);return this.J([...B,...z],i.ExtensionType.System,H,!1)}async scanUserExtensions(H){const Z=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(Z,!!H.profileLocation,i.ExtensionType.User,!H.includeUninstalled,H.language,!0,B,H.productVersion??this.R()),x=H.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let K;try{K=await x.scanExtensions(z)}catch(te){if(te instanceof $.$Fq&&te.code===$.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),K=await x.scanExtensions(z);else throw te}return K=await this.J(K,i.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(H,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===f.Schemas.file).map(async z=>{const x=await this.P(z,!1,i.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(x)).map(te=>(te.type=Z.find(ne=>(0,y.$Jp)(ne.identifier,te.identifier))?.type??te.type,this.n.validate(te,x)))}))).flat();return this.J(B,"development",H,!0)}return[]}async scanExistingExtension(H,Z,B){const z=await this.P(H,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),x=await this.n.scanExtension(z);return!x||!B.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(H,Z,B){const z=await this.P(H,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),x=await this.n.scanOneOrMultipleExtensions(z);return this.J(x,Z,B,!0)}async scanMultipleExtensions(H,Z,B){const z=[];return await Promise.all(H.map(async x=>{const K=await this.scanOneOrMultipleExtensions(x,Z,B);z.push(...K)})),this.J(z,Z,B,!0)}async scanMetadata(H){const Z=(0,p.$dh)(H,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(H,Z){const B=(0,p.$dh)(H,"package.json"),z=(await this.w.readFile(B)).value.toString(),x=JSON.parse(z);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,x.__metadata={...x.__metadata,...Z},await this.w.writeFile((0,p.$dh)(H,"package.json"),I.$Le.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof $.$Fq&&H.code===$.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,I.$Le.fromString(JSON.stringify([])))}catch(Z){(0,n.$ol)(Z)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$9)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Z,B,z){return B.includeAllVersions||(H=this.L(Z===i.ExtensionType.System?H:void 0,Z===i.ExtensionType.User?H:void 0,Z==="development"?H:void 0,await this.getTargetPlatform(),z)),B.includeInvalid||(H=H.filter(x=>x.isValid)),H.sort((x,K)=>{const te=c.$mc(x.location.fsPath),ne=c.$mc(K.location.fsPath);return te<ne?-1:te>ne?1:0})}L(H,Z,B,z,x){const K=(ne,j,W)=>{if(ne.isValid&&!j.isValid)return!1;if(ne.isValid===j.isValid){if(x&&v.gt(ne.manifest.version,j.manifest.version))return this.y.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${ne.location.path} with version ${ne.manifest.version}`),!1;if(v.eq(ne.manifest.version,j.manifest.version)){if(ne.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${j.location.path} in favour of system extension ${ne.location.path} with same version`),!1;if(ne.targetPlatform===z)return this.y.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return W?this.y.warn(`Overwriting user extension ${ne.location.path} with ${j.location.path}.`):this.y.debug(`Overwriting user extension ${ne.location.path} with ${j.location.path}.`),!0},te=new i.$qn;return H?.forEach(ne=>{const j=te.get(ne.identifier.id);(!j||K(j,ne,!1))&&te.set(ne.identifier.id,ne)}),Z?.forEach(ne=>{const j=te.get(ne.identifier.id);if(!j&&H&&ne.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${ne.location.path}.`);return}(!j||K(j,ne,!1))&&te.set(ne.identifier.id,ne)}),B?.forEach(ne=>{const j=te.get(ne.identifier.id);(!j||K(j,ne,!0))&&te.set(ne.identifier.id,ne),te.set(ne.identifier.id,ne)}),[...te.values()]}async M(H,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Z,!0,void 0,this.R()),x=await(H&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",x.length),x}async N(H,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const z=Z?await this.O():{},x=[],K=d.URI.file(c.$gc(c.$ic(f.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ne of B){const j=z[ne.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":x.push((0,p.$dh)(K,ne.name));break;default:x.push(d.URI.file(j));break}}const te=await Promise.all(x.map(async ne=>this.n.scanExtension(await this.P(ne,!1,i.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",te.length),(0,S.$Gb)(te)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Z,B,z,x,K,te,ne){const j=await this.f(x??h.$x),W=await this.Q(H),q=Z&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,b=q?await this.Q(q):void 0;return new Y(H,W,q,b,Z,te,B,z,K,ne.version,ne.date,this.C.commit,!this.z.isBuilt,x,j)}async Q(H){try{const Z=await this.w.stat(H);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};t.$Lq=M,t.$Lq=M=ve([se(4,A.$Jl),se(5,$.$Gq),se(6,n.$0k),se(7,e.$0j),se(8,R.$Ji),se(9,s.$qk),se(10,T.$Hl),se(11,r.$Bi)],M);class Y{constructor(H,Z,B,z,x,K,te,ne,j,W,q,b,F,U,C){this.location=H,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=z,this.profile=x,this.profileScanOptions=K,this.type=te,this.excludeObsolete=ne,this.validate=j,this.productVersion=W,this.productDate=q,this.productCommit=b,this.devMode=F,this.language=U,this.translations=C}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Z){return(0,p.$9g)(H.location,Z.location)&&H.mtime===Z.mtime&&(0,p.$9g)(H.applicationExtensionslocation,Z.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&H.profile===Z.profile&&w.$fo(H.profileScanOptions,Z.profileScanOptions)&&H.type===Z.type&&H.excludeObsolete===Z.excludeObsolete&&H.validate===Z.validate&&H.productVersion===Z.productVersion&&H.productDate===Z.productDate&&H.productCommit===Z.productCommit&&H.devMode===Z.devMode&&H.language===Z.language&&N.equals(H.translations,Z.translations)}}t.$Mq=Y;let J=class extends a.$Tc{constructor(H,Z,B,z,x,K,te){super(),this.g=H,this.h=Z,this.j=B,this.m=z,this.n=K,this.r=te,this.f=x.extensionsEnabledWithApiProposalVersion?.map(ne=>ne.toLowerCase())??[]}async scanExtensions(H){const Z=H.profile?await this.t(H):await this.s(H);let B={};if(H.excludeObsolete&&H.type===i.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(z)}catch{}return(0,E.$pg)(B)?Z:Z.filter(z=>!B[y.$Kp.create(z).toString()])}async s(H){const Z=await this.m.resolve(H.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async z=>{if(!z.isDirectory||H.type===i.ExtensionType.User&&(0,p.$ah)(z.resource).indexOf(".")===0)return null;const x=new Y(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(x)}));return(0,S.$Gb)(B).sort((z,x)=>z.location.path<x.location.path?-1:1)}async t(H){let Z=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){Z=Z.filter(z=>!z.metadata?.isApplicationScoped);const B=await this.u(H.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,H);Z.push(...B)}return Z}async u(H,Z,B){const z=await this.h.scanProfileExtensions(H,B.profileScanOptions);if(!z.length)return[];const x=await Promise.all(z.map(async K=>{if(Z(K)){const te=new Y(K.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(te,K.metadata)}return null}));return(0,S.$Gb)(x)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,p.$dh)(H.location,"package.json"))){const Z=await this.scanExtension(H);return Z?[Z]:[]}else return await this.scanExtensions(H)}catch(Z){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,L.$9)(Z)),[]}}async scanExtension(H,Z){try{let B=await this.w(H.location);if(B){B.publisher||(B.publisher=i.$kn),Z=Z??B.__metadata,delete B.__metadata;const z=(0,y.$Op)(B.publisher,B.name),x=Z?.id?{id:z,uuid:Z.id}:{id:z},K=Z?.isSystem?i.ExtensionType.System:H.type,te=K===i.ExtensionType.System||!!Z?.isBuiltin;B=await this.y(H.location,B,Y.createNlsConfiguration(H));let ne={type:K,identifier:x,manifest:B,location:H.location,isBuiltin:te,targetPlatform:Z?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return H.validate&&(ne=this.validate(ne,H)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(z.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,i.$wn)([...B.enabledApiProposals])),ne}}catch(B){H.type!==i.ExtensionType.System&&this.r.error(B)}return null}validate(H,Z){let B=!0;const z=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),x=(0,l.$1p)(Z.productVersion,Z.productDate,Z.location,H.manifest,H.isBuiltin,z);for(const[K,te]of x)K===O.default.Error&&(B=!1,this.r.error(this.F(Z.location,te)));return H.isValid=B,H.validations=x,H}async w(H){const Z=(0,p.$dh)(H,"package.json");let B;try{B=(await this.m.readFile(Z)).value.toString()}catch(x){return(0,n.$ol)(x)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,m.localize)(11294,null,Z.path,x.message))),null}let z;try{z=JSON.parse(B)}catch{const K=[];(0,k.$Vn)(B,K);for(const te of K)this.r.error(this.F(H,(0,m.localize)(11295,null,Z.path,te.offset,te.length,(0,g.$Iq)(te.error))));return null}return(0,k.$4n)(z)!=="object"?(this.r.error(this.F(H,(0,m.localize)(11296,null,Z.path))),null):z}async y(H,Z,B){const z=await this.z(H,Z,B);if(z)try{const x=[],K=await this.C(z.default,x);if(x.length>0)return x.forEach(ne=>{this.r.error(this.F(H,(0,m.localize)(11297,null,z.default?.path,(0,g.$Iq)(ne.error))))}),Z;if((0,k.$4n)(z)!=="object")return this.r.error(this.F(H,(0,m.localize)(11298,null,z.default?.path))),Z;const te=z.values||Object.create(null);return(0,D.$Jq)(this.r,Z,te,K)}catch{}return Z}async z(H,Z,B){const z=(0,p.$dh)(H,"package.nls.json"),x=(j,W)=>{W.forEach(q=>{this.r.error(this.F(H,(0,m.localize)(11299,null,j?.path,(0,g.$Iq)(q.error))))})},K=j=>{this.r.error(this.F(H,(0,m.localize)(11300,null,j?.path)))},te=`${Z.publisher}.${Z.name}`,ne=B.translations[te];if(ne)try{const j=d.URI.file(ne),W=(await this.m.readFile(j)).value.toString(),q=[],b=(0,k.$Vn)(W,q);return q.length>0?(x(j,q),{values:void 0,default:z}):(0,k.$4n)(b)!=="object"?(K(j),{values:void 0,default:z}):{values:b.contents?b.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let W;try{W=await this.D(H,B)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const q=(await this.m.readFile(W.localized)).value.toString(),b=[],F=(0,k.$Vn)(q,b);return b.length>0?(x(W.localized,b),{values:void 0,default:W.original}):(0,k.$4n)(F)!=="object"?(K(W.localized),{values:void 0,default:W.original}):{values:F,default:W.original}}catch{return{values:void 0,default:W.original}}}}async C(H,Z){if(H)try{const B=(await this.m.readFile(H)).value.toString();return(0,k.$Vn)(B,Z)}catch{}}D(H,Z){return new Promise((B,z)=>{const x=K=>{const te=(0,p.$dh)(H,`package.nls.${K}.json`);this.m.exists(te).then(ne=>{ne&&B({localized:te,original:(0,p.$dh)(H,"package.nls.json")});const j=K.lastIndexOf("-");j===-1?B({localized:(0,p.$dh)(H,"package.nls.json"),original:null}):(K=K.substring(0,j),x(K))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,p.$dh)(H,"package.nls.json"),original:null});x(Z.language)})}F(H,Z){return`[${H.path}]: ${Z}`}};J=ve([se(1,$.$Gq),se(2,T.$Hl),se(3,n.$0k),se(4,s.$qk),se(5,R.$Ji),se(6,e.$0j)],J);let re=class extends J{constructor(H,Z,B,z,x,K,te,ne,j){super(Z,z,x,K,te,ne,j),this.J=H,this.L=B,this.H=this.B(new P.$Ah(3e3)),this.I=this.B(new o.$je),this.onDidChangeCache=this.I.event}async scanExtensions(H){const Z=this.P(H),B=await this.M(Z);if(this.G=H,B&&B.input&&Y.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===i.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),B.result.map(x=>(x.location=d.URI.revive(x.location),x));const z=await super.scanExtensions(H);return await this.N(Z,{input:H,result:z}),z}async M(H){try{const Z=await this.m.readFile(H),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,u.$_h)(B.input)}}catch(Z){this.r.debug("Error while reading the extension cache file:",H.path,(0,L.$9)(Z))}return null}async N(H,Z){try{await this.m.writeFile(H,I.$Le.fromString(JSON.stringify(Z)))}catch(B){this.r.debug("Error while writing the extension cache file:",H.path,(0,L.$9)(B))}}async O(){if(!this.G)return;const H=this.P(this.G),Z=await this.M(H);if(!Z)return;const B=Z.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!w.$fo(z,B))try{this.r.info("Invalidating Cache",B,z),await this.m.del(H),this.I.fire()}catch(x){this.r.error(x)}}P(H){const Z=this.Q(H);return this.j.extUri.joinPath(Z.cacheHome,H.type===i.ExtensionType.System?i.$jn:i.$in)}Q(H){return H.type===i.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Z=>this.j.extUri.isEqual(H.location,Z.extensionsResource))??this.J:this.L.defaultProfile}};re=ve([se(2,A.$Jl),se(3,$.$Gq),se(4,T.$Hl),se(5,n.$0k),se(6,s.$qk),se(7,R.$Ji),se(8,e.$0j)],re);function ae(de,H){const Z=(0,y.$Mp)(de.manifest.publisher,de.manifest.name);return{id:Z,identifier:new i.$on(Z),isBuiltin:de.type===i.ExtensionType.System,isUserBuiltin:de.type===i.ExtensionType.User&&de.isBuiltin,isUnderDevelopment:H,extensionLocation:de.location,uuid:de.identifier.uuid,targetPlatform:de.targetPlatform,publisherDisplayName:de.publisherDisplayName,...de.manifest}}class ue extends M{constructor(H,Z,B,z,x,K,te,ne,j,W,q,b){super(H,Z,(0,p.$dh)(B,".vscode-oss-dev","extensions","control.json"),z,x,K,te,ne,j,W,q,b),this.S=(async()=>{if(h.$A)try{const F=await this.w.readFile(d.URI.file(h.$A));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}t.$Oq=ue}),define(ce[135],le([0,1,60,8,38,4,2,14,15,28,6,24]),function(Q,t,S,P,w,I,L,k,g,a,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sq=void 0;let h=class extends L.$Tc{constructor(v,O){super(),this.b=v,this.f=O,this.a=new P.$Ih(5)}async postUninstall(v){const O=this.g(v,"uninstall");O&&(this.f.info(v.identifier.id,v.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(O.script,"uninstall",O.args,!0,v),this.f.info("Finished running post uninstall script",v.identifier.id,v.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",v.identifier.id,v.manifest.version),this.f.error(E)}}));try{await a.Promises.rm(this.m(v))}catch(E){this.f.error("Error while removing extension storage path",v.identifier.id),this.f.error(E)}}g(v,O){const E=`vscode:${O}`;if(v.location.scheme===k.Schemas.file&&v.manifest&&v.manifest.scripts&&typeof v.manifest.scripts[E]=="string"){const d=v.manifest.scripts[E].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(v.identifier.id,v.manifest.version,`${E} should be a node script`),null):{script:(0,g.$ic)(v.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(v,O,E,d,m){return new Promise((R,y)=>{const i=this.j(v,O,E,m);let l;const n=r=>{l&&(clearTimeout(l),l=null),r?y(r):R(void 0)};i.on("error",r=>{n((0,w.$nj)(r)||"Unknown")}),i.on("exit",(r,e)=>{n(r?`post-${O} process exited with code ${r}`:void 0)}),d&&(l=setTimeout(()=>{l=null,i.kill(),y("timed out")},5e3))})}j(v,O,E,d){const m={silent:!0,execArgv:void 0},R=(0,S.fork)(v,[`--type=extension-post-${O}`,...E],m);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const y=I.Event.fromNodeEventEmitter(R.stdout,"data"),i=I.Event.fromNodeEventEmitter(R.stderr,"data");this.B(y(r=>this.f.info(d.identifier.id,d.manifest.version,`post-${O}`,r))),this.B(i(r=>this.f.error(d.identifier.id,d.manifest.version,`post-${O}`,r)));const l=I.Event.any(I.Event.map(y,r=>({data:`%c${r}`,format:[""]}),this.q),I.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return I.Event.debounce(l,(r,e)=>r?{data:r.data+e.data,format:[...r.format,...e.format]}:{data:e.data,format:e.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(d.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),R}m(v){return(0,g.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,v.identifier.id.toLowerCase())}};t.$Sq=h,t.$Sq=h=ve([se(0,c.$Jl),se(1,f.$0j)],h)}),define(ce[72],le([0,1,50,5,53,20]),function(Q,t,S,P,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pq=L,t.$Qq=k;function L(g){let a=I.ExtensionManagementErrorCode.Extract;return g instanceof S.$yq&&(g.type==="CorruptZip"?a=I.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(a=I.ExtensionManagementErrorCode.IncompleteZip)),(0,w.$Dq)(g,a)}async function k(g){let a;try{a=await(0,S.$Bq)(g,"extension/package.json")}catch(f){throw L(f)}try{return JSON.parse(a.toString("utf8"))}catch{throw new I.$kp((0,P.localize)(11285,null),I.ExtensionManagementErrorCode.Invalid)}}}),define(ce[136],le([0,1,8,7,2,14,16,45,3,27,28,50,29,17,53,20,25,72,71,9,6,18]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m,R,y,i){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),t.$Rq=void 0,k=ye(k);let n=class extends w.$Tc{static{l=this}static{this.c=".sigzip"}constructor(e,s,o,u,$,A,T){super(),this.h=s,this.j=o,this.m=u,this.n=$,this.r=A,this.t=T,this.extensionsDownloadDir=e.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(e,s,o,u){await this.g;const $=await this.w(e,s);let A=!1;if(o&&this.u(e)){let T;try{T=await this.y(e)}catch(D){try{await this.delete($)}catch(N){this.t.error(N)}throw D}try{A=await this.n.verify(e,$.fsPath,T.fsPath,u)}catch(D){if(A=D.code,A===m.ExtensionSignatureVerificationCode.PackageIsInvalidZip||A===m.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete($)}catch(N){this.t.error(N)}throw new O.$kp(c.$xq,O.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(T)}catch(D){this.t.error(D)}}}return{location:$,verificationStatus:A}}u(e){if(!e.isSigned)return this.t.info(`Extension is not signed: ${e.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,g.$ig)(s)?s:!0}async w(e,s){try{const o=(0,L.$dh)(this.extensionsDownloadDir,this.G(e)),u=await this.C(e,"vsix",async()=>{await this.z(e,o,$=>this.j.download(e,$,s));try{await this.D(o.fsPath,"extension/package.json")}catch($){try{await this.h.del(o)}catch(A){this.t.warn(`Error while deleting: ${o.path}`,(0,P.$9)(A))}throw $}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:e.identifier.id,attempts:u}),o}catch(o){throw(0,v.$Dq)(o,O.ExtensionManagementErrorCode.Download)}}async y(e){try{const s=(0,L.$dh)(this.extensionsDownloadDir,`.${(0,a.$Yg)()}`),o=await this.C(e,"sigzip",async()=>{await this.j.downloadSignatureArchive(e,s);try{await this.D(s.fsPath,".signature.p7s")}catch(u){try{await this.h.del(s)}catch($){this.t.warn(`Error while deleting: ${s.path}`,(0,P.$9)($))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:e.identifier.id,attempts:o}),s}catch(s){throw(0,v.$Dq)(s,O.ExtensionManagementErrorCode.DownloadSignature)}}async z(e,s,o){if(await this.h.exists(s))return;if(s.scheme!==I.Schemas.file){await o(s);return}const u=(0,L.$dh)(this.extensionsDownloadDir,`.${(0,a.$Yg)()}`);try{await o(u)}catch($){try{await this.h.del(u)}catch{}throw $}try{await f.Promises.rename(u.fsPath,s.fsPath,2*60*1e3)}catch($){try{await this.h.del(u)}catch{}let A=!1;try{A=await this.h.exists(s)}catch{}if(A)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",e.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,P.$9)($)}. Deleted the file from downloaded location`,u.path),$}}async C(e,s,o,u){let $=1;for(;;)try{return await o(),$}catch(A){if($++>u)throw A;this.t.warn(`Failed downloading ${s}. ${(0,P.$9)(A)}. Retry again...`,e.identifier.id)}}async D(e,s){try{await(0,c.$Bq)(e,s)}catch(o){throw(0,d.$Pq)(o)}}async delete(e){await this.g,await this.h.del(e)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const e=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(e.children){const s=[],o=[],u=[];for(const T of e.children)if(T.name.endsWith(l.c))u.push(T.resource);else{const D=E.$Kp.parse(T.name);D&&o.push([D,T])}const $=(0,E.$Pp)(o,([T])=>T),A=[];for(const T of $)T.sort((D,N)=>k.rcompare(D[0].version,N[0].version)),s.push(...T.slice(1).map(D=>D[1].resource)),A.push(T[0][1]);A.sort((T,D)=>T.mtime-D.mtime),s.push(...A.slice(0,Math.max(0,A.length-this.f)).map(T=>T.resource)),s.push(...u),await S.Promises.settled(s.map(T=>(this.t.trace("Deleting from cache",T.path),this.h.del(T))))}}catch(e){this.t.error(e)}}G(e){return this.f?E.$Kp.create(e).toString().toLowerCase():(0,a.$Yg)()}};t.$Rq=n,t.$Rq=n=l=ve([se(0,p.$Ki),se(1,R.$0k),se(2,O.$ip),se(3,h.$9i),se(4,m.$qq),se(5,i.$9l),se(6,y.$0j)],n)}),define(ce[137],le([0,1,32,8,13,21,38,7,4,43,2,30,14,15,16,45,3,11,27,28,50,5,61,17,53,20,25,42,54,136,135,72,117,124,22,44,9,10,6,33,18,23,24]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m,R,y,i,l,n,r,e,s,o,u,$,A,T,D,N,M,Y,J,re,ae,ue,de,H,Z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xq=t.$Wq=t.$Vq=void 0,S=ye(S),p=ye(p),O=ye(O),R=ye(R),i=ye(i),t.$Vq=(0,re.$Di)(e.$lp);const B=".vsctmp";let z=class extends r.$Cq{constructor(j,W,q,b,F,U,C,G,X,ee,oe,fe){super(j,W,oe,q,ee,fe),this.eb=F,this.fb=U,this.gb=C,this.hb=G,this.ib=X,this.db=new Map,this.tb=new c.$Ac;const me=this.B(G.createInstance(A.$Sq));this.ab=this.B(G.createInstance(x,we=>me.postUninstall(we))),this.bb=this.B(new D.$Tq(fe,X,oe,this,this.F)),this.cb=this.B(G.createInstance($.$Rq));const ge=this.B(new N.$Uq(this,this.eb,fe,U,oe,X,q));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.sb(we))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Up)(this.ib,this.F)),this.jb}async zip(j){this.F.trace("ExtensionManagementService#zip",j.identifier.id);const W=await this.rb(j),q=await(0,y.zip)((0,v.$dh)(this.cb.extensionsDownloadDir,(0,m.$Yg)()).fsPath,W);return d.URI.file(q)}async unzip(j){return this.F.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:W,cleanup:q}=await this.lb(j),b=p.$jc(W.fsPath);try{return await(0,T.$Qq)(b)}finally{await q()}}getInstalled(j,W=this.H.defaultProfile.extensionsResource,q={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(j??null,W,q)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(j){return this.ab.scanUserExtensionAtLocation(j)}async install(j,W={}){this.F.trace("ExtensionManagementService#install",j.toString());const{location:q,cleanup:b}=await this.lb(j);try{const F=await(0,T.$Qq)(p.$jc(q.fsPath)),U=(0,s.$Op)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,Y.$3p)(F.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(11286,null,U,this.G.version));const G=(await this.I([{manifest:F,extension:q,options:W}])).find(({identifier:X})=>(0,s.$Jp)(X,{id:U}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Dq)(new Error(`Unknown error while installing extension ${U}`))}finally{await b()}}async installFromLocation(j,W){this.F.trace("ExtensionManagementService#installFromLocation",j.toString());const q=await this.ab.scanUserExtensionAtLocation(j);if(!q||!q.manifest.name||!q.manifest.version)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.wb([[q,{source:"resource"}]],W),this.F.info("Successfully installed extension",q.identifier.id,W.toString()),q}async installExtensionsFromProfile(j,W,q){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",j,W.toString(),q.toString());const b=(await this.getInstalled(M.ExtensionType.User,W)).filter(F=>j.some(U=>(0,s.$Jp)(U,F.identifier)));if(b.length){const F=await Promise.all(b.map(U=>this.ab.scanMetadata(U,W)));await this.wb(b.map((U,C)=>[U,F[C]]),q),this.F.info("Successfully installed extensions",b.map(U=>U.identifier.id),q.toString())}return b}async updateMetadata(j,W,q){return this.F.trace("ExtensionManagementService#updateMetadata",j.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),j=await this.ab.updateMetadata(j,W,q),this.bb.invalidate(q),this.w.fire({local:j,profileLocation:q}),j}async reinstallFromGallery(j){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.z.isEnabled())throw new Error(i.localize(11287,null));const W=await this.getTargetPlatform(),[q]=await this.z.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:W,compatible:!0},I.CancellationToken.None);if(!q)throw new Error(i.localize(11288,null));await this.ab.setUninstalled(j);try{await this.ab.removeUninstalledExtension(j)}catch(b){throw new Error(i.localize(11289,null,(0,L.$nj)(b)))}return this.installFromGallery(q)}$(j,W,q,b){return this.ab.copyExtension(j,W,q,b)}copyExtensions(j,W){return this.ab.copyExtensions(j,W,{version:this.G.version,date:this.G.date})}markAsUninstalled(...j){return this.ab.setUninstalled(...j)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(j){this.F.error(j)}}async download(j,W,q){const{location:b}=await this.cb.download(j,W,!q);return b}async lb(j){if(j.scheme===h.Schemas.file)return{location:j,async cleanup(){}};this.F.trace("Downloading extension from",j.toString());const W=(0,v.$dh)(this.cb.extensionsDownloadDir,(0,m.$Yg)());return await this.gb.download(j,W),this.F.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.ib.del(W)}catch(b){this.F.error(b)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(j,W,q){const b=W instanceof d.URI?new s.$Kp({id:(0,s.$Op)(j.publisher,j.name)},j.version):s.$Kp.create(W);return this.hb.createInstance(K,b,j,W,q,(F,U)=>{if(W instanceof d.URI)return this.qb(b,W,q,U);let C=this.db.get(b.toString());return C||(this.db.set(b.toString(),C=this.pb(b,W,F,q,U)),C.finally(()=>this.db.delete(b.toString()))),C},this.ab)}Z(j,W){return new te(j,W.profileLocation,this.fb)}async pb(j,W,q,b,F){const{verificationStatus:U,location:C}=await this.cb.download(W,q,!b.donotVerifySignature,b.context?.[e.$bp]);try{if(F.isCancellationRequested)throw new k.$4;return await(0,T.$Qq)(C.fsPath),{local:await this.ab.extractUserExtension(j,C.fsPath,{id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName,targetPlatform:W.properties.targetPlatform,isApplicationScoped:b.isApplicationScoped,isMachineScoped:b.isMachineScoped,isBuiltin:b.isBuiltin,isPreReleaseVersion:W.properties.isPreReleaseVersion,hasPreReleaseVersion:W.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:b.installGivenVersion?!0:!!b.pinned,preRelease:(0,E.$ig)(b.preRelease)?b.preRelease:b.installPreReleaseVersion||W.properties.isPreReleaseVersion,source:"gallery"},!1,F),verificationStatus:U}}catch(G){try{await this.cb.delete(C)}catch(X){this.F.warn("Error while deleting the downloaded file",C.toString(),(0,k.$9)(X))}throw(0,r.$Dq)(G)}}async qb(j,W,q,b){return{local:await this.ab.extractUserExtension(j,p.$jc(W.fsPath),{isApplicationScoped:q.isApplicationScoped,isMachineScoped:q.isMachineScoped,isBuiltin:q.isBuiltin,installedTimestamp:Date.now(),pinned:q.installGivenVersion?!0:!!q.pinned,source:"vsix"},!0,b)}}async rb(j){const W=async b=>{let F=await R.Promises.readdir(b);F=F.map(G=>p.$ic(b,G));const U=await Promise.all(F.map(G=>S.promises.stat(G)));let C=Promise.resolve([]);return U.forEach((G,X)=>{const ee=F[X];G.isFile()&&(C=C.then(oe=>[...oe,ee])),G.isDirectory()&&(C=C.then(oe=>W(ee).then(fe=>[...oe,...fe])))}),C};return(await W(j.location.fsPath)).map(b=>({path:`extension/${p.$kc(j.location.fsPath,b)}`,localPath:b}))}async sb({added:j,removed:W}){if(W){const q=j&&this.D.extUri.isEqual(W.profileLocation,j.profileLocation)?W.extensions.filter(b=>j.extensions.every(F=>!(0,s.$Jp)(F,b))):W.extensions;for(const b of q)this.F.info("Extensions removed from another source",b.id,W.profileLocation.toString()),this.u.fire({identifier:b,profileLocation:W.profileLocation})}if(j){const b=(await this.getInstalled(M.ExtensionType.User,j.profileLocation)).filter(F=>j.extensions.some(U=>(0,s.$Jp)(U,F.identifier)));this.s.fire(b.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,j.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:j.profileLocation,operation:e.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(W=>this.tb.add(W)));const j=await this.ib.resolve(this.eb.userExtensionsLocation);for(const W of j.children??[])W.isDirectory&&this.tb.add(W.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(W=>this.vb(W)))}async vb(j){if(!j.affects(this.eb.userExtensionsLocation,J.FileChangeType.ADDED))return;const W=[];for(const q of j.rawAdded){if(this.tb.has(q)||!this.D.extUri.isEqual(this.D.extUri.dirname(q),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(q,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(q).startsWith(".")||!(await this.ib.stat(q)).isDirectory)continue;const b=await this.ab.scanUserExtensionAtLocation(q);b&&b.installedTimestamp===void 0&&(this.tb.add(q),W.push(b))}W.length&&(await this.wb(W.map(q=>[q,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",W.map(q=>q.identifier.id)))}async wb(j,W){const q=j.map(b=>b[0]);await this.xb(q),await this.fb.addExtensionsToProfile(j,W),this.s.fire(q.map(b=>({local:b,identifier:b.identifier,operation:e.InstallOperation.None,profileLocation:W})))}async xb(j){const W=await this.ab.getUninstalledExtensions();for(const q of j){const b=s.$Kp.create(q);W[b.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",b.id),await this.ab.setInstalled(b),this.F.info("Removed the extension from uninstalled list:",b.id))}}};t.$Wq=z,t.$Wq=z=ve([se(0,e.$ip),se(1,de.$9l),se(2,ae.$0j),se(3,n.$Ki),se(4,u.$Kq),se(5,o.$Gq),se(6,l.$Yo),se(7,re.$Bi),se(8,J.$0k),se(9,ue.$qk),se(10,H.$Hl),se(11,Z.$Jl)],z);let x=class extends f.$Tc{constructor(j,W,q,b,F,U,C){super(),this.n=j,this.s=W,this.t=q,this.u=b,this.w=F,this.y=U,this.z=C,this.h=this.B(new g.$je),this.onExtract=this.h.event,this.j=new c.$zc,this.m=new c.$zc,this.c=(0,v.$dh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Jh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(j,W,q){try{const b={includeInvalid:!0,profileLocation:W,productVersion:q};let F=[];if(j===null||j===M.ExtensionType.System){let U=this.j.get(W);U||(U=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},b,!1).finally(()=>this.j.delete(W)),this.j.set(W,U)),F.push(...await U)}else if(j===M.ExtensionType.User){let U=this.m.get(W);U||(U=this.t.scanUserExtensions(b).finally(()=>this.m.delete(W)),this.m.set(W,U)),F.push(...await U)}return F=j!==null?F.filter(U=>U.type===j):F,await Promise.all(F.map(U=>this.H(U)))}catch(b){throw(0,r.$Dq)(b,e.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(j){try{const W=await this.t.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return await Promise.all(W.map(q=>this.H(q)))}catch(W){throw(0,r.$Dq)(W,e.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(j){try{const W=await this.t.scanExistingExtension(j,M.ExtensionType.User,{includeInvalid:!0});if(W)return await this.H(W)}catch(W){this.z.error(W)}return null}async extractUserExtension(j,W,q,b,F){const U=j.toString(),C=d.URI.file(p.$ic(this.t.userExtensionsLocation.fsPath,`.${(0,m.$Yg)()}`)),G=d.URI.file(p.$ic(this.t.userExtensionsLocation.fsPath,U));let X=await this.s.exists(G);if(X&&b){try{await this.D(j.id,G,"removeExisting")}catch{throw new e.$kp(i.localize(11290,null,G.fsPath,j.id),e.ExtensionManagementErrorCode.Delete)}X=!1}if(X)try{await this.t.updateMetadata(G,q)}catch(ee){throw this.y.publicLog2("extension:extract",{extensionId:j.id,code:`${(0,J.$ol)(ee)}`}),(0,r.$Dq)(ee,e.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(F.isCancellationRequested)throw new k.$4;try{this.z.trace(`Started extracting the extension from ${W} to ${G.fsPath}`),await(0,y.$Aq)(W,C.fsPath,{sourcePath:"extension",overwrite:!0},F),this.z.info(`Extracted extension to ${G}:`,j.id)}catch(ee){throw(0,T.$Pq)(ee)}try{await this.t.updateMetadata(C,q)}catch(ee){throw this.y.publicLog2("extension:extract",{extensionId:j.id,code:`${(0,J.$ol)(ee)}`}),(0,r.$Dq)(ee,e.ExtensionManagementErrorCode.UpdateMetadata)}if(F.isCancellationRequested)throw new k.$4;try{this.z.trace(`Started renaming the extension from ${C.fsPath} to ${G.fsPath}`),await this.G(C.fsPath,G.fsPath),this.z.info("Renamed to",G.fsPath)}catch(ee){if(ee.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);try{await this.s.del(C,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,k.$9)(ee)}. Deleted from extracted location`,C),ee}this.h.fire(G)}catch(ee){try{await this.s.del(C,{recursive:!0})}catch{}throw ee}return this.scanLocalExtension(G,M.ExtensionType.User)}async scanMetadata(j,W){return W?(await this.C(j,W))?.metadata:this.t.scanMetadata(j.location)}async C(j,W){return(await this.u.scanProfileExtensions(W)).find(b=>(0,s.$Jp)(b.identifier,j.identifier))}async updateMetadata(j,W,q){try{q?await this.u.updateMetadata([[j,W]],q):await this.t.updateMetadata(j.location,W)}catch(b){throw this.y.publicLog2("extension:extract",{extensionId:j.identifier.id,code:`${(0,J.$ol)(b)}`}),(0,r.$Dq)(b,e.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(j.location,j.type,q)}async getUninstalledExtensions(){try{return await this.F()}catch(j){throw(0,r.$Dq)(j,e.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...j){const W=j.map(q=>s.$Kp.create(q));await this.F(q=>W.forEach(b=>{q[b.toString()]=!0,this.z.info("Marked extension as uninstalled",b.toString())}))}async setInstalled(j){try{await this.F(W=>delete W[j.toString()])}catch(W){throw(0,r.$Dq)(W,e.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(j,W){if(this.w.extUri.isEqualOrParent(j.location,this.t.userExtensionsLocation))return this.D(j.identifier.id,j.location,W)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.F(W=>delete W[s.$Kp.create(j).toString()])}async copyExtension(j,W,q,b){const F=await this.C(j,W),U=await this.C(j,q);if(b={...F?.metadata,...b},U)if(this.w.extUri.isEqual(U.location,j.location))await this.u.updateMetadata([[j,{...U.metadata,...b}]],q);else{const C=await this.scanLocalExtension(U.location,j.type,q);await this.u.removeExtensionFromProfile(C,q),await this.u.addExtensionsToProfile([[j,{...U.metadata,...b}]],q)}else await this.u.addExtensionsToProfile([[j,b]],q);return this.scanLocalExtension(j.location,j.type,q)}async copyExtensions(j,W,q){const b=await this.scanExtensions(M.ExtensionType.User,j,q),F=await Promise.all(b.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,j)]));await this.u.addExtensionsToProfile(F,W)}async D(j,W,q){this.z.trace(`Deleting ${q} extension from disk`,j,W.fsPath);const b=this.w.extUri.joinPath(this.w.extUri.dirname(W),`${this.w.extUri.basename(W)}.${(0,a.$qj)((0,m.$Yg)()).toString(16)}${B}`);await this.G(W.fsPath,b.fsPath),await this.s.del(b,{recursive:!0}),this.z.info(`Deleted ${q} extension from disk`,j,W.fsPath)}F(j){return this.g.queue(async()=>{let W;try{W=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(b){if((0,J.$ol)(b)!==J.FileOperationResult.FILE_NOT_FOUND)throw b}let q={};if(W)try{q=JSON.parse(W)}catch{}return j&&(j(q),Object.keys(q).length?await this.s.writeFile(this.c,w.$Le.fromString(JSON.stringify(q))):await this.s.del(this.c)),q})}async G(j,W){try{await R.Promises.rename(j,W,2*60*1e3)}catch(q){throw(0,r.$Dq)(q,e.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(j,W,q){try{if(q){const F=(await this.t.scanUserExtensions({profileLocation:q})).find(U=>this.w.extUri.isEqual(U.location,j));if(F)return await this.H(F)}else{const b=await this.t.scanExistingExtension(j,W,{includeInvalid:!0});if(b)return await this.H(b)}throw new e.$kp(i.localize(11291,null,j.path),e.ExtensionManagementErrorCode.ScanningExtension)}catch(b){throw(0,r.$Dq)(b,e.ExtensionManagementErrorCode.ScanningExtension)}}async H(j){const W=await this.s.resolve(j.location);let q,b;return W.children&&(q=W.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,b=W.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:q,changelogUrl:b,publisherDisplayName:j.metadata?.publisherDisplayName,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!j.metadata?.hasPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned,isWorkspaceScoped:!1,source:j.metadata?.source??(j.identifier.uuid?"gallery":"vsix")}}async I(){const j=await this.getUninstalledExtensions();if(Object.keys(j).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(j));const W=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const F of W)j[s.$Kp.create(F).toString()]||q.add(F.identifier.id.toLowerCase());try{const F=(0,s.$Pp)(W,U=>U.identifier);await P.Promises.settled(F.map(async U=>{const C=U.sort((G,X)=>O.rcompare(G.manifest.version,X.manifest.version))[0];q.has(C.identifier.id.toLowerCase())||await this.n(await this.H(C))}))}catch(F){this.z.error(F)}const b=W.filter(F=>F.metadata&&j[s.$Kp.create(F).toString()]);await Promise.allSettled(b.map(F=>this.removeUninstalledExtension(F)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let j;try{j=await this.s.resolve(this.t.userExtensionsLocation)}catch(W){(0,J.$ol)(W)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(W);return}if(j?.children)try{await Promise.allSettled(j.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.s.del(W.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(q){(0,J.$ol)(q)!==J.FileOperationResult.FILE_NOT_FOUND&&this.z.error(q)}}}))}catch{}}};t.$Xq=x,t.$Xq=x=ve([se(1,J.$0k),se(2,u.$Kq),se(3,o.$Gq),se(4,H.$Hl),se(5,de.$9l),se(6,ae.$0j)],x);let K=class extends r.$Eq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(j,W,q,b,F,U,C,G,X,ee,oe,fe){super(),this.l=j,this.manifest=W,this.source=q,this.options=b,this.m=F,this.n=U,this.o=C,this.p=G,this.q=X,this.s=ee,this.t=oe,this.u=fe,this.j=e.InstallOperation.Install,this.identifier=this.l.identifier}async h(j){const q=(await this.n.scanExtensions(M.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(C=>(0,s.$Jp)(C.identifier,this.identifier));q&&(this.j=e.InstallOperation.Update);const b={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===M.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof d.URI?"vsix":"gallery"};let F;if(this.source instanceof d.URI){if(q&&this.l.equals(new s.$Kp(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(i.localize(11292,null,this.manifest.displayName||this.manifest.name))}const C=await this.w(this.l);if(C)try{await this.n.removeExtension(C,"existing")}catch{throw new Error(i.localize(11293,null,this.manifest.displayName||this.manifest.name))}}else{if(b.id=this.source.identifier.uuid,b.publisherId=this.source.publisherId,b.publisherDisplayName=this.source.publisherDisplayName,b.targetPlatform=this.source.properties.targetPlatform,b.updated=!!q,b.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,b.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,b.preRelease=(0,E.$ig)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==M.ExtensionType.System&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,b,this.options.profileLocation);F=await this.w(this.l)}if(j.isCancellationRequested)throw(0,r.$Dq)(new k.$4);if(!F){const C=await this.m(this.operation,j);F=C.local,this.k=C.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(C){throw(0,r.$Dq)(C,e.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(j.isCancellationRequested)throw(0,r.$Dq)(new k.$4);try{await this.t.addExtensionsToProfile([[F,b]],this.options.profileLocation,!F.isValid)}catch(C){throw(0,r.$Dq)(C,e.ExtensionManagementErrorCode.AddToProfile)}const U=await this.n.scanLocalExtension(F.location,M.ExtensionType.User,this.options.profileLocation);if(!U)throw new e.$kp("Cannot find the installed extension",e.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof d.URI&&this.x(F,j),U}async w(j){return(await this.n.getUninstalledExtensions())[j.toString()]?(this.u.trace("Removing the extension from uninstalled list:",j.id),await this.n.setInstalled(j),this.u.info("Removed the extension from uninstalled list:",j.id),(await this.n.scanAllUserExtensions(!0)).find(b=>s.$Kp.create(b).equals(j))):void 0}async x(j,W){try{let[q]=await this.p.getExtensions([{id:j.identifier.id,version:j.manifest.version}],W);if(q||([q]=await this.p.getExtensions([{id:j.identifier.id}],W)),q){const b={id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:j.hasPreReleaseVersion||q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(j,b,this.options.profileLocation)}}catch{}}};K=ve([se(6,H.$Hl),se(7,e.$ip),se(8,Z.$Jl),se(9,u.$Kq),se(10,o.$Gq),se(11,ae.$0j)],K);class te extends r.$Eq{constructor(j,W,q){super(),this.extension=j,this.j=W,this.k=q}async h(j){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ce[138],le([0,1,6,24,23,18,42,9,17,11]),function(Q,t,S,P,w,I,L,k,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pR=void 0;let f=class extends L.$Hq{constructor(h,p,v,O,E,d){super(a.URI.file(h.extensionsPath),p,v,O,E,d)}};t.$pR=f,t.$pR=f=ve([se(0,g.$Ki),se(1,k.$0k),se(2,P.$Jl),se(3,w.$Hl),se(4,I.$9l),se(5,S.$0j)],f)}),define(ce[139],le([0,1,11,17,42,54,9,10,6,33,23,24]),function(Q,t,S,P,w,I,L,k,g,a,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vgc=void 0;let h=class extends I.$Oq{constructor(v,O,E,d,m,R,y,i){super(S.URI.file(m.builtinExtensionsPath),S.URI.file(m.extensionsPath),m.userHome,v.defaultProfile,v,O,E,d,m,R,y,i)}};t.$vgc=h,t.$vgc=h=ve([se(0,c.$Jl),se(1,w.$Gq),se(2,L.$0k),se(3,g.$0j),se(4,P.$Ki),se(5,a.$qk),se(6,f.$Hl),se(7,k.$Bi)],h)}),define(ce[73],le([0,1,8,4,2,107,3,87,10,24]),function(Q,t,S,P,w,I,L,k,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jq=t.$hq=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.$fq=t.$eq=t.$dq=void 0,t.$gq=p,t.$iq=O,t.$kq=d,t.$dq="__$__isNewStorageMarker",t.$eq="__$__targetStorageMarker",t.$fq=(0,g.$Ci)("storageService");var f;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(f||(t.WillSaveStateReason=f={}));var c;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(c||(t.StorageScope=c={}));var h;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(h||(t.StorageTarget=h={}));function p(m){const R=m.get(t.$eq);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class v extends w.$Tc{static{this.a=60*1e3}constructor(R={flushInterval:v.a}){super(),this.m=R,this.b=this.B(new P.$me),this.c=this.B(new P.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$je),this.onWillSaveState=this.f.event,this.h=this.B(new S.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new w.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(R,y,i){return P.Event.filter(this.b.event,l=>l.scope===R&&(y===void 0||l.key===y),i)}n(){this.j.value=(0,S.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,w.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(R,y){const{key:i,external:l}=y;if(i===t.$eq){switch(R){case c.APPLICATION:this.H=void 0;break;case c.PROFILE:this.F=void 0;break;case c.WORKSPACE:this.C=void 0;break}this.c.fire({scope:R})}else this.b.fire({scope:R,key:i,target:this.J(R)[i],external:l})}w(R){this.f.fire({reason:R})}get(R,y,i){return this.P(y)?.get(R,i)}getBoolean(R,y,i){return this.P(y)?.getBoolean(R,i)}getNumber(R,y,i){return this.P(y)?.getNumber(R,i)}getObject(R,y,i){return this.P(y)?.getObject(R,i)}storeAll(R,y){this.y(()=>{for(const i of R)this.store(i.key,i.value,i.scope,i.target,y)})}store(R,y,i,l,n=!1){if((0,L.$lg)(y)){this.remove(R,i,n);return}this.y(()=>{this.z(R,i,l),this.P(i)?.set(R,y,n)})}remove(R,y,i=!1){this.y(()=>{this.z(R,y,void 0),this.P(y)?.delete(R,i)})}y(R){this.b.pause(),this.c.pause();try{R()}finally{this.b.resume(),this.c.resume()}}keys(R,y){const i=[],l=this.J(R);for(const n of Object.keys(l))l[n]===y&&i.push(n);return i}z(R,y,i,l=!1){const n=this.J(y);typeof i=="number"?n[R]!==i&&(n[R]=i,this.P(y)?.set(t.$eq,JSON.stringify(n),l)):typeof n[R]=="number"&&(delete n[R],this.P(y)?.set(t.$eq,JSON.stringify(n),l))}get D(){return this.C||(this.C=this.L(c.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(c.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(c.APPLICATION)),this.H}J(R){switch(R){case c.APPLICATION:return this.I;case c.PROFILE:return this.G;default:return this.D}}L(R){const y=this.P(R);return y?p(y):Object.create(null)}isNew(R){return this.getBoolean(t.$dq,R)===!0}async flush(R=f.NONE){this.f.fire({reason:R});const y=this.P(c.APPLICATION),i=this.P(c.PROFILE),l=this.P(c.WORKSPACE);switch(R){case f.NONE:await S.Promises.settled([y?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await S.Promises.settled([y?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.P(c.APPLICATION)?.items??new Map,y=this.P(c.PROFILE)?.items??new Map,i=this.P(c.WORKSPACE)?.items??new Map;return d(R,y,i,this.Q(c.APPLICATION)??"",this.Q(c.PROFILE)??"",this.Q(c.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.P(R)?.optimize()}async switch(R,y){return this.w(f.NONE),(0,a.$Il)(R)?this.R(R,y):this.S(R,y)}M(R,y){return!(R.id===y.id||O(y)&&O(R))}N(R,y,i){this.y(()=>{const l=new Set;for(const[n,r]of R)l.add(n),y.get(n)!==r&&this.u(i,{key:n,external:!0});for(const[n]of y.items)l.has(n)||this.u(i,{key:n,external:!0})})}}t.$hq=v;function O(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class E extends v{constructor(){super(),this.U=this.B(new k.$bq(new k.$cq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$bq(new k.$cq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$bq(new k.$cq,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(R=>this.u(c.WORKSPACE,R))),this.B(this.W.onDidChangeStorage(R=>this.u(c.PROFILE,R))),this.B(this.U.onDidChangeStorage(R=>this.u(c.APPLICATION,R)))}P(R){switch(R){case c.APPLICATION:return this.U;case c.PROFILE:return this.W;default:return this.X}}Q(R){switch(R){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(R){return!1}}t.$jq=E;async function d(m,R,y,i,l,n){const r=N=>{try{return JSON.parse(N)}catch{return N}},e=new Map,s=new Map;m.forEach((N,M)=>{e.set(M,N),s.set(M,r(N))});const o=new Map,u=new Map;R.forEach((N,M)=>{o.set(M,N),u.set(M,r(N))});const $=new Map,A=new Map;y.forEach((N,M)=>{$.set(M,N),A.set(M,r(N))}),console.group(i!==l?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const T=[];if(e.forEach((N,M)=>{T.push({key:M,value:N})}),console.table(T),console.groupEnd(),console.log(s),i!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const N=[];o.forEach((M,Y)=>{N.push({key:Y,value:M})}),console.table(N),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${n})`);const D=[];$.forEach((N,M)=>{D.push({key:M,value:N})}),console.table(D),console.groupEnd(),console.log(A)}}),define(ce[140],le([0,1,13,27,73]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lq=I;async function I(L,k,g){let a=g&&g.get("storage.serviceMachineId",w.StorageScope.APPLICATION)||null;if(a)return a;try{const c=(await k.readFile(L.serviceMachineIdResource)).value.toString();a=(0,P.$Xg)(c)?c:null}catch{a=null}if(!a){a=(0,P.$Yg)();try{await k.writeFile(L.serviceMachineIdResource,S.$Le.fromString(a))}catch{}}return g?.store("storage.serviceMachineId",a,w.StorageScope.APPLICATION,w.StorageTarget.MACHINE),a}}),define(ce[141],le([0,1,140,18,41]),function(Q,t,S,P,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mq=I;async function I(L,k,g,a,f,c,h){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${k.nameShort})`};if((0,w.$Bp)(k,g)&&(0,w.$Dp)(a)===P.TelemetryLevel.USAGE){const v=await(0,S.$lq)(g,f,c);p["X-Market-User-Id"]=v,p["VSCode-SessionId"]=h.machineId||v}return p}}),define(ce[142],le([0,1,19,21,7,12,36,3,11,29,17,20,25,22,44,9,6,33,46,141,73,18,154]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m,R,y,i,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pq=t.$oq=void 0,t.$nq=ne;const n=I.$p?p.TargetPlatform.WEB:(0,c.$ep)(I.$v,L.$dc),r="X-Market-Search-Activity-Id";var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function s(...U){return String(U.reduce((C,G)=>C|G,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},$={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},T={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:e.None,criteria:[],assetTypes:[]};class D{constructor(C=T){this.d=C}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(C,G=this.d.pageSize){return new D({...this.d,pageNumber:C,pageSize:G})}withFilter(C,...G){const X=[...this.d.criteria,...G.length?G.map(ee=>({filterType:C,value:ee})):[{filterType:C}]];return new D({...this.d,criteria:X})}withSortBy(C){return new D({...this.d,sortBy:C})}withSortOrder(C){return new D({...this.d,sortOrder:C})}withFlags(...C){return new D({...this.d,flags:C.reduce((G,X)=>G|X,0)})}withAssetTypes(...C){return new D({...this.d,assetTypes:C})}withSource(C){return new D({...this.d,source:C})}get raw(){const{criteria:C,pageNumber:G,pageSize:X,sortBy:ee,sortOrder:oe,flags:fe,assetTypes:me}=this.d;return{filters:[{criteria:C,pageNumber:G,pageSize:X,sortBy:ee,sortOrder:oe}],assetTypes:me,flags:fe}}get searchText(){const C=this.d.criteria.filter(G=>G.filterType===o.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(C=>String(C.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(U,C){const G=(U||[]).filter(X=>X.statisticName===C)[0];return G?G.value:0}function M(U){const C="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(X=>X.assetType.indexOf(C)===0).reduce((X,ee)=>{const oe=re(U,ee.assetType);return oe&&X.push([ee.assetType.substring(C.length),oe]),X},[])}function Y(U){if(U.properties){const C=U.properties.filter(ee=>ee.key===u.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=C.filter(ee=>G.test(ee.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return re(U,u.Repository)}function J(U){return{uri:`${U.fallbackAssetUri}/${u.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${u.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function re(U,C){return U.files.filter(X=>X.assetType===C)[0]?{uri:`${U.assetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${C}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ae(U,C){const G=U.properties?U.properties.filter(ee=>ee.key===C):[],X=G.length>0&&G[0].value;return X?X.split(",").map(ee=>(0,h.$Np)(ee)):[]}function ue(U){const C=U.properties?U.properties.filter(G=>G.key===$.Engine):[];return C.length>0&&C[0].value||""}function de(U){const C=U.properties?U.properties.filter(G=>G.key===$.PreRelease):[];return C.length>0&&C[0].value==="true"}function H(U){const C=U.properties?U.properties.filter(X=>X.key===$.EnabledApiProposals):[],G=C.length>0&&C[0].value||"";return G?G.split(","):[]}function Z(U){const C=U.properties?U.properties.filter(X=>X.key===$.LocalizedLanguages):[],G=C.length>0&&C[0].value||"";return G?G.split(","):[]}function B(U){return U.properties?.find(C=>C.key===$.SponsorLink)?.value}function z(U){return U.properties?.find(C=>C.key===$.SupportLink)?.value}function x(U){return U.indexOf("preview")!==-1}function K(U){return U.targetPlatform?(0,c.$dp)(U.targetPlatform):p.TargetPlatform.UNDEFINED}function te(U){const C=(0,S.$Lb)(U.versions.map(K)),G=!!U.tags?.includes(c.$0o),X=C.indexOf(p.TargetPlatform.WEB);return G?X===-1&&C.push(p.TargetPlatform.WEB):X!==-1&&C.splice(X,1),C}function ne(U,C){for(let G=0;G<U.length;G++){const X=U[G];if(X.version===U[G-1]?.version){let ee=G;if(K(X)===C)for(;ee>0&&U[ee-1].version===X.version;)ee--;ee!==G&&(U.splice(G,1),U.splice(ee,0,X))}}return U}function j(U,C,G){U.telemetryData={index:C,querySource:G,queryActivityId:U.queryContext?.[r]}}function W(U,C,G,X){const ee=U.versions[0],oe={manifest:re(C,u.Manifest),readme:re(C,u.Details),changelog:re(C,u.Changelog),license:re(C,u.License),repository:Y(C),download:J(C),icon:re(C,u.Icon),signature:re(C,u.Signature),coreTranslations:M(C)};return{type:"gallery",identifier:{id:(0,h.$Op)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:C.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(ee),description:U.shortDescription??"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:G,assets:oe,properties:{dependencies:ae(C,$.Dependency),extensionPack:ae(C,$.ExtensionPack),engine:ue(C),enabledApiProposals:H(C),localizedLanguages:Z(C),targetPlatform:K(C),isPreReleaseVersion:de(C)},hasPreReleaseVersion:de(ee),hasReleaseVersion:!0,preview:x(U.flags),isSigned:!!oe.signature,queryContext:X,supportLink:z(ee)}}let q=class{constructor(C,G,X,ee,oe,fe,me,ge){this.l=G,this.n=X,this.o=ee,this.q=oe,this.u=fe,this.w=me,this.x=ge;const we=me.extensionsGallery,he=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=he?we.servicePPEUrl:we?.serviceUrl,this.g=he?void 0:we?.searchUrl,this.h=we?.controlUrl,this.k=me.extensionsEnabledWithApiProposalVersion?.map(pe=>pe.toLowerCase())??[],this.j=(0,R.$mq)(me.version,me,this.o,this.x,this.u,C,this.q)}y(C=""){return`${this.d}${C}`}isEnabled(){return!!this.d}async getExtensions(C,G,X){const ee=P.CancellationToken.isCancellationToken(G)?{}:G,oe=P.CancellationToken.isCancellationToken(G)?G:X,fe=[],me=[],ge=[],we=[];let he=!0;for(const Se of C){Se.uuid?me.push(Se.uuid):fe.push(Se.id);const V=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:V}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),he=he&&!!Se.hasPreRelease&&!V}if(!me.length&&!fe.length)return[];let pe=new D().withPage(1,C.length);me.length&&(pe=pe.withFilter(o.ExtensionId,...me)),fe.length&&(pe=pe.withFilter(o.ExtensionName,...fe)),(ee.queryAllVersions||he)&&(pe=pe.withFlags(pe.flags,e.IncludeVersions)),ee.source&&(pe=pe.withSource(ee.source));const{extensions:be}=await this.B(pe,{targetPlatform:ee.targetPlatform??n,includePreRelease:ge,versions:we,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.w.version,date:this.w.date}},oe);return ee.source&&be.forEach((Se,V)=>j(Se,V,ee.source)),be}async getCompatibleExtension(C,G,X,ee={version:this.w.version,date:this.w.date}){if((0,c.$fp)(C.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(C,G,X))return C;const oe=new D().withFlags(e.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,C.identifier.uuid),{extensions:fe}=await this.B(oe,{targetPlatform:X,compatible:!0,includePreRelease:G,productVersion:ee},P.CancellationToken.None);return fe[0]||null}async isExtensionCompatible(C,G,X,ee={version:this.w.version,date:this.w.date}){if(!(0,c.$gp)(C.properties.targetPlatform,C.allTargetPlatforms,X)||!G&&C.properties.isPreReleaseVersion)return!1;let oe=C.properties.engine;if(!oe){const fe=await this.getManifest(C,P.CancellationToken.None);if(!fe)throw new Error("Manifest was not found");oe=fe.engines.vscode}return!(!(0,v.$3p)(oe,ee.version,ee.date)||!this.z(C.identifier,C.properties.enabledApiProposals))}z(C,G){return!G||!this.k.includes(C.id.toLowerCase())?!0:(0,v.$4p)(G)}async A(C,G,X,ee,oe,fe,me={version:this.w.version,date:this.w.date}){if(!(0,c.$gp)(K(G),oe,fe)||X!=="any"&&de(G)!==(X==="prerelease"))return!1;if(ee)try{const ge=await this.G(C,G);if(!(0,v.$3p)(ge,me.version,me.date))return!1}catch(ge){return this.n.error(`Error while getting the engine for the version ${G.version}.`,(0,w.$9)(ge)),!1}return!0}async query(C,G){let X=C.text||"";const ee=C.pageSize??50;let oe=new D().withPage(1,ee);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,be)=>(oe=oe.withFilter(o.Category,be||pe),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,be)=>(oe=oe.withFilter(o.Tag,be||pe),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(o.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),oe=oe.withFilter(o.SearchText,X)),oe=oe.withSortBy(c.SortBy.NoneOrRelevance)):C.ids?oe=oe.withFilter(o.ExtensionId,...C.ids):C.names?oe=oe.withFilter(o.ExtensionName,...C.names):oe=oe.withSortBy(c.SortBy.InstallCount),typeof C.sortBy=="number"&&(oe=oe.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(oe=oe.withSortOrder(C.sortOrder)),C.source&&(oe=oe.withSource(C.source));const fe=async(he,pe)=>{const{extensions:be,total:Se}=await this.B(he,{targetPlatform:n,compatible:!1,includePreRelease:!!C.includePreRelease,productVersion:C.productVersion??{version:this.w.version,date:this.w.date}},pe);return be.forEach((V,_)=>j(V,(he.pageNumber-1)*he.pageSize+_,C.source)),{extensions:be,total:Se}},{extensions:me,total:ge}=await fe(oe,G),we=async(he,pe)=>{if(pe.isCancellationRequested)throw new w.$4;const{extensions:be}=await fe(oe.withPage(he+1),pe);return be};return{firstPage:me,total:ge,pageSize:oe.pageSize,getPage:we}}async B(C,G,X){const ee=C.flags;C.flags&e.IncludeLatestVersionOnly&&C.flags&e.IncludeVersions&&(C=C.withFlags(C.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(C.flags&e.IncludeLatestVersionOnly)&&!(C.flags&e.IncludeVersions)&&(C=C.withFlags(C.flags,e.IncludeLatestVersionOnly)),G.versions?.length&&(C=C.withFlags(C.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),C=C.withFlags(C.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:oe,total:fe,context:me}=await this.D(C,X);if(!(C.flags&e.IncludeLatestVersionOnly)){const pe=[];for(const be of oe){const Se=await this.C(be,G,me);Se&&pe.push(Se)}return{extensions:pe,total:fe}}const we=[],he=new Map;for(let pe=0;pe<oe.length;pe++){const be=oe[pe],Se={id:(0,h.$Op)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},V=(0,k.$ig)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(ie=>(0,h.$Jp)(ie,Se))?.includePreRelease;if(G.compatible&&(0,c.$fp)(te(be),G.targetPlatform))continue;const _=await this.C(be,G,me);!_||_.properties.isPreReleaseVersion&&(!V||!_.hasReleaseVersion)||!_.properties.isPreReleaseVersion&&_.properties.targetPlatform!==G.targetPlatform&&_.hasPreReleaseVersion?he.set(be.extensionId,pe):we.push([pe,_])}if(he.size){const pe=new l.$de,be=new D().withFlags(ee&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,he.size).withFilter(o.ExtensionId,...he.keys()),{extensions:Se}=await this.B(be,G,X);this.q.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:he.size});for(const V of Se){const _=he.get(V.identifier.uuid);we.push([_,V])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:fe}}async C(C,G,X){const ee={id:(0,h.$Op)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},oe=G.versions?.find(we=>(0,h.$Jp)(we,ee))?.version,fe=(0,k.$ig)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(we=>(0,h.$Jp)(we,ee))?.includePreRelease,me=te(C),ge=ne(C.versions,G.targetPlatform);if(G.compatible&&(0,c.$fp)(me,G.targetPlatform))return null;for(let we=0;we<ge.length;we++){const he=ge[we];if(!(oe&&he.version!==oe)){if(await this.A(ee.id,he,fe?"any":"release",G.compatible,me,G.targetPlatform,G.productVersion))return G.compatible&&!this.z(ee,H(he))?null:W(C,he,me,X);if(oe&&he.version===oe)return null}}return oe||G.compatible?null:W(C,C.versions[0],me)}async D(C,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,e.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,s(e.Unpublished));const X=await this.j,ee=JSON.stringify(C.raw),oe={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},fe=new l.$de;let me,ge,we=0;try{if(me=await this.l.request({type:"POST",url:this.g&&C.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:ee,headers:oe},G),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:we};const he=await(0,m.$$p)(me);if(he){const pe=he.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(V=>V.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(V=>V.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:{[r]:me.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(he){if((0,w.$3)(he))throw ge=c.ExtensionGalleryErrorCode.Cancelled,he;{const pe=(0,w.$9)(he);throw ge=pe.startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed,new c.$jp(pe,ge)}}finally{this.q.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(ee.length),duration:fe.elapsed(),success:!!me&&(0,m.$7p)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(C,G,X,ee){if(!this.isEnabled())return;const oe=I.$p?this.y(`/itemName/${C}.${G}/version/${X}/statType/${ee===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${C}/extensions/${G}/${X}/stats?statType=${ee}`),fe=I.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:fe};try{await this.l.request({type:"POST",url:oe,headers:ge},P.CancellationToken.None)}catch{}}async download(C,G,X){this.n.trace("ExtensionGalleryService#download",C.identifier.id);const ee=(0,h.$Rp)(C),oe=new Date().getTime(),fe=X===c.InstallOperation.Install?"install":X===c.InstallOperation.Update?"update":"",me=fe?{uri:`${C.assets.download.uri}${g.URI.parse(C.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${C.assets.download.fallbackUri}${g.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:C.assets.download,ge=C.queryContext?.[r]?{[r]:C.queryContext[r]}:void 0,we=await this.F(C.identifier.id,me,u.VSIX,ge?{headers:ge}:void 0);try{await this.u.writeFile(G,we.stream)}catch(he){try{await this.u.del(G)}catch(pe){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,w.$9)(pe))}throw new c.$jp((0,w.$9)(he),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...ee,duration:new Date().getTime()-oe})}async downloadSignatureArchive(C,G){if(!C.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const X=await this.F(C.identifier.id,C.assets.signature,u.Signature);try{await this.u.writeFile(G,X.stream)}catch(ee){try{await this.u.del(G)}catch(oe){this.n.warn(`Error while deleting the file ${G.toString()}`,(0,w.$9)(oe))}throw new c.$jp((0,w.$9)(ee),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(C,G){if(C.assets.readme){const X=await this.F(C.identifier.id,C.assets.readme,u.Details,{},G);return await(0,m.$0p)(X)||""}return""}async getManifest(C,G){if(C.assets.manifest){const X=await this.F(C.identifier.id,C.assets.manifest,u.Manifest,{},G),ee=await(0,m.$0p)(X);return ee?JSON.parse(ee):null}return null}async E(C,G,X){const ee=re(G,u.Manifest);if(!ee)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},fe=await this.F(C,ee,u.Manifest,{headers:oe});return await(0,m.$$p)(fe)}async getCoreTranslation(C,G){const X=C.assets.coreTranslations.filter(ee=>ee[0]===G.toUpperCase())[0];if(X){const ee=await this.F(C.identifier.id,X[1],X[0]),oe=await(0,m.$0p)(ee);return oe?JSON.parse(oe):null}return null}async getChangelog(C,G){if(C.assets.changelog){const X=await this.F(C.identifier.id,C.assets.changelog,u.Changelog,{},G);return await(0,m.$0p)(X)||""}return""}async getAllCompatibleVersions(C,G,X){let ee=new D().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);C.uuid?ee=ee.withFilter(o.ExtensionId,C.uuid):ee=ee.withFilter(o.ExtensionName,C.id);const{galleryExtensions:oe}=await this.D(ee,P.CancellationToken.None);if(!oe.length)return[];const fe=te(oe[0]);if((0,c.$fp)(fe,X))return[];const me=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.A(C.id,he,G?"any":"release",!0,fe,X)&&this.z(C,H(he))&&me.push(he)}catch{}}));const ge=[],we=new Set;for(const he of ne(me,X))we.has(he.version)||(we.add(he.version),ge.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:de(he)}));return ge}async F(C,G,X,ee={},oe=P.CancellationToken.None){const fe=await this.j,me={type:"GET"},ge={...fe,...ee.headers||{}};ee={...ee,...me,headers:ge};const we=G.uri,he=G.fallbackUri,pe={...ee,url:we};try{const be=await this.l.request(pe,oe);if(be.res.statusCode===200)return be;const Se=await(0,m.$0p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,w.$3)(be))throw be;const Se=(0,w.$9)(be);this.q.publicLog2("galleryService:cdnFallback",{extension:C,assetType:X,message:Se});const V={...ee,url:he};return this.l.request(V,oe)}}async G(C,G){let X=ue(G);if(!X){this.q.publicLog2("galleryService:engineFallback",{extension:C,version:G.version});const ee=await this.E(C,G,P.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");X=ee.engines.vscode}return X}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const C=await this.l.request({type:"GET",url:this.h},P.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,m.$$p)(C),X=[],ee={},oe=[],fe=[];if(G){for(const me of G.malicious)X.push({id:me});if(G.migrateToPreRelease)for(const[me,ge]of Object.entries(G.migrateToPreRelease))(!ge.engine||(0,v.$3p)(ge.engine,this.w.version,this.w.date))&&(ee[me.toLowerCase()]={disallowInstall:!0,extension:{id:ge.id,displayName:ge.displayName,autoMigrate:{storage:!!ge.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[me,ge]of Object.entries(G.deprecated))ge&&(ee[me.toLowerCase()]=(0,k.$ig)(ge)?{}:ge);if(G.search)for(const me of G.search)oe.push(me);if(Array.isArray(G.extensionsEnabledWithPreRelease))for(const me of G.extensionsEnabledWithPreRelease)fe.push(me.toLowerCase())}return{malicious:X,deprecated:ee,search:oe,extensionsEnabledWithPreRelease:fe}}};q=ve([se(1,m.$5p),se(2,E.$0j),se(3,f.$Ji),se(4,i.$9l),se(5,O.$0k),se(6,d.$qk),se(7,a.$9i)],q);let b=class extends q{constructor(C,G,X,ee,oe,fe,me,ge){super(C,G,X,ee,oe,fe,me,ge)}};t.$oq=b,t.$oq=b=ve([se(0,y.$fq),se(1,m.$5p),se(2,E.$0j),se(3,f.$Ji),se(4,i.$9l),se(5,O.$0k),se(6,d.$qk),se(7,a.$9i)],b);let F=class extends q{constructor(C,G,X,ee,oe,fe,me){super(void 0,C,G,X,ee,oe,fe,me)}};t.$pq=F,t.$pq=F=ve([se(0,m.$5p),se(1,E.$0j),se(2,f.$Ji),se(3,i.$9l),se(4,O.$0k),se(5,d.$qk),se(6,a.$9i)],F)}),define(ce[143],le([0,1,11,17,9,6,122,23,24,3,69]),function(Q,t,S,P,w,I,L,k,g,a,f){"use strict";var c,h;Object.defineProperty(t,"__esModule",{value:!0}),t.$oR=t.$nR=t.$mR=void 0;let p=class extends g.$Ml{static{c=this}static{this.a="profileAssociationsMigration"}constructor(d,m,R,y,i){super(R,y,m,i),this.U=d,this.W=R}O(){return this.U.getItem(c.b,[]).map(m=>({...m,location:(0,a.$cg)(m.location)?this.w.extUri.joinPath(this.profilesHome,m.location):S.URI.revive(m.location)}))}Q(){const d=this.U.getItem(c.c,{});return this.U.getItem(c.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};t.$mR=p,t.$mR=p=c=ve([se(0,L.$hR),se(1,k.$Hl),se(2,P.$Ki),se(3,w.$0k),se(4,I.$0j)],p);let v=h=class extends p{constructor(d,m,R,y,i){super(d,m,R,y,i),this.$=d}P(d){d.length?this.$.setItem(h.b,d.map(m=>({...m,location:this.w.extUri.basename(m.location)}))):this.$.removeItem(h.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(h.c,d):this.$.removeItem(h.c)}Q(){const d="workspaceAndProfileInfo",m=this.$.getItem(d,void 0);if(m){this.$.removeItem(d);const y=m.reduce((i,{workspace:l,profile:n})=>(i[S.URI.revive(l).toString()]=S.URI.revive(n).toString(),i),{});this.$.setItem(h.c,{workspaces:y})}const R=super.Q();return this.$.getItem(h.a,!1)||(this.R(R),this.$.setItem(h.a,!0)),R}};t.$nR=v,t.$nR=v=h=ve([se(0,L.$iR),se(1,k.$Hl),se(2,P.$Ki),se(3,w.$0k),se(4,I.$0j)],v);let O=class extends v{constructor(d,m,R,y){super(new f.$lR(f.SaveStrategy.IMMEDIATE,m,y,R),d,m,R,y)}async init(){return await this.$.init(),super.init()}};t.$oR=O,t.$oR=O=ve([se(0,k.$Hl),se(1,P.$Ki),se(2,w.$0k),se(3,I.$0j)],O)}),define(ce[144],le([0,1,120,8,13,7,3,29,17,121,6,46,119,155]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cs=void 0,t.$ds=E;let v=class extends c.$6p{constructor(m,R,y,i){super(i),this.m=m,this.n=R,this.r=y,this.s(),this.B(m.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const m=this.m.getValue("http");this.f=m?.proxy,this.g=!!m?.proxyStrictSSL,this.h=m?.proxyAuthorization}async request(m,R){const{f:y,g:i}=this;let l;try{l=await(0,a.$Om)(this.m,this.r,this.n.args,process.env)}catch(e){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,I.$9)(e)))}const n={...process.env,...l},r=m.agent?m.agent:await(0,h.$bs)(m.url||"",n,{proxyUrl:y,strictSSL:i});return m.agent=r,m.strictSSL=i,this.h&&(m.headers={...m.headers||{},"Proxy-Authorization":this.h}),this.c(m.isChromiumNetwork?"electron":"node",m,()=>E(m,R))}async resolveProxy(m){}async lookupAuthorization(m){}async loadCertificates(){return(await new Promise((R,y)=>{Q(["@vscode/proxy-agent"],R,y)}).then(ye)).loadSystemCertificates({log:this.r})}};t.$cs=v,t.$cs=v=ve([se(0,k.$9i),se(1,g.$Ki),se(2,f.$0j),se(3,f.$$j)],v);async function O(d){return((0,S.parse)(d.url).protocol==="https:"?await new Promise((y,i)=>{Q(["https"],y,i)}).then(ye):await new Promise((y,i)=>{Q(["http"],y,i)}).then(ye)).request}async function E(d,m){return P.Promises.withAsyncBody(async(R,y)=>{const i=(0,S.parse)(d.url),l=d.getRawRequest?d.getRawRequest(d):await O(d),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,L.$ig)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(n.auth=d.user+":"+d.password);const r=l(n,e=>{const s=(0,L.$gg)(d.followRedirects)?d.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&s>0&&e.headers.location)E({...d,url:e.headers.location,followRedirects:s-1},m).then(R,y);else{let o=e;!d.isChromiumNetwork&&e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,p.createGunzip)())),R({res:e,stream:(0,w.$1e)(o)})}});r.on("error",y),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),m.onCancellationRequested(()=>{r.abort(),y(new I.$4)})})}});var qe=this&&this.__importDefault||function(Q){return Q&&Q.__esModule?Q:{default:Q}};define(ce[156],le([0,1,32,35,8,38,7,2,14,15,12,36,11,29,116,61,118,17,94,142,20,71,123,42,54,137,139,9,106,108,51,104,64,68,125,6,112,39,113,128,33,46,144,69,70,18,127,41,129,130,23,132,24,143,131,138,109,111,5,133,157]),function(Q,t,S,P,w,I,L,k,g,a,f,c,h,p,v,O,E,d,m,R,y,i,l,n,r,e,s,o,u,$,A,T,D,N,M,Y,J,re,ae,ue,de,H,Z,B,z,x,K,te,ne,j,W,q,b,F,U,C,G,X,ee,oe,fe){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=ge,S=ye(S),ue=qe(ue);class me extends k.$Tc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,pe]=await this.f();return he.invokeFunction(async be=>{const Se=be.get(Y.$0j),V=be.get(o.$0k),_=be.get(d.$Ki),ie=be.get(b.$Jl);Se.info("CLI main",this.b),this.h(Se),await this.j(_,V,ie,he),await Promise.all(pe.map($e=>{(0,w.$th)($e.flush(),1e3)}))})}async f(){const he=new D.$Ai,pe={_serviceBrand:void 0,...ue.default};he.set(de.$qk,pe);const be=new m.$6m(this.b,pe);he.set(d.$Ki,be),await Promise.all([this.g(be.appSettingsHome.with({scheme:g.Schemas.file}).fsPath),this.g(be.extensionsPath)].map(Ie=>Ie?S.promises.mkdir(Ie,{recursive:!0}):void 0));const Se=new X.$gR((0,Y.$lk)(be),be.logsHome);he.set(Y.$$j,Se);const V=this.B(Se.createLogger("cli",{name:(0,ee.localize)(12761,null)})),_=[];Se.getLogLevel()===Y.LogLevel.Trace&&_.push(new Y.$fk(Se.getLogLevel()));const ie=this.B(new G.$qR(V,_));he.set(Y.$0j,ie);const $e=this.B(new u.$Zq(ie));he.set(o.$0k,$e);const Ee=this.B(new $.$qr(ie));$e.registerProvider(g.Schemas.file,Ee);const Ne=new q.$Rs($e);he.set(W.$Hl,Ne);const ke=new B.$kR(B.SaveStrategy.DELAYED,be,ie,$e),Ce=new F.$mR(ke,Ne,be,$e,ie);he.set(b.$Jl,Ce),$e.registerProvider(g.Schemas.vscodeUserData,new oe.$Ygc(g.Schemas.file,Ee,g.Schemas.vscodeUserData,Ce,Ne,ie));const Re=f.$j&&pe.win32RegValueName?this.B(new ae.$Wgc(ie,pe.win32RegValueName)):be.policyFile?this.B(new J.$Xgc(be.policyFile,$e,ie)):new re.$so;he.set(re.$qo,Re);const Le=this.B(new v.$Uo(Ce.defaultProfile.settingsResource,$e,Re,ie));he.set(p.$9i,Le),await Promise.all([ke.init(),Le.initialize()]);let ze;try{ze=await(0,U.$ygc)(ke,ie)}catch(Ie){Ie.code!=="ENOENT"&&ie.error(Ie)}const Ae=await(0,U.$zgc)(ke,ie),Te=await(0,U.$Agc)(ke,ie);Ce.init(),he.set(W.$Hl,new q.$Rs($e));const je=new Z.$cs(Le,be,ie,Se);he.set(H.$5p,je),he.set(O.$Yo,new A.$zi(E.$FR,void 0,!0)),he.set(n.$Gq,new A.$zi(C.$pR,void 0,!0)),he.set(r.$Kq,new A.$zi(s.$vgc,void 0,!0)),he.set(i.$qq,new A.$zi(i.$sq,void 0,!0)),he.set(e.$Vq,new A.$zi(e.$Wq,void 0,!0)),he.set(y.$ip,new A.$zi(R.$pq,void 0,!0)),he.set(N.$9r,new A.$zi(M.$$r,void 0,!1));const Ue=[],Pe=(0,te.$Gp)(pe,Le);if((0,te.$Bp)(pe,be)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ue.push(new ne.$eR(je,Pe,"monacoworkbench",null,pe.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,z.$sp)((0,P.release)(),(0,P.hostname)(),process.arch,pe.commit,pe.version,ze,Ae,Te,Pe),piiPaths:(0,te.$Hp)(be)};he.set(x.$9l,new A.$zi(K.$es,[Ie],!1))}else he.set(x.$9l,te.$wp);return[new T.$tr(he),Ue]}g(he){if(f.$j){const pe=(0,fe.getUNCHost)(he);pe&&(0,fe.addUNCHostToAllowlist)(pe)}return he}h(he){(0,L.setUnexpectedErrorHandler)(pe=>{const be=(0,I.$nj)(pe,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",pe=>{(0,L.$X)(pe)||(0,L.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,L.$Y)(pe))}async j(he,pe,be,Se){let V;if(he.args.profile&&(V=be.profiles.find(ie=>ie.name===he.args.profile),!V))throw new Error(`Profile '${he.args.profile}' not found.`);const _=(V??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,_);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ie={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:_};return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ie,!!this.b.force)}else{if(this.b["uninstall-extension"])return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,_);if(this.b["update-extensions"])return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).updateExtensions(_);if(this.b["locate-extension"])return Se.createInstance(l.$tq,new Y.$fk(Y.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,j.$chc)(he.appRoot,he.extensionsPath))}}m(he){return he.map(pe=>/\.vsix$/i.test(pe)?h.URI.file((0,a.$hc)(pe)?pe:(0,a.$ic)((0,c.cwd)(),pe)):pe)}}async function ge(we){const he=new me(we);try{await he.run()}finally{he.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/19fa52145f34c62a9b743d33279cfc8cc0552fea/core/vs/code/node/cliProcessMain.js.map
