/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","vs/base/common/marshalling","net","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/osDisplayProtocolInfo","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/node/processes","vs/base/node/ps","vs/base/parts/sandbox/node/electronTypes","vs/base/parts/ipc/node/ipc.mp","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ue=function(oe){for(var e=[],I=0,c=oe.length;I<c;I++)e[I]=he[oe[I]];return e};define(he[128],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var I;(function(L){L[L.LoaderAvailable=1]="LoaderAvailable",L[L.BeginLoadingScript=10]="BeginLoadingScript",L[L.EndLoadingScriptOK=11]="EndLoadingScriptOK",L[L.EndLoadingScriptError=12]="EndLoadingScriptError",L[L.BeginInvokeFactory=21]="BeginInvokeFactory",L[L.EndInvokeFactory=22]="EndInvokeFactory",L[L.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",L[L.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",L[L.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",L[L.NodeEndNativeRequire=34]="NodeEndNativeRequire",L[L.CachedDataFound=60]="CachedDataFound",L[L.CachedDataMissed=61]="CachedDataMissed",L[L.CachedDataRejected=62]="CachedDataRejected",L[L.CachedDataCreated=63]="CachedDataCreated"})(I||(e.LoaderEventType=I={}));class c{static get(){const A=new Map,N=new Map,O=new Map,k=new Map;function b(l,p){l.has(p.detail)||l.set(p.detail,-p.timestamp)}function R(l,p){const S=l.get(p.detail);S&&(S>=0||l.set(p.detail,S+p.timestamp))}let d=[];typeof oe=="function"&&typeof oe.getStats=="function"&&(d=oe.getStats().slice(0).sort((l,p)=>l.timestamp-p.timestamp));for(const l of d)switch(l.type){case I.BeginLoadingScript:b(A,l);break;case I.EndLoadingScriptOK:case I.EndLoadingScriptError:R(A,l);break;case I.BeginInvokeFactory:b(N,l);break;case I.EndInvokeFactory:R(N,l);break;case I.NodeBeginNativeRequire:b(O,l);break;case I.NodeEndNativeRequire:R(O,l);break;case I.NodeBeginEvaluatingScript:b(k,l);break;case I.NodeEndEvaluatingScript:R(k,l);break}let f=0;O.forEach(l=>f+=l);function $(l){const p=[];return l.forEach((S,g)=>p.push([g,S])),p}return{amdLoad:$(A),amdInvoke:$(N),nodeRequire:$(O),nodeEval:$(k),nodeRequireTotal:f}}static toMarkdownTable(A,N){let O="";const k=[];return A.forEach((b,R)=>{k[R]=b.length}),N.forEach(b=>{b.forEach((R,d)=>{typeof R>"u"&&(R=b[d]="-");const f=R.toString().length;k[d]=Math.max(f,k[d])})}),A.forEach((b,R)=>{O+=`| ${b+" ".repeat(k[R]-b.toString().length)} `}),O+=`|
`,A.forEach((b,R)=>{O+=`| ${"-".repeat(k[R])} `}),O+=`|
`,N.forEach(b=>{b.forEach((R,d)=>{typeof R<"u"&&(O+=`| ${R+" ".repeat(k[d]-R.toString().length)} `)}),O+=`|
`}),O}}e.$S=c}),define(he[129],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=I,e.$fb=c,e.$gb=L,e.$hb=A,e.$ib=N,e.$jb=O,e.$kb=k,e.$mb=R,e.$nb=d,e.$ob=f,e.$pb=$,e.$qb=l;function I(p,S){const g=c(p,S);if(g!==-1)return p[g]}function c(p,S,g=p.length-1){for(let w=g;w>=0;w--){const P=p[w];if(S(P))return w}return-1}function L(p,S){const g=A(p,S);return g===-1?void 0:p[g]}function A(p,S,g=0,w=p.length){let P=g,m=w;for(;P<m;){const o=Math.floor((P+m)/2);S(p[o])?P=o+1:m=o}return P-1}function N(p,S){const g=O(p,S);return g===p.length?void 0:p[g]}function O(p,S,g=0,w=p.length){let P=g,m=w;for(;P<m;){const o=Math.floor((P+m)/2);S(p[o])?m=o:P=o+1}return P}function k(p,S,g=0,w=p.length){const P=O(p,S,g,w);return P===p.length?-1:P}class b{static{this.assertInvariants=!1}constructor(S){this.e=S,this.c=0}findLastMonotonous(S){if(b.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!S(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=S}const g=A(this.e,S,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$lb=b;function R(p,S){if(p.length===0)return;let g=p[0];for(let w=1;w<p.length;w++){const P=p[w];S(P,g)>0&&(g=P)}return g}function d(p,S){if(p.length===0)return;let g=p[0];for(let w=1;w<p.length;w++){const P=p[w];S(P,g)>=0&&(g=P)}return g}function f(p,S){return R(p,(g,w)=>-S(g,w))}function $(p,S){if(p.length===0)return-1;let g=0;for(let w=1;w<p.length;w++){const P=p[w];S(P,p[g])>0&&(g=w)}return g}function l(p,S){for(const g of p){const w=S(g);if(w!==void 0)return w}}}),define(he[39],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var I;(function(c){c[c.Null=0]="Null",c[c.Backspace=8]="Backspace",c[c.Tab=9]="Tab",c[c.LineFeed=10]="LineFeed",c[c.CarriageReturn=13]="CarriageReturn",c[c.Space=32]="Space",c[c.ExclamationMark=33]="ExclamationMark",c[c.DoubleQuote=34]="DoubleQuote",c[c.Hash=35]="Hash",c[c.DollarSign=36]="DollarSign",c[c.PercentSign=37]="PercentSign",c[c.Ampersand=38]="Ampersand",c[c.SingleQuote=39]="SingleQuote",c[c.OpenParen=40]="OpenParen",c[c.CloseParen=41]="CloseParen",c[c.Asterisk=42]="Asterisk",c[c.Plus=43]="Plus",c[c.Comma=44]="Comma",c[c.Dash=45]="Dash",c[c.Period=46]="Period",c[c.Slash=47]="Slash",c[c.Digit0=48]="Digit0",c[c.Digit1=49]="Digit1",c[c.Digit2=50]="Digit2",c[c.Digit3=51]="Digit3",c[c.Digit4=52]="Digit4",c[c.Digit5=53]="Digit5",c[c.Digit6=54]="Digit6",c[c.Digit7=55]="Digit7",c[c.Digit8=56]="Digit8",c[c.Digit9=57]="Digit9",c[c.Colon=58]="Colon",c[c.Semicolon=59]="Semicolon",c[c.LessThan=60]="LessThan",c[c.Equals=61]="Equals",c[c.GreaterThan=62]="GreaterThan",c[c.QuestionMark=63]="QuestionMark",c[c.AtSign=64]="AtSign",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.OpenSquareBracket=91]="OpenSquareBracket",c[c.Backslash=92]="Backslash",c[c.CloseSquareBracket=93]="CloseSquareBracket",c[c.Caret=94]="Caret",c[c.Underline=95]="Underline",c[c.BackTick=96]="BackTick",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z",c[c.OpenCurlyBrace=123]="OpenCurlyBrace",c[c.Pipe=124]="Pipe",c[c.CloseCurlyBrace=125]="CloseCurlyBrace",c[c.Tilde=126]="Tilde",c[c.NoBreakSpace=160]="NoBreakSpace",c[c.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",c[c.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",c[c.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",c[c.U_Combining_Tilde=771]="U_Combining_Tilde",c[c.U_Combining_Macron=772]="U_Combining_Macron",c[c.U_Combining_Overline=773]="U_Combining_Overline",c[c.U_Combining_Breve=774]="U_Combining_Breve",c[c.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",c[c.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",c[c.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",c[c.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",c[c.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",c[c.U_Combining_Caron=780]="U_Combining_Caron",c[c.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",c[c.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",c[c.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",c[c.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",c[c.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",c[c.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",c[c.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",c[c.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",c[c.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",c[c.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",c[c.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",c[c.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",c[c.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",c[c.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",c[c.U_Combining_Horn=795]="U_Combining_Horn",c[c.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",c[c.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",c[c.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",c[c.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",c[c.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",c[c.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",c[c.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",c[c.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",c[c.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",c[c.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",c[c.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",c[c.U_Combining_Cedilla=807]="U_Combining_Cedilla",c[c.U_Combining_Ogonek=808]="U_Combining_Ogonek",c[c.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",c[c.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",c[c.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",c[c.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",c[c.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",c[c.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",c[c.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",c[c.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",c[c.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",c[c.U_Combining_Low_Line=818]="U_Combining_Low_Line",c[c.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",c[c.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",c[c.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",c[c.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",c[c.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",c[c.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",c[c.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",c[c.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",c[c.U_Combining_Square_Below=827]="U_Combining_Square_Below",c[c.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",c[c.U_Combining_X_Above=829]="U_Combining_X_Above",c[c.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",c[c.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",c[c.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",c[c.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",c[c.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",c[c.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",c[c.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",c[c.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",c[c.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",c[c.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",c[c.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",c[c.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",c[c.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",c[c.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",c[c.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",c[c.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",c[c.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",c[c.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",c[c.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",c[c.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",c[c.U_Combining_Fermata=850]="U_Combining_Fermata",c[c.U_Combining_X_Below=851]="U_Combining_X_Below",c[c.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",c[c.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",c[c.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",c[c.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",c[c.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",c[c.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",c[c.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",c[c.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",c[c.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",c[c.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",c[c.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",c[c.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",c[c.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",c[c.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",c[c.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",c[c.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",c[c.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",c[c.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",c[c.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",c[c.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",c[c.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",c[c.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",c[c.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",c[c.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",c[c.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",c[c.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",c[c.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",c[c.LINE_SEPARATOR=8232]="LINE_SEPARATOR",c[c.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",c[c.NEXT_LINE=133]="NEXT_LINE",c[c.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",c[c.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",c[c.U_DIAERESIS=168]="U_DIAERESIS",c[c.U_MACRON=175]="U_MACRON",c[c.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",c[c.U_CEDILLA=184]="U_CEDILLA",c[c.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",c[c.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",c[c.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",c[c.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",c[c.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",c[c.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",c[c.U_BREVE=728]="U_BREVE",c[c.U_DOT_ABOVE=729]="U_DOT_ABOVE",c[c.U_RING_ABOVE=730]="U_RING_ABOVE",c[c.U_OGONEK=731]="U_OGONEK",c[c.U_SMALL_TILDE=732]="U_SMALL_TILDE",c[c.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",c[c.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",c[c.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",c[c.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",c[c.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",c[c.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",c[c.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",c[c.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",c[c.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",c[c.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",c[c.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",c[c.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",c[c.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",c[c.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",c[c.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",c[c.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",c[c.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",c[c.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",c[c.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",c[c.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",c[c.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",c[c.U_GREEK_TONOS=900]="U_GREEK_TONOS",c[c.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",c[c.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",c[c.U_GREEK_PSILI=8127]="U_GREEK_PSILI",c[c.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",c[c.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",c[c.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",c[c.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",c[c.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",c[c.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",c[c.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",c[c.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",c[c.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",c[c.U_GREEK_VARIA=8175]="U_GREEK_VARIA",c[c.U_GREEK_OXIA=8189]="U_GREEK_OXIA",c[c.U_GREEK_DASIA=8190]="U_GREEK_DASIA",c[c.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",c[c.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",c[c.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",c[c.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",c[c.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",c[c.U_OVERLINE=8254]="U_OVERLINE",c[c.UTF8_BOM=65279]="UTF8_BOM",c[c.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",c[c.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(I||(e.CharCode=I={}))}),define(he[130],ue([0,1]),function(oe,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=c,e.$d=L,e.$e=A,e.$f=N;function c(k,b){const R=Object.create(null);for(const d of k){const f=b(d);let $=R[f];$||($=R[f]=[]),$.push(d)}return R}function L(k,b){const R=[],d=[];for(const f of k)b.has(f)||R.push(f);for(const f of b)k.has(f)||d.push(f);return{removed:R,added:d}}function A(k,b){const R=[],d=[];for(const[f,$]of k)b.has(f)||R.push($);for(const[f,$]of b)k.has(f)||d.push($);return{removed:R,added:d}}function N(k,b){const R=new Set;for(const d of b)k.has(d)&&R.add(d);return R}class O{static{I=Symbol.toStringTag}constructor(b,R){this.b=R,this.a=new Map,this[I]="SetWithKey";for(const d of b)this.add(d)}get size(){return this.a.size}add(b){const R=this.b(b);return this.a.set(R,b),this}delete(b){return this.a.delete(this.b(b))}has(b){return this.a.has(this.b(b))}*entries(){for(const b of this.a.values())yield[b,b]}keys(){return this.values()}*values(){for(const b of this.a.values())yield b}clear(){this.a.clear()}forEach(b,R){this.a.forEach(d=>b.call(R,d,d,this))}[Symbol.iterator](){return this.values()}}e.$g=O}),define(he[87],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=c,e.$8h=L,e.$9h=A;function I(N){return(O,k,b)=>{let R=null,d=null;if(typeof b.value=="function"?(R="value",d=b.value):typeof b.get=="function"&&(R="get",d=b.get),!d)throw new Error("not supported");b[R]=N(d,k)}}function c(N,O,k){let b=null,R=null;if(typeof k.value=="function"?(b="value",R=k.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(b="get",R=k.get),!R)throw new Error("not supported");const d=`$memoize$${O}`;k[b]=function(...f){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,f)}),this[d]}}function L(N,O,k){return I((b,R)=>{const d=`$debounce$${R}`,f=`$debounce$result$${R}`;return function(...$){this[f]||(this[f]=k?k():void 0),clearTimeout(this[d]),O&&(this[f]=O(this[f],...$),$=[this[f]]),this[d]=setTimeout(()=>{b.apply(this,$),this[f]=k?k():void 0},N)}})}function A(N,O,k){return I((b,R)=>{const d=`$throttle$timer$${R}`,f=`$throttle$result$${R}`,$=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...p){if(this[f]||(this[f]=k?k():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),O&&(this[f]=O(this[f],...p)),this[l])return;const S=this[$]+N;S<=Date.now()?(this[$]=Date.now(),b.apply(this,[this[f]]),this[f]=k?k():void 0):(this[l]=!0,this[d]=setTimeout(()=>{this[l]=!1,this[$]=Date.now(),b.apply(this,[this[f]]),this[f]=k?k():void 0},S-Date.now()))}})}}),define(he[8],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=c,e.$X=L,e.$Y=A,e.$Z=N,e.$1=O,e.$2=k,e.$3=R,e.$5=f,e.$6=$,e.$7=l,e.$9=S;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?m.isErrorNoTelemetry(i)?new m(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=I,e.$V=new I;function c(h){e.$V.setUnexpectedErrorHandler(h)}function L(h){if(!h||typeof h!="object")return!1;const i=h;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function A(h){R(h)||e.$V.onUnexpectedError(h)}function N(h){R(h)||e.$V.onUnexpectedExternalError(h)}function O(h){if(h instanceof Error){const{name:i,message:s}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:i,message:s,stack:t,noTelemetry:m.isErrorNoTelemetry(h)}}return h}function k(h){let i;return h.noTelemetry?i=new m:(i=new Error,i.name=h.name),i.message=h.message,i.stack=h.stack,i}const b="Canceled";function R(h){return h instanceof d?!0:h instanceof Error&&h.name===b&&h.message===b}class d extends Error{constructor(){super(b),this.name=this.message}}e.$4=d;function f(){const h=new Error(b);return h.name=h.message,h}function $(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function l(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class p extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=p;function S(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class g extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=g;class w extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=w;class P extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=P;class m extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof m)return i;const s=new m;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=m;class o extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(he[17],ue([0,1,8,129]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=L,e.$sb=A,e.$tb=N,e.$ub=O,e.$vb=k,e.$wb=b,e.$xb=R,e.$yb=d,e.$zb=f,e.$Ab=$,e.$Bb=l,e.$Cb=p,e.$Db=S,e.top=g,e.$Fb=w,e.$Gb=m,e.$Hb=o,e.$Ib=h,e.$Jb=i,e.$Kb=s,e.$Lb=t,e.$Mb=n,e.$Nb=r,e.$Ob=a,e.$Pb=u,e.$Qb=y,e.$Rb=C,e.$Sb=v,e.$Tb=E,e.$Ub=T,e.$Vb=F,e.$Wb=U,e.$Xb=j,e.$Yb=K,e.$Zb=V,e.$1b=x,e.$2b=H,e.$3b=ie,e.$4b=W,e.$5b=ne,e.$6b=ce,e.$9b=G;function L(q,M=0){return q[q.length-(1+M)]}function A(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}function N(q,M,Z=(ee,X)=>ee===X){if(q===M)return!0;if(!q||!M||q.length!==M.length)return!1;for(let ee=0,X=q.length;ee<X;ee++)if(!Z(q[ee],M[ee]))return!1;return!0}function O(q,M){const Z=q.length-1;M<Z&&(q[M]=q[Z]),q.pop()}function k(q,M,Z){return b(q.length,ee=>Z(q[ee],M))}function b(q,M){let Z=0,ee=q-1;for(;Z<=ee;){const X=(Z+ee)/2|0,re=M(X);if(re<0)Z=X+1;else if(re>0)ee=X-1;else return X}return-(Z+1)}function R(q,M,Z){if(q=q|0,q>=M.length)throw new TypeError("invalid index");const ee=M[Math.floor(M.length*Math.random())],X=[],re=[],le=[];for(const ge of M){const pe=Z(ge,ee);pe<0?X.push(ge):pe>0?re.push(ge):le.push(ge)}return q<X.length?R(q,X,Z):q<X.length+le.length?le[0]:R(q-(X.length+le.length),re,Z)}function d(q,M){const Z=[];let ee;for(const X of q.slice(0).sort(M))!ee||M(ee[0],X)!==0?(ee=[X],Z.push(ee)):ee.push(X);return Z}function*f(q,M){let Z,ee;for(const X of q)ee!==void 0&&M(ee,X)?Z.push(X):(Z&&(yield Z),Z=[X]),ee=X;Z&&(yield Z)}function $(q,M){for(let Z=0;Z<=q.length;Z++)M(Z===0?void 0:q[Z-1],Z===q.length?void 0:q[Z])}function l(q,M){for(let Z=0;Z<q.length;Z++)M(Z===0?void 0:q[Z-1],q[Z],Z+1===q.length?void 0:q[Z+1])}function p(q,M,Z){const ee=[];function X(ge,pe,Ee){if(pe===0&&Ee.length===0)return;const we=ee[ee.length-1];we&&we.start+we.deleteCount===ge?(we.deleteCount+=pe,we.toInsert.push(...Ee)):ee.push({start:ge,deleteCount:pe,toInsert:Ee})}let re=0,le=0;for(;;){if(re===q.length){X(re,0,M.slice(le));break}if(le===M.length){X(re,q.length-re,[]);break}const ge=q[re],pe=M[le],Ee=Z(ge,pe);Ee===0?(re+=1,le+=1):Ee<0?(X(re,1,[]),re+=1):Ee>0&&(X(re,0,[pe]),le+=1)}return ee}function S(q,M,Z){const ee=p(q,M,Z),X=[],re=[];for(const le of ee)X.push(...q.slice(le.start,le.start+le.deleteCount)),re.push(...le.toInsert);return{removed:X,added:re}}function g(q,M,Z){if(Z===0)return[];const ee=q.slice(0,Z).sort(M);return P(q,M,ee,Z,q.length),ee}function w(q,M,Z,ee,X){return Z===0?Promise.resolve([]):new Promise((re,le)=>{(async()=>{const ge=q.length,pe=q.slice(0,Z).sort(M);for(let Ee=Z,we=Math.min(Z+ee,ge);Ee<ge;Ee=we,we=Math.min(we+ee,ge)){if(Ee>Z&&await new Promise(be=>setTimeout(be)),X&&X.isCancellationRequested)throw new I.$4;P(q,M,pe,Ee,we)}return pe})().then(re,le)})}function P(q,M,Z,ee,X){for(const re=Z.length;ee<X;ee++){const le=q[ee];if(M(le,Z[re-1])<0){Z.pop();const ge=(0,c.$jb)(Z,pe=>M(le,pe)<0);Z.splice(ge,0,le)}}}function m(q){return q.filter(M=>!!M)}function o(q){let M=0;for(let Z=0;Z<q.length;Z++)q[Z]&&(q[M]=q[Z],M+=1);q.length=M}function h(q,M,Z){q.splice(Z,0,q.splice(M,1)[0])}function i(q){return!Array.isArray(q)||q.length===0}function s(q){return Array.isArray(q)&&q.length>0}function t(q,M=Z=>Z){const Z=new Set;return q.filter(ee=>{const X=M(ee);return Z.has(X)?!1:(Z.add(X),!0)})}function n(q){const M=new Set;return Z=>{const ee=q(Z);return M.has(ee)?!1:(M.add(ee),!0)}}function r(q,M){return q.length>0?q[0]:M}function a(q,M){return q.length>0?q[q.length-1]:M}function u(q,M,Z=(ee,X)=>ee===X){let ee=0;for(let X=0,re=Math.min(q.length,M.length);X<re&&Z(q[X],M[X]);X++)ee++;return ee}function y(q,M){let Z=typeof M=="number"?q:0;typeof M=="number"?Z=q:(Z=0,M=q);const ee=[];if(Z<=M)for(let X=Z;X<M;X++)ee.push(X);else for(let X=Z;X>M;X--)ee.push(X);return ee}function C(q,M,Z){return q.reduce((ee,X)=>(ee[M(X)]=Z?Z(X):X,ee),Object.create(null))}function v(q,M){return q.push(M),()=>E(q,M)}function E(q,M){const Z=q.indexOf(M);if(Z>-1)return q.splice(Z,1),M}function T(q,M,Z){const ee=q.slice(0,M),X=q.slice(M);return ee.concat(Z,X)}function F(q,M){let Z;if(typeof M=="number"){let ee=M;Z=()=>{const X=Math.sin(ee++)*179426549;return X-Math.floor(X)}}else Z=Math.random;for(let ee=q.length-1;ee>0;ee-=1){const X=Math.floor(Z()*(ee+1)),re=q[ee];q[ee]=q[X],q[X]=re}}function U(q,M){const Z=q.indexOf(M);Z>-1&&(q.splice(Z,1),q.unshift(M))}function j(q,M){const Z=q.indexOf(M);Z>-1&&(q.splice(Z,1),q.push(M))}function K(q,M){for(const Z of M)q.push(Z)}function V(q,M){return Array.isArray(q)?q.map(M):M(q)}function x(q){return Array.isArray(q)?q:[q]}function H(q){return q[Math.floor(Math.random()*q.length)]}function ie(q,M,Z){const ee=z(q,M),X=q.length,re=Z.length;q.length=X+re;for(let le=X-1;le>=ee;le--)q[le+re]=q[le];for(let le=0;le<re;le++)q[le+ee]=Z[le]}function W(q,M,Z,ee){const X=z(q,M);let re=q.splice(X,Z);return re===void 0&&(re=[]),ie(q,X,ee),re}function z(q,M){return M<0?Math.max(M+q.length,0):Math.min(M,q.length)}var _;(function(q){function M(re){return re<0}q.isLessThan=M;function Z(re){return re<=0}q.isLessThanOrEqual=Z;function ee(re){return re>0}q.isGreaterThan=ee;function X(re){return re===0}q.isNeitherLessOrGreaterThan=X,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function ne(q,M){return(Z,ee)=>M(q(Z),q(ee))}function ce(...q){return(M,Z)=>{for(const ee of q){const X=ee(M,Z);if(!_.isNeitherLessOrGreaterThan(X))return X}return _.neitherLessOrGreaterThan}}const te=(q,M)=>q-M;e.$7b=te;const Y=(q,M)=>(0,e.$7b)(q?1:0,M?1:0);e.$8b=Y;function G(q){return(M,Z)=>-q(M,Z)}class B{constructor(M){this.g=M,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(M){let Z=this.c;for(;Z<this.g.length&&M(this.g[Z]);)Z++;const ee=Z===this.c?null:this.g.slice(this.c,Z);return this.c=Z,ee}takeFromEndWhile(M){let Z=this.d;for(;Z>=0&&M(this.g[Z]);)Z--;const ee=Z===this.d?null:this.g.slice(Z+1,this.d+1);return this.d=Z,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const M=this.g[this.c];return this.c++,M}removeLast(){const M=this.g[this.d];return this.d--,M}takeCount(M){const Z=this.g.slice(this.c,this.c+M);return this.c+=M,Z}}e.$0b=B;class D{static{this.empty=new D(M=>{})}constructor(M){this.iterate=M}forEach(M){this.iterate(Z=>(M(Z),!0))}toArray(){const M=[];return this.iterate(Z=>(M.push(Z),!0)),M}filter(M){return new D(Z=>this.iterate(ee=>M(ee)?Z(ee):!0))}map(M){return new D(Z=>this.iterate(ee=>Z(M(ee))))}some(M){let Z=!1;return this.iterate(ee=>(Z=M(ee),!Z)),Z}findFirst(M){let Z;return this.iterate(ee=>M(ee)?(Z=ee,!1):!0),Z}findLast(M){let Z;return this.iterate(ee=>(M(ee)&&(Z=ee),!0)),Z}findLastMaxBy(M){let Z,ee=!0;return this.iterate(X=>((ee||_.isGreaterThan(M(X,Z)))&&(ee=!1,Z=X),!0)),Z}}e.$$b=D;class J{constructor(M){this.c=M}static createSortPermutation(M,Z){const ee=Array.from(M.keys()).sort((X,re)=>Z(M[X],M[re]));return new J(ee)}apply(M){return M.map((Z,ee)=>M[this.c[ee]])}inverse(){const M=this.c.slice();for(let Z=0;Z<this.c.length;Z++)M[this.c[Z]]=Z;return new J(M)}}e.$_b=J}),define(he[131],ue([0,1,8]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=c,e.$dd=L,e.$ed=A,e.$fd=N,e.$gd=O,e.$hd=k;function c(b,R){if(!b)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}function L(b,R="Unreachable"){throw new Error(R)}function A(b,R="unexpected state"){if(!b)throw new I.$bb(`Assertion Failed: ${R}`)}function N(b){b||(0,I.$Y)(new I.$bb("Soft Assertion Failed"))}function O(b){if(!b()){debugger;b(),(0,I.$Y)(new I.$bb("Assertion Failed"))}}function k(b,R){let d=0;for(;d<b.length-1;){const f=b[d],$=b[d+1];if(!R(f,$))return!1;d++}return!0}}),define(he[88],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=I;function I(c,L){const A=this;let N=!1,O;return function(){if(N)return O;if(N=!0,L)try{O=c.apply(A,arguments)}finally{L()}else O=c.apply(A,arguments);return O}}}),define(he[63],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(c){function L(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}c.is=L;const A=Object.freeze([]);function N(){return A}c.empty=N;function*O(i){yield i}c.single=O;function k(i){return L(i)?i:O(i)}c.wrap=k;function b(i){return i||A}c.from=b;function*R(i){for(let s=i.length-1;s>=0;s--)yield i[s]}c.reverse=R;function d(i){return!i||i[Symbol.iterator]().next().done===!0}c.isEmpty=d;function f(i){return i[Symbol.iterator]().next().value}c.first=f;function $(i,s){let t=0;for(const n of i)if(s(n,t++))return!0;return!1}c.some=$;function l(i,s){for(const t of i)if(s(t))return t}c.find=l;function*p(i,s){for(const t of i)s(t)&&(yield t)}c.filter=p;function*S(i,s){let t=0;for(const n of i)yield s(n,t++)}c.map=S;function*g(i,s){let t=0;for(const n of i)yield*s(n,t++)}c.flatMap=g;function*w(...i){for(const s of i)yield*s}c.concat=w;function P(i,s,t){let n=t;for(const r of i)n=s(n,r);return n}c.reduce=P;function*m(i,s,t=i.length){for(s<0&&(s+=i.length),t<0?t+=i.length:t>i.length&&(t=i.length);s<t;s++)yield i[s]}c.slice=m;function o(i,s=Number.POSITIVE_INFINITY){const t=[];if(s===0)return[t,i];const n=i[Symbol.iterator]();for(let r=0;r<s;r++){const a=n.next();if(a.done)return[t,c.empty()];t.push(a.value)}return[t,{[Symbol.iterator](){return n}}]}c.consume=o;async function h(i){const s=[];for await(const t of i)s.push(t);return Promise.resolve(s)}c.asyncToArray=h})(I||(e.Iterable=I={}))}),define(he[35],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=N,e.$Un=d,e.$Vn=f,e.$Wn=$,e.$Xn=l,e.$Yn=p,e.$Zn=S,e.$1n=g,e.$2n=w,e.$3n=P,e.$4n=m;var I;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var c;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(c||(e.SyntaxKind=c={}));var L;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function N(o,h=!1){let i=0;const s=o.length;let t="",n=0,r=c.Unknown,a=I.None;function u(U){let j=0,K=0;for(;j<U;){const V=o.charCodeAt(i);if(V>=R._0&&V<=R._9)K=K*16+V-R._0;else if(V>=R.A&&V<=R.F)K=K*16+V-R.A+10;else if(V>=R.a&&V<=R.f)K=K*16+V-R.a+10;else break;i++,j++}return j<U&&(K=-1),K}function y(U){i=U,t="",n=0,r=c.Unknown,a=I.None}function C(){const U=i;if(o.charCodeAt(i)===R._0)i++;else for(i++;i<o.length&&b(o.charCodeAt(i));)i++;if(i<o.length&&o.charCodeAt(i)===R.dot)if(i++,i<o.length&&b(o.charCodeAt(i)))for(i++;i<o.length&&b(o.charCodeAt(i));)i++;else return a=I.UnexpectedEndOfNumber,o.substring(U,i);let j=i;if(i<o.length&&(o.charCodeAt(i)===R.E||o.charCodeAt(i)===R.e))if(i++,(i<o.length&&o.charCodeAt(i)===R.plus||o.charCodeAt(i)===R.minus)&&i++,i<o.length&&b(o.charCodeAt(i))){for(i++;i<o.length&&b(o.charCodeAt(i));)i++;j=i}else a=I.UnexpectedEndOfNumber;return o.substring(U,j)}function v(){let U="",j=i;for(;;){if(i>=s){U+=o.substring(j,i),a=I.UnexpectedEndOfString;break}const K=o.charCodeAt(i);if(K===R.doubleQuote){U+=o.substring(j,i),i++;break}if(K===R.backslash){if(U+=o.substring(j,i),i++,i>=s){a=I.UnexpectedEndOfString;break}switch(o.charCodeAt(i++)){case R.doubleQuote:U+='"';break;case R.backslash:U+="\\";break;case R.slash:U+="/";break;case R.b:U+="\b";break;case R.f:U+="\f";break;case R.n:U+=`
`;break;case R.r:U+="\r";break;case R.t:U+="	";break;case R.u:{const x=u(4);x>=0?U+=String.fromCharCode(x):a=I.InvalidUnicode;break}default:a=I.InvalidEscapeCharacter}j=i;continue}if(K>=0&&K<=31)if(k(K)){U+=o.substring(j,i),a=I.UnexpectedEndOfString;break}else a=I.InvalidCharacter;i++}return U}function E(){if(t="",a=I.None,n=i,i>=s)return n=s,r=c.EOF;let U=o.charCodeAt(i);if(O(U)){do i++,t+=String.fromCharCode(U),U=o.charCodeAt(i);while(O(U));return r=c.Trivia}if(k(U))return i++,t+=String.fromCharCode(U),U===R.carriageReturn&&o.charCodeAt(i)===R.lineFeed&&(i++,t+=`
`),r=c.LineBreakTrivia;switch(U){case R.openBrace:return i++,r=c.OpenBraceToken;case R.closeBrace:return i++,r=c.CloseBraceToken;case R.openBracket:return i++,r=c.OpenBracketToken;case R.closeBracket:return i++,r=c.CloseBracketToken;case R.colon:return i++,r=c.ColonToken;case R.comma:return i++,r=c.CommaToken;case R.doubleQuote:return i++,t=v(),r=c.StringLiteral;case R.slash:{const j=i-1;if(o.charCodeAt(i+1)===R.slash){for(i+=2;i<s&&!k(o.charCodeAt(i));)i++;return t=o.substring(j,i),r=c.LineCommentTrivia}if(o.charCodeAt(i+1)===R.asterisk){i+=2;const K=s-1;let V=!1;for(;i<K;){if(o.charCodeAt(i)===R.asterisk&&o.charCodeAt(i+1)===R.slash){i+=2,V=!0;break}i++}return V||(i++,a=I.UnexpectedEndOfComment),t=o.substring(j,i),r=c.BlockCommentTrivia}return t+=String.fromCharCode(U),i++,r=c.Unknown}case R.minus:if(t+=String.fromCharCode(U),i++,i===s||!b(o.charCodeAt(i)))return r=c.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return t+=C(),r=c.NumericLiteral;default:for(;i<s&&T(U);)i++,U=o.charCodeAt(i);if(n!==i){switch(t=o.substring(n,i),t){case"true":return r=c.TrueKeyword;case"false":return r=c.FalseKeyword;case"null":return r=c.NullKeyword}return r=c.Unknown}return t+=String.fromCharCode(U),i++,r=c.Unknown}}function T(U){if(O(U)||k(U))return!1;switch(U){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function F(){let U;do U=E();while(U>=c.LineCommentTrivia&&U<=c.Trivia);return U}return{setPosition:y,getPosition:()=>i,scan:h?F:E,getToken:()=>r,getTokenValue:()=>t,getTokenOffset:()=>n,getTokenLength:()=>i-n,getTokenError:()=>a}}function O(o){return o===R.space||o===R.tab||o===R.verticalTab||o===R.formFeed||o===R.nonBreakingSpace||o===R.ogham||o>=R.enQuad&&o<=R.zeroWidthSpace||o===R.narrowNoBreakSpace||o===R.mathematicalSpace||o===R.ideographicSpace||o===R.byteOrderMark}function k(o){return o===R.lineFeed||o===R.carriageReturn||o===R.lineSeparator||o===R.paragraphSeparator}function b(o){return o>=R._0&&o<=R._9}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function d(o,h){const i=[],s=new Object;let t;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function a(u,y,C,v){n.value=u,n.offset=y,n.length=C,n.type=v,n.colonOffset=void 0,t=n}try{P(o,{onObjectBegin:(u,y)=>{if(h<=u)throw s;t=void 0,r=h>u,i.push("")},onObjectProperty:(u,y,C)=>{if(h<y||(a(u,y,C,"property"),i[i.length-1]=u,h<=y+C))throw s},onObjectEnd:(u,y)=>{if(h<=u)throw s;t=void 0,i.pop()},onArrayBegin:(u,y)=>{if(h<=u)throw s;t=void 0,i.push(0)},onArrayEnd:(u,y)=>{if(h<=u)throw s;t=void 0,i.pop()},onLiteralValue:(u,y,C)=>{if(h<y||(a(u,y,C,m(u)),h<=y+C))throw s},onSeparator:(u,y,C)=>{if(h<=y)throw s;if(u===":"&&t&&t.type==="property")t.colonOffset=y,r=!1,t=void 0;else if(u===","){const v=i[i.length-1];typeof v=="number"?i[i.length-1]=v+1:(r=!0,i[i.length-1]=""),t=void 0}}})}catch(u){if(u!==s)throw u}return{path:i,previousNode:t,isAtPropertyKey:r,matches:u=>{let y=0;for(let C=0;y<u.length&&C<i.length;C++)if(u[y]===i[C]||u[y]==="*")y++;else if(u[y]!=="**")return!1;return y===u.length}}}function f(o,h=[],i=A.DEFAULT){let s=null,t=[];const n=[];function r(u){Array.isArray(t)?t.push(u):s!==null&&(t[s]=u)}return P(o,{onObjectBegin:()=>{const u={};r(u),n.push(t),t=u,s=null},onObjectProperty:u=>{s=u},onObjectEnd:()=>{t=n.pop()},onArrayBegin:()=>{const u=[];r(u),n.push(t),t=u,s=null},onArrayEnd:()=>{t=n.pop()},onLiteralValue:r,onError:(u,y,C)=>{h.push({error:u,offset:y,length:C})}},i),t[0]}function $(o,h=[],i=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(u){s.type==="property"&&(s.length=u-s.offset,s=s.parent)}function n(u){return s.children.push(u),u}P(o,{onObjectBegin:u=>{s=n({type:"object",offset:u,length:-1,parent:s,children:[]})},onObjectProperty:(u,y,C)=>{s=n({type:"property",offset:y,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:u,offset:y,length:C,parent:s})},onObjectEnd:(u,y)=>{s.length=u+y-s.offset,s=s.parent,t(u+y)},onArrayBegin:(u,y)=>{s=n({type:"array",offset:u,length:-1,parent:s,children:[]})},onArrayEnd:(u,y)=>{s.length=u+y-s.offset,s=s.parent,t(u+y)},onLiteralValue:(u,y,C)=>{n({type:m(u),offset:y,length:C,parent:s,value:u}),t(y+C)},onSeparator:(u,y,C)=>{s.type==="property"&&(u===":"?s.colonOffset=y:u===","&&t(y))},onError:(u,y,C)=>{h.push({error:u,offset:y,length:C})}},i);const a=s.children[0];return a&&delete a.parent,a}function l(o,h){if(!o)return;let i=o;for(const s of h)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let t=!1;for(const n of i.children)if(Array.isArray(n.children)&&n.children[0].value===s){i=n.children[1],t=!0;break}if(!t)return}else{const t=s;if(i.type!=="array"||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i}function p(o){if(!o.parent||!o.parent.children)return[];const h=p(o.parent);if(o.parent.type==="property"){const i=o.parent.children[0].value;h.push(i)}else if(o.parent.type==="array"){const i=o.parent.children.indexOf(o);i!==-1&&h.push(i)}return h}function S(o){switch(o.type){case"array":return o.children.map(S);case"object":{const h=Object.create(null);for(const i of o.children){const s=i.children[1];s&&(h[i.children[0].value]=S(s))}return h}case"null":case"string":case"number":case"boolean":return o.value;default:return}}function g(o,h,i=!1){return h>=o.offset&&h<o.offset+o.length||i&&h===o.offset+o.length}function w(o,h,i=!1){if(g(o,h,i)){const s=o.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=h;t++){const n=w(s[t],h,i);if(n)return n}return o}}function P(o,h,i=A.DEFAULT){const s=N(o,!1);function t(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function n(ne){return ne?ce=>ne(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const r=t(h.onObjectBegin),a=n(h.onObjectProperty),u=t(h.onObjectEnd),y=t(h.onArrayBegin),C=t(h.onArrayEnd),v=n(h.onLiteralValue),E=n(h.onSeparator),T=t(h.onComment),F=n(h.onError),U=i&&i.disallowComments,j=i&&i.allowTrailingComma;function K(){for(;;){const ne=s.scan();switch(s.getTokenError()){case I.InvalidUnicode:V(L.InvalidUnicode);break;case I.InvalidEscapeCharacter:V(L.InvalidEscapeCharacter);break;case I.UnexpectedEndOfNumber:V(L.UnexpectedEndOfNumber);break;case I.UnexpectedEndOfComment:U||V(L.UnexpectedEndOfComment);break;case I.UnexpectedEndOfString:V(L.UnexpectedEndOfString);break;case I.InvalidCharacter:V(L.InvalidCharacter);break}switch(ne){case c.LineCommentTrivia:case c.BlockCommentTrivia:U?V(L.InvalidCommentToken):T();break;case c.Unknown:V(L.InvalidSymbol);break;case c.Trivia:case c.LineBreakTrivia:break;default:return ne}}}function V(ne,ce=[],te=[]){if(F(ne),ce.length+te.length>0){let Y=s.getToken();for(;Y!==c.EOF;){if(ce.indexOf(Y)!==-1){K();break}else if(te.indexOf(Y)!==-1)break;Y=K()}}}function x(ne){const ce=s.getTokenValue();return ne?v(ce):a(ce),K(),!0}function H(){switch(s.getToken()){case c.NumericLiteral:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(V(L.InvalidNumberFormat),ne=0)}catch{V(L.InvalidNumberFormat)}v(ne);break}case c.NullKeyword:v(null);break;case c.TrueKeyword:v(!0);break;case c.FalseKeyword:v(!1);break;default:return!1}return K(),!0}function ie(){return s.getToken()!==c.StringLiteral?(V(L.PropertyNameExpected,[],[c.CloseBraceToken,c.CommaToken]),!1):(x(!1),s.getToken()===c.ColonToken?(E(":"),K(),_()||V(L.ValueExpected,[],[c.CloseBraceToken,c.CommaToken])):V(L.ColonExpected,[],[c.CloseBraceToken,c.CommaToken]),!0)}function W(){r(),K();let ne=!1;for(;s.getToken()!==c.CloseBraceToken&&s.getToken()!==c.EOF;){if(s.getToken()===c.CommaToken){if(ne||V(L.ValueExpected,[],[]),E(","),K(),s.getToken()===c.CloseBraceToken&&j)break}else ne&&V(L.CommaExpected,[],[]);ie()||V(L.ValueExpected,[],[c.CloseBraceToken,c.CommaToken]),ne=!0}return u(),s.getToken()!==c.CloseBraceToken?V(L.CloseBraceExpected,[c.CloseBraceToken],[]):K(),!0}function z(){y(),K();let ne=!1;for(;s.getToken()!==c.CloseBracketToken&&s.getToken()!==c.EOF;){if(s.getToken()===c.CommaToken){if(ne||V(L.ValueExpected,[],[]),E(","),K(),s.getToken()===c.CloseBracketToken&&j)break}else ne&&V(L.CommaExpected,[],[]);_()||V(L.ValueExpected,[],[c.CloseBracketToken,c.CommaToken]),ne=!0}return C(),s.getToken()!==c.CloseBracketToken?V(L.CloseBracketExpected,[c.CloseBracketToken],[]):K(),!0}function _(){switch(s.getToken()){case c.OpenBracketToken:return z();case c.OpenBraceToken:return W();case c.StringLiteral:return x(!0);default:return H()}}return K(),s.getToken()===c.EOF?i.allowEmptyContent?!0:(V(L.ValueExpected,[],[]),!1):_()?(s.getToken()!==c.EOF&&V(L.EndOfFileExpected,[],[]),!0):(V(L.ValueExpected,[],[]),!1)}function m(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}}),define(he[45],ue([0,1,35]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=c,e.$6n=L,e.$7n=O,e.$8n=k;function c(b,R,d){let f,$,l,p,S;if(R){for(p=R.offset,S=p+R.length,l=p;l>0&&!k(b,l-1);)l--;let a=S;for(;a<b.length&&!k(b,a);)a++;$=b.substring(l,a),f=N($,d)}else $=b,f=0,l=0,p=0,S=b.length;const g=O(d,b);let w=!1,P=0,m;d.insertSpaces?m=A(" ",d.tabSize||4):m="	";const o=(0,I.$Tn)($,!1);let h=!1;function i(){return g+A(m,f+P)}function s(){let a=o.scan();for(w=!1;a===I.SyntaxKind.Trivia||a===I.SyntaxKind.LineBreakTrivia;)w=w||a===I.SyntaxKind.LineBreakTrivia,a=o.scan();return h=a===I.SyntaxKind.Unknown||o.getTokenError()!==I.ScanError.None,a}const t=[];function n(a,u,y){!h&&u<S&&y>p&&b.substring(u,y)!==a&&t.push({offset:u,length:y-u,content:a})}let r=s();if(r!==I.SyntaxKind.EOF){const a=o.getTokenOffset()+l,u=A(m,f);n(u,l,a)}for(;r!==I.SyntaxKind.EOF;){let a=o.getTokenOffset()+o.getTokenLength()+l,u=s(),y="";for(;!w&&(u===I.SyntaxKind.LineCommentTrivia||u===I.SyntaxKind.BlockCommentTrivia);){const v=o.getTokenOffset()+l;n(" ",a,v),a=o.getTokenOffset()+o.getTokenLength()+l,y=u===I.SyntaxKind.LineCommentTrivia?i():"",u=s()}if(u===I.SyntaxKind.CloseBraceToken)r!==I.SyntaxKind.OpenBraceToken&&(P--,y=i());else if(u===I.SyntaxKind.CloseBracketToken)r!==I.SyntaxKind.OpenBracketToken&&(P--,y=i());else{switch(r){case I.SyntaxKind.OpenBracketToken:case I.SyntaxKind.OpenBraceToken:P++,y=i();break;case I.SyntaxKind.CommaToken:case I.SyntaxKind.LineCommentTrivia:y=i();break;case I.SyntaxKind.BlockCommentTrivia:w?y=i():y=" ";break;case I.SyntaxKind.ColonToken:y=" ";break;case I.SyntaxKind.StringLiteral:if(u===I.SyntaxKind.ColonToken){y="";break}case I.SyntaxKind.NullKeyword:case I.SyntaxKind.TrueKeyword:case I.SyntaxKind.FalseKeyword:case I.SyntaxKind.NumericLiteral:case I.SyntaxKind.CloseBraceToken:case I.SyntaxKind.CloseBracketToken:u===I.SyntaxKind.LineCommentTrivia||u===I.SyntaxKind.BlockCommentTrivia?y=" ":u!==I.SyntaxKind.CommaToken&&u!==I.SyntaxKind.EOF&&(h=!0);break;case I.SyntaxKind.Unknown:h=!0;break}w&&(u===I.SyntaxKind.LineCommentTrivia||u===I.SyntaxKind.BlockCommentTrivia)&&(y=i())}const C=o.getTokenOffset()+l;n(y,a,C),r=u}return t}function L(b,R){const d=JSON.stringify(b,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?d.replace(/\r\n|\r|\n/g,R.eol):d}function A(b,R){let d="";for(let f=0;f<R;f++)d+=b;return d}function N(b,R){let d=0,f=0;const $=R.tabSize||4;for(;d<b.length;){const l=b.charAt(d);if(l===" ")f++;else if(l==="	")f+=$;else break;d++}return Math.floor(f/$)}function O(b,R){for(let d=0;d<R.length;d++){const f=R.charAt(d);if(f==="\r")return d+1<R.length&&R.charAt(d+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return b&&b.eol||`
`}function k(b,R){return`\r
`.indexOf(b.charAt(R))!==-1}}),define(he[64],ue([0,1,35,45]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=L,e.$0n=A,e.$$n=N,e.$_n=O,e.$ao=k;function L(b,R,d){return A(b,R,void 0,d)}function A(b,R,d,f,$){const l=R.slice(),p=[],S=(0,I.$Wn)(b,p);let g,w;for(;l.length>0&&(w=l.pop(),g=(0,I.$Xn)(S,l),g===void 0&&d!==void 0);)typeof w=="string"?d={[w]:d}:d=[d];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const P=(0,I.$Xn)(g,[w]);if(P!==void 0)if(d===void 0){if(!P.parent)throw new Error("Malformed AST");const m=g.children.indexOf(P.parent);let o,h=P.parent.offset+P.parent.length;if(m>0){const i=g.children[m-1];o=i.offset+i.length}else o=g.offset+1,g.children.length>1&&(h=g.children[1].offset);return N(b,{offset:o,length:h-o,content:""},f)}else return N(b,{offset:P.offset,length:P.length,content:JSON.stringify(d)},f);else{if(d===void 0)return[];const m=`${JSON.stringify(w)}: ${JSON.stringify(d)}`,o=$?$(g.children.map(i=>i.children[0].value)):g.children.length;let h;if(o>0){const i=g.children[o-1];h={offset:i.offset+i.length,length:0,content:","+m}}else g.children.length===0?h={offset:g.offset+1,length:0,content:m}:h={offset:g.offset+1,length:0,content:m+","};return N(b,h,f)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(d!==void 0){const P=`${JSON.stringify(d)}`;let m;if(g.children.length===0||w===0)m={offset:g.offset+1,length:0,content:g.children.length===0?P:P+","};else{const o=w===-1||w>g.children.length?g.children.length:w,h=g.children[o-1];m={offset:h.offset+h.length,length:0,content:","+P}}return N(b,m,f)}else{const P=w,m=g.children[P];let o;if(g.children.length===1)o={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===P){const h=g.children[P-1],i=h.offset+h.length,s=g.offset+g.length;o={offset:i,length:s-2-i,content:""}}else o={offset:m.offset,length:g.children[P+1].offset-m.offset,content:""};return N(b,o,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else return d===void 0?[]:N(b,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(d)},f)}function N(b,R,d){let f=O(b,R),$=R.offset,l=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;$>0&&!(0,c.$8n)(f,$-1);)$--;for(;l<f.length&&!(0,c.$8n)(f,l);)l++}const p=(0,c.$5n)(f,{offset:$,length:l-$},d);for(let g=p.length-1;g>=0;g--){const w=p[g];f=O(f,w),$=Math.min($,w.offset),l=Math.max(l,w.offset+w.length),l+=w.content.length-w.length}const S=b.length-(f.length-l)-$;return[{offset:$,length:S,content:f.substring($,l)}]}function O(b,R){return b.substring(0,R.offset)+R.content+b.substring(R.offset+R.length)}function k(b,R){const d=R.slice(0).sort(($,l)=>{const p=$.offset-l.offset;return p===0?$.length-l.length:p});let f=b.length;for(let $=d.length-1;$>=0;$--){const l=d[$];if(l.offset+l.length<=f)b=O(b,l);else throw new Error("Overlapping edit");f=l.offset}return b}}),define(he[53],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class I{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=I}),define(he[89],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}class c{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let A=this.a;for(;A!==I.Undefined;){const N=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=N}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,N){const O=new I(A);if(this.a===I.Undefined)this.a=O,this.b=O;else if(N){const b=this.b;this.b=O,O.prev=b,b.next=O}else{const b=this.a;this.a=O,O.next=b,b.prev=O}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(O))}}shift(){if(this.a!==I.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==I.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const N=A.prev;N.next=A.next,A.next.prev=N}else A.prev===I.Undefined&&A.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):A.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):A.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.$4c=c}),define(he[36],ue([0,1]),function(oe,e){"use strict";var I,c,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=void 0,e.$wc=A,e.$xc=N,e.$yc=O,e.$Hc=m;function A(o,h,i){let s=o.get(h);return s===void 0&&(s=i,o.set(h,s)),s}function N(o){const h=[];return o.forEach((i,s)=>{h.push(`${s} => ${i}`)}),`Map(${o.size}) {${h.join(", ")}}`}function O(o){const h=[];return o.forEach(i=>{h.push(i)}),`Set(${o.size}) {${h.join(", ")}}`}class k{constructor(h,i){this.uri=h,this.value=i}}function b(o){return Array.isArray(o)}class R{static{this.c=h=>h.toString()}constructor(h,i){if(this[I]="ResourceMap",h instanceof R)this.d=new Map(h.d),this.e=i??R.c;else if(b(h)){this.d=new Map,this.e=i??R.c;for(const[s,t]of h)this.set(s,t)}else this.d=new Map,this.e=h??R.c}set(h,i){return this.d.set(this.e(h),new k(h,i)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,i){typeof i<"u"&&(h=h.bind(i));for(const[s,t]of this.d)h(t.value,t.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$zc=R;class d{constructor(h,i){this[c]="ResourceSet",!h||typeof h=="function"?this.c=new R(h):(this.c=new R(i),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,i){this.c.forEach((s,t)=>h.call(i,t,t,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=d;var f;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class ${constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,i=f.None){const s=this.c.get(h);if(s)return i!==f.None&&this.m(s,i),s.value}set(h,i,s=f.None){let t=this.c.get(h);if(t)t.value=i,s!==f.None&&this.m(t,s);else{switch(t={key:h,value:i,next:void 0,previous:void 0},s){case f.None:this.k(t);break;case f.AsOld:this.j(t);break;case f.AsNew:this.k(t);break;default:this.k(t);break}this.c.set(h,t),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const i=this.c.get(h);if(i)return this.c.delete(h),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.l(h),this.f--,h.value}forEach(h,i){const s=this.g;let t=this.d;for(;t;){if(i?h.bind(i)(t.value,t.key,this):h(t.value,t.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const h=this,i=this.g;let s=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:s.key,done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return t}values(){const h=this,i=this.g;let s=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:s.value,done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return t}entries(){const h=this,i=this.g;let s=this.d;const t={[Symbol.iterator](){return t},next(){if(h.g!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const n={value:[s.key,s.value],done:!1};return s=s.next,n}else return{value:void 0,done:!0}}};return t}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.d,s=this.size;for(;i&&s>h;)this.c.delete(i.key),i=i.next,s--;this.d=i,this.f=s,i&&(i.previous=void 0),this.g++}i(h){if(h>=this.size)return;if(h===0){this.clear();return}let i=this.e,s=this.size;for(;i&&s>h;)this.c.delete(i.key),i=i.previous,s--;this.e=i,this.f=s,i&&(i.next=void 0),this.g++}j(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}k(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}l(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const i=h.next,s=h.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}h.next=void 0,h.previous=void 0,this.g++}m(h,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==f.AsOld&&i!==f.AsNew)){if(i===f.AsOld){if(h===this.d)return;const s=h.next,t=h.previous;h===this.e?(t.next=void 0,this.e=t):(s.previous=t,t.next=s),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(i===f.AsNew){if(h===this.e)return;const s=h.next,t=h.previous;h===this.d?(s.previous=void 0,this.d=s):(s.previous=t,t.next=s),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((i,s)=>{h.push([s,i])}),h}fromJSON(h){this.clear();for(const[i,s]of h)this.set(i,s)}}e.$Bc=$;class l extends ${constructor(h,i=1){super(),this.n=h,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(h){this.n=h,this.p()}get ratio(){return this.o}set ratio(h){this.o=Math.min(Math.max(0,h),1),this.p()}get(h,i=f.AsNew){return super.get(h,i)}peek(h){return super.get(h,f.None)}set(h,i){return super.set(h,i,f.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class p extends l{constructor(h,i=1){super(h,i)}q(h){this.h(h)}set(h,i){return super.set(h,i),this.p(),this}}e.$Cc=p;class S extends l{constructor(h,i=1){super(h,i)}q(h){this.i(h)}set(h,i){return this.n<=this.size&&!this.has(h)&&this.q(Math.round(this.n*this.o)-1),super.set(h,i),this}}e.$Dc=S;class g{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let i=this.c.get(h)||0;return i===0?!1:(i--,i===0?this.c.delete(h):this.c.set(h,i),!0)}has(h){return this.c.has(h)}}e.$Ec=g;class w{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[i,s]of h)this.set(i,s)}clear(){this.c.clear(),this.d.clear()}set(h,i){this.c.set(h,i),this.d.set(i,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const i=this.c.get(h);return i===void 0?!1:(this.c.delete(h),this.d.delete(i),!0)}forEach(h,i){this.c.forEach((s,t)=>{h.call(i,s,t,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=w;class P{constructor(){this.c=new Map}add(h,i){let s=this.c.get(h);s||(s=new Set,this.c.set(h,s)),s.add(i)}delete(h,i){const s=this.c.get(h);s&&(s.delete(i),s.size===0&&this.c.delete(h))}forEach(h,i){const s=this.c.get(h);s&&s.forEach(i)}get(h){const i=this.c.get(h);return i||new Set}}e.$Gc=P;function m(o,h){if(o===h)return!0;if(o.size!==h.size)return!1;for(const[i,s]of o)if(!h.has(i)||h.get(i)!==s)return!1;for(const[i]of h)if(!o.has(i))return!1;return!0}}),define(he[2],ue([0,1,17,130,36,88,63]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Ic=void 0,e.$Jc=R,e.$Kc=d,e.$Lc=f,e.$Mc=p,e.$Nc=S,e.$Oc=g,e.$Pc=w,e.$Qc=P,e.$Rc=m,e.$2c=y;const O=!1;let k=null;class b{constructor(){this.b=new Map}static{this.a=0}c(E){let T=this.b.get(E);return T||(T={parent:null,source:null,isSingleton:!1,value:E,idx:b.a++},this.b.set(E,T)),T}trackDisposable(E){const T=this.c(E);T.source||(T.source=new Error().stack)}setParent(E,T){const F=this.c(E);F.parent=T}markAsDisposed(E){this.b.delete(E)}markAsSingleton(E){this.c(E).isSingleton=!0}f(E,T){const F=T.get(E);if(F)return F;const U=E.parent?this.f(this.c(E.parent),T):E;return T.set(E,U),U}getTrackedDisposables(){const E=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,E).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(E=10,T){let F;if(T)F=T;else{const x=new Map,H=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,x).isSingleton);if(H.length===0)return;const ie=new Set(H.map(W=>W.value));if(F=H.filter(W=>!(W.parent&&ie.has(W.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function U(x){function H(W,z){for(;W.length>0&&z.some(_=>typeof _=="string"?_===W[0]:W[0].match(_));)W.shift()}const ie=x.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return H(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const j=new L.$Gc;for(const x of F){const H=U(x);for(let ie=0;ie<=H.length;ie++)j.add(H.slice(0,ie).join(`
`),x)}F.sort((0,I.$5b)(x=>x.idx,I.$7b));let K="",V=0;for(const x of F.slice(0,E)){V++;const H=U(x),ie=[];for(let W=0;W<H.length;W++){let z=H[W];z=`(shared with ${j.get(H.slice(0,W+1).join(`
`)).size}/${F.length} leaks) at ${z}`;const ne=j.get(H.slice(0,W).join(`
`)),ce=(0,c.$c)([...ne].map(te=>U(te)[W]),te=>te);delete ce[H[W]];for(const[te,Y]of Object.entries(ce))ie.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${te}`);ie.unshift(z)}K+=`


==================== Leaking disposable ${V}/${F.length}: ${x.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return F.length>E&&(K+=`


... and ${F.length-E} more leaking disposables

`),{leaks:F,details:K}}}e.$Ic=b;function R(v){k=v}if(O){const v="__is_disposable_tracked__";R(new class{trackDisposable(E){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[v]||console.log(T)},3e3)}setParent(E,T){if(E&&E!==h.None)try{E[v]=!0}catch{}}markAsDisposed(E){if(E&&E!==h.None)try{E[v]=!0}catch{}}markAsSingleton(E){}})}function d(v){return k?.trackDisposable(v),v}function f(v){k?.markAsDisposed(v)}function $(v,E){k?.setParent(v,E)}function l(v,E){if(k)for(const T of v)k.setParent(T,E)}function p(v){return k?.markAsSingleton(v),v}function S(v){return typeof v=="object"&&v!==null&&typeof v.dispose=="function"&&v.dispose.length===0}function g(v){if(N.Iterable.is(v)){const E=[];for(const T of v)if(T)try{T.dispose()}catch(F){E.push(F)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}function w(v){for(const E of v)S(E)&&E.dispose();return[]}function P(...v){const E=m(()=>g(v));return l(v,E),E}function m(v){const E=d({dispose:(0,A.$cb)(()=>{f(E),v()})});return E}class o{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return $(E,this),this.g?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(E),E.dispose()}}deleteAndLeak(E){E&&this.f.has(E)&&(this.f.delete(E),$(E,null))}}e.$Sc=o;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new o,d(this),$(this.q,this)}dispose(){f(this),this.q.dispose()}B(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(E)}}e.$Tc=h;class i{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(E){this.b||E===this.a||(this.a?.dispose(),E&&$(E,this),this.a=E)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const E=this.a;return this.a=void 0,E&&$(E,null),E}}e.$Uc=i;class s{constructor(E){this.a=new i,this.b=!1,this.a.value=E}get value(){return this.a.value}set value(E){this.b||E===this.a.value||(this.a.value=E)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class t{constructor(E){this.b=E,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=t;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(E){let T=E;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,f(this))},this}}e.$Xc=n;class r{constructor(){this.a=new Map}acquire(E,...T){let F=this.a.get(E);F||(F={counter:0,object:this.b(E,...T)},this.a.set(E,F));const{object:U}=F,j=(0,A.$cb)(()=>{--F.counter===0&&(this.c(E,F.object),this.a.delete(E))});return F.counter++,{object:U,dispose:j}}}e.$Yc=r;class a{constructor(E){this.a=E}async acquire(E,...T){const F=this.a.acquire(E,...T);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(U){throw F.dispose(),U}}}e.$Zc=a;class u{constructor(E){this.object=E}dispose(){}}e.$1c=u;function y(v){const E=new o;try{v(E)}finally{E.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(E){return this.a.has(E)}get size(){return this.a.size}get(E){return this.a.get(E)}set(E,T,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(E)?.dispose(),this.a.set(E,T)}deleteAndDispose(E){this.a.get(E)?.dispose(),this.a.delete(E)}deleteAndLeak(E){const T=this.a.get(E);return this.a.delete(E),T}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=C}),define(he[65],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var I;(function(c){c[c.Uri=1]="Uri",c[c.Regexp=2]="Regexp",c[c.ScmResource=3]="ScmResource",c[c.ScmResourceGroup=4]="ScmResourceGroup",c[c.ScmProvider=5]="ScmProvider",c[c.CommentController=6]="CommentController",c[c.CommentThread=7]="CommentThread",c[c.CommentThreadInstance=8]="CommentThreadInstance",c[c.CommentThreadReply=9]="CommentThreadReply",c[c.CommentNode=10]="CommentNode",c[c.CommentThreadNode=11]="CommentThreadNode",c[c.TimelineActionContext=12]="TimelineActionContext",c[c.NotebookCellActionContext=13]="NotebookCellActionContext",c[c.NotebookActionContext=14]="NotebookActionContext",c[c.TerminalContext=15]="TerminalContext",c[c.TestItemContext=16]="TestItemContext",c[c.Date=17]="Date",c[c.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(I||(e.MarshalledId=I={}))}),define(he[90],ue([0,1,36]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=void 0,e.$km=L,e.$lm=N;const c=new I.$Cc(1e4);function L(b){return k(b,"NFC",c)}const A=new I.$Cc(1e4);function N(b){return k(b,"NFD",A)}const O=/[^\u0000-\u0080]/;function k(b,R,d){if(!b)return b;const f=d.get(b);if(f)return f;let $;return O.test(b)?$=b.normalize(R):$=b,d.set(b,$),$}e.$mm=function(){const b=/[\u0300-\u036f]/g;return function(R){return N(R).replace(b,"")}}()}),function(){function oe(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function N(k){A.push(k,Date.now())}function O(){const k=[];for(let b=0;b<A.length;b+=2)k.push({name:A[b],startTime:A[b+1]});return k}return{mark:N,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const N of performance.getEntriesByType("mark"))A.push({name:N.name,startTime:Math.round(L+N.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function I(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var c;typeof global=="object"?c=global:typeof self=="object"?c=self:c={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(c)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(c):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),c.perf=I(c))}(),define(he[5],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=h,e.$E=a,e.$K=u,e.$h="en";let I=!1,c=!1,L=!1,A=!1,N=!1,O=!1,k=!1,b=!1,R=!1,d=!1,f,$=e.$h,l=e.$h,p,S;const g=globalThis;let w;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?w=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const P=typeof w?.versions?.electron=="string",m=P&&w?.type==="renderer";if(typeof w=="object"){I=w.platform==="win32",c=w.platform==="darwin",L=w.platform==="linux",A=L&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,k=P,R=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$h,$=e.$h;const y=w.env.VSCODE_NLS_CONFIG;if(y)try{const C=JSON.parse(y);f=C.userLocale,l=C.osLocale,$=C.resolvedLanguage||e.$h,p=C.languagePack?.translationsConfigFile}catch{}N=!0}else typeof navigator=="object"&&!m?(S=navigator.userAgent,I=S.indexOf("Windows")>=0,c=S.indexOf("Macintosh")>=0,b=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=S.indexOf("Linux")>=0,d=S?.indexOf("Mobi")>=0,O=!0,$=globalThis._VSCODE_NLS_LANGUAGE||e.$h,f=navigator.language.toLowerCase(),l=f):console.error("Unable to resolve platform.");var o;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(o||(e.Platform=o={}));function h(y){switch(y){case o.Web:return"Web";case o.Mac:return"Mac";case o.Linux:return"Linux";case o.Windows:return"Windows"}}let i=o.Web;c?i=o.Mac:I?i=o.Windows:L&&(i=o.Linux),e.$j=I,e.$k=c,e.$l=L,e.$m=A,e.$n=N,e.$o=k,e.$p=O,e.$q=O&&typeof g.importScripts=="function",e.$r=e.$q?g.origin:void 0,e.$s=b,e.$t=d,e.$u=R,e.$v=i,e.$w=S,e.$x=$;var s;(function(y){function C(){return e.$x}y.value=C;function v(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}y.isDefaultVariant=v;function E(){return e.$x==="en"}y.isDefault=E})(s||(e.Language=s={})),e.$y=f,e.$z=l,e.$A=p,e.$B=typeof g.postMessage=="function"&&!g.importScripts,e.$C=(()=>{if(e.$B){const y=[];g.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let E=0,T=y.length;E<T;E++){const F=y[E];if(F.id===v.data.vscodeScheduleAsyncWork){y.splice(E,1),F.callback();return}}});let C=0;return v=>{const E=++C;y.push({id:E,callback:v}),g.postMessage({vscodeScheduleAsyncWork:E},"*")}}return y=>setTimeout(y)})();var t;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=c||b?t.Macintosh:I?t.Windows:t.Linux;let n=!0,r=!1;function a(){if(!r){r=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,n=new Uint16Array(y.buffer)[0]===513}return n}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function u(y){return parseFloat(y)>=20}}),define(he[37],ue([0,1,5]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let c;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;c={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?c={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:c={get platform(){return I.$j?"win32":I.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=c.cwd,e.env=c.env,e.$cc=c.platform,e.$dc=c.arch}),define(he[132],ue([0,1,37]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aX=N;var c;(function(O){O.UNKNOWN="UNKNOWN",O.CINNAMON="CINNAMON",O.DEEPIN="DEEPIN",O.GNOME="GNOME",O.KDE3="KDE3",O.KDE4="KDE4",O.KDE5="KDE5",O.KDE6="KDE6",O.PANTHEON="PANTHEON",O.UNITY="UNITY",O.XFCE="XFCE",O.UKUI="UKUI",O.LXQT="LXQT"})(c||(c={}));const L="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function N(){const O=I.env[L];if(O){const b=O.split(":").map(R=>R.trim()).filter(R=>R.length>0);for(const R of b)switch(R){case"Unity":{const d=I.env.DESKTOP_SESSION;return d&&d.includes("gnome-fallback")?c.GNOME:c.UNITY}case"Deepin":return c.DEEPIN;case"GNOME":return c.GNOME;case"X-Cinnamon":return c.CINNAMON;case"KDE":{const d=I.env[A];return d==="5"?c.KDE5:d==="6"?c.KDE6:c.KDE4}case"Pantheon":return c.PANTHEON;case"XFCE":return c.XFCE;case"UKUI":return c.UKUI;case"LXQt":return c.LXQT}}const k=I.env.DESKTOP_SESSION;if(k)switch(k){case"deepin":return c.DEEPIN;case"gnome":case"mate":return c.GNOME;case"kde4":case"kde-plasma":return c.KDE4;case"kde":return A in I.env?c.KDE4:c.KDE3;case"xfce":case"xubuntu":return c.XFCE;case"ukui":return c.UKUI}return"GNOME_DESKTOP_SESSION_ID"in I.env?c.GNOME:"KDE_FULL_SESSION"in I.env?A in I.env?c.KDE4:c.KDE3:c.UNKNOWN}});var Ot=this&&this.__createBinding||(Object.create?function(oe,e,I,c){c===void 0&&(c=I);var L=Object.getOwnPropertyDescriptor(e,I);(!L||("get"in L?!e.__esModule:L.writable||L.configurable))&&(L={enumerable:!0,get:function(){return e[I]}}),Object.defineProperty(oe,c,L)}:function(oe,e,I,c){c===void 0&&(c=I),oe[c]=e[I]}),At=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),ke=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var I in oe)I!=="default"&&Object.prototype.hasOwnProperty.call(oe,I)&&Ot(e,oe,I);return At(e,oe),e};define(he[13],ue([0,1,37]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0,I=ke(I);const c=65,L=97,A=90,N=122,O=46,k=47,b=92,R=58,d=63;class f extends Error{constructor(s,t,n){let r;typeof t=="string"&&t.indexOf("not ")===0?(r="must not be",t=t.replace(/^not /,"")):r="must be";const a=s.indexOf(".")!==-1?"property":"argument";let u=`The "${s}" ${a} ${r} of type ${t}`;u+=`. Received type ${typeof n}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function $(i,s){if(i===null||typeof i!="object")throw new f(s,"Object",i)}function l(i,s){if(typeof i!="string")throw new f(s,"string",i)}const p=I.$cc==="win32";function S(i){return i===k||i===b}function g(i){return i===k}function w(i){return i>=c&&i<=A||i>=L&&i<=N}function P(i,s,t,n){let r="",a=0,u=-1,y=0,C=0;for(let v=0;v<=i.length;++v){if(v<i.length)C=i.charCodeAt(v);else{if(n(C))break;C=k}if(n(C)){if(!(u===v-1||y===1))if(y===2){if(r.length<2||a!==2||r.charCodeAt(r.length-1)!==O||r.charCodeAt(r.length-2)!==O){if(r.length>2){const E=r.lastIndexOf(t);E===-1?(r="",a=0):(r=r.slice(0,E),a=r.length-1-r.lastIndexOf(t)),u=v,y=0;continue}else if(r.length!==0){r="",a=0,u=v,y=0;continue}}s&&(r+=r.length>0?`${t}..`:"..",a=2)}else r.length>0?r+=`${t}${i.slice(u+1,v)}`:r=i.slice(u+1,v),a=v-u-1;u=v,y=0}else C===O&&y!==-1?++y:y=-1}return r}function m(i){return i?`${i[0]==="."?"":"."}${i}`:""}function o(i,s){$(s,"pathObject");const t=s.dir||s.root,n=s.base||`${s.name||""}${m(s.ext)}`;return t?t===s.root?`${t}${n}`:`${t}${i}${n}`:n}e.$ec={resolve(...i){let s="",t="",n=!1;for(let r=i.length-1;r>=-1;r--){let a;if(r>=0){if(a=i[r],l(a,`paths[${r}]`),a.length===0)continue}else s.length===0?a=I.cwd():(a=I.env[`=${s}`]||I.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==s.toLowerCase()&&a.charCodeAt(2)===b)&&(a=`${s}\\`));const u=a.length;let y=0,C="",v=!1;const E=a.charCodeAt(0);if(u===1)S(E)&&(y=1,v=!0);else if(S(E))if(v=!0,S(a.charCodeAt(1))){let T=2,F=T;for(;T<u&&!S(a.charCodeAt(T));)T++;if(T<u&&T!==F){const U=a.slice(F,T);for(F=T;T<u&&S(a.charCodeAt(T));)T++;if(T<u&&T!==F){for(F=T;T<u&&!S(a.charCodeAt(T));)T++;(T===u||T!==F)&&(C=`\\\\${U}\\${a.slice(F,T)}`,y=T)}}}else y=1;else w(E)&&a.charCodeAt(1)===R&&(C=a.slice(0,2),y=2,u>2&&S(a.charCodeAt(2))&&(v=!0,y=3));if(C.length>0)if(s.length>0){if(C.toLowerCase()!==s.toLowerCase())continue}else s=C;if(n){if(s.length>0)break}else if(t=`${a.slice(y)}\\${t}`,n=v,v&&s.length>0)break}return t=P(t,!n,"\\",S),n?`${s}\\${t}`:`${s}${t}`||"."},normalize(i){l(i,"path");const s=i.length;if(s===0)return".";let t=0,n,r=!1;const a=i.charCodeAt(0);if(s===1)return g(a)?"\\":i;if(S(a))if(r=!0,S(i.charCodeAt(1))){let y=2,C=y;for(;y<s&&!S(i.charCodeAt(y));)y++;if(y<s&&y!==C){const v=i.slice(C,y);for(C=y;y<s&&S(i.charCodeAt(y));)y++;if(y<s&&y!==C){for(C=y;y<s&&!S(i.charCodeAt(y));)y++;if(y===s)return`\\\\${v}\\${i.slice(C)}\\`;y!==C&&(n=`\\\\${v}\\${i.slice(C,y)}`,t=y)}}}else t=1;else w(a)&&i.charCodeAt(1)===R&&(n=i.slice(0,2),t=2,s>2&&S(i.charCodeAt(2))&&(r=!0,t=3));let u=t<s?P(i.slice(t),!r,"\\",S):"";return u.length===0&&!r&&(u="."),u.length>0&&S(i.charCodeAt(s-1))&&(u+="\\"),n===void 0?r?`\\${u}`:u:r?`${n}\\${u}`:`${n}${u}`},isAbsolute(i){l(i,"path");const s=i.length;if(s===0)return!1;const t=i.charCodeAt(0);return S(t)||s>2&&w(t)&&i.charCodeAt(1)===R&&S(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,t;for(let a=0;a<i.length;++a){const u=i[a];l(u,"path"),u.length>0&&(s===void 0?s=t=u:s+=`\\${u}`)}if(s===void 0)return".";let n=!0,r=0;if(typeof t=="string"&&S(t.charCodeAt(0))){++r;const a=t.length;a>1&&S(t.charCodeAt(1))&&(++r,a>2&&(S(t.charCodeAt(2))?++r:n=!1))}if(n){for(;r<s.length&&S(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.$ec.normalize(s)},relative(i,s){if(l(i,"from"),l(s,"to"),i===s)return"";const t=e.$ec.resolve(i),n=e.$ec.resolve(s);if(t===n||(i=t.toLowerCase(),s=n.toLowerCase(),i===s))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===b;)r++;let a=i.length;for(;a-1>r&&i.charCodeAt(a-1)===b;)a--;const u=a-r;let y=0;for(;y<s.length&&s.charCodeAt(y)===b;)y++;let C=s.length;for(;C-1>y&&s.charCodeAt(C-1)===b;)C--;const v=C-y,E=u<v?u:v;let T=-1,F=0;for(;F<E;F++){const j=i.charCodeAt(r+F);if(j!==s.charCodeAt(y+F))break;j===b&&(T=F)}if(F!==E){if(T===-1)return n}else{if(v>E){if(s.charCodeAt(y+F)===b)return n.slice(y+F+1);if(F===2)return n.slice(y+F)}u>E&&(i.charCodeAt(r+F)===b?T=F:F===2&&(T=3)),T===-1&&(T=0)}let U="";for(F=r+T+1;F<=a;++F)(F===a||i.charCodeAt(F)===b)&&(U+=U.length===0?"..":"\\..");return y+=T,U.length>0?`${U}${n.slice(y,C)}`:(n.charCodeAt(y)===b&&++y,n.slice(y,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.$ec.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===b){if(s.charCodeAt(1)===b){const t=s.charCodeAt(2);if(t!==d&&t!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(w(s.charCodeAt(0))&&s.charCodeAt(1)===R&&s.charCodeAt(2)===b)return`\\\\?\\${s}`;return i},dirname(i){l(i,"path");const s=i.length;if(s===0)return".";let t=-1,n=0;const r=i.charCodeAt(0);if(s===1)return S(r)?i:".";if(S(r)){if(t=n=1,S(i.charCodeAt(1))){let y=2,C=y;for(;y<s&&!S(i.charCodeAt(y));)y++;if(y<s&&y!==C){for(C=y;y<s&&S(i.charCodeAt(y));)y++;if(y<s&&y!==C){for(C=y;y<s&&!S(i.charCodeAt(y));)y++;if(y===s)return i;y!==C&&(t=n=y+1)}}}}else w(r)&&i.charCodeAt(1)===R&&(t=s>2&&S(i.charCodeAt(2))?3:2,n=t);let a=-1,u=!0;for(let y=s-1;y>=n;--y)if(S(i.charCodeAt(y))){if(!u){a=y;break}}else u=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,s){s!==void 0&&l(s,"suffix"),l(i,"path");let t=0,n=-1,r=!0,a;if(i.length>=2&&w(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(t=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let u=s.length-1,y=-1;for(a=i.length-1;a>=t;--a){const C=i.charCodeAt(a);if(S(C)){if(!r){t=a+1;break}}else y===-1&&(r=!1,y=a+1),u>=0&&(C===s.charCodeAt(u)?--u===-1&&(n=a):(u=-1,n=y))}return t===n?n=y:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=t;--a)if(S(i.charCodeAt(a))){if(!r){t=a+1;break}}else n===-1&&(r=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){l(i,"path");let s=0,t=-1,n=0,r=-1,a=!0,u=0;i.length>=2&&i.charCodeAt(1)===R&&w(i.charCodeAt(0))&&(s=n=2);for(let y=i.length-1;y>=s;--y){const C=i.charCodeAt(y);if(S(C)){if(!a){n=y+1;break}continue}r===-1&&(a=!1,r=y+1),C===O?t===-1?t=y:u!==1&&(u=1):t!==-1&&(u=-1)}return t===-1||r===-1||u===0||u===1&&t===r-1&&t===n+1?"":i.slice(t,r)},format:o.bind(null,"\\"),parse(i){l(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const t=i.length;let n=0,r=i.charCodeAt(0);if(t===1)return S(r)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(S(r)){if(n=1,S(i.charCodeAt(1))){let T=2,F=T;for(;T<t&&!S(i.charCodeAt(T));)T++;if(T<t&&T!==F){for(F=T;T<t&&S(i.charCodeAt(T));)T++;if(T<t&&T!==F){for(F=T;T<t&&!S(i.charCodeAt(T));)T++;T===t?n=T:T!==F&&(n=T+1)}}}}else if(w(r)&&i.charCodeAt(1)===R){if(t<=2)return s.root=s.dir=i,s;if(n=2,S(i.charCodeAt(2))){if(t===3)return s.root=s.dir=i,s;n=3}}n>0&&(s.root=i.slice(0,n));let a=-1,u=n,y=-1,C=!0,v=i.length-1,E=0;for(;v>=n;--v){if(r=i.charCodeAt(v),S(r)){if(!C){u=v+1;break}continue}y===-1&&(C=!1,y=v+1),r===O?a===-1?a=v:E!==1&&(E=1):a!==-1&&(E=-1)}return y!==-1&&(a===-1||E===0||E===1&&a===y-1&&a===u+1?s.base=s.name=i.slice(u,y):(s.name=i.slice(u,a),s.base=i.slice(u,y),s.ext=i.slice(a,y))),u>0&&u!==n?s.dir=i.slice(0,u-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(p){const i=/\\/g;return()=>{const s=I.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...i){let s="",t=!1;for(let n=i.length-1;n>=-1&&!t;n--){const r=n>=0?i[n]:h();l(r,`paths[${n}]`),r.length!==0&&(s=`${r}/${s}`,t=r.charCodeAt(0)===k)}return s=P(s,!t,"/",g),t?`/${s}`:s.length>0?s:"."},normalize(i){if(l(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===k,t=i.charCodeAt(i.length-1)===k;return i=P(i,!s,"/",g),i.length===0?s?"/":t?"./":".":(t&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return l(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let s;for(let t=0;t<i.length;++t){const n=i[t];l(n,"path"),n.length>0&&(s===void 0?s=n:s+=`/${n}`)}return s===void 0?".":e.$fc.normalize(s)},relative(i,s){if(l(i,"from"),l(s,"to"),i===s||(i=e.$fc.resolve(i),s=e.$fc.resolve(s),i===s))return"";const t=1,n=i.length,r=n-t,a=1,u=s.length-a,y=r<u?r:u;let C=-1,v=0;for(;v<y;v++){const T=i.charCodeAt(t+v);if(T!==s.charCodeAt(a+v))break;T===k&&(C=v)}if(v===y)if(u>y){if(s.charCodeAt(a+v)===k)return s.slice(a+v+1);if(v===0)return s.slice(a+v)}else r>y&&(i.charCodeAt(t+v)===k?C=v:v===0&&(C=0));let E="";for(v=t+C+1;v<=n;++v)(v===n||i.charCodeAt(v)===k)&&(E+=E.length===0?"..":"/..");return`${E}${s.slice(a+C)}`},toNamespacedPath(i){return i},dirname(i){if(l(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===k;let t=-1,n=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===k){if(!n){t=r;break}}else n=!1;return t===-1?s?"/":".":s&&t===1?"//":i.slice(0,t)},basename(i,s){s!==void 0&&l(s,"ext"),l(i,"path");let t=0,n=-1,r=!0,a;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let u=s.length-1,y=-1;for(a=i.length-1;a>=0;--a){const C=i.charCodeAt(a);if(C===k){if(!r){t=a+1;break}}else y===-1&&(r=!1,y=a+1),u>=0&&(C===s.charCodeAt(u)?--u===-1&&(n=a):(u=-1,n=y))}return t===n?n=y:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===k){if(!r){t=a+1;break}}else n===-1&&(r=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){l(i,"path");let s=-1,t=0,n=-1,r=!0,a=0;for(let u=i.length-1;u>=0;--u){const y=i.charCodeAt(u);if(y===k){if(!r){t=u+1;break}continue}n===-1&&(r=!1,n=u+1),y===O?s===-1?s=u:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||n===-1||a===0||a===1&&s===n-1&&s===t+1?"":i.slice(s,n)},format:o.bind(null,"/"),parse(i){l(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const t=i.charCodeAt(0)===k;let n;t?(s.root="/",n=1):n=0;let r=-1,a=0,u=-1,y=!0,C=i.length-1,v=0;for(;C>=n;--C){const E=i.charCodeAt(C);if(E===k){if(!y){a=C+1;break}continue}u===-1&&(y=!1,u=C+1),E===O?r===-1?r=C:v!==1&&(v=1):r!==-1&&(v=-1)}if(u!==-1){const E=a===0&&t?1:a;r===-1||v===0||v===1&&r===u-1&&r===a+1?s.base=s.name=i.slice(E,u):(s.name=i.slice(E,r),s.base=i.slice(E,u),s.ext=i.slice(r,u))}return a>0?s.dir=i.slice(0,a-1):t&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=p?e.$ec.normalize:e.$fc.normalize,e.$hc=p?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=p?e.$ec.join:e.$fc.join,e.$jc=p?e.$ec.resolve:e.$fc.resolve,e.$kc=p?e.$ec.relative:e.$fc.relative,e.$lc=p?e.$ec.dirname:e.$fc.dirname,e.$mc=p?e.$ec.basename:e.$fc.basename,e.$nc=p?e.$ec.extname:e.$fc.extname,e.$oc=p?e.$ec.format:e.$fc.format,e.$pc=p?e.$ec.parse:e.$fc.parse,e.$qc=p?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=p?e.$ec.sep:e.$fc.sep,e.$sc=p?e.$ec.delimiter:e.$fc.delimiter}),define(he[133],ue([0,1,13]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$9s=A,e.$0s=N,e.$$s=O,e.$_s=b,e.$8s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const c={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const d=(0,I.$nc)(R),f=c[d.toLowerCase()];return f!==void 0?f:N(R)}function N(R){const d=(0,I.$nc)(R);return L[d.toLowerCase()]}function O(R){for(const d in L)if(L[d]===R)return d}const k=/^(.+)\/(.+?)(;.+)?$/;function b(R,d){const f=k.exec(R);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:d?void 0:R}}),define(he[91],ue([0,1,5]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$im=A,e.$jm=N;var c;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(c||(e.Source=c={}));var L;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(O,...k){const b=k.reduce((f,$)=>(f[$]=!0,f),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(f=>!b[f]).forEach(f=>{for(let $=0;$<R.length;$++)if(f.search(R[$])!==-1){delete O[f];break}})}function N(O){O&&(delete O.DEBUG,I.$l&&delete O.LD_PRELOAD)}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var c in I)(typeof exports=="object"?exports:oe)[c]=I[c]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function I(c){if(e[c])return e[c].exports;var L=e[c]={i:c,l:!1,exports:{}};return oe[c].call(L.exports,L,L.exports,I),L.l=!0,L.exports}return I.m=oe,I.c=e,I.d=function(c,L,A){I.o(c,L)||Object.defineProperty(c,L,{enumerable:!0,get:A})},I.r=function(c){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(c,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(c,"__esModule",{value:!0})},I.t=function(c,L){if(1&L&&(c=I(c)),8&L||4&L&&typeof c=="object"&&c&&c.__esModule)return c;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:c}),2&L&&typeof c!="string")for(var N in c)I.d(A,N,function(O){return c[O]}.bind(null,N));return A},I.n=function(c){var L=c&&c.__esModule?function(){return c.default}:function(){return c};return I.d(L,"a",L),L},I.o=function(c,L){return Object.prototype.hasOwnProperty.call(c,L)},I.p="",I(I.s=0)}([function(oe,e,I){(function(c){var L;e=oe.exports=Y,L=typeof c=="object"&&c.env&&c.env.NODE_DEBUG&&/\bsemver\b/i.test(c.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],k=e.src=[],b=0,R=b++;k[R]="0|[1-9]\\d*";var d=b++;k[d]="[0-9]+";var f=b++;k[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=b++;k[$]="("+k[R]+")\\.("+k[R]+")\\.("+k[R]+")";var l=b++;k[l]="("+k[d]+")\\.("+k[d]+")\\.("+k[d]+")";var p=b++;k[p]="(?:"+k[R]+"|"+k[f]+")";var S=b++;k[S]="(?:"+k[d]+"|"+k[f]+")";var g=b++;k[g]="(?:-("+k[p]+"(?:\\."+k[p]+")*))";var w=b++;k[w]="(?:-?("+k[S]+"(?:\\."+k[S]+")*))";var P=b++;k[P]="[0-9A-Za-z-]+";var m=b++;k[m]="(?:\\+("+k[P]+"(?:\\."+k[P]+")*))";var o=b++,h="v?"+k[$]+k[g]+"?"+k[m]+"?";k[o]="^"+h+"$";var i="[v=\\s]*"+k[l]+k[w]+"?"+k[m]+"?",s=b++;k[s]="^"+i+"$";var t=b++;k[t]="((?:<|>)?=?)";var n=b++;k[n]=k[d]+"|x|X|\\*";var r=b++;k[r]=k[R]+"|x|X|\\*";var a=b++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[g]+")?"+k[m]+"?)?)?";var u=b++;k[u]="[v=\\s]*("+k[n]+")(?:\\.("+k[n]+")(?:\\.("+k[n]+")(?:"+k[w]+")?"+k[m]+"?)?)?";var y=b++;k[y]="^"+k[t]+"\\s*"+k[a]+"$";var C=b++;k[C]="^"+k[t]+"\\s*"+k[u]+"$";var v=b++;k[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=b++;k[E]="(?:~>?)";var T=b++;k[T]="(\\s*)"+k[E]+"\\s+",O[T]=new RegExp(k[T],"g");var F=b++;k[F]="^"+k[E]+k[a]+"$";var U=b++;k[U]="^"+k[E]+k[u]+"$";var j=b++;k[j]="(?:\\^)";var K=b++;k[K]="(\\s*)"+k[j]+"\\s+",O[K]=new RegExp(k[K],"g");var V=b++;k[V]="^"+k[j]+k[a]+"$";var x=b++;k[x]="^"+k[j]+k[u]+"$";var H=b++;k[H]="^"+k[t]+"\\s*("+i+")$|^$";var ie=b++;k[ie]="^"+k[t]+"\\s*("+h+")$|^$";var W=b++;k[W]="(\\s*)"+k[t]+"\\s*("+i+"|"+k[a]+")",O[W]=new RegExp(k[W],"g");var z=b++;k[z]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var _=b++;k[_]="^\\s*("+k[u]+")\\s+-\\s+("+k[u]+")\\s*$";var ne=b++;k[ne]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)L(ce,k[ce]),O[ce]||(O[ce]=new RegExp(k[ce]));function te(ae,de){if(ae instanceof Y)return ae;if(typeof ae!="string"||ae.length>A||!(de?O[s]:O[o]).test(ae))return null;try{return new Y(ae,de)}catch{return null}}function Y(ae,de){if(ae instanceof Y){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Y))return new Y(ae,de);L("SemVer",ae,de),this.loose=de;var me=ae.trim().match(de?O[s]:O[o]);if(!me)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Oe=+Pe;if(Oe>=0&&Oe<N)return Oe}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=te,e.valid=function(ae,de){var me=te(ae,de);return me?me.version:null},e.clean=function(ae,de){var me=te(ae.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ae){return L("SemVer.compare",this.version,this.loose,ae),ae instanceof Y||(ae=new Y(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},Y.prototype.compareMain=function(ae){return ae instanceof Y||(ae=new Y(ae,this.loose)),B(this.major,ae.major)||B(this.minor,ae.minor)||B(this.patch,ae.patch)},Y.prototype.comparePre=function(ae){if(ae instanceof Y||(ae=new Y(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=ae.prerelease[de];if(L("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return B(me,Pe)}while(++de)},Y.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new Y(ae,me).inc(de,Pe).version}catch{return null}},e.diff=function(ae,de){if(M(ae,de))return null;var me=te(ae),Pe=te(de);if(me.prerelease.length||Pe.prerelease.length){for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return Oe},e.compareIdentifiers=B;var G=/^[0-9]+$/;function B(ae,de){var me=G.test(ae),Pe=G.test(de);return me&&Pe&&(ae=+ae,de=+de),me&&!Pe?-1:Pe&&!me?1:ae<de?-1:ae>de?1:0}function D(ae,de,me){return new Y(ae,me).compare(new Y(de,me))}function J(ae,de,me){return D(ae,de,me)>0}function q(ae,de,me){return D(ae,de,me)<0}function M(ae,de,me){return D(ae,de,me)===0}function Z(ae,de,me){return D(ae,de,me)!==0}function ee(ae,de,me){return D(ae,de,me)>=0}function X(ae,de,me){return D(ae,de,me)<=0}function re(ae,de,me,Pe){var Oe;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Oe=ae===me;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Oe=ae!==me;break;case"":case"=":case"==":Oe=M(ae,me,Pe);break;case"!=":Oe=Z(ae,me,Pe);break;case">":Oe=J(ae,me,Pe);break;case">=":Oe=ee(ae,me,Pe);break;case"<":Oe=q(ae,me,Pe);break;case"<=":Oe=X(ae,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Oe}function le(ae,de){if(ae instanceof le){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof le))return new le(ae,de);L("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(ae,de){return B(de,ae)},e.major=function(ae,de){return new Y(ae,de).major},e.minor=function(ae,de){return new Y(ae,de).minor},e.patch=function(ae,de){return new Y(ae,de).patch},e.compare=D,e.compareLoose=function(ae,de){return D(ae,de,!0)},e.rcompare=function(ae,de,me){return D(de,ae,me)},e.sort=function(ae,de){return ae.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(ae,de){return ae.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=J,e.lt=q,e.eq=M,e.neq=Z,e.gte=ee,e.lte=X,e.cmp=re,e.Comparator=le;var ge={};function pe(ae,de){if(ae instanceof pe)return ae.loose===de?ae:new pe(ae.raw,de);if(ae instanceof le)return new pe(ae.value,de);if(!(this instanceof pe))return new pe(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ee(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function we(ae,de,me,Pe,Oe,Fe,Ne,Le,Ue,qe,He,je,Be){return((de=Ee(me)?"":Ee(Pe)?">="+me+".0.0":Ee(Oe)?">="+me+"."+Pe+".0":">="+de)+" "+(Le=Ee(Ue)?"":Ee(qe)?"<"+(+Ue+1)+".0.0":Ee(He)?"<"+Ue+"."+(+qe+1)+".0":je?"<="+Ue+"."+qe+"."+He+"-"+je:"<="+Le)).trim()}function be(ae,de){for(var me=0;me<ae.length;me++)if(!ae[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<ae.length;me++)if(L(ae[me].semver),ae[me].semver!==ge&&ae[me].semver.prerelease.length>0){var Pe=ae[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Se(ae,de,me){try{de=new pe(de,me)}catch{return!1}return de.test(ae)}function Ie(ae,de,me,Pe){var Oe,Fe,Ne,Le,Ue;switch(ae=new Y(ae,Pe),de=new pe(de,Pe),me){case">":Oe=J,Fe=X,Ne=q,Le=">",Ue=">=";break;case"<":Oe=q,Fe=ee,Ne=J,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(ae,de,Pe))return!1;for(var qe=0;qe<de.set.length;++qe){var He=de.set[qe],je=null,Be=null;if(He.forEach(function(ze){ze.semver===ge&&(ze=new le(">=0.0.0")),je=je||ze,Be=Be||ze,Oe(ze.semver,je.semver,Pe)?je=ze:Ne(ze.semver,Be.semver,Pe)&&(Be=ze)}),je.operator===Le||je.operator===Ue||(!Be.operator||Be.operator===Le)&&Fe(ae,Be.semver)||Be.operator===Ue&&Ne(ae,Be.semver))return!1}return!0}le.prototype.parse=function(ae){var de=this.loose?O[H]:O[ie],me=ae.match(de);if(!me)throw new TypeError("Invalid comparator: "+ae);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new Y(me[2],this.loose):this.semver=ge},le.prototype.toString=function(){return this.value},le.prototype.test=function(ae){return L("Comparator.test",ae,this.loose),this.semver===ge||(typeof ae=="string"&&(ae=new Y(ae,this.loose)),re(ae,this.operator,this.semver,this.loose))},le.prototype.intersects=function(ae,de){if(!(ae instanceof le))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new pe(ae.value,de),Se(this.value,me,de);if(ae.operator==="")return me=new pe(this.value,de),Se(ae.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Fe=this.semver.version===ae.semver.version,Ne=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Le=re(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ue=re(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Pe||Oe||Fe&&Ne||Le||Ue},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),L("range",ae,de);var me=de?O[_]:O[z];ae=ae.replace(me,we),L("hyphen replace",ae),ae=ae.replace(O[W],"$1$2$3"),L("comparator trim",ae,O[W]),ae=(ae=(ae=ae.replace(O[T],"$1~")).replace(O[K],"$1^")).split(/\s+/).join(" ");var Pe=de?O[H]:O[ie],Oe=ae.split(" ").map(function(Fe){return function(Ne,Le){return L("comp",Ne),Ne=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(je,Be){L("caret",je,Be);var ze=Be?O[x]:O[V];return je.replace(ze,function(We,Ce,se,fe,$e){var ye;return L("caret",je,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=Ce==="0"?">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+".0 <"+(+Ce+1)+".0.0":$e?(L("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+$e+" <"+(+Ce+1)+".0.0"):(L("no pr"),ye=Ce==="0"?se==="0"?">="+Ce+"."+se+"."+fe+" <"+Ce+"."+se+"."+(+fe+1):">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0":">="+Ce+"."+se+"."+fe+" <"+(+Ce+1)+".0.0"),L("caret return",ye),ye})}(He,qe)}).join(" ")}(Ne,Le),L("caret",Ne),Ne=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(je,Be){var ze=Be?O[U]:O[F];return je.replace(ze,function(We,Ce,se,fe,$e){var ye;return L("tilde",je,We,Ce,se,fe,$e),Ee(Ce)?ye="":Ee(se)?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ee(fe)?ye=">="+Ce+"."+se+".0 <"+Ce+"."+(+se+1)+".0":$e?(L("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Ce+"."+se+"."+fe+$e+" <"+Ce+"."+(+se+1)+".0"):ye=">="+Ce+"."+se+"."+fe+" <"+Ce+"."+(+se+1)+".0",L("tilde return",ye),ye})}(He,qe)}).join(" ")}(Ne,Le),L("tildes",Ne),Ne=function(Ue,qe){return L("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(He){return function(je,Be){je=je.trim();var ze=Be?O[C]:O[y];return je.replace(ze,function(We,Ce,se,fe,$e,ye){L("xRange",je,We,Ce,se,fe,$e,ye);var Ae=Ee(se),Te=Ae||Ee(fe),Me=Te||Ee($e);return Ce==="="&&Me&&(Ce=""),Ae?We=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Me?(Te&&(fe=0),Me&&($e=0),Ce===">"?(Ce=">=",Te?(se=+se+1,fe=0,$e=0):Me&&(fe=+fe+1,$e=0)):Ce==="<="&&(Ce="<",Te?se=+se+1:fe=+fe+1),We=Ce+se+"."+fe+"."+$e):Te?We=">="+se+".0.0 <"+(+se+1)+".0.0":Me&&(We=">="+se+"."+fe+".0 <"+se+"."+(+fe+1)+".0"),L("xRange return",We),We})}(He,qe)}).join(" ")}(Ne,Le),L("xrange",Ne),Ne=function(Ue,qe){return L("replaceStars",Ue,qe),Ue.trim().replace(O[ne],"")}(Ne,Le),L("stars",Ne),Ne}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Fe){return!!Fe.match(Pe)})),Oe=Oe.map(function(Fe){return new le(Fe,de)})},pe.prototype.intersects=function(ae,de){if(!(ae instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return ae.set.some(function(Oe){return Oe.every(function(Fe){return Pe.intersects(Fe,de)})})})})},e.toComparators=function(ae,de){return new pe(ae,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new Y(ae,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],ae))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(ae,de,me){var Pe=null,Oe=null;try{var Fe=new pe(de,me)}catch{return null}return ae.forEach(function(Ne){Fe.test(Ne)&&(Pe&&Oe.compare(Ne)!==-1||(Oe=new Y(Pe=Ne,me)))}),Pe},e.minSatisfying=function(ae,de,me){var Pe=null,Oe=null;try{var Fe=new pe(de,me)}catch{return null}return ae.forEach(function(Ne){Fe.test(Ne)&&(Pe&&Oe.compare(Ne)!==1||(Oe=new Y(Pe=Ne,me)))}),Pe},e.validRange=function(ae,de){try{return new pe(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,me){return Ie(ae,de,"<",me)},e.gtr=function(ae,de,me){return Ie(ae,de,">",me)},e.outside=Ie,e.prerelease=function(ae,de){var me=te(ae,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ae,de,me){return ae=new pe(ae,me),de=new pe(de,me),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof Y)return ae;if(typeof ae!="string")return null;var de=ae.match(O[v]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,I(1))},function(oe,e){var I,c,L=oe.exports={};function A(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function O(S){if(I===setTimeout)return setTimeout(S,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(S,0);try{return I(S,0)}catch{try{return I.call(null,S,0)}catch{return I.call(this,S,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{c=typeof clearTimeout=="function"?clearTimeout:N}catch{c=N}})();var k,b=[],R=!1,d=-1;function f(){R&&k&&(R=!1,k.length?b=k.concat(b):d=-1,b.length&&$())}function $(){if(!R){var S=O(f);R=!0;for(var g=b.length;g;){for(k=b,b=[];++d<g;)k&&k[d].run();d=-1,g=b.length}k=null,R=!1,function(w){if(c===clearTimeout)return clearTimeout(w);if((c===N||!c)&&clearTimeout)return c=clearTimeout,clearTimeout(w);try{c(w)}catch{try{return c.call(null,w)}catch{return c.call(this,w)}}}(S)}}function l(S,g){this.fun=S,this.array=g}function p(){}L.nextTick=function(S){var g=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)g[w-1]=arguments[w];b.push(new l(S,g)),b.length!==1||R||O($)},l.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=p,L.addListener=p,L.once=p,L.off=p,L.removeListener=p,L.removeAllListeners=p,L.emit=p,L.prependListener=p,L.prependOnceListener=p,L.listeners=function(S){return[]},L.binding=function(S){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(S){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(he[134],ue([0,1]),function(oe,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0;class c{constructor(O,k,b){this.level=O,this.key=k,this.value=b,this.forward=[]}}const L=void 0;class A{constructor(O,k=2**16){this.comparator=O,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new c(this.c,L,L)}get size(){return this.f}clear(){this.e=new c(this.c,L,L),this.f=0}has(O){return!!A.g(this,O,this.comparator)}get(O){return A.g(this,O,this.comparator)?.value}set(O,k){return A.h(this,O,k,this.comparator)&&(this.f+=1),this}delete(O){const k=A.k(this,O,this.comparator);return k&&(this.f-=1),k}forEach(O,k){let b=this.e.forward[0];for(;b;)O.call(k,b.value,b.key,this),b=b.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",k=this.e.forward[0];for(;k;)O+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return O}static g(O,k,b){let R=O.e;for(let d=O.d-1;d>=0;d--)for(;R.forward[d]&&b(R.forward[d].key,k)<0;)R=R.forward[d];if(R=R.forward[0],R&&b(R.key,k)===0)return R}static h(O,k,b,R){const d=[];let f=O.e;for(let $=O.d-1;$>=0;$--){for(;f.forward[$]&&R(f.forward[$].key,k)<0;)f=f.forward[$];d[$]=f}if(f=f.forward[0],f&&R(f.key,k)===0)return f.value=b,!1;{const $=A.j(O);if($>O.d){for(let l=O.d;l<$;l++)d[l]=O.e;O.d=$}f=new c($,k,b);for(let l=0;l<$;l++)f.forward[l]=d[l].forward[l],d[l].forward[l]=f;return!0}}static j(O,k=.5){let b=1;for(;Math.random()<k&&b<O.c;)b+=1;return b}static k(O,k,b){const R=[];let d=O.e;for(let f=O.d-1;f>=0;f--){for(;d.forward[f]&&b(d.forward[f].key,k)<0;)d=d.forward[f];R[f]=d}if(d=d.forward[0],!d||b(d.key,k)!==0)return!1;for(let f=0;f<O.d&&R[f].forward[f]===d;f++)R[f].forward[f]=d.forward[f];for(;O.d>0&&O.e.forward[O.d-1]===L;)O.d-=1;return!0}}e.$Qs=A}),define(he[54],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class c{static create(A){return new c(A)}constructor(A){this.c=I&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$de=c}),define(he[3],ue([0,1,8,88,2,89,54]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$fe=e.Event=void 0,e.$ge=$;const O=!1,k=!1,b=!1;var R;(function(U){U.None=()=>L.$Tc.None;function j(we){if(b){const{onDidAddListener:be}=we,Se=p.create();let Ie=0;we.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),be?.()}}}function K(we,be){return te(we,()=>{},0,void 0,!0,void 0,be)}U.defer=K;function V(we){return(be,Se=null,Ie)=>{let ae=!1,de;return de=we(me=>{if(!ae)return de?de.dispose():ae=!0,be.call(Se,me)},null,Ie),ae&&de.dispose(),de}}U.once=V;function x(we,be,Se){return ne((Ie,ae=null,de)=>we(me=>Ie.call(ae,be(me)),null,de),Se)}U.map=x;function H(we,be,Se){return ne((Ie,ae=null,de)=>we(me=>{be(me),Ie.call(ae,me)},null,de),Se)}U.forEach=H;function ie(we,be,Se){return ne((Ie,ae=null,de)=>we(me=>be(me)&&Ie.call(ae,me),null,de),Se)}U.filter=ie;function W(we){return we}U.signal=W;function z(...we){return(be,Se=null,Ie)=>{const ae=(0,L.$Qc)(...we.map(de=>de(me=>be.call(Se,me))));return ce(ae,Ie)}}U.any=z;function _(we,be,Se,Ie){let ae=Se;return x(we,de=>(ae=be(ae,de),ae),Ie)}U.reduce=_;function ne(we,be){let Se;const Ie={onWillAddFirstListener(){Se=we(ae.fire,ae)},onDidRemoveLastListener(){Se?.dispose()}};be||j(Ie);const ae=new i(Ie);return be?.add(ae),ae.event}function ce(we,be){return be instanceof Array?be.push(we):be&&be.add(we),we}function te(we,be,Se=100,Ie=!1,ae=!1,de,me){let Pe,Oe,Fe,Ne=0,Le;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Pe=we(He=>{Ne++,Oe=be(Oe,He),Ie&&!Fe&&(qe.fire(Oe),Oe=void 0),Le=()=>{const je=Oe;Oe=void 0,Fe=void 0,(!Ie||Ne>1)&&qe.fire(je),Ne=0},typeof Se=="number"?(clearTimeout(Fe),Fe=setTimeout(Le,Se)):Fe===void 0&&(Fe=0,queueMicrotask(Le))})},onWillRemoveListener(){ae&&Ne>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,Pe.dispose()}};me||j(Ue);const qe=new i(Ue);return me?.add(qe),qe.event}U.debounce=te;function Y(we,be=0,Se){return U.debounce(we,(Ie,ae)=>Ie?(Ie.push(ae),Ie):[ae],be,void 0,!0,void 0,Se)}U.accumulate=Y;function G(we,be=(Ie,ae)=>Ie===ae,Se){let Ie=!0,ae;return ie(we,de=>{const me=Ie||!be(de,ae);return Ie=!1,ae=de,me},Se)}U.latch=G;function B(we,be,Se){return[U.filter(we,be,Se),U.filter(we,Ie=>!be(Ie),Se)]}U.split=B;function D(we,be=!1,Se=[],Ie){let ae=Se.slice(),de=we(Oe=>{ae?ae.push(Oe):Pe.fire(Oe)});Ie&&Ie.add(de);const me=()=>{ae?.forEach(Oe=>Pe.fire(Oe)),ae=null},Pe=new i({onWillAddFirstListener(){de||(de=we(Oe=>Pe.fire(Oe)),Ie&&Ie.add(de))},onDidAddFirstListener(){ae&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Ie&&Ie.add(Pe),Pe.event}U.buffer=D;function J(we,be){return(Ie,ae,de)=>{const me=be(new M);return we(function(Pe){const Oe=me.evaluate(Pe);Oe!==q&&Ie.call(ae,Oe)},void 0,de)}}U.chain=J;const q=Symbol("HaltChainable");class M{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Se=>(be(Se),Se)),this}filter(be){return this.f.push(Se=>be(Se)?Se:q),this}reduce(be,Se){let Ie=Se;return this.f.push(ae=>(Ie=be(Ie,ae),Ie)),this}latch(be=(Se,Ie)=>Se===Ie){let Se=!0,Ie;return this.f.push(ae=>{const de=Se||!be(ae,Ie);return Se=!1,Ie=ae,de?ae:q}),this}evaluate(be){for(const Se of this.f)if(be=Se(be),be===q)break;return be}}function Z(we,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),ae=()=>we.on(be,Ie),de=()=>we.removeListener(be,Ie),me=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}U.fromNodeEventEmitter=Z;function ee(we,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),ae=()=>we.addEventListener(be,Ie),de=()=>we.removeEventListener(be,Ie),me=new i({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}U.fromDOMEventEmitter=ee;function X(we){return new Promise(be=>V(we)(be))}U.toPromise=X;function re(we){const be=new i;return we.then(Se=>{be.fire(Se)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}U.fromPromise=re;function le(we,be,Se){return be(Se),we(Ie=>be(Ie))}U.runAndSubscribe=le;class ge{constructor(be,Se){this._observable=be,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Se||j(Ie),this.emitter=new i(Ie),Se&&Se.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Se){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(we,be){return new ge(we,be).emitter.event}U.fromObservable=pe;function Ee(we){return(be,Se,Ie)=>{let ae=0,de=!1;const me={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(we.reportChanges(),de&&(de=!1,be.call(Se)))},handlePossibleChange(){},handleChange(){de=!0}};we.addObserver(me),we.reportChanges();const Pe={dispose(){we.removeObserver(me)}};return Ie instanceof L.$Sc?Ie.add(Pe):Array.isArray(Ie)&&Ie.push(Pe),Pe}}U.fromObservableLight=Ee})(R||(e.Event=R={}));class d{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${d.f++}`,d.all.add(this)}start(j){this.g=new N.$de,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$fe=d;let f=-1;function $(U){const j=f;return f=U,{dispose(){f=j}}}class l{static{this.f=1}constructor(j,K,V=(l.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=K,this.name=V,this.h=0}dispose(){this.g?.clear()}check(j,K){const V=this.threshold;if(V<=0||K<V)return;this.g||(this.g=new Map);const x=this.g.get(j.value)||0;if(this.g.set(j.value,x+1),this.h-=1,this.h<=0){this.h=V*.5;const[H,ie]=this.getMostFrequentStack(),W=`[${this.name}] potential listener LEAK detected, having ${K} listeners already. MOST frequent listener (${ie}):`;console.warn(W),console.warn(H);const z=new S(W,H);this.j(z)}return()=>{const H=this.g.get(j.value)||0;this.g.set(j.value,H-1)}}getMostFrequentStack(){if(!this.g)return;let j,K=0;for(const[V,x]of this.g)(!j||K<x)&&(j=[V,x],K=x);return j}}class p{static create(){const j=new Error;return new p(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S extends Error{constructor(j,K){super(j),this.name="ListenerLeakError",this.stack=K}}e.$he=S;class g extends Error{constructor(j,K){super(j),this.name="ListenerRefusalError",this.stack=K}}e.$ie=g;let w=0;class P{constructor(j){this.value=j,this.id=w++}}const m=2,o=(U,j)=>{if(U instanceof P)j(U);else for(let K=0;K<U.length;K++){const V=U[K];V&&j(V)}};let h;if(O){const U=[];setInterval(()=>{U.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(U.join(`
`)),U.length=0)},3e3),h=new FinalizationRegistry(j=>{typeof j=="string"&&U.push(j)})}class i{constructor(j){this.z=0,this.f=j,this.g=f>0||this.f?.leakWarningThreshold?new l(j?.onListenerError??I.$Y,this.f?.leakWarningThreshold??f):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(k){const j=this.u;queueMicrotask(()=>{o(j,K=>K.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,K,V)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const _=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ne=new g(`${z}. HINT: Stack shows most frequent listener (${_[1]}-times)`,_[0]);return(this.f?.onListenerError||I.$Y)(ne),L.$Tc.None}if(this.m)return L.$Tc.None;K&&(j=j.bind(K));const x=new P(j);let H,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(x.stack=p.create(),H=this.g.check(x.stack,this.z+1)),k&&(x.stack=ie??p.create()),this.u?this.u instanceof P?(this.w??=new t,this.u=[this.u,x]):this.u.push(x):(this.f?.onWillAddFirstListener?.(this),this.u=x,this.f?.onDidAddFirstListener?.(this)),this.z++;const W=(0,L.$Rc)(()=>{h?.unregister(W),H?.(),this.A(x)});if(V instanceof L.$Sc?V.add(W):Array.isArray(V)&&V.push(W),h){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),_=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);h.register(W,_?.[2]??z,W)}return W},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const K=this.u,V=K.indexOf(j);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,K[V]=void 0;const x=this.w.current===this;if(this.z*m<=K.length){let H=0;for(let ie=0;ie<K.length;ie++)K[ie]?K[H++]=K[ie]:x&&(this.w.end--,H<this.w.i&&this.w.i--);K.length=H}}B(j,K){if(!j)return;const V=this.f?.onListenerError||I.$Y;if(!V){j.value(K);return}try{j.value(K)}catch(x){V(x)}}C(j){const K=j.current.u;for(;j.i<j.end;)this.B(K[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof P)this.B(this.u,j);else{const K=this.w;K.enqueue(this,j,this.u.length),this.C(K)}this.j?.stop()}hasListeners(){return this.z>0}}e.$je=i;const s=()=>new t;e.$ke=s;class t{constructor(){this.i=-1,this.end=0}enqueue(j,K,V){this.i=0,this.end=V,this.current=j,this.value=K}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends i{async fireAsync(j,K,V){if(this.u)for(this.h||(this.h=new A.$4c),o(this.u,x=>this.h.push([x.value,j]));this.h.size>0&&!K.isCancellationRequested;){const[x,H]=this.h.shift(),ie=[],W={...H,token:K,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");V&&(z=V(z,x)),ie.push(z)}};try{x(W)}catch(z){(0,I.$Y)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const _ of z)_.status==="rejected"&&(0,I.$Y)(_.reason)})}}}e.$le=n;class r extends i{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new A.$4c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$me=r;class a extends r{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$ne=a;class u extends i{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(K=>super.fire(K)),this.h=[]}))}}e.$oe=u;class y{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const K={event:j,listener:null};this.h.push(K),this.g&&this.m(K);const V=()=>{this.g&&this.o(K);const x=this.h.indexOf(K);this.h.splice(x,1)};return(0,L.$Rc)((0,c.$cb)(V))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(K=>this.f.fire(K))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$pe=y;class C{constructor(j,K,V,x){this.f=new L.$Sc;const H=this.f.add(new y),ie=this.f.add(new L.$3c);function W(z){ie.set(z,H.add(x(z)))}for(const z of j)W(z);this.f.add(K(z=>{W(z)})),this.f.add(V(z=>{ie.deleteAndDispose(z)})),this.event=H.event}dispose(){this.f.dispose()}}e.$qe=C;class v{constructor(){this.f=[]}wrapEvent(j,K,V){return(x,H,ie)=>j(W=>{const z=this.f[this.f.length-1];if(!K){z?z.buffers.push(()=>x.call(H,W)):x.call(H,W);return}const _=z;if(!_){x.call(H,K(V,W));return}_.items??=[],_.items.push(W),_.buffers.length===0&&z.buffers.push(()=>{_.reducedResult??=V?_.items.reduce(K,V):_.items.reduce(K),x.call(H,_.reducedResult)})},void 0,ie)}bufferEvents(j){const K={buffers:new Array};this.f.push(K);const V=j();return this.f.pop(),K.buffers.forEach(x=>x()),V}}e.$re=v;class E{constructor(){this.f=!1,this.g=R.None,this.h=L.$Tc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$se=E;class T{static const(j){return new F(j)}constructor(j){this.g=j,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$te=T;class F{constructor(j){this.value=j,this.onDidChange=R.None}}}),define(he[25],ue([0,1,3]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.CancellationToken=void 0,e.$ve=O;const c=Object.freeze(function(k,b){const R=setTimeout(k.bind(b),0);return{dispose(){clearTimeout(R)}}});var L;(function(k){function b(R){return R===k.None||R===k.Cancelled||R instanceof A?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}k.isCancellationToken=b,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:c})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?c:(this.b||(this.b=new I.$je),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$ue=N;function O(k){const b=new N;return k.add({dispose(){b.cancel()}}),b.token}}),define(he[135],ue([0,1,25]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0e=e.$9e=e.$7e=void 0,e.$8e=L;class c{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new I.$ue,b=this.b(k.token);return this.a={promise:b,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.$7e=c;function L(O){return O}class A{constructor(k,b){this.a=void 0,this.b=void 0,typeof k=="function"?(this.c=k,this.d=L):(this.c=b,this.d=k.getCacheKey)}get(k){const b=this.d(k);return this.b!==b&&(this.b=b,this.a=this.c(k)),this.a}}e.$9e=A;class N{get cachedValues(){return this.a}constructor(k,b){this.a=new Map,this.b=new Map,typeof k=="function"?(this.c=k,this.d=L):(this.c=b,this.d=k.getCacheKey)}get(k){const b=this.d(k);if(this.b.has(b))return this.b.get(b);const R=this.c(k);return this.a.set(k,R),this.b.set(b,R),R}}e.$0e=N}),define(he[50],ue([0,1,8,2]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=L,e.$xe=A,e.$ye=N,e.$ze=O,e.$Ae=b,e.$Be=R,e.$Ce=d,e.$De=f,e.$Ee=$,e.$Fe=l,e.$Ge=p,e.$He=S,e.$Ie=g,e.$Je=w,e.$Ke=P;function L(m){const o=m;return o?typeof o.read=="function":!1}function A(m){const o=m;return o?[o.on,o.pause,o.resume,o.destroy].every(h=>typeof h=="function"):!1}function N(m){const o=m;return o?A(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}function O(m,o){return new k(m,o)}class k{constructor(o,h){this.e=o,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(o){if(!this.a.destroyed){if(this.a.flowing)this.g(o);else if(this.b.data.push(o),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(o){this.a.destroyed||(this.a.flowing?this.h(o):this.b.error.push(o))}end(o){this.a.destroyed||(typeof o<"u"&&this.write(o),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(o){this.c.data.slice(0).forEach(h=>h(o))}h(o){this.c.error.length===0?(0,I.$Y)(o):this.c.error.slice(0).forEach(h=>h(o))}i(){this.c.end.slice(0).forEach(o=>o())}on(o,h){if(!this.a.destroyed)switch(o){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(o,h){if(this.a.destroyed)return;let i;switch(o){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const s=i.indexOf(h);s>=0&&i.splice(s,1)}}j(){if(this.b.data.length>0){const o=this.e(this.b.data);this.g(o),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const o of this.b.error)this.h(o);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(m,o){const h=[];let i;for(;(i=m.read())!==null;)h.push(i);return o(h)}function R(m,o,h){const i=[];let s;for(;(s=m.read())!==null&&i.length<h;)i.push(s);return s===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s<"u"){const t=s;return s=void 0,t}return m.read()}}}function d(m,o){return new Promise((h,i)=>{const s=[];f(m,{onData:t=>{o&&s.push(t)},onError:t=>{o?i(t):h(void 0)},onEnd:()=>{h(o?o(s):void 0)}})})}function f(m,o,h){m.on("error",i=>{h?.isCancellationRequested||o.onError(i)}),m.on("end",()=>{h?.isCancellationRequested||o.onEnd()}),m.on("data",i=>{h?.isCancellationRequested||o.onData(i)})}function $(m,o){return new Promise((h,i)=>{const s=new c.$Sc,t=[],n=u=>{if(t.push(u),t.length>o)return s.dispose(),m.pause(),h({stream:m,buffer:t,ended:!1})},r=u=>(s.dispose(),i(u)),a=()=>(s.dispose(),h({stream:m,buffer:t,ended:!0}));s.add((0,c.$Rc)(()=>m.removeListener("error",r))),m.on("error",r),s.add((0,c.$Rc)(()=>m.removeListener("end",a))),m.on("end",a),s.add((0,c.$Rc)(()=>m.removeListener("data",n))),m.on("data",n)})}function l(m,o){const h=O(o);return h.end(m),h}function p(){const m=O(()=>{throw new Error("not supported")});return m.end(),m}function S(m){let o=!1;return{read:()=>o?null:(o=!0,m)}}function g(m,o,h){const i=O(h);return f(m,{onData:s=>i.write(o.data(s)),onError:s=>i.error(o.error?o.error(s):s),onEnd:()=>i.end()}),i}function w(m,o,h){let i=!1;return{read:()=>{const s=o.read();return i?s:(i=!0,s!==null?h([m,s]):m)}}}function P(m,o,h){let i=!1;const s=O(h);return f(o,{onData:t=>i?s.write(t):(i=!0,s.write(h([m,t]))),onError:t=>s.error(t),onEnd:()=>{i||(i=!0,s.write(m)),s.end()}}),s}}),define(he[14],ue([0,1,53,50]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=void 0,e.$Me=b,e.$Ne=R,e.$Oe=d,e.$Pe=f,e.$Qe=$,e.$Re=l,e.$Se=p,e.$Te=S,e.$Ue=g,e.$Ve=w,e.$We=P,e.$Xe=m,e.$Ye=o,e.$Ze=h,e.$1e=i,e.$2e=s,e.$3e=t,e.$4e=n,e.$5e=r,e.$6e=y,c=ke(c);const L=typeof Buffer<"u",A=new I.$T(()=>new Uint8Array(256));let N,O;class k{static alloc(v){return L?new k(Buffer.allocUnsafe(v)):new k(new Uint8Array(v))}static wrap(v){return L&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new k(v)}static fromString(v,E){return!(E?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(v)):(N||(N=new TextEncoder),new k(N.encode(v)))}static fromByteArray(v){const E=k.alloc(v.length);for(let T=0,F=v.length;T<F;T++)E.buffer[T]=v[T];return E}static concat(v,E){if(typeof E>"u"){E=0;for(let U=0,j=v.length;U<j;U++)E+=v[U].byteLength}const T=k.alloc(E);let F=0;for(let U=0,j=v.length;U<j;U++){const K=v[U];T.set(K,F),F+=K.byteLength}return T}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=k.alloc(this.byteLength);return v.set(this),v}toString(){return L?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(v,E){return new k(this.buffer.subarray(v,E))}set(v,E){if(v instanceof k)this.buffer.set(v.buffer,E);else if(v instanceof Uint8Array)this.buffer.set(v,E);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),E);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return f(this.buffer,v)}writeUInt32BE(v,E){$(this.buffer,v,E)}readUInt32LE(v){return l(this.buffer,v)}writeUInt32LE(v,E){p(this.buffer,v,E)}readUInt8(v){return S(this.buffer,v)}writeUInt8(v,E){g(this.buffer,v,E)}indexOf(v,E=0){return b(this.buffer,v instanceof k?v.buffer:v,E)}}e.$Le=k;function b(C,v,E=0){const T=v.byteLength,F=C.byteLength;if(T===0)return 0;if(T===1)return C.indexOf(v[0]);if(T>F-E)return-1;const U=A.value;U.fill(v.length);for(let x=0;x<v.length;x++)U[v[x]]=v.length-x-1;let j=E+v.length-1,K=j,V=-1;for(;j<F;)if(C[j]===v[K]){if(K===0){V=j;break}j--,K--}else j+=Math.max(v.length-K,U[C[j]]),K=v.length-1;return V}function R(C,v){return C[v+0]<<0>>>0|C[v+1]<<8>>>0}function d(C,v,E){C[E+0]=v&255,v=v>>>8,C[E+1]=v&255}function f(C,v){return C[v]*2**24+C[v+1]*2**16+C[v+2]*2**8+C[v+3]}function $(C,v,E){C[E+3]=v,v=v>>>8,C[E+2]=v,v=v>>>8,C[E+1]=v,v=v>>>8,C[E]=v}function l(C,v){return C[v+0]<<0>>>0|C[v+1]<<8>>>0|C[v+2]<<16>>>0|C[v+3]<<24>>>0}function p(C,v,E){C[E+0]=v&255,v=v>>>8,C[E+1]=v&255,v=v>>>8,C[E+2]=v&255,v=v>>>8,C[E+3]=v&255}function S(C,v){return C[v]}function g(C,v,E){C[E]=v}function w(C){return c.$Ae(C,v=>k.concat(v))}function P(C){return c.$He(C)}function m(C){return c.$Ce(C,v=>k.concat(v))}async function o(C){return C.ended?k.concat(C.buffer):k.concat([...C.buffer,await m(C.stream)])}function h(C){return c.$Fe(C,v=>k.concat(v))}function i(C){return c.$Ie(C,{data:v=>typeof v=="string"?k.fromString(v):k.wrap(v)},v=>k.concat(v))}function s(C){return c.$ze(v=>k.concat(v),C)}function t(C,v){return c.$Je(C,v,E=>k.concat(E))}function n(C,v){return c.$Ke(C,v,E=>k.concat(E))}function r(C){let v=0,E=0,T=0;const F=new Uint8Array(Math.floor(C.length/4*3)),U=K=>{switch(E){case 3:F[T++]=v|K,E=0;break;case 2:F[T++]=v|K>>>2,v=K<<6,E=3;break;case 1:F[T++]=v|K>>>4,v=K<<4,E=2;break;default:v=K<<2,E=1}};for(let K=0;K<C.length;K++){const V=C.charCodeAt(K);if(V>=65&&V<=90)U(V-65);else if(V>=97&&V<=122)U(V-97+26);else if(V>=48&&V<=57)U(V-48+52);else if(V===43||V===45)U(62);else if(V===47||V===95)U(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${C[K]}`)}}const j=T;for(;E>0;)U(0);return k.wrap(F).slice(0,j)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:C},v=!0,E=!1){const T=E?u:a;let F="";const U=C.byteLength%3;let j=0;for(;j<C.byteLength-U;j+=3){const K=C[j+0],V=C[j+1],x=C[j+2];F+=T[K>>>2],F+=T[(K<<4|V>>>4)&63],F+=T[(V<<2|x>>>6)&63],F+=T[x&63]}if(U===1){const K=C[j+0];F+=T[K>>>2],F+=T[K<<4&63],v&&(F+="==")}else if(U===2){const K=C[j+0],V=C[j+1];F+=T[K>>>2],F+=T[(K<<4|V>>>4)&63],F+=T[V<<2&63],v&&(F+="=")}return F}}),define(he[136],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=void 0,e.$ee=Symbol("MicrotaskDelay")}),define(he[12],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=I,e.$dg=c,e.$eg=L,e.$fg=A,e.$gg=N,e.$hg=O,e.$ig=k,e.$jg=b,e.$kg=R,e.$lg=d,e.$mg=f,e.$ng=$,e.$og=l,e.$pg=S,e.$qg=g,e.$rg=w,e.$sg=P,e.$tg=m;function I(o){return typeof o=="string"}function c(o){return Array.isArray(o)&&o.every(h=>I(h))}function L(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}function A(o){const h=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof h}function N(o){return typeof o=="number"&&!isNaN(o)}function O(o){return!!o&&typeof o[Symbol.iterator]=="function"}function k(o){return o===!0||o===!1}function b(o){return typeof o>"u"}function R(o){return!d(o)}function d(o){return b(o)||o===null}function f(o,h){if(!o)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}function $(o){if(d(o))throw new Error("Assertion Failed: argument is undefined or null");return o}function l(...o){const h=[];for(let i=0;i<o.length;i++){const s=o[i];if(d(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);h.push(s)}return h}const p=Object.prototype.hasOwnProperty;function S(o){if(!L(o))return!1;for(const h in o)if(p.call(o,h))return!1;return!0}function g(o){return typeof o=="function"}function w(...o){return o.length>0&&o.every(g)}function P(o,h){const i=Math.min(o.length,h.length);for(let s=0;s<i;s++)m(o[s],h[s])}function m(o,h){if(I(h)){if(typeof o!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(g(h)){try{if(o instanceof h)return}catch{}if(!d(o)&&o.constructor===h||h.length===1&&h.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(he[29],ue([0,1,12]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=c,e.$co=L,e.$do=N,e.$eo=k,e.$fo=b,e.$go=R,e.$ho=d,e.$io=f,e.$jo=$,e.$ko=l,e.$lo=p,e.$mo=S,e.$no=g;function c(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const P=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([m,o])=>{P[m]=o&&typeof o=="object"?c(o):o}),P}function L(w){if(!w||typeof w!="object")return w;const P=[w];for(;P.length>0;){const m=P.shift();Object.freeze(m);for(const o in m)if(A.call(m,o)){const h=m[o];typeof h=="object"&&!Object.isFrozen(h)&&!(0,I.$fg)(h)&&P.push(h)}}return w}const A=Object.prototype.hasOwnProperty;function N(w,P){return O(w,P,new Set)}function O(w,P,m){if((0,I.$lg)(w))return w;const o=P(w);if(typeof o<"u")return o;if(Array.isArray(w)){const h=[];for(const i of w)h.push(O(i,P,m));return h}if((0,I.$eg)(w)){if(m.has(w))throw new Error("Cannot clone recursive data-structure");m.add(w);const h={};for(const i in w)A.call(w,i)&&(h[i]=O(w[i],P,m));return m.delete(w),h}return w}function k(w,P,m=!0){return(0,I.$eg)(w)?((0,I.$eg)(P)&&Object.keys(P).forEach(o=>{o in w?m&&((0,I.$eg)(w[o])&&(0,I.$eg)(P[o])?k(w[o],P[o],m):w[o]=P[o]):w[o]=P[o]}),w):P}function b(w,P){if(w===P)return!0;if(w==null||P===null||P===void 0||typeof w!=typeof P||typeof w!="object"||Array.isArray(w)!==Array.isArray(P))return!1;let m,o;if(Array.isArray(w)){if(w.length!==P.length)return!1;for(m=0;m<w.length;m++)if(!b(w[m],P[m]))return!1}else{const h=[];for(o in w)h.push(o);h.sort();const i=[];for(o in P)i.push(o);if(i.sort(),!b(h,i))return!1;for(m=0;m<h.length;m++)if(!b(w[h[m]],P[h[m]]))return!1}return!0}function R(w){const P=new Set;return JSON.stringify(w,(m,o)=>{if((0,I.$eg)(o)||Array.isArray(o)){if(P.has(o))return"[Circular]";P.add(o)}return typeof o=="bigint"?`[BigInt ${o.toString()}]`:o})}function d(w,P){const m=Object.create(null);return!w||!P||Object.keys(P).forEach(h=>{const i=w[h],s=P[h];b(i,s)||(m[h]=s)}),m}function f(w,P){const m=P.toLowerCase(),o=Object.keys(w).find(h=>h.toLowerCase()===m);return o?w[o]:w[P]}function $(w,P){const m=Object.create(null);for(const[o,h]of Object.entries(w))P(o,h)&&(m[o]=h);return m}function l(w){let P=[];for(;Object.prototype!==w;)P=P.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return P}function p(w){const P=[];for(const m of l(w))typeof w[m]=="function"&&P.push(m);return P}function S(w,P){const m=h=>function(){const i=Array.prototype.slice.call(arguments,0);return P(h,i)},o={};for(const h of w)o[h]=m(h);return o}function g(w,P){const m={};for(const[o,h]of Object.entries(w))m[o]=P(h,o);return m}}),define(he[137],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$$e=c,e.$_e=L;var I;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function c(A){return A<0?0:A>I.MAX_UINT_8?I.MAX_UINT_8:A|0}function L(A){return A<0?0:A>I.MAX_UINT_32?I.MAX_UINT_32:A|0}}),define(he[26],ue([0,1,135,39,53,137]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.GraphemeBreakType=e.$2f=e.$Tf=e.$Mf=e.$Lf=void 0,e.$af=N,e.$bf=k,e.$cf=R,e.$df=d,e.$ef=f,e.$ff=$,e.$gf=l,e.$hf=p,e.$if=S,e.$jf=g,e.$kf=w,e.$lf=P,e.$mf=m,e.$nf=o,e.$of=h,e.$pf=i,e.$qf=s,e.$rf=t,e.$sf=n,e.$tf=r,e.$uf=a,e.$vf=u,e.$wf=y,e.$xf=C,e.$yf=v,e.$zf=E,e.$Af=T,e.$Bf=F,e.$Cf=U,e.$Df=j,e.$Ef=K,e.$Ff=V,e.$Gf=x,e.$Hf=H,e.$If=ie,e.$Jf=W,e.$Kf=z,e.$Nf=te,e.$Of=Y,e.$Pf=G,e.$Qf=B,e.$Rf=q,e.$Sf=Z,e.$Uf=ee,e.$Vf=X,e.$Wf=re,e.$Xf=le,e.$Yf=pe,e.$Zf=Ee,e.$1f=be,e.$3f=Se,e.$4f=Ie,e.$5f=ae,e.$6f=de,e.$7f=me,e.$8f=Pe,e.$9f=Oe,e.$0f=Fe,e.$$f=He;function N(se){return!se||typeof se!="string"?!0:se.trim().length===0}const O=/{(\d+)}/g;function k(se,...fe){return fe.length===0?se:se.replace(O,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const b=/{([^}]+)}/g;function R(se,fe){return Object.keys(fe).length===0?se:se.replace(b,($e,ye)=>fe[ye]??$e)}function d(se){return se.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function f(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function $(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function l(se,fe){let $e=0,ye=se.indexOf(fe);for(;ye!==-1;)$e++,ye=se.indexOf(fe,ye+fe.length);return $e}function p(se,fe,$e="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${$e}`}function S(se,fe,$e="\u2026"){if(se.length<=fe)return se;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Ae)}`}function g(se,fe=" "){const $e=w(se,fe);return P($e,fe)}function w(se,fe){if(!se||!fe)return se;const $e=fe.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+$e;return se.substring(ye)}function P(se,fe){if(!se||!fe)return se;const $e=fe.length,ye=se.length;if($e===0||ye===0)return se;let Ae=ye,Te=-1;for(;Te=se.lastIndexOf(fe,Ae-1),!(Te===-1||Te+$e!==Ae);){if(Te===0)return"";Ae=Te}return se.substring(0,Ae)}function m(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function o(se){return se.replace(/\*/g,"")}function h(se,fe,$e={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=$(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function i(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function s(se){return se.split(/\r\n|\r|\n/)}function t(se){const fe=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(se){for(let fe=0,$e=se.length;fe<$e;fe++){const ye=se.charCodeAt(fe);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return fe}return-1}function r(se,fe=0,$e=se.length){for(let ye=fe;ye<$e;ye++){const Ae=se.charCodeAt(ye);if(Ae!==c.CharCode.Space&&Ae!==c.CharCode.Tab)return se.substring(fe,ye)}return se.substring(fe,$e)}function a(se,fe=se.length-1){for(let $e=fe;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==c.CharCode.Space&&ye!==c.CharCode.Tab)return $e}return-1}function u(se,fe,$e){const ye=[];let Ae=0;for(const Te of se.matchAll(fe)){if(ye.push(se.slice(Ae,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");Ae=Te.index+Te[0].length,ye.push($e(Te[0],...Te.slice(1),Te.index,se,Te.groups))}return ye.push(se.slice(Ae)),Promise.all(ye).then(Te=>Te.join(""))}function y(se,fe){return se<fe?-1:se>fe?1:0}function C(se,fe,$e=0,ye=se.length,Ae=0,Te=fe.length){for(;$e<ye&&Ae<Te;$e++,Ae++){const Je=se.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Je<Ye)return-1;if(Je>Ye)return 1}const Me=ye-$e,xe=Te-Ae;return Me<xe?-1:Me>xe?1:0}function v(se,fe){return E(se,fe,0,se.length,0,fe.length)}function E(se,fe,$e=0,ye=se.length,Ae=0,Te=fe.length){for(;$e<ye&&Ae<Te;$e++,Ae++){let Je=se.charCodeAt($e),Ye=fe.charCodeAt(Ae);if(Je===Ye)continue;if(Je>=128||Ye>=128)return C(se.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Te);F(Je)&&(Je-=32),F(Ye)&&(Ye-=32);const Ve=Je-Ye;if(Ve!==0)return Ve}const Me=ye-$e,xe=Te-Ae;return Me<xe?-1:Me>xe?1:0}function T(se){return se>=c.CharCode.Digit0&&se<=c.CharCode.Digit9}function F(se){return se>=c.CharCode.a&&se<=c.CharCode.z}function U(se){return se>=c.CharCode.A&&se<=c.CharCode.Z}function j(se,fe){return se.length===fe.length&&E(se,fe)===0}function K(se,fe){const $e=fe.length;return fe.length>se.length?!1:E(se,fe,0,$e)===0}function V(se,fe){const $e=Math.min(se.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function x(se,fe){const $e=Math.min(se.length,fe.length);let ye;const Ae=se.length-1,Te=fe.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Ae-ye)!==fe.charCodeAt(Te-ye))return ye;return $e}function H(se){return 55296<=se&&se<=56319}function ie(se){return 56320<=se&&se<=57343}function W(se,fe){return(se-55296<<10)+(fe-56320)+65536}function z(se,fe,$e){const ye=se.charCodeAt($e);if(H(ye)&&$e+1<fe){const Ae=se.charCodeAt($e+1);if(ie(Ae))return W(ye,Ae)}return ye}function _(se,fe){const $e=se.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=se.charCodeAt(fe-2);if(H(ye))return W(ye,$e)}return $e}class ne{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=_(this.c,this.e);return this.e-=fe>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=A.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Lf=ne;class ce{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new ne(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Te=$e.offset,Me=fe.getGraphemeBreakType($e.nextCodePoint());if(Ne(Ae,Me)){$e.setOffset(Te);break}Ae=Me}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Te=$e.offset,Me=fe.getGraphemeBreakType($e.prevCodePoint());if(Ne(Me,Ae)){$e.setOffset(Te);break}Ae=Me}return ye-$e.offset}eol(){return this.c.eol()}}e.$Mf=ce;function te(se,fe){return new ce(se,fe).nextGraphemeLength()}function Y(se,fe){return new ce(se,fe).prevGraphemeLength()}function G(se,fe){fe>0&&ie(se.charCodeAt(fe))&&fe--;const $e=fe+te(se,fe);return[$e-Y(se,$e),$e]}function B(se){const fe=new ce(se);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(se){return D||(D=J()),D.test(se)}const M=/^[\t\n\r\x20-\x7E]*$/;function Z(se){return M.test(se)}e.$Tf=/[\u2028\u2029]/;function ee(se){return e.$Tf.test(se)}function X(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function re(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function le(se,fe,$e=""){const ye=se.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Te=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Te=Ae.lastIndex,Ae.lastIndex+=1;return Te===0?ye:$e+ye.substring(Te).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(se){let fe=0;for(const $e of se.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:se.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==se.length&&(yield{isCode:!1,str:se.substring(fe)})}function Ee(se){return se&&(se=se.replace(ge,"")),se}const we=/\\\[.*?\\\]/g;function be(se){return Ee(se).replace(we,"")}e.$2f=String.fromCharCode(c.CharCode.UTF8_BOM);function Se(se){return!!(se&&se.length>0&&se.charCodeAt(0)===c.CharCode.UTF8_BOM)}function Ie(se){return Se(se)?se.substr(1):se}function ae(se,fe){if(!se||!fe||se.length<fe.length)return!1;const $e=fe.length,ye=se.toLowerCase();let Ae=0,Te=-1;for(;Ae<$e;){const Me=ye.indexOf(fe[Ae],Te+1);if(Me<0)return!1;Te=Me,Ae++}return!0}function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Pe(se,fe=1){if(fe===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Oe(se){const fe=c.CharCode.Z-c.CharCode.A+1;return se=se%(2*fe),se<fe?String.fromCharCode(c.CharCode.a+se):String.fromCharCode(c.CharCode.A+se-fe)}function Fe(se){return Ue.getInstance().getGraphemeBreakType(se)}function Ne(se,fe){return se===Le.Other?fe!==Le.Extend&&fe!==Le.SpacingMark:se===Le.CR&&fe===Le.LF?!1:se===Le.Control||se===Le.CR||se===Le.LF||fe===Le.Control||fe===Le.CR||fe===Le.LF?!0:!(se===Le.L&&(fe===Le.L||fe===Le.V||fe===Le.LV||fe===Le.LVT)||(se===Le.LV||se===Le.V)&&(fe===Le.V||fe===Le.T)||(se===Le.LVT||se===Le.T)&&fe===Le.T||fe===Le.Extend||fe===Le.ZWJ||fe===Le.SpacingMark||se===Le.Prepend||se===Le.ZWJ&&fe===Le.Extended_Pictographic||se===Le.Regional_Indicator&&fe===Le.Regional_Indicator)}var Le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===c.CharCode.LineFeed?Le.LF:fe===c.CharCode.CarriageReturn?Le.CR:Le.Control;if(fe<127)return Le.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Le.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(se,fe){if(se===0)return 0;const $e=je(se,fe);if($e!==void 0)return $e;const ye=new ne(fe,se);return ye.prevCodePoint(),ye.offset}function je(se,fe){const $e=new ne(fe,se);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!re(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$_f="\xA0";class We{static{this.c=new L.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$9e({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Qe=0;Qe<Ve.length;Qe+=2)_e.set(Ve[Qe],Ve[Qe+1]);return _e}function ye(Ve,_e){const Qe=new Map(Ve);for(const[nt,at]of _e)Qe.set(nt,at);return Qe}function Ae(Ve,_e){if(!Ve)return _e;const Qe=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Qe.set(nt,at);return Qe}const Te=this.c.value;let Me=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Te);Me.length===0&&(Me=["_default"]);let xe;for(const Ve of Me){const _e=$e(Te[Ve]);xe=Ae(xe,_e)}const Je=$e(Te._common),Ye=ye(Je,xe);return new We(Ye)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new L.$T(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ag=We;class Ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ce.c())),this.d}static isInvisibleCharacter(fe){return Ce.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Ce.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ce.e()}}e.$bg=Ce}),define(he[41],ue([0,1,39,13,5,26,12]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=O,e.$vg=k,e.$wg=b,e.$xg=R,e.$yg=d,e.$zg=p,e.$Ag=S,e.$Bg=g,e.$Cg=w,e.$Dg=P,e.$Eg=m,e.$Fg=o,e.$Gg=h,e.$Hg=i,e.$Ig=s,e.$Jg=t,e.$Kg=a;function O(u){return u===I.CharCode.Slash||u===I.CharCode.Backslash}function k(u){return u.replace(/[\\/]/g,c.$fc.sep)}function b(u){return u.indexOf("/")===-1&&(u=k(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function R(u,y=c.$fc.sep){if(!u)return"";const C=u.length,v=u.charCodeAt(0);if(O(v)){if(O(u.charCodeAt(1))&&!O(u.charCodeAt(2))){let T=3;const F=T;for(;T<C&&!O(u.charCodeAt(T));T++);if(F!==T&&!O(u.charCodeAt(T+1))){for(T+=1;T<C;T++)if(O(u.charCodeAt(T)))return u.slice(0,T+1).replace(/[\\/]/g,y)}}return y}else if(w(v)&&u.charCodeAt(1)===I.CharCode.Colon)return O(u.charCodeAt(2))?u.slice(0,2)+y:u.slice(0,2);let E=u.indexOf("://");if(E!==-1){for(E+=3;E<C;E++)if(O(u.charCodeAt(E)))return u.slice(0,E+1)}return""}function d(u){if(!L.$j||!u||u.length<5)return!1;let y=u.charCodeAt(0);if(y!==I.CharCode.Backslash||(y=u.charCodeAt(1),y!==I.CharCode.Backslash))return!1;let C=2;const v=C;for(;C<u.length&&(y=u.charCodeAt(C),y!==I.CharCode.Backslash);C++);return!(v===C||(y=u.charCodeAt(C+1),isNaN(y)||y===I.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,$=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(u,y=L.$j){const C=y?f:$;return!(!u||u.length===0||/^\s+$/.test(u)||(C.lastIndex=0,C.test(u))||y&&l.test(u)||u==="."||u===".."||y&&u[u.length-1]==="."||y&&u.length!==u.trim().length||u.length>255)}function S(u,y,C){const v=u===y;return!C||v?v:!u||!y?!1:(0,A.$Df)(u,y)}function g(u,y,C,v=c.sep){if(u===y)return!0;if(!u||!y||y.length>u.length)return!1;if(C){if(!(0,A.$Ef)(u,y))return!1;if(y.length===u.length)return!0;let T=y.length;return y.charAt(y.length-1)===v&&T--,u.charAt(T)===v}return y.charAt(y.length-1)!==v&&(y+=v),u.indexOf(y)===0}function w(u){return u>=I.CharCode.A&&u<=I.CharCode.Z||u>=I.CharCode.a&&u<=I.CharCode.z}function P(u,y){return L.$j&&u.endsWith(":")&&(u+=c.sep),(0,c.$hc)(u)||(u=(0,c.$ic)(y,u)),u=(0,c.$gc)(u),m(u)}function m(u){return L.$j?(u=(0,A.$lf)(u,c.sep),u.endsWith(":")&&(u+=c.sep)):(u=(0,A.$lf)(u,c.sep),u||(u=c.sep)),u}function o(u){const y=(0,c.$gc)(u);return L.$j?u.length>3?!1:h(y)&&(u.length===2||y.charCodeAt(2)===I.CharCode.Backslash):y===c.$fc.sep}function h(u,y=L.$j){return y?w(u.charCodeAt(0))&&u.charCodeAt(1)===I.CharCode.Colon:!1}function i(u,y=L.$j){return h(u,y)?u[0]:void 0}function s(u,y,C){return y.length>u.length?-1:u===y?0:(C&&(u=u.toLowerCase(),y=y.toLowerCase()),u.indexOf(y))}function t(u){const y=u.split(":");let C,v,E;for(const T of y){const F=Number(T);(0,N.$gg)(F)?v===void 0?v=F:E===void 0&&(E=F):C=C?[C,T].join(":"):T}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:v!==void 0?v:void 0,column:E!==void 0?E:v!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",r="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(u,y,C=8){let v="";for(let T=0;T<C;T++){let F;T===0&&L.$j&&!y&&(C===3||C===4)?F=r:F=n,v+=F.charAt(Math.floor(Math.random()*F.length))}let E;return y?E=`${y}-${v}`:E=v,u?(0,c.$ic)(u,E):E}}),define(he[55],ue([0,1,26]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$uj=void 0,e.$qj=c,e.$rj=L,e.$sj=A,e.$tj=O,e.$vj=p,I=ke(I);function c(g){return L(g,0)}function L(g,w){switch(typeof g){case"object":return g===null?A(349,w):Array.isArray(g)?k(g,w):b(g,w);case"string":return O(g,w);case"boolean":return N(g,w);case"number":return A(g,w);case"undefined":return A(937,w);default:return A(617,w)}}function A(g,w){return(w<<5)-w+g|0}function N(g,w){return A(g?433:863,w)}function O(g,w){w=A(149417,w);for(let P=0,m=g.length;P<m;P++)w=A(g.charCodeAt(P),w);return w}function k(g,w){return w=A(104579,w),g.reduce((P,m)=>L(m,P),w)}function b(g,w){return w=A(181387,w),Object.keys(g).sort().reduce((P,m)=>(P=O(m,P),L(g[m],P)),w)}class R{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=L(w,this.g),this.g}}e.$uj=R;var d;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function f(g,w,P=32){const m=P-w,o=~((1<<m)-1);return(g<<w|(o&g)>>>m)>>>0}function $(g,w=0,P=g.byteLength,m=0){for(let o=0;o<P;o++)g[w+o]=m}function l(g,w,P="0"){for(;g.length<w;)g=P+g;return g}function p(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(P=>P.toString(16).padStart(2,"0")).join(""):l((g>>>0).toString(16),w/4)}class S{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(d.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const P=w.length;if(P===0)return;const m=this.p;let o=this.r,h=this.u,i,s;for(h!==0?(i=h,s=-1,h=0):(i=w.charCodeAt(0),s=0);;){let t=i;if(I.$Hf(i))if(s+1<P){const n=w.charCodeAt(s+1);I.$If(n)?(s++,t=I.$Jf(i,n)):t=d.UNICODE_REPLACEMENT}else{h=i;break}else I.$If(i)&&(t=d.UNICODE_REPLACEMENT);if(o=this.w(m,o,t),s++,s<P)i=w.charCodeAt(s);else break}this.r=o,this.u=h}w(w,P,m){return m<128?w[P++]=m:m<2048?(w[P++]=192|(m&1984)>>>6,w[P++]=128|(m&63)>>>0):m<65536?(w[P++]=224|(m&61440)>>>12,w[P++]=128|(m&4032)>>>6,w[P++]=128|(m&63)>>>0):(w[P++]=240|(m&1835008)>>>18,w[P++]=128|(m&258048)>>>12,w[P++]=128|(m&4032)>>>6,w[P++]=128|(m&63)>>>0),P>=d.BLOCK_SIZE&&(this.y(),P-=d.BLOCK_SIZE,this.t+=d.BLOCK_SIZE,w[0]=w[d.BLOCK_SIZE+0],w[1]=w[d.BLOCK_SIZE+1],w[2]=w[d.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,d.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=S.g,P=this.q;for(let a=0;a<64;a+=4)w.setUint32(a,P.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)w.setUint32(a,f(w.getUint32(a-12,!1)^w.getUint32(a-32,!1)^w.getUint32(a-56,!1)^w.getUint32(a-64,!1),1),!1);let m=this.h,o=this.l,h=this.m,i=this.n,s=this.o,t,n,r;for(let a=0;a<80;a++)a<20?(t=o&h|~o&i,n=1518500249):a<40?(t=o^h^i,n=1859775393):a<60?(t=o&h|o&i|h&i,n=2400959708):(t=o^h^i,n=3395469782),r=f(m,5)+t+s+n+w.getUint32(a*4,!1)&4294967295,s=i,i=h,h=f(o,30),o=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+o&4294967295,this.m=this.m+h&4294967295,this.n=this.n+i&4294967295,this.o=this.o+s&4294967295}}e.$wj=S}),define(he[92],ue([0,1,26]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),I=ke(I);var c;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(c||(c={})),function(L){const A="error",N="warning",O="warn",k="info",b="ignore";function R(f){return f?I.$Df(A,f)?L.Error:I.$Df(N,f)||I.$Df(O,f)?L.Warning:I.$Df(k,f)?L.Info:L.Ignore:L.Ignore}L.fromValue=R;function d(f){switch(f){case L.Error:return A;case L.Warning:return N;case L.Info:return k;default:return b}}L.toString=d}(c||(c={})),e.default=c}),define(he[51],ue([0,1,17,39,26]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const p=l.charCodeAt(0),S=this.b.charCodeAt(this.c);return p-S}value(){return this.b[this.c]}}e.$Ei=A;class N{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===c.CharCode.Period)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,L.$xf)(l,this.b,0,l.length,this.c,this.d):(0,L.$zf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Fi=N;class O{constructor(l=!0,p=!0){this.f=l,this.g=p}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let p=l.length-1;p>=0;p--,this.c--){const S=this.b.charCodeAt(p);if(!(S===c.CharCode.Slash||this.f&&S===c.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===c.CharCode.Slash||this.f&&p===c.CharCode.Backslash)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,L.$xf)(l,this.b,0,l.length,this.d,this.e):(0,L.$zf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Gi=O;var k;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(k||(k={}));class b{constructor(l,p){this.f=l,this.g=p,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(k.Scheme),this.c.authority&&this.d.push(k.Authority),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(k.Path)),this.g(l)||(this.c.query&&this.d.push(k.Query),this.c.fragment&&this.d.push(k.Fragment)),this.e=0,this}next(){return this.d[this.e]===k.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===k.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===k.Scheme)return(0,L.$yf)(l,this.c.scheme);if(this.d[this.e]===k.Authority)return(0,L.$yf)(l,this.c.authority);if(this.d[this.e]===k.Path)return this.b.cmp(l);if(this.d[this.e]===k.Query)return(0,L.$wf)(l,this.c.query);if(this.d[this.e]===k.Fragment)return(0,L.$wf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===k.Scheme)return this.c.scheme;if(this.d[this.e]===k.Authority)return this.c.authority;if(this.d[this.e]===k.Path)return this.b.value();if(this.d[this.e]===k.Query)return this.c.query;if(this.d[this.e]===k.Fragment)return this.c.fragment;throw new Error}}e.$Hi=b;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(d||(d={}));class f{static forUris(l=()=>!1,p=()=>!1){return new f(new b(l,p))}static forPaths(l=!1){return new f(new O(void 0,!l))}static forStrings(){return new f(new A)}static forConfigKeys(){return new f(new N)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,p){if(p){const S=p.slice(0);(0,I.$Vb)(S);for(const g of S)this.set(g,l)}else{const S=l.slice(0);(0,I.$Vb)(S);for(const g of S)this.set(g[0],g[1])}}set(l,p){const S=this.b.reset(l);let g;this.c||(this.c=new R,this.c.segment=S.value());const w=[];for(g=this.c;;){const m=S.cmp(g.segment);if(m>0)g.left||(g.left=new R,g.left.segment=S.value()),w.push([d.Left,g]),g=g.left;else if(m<0)g.right||(g.right=new R,g.right.segment=S.value()),w.push([d.Right,g]),g=g.right;else if(S.hasNext())S.next(),g.mid||(g.mid=new R,g.mid.segment=S.value()),w.push([d.Mid,g]),g=g.mid;else break}const P=g.value;g.value=p,g.key=l;for(let m=w.length-1;m>=0;m--){const o=w[m][1];o.updateHeight();const h=o.balanceFactor();if(h<-1||h>1){const i=w[m][0],s=w[m+1][0];if(i===d.Right&&s===d.Right)w[m][1]=o.rotateLeft();else if(i===d.Left&&s===d.Left)w[m][1]=o.rotateRight();else if(i===d.Right&&s===d.Left)o.right=w[m+1][1]=w[m+1][1].rotateRight(),w[m][1]=o.rotateLeft();else if(i===d.Left&&s===d.Right)o.left=w[m+1][1]=w[m+1][1].rotateLeft(),w[m][1]=o.rotateRight();else throw new Error;if(m>0)switch(w[m-1][0]){case d.Left:w[m-1][1].left=w[m][1];break;case d.Right:w[m-1][1].right=w[m][1];break;case d.Mid:w[m-1][1].mid=w[m][1];break}else this.c=w[0][1]}}return P}get(l){return this.d(l)?.value}d(l){const p=this.b.reset(l);let S=this.c;for(;S;){const g=p.cmp(S.segment);if(g>0)S=S.left;else if(g<0)S=S.right;else if(p.hasNext())p.next(),S=S.mid;else break}return S}has(l){const p=this.d(l);return!(p?.value===void 0&&p?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,p){const S=this.b.reset(l),g=[];let w=this.c;for(;w;){const P=S.cmp(w.segment);if(P>0)g.push([d.Left,w]),w=w.left;else if(P<0)g.push([d.Right,w]),w=w.right;else if(S.hasNext())S.next(),g.push([d.Mid,w]),w=w.mid;else break}if(w){if(p?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const P=this.f(w.right);if(P.key){const{key:m,value:o,segment:h}=P;this.e(P.key,!1),w.key=m,w.value=o,w.segment=h}}else{const P=w.left??w.right;if(g.length>0){const[m,o]=g[g.length-1];switch(m){case d.Left:o.left=P;break;case d.Mid:o.mid=P;break;case d.Right:o.right=P;break}}else this.c=P}for(let P=g.length-1;P>=0;P--){const m=g[P][1];m.updateHeight();const o=m.balanceFactor();if(o>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[P][1]=m.rotateLeft()):o<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[P][1]=m.rotateRight()),P>0)switch(g[P-1][0]){case d.Left:g[P-1][1].left=g[P][1];break;case d.Right:g[P-1][1].right=g[P][1];break;case d.Mid:g[P-1][1].mid=g[P][1];break}else this.c=g[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const p=this.b.reset(l);let S=this.c,g;for(;S;){const w=p.cmp(S.segment);if(w>0)S=S.left;else if(w<0)S=S.right;else if(p.hasNext())p.next(),g=S.value||g,S=S.mid;else break}return S&&S.value||g}findSuperstr(l){return this.g(l,!1)}g(l,p){const S=this.b.reset(l);let g=this.c;for(;g;){const w=S.cmp(g.segment);if(w>0)g=g.left;else if(w<0)g=g.right;else if(S.hasNext())S.next(),g=g.mid;else return g.mid?this.h(g.mid):p?g.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[p,S]of this)l(S,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const p=[];return this.j(l,p),p[Symbol.iterator]()}j(l,p){l&&(l.left&&this.j(l.left,p),l.value&&p.push([l.key,l.value]),l.mid&&this.j(l.mid,p),l.right&&this.j(l.right,p))}_isBalanced(){const l=p=>{if(!p)return!0;const S=p.balanceFactor();return S<-1||S>1?!1:l(p.left)&&l(p.right)};return l(this.c)}}e.$Ii=f}),define(he[9],ue([0,1,39,65,13,5]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$uc=S,e.$vc=h,L=ke(L);const N=/^\w[\w\d+.-]*$/,O=/^\//,k=/^\/\//;function b(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!N.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!O.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function R(r,a){return!r&&!a?"file":r}function d(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==$&&(a=$+a):a=$;break}return a}const f="",$="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(a){return a instanceof p?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,u,y,C,v,E=!1){typeof a=="object"?(this.scheme=a.scheme||f,this.authority=a.authority||f,this.path=a.path||f,this.query=a.query||f,this.fragment=a.fragment||f):(this.scheme=R(a,E),this.authority=u||f,this.path=d(this.scheme,y||f),this.query=C||f,this.fragment=v||f,b(this,E))}get fsPath(){return h(this,!1)}with(a){if(!a)return this;let{scheme:u,authority:y,path:C,query:v,fragment:E}=a;return u===void 0?u=this.scheme:u===null&&(u=f),y===void 0?y=this.authority:y===null&&(y=f),C===void 0?C=this.path:C===null&&(C=f),v===void 0?v=this.query:v===null&&(v=f),E===void 0?E=this.fragment:E===null&&(E=f),u===this.scheme&&y===this.authority&&C===this.path&&v===this.query&&E===this.fragment?this:new w(u,y,C,v,E)}static parse(a,u=!1){const y=l.exec(a);return y?new w(y[2]||f,n(y[4]||f),n(y[5]||f),n(y[7]||f),n(y[9]||f),u):new w(f,f,f,f,f)}static file(a){let u=f;if(A.$j&&(a=a.replace(/\\/g,$)),a[0]===$&&a[1]===$){const y=a.indexOf($,2);y===-1?(u=a.substring(2),a=$):(u=a.substring(2,y),a=a.substring(y)||$)}return new w("file",u,a,f,f)}static from(a,u){return new w(a.scheme,a.authority,a.path,a.query,a.fragment,u)}static joinPath(a,...u){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return A.$j&&a.scheme==="file"?y=p.file(L.$ec.join(h(a,!0),...u)).path:y=L.$fc.join(a.path,...u),a.with({path:y})}toString(a=!1){return i(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof p)return a;{const u=new w(a);return u._formatted=a.external??null,u._fsPath=a._sep===g?a.fsPath??null:null,u}}else return a}}e.URI=p;function S(r){return!r||typeof r!="object"?!1:typeof r.scheme=="string"&&(typeof r.authority=="string"||typeof r.authority>"u")&&(typeof r.path=="string"||typeof r.path>"u")&&(typeof r.query=="string"||typeof r.query>"u")&&(typeof r.fragment=="string"||typeof r.fragment>"u")}const g=A.$j?1:void 0;class w extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(a=!1){return a?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const a={$mid:c.MarshalledId.Uri};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=g),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[I.CharCode.Colon]:"%3A",[I.CharCode.Slash]:"%2F",[I.CharCode.QuestionMark]:"%3F",[I.CharCode.Hash]:"%23",[I.CharCode.OpenSquareBracket]:"%5B",[I.CharCode.CloseSquareBracket]:"%5D",[I.CharCode.AtSign]:"%40",[I.CharCode.ExclamationMark]:"%21",[I.CharCode.DollarSign]:"%24",[I.CharCode.Ampersand]:"%26",[I.CharCode.SingleQuote]:"%27",[I.CharCode.OpenParen]:"%28",[I.CharCode.CloseParen]:"%29",[I.CharCode.Asterisk]:"%2A",[I.CharCode.Plus]:"%2B",[I.CharCode.Comma]:"%2C",[I.CharCode.Semicolon]:"%3B",[I.CharCode.Equals]:"%3D",[I.CharCode.Space]:"%20"};function m(r,a,u){let y,C=-1;for(let v=0;v<r.length;v++){const E=r.charCodeAt(v);if(E>=I.CharCode.a&&E<=I.CharCode.z||E>=I.CharCode.A&&E<=I.CharCode.Z||E>=I.CharCode.Digit0&&E<=I.CharCode.Digit9||E===I.CharCode.Dash||E===I.CharCode.Period||E===I.CharCode.Underline||E===I.CharCode.Tilde||a&&E===I.CharCode.Slash||u&&E===I.CharCode.OpenSquareBracket||u&&E===I.CharCode.CloseSquareBracket||u&&E===I.CharCode.Colon)C!==-1&&(y+=encodeURIComponent(r.substring(C,v)),C=-1),y!==void 0&&(y+=r.charAt(v));else{y===void 0&&(y=r.substr(0,v));const T=P[E];T!==void 0?(C!==-1&&(y+=encodeURIComponent(r.substring(C,v)),C=-1),y+=T):C===-1&&(C=v)}}return C!==-1&&(y+=encodeURIComponent(r.substring(C))),y!==void 0?y:r}function o(r){let a;for(let u=0;u<r.length;u++){const y=r.charCodeAt(u);y===I.CharCode.Hash||y===I.CharCode.QuestionMark?(a===void 0&&(a=r.substr(0,u)),a+=P[y]):a!==void 0&&(a+=r[u])}return a!==void 0?a:r}function h(r,a){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===I.CharCode.Slash&&(r.path.charCodeAt(1)>=I.CharCode.A&&r.path.charCodeAt(1)<=I.CharCode.Z||r.path.charCodeAt(1)>=I.CharCode.a&&r.path.charCodeAt(1)<=I.CharCode.z)&&r.path.charCodeAt(2)===I.CharCode.Colon?a?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,A.$j&&(u=u.replace(/\//g,"\\")),u}function i(r,a){const u=a?o:m;let y="",{scheme:C,authority:v,path:E,query:T,fragment:F}=r;if(C&&(y+=C,y+=":"),(v||C==="file")&&(y+=$,y+=$),v){let U=v.indexOf("@");if(U!==-1){const j=v.substr(0,U);v=v.substr(U+1),U=j.lastIndexOf(":"),U===-1?y+=u(j,!1,!1):(y+=u(j.substr(0,U),!1,!1),y+=":",y+=u(j.substr(U+1),!1,!0)),y+="@"}v=v.toLowerCase(),U=v.lastIndexOf(":"),U===-1?y+=u(v,!1,!0):(y+=u(v.substr(0,U),!1,!0),y+=v.substr(U))}if(E){if(E.length>=3&&E.charCodeAt(0)===I.CharCode.Slash&&E.charCodeAt(2)===I.CharCode.Colon){const U=E.charCodeAt(1);U>=I.CharCode.A&&U<=I.CharCode.Z&&(E=`/${String.fromCharCode(U+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===I.CharCode.Colon){const U=E.charCodeAt(0);U>=I.CharCode.A&&U<=I.CharCode.Z&&(E=`${String.fromCharCode(U+32)}:${E.substr(2)}`)}y+=u(E,!0,!1)}return T&&(y+="?",y+=u(T,!1,!1)),F&&(y+="#",y+=a?F:m(F,!1,!1)),y}function s(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+s(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,a=>s(a)):r}}),define(he[138],ue([0,1,9]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=c,e.$br=L,e.$cr=A,e.log=O;function c(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}function L(b){const R=[];let d;try{const f=JSON.parse(b.arguments),$=f[f.length-1];$&&$.__$stack&&(f.pop(),d=$.__$stack),R.push(...f)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:d}}function A(b){if(typeof b!="string")return A(L(b).stack);const R=b;if(R){const d=N(R),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(f&&f.length===4)return{uri:I.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function N(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function O(b,R){const{args:d,stack:f}=L(b),$=typeof d[0]=="string"&&d.length===1;let l=N(f);l&&(l=`(${l.trim()})`);let p=[];if(typeof d[0]=="string"?l&&$?p=[`%c[${R}] %c${d[0]} %c${l}`,k("blue"),k(""),k("grey")]:p=[`%c[${R}] %c${d[0]}`,k("blue"),k(""),...d.slice(1)]:p=[`%c[${R}]%`,k("blue"),...d],l&&!$&&p.push(l),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}function k(b){return`color: ${b}`}}),define(he[66],ue([0,1,14,9,65]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=A,e.$$h=N,e.$_h=k;function A(b){return JSON.stringify(b,O)}function N(b){let R=JSON.parse(b);return R=k(R),R}function O(b,R){return R instanceof RegExp?{$mid:L.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function k(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case L.MarshalledId.Uri:return c.URI.revive(b);case L.MarshalledId.Regexp:return new RegExp(b.source,b.flags);case L.MarshalledId.Date:return new Date(b.source)}if(b instanceof I.$Le||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let d=0;d<b.length;++d)b[d]=k(b[d],R+1);else for(const d in b)Object.hasOwnProperty.call(b,d)&&(b[d]=k(b[d],R+1))}return b}}),define(he[22],ue([0,1,8,5,26,9,13]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Pg=e.$Og=e.$Ng=e.Schemas=void 0,e.$Lg=k,e.$Mg=b,e.$Qg=d,I=ke(I),c=ke(c),N=ke(N);var O;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",l.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.commentsInput="comment",l.codeSetting="code-setting"})(O||(e.Schemas=O={}));function k(l,p){return A.URI.isUri(l)?(0,L.$Df)(l.scheme,p):(0,L.$Ef)(l,p+":")}function b(l,...p){return p.some(S=>k(l,S))}e.$Ng="vscode-tkn",e.$Og="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p,S){this.f=d(p,S)}getServerRootPath(){return this.f}get g(){return N.$fc.join(this.f,O.vscodeRemoteResource)}set(p,S,g){this.a[p]=S,this.b[p]=g}setConnectionToken(p,S){this.c[p]=S}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(o){return I.$Y(o),p}const S=p.authority;let g=this.a[S];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const w=this.b[S],P=this.c[S];let m=`path=${encodeURIComponent(p.path)}`;return typeof P=="string"&&(m+=`&${e.$Og}=${encodeURIComponent(P)}`),A.URI.from({scheme:c.$p?this.d:O.vscodeRemoteResource,authority:`${g}:${w}`,path:this.g,query:m})}}e.$Pg=new R;function d(l,p){return N.$fc.join(p??"/",`${l.quality??"oss"}-${l.commit??"dev"}`)}e.$Rg="vs/../../extensions",e.$Sg="vs/../../node_modules",e.$Tg="vs/../../node_modules.asar",e.$Ug="vs/../../node_modules.asar.unpacked",e.$Vg="vscode-app";class f{static{this.a=e.$Vg}asBrowserUri(p){const S=this.b(p,oe);return this.uriToBrowserUri(S)}uriToBrowserUri(p){return p.scheme===O.vscodeRemote?e.$Pg.rewrite(p):p.scheme===O.file&&(c.$n||c.$r===`${O.vscodeFileResource}://${f.a}`)?p.with({scheme:O.vscodeFileResource,authority:p.authority||f.a,query:null,fragment:null}):p}asFileUri(p){const S=this.b(p,oe);return this.uriToFileUri(S)}uriToFileUri(p){return p.scheme===O.vscodeFileResource?p.with({scheme:O.file,authority:p.authority!==f.a?p.authority:null,query:null,fragment:null}):p}b(p,S){return A.URI.isUri(p)?p:A.URI.parse(S.toUrl(p))}}e.$Wg=new f;var $;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const S="vscode-coi";function g(P){let m;typeof P=="string"?m=new URL(P).searchParams:P instanceof URL?m=P.searchParams:A.URI.isUri(P)&&(m=new URL(P.toString(!0)).searchParams);const o=m?.get(S);if(o)return p.get(o)}l.getHeadersFromQuery=g;function w(P,m,o){if(!globalThis.crossOriginIsolated)return;const h=m&&o?"3":o?"2":"1";P instanceof URLSearchParams?P.set(S,h):P[S]=h}l.addSearchParam=w})($||(e.COI=$={}))}),define(he[139],ue([0,1,128,22,5,9]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=R,L=ke(L);class N{constructor(f,$,l){this.id=f,this.dependencies=$,this.callback=l}}class O{static{this.INSTANCE=new O}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,$,l)=>{typeof f!="string"&&(l=$,$=f,f=null),(typeof $!="object"||!Array.isArray($))&&(l=$,$=null),this.c.push(new N(f,$,l))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const $=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!$)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(f){return new Promise(($,l)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const S=()=>{p.removeEventListener("load",g),p.removeEventListener("error",w)},g=P=>{S(),$(this.c.pop())},w=P=>{S(),l(P)};p.addEventListener("load",g),p.addEventListener("error",w),this.f&&(f=this.f.createScriptURL(f)),p.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(f){return new Promise(($,l)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),$(this.c.pop())}catch(p){l(p)}})}async j(f){try{const $=globalThis._VSCODE_NODE_MODULES.fs,l=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,S=A.URI.parse(f).fsPath,g=$.readFileSync(S).toString(),w=p.wrap(g.replace(/^#!.*/,""));return new l.Script(w).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const k=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function R(d,f,$){if(I.$R){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[d]&&(d=b[d]);const l=`${d}/${f}`;if(k.has(l))return k.get(l);let p;if(/^\w[\w\d+.-]*:\/\//.test(l))p=l;else{const P=`${$&&!L.$p?c.$Tg:c.$Sg}/${l}`;p=c.$Wg.asBrowserUri(P).toString(!0)}const S=O.INSTANCE.load(p);return k.set(l,S),S}else return await new Promise((l,p)=>{oe([d],l,p)}).then(ke)}}),define(he[20],ue([0,1,39,41,22,13,5,26,9]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0,e.$4g=b,e.$mh=d,e.$nh=$,c=ke(c),A=ke(A);function b(l){return(0,k.$vc)(l,!0)}class R{constructor(p){this.a=p}compare(p,S,g=!1){return p===S?0:(0,O.$wf)(this.getComparisonKey(p,g),this.getComparisonKey(S,g))}isEqual(p,S,g=!1){return p===S?!0:!p||!S?!1:this.getComparisonKey(p,g)===this.getComparisonKey(S,g)}getComparisonKey(p,S=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,S,g=!1){if(p.scheme===S.scheme){if(p.scheme===L.Schemas.file)return c.$Bg(b(p),b(S),this.a(p))&&p.query===S.query&&(g||p.fragment===S.fragment);if((0,e.$ih)(p.authority,S.authority))return c.$Bg(p.path,S.path,this.a(p),"/")&&p.query===S.query&&(g||p.fragment===S.fragment)}return!1}joinPath(p,...S){return k.URI.joinPath(p,...S)}basenameOrAuthority(p){return(0,e.$ah)(p)||p.authority}basename(p){return A.$fc.basename(p.path)}extname(p){return A.$fc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let S;return p.scheme===L.Schemas.file?S=k.URI.file(A.$lc(b(p))).path:(S=A.$fc.dirname(p.path),p.authority&&S.length&&S.charCodeAt(0)!==I.CharCode.Slash&&(console.error(`dirname("${p.toString})) resulted in a relative path`),S="/")),p.with({path:S})}normalizePath(p){if(!p.path.length)return p;let S;return p.scheme===L.Schemas.file?S=k.URI.file(A.$gc(b(p))).path:S=A.$fc.normalize(p.path),p.with({path:S})}relativePath(p,S){if(p.scheme!==S.scheme||!(0,e.$ih)(p.authority,S.authority))return;if(p.scheme===L.Schemas.file){const P=A.$kc(b(p),b(S));return N.$j?c.$vg(P):P}let g=p.path||"/";const w=S.path||"/";if(this.a(p)){let P=0;for(const m=Math.min(g.length,w.length);P<m&&!(g.charCodeAt(P)!==w.charCodeAt(P)&&g.charAt(P).toLowerCase()!==w.charAt(P).toLowerCase());P++);g=w.substr(0,P)+g.substr(P)}return A.$fc.relative(g,w)}resolvePath(p,S){if(p.scheme===L.Schemas.file){const g=k.URI.file(A.$jc(b(p),S));return p.with({authority:g.authority,path:g.path})}return S=c.$wg(S),p.with({path:A.$fc.resolve(p.path,S)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,S){return p===S||p!==void 0&&S!==void 0&&(0,O.$Df)(p,S)}hasTrailingPathSeparator(p,S=A.sep){if(p.scheme===L.Schemas.file){const g=b(p);return g.length>c.$xg(g).length&&g[g.length-1]===S}else{const g=p.path;return g.length>1&&g.charCodeAt(g.length-1)===I.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,S=A.sep){return(0,e.$jh)(p,S)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,S=A.sep){let g=!1;if(p.scheme===L.Schemas.file){const w=b(p);g=w!==void 0&&w.length===c.$xg(w).length&&w[w.length-1]===S}else{S="/";const w=p.path;g=w.length===1&&w.charCodeAt(w.length-1)===I.CharCode.Slash}return!g&&!(0,e.$jh)(p,S)?p.with({path:p.path+"/"}):p}}e.$5g=R,e.$6g=new R(()=>!1),e.$7g=new R(l=>l.scheme===L.Schemas.file?!N.$l:!0),e.$8g=new R(l=>!0),e.$9g=e.$6g.isEqual.bind(e.$6g),e.$0g=e.$6g.isEqualOrParent.bind(e.$6g),e.$$g=e.$6g.getComparisonKey.bind(e.$6g),e.$_g=e.$6g.basenameOrAuthority.bind(e.$6g),e.$ah=e.$6g.basename.bind(e.$6g),e.$bh=e.$6g.extname.bind(e.$6g),e.$ch=e.$6g.dirname.bind(e.$6g),e.$dh=e.$6g.joinPath.bind(e.$6g),e.$eh=e.$6g.normalizePath.bind(e.$6g),e.$fh=e.$6g.relativePath.bind(e.$6g),e.$gh=e.$6g.resolvePath.bind(e.$6g),e.$hh=e.$6g.isAbsolutePath.bind(e.$6g),e.$ih=e.$6g.isEqualAuthority.bind(e.$6g),e.$jh=e.$6g.hasTrailingPathSeparator.bind(e.$6g),e.$kh=e.$6g.removeTrailingPathSeparator.bind(e.$6g),e.$lh=e.$6g.addTrailingPathSeparator.bind(e.$6g);function d(l,p){const S=[];for(let g=0;g<l.length;g++){const w=p(l[g]);l.some((P,m)=>m===g?!1:(0,e.$0g)(w,p(P)))||S.push(l[g])}return S}var f;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function p(S){const g=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(m=>{const[o,h]=m.split(":");o&&h&&g.set(o,h)});const P=S.path.substring(0,S.path.indexOf(";"));return P&&g.set(l.META_DATA_MIME,P),g}l.parseMetaData=p})(f||(e.DataUri=f={}));function $(l,p,S){if(p){let g=l.path;return g&&g[0]!==A.$fc.sep&&(g=A.$fc.sep+g),l.with({scheme:S,authority:p,path:g})}return l.with({scheme:S})}}),define(he[6],ue([0,1,25,8,3,2,20,5,136,53]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$4h=e.$3h=e.$2h=e.$1h=e.Promises=e.$Zh=e.$Yh=e.$Xh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$oh=R,e.$ph=d,e.$qh=f,e.$rh=$,e.$sh=l,e.$th=p,e.$uh=S,e.$vh=g,e.$Dh=r,e.$Eh=a,e.$Fh=u,e.$Gh=y,e.$Hh=C,e.$Wh=z,e.$5h=M;function R(ee){return!!ee&&typeof ee.then=="function"}function d(ee){const X=new I.$ue,re=ee(X.token),le=new Promise((ge,pe)=>{const Ee=X.token.onCancellationRequested(()=>{Ee.dispose(),pe(new c.$4)});Promise.resolve(re).then(we=>{Ee.dispose(),X.dispose(),ge(we)},we=>{Ee.dispose(),X.dispose(),pe(we)})});return new class{cancel(){X.cancel(),X.dispose()}then(ge,pe){return le.then(ge,pe)}catch(ge){return this.then(void 0,ge)}finally(ge){return le.finally(ge)}}}function f(ee,X,re){return new Promise((le,ge)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),le(re)});ee.then(le,ge).finally(()=>pe.dispose())})}function $(ee,X){return new Promise((re,le)=>{const ge=X.onCancellationRequested(()=>{ge.dispose(),le(new c.$4)});ee.then(re,le).finally(()=>ge.dispose())})}async function l(ee){let X=-1;const re=ee.map((le,ge)=>le.then(pe=>(X=ge,pe)));try{return await Promise.race(re)}finally{ee.forEach((le,ge)=>{ge!==X&&le.cancel()})}}function p(ee,X,re){let le;const ge=setTimeout(()=>{le?.(void 0),re?.()},X);return Promise.race([ee.finally(()=>clearTimeout(ge)),new Promise(pe=>le=pe)])}function S(ee){return new Promise((X,re)=>{const le=ee();R(le)?le.then(X,re):X(le)})}function g(){let ee,X;return{promise:new Promise((le,ge)=>{ee=le,X=ge}),resolve:ee,reject:X}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const re=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(re,re).then(le)})}return new Promise((re,le)=>{this.b.then(re,le)})}return this.a=X(),new Promise((re,le)=>{this.a.then(ge=>{this.a=null,re(ge)},ge=>{this.a=null,le(ge)})})}dispose(){this.f=!0}}e.$wh=w;class P{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$xh=P;class m{constructor(){this.a=new Map}queue(X,re){const ge=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(X)===ge&&this.a.delete(X)});return this.a.set(X,ge),ge}}e.$yh=m;const o=(ee,X)=>{let re=!0;const le=setTimeout(()=>{re=!1,X()},ee);return{isTriggered:()=>re,dispose:()=>{clearTimeout(le),re=!1}}},h=ee=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ee())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class i{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,re=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((ge,pe)=>{this.d=ge,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=re===k.$ee?h(le):o(re,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new c.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$zh=i;class s{constructor(X){this.a=new i(X),this.b=new w}trigger(X,re){return this.a.trigger(()=>this.b.queue(X),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ah=s;class t{constructor(){this.a=!1,this.b=new Promise((X,re)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Bh=t;class n extends t{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Ch=n;function r(ee,X){return X?new Promise((re,le)=>{const ge=setTimeout(()=>{pe.dispose(),re()},ee),pe=X.onCancellationRequested(()=>{clearTimeout(ge),pe.dispose(),le(new c.$4)})}):d(re=>r(ee,re))}function a(ee,X=0,re){const le=setTimeout(()=>{ee(),re&&ge.dispose()},X),ge=(0,A.$Rc)(()=>{clearTimeout(le),re?.deleteAndLeak(ge)});return re?.add(ge),ge}function u(ee){const X=[];let re=0;const le=ee.length;function ge(){return re<le?ee[re++]():null}function pe(Ee){Ee!=null&&X.push(Ee);const we=ge();return we?we.then(pe):Promise.resolve(X)}return Promise.resolve(null).then(pe)}function y(ee,X=le=>!!le,re=null){let le=0;const ge=ee.length,pe=()=>{if(le>=ge)return Promise.resolve(re);const Ee=ee[le++];return Promise.resolve(Ee()).then(be=>X(be)?Promise.resolve(be):pe())};return pe()}function C(ee,X=le=>!!le,re=null){if(ee.length===0)return Promise.resolve(re);let le=ee.length;const ge=()=>{le=-1;for(const pe of ee)pe.cancel?.()};return new Promise((pe,Ee)=>{for(const we of ee)we.then(be=>{--le>=0&&X(be)?(ge(),pe(be)):le===0&&pe(re)}).catch(be=>{--le>=0&&(ge(),Ee(be))})})}class v{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new L.$je}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,le)=>{this.g.push({factory:X,c:re,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const re=X.factory();re.then(X.c,X.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ih=v;class E extends v{constructor(){super(1)}}e.$Jh=E;class T{constructor(){this.a=new _,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Kh=T;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new te;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,re=N.$6g){const le=re.getComparisonKey(X);return this.a.get(le)?.size??0}queueFor(X,re,le=N.$6g){const ge=le.getComparisonKey(X);let pe=this.a.get(ge);if(!pe){pe=new E;const Ee=this.f++,we=L.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(Ee,we),this.a.set(ge,pe)}return pe.queue(re)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Lh=F;class U{constructor(X,re){this.b=!1,this.a=-1,typeof X=="function"&&typeof re=="number"&&this.setIfNotSet(X,re)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,re){if(this.b)throw new c.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},re)}setIfNotSet(X,re){if(this.b)throw new c.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},re))}}e.$Mh=U;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,re,le=globalThis){if(this.f)throw new c.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=le.setInterval(()=>{X()},re);this.d=(0,A.$Rc)(()=>{le.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Nh=j;class K{constructor(X,re){this.b=-1,this.a=X,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Oh=K;class V{constructor(X,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=X,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ph=V;class x extends K{constructor(X,re){super(X,re),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Qh=x;class H extends A.$Tc{constructor(X,re){super(),this.g=X,this.h=re,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of X)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Rh=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Th=(ee,X)=>{(0,O.$C)(()=>{if(re)return;const le=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Th=(ee,X,re)=>{const le=ee.requestIdleCallback(X,typeof re=="number"?{timeout:re}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,ee.cancelIdleCallback(le))}}},e.$Sh=ee=>(0,e.$Th)(globalThis,ee)}();class ie{constructor(X,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Th)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Uh=ie;class W extends ie{constructor(X){super(globalThis,X)}}e.$Vh=W;async function z(ee,X,re){let le;for(let ge=0;ge<re;ge++)try{return await ee()}catch(pe){le=pe,await r(X)}throw le}class _{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,re,le){return this.a={taskId:X,cancel:()=>le?.(),promise:re},re.then(()=>this.d(X),()=>this.d(X)),re}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:re,resolve:le,reject:ge}=g();this.b={run:X,promise:re,promiseResolve:le,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Xh=_;class ne{constructor(X,re=()=>Date.now()){this.d=X,this.f=re,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Yh=ne;var ce;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(ce||(ce={}));class te{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,re)=>{this.a=X,this.b=re})}complete(X){return new Promise(re=>{this.a(X),this.d={outcome:ce.Resolved,value:X},re()})}error(X){return new Promise(re=>{this.b(X),this.d={outcome:ce.Rejected,value:X},re()})}cancel(){return this.error(new c.$4)}}e.$Zh=te;var Y;(function(ee){async function X(le){let ge;const pe=await Promise.all(le.map(Ee=>Ee.then(we=>we,we=>{ge||(ge=we)})));if(typeof ge<"u")throw ge;return pe}ee.settled=X;function re(le){return new Promise(async(ge,pe)=>{try{await le(ge,pe)}catch(Ee){pe(Ee)}})}ee.withAsyncBody=re})(Y||(e.Promises=Y={}));class G{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new c.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$1h=G;class B{constructor(X){this.b=X,this.a=new b.$T(()=>new G(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$2h=B;var D;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(D||(D={}));class J{static fromArray(X){return new J(re=>{re.emitMany(X)})}static fromPromise(X){return new J(async re=>{re.emitMany(await X)})}static fromPromises(X){return new J(async re=>{await Promise.all(X.map(async le=>re.emitOne(await le)))})}static merge(X){return new J(async re=>{await Promise.all(X.map(async le=>{for await(const ge of le)re.emitOne(ge)}))})}static{this.EMPTY=J.fromArray([])}constructor(X,re){this.a=D.Initial,this.b=[],this.d=null,this.f=re,this.g=new L.$je,queueMicrotask(async()=>{const le={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(X(le)),this.k()}catch(ge){this.l(ge)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,re){return new J(async le=>{for await(const ge of X)le.emitOne(re(ge))})}map(X){return J.map(this,X)}static filter(X,re){return new J(async le=>{for await(const ge of X)re(ge)&&le.emitOne(ge)})}filter(X){return J.filter(this,X)}static coalesce(X){return J.filter(X,re=>!!re)}coalesce(){return J.coalesce(this)}static async toPromise(X){const re=[];for await(const le of X)re.push(le);return re}toPromise(){return J.toPromise(this)}h(X){this.a===D.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===D.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(X){this.a===D.Initial&&(this.a=D.DoneError,this.d=X,this.g.fire())}}e.$3h=J;class q extends J{constructor(X,re){super(re),this.m=X}cancel(){this.m.cancel()}}e.$4h=q;function M(ee){const X=new I.$ue,re=ee(X.token);return new q(X,async le=>{const ge=X.token.onCancellationRequested(()=>{ge.dispose(),X.dispose(),le.reject(new c.$4)});try{for await(const pe of re){if(X.token.isCancellationRequested)return;le.emitOne(pe)}ge.dispose(),X.dispose()}catch(pe){ge.dispose(),X.dispose(),le.reject(pe)}})}class Z{constructor(X){this.a=new te,this.b=new J(ge=>{if(re){ge.reject(re);return}return le&&ge.emitMany(le),this.d=pe=>ge.reject(pe),this.f=pe=>ge.emitOne(pe),this.a.p},X);let re,le;this.f=ge=>{le||(le=[]),le.push(ge)},this.d=ge=>{re||(re=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$6h=Z}),define(he[93],ue([0,1,17,6,39,41,36,13,5,26]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=void 0,e.$sk=R,e.$vk=p,e.$wk=T,e.$xk=F,e.$yk=U,e.$zk=j,e.$Ak=K,e.$Bk=ie;function R(){return Object.create(null)}e.$tk="**",e.$uk="/";const d="[/\\\\]",f="[^/\\\\]",$=/\//g;function l(W,z){switch(W){case 0:return"";case 1:return`${f}*?`;default:return`(?:${d}|${f}+${d}${z?`|${d}${f}+`:""})*?`}}function p(W,z){if(!W)return[];const _=[];let ne=!1,ce=!1,te="";for(const Y of W){switch(Y){case z:if(!ne&&!ce){_.push(te),te="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}te+=Y}return te&&_.push(te),_}function S(W){if(!W)return"";let z="";const _=p(W,e.$uk);if(_.every(ne=>ne===e.$tk))z=".*";else{let ne=!1;_.forEach((ce,te)=>{if(ce===e.$tk){if(ne)return;z+=l(2,te===_.length-1)}else{let Y=!1,G="",B=!1,D="";for(const J of ce){if(J!=="}"&&Y){G+=J;continue}if(B&&(J!=="]"||!D)){let q;J==="-"?q=J:(J==="^"||J==="!")&&!D?q="^":J===e.$uk?q="":q=(0,b.$ff)(J),D+=q;continue}switch(J){case"{":Y=!0;continue;case"[":B=!0;continue;case"}":{const M=`(?:${p(G,",").map(Z=>S(Z)).join("|")})`;z+=M,Y=!1,G="";break}case"]":{z+="["+D+"]",B=!1,D="";break}case"?":z+=f;continue;case"*":z+=l(1);continue;default:z+=(0,b.$ff)(J)}}te<_.length-1&&(_[te+1]!==e.$tk||te+2<_.length)&&(z+=d)}ne=ce===e.$tk})}return z}const g=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,P=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new N.$Cc(1e4),s=function(){return!1},t=function(){return null};function n(W,z){if(!W)return t;let _;typeof W!="string"?_=W.pattern:_=W,_=_.trim();const ne=`${_}_${!!z.trimForExclusions}`;let ce=i.get(ne);if(ce)return r(ce,W);let te;return g.test(_)?ce=u(_.substr(4),_):(te=w.exec(a(_,z)))?ce=y(te[1],_):(z.trimForExclusions?m:P).test(_)?ce=C(_,z):(te=o.exec(a(_,z)))?ce=v(te[1].substr(1),_,!0):(te=h.exec(a(_,z)))?ce=v(te[1],_,!1):ce=E(_),i.set(ne,ce),r(ce,W)}function r(W,z){if(typeof z=="string")return W;const _=function(ne,ce){return(0,A.$Bg)(ne,z.base,!k.$l)?W((0,b.$kf)(ne.substr(z.base.length),O.sep),ce):null};return _.allBasenames=W.allBasenames,_.allPaths=W.allPaths,_.basenames=W.basenames,_.patterns=W.patterns,_}function a(W,z){return z.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function u(W,z){return function(_,ne){return typeof _=="string"&&_.endsWith(W)?z:null}}function y(W,z){const _=`/${W}`,ne=`\\${W}`,ce=function(Y,G){return typeof Y!="string"?null:G?G===W?z:null:Y===W||Y.endsWith(_)||Y.endsWith(ne)?z:null},te=[W];return ce.basenames=te,ce.patterns=[z],ce.allBasenames=te,ce}function C(W,z){const _=H(W.slice(1,-1).split(",").map(G=>n(G,z)).filter(G=>G!==t),W),ne=_.length;if(!ne)return t;if(ne===1)return _[0];const ce=function(G,B){for(let D=0,J=_.length;D<J;D++)if(_[D](G,B))return W;return null},te=_.find(G=>!!G.allBasenames);te&&(ce.allBasenames=te.allBasenames);const Y=_.reduce((G,B)=>B.allPaths?G.concat(B.allPaths):G,[]);return Y.length&&(ce.allPaths=Y),ce}function v(W,z,_){const ne=O.sep===O.$fc.sep,ce=ne?W:W.replace($,O.sep),te=O.sep+ce,Y=O.$fc.sep+W;let G;return _?G=function(B,D){return typeof B=="string"&&(B===ce||B.endsWith(te)||!ne&&(B===W||B.endsWith(Y)))?z:null}:G=function(B,D){return typeof B=="string"&&(B===ce||!ne&&B===W)?z:null},G.allPaths=[(_?"*/":"./")+W],G}function E(W){try{const z=new RegExp(`^${S(W)}$`);return function(_){return z.lastIndex=0,typeof _=="string"&&z.test(_)?W:null}}catch{return t}}function T(W,z,_){return!W||typeof z!="string"?!1:F(W)(z,void 0,_)}function F(W,z={}){if(!W)return s;if(typeof W=="string"||U(W)){const _=n(W,z);if(_===t)return s;const ne=function(ce,te){return!!_(ce,te)};return _.allBasenames&&(ne.allBasenames=_.allBasenames),_.allPaths&&(ne.allPaths=_.allPaths),ne}return V(W,z)}function U(W){const z=W;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function j(W){return W.allBasenames||[]}function K(W){return W.allPaths||[]}function V(W,z){const _=H(Object.getOwnPropertyNames(W).map(G=>x(G,W[G],z)).filter(G=>G!==t)),ne=_.length;if(!ne)return t;if(!_.some(G=>!!G.requiresSiblings)){if(ne===1)return _[0];const G=function(J,q){let M;for(let Z=0,ee=_.length;Z<ee;Z++){const X=_[Z](J,q);if(typeof X=="string")return X;(0,c.$oh)(X)&&(M||(M=[]),M.push(X))}return M?(async()=>{for(const Z of M){const ee=await Z;if(typeof ee=="string")return ee}return null})():null},B=_.find(J=>!!J.allBasenames);B&&(G.allBasenames=B.allBasenames);const D=_.reduce((J,q)=>q.allPaths?J.concat(q.allPaths):J,[]);return D.length&&(G.allPaths=D),G}const ce=function(G,B,D){let J,q;for(let M=0,Z=_.length;M<Z;M++){const ee=_[M];ee.requiresSiblings&&D&&(B||(B=(0,O.$mc)(G)),J||(J=B.substr(0,B.length-(0,O.$nc)(G).length)));const X=ee(G,B,J,D);if(typeof X=="string")return X;(0,c.$oh)(X)&&(q||(q=[]),q.push(X))}return q?(async()=>{for(const M of q){const Z=await M;if(typeof Z=="string")return Z}return null})():null},te=_.find(G=>!!G.allBasenames);te&&(ce.allBasenames=te.allBasenames);const Y=_.reduce((G,B)=>B.allPaths?G.concat(B.allPaths):G,[]);return Y.length&&(ce.allPaths=Y),ce}function x(W,z,_){if(z===!1)return t;const ne=n(W,_);if(ne===t)return t;if(typeof z=="boolean")return ne;if(z){const ce=z.when;if(typeof ce=="string"){const te=(Y,G,B,D)=>{if(!D||!ne(Y,G))return null;const J=ce.replace("$(basename)",()=>B),q=D(J);return(0,c.$oh)(q)?q.then(M=>M?W:null):q?W:null};return te.requiresSiblings=!0,te}}return ne}function H(W,z){const _=W.filter(G=>!!G.basenames);if(_.length<2)return W;const ne=_.reduce((G,B)=>{const D=B.basenames;return D?G.concat(D):G},[]);let ce;if(z){ce=[];for(let G=0,B=ne.length;G<B;G++)ce.push(z)}else ce=_.reduce((G,B)=>{const D=B.patterns;return D?G.concat(D):G},[]);const te=function(G,B){if(typeof G!="string")return null;if(!B){let J;for(J=G.length;J>0;J--){const q=G.charCodeAt(J-1);if(q===L.CharCode.Slash||q===L.CharCode.Backslash)break}B=G.substr(J)}const D=ne.indexOf(B);return D!==-1?ce[D]:null};te.basenames=ne,te.patterns=ce,te.allBasenames=ne;const Y=W.filter(G=>!G.basenames);return Y.push(te),Y}function ie(W,z){return(0,I.$tb)(W,z,(_,ne)=>typeof _=="string"&&typeof ne=="string"?_===ne:typeof _!="string"&&typeof ne!="string"?_.base===ne.base&&_.pattern===ne.pattern:!1)}}),define(he[94],ue([0,1,14,65,9]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=k,e.$Mn=R,e.$Nn=d;function A(f){return f.toJSON()}class N{constructor($){this.a=$}transformIncoming($){const l=this.a.transformIncoming($);return l===$?$:A(L.URI.from(l))}transformOutgoing($){const l=this.a.transformOutgoing($);return l===$?$:A(L.URI.from(l))}transformOutgoingURI($){const l=this.a.transformOutgoing($);return l===$?$:L.URI.from(l)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Jn=N,e.$Kn=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function O(f,$,l){if(!f||l>200)return null;if(typeof f=="object"){if(f instanceof L.URI)return $.transformOutgoing(f);for(const p in f)if(Object.hasOwnProperty.call(f,p)){const S=O(f[p],$,l+1);S!==null&&(f[p]=S)}}return null}function k(f,$){const l=O(f,$,0);return l===null?f:l}function b(f,$,l,p){if(!f||p>200)return null;if(typeof f=="object"){if(f.$mid===c.MarshalledId.Uri)return l?L.URI.revive($.transformIncoming(f)):$.transformIncoming(f);if(f instanceof I.$Le)return null;for(const S in f)if(Object.hasOwnProperty.call(f,S)){const g=b(f[S],$,l,p+1);g!==null&&(f[S]=g)}}return null}function R(f,$){const l=b(f,$,!1,0);return l===null?f:l}function d(f,$){const l=b(f,$,!0,0);return l===null?f:l}}),define(he[31],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=void 0,e.$Xg=c;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function c(L){return I.test(L)}e.$Yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(O){for(let k=0;k<O.length;k++)O[k]=Math.floor(Math.random()*256);return O};const A=new Uint8Array(16),N=[];for(let O=0;O<256;O++)N.push(O.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let k=0,b="";return b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+="-",b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b+=N[A[k++]],b}}()}),define(he[140],ue([0,1,38]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=A;const c=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(N){const O=N.replace(/\-/g,":").toLowerCase();return!c.has(O)}function A(){const N=(0,I.networkInterfaces)();for(const O in N){const k=N[O];if(k){for(const{mac:b}of k)if(L(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(he[141],ue([0,1,38,51,31,140,5]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=k,e.$Rn=d,e.$Sn=f,L=ke(L),e.$Pn=new class{c($){return this.a||(this.a=c.$Ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,l=0;const p=(0,I.networkInterfaces)();for(const S in p){const g=p[S];if(g)for(const{mac:w,internal:P}of g)P||(l+=1,this.c(w.toUpperCase())&&($+=1))}this.b=l>0?$/l:0}return this.b}};let O;async function k($){return O||(O=(async()=>await b($)||L.$Yg())()),O}async function b($){try{const l=await new Promise((S,g)=>{oe(["crypto"],S,g)}).then(ke),p=(0,A.$On)();return l.createHash("sha256").update(p,"utf8").digest("hex")}catch(l){$(l);return}}const R="Software\\Microsoft\\SQMClient";async function d($){if(N.$j){const l=await new Promise((p,S)=>{oe(["@vscode/windows-registry"],p,S)}).then(ke);try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",R,"MachineId")||""}catch(p){return $(p),""}}return""}async function f($){try{return await(await new Promise((S,g)=>{oe(["@vscode/deviceid"],S,g)}).then(ke)).getDeviceId()}catch(l){return $(l),""}}}),define(he[142],ue([0,1,239,14]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vX=void 0;class L extends I.Transform{constructor(N){if(super(),typeof N=="number")this.b=N,this.c=1;else{const O=Buffer.isBuffer(N)?N:Buffer.from(N);this.b=O.length===1?O[0]:O,this.c=O.length}}_transform(N,O,k){this.a?this.a=Buffer.concat([this.a,N]):this.a=N;let b=0;for(;b<this.a.length;){const R=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,c.$Me)(this.a,this.b,b);if(R===-1)break;this.push(this.a.slice(b,R+this.c)),b=R+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),k()}_flush(N){this.a&&this.push(this.a),N()}}e.$vX=L}),define(he[143],ue([0,1,32,13,37]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wX=b,e.$xX=R;const A="XDG_SESSION_TYPE",N="WAYLAND_DISPLAY",O="XDG_RUNTIME_DIR";var k;(function(d){d.Wayland="wayland",d.XWayland="xwayland",d.X11="x11",d.Unknown="unknown"})(k||(k={}));async function b(d){const f=L.env[A];if(f)return f===k.Wayland||f===k.X11?f:k.Unknown;if(L.env[N]){const l=L.env[O];if(l){const p=(0,c.$ic)(l,"wayland-0");try{return await I.promises.access(p,I.constants.R_OK),k.Wayland}catch(S){return d(S),k.Unknown}}else return k.Unknown}else return k.X11}function R(d,f){if(f)switch(f){case"auto":return d;case"x11":return d===k.Wayland?k.XWayland:k.X11;case"wayland":return k.Wayland;default:return k.Unknown}else return d===k.Wayland?k.XWayland:k.X11}}),define(he[144],ue([0,1,32,240,5]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=A,L=ke(L);async function A(N){if(L.$k||L.$j)return;let O;for(const k of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{O=await I.promises.open(k,I.constants.R_OK);break}catch{}if(!O){N("Unable to retrieve release information from known identifier paths.");return}try{const k=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),b={id:"unknown"};for await(const R of(0,c.createInterface)({input:O.createReadStream(),crlfDelay:1/0})){if(!R.includes("="))continue;const d=R.split("=")[0].toUpperCase().trim();if(k.has(d)){const f=R.split("=")[1].replace(/"/g,"").toLowerCase().trim();d==="ID"||d==="DISTRIB_ID"?b.id=f:d==="ID_LIKE"?b.id_like=f:(d==="VERSION_ID"||d==="DISTRIB_RELEASE")&&(b.version_id=f)}}return b}catch(k){N(k)}}}),define(he[30],ue([0,1,32,38,241,6,41,90,13,5,20,9]),function(oe,e,I,c,L,A,N,O,k,b,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=S,e.readdirSync=P,e.whenDeleted=h,e.configureFlushOnWrite=r,e.writeFileSync=u,I=ke(I);var f;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function $(V,x=f.UNLINK,H){if((0,N.$Fg)(V))throw new Error("rimraf - will refuse to recursively delete root");return x===f.UNLINK?p(V):l(V,H)}async function l(V,x=(0,N.$Kg)((0,c.tmpdir)())){try{try{await I.promises.rename(V,x)}catch(H){return H.code==="ENOENT"?void 0:p(V)}p(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function p(V){return I.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function S(V){if((0,N.$Fg)(V))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function g(V,x){return m(await(x?w(V):I.promises.readdir(V)))}async function w(V){try{return await I.promises.readdir(V,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const x=[],H=await g(V);for(const ie of H){let W=!1,z=!1,_=!1;try{const ne=await I.promises.lstat((0,k.$ic)(V,ie));W=ne.isFile(),z=ne.isDirectory(),_=ne.isSymbolicLink()}catch(ne){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ne)}x.push({name:ie,isFile:()=>W,isDirectory:()=>z,isSymbolicLink:()=>_})}return x}function P(V){return m(I.readdirSync(V))}function m(V){return V.map(x=>typeof x=="string"?b.$k?(0,O.$km)(x):x:(x.name=b.$k?(0,O.$km)(x.name):x.name,x))}async function o(V){const x=await g(V),H=[];for(const ie of x)await i.existsDirectory((0,k.$ic)(V,ie))&&H.push(ie);return H}function h(V,x=1e3){return new Promise(H=>{let ie=!1;const W=setInterval(()=>{ie||(ie=!0,I.access(V,z=>{ie=!1,z&&(clearInterval(W),H(void 0))}))},x)})}var i;(function(V){async function x(W){let z;try{if(z=await I.promises.lstat(W),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await I.promises.stat(W),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(b.$j&&_.code==="EACCES")try{return{stat:await I.promises.stat(await I.promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(ne){if(ne.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ne}throw _}}V.stat=x;async function H(W){try{const{stat:z,symbolicLink:_}=await V.stat(W);return z.isFile()&&_?.dangling!==!0}catch{}return!1}V.existsFile=H;async function ie(W){try{const{stat:z,symbolicLink:_}=await V.stat(W);return z.isDirectory()&&_?.dangling!==!0}catch{}return!1}V.existsDirectory=ie})(i||(e.SymlinkSupport=i={}));const s=new A.$Lh;function t(V,x,H){return s.queueFor(d.URI.file(V),()=>{const ie=y(H);return new Promise((W,z)=>a(V,x,ie,_=>_?z(_):W()))},R.$7g)}let n=!0;function r(V){n=V}function a(V,x,H,ie){if(!n)return I.writeFile(V,x,{mode:H.mode,flag:H.flag},ie);I.open(V,H.flag,H.mode,(W,z)=>{if(W)return ie(W);I.writeFile(z,x,_=>{if(_)return I.close(z,()=>ie(_));I.fdatasync(z,ne=>(ne&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ne),r(!1)),I.close(z,ce=>ie(ce))))})})}function u(V,x,H){const ie=y(H);if(!n)return I.writeFileSync(V,x,{mode:ie.mode,flag:ie.flag});const W=I.openSync(V,ie.flag,ie.mode);try{I.writeFileSync(W,x);try{I.fdatasyncSync(W)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),r(!1)}}finally{I.closeSync(W)}}function y(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function C(V,x,H=6e4){if(V!==x)try{b.$j&&typeof H=="number"?await v(V,x,Date.now(),H):await I.promises.rename(V,x)}catch(ie){if(V.toLowerCase()!==x.toLowerCase()&&ie.code==="EXDEV"||V.endsWith("."))await E(V,x,{preserveSymlinks:!1}),await $(V,f.MOVE);else throw ie}}async function v(V,x,H,ie,W=0){try{return await I.promises.rename(V,x)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-H>=ie)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${z}`),z;if(W===0){let _=!1;try{const{stat:ne}=await i.stat(x);ne.isFile()||(_=!0)}catch{}if(_)throw z}return await(0,A.$Dh)(Math.min(100,W*10)),v(V,x,H,ie,W+1)}}async function E(V,x,H){return F(V,x,{root:{source:V,target:x},options:H,handledSourcePaths:new Set})}const T=511;async function F(V,x,H){if(H.handledSourcePaths.has(V))return;H.handledSourcePaths.add(V);const{stat:ie,symbolicLink:W}=await i.stat(V);if(W){if(H.options.preserveSymlinks)try{return await K(V,x,H)}catch{}if(W.dangling)return}return ie.isDirectory()?U(V,x,ie.mode&T,H):j(V,x,ie.mode&T)}async function U(V,x,H,ie){await I.promises.mkdir(x,{recursive:!0,mode:H});const W=await g(V);for(const z of W)await F((0,k.$ic)(V,z),(0,k.$ic)(x,z),ie)}async function j(V,x,H){await I.promises.copyFile(V,x),await I.promises.chmod(x,H)}async function K(V,x,H){let ie=await I.promises.readlink(V);(0,N.$Bg)(ie,H.root.source,!b.$l)&&(ie=(0,k.$ic)(H.root.target,ie.substr(H.root.source.length+1))),await I.promises.symlink(ie,x)}e.Promises=new class{get read(){return(V,x,H,ie,W)=>new Promise((z,_)=>{I.read(V,x,H,ie,W,(ne,ce,te)=>ne?_(ne):z({bytesRead:ce,buffer:te}))})}get write(){return(V,x,H,ie,W)=>new Promise((z,_)=>{I.write(V,x,H,ie,W,(ne,ce,te)=>ne?_(ne):z({bytesWritten:ce,buffer:te}))})}get fdatasync(){return(0,L.promisify)(I.fdatasync)}get open(){return(0,L.promisify)(I.open)}get close(){return(0,L.promisify)(I.close)}get realpath(){return(0,L.promisify)(I.realpath)}async exists(V){try{return await I.promises.access(V),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return o}get writeFile(){return t}get rm(){return $}get rename(){return C}get copy(){return E}}}),define(he[145],ue([0,1,32,13,5,26,30]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=O,e.$jr=k,e.$kr=b,e.$lr=R,I=ke(I);function O(f){if(L.$l)return f;const $=(0,c.$lc)(f);if(f===$)return f;const l=((0,c.$mc)(f)||f).toLowerCase();try{const S=(0,N.readdirSync)($).filter(g=>g.toLowerCase()===l);if(S.length===1){const g=O($);if(g)return(0,c.$ic)(g,S[0])}else if(S.length>1){const g=S.indexOf(l);if(g>=0){const w=O($);if(w)return(0,c.$ic)(w,S[g])}}}catch{}return null}async function k(f,$){if(L.$l)return f;const l=(0,c.$lc)(f);if(f===l)return f;const p=((0,c.$mc)(f)||f).toLowerCase();try{if($?.isCancellationRequested)return null;const g=(await N.Promises.readdir(l)).filter(w=>w.toLowerCase()===p);if(g.length===1){const w=await k(l,$);if(w)return(0,c.$ic)(w,g[0])}else if(g.length>1){const w=g.indexOf(p);if(w>=0){const P=await k(l,$);if(P)return(0,c.$ic)(P,g[w])}}}catch{}return null}async function b(f){try{return await N.Promises.realpath(f)}catch{const l=d(f);return await I.promises.access(l,I.constants.R_OK),l}}function R(f){try{return I.realpathSync(f)}catch{const l=d(f);return I.accessSync(l,I.constants.R_OK),l}}function d(f){return(0,A.$lf)((0,c.$gc)(f),c.sep)}}),define(he[146],ue([0,1,67]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=c,e.$3g=A,I=ke(I);function c(O,k,b,R=1){let d=!1;return new Promise(f=>{const $=setTimeout(()=>{if(!d)return d=!0,f(0)},b);L(O,k,R,l=>{if(!d)return d=!0,clearTimeout($),f(l)})})}function L(O,k,b,R){if(k===0)return R(0);const d=new I.Socket;d.once("connect",()=>(N(d),L(O+b,k-1,b,R))),d.once("data",()=>{}),d.once("error",f=>(N(d),f.code!=="ECONNREFUSED"?L(O+b,k-1,b,R):R(O))),d.connect(O,"127.0.0.1")}e.$2g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(O,k,b,R="127.0.0.1"){let d=!1,f,$=1;const l=I.createServer({pauseOnConnect:!0});function p(S,g){d||(d=!0,l.removeAllListeners(),l.close(),f&&clearTimeout(f),g(S))}return new Promise(S=>{f=setTimeout(()=>{p(0,S)},b),l.on("listening",()=>{p(O,S)}),l.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&$<k?(O++,$++,l.listen(O,R)):p(0,S)}),l.on("close",()=>{p(0,S)}),l.listen(O,R)})}function N(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch(k){console.error(k)}}}),define(he[147],ue([0,1,32,13,5,37,91,12,30]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$vm=b,e.$wm=R,c=ke(c),L=ke(L),A=ke(A),O=ke(O),k=ke(k),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function b(f=A.env){return f.comspec||"cmd.exe"}function R(f){let $=[],l=!1;const p=function(S){if(l){$.push(S);return}(!f.send(S,w=>{if(w&&console.error(w),l=!1,$.length>0){const P=$.slice(0);$=[],P.forEach(m=>p(m))}})||L.$j)&&(l=!0)};return{send:p}}var d;(function(f){async function $(l,p,S){if(c.$hc(l))return l;if(p===void 0&&(p=A.cwd()),c.$lc(l)!=="."||(S===void 0&&O.$cg(A.env.PATH)&&(S=A.env.PATH.split(c.$sc)),S===void 0||S.length===0))return c.$ic(p,l);async function w(P){if(await k.Promises.exists(P)){let m;try{m=await I.promises.stat(P)}catch(o){o.message.startsWith("EACCES")&&(m=await I.promises.lstat(P))}return m?!m.isDirectory():!1}return!1}for(const P of S){let m;if(c.$hc(P)?m=c.$ic(P,l):m=c.$ic(p,P,l),await w(m))return m;let o=m+".com";if(await w(o)||(o=m+".exe",await w(o)))return o}return c.$ic(p,l)}f.findExecutable=$})(d||(e.win32=d={}))}),define(he[148],ue([0,1,68,22]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=L;function L(N){return new Promise((O,k)=>{let b;const R=new Map;function d($,l,p,S,g){const w=R.get(l);if($===N||w){const P={name:f(p),cmd:p,pid:$,ppid:l,load:S,mem:g};R.set($,P),$===N&&(b=P),w&&(w.children||(w.children=[]),w.children.push(P),w.children.length>1&&(w.children=w.children.sort((m,o)=>m.pid-o.pid)))}}function f($){const l=/--utility-sub-type=network/i,p=/--crashes-directory/i,S=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(p.exec($))return"electron-crash-reporter";if(S.exec($))return"winpty-agent";if(g.exec($))return"conpty-agent";let P=w.exec($);if(P&&P.length===2)return P[1]==="renderer"?"window":P[1]==="utility"?l.exec($)?"utility-network-service":"utility-process":P[1]==="extensionHost"?"extension-host":P[1];const m=/[a-zA-Z-]+\.js/g;let o="";do P=m.exec($),P&&(o+=P+" ");while(P);return o&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${o})`:$}if(process.platform==="win32"){const $=l=>l.indexOf("\\\\?\\")===0||l.indexOf("\\??\\")===0?l.substring(4):l.indexOf('"\\\\?\\')===0||l.indexOf('"\\??\\')===0?'"'+l.substring(5):l;new Promise((l,p)=>{oe(["@vscode/windows-process-tree"],l,p)}).then(ke).then(l=>{l.getProcessList(N,p=>{if(!p){k(new Error(`Root process ${N} not found`));return}l.getProcessCpuUsage(p,S=>{const g=new Map;S.forEach(w=>{const P=$(w.commandLine||"");g.set(w.pid,{name:f(P),cmd:P,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),b=g.get(N),b?(g.forEach(w=>{const P=g.get(w.ppid);P&&(P.children||(P.children=[]),P.children.push(w))}),g.forEach(w=>{w.children&&(w.children=w.children.sort((P,m)=>P.pid-m.pid))}),O(b)):k(new Error(`Root process ${N} not found`))})},l.ProcessDataFlag.CommandLine|l.ProcessDataFlag.Memory)})}else{let $=function(){let l=[b];const p=[];for(;l.length;){const g=l.shift();g&&(p.push(g.pid),g.children&&(l=l.concat(g.children)))}let S=JSON.stringify(c.$Wg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);S+=" "+p.join(" "),(0,I.exec)(S,{},(g,w,P)=>{if(g||P)k(g||new Error(P.toString()));else{const m=w.toString().split(`
`);for(let o=0;o<p.length;o++){const h=R.get(p[o]);h.load=parseFloat(m[o])}if(!b){k(new Error(`Root process ${N} not found`));return}O(b)}})};(0,I.exec)("which ps",{},(l,p,S)=>{if(l||S)if(process.platform!=="linux")k(l||new Error(S.toString()));else{const g=JSON.stringify(c.$Wg.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(g,{},(w,P,m)=>{w||m?k(w||new Error(m.toString())):(A(P,d),$())})}else{const g=p.toString().trim();(0,I.exec)(`${g} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(P,m,o)=>{P||o&&!o.includes("screen size is bogus")?k(P||new Error(o.toString())):(A(m,d),process.platform==="linux"?$():b?O(b):k(new Error(`Root process ${N} not found`)))})}})}})}function A(N,O){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=N.toString().split(`
`);for(const R of b){const d=k.exec(R.trim());d&&d.length===6&&O(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}});var ve=this&&this.__decorate||function(oe,e,I,c){var L=arguments.length,A=L<3?e:c===null?c=Object.getOwnPropertyDescriptor(e,I):c,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(oe,e,I,c);else for(var O=oe.length-1;O>=0;O--)(N=oe[O])&&(A=(L<3?N(A):L>3?N(e,I,A):N(e,I))||A);return L>3&&A&&Object.defineProperty(e,I,A),A};define(he[42],ue([0,1,17,6,14,25,87,8,3,2,66,26,12]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$li=e.ProxyChannel=e.$ki=e.$hi=e.$gi=e.$fi=e.RequestInitiator=e.$ei=e.$bi=e.$ai=void 0,e.$ci=r,e.$di=a,e.$ii=T,e.$ji=F,d=ke(d);var $;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})($||($={}));function l(W){switch(W){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var p;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(p||(p={}));function S(W){switch(W){case p.Initialize:return"init";case p.PromiseSuccess:return"reply:";case p.PromiseError:case p.PromiseErrorObj:return"replyErr:";case p.EventFire:return"event:"}}var g;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(g||(g={}));function w(W){let z=0;for(let _=0;;_+=7){const ne=W.read(1);if(z|=(ne.buffer[0]&127)<<_,!(ne.buffer[0]&128))return z}}const P=s(0);function m(W,z){if(z===0){W.write(P);return}let _=0;for(let ce=z;ce!==0;ce=ce>>>7)_++;const ne=L.$Le.alloc(_);for(let ce=0;z!==0;ce++)ne.buffer[ce]=z&127,z=z>>>7,z>0&&(ne.buffer[ce]|=128);W.write(ne)}class o{constructor(z){this.b=z,this.a=0}read(z){const _=this.b.slice(this.a,this.a+z);return this.a+=_.byteLength,_}}e.$ai=o;class h{constructor(){this.a=[]}get buffer(){return L.$Le.concat(this.a)}write(z){this.a.push(z)}}e.$bi=h;var i;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(i||(i={}));function s(W){const z=L.$Le.alloc(1);return z.writeUInt8(W,0),z}const t={Undefined:s(i.Undefined),String:s(i.String),Buffer:s(i.Buffer),VSBuffer:s(i.VSBuffer),Array:s(i.Array),Object:s(i.Object),Uint:s(i.Int)},n=typeof Buffer<"u";function r(W,z){if(typeof z>"u")W.write(t.Undefined);else if(typeof z=="string"){const _=L.$Le.fromString(z);W.write(t.String),m(W,_.byteLength),W.write(_)}else if(n&&Buffer.isBuffer(z)){const _=L.$Le.wrap(z);W.write(t.Buffer),m(W,_.byteLength),W.write(_)}else if(z instanceof L.$Le)W.write(t.VSBuffer),m(W,z.byteLength),W.write(z);else if(Array.isArray(z)){W.write(t.Array),m(W,z.length);for(const _ of z)r(W,_)}else if(typeof z=="number"&&(z|0)===z)W.write(t.Uint),m(W,z);else{const _=L.$Le.fromString(JSON.stringify(z));W.write(t.Object),m(W,_.byteLength),W.write(_)}}function a(W){switch(W.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return W.read(w(W)).toString();case i.Buffer:return W.read(w(W)).buffer;case i.VSBuffer:return W.read(w(W));case i.Array:{const _=w(W),ne=[];for(let ce=0;ce<_;ce++)ne.push(a(W));return ne}case i.Object:return JSON.parse(W.read(w(W)).toString());case i.Int:return w(W)}}class u{constructor(z,_,ne=null,ce=1e3){this.h=z,this.j=_,this.k=ne,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:p.Initialize})}registerChannel(z,_){this.b.set(z,_),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case p.Initialize:{const _=this.o([z.type]);this.k?.logOutgoing(_,0,y.OtherSide,S(z.type));return}case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:{const _=this.o([z.type,z.id],z.data);this.k?.logOutgoing(_,z.id,y.OtherSide,S(z.type),z.data);return}}}o(z,_=void 0){const ne=new h;return r(ne,z),r(ne,_),this.p(ne.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const _=new o(z),ne=a(_),ce=a(_),te=ne[0];switch(te){case $.Promise:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(te)}: ${ne[2]}.${ne[3]}`,ce),this.s({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:ce});case $.EventListen:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(te)}: ${ne[2]}.${ne[3]}`,ce),this.t({type:te,id:ne[1],channelName:ne[2],name:ne[3],arg:ce});case $.PromiseCancel:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(te)}`),this.u({type:te,id:ne[1]});case $.EventDispose:return this.k?.logIncoming(z.byteLength,ne[1],y.OtherSide,`${l(te)}`),this.u({type:te,id:ne[1]})}}s(z){const _=this.b.get(z.channelName);if(!_){this.v(z);return}const ne=new A.$ue;let ce;try{ce=_.call(this.j,z.name,z.arg,ne.token)}catch(G){ce=Promise.reject(G)}const te=z.id;ce.then(G=>{this.m({id:te,data:G,type:p.PromiseSuccess})},G=>{G instanceof Error?this.m({id:te,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split(`
`):void 0},type:p.PromiseError}):this.m({id:te,data:G,type:p.PromiseErrorObj})}).finally(()=>{Y.dispose(),this.d.delete(z.id)});const Y=(0,b.$Rc)(()=>ne.cancel());this.d.set(z.id,Y)}t(z){const _=this.b.get(z.channelName);if(!_){this.v(z);return}const ne=z.id,te=_.listen(this.j,z.name,z.arg)(Y=>this.m({id:ne,data:Y,type:p.EventFire}));this.d.set(z.id,te)}u(z){const _=this.d.get(z.id);_&&(_.dispose(),this.d.delete(z.id))}v(z){let _=this.g.get(z.channelName);_||(_=[],this.g.set(z.channelName,_));const ne=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===$.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:p.PromiseError})},this.l);_.push({request:z,timeoutTimer:ne})}w(z){const _=this.g.get(z);if(_){for(const ne of _)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case $.Promise:this.s(ne.request);break;case $.EventListen:this.t(ne.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Oc)(this.d.values()),this.d.clear()}}e.$ei=u;var y;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class C{constructor(z,_=null){this.l=z,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$je,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=_}getChannel(z){const _=this;return{call(ne,ce,te){return _.a?Promise.reject(new O.$4):_.m(z,ne,ce,te)},listen(ne,ce){return _.a?k.Event.None:_.o(z,ne,ce)}}}m(z,_,ne,ce=A.CancellationToken.None){const te=this.g++,Y=$.Promise,G={id:te,type:Y,channelName:z,name:_,arg:ne};if(ce.isCancellationRequested)return Promise.reject(new O.$4);let B;return new Promise((J,q)=>{if(ce.isCancellationRequested)return q(new O.$4);const M=()=>{const re=le=>{switch(le.type){case p.PromiseSuccess:this.f.delete(te),J(le.data);break;case p.PromiseError:{this.f.delete(te);const ge=new Error(le.data.message);ge.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ge.name=le.data.name,q(ge);break}case p.PromiseErrorObj:this.f.delete(te),q(le.data);break}};this.f.set(te,re),this.p(G)};let Z=null;this.b===g.Idle?M():(Z=(0,c.$ph)(re=>this.u()),Z.then(()=>{Z=null,M()}));const ee=()=>{Z?(Z.cancel(),Z=null):this.p({id:te,type:$.PromiseCancel}),q(new O.$4)},X=ce.onCancellationRequested(ee);B=(0,b.$Qc)((0,b.$Rc)(ee),X),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(z,_,ne){const ce=this.g++,te=$.EventListen,Y={id:ce,type:te,channelName:z,name:_,arg:ne};let G=null;const B=new k.$je({onWillAddFirstListener:()=>{G=(0,c.$ph)(J=>this.u()),G.then(()=>{G=null,this.d.add(B),this.p(Y)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(B),this.p({id:ce,type:$.EventDispose}))}}),D=J=>B.fire(J.data);return this.f.set(ce,D),B.event}p(z){switch(z.type){case $.Promise:case $.EventListen:{const _=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(_,z.id,y.LocalSide,`${l(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case $.PromiseCancel:case $.EventDispose:{const _=this.q([z.type,z.id]);this.j?.logOutgoing(_,z.id,y.LocalSide,l(z.type));return}}}q(z,_=void 0){const ne=new h;return r(ne,z),r(ne,_),this.r(ne.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const _=new o(z),ne=a(_),ce=a(_),te=ne[0];switch(te){case p.Initialize:return this.j?.logIncoming(z.byteLength,0,y.LocalSide,S(te)),this.t({type:ne[0]});case p.PromiseSuccess:case p.PromiseError:case p.EventFire:case p.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,ne[1],y.LocalSide,S(te),ce),this.t({type:ne[0],id:ne[1],data:ce})}}t(z){if(z.type===p.Initialize){this.b=g.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Oc)(this.d.values()),this.d.clear()}}e.$fi=C,ve([N.$7h],C.prototype,"onDidInitializePromise",null);class v{get connections(){const z=[];return this.f.forEach(_=>z.push(_)),z}constructor(z,_,ne){this.a=new Map,this.f=new Set,this.g=new k.$je,this.onDidAddConnection=this.g.event,this.h=new k.$je,this.onDidRemoveConnection=this.h.event,this.j=new b.$Sc,this.j.add(z(({protocol:ce,onDidClientDisconnect:te})=>{const Y=k.Event.once(ce.onMessage);this.j.add(Y(G=>{const B=new o(G),D=a(B),J=new u(ce,D,_,ne),q=new C(ce,_);this.a.forEach((Z,ee)=>J.registerChannel(ee,Z));const M={channelServer:J,channelClient:q,ctx:D};this.f.add(M),this.g.fire(M),this.j.add(te(()=>{J.dispose(),q.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(z,_){const ne=this;return{call(ce,te,Y){let G;if((0,f.$qg)(_)){const D=(0,I.$2b)(ne.connections.filter(_));G=D?Promise.resolve(D):k.Event.toPromise(k.Event.filter(ne.onDidAddConnection,_))}else G=_.routeCall(ne,ce,te);const B=G.then(D=>D.channelClient.getChannel(z));return T(B).call(ce,te,Y)},listen(ce,te){if((0,f.$qg)(_))return ne.k(z,_,ce,te);const Y=_.routeEvent(ne,ce,te).then(G=>G.channelClient.getChannel(z));return T(Y).listen(ce,te)}}}k(z,_,ne,ce){const te=this;let Y;const G=new k.$je({onWillAddFirstListener:()=>{Y=new b.$Sc;const B=new k.$pe,D=new Map,J=M=>{const ee=M.channelClient.getChannel(z).listen(ne,ce),X=B.add(ee);D.set(M,X)},q=M=>{const Z=D.get(M);Z&&(Z.dispose(),D.delete(M))};te.connections.filter(_).forEach(J),k.Event.filter(te.onDidAddConnection,_)(J,void 0,Y),te.onDidRemoveConnection(q,void 0,Y),B.event(G.fire,G,Y),Y.add(B)},onDidRemoveLastListener:()=>{Y?.dispose(),Y=void 0}});return G.event}registerChannel(z,_){this.a.set(z,_);for(const ne of this.f)ne.channelServer.registerChannel(z,_)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$gi=v;class E{constructor(z,_,ne=null){const ce=new h;r(ce,_),z.send(ce.buffer),this.a=new C(z,ne),this.d=new u(z,_,ne)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,_){this.d.registerChannel(z,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$hi=E;function T(W){return{call(z,_,ne){return W.then(ce=>ce.call(z,_,ne))},listen(z,_){const ne=new k.$se;return W.then(ce=>ne.input=ce.listen(z,_)),ne.event}}}function F(W){let z=!1;return{call(_,ne,ce){return z?W.call(_,ne,ce):(0,c.$Dh)(0).then(()=>z=!0).then(()=>W.call(_,ne,ce))},listen(_,ne){if(z)return W.listen(_,ne);const ce=new k.$se;return(0,c.$Dh)(0).then(()=>z=!0).then(()=>ce.input=W.listen(_,ne)),ce.event}}}class U{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const _ of z.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await k.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ki=U;var j;(function(W){function z(te,Y,G){const B=te,D=G&&G.disableMarshalling,J=new Map;for(const q in B)ne(q)&&J.set(q,k.Event.buffer(B[q],!0,void 0,Y));return new class{listen(q,M,Z){const ee=J.get(M);if(ee)return ee;const X=B[M];if(typeof X=="function"){if(ce(M))return X.call(B,Z);if(ne(M))return J.set(M,k.Event.buffer(B[M],!0,void 0,Y)),J.get(M)}throw new O.$ab(`Event not found: ${M}`)}call(q,M,Z){const ee=B[M];if(typeof ee=="function"){if(!D&&Array.isArray(Z))for(let re=0;re<Z.length;re++)Z[re]=(0,R.$_h)(Z[re]);let X=ee.apply(B,Z);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new O.$ab(`Method not found: ${M}`)}}}W.fromService=z;function _(te,Y){const G=Y&&Y.disableMarshalling;return new Proxy({},{get(B,D){if(typeof D=="string")return Y?.properties?.has(D)?Y.properties.get(D):ce(D)?function(J){return te.listen(D,J)}:ne(D)?te.listen(D):async function(...J){let q;Y&&!(0,f.$lg)(Y.context)?q=[Y.context,...J]:q=J;const M=await te.call(D,q);return G?M:(0,R.$_h)(M)};throw new O.$ab(`Property not found: ${String(D)}`)}})}W.toService=_;function ne(te){return te[0]==="o"&&te[1]==="n"&&d.$Cf(te.charCodeAt(2))}function ce(te){return/^onDynamic/.test(te)&&d.$Cf(te.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const z=W.toString();if(z!=="[object Object]")return z}return W}function x(W){return Array.isArray(W)?W.map(V):V(W)}function H(W,z,_,ne,ce,te,Y){Y=x(Y);const G=K[ce],B=G[ne%G.length];let D=[`%c[${W}]%c[${String(z).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(te)?(D=D.concat(Y),D.push(")")):D.push(Y),console.log.apply(console,D)}class ie{constructor(z,_){this.d=z,this.f=_,this.a=0,this.b=0}logOutgoing(z,_,ne,ce,te){this.b+=z,H(this.d,this.b,z,_,ne,ce,te)}logIncoming(z,_,ne,ce,te){this.a+=z,H(this.f,this.a,z,_,ne,ce,te)}}e.$li=ie}),define(he[69],ue([0,1,14,3,2,42]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=e.$oi=e.$ni=e.ProtocolConstants=e.$mi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var N;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(N||(e.SocketDiagnosticsEventType=N={}));var O;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let r=0;function a(y,C){if(!n.has(y)){const v=String(++r);n.set(y,v)}return n.get(y)}function u(y,C,v,E){if(!t.enableDiagnostics)return;const T=a(y,C);if(E instanceof I.$Le||E instanceof Uint8Array||E instanceof ArrayBuffer||ArrayBuffer.isView(E)){const F=I.$Le.alloc(E.byteLength);F.set(E),t.records.push({timestamp:Date.now(),id:T,label:C,type:v,buff:F})}else t.records.push({timestamp:Date.now(),id:T,label:C,type:v,data:E})}t.traceSocketEvent=u})(O||(e.SocketDiagnostics=O={}));var k;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let b=null;function R(){return b||(b=I.$Le.alloc(0)),b}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,r){if(n===0)return R();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const C=this.a[0];return r&&(this.a.shift(),this.b-=n),C}if(this.a[0].byteLength>n){const C=this.a[0].slice(0,n);return r&&(this.a[0]=this.a[0].slice(n),this.b-=n),C}const a=I.$Le.alloc(n);let u=0,y=0;for(;n>0;){const C=this.a[y];if(C.byteLength>n){const v=C.slice(0,n);a.set(v,u),u+=n,r&&(this.a[y]=C.slice(n),this.b-=n),n-=n}else a.set(C,u),u+=C.byteLength,r?(this.a.shift(),this.b-=C.byteLength):y++,n-=C.byteLength}return a}}e.$mi=d;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(f||(f={}));function $(t){switch(t){case f.None:return"None";case f.Regular:return"Regular";case f.Control:return"Control";case f.Ack:return"Ack";case f.Disconnect:return"Disconnect";case f.ReplayRequest:return"ReplayRequest";case f.Pause:return"PauseWriting";case f.Resume:return"ResumeWriting";case f.KeepAlive:return"KeepAlive"}}var l;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(l||(e.ProtocolConstants=l={}));class p{constructor(n,r,a,u){this.type=n,this.id=r,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class S extends L.$Tc{constructor(n){super(),this.f=this.B(new c.$je),this.onMessage=this.f.event,this.g={readHead:!0,readLen:l.HeaderLength,messageType:f.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new d,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent(N.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,u=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=l.HeaderLength,this.g.messageType=f.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(N.ProtocolMessageRead,r),this.f.fire(new p(a,u,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$Le.alloc(l.HeaderLength);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(N.ProtocolHeaderWrite,{messageType:$(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(N.ProtocolMessageWrite,n.data),this.j(r,n.data)}g(n,r){const a=this.f===0;return this.d.push(n,r),this.f+=n.byteLength+r.byteLength,a}h(){const n=I.$Le.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,r){this.g(n,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(N.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class w extends L.$Tc{constructor(n){super(),this.f=new c.$je,this.onMessage=this.f.event,this.g=new c.$je,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new S(this.a)),this.B(this.c.onMessage(r=>{r.type===f.Regular&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new p(f.Regular,0,0,n))}}e.$ni=w;class P extends A.$hi{static fromSocket(n,r){return new P(new w(n),r)}get onDidDispose(){return this.b.onDidDispose}constructor(n,r,a=null){super(n,r,a),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$oi=P;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.$je({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$pi=m;class o{constructor(n){this.data=n,this.next=null}}class h{constructor(){this.a=null,this.b=null}length(){let n=0,r=this.a;for(;r;)r=r.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let r=0,a=this.a;for(;a;)n[r++]=a.data,a=a.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const r=new o(n);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const n=Date.now();for(let r=0;r<i.a;r++)this.c[r]=n-1e3*r;setInterval(()=>{for(let r=i.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),r=(1+i.a)*1e3;let a=0;for(let u=0;u<i.a;u++)n-this.c[u]<=r&&a++;return 1-a/i.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.d-this.f}constructor(n){this.v=new m,this.onControlMessage=this.v.event,this.w=new m,this.onMessage=this.w.event,this.x=new m,this.onDidDispose=this.x.event,this.y=new m,this.onSocketClose=this.y.event,this.z=new m,this.onSocketTimeout=this.z.event,this.t=n.loadEstimator??i.getInstance(),this.u=n.sendKeepAlive??!0,this.a=!1,this.c=new h,this.d=0,this.f=0,this.g=null,this.h=0,this.j=0,this.k=0,this.l=null,this.n=0,this.o=Date.now(),this.s=new L.$Sc,this.p=n.socket,this.q=this.s.add(new g(this.p)),this.r=this.s.add(new S(this.p)),this.s.add(this.r.onMessage(r=>this.A(r))),this.s.add(this.p.onClose(r=>this.y.fire(r))),n.initialChunk&&this.r.acceptChunk(n.initialChunk),this.u?this.m=setInterval(()=>{this.E()},l.KeepAliveSendTime):this.m=null}dispose(){this.g&&(clearTimeout(this.g),this.g=null),this.l&&(clearTimeout(this.l),this.l=null),this.m&&(clearInterval(this.m),this.m=null),this.s.dispose()}drain(){return this.q.drain()}sendDisconnect(){if(!this.b){this.b=!0;const n=new p(f.Disconnect,0,0,R());this.q.write(n),this.q.flush()}}sendPause(){const n=new p(f.Pause,0,0,R());this.q.write(n)}sendResume(){const n=new p(f.Resume,0,0,R());this.q.write(n)}pauseSocketWriting(){this.q.pause()}getSocket(){return this.p}getMillisSinceLastIncomingData(){return Date.now()-this.r.lastReadTime}beginAcceptReconnection(n,r){this.a=!0,this.s.dispose(),this.s=new L.$Sc,this.v.flushBuffer(),this.y.flushBuffer(),this.z.flushBuffer(),this.p.dispose(),this.n=0,this.o=Date.now(),this.p=n,this.q=this.s.add(new g(this.p)),this.r=this.s.add(new S(this.p)),this.s.add(this.r.onMessage(a=>this.A(a))),this.s.add(this.p.onClose(a=>this.y.fire(a))),this.r.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.j=this.h;const n=new p(f.Ack,0,this.j,R());this.q.write(n);const r=this.c.toArray();for(let a=0,u=r.length;a<u;a++)this.q.write(r[a]);this.C()}acceptDisconnect(){this.x.fire()}A(n){if(n.ack>this.f){this.f=n.ack;do{const r=this.c.peek();if(r&&r.id<=n.ack)this.c.pop();else break}while(!0)}switch(n.type){case f.None:break;case f.Regular:{if(n.id>this.h)if(n.id!==this.h+1){const r=Date.now();r-this.n>1e4&&(this.n=r,this.q.write(new p(f.ReplayRequest,0,0,R())))}else this.h=n.id,this.k=Date.now(),this.B(),this.w.fire(n.data);break}case f.Control:{this.v.fire(n.data);break}case f.Ack:break;case f.Disconnect:{this.x.fire();break}case f.ReplayRequest:{const r=this.c.toArray();for(let a=0,u=r.length;a<u;a++)this.q.write(r[a]);this.C();break}case f.Pause:{this.q.pause();break}case f.Resume:{this.q.resume();break}case f.KeepAlive:break}}readEntireBuffer(){return this.r.readEntireBuffer()}flush(){this.q.flush()}send(n){const r=++this.d;this.j=this.h;const a=new p(f.Regular,r,this.j,n);this.c.push(a),this.a||(this.q.write(a),this.C())}sendControl(n){const r=new p(f.Control,0,0,n);this.q.write(r)}B(){if(this.h<=this.j||this.l)return;const n=Date.now()-this.k;if(n>=l.AcknowledgeTime){this.D();return}this.l=setTimeout(()=>{this.l=null,this.B()},l.AcknowledgeTime-n+5)}C(){if(this.d<=this.f||this.g||this.a)return;const n=this.c.peek(),r=Date.now()-n.writtenTime,a=Date.now()-this.r.lastReadTime,u=Date.now()-this.o;if(r>=l.TimeoutTime&&a>=l.TimeoutTime&&u>=l.TimeoutTime&&!this.t.hasHighLoad()){this.o=Date.now(),this.z.fire({unacknowledgedMsgCount:this.c.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const y=Math.max(l.TimeoutTime-r,l.TimeoutTime-a,l.TimeoutTime-u,500);this.g=setTimeout(()=>{this.g=null,this.C()},y)}D(){if(this.h<=this.j)return;this.j=this.h;const n=new p(f.Ack,0,this.j,R());this.q.write(n)}E(){this.j=this.h;const n=new p(f.KeepAlive,0,this.j,R());this.q.write(n)}}e.$qi=s}),define(he[95],ue([0,1,68,6,14,25,138,8,3,2,29,147,91,42]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0,O=ke(O);class l extends $.$ei{constructor(g){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",w=>L.$Le.wrap(Buffer.from(w,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$er=l;class p{constructor(g,w){this.i=g,this.j=w,this.c=new Set,this.g=new Map,this.h=new k.$je,this.onDidProcessExit=this.h.event;const P=w&&w.timeout?w.timeout:6e4;this.b=new c.$zh(P),this.d=null,this.f=null}getChannel(g){const w=this;return{call(P,m,o){return w.k(g,P,m,o)},listen(P,m){return w.l(g,P,m)}}}k(g,w,P,m=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(O.$5());this.b.cancel();const o=this.n(g),h=(0,c.$ph)(t=>o.call(w,P,t)),i=m.onCancellationRequested(()=>h.cancel()),s=(0,b.$Rc)(()=>h.cancel());return this.c.add(s),h.finally(()=>{i.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),h}l(g,w,P){if(!this.b)return k.Event.None;this.b.cancel();let m;const o=new k.$je({onWillAddFirstListener:()=>{m=this.n(g).listen(w,P)(o.fire,o),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return o.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,R.$bo)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,f.$jm)(w.env),this.d=(0,I.fork)(this.i,g,w);const P=new k.$je,o=k.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,N.$ar)(r)){(0,N.log)(r,`IPC Library: ${this.j.serverName}`);return}P.fire(L.$Le.wrap(Buffer.from(r,"base64")))}),h=this.j.useQueue?(0,d.$wm)(this.d):this.d,i=r=>this.d&&this.d.connected&&h.send(r.buffer.toString("base64")),s=P.event,t={send:i,onMessage:s};this.f=new $.$fi(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",n),o.dispose(),this.c.forEach(u=>(0,b.$Oc)(u)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(g){let w=this.g.get(g);return w||(w=this.m.getChannel(g),this.g.set(g,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$fr=p}),define(he[149],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NX=I;function I(c){return!!c.parentPort}}),define(he[150],ue([0,1,149,14,42,3,12,17]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OX=void 0,e.$PX=R;class k{constructor(f){this.a=f,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",$=>$.data?c.$Le.wrap($.data):c.$Le.alloc(0)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}class b extends L.$gi{static b(f){(0,N.$mg)((0,I.$NX)(process),"Electron Utility Process");const $=new A.$je;return process.parentPort.on("message",l=>{if(f?.handledClientConnection(l))return;const p=(0,O.$Nb)(l.ports);p&&$.fire(p)}),A.Event.map($.event,l=>({protocol:new k(l),onDidClientDisconnect:A.Event.fromNodeEventEmitter(l,"close")}))}constructor(f){super(b.b(f))}}e.$OX=b;function R(d,f,$){const l=p=>{p.data===f&&(d.removeListener("message",l),$())};d.on("message",l)}}),define(he[70],ue([0,1,6,3,2,66,12]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.StorageState=e.StorageHint=void 0,e.$aq=k;var O;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function k(f){const $=f;return $?.changed instanceof Map||$?.deleted instanceof Set}var b;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(b||(e.StorageState=b={}));class R extends L.$Tc{static{this.a=100}constructor($,l=Object.create(null)){super(),this.r=$,this.s=l,this.b=this.B(new c.$me),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new I.$Ah(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((l,p)=>this.w(p,l)),$.deleted?.forEach(l=>this.w(l,void 0))}finally{this.b.resume()}}w($,l){if(this.c===b.Closed)return;let p=!1;(0,N.$lg)(l)?p=this.f.delete($):this.f.get($)!==l&&(this.f.set($,l),p=!0),p&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,l){const p=this.f.get($);return(0,N.$lg)(p)?l:p}getBoolean($,l){const p=this.get($);return(0,N.$lg)(p)?l:p==="true"}getNumber($,l){const p=this.get($);return(0,N.$lg)(p)?l:parseInt(p,10)}getObject($,l){const p=this.get($);return(0,N.$lg)(p)?l:(0,A.$$h)(p)}async set($,l,p=!1){if(this.c===b.Closed)return;if((0,N.$lg)(l))return this.delete($,p);const S=(0,N.$eg)(l)||Array.isArray(l)?(0,A.$0h)(l):String(l);if(this.f.get($)!==S)return this.f.set($,S),this.j.set($,S),this.h.delete($),this.b.fire({key:$,external:p}),this.D()}async delete($,l=!1){if(!(this.c===b.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:l}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===b.Closed||this.m))return this.D($)}async D($){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$bq=R;class d{constructor(){this.onDidChangeItemsExternal=c.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((l,p)=>this.a.set(p,l)),$.delete?.forEach(l=>this.a.delete(l))}async optimize(){}async close(){}}e.$cq=d}),define(he[11],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=L,e.localize2=N;const I=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function c(O,k){let b;return k.length===0?b=O:b=O.replace(/\{(\d+)\}/g,(R,d)=>{const f=d[0],$=k[f];let l=R;return typeof $=="string"?l=$:(typeof $=="number"||typeof $=="boolean"||$===void 0||$===null)&&(l=String($)),l}),I&&(b="\uFF3B"+b.replace(/[aouei]/g,"$&$&")+"\uFF3D"),b}function L(O,k,...b){return c(typeof O=="number"?A(O,k):k,b)}function A(O,k){const b=globalThis._VSCODE_NLS_MESSAGES?.[O];if(typeof b!="string"){if(typeof k=="string")return k;throw new Error(`!!! NLS MISSING: ${O} !!!`)}return b}function N(O,k,...b){let R;typeof O=="number"?R=A(O,k):R=k;const d=c(R,b);return{value:d,original:k===R?d:c(k,b)}}}),define(he[71],ue([0,1,11]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=b,e.$Zm=R,e.$1m=d;const c=60,L=c*60,A=L*24,N=A*7,O=A*30,k=A*365;function b(f,$,l,p){typeof f!="number"&&(f=f.getTime());const S=Math.round((new Date().getTime()-f)/1e3);if(S<-30)return(0,I.localize)(12817,null,b(new Date().getTime()+S*1e3,!1));if(!p&&S<30)return(0,I.localize)(12818,null);let g;return S<c?(g=S,$?g===1?l?(0,I.localize)(12819,null,g):(0,I.localize)(12820,null,g):l?(0,I.localize)(12821,null,g):(0,I.localize)(12822,null,g):g===1?l?(0,I.localize)(12823,null,g):(0,I.localize)(12824,null,g):l?(0,I.localize)(12825,null,g):(0,I.localize)(12826,null,g)):S<L?(g=Math.floor(S/c),$?g===1?l?(0,I.localize)(12827,null,g):(0,I.localize)(12828,null,g):l?(0,I.localize)(12829,null,g):(0,I.localize)(12830,null,g):g===1?l?(0,I.localize)(12831,null,g):(0,I.localize)(12832,null,g):l?(0,I.localize)(12833,null,g):(0,I.localize)(12834,null,g)):S<A?(g=Math.floor(S/L),$?g===1?l?(0,I.localize)(12835,null,g):(0,I.localize)(12836,null,g):l?(0,I.localize)(12837,null,g):(0,I.localize)(12838,null,g):g===1?l?(0,I.localize)(12839,null,g):(0,I.localize)(12840,null,g):l?(0,I.localize)(12841,null,g):(0,I.localize)(12842,null,g)):S<N?(g=Math.floor(S/A),$?g===1?(0,I.localize)(12843,null,g):(0,I.localize)(12844,null,g):g===1?(0,I.localize)(12845,null,g):(0,I.localize)(12846,null,g)):S<O?(g=Math.floor(S/N),$?g===1?l?(0,I.localize)(12847,null,g):(0,I.localize)(12848,null,g):l?(0,I.localize)(12849,null,g):(0,I.localize)(12850,null,g):g===1?l?(0,I.localize)(12851,null,g):(0,I.localize)(12852,null,g):l?(0,I.localize)(12853,null,g):(0,I.localize)(12854,null,g)):S<k?(g=Math.floor(S/O),$?g===1?l?(0,I.localize)(12855,null,g):(0,I.localize)(12856,null,g):l?(0,I.localize)(12857,null,g):(0,I.localize)(12858,null,g):g===1?l?(0,I.localize)(12859,null,g):(0,I.localize)(12860,null,g):l?(0,I.localize)(12861,null,g):(0,I.localize)(12862,null,g)):(g=Math.floor(S/k),$?g===1?l?(0,I.localize)(12863,null,g):(0,I.localize)(12864,null,g):l?(0,I.localize)(12865,null,g):(0,I.localize)(12866,null,g):g===1?l?(0,I.localize)(12867,null,g):(0,I.localize)(12868,null,g):l?(0,I.localize)(12869,null,g):(0,I.localize)(12870,null,g))}function R(f,$){const l=Math.abs(f/1e3);return l<1?$?(0,I.localize)(12871,null,f):(0,I.localize)(12872,null,f):l<c?$?(0,I.localize)(12873,null,Math.round(f)/1e3):(0,I.localize)(12874,null,Math.round(f)/1e3):l<L?$?(0,I.localize)(12875,null,Math.round(f/(1e3*c))):(0,I.localize)(12876,null,Math.round(f/(1e3*c))):l<A?$?(0,I.localize)(12877,null,Math.round(f/(1e3*L))):(0,I.localize)(12878,null,Math.round(f/(1e3*L))):(0,I.localize)(12879,null,Math.round(f/(1e3*A)))}function d(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[43],ue([0,1,17,12,11]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=k,e.$oj=b,e.$pj=R,I=ke(I),c=ke(c),L=ke(L);function A(d,f){return f&&(d.stack||d.stacktrace)?L.localize(12811,null,O(d),N(d.stack)||N(d.stacktrace)):O(d)}function N(d){return Array.isArray(d)?d.join(`
`):d}function O(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?L.localize(12812,null,d.message):d.message||L.localize(12813,null)}function k(d=null,f=!1){if(!d)return L.localize(12814,null);if(Array.isArray(d)){const $=I.$Gb(d),l=k($[0],f);return $.length>1?L.localize(12815,null,l,$.length):l}if(c.$cg(d))return d;if(d.detail){const $=d.detail;if($.error)return A($.error,f);if($.exception)return A($.exception,f)}return d.stack?A(d,f):d.message?d.message:L.localize(12816,null)}function b(d){const f=d;return f instanceof Error&&Array.isArray(f.actions)}function R(d,f){let $;return typeof d=="string"?$=new Error(d):$=d,$.actions=f,$}}),define(he[151],ue([0,1,11,35]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=L;function L(A){switch(A){case c.ParseErrorCode.InvalidSymbol:return(0,I.localize)(12802,null);case c.ParseErrorCode.InvalidNumberFormat:return(0,I.localize)(12803,null);case c.ParseErrorCode.PropertyNameExpected:return(0,I.localize)(12804,null);case c.ParseErrorCode.ValueExpected:return(0,I.localize)(12805,null);case c.ParseErrorCode.ColonExpected:return(0,I.localize)(12806,null);case c.ParseErrorCode.CommaExpected:return(0,I.localize)(12807,null);case c.ParseErrorCode.CloseBraceExpected:return(0,I.localize)(12808,null);case c.ParseErrorCode.CloseBracketExpected:return(0,I.localize)(12809,null);case c.ParseErrorCode.EndOfFileExpected:return(0,I.localize)(12810,null);default:return""}}}),define(he[72],ue([0,1,32,6,13,12,30,11]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0,e.zip=S,e.$Aq=g,e.$Bq=P,L=ke(L),O=ke(O),e.$xq="end of central directory record signature not found";const k=new RegExp(e.$xq);class b extends Error{constructor(o,h){let i=h.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=h}}e.$yq=b;function R(m){const o=m.externalFileAttributes>>16||33188;return[448,56,7].map(h=>o&h).reduce((h,i)=>h+i,o&61440)}function d(m){if(m instanceof b)return m;let o;return k.test(m.message)&&(o="CorruptZip"),new b(o,m)}function f(m,o,h,i,s,t){const n=L.$lc(o),r=L.$ic(i,n);if(!r.startsWith(i))return Promise.reject(new Error(O.localize(12779,null,o)));const a=L.$ic(i,o);let u;return t.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(I.promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,C)=>{if(!t.isCancellationRequested)try{u=(0,I.createWriteStream)(a,{mode:h}),u.once("close",()=>y()),u.once("error",C),m.once("error",C),m.pipe(u)}catch(v){C(v)}}))}function $(m,o,h,i){let s=(0,c.$ph)(()=>Promise.resolve()),t=0;const n=i.onCancellationRequested(()=>{s.cancel(),m.close()});return new Promise((r,a)=>{const u=new c.$xh,y=C=>{C.isCancellationRequested||(t++,m.readEntry())};m.once("error",a),m.once("close",()=>s.then(()=>{i.isCancellationRequested||m.entryCount===t?r():a(new b("Incomplete",new Error(O.localize(12780,null,t,m.entryCount))))},a)),m.readEntry(),m.on("entry",C=>{if(i.isCancellationRequested)return;if(!h.sourcePathRegex.test(C.fileName)){y(i);return}const v=C.fileName.replace(h.sourcePathRegex,"");if(/\/$/.test(v)){const F=L.$ic(o,v);s=(0,c.$ph)(U=>I.promises.mkdir(F,{recursive:!0}).then(()=>y(U)).then(void 0,a));return}const E=p(m,C),T=R(C);s=(0,c.$ph)(F=>u.queue(()=>E.then(U=>f(U,v,T,o,h,F).then(()=>y(F)))).then(null,a))})}).finally(()=>n.dispose())}async function l(m,o=!1){const{open:h}=await new Promise((i,s)=>{oe(["yauzl"],i,s)}).then(ke);return new Promise((i,s)=>{h(m,o?{lazyEntries:!0}:void 0,(t,n)=>{t?s(d(t)):i((0,A.$ng)(n))})})}function p(m,o){return new Promise((h,i)=>{m.openReadStream(o,(s,t)=>{s?i(d(s)):h((0,A.$ng)(t))})})}async function S(m,o){const{ZipFile:h}=await new Promise((i,s)=>{oe(["yazl"],i,s)}).then(ke);return new Promise((i,s)=>{const t=new h;o.forEach(r=>{r.contents?t.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&t.addFile(r.localPath,r.path)}),t.end();const n=(0,I.createWriteStream)(m);t.outputStream.pipe(n),t.outputStream.once("error",s),n.once("error",s),n.once("finish",()=>i(m))})}function g(m,o,h={},i){const s=new RegExp(h.sourcePath?`^${h.sourcePath}`:"");let t=l(m,!0);return h.overwrite&&(t=t.then(n=>N.Promises.rm(o).then(()=>n))),t.then(n=>$(n,o,{sourcePathRegex:s},i))}function w(m,o){return l(m).then(h=>new Promise((i,s)=>{h.on("entry",t=>{t.fileName===o&&p(h,t).then(n=>i(n),n=>s(n))}),h.once("close",()=>s(new Error(O.localize(12781,null,o))))}))}function P(m,o){return w(m,o).then(h=>new Promise((i,s)=>{const t=[];h.once("error",s),h.on("data",n=>t.push(n)),h.on("end",()=>i(Buffer.concat(t)))}))}}),define(he[152],ue([0,1,39,8,11]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.TokenType=void 0;var A;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(A||(e.TokenType=A={}));function N(...R){switch(R.length){case 1:return(0,L.localize)(11418,null,R[0]);case 2:return(0,L.localize)(11419,null,R[0],R[1]);case 3:return(0,L.localize)(11420,null,R[0],R[1],R[2]);default:return}}const O=(0,L.localize)(11421,null),k=(0,L.localize)(11422,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case A.LParen:return"(";case A.RParen:return")";case A.Neg:return"!";case A.Eq:return d.isTripleEq?"===":"==";case A.NotEq:return d.isTripleEq?"!==":"!=";case A.Lt:return"<";case A.LtEq:return"<=";case A.Gt:return">=";case A.GtEq:return">=";case A.RegexOp:return"=~";case A.RegexStr:return d.lexeme;case A.True:return"true";case A.False:return"false";case A.In:return"in";case A.Not:return"not";case A.And:return"&&";case A.Or:return"||";case A.Str:return d.lexeme;case A.QuotedStr:return d.lexeme;case A.Error:return d.lexeme;case A.EOF:return"EOF";default:throw(0,c.$7)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",A.Not],["in",A.In],["false",A.False],["true",A.True]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case I.CharCode.OpenParen:this.k(A.LParen);break;case I.CharCode.CloseParen:this.k(A.RParen);break;case I.CharCode.ExclamationMark:if(this.h(I.CharCode.Equals)){const f=this.h(I.CharCode.Equals);this.f.push({type:A.NotEq,offset:this.d,isTripleEq:f})}else this.k(A.Neg);break;case I.CharCode.SingleQuote:this.o();break;case I.CharCode.Slash:this.q();break;case I.CharCode.Equals:if(this.h(I.CharCode.Equals)){const f=this.h(I.CharCode.Equals);this.f.push({type:A.Eq,offset:this.d,isTripleEq:f})}else this.h(I.CharCode.Tilde)?this.k(A.RegexOp):this.l(N("==","=~"));break;case I.CharCode.LessThan:this.k(this.h(I.CharCode.Equals)?A.LtEq:A.Lt);break;case I.CharCode.GreaterThan:this.k(this.h(I.CharCode.Equals)?A.GtEq:A.Gt);break;case I.CharCode.Ampersand:this.h(I.CharCode.Ampersand)?this.k(A.And):this.l(N("&&"));break;case I.CharCode.Pipe:this.h(I.CharCode.Pipe)?this.k(A.Or):this.l(N("||"));break;case I.CharCode.Space:case I.CharCode.CarriageReturn:case I.CharCode.Tab:case I.CharCode.LineFeed:case I.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(A.EOF),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?I.CharCode.Null:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const f=this.d,$=this.c.substring(this.d,this.e),l={type:A.Error,offset:this.d,lexeme:$};this.g.push({offset:f,lexeme:$,additionalInfo:d}),this.f.push(l)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const f=this.c.substring(this.d,this.e),$=b.b.get(f);$?this.k($):this.f.push({type:A.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==I.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:A.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,f=!1,$=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(k);return}const p=this.c.charCodeAt(d);if(f)f=!1;else if(p===I.CharCode.Slash&&!$){d++;break}else p===I.CharCode.OpenSquareBracket?$=!0:p===I.CharCode.Backslash?f=!0:p===I.CharCode.CloseSquareBracket&&($=!1);d++}for(;d<this.c.length&&b.a.has(this.c.charCodeAt(d));)d++;this.e=d;const l=this.c.substring(this.d,this.e);this.f.push({type:A.RegexStr,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$xj=b}),define(he[153],ue([0,1,71,87,22,13,37,20,9]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$4m=R,e.$5m=d,e.$2m=/^([^.]+\..+)[:=](.+)$/;class b{get appRoot(){return(0,A.$lc)(L.$Wg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,A.$ic)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,O.$dh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$dh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,I.$1m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$ic)(this.userDataPath,"logs",$)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$dh)(k.URI.file((0,A.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$dh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$dh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$dh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=N.env.VSCODE_PORTABLE;return $?k.URI.file((0,A.$ic)($,"argv.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,A.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,A.$jc)($):(0,A.$gc)((0,A.$ic)(L.$Wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?k.URI.file((0,A.$jc)($)):k.URI.file((0,A.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,A.$jc)($);const l=N.env.VSCODE_EXTENSIONS;if(l)return l;const p=N.env.VSCODE_PORTABLE;return p?(0,A.$ic)(p,"extensions"):(0,O.$dh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(l=>/^[^:/?#]+?:\/\//.test(l)?k.URI.parse(l):k.URI.file((0,A.$gc)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?k.URI.parse($):k.URI.file((0,A.$gc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$2m.test($))}get extensionLogLevel(){const $=[];for(const l of this.args.log||[]){const p=e.$2m.exec(l);p&&p[1]&&p[2]&&$.push([p[1],p[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,O.$dh)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=N.env.VSCODE_PORTABLE;return $?k.URI.file((0,A.$ic)($,"policy.json")):(0,O.$dh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,l,p){this.a=$,this.b=l,this.c=p,this.editSessionId=this.args.editSessionId}}e.$3m=b,ve([c.$7h],b.prototype,"appRoot",null),ve([c.$7h],b.prototype,"userHome",null),ve([c.$7h],b.prototype,"userDataPath",null),ve([c.$7h],b.prototype,"appSettingsHome",null),ve([c.$7h],b.prototype,"tmpDir",null),ve([c.$7h],b.prototype,"cacheHome",null),ve([c.$7h],b.prototype,"stateResource",null),ve([c.$7h],b.prototype,"userRoamingDataHome",null),ve([c.$7h],b.prototype,"userDataSyncHome",null),ve([c.$7h],b.prototype,"sync",null),ve([c.$7h],b.prototype,"machineSettingsResource",null),ve([c.$7h],b.prototype,"workspaceStorageHome",null),ve([c.$7h],b.prototype,"localHistoryHome",null),ve([c.$7h],b.prototype,"keyboardLayoutResource",null),ve([c.$7h],b.prototype,"argvResource",null),ve([c.$7h],b.prototype,"isExtensionDevelopment",null),ve([c.$7h],b.prototype,"untitledWorkspacesHome",null),ve([c.$7h],b.prototype,"builtinExtensionsPath",null),ve([c.$7h],b.prototype,"extensionsPath",null),ve([c.$7h],b.prototype,"extensionDevelopmentLocationURI",null),ve([c.$7h],b.prototype,"extensionDevelopmentKind",null),ve([c.$7h],b.prototype,"extensionTestsLocationURI",null),ve([c.$7h],b.prototype,"debugExtensionHost",null),ve([c.$7h],b.prototype,"logLevel",null),ve([c.$7h],b.prototype,"extensionLogLevel",null),ve([c.$7h],b.prototype,"serviceMachineIdResource",null),ve([c.$7h],b.prototype,"disableTelemetry",null),ve([c.$7h],b.prototype,"disableWorkspaceTrust",null),ve([c.$7h],b.prototype,"useInMemorySecretStorage",null),ve([c.$7h],b.prototype,"policyFile",null);function R(f,$){return d(f["inspect-extensions"],f["inspect-brk-extensions"],5870,$,f.debugId,f.extensionEnvironment)}function d(f,$,l,p,S,g){const P=Number($||f)||(p?null:l),m=P?!!$:!1;let o;if(g)try{o=JSON.parse(g)}catch{}return{port:P,break:m,debugId:S,env:o}}}),function(){"use strict";function oe(e,I,c){function L(N,O){const k=A(N,O),b=[k];return e.isAbsolute(k)||b.unshift(c),e.resolve(...b)}function A(N,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,O);const R=N["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(d,"AppData","Roaming")}break;case"darwin":b=e.join(I.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,O)}return{getUserDataPath:L}}if(typeof define=="function")define(he[154],ue([242,38,37]),function(e,I,c){return oe(e,I,c.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=oe(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[155],ue([0,1,38,153,154]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=void 0,e.$7m=N,e.$8m=O;class A extends c.$3m{constructor(b,R){super(b,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,L.getUserDataPath)(b,R.nameShort)},R)}}e.$6m=A;function N(k,b){return(0,c.$5m)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,b,k.extensionEnvironment)}function O(k,b){return(0,c.$5m)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,b,k.extensionEnvironment)}}),define(he[156],ue([0,1,12,11]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=L;function L(N,O,k,b){try{A(N,O,k,b)}catch(R){N.error(R?.message??R)}return O}function A(N,O,k,b){const R=(d,f,$)=>{const l=d[f];if((0,I.$cg)(l)){const p=l,S=p.length;if(S>1&&p[0]==="%"&&p[S-1]==="%"){const g=p.substr(1,S-2);let w=k[g];w===void 0&&b&&(w=b[g]);const P=typeof w=="string"?w:w?.message,m=b?.[g],o=typeof m=="string"?m:m?.message;if(!P){o||N.warn(`[${O.name}]: ${(0,c.localize)(11301,null,g)}`);return}if($&&(f==="title"||f==="category")&&o&&o!==P){const h={value:P,original:o};d[f]=h}else d[f]=P}}else if((0,I.$eg)(l))for(const p in l)l.hasOwnProperty(p)&&(p==="commands"?R(l,p,!0):R(l,p,$));else if(Array.isArray(l))for(let p=0;p<l.length;p++)R(l,p,$)};for(const d in O)O.hasOwnProperty(d)&&R(O,d)}}),define(he[157],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=e.$Jhc=void 0;class I{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Jhc=I;class c{constructor(A){this.a=A}listen(A,N){throw new Error(`Event not found: ${N}`)}call(A,N,O){switch(N){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(O[0])}throw new Error(`Call not found: ${N}`)}}e.$Khc=c}),define(he[158],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const I={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(I)}),define(he[73],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=void 0;class I{constructor(L,A=[],N=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=N}}e.$zi=I}),define(he[159],ue([0,1,73]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Os=A,e.$Ps=N;const c=[];var L;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(O,k,b){k instanceof I.$zi||(k=new I.$zi(k,[],!!b)),c.push([O,k])}function N(){return c}}),define(he[160],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=void 0;class I{constructor(A,N){this.key=A,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$rr=I;class c{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const N of this.a.values())N.outgoing.size===0&&A.push(N);return A}insertEdge(A,N){const O=this.lookupOrInsertNode(A),k=this.lookupOrInsertNode(N);O.outgoing.set(k.key,k),k.incoming.set(O.key,O)}removeNode(A){const N=this.b(A);this.a.delete(N);for(const O of this.a.values())O.outgoing.delete(N),O.incoming.delete(N)}lookupOrInsertNode(A){const N=this.b(A);let O=this.a.get(N);return O||(O=new I(N,A),this.a.set(N,O)),O}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[N,O]of this.a)A.push(`${N}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,N]of this.a){const O=new Set([A]),k=this.c(N,O);if(k)return k}}c(A,N){for(const[O,k]of A.outgoing){if(N.has(O))return[...N,O].join(" -> ");N.add(O);const b=this.c(k,N);if(b)return b;N.delete(O)}}}e.$sr=c}),define(he[4],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e._util=void 0,e.$Ci=L,e.$Di=A;var I;(function(N){N.serviceIds=new Map,N.DI_TARGET="$di$target",N.DI_DEPENDENCIES="$di$dependencies";function O(k){return k[N.DI_DEPENDENCIES]||[]}N.getServiceDependencies=O})(I||(e._util=I={})),e.$Bi=L("instantiationService");function c(N,O,k){O[I.DI_TARGET]===O?O[I.DI_DEPENDENCIES].push({id:N,index:k}):(O[I.DI_DEPENDENCIES]=[{id:N,index:k}],O[I.DI_TARGET]=O)}function L(N){if(I.serviceIds.has(N))return I.serviceIds.get(N);const O=function(k,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");c(O,k,R)};return O.toString=()=>N,I.serviceIds.set(N,O),O}function A(N){return N}}),define(he[161],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0,e.$jhc=(0,I.$Ci)("checksumService")}),define(he[21],ue([0,1,12,9,4]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$9i=void 0,e.$0i=A,e.$$i=N,e.$_i=k,e.$aj=b,e.$bj=R,e.$cj=d,e.$dj=f,e.$ej=l,e.$fj=p,e.$gj=S,I=ke(I),e.$9i=(0,L.$Ci)("configurationService");function A(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof c.URI)}function N(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof c.URI)}var O;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function k(g){switch(g){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function b(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function R(g,w){const P=Object.create(null);for(const m in g)d(P,m,g[m],w);return P}function d(g,w,P,m){const o=w.split("."),h=o.pop();let i=g;for(let s=0;s<o.length;s++){const t=o[s];let n=i[t];switch(typeof n){case"undefined":n=i[t]=Object.create(null);break;case"object":if(n===null){m(`Ignoring ${w} as ${o.slice(0,s+1).join(".")} is null`);return}break;default:m(`Ignoring ${w} as ${o.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[h]=P}catch{m(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(i)}`)}else m(`Ignoring ${w} as ${o.join(".")} is ${JSON.stringify(i)}`)}function f(g,w){const P=w.split(".");$(g,P)}function $(g,w){const P=w.shift();if(w.length===0){delete g[P];return}if(Object.keys(g).indexOf(P)!==-1){const m=g[P];typeof m=="object"&&!Array.isArray(m)&&($(m,w),Object.keys(m).length===0&&delete g[P])}}function l(g,w,P){function m(i,s){let t=i;for(const n of s){if(typeof t!="object"||t===null)return;t=t[n]}return t}const o=w.split("."),h=m(g,o);return typeof h>"u"?P:h}function p(g,w,P){Object.keys(w).forEach(m=>{m!=="__proto__"&&(m in g?I.$eg(g[m])&&I.$eg(w[m])?p(g[m],w[m],P):P&&(g[m]=w[m]):g[m]=w[m])})}function S(g){return g.replace(/[\[\]]/g,"")}}),define(he[96],ue([0,1,39,5,26,152,4,11,8]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Aj=e.$zj=e.ContextKeyExprType=void 0,e.$yj=R,e.$Bj=s,e.$Cj=t,e.$Vj=te;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",c.$k),b.set("isLinux",c.$l),b.set("isWindows",c.$j),b.set("isWeb",c.$p),b.set("isMacNative",c.$k&&!c.$p),b.set("isEdge",c.$I),b.set("isFirefox",c.$G),b.set("isChrome",c.$F),b.set("isSafari",c.$H);function R(B,D){if(b.get(B)!==void 0)throw(0,k.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(B,D)}const d=Object.prototype.hasOwnProperty;var f;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const $={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(11432,null),p=(0,O.localize)(11433,null),S=(0,O.localize)(11434,null),g=(0,O.localize)(11435,null),w=(0,O.localize)(11436,null),P=(0,O.localize)(11437,null),m=(0,O.localize)(11438,null),o=(0,O.localize)(11439,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=$){this.k=D,this.d=new A.$xj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const q=this.D(),M=q.type===A.TokenType.Str?P:void 0;throw this.h.push({message:w,offset:q.offset,lexeme:A.$xj.getLexeme(q),additionalInfo:M}),h.c}return J}catch(J){if(J!==h.c)throw J;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(A.TokenType.Or);){const J=this.o();D.push(J)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(A.TokenType.And);){const J=this.s();D.push(J)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(A.TokenType.Neg)){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),r.INSTANCE;case A.TokenType.False:return this.z(),a.INSTANCE;case A.TokenType.LParen:{this.z();const J=this.l();return this.A(A.TokenType.RParen,g),J?.negate()}case A.TokenType.Str:return this.z(),T.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case A.TokenType.True:return this.z(),i.true();case A.TokenType.False:return this.z(),i.false();case A.TokenType.LParen:{this.z();const J=this.l();return this.A(A.TokenType.RParen,g),J}case A.TokenType.Str:{const J=D.lexeme;if(this.z(),this.y(A.TokenType.RegexOp)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==A.TokenType.RegexStr)throw this.B("REGEX",M);const Z=M.lexeme,ee=Z.lastIndexOf("/"),X=ee===Z.length-1?void 0:this.w(Z.substring(ee+1));let re;try{re=new RegExp(Z.substring(1,ee),X)}catch{throw this.B("REGEX",M)}return x.create(J,re)}switch(M.type){case A.TokenType.RegexStr:case A.TokenType.Error:{const Z=[M.lexeme];this.z();let ee=this.D(),X=0;for(let Ee=0;Ee<M.lexeme.length;Ee++)M.lexeme.charCodeAt(Ee)===I.CharCode.OpenParen?X++:M.lexeme.charCodeAt(Ee)===I.CharCode.CloseParen&&X--;for(;!this.E()&&ee.type!==A.TokenType.And&&ee.type!==A.TokenType.Or;){switch(ee.type){case A.TokenType.LParen:X++;break;case A.TokenType.RParen:X--;break;case A.TokenType.RegexStr:case A.TokenType.QuotedStr:for(let Ee=0;Ee<ee.lexeme.length;Ee++)ee.lexeme.charCodeAt(Ee)===I.CharCode.OpenParen?X++:M.lexeme.charCodeAt(Ee)===I.CharCode.CloseParen&&X--}if(X<0)break;Z.push(A.$xj.getLexeme(ee)),this.z(),ee=this.D()}const re=Z.join(""),le=re.lastIndexOf("/"),ge=le===re.length-1?void 0:this.w(re.substring(le+1));let pe;try{pe=new RegExp(re.substring(1,le),ge)}catch{throw this.B("REGEX",M)}return i.regex(J,pe)}case A.TokenType.QuotedStr:{const Z=M.lexeme;this.z();let ee=null;if(!(0,L.$af)(Z)){const X=Z.indexOf("/"),re=Z.lastIndexOf("/");if(X!==re&&X>=0){const le=Z.slice(X+1,re),ge=Z[re+1]==="i"?"i":"";try{ee=new RegExp(le,ge)}catch{throw this.B("REGEX",M)}}}if(ee===null)throw this.B("REGEX",M);return x.create(J,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(A.TokenType.Not)){this.A(A.TokenType.In,S);const M=this.u();return i.notIn(J,M)}switch(this.D().type){case A.TokenType.Eq:{this.z();const M=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.equals(J,M);switch(M){case"true":return i.has(J);case"false":return i.not(J);default:return i.equals(J,M)}}case A.TokenType.NotEq:{this.z();const M=this.u();if(this.x().type===A.TokenType.QuotedStr)return i.notEquals(J,M);switch(M){case"true":return i.not(J);case"false":return i.has(J);default:return i.notEquals(J,M)}}case A.TokenType.Lt:return this.z(),K.create(J,this.u());case A.TokenType.LtEq:return this.z(),V.create(J,this.u());case A.TokenType.Gt:return this.z(),U.create(J,this.u());case A.TokenType.GtEq:return this.z(),j.create(J,this.u());case A.TokenType.In:return this.z(),i.in(J,this.u());default:return i.has(J)}}case A.TokenType.EOF:throw this.h.push({message:m,offset:D.offset,lexeme:"",additionalInfo:o}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case A.TokenType.Str:case A.TokenType.QuotedStr:return this.z(),D.lexeme;case A.TokenType.True:return this.z(),"true";case A.TokenType.False:return this.z(),"false";case A.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,J){if(this.C(D))return this.z();throw this.B(J,this.D())}B(D,J,q){const M=(0,O.localize)(11440,null,D,A.$xj.getLexeme(J)),Z=J.offset,ee=A.$xj.getLexeme(J);return this.h.push({message:M,offset:Z,lexeme:ee,additionalInfo:q}),h.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===A.TokenType.EOF}}e.$zj=h;class i{static false(){return r.INSTANCE}static true(){return a.INSTANCE}static has(D){return u.create(D)}static equals(D,J){return y.create(D,J)}static notEquals(D,J){return E.create(D,J)}static regex(D,J){return x.create(D,J)}static in(D,J){return C.create(D,J)}static notIn(D,J){return v.create(D,J)}static not(D){return T.create(D)}static and(...D){return W.create(D,null,!0)}static or(...D){return z.create(D,null,!0)}static greater(D,J){return U.create(D,J)}static greaterEquals(D,J){return j.create(D,J)}static smaller(D,J){return K.create(D,J)}static smallerEquals(D,J){return V.create(D,J)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Aj=i;function s(B){const D=new h({regexParsingWithErrorRecovery:!1});return B.map(J=>(D.parse(J),D.lexingErrors.length>0?D.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,O.localize)(11441,null,q.additionalInfo):(0,O.localize)(11442,null),offset:q.offset,length:q.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}function t(B,D){const J=B?B.substituteConstants():void 0,q=D?D.substituteConstants():void 0;return!J&&!q?!0:!J||!q?!1:J.equals(q)}function n(B,D){return B.cmp(D)}class r{static{this.INSTANCE=new r}constructor(){this.type=f.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return a.INSTANCE}}e.$Dj=r;class a{static{this.INSTANCE=new a}constructor(){this.type=f.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$Ej=a;class u{static create(D,J=null){const q=b.get(D);return typeof q=="boolean"?q?a.INSTANCE:r.INSTANCE:new u(D,J)}constructor(D,J){this.key=D,this.c=J,this.type=f.Defined}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=b.get(this.key);return typeof D=="boolean"?D?a.INSTANCE:r.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$Fj=u;class y{static create(D,J,q=null){if(typeof J=="boolean")return J?u.create(D,q):T.create(D,q);const M=b.get(D);return typeof M=="boolean"?J===(M?"true":"false")?a.INSTANCE:r.INSTANCE:new y(D,J,q)}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=f.Equals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?a.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Gj=y;class C{static create(D,J){return new C(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=f.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.f),q=D.getValue(this.d);return Array.isArray(J)?J.includes(q):typeof q=="string"&&typeof J=="object"&&J!==null?d.call(J,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Hj=C;class v{static create(D,J){return new v(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=f.NotIn,this.c=C.create(D,J)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ij=v;class E{static create(D,J,q=null){if(typeof J=="boolean")return J?T.create(D,q):u.create(D,q);const M=b.get(D);return typeof M=="boolean"?J===(M?"true":"false")?r.INSTANCE:a.INSTANCE:new E(D,J,q)}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=f.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=b.get(this.c);if(typeof D=="boolean"){const J=D?"true":"false";return this.d===J?r.INSTANCE:a.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Jj=E;class T{static create(D,J=null){const q=b.get(D);return typeof q=="boolean"?q?r.INSTANCE:a.INSTANCE:new T(D,J)}constructor(D,J){this.c=D,this.d=J,this.type=f.Not}cmp(D){return D.type!==this.type?this.type-D.type:ne(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=b.get(this.c);return typeof D=="boolean"?D?r.INSTANCE:a.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Kj=T;function F(B,D){if(typeof B=="string"){const J=parseFloat(B);isNaN(J)||(B=J)}return typeof B=="string"||typeof B=="number"?D(B):r.INSTANCE}class U{static create(D,J,q=null){return F(J,M=>new U(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=f.Greater}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Lj=U;class j{static create(D,J,q=null){return F(J,M=>new j(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=f.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Mj=j;class K{static create(D,J,q=null){return F(J,M=>new K(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=f.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Nj=K;class V{static create(D,J,q=null){return F(J,M=>new V(D,M,q))}constructor(D,J,q){this.c=D,this.d=J,this.f=q,this.type=f.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Oj=V;class x{static create(D,J){return new x(D,J)}constructor(D,J){this.d=D,this.f=J,this.type=f.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const J=this.f?this.f.source:"",q=D.f?D.f.source:"";return J<q?-1:J>q?1:0}equals(D){if(D.type===this.type){const J=this.f?this.f.source:"",q=D.f?D.f.source:"";return this.d===D.d&&J===q}return!1}substituteConstants(){return this}evaluate(D){const J=D.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Pj=x;class H{static create(D){return new H(D)}constructor(D){this.c=D,this.type=f.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new H(this.c.map(D))}negate(){return this.c}}e.$Qj=H;function ie(B){let D=null;for(let J=0,q=B.length;J<q;J++){const M=B[J].substituteConstants();if(B[J]!==M&&D===null){D=[];for(let Z=0;Z<J;Z++)D[Z]=B[Z]}D!==null&&(D[J]=M)}return D===null?B:D}class W{static create(D,J,q){return W.d(D,J,q)}constructor(D,J){this.expr=D,this.c=J,this.type=f.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,q=this.expr.length;J<q;J++){const M=n(this.expr[J],D.expr[J]);if(M!==0)return M}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:W.create(D,this.c,!1)}evaluate(D){for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].evaluate(D))return!1;return!0}static d(D,J,q){const M=[];let Z=!1;for(const ee of D)if(ee){if(ee.type===f.True){Z=!0;continue}if(ee.type===f.False)return r.INSTANCE;if(ee.type===f.And){M.push(...ee.expr);continue}M.push(ee)}if(M.length===0&&Z)return a.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let ee=1;ee<M.length;ee++)M[ee-1].equals(M[ee])&&(M.splice(ee,1),ee--);if(M.length===1)return M[0];for(;M.length>1;){const ee=M[M.length-1];if(ee.type!==f.Or)break;M.pop();const X=M.pop(),re=M.length===0,le=z.create(ee.expr.map(ge=>W.create([ge,X],null,q)),null,re);le&&(M.push(le),M.sort(n))}if(M.length===1)return M[0];if(q){for(let ee=0;ee<M.length;ee++)for(let X=ee+1;X<M.length;X++)if(M[ee].negate().equals(M[X]))return r.INSTANCE;if(M.length===1)return M[0]}return new W(M,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new W(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());this.c=z.create(D,this,!0)}return this.c}}e.$Rj=W;class z{static create(D,J,q){return z.d(D,J,q)}constructor(D,J){this.expr=D,this.c=J,this.type=f.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let J=0,q=this.expr.length;J<q;J++){const M=n(this.expr[J],D.expr[J]);if(M!==0)return M}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let J=0,q=this.expr.length;J<q;J++)if(!this.expr[J].equals(D.expr[J]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let J=0,q=this.expr.length;J<q;J++)if(this.expr[J].evaluate(D))return!0;return!1}static d(D,J,q){let M=[],Z=!1;if(D){for(let ee=0,X=D.length;ee<X;ee++){const re=D[ee];if(re){if(re.type===f.False){Z=!0;continue}if(re.type===f.True)return a.INSTANCE;if(re.type===f.Or){M=M.concat(re.expr);continue}M.push(re)}}if(M.length===0&&Z)return r.INSTANCE;M.sort(n)}if(M.length!==0){if(M.length===1)return M[0];for(let ee=1;ee<M.length;ee++)M[ee-1].equals(M[ee])&&(M.splice(ee,1),ee--);if(M.length===1)return M[0];if(q){for(let ee=0;ee<M.length;ee++)for(let X=ee+1;X<M.length;X++)if(M[ee].negate().equals(M[X]))return a.INSTANCE;if(M.length===1)return M[0]}return new z(M,J)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const J of this.expr)D.push(...J.keys());return D}map(D){return new z(this.expr.map(J=>J.map(D)),null)}negate(){if(!this.c){const D=[];for(const J of this.expr)D.push(J.negate());for(;D.length>1;){const J=D.shift(),q=D.shift(),M=[];for(const Z of G(J))for(const ee of G(q))M.push(W.create([Z,ee],null,!1));D.unshift(z.create(M,null,!1))}this.c=z.create(D,this,!0)}return this.c}}e.$Sj=z;class _ extends u{static{this.d=[]}static all(){return _.d.values()}constructor(D,J,q){super(D,null),this.f=J,typeof q=="object"?_.d.push({...q,key:D}):q!==!0&&_.d.push({key:D,description:q,type:J!=null?typeof J:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return E.create(this.key,D)}}e.$Tj=_,e.$Uj=(0,N.$Ci)("contextKeyService");function ne(B,D){return B<D?-1:B>D?1:0}function ce(B,D,J,q){return B<J?-1:B>J?1:D<q?-1:D>q?1:0}function te(B,D){if(B.type===f.False||D.type===f.True)return!0;if(B.type===f.Or)return D.type===f.Or?Y(B.expr,D.expr):!1;if(D.type===f.Or){for(const J of D.expr)if(te(B,J))return!0;return!1}if(B.type===f.And){if(D.type===f.And)return Y(D.expr,B.expr);for(const J of B.expr)if(te(J,D))return!0;return!1}return B.equals(D)}function Y(B,D){let J=0,q=0;for(;J<B.length&&q<D.length;){const M=B[J].cmp(D[q]);if(M<0)return!1;M===0&&J++,q++}return J===B.length}function G(B){return B.type===f.Or?B.expr:[B]}}),define(he[97],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Qm=e.ID=void 0,e.$Rm=c,e.ID="diagnosticsService",e.$Qm=(0,I.$Ci)(e.ID);function c(A){return!!A.hostName&&!!A.errorMessage}class L{async getPerformanceInfo(N,O){return{}}async getSystemInfo(N,O){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(N,O){return""}async getWorkspaceFileExtensions(N){return{extensions:[]}}async reportWorkspaceStats(N){}}e.$Sm=L}),define(he[98],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=void 0,e.$Yo=(0,I.$Ci)("downloadService")}),define(he[15],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=void 0,e.$Ji=(0,I.$Ci)("environmentService"),e.$Ki=(0,I.$Di)(e.$Ji)}),define(he[74],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$H6b=L;var c;(function(N){N[N.FILE=1]="FILE",N[N.WORKSPACE=2]="WORKSPACE",N[N.EXE=3]="EXE"})(c||(e.RecommendationSource=c={}));function L(N){switch(N){case c.FILE:return"file";case c.WORKSPACE:return"workspace";case c.EXE:return"exe"}}var A;(function(N){N.Ignored="ignored",N.Cancelled="cancelled",N.TooMany="toomany",N.IncompatibleWindow="incompatibleWindow",N.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$I6b=(0,I.$Ci)("IExtensionRecommendationNotificationService")}),define(he[7],ue([0,1,51,13,26,12,9,11,4,5,22,53]),function(oe,e,I,c,L,A,N,O,k,b,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$Cl=e.FileKind=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.FileOperationResult=e.$ul=e.$tl=e.$sl=e.$ql=e.FileChangeType=e.$pl=e.FileOperation=e.$jl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$0k=void 0,e.$$k=f,e.$_k=S,e.$al=w,e.$bl=P,e.$cl=m,e.$dl=o,e.$el=h,e.$fl=i,e.$gl=s,e.$hl=t,e.$il=n,e.$kl=u,e.$ll=y,e.$ml=C,e.$nl=v,e.$ol=E,e.$rl=K,e.$Dl=z,e.$El=_,e.$Gl=ce,e.$0k=(0,k.$Ci)("fileService");function f(te){return te.create===!0}var $;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var l;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(l||(e.FilePermission=l={}));var p;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function S(te){const Y=te;return!!Y&&typeof Y.onDidChange=="function"}var g;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function w(te){return!!(te.capabilities&g.FileReadWrite)}function P(te){return!!(te.capabilities&g.FileFolderCopy)}function m(te){return!!(te.capabilities&g.FileClone)}function o(te){return!!(te.capabilities&g.FileOpenReadWriteClose)}function h(te){return!!(te.capabilities&g.FileReadStream)}function i(te){return w(te)?!!(te.capabilities&g.FileAtomicRead):!1}function s(te){return w(te)?!!(te.capabilities&g.FileAtomicWrite):!1}function t(te){return!!(te.capabilities&g.FileAtomicDelete)}function n(te){return!!(te.capabilities&g.Readonly)}var r;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class a extends Error{static create(Y,G){const B=new a(Y.toString(),G);return C(B,G),B}constructor(Y,G){super(Y),this.code=G}}e.$jl=a;function u(te,Y){return a.create(te,Y)}function y(te){return te||u((0,O.localize)(11219,null),r.Unknown)}function C(te,Y){return te.name=Y?`${Y} (FileSystemError)`:"FileSystemError",te}function v(te){if(!te)return r.Unknown;if(te instanceof a)return te.code;const Y=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Y)return r.Unknown;switch(Y[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}function E(te){if(te instanceof V)return te.fileOperationResult;switch(v(te)){case r.FileNotFound:return ie.FILE_NOT_FOUND;case r.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case r.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case r.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case r.NoPermissions:return ie.FILE_PERMISSION_DENIED;case r.FileExists:return ie.FILE_MOVE_CONFLICT;case r.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var T;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class F{constructor(Y,G,B){this.resource=Y,this.operation=G,this.target=B}isOperation(Y){return this.operation===Y}}e.$pl=F;var U;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class j{static{this.a=null}constructor(Y,G){this.c=G,this.b=void 0,this.d=new d.$T(()=>{const B=I.$Ii.forUris(()=>this.c);return B.fill(this.rawAdded.map(D=>[D,!0])),B}),this.f=new d.$T(()=>{const B=I.$Ii.forUris(()=>this.c);return B.fill(this.rawUpdated.map(D=>[D,!0])),B}),this.g=new d.$T(()=>{const B=I.$Ii.forUris(()=>this.c);return B.fill(this.rawDeleted.map(D=>[D,!0])),B}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const B of Y){switch(B.type){case U.ADDED:this.rawAdded.push(B.resource);break;case U.UPDATED:this.rawUpdated.push(B.resource);break;case U.DELETED:this.rawDeleted.push(B.resource);break}this.b!==j.a&&(typeof B.cId=="number"?this.b===void 0?this.b=B.cId:this.b!==B.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(Y,...G){return this.h(Y,{includeChildren:!1},...G)}affects(Y,...G){return this.h(Y,{includeChildren:!0},...G)}h(Y,G,...B){if(!Y)return!1;const D=B.length>0;return!!((!D||B.includes(U.ADDED))&&(this.d.value.get(Y)||G.includeChildren&&this.d.value.findSuperstr(Y))||(!D||B.includes(U.UPDATED))&&(this.f.value.get(Y)||G.includeChildren&&this.f.value.findSuperstr(Y))||(!D||B.includes(U.DELETED))&&(this.g.value.findSubstr(Y)||G.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}e.$ql=j;function K(te,Y,G){return!te||!Y||te===Y||Y.length>te.length?!1:(Y.charAt(Y.length-1)!==c.sep&&(Y+=c.sep),G?(0,L.$Ef)(te,Y):te.indexOf(Y)===0)}class V extends Error{constructor(Y,G,B){super(Y),this.fileOperationResult=G,this.options=B}}e.$sl=V;class x extends V{constructor(Y,G,B,D){super(Y,G,D),this.fileOperationResult=G,this.size=B}}e.$tl=x;class H extends V{constructor(Y,G,B){super(Y,ie.FILE_NOT_MODIFIED_SINCE,B),this.stat=G}}e.$ul=H;var ie;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$vl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xl="files.associations",e.$yl="files.exclude",e.$zl="files.readonlyInclude",e.$Al="files.readonlyExclude",e.$Bl="files.readonlyFromPermissions";var W;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.$Cl="";function z(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function _(te,Y){if(!Y.hasProvider(N.URI.from({scheme:te.scheme})))return new Promise(G=>{const B=Y.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===te.scheme&&D.added&&(B.dispose(),G())})})}class ne{static{this.KB=1024}static{this.MB=ne.KB*ne.KB}static{this.GB=ne.MB*ne.KB}static{this.TB=ne.GB*ne.KB}static formatSize(Y){return(0,A.$gg)(Y)||(Y=0),Y<ne.KB?(0,O.localize)(11220,null,Y.toFixed(0)):Y<ne.MB?(0,O.localize)(11221,null,(Y/ne.KB).toFixed(2)):Y<ne.GB?(0,O.localize)(11222,null,(Y/ne.MB).toFixed(2)):Y<ne.TB?(0,O.localize)(11223,null,(Y/ne.GB).toFixed(2)):(0,O.localize)(11224,null,(Y/ne.TB).toFixed(2))}}e.$Fl=ne;function ce(te){const Y=typeof te=="string"||te?.scheme===R.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===R.Schemas.file?1024*ne.MB:Y?10*ne.MB:b.$p?50*ne.MB:1024*ne.MB}});var Q=this&&this.__param||function(oe,e){return function(I,c){e(I,c,oe)}};define(he[162],ue([0,1,75,50,7]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;let A=class{constructor(O){this.a=O}async checksum(O){const k=(await this.a.readFileStream(O)).value;return new Promise((b,R)=>{const d=(0,I.createHash)("sha256");(0,c.$De)(k,{onData:f=>d.update(f.buffer),onError:f=>R(f),onEnd:()=>b(d.digest("base64").replace(/=+$/,""))})})}};e.$khc=A,e.$khc=A=ve([Q(0,L.$0k)],A)}),define(he[99],ue([0,1,14,8,11,7]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=N;async function N(R,d,f,$,l,p){let S;try{await O(R,d,f,$,l,p)}catch(g){S=g}finally{S&&l.errorTransformer&&(S=l.errorTransformer(S)),typeof S<"u"&&f.error(S),f.end()}}async function O(R,d,f,$,l,p){k(p);const S=await R.open(d,{create:!1});try{k(p);let g=0,w=0,P=l&&typeof l.length=="number"?l.length:void 0,m=I.$Le.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),o=l&&typeof l.position=="number"?l.position:0,h=0;do w=await R.read(S,o,m.buffer,h,m.byteLength-h),o+=w,h+=w,g+=w,typeof P=="number"&&(P-=w),h===m.byteLength&&(await f.write($(m)),m=I.$Le.alloc(Math.min(l.bufferSize,typeof P=="number"?P:l.bufferSize)),h=0);while(w>0&&(typeof P!="number"||P>0)&&k(p)&&b(g,l));if(h>0){let i=h;typeof P=="number"&&(i=Math.min(h,P)),f.write($(m.slice(0,i)))}}catch(g){throw(0,A.$ll)(g)}finally{await R.close(S)}}function k(R){if(R.isCancellationRequested)throw(0,c.$5)();return!0}function b(R,d){if(typeof d?.limits?.size=="number"&&R>d.limits.size)throw(0,A.$kl)((0,L.localize)(11218,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(he[46],ue([0,1,93,2,13,5,9,7]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=e.$3q=void 0,e.$1q=k,e.$2q=b,e.$6q=$,e.$7q=l,e.$8q=p,e.$9q=S,e.$0q=w,e.$$q=P;function k(m){return typeof m.correlationId=="number"}function b(m){return m.recursive===!0}class R extends c.$Tc{static{this.a=5}constructor(o,h,i,s){super(),this.h=o,this.j=h,this.m=i,this.n=s,this.c=this.B(new c.$Uc),this.f=void 0,this.g=0}s(){const o=new c.$Sc;this.c.value=o,this.b=this.r(o),this.b.setVerboseLogging(this.m),o.add(this.b.onDidChangeFile(h=>this.h(h))),o.add(this.b.onDidLogMessage(h=>this.j(h))),o.add(this.b.onDidError(h=>this.t(h.error,h.request)))}t(o,h){this.u(o,h)?this.g<R.a&&this.f?(this.y(`restarting watcher after unexpected error: ${o}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${o}`):this.y(o)}u(o,h){return!(!this.n.restartOnError||h||o.indexOf("No space left on device")!==-1||o.indexOf("EMFILE")!==-1)}w(o){this.g++,this.s(),this.watch(o)}async watch(o){this.f=o,await this.b?.watch(o)}async setVerboseLogging(o){this.m=o,await this.b?.setVerboseLogging(o)}y(o){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${o}`})}z(o){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${o}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3q=R;class d extends R{constructor(o,h,i){super(o,h,i,{type:"node.js",restartOnError:!1})}}e.$4q=d;class f extends R{constructor(o,h,i){super(o,h,i,{type:"universal",restartOnError:!0})}}e.$5q=f;function $(m){return m.map(o=>({type:o.type,resource:N.URI.revive(o.resource),cId:o.cId}))}function l(m){const o=new g;for(const h of m)o.processEvent(h);return o.coalesce()}function p(m,o){return typeof o=="string"&&!o.startsWith(I.$tk)&&!(0,L.$hc)(o)?{base:m,pattern:o}:o}function S(m,o){const h=[];for(const i of o)h.push((0,I.$xk)(p(m,i)));return h}class g{constructor(){this.a=new Set,this.b=new Map}c(o){return A.$l?o.resource.fsPath:o.resource.fsPath.toLowerCase()}processEvent(o){const h=this.b.get(this.c(o));let i=!1;if(h){const s=h.type,t=o.type;h.resource.fsPath!==o.resource.fsPath&&(o.type===O.FileChangeType.DELETED||o.type===O.FileChangeType.ADDED)?i=!0:s===O.FileChangeType.ADDED&&t===O.FileChangeType.DELETED?(this.b.delete(this.c(o)),this.a.delete(h)):s===O.FileChangeType.DELETED&&t===O.FileChangeType.ADDED?h.type=O.FileChangeType.UPDATED:s===O.FileChangeType.ADDED&&t===O.FileChangeType.UPDATED||(h.type=t)}else i=!0;i&&(this.a.add(o),this.b.set(this.c(o),o))}coalesce(){const o=[],h=[];return Array.from(this.a).filter(i=>i.type!==O.FileChangeType.DELETED?(o.push(i),!1):!0).sort((i,s)=>i.resource.fsPath.length-s.resource.fsPath.length).filter(i=>h.some(s=>(0,O.$rl)(i.resource.fsPath,s,!A.$l))?!1:(h.push(i.resource.fsPath),!0)).concat(o)}}function w(m,o){if(typeof o=="number")switch(m.type){case O.FileChangeType.ADDED:return(o&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(o&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(o&O.FileChangeFilter.UPDATED)===0}return!1}function P(m){if(typeof m=="number"){const o=[];return m&O.FileChangeFilter.ADDED&&o.push("Added"),m&O.FileChangeFilter.DELETED&&o.push("Deleted"),m&O.FileChangeFilter.UPDATED&&o.push("Updated"),o.length===0?"<all>":`[${o.join(", ")}]`}return"<none>"}}),define(he[163],ue([0,1,14,43,8,3,2,50,31,7,46]),function(oe,e,I,c,L,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=e.$$Q=void 0,e.$$Q="localFilesystem";class d extends N.$Tc{constructor($,l){super(),this.a=$,this.b=l,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$je),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$je),this.onDidWatchError=this.g.event,this.h=(0,k.$Yg)(),this.j()}get capabilities(){return this.c||(this.c=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=b.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=b.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,l){const{buffer:p}=await this.a.call("readFile",[$,l]);return p}readFileStream($,l,p){const S=(0,O.$ze)(w=>I.$Le.concat(w.map(P=>I.$Le.wrap(P))).buffer),g=new N.$Sc;return g.add(this.a.listen("readFileStream",[$,l])(w=>{if(w instanceof I.$Le)S.write(w.buffer);else{if(w==="end")S.end();else{let P;if(w instanceof Error)P=w;else{const m=w;P=(0,b.$kl)(m.message??(0,c.$nj)(m),m.code??b.FileSystemProviderErrorCode.Unknown)}S.error(P),S.end()}g.dispose()}})),g.add(p.onCancellationRequested(()=>{S.error((0,L.$5)()),S.end(),g.dispose()})),S}writeFile($,l,p){return this.a.call("writeFile",[$,I.$Le.wrap(l),p])}open($,l){return this.a.call("open",[$,l])}close($){return this.a.call("close",[$])}async read($,l,p,S,g){const[w,P]=await this.a.call("read",[$,l,g]);return p.set(w.buffer.slice(0,P),S),P}write($,l,p,S,g){return this.a.call("write",[$,l,I.$Le.wrap(p),S,g])}mkdir($){return this.a.call("mkdir",[$])}delete($,l){return this.a.call("delete",[$,l])}rename($,l,p){return this.a.call("rename",[$,l,p])}copy($,l,p){return this.a.call("copy",[$,l,p])}cloneFile($,l){return this.a.call("cloneFile",[$,l])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const l=$;this.f.fire((0,R.$6q)(l))}else{const l=$;this.g.fire(l)}}))}watch($,l){const p=(0,k.$Yg)();return this.a.call("watch",[this.h,p,$,l]),(0,N.$Rc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$_Q=d}),define(he[164],ue([0,1,32,2,46,3,7,9,6]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class b extends c.$Tc{constructor(){super(),this.a=this.B(new A.$je),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$je),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$je),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new c.$3c),this.m=new Set,this.n=this.B(new k.$Ah(this.y())),this.r=5007,this.s=new k.$Zh,this.R=!1,this.B(this.f(d=>this.t(d)))}t(d){this.u(d)&&this.z(d)}u(d){return(0,L.$1q)(d)}async watch(d){this.s.isSettled||this.s.complete(),this.s=new k.$Zh;try{this.h.clear(),this.g.clear();for(const f of d)this.u(f)?this.h.set(f.correlationId,f):this.g.add(f);for(const[f]of this.j)this.h.has(f)||(this.j.deleteAndDispose(f),this.m.delete(f));return await this.w(!1)}finally{this.s.complete()}}w(d){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(f=>!this.j.has(f.correlationId))]),d?this.y():0)}y(){return 800}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async z(d){if(this.j.has(d.correlationId))return;const f=new c.$Sc;this.j.set(d.correlationId,f),await this.s.p,!f.isDisposed&&(this.D(d,f),this.w(!0))}C(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.w(!1)}D(d,f){this.F(d,f)?(this.P(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.G(d,f),this.m.add(d.correlationId))}F(d,f){const $=this.O?.subscribe(d.path,(l,p)=>{f.isDisposed||(l?this.D(d,f):p?.type===N.FileChangeType.ADDED&&this.H(d))});return $?(f.add($),!0):!1}G(d,f){let $=!1;const l=(p,S)=>{if(f.isDisposed)return;const g=this.I(p),w=this.I(S),P=$;$=g,!g&&(w||P)&&this.H(d)};this.P(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,I.watchFile)(d.path,{persistent:!1,interval:this.r},l)}catch(p){this.Q(`fs.watchFile() failed with error ${p} on path ${d.path} (correlationId: ${d.correlationId})`)}f.add((0,c.$Rc)(()=>{this.P(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,I.unwatchFile)(d.path,l)}catch(p){this.Q(`fs.unwatchFile() failed with error ${p} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}H(d){this.P(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const f={resource:O.URI.file(d.path),type:N.FileChangeType.ADDED,cId:d.correlationId};this.a.fire([f]),this.J(f,d),this.C(d)}I(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(d,f){if(this.R){const $=` >> normalized ${d.type===N.FileChangeType.ADDED?"[ADDED]":d.type===N.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.L($,f)}}L(d,f){this.R&&this.P(`${d}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}M(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,L.$$q)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.R=d}}e.$hr=b}),define(he[165],ue([0,1,32,6,25,41,2,90,13,5,20,9,145,30,7,46]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0,e.$nr=g;class S extends N.$Tc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(P,m,o,h,i,s){super(),this.s=P,this.t=m,this.u=o,this.w=h,this.y=i,this.z=s,this.c=this.B(new c.$Rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.u(t))),this.f=this.B(new c.$Qh(t=>this.M(t),S.b)),this.g=(0,p.$9q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,p.$9q)(this.s.path,this.s.includes):void 0,this.j=(0,p.$1q)(this.s)?this.s.filter:void 0,this.m=new L.$ue,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const P=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const m=await I.promises.stat(P);if(this.m.token.isCancellationRequested)return;this.B(await this.G(P,m.isDirectory()))}catch(P){P.code!=="ENOENT"?this.O(P):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${P})`),this.D()}}D(){this.r=!0,this.w?.()}async F(P){let m=P.path;try{m=await $.Promises.realpath(P.path),P.path===m&&(m=await(0,f.$jr)(P.path,this.m.token)??P.path),P.path!==m&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${m})`)}catch{}return m}async G(P,m){const o=new N.$Sc;return this.H(P,m,o)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(P,m,o)),o}H(P,m,o){if(m)return!1;const h=d.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(s,t)=>{if(!o.isDisposed)if(s){const n=await this.G(P,m);o.isDisposed?n.dispose():o.add(n)}else t&&(typeof t.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:t.type,cId:this.s.correlationId},!0)});return i?(o.add(i),!0):!1}async I(P,m,o){if(b.$k&&(0,A.$Bg)(P,"/Volumes/",!0)){this.O(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new L.$ue(this.m.token);o.add((0,N.$Rc)(()=>h.dispose(!0)));const i=new N.$Sc;o.add(i);try{const s=d.URI.file(this.s.path),t=(0,k.$mc)(P),n=(0,I.watch)(P);i.add((0,N.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${P}'`);const r=new Set;if(m)try{for(const u of await $.Promises.readdir(P))r.add(u)}catch(u){this.O(u)}if(h.token.isCancellationRequested)return;const a=new Map;i.add((0,N.$Rc)(()=>{for(const[,u]of a)u.dispose();a.clear()})),n.on("error",(u,y)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${P} for changes using fs.watch() (${u}, ${y})`),this.D())}),n.on("change",(u,y)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${u}"] ${y}`);let C="";if(y&&(C=y.toString(),b.$k&&(C=(0,O.$km)(C))),!(!C||u!=="change"&&u!=="rename"))if(m)if(u==="rename"){a.get(C)?.dispose();const v=setTimeout(async()=>{if(a.delete(C),C===t&&!await $.Promises.exists(P)){this.J(s);return}if(h.token.isCancellationRequested)return;const E=await this.N((0,k.$ic)(P,C));if(h.token.isCancellationRequested)return;let T;E?r.has(C)?T=l.FileChangeType.UPDATED:(T=l.FileChangeType.ADDED,r.add(C)):(r.delete(C),T=l.FileChangeType.DELETED),this.L({resource:(0,R.$dh)(s,C),type:T,cId:this.s.correlationId})},S.a);a.set(C,(0,N.$Rc)(()=>clearTimeout(v)))}else{let v;r.has(C)?v=l.FileChangeType.UPDATED:(v=l.FileChangeType.ADDED,r.add(C)),this.L({resource:(0,R.$dh)(s,C),type:v,cId:this.s.correlationId})}else if(u==="rename"||C!==t){const v=setTimeout(async()=>{const E=await $.Promises.exists(P);h.token.isCancellationRequested||(E?(this.L({resource:s,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(P,!1))):this.J(s))},S.a);i.clear(),i.add((0,N.$Rc)(()=>clearTimeout(v)))}else this.L({resource:s,type:l.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(s){h.token.isCancellationRequested||this.O(`Failed to watch ${P} for changes using fs.watch() (${s.toString()})`),this.D()}}J(P){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:P,type:l.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(P,m=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${P.type===l.FileChangeType.ADDED?"[ADDED]":P.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${P.resource.fsPath}`),!m&&this.g.some(o=>o(P.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${P.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(o=>o(P.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${P.resource.fsPath}`):this.f.work(P))}M(P){const m=(0,p.$7q)(P),o=[];for(const i of m){if((0,p.$0q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}o.push(i)}if(o.length===0)return;if(this.z)for(const i of o)this.R(` >> normalized ${i.type===l.FileChangeType.ADDED?"[ADDED]":i.type===l.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(P){if(b.$l)return $.Promises.exists(P);try{const m=(0,k.$mc)(P);return(await $.Promises.readdir((0,k.$lc)(P))).some(h=>h===m)}catch(m){return this.Q(m),!1}}setVerboseLogging(P){this.z=P}O(P){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}P(P){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}Q(P){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}R(P){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${P}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$mr=S;async function g(w,P,m,o,h=512){const i=await $.Promises.open(w,"r"),s=Buffer.allocUnsafe(h),t=new L.$ue(o);let n,r=!1;const a={path:w,excludes:[],recursive:!1},u=new S(a,void 0,y=>{(async()=>{for(const{type:C}of y)if(C===l.FileChangeType.UPDATED){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:v}=await $.Promises.read(i,s,0,h,null);if(!v||t.token.isCancellationRequested)break;P(s.slice(0,v))}}catch(v){n=new Error(v),t.dispose(!0)}finally{r=!1}}})()});return await u.ready,m(),new Promise((y,C)=>{t.token.onCancellationRequested(async()=>{u.dispose();try{await $.Promises.close(i)}catch(v){n=new Error(v)}n?C(n):y()})})}}),define(he[166],ue([0,1,3,93,164,5,165,41]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class k extends L.$hr{constructor(R){super(),this.O=R,this.onDidError=I.Event.None,this.watchers=new Set}async N(R){R=this.Z(R);const d=[],f=new Set(Array.from(this.watchers));for(const $ of R){const l=this.W($);l&&(0,c.$Bk)(l.request.excludes,$.excludes)&&(0,c.$Bk)(l.request.includes,$.includes)?f.delete(l):d.push($)}d.length&&this.P(`Request to start watching: ${d.map($=>this.M($)).join(",")}`),f.size&&this.P(`Request to stop watching: ${Array.from(f).map($=>this.M($.request)).join(",")}`);for(const $ of f)this.Y($);for(const $ of d)this.X($)}W(R){for(const d of this.watchers)if(typeof R.correlationId=="number"||typeof d.request.correlationId=="number"){if(d.request.correlationId===R.correlationId)return d}else if((0,O.$Ag)(d.request.path,R.path,!A.$l))return d}X(R){const d=new N.$mr(R,this.O,$=>this.a.fire($),()=>this.c.fire(R),$=>this.b.fire($),this.R),f={request:R,instance:d};this.watchers.add(f)}async stop(){await super.stop();for(const R of this.watchers)this.Y(R)}Y(R){this.P("stopping file watcher",R),this.watchers.delete(R),R.instance.dispose()}Z(R){const d=new Map;for(const f of R){const $=A.$l?f.path:f.path.toLowerCase();let l=d.get(f.correlationId);l||(l=new Map,d.set(f.correlationId,l)),l.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(f)}`),l.set($,f)}return Array.from(d.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(R){super.setVerboseLogging(R);for(const d of this.watchers)d.instance.setVerboseLogging(R)}P(R,d){this.R&&this.b.fire({type:"trace",message:this.bb(R,d)})}Q(R){this.b.fire({type:"warn",message:this.bb(R)})}bb(R,d){return d?`[File Watcher (node.js)] ${R} (${this.M(d.request)})`:`[File Watcher (node.js)] ${R}`}}e.$or=k}),define(he[167],ue([0,1,46,166]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class L extends I.$4q{constructor(N,O,k){super(N,O,k),this.s()}r(N){return N.add(new c.$or(void 0))}}e.$pr=L}),define(he[168],ue([0,1,22,42,95,46]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class N extends A.$5q{constructor(k,b,R){super(k,b,R),this.s()}r(k){const b=k.add(new L.$fr(I.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(b.onDidProcessExit(({code:R,signal:d})=>this.t(`terminated by itself with code ${R}, signal: ${d} (ETERM)`))),c.ProxyChannel.toService((0,c.$ji)(b.getChannel("watcher")))}}e.$gr=N}),define(he[76],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=void 0;class I{constructor(...L){this.a=new Map;for(const[A,N]of L)this.set(A,N)}set(L,A){const N=this.a.get(L);return this.a.set(L,A),N}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$Ai=I}),define(he[169],ue([0,1,6,8,2,73,160,4,76,89]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;const R=!1;class d extends Error{constructor(S){super("cyclic dependency between services"),this.message=S.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${S.toString()}`}}class f{constructor(S=new k.$Ai,g=!1,w,P=R){this.i=S,this.j=g,this.k=w,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Bi,this),this._globalGraph=P?w?._globalGraph??new N.$sr(m=>m):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Oc)(this.h),this.h.clear();for(const S of this.g)(0,L.$Nc)(S)&&S.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(S,g){this.m();const w=this,P=new class extends f{dispose(){w.h.delete(P),super.dispose()}}(S,this.j,this,this.l);return this.h.add(P),g?.add(P),P}invokeFunction(S,...g){this.m();const w=l.traceInvocation(this.l,S);let P=!1;try{return S({get:o=>{if(P)throw(0,c.$7)("service accessor is only valid during the invocation of its target method");const h=this.s(o,w);if(!h)throw new Error(`[invokeFunction] unknown service '${o}'`);return h}},...g)}finally{P=!0,w.stop()}}createInstance(S,...g){this.m();let w,P;return S instanceof A.$zi?(w=l.traceCreation(this.l,S.ctor),P=this.o(S.ctor,S.staticArguments.concat(g),w)):(w=l.traceCreation(this.l,S),P=this.o(S,g,w)),w.stop(),P}o(S,g=[],w){const P=O._util.getServiceDependencies(S).sort((h,i)=>h.index-i.index),m=[];for(const h of P){const i=this.s(h.id,w);i||this.y(`[createInstance] ${S.name} depends on UNKNOWN service ${h.id}.`,!1),m.push(i)}const o=P.length>0?P[0].index:g.length;if(g.length!==o){console.trace(`[createInstance] First service dependency of ${S.name} at position ${o+1} conflicts with ${g.length} static arguments`);const h=o-g.length;h>0?g=g.concat(new Array(h)):g=g.slice(0,o)}return Reflect.construct(S,g.concat(m))}q(S,g){if(this.i.get(S)instanceof A.$zi)this.i.set(S,g);else if(this.k)this.k.q(S,g);else throw new Error("illegalState - setting UNKNOWN service instance")}r(S){const g=this.i.get(S);return!g&&this.k?this.k.r(S):g}s(S,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(S));const w=this.r(S);return w instanceof A.$zi?this.u(S,w,g.branch(S,!0)):(g.branch(S,!1),w)}u(S,g,w){if(this.t.has(S))throw new Error(`illegal state - RECURSIVELY instantiating service '${S}'`);this.t.add(S);try{return this.v(S,g,w)}finally{this.t.delete(S)}}v(S,g,w){const P=new N.$sr(i=>i.id.toString());let m=0;const o=[{id:S,desc:g,_trace:w}],h=new Set;for(;o.length;){const i=o.pop();if(!h.has(String(i.id))){if(h.add(String(i.id)),P.lookupOrInsertNode(i),m++>1e3)throw new d(P);for(const s of O._util.getServiceDependencies(i.desc.ctor)){const t=this.r(s.id);if(t||this.y(`[createInstance] ${S} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),t instanceof A.$zi){const n={id:s.id,desc:t,_trace:i._trace.branch(s.id,!0)};P.insertEdge(i,n),o.push(n)}}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new d(P);break}for(const{data:s}of i){if(this.r(s.id)instanceof A.$zi){const n=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,n)}P.removeNode(s)}}return this.r(S)}w(S,g,w=[],P,m){if(this.i.get(S)instanceof A.$zi)return this.x(S,g,w,P,m,this.g);if(this.k)return this.k.w(S,g,w,P,m);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}x(S,g,w=[],P,m,o){if(P){const h=new f(void 0,this.j,this,this.l);h.c=String(S);const i=new Map,s=new I.$Vh(()=>{const t=h.o(g,w,m);for(const[n,r]of i){const a=t[n];if(typeof a=="function")for(const u of r)u.disposable=a.apply(t,u.listener)}return i.clear(),o.add(t),t});return new Proxy(Object.create(null),{get(t,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let u=i.get(n);return u||(u=new b.$4c,i.set(n,u)),(C,v,E)=>{if(s.isInitialized)return s.value[n](C,v,E);{const T={listener:[C,v,E],disposable:void 0},F=u.push(T);return(0,L.$Rc)(()=>{F(),T.disposable?.dispose()})}}}if(n in t)return t[n];const r=s.value;let a=r[n];return typeof a!="function"||(a=a.bind(r),t[n]=a),a},set(t,n,r){return s.value[n]=r,!0},getPrototypeOf(t){return g.prototype}})}else{const h=this.o(g,w,m);return o.add(h),h}}y(S,g){if(g&&console.warn(S),this.j)throw new Error(S)}}e.$tr=f;var $;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})($||($={}));class l{static{this.all=new Set}static{this.c=new class extends l{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(S,g){return S?new l($.Invocation,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):l.c}static traceCreation(S,g){return S?new l($.Creation,g.name):l.c}static{this.f=0}constructor(S,g){this.type=S,this.name=g,this.g=Date.now(),this.h=[]}branch(S,g){const w=new l($.Branch,S.toString());return this.h.push([S,g,w]),w}stop(){const S=Date.now()-this.g;l.f+=S;let g=!1;function w(m,o){const h=[],i=new Array(m+1).join("	");for(const[s,t,n]of o.h)if(t&&n){g=!0,h.push(`${i}CREATES -> ${s}`);const r=w(m+1,n);r&&h.push(r)}else h.push(`${i}uses -> ${s}`);return h.join(`
`)}const P=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${S.toFixed(2)}ms (grand total ${l.f.toFixed(2)}ms)`];(S>2||g)&&l.all.add(P.join(`
`))}}e.$ur=l}),define(he[56],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0,e.$Zgc=(0,I.$Ci)("mainProcessService");class c{constructor(A,N){this.a=A,this.b=N}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,N){this.a.registerChannel(A,N)}}e.$1gc=c}),define(he[10],ue([0,1,11,43,3,55,2,36,5,20,12,9,96,4]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$ak=e.LogLevel=e.$$j=e.$0j=void 0,e.$_j=p,e.log=g,e.$lk=a,e.$mk=u,e.$nk=y,e.$ok=C,I=ke(I),e.$0j=(0,$.$Ci)("logService"),e.$$j=(0,$.$Ci)("loggerService");function l(){return new Date().toISOString()}function p(v){return(0,R.$gg)(v)}var S;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(S||(e.LogLevel=S={})),e.$ak=S.Info;function g(v,E,T){switch(E){case S.Trace:v.trace(T);break;case S.Debug:v.debug(T);break;case S.Info:v.info(T);break;case S.Warning:v.warn(T);break;case S.Error:v.error(T);break;case S.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function w(v,E=!1){let T="";for(let F=0;F<v.length;F++){let U=v[F];if(U instanceof Error&&(U=(0,c.$nj)(U,E)),typeof U=="object")try{U=JSON.stringify(U)}catch{}T+=(F>0?" ":"")+U}return T}class P extends N.$Tc{constructor(){super(...arguments),this.b=e.$ak,this.c=this.B(new L.$je),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==S.Off&&this.b<=E}}e.$ck=P;class m extends P{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...T){this.f(S.Trace)&&this.g(S.Trace,w([E,...T],!0))}debug(E,...T){this.f(S.Debug)&&this.g(S.Debug,w([E,...T]))}info(E,...T){this.f(S.Info)&&this.g(S.Info,w([E,...T]))}warn(E,...T){this.f(S.Warning)&&this.g(S.Warning,w([E,...T]))}error(E,...T){if(this.f(S.Error))if(E instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=E.stack,this.g(S.Error,w(F))}else this.g(S.Error,w([E,...T]))}flush(){}}e.$dk=m;class o extends P{constructor(E=e.$ak){super(),this.setLevel(E),this.g=!k.$j}trace(E,...T){this.f(S.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...T):console.log(`[main ${l()}]`,E,...T))}debug(E,...T){this.f(S.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...T):console.log(`[main ${l()}]`,E,...T))}info(E,...T){this.f(S.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,E,...T):console.log(`[main ${l()}]`,E,...T))}warn(E,...T){this.f(S.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,E,...T):console.warn(`[main ${l()}]`,E,...T))}error(E,...T){this.f(S.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,E,...T):console.error(`[main ${l()}]`,E,...T))}flush(){}}e.$ek=o;class h extends P{constructor(E=e.$ak,T=!0){super(),this.g=T,this.setLevel(E)}trace(E,...T){this.f(S.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...T):console.log(E,...T))}debug(E,...T){this.f(S.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...T):console.log(E,...T))}info(E,...T){this.f(S.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...T):console.log(E,...T))}warn(E,...T){this.f(S.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...T):console.log(E,...T))}error(E,...T){this.f(S.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...T):console.error(E,...T))}flush(){}}e.$fk=h;class i extends P{constructor(E,T=e.$ak){super(),this.g=E,this.setLevel(T)}trace(E,...T){this.f(S.Trace)&&this.g.log(S.Trace,[this.h(E),...T])}debug(E,...T){this.f(S.Debug)&&this.g.log(S.Debug,[this.h(E),...T])}info(E,...T){this.f(S.Info)&&this.g.log(S.Info,[this.h(E),...T])}warn(E,...T){this.f(S.Warning)&&this.g.log(S.Warning,[this.h(E),...T])}error(E,...T){this.f(S.Error)&&this.g.log(S.Error,[this.h(E),...T])}h(E){return typeof E=="string"?E:(0,c.$nj)(E,this.f(S.Trace))}flush(){}}e.$gk=i;class s extends P{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const T of this.g)T.setLevel(E);super.setLevel(E)}trace(E,...T){for(const F of this.g)F.trace(E,...T)}debug(E,...T){for(const F of this.g)F.debug(E,...T)}info(E,...T){for(const F of this.g)F.info(E,...T)}warn(E,...T){for(const F of this.g)F.warn(E,...T)}error(E,...T){for(const F of this.g)F.error(E,...T)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$hk=s;class t extends N.$Tc{constructor(E,T,F){if(super(),this.h=E,this.j=T,this.b=new O.$zc,this.c=this.B(new L.$je),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$je),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$je),this.onDidChangeVisibility=this.g.event,F)for(const U of F)this.b.set(U.resource,{logger:void 0,info:U})}m(E){return(0,R.$cg)(E)?[...this.b.values()].find(T=>T.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,T){const F=this.n(E),U=(0,R.$cg)(E)?E:T?.id??(0,A.$qj)(F.toString()).toString(16);let j=this.b.get(F)?.logger;const K=T?.logLevel==="always"?S.Trace:T?.logLevel;j||(j=this.s(F,K??this.getLogLevel(F)??this.h,{...T,id:U}));const V={logger:j,info:{resource:F,id:U,logLevel:K,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(V.info),this.b.set(F,V),j}n(E){return(0,R.$cg)(E)?(0,b.$dh)(this.j,`${E}.log`):E}setLogLevel(E,T){if(d.URI.isUri(E)){const F=E,U=T,j=this.b.get(F);j&&U!==j.info.logLevel&&(j.info.logLevel=U===this.h?void 0:U,j.logger?.setLevel(U),this.b.set(j.info.resource,j),this.f.fire([F,U]))}else{this.h=E;for(const[F,U]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,T){const F=this.m(E);F&&T!==!F.info.hidden&&(F.info.hidden=!T,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,T]))}getLogLevel(E){let T;return E&&(T=this.b.get(E)?.info.logLevel),T??this.h}registerLogger(E){const T=this.b.get(E.resource);T?T.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const T=this.b.get(E);T&&(T.logger&&T.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ik=t;class n{constructor(){this.onDidChangeLogLevel=new L.$je().event}setLevel(E){}getLevel(){return S.Info}trace(E,...T){}debug(E,...T){}info(E,...T){}warn(E,...T){}error(E,...T){}critical(E,...T){}dispose(){}flush(){}}e.$jk=n;class r extends n{}e.$kk=r;function a(v){if(v.verbose)return S.Trace;if(typeof v.logLevel=="string"){const E=C(v.logLevel.toLowerCase());if(E!==void 0)return E}return e.$ak}function u(v){switch(v){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}function y(v){switch(v){case S.Trace:return{original:"Trace",value:I.localize(11152,null)};case S.Debug:return{original:"Debug",value:I.localize(11153,null)};case S.Info:return{original:"Info",value:I.localize(11154,null)};case S.Warning:return{original:"Warning",value:I.localize(11155,null)};case S.Error:return{original:"Error",value:I.localize(11156,null)};case S.Off:return{original:"Off",value:I.localize(11157,null)}}}function C(v){switch(v){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.$pk=new f.$Tj("logLevel",u(S.Info))}),define(he[170],ue([0,1,6,8,2,22,13,20,30,15,10]),function(oe,e,I,c,L,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let d=class extends L.$Tc{constructor($,l){super(),this.a=$,this.b=l,this.B(new I.$Oh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const $=(0,O.$ah)(this.a.logsHome),l=(0,O.$ch)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,g=(await k.Promises.readdir(l)).filter(P=>/^\d{8}T\d{6}$/.test(P)).sort().filter(P=>P!==$),w=g.slice(0,Math.max(0,g.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(P=>k.Promises.rm((0,N.$ic)(l,P)))))}catch($){(0,c.$Y)($)}}};e.$hhc=d,e.$hhc=d=ve([Q(0,b.$Ji),Q(1,R.$0j)],d)}),define(he[171],ue([0,1,17,6,8,3,41,2,13,46,10]),function(oe,e,I,c,L,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class d extends O.$Tc{constructor($,l){super(),this.a=$,this.b=l,this.c=this.B(new A.$je),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$je),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new c.$Ah(0)),this.w=[],this.y=this.B(new c.$Ah(0))}watch($,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n($,l):this.z($,l)}n($,l){const p={path:this.J($),excludes:l.excludes,includes:l.includes,recursive:l.recursive,filter:l.filter,correlationId:l.correlationId},S=(0,I.$Sb)(this.j,p);return this.r(),(0,O.$Rc)(()=>{S(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,L.$Y)($))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,b.$6q)(l)),l=>this.G(l),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const l of this.j)(0,b.$2q)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const l of this.j)(0,b.$2q)(l)&&$.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,l){const p={path:this.J($),excludes:l.excludes,includes:l.includes,recursive:!1,filter:l.filter,correlationId:l.correlationId},S=(0,I.$Sb)(this.w,p);return this.C(),(0,O.$Rc)(()=>{S(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,L.$Y)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,b.$6q)($)),$=>this.G($),this.a.getLevel()===R.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===R.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,k.$gc)($.fsPath)}J($){const l=this.I($);return(0,N.$Eg)(l)}}e.$_q=d}),define(he[172],ue([0,1,17,6,14,25,3,55,63,2,51,22,100,20,50,11,7,99,10,8]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let o=class extends b.$Tc{static{m=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new N.$je),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$je),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$je),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$je),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$je),this.Y=this.B(new N.$je),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$je),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new c.$Lh)}registerProvider(i,s){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${i}`);const t=new b.$Sc;return this.h.set(i,s),this.c.fire({added:!0,scheme:i,provider:s}),t.add(s.onDidChangeFile(n=>{const r=new S.$ql(n,!this.S(s));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof s.onDidWatchError=="function"&&t.add(s.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:i}))),(0,b.$Rc)(()=>{this.c.fire({added:!1,scheme:i,provider:s}),this.h.delete(i),(0,b.$Oc)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const s=[];this.f.fire({scheme:i,join(t){s.push(t)}}),!this.h.has(i)&&await c.Promises.settled(s)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,s){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return k.Iterable.map(this.h,([i,s])=>({scheme:i,capabilities:s.capabilities}))}async j(i){if(!(0,$.$hh)(i))throw new S.$sl((0,p.localize)(11225,null,this.sb(i)),S.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(i.scheme);const s=this.h.get(i.scheme);if(!s){const t=new P.$ab;throw t.message=(0,p.localize)(11226,null,i.toString()),t}return s}async m(i){const s=await this.j(i);if((0,S.$dl)(s)||(0,S.$al)(s)||(0,S.$el)(s))return s;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const s=await this.j(i);if((0,S.$dl)(s)||(0,S.$al)(s))return s;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,s){try{return await this.s(i,s)}catch(t){throw(0,S.$nl)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.$sl((0,p.localize)(11227,null,this.sb(i)),S.FileOperationResult.FILE_NOT_FOUND):(0,S.$ll)(t)}}async s(i,s){const t=await this.j(i),n=this.S(t),r=s?.resolveTo,a=s?.resolveSingleChildDescendants,u=s?.resolveMetadata,y=await t.stat(i);let C;return this.t(t,i,y,void 0,!!u,(v,E)=>(C||(C=R.$Ii.forUris(()=>!n),C.set(i,!0),r&&C.fill(!0,r)),C.get(v.resource)||C.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&a?E===1:!1))}async t(i,s,t,n,r,a){const{providerExtUri:u}=this.R(i),y={resource:s,name:u.basename(s),isFile:(t.type&S.FileType.File)!==0,isDirectory:(t.type&S.FileType.Directory)!==0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&S.FilePermission.Readonly)||!!(i.capabilities&S.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&S.FilePermission.Locked),etag:(0,S.$Dl)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&a(y,n)){try{const C=await i.readdir(s),v=await c.Promises.settled(C.map(async([E,T])=>{try{const F=u.joinPath(s,E),U=r?await i.stat(F):{type:T};return await this.t(i,F,U,C.length,r,a)}catch(F){return this.b.trace(F),null}}));y.children=(0,I.$Gb)(v)}catch(C){this.b.trace(C),y.children=[]}return y}return y}async resolveAll(i){return c.Promises.settled(i.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const s=await this.j(i),t=await s.stat(i);return this.t(s,i,t,void 0,!0,()=>!1)}async exists(i){const s=await this.j(i);try{return!!await s.stat(i)}catch{return!1}}async canCreateFile(i,s){try{await this.u(i,s)}catch(t){return t}return!0}async u(i,s){if(!s?.overwrite&&await this.exists(i))throw new S.$sl((0,p.localize)(11228,null,this.sb(i)),S.FileOperationResult.FILE_MODIFIED_SINCE,s)}async createFile(i,s=L.$Le.fromString(""),t){await this.u(i,t);const n=await this.writeFile(i,s);return this.r.fire(new S.$pl(i,S.FileOperation.CREATE,n)),n}async writeFile(i,s,t){const n=this.qb(await this.n(i),i),{providerExtUri:r}=this.R(n);let a=t;if((0,S.$gl)(n)&&!a?.atomic){const u=n.enforceAtomicWriteFile?.(i);u&&(a={...t,atomic:u})}try{await this.w(n,i,a)||await this.U(n,r.dirname(i));let y;if((0,S.$al)(n)&&!(s instanceof L.$Le))if((0,l.$xe)(s)){const C=await(0,l.$Ee)(s,3);C.ended?y=L.$Le.concat(C.buffer):y=C}else y=(0,l.$Be)(s,C=>L.$Le.concat(C),3);else y=s;!(0,S.$dl)(n)||(0,S.$al)(n)&&y instanceof L.$Le||(0,S.$al)(n)&&(0,S.$gl)(n)&&a?.atomic?await this.hb(n,i,a,y):await this.db(n,i,a,y instanceof L.$Le?(0,L.$We)(y):y),this.r.fire(new S.$pl(i,S.FileOperation.WRITE))}catch(u){throw new S.$sl((0,p.localize)(11229,null,this.sb(i),(0,S.$ll)(u).toString()),(0,S.$ol)(u),a)}return this.resolve(i,{resolveMetadata:!0})}async w(i,s,t){const n=!!t?.unlock;if(n&&!(i.capabilities&S.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,p.localize)(11230,null,this.sb(s)));if(!!t?.atomic){if(!(i.capabilities&S.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,p.localize)(11231,null,this.sb(s)));if(!(i.capabilities&S.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,p.localize)(11232,null,this.sb(s)));if(n)throw new Error((0,p.localize)(11233,null,this.sb(s)))}let a;try{a=await i.stat(s)}catch{return}if(a.type&S.FileType.Directory)throw new S.$sl((0,p.localize)(11234,null,this.sb(s)),S.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(s,a),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.$Cl&&typeof a.mtime=="number"&&typeof a.size=="number"&&t.mtime<a.mtime&&t.etag!==(0,S.$Dl)({mtime:t.mtime,size:a.size}))throw new S.$sl((0,p.localize)(11235,null),S.FileOperationResult.FILE_MODIFIED_SINCE,t);return a}async readFile(i,s,t){const n=await this.m(i);return s?.atomic?this.z(n,i,s,t):this.C(n,i,s,t)}async z(i,s,t,n){return new Promise((r,a)=>{this.cb.queueFor(s,async()=>{try{const u=await this.C(i,s,t,n);r(u)}catch(u){a(u)}},this.R(i).providerExtUri)})}async C(i,s,t,n){const r=await this.D(i,s,{...t,preferUnbuffered:!0},n);return{...r,value:await(0,L.$Xe)(r.value)}}async readFileStream(i,s,t){const n=await this.m(i);return this.D(n,i,s,t)}async D(i,s,t,n){const r=new A.$ue(n);let a=t;(0,S.$fl)(i)&&i.enforceAtomicReadFile?.(s)&&(a={...t,atomic:!0});const u=this.J(s,a).then(C=>C,C=>{throw r.dispose(!0),C});let y;try{return typeof a?.etag=="string"&&a.etag!==S.$Cl&&await u,a?.atomic&&(0,S.$fl)(i)||!((0,S.$dl)(i)||(0,S.$el)(i))||(0,S.$al)(i)&&a?.preferUnbuffered?y=this.I(i,s,a):(0,S.$el)(i)?y=this.G(i,s,r.token,a):y=this.H(i,s,r.token,a),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await u,value:y}}catch(C){throw y&&await(0,l.$Ce)(y),this.F(C,s,a)}}F(i,s,t){const n=(0,p.localize)(11236,null,this.sb(s),(0,S.$ll)(i).toString());return i instanceof S.$ul?new S.$ul(n,i.stat,t):i instanceof S.$tl?new S.$tl(n,i.fileOperationResult,i.size,i.options):new S.$sl(n,(0,S.$ol)(i),t)}G(i,s,t,n=Object.create(null)){const r=i.readFileStream(s,n,t);return(0,l.$Ie)(r,{data:a=>a instanceof L.$Le?a:L.$Le.wrap(a),error:a=>this.F(a,s,n)},a=>L.$Le.concat(a))}H(i,s,t,n=Object.create(null)){const r=(0,L.$2e)();return(0,g.$Yq)(i,s,r,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.F(a,s,n)},t),r}I(i,s,t){const n=(0,l.$ze)(r=>L.$Le.concat(r));return(async()=>{try{let r;t?.atomic&&(0,S.$fl)(i)?r=await i.readFile(s,{atomic:!0}):r=await i.readFile(s),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(s,r.byteLength,t),n.end(L.$Le.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(i,s){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new S.$sl((0,p.localize)(11237,null,this.sb(i)),S.FileOperationResult.FILE_IS_DIRECTORY,s);if(typeof s?.etag=="string"&&s.etag!==S.$Cl&&s.etag===t.etag)throw new S.$ul((0,p.localize)(11238,null),t,s);return this.L(i,t.size,s),t}L(i,s,t){if(typeof t?.limits?.size=="number"&&s>t.limits.size)throw new S.$tl((0,p.localize)(11239,null,this.sb(i)),S.FileOperationResult.FILE_TOO_LARGE,s,t)}async canMove(i,s,t){return this.M(i,s,"move",t)}async canCopy(i,s,t){return this.M(i,s,"copy",t)}async M(i,s,t,n){if(i.toString()!==s.toString())try{const r=t==="move"?this.qb(await this.n(i),i):await this.m(i),a=this.qb(await this.n(s),s);await this.Q(r,i,a,s,t,n)}catch(r){return r}return!0}async move(i,s,t){const n=this.qb(await this.n(i),i),r=this.qb(await this.n(s),s),a=await this.N(n,i,r,s,"move",!!t),u=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new S.$pl(i,a==="move"?S.FileOperation.MOVE:S.FileOperation.COPY,u)),u}async copy(i,s,t){const n=await this.m(i),r=this.qb(await this.n(s),s),a=await this.N(n,i,r,s,"copy",!!t),u=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new S.$pl(i,a==="copy"?S.FileOperation.COPY:S.FileOperation.MOVE,u)),u}async N(i,s,t,n,r,a){if(s.toString()===n.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:y}=await this.Q(i,s,t,n,r,a);if(u&&!y&&a&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),r==="copy"){if(i===t&&(0,S.$bl)(i))await i.copy(s,n,{overwrite:a});else{const C=await this.resolve(s);C.isDirectory?await this.P(i,C,t,n):await this.O(i,s,t,n)}return r}else return i===t?(await i.rename(s,n,{overwrite:a}),r):(await this.N(i,s,t,n,"copy",a),await this.del(s,{recursive:!0}),"copy")}async O(i,s,t,n){if((0,S.$dl)(i)&&(0,S.$dl)(t))return this.jb(i,s,t,n);if((0,S.$dl)(i)&&(0,S.$al)(t))return this.pb(i,s,t,n);if((0,S.$al)(i)&&(0,S.$dl)(t))return this.nb(i,s,t,n);if((0,S.$al)(i)&&(0,S.$al)(t))return this.lb(i,s,t,n)}async P(i,s,t,n){await t.mkdir(n),Array.isArray(s.children)&&await c.Promises.settled(s.children.map(async r=>{const a=this.R(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(i,await this.resolve(r.resource),t,a):this.O(i,r.resource,t,a)}))}async Q(i,s,t,n,r,a){let u=!1;if(i===t){const{providerExtUri:C,isPathCaseSensitive:v}=this.R(i);if(v||(u=C.isEqual(s,n)),u&&r==="copy")throw new Error((0,p.localize)(11240,null,this.sb(s),this.sb(n)));if(!u&&C.isEqualOrParent(n,s))throw new Error((0,p.localize)(11241,null,this.sb(s),this.sb(n)))}const y=await this.exists(n);if(y&&!u){if(!a)throw new S.$sl((0,p.localize)(11242,null,this.sb(s),this.sb(n)),S.FileOperationResult.FILE_MOVE_CONFLICT);if(i===t){const{providerExtUri:C}=this.R(i);if(C.isEqualOrParent(s,n))throw new Error((0,p.localize)(11243,null,this.sb(s),this.sb(n)))}}return{exists:y,isSameResourceWithDifferentPathCase:u}}R(i){const s=this.S(i);return{providerExtUri:s?$.$6g:$.$8g,isPathCaseSensitive:s}}S(i){return!!(i.capabilities&S.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(i){const s=this.qb(await this.j(i),i);await this.U(s,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new S.$pl(i,S.FileOperation.CREATE,t)),t}async U(i,s){const t=[],{providerExtUri:n}=this.R(i);for(;!n.isEqual(s,n.dirname(s));)try{if(!((await i.stat(s)).type&S.FileType.Directory))throw new Error((0,p.localize)(11244,null,this.sb(s)));break}catch(r){if((0,S.$nl)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(s)),s=n.dirname(s)}for(let r=t.length-1;r>=0;r--){s=n.joinPath(s,t[r]);try{await i.mkdir(s)}catch(a){if((0,S.$nl)(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,s){try{await this.W(i,s)}catch(t){return t}return!0}async W(i,s){const t=this.qb(await this.j(i),i),n=!!s?.useTrash;if(n&&!(t.capabilities&S.FileSystemProviderCapabilities.Trash))throw new Error((0,p.localize)(11245,null,this.sb(i)));const r=s?.atomic;if(r&&!(t.capabilities&S.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,p.localize)(11246,null,this.sb(i)));if(n&&r)throw new Error((0,p.localize)(11247,null,this.sb(i)));let a;try{a=await t.stat(i)}catch{}if(a)this.rb(i,a);else throw new S.$sl((0,p.localize)(11248,null,this.sb(i)),S.FileOperationResult.FILE_NOT_FOUND);if(!!!s?.recursive){const y=await this.resolve(i);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,p.localize)(11249,null,this.sb(i)))}return t}async del(i,s){const t=await this.W(i,s);let n=s;if((0,S.$hl)(t)&&!n?.atomic){const y=t.enforceAtomicDelete?.(i);y&&(n={...s,atomic:y})}const r=!!n?.useTrash,a=!!n?.recursive,u=n?.atomic??!1;await t.delete(i,{recursive:a,useTrash:r,atomic:u}),this.r.fire(new S.$pl(i,S.FileOperation.DELETE))}async cloneFile(i,s){const t=await this.j(i),n=this.qb(await this.n(s),s);if(!(t===n&&this.R(t).providerExtUri.isEqual(i,s)))return t===n&&(0,S.$cl)(t)?t.cloneFile(i,s):(await this.U(n,this.R(n).providerExtUri.dirname(s)),t===n&&(0,S.$bl)(t)?this.cb.queueFor(i,()=>t.copy(i,s,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(i,()=>this.O(t,i,n,s),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(i,s){return this.watch(i,{...s,correlationId:m.ab++})}watch(i,s={recursive:!1,excludes:[]}){const t=new b.$Sc;let n=!1,r=()=>{n=!0};t.add((0,b.$Rc)(()=>r())),(async()=>{try{const u=await this.bb(i,s);n?(0,b.$Oc)(u):r=()=>(0,b.$Oc)(u)}catch(u){this.b.error(u)}})();const a=s.correlationId;if(typeof a=="number"){const u=t.add(new N.$je);return t.add(this.X.event(C=>{C.correlates(a)&&u.fire(C)})),{onDidChange:u.event,dispose:()=>t.dispose()}}return t}async bb(i,s){const t=await this.j(i),n=(0,O.$qj)([this.R(t).providerExtUri.getComparisonKey(i),s]);let r=this.$.get(n);return r||(r={count:0,disposable:t.watch(i,s)},this.$.set(n,r)),r.count+=1,(0,b.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,b.$Oc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,b.$Oc)(i.disposable);this.$.clear()}async db(i,s,t,n){return this.cb.queueFor(s,async()=>{const r=await i.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,l.$xe)(n)||(0,l.$ye)(n)?await this.eb(i,r,n):await this.fb(i,r,n)}catch(a){throw(0,S.$ll)(a)}finally{await i.close(r)}},this.R(i).providerExtUri)}async eb(i,s,t){let n=0,r;if((0,l.$ye)(t)){if(t.buffer.length>0){const a=L.$Le.concat(t.buffer);await this.gb(i,s,a,a.byteLength,n,0),n+=a.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((a,u)=>{(0,l.$De)(r,{onData:async y=>{r.pause();try{await this.gb(i,s,y,y.byteLength,n,0)}catch(C){return u(C)}n+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>u(y),onEnd:()=>a()})})}async fb(i,s,t){let n=0,r;for(;(r=t.read())!==null;)await this.gb(i,s,r,r.byteLength,n,0),n+=r.byteLength}async gb(i,s,t,n,r,a){let u=0;for(;u<n;){const y=await i.write(s,r+u,t.buffer,a+u,n-u);u+=y}}async hb(i,s,t,n){return this.cb.queueFor(s,()=>this.ib(i,s,t,n),this.R(i).providerExtUri)}async ib(i,s,t,n){let r;n instanceof L.$Le?r=n:(0,l.$xe)(n)?r=await(0,L.$Xe)(n):(0,l.$ye)(n)?r=await(0,L.$Ye)(n):r=(0,L.$Ve)(n),await i.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(i,s,t,n){return this.cb.queueFor(n,()=>this.kb(i,s,t,n),this.R(t).providerExtUri)}async kb(i,s,t,n){let r,a;try{r=await i.open(s,{create:!1}),a=await t.open(n,{create:!0,unlock:!1});const u=L.$Le.alloc(this.a);let y=0,C=0,v=0;do v=await i.read(r,y,u.buffer,C,u.byteLength-C),await this.gb(t,a,u,v,y,C),y+=v,C+=v,C===u.byteLength&&(C=0);while(v>0)}catch(u){throw(0,S.$ll)(u)}finally{await c.Promises.settled([typeof r=="number"?i.close(r):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async lb(i,s,t,n){return this.cb.queueFor(n,()=>this.mb(i,s,t,n),this.R(t).providerExtUri)}async mb(i,s,t,n){return t.writeFile(n,await i.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,s,t,n){return this.cb.queueFor(n,()=>this.ob(i,s,t,n),this.R(t).providerExtUri)}async ob(i,s,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const a=await i.readFile(s);await this.gb(t,r,L.$Le.wrap(a),a.byteLength,0,0)}catch(a){throw(0,S.$ll)(a)}finally{await t.close(r)}}async pb(i,s,t,n){const r=await(0,L.$Xe)(this.H(i,s,A.CancellationToken.None));await this.hb(t,n,void 0,r)}qb(i,s){if(i.capabilities&S.FileSystemProviderCapabilities.Readonly)throw new S.$sl((0,p.localize)(11250,null,this.sb(s)),S.FileOperationResult.FILE_PERMISSION_DENIED);return i}rb(i,s){if((s.permissions??0)&S.FilePermission.Readonly)throw new S.$sl((0,p.localize)(11251,null,this.sb(i)),S.FileOperationResult.FILE_PERMISSION_DENIED)}sb(i){return i.scheme===d.Schemas.file?i.fsPath:i.toString(!0)}};e.$Zq=o,e.$Zq=o=m=ve([Q(0,w.$0j)],o)}),define(he[173],ue([0,1,32,6,36,14,3,41,2,13,5,20,50,30,11,7,99,171,168,167]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class m extends g.$_q{static{this.L=!1}constructor(h,i){super(h,i),this.onDidChangeCapabilities=N.Event.None,this.P=new L.$zc(s=>d.$7g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,R.$l&&(this.M|=p.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:i,symbolicLink:s}=await $.SymlinkSupport.stat(this.I(h));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const i=await $.Promises.readdir(this.I(h),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async t=>{try{let n;t.isSymbolicLink()?n=(await this.stat((0,d.$dh)(h,t.name))).type:n=this.O(t),s.push([t.name,n])}catch(n){this.a.trace(n)}})),s}catch(i){throw this.hb(i)}}O(h,i){let s;return i?.dangling?s=p.FileType.Unknown:h.isFile()?s=p.FileType.File:h.isDirectory()?s=p.FileType.Directory:s=p.FileType.Unknown,i&&(s|=p.FileType.SymbolicLink),s}async Q(h){const i=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const t=new c.$Bh;return this.P.set(h,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,k.$Rc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(h)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),t.open()})}async readFile(h,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),s=await this.Q(h));const t=this.I(h);return await I.promises.readFile(t)}catch(t){throw this.hb(t)}finally{s?.dispose()}}R(h){m.L&&this.a.trace(h)}readFileStream(h,i,s){const t=(0,f.$ze)(n=>A.$Le.concat(n.map(r=>A.$Le.wrap(r))).buffer);return(0,S.$Yq)(this,h,t,n=>n.buffer,{...i,bufferSize:256*1024},s),t}async writeFile(h,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(h)?this.U(h,(0,d.$dh)((0,d.$ch)(h),`${(0,d.$ah)(h)}${s.atomic.postfix}`),i,s):this.W(h,i,s)}async S(h){try{const i=this.I(h),{symbolicLink:s}=await $.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(h,i,s,t){const n=new k.$Sc;try{n.add(await this.Q(h)),n.add(await this.Q(i)),await this.W(i,s,t,!0);try{await this.rename(i,h,{overwrite:!0})}catch(r){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}finally{n.dispose()}}async W(h,i,s,t){let n;try{const r=this.I(h);if(!s.create||!s.overwrite){if(await $.Promises.exists(r)){if(!s.overwrite)throw(0,p.$kl)((0,l.localize)(11209,null),p.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,p.$kl)((0,l.localize)(11210,null),p.FileSystemProviderErrorCode.FileNotFound)}n=await this.open(h,{create:!0,unlock:s.unlock},t),await this.write(n,0,i,0,i.byteLength)}catch(r){throw await this.ib(h,r)}finally{typeof n=="number"&&await this.close(n)}}static{this.$=!0}static configureFlushOnWrite(h){m.$=h}async open(h,i,s){const t=this.I(h);let n;(0,p.$$k)(i)&&!s&&(n=await this.Q(h));let r;try{if((0,p.$$k)(i)&&i.unlock)try{const{stat:u}=await $.SymlinkSupport.stat(t);u.mode&128||await I.promises.chmod(t,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let a;if((0,p.$$k)(i)){if(R.$j)try{await I.promises.truncate(t,0),a="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}a||(a="w")}else a="r";r=await $.Promises.open(t,a)}catch(a){throw n?.dispose(),(0,p.$$k)(i)?await this.ib(h,a):this.hb(a)}if(this.X.set(r,0),(0,p.$$k)(i)&&this.Z.set(r,h),n){const a=this.Y.get(r);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${t})`),this.Y.set(r,n),a&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${t})`),a.dispose())}return r}async close(h){const i=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&m.$)try{await $.Promises.fdatasync(h)}catch(s){m.configureFlushOnWrite(!1),this.a.error(s)}return await $.Promises.close(h)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(h)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),i.dispose())}}async read(h,i,s,t,n){const r=this.ab(h,i);let a=null;try{a=(await $.Promises.read(h,s,t,n,r)).bytesRead}catch(u){throw this.hb(u)}finally{this.bb(h,r,a)}return a}ab(h,i){return i===this.X.get(h)?null:i}bb(h,i,s){const t=this.X.get(h);typeof t=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(h,t+s):this.X.delete(h)))}async write(h,i,s,t,n){return(0,c.$Wh)(()=>this.cb(h,i,s,t,n),100,3)}async cb(h,i,s,t,n){const r=this.ab(h,i);let a=null;try{a=(await $.Promises.write(h,s,t,n,r)).bytesWritten}catch(u){throw await this.ib(this.Z.get(h),u)}finally{this.bb(h,r,a)}return a}async mkdir(h){try{await I.promises.mkdir(this.I(h))}catch(i){throw this.hb(i)}}async delete(h,i){try{const s=this.I(h);if(i.recursive){let t;i?.atomic!==!1&&i.atomic.postfix&&(t=(0,b.$ic)((0,b.$lc)(s),`${(0,b.$mc)(s)}${i.atomic.postfix}`)),await $.Promises.rm(s,$.RimRafMode.MOVE,t)}else try{await I.promises.unlink(s)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let n=!1;try{const{stat:r,symbolicLink:a}=await $.SymlinkSupport.stat(s);n=r.isDirectory()&&!a}catch{}if(n)await I.promises.rmdir(s);else throw t}else throw t}}catch(s){throw this.hb(s)}}async rename(h,i,s){const t=this.I(h),n=this.I(i);if(t!==n)try{await this.db(h,i,"move",s.overwrite),await $.Promises.rename(t,n)}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11211,null,(0,b.$mc)(t),(0,b.$mc)((0,b.$lc)(n)),r.toString()))),this.hb(r)}}async copy(h,i,s){const t=this.I(h),n=this.I(i);if(t!==n)try{await this.db(h,i,"copy",s.overwrite),await $.Promises.copy(t,n,{preserveSymlinks:!0})}catch(r){throw(r.code==="EINVAL"||r.code==="EBUSY"||r.code==="ENAMETOOLONG")&&(r=new Error((0,l.localize)(11212,null,(0,b.$mc)(t),(0,b.$mc)((0,b.$lc)(n)),r.toString()))),this.hb(r)}}async db(h,i,s,t){const n=this.I(h),r=this.I(i);let a=!1;if(!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)||(a=(0,O.$Ag)(n,r,!0)),a){if(s==="copy")throw(0,p.$kl)((0,l.localize)(11213,null),p.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const y=await this.N(h);if(!y)throw(0,p.$kl)((0,l.localize)(11214,null),p.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(i);if(C){if(!t)throw(0,p.$kl)((0,l.localize)(11215,null),p.FileSystemProviderErrorCode.FileExists);y.type&p.FileType.File&&C.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,i){return this.eb(h,i,!1)}async eb(h,i,s){const t=this.I(h),n=this.I(i),r=!!(this.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Ag)(t,n,!r))return;const a=new k.$Sc;try{a.add(await this.Q(h)),a.add(await this.Q(i)),s&&await I.promises.mkdir((0,b.$lc)(n),{recursive:!0}),await I.promises.copyFile(t,n)}catch(u){if(u.code==="ENOENT"&&!s)return this.eb(h,i,!0);throw this.hb(u)}finally{a.dispose()}}t(h,i,s){return new w.$gr(t=>h(t),t=>i(t),s)}F(h,i,s){return new P.$pr(t=>h(t),t=>i(t),s)}hb(h){if(h instanceof p.$jl)return h;let i=h,s;switch(h.code){case"ENOENT":s=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=p.FileSystemProviderErrorCode.Unknown;break;default:s=p.FileSystemProviderErrorCode.Unknown}return(0,p.$kl)(i,s)}async ib(h,i){let s=this.hb(i);if(h&&s.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await $.SymlinkSupport.stat(this.I(h));t.mode&128||(s=(0,p.$kl)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return s}}e.$qr=m}),define(he[101],ue([0,1,3,2,4,10]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=void 0,e.$Ghc=(0,L.$Ci)("sharedProcessLifecycleService");let N=class extends c.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new I.$je),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Hhc=N,e.$Hhc=N=ve([Q(0,A.$0j)],N)}),define(he[174],ue([0,1,9,3,10,2]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=void 0;class N extends L.$ik{constructor(d,f,$,l,p){super(f,$,l),this.r=d,this.t=p,this.B(p.listen("onDidChangeLogLevel",d)(S=>{(0,L.$_j)(S)?super.setLogLevel(S):super.setLogLevel(I.URI.revive(S[0]),S[1])})),this.B(p.listen("onDidChangeVisibility",d)(([S,g])=>super.setVisibility(I.URI.revive(S),g))),this.B(p.listen("onDidChangeLoggers",d)(({added:S,removed:g})=>{for(const w of S)super.registerLogger({...w,resource:I.URI.revive(w.resource)});for(const w of g)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new L.$gk({log:(d,f)=>{this.t.call("consoleLog",[d,f])}})}registerLogger(d){super.registerLogger(d),this.t.call("registerLogger",[d,this.r])}deregisterLogger(d){super.deregisterLogger(d),this.t.call("deregisterLogger",[d,this.r])}setLogLevel(d,f){super.setLogLevel(d,f),this.t.call("setLogLevel",[d,f])}setVisibility(d,f){super.setVisibility(d,f),this.t.call("setVisibility",[this.n(d),f])}s(d,f,$){return new O(this.t,d,f,$,this.r)}static setLogLevel(d,f,$){return d.call("setLogLevel",[f,$])}}e.$qs=N;class O extends L.$dk{constructor(d,f,$,l,p){super(l?.logLevel==="always"),this.r=d,this.s=f,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[f,l,p]).then(()=>{this.u(this.n),this.m=!0})}g(d,f){const $=[[d,f]];this.m?this.u($):this.n.push(...$)}u(d){this.r.call("log",[this.s,d])}}class k{constructor(d,f){this.a=d,this.b=f}listen(d,f){const $=this.b(d);switch(f){case"onDidChangeLoggers":return c.Event.map(this.a.onDidChangeLoggers,l=>({added:[...l.added].map(p=>this.c(p,$)),removed:[...l.removed].map(p=>this.c(p,$))}));case"onDidChangeVisibility":return c.Event.map(this.a.onDidChangeVisibility,l=>[$.transformOutgoingURI(l[0]),l[1]]);case"onDidChangeLogLevel":return c.Event.map(this.a.onDidChangeLogLevel,l=>(0,L.$_j)(l)?l:[$.transformOutgoingURI(l[0]),l[1]])}throw new Error(`Event not found: ${f}`)}async call(d,f,$){const l=this.b(d);switch(f){case"setLogLevel":return(0,L.$_j)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(I.URI.revive(l.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,l)))}throw new Error(`Call not found: ${f}`)}c(d,f){return{...d,resource:f.transformOutgoingURI(d.resource)}}}e.$rs=k;class b extends A.$Tc{constructor(d,f){super(),f.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel($=>f.call("setLogLevel",[$]))),f.call("getRegisteredLoggers").then($=>{for(const l of $)d.registerLogger({...l,resource:I.URI.revive(l.resource)})}),this.B(f.listen("onDidChangeVisibility")(([$,l])=>d.setVisibility(I.URI.revive($),l))),this.B(f.listen("onDidChangeLoggers")(({added:$,removed:l})=>{for(const p of $)d.registerLogger({...p,resource:I.URI.revive(p.resource)});for(const p of l)d.deregisterLogger(p.resource)}))}}e.$ss=b}),define(he[175],ue([0,1,2,10]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qR=void 0;class L extends I.$Tc{constructor(N,O=[]){super(),this.a=new c.$hk([N,...O]),this.B(N.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...O){this.a.trace(N,...O)}debug(N,...O){this.a.debug(N,...O)}info(N,...O){this.a.info(N,...O)}warn(N,...O){this.a.warn(N,...O)}error(N,...O){this.a.error(N,...O)}flush(){this.a.flush()}}e.$qR=L}),define(he[57],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0,e.$Hfc=(0,I.$Ci)("nativeHostService")}),define(he[176],ue([0,1,42,56]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;let L=class{constructor(N,O){return this.windowId=N,I.ProxyChannel.toService(O.getChannel("nativeHost"),{context:N,properties:(()=>{const k=new Map;return k.set("windowId",N),k})()})}};e.$3gc=L,e.$3gc=L=ve([Q(1,c.$Zgc)],L)}),define(he[58],ue([0,1,3,63,2,4]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=void 0,e.$qo=(0,A.$Ci)("policy");class N extends L.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$je),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const R=Object.keys(this.f).length;return this.f={...b,...this.f},R!==Object.keys(this.f).length&&await this.j(b),c.Iterable.reduce(this.g.entries(),(d,[f,$])=>({...d,[f]:$}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return c.Iterable.reduce(Object.entries(this.f),(b,[R,d])=>({...b,[R]:{definition:d,value:this.g.get(R)}}),{})}}e.$ro=N;class O{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$so=O}),define(he[177],ue([0,1,3,2,58]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=e.$tgc=void 0;class A{constructor(k){this.b=k,this.a=new c.$Sc}listen(k,b){switch(b){case"onDidChange":return I.Event.map(this.b.onDidChange,R=>R.reduce((d,f)=>({...d,[f]:this.b.getPolicyValue(f)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(k,b,R){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$tgc=A;class N extends L.$ro{constructor(k,b){super(),this.a=b;for(const R in k){const{definition:d,value:f}=k[R];this.f[R]=d,f!==void 0&&this.g.set(R,f)}this.a.listen("onDidChange")(R=>{for(const d in R){const f=R[d];f===null?this.g.delete(d):this.g.set(d,f)}this.h.fire(Object.keys(R))})}async j(k){const b=await this.a.call("updatePolicyDefinitions",k);for(const R in b)this.g.set(R,b[R])}}e.$ugc=N}),define(he[102],ue([0,1,37]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)c=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:A.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(he[23],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$qk=(0,I.$Ci)("productService"),e.$rk="vscode://schemas/vscode-product"}),define(he[178],ue([0,1,32,6,8,2,13,30,10,23]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0,I=ke(I);let R=class extends A.$Tc{constructor(f,$,l){super(),this.b=$,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,f&&this.B(new c.$Oh(()=>{this.f(f)},3e4)).schedule()}async f(f){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),l=(0,N.$lc)(f),p=(0,N.$mc)(f),S=await O.Promises.readdir(l);await Promise.all(S.map(async g=>{if(g===p)return;const w=(0,N.$ic)(l,g),P=await I.promises.stat(w);if(P.isDirectory()&&$-P.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),O.Promises.rm(w)}))}catch($){(0,L.$Y)($)}}};e.$ehc=R,e.$ehc=R=ve([Q(1,b.$qk),Q(2,k.$0j)],R)}),define(he[179],ue([0,1,32,6,8,2,13,30,15,10,23]),function(oe,e,I,c,L,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0,I=ke(I);let d=class extends A.$Tc{constructor($,l,p){super(),this.b=$,this.c=l,this.f=p,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new c.$Oh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),l=JSON.parse(await I.promises.readFile((0,N.$ic)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const P of Object.keys(l)){const m=l[P];$[`${m.hash}.${P}`]=!0}const p=(0,N.$ic)(this.b.userDataPath,"clp");if(!await O.Promises.exists(p))return;const g=await O.Promises.readdir(p);for(const P of g){if($[P]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${P}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${P}`),await O.Promises.rm((0,N.$ic)(p,P))}const w=Date.now();for(const P of Object.keys($)){const m=(0,N.$ic)(p,P),o=await O.Promises.readdir(m);for(const h of o){if(h==="tcf.json")continue;const i=(0,N.$ic)(m,h),s=await I.promises.stat(i);s.isDirectory()&&w-s.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,N.$ic)(P,h)}`),await O.Promises.rm(i))}}}catch($){(0,L.$Y)($)}}};e.$fhc=d,e.$fhc=d=ve([Q(0,k.$Ki),Q(1,b.$0j),Q(2,R.$qk)],d)}),define(he[180],ue([0,1,13,4]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$NG=void 0,e.$NG=(0,c.$Ci)("IV8InspectProfilingService");var L;(function(A){function N(k){return!!(k.samples&&k.timeDeltas)}A.isValidProfile=N;function O(k,b="noAbsolutePaths"){for(const R of k.nodes)R.callFrame&&R.callFrame.url&&((0,I.$hc)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,I.$ic)(b,(0,I.$mc)(R.callFrame.url)));return k}A.rewriteAbsolutePaths=O})(L||(e.Utils=L={}))}),define(he[181],ue([0,1,31]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class c{constructor(){this.a=new Map}async startProfiling(A){const O=await(await new Promise((b,R)=>{oe(["v8-inspect-profiler"],b,R)}).then(ke)).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),k=(0,I.$Yg)();return this.a.set(k,O),k}async stopProfiling(A){const N=this.a.get(A);if(!N)throw new Error(`UNKNOWN session '${A}'`);const O=await N.stop();return this.a.delete(A),O.profile}}e.$whc=c}),define(he[44],ue([0,1,131,12]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=void 0,I=ke(I),c=ke(c);class L{constructor(){this.a=new Map}add(N,O){I.ok(c.$cg(N)),I.ok(c.$eg(O)),I.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,O)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$oo=new L}),define(he[103],ue([0,1,3,44]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,c=ke(c),e.$po={JSONContribution:"base.contributions.json"};function L(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class A{constructor(){this.b=new I.$je,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,b){this.a[L(k)]=b,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const N=new A;c.$oo.add(e.$po.JSONContribution,N)}),define(he[47],ue([0,1,17,3,12,11,21,103,44]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.ConfigurationScope=e.$to=e.EditPresentationTypes=void 0,e.$Eo=p,e.$Fo=S,e.$Go=g,e.$Ho=P,e.$Io=m,e.$Jo=o,e.$Ko=h,L=ke(L),A=ke(A);var b;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$to={Configuration:"base.contributions.configuration"};var R;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao="vscode://schemas/settings/resourceLanguage",e.$Bo="vscode://schemas/settings/configurationDefaults";const d=k.$oo.as(O.$po.JSONContribution);class f{constructor(){this.a=[],this.i=new Set,this.j=new c.$je,this.onDidSchemaChange=this.j.event,this.k=new c.$je,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:A.localize(11444,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},d.registerSchema(e.$Ao,this.h),this.z()}registerConfiguration(s,t=!0){this.registerConfigurations([s],t)}registerConfigurations(s,t=!0){const n=new Set;this.r(s,t,n),d.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:n})}deregisterConfigurations(s){const t=new Set;this.s(s,t),d.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:s,remove:t}){const n=new Set;this.s(t,n),this.r(s,!1,n),d.registerSchema(e.$Ao,this.h),this.j.fire(),this.k.fire({properties:n})}registerDefaultConfigurations(s){const t=new Set;this.l(s,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(s,t){this.a.push(...s);const n=[];for(const{overrides:r,source:a}of s)for(const u in r){t.add(u);const y=this.b.get(u)??this.b.set(u,{configurationDefaultOverrides:[]}).get(u),C=r[u];if(y.configurationDefaultOverrides.push({value:C,source:a}),e.$Do.test(u)){const v=this.o(u,C,a,y.configurationDefaultOverrideValue);if(!v)continue;y.configurationDefaultOverrideValue=v,this.n(u,v,a),n.push(...p(u))}else{const v=this.p(u,C,a,y.configurationDefaultOverrideValue);if(!v)continue;y.configurationDefaultOverrideValue=v;const E=this.e[u];E&&(this.A(u,E),this.w(u,E))}}this.q(n)}deregisterDefaultConfigurations(s){const t=new Set;this.m(s,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(s,t){for(const n of s){const r=this.a.indexOf(n);r!==-1&&this.a.splice(r,1)}for(const{overrides:n,source:r}of s)for(const a in n){const u=this.b.get(a);if(!u)continue;const y=u.configurationDefaultOverrides.findIndex(C=>r?C.source?.id===r.id:C.value===n[a]);if(y!==-1){if(u.configurationDefaultOverrides.splice(y,1),u.configurationDefaultOverrides.length===0&&this.b.delete(a),e.$Do.test(a)){let C;for(const v of u.configurationDefaultOverrides)C=this.o(a,v.value,v.source,C);C&&!L.$pg(C.value)?(u.configurationDefaultOverrideValue=C,this.n(a,C,r)):(this.b.delete(a),delete this.e[a],delete this.c.properties[a])}else{let C;for(const E of u.configurationDefaultOverrides)C=this.p(a,E.value,E.source,C);u.configurationDefaultOverrideValue=C;const v=this.e[a];v&&(this.A(a,v),this.w(a,v))}t.add(a)}}this.y()}n(s,t,n){const r={type:"object",default:t.value,description:A.localize(11445,null,(0,N.$gj)(s)),$ref:e.$Ao,defaultDefaultValue:t.value,source:n,defaultValueSource:n};this.e[s]=r,this.c.properties[s]=r}o(s,t,n,r){const a=r?.value||{},u=r?.source??new Map;if(!(u instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const y of Object.keys(t)){const C=t[y];if(L.$eg(C)&&(L.$jg(a[y])||L.$eg(a[y]))){if(a[y]={...a[y]??{},...C},n)for(const E in C)u.set(`${y}.${E}`,n)}else a[y]=C,n?u.set(y,n):u.delete(y)}return{value:a,source:u}}p(s,t,n,r){const a=this.e[s],u=r?.value??a?.defaultDefaultValue;let y=n;if(L.$eg(t)&&(a!==void 0&&a.type==="object"||a===void 0&&(L.$jg(u)||L.$eg(u)))){if(y=r?.source??new Map,!(y instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const v in t)n&&y.set(`${s}.${v}`,n);t={...L.$eg(u)?u:{},...t}}return{value:t,source:y}}deltaConfiguration(s){let t=!1;const n=new Set;s.removedDefaults&&(this.m(s.removedDefaults,n),t=!0),s.addedDefaults&&(this.l(s.addedDefaults,n),t=!0),s.removedConfigurations&&this.s(s.removedConfigurations,n),s.addedConfigurations&&this.r(s.addedConfigurations,!1,n),this.j.fire(),this.k.fire({properties:n,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...s){this.j.fire()}registerOverrideIdentifiers(s){this.q(s),this.j.fire()}q(s){for(const t of s)this.i.add(t);this.y()}r(s,t,n){s.forEach(r=>{this.u(r,t,r.extensionInfo,r.restrictedProperties,void 0,n),this.d.push(r),this.v(r)})}s(s,t){const n=r=>{if(r.properties)for(const a in r.properties){t.add(a);const u=this.e[a];u?.policy?.name&&this.f.delete(u.policy.name),delete this.e[a],this.x(a,r.properties[a])}r.allOf?.forEach(a=>n(a))};for(const r of s){n(r);const a=this.d.indexOf(r);a!==-1&&this.d.splice(a,1)}}u(s,t=!0,n,r,a=R.WINDOW,u){a=L.$lg(s.scope)?a:s.scope;const y=s.properties;if(y)for(const v in y){const E=y[v];if(t&&P(v,E)){delete y[v];continue}if(E.source=n,E.defaultDefaultValue=y[v].default,this.A(v,E),e.$Do.test(v)?E.scope=void 0:(E.scope=L.$lg(E.scope)?a:E.scope,E.restricted=L.$lg(E.restricted)?!!r?.includes(v):E.restricted),y[v].hasOwnProperty("included")&&!y[v].included){this.g[v]=y[v],delete y[v];continue}else this.e[v]=y[v],y[v].policy?.name&&this.f.set(y[v].policy.name,v);!y[v].deprecationMessage&&y[v].markdownDeprecationMessage&&(y[v].deprecationMessage=y[v].markdownDeprecationMessage),u.add(v)}const C=s.allOf;if(C)for(const v of C)this.u(v,t,n,r,a,u)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const s=new Map;for(const[t,n]of this.b)n.configurationDefaultOverrideValue&&s.set(t,n.configurationDefaultOverrideValue);return s}v(s){const t=n=>{const r=n.properties;if(r)for(const u in r)this.w(u,r[u]);n.allOf?.forEach(t)};t(s)}w(s,t){switch(e.$uo.properties[s]=t,t.scope){case R.APPLICATION:e.$vo.properties[s]=t;break;case R.MACHINE:e.$wo.properties[s]=t;break;case R.MACHINE_OVERRIDABLE:e.$xo.properties[s]=t;break;case R.WINDOW:e.$yo.properties[s]=t;break;case R.RESOURCE:e.$zo.properties[s]=t;break;case R.LANGUAGE_OVERRIDABLE:e.$zo.properties[s]=t,this.h.properties[s]=t;break}}x(s,t){switch(delete e.$uo.properties[s],t.scope){case R.APPLICATION:delete e.$vo.properties[s];break;case R.MACHINE:delete e.$wo.properties[s];break;case R.MACHINE_OVERRIDABLE:delete e.$xo.properties[s];break;case R.WINDOW:delete e.$yo.properties[s];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$zo.properties[s],delete this.h.properties[s];break}}y(){for(const s of this.i.values()){const t=`[${s}]`,n={type:"object",description:A.localize(11446,null),errorMessage:A.localize(11447,null),$ref:e.$Ao};this.A(t,n),e.$uo.properties[t]=n,e.$vo.properties[t]=n,e.$wo.properties[t]=n,e.$xo.properties[t]=n,e.$yo.properties[t]=n,e.$zo.properties[t]=n}}z(){const s={type:"object",description:A.localize(11448,null),errorMessage:A.localize(11449,null),$ref:e.$Ao};e.$uo.patternProperties[e.$Co]=s,e.$vo.patternProperties[e.$Co]=s,e.$wo.patternProperties[e.$Co]=s,e.$xo.patternProperties[e.$Co]=s,e.$yo.patternProperties[e.$Co]=s,e.$zo.patternProperties[e.$Co]=s,this.j.fire()}A(s,t){const n=this.b.get(s)?.configurationDefaultOverrideValue;let r,a;n&&(!t.disallowConfigurationDefault||!n.source)&&(r=n.value,a=n.source),L.$jg(r)&&(r=t.defaultDefaultValue,a=void 0),L.$jg(r)&&(r=g(t.type)),t.default=r,t.defaultValueSource=a}}const $="\\[([^\\]]+)\\]",l=new RegExp($,"g");e.$Co=`^(${$})+$`,e.$Do=new RegExp(e.$Co);function p(i){const s=[];if(e.$Do.test(i)){let t=l.exec(i);for(;t?.length;){const n=t[1].trim();n&&s.push(n),t=l.exec(i)}}return(0,I.$Lb)(s)}function S(i){return i.reduce((s,t)=>`${s}[${t}]`,"")}function g(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new f;k.$oo.add(e.$to.Configuration,w);function P(i,s){return i.trim()?e.$Do.test(i)?A.localize(11451,null,i):w.getConfigurationProperties()[i]!==void 0?A.localize(11452,null,i):s.policy?.name&&w.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(11453,null,i,s.policy?.name,w.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(11450,null)}function m(){const i=[],s=w.getConfigurationProperties();for(const t of Object.keys(s))i.push([t,s[t].scope]);return i.push(["launch",R.RESOURCE]),i.push(["task",R.RESOURCE]),i}function o(i){const s={};for(const t of i){const n=t.properties;if(L.$eg(n))for(const r in n)s[r]=n[r];t.allOf&&Object.assign(s,o(t.allOf))}return s}function h(i){switch(i){case"application":return R.APPLICATION;case"machine":return R.MACHINE;case"resource":return R.RESOURCE;case"machine-overridable":return R.MACHINE_OVERRIDABLE;case"language-overridable":return R.LANGUAGE_OVERRIDABLE;default:return R.WINDOW}}}),define(he[77],ue([0,1,17,3,35,2,36,29,12,9,21,47,7,44]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0,e.$Po=m,I=ke(I),L=ke(L),O=ke(O),k=ke(k);function l(s){return Object.isFrozen(s)?s:O.$co(s)}class p{static createEmptyModel(t){return new p({},[],[],void 0,t)}constructor(t,n,r,a,u){this.b=t,this.c=n,this.d=r,this.raw=a,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof p)return n;const r=new S("",this.f);return r.parseRaw(n),r.configurationModel});this.g=t.reduce((n,r)=>r===n?r:n.merge(r),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,R.$ej)(this.contents,t):this.contents}inspect(t,n){const r=this;return{get value(){return l(r.rawConfiguration.getValue(t))},get override(){return n?l(r.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return l(n?r.rawConfiguration.override(n).getValue(t):r.rawConfiguration.getValue(t))},get overrides(){const a=[];for(const{contents:u,identifiers:y,keys:C}of r.rawConfiguration.overrides){const v=new p(u,C,[],void 0,r.f).getValue(t);v!==void 0&&a.push({identifiers:y,value:v})}return a.length?l(a):void 0}}}getOverrideValue(t,n){const r=this.j(n);return r?t?(0,R.$ej)(r,t):r:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const r of this.overrides)r.identifiers.includes(t)&&n.push(...r.keys);return I.$Lb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return I.$Lb(t)}override(t){let n=this.a.get(t);return n||(n=this.h(t),this.a.set(t,n)),n}merge(...t){const n=O.$bo(this.contents),r=O.$bo(this.overrides),a=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const y of t)if(u.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(n,y.contents);for(const C of y.overrides){const[v]=r.filter(E=>I.$tb(E.identifiers,C.identifiers));v?(this.i(v.contents,C.contents),v.keys.push(...C.keys),v.keys=I.$Lb(v.keys)):r.push(O.$bo(C))}for(const C of y.keys)a.indexOf(C)===-1&&a.push(C)}return new p(n,a,r,u.every(y=>y instanceof p)?void 0:u,this.f)}h(t){const n=this.j(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const a of I.$Lb([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[a];const y=n[a];y&&(typeof u=="object"&&typeof y=="object"?(u=O.$bo(u),this.i(u,y)):u=y),r[a]=u}return new p(r,this.keys,this.overrides,void 0,this.f)}i(t,n){for(const r of Object.keys(n)){if(r in t&&k.$eg(t[r])&&k.$eg(n[r])){this.i(t[r],n[r]);continue}t[r]=O.$bo(n[r])}}j(t){let n=null,r=null;const a=u=>{u&&(r?this.i(r,u):r=O.$bo(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?n=u.contents:u.identifiers.includes(t)&&a(u.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.k(t,n,!0)}setValue(t,n){this.k(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,R.$dj)(this.contents,t),d.$Do.test(t)&&this.overrides.splice(this.overrides.findIndex(r=>I.$tb(r.identifiers,(0,d.$Eo)(t))),1))}k(t,n,r){if((0,R.$cj)(this.contents,t,n,a=>this.f.error(a)),r=r||this.keys.indexOf(t)===-1,r&&this.keys.push(t),d.$Do.test(t)){const a=(0,d.$Eo)(t),u={identifiers:a,keys:Object.keys(this.contents[t]),contents:(0,R.$bj)(this.contents[t],C=>this.f.error(C))},y=this.overrides.findIndex(C=>I.$tb(C.identifiers,a));y!==-1?this.overrides[y]=u:this.overrides.push(u)}}}e.$Lo=p;class S{constructor(t,n){this.f=t,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!k.$lg(t)){const r=this.h(t);this.parseRaw(r,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:r,keys:a,overrides:u,restricted:y,hasExcludedProperties:C}=this.i(t,n);this.b=new p(r,a,u,C?[t]:void 0,this.g),this.c=y||[]}h(t){let n={},r=null,a=[];const u=[],y=[];function C(E){Array.isArray(a)?a.push(E):r!==null&&(a[r]=E)}const v={onObjectBegin:()=>{const E={};C(E),u.push(a),a=E,r=null},onObjectProperty:E=>{r=E},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{const E=[];C(E),u.push(a),a=E,r=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:C,onError:(E,T,F)=>{y.push({error:E,offset:T,length:F})}};if(t)try{L.$3n(t,v),n=a[0]||{}}catch(E){this.g.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return n}i(t,n){const r=$.$oo.as(d.$to.Configuration).getConfigurationProperties(),a=this.j(t,r,!0,n);t=a.raw;const u=(0,R.$bj)(t,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),y=Object.keys(t),C=this.l(t,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:u,keys:y,overrides:C,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(t,n,r,a){let u=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const y={},C=[];for(const v in t)if(d.$Do.test(v)&&r){const E=this.j(t[v],n,!1,a);y[v]=E.raw,u=u||E.hasExcludedProperties,C.push(...E.restricted)}else{const E=n[v],T=E?typeof E.scope<"u"?E.scope:d.ConfigurationScope.WINDOW:void 0;E?.restricted&&C.push(v),!a.exclude?.includes(v)&&(a.include?.includes(v)||(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&!(a.skipRestricted&&E?.restricted))?y[v]=t[v]:u=!0}return{raw:y,restricted:C,hasExcludedProperties:u}}l(t,n){const r=[];for(const a of Object.keys(t))if(d.$Do.test(a)){const u={};for(const y in t[a])u[y]=t[a][y];r.push({identifiers:(0,d.$Eo)(a),keys:Object.keys(u),contents:(0,R.$bj)(u,n)})}return r}}e.$Mo=S;class g extends A.$Tc{constructor(t,n,r,a,u){super(),this.c=t,this.f=n,this.g=a,this.h=u,this.b=this.B(new c.$je),this.onDidChange=this.b.event,this.a=new S(this.c.toString(),u),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(c.Event.any(c.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),c.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(f.FileOperation.CREATE)||y.isOperation(f.FileOperation.COPY)||y.isOperation(f.FileOperation.DELETE)||y.isOperation(f.FileOperation.WRITE))&&r.isEqual(y.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$No=g;class w{constructor(t,n,r,a,u,y,C,v,E,T,F,U,j){this.a=t,this.b=n,this.c=r,this.overrideIdentifiers=a,this.d=u,this.f=y,this.g=C,this.h=v,this.i=E,this.j=T,this.k=F,this.l=U,this.m=j}get value(){return l(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,n,r,a,u,y,C,v,E,T){this.j=t,this.l=n,this.m=r,this.n=a,this.p=u,this.q=y,this.r=C,this.s=v,this.t=E,this.u=T,this.h=null,this.i=new N.$zc,this.v=null}getValue(t,n,r){return this.w(t,n,r).getValue(t)}updateValue(t,n,r={}){let a;r.resource?(a=this.t.get(r.resource),a||(a=p.createEmptyModel(this.u),this.t.set(r.resource,a))):a=this.s,n===void 0?a.removeValue(t):a.setValue(t,n),r.resource||(this.h=null)}inspect(t,n,r){const a=this.w(t,n,r),u=this.A(n.resource,r),y=n.resource?this.t.get(n.resource)||this.s:this.s,C=new Set;for(const v of a.overrides)for(const E of v.identifiers)a.getOverrideValue(t,E)!==void 0&&C.add(E);return new w(t,n,a.getValue(t),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.q:void 0,u||void 0,y)}keys(t){const n=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,n){this.r.set(t,n),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=[];if(!n){const{added:a,updated:u,removed:y}=h(this.j,t);n=[...a,...u,...y]}for(const a of n)for(const u of(0,d.$Eo)(a)){const y=this.j.getKeysForOverrideIdentifier(u),C=t.getKeysForOverrideIdentifier(u),v=[...C.filter(E=>y.indexOf(E)===-1),...y.filter(E=>C.indexOf(E)===-1),...y.filter(E=>!O.$fo(this.j.override(u).getValue(E),t.override(u).getValue(E)))];r.push([u,v])}return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:r,removed:a}=h(this.l,t),u=[...n,...r,...a];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:r,removed:a,overrides:u}=h(this.applicationConfiguration,t),y=[...n,...r,...a];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:a,overrides:u}=h(this.localUserConfiguration,t),y=[...n,...r,...a];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:a,overrides:u}=h(this.remoteUserConfiguration,t),y=[...n,...r,...a];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:a,overrides:u}=h(this.workspaceConfiguration,t),y=[...n,...r,...a];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:a,updated:u,removed:y,overrides:C}=h(r,n),v=[...a,...u,...y];return(v.length||!r)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:C}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:a,removed:u,overrides:y}=h(n,void 0);return{keys:[...r,...a,...u],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,n,r){let a=this.x(n,r);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(a=a.merge(this.l)),a}x({resource:t},n){let r=this.y();if(n&&t){const a=n.getFolder(t);a&&(r=this.z(a.uri)||r);const u=this.t.get(t);u&&(r=r.merge(u))}return r}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let n=this.i.get(t);if(!n){const r=this.y(),a=this.r.get(t);a?(n=r.merge(a),this.i.set(t,n)):n=r}return n}A(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this.r.get(r.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,n)=>{const{contents:r,overrides:a,keys:u}=this.r.get(n);return t.push([n,{contents:r,overrides:a,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.q.keys.forEach(n=>t.add(n)),this.r.forEach(n=>n.keys.forEach(r=>t.add(r))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>t.add(r))),[...t.values()]}D(t){const n=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.q.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.r.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t,n){const r=this.E(t.defaults,n),a=this.E(t.policy,n),u=this.E(t.application,n),y=this.E(t.user,n),C=this.E(t.workspace,n),v=t.folders.reduce((E,T)=>(E.set(b.URI.revive(T[0]),this.E(T[1],n)),E),new N.$zc);return new P(r,a,u,y,p.createEmptyModel(n),C,v,p.createEmptyModel(n),new N.$zc,n)}static E(t,n){return new p(t.contents,t.keys,t.overrides,void 0,n)}}e.$Oo=P;function m(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,n=new Map;for(const a of s)a.keys.forEach(u=>t.add(u)),a.overrides.forEach(([u,y])=>{const C=(0,N.$wc)(n,u,new Set);y.forEach(v=>C.add(v))});const r=[];return n.forEach((a,u)=>r.push([u,[...a.values()]])),{keys:[...t.values()],overrides:r}}class o{constructor(t,n,r,a,u){this.change=t,this.f=n,this.g=r,this.h=a,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of t.keys)this.affectedKeys.add(y);for(const[,y]of t.overrides)for(const C of y)this.affectedKeys.add(C);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,n){const r=this.a+t,a=this.d.indexOf(r);if(a<0)return!1;const u=a+r.length;if(u>=this.d.length)return!1;const y=this.d.charCodeAt(u);if(y!==this.b&&y!==this.c)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,v=this.g.getValue(t,n,this.h);return!O.$fo(C,v)}return!0}}e.$Qo=o;function h(s,t){const{added:n,removed:r,updated:a}=i(t?.rawConfiguration,s?.rawConfiguration),u=[],y=s?.getAllOverrideIdentifiers()||[],C=t?.getAllOverrideIdentifiers()||[];if(t){const v=C.filter(E=>!y.includes(E));for(const E of v)u.push([E,t.getKeysForOverrideIdentifier(E)])}if(s){const v=y.filter(E=>!C.includes(E));for(const E of v)u.push([E,s.getKeysForOverrideIdentifier(E)])}if(t&&s){for(const v of y)if(C.includes(v)){const E=i({contents:s.getOverrideValue(void 0,v)||{},keys:s.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});u.push([v,[...E.added,...E.removed,...E.updated]])}}return{added:n,removed:r,updated:a,overrides:u}}function i(s,t){const n=s?t?s.keys.filter(u=>t.keys.indexOf(u)===-1):[...s.keys]:[],r=t?s?t.keys.filter(u=>s.keys.indexOf(u)===-1):[...t.keys]:[],a=[];if(s&&t){for(const u of t.keys)if(s.keys.indexOf(u)!==-1){const y=(0,R.$ej)(t.contents,u),C=(0,R.$ej)(s.contents,u);O.$fo(y,C)||a.push(u)}}return{added:n,removed:r,updated:a}}}),define(he[182],ue([0,1,17,3,2,29,12,77,47,10,58,44]),function(oe,e,I,c,L,A,N,O,k,b,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.$Ro=void 0;class f extends L.$Tc{get configurationModel(){return this.b}constructor(S){super(),this.c=S,this.a=this.B(new c.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Lo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(d.$oo.as(k.$to.Configuration).onDidUpdateConfiguration(({properties:S,defaultsOverrides:g})=>this.f(Array.from(S),g))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(S,g){this.j(S,d.$oo.as(k.$to.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:S})}g(){return{}}h(){this.b=O.$Lo.createEmptyModel(this.c);const S=d.$oo.as(k.$to.Configuration).getConfigurationProperties();this.j(Object.keys(S),S)}j(S,g){const w=this.g();for(const P of S){const m=w[P],o=g[P];m!==void 0?this.b.setValue(P,m):o?this.b.setValue(P,o.default):this.b.removeValue(P)}}}e.$Ro=f;class ${constructor(){this.onDidChangeConfiguration=c.Event.None,this.configurationModel=O.$Lo.createEmptyModel(new b.$kk)}async initialize(){return this.configurationModel}}e.$So=$;let l=class extends L.$Tc{get configurationModel(){return this.b}constructor(S,g,w){super(),this.c=S,this.f=g,this.g=w,this.a=this.B(new c.$je),this.onDidChangeConfiguration=this.a.event,this.b=O.$Lo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(S=>this.j(S))),this.B(this.c.onDidChangeConfiguration(async({properties:S})=>this.m(await this.h(S),!0))),this.b}async h(S){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",S);const g={},w=[],P=d.$oo.as(k.$to.Configuration).getConfigurationProperties();for(const m of S){const o=P[m];if(!o){w.push(m);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.g.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}w.push(m),g[o.policy.name]={type:o.type}}}return(0,N.$pg)(g)||await this.f.updatePolicyDefinitions(g),w}j(S){this.g.trace("PolicyConfiguration#onDidChangePolicies",S);const g=d.$oo.as(k.$to.Configuration).getPolicyConfigurations(),w=(0,I.$Gb)(S.map(P=>g.get(P)));this.m(w,!0)}m(S,g){this.g.trace("PolicyConfiguration#update",S);const w=d.$oo.as(k.$to.Configuration).getConfigurationProperties(),P=[],m=this.b.isEmpty();for(const o of S){const h=w[o]?.policy?.name;if(h){const i=this.f.getPolicyValue(h);(m?i!==void 0:!(0,A.$fo)(this.b.getValue(o),i))&&P.push([o,i])}else this.b.getValue(o)!==void 0&&P.push([o,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const o=this.b;this.b=O.$Lo.createEmptyModel(this.g);for(const h of o.keys)this.b.setValue(h,o.getValue(h));for(const[h,i]of P)i===void 0?this.b.removeValue(h):this.b.setValue(h,i);g&&this.a.fire(this.b)}}};e.$To=l,e.$To=l=ve([Q(1,R.$qo),Q(2,b.$0j)],l)}),define(he[183],ue([0,1,17,6,14,3,35,64,2,36,29,5,20,21,77,47,182,7,58]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=void 0;class P extends k.$Tc{constructor(h,i,s,t){super(),this.m=h,this.n=t,this.h=this.B(new A.$je),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$Ro(t)),this.c=s instanceof w.$so?new S.$So:this.B(new S.$To(this.b,s,t)),this.f=this.B(new l.$No(this.m,{},f.$7g,i,t)),this.a=new l.$Oo(this.b.configurationModel,this.c.configurationModel,l.$Lo.createEmptyModel(t),l.$Lo.createEmptyModel(t),l.$Lo.createEmptyModel(t),l.$Lo.createEmptyModel(t),new b.$zc,l.$Lo.createEmptyModel(t),new b.$zc,t),this.j=new m(h,i,this),this.g=this.B(new c.$Oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:r})=>this.s(n,r))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,i,s]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$Oo(h,i,l.$Lo.createEmptyModel(this.n),s,l.$Lo.createEmptyModel(this.n),l.$Lo.createEmptyModel(this.n),new b.$zc,l.$Lo.createEmptyModel(this.n),new b.$zc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,i){const s=typeof h=="string"?h:void 0,t=(0,$.$0i)(h)?h:(0,$.$0i)(i)?i:{};return this.a.getValue(s,t,void 0)}async updateValue(h,i,s,t,n){const r=(0,$.$$i)(s)?s:(0,$.$0i)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,a=r?t:s;if(a!==void 0&&a!==$.ConfigurationTarget.USER_LOCAL&&a!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${h} to target ${a}.`);r?.overrideIdentifiers&&(r.overrideIdentifiers=(0,I.$Lb)(r.overrideIdentifiers),r.overrideIdentifiers=r.overrideIdentifiers.length?r.overrideIdentifiers:void 0);const u=this.inspect(h,{resource:r?.resource,overrideIdentifier:r?.overrideIdentifiers?r.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,R.$fo)(i,u.defaultValue)&&(i=void 0),r?.overrideIdentifiers?.length&&r.overrideIdentifiers.length>1){const C=r.overrideIdentifiers.sort(),v=this.a.localUserConfiguration.overrides.find(E=>(0,I.$tb)([...E.identifiers].sort(),C));v&&(r.overrideIdentifiers=v.identifiers)}const y=r?.overrideIdentifiers?.length?[(0,p.$Fo)(r.overrideIdentifiers),h]:[h];await this.j.write(y,i),await this.reloadConfiguration()}inspect(h,i={}){return this.a.inspect(h,i,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const i=this.a.toData(),s=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(s,i,$.ConfigurationTarget.USER)}s(h,i){const s=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(h,i);this.u(t,s,$.ConfigurationTarget.DEFAULT)}t(h){const i=this.a.toData(),s=this.a.compareAndUpdatePolicyConfiguration(h);this.u(s,i,$.ConfigurationTarget.DEFAULT)}u(h,i,s){const t=new l.$Qo(h,{data:i},this.a,void 0,this.n);t.source=s,this.h.fire(t)}}e.$Uo=P;class m{constructor(h,i,s){this.b=h,this.c=i,this.d=s,this.a=new c.$Jh}write(h,i){return this.a.queue(()=>this.e(h,i))}async e(h,i){let s;try{s=(await this.c.readFile(this.b)).value.toString()}catch(r){if(r.fileOperationResult===g.FileOperationResult.FILE_NOT_FOUND)s="{}";else throw r}const t=[];if((0,N.$Vn)(s,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(s,h,i);s=(0,O.$ao)(s,n),await this.c.writeFile(this.b,L.$Le.fromString(s))}f(h,i,s){const{tabSize:t,insertSpaces:n,eol:r}=this.h;if(!i.length){const a=JSON.stringify(s,null,n?" ".repeat(t):"	");return[{content:a,length:a.length,offset:0}]}return(0,O.$0n)(h,i,s,{tabSize:t,insertSpaces:n,eol:r})}get h(){if(!this.g){let h=d.OS===d.OperatingSystem.Linux||d.OS===d.OperatingSystem.Macintosh?`
`:`\r
`;const i=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});i&&typeof i=="string"&&i!=="auto"&&(h=i),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(he[184],ue([0,1,14,3,2,69]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dxb=e.$bxb=e.$axb=void 0,e.$cxb=O;const N=(b,R,d)=>{const f=new Uint8Array(16);for(let p=0;p<16;p++)f[p]=Math.round(Math.random()*256);const $=(0,I.$6e)(I.$Le.wrap(f));return[`GET ws://localhost${b}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${$}`].join(`\r
`)+`\r
\r
`};e.$axb=N,e.$bxb=I.$Le.fromString(`\r
\r
`);async function O(b,R,d,f,$){b.write(I.$Le.fromString((0,e.$axb)(R,d,f)));const l=new L.$Sc;try{return await new Promise((p,S)=>{let g;l.add(b.onData(w=>{g?g=I.$Le.concat([g,w],g.byteLength+w.byteLength):g=w;const P=g.indexOf(e.$bxb);if(P===-1)return;p(b),b.pauseData();const m=g.slice(P+e.$bxb.byteLength);m.byteLength&&$.onData.fire(m)})),l.add(b.onClose(w=>S(w??new Error("socket closed")))),l.add(b.onEnd(()=>S(new Error("socket ended"))))})}catch(p){throw b.dispose(),p}finally{l.dispose()}}class k extends L.$Tc{constructor(R,d){super(),this.g=R,this.a=this.B(new c.$me),this.onData=(...f)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...f)),this.b=this.B(new c.$je),this.onDidDispose=this.b.event,this.f=!1,this.B(d.onData),this.B(d.onData.event(f=>this.a.fire(f))),this.onClose=this.B(d.onClose).event,this.onEnd=this.B(d.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,d){A.SocketDiagnostics.traceSocketEvent(this,this.g,R,d)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$dxb=k}),define(he[104],ue([0,1,8,4]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.RemoteAuthorityResolverErrorCode=e.$Ql=e.$Pl=e.RemoteConnectionType=e.$Ol=void 0,e.$Sl=b,e.$Ol=(0,c.$Ci)("remoteAuthorityResolverService");var L;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(d){this.id=d,this.type=L.Managed}toString(){return`Managed(${this.id})`}}e.$Pl=A;class N{constructor(d,f){this.host=d,this.port=f,this.type=L.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ql=N;var O;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class k extends I.$ab{static isNotAvailable(d){return d instanceof k&&d._code===O.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof k&&d._code===O.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof k&&d._code===O.NoResolverFound}static isInvalidAuthority(d){return d instanceof k&&d._code===O.InvalidAuthority}static isHandled(d){return d instanceof k&&d.isHandled}constructor(d,f=O.Unknown,$){super(d),this._message=d,this._code=f,this._detail=$,this.isHandled=f===O.NotAvailable&&$===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Rl=k;function b(R){const d=R.indexOf("+");return d===-1?R:R.substring(0,d)}}),define(he[185],ue([0,1,6,14,25,8,3,2,22,100,54,31,69,104]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Xl=u,e.$Yl=y,e.$Zl=v,b=ke(b);const l=30*1e3;var p;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function S(G){switch(G){case p.Management:return"Management";case p.ExtensionHost:return"ExtensionHost";case p.Tunnel:return"Tunnel"}}function g(G){const B=new L.$ue;return setTimeout(()=>B.cancel(),G),B.token}function w(G,B){if(G.isCancellationRequested||B.isCancellationRequested)return L.CancellationToken.Cancelled;const D=new L.$ue;return G.onCancellationRequested(()=>D.cancel()),B.onCancellationRequested(()=>D.cancel()),D.token}class P{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new O.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$vh)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function m(G,B){const D=new P(B);return D.registerDisposable(G.onControlMessage(J=>{const q=JSON.parse(J.toString()),M=z(q);M?D.reject(M):D.resolve(q)})),D.promise}function o(G,B,D,J,q,M,Z,ee){const X=new P(ee),re=R.$de.create(!1);return G.info(`Creating a socket (${Z})...`),b.mark(`code/willCreateSocket/${M}`),B.connect(D,J,q,Z).then(le=>{X.didTimeout?(b.mark(`code/didCreateSocketError/${M}`),G.info(`Creating a socket (${Z}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(b.mark(`code/didCreateSocketOK/${M}`),G.info(`Creating a socket (${Z}) was successful after ${re.elapsed()} ms.`),X.resolve(le))},le=>{b.mark(`code/didCreateSocketError/${M}`),G.info(`Creating a socket (${Z}) returned an error after ${re.elapsed()} ms.`),G.error(le),X.reject(le)}),X.promise}function h(G,B){const D=new P(B);return G.then(J=>{D.didTimeout||D.resolve(J)},J=>{D.didTimeout||D.reject(J)}),D.promise}async function i(G,B,D,J){const q=te(G,B);G.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let M;try{M=await o(G.logService,G.remoteSocketFactoryService,G.connectTo,k.$Pg.getServerRootPath(),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,S(B),`renderer-${S(B)}-${G.reconnectionToken}`,J)}catch(le){throw G.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),G.logService.error(le),le}G.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let Z,ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(M,null),Z=G.reconnectionProtocol,ee=!1):(Z=new f.$qi({socket:M}),ee=!0),G.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const X=await h(G.signService.createNewMessage((0,d.$Yg)()),J),re={type:"auth",auth:G.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(c.$Le.fromString(JSON.stringify(re)));try{const le=await m(Z,w(J,g(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(G.logService.trace(`${q} 4/6. received SignRequest control message.`),!await h(G.signService.validate(X,le.signedData),J)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const pe=await h(G.signService.sign(le.data),J),Ee={type:"connectionType",commit:G.commit,signedData:pe,desiredConnectionType:B};return D&&(Ee.args=D),G.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(c.$Le.fromString(JSON.stringify(Ee))),{protocol:Z,ownsProtocol:ee}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(G.logService.error(`${q} the handshake timed out. Error:`),G.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${q} received error control message when negotiating connection. Error:`),G.logService.error(le)),ee&&W(Z),le}}async function s(G,B,D,J){const q=Date.now(),M=te(G,B),{protocol:Z,ownsProtocol:ee}=await i(G,B,D,J),X=new P(J);return X.registerDisposable(Z.onControlMessage(re=>{const le=JSON.parse(re.toString()),ge=z(le);ge?(G.logService.error(`${M} received error control message when negotiating connection. Error:`),G.logService.error(ge),ee&&W(Z),X.reject(ge)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${M} 6/6. handshake finished, connection is up and running after ${Y(q)}!`),X.resolve({protocol:Z,firstMessage:le}))})),X.promise}async function t(G,B){const{protocol:D}=await s(G,p.Management,void 0,B);return{protocol:D}}async function n(G,B,D){const{protocol:J,firstMessage:q}=await s(G,p.ExtensionHost,B,D),M=q&&q.debugPort;return{protocol:J,debugPort:M}}async function r(G,B,D){const J=Date.now(),q=te(G,p.Tunnel),{protocol:M}=await i(G,p.Tunnel,B,D);return G.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${Y(J)}!`),M}async function a(G,B,D){const{connectTo:J,connectionToken:q}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:J,connectionToken:q,reconnectionToken:B,reconnectionProtocol:D,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function u(G,B,D){return C(G,async J=>{const{protocol:q}=await t(J,L.CancellationToken.None);return new H(G,B,D,J.reconnectionToken,q)})}async function y(G,B){return C(G,async D=>{const{protocol:J,debugPort:q}=await n(D,B,L.CancellationToken.None);return new ie(G,B,D.reconnectionToken,J,q)})}async function C(G,B){for(let J=1;;J++)try{const q=(0,d.$Yg)(),M=await a(G,q,null);return await B(M)}catch(q){if(J<5)G.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(q);else throw G.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(q),x.triggerPermanentFailure(0,0,$.$Rl.isHandled(q)),q}}async function v(G,B,D){const J=await a(G,(0,d.$Yg)(),null);return await r(J,{host:B,port:D},L.CancellationToken.None)}function E(G){return(0,I.$ph)(B=>new Promise((D,J)=>{const q=setTimeout(D,G*1e3);B.onCancellationRequested(()=>{clearTimeout(q),D()})}))}var T;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class F{constructor(B,D){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.type=T.ConnectionLost}}e.$1l=F;class U{constructor(B,D,J,q){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.durationSeconds=J,this.c=q,this.type=T.ReconnectionWait}skipWait(){this.c.cancel()}}e.$2l=U;class j{constructor(B,D,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=T.ReconnectionRunning}}e.$3l=j;class K{constructor(B,D,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.type=T.ConnectionGain}}e.$4l=K;class V{constructor(B,D,J,q){this.reconnectionToken=B,this.millisSinceLastIncomingData=D,this.attempt=J,this.handled=q,this.type=T.ReconnectionPermanentFailure}}e.$5l=V;class x extends O.$Tc{static triggerPermanentFailure(B,D,J){this._permanentFailure=!0,this.f=B,this.g=D,this.h=J,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(B,D,J,q,M){super(),this.t=B,this.u=D,this.reconnectionToken=J,this.protocol=q,this.w=M,this.m=this.B(new N.$je),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new K(this.reconnectionToken,0,0)),this.B(q.onSocketClose(Z=>{const ee=ce(this.t,this.reconnectionToken,!0);Z?Z.type===f.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${ee} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.u.logService.error(Z.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.u.logService.error(Z.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(Z=>{const ee=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,O.$Rc)(()=>{const Z=x.j.indexOf(this);Z>=0&&x.j.splice(Z,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const q=J<D.length?D[J]:D[D.length-1];try{if(q>0){const Z=E(q);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,Z)),this.u.logService.info(`${B} waiting for ${q} seconds before reconnecting...`);try{await Z}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this.u.logService.info(`${B} resolving connection...`);const M=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${M.connectTo}...`),await this.G(M,g(l)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(M){if(M.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if($.$Rl.isTemporarilyNotAvailable(M)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if((M.code==="ETIMEDOUT"||M.code==="ENETUNREACH"||M.code==="ECONNREFUSED"||M.code==="ECONNRESET")&&M.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if((0,A.$3)(M)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(M);continue}if(M instanceof $.$Rl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,$.$Rl.isHandled(M));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(M),this.C(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this.n&&!this.s)}C(B,D,J){this.w?x.triggerPermanentFailure(B,D,J):this.D(B,D,J)}D(B,D,J){this.m.fire(new V(this.reconnectionToken,B,D,J)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6l=x;class H extends x{constructor(B,D,J,q,M){super(p.Management,B,q,M,!0),this.client=this.B(new f.$oi(M,{remoteAuthority:D,clientId:J},B.ipcLogger))}async G(B,D){await t(B,D)}}e.$7l=H;class ie extends x{constructor(B,D,J,q,M){super(p.ExtensionHost,B,J,q,!1),this.H=D,this.debugPort=M}async G(B,D){await n(B,this.H,D)}}e.$8l=ie;function W(G){try{G.acceptDisconnect();const B=G.getSocket();G.dispose(),B.dispose()}catch(B){(0,A.$Y)(B)}}function z(G){if(G&&G.type==="error"){const B=new Error(`Connection error: ${G.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function _(G,B){for(;G.length<B;)G+=" ";return G}function ne(G,B){return`[remote-connection][${_(S(G),13)}][${B.substr(0,5)}\u2026]`}function ce(G,B,D){return`${ne(G,B)}[${D?"reconnect":"initial"}]`}function te(G,B){return`${ce(B,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function Y(G){return`${Date.now()-G} ms`}}),define(he[105],ue([0,1,22]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=c,e.$fn=L,e.$gn=A,e.$hn=N;function c(k){return k.scheme===I.Schemas.vscodeRemote?k.authority:void 0}function L(k){if(!k)return;const b=k.indexOf("+");return b<0?k:k.substr(0,b)}function A(k){const{host:b,port:R}=O(k);if(typeof R>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:b,port:R}}function N(k,b){let{host:R,port:d}=O(k);return typeof d>"u"&&(d=b),{host:R,port:d}}function O(k){const b=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const R=k.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const d=k.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:k,port:void 0}}}),define(he[33],ue([0,1,26,4,105]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$qn=e.$pn=e.$on=e.TargetPlatform=e.ExtensionType=e.$nn=e.$ln=e.$kn=e.$jn=e.$in=void 0,e.$mn=A,e.$rn=d,e.$sn=f,e.$tn=$,e.$un=l,e.$vn=p,e.$wn=S,I=ke(I),e.$in="extensions.user.cache",e.$jn="extensions.builtin.cache",e.$kn="undefined_publisher",e.$ln=["ui","workspace","web"];function A(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$nn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(N||(e.ExtensionType=N={}));var O;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class k{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,P){if(typeof w>"u"||w===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof w=="string"||typeof P=="string"){const m=typeof w=="string"?w:w.value,o=typeof P=="string"?P:P.value;return I.$Df(m,o)}return w._lower===P._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$on=k;class b{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const P of w)this.add(P)}add(w){this.c.add(k.toKey(w))}delete(w){return this.c.delete(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}}e.$pn=b;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(k.toKey(w))}get(w){return this.c.get(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}set(w,P){this.c.set(k.toKey(w),P)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$qn=R;function d(g){return f(g)}function f(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}function $(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}function l(g,w){if(w){const P=`onResolveRemoteAuthority:${(0,L.$fn)(w)}`;return!!g.activationEvents?.includes(P)}return!1}function p(g){return g.map(w=>{const[P,m]=w.split("@");return{proposalName:P,version:m?parseInt(m):void 0}})}function S(g){return g.map(w=>w.split("@")[0])}e.$xn=(0,c.$Ci)("IBuiltinExtensionsScannerService")}),define(he[27],ue([0,1,5,11,33,4]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.ExtensionManagementErrorCode=e.$jp=e.ExtensionGalleryErrorCode=e.$ip=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=void 0,e.$cp=O,e.$dp=k,e.$ep=b,e.$fp=R,e.$gp=d,e.$hp=f,e.$8o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9o=new RegExp(e.$8o),e.$0o="__web_extension",e.$$o="skipWalkthrough",e.$_o="extensionInstallSource",e.$ap="dependecyOrPackExtensionInstall",e.$bp="clientTargetPlatform";var N;(function(o){o.COMMAND="command",o.SETTINGS_SYNC="settingsSync"})(N||(e.ExtensionInstallSource=N={}));function O(o){switch(o){case L.TargetPlatform.WIN32_X64:return"Windows 64 bit";case L.TargetPlatform.WIN32_ARM64:return"Windows ARM";case L.TargetPlatform.LINUX_X64:return"Linux 64 bit";case L.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case L.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case L.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case L.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case L.TargetPlatform.DARWIN_X64:return"Mac";case L.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case L.TargetPlatform.WEB:return"Web";case L.TargetPlatform.UNIVERSAL:return L.TargetPlatform.UNIVERSAL;case L.TargetPlatform.UNKNOWN:return L.TargetPlatform.UNKNOWN;case L.TargetPlatform.UNDEFINED:return L.TargetPlatform.UNDEFINED}}function k(o){switch(o){case L.TargetPlatform.WIN32_X64:return L.TargetPlatform.WIN32_X64;case L.TargetPlatform.WIN32_ARM64:return L.TargetPlatform.WIN32_ARM64;case L.TargetPlatform.LINUX_X64:return L.TargetPlatform.LINUX_X64;case L.TargetPlatform.LINUX_ARM64:return L.TargetPlatform.LINUX_ARM64;case L.TargetPlatform.LINUX_ARMHF:return L.TargetPlatform.LINUX_ARMHF;case L.TargetPlatform.ALPINE_X64:return L.TargetPlatform.ALPINE_X64;case L.TargetPlatform.ALPINE_ARM64:return L.TargetPlatform.ALPINE_ARM64;case L.TargetPlatform.DARWIN_X64:return L.TargetPlatform.DARWIN_X64;case L.TargetPlatform.DARWIN_ARM64:return L.TargetPlatform.DARWIN_ARM64;case L.TargetPlatform.WEB:return L.TargetPlatform.WEB;case L.TargetPlatform.UNIVERSAL:return L.TargetPlatform.UNIVERSAL;default:return L.TargetPlatform.UNKNOWN}}function b(o,h){switch(o){case I.Platform.Windows:return h==="x64"?L.TargetPlatform.WIN32_X64:h==="arm64"?L.TargetPlatform.WIN32_ARM64:L.TargetPlatform.UNKNOWN;case I.Platform.Linux:return h==="x64"?L.TargetPlatform.LINUX_X64:h==="arm64"?L.TargetPlatform.LINUX_ARM64:h==="arm"?L.TargetPlatform.LINUX_ARMHF:L.TargetPlatform.UNKNOWN;case"alpine":return h==="x64"?L.TargetPlatform.ALPINE_X64:h==="arm64"?L.TargetPlatform.ALPINE_ARM64:L.TargetPlatform.UNKNOWN;case I.Platform.Mac:return h==="x64"?L.TargetPlatform.DARWIN_X64:h==="arm64"?L.TargetPlatform.DARWIN_ARM64:L.TargetPlatform.UNKNOWN;case I.Platform.Web:return L.TargetPlatform.WEB}}function R(o,h){return h===L.TargetPlatform.WEB&&!o.includes(L.TargetPlatform.WEB)}function d(o,h,i){return R(h,i)?!1:o===L.TargetPlatform.UNDEFINED||o===L.TargetPlatform.UNIVERSAL?!0:o===L.TargetPlatform.UNKNOWN?!1:o===i}function f(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}var $;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var l;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(l||(e.SortOrder=l={}));var p;(function(o){o.Install="install",o.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var S;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$ip=(0,A.$Ci)("extensionGalleryService");var g;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed",o.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class w extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$jp=w;var P;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleApi="IncompatibleApi",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.DownloadFailedWriting="DownloadFailedWriting",o.UpdateExistingMetadata="UpdateExistingMetadata",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.ScanningExtension="ScanningExtension",o.ReadUninstalled="ReadUninstalled",o.UnsetUninstalled="UnsetUninstalled",o.Delete="Delete",o.Rename="Rename",o.IntializeDefaultProfile="IntializeDefaultProfile",o.AddToProfile="AddToProfile",o.InstalledExtensionNotFound="InstalledExtensionNotFound",o.PostInstall="PostInstall",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Cancelled="Cancelled",o.Unknown="Unknown",o.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class m extends Error{constructor(h,i){super(h),this.code=i,this.name=i}}e.$kp=m,e.$lp=(0,A.$Ci)("extensionManagementService"),e.$mp="extensionsIdentifiers/disabled",e.$np="extensionsIdentifiers/enabled",e.$op=(0,A.$Ci)("IGlobalExtensionEnablementService"),e.$pp=(0,A.$Ci)("IExtensionTipsService"),e.$qp=(0,c.localize2)(11334,"Extensions"),e.$rp=(0,c.localize2)(11335,"Preferences")}),define(he[186],ue([0,1,3,2,29,9,94,27]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=void 0;function k(S,g){return S?A.URI.revive(g?g.transformIncoming(S):S):void 0}function b(S,g){return g?g.transformOutgoingURI(S):S}function R(S,g){g=g||N.$Kn;const w=S.manifest;return{...(0,N.$Nn)({...S,manifest:void 0},g),manifest:w}}function d(S,g){return S?.profileLocation?(0,N.$Nn)(S,g??N.$Kn):S}function f(S,g){return g?(0,L.$do)(S,w=>w instanceof A.URI?g.transformOutgoingURI(w):void 0):S}class ${constructor(g,w){this.a=g,this.b=w,this.onInstallExtension=I.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(g.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(g.onDidUpdateExtensionMetadata,!0)}listen(g,w){const P=this.b(g);switch(w){case"onInstallExtension":return I.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?b(m.profileLocation,P):m.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,m=>m.map(o=>({...o,local:o.local?f(o.local,P):o.local,profileLocation:o.profileLocation?b(o.profileLocation,P):o.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?b(m.profileLocation,P):m.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?b(m.profileLocation,P):m.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,m=>({local:f(m.local,P),profileLocation:b(m.profileLocation,P)}))}throw new Error("Invalid listen")}async call(g,w,P){const m=this.b(g);switch(w){case"zip":{const o=R(P[0],m),h=await this.a.zip(o);return b(h,m)}case"unzip":return this.a.unzip(k(P[0],m));case"install":return this.a.install(k(P[0],m),d(P[1],m));case"installFromLocation":return this.a.installFromLocation(k(P[0],m),k(P[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(P[0],k(P[1],m),k(P[2],m));case"getManifest":return this.a.getManifest(k(P[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(P[0]);case"installFromGallery":return this.a.installFromGallery(P[0],d(P[1],m));case"installGalleryExtensions":{const o=P[0];return this.a.installGalleryExtensions(o.map(({extension:h,options:i})=>({extension:h,options:d(i,m)??{}})))}case"uninstall":return this.a.uninstall(R(P[0],m),d(P[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(R(P[0],m));case"getInstalled":return(await this.a.getInstalled(P[0],k(P[1],m),P[2])).map(h=>f(h,m));case"toggleAppliationScope":{const o=await this.a.toggleAppliationScope(R(P[0],m),k(P[1],m));return f(o,m)}case"copyExtensions":return this.a.copyExtensions(k(P[0],m),k(P[1],m));case"updateMetadata":{const o=await this.a.updateMetadata(R(P[0],m),P[1],k(P[2],m));return f(o,m)}case"resetPinnedStateForAllUserExtensions":return this.a.resetPinnedStateForAllUserExtensions(P[0]);case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(P[0],P[1],P[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$uq=$;class l extends c.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(g){super(),this.m=g,this.c=this.B(new I.$je),this.f=this.B(new I.$je),this.g=this.B(new I.$je),this.h=this.B(new I.$je),this.j=this.B(new I.$je),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?A.URI.revive(w.source):w.source,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(P=>({...P,local:P.local?R(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:A.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.n(this.j,{profileLocation:A.URI.revive(w.profileLocation),local:R(w.local,null)})))}n(g,w){g.fire(w)}r(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(g){const w=await this.getTargetPlatform();return g.allTargetPlatforms.some(P=>(0,O.$gp)(P,g.allTargetPlatforms,w))}zip(g){return Promise.resolve(this.m.call("zip",[g]).then(w=>A.URI.revive(w)))}unzip(g){return Promise.resolve(this.m.call("unzip",[g]))}install(g,w){return Promise.resolve(this.m.call("install",[g,w])).then(P=>R(P,null))}installFromLocation(g,w){return Promise.resolve(this.m.call("installFromLocation",[g,w])).then(P=>R(P,null))}async installExtensionsFromProfile(g,w,P){return(await this.m.call("installExtensionsFromProfile",[g,w,P])).map(o=>R(o,null))}getManifest(g){return Promise.resolve(this.m.call("getManifest",[g]))}installFromGallery(g,w){return Promise.resolve(this.m.call("installFromGallery",[g,w])).then(P=>R(P,null))}async installGalleryExtensions(g){return(await this.m.call("installGalleryExtensions",[g])).map(P=>({...P,local:P.local?R(P.local,null):P.local,source:this.r(P.source)?A.URI.revive(P.source):P.source,profileLocation:A.URI.revive(P.profileLocation)}))}uninstall(g,w){if(g.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[g,w]))}reinstallFromGallery(g){return Promise.resolve(this.m.call("reinstallFromGallery",[g])).then(w=>R(w,null))}getInstalled(g=null,w,P){return Promise.resolve(this.m.call("getInstalled",[g,w,P])).then(m=>m.map(o=>R(o,null)))}updateMetadata(g,w,P){return Promise.resolve(this.m.call("updateMetadata",[g,w,P])).then(m=>R(m,null))}resetPinnedStateForAllUserExtensions(g){return this.m.call("resetPinnedStateForAllUserExtensions",[g])}toggleAppliationScope(g,w){return this.m.call("toggleAppliationScope",[g,w]).then(P=>R(P,null))}copyExtensions(g,w){return this.m.call("copyExtensions",[g,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(g,w,P){const m=await this.m.call("download",[g,w,P]);return A.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$vq=l;class p{constructor(g){this.a=g}listen(g,w){throw new Error("Invalid listen")}call(g,w,P){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(P[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$wq=p}),define(he[187],ue([0,1,2,33,7]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class A extends I.$Tc{constructor(O,k,b,R,d){super(),this.a=O,this.b=k,this.c=b,this.f=d,this.B(R.onDidInstallExtensions(f=>this.g(f))),this.B(R.onDidUninstallExtension(f=>this.h(f)))}g(O){for(const k of O)k.local&&this.invalidate(k.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,O)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,c.$in))}catch(k){(0,L.$ol)(k)!==L.FileOperationResult.FILE_NOT_FOUND&&this.f.error(k)}}}e.$Tq=A});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[59],ue([0,1,20,92,11,60,33,158]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=R,e.$Xp=d,e.$Yp=f,e.$Zp=$,e.$1p=l,e.$2p=p,e.$3p=S,e.$4p=g,c=it(c),L=ke(L),A=ke(A);const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R(m){return m=m.trim(),m==="*"||k.test(m)}function d(m){if(!R(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const o=m.match(k);return o?{hasCaret:o[1]==="^",hasGreaterEquals:o[1]===">=",majorBase:o[2]==="x"?0:parseInt(o[2],10),majorMustEqual:o[2]!=="x",minorBase:o[4]==="x"?0:parseInt(o[4],10),minorMustEqual:o[4]!=="x",patchBase:o[6]==="x"?0:parseInt(o[6],10),patchMustEqual:o[6]!=="x",preRelease:o[8]||null}:null}function f(m){if(!m)return null;const o=m.majorBase,h=m.majorMustEqual,i=m.minorBase;let s=m.minorMustEqual;const t=m.patchBase;let n=m.patchMustEqual;m.hasCaret&&(o===0||(s=!1),n=!1);let r=0;if(m.preRelease){const a=b.exec(m.preRelease);if(a){const[,u,y,C]=a;r=Date.UTC(Number(u),Number(y)-1,Number(C))}}return{majorBase:o,majorMustEqual:h,minorBase:i,minorMustEqual:s,patchBase:t,patchMustEqual:n,isMinimum:m.hasGreaterEquals,notBefore:r}}function $(m,o,h){let i;typeof m=="string"?i=f(d(m)):i=m;let s;o instanceof Date?s=o.getTime():typeof o=="string"&&(s=new Date(o).getTime());let t;if(typeof h=="string"?t=f(d(h)):t=h,!i||!t)return!1;const n=i.majorBase,r=i.minorBase,a=i.patchBase;let u=t.majorBase,y=t.minorBase,C=t.patchBase;const v=t.notBefore;let E=t.majorMustEqual,T=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?n>u?!0:n<u?!1:r>y?!0:r<y||s&&s<v?!1:a>=C:(n===1&&u===0&&(!E||!T||!F)&&(u=1,y=0,C=0,E=!0,T=!1,F=!1),n<u?!1:n>u?!E:r<y?!1:r>y?!T:a<C?!1:a>C?!F:!(s&&s<v))}function l(m,o,h,i,s,t){const n=[];if(typeof i.publisher<"u"&&typeof i.publisher!="string")return n.push([c.default.Error,L.localize(11266,null)]),n;if(typeof i.name!="string")return n.push([c.default.Error,L.localize(11267,null,"name")]),n;if(typeof i.version!="string")return n.push([c.default.Error,L.localize(11268,null,"version")]),n;if(!i.engines)return n.push([c.default.Error,L.localize(11269,null,"engines")]),n;if(typeof i.engines.vscode!="string")return n.push([c.default.Error,L.localize(11270,null,"engines.vscode")]),n;if(typeof i.extensionDependencies<"u"&&!P(i.extensionDependencies))return n.push([c.default.Error,L.localize(11271,null,"extensionDependencies")]),n;if(typeof i.activationEvents<"u"){if(!P(i.activationEvents))return n.push([c.default.Error,L.localize(11272,null,"activationEvents")]),n;if(typeof i.main>"u"&&typeof i.browser>"u")return n.push([c.default.Error,L.localize(11273,null,"activationEvents","main","browser")]),n}if(typeof i.extensionKind<"u"&&typeof i.main>"u"&&n.push([c.default.Warning,L.localize(11274,null,"extensionKind")]),typeof i.main<"u"){if(typeof i.main!="string")return n.push([c.default.Error,L.localize(11275,null,"main")]),n;{const u=(0,I.$dh)(h,i.main);(0,I.$0g)(u,h)||n.push([c.default.Warning,L.localize(11276,null,u.path,h.path)])}}if(typeof i.browser<"u"){if(typeof i.browser!="string")return n.push([c.default.Error,L.localize(11277,null,"browser")]),n;{const u=(0,I.$dh)(h,i.browser);(0,I.$0g)(u,h)||n.push([c.default.Warning,L.localize(11278,null,u.path,h.path)])}}if(!A.valid(i.version))return n.push([c.default.Error,L.localize(11279,null)]),n;const r=[];if(!p(m,o,i,s,r))for(const u of r)n.push([c.default.Error,u]);if(t&&i.enabledApiProposals?.length){const u=[];if(!g([...i.enabledApiProposals],u))for(const y of u)n.push([c.default.Error,y])}return n}function p(m,o,h,i,s){return i||typeof h.main>"u"&&typeof h.browser>"u"?!0:w(m,o,h.engines.vscode,s)}function S(m,o,h){return m==="*"||w(o,h,m)}function g(m,o){if(m.length===0)return!0;const h=Array.isArray(o)?o:void 0,i=(h?void 0:o)??O.allApiProposals,s=[],t=(0,N.$vn)(m);for(const{proposalName:n,version:r}of t){const a=i[n];a&&r&&a.version!==r&&s.push(L.localize(11280,null,n))}return h?.push(...s),s.length===0}function w(m,o,h,i=[]){const s=f(d(h));if(!s)return i.push(L.localize(11281,null,h)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return i.push(L.localize(11282,null,h)),!1}else if(!s.majorMustEqual)return i.push(L.localize(11283,null,h)),!1;return $(m,o,s)?!0:(i.push(L.localize(11284,null,m,h)),!1)}function P(m){if(!Array.isArray(m))return!1;for(let o=0,h=m.length;o<h;o++)if(typeof m[o]!="string")return!1;return!0}}),define(he[78],ue([0,1,25,2,5,11,27,4]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=void 0,e.$8r=k;function k(R){return R.tags.find(d=>d.startsWith("lp-"))?.split("lp-")[1]}e.$9r=(0,O.$Ci)("languagePackService");let b=class extends c.$Tc{constructor(d){super(),this.c=d}async getAvailableLanguages(){const d=new I.$ue;setTimeout(()=>d.cancel(),1e3);let f;try{f=await this.c.query({text:'category:"language packs"',pageSize:20},d.token)}catch{return[]}const l=f.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(S=>S.startsWith("lp-"))).map(p=>{const S=p.properties.localizedLanguages?.[0],g=k(p);return{...this.f(g,S,p),extensionId:p.identifier.id,galleryExtension:p}});return l.push(this.f("en","English")),l}f(d,f,$){const l=f??d;let p;if(l!==d&&(p=`(${d})`),d.toLowerCase()===L.$x.toLowerCase()&&(p??="",p+=(0,A.localize)(11188,null)),$?.installCount){p??="";const S=$.installCount;let g;S>1e6?g=`${Math.floor(S/1e5)/10}M`:S>1e3?g=`${Math.floor(S/1e3)}K`:g=String(S),p+=` $(cloud-download) ${g}`}return{id:d,label:l,description:p}}};e.$0r=b,e.$0r=b=ve([Q(0,N.$ip)],b)}),define(he[188],ue([0,1,2,78]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let L=class extends I.$Tc{constructor(N){super(),this.a=N,this.b()}b(){this.a.update()}};e.$ghc=L,e.$ghc=L=ve([Q(0,c.$9r)],L)}),define(he[106],ue([0,1,2,4]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=void 0,e.$Tl=(0,c.$Ci)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(N,O){return this.a[N]??=[],this.a[N].push(O),(0,I.$Rc)(()=>{const k=this.a[N]?.indexOf(O);typeof k=="number"&&k>=0&&this.a[N]?.splice(k,1)})}b(N){return(this.a[N.type]||[]).find(k=>k.supports(N))}connect(N,O,k,b){const R=this.b(N);if(!R)throw new Error(`No socket factory found for ${N}`);return R.connect(N,O,k,b)}}e.$Ul=L}),define(he[189],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhc=e.$thc=void 0,e.$thc=(0,I.$Ci)("sharedProcessTunnelService"),e.$uhc="sharedProcessTunnel"}),define(he[107],ue([0,1,4,11]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=e.$Chc=e.$Bhc=e.$Ahc=e.TunnelStates=e.$zhc=e.$yhc=void 0,e.$yhc=(0,I.$Ci)("IRemoteTunnelService"),e.$zhc={active:!1};var L;(function(A){A.disconnected=N=>({type:"disconnected",onTokenFailed:N}),A.connected=(N,O)=>({type:"connected",info:N,serviceInstallFailed:O}),A.connecting=N=>({type:"connecting",progress:N}),A.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$Ahc="remote.tunnels.access",e.$Bhc=e.$Ahc+".hostNameOverride",e.$Chc=e.$Ahc+".preventSleep",e.$Dhc="remoteTunnelService",e.$Ehc=(0,c.localize)(11072,null)}),define(he[61],ue([0,1,14,8,2,11,47,4,10,44]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0,e.$7p=f,e.$8p=$,e.$9p=l,e.$0p=p,e.$$p=S,e.$_p=g,e.$5p=(0,O.$Ci)("requestService");class R{constructor(o){this.b=o}toJSON(){if(!this.a){const o=Object.create(null);for(const h in this.b)h.toLowerCase()==="authorization"||h.toLowerCase()==="proxy-authorization"?o[h]="*****":o[h]=this.b[h];this.a=o}return this.a}}class d extends L.$Tc{constructor(o){super(),this.b=0,this.a=o.createLogger("network",{name:(0,A.localize)(11053,null),when:k.$pk.isEqualTo((0,k.$mk)(k.LogLevel.Trace)).serialize()})}async c(o,h,i){const s=`${o} #${++this.b}: ${h.url}`;this.a.trace(`${s} - begin`,h.type,new R(h.headers??{}));try{const t=await i();return this.a.trace(`${s} - end`,h.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${s} - error`,h.type,(0,c.$9)(t)),t}}}e.$6p=d;function f(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}function $(m){return m.res.statusCode===204}async function l(m){return $(m)?null:(await(0,I.$Xe)(m.stream)).toString()}async function p(m){if(!f(m))throw new Error("Server returned "+m.res.statusCode);return l(m)}async function S(m){if(!f(m))throw new Error("Server returned "+m.res.statusCode);if($(m))return null;const h=(await(0,I.$Xe)(m.stream)).toString();try{return JSON.parse(h)}catch(i){throw i.message+=`:
`+h,i}}function g(m){P(m)}let w;function P(m){const o=b.$oo.as(N.$to.Configuration),h=w;w={id:"http",order:15,title:(0,A.localize)(11054,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(11055,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(11056,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(11057,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,A.localize)(11058,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(11059,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(11060,null),(0,A.localize)(11061,null),(0,A.localize)(11062,null),(0,A.localize)(11063,null)],default:"override",description:(0,A.localize)(11064,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11065,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(11066,null),restricted:!0}}},o.updateConfigurations({add:[w],remove:h?[h]:[]})}P(N.ConfigurationScope.APPLICATION)}),define(he[190],ue([0,1,25,22,7,61]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FR=void 0;let N=class{constructor(k,b){this.a=k,this.b=b}async download(k,b,R=I.CancellationToken.None){if(k.scheme===c.Schemas.file||k.scheme===c.Schemas.vscodeRemote){await this.b.copy(k,b);return}const d={type:"GET",url:k.toString(!0)},f=await this.a.request(d,R);if(f.res.statusCode===200)await this.b.writeFile(b,f.stream);else{const $=await(0,A.$0p)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${$}`)}}};e.$FR=N,e.$FR=N=ve([Q(0,A.$5p),Q(1,L.$0k)],N)}),define(he[191],ue([0,1,14,25]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=void 0;class L{constructor(O){this.a=O}listen(O,k){throw new Error("Invalid listen")}call(O,k,b,R=c.CancellationToken.None){switch(k){case"request":return this.a.request(b[0],R).then(async({res:d,stream:f})=>{const $=await(0,I.$Xe)(f);return[{statusCode:d.statusCode,headers:d.headers},$]});case"resolveProxy":return this.a.resolveProxy(b[0]);case"lookupAuthorization":return this.a.lookupAuthorization(b[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_r=L;class A{constructor(O){this.a=O}async request(O,k){const[b,R]=await this.a.call("request",[O],k);return{res:b,stream:(0,I.$Ze)(R)}}async resolveProxy(O){return this.a.call("resolveProxy",[O])}async lookupAuthorization(O){return this.a.call("lookupAuthorization",[O])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$as=A}),define(he[192],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=e.$4fc=void 0,e.$4fc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$5fc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$6fc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(he[193],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const N=String(I.a++);return this.b.set(N,A),{id:N,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const N=this.b.get(L.id);if(!N)return!1;this.b.delete(L.id);try{return N.validate(A)==="ok"}catch{return!1}finally{N.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$Obc=I}),define(he[108],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl="signService",e.$Wl=(0,I.$Ci)(e.$Vl)}),define(he[194],ue([0,1,193]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class c extends I.$Obc{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(N=>new N.signer().sign(A))}h(){return new Promise((A,N)=>oe(["vsda"],A,N))}}e.$Vgc=c}),define(he[79],ue([0,1,3,2]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KMb=e.$JMb=e.$IMb=e.$HMb=void 0;class L extends c.$Tc{constructor(d,f,$){super(),this.a=d,this.b=f,this.c=$}async getItems(){const d={profile:this.b,workspace:this.c},f=await this.a.call("getItems",d);return new Map(f)}updateItems(d){const f={profile:this.b,workspace:this.c};return d.insert&&(f.insert=Array.from(d.insert.entries())),d.delete&&(f.delete=Array.from(d.delete.values())),this.a.call("updateItems",f)}optimize(){const d={profile:this.b,workspace:this.c};return this.a.call("optimize",d)}}class A extends L{constructor(d,f){super(d,f,void 0),this.f=this.B(new I.$je),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(d=>this.h(d)))}h(d){(Array.isArray(d.changed)||Array.isArray(d.deleted))&&this.f.fire({changed:d.changed?new Map(d.changed):void 0,deleted:d.deleted?new Set(d.deleted):void 0})}}class N extends A{constructor(d){super(d,void 0)}async close(){this.dispose()}}e.$HMb=N;class O extends A{constructor(d,f){super(d,f)}async close(){this.dispose()}}e.$IMb=O;class k extends L{constructor(d,f){super(d,void 0,f),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$JMb=k;class b{constructor(d){this.a=d}isUsed(d){const f={payload:d,profile:void 0,workspace:void 0};return this.a.call("isUsed",f)}}e.$KMb=b}),define(he[109],ue([0,1,5,37,31]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=N,e.$tp=O;function A(k){if(I.$v===I.Platform.Linux&&/^penguin(\.|$)/i.test(k))return"chromebook"}function N(k,b,R,d,f,$,l,p,S,g){const w=Object.create(null);w["common.machineId"]=$,w["common.sqmId"]=l,w["common.devDeviceId"]=p,w.sessionID=(0,L.$Yg)()+Date.now(),w.commitHash=d,w.version=f,w["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,I.$i)(I.$v),w["common.nodePlatform"]=c.$cc,w["common.nodeArch"]=R,w["common.product"]=g||"desktop",S&&(w["common.msftInternal"]=S);let P=0;const m=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),I.$m&&(w["common.snap"]="true");const o=A(b);return o&&(w["common.platformDetail"]=o),w}function O(k){const b=c.env.USERDNSDOMAIN;if(!b)return!1;const R=b.toLowerCase();return k.some(d=>R===d)}}),define(he[18],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=(0,I.$Ci)("telemetryService"),e.$0l=(0,I.$Ci)("customEndpointTelemetryService"),e.$$l="telemetry.currentSessionDate",e.$_l="telemetry.firstSessionDate",e.$am="telemetry.lastSessionDate",e.$bm="telemetry.machineId",e.$cm="telemetry.sqmId",e.$dm="telemetry.devDeviceId",e.$em="telemetry",e.$fm="telemetry.telemetryLevel",e.$gm="telemetry.enableCrashReporter",e.$hm="telemetry.enableTelemetry";var c;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(c||(e.TelemetryLevel=c={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(he[195],ue([0,1,32,38,6,35,22,13,5,54,9,141,30,148,97,7,23,18]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0,e.$Vs=P,e.$Ws=o,e.$Xs=h,I=ke(I),c=ke(c);const w=new Map;async function P(s,t){const n=`${s}::${t.join(":")}`,r=w.get(n);if(r)return r;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,y=new Map,C=2e4;function v(T,F,U,j){const K=F.substring(T.length+1);return L.Promises.withAsyncBody(async V=>{let x;j.readdirCount++;try{x=await f.Promises.readdir(F,{withFileTypes:!0})}catch{V();return}if(j.count>=C){j.count+=x.length,j.maxReached=!0,V();return}let H=x.length;if(H===0){V();return}let ie=x;j.count+x.length>C&&(j.maxReached=!0,H=C-j.count,ie=x.slice(0,H)),j.count+=x.length;for(const W of ie)if(W.isDirectory()){if(U.includes(W.name)||await v(T,(0,O.$ic)(F,W.name),U,j),--H===0){V();return}}else{const z=W.name.lastIndexOf(".");if(z>=0){const _=W.name.substring(z+1);_&&u.set(_,(u.get(_)??0)+1)}for(const _ of a)_.relativePathPattern?.test(K)!==!1&&_.filePattern.test(W.name)&&y.set(_.tag,(y.get(_.tag)??0)+1);if(--H===0){V();return}}})}const E=L.Promises.withAsyncBody(async T=>{const F={count:0,maxReached:!1,readdirCount:0},U=new b.$de(!0);await v(s,s,t,F);const j=await h(s);T({configFiles:m(y),fileTypes:m(u),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:j,totalScanTime:U.elapsed(),totalReaddirCount:F.readdirCount})});return w.set(n,E),E}function m(s){return Array.from(s.entries(),([t,n])=>({name:t,count:n})).sort((t,n)=>n.count-t.count)}function o(){const s={os:`${c.type()} ${c.arch()} ${c.release()}`,memory:`${(c.totalmem()/p.$Fl.GB).toFixed(2)}GB (${(c.freemem()/p.$Fl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Pn.value()*100)}%`},t=c.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}async function h(s){try{const t=new Map,n=(0,O.$ic)(s,".vscode","launch.json"),r=await I.promises.readFile(n),a=[],u=(0,A.$Vn)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${n}`),[];if((0,A.$4n)(u)==="object"&&u.configurations)for(const y of u.configurations){const C=y.type;C&&(t.has(C)?t.set(C,t.get(C)+1):t.set(C,1))}return m(t)}catch{return[]}}let i=class{constructor(t,n){this.c=t,this.d=n}f(t){const n=[];return n.push(`OS Version:       ${t.os}`),n.push(`CPUs:             ${t.cpus}`),n.push(`Memory (System):  ${t.memory}`),n.push(`VM:               ${t.vmHint}`),n.join(`
`)}g(t){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${c.type()} ${c.arch()} ${c.release()}`);const r=c.cpus();return r&&r.length>0&&n.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),n.push(`Memory (System):  ${(c.totalmem()/p.$Fl.GB).toFixed(2)}GB (${(c.freemem()/p.$Fl.GB).toFixed(2)}GB free)`),k.$j||n.push(`Load (avg):       ${c.loadavg().map(a=>Math.round(a)).join(", ")}`),n.push(`VM:               ${Math.round(d.$Pn.value()*100)}%`),n.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${t.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(t.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(t,n){return Promise.all([(0,$.$Us)(t.mainPID),this.k(t)]).then(async r=>{let[a,u]=r,y=this.m(t,a);return n.forEach(C=>{if((0,l.$Rm)(C))y+=`
${C.errorMessage}`,u+=`
${C.errorMessage}`;else if(y+=`

Remote: ${C.hostName}`,C.processes&&(y+=`
${this.m(t,C.processes)}`),C.workspaceMetadata){u+=`
|  Remote: ${C.hostName}`;for(const v of Object.keys(C.workspaceMetadata)){const E=C.workspaceMetadata[v];let T=`${E.fileCount} files`;E.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${v}): ${T}`,u+=this.h(E)}}}),{processInfo:y,workspaceInfo:u}})}async getSystemInfo(t,n){const{memory:r,vmHint:a,os:u,cpus:y}=o(),C={os:u,memory:r,cpus:y,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:n};return k.$j||(C.load=`${c.loadavg().map(v=>Math.round(v)).join(", ")}`),k.$l&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(t,n){const r=[];return(0,$.$Us)(t.mainPID).then(async a=>(r.push(""),r.push(this.g(t)),r.push(""),r.push(this.m(t,a)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(t))),n.forEach(u=>{if((0,l.$Rm)(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.f(u.machineInfo)),u.processes&&r.push(this.m(t,u.processes)),u.workspaceMetadata)for(const y of Object.keys(u.workspaceMetadata)){const C=u.workspaceMetadata[y];let v=`${C.fileCount} files`;C.maxFilesReached&&(v=`more than ${v}`),r.push(`Folder (${y}): ${v}`),r.push(this.h(C))}}),r.push(""),r.push(""),r.join(`
`)))}h(t){const n=[];let a=0;const u=(E,T)=>{const F=` ${E}(${T})`;a+F.length>60?(n.push(y),y="|                 ",a=y.length):a+=F.length,y+=F};let y="|      File types:";const C=10,v=t.fileTypes.length>C?C:t.fileTypes.length;for(let E=0;E<v;E++){const T=t.fileTypes[E];u(T.name,T.count)}if(n.push(y),t.configFiles.length>=0&&(y="|      Conf files:",a=0,t.configFiles.forEach(E=>{u(E.name,E.count)}),n.push(y)),t.launchConfigFiles.length>0){let E="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{const F=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`;E+=F}),n.push(E)}return n.join(`
`)}j(t){const n=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(n-r.length)}  ${t[r]}`).join(`
                  `)}k(t){const n=[],r=[];return t.windows.forEach(a=>{a.folderURIs.length===0||a.remoteAuthority||(n.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const y=R.URI.revive(u);if(y.scheme===N.Schemas.file){const C=y.fsPath;r.push(P(C,["node_modules",".git"]).then(v=>{let E=`${v.fileCount} files`;v.maxFilesReached&&(E=`more than ${E}`),n.push(`|    Folder (${(0,O.$mc)(C)}): ${E}`),n.push(this.h(v))}).catch(v=>{n.push(`|      Error: Unable to collect workspace stats for folder ${C} (${v.toString()})`)}))}else n.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>n.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}m(t,n){const r=new Map;t.windows.forEach(u=>r.set(u.pid,`window [${u.id}] (${u.title})`)),t.pidToNames.forEach(({pid:u,name:y})=>r.set(u,y));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),n&&this.n(t.mainPID,r,a,n,0),a.join(`
`)}n(t,n,r,a,u){const y=u===0;let C;y?C=a.pid===t?`${this.d.applicationName} main`:"remote agent":n.has(a.pid)?C=n.get(a.pid):C=`${"  ".repeat(u)} ${a.name}`;const v=process.platform==="win32"?a.mem:c.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(v/p.$Fl.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(a.children)&&a.children.forEach(E=>this.n(t,n,r,E,u+1))}async getWorkspaceFileExtensions(t){const n=new Set;for(const{uri:r}of t.folders){const a=R.URI.revive(r);if(a.scheme!==N.Schemas.file)continue;const u=a.fsPath;try{(await P(u,["node_modules",".git"])).fileTypes.forEach(C=>n.add(C.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(t){for(const{uri:n}of t.folders){const r=R.URI.revive(n);if(r.scheme!==N.Schemas.file)continue;const a=r.fsPath;try{const u=await P(a,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),u.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),u.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:u.totalScanTime,reachedLimit:u.maxFilesReached,fileCount:u.fileCount,readdirCount:u.totalReaddirCount})}catch{}}}};e.$Ys=i,e.$Ys=i=ve([Q(0,g.$9l),Q(1,S.$qk)],i)}),define(he[110],ue([0,1,8,4,10,18]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.ExtensionSignatureVerificationCode=e.$qq=void 0,e.$qq=(0,c.$Ci)("IExtensionSignatureVerificationService");var N;(function(b){b.Success="Success",b.RequiredArgumentMissing="RequiredArgumentMissing",b.InvalidArgument="InvalidArgument",b.PackageIsUnreadable="PackageIsUnreadable",b.UnhandledException="UnhandledException",b.SignatureManifestIsMissing="SignatureManifestIsMissing",b.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",b.SignatureIsMissing="SignatureIsMissing",b.SignatureIsUnreadable="SignatureIsUnreadable",b.CertificateIsUnreadable="CertificateIsUnreadable",b.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",b.FileAlreadyExists="FileAlreadyExists",b.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",b.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",b.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",b.SignatureIsInvalid="SignatureIsInvalid",b.SignatureManifestIsInvalid="SignatureManifestIsInvalid",b.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",b.EntryIsMissing="EntryIsMissing",b.EntryIsTampered="EntryIsTampered",b.Untrusted="Untrusted",b.CertificateRevoked="CertificateRevoked",b.SignatureIsNotValid="SignatureIsNotValid",b.UnknownError="UnknownError",b.PackageIsInvalidZip="PackageIsInvalidZip",b.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(N||(e.ExtensionSignatureVerificationCode=N={}));class O extends Error{constructor(R){super(R),this.code=R}}e.$rq=O;let k=class{constructor(R,d){this.b=R,this.c=d}d(){return this.a||(this.a=new Promise((R,d)=>oe(["@vscode/vsce-sign"],async f=>R(f),d))),this.a}async verify(R,d,f,$){let l;const p=R.identifier.id;try{l=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,I.$9)(P)),this.b.info(`Extension signature verification is not done: ${p}`),!1}const S=new Date().getTime();let g;try{this.b.trace(`Verifying extension signature for ${p}...`),g=await l.verify(d,f,this.b.getLevel()===L.LogLevel.Trace)}catch(P){g={code:N.UnknownError,didExecute:!1,output:(0,I.$9)(P)}}const w=new Date().getTime()-S;if(this.b.info(`Extension signature verification result for ${p}: ${g.code}. Executed: ${g.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${p}:
${g.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:p,extensionVersion:R.version,code:g.code,internalCode:g.internalCode,duration:w,didExecute:g.didExecute,clientTargetPlatform:$}),g.code===N.Success)return!0;throw new O(g.code)}};e.$sq=k,e.$sq=k=ve([Q(0,L.$0j),Q(1,A.$9l)],k)}),define(he[111],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0;class I{constructor(A){this.b=A}listen(A,N){throw new Error(`Event not found: ${N}`)}call(A,N,{eventName:O,data:k}){return this.b.forEach(b=>b.log(O,k)),Promise.resolve(null)}}e.$9fc=I;class c{constructor(A){this.b=A}log(A,N){return this.b.call("log",{eventName:A,data:N}).then(void 0,O=>`Failed to log telemetry: ${console.warn(O)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$0fc=c}),define(he[48],ue([0,1,29,12,105,109,18]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=void 0,e.$Bp=R,e.$Cp=d,e.$Dp=f,e.$Ep=$,e.$Fp=p,e.$Gp=g,e.$Hp=w,e.$Ip=o;class O{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$up=O;class k{constructor(){this.telemetryLevel=N.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$vp=k,e.$wp=new k;class b{async publicLog(i,s,t){}async publicLogError(i,s,t){}}e.$xp=b,e.$yp="telemetry",e.$zp="extensionTelemetryLog",e.$Ap={log:()=>null,flush:()=>Promise.resolve(null)};function R(h,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!h.enableTelemetry)}function d(h,i){return i.extensionTestsLocationURI?!0:!(i.isBuilt||i.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}function f(h){const i=h.getValue(N.$fm),s=h.getValue(N.$gm);if(h.getValue(N.$hm)===!1||s===!1)return N.TelemetryLevel.NONE;switch(i??N.TelemetryConfiguration.ON){case N.TelemetryConfiguration.ON:return N.TelemetryLevel.USAGE;case N.TelemetryConfiguration.ERROR:return N.TelemetryLevel.ERROR;case N.TelemetryConfiguration.CRASH:return N.TelemetryLevel.CRASH;case N.TelemetryConfiguration.OFF:return N.TelemetryLevel.NONE}}function $(h){const i={},s={},t={};S(h,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const r=t[n];typeof r=="number"?s[n]=r:typeof r=="boolean"?s[n]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${r.length}`),i[n]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(i[n]=r)}return{properties:i,measurements:s}}const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(h){if(!h)return"none";const i=(0,L.$fn)(h);return l.has(i)?i:"other"}function S(h,i,s=0,t){if(h)for(const n of Object.getOwnPropertyNames(h)){const r=h[n],a=t?t+n:n;Array.isArray(r)?i[a]=(0,I.$go)(r):r instanceof Date?i[a]=r.toISOString():(0,c.$eg)(r)?s<2?S(r,i,s+1,a+"."):i[a]=(0,I.$go)(r):i[a]=r}}function g(h,i){const s=h.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,A.$tp)(s)||t}function w(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}function P(h,i){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let s=h;const t=[];for(const u of i)for(;;){const y=u.exec(h);if(!y)break;t.push([y.index,u.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(s="";;){const u=r.exec(h);if(!u)break;const y=t.some(([C,v])=>u.index<v&&C<r.lastIndex);!n.test(u[0])&&!y&&(s+=h.substring(a,u.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<h.length&&(s+=h.substr(a)),s}function m(h){if(!h)return h;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of i)if(s.regex.test(h))return`<REDACTED: ${s.label}>`;return h}function o(h,i){return(0,I.$do)(h,s=>{if(s instanceof O||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let t=s.replaceAll("%20"," ");t=P(t,i);for(const n of i)t=t.replace(n,"");return t=m(t),t}})}}),define(he[34],ue([0,1,26,27,33,5,9,8,37,48]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Kp=void 0,e.$Jp=R,e.$Lp=l,e.$Mp=p,e.$Np=S,e.$Op=g,e.$Pp=w,e.$Qp=P,e.$Rp=m,e.$Tp=o,e.$Up=i;function R(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,I.$yf)(s.id,t.id)===0}const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(t){const n=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new f(t.identifier,n,r)}static parse(t){const n=d.exec(t);return n&&n[1]&&n[2]?new f({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,r=L.TargetPlatform.UNDEFINED){this.identifier=t,this.version=n,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==L.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof f?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Kp=f;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function l(s){const t=$.exec(s);return t&&t[1]?[S(t[1]),t[2]]:[S(s),void 0]}function p(s,t){return`${s}.${t}`}function S(s){return s.toLowerCase()}function g(s,t){return S(p(s??L.$kn,t))}function w(s,t){const n=[],r=a=>{for(const u of n)if(u.some(y=>R(t(y),t(a))))return u;return null};for(const a of s){const u=r(a);u?u.push(a):n.push([a])}return n}function P(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function m(s){return{id:new b.$up(s.identifier.id),name:new b.$up(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Sp=new L.$on("pprice.better-merge");function o(s,t){const n=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&n.every(u=>!R(u.identifier,{id:a}))){const u=s.filter(y=>R(y.identifier,{id:a}));u.length===1&&(n.push(u[0]),r.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function h(s,t){if(!A.$l)return!1;let n;try{n=(await s.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await s.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){t.debug("Error while getting the os-release file.",(0,O.$9)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(s,t){const n=await h(s,t),r=(0,c.$ep)(n?"alpine":A.$v,k.$dc);return t.debug("ComputeTargetPlatform:",r),r}}),define(he[196],ue([0,1,25,27,34,33]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$16b=N;async function N(O,k,b,R,d){try{const f=await O.getExtensionsControlManifest();if(!f.deprecated)return;const $=await O.getInstalled(A.ExtensionType.User);for(const[l,p]of Object.entries(f.deprecated)){if(!p?.extension)continue;const{id:S,autoMigrate:g,preRelease:w}=p.extension;if(!g)continue;const P=$.find(o=>(0,L.$Jp)(o.identifier,{id:l}));if(!P)continue;const m=(await k.getExtensions([{id:S,preRelease:w}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!m){d.info(`Skipping migrating '${P.identifier.id}' extension because, the comaptible target '${S}' extension is not found`);continue}try{d.info(`Migrating '${P.identifier.id}' extension to '${S}' extension...`);const o=!R.getDisabledExtensions().some(i=>(0,L.$Jp)(i,P.identifier));await O.uninstall(P),d.info(`Uninstalled the unsupported extension '${P.identifier.id}'`);let h=$.find(i=>(0,L.$Jp)(i.identifier,{id:S}));(!h||!h.isPreReleaseVersion&&o)&&(h=await O.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:P.isMachineScoped,operation:c.InstallOperation.Migrate}),d.info(`Installed the pre-release extension '${h.identifier.id}'`),o||(await R.disableExtension(h.identifier),d.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${P.identifier.id}' is disabled`)),g.storage&&(b.addToMigrationList((0,L.$Mp)(P.manifest.publisher,P.manifest.name),(0,L.$Mp)(h.manifest.publisher,h.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${P.identifier.id}' extension to '${S}' extension.`)}catch(o){d.error(o)}}}catch(f){d.error(f)}}}),define(he[197],ue([0,1,8,3,2,36,34,33,7]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class b extends L.$Tc{constructor(d,f,$,l,p,S,g){super(),this.f=d,this.g=f,this.h=$,this.j=l,this.m=p,this.n=S,this.r=g,this.a=this.B(new c.$je),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$3c),this.s().then(null,w=>g.error("Error while initializing Extensions Watcher",(0,I.$9)(w)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(f=>(this.c.set(f.id,(0,L.$Qc)(this.n.watch(this.m.extUri.dirname(f.extensionsResource)),this.n.watch(f.extensionsResource))),this.G(f.extensionsResource))))}catch(f){throw this.r.error(f),f}}async w(d){for(const f of d.extensions)this.I(this.L(f.identifier,f.version),d.profileLocation)}async y(d){for(const f of d.extensions){const $=this.L(f.identifier,f.version);d.error?this.J($,d.profileLocation):this.I($,d.profileLocation)}}async z(d){for(const f of d.extensions)this.J(this.L(f.identifier,f.version),d.profileLocation)}async C(d){const f=[],$=[];for(const l of d.extensions){const p=this.L(l.identifier,l.version);d.error?this.I(p,d.profileLocation):(this.J(p,d.profileLocation),this.b.has(p)||(this.r.debug("Extension is removed from all profiles",l.identifier.id,l.version),$.push(this.f.scanInstalledExtensionAtLocation(l.location).then(S=>{S?f.push(S):this.r.info("Extension not found at the location",l.location.toString())},S=>this.r.error(S)))))}try{await Promise.all($),f.length&&await this.H(f)}catch(l){this.r.error(l)}}D(d){for(const f of this.h.profiles)d.contains(f.extensionsResource,k.FileChangeType.UPDATED,k.FileChangeType.ADDED)&&this.F(f.extensionsResource)}async F(d){const f=[],$=[],l=await this.j.scanProfileExtensions(d),p=new Set,S=new Set;for(const[g,w]of this.b)w.has(d)&&S.add(g);for(const g of l){const w=this.L(g.identifier,g.version);p.add(w),S.has(w)||(f.push(g.identifier),this.I(w,d))}for(const g of S)if(!p.has(g)){const w=this.M(g);w&&($.push(w.identifier),this.J(g,d))}(f.length||$.length)&&this.a.fire({added:f.length?{extensions:f,profileLocation:d}:void 0,removed:$.length?{extensions:$,profileLocation:d}:void 0})}async G(d){const f=await this.j.scanProfileExtensions(d);for(const $ of f)this.I(this.L($.identifier,$.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter($=>!this.b.has(this.L($.identifier,$.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,f){let $=this.b.get(d);$||this.b.set(d,$=new A.$Ac(l=>this.m.extUri.getComparisonKey(l))),$.add(f)}J(d,f){const $=this.b.get(d);$&&$.delete(f),$?.size||this.b.delete(d)}L(d,f){return`${O.$on.toKey(d.id)}@${f}`}M(d){const[f,$]=(0,N.$Lp)(d);return $?{identifier:{id:f},version:$}:void 0}}e.$Uq=b}),define(he[198],ue([0,1,32,75,17,6,2,22,13,30,15,27,34,10,78,9]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0,I=ke(I);let S=class extends l.$0r{constructor(m,o,h,i){super(h),this.h=m,this.j=i,this.g=this.B(new g(o,i)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(m,o){const i=(await this.g.getLanguagePacks())[o];if(!i){this.j.warn(`No language pack found for ${o}`);return}const s=i.translations[m];return s?p.URI.file(s):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),o=Object.keys(m).map(h=>{const i=m[h];return{...this.f(h,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return o.push(this.f("en","English")),o.sort((h,i)=>h.label.localeCompare(i.label)),o}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const o=await this.g.getLanguagePacks();Object.keys(o).some(h=>o[h]&&o[h].extensions.some(i=>(0,f.$Jp)(i.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,o]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(o);return!(0,L.$tb)(Object.keys(m),Object.keys(h))}};e.$$r=S,e.$$r=S=ve([Q(0,d.$lp),Q(1,R.$Ki),Q(2,d.$ip),Q(3,$.$0j)],S);let g=class extends N.$Tc{constructor(m,o){super(),this.j=o,this.c={},this.f=(0,k.$ic)(m.userDataPath,"languagepacks.json"),this.g=new A.$Jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(o=>{Object.keys(o).forEach(h=>delete o[h]),this.m(o,...m)}).then(()=>this.c)}m(m,...o){for(const h of o)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n(m,h);Object.keys(m).forEach(h=>this.r(m[h]))}n(m,o){const h=o.identifier,i=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const s of i)if(o.location.scheme===O.Schemas.file&&w(s)){let t=m[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},m[s.languageId]=t);const n=t.extensions.filter(r=>(0,f.$Jp)(r.extensionIdentifier,h))[0];n?n.version=o.manifest.version:t.extensions.push({extensionIdentifier:h,version:o.manifest.version});for(const r of s.translations)t.translations[r.id]=(0,k.$ic)(o.location.fsPath,r.path)}}r(m){if(m){const o=(0,c.createHash)("md5");for(const h of m.extensions)o.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);m.hash=o.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let o=null;return I.promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(o=m(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.c=h,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),b.Promises.writeFile(this.f,i)}).then(()=>o,h=>this.j.error(h))})}};g=ve([Q(0,R.$Ki),Q(1,$.$0j)],g);function w(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const m of P.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}}),define(he[199],ue([0,1,139,8,29,48]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dR=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function k(R,d,f){const $=await(0,I.$sE)("@microsoft/1ds-core-js","dist/ms.core.js"),l=await(0,I.$sE)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new $.AppInsightsCore,S=new l.PostChannel,g={instrumentationKey:R,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[S]]};if(f){g.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:f};g.extensionConfig[S.identifier]=w}return p.initialize(g,[]),p.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',d&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),p}class b{constructor(d,f,$,l,p){this.e=d,this.f=f,this.g=$,this.h=p,this.c=N,this.d=O,this.g||(this.g={}),typeof l=="function"?this.a=l():this.a=l,this.b=null}i(d){if(this.a){if(typeof this.a!="string"){d(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(f=>{d(f)},f=>{(0,c.$Y)(f),console.error(f)})}}log(d,f){if(!this.a)return;f=(0,L.$eo)(f,this.g),f=(0,A.$Ep)(f);const $=this.f+"/"+d;try{this.i(l=>{l.pluginVersionString=f?.properties.version??"Unknown",l.track({name:$,baseData:{name:$,properties:f?.properties,measurements:f?.measurements}})})}catch{}}flush(){return this.a?new Promise(d=>{this.i(f=>{f.unload(!0,()=>{this.a=void 0,d(void 0)})})}):Promise.resolve(void 0)}}e.$dR=b}),define(he[112],ue([0,1,2,11,15,10,23,48]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;let k=class extends I.$Tc{constructor(R,d,f,$,l=""){super(),this.b=l;const p=d.getLogger(O.$yp);if(p)this.a=this.B(p);else{const g=(0,O.$Cp)($,f)?" (Not Sent)":"",w=()=>(0,O.$Bp)($,f)&&R.getLevel()===A.LogLevel.Trace;this.a=this.B(d.createLogger(O.$yp,{name:(0,c.localize)(11049,null,g),hidden:!w()})),this.B(R.onDidChangeLogLevel(()=>d.setVisibility(O.$yp,w()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,d){this.a.trace(`${this.b}telemetry/${R}`,(0,O.$Ep)(d))}};e.$ldc=k,e.$ldc=k=ve([Q(0,A.$0j),Q(1,A.$$j),Q(2,L.$Ji),Q(3,N.$qk)],k)});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[113],ue([0,1,2,29,5,26,11,21,47,102,23,44,18,48]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,b=it(b);let l=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,w,P){this.k=w,this.l=P,this.d={},this.i=new I.$Sc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=f.TelemetryLevel.USAGE,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,A.$ff)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$ff)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(f.$fm)||m.affectsConfiguration(f.$hm)||m.affectsConfiguration(f.$gm))&&this.m()}))}setExperimentProperty(g,w){this.d[g]=w}m(){let g=(0,$.$Dp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const P=w.usage?f.TelemetryLevel.USAGE:w.error?f.TelemetryLevel.ERROR:f.TelemetryLevel.NONE;g=Math.min(g,P)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,w,P){this.g<w||(P=(0,c.$eo)(P,this.d),P=(0,$.$Ip)(P,this.j),P=(0,c.$eo)(P,this.c),this.b.forEach(m=>m.log(g,P)))}publicLog(g,w){this.n(g,f.TelemetryLevel.USAGE,w)}publicLog2(g,w){this.publicLog(g,w)}publicLogError(g,w){this.h&&this.n(g,f.TelemetryLevel.ERROR,w)}publicLogError2(g,w){this.publicLogError(g,w)}};e.$es=l,e.$es=l=ve([Q(1,O.$9i),Q(2,R.$qk)],l);function p(){const S=(0,N.localize)(11031,null,b.default.nameLong),g=b.default.privacyStatementUrl?(0,N.localize)(11033,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,N.localize)(11032,null,"https://aka.ms/vscode-telemetry"),w=L.$p?"":(0,N.localize)(11034,null),P=(0,N.localize)(11035,null),m=(0,N.localize)(11036,null),o=(0,N.localize)(11037,null),h=(0,N.localize)(11038,null),i=`
|       | ${P} | ${m} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,N.localize)(11039,null);return`
${S} ${g} ${w}

&nbsp;

${h}
${i}

&nbsp;

${s}
`}d.$oo.as(k.$to.Configuration).registerConfiguration({id:f.$em,order:1,type:"object",title:(0,N.localize)(11040,null),properties:{[f.$fm]:{type:"string",enum:[f.TelemetryConfiguration.ON,f.TelemetryConfiguration.ERROR,f.TelemetryConfiguration.CRASH,f.TelemetryConfiguration.OFF],enumDescriptions:[(0,N.localize)(11041,null),(0,N.localize)(11042,null),(0,N.localize)(11043,null),(0,N.localize)(11044,null)],markdownDescription:p(),default:f.TelemetryConfiguration.ON,restricted:!0,scope:k.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),d.$oo.as(k.$to.Configuration).registerConfiguration({id:f.$em,order:110,type:"object",title:(0,N.localize)(11045,null),properties:{[f.$hm]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,N.localize)(11047,null,b.default.nameLong,b.default.privacyStatementUrl):(0,N.localize)(11046,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(11048,null,`\`#${f.$fm}#\``),scope:k.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(he[200],ue([0,1,14,25,243,199]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eR=void 0,L=ke(L);async function N(R,d){const f=await d.request(R,c.CancellationToken.None),$=(await(0,I.$Xe)(f.stream)).toString(),l=f.res.statusCode??200;return{headers:f.res.headers,statusCode:l,responseData:$}}async function O(R){const d={method:R.type,headers:R.headers};return new Promise(($,l)=>{const p=L.request(R.url??"",d,S=>{S.on("data",function(g){$({headers:S.headers,statusCode:S.statusCode??200,responseData:g.toString()})}),S.on("error",function(g){l(g)})});p.write(R.data,S=>{S&&l(S)}),p.end()})}async function k(R,d,f){const $=typeof d.data=="string"?d.data:new TextDecoder().decode(d.data),l={type:"POST",headers:{...d.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(d.data).toString()},url:d.urlString,data:$};try{const p=R?await N(l,R):await O(l);f(p.statusCode,p.headers,p.responseData)}catch{f(0,{})}}class b extends A.$dR{constructor(d,f,$,l,p){const S={sendPOST:(g,w)=>{k(d,g,w)}};super(f,$,l,p,S)}}e.$eR=b}),define(he[201],ue([0,1,22,95,21,15,10,23,18,111,112,113]),function(oe,e,I,c,L,A,N,O,k,b,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;let f=class{constructor(l,p,S,g,w,P){this.b=l,this.c=p,this.d=S,this.e=g,this.f=w,this.g=P,this.a=new Map}h(l){if(!this.a.has(l.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const S=[l.id,JSON.stringify(p),l.aiKey],w=new c.$fr(I.$Wg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:S,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),P=[new b.$0fc(w),new R.$ldc(this.d,this.e,this.f,this.g,`[${l.id}] `)];this.a.set(l.id,new d.$es({appenders:P,sendErrorTelemetry:l.sendErrorTelemetry},this.b,this.g))}return this.a.get(l.id)}publicLog(l,p,S){this.h(l).publicLog(p,S)}publicLogError(l,p,S){this.h(l).publicLogError(p,S)}};e.$lhc=f,e.$lhc=f=ve([Q(0,L.$9i),Q(1,k.$9l),Q(2,N.$0j),Q(3,N.$$j),Q(4,A.$Ji),Q(5,O.$qk)],f)}),define(he[80],ue([0,1,3,2,5,9,21,4,10]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mw=e.$Lw=e.$Iw=e.$Gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Cw=e.$Bw=void 0,e.$Dw=d,e.$Ew=$,e.$Fw=l,e.$Hw=p,e.$Jw=S,e.$Kw=g,e.$Bw=(0,O.$Ci)("tunnelService"),e.$Cw=(0,O.$Ci)("sharedTunnelsService");var b;(function(m){m.Http="http",m.Https="https"})(b||(e.TunnelProtocol=b={}));var R;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(R||(e.TunnelPrivacyId=R={}));function d(m){return!!m.forwardPort}var f;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function $(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(o)return{address:o[1],port:+o[2]}}function l(m){if(m.scheme!=="http"&&m.scheme!=="https"||!m.query)return;const o=m.query.split("&");for(const h of o){const i=h.split("=")[1];if(/^https?:/.exec(i)){const s=$(A.URI.parse(i));if(s)return s}}}e.$Gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(m){return e.$Gw.indexOf(m)>=0}e.$Iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(m){return e.$Iw.indexOf(m)>=0}function g(m,o,h,i){if(h===L.OperatingSystem.Windows)return!1;if(h===L.OperatingSystem.Macintosh&&S(o)){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(s?.length===4&&parseInt(s[1])>=18)return!1}return m<1024}class w{constructor(o,h,i){this.remoteAddress=o,this.localAddress=h,this.b=i,this.a=new I.$je,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lw=w;let P=class extends c.$Tc{constructor(o,h){super(),this.r=o,this.s=h,this.a=new I.$je,this.onTunnelOpened=this.a.event,this.b=new I.$je,this.onTunnelClosed=this.b.event,this.c=new I.$je,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const o=this.s.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.g=o,o?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.h=o.elevation,this.m=o.privacyOptions,this.j=o.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const o=[],h=Array.from(this.f.values());for(const i of h){const s=Array.from(i.values());for(const t of s){const n=await t.value;n&&typeof n!="string"&&o.push(n)}}return o}async dispose(){super.dispose();for(const o of this.f.values()){for(const{value:h}of o.values())await h.then(i=>typeof i!="string"?i?.dispose():void 0);o.clear()}this.f.clear()}setEnvironmentTunnel(o,h,i,s,t){this.z(o,h,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:h,localAddress:i,privacy:s,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,h){(S(o)||p(o))&&(o=e.$Gw[0]);const i=this.D(o,h);if(i)return++i.refcount,i.value}openTunnel(o,h,i,s,t,n=!1,r,a){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${i} on local port ${t}.`);const u=this.g??o;if(!u)return;if(h||(h="localhost"),s||(s=this.t),this.g&&this.n.has(i)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.F(u,h,i,s,t,n,r,a);return y?y.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(h,i),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(h,i);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.w(C);return(C.tunnelRemoteHost!==h||C.tunnelRemotePort!==i)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&C.privacy!==r&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}w(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const h=this.f.get(o.tunnelRemoteHost);if(h){const i=h.get(o.tunnelRemotePort);i&&(i.refcount--,await this.y(o.tunnelRemoteHost,o.tunnelRemotePort,i))}}}}async y(o,h,i){if(i.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${h}.`);const s=i.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.f.has(o)&&this.f.get(o).delete(h),s}}async closeTunnel(o,h){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${h} `);const i=this.f.get(o);if(i&&i.has(h)){const s=i.get(h);s.refcount=0,await this.y(o,h,s)}}z(o,h,i){this.f.has(o)||this.f.set(o,new Map),this.f.get(o).set(h,{refcount:1,value:i})}async C(o,h){const i=this.f.get(o);if(i){const s=i.get(h),t=s?await s.value:void 0;(!t||typeof t=="string")&&i.delete(h),i.size===0&&this.f.delete(o)}}D(o,h){const i=[o];p(o)?(i.push(...e.$Gw),i.push(...e.$Iw)):S(o)&&i.push(...e.$Iw);const s=i.map(t=>this.f.get(t));for(const t of s){const n=t?.get(h);if(n)return n}}canTunnel(o){return!!$(o)}G(o,h,i,s,t,n,r){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${i} on local port ${s}.`);const a=i;this.n.add(a);const u=s===void 0?i:s,y={elevationRequired:t?this.isPortPrivileged(u):!1},C={remoteAddress:{host:h,port:i},localAddressPort:s,privacy:n,public:n?n!==R.Private:void 0,protocol:r},v=o.forwardPort(C,y);return v?(this.z(h,i,v),v.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(a)})):this.n.delete(a),v}};e.$Mw=P,e.$Mw=P=ve([Q(0,k.$0j),Q(1,N.$9i)],P)}),define(he[202],ue([0,1,10,80,2,8,6]),function(oe,e,I,c,L,A,N){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=void 0;class k extends L.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new N.$Zh),this.b.p)}setAddress(d){this.a=d,this.b&&(this.b.complete(d),this.b=null)}setTunnel(d){this.B(d)}}let b=class extends L.$Tc{static{O=this}static{this.a=0}constructor(d,f){super(),this.f=d,this.g=f,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(d=>d.dispose())}async createTunnel(){return{id:String(++O.a)}}async startTunnel(d,f,$,l,p,S,g){const w=new k,P=await Promise.resolve(this.f.openTunnel(d,w,$,l,p,S,g));if(!P||typeof P=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${$}:${l} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(f))throw this.c.delete(f),w.dispose(),await P.dispose(),(0,A.$5)();return w.setTunnel(P),this.b.set(f,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${f}: ${P.localAddress} (local) to ${$}:${l} (remote).`),{tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress}}async setAddress(d,f){const $=this.b.get(d);$&&$.setAddress(f)}async destroyTunnel(d){const f=this.b.get(d);if(f){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${d}.`),this.b.delete(d),await f.dispose();return}this.c.add(d)}};e.$vhc=b,e.$vhc=b=O=ve([Q(0,c.$Cw),Q(1,I.$0j)],b)}),define(he[28],ue([0,1,4]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=void 0,e.$Hl=(0,I.$Ci)("IUriIdentityService")}),define(he[203],ue([0,1,28,159,7,20,134,3,2]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class b{static{this._clock=0}constructor(f){this.uri=f,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let R=class{constructor(f){this.g=f,this.c=new k.$Sc,this.f=2**16;const $=new Map,l=p=>{let S=$.get(p.scheme);return S===void 0&&(S=f.hasProvider(p)&&!this.g.hasCapability(p,L.FileSystemProviderCapabilities.PathCaseSensitive),$.set(p.scheme,S)),S};this.c.add(O.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(p=>{$.delete(p.scheme)})),this.extUri=new A.$5g(l),this.d=new N.$Qs((p,S)=>this.extUri.compare(p,S,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(f){this.g.hasProvider(f)&&(f=(0,A.$eh)(f));const $=this.d.get(f);return $?$.touch().uri.with({fragment:f.fragment}):(this.d.set(f,new b(f)),this.h(),f)}h(){if(this.d.size<this.f)return;const f=[...this.d.entries()].sort((l,p)=>l[1].time<p[1].time?1:l[1].time>p[1].time?-1:0);b._clock=0,this.d.clear();const $=this.f*.5;for(let l=0;l<$;l++)this.d.set(f[l][0],f[l][1].touch())}};e.$Rs=R,e.$Rs=R=ve([Q(0,L.$0k)],R),(0,c.$Os)(I.$Hl,R,c.InstantiationType.Delayed)}),define(he[204],ue([0,1,3,2,7,51,36]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class O extends c.$Tc{constructor(b,R,d,f,$,l){super(),this.f=b,this.g=R,this.h=d,this.j=f,this.m=$,this.n=l,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new I.$je),this.onDidChangeFile=this.a.event,this.b=A.$Ii.forUris(()=>!(this.capabilities&L.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new N.$Ac(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(f.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const b of this.j.profiles)this.c.add(b.settingsResource),this.c.add(b.keybindingsResource),this.c.add(b.tasksResource),this.c.add(b.extensionsResource)}open(b,R){return this.g.open(this.t(b),R)}close(b){return this.g.close(b)}read(b,R,d,f,$){return this.g.read(b,R,d,f,$)}write(b,R,d,f,$){return this.g.write(b,R,d,f,$)}watch(b,R){this.b.set(b,b);const d=this.g.watch(this.t(b),R);return(0,c.$Rc)(()=>{this.b.delete(b),d.dispose()})}stat(b){return this.g.stat(this.t(b))}mkdir(b){return this.g.mkdir(this.t(b))}rename(b,R,d){return this.g.rename(this.t(b),this.t(R),d)}readFile(b,R){return this.g.readFile(this.t(b),R)}readFileStream(b,R,d){return this.g.readFileStream(this.t(b),R,d)}readdir(b){return this.g.readdir(this.t(b))}enforceAtomicReadFile(b){return this.c.has(b)}writeFile(b,R,d){return this.g.writeFile(this.t(b),R,d)}enforceAtomicWriteFile(b){return this.c.has(b)?{postfix:".vsctmp"}:!1}delete(b,R){return this.g.delete(this.t(b),R)}copy(b,R,d){if((0,L.$bl)(this.g))return this.g.copy(this.t(b),this.t(R),d);throw new Error("copy not supported")}cloneFile(b,R){if((0,L.$cl)(this.g))return this.g.cloneFile(this.t(b),this.t(R));throw new Error("clone not supported")}s(b){const R=[];for(const d of b){if(d.resource.scheme!==this.f)continue;const f=this.u(d.resource);this.b.findSubstr(f)&&R.push({resource:f,type:d.type,cId:d.cId})}R.length&&(this.n.debug("User data changed"),this.a.fire(R))}t(b){return b.with({scheme:this.f})}u(b){return b.with({scheme:this.h})}}e.$Ygc=O}),define(he[81],ue([0,1,64]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=c,e.$nMb=L,e.$oMb=A;function c(N,O,k,b){const R=(0,I.$0n)(N,O,k,b)[0];return R&&(N=N.substring(0,R.offset)+R.content+N.substring(R.offset+R.length)),N}function L(N,O,k){let b=k;for(;b>=0;){if(N.charAt(b)===O.charAt(O.length-1)&&O.length===1)return b+1;if(b--,O.length===2&&b>=0&&N.charAt(b)===O.charAt(0))return b+2}return 0}function A(N,O,k){let b=k;for(;b>=0;)if(N.charAt(b)===O.charAt(O.length-1)&&O.length===1||(b++,O.length===2&&b>=0&&N.charAt(b)===O.charAt(1)))return b;return N.length-1}}),define(he[205],ue([0,1,29,60,12]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=A,c=ke(c);function A($,l,p,S,g,w){const P=[],m=[],o=[];if(!l){const j=$.filter(({identifier:K})=>g.every(V=>V.toLowerCase()!==K.id.toLowerCase()));return{local:{added:P,removed:m,updated:o},remote:j.length>0?{added:j,updated:[],removed:[],all:j}:null}}$=$.map(d),l=l.map(d),p=p?p.map(d):null;const h=new Map,i=j=>{j.uuid&&h.set(j.id.toLowerCase(),j.uuid)};$.forEach(({identifier:j})=>i(j)),l.forEach(({identifier:j})=>i(j)),p?.forEach(({identifier:j})=>i(j)),S?.forEach(({identifier:j})=>i(j)),w?.forEach(j=>i(j));const s=j=>{const K=j.identifier.uuid||h.get(j.identifier.id.toLowerCase());return K?`uuid:${K}`:`id:${j.identifier.id.toLowerCase()}`},t=(j,K)=>(j.set(s(K),K),j),n=$.reduce(t,new Map),r=l.reduce(t,new Map),a=l.reduce((j,K)=>t(j,(0,I.$bo)(K)),new Map),u=p?p.reduce(t,new Map):null,y=S.reduce(t,new Map),C=g.reduce((j,K)=>{const V=h.get(K.toLowerCase());return j.add(V?`uuid:${V}`:`id:${K.toLowerCase()}`)},new Set),v=w?w.reduce((j,{id:K,uuid:V})=>(V=V??h.get(K.toLowerCase()),j.add(V?`uuid:${V}`:`id:${K.toLowerCase()}`)),new Set):null,E=N(n,r,C,!1);if(E.added.size>0||E.removed.size>0||E.updated.size>0){const j=N(u,n,C,!1),K=N(u,r,C,!0),V=(x,H,ie,W)=>{let z,_,ne;return H.installed?(z=W.pinned,ne=W.preRelease,z&&(_=W.version)):(z=ie.pinned,ne=ie.preRelease,z&&(_=ie.version)),z===void 0&&(z=H.pinned,z&&(_=H.version)),ne===void 0&&(ne=H.preRelease),{...W,installed:H.installed||ie.installed,pinned:z,preRelease:ne,version:_??(ie.version&&(!H.installed||c.gt(ie.version,H.version))?ie.version:H.version),state:k(H,ie,u?.get(x))}};for(const x of K.removed.values()){const H=n.get(x);if(!H)continue;const ie=(0,L.$ng)(u?.get(x)),W=v&&!v.has(x)&&ie.installed;H.installed&&W?m.push(H.identifier):a.set(x,H)}for(const x of K.added.values()){const H=(0,L.$ng)(r.get(x)),ie=n.get(x);if(ie){if(E.updated.has(x)){const W=V(x,ie,H,H);O(ie,H,!1,!1)||o.push(f(W,x)),a.set(x,W)}}else H.installed&&P.push(f(H,x))}for(const x of K.updated.values()){const H=(0,L.$ng)(r.get(x)),ie=(0,L.$ng)(u?.get(x)),W=n.get(x);if(W)if(v&&!v.has(x)&&ie.installed&&W.installed&&!H.installed)m.push(W.identifier);else{const _=V(x,W,H,H);o.push(f(_,x)),a.set(x,_)}else H.installed&&P.push(f(H,x))}for(const x of j.added.values())K.added.has(x)||a.set(x,(0,L.$ng)(n.get(x)));for(const x of j.updated.values()){if(K.removed.has(x)||K.updated.has(x))continue;const H=(0,L.$ng)(n.get(x)),ie=(0,L.$ng)(r.get(x));a.set(x,V(x,H,ie,H))}for(const x of j.removed.values())K.updated.has(x)||K.removed.has(x)||y.has(x)||(0,L.$ng)(r.get(x)).installed&&v&&(v.has(x)||!(0,L.$ng)(u?.get(x)).installed||a.delete(x))}const T=[],F=N(r,a,new Set,!0),U=F.added.size>0||F.updated.size>0||F.removed.size>0;return U&&a.forEach((j,K)=>T.push(f(j,K))),{local:{added:P,removed:m,updated:o},remote:U?{added:[...F.added].map(j=>a.get(j)),updated:[...F.updated].map(j=>a.get(j)),removed:[...F.removed].map(j=>r.get(j)),all:T}:null}}function N($,l,p,S){const g=$?[...$.keys()].filter(h=>!p.has(h)):[],w=[...l.keys()].filter(h=>!p.has(h)),P=w.filter(h=>!g.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),m=g.filter(h=>!w.includes(h)).reduce((h,i)=>(h.add(i),h),new Set),o=new Set;for(const h of g){if(m.has(h))continue;const i=$.get(h),s=l.get(h);(!s||!O(i,s,S,!0))&&o.add(h)}return{added:P,removed:m,updated:o}}function O($,l,p,S){return!($.disabled!==l.disabled||!!$.isApplicationScoped!=!!l.isApplicationScoped||S&&$.installed!==l.installed||$.installed&&l.installed&&($.preRelease!==l.preRelease||$.pinned!==l.pinned||l.pinned&&$.version!==l.version)||!R($.state,l.state)||p&&$.version!==l.version)}function k($,l,p){const S=$.state,g=l.state,w=p?.state;if(!l.version||S&&c.gt($.version,l.version))return S;if(g&&c.gt(l.version,$.version)||!S)return g;if(!g)return S;const P=(0,I.$bo)(S),m=w?b(w,g):{added:Object.keys(g).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set},o=w?b(w,S):{added:Object.keys(S).reduce((h,i)=>(h.add(i),h),new Set),removed:new Set,updated:new Set};for(const h of[...m.added.values(),...m.updated.values()])P[h]=g[h];for(const h of m.removed.values())o.updated.has(h)||delete P[h];return P}function b($,l){const p=Object.keys($),S=Object.keys(l),g=S.filter(m=>!p.includes(m)).reduce((m,o)=>(m.add(o),m),new Set),w=p.filter(m=>!S.includes(m)).reduce((m,o)=>(m.add(o),m),new Set),P=new Set;for(const m of p){if(w.has(m))continue;const o=$[m],h=l[m];(0,I.$fo)(o,h)||P.add(m)}return{added:g,removed:w,updated:P}}function R($={},l={}){const{added:p,removed:S,updated:g}=b($,l);return p.size===0&&S.size===0&&g.size===0}function d($){return{...$,disabled:!!$.disabled,installed:!!$.installed}}function f($,l){const p={...$,identifier:{id:$.identifier.id,uuid:l.startsWith("uuid:")?l.substring(5):void 0},preRelease:!!$.preRelease,pinned:!!$.pinned};return $.disabled||delete p.disabled,$.installed||delete p.installed,$.state||delete p.state,$.isApplicationScoped||delete p.isApplicationScoped,p}}),define(he[114],ue([0,1,17,21,4]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EOb=e.$DOb=void 0,e.$DOb=(0,L.$Ci)("IIgnoredExtensionsManagementService");let A=class{constructor(O){this.a=O}hasToNeverSyncExtension(O){return this.b().includes(O.toLowerCase())}hasToAlwaysSyncExtension(O){return this.b().includes(`-${O.toLowerCase()}`)}updateIgnoredExtensions(O,k){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==O&&R!==`-${O}`),k&&b.push(O.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,c.ConfigurationTarget.USER)}updateSynchronizedExtensions(O,k){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return b=b.filter(R=>R!==O&&R!==`-${O}`),k&&b.push(`-${O.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,c.ConfigurationTarget.USER)}getIgnoredExtensions(O){const k=O.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),b=this.b().map(f=>f.toLowerCase()),R=[],d=[];if(Array.isArray(b))for(const f of b)f.startsWith("-")?d.push(f.substring(1)):R.push(f);return(0,I.$Lb)([...k,...R].filter(f=>!d.includes(f)))}b(){let O=this.a.inspect("settingsSync.ignoredExtensions").userValue;return O!==void 0||(O=this.a.inspect("sync.ignoredExtensions").userValue,O!==void 0)?O:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$EOb=A,e.$EOb=A=ve([Q(0,c.$9i)],A)}),define(he[206],ue([0,1,17,35,29,96,81]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=k,L=ke(L),N=ke(N);function O(m){return(0,c.$Vn)(m)||[]}async function k(m,o,h,i,s){const t=O(m),n=O(o),r=h?O(h):null,a=[...t,...n,...r||[]].map(V=>V.key),u=await s.resolveUserBindings(a),y=R(t,n,r,u);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const C=f(t),v=f(n),E=r?f(r):null,T=l(C,v,u),F=E?l(E,C,u):{added:[...C.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},U=E?l(E,v,u):{added:[...v.keys()].reduce((V,x)=>(V.add(x),V),new Set),removed:new Set,updated:new Set},j=b(T,F,U);let K=m;for(const V of j.removed.values())j.conflicts.has(V)||(K=w(K,V,i));for(const V of j.added.values()){if(j.conflicts.has(V))continue;const x=v.get(V);if(x.some(H=>H.command!==`-${V}`&&y.conflicts.has(u[H.key]))){j.conflicts.add(V);continue}K=g(K,x,i)}for(const V of j.updated.values()){if(j.conflicts.has(V))continue;const x=v.get(V);if(x.some(H=>H.command!==`-${V}`&&y.conflicts.has(u[H.key]))){j.conflicts.add(V);continue}K=P(K,V,x,i)}return{mergeContent:K,hasChanges:!0,hasConflicts:j.conflicts.size>0}}function b(m,o,h){const i=new Set,s=new Set,t=new Set,n=new Set;for(const r of o.removed.values())h.updated.has(r)&&n.add(r);for(const r of h.removed.values())n.has(r)||(o.updated.has(r)?n.add(r):s.add(r));for(const r of o.added.values())n.has(r)||h.added.has(r)&&m.updated.has(r)&&n.add(r);for(const r of h.added.values())n.has(r)||(o.added.has(r)?m.updated.has(r)&&n.add(r):i.add(r));for(const r of o.updated.values())n.has(r)||h.updated.has(r)&&m.updated.has(r)&&n.add(r);for(const r of h.updated.values())n.has(r)||(o.updated.has(r)?m.updated.has(r)&&n.add(r):t.add(r));return{added:i,removed:s,updated:t,conflicts:n}}function R(m,o,h,i){const s=new Set,t=d(m,i),n=d(o,i),r=h?d(h,i):null,a=$(t,n);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const u=r?$(r,t):{added:[...t.keys()].reduce((F,U)=>(F.add(U),F),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const y=r?$(r,n):{added:[...n.keys()].reduce((F,U)=>(F.add(U),F),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:C,removed:v,updated:E,conflicts:T}=b(a,u,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:v,updated:E,conflicts:T}}function d(m,o){const h=new Map;for(const i of m){const s=o[i.key];let t=h.get(s);t||(t=[],h.set(s,t)),t.push(i)}return h}function f(m){const o=new Map;for(const h of m){const i=h.command[0]==="-"?h.command.substring(1):h.command;let s=o.get(i);s||(s=[],o.set(i,s)),s.push(h)}return o}function $(m,o){const h=[...m.keys()],i=[...o.keys()],s=i.filter(r=>!h.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=h.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),n=new Set;for(const r of h){if(t.has(r))continue;const a=m.get(r).map(y=>({...y,key:r})),u=o.get(r).map(y=>({...y,key:r}));(0,I.$tb)(a,u,(y,C)=>S(y,C))||n.add(r)}return{added:s,removed:t,updated:n}}function l(m,o,h){const i=[...m.keys()],s=[...o.keys()],t=s.filter(a=>!i.includes(a)).reduce((a,u)=>(a.add(u),a),new Set),n=i.filter(a=>!s.includes(a)).reduce((a,u)=>(a.add(u),a),new Set),r=new Set;for(const a of i){if(n.has(a))continue;const u=m.get(a).map(C=>({...C,key:h[C.key]})),y=o.get(a).map(C=>({...C,key:h[C.key]}));p(u,y)||r.add(a)}return{added:t,removed:n,updated:r}}function p(m,o){return!(!(0,I.$tb)(m.filter(({command:h})=>h[0]!=="-"),o.filter(({command:h})=>h[0]!=="-"),(h,i)=>S(h,i))||!(0,I.$tb)(m.filter(({command:h})=>h[0]==="-"),o.filter(({command:h})=>h[0]==="-"),(h,i)=>S(h,i)))}function S(m,o){if(m.command!==o.command||m.key!==o.key)return!1;const h=A.$Aj.deserialize(m.when),i=A.$Aj.deserialize(o.when);return!(h&&!i||!h&&i||h&&i&&!h.equals(i)||!L.$fo(m.args,o.args))}function g(m,o,h){for(const i of o)m=N.edit(m,[-1],i,h);return m}function w(m,o,h){const i=O(m);for(let s=i.length-1;s>=0;s--)(i[s].command===o||i[s].command===`-${o}`)&&(m=N.edit(m,[s],void 0,h));return m}function P(m,o,h,i){const s=O(m),t=s.findIndex(n=>n.command===o||n.command===`-${o}`);for(let n=s.length-1;n>=0;n--)(s[n].command===o||s[n].command===`-${o}`)&&(m=N.edit(m,[n],void 0,i));for(let n=h.length-1;n>=0;n--)m=N.edit(m,[t],h[n],i);return m}}),define(he[207],ue([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=I,e.$dcc=L;function I(A,N,O){const k={},b={},R=new Set;if(!N)return{local:{added:k,updated:b,removed:[...R.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const d=c(A,N);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{local:{added:k,updated:b,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=c(O,A),$=c(O,N),l={},p={},S=new Set,g=new Set;for(const w of f.removed.values())$.updated.has(w)?k[w]=N[w]:S.add(w);for(const w of $.removed.values())g.has(w)||(f.updated.has(w)?g.add(w):R.add(w));for(const w of f.updated.values())g.has(w)||($.updated.has(w)?d.updated.has(w)&&g.add(w):p[w]=A[w]);for(const w of $.updated.values())g.has(w)||(f.updated.has(w)?d.updated.has(w)&&g.add(w):A[w]!==void 0&&(b[w]=N[w]));for(const w of f.added.values())g.has(w)||($.added.has(w)?d.updated.has(w)&&g.add(w):l[w]=A[w]);for(const w of $.added.values())g.has(w)||(f.added.has(w)?d.updated.has(w)&&g.add(w):k[w]=N[w]);return{local:{added:k,removed:[...R.values()],updated:b},remote:{added:l,removed:[...S.values()],updated:p},conflicts:[...g.values()]}}function c(A,N){const O=A?Object.keys(A):[],k=N?Object.keys(N):[],b=k.filter(f=>!O.includes(f)).reduce((f,$)=>(f.add($),f),new Set),R=O.filter(f=>!k.includes(f)).reduce((f,$)=>(f.add($),f),new Set),d=new Set;for(const f of O){if(R.has(f))continue;const $=A[f],l=N[f];$!==l&&d.add(f)}return{added:b,removed:R,updated:d}}function L(A,N){const{added:O,removed:k,updated:b}=c(A,N);return O.size===0&&k.size===0&&b.size===0}}),define(he[208],ue([0,1,29]),function(oe,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=c;function c(A,N,O,k){const b={added:[],removed:[],updated:[]};let R={added:[],removed:[],updated:[]};if(!N){const f=A.filter(({id:$})=>!k.includes($));return f.length?R.added=f:R=null,{local:b,remote:R}}const d=L(A,N,k);if(d.added.length>0||d.removed.length>0||d.updated.length>0){const f=L(O,A,k),$=L(O,N,k);for(const l of $.removed){const p=A.find(S=>S.id===l);p&&b.removed.push(p)}for(const l of $.added){const p=N.find(S=>S.id===l);f.added.includes(l)?d.updated.includes(l)&&b.updated.push(p):b.added.push(p)}for(const l of $.updated)b.updated.push(N.find(p=>p.id===l));for(const l of f.added)$.added.includes(l)||R.added.push(A.find(p=>p.id===l));for(const l of f.updated)$.removed.includes(l)||$.updated.includes(l)||R.updated.push(A.find(p=>p.id===l));for(const l of f.removed){const p=N.find(S=>S.id===l);p&&R.removed.push(p)}}return R.added.length===0&&R.removed.length===0&&R.updated.length===0&&(R=null),{local:b,remote:R}}function L(A,N,O){A=A?A.filter(({id:$})=>!O.includes($)):[],N=N.filter(({id:$})=>!O.includes($));const k=A.map(({id:$})=>$),b=N.map(({id:$})=>$),R=b.filter($=>!k.includes($)),d=k.filter($=>!b.includes($)),f=[];for(const{id:$,name:l,shortName:p,icon:S,useDefaultFlags:g}of A){if(d.includes($))continue;const w=N.find(P=>P.id===$);(!w||w.name!==l||w.shortName!==p||w.icon!==S||!(0,I.$fo)(w.useDefaultFlags,g))&&f.push($)}return{added:R,removed:d,updated:f}}}),define(he[24],ue([0,1,17,12,11,47,27,4,103,44]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnb=e.$Inb=e.$Hnb=e.$Gnb=e.$Fnb=e.$Enb=e.$Dnb=e.$Cnb=e.$Bnb=e.$znb=e.MergeState=e.Change=e.SyncStatus=e.$ynb=e.$xnb=e.$wnb=e.UserDataSyncErrorCode=e.$unb=e.$tnb=e.$snb=e.$rnb=e.$qnb=e.$nnb=e.SyncResource=e.$knb=e.$jnb=void 0,e.$gnb=R,e.$hnb=d,e.$inb=f,e.$lnb=l,e.$mnb=p,e.$onb=g,e.$pnb=w,e.$vnb=P,e.$Anb=r;function R(){const a=b.$oo.as(A.$to.Configuration).getConfigurationProperties();return Object.keys(a).filter(u=>!!a[u].disallowSyncIgnore)}function d(a=!1){const u=b.$oo.as(A.$to.Configuration).getConfigurationProperties(),y=$(u,a),C=R();return(0,I.$Lb)([...y,...C])}function f(a){if(!a.contributes?.configuration)return[];const u=Array.isArray(a.contributes.configuration)?a.contributes.configuration:[a.contributes.configuration];if(!u.length)return[];const y=(0,A.$Jo)(u);return $(y,!1)}function $(a,u){const y=new Set;for(const C in a){if(u&&a[C].source)continue;const v=(0,c.$cg)(a[C].scope)?(0,A.$Ko)(a[C].scope):a[C].scope;(a[C].ignoreSync||v===A.ConfigurationScope.MACHINE||v===A.ConfigurationScope.MACHINE_OVERRIDABLE)&&y.add(C)}return[...y.values()]}e.$jnb="settingsSync",e.$knb="settingsSync.keybindingsPerPlatform";function l(){const a="vscode://schemas/ignoredSettings",u=b.$oo.as(A.$to.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(10894,null),type:"object",properties:{[e.$knb]:{type:"boolean",description:(0,L.localize)(10895,null),default:!0,scope:A.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(10896,null),items:[{type:"string",pattern:N.$8o,errorMessage:(0,L.localize)(10897,null)}],default:[],scope:A.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(10898,null),default:[],scope:A.ConfigurationScope.APPLICATION,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=b.$oo.as(k.$po.JSONContribution),C=()=>{const v=R(),E=d(),T=Object.keys(A.$uo.properties).filter(j=>!E.includes(j)),F=E.filter(j=>!v.includes(j)),U={items:{type:"string",enum:[...T,...F.map(j=>`-${j}`)]}};y.registerSchema(a,U)};return u.onDidUpdateConfiguration(()=>C())}function p(a){return a&&(0,c.$eg)(a)&&(0,c.$cg)(a.id)&&Array.isArray(a.scopes)}var S;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState",a.Profiles="profiles",a.WorkspaceState="workspaceState"})(S||(e.SyncResource=S={})),e.$nnb=[S.Settings,S.Keybindings,S.Snippets,S.Tasks,S.Extensions,S.GlobalState,S.Profiles];function g(a,...u){return a?[a,...u]:u}function w(a,u,y,C){return C.joinPath(y.userDataSyncHome,...g(a,u,`lastSync${u}.json`))}e.$qnb=(0,O.$Ci)("IUserDataSyncStoreManagementService"),e.$rnb=(0,O.$Ci)("IUserDataSyncStoreService"),e.$snb=(0,O.$Ci)("IUserDataSyncLocalStoreService"),e.$tnb="x-operation-id",e.$unb="X-Execution-Id";function P(a){const u={};return u[e.$unb]=a,u}var m;(function(a){a.Unauthorized="Unauthorized",a.Forbidden="Forbidden",a.NotFound="NotFound",a.MethodNotFound="MethodNotFound",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.RequestProtocolNotSupported="RequestProtocolNotSupported",a.RequestPathNotEscaped="RequestPathNotEscaped",a.RequestHeadersNotObject="RequestHeadersNotObject",a.NoCollection="NoCollection",a.NoRef="NoRef",a.EmptyResponse="EmptyResponse",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyProfiles="LocalTooManyProfiles",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.Unknown="Unknown"})(m||(e.UserDataSyncErrorCode=m={}));class o extends Error{constructor(u,y,C,v){super(u),this.code=y,this.resource=C,this.operationId=v,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$wnb=o;class h extends o{constructor(u,y,C,v,E){super(u,C,void 0,E),this.url=y,this.serverCode=v}}e.$xnb=h;class i extends o{constructor(u,y){super(u,y)}}e.$ynb=i,function(a){function u(y){if(y instanceof a)return y;const C=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(C&&C[1]){const v=C[2]==="unknown"?void 0:C[2],E=C[3]==="unknown"?void 0:C[3];return new a(y.message,C[1],v,E)}return new a(y.message,m.Unknown)}a.toUserDataSyncError=u}(o||(e.$wnb=o={}));var s;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(s||(e.SyncStatus=s={}));var t;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(t||(e.Change=t={}));var n;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(n||(e.MergeState=n={})),e.$znb="sync.store.url.type";function r(a){return`sync.enable.${a}`}e.$Bnb=(0,O.$Ci)("IUserDataSyncEnablementService"),e.$Cnb=(0,O.$Ci)("IUserDataSyncService"),e.$Dnb=(0,O.$Ci)("IUserDataSyncResourceProviderService"),e.$Enb=(0,O.$Ci)("IUserDataAutoSyncService"),e.$Fnb=(0,O.$Ci)("IUserDataSyncUtilService"),e.$Gnb=(0,O.$Ci)("IUserDataSyncLogService"),e.$Hnb="userDataSync",e.$Inb="vscode-userdata-sync",e.$Jnb="preview"}),define(he[209],ue([0,1,29,24]),function(oe,e,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VNb=L,I=ke(I);function L(N,O,k,b,R){if(!O)return{remote:{added:Object.keys(N),removed:[],updated:[],all:Object.keys(N).length>0?N:null},local:{added:{},removed:[],updated:{}}};const d=A(N,O);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const f=k?A(k,O):{added:Object.keys(O).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},$=k?A(k,N):{added:Object.keys(N).reduce((w,P)=>(w.add(P),w),new Set),removed:new Set,updated:new Set},l={added:{},removed:[],updated:{}},p=I.$bo(O),S=!k;for(const w of $.added.values())w!==c.$znb&&S&&f.added.has(w)||(p[w]=N[w]);for(const w of $.updated.values())p[w]=N[w];for(const w of $.removed.values())b.unregistered.includes(w)||delete p[w];for(const w of f.added.values()){const P=O[w];if(b.machine.includes(w)){R.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(k&&$.added.has(w))continue;const m=N[w];m&&m.value===P.value||w===c.$znb&&S&&$.added.has(w)||(m?l.updated[w]=P:l.added[w]=P)}for(const w of f.updated.values()){const P=O[w];if(b.machine.includes(w)){R.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if($.updated.has(w)||$.removed.has(w))continue;const m=N[w];m&&m.value===P.value||(l.updated[w]=P)}for(const w of f.removed.values()){if(b.machine.includes(w)){R.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}$.updated.has(w)||$.removed.has(w)||l.removed.push(w)}const g=A(O,p);return{local:l,remote:{added:[...g.added],updated:[...g.updated],removed:[...g.removed],all:g.added.size===0&&g.removed.size===0&&g.updated.size===0?null:p}}}function A(N,O){const k=Object.keys(N),b=Object.keys(O),R=b.filter($=>!k.includes($)).reduce(($,l)=>($.add(l),$),new Set),d=k.filter($=>!b.includes($)).reduce(($,l)=>($.add(l),$),new Set),f=new Set;for(const $ of k){if(d.has($))continue;const l=N[$],p=O[$];I.$fo(l,p)||f.add($)}return{added:R,removed:d,updated:f}}}),define(he[210],ue([0,1,17,35,64,45,29,81,24]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pMb=b,e.$qMb=f,e.$rMb=$,e.$sMb=l,e.$tMb=S,e.$uMb=w,N=ke(N),O=ke(O);function b(a,u,y){let C=[];y?C=d(y):C=R(u);const v=[],E=[...(0,k.$gnb)()];if(Array.isArray(C))for(const T of C)T.startsWith("-")?E.push(T.substring(1)):v.push(T);return(0,I.$Lb)([...a,...v].filter(T=>!E.includes(T)))}function R(a){let u=a.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=a.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:a.getValue("settingsSync.ignoredSettings")||[]}function d(a){const u=(0,c.$Vn)(a);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function f(a,u){const y=(0,c.$Vn)(a)||{};let C="{}";for(const v of Object.keys(y)){const E=(0,L.$0n)(C,[v],y[v],u);C=(0,L.$ao)(C,E)}return C}function $(a,u,y,C){if(y.length){const v=r(u),E=(0,c.$Vn)(u)||{},T=(0,c.$Vn)(a);if(!T)return a;const F=[];for(const U of y){const j=E[U],K=T[U];j===void 0?a=O.edit(a,[U],void 0,C):K!==void 0?a=O.edit(a,[U],j,C):F.push(h(U,v))}F.sort((U,j)=>U.startOffset-j.startOffset),F.forEach(U=>a=w(U.setting.key,u,a,C))}return a}function l(a,u,y,C,v,E){const T=$(a,u,C,E),F=y!==T,U=y!==u;if(!F&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:$(u,a,C,E),remoteContent:null,hasConflicts:!1};if(y===null&&S(a)){const D=p(a,u,C)?null:$(u,a,C,E);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let j=a,K=u;const V=(0,c.$Vn)(a),x=(0,c.$Vn)(u),H=y?(0,c.$Vn)(y):null,ie=C.reduce((D,J)=>(D.add(J),D),new Set),W=g(V,x,ie),z=g(H,V,ie),_=g(H,x,ie),ne=new Map,ce=new Set,te=D=>{ce.add(D);const J=v.filter(({key:q})=>q===D)[0];J?(j=O.edit(j,[D],J.value,E),K=O.edit(K,[D],J.value,E)):ne.set(D,{key:D,localValue:V[D],remoteValue:x[D]})};for(const D of z.removed.values())_.updated.has(D)?te(D):K=O.edit(K,[D],void 0,E);for(const D of _.removed.values())ce.has(D)||(z.updated.has(D)?te(D):j=O.edit(j,[D],void 0,E));for(const D of z.updated.values())ce.has(D)||(_.updated.has(D)?W.updated.has(D)&&te(D):K=O.edit(K,[D],V[D],E));for(const D of _.updated.values())ce.has(D)||(z.updated.has(D)?W.updated.has(D)&&te(D):j=O.edit(j,[D],x[D],E));for(const D of z.added.values())ce.has(D)||(_.added.has(D)?W.updated.has(D)&&te(D):K=w(D,j,K,E));for(const D of _.added.values())ce.has(D)||(z.added.has(D)?W.updated.has(D)&&te(D):j=w(D,K,j,E));const Y=ne.size>0||!p(j,K,C),G=Y||!p(j,a,[]),B=Y||!p(K,u,[]);return{localContent:G?j:null,remoteContent:B?K:null,conflictsSettings:[...ne.values()],hasConflicts:Y}}function p(a,u,y){if(a===u)return!0;const C=(0,c.$Vn)(a),v=(0,c.$Vn)(u),E=y.reduce((U,j)=>(U.add(j),U),new Set),T=r(a).filter(U=>!(U.setting&&E.has(U.setting.key))),F=r(u).filter(U=>!(U.setting&&E.has(U.setting.key)));if(T.length!==F.length)return!1;for(let U=0;U<T.length;U++){const j=T[U],K=F[U];if(j.setting&&K.setting){if(j.setting.key!==K.setting.key||!N.$fo(C[j.setting.key],v[j.setting.key]))return!1}else if(!j.setting&&!K.setting){if(j.value!==K.value)return!1}else return!1}return!0}function S(a){return a?r(a).length===0:!0}function g(a,u,y){const C=a?Object.keys(a).filter(U=>!y.has(U)):[],v=Object.keys(u).filter(U=>!y.has(U)),E=v.filter(U=>!C.includes(U)).reduce((U,j)=>(U.add(j),U),new Set),T=C.filter(U=>!v.includes(U)).reduce((U,j)=>(U.add(j),U),new Set),F=new Set;if(a)for(const U of C){if(T.has(U))continue;const j=a[U],K=u[U];N.$fo(j,K)||F.add(U)}return{added:E,removed:T,updated:F}}function w(a,u,y,C){const v=(0,c.$Vn)(u),E=r(u),T=r(y),F=P(a,E,T);return m(y,a,v[a],F,T,C)}function P(a,u,y){const C=u.findIndex(E=>E.setting?.key===a),v=u[C-1];if(v){if(v.setting){const T=h(v.setting.key,y);if(T)return{index:y.indexOf(T),insertAfter:!0}}else{const T=i(C,u);if(T){const F=h(T.setting.key,y);if(F){const U=s(y.indexOf(F),y),j=t(u,T,u[C]);if(U){const K=t(y,F,U),V=n(j,K);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.indexOf(U),insertAfter:!1}}else{const K=t(y,F,y[y.length-1]),V=n(j,K);return V?{index:y.indexOf(V),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const E=u[C+1];if(E)if(E.setting){const T=h(E.setting.key,y);if(T)return{index:y.indexOf(T),insertAfter:!1}}else{const T=s(C,u);if(T){const F=h(T.setting.key,y);if(F){const U=i(y.indexOf(F),y),j=t(u,u[C],T);if(U){const K=t(y,U,F),V=n(j.reverse(),K.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:y.indexOf(U),insertAfter:!0}}else{const K=t(y,y[0],F),V=n(j.reverse(),K.reverse());return V?{index:y.indexOf(V),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function m(a,u,y,C,v,E){let T;return C.index===-1?T=(0,L.$0n)(a,[u],y,E):T=o(a,u,y,C,v,E).map(F=>(0,L.$$n)(a,F,E)[0]),(0,L.$ao)(a,T)}function o(a,u,y,C,v,E){const T=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,F=(0,A.$7n)(E,a),U=v[C.index];if(C.insertAfter){const j=[];if(U.setting)j.push({offset:U.endOffset,length:0,content:","+T});else{const K=s(C.index,v),V=i(C.index,v),x=V?.setting?.commaOffset;V&&x===void 0&&j.push({offset:V.endOffset,length:0,content:","});const H=x!==void 0&&x>U.endOffset;j.push({offset:H?x+1:U.endOffset,length:0,content:K?F+T+",":F+T})}return j}else{if(U.setting)return[{offset:U.startOffset,length:0,content:T+","}];const j=(v[C.index-1]&&!v[C.index-1].setting?F:"")+T+(s(C.index,v)?",":"")+F;return[{offset:U.startOffset,length:0,content:j}]}}function h(a,u){return u.filter(y=>y.setting?.key===a)[0]}function i(a,u){for(let y=a-1;y>=0;y--)if(u[y].setting)return u[y]}function s(a,u){for(let y=a+1;y<u.length;y++)if(u[y].setting)return u[y]}function t(a,u,y){const C=a.indexOf(u),v=a.indexOf(y);return a.filter((E,T)=>C<T&&T<v)}function n(a,u){if(a.length&&u.length){let y=0;for(;y<u.length&&y<a.length;y++)if(a[y].value!==u[y].value)return u[y-1];return u[y-1]}}function r(a){const u=[];let y=-1,C,v;const E={onObjectBegin:T=>{y++},onObjectProperty:(T,F,U)=>{y===0&&(C=F,v=T)},onObjectEnd:(T,F)=>{y--,y===0&&u.push({startOffset:C,endOffset:T+F,value:a.substring(C,T+F),setting:{key:v,commaOffset:void 0}})},onArrayBegin:(T,F)=>{y++},onArrayEnd:(T,F)=>{y--,y===0&&u.push({startOffset:C,endOffset:T+F,value:a.substring(C,T+F),setting:{key:v,commaOffset:void 0}})},onLiteralValue:(T,F,U)=>{y===0&&u.push({startOffset:C,endOffset:F+U,value:a.substring(C,F+U),setting:{key:v,commaOffset:void 0}})},onSeparator:(T,F,U)=>{if(y===0&&T===","){let j=u.length-1;for(;j>=0&&!u[j].setting;j--);const K=u[j];K&&u.splice(j,1,{startOffset:K.startOffset,endOffset:K.endOffset,value:K.value,setting:{key:K.setting.key,commaOffset:F}})}},onComment:(T,F)=>{y===0&&u.push({startOffset:T,endOffset:T+F,value:a.substring(T,T+F)})}};return(0,c.$3n)(a,E),u}}),define(he[82],ue([0,1,3,2,4,24]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aMb=e.$_Lb=void 0,e.$_Lb=(0,L.$Ci)("IUserDataSyncAccountService");let N=class extends c.$Tc{get account(){return this.a}constructor(k,b){super(),this.g=k,this.h=b,this.b=this.B(new I.$je),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$je),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(R=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,R),this.updateAccount(void 0),R===A.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$aMb=N,e.$aMb=N=ve([Q(0,A.$rnb),Q(1,A.$Gnb)],N)}),define(he[211],ue([0,1,20,11,15,10,24]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FOb=void 0;let O=class extends A.$ck{constructor(b,R){super(),this.g=this.B(b.createLogger((0,I.$dh)(R.logsHome,`${N.$Hnb}.log`),{id:N.$Hnb,name:(0,c.localize)(10893,null)}))}trace(b,...R){this.g.trace(b,...R)}debug(b,...R){this.g.debug(b,...R)}info(b,...R){this.g.info(b,...R)}warn(b,...R){this.g.warn(b,...R)}error(b,...R){this.g.error(b,...R)}flush(){this.g.flush()}};e.$FOb=O,e.$FOb=O=ve([Q(0,A.$$j),Q(1,L.$Ji)],O)}),define(he[212],ue([0,1,6,3,2]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class A extends L.$Tc{constructor({onDidOpenMainWindow:O,onDidFocusMainWindow:k,getActiveWindowId:b}){super(),this.a=this.B(new L.$Sc),c.Event.latch(c.Event.any(O,k))(this.f,this,this.a),this.b=(0,I.$ph)(()=>b()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(O){this.b&&(this.b.cancel(),this.b=void 0),this.c=O}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$rgc=A}),define(he[115],ue([0,1,11,13,51,20,9,4,22]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Wi=e.$Vi=e.WorkbenchState=e.$Pi=e.$Oi=e.$Li=void 0,e.$Mi=b,e.$Ni=R,e.$Qi=d,e.$Ri=f,e.$Si=$,e.$Ti=p,e.$Ui=S,e.$Xi=P,e.$3i=m,e.$4i=o,e.$6i=h,e.$7i=i,e.$8i=s,e.$Li=(0,O.$Ci)("contextService");function b(t){const n=t;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}function R(t){return typeof t?.id=="string"&&!b(t)&&!f(t)}e.$Oi={id:"ext-dev"},e.$Pi={id:"empty-window"};function d(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,c.$mc)(t)}:n?e.$Oi:e.$Pi;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}function f(t){const n=t;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}function $(t){const n=t;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}var l;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(l||(e.WorkbenchState=l={}));function p(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function S(t){const n=t;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class g{constructor(n,r,a,u,y){this.h=n,this.j=a,this.k=u,this.l=y,this.c=L.$Ii.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=L.$Ii.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Vi=g;class w{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$dh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Wi=w;function P(t){return new w({uri:t,index:0,name:(0,A.$_g)(t)},{uri:t.toString()})}e.$Yi="code-workspace",e.$Zi=`.${e.$Yi}`,e.$1i=[{name:(0,I.localize)(10864,null),extensions:[e.$Yi]}],e.$2i="workspace.json";function m(t,n){return A.$7g.isEqualOrParent(t,n.untitledWorkspacesHome)}function o(t){let n;return N.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===k.Schemas.tmp}e.$5i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function h(t){return t.id===e.$5i}function i(t,n){return!m(t,n)&&!o(t)}function s(t){return(typeof t=="string"?(0,c.$nc)(t):(0,A.$bh)(t))===e.$Zi}}),define(he[19],ue([0,1,55,3,2,20,9,11,15,7,4,10,115,36,28,6,31,26,12]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Jl=e.ProfileResourceType=void 0,e.$Il=m,e.$Kl=o,e.$Ll=h;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$Jl=(0,R.$Ci)("IUserDataProfilesService");function o(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:N.URI.revive(t.location).with({scheme:n}),globalStorageHome:N.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function h(t,n,r,a,u,y){return{id:t,name:n,location:r,isDefault:!1,shortName:u?.shortName,icon:u?.icon,globalStorageHome:y&&u?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$dh)(r,"globalStorage"),settingsResource:y&&u?.useDefaultFlags?.settings?y.settingsResource:(0,A.$dh)(r,"settings.json"),keybindingsResource:y&&u?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$dh)(r,"keybindings.json"),tasksResource:y&&u?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$dh)(r,"tasks.json"),snippetsHome:y&&u?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$dh)(r,"snippets"),extensionsResource:y&&u?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$dh)(r,"extensions.json"),cacheHome:(0,A.$dh)(a,t),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}let i=class extends L.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,a,u){super(),this.t=n,this.u=r,this.w=a,this.y=u,this.f=!0,this.h=this.B(new c.$je),this.onDidChangeProfiles=this.h.event,this.j=this.B(new c.$je),this.onWillCreateProfile=this.j.event,this.m=this.B(new c.$je),this.onWillRemoveProfile=this.m.event,this.n=this.B(new c.$je),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$zc,workspaces:new $.$zc,emptyWindows:new Map},this.profilesHome=(0,A.$dh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$dh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,w.$cg)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(h((0,A.$ah)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},n))}}catch(y){this.y.error(y)}const a=new $.$zc,u=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[C,v]of Object.entries(y.workspaces)){const E=N.URI.parse(C),T=r.find(F=>F.id===v);T&&a.set(E,T)}if(y.emptyWindows)for(const[C,v]of Object.entries(y.emptyWindows)){const E=r.find(T=>T.id===v);E&&u.set(C,E)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:a,emptyWindows:u}}return this.z}D(){const n=h("__default__profile__",(0,O.localize)(10911,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",a=new RegExp(`${(0,g.$ff)(r)}\\s(\\d+)`);let u=0;for(const C of this.profiles){const v=a.exec(C.name),E=v?parseInt(v[1]):0;u=E>u?E:u}const y=`${r} ${u+1}`;return this.createProfile((0,I.$qj)((0,S.$Yg)()).toString(16),y,{transient:!0},n)}async createNamedProfile(n,r,a){return this.createProfile((0,I.$qj)((0,S.$Yg)()).toString(16),n,r,a)}async createProfile(n,r,a,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(n,r,a);return u&&await this.setProfileForWorkspace(u,y),y}async F(n,r,a){if(!(0,w.$cg)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let u=this.r.get(r);return u||(u=(async()=>{try{if(this.profiles.find(E=>E.name===r||E.id===n))throw new Error(`Profile with ${r} name already exists`);const C=h(n,r,(0,A.$dh)(this.profilesHome,n),this.g,a,this.defaultProfile);await this.u.createFolder(C.location);const v=[];return this.j.fire({profile:C,join(E){v.push(E)}}),await p.Promises.settled(v),this.I([C],[],[]),C}finally{this.r.delete(r)}})(),this.r.set(r,u)),u}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(u=>u.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=h(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.m.fire({profile:r,join(u){a.push(u)}});try{await Promise.allSettled(a)}catch(u){this.y.error(u)}for(const u of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(u)?.id&&this.C.emptyWindows.delete(u);for(const u of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(u)?.id&&this.C.workspaces.delete(u);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(u){(0,b.$ol)(u)!==b.FileOperationResult.FILE_NOT_FOUND&&this.y.error(u)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(u=>u.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,a)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n),a=N.URI.isUri(r)?this.C.workspaces.get(r):this.C.emptyWindows.get(r);return a||((0,f.$Mi)(n)?this.s.folders.get(n.uri):(0,f.$Ri)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,f.$Mi)(n)?n.uri:(0,f.$Ri)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.folders.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,a){const u=[...this.profiles,...n],y=[],C=this.s.profiles;this.s.profiles=[];for(let v of u){if(v.isDefault||r.some(T=>v.id===T.id))continue;v=a.find(T=>v.id===T.id)??v;const E=C.find(T=>v.id===T.id);if(v.isTransient)this.s.profiles.push(v);else{if(E){for(const[T,F]of this.s.emptyWindows.entries())if(v.id===F.id){this.L({id:T},v);break}for(const[T,F]of this.s.workspaces.entries())if(v.id===F.id){this.L({id:"",configPath:T},v);break}for(const[T,F]of this.s.folders.entries())if(v.id===F.id){this.L({id:"",uri:T},v);break}}y.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags})}}this.P(y),this.z=void 0,this.J(n,r,a)}J(n,r,a){this.h.fire({added:n,removed:r,updated:a,all:this.profiles})}L(n,r,a){if(a=r?.isTransient?!0:a,a)(0,f.$Mi)(n)?(this.s.folders.delete(n.uri),r&&this.s.folders.set(n.uri,r)):(0,f.$Ri)(n)?(this.s.workspaces.delete(n.configPath),r&&this.s.workspaces.set(n.configPath,r)):(this.s.emptyWindows.delete(n.id),r&&this.s.emptyWindows.set(n.id,r));else{this.L(n,void 0,!0);const u=this.G(n);N.URI.isUri(u)?(this.C.workspaces.delete(u),r&&this.C.workspaces.set(u,r)):(this.C.emptyWindows.delete(u),r&&this.C.emptyWindows.set(u,r)),this.M()}}M(){const n={};for(const[a,u]of this.C.workspaces.entries())n[a.toString()]=u.id;const r={};for(const[a,u]of this.C.emptyWindows.entries())r[a.toString()]=u.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},a=this.D();if(n.workspaces)for(const[y,C]of Object.entries(n.workspaces)){const v=N.URI.parse(C);r[y]=this.w.extUri.isEqual(v,a.location)?a.id:this.w.extUri.basename(v)}const u={};if(n.emptyWindows)for(const[y,C]of Object.entries(n.emptyWindows)){const v=N.URI.parse(C);u[y]=this.w.extUri.isEqual(v,a.location)?a.id:this.w.extUri.basename(v)}return{workspaces:r,emptyWindows:u}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ml=i,e.$Ml=i=ve([Q(0,k.$Ji),Q(1,b.$0k),Q(2,l.$Hl),Q(3,d.$0j)],i);class s extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Nl=s}),define(he[213],ue([0,1,6,2,19]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;let A=class extends c.$Tc{constructor(O){super(),this.B(new I.$Oh(()=>{O.cleanUp()},10*1e3)).schedule()}};e.$xhc=A,e.$xhc=A=ve([Q(0,L.$Jl)],A)}),define(he[83],ue([0,1,17,6,25,8,3,2,5,12,9,11,27,34,33,59,10,23,18,28,19]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Cq=void 0,e.$Dq=h,d=ke(d);let o=class extends O.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,a,u,y,C){super(),this.z=n,this.C=r,this.D=a,this.F=u,this.G=y,this.H=C,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$je),this.s=this.B(new N.$je),this.t=this.B(new N.$je),this.u=this.B(new N.$je),this.w=this.B(new N.$je),this.y=[],this.B((0,O.$Rc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,f.$gp)(a,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const u=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:y})=>(0,$.$Jp)(y,n.identifier));if(u?.local)return u?.local;throw u?.error?u.error:new f.$kp(`Unknown error while installing extension ${n.identifier.id}`,f.ExtensionManagementErrorCode.Unknown)}catch(a){throw h(a)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new f.$kp(d.localize(11336,null),f.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];return await Promise.allSettled(n.map(async({extension:u,options:y})=>{try{const C=await this.N(u,!!y?.installGivenVersion,!!y?.installPreReleaseVersion,y.productVersion??{version:this.G.version,date:this.G.date});a.push({...C,options:y})}catch(C){r.push({identifier:u.identifier,operation:f.InstallOperation.Install,source:u,error:C,profileLocation:y.profileLocation??this.X()})}})),a.length&&r.push(...await this.I(a)),r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.P(n,r)}async toggleAppliationScope(n,r){if((0,l.$rn)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let a=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(n,this.H.defaultProfile.extensionsResource,r));for(const u of this.H.profiles){const y=(await this.getInstalled(l.ExtensionType.User,u.extensionsResource)).find(C=>(0,$.$Jp)(C.identifier,n.identifier));y?this.w.fire({local:y,profileLocation:u.extensionsResource}):this.u.fire({identifier:n.identifier,profileLocation:u.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:f.InstallOperation.Install,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.W(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async resetPinnedStateForAllUserExtensions(n){try{await this.L(this.H.profiles.map(async r=>{const a=await this.getInstalled(l.ExtensionType.User,r.extensionsResource);await this.L(a.map(async u=>{u.pinned!==n&&await this.updateMetadata(u,{pinned:n},r.extensionsResource)}))}))}catch(r){throw this.F.error("Error while resetting pinned state for all user extensions",(0,A.$9)(r)),r}}async I(n){const r=new Map,a=new Map,u=[],y=(v,E)=>`${$.$Kp.create(v).toString()}-${E.toString()}`,C=(v,E,T,F)=>{const U=this.Y(v,E,T),j=`${(0,$.$Op)(v.publisher,v.name)}-${T.profileLocation.toString()}`;a.set(j,{task:U,root:F}),this.n.fire({identifier:U.identifier,source:E,profileLocation:T.profileLocation}),this.F.info("Installing extension:",U.identifier.id,T),R.URI.isUri(E)||this.j.set(y(E,T.profileLocation),{task:U,waitingTasks:[]})};try{for(const{manifest:v,extension:E,options:T}of n){const F=T.isApplicationScoped||T.isBuiltin||(0,l.$rn)(v),U={...T,installOnlyNewlyAddedFromExtensionPack:T.installOnlyNewlyAddedFromExtensionPack??!R.URI.isUri(E),isApplicationScoped:F,profileLocation:F?this.H.defaultProfile.extensionsResource:T.profileLocation??this.X(),productVersion:T.productVersion??{version:this.G.version,date:this.G.date}},j=R.URI.isUri(E)?void 0:this.j.get(y(E,U.profileLocation));j?(this.F.info("Extension is already requested to install",j.task.identifier.id,U.profileLocation.toString()),u.push(j.task.waitUntilTaskIsFinished())):C(v,E,U,void 0)}return await Promise.all([...a.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const E=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),T=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),F={...v.options,context:{...v.options.context,[f.$ap]:!0}};for(const{gallery:U,manifest:j}of(0,I.$Lb)(E,({gallery:K})=>K.identifier.id)){if(a.has(`${U.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`))continue;const K=this.j.get(y(U,F.profileLocation));if(K){if(this.J(v,K.task)){const V=K.task.identifier;this.F.info("Waiting for already requested installing extension",V.id,v.identifier.id,F.profileLocation.toString()),K.waitingTasks.push(v),u.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,x=>x.some(H=>(0,$.$Jp)(H.identifier,V)))).then(x=>{if(this.F.info("Finished waiting for already requested installing extension",V.id,v.identifier.id,F.profileLocation.toString()),!x.find(ie=>(0,$.$Jp)(ie.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else T.some(({identifier:V})=>(0,$.$Jp)(V,U.identifier))||C(j,U,F,v)}}catch(E){if(R.URI.isUri(v.source))(0,I.$Kb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,E.message),(0,I.$Kb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,E.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),E}})),await this.L([...a.entries()].map(async([v,{task:E}])=>{const T=new Date().getTime();let F;try{F=await E.run(),await this.L(this.y.map(U=>U.postInstall(F,E.source,E.options,L.CancellationToken.None)),f.ExtensionManagementErrorCode.PostInstall)}catch(U){const j=h(U);throw R.URI.isUri(E.source)||i(this.C,E.operation===f.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Rp)(E.source),error:j,source:E.options.context?.[f.$_o]}),r.set(v,{error:j,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:E.options.isApplicationScoped}),this.F.error("Error while installing the extension",E.identifier.id,(0,A.$9)(j),E.options.profileLocation.toString()),j}if(!R.URI.isUri(E.source)){const U=E.operation===f.InstallOperation.Update,j=U?void 0:(new Date().getTime()-E.source.lastUpdated)/1e3;if(i(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Rp)(E.source),verificationStatus:E.verificationStatus,duration:new Date().getTime()-T,durationSinceUpdate:j,source:E.options.context?.[f.$_o]}),k.$p&&E.operation!==f.InstallOperation.Update)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,f.StatisticType.Install)}catch{}}r.set(v,{local:F,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:F.isApplicationScoped})})),u.length&&await this.L(u),[...r.values()]}catch(v){const E=(U,j,K)=>{const V=[];U.manifest.extensionDependencies?.length&&V.push(...U.manifest.extensionDependencies),U.manifest.extensionPack?.length&&V.push(...U.manifest.extensionPack);for(const x of V){if(K.includes(x.toLowerCase()))continue;K.push(x.toLowerCase());const H=r.get(`${x.toLowerCase()}-${j.toString()}`);H?.local&&(K=E(H.local,j,K))}return K},T=U=>({identifier:U.identifier,operation:f.InstallOperation.Install,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,error:v}),F=[];for(const[U,{task:j,root:K}]of a){const V=r.get(U);V?V.local&&K&&!r.get(`${K.identifier.id.toLowerCase()}-${j.options.profileLocation.toString()}`)?.local&&(F.push(this.Z(V.local,{versionOnly:!0,profileLocation:j.options.profileLocation})),r.set(U,T(j))):(j.cancel(),r.set(U,T(j)))}for(const[U,{task:j}]of a){const K=r.get(U);if(!K?.local||j.options.donotIncludePackAndDependencies)continue;E(K.local,j.options.profileLocation,[K.local.identifier.id.toLowerCase()]).slice(1).some(x=>a.has(`${x.toLowerCase()}-${j.options.profileLocation.toString()}`)&&!r.get(`${x.toLowerCase()}-${j.options.profileLocation.toString()}`)?.local)&&(F.push(this.Z(K.local,{versionOnly:!0,profileLocation:j.options.profileLocation})),r.set(U,T(j)))}throw F.length&&await Promise.allSettled(F.map(async U=>{try{await U.run(),this.F.info("Rollback: Uninstalled extension",U.extension.identifier.id)}catch(j){this.F.warn("Rollback: Error while uninstalling extension",U.extension.identifier.id,(0,A.$9)(j))}})),v}finally{for(const{task:v}of a.values())v.source&&!R.URI.isUri(v.source)&&this.j.delete(y(v.source,v.options.profileLocation));if(r.size){const v=[...r.values()];for(const E of v)E.local&&this.F.info("Extension installed successfully:",E.identifier.id,E.profileLocation.toString());this.s.fire(v)}}}J(n,r){for(const[,{task:a,waitingTasks:u}]of this.j.entries())if(a===n&&(u.includes(r)||u.some(y=>this.J(y,r)))||a===r&&u[0]&&!this.J(n,u[0]))return!1;return!0}async L(n,r){const a=[],u=[],y=await Promise.allSettled(n);for(const v of y)v.status==="fulfilled"?a.push(v.value):u.push(h(v.reason,r));if(!u.length)return a;if(u.length===1)throw u[0];let C=new f.$kp("",f.ExtensionManagementErrorCode.Unknown);for(const v of u)C=new f.$kp(C.message?`${C.message}, ${v.message}`:v.message,v.code!==f.ExtensionManagementErrorCode.Unknown&&v.code!==f.ExtensionManagementErrorCode.Internal?v.code:C.code);throw C}async M(n,r,a,u,y,C){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,y,C),E=[],T=[],F=async(U,j)=>{E.push(U);const K=j.extensionDependencies||[],V=[...K];if(j.extensionPack){const x=a?v.find(H=>(0,$.$Jp)(H.identifier,U)):void 0;for(const H of j.extensionPack)x&&x.manifest.extensionPack&&x.manifest.extensionPack.some(ie=>(0,$.$Jp)({id:ie},{id:H}))||V.every(ie=>!(0,$.$Jp)({id:ie},{id:H}))&&V.push(H)}if(V.length){const x=V.filter(H=>E.every(ie=>!(0,$.$Jp)(ie,{id:H})));if(x.length){const H=await this.z.getExtensions(x.map(ie=>({id:ie,preRelease:u})),L.CancellationToken.None);for(const ie of H){if(E.find(_=>(0,$.$Jp)(_,ie.identifier)))continue;const W=K.some(_=>(0,$.$Jp)({id:_},ie.identifier));let z;try{z=await this.N(ie,!1,u,C)}catch(_){if(W)throw _;this.F.info("Skipping the packed extension as it cannot be installed",ie.identifier.id,(0,A.$9)(_));continue}T.push({gallery:z.extension,manifest:z.manifest}),await F(z.extension.identifier,z.manifest)}}}};return await F(n,r),T}async N(n,r,a,u){let y;const C=await this.getExtensionsControlManifest();if(C.malicious.some(T=>(0,$.$Jp)(n.identifier,T)))throw new f.$kp(d.localize(11337,null,n.identifier.id),f.ExtensionManagementErrorCode.Malicious);const v=C.deprecated[n.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),y=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:u},L.CancellationToken.None))[0],!y)throw new f.$kp(d.localize(11338,null,n.identifier.id,v.extension.id),f.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const T=await this.getTargetPlatform();throw new f.$kp(d.localize(11339,null,n.identifier.id,this.G.nameLong,(0,f.$cp)(T)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(y=await this.O(n,r,a,u),!y){const T=[];throw(0,p.$4p)(n.properties.enabledApiProposals??[],T)?!a&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],L.CancellationToken.None))[0]?new f.$kp(d.localize(11341,null,n.displayName??n.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.$kp(d.localize(11342,null,n.identifier.id,this.G.nameLong,this.G.version),f.ExtensionManagementErrorCode.Incompatible):new f.$kp(d.localize(11340,null,n.displayName??n.identifier.id,T[0]),f.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",y.identifier.id);const E=await this.z.getManifest(y,L.CancellationToken.None);if(E===null)throw new f.$kp(`Missing manifest for extension ${y.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(E.version!==y.version)throw new f.$kp(`Cannot install '${y.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:E}}async O(n,r,a,u){const y=await this.getTargetPlatform();let C=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(C=(await this.z.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:y,compatible:!0,productVersion:u},L.CancellationToken.None))[0]||null),!C&&await this.z.isExtensionCompatible(n,a,y,u)&&(C=n),C||(r?C=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:y,compatible:!0,productVersion:u},L.CancellationToken.None))[0]||null:C=await this.z.getCompatibleExtension(n,a,y,u)),C}async P(n,r){const a={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},u=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,y=this.m.get(u(n.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),y.waitUntilTaskIsFinished();const C=F=>{const U=this.Z(F,a);return this.m.set(u(U.extension.identifier),U),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.t.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),U},v=(F,U)=>{U?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,U.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Qp)(F),error:U}),this.u.fire({identifier:F.identifier,error:U?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},E=[],T=[];try{E.push(C(n));const F=await this.getInstalled(l.ExtensionType.User,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const U=this.S(n,F);for(const j of U)this.m.has(u(j.identifier))?this.F.info("Extensions is already requested to uninstall",j.identifier.id):E.push(C(j))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.Q(E.map(U=>U.extension),F,n),await this.L(E.map(async U=>{try{if(await U.run(),await this.L(this.y.map(j=>j.postUninstall(U.extension,a,L.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,f.StatisticType.Uninstall)}catch{}v(U.extension)}catch(j){const K=h(j);throw v(U.extension,K),K}finally{T.push(U)}}))}catch(F){const U=h(F);for(const j of E){try{j.cancel()}catch{}T.includes(j)||v(j.extension,U)}throw U}finally{for(const F of E)this.m.delete(u(F.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}Q(n,r,a){for(const u of n){const y=this.U(u,r);if(y.length){const C=y.filter(v=>!n.some(E=>(0,$.$Jp)(E.identifier,v.identifier)));if(C.length)throw new Error(this.R(u,C,a))}}}R(n,r,a){return a===n?r.length===1?d.localize(11343,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?d.localize(11344,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):d.localize(11345,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?d.localize(11346,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?d.localize(11347,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):d.localize(11348,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(n,r,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const u=n.manifest.extensionPack?n.manifest.extensionPack:[];if(u.length){const y=r.filter(v=>!v.isBuiltin&&u.some(E=>(0,$.$Jp)({id:E},v.identifier))),C=[];for(const v of y)C.push(...this.S(v,r,a));return[...y,...C]}return[]}U(n,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(u=>(0,$.$Jp)({id:u},n.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(n){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$9)(n)),{malicious:[],deprecated:{},search:[]}}}};e.$Cq=o,e.$Cq=o=ve([Q(0,f.$ip),Q(1,w.$9l),Q(2,P.$Hl),Q(3,S.$0j),Q(4,g.$qk),Q(5,m.$Jl)],o);function h(t,n){if(t instanceof f.$kp)return t;let r;return t instanceof f.$jp?r=new f.$kp(t.message,t.code===f.ExtensionGalleryErrorCode.DownloadFailedWriting?f.ExtensionManagementErrorCode.DownloadFailedWriting:f.ExtensionManagementErrorCode.Gallery):r=new f.$kp(t.message,(0,A.$3)(t)?f.ExtensionManagementErrorCode.Cancelled:n??f.ExtensionManagementErrorCode.Internal),r.stack=t.stack,r}function i(t,n,{extensionData:r,verificationStatus:a,duration:u,error:y,source:C,durationSinceUpdate:v}){let E,T;(0,b.$kg)(a)&&(a===!0?a="Verified":(a===!1||(E=f.ExtensionManagementErrorCode.Signature,T=a),a="Unverified")),y&&(E=y.code,y.code===f.ExtensionManagementErrorCode.Signature&&(T=y.message)),t.publicLog(n,{...r,verificationStatus:a,success:!y,duration:u,errorcode:E,errorcodeDetail:T,durationSinceUpdate:v,source:C})}class s{constructor(){this.d=new c.$Bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,c.$ph)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,c.$ph)(n=>new Promise((r,a)=>{const u=n.onCancellationRequested(()=>{u.dispose(),a(new A.$4)})})),this.d.open()),this.g.cancel()}}e.$Eq=s}),define(he[52],ue([0,1,6,14,2,3,36,9,27,34,7,4,10,19,28,12,8,18]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class P extends Error{constructor(s,t){super(s),this.code=t}}e.$Fq=P,e.$Gq=(0,d.$Ci)("IExtensionsProfileScannerService");let m=class extends L.$Tc{constructor(s,t,n,r,a,u){super(),this.j=s,this.m=t,this.n=n,this.r=r,this.s=a,this.t=u,this.b=this.B(new A.$je),this.onAddExtensions=this.b.event,this.c=this.B(new A.$je),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$je),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$je),this.onDidRemoveExtensions=this.g.event,this.h=new N.$zc}scanProfileExtensions(s,t){return this.u(s,void 0,t)}async addExtensionsToProfile(s,t,n){const r=[],a=[];try{return await this.u(t,u=>{const y=[];if(n)y.push(...u);else for(const C of u)s.some(([v])=>(0,b.$Jp)(v.identifier,C.identifier)&&v.manifest.version!==C.version)?r.push(C):y.push(C);for(const[C,v]of s){const E=y.findIndex(F=>(0,b.$Jp)(F.identifier,C.identifier)&&F.version===C.manifest.version),T={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:v};E===-1?(a.push(T),y.push(T)):y.splice(E,1,T)}return a.length&&this.b.fire({extensions:a,profileLocation:t}),r.length&&this.f.fire({extensions:r,profileLocation:t}),y}),a.length&&this.c.fire({extensions:a,profileLocation:t}),r.length&&this.g.fire({extensions:r,profileLocation:t}),a}catch(u){throw a.length&&this.c.fire({extensions:a,error:u,profileLocation:t}),r.length&&this.g.fire({extensions:r,error:u,profileLocation:t}),u}}async updateMetadata(s,t){const n=[];return await this.u(t,r=>{const a=[];for(const u of r){const y=s.find(([C])=>(0,b.$Jp)(C.identifier,u.identifier)&&C.manifest.version===u.version);y&&(u.metadata={...u.metadata,...y[1]},n.push(u)),a.push(u)}return a}),n}async removeExtensionFromProfile(s,t){const n=[];try{await this.u(t,r=>{const a=[];for(const u of r)(0,b.$Jp)(u.identifier,s.identifier)?n.push(u):a.push(u);return n.length&&this.f.fire({extensions:n,profileLocation:t}),a}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:t}),r}}async u(s,t,n){return this.F(s).queue(async()=>{let r=[],a;try{const u=await this.m.readFile(s);a=JSON.parse(u.value.toString().trim()||"[]")}catch(u){if((0,R.$ol)(u)!==R.FileOperationResult.FILE_NOT_FOUND)throw u;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&n?.bailOutWhenFileNotFound)throw new P((0,S.$9)(u),w.ERROR_PROFILE_NOT_FOUND)}if(a){Array.isArray(a)||this.w(s);let u=!1;for(const y of a){o(y)||this.w(s);let C;if((0,p.$cg)(y.relativeLocation)&&y.relativeLocation)C=this.z(y.relativeLocation);else if((0,p.$cg)(y.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${y.location}`);continue}else{C=O.URI.revive(y.location);const v=this.y(C);v&&(u=!0,y.relativeLocation=v)}(0,p.$jg)(y.metadata?.hasPreReleaseVersion)&&y.metadata?.preRelease&&(u=!0,y.metadata.hasPreReleaseVersion=!0),r.push({identifier:y.identifier,location:C,version:y.version,metadata:y.metadata})}u&&await this.m.writeFile(s,c.$Le.fromString(JSON.stringify(a)))}if(t){r=t(r);const u=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(s,c.$Le.fromString(JSON.stringify(u)))}return r})}w(s){const t=new P(`Invalid extensions content in ${s.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(s)).value.toString()}catch(a){if((0,R.$ol)(a)===R.FileOperationResult.FILE_NOT_FOUND)return;throw a}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const a=JSON.parse(n);Array.isArray(a)&&a.every(u=>o(u))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,c.$Le.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,R.$ol)(a)===R.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(s)}catch(a){(0,R.$ol)(a)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(a)}try{await this.m.del(t)}catch(a){(0,R.$ol)(a)!==R.FileOperationResult.FILE_NOT_FOUND&&this.t.error(a)}return r})()),this.C}F(s){let t=this.h.get(s);return t||(t=new I.$Jh,this.h.set(s,t)),t}};e.$Hq=m,e.$Hq=m=ve([Q(1,R.$0k),Q(2,$.$Jl),Q(3,l.$Hl),Q(4,g.$9l),Q(5,f.$0j)],m);function o(i){return(0,p.$eg)(i)&&(0,k.$hp)(i.identifier)&&(h(i.location)||(0,p.$cg)(i.location)&&i.location)&&((0,p.$jg)(i.relativeLocation)||(0,p.$cg)(i.relativeLocation))&&i.version&&(0,p.$cg)(i.version)}function h(i){return i?(0,p.$cg)(i.path)&&(0,p.$cg)(i.scheme):!1}});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[84],ue([0,1,17,6,29,14,8,35,151,2,22,13,5,20,60,92,12,9,11,15,34,33,59,7,4,10,23,3,66,52,19,28,156]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o,h,i,s,t,n,r,a,u,y,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Mq=e.$Lq=e.$Kq=e.Translations=void 0,e.$Nq=K,L=ke(L),d=ke(d),f=ke(f),l=ke(l),p=it(p);var E;(function(x){function H(ie,W){if(ie===W)return!0;const z=Object.keys(ie),_=new Set;for(const ne of Object.keys(W))_.add(ne);if(z.length!==_.size)return!1;for(const ne of z){if(ie[ne]!==W[ne])return!1;_.delete(ne)}return _.size===0}x.equals=H})(E||(e.Translations=E={})),e.$Kq=(0,s.$Ci)("IExtensionsScannerService");let T=class extends b.$Tc{constructor(H,ie,W,z,_,ne,ce,te,Y,G,B,D){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=ie,this.r=W,this.s=z,this.t=_,this.u=ne,this.w=ce,this.y=te,this.z=Y,this.C=G,this.D=B,this.F=D,this.g=this.B(new r.$je),this.onDidChangeCache=this.g.event,this.h=(0,$.$dh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(j,this.s,this.h)),this.m=this.B(this.F.createInstance(j,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(o.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(o.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Up)(this.w,this.y)),this.G}async scanAllExtensions(H,ie,W){const[z,_]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(ie)]),ne=W?await this.scanExtensionsUnderDevelopment(H,[...z,..._]):[];return this.L(z,_,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const ie=[];ie.push(this.M(!!H.useCache,H.language)),ie.push(this.N(H.language,!!H.checkControlFile));const[W,z]=await Promise.all(ie);return this.J([...W,...z],o.ExtensionType.System,H,!1)}async scanUserExtensions(H){const ie=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const W=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!H.profileLocation,o.ExtensionType.User,!H.includeUninstalled,H.language,!0,W,H.productVersion??this.R()),_=H.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let ne;try{ne=await _.scanExtensions(z)}catch(ce){if(ce instanceof u.$Fq&&ce.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ne=await _.scanExtensions(z);else throw ce}return ne=await this.J(ne,o.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(H,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===R.Schemas.file).map(async z=>{const _=await this.P(z,!1,o.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(_)).map(ce=>(ce.type=ie.find(te=>(0,m.$Jp)(te.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,_)))}))).flat();return this.J(W,"development",H,!0)}return[]}async scanExistingExtension(H,ie,W){const z=await this.P(H,!1,ie,!0,W.language,!0,void 0,W.productVersion??this.R()),_=await this.n.scanExtension(z);return!_||!W.includeInvalid&&!_.isValid?null:_}async scanOneOrMultipleExtensions(H,ie,W){const z=await this.P(H,!1,ie,!0,W.language,!0,void 0,W.productVersion??this.R()),_=await this.n.scanOneOrMultipleExtensions(z);return this.J(_,ie,W,!0)}async scanMultipleExtensions(H,ie,W){const z=[];return await Promise.all(H.map(async _=>{const ne=await this.scanOneOrMultipleExtensions(_,ie,W);z.push(...ne)})),this.J(z,ie,W,!0)}async scanMetadata(H){const ie=(0,$.$dh)(H,"package.json"),W=(await this.w.readFile(ie)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(H,ie){const W=(0,$.$dh)(H,"package.json"),z=(await this.w.readFile(W)).value.toString(),_=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,_.__metadata={..._.__metadata,...ie},await this.w.writeFile((0,$.$dh)(H,"package.json"),A.$Le.fromString(JSON.stringify(_,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof u.$Fq&&H.code===u.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Le.fromString(JSON.stringify([])))}catch(ie){(0,i.$ol)(ie)!==i.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$9)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,ie,W,z){return W.includeAllVersions||(H=this.L(ie===o.ExtensionType.System?H:void 0,ie===o.ExtensionType.User?H:void 0,ie==="development"?H:void 0,await this.getTargetPlatform(),z)),W.includeInvalid||(H=H.filter(_=>_.isValid)),H.sort((_,ne)=>{const ce=d.$mc(_.location.fsPath),te=d.$mc(ne.location.fsPath);return ce<te?-1:ce>te?1:0})}L(H,ie,W,z,_){const ne=(te,Y,G)=>{if(te.isValid&&!Y.isValid)return!1;if(te.isValid===Y.isValid){if(_&&l.gt(te.manifest.version,Y.manifest.version))return this.y.debug(`Skipping extension ${Y.location.path} with lower version ${Y.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(l.eq(te.manifest.version,Y.manifest.version)){if(te.type===o.ExtensionType.System)return this.y.debug(`Skipping extension ${Y.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===z)return this.y.debug(`Skipping extension ${Y.location.path} from different target platform ${Y.targetPlatform}`),!1}}return G?this.y.warn(`Overwriting user extension ${te.location.path} with ${Y.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${Y.location.path}.`),!0},ce=new o.$qn;return H?.forEach(te=>{const Y=ce.get(te.identifier.id);(!Y||ne(Y,te,!1))&&ce.set(te.identifier.id,te)}),ie?.forEach(te=>{const Y=ce.get(te.identifier.id);if(!Y&&H&&te.type===o.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!Y||ne(Y,te,!1))&&ce.set(te.identifier.id,te)}),W?.forEach(te=>{const Y=ce.get(te.identifier.id);(!Y||ne(Y,te,!0))&&ce.set(te.identifier.id,te),ce.set(te.identifier.id,te)}),[...ce.values()]}async M(H,ie){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,o.ExtensionType.System,!0,ie,!0,void 0,this.R()),_=await(H&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",_.length),_}async N(H,ie){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},_=[],ne=g.URI.file(d.$gc(d.$ic(R.$Wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of W){const Y=z[te.name]||"marketplace";switch(Y){case"disabled":break;case"marketplace":_.push((0,$.$dh)(ne,te.name));break;default:_.push(g.URI.file(Y));break}}const ce=await Promise.all(_.map(async te=>this.n.scanExtension(await this.P(te,!1,o.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,I.$Gb)(ce)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,ie,W,z,_,ne,ce,te){const Y=await this.f(_??f.$x),G=await this.Q(H),B=ie&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=B?await this.Q(B):void 0;return new F(H,G,B,D,ie,ce,W,z,ne,te.version,te.date,this.C.commit,!this.z.isBuilt,_,Y)}async Q(H){try{const ie=await this.w.stat(H);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Lq=T,e.$Lq=T=ve([Q(4,y.$Jl),Q(5,u.$Gq),Q(6,i.$0k),Q(7,t.$0j),Q(8,P.$Ji),Q(9,n.$qk),Q(10,C.$Hl),Q(11,s.$Bi)],T);class F{constructor(H,ie,W,z,_,ne,ce,te,Y,G,B,D,J,q,M){this.location=H,this.mtime=ie,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=z,this.profile=_,this.profileScanOptions=ne,this.type=ce,this.excludeObsolete=te,this.validate=Y,this.productVersion=G,this.productDate=B,this.productCommit=D,this.devMode=J,this.language=q,this.translations=M}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,ie){return(0,$.$9g)(H.location,ie.location)&&H.mtime===ie.mtime&&(0,$.$9g)(H.applicationExtensionslocation,ie.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&H.profile===ie.profile&&L.$fo(H.profileScanOptions,ie.profileScanOptions)&&H.type===ie.type&&H.excludeObsolete===ie.excludeObsolete&&H.validate===ie.validate&&H.productVersion===ie.productVersion&&H.productDate===ie.productDate&&H.productCommit===ie.productCommit&&H.devMode===ie.devMode&&H.language===ie.language&&E.equals(H.translations,ie.translations)}}e.$Mq=F;let U=class extends b.$Tc{constructor(H,ie,W,z,_,ne,ce){super(),this.g=H,this.h=ie,this.j=W,this.m=z,this.n=ne,this.r=ce,this.f=_.extensionsEnabledWithApiProposalVersion?.map(te=>te.toLowerCase())??[]}async scanExtensions(H){const ie=H.profile?await this.t(H):await this.s(H);let W={};if(H.excludeObsolete&&H.type===o.ExtensionType.User)try{const z=(await this.m.readFile(this.g)).value.toString();W=JSON.parse(z)}catch{}return(0,S.$pg)(W)?ie:ie.filter(z=>!W[m.$Kp.create(z).toString()])}async s(H){const ie=await this.m.resolve(H.location);if(!ie.children?.length)return[];const W=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||H.type===o.ExtensionType.User&&(0,$.$ah)(z.resource).indexOf(".")===0)return null;const _=new F(z.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(_)}));return(0,I.$Gb)(W).sort((z,_)=>z.location.path<_.location.path?-1:1)}async t(H){let ie=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const W=await this.u(H.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,H);ie.push(...W)}return ie}async u(H,ie,W){const z=await this.h.scanProfileExtensions(H,W.profileScanOptions);if(!z.length)return[];const _=await Promise.all(z.map(async ne=>{if(ie(ne)){const ce=new F(ne.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ce,ne.metadata)}return null}));return(0,I.$Gb)(_)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,$.$dh)(H.location,"package.json"))){const ie=await this.scanExtension(H);return ie?[ie]:[]}else return await this.scanExtensions(H)}catch(ie){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,N.$9)(ie)),[]}}async scanExtension(H,ie){try{let W=await this.w(H.location);if(W){W.publisher||(W.publisher=o.$kn),ie=ie??W.__metadata,delete W.__metadata;const z=(0,m.$Op)(W.publisher,W.name),_=ie?.id?{id:z,uuid:ie.id}:{id:z},ne=ie?.isSystem?o.ExtensionType.System:H.type,ce=ne===o.ExtensionType.System||!!ie?.isBuiltin;W=await this.y(H.location,W,F.createNlsConfiguration(H));let te={type:ne,identifier:_,manifest:W,location:H.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??o.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return H.validate&&(te=this.validate(te,H)),W.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(z.toLowerCase()))&&(W.originalEnabledApiProposals=W.enabledApiProposals,W.enabledApiProposals=(0,o.$wn)([...W.enabledApiProposals])),te}}catch(W){H.type!==o.ExtensionType.System&&this.r.error(W)}return null}validate(H,ie){let W=!0;const z=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),_=(0,h.$1p)(ie.productVersion,ie.productDate,ie.location,H.manifest,H.isBuiltin,z);for(const[ne,ce]of _)ne===p.default.Error&&(W=!1,this.r.error(this.F(ie.location,ce)));return H.isValid=W,H.validations=_,H}async w(H){const ie=(0,$.$dh)(H,"package.json");let W;try{W=(await this.m.readFile(ie)).value.toString()}catch(_){return(0,i.$ol)(_)!==i.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,w.localize)(11294,null,ie.path,_.message))),null}let z;try{z=JSON.parse(W)}catch{const ne=[];(0,O.$Vn)(W,ne);for(const ce of ne)this.r.error(this.F(H,(0,w.localize)(11295,null,ie.path,ce.offset,ce.length,(0,k.$Iq)(ce.error))));return null}return(0,O.$4n)(z)!=="object"?(this.r.error(this.F(H,(0,w.localize)(11296,null,ie.path))),null):z}async y(H,ie,W){const z=await this.z(H,ie,W);if(z)try{const _=[],ne=await this.C(z.default,_);if(_.length>0)return _.forEach(te=>{this.r.error(this.F(H,(0,w.localize)(11297,null,z.default?.path,(0,k.$Iq)(te.error))))}),ie;if((0,O.$4n)(z)!=="object")return this.r.error(this.F(H,(0,w.localize)(11298,null,z.default?.path))),ie;const ce=z.values||Object.create(null);return(0,v.$Jq)(this.r,ie,ce,ne)}catch{}return ie}async z(H,ie,W){const z=(0,$.$dh)(H,"package.nls.json"),_=(Y,G)=>{G.forEach(B=>{this.r.error(this.F(H,(0,w.localize)(11299,null,Y?.path,(0,k.$Iq)(B.error))))})},ne=Y=>{this.r.error(this.F(H,(0,w.localize)(11300,null,Y?.path)))},ce=`${ie.publisher}.${ie.name}`,te=W.translations[ce];if(te)try{const Y=g.URI.file(te),G=(await this.m.readFile(Y)).value.toString(),B=[],D=(0,O.$Vn)(G,B);return B.length>0?(_(Y,B),{values:void 0,default:z}):(0,O.$4n)(D)!=="object"?(ne(Y),{values:void 0,default:z}):{values:D.contents?D.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.m.exists(z))return;let G;try{G=await this.D(H,W)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const B=(await this.m.readFile(G.localized)).value.toString(),D=[],J=(0,O.$Vn)(B,D);return D.length>0?(_(G.localized,D),{values:void 0,default:G.original}):(0,O.$4n)(J)!=="object"?(ne(G.localized),{values:void 0,default:G.original}):{values:J,default:G.original}}catch{return{values:void 0,default:G.original}}}}async C(H,ie){if(H)try{const W=(await this.m.readFile(H)).value.toString();return(0,O.$Vn)(W,ie)}catch{}}D(H,ie){return new Promise((W,z)=>{const _=ne=>{const ce=(0,$.$dh)(H,`package.nls.${ne}.json`);this.m.exists(ce).then(te=>{te&&W({localized:ce,original:(0,$.$dh)(H,"package.nls.json")});const Y=ne.lastIndexOf("-");Y===-1?W({localized:(0,$.$dh)(H,"package.nls.json"),original:null}):(ne=ne.substring(0,Y),_(ne))})};if(ie.devMode||ie.pseudo||!ie.language)return W({localized:(0,$.$dh)(H,"package.nls.json"),original:null});_(ie.language)})}F(H,ie){return`[${H.path}]: ${ie}`}};U=ve([Q(1,u.$Gq),Q(2,C.$Hl),Q(3,i.$0k),Q(4,n.$qk),Q(5,P.$Ji),Q(6,t.$0j)],U);let j=class extends U{constructor(H,ie,W,z,_,ne,ce,te,Y){super(ie,z,_,ne,ce,te,Y),this.J=H,this.L=W,this.H=this.B(new c.$Ah(3e3)),this.I=this.B(new r.$je),this.onDidChangeCache=this.I.event}async scanExtensions(H){const ie=this.P(H),W=await this.M(ie);if(this.G=H,W&&W.input&&F.equals(W.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===o.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),W.result.map(_=>(_.location=g.URI.revive(_.location),_));const z=await super.scanExtensions(H);return await this.N(ie,{input:H,result:z}),z}async M(H){try{const ie=await this.m.readFile(H),W=JSON.parse(ie.value.toString());return{result:W.result,input:(0,a.$_h)(W.input)}}catch(ie){this.r.debug("Error while reading the extension cache file:",H.path,(0,N.$9)(ie))}return null}async N(H,ie){try{await this.m.writeFile(H,A.$Le.fromString(JSON.stringify(ie)))}catch(W){this.r.debug("Error while writing the extension cache file:",H.path,(0,N.$9)(W))}}async O(){if(!this.G)return;const H=this.P(this.G),ie=await this.M(H);if(!ie)return;const W=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!L.$fo(z,W))try{this.r.info("Invalidating Cache",W,z),await this.m.del(H),this.I.fire()}catch(_){this.r.error(_)}}P(H){const ie=this.Q(H);return this.j.extUri.joinPath(ie.cacheHome,H.type===o.ExtensionType.System?o.$jn:o.$in)}Q(H){return H.type===o.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(ie=>this.j.extUri.isEqual(H.location,ie.extensionsResource))??this.J:this.L.defaultProfile}};j=ve([Q(2,y.$Jl),Q(3,u.$Gq),Q(4,C.$Hl),Q(5,i.$0k),Q(6,n.$qk),Q(7,P.$Ji),Q(8,t.$0j)],j);function K(x,H){const ie=(0,m.$Mp)(x.manifest.publisher,x.manifest.name);return{id:ie,identifier:new o.$on(ie),isBuiltin:x.type===o.ExtensionType.System,isUserBuiltin:x.type===o.ExtensionType.User&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,publisherDisplayName:x.publisherDisplayName,...x.manifest}}class V extends T{constructor(H,ie,W,z,_,ne,ce,te,Y,G,B,D){super(H,ie,(0,$.$dh)(W,".vscode-oss-dev","extensions","control.json"),z,_,ne,ce,te,Y,G,B,D),this.S=(async()=>{if(f.$A)try{const J=await this.w.readFile(g.URI.file(f.$A));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Oq=V}),define(he[214],ue([0,1,68,6,43,3,2,22,13,30,10,19]),function(oe,e,I,c,L,A,N,O,k,b,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let f=class extends N.$Tc{constructor(l,p){super(),this.b=l,this.f=p,this.a=new c.$Ih(5)}async postUninstall(l){const p=this.g(l,"uninstall");p&&(this.f.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,l),this.f.info("Finished running post uninstall script",l.identifier.id,l.manifest.version)}catch(S){this.f.error("Failed to run post uninstall script",l.identifier.id,l.manifest.version),this.f.error(S)}}));try{await b.Promises.rm(this.m(l))}catch(S){this.f.error("Error while removing extension storage path",l.identifier.id),this.f.error(S)}}g(l,p){const S=`vscode:${p}`;if(l.location.scheme===O.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[S]=="string"){const g=l.manifest.scripts[S].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.f.warn(l.identifier.id,l.manifest.version,`${S} should be a node script`),null):{script:(0,k.$ic)(l.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}h(l,p,S,g,w){return new Promise((P,m)=>{const o=this.j(l,p,S,w);let h;const i=s=>{h&&(clearTimeout(h),h=null),s?m(s):P(void 0)};o.on("error",s=>{i((0,L.$nj)(s)||"Unknown")}),o.on("exit",(s,t)=>{i(s?`post-${p} process exited with code ${s}`:void 0)}),g&&(h=setTimeout(()=>{h=null,o.kill(),m("timed out")},5e3))})}j(l,p,S,g){const w={silent:!0,execArgv:void 0},P=(0,I.fork)(l,[`--type=extension-post-${p}`,...S],w);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const m=A.Event.fromNodeEventEmitter(P.stdout,"data"),o=A.Event.fromNodeEventEmitter(P.stderr,"data");this.B(m(s=>this.f.info(g.identifier.id,g.manifest.version,`post-${p}`,s))),this.B(o(s=>this.f.error(g.identifier.id,g.manifest.version,`post-${p}`,s)));const h=A.Event.any(A.Event.map(m,s=>({data:`%c${s}`,format:[""]}),this.q),A.Event.map(o,s=>({data:`%c${s}`,format:["color: red"]}),this.q));return A.Event.debounce(h,(s,t)=>s?{data:s.data+t.data,format:[...s.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(s=>{console.group(g.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),P}m(l){return(0,k.$ic)(this.b.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};e.$Sq=f,e.$Sq=f=ve([Q(0,d.$Jl),Q(1,R.$0j)],f)}),define(he[116],ue([0,1,72,11,83,27]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=N,e.$Qq=O;function N(k){let b=A.ExtensionManagementErrorCode.Extract;return k instanceof I.$yq&&(k.type==="CorruptZip"?b=A.ExtensionManagementErrorCode.CorruptZip:k.type==="Incomplete"&&(b=A.ExtensionManagementErrorCode.IncompleteZip)),(0,L.$Dq)(k,b)}async function O(k){let b;try{b=await(0,I.$Bq)(k,"extension/package.json")}catch(R){throw N(R)}try{return JSON.parse(b.toString("utf8"))}catch{throw new A.$kp((0,c.localize)(11285,null),A.ExtensionManagementErrorCode.Invalid)}}}),define(he[215],ue([0,1,6,8,2,22,20,60,12,31,30,72,21,15,83,27,34,116,110,7,10,18]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,O=ke(O);let i=class extends L.$Tc{static{h=this}static{this.c=".sigzip"}constructor(t,n,r,a,u,y,C){super(),this.h=n,this.j=r,this.m=a,this.n=u,this.r=y,this.t=C,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,n,r,a){await this.g;const u=await this.w(t,n);let y=!1;if(r&&this.u(t)){let C;try{C=await this.y(t)}catch(v){try{await this.delete(u)}catch(E){this.t.error(E)}throw v}try{y=await this.n.verify(t,u.fsPath,C.fsPath,a)}catch(v){if(y=v.code,y===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||y===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(u)}catch(E){this.t.error(E)}throw new p.$kp(d.$xq,p.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(C)}catch(v){this.t.error(v)}}}return{location:u,verificationStatus:y}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,k.$ig)(n)?n:!0}async w(t,n){try{const r=(0,N.$dh)(this.extensionsDownloadDir,this.G(t)),a=await this.C(t,"vsix",async()=>{await this.z(t,r,u=>this.j.download(t,u,n));try{await this.D(r.fsPath,"extension/package.json")}catch(u){try{await this.h.del(r)}catch(y){this.t.warn(`Error while deleting: ${r.path}`,(0,c.$9)(y))}throw u}},2);return a>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:a}),r}catch(r){throw(0,l.$Dq)(r,p.ExtensionManagementErrorCode.Download)}}async y(t){try{const n=(0,N.$dh)(this.extensionsDownloadDir,`.${(0,b.$Yg)()}`),r=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,n);try{await this.D(n.fsPath,".signature.p7s")}catch(a){try{await this.h.del(n)}catch(u){this.t.warn(`Error while deleting: ${n.path}`,(0,c.$9)(u))}throw a}},2);return r>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:r}),n}catch(n){throw(0,l.$Dq)(n,p.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,n,r){if(await this.h.exists(n))return;if(n.scheme!==A.Schemas.file){await r(n);return}const a=(0,N.$dh)(this.extensionsDownloadDir,`.${(0,b.$Yg)()}`);try{await r(a)}catch(u){try{await this.h.del(a)}catch{}throw u}try{await R.Promises.rename(a.fsPath,n.fsPath,2*60*1e3)}catch(u){try{await this.h.del(a)}catch{}let y=!1;try{y=await this.h.exists(n)}catch{}if(y)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,c.$9)(u)}. Deleted the file from downloaded location`,a.path),u}}async C(t,n,r,a){let u=1;for(;;)try{return await r(),u}catch(y){if(u++>a)throw y;this.t.warn(`Failed downloading ${n}. ${(0,c.$9)(y)}. Retry again...`,t.identifier.id)}}async D(t,n){try{await(0,d.$Bq)(t,n)}catch(r){throw(0,g.$Pq)(r)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],r=[],a=[];for(const C of t.children)if(C.name.endsWith(h.c))a.push(C.resource);else{const v=S.$Kp.parse(C.name);v&&r.push([v,C])}const u=(0,S.$Pp)(r,([C])=>C),y=[];for(const C of u)C.sort((v,E)=>O.rcompare(v[0].version,E[0].version)),n.push(...C.slice(1).map(v=>v[1].resource)),y.push(C[0][1]);y.sort((C,v)=>C.mtime-v.mtime),n.push(...y.slice(0,Math.max(0,y.length-this.f)).map(C=>C.resource)),n.push(...a),await I.Promises.settled(n.map(C=>(this.t.trace("Deleting from cache",C.path),this.h.del(C))))}}catch(t){this.t.error(t)}}G(t){return this.f?S.$Kp.create(t).toString().toLowerCase():(0,b.$Yg)()}};e.$Rq=i,e.$Rq=i=h=ve([Q(0,$.$Ki),Q(1,P.$0k),Q(2,p.$ip),Q(3,f.$9i),Q(4,w.$qq),Q(5,o.$9l),Q(6,m.$0j)],i)}),define(he[117],ue([0,1,32,6,14,25,43,8,3,55,2,36,22,13,20,60,12,9,31,30,72,11,98,15,83,27,34,52,84,215,214,116,187,197,33,59,7,4,10,23,18,28,19]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o,h,i,s,t,n,r,a,u,y,C,v,E,T,F,U,j,K,V,x,H,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=e.$Vq=void 0,I=ke(I),$=ke($),p=ke(p),P=ke(P),o=ke(o),e.$Vq=(0,j.$Di)(t.$lp);const W=".vsctmp";let z=class extends s.$Cq{constructor(Y,G,B,D,J,q,M,Z,ee,X,re,le){super(Y,G,re,B,X,le),this.eb=J,this.fb=q,this.gb=M,this.hb=Z,this.ib=ee,this.db=new Map,this.tb=new d.$Ac;const ge=this.B(Z.createInstance(y.$Sq));this.ab=this.B(Z.createInstance(_,Ee=>ge.postUninstall(Ee))),this.bb=this.B(new v.$Tq(le,ee,re,this,this.F)),this.cb=this.B(Z.createInstance(u.$Rq));const pe=this.B(new E.$Uq(this,this.eb,le,q,re,ee,B));this.B(pe.onDidChangeExtensionsByAnotherSource(Ee=>this.sb(Ee))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Up)(this.ib,this.F)),this.jb}async zip(Y){this.F.trace("ExtensionManagementService#zip",Y.identifier.id);const G=await this.rb(Y),B=await(0,m.zip)((0,l.$dh)(this.cb.extensionsDownloadDir,(0,w.$Yg)()).fsPath,G);return g.URI.file(B)}async unzip(Y){return this.F.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:G,cleanup:B}=await this.lb(Y),D=$.$jc(G.fsPath);try{return await(0,C.$Qq)(D)}finally{await B()}}getInstalled(Y,G=this.H.defaultProfile.extensionsResource,B={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(Y??null,G,B)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Y){return this.ab.scanUserExtensionAtLocation(Y)}async install(Y,G={}){this.F.trace("ExtensionManagementService#install",Y.toString());const{location:B,cleanup:D}=await this.lb(Y);try{const J=await(0,C.$Qq)($.$jc(B.fsPath)),q=(0,n.$Op)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,F.$3p)(J.engines.vscode,this.G.version,this.G.date))throw new Error(o.localize(11286,null,q,this.G.version));const Z=(await this.I([{manifest:J,extension:B,options:G}])).find(({identifier:ee})=>(0,n.$Jp)(ee,{id:q}));if(Z?.local)return Z.local;throw Z?.error?Z.error:(0,s.$Dq)(new Error(`Unknown error while installing extension ${q}`))}finally{await D()}}async installFromLocation(Y,G){this.F.trace("ExtensionManagementService#installFromLocation",Y.toString());const B=await this.ab.scanUserExtensionAtLocation(Y);if(!B||!B.manifest.name||!B.manifest.version)throw new Error(`Cannot find a valid extension from the location ${Y.toString()}`);return await this.wb([[B,{source:"resource"}]],G),this.F.info("Successfully installed extension",B.identifier.id,G.toString()),B}async installExtensionsFromProfile(Y,G,B){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Y,G.toString(),B.toString());const D=(await this.getInstalled(T.ExtensionType.User,G)).filter(J=>Y.some(q=>(0,n.$Jp)(q,J.identifier)));if(D.length){const J=await Promise.all(D.map(q=>this.ab.scanMetadata(q,G)));await this.wb(D.map((q,M)=>[q,J[M]]),B),this.F.info("Successfully installed extensions",D.map(q=>q.identifier.id),B.toString())}return D}async updateMetadata(Y,G,B){return this.F.trace("ExtensionManagementService#updateMetadata",Y.identifier.id),G.isPreReleaseVersion&&(G.preRelease=!0,G.hasPreReleaseVersion=!0),G.isMachineScoped===!1&&(G.isMachineScoped=void 0),G.isBuiltin===!1&&(G.isBuiltin=void 0),G.pinned===!1&&(G.pinned=void 0),Y=await this.ab.updateMetadata(Y,G,B),this.bb.invalidate(B),this.w.fire({local:Y,profileLocation:B}),Y}async reinstallFromGallery(Y){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Y.identifier.id),!this.z.isEnabled())throw new Error(o.localize(11287,null));const G=await this.getTargetPlatform(),[B]=await this.z.getExtensions([{...Y.identifier,preRelease:Y.preRelease}],{targetPlatform:G,compatible:!0},A.CancellationToken.None);if(!B)throw new Error(o.localize(11288,null));await this.ab.setUninstalled(Y);try{await this.ab.removeUninstalledExtension(Y)}catch(D){throw new Error(o.localize(11289,null,(0,N.$nj)(D)))}return this.installFromGallery(B)}$(Y,G,B,D){return this.ab.copyExtension(Y,G,B,D)}copyExtensions(Y,G){return this.ab.copyExtensions(Y,G,{version:this.G.version,date:this.G.date})}markAsUninstalled(...Y){return this.ab.setUninstalled(...Y)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(Y){this.F.error(Y)}}async download(Y,G,B){const{location:D}=await this.cb.download(Y,G,!B);return D}async lb(Y){if(Y.scheme===f.Schemas.file)return{location:Y,async cleanup(){}};this.F.trace("Downloading extension from",Y.toString());const G=(0,l.$dh)(this.cb.extensionsDownloadDir,(0,w.$Yg)());return await this.gb.download(Y,G),this.F.info("Downloaded extension to",G.toString()),{location:G,cleanup:async()=>{try{await this.ib.del(G)}catch(D){this.F.error(D)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(Y,G,B){const D=G instanceof g.URI?new n.$Kp({id:(0,n.$Op)(Y.publisher,Y.name)},Y.version):n.$Kp.create(G);return this.hb.createInstance(ne,D,Y,G,B,(J,q)=>{if(G instanceof g.URI)return this.qb(D,G,B,q);let M=this.db.get(D.toString());return M||(this.db.set(D.toString(),M=this.pb(D,G,J,B,q)),M.finally(()=>this.db.delete(D.toString()))),M},this.ab)}Z(Y,G){return new ce(Y,G.profileLocation,this.fb)}async pb(Y,G,B,D,J){const{verificationStatus:q,location:M}=await this.cb.download(G,B,!D.donotVerifySignature,D.context?.[t.$bp]);try{if(J.isCancellationRequested)throw new O.$4;return await(0,C.$Qq)(M.fsPath),{local:await this.ab.extractUserExtension(Y,M.fsPath,{id:G.identifier.uuid,publisherId:G.publisherId,publisherDisplayName:G.publisherDisplayName,targetPlatform:G.properties.targetPlatform,isApplicationScoped:D.isApplicationScoped,isMachineScoped:D.isMachineScoped,isBuiltin:D.isBuiltin,isPreReleaseVersion:G.properties.isPreReleaseVersion,hasPreReleaseVersion:G.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:D.installGivenVersion?!0:!!D.pinned,preRelease:(0,S.$ig)(D.preRelease)?D.preRelease:D.installPreReleaseVersion||G.properties.isPreReleaseVersion,source:"gallery"},!1,J),verificationStatus:q}}catch(Z){try{await this.cb.delete(M)}catch(ee){this.F.warn("Error while deleting the downloaded file",M.toString(),(0,O.$9)(ee))}throw(0,s.$Dq)(Z)}}async qb(Y,G,B,D){return{local:await this.ab.extractUserExtension(Y,$.$jc(G.fsPath),{isApplicationScoped:B.isApplicationScoped,isMachineScoped:B.isMachineScoped,isBuiltin:B.isBuiltin,installedTimestamp:Date.now(),pinned:B.installGivenVersion?!0:!!B.pinned,source:"vsix"},!0,D)}}async rb(Y){const G=async D=>{let J=await P.Promises.readdir(D);J=J.map(Z=>$.$ic(D,Z));const q=await Promise.all(J.map(Z=>I.promises.stat(Z)));let M=Promise.resolve([]);return q.forEach((Z,ee)=>{const X=J[ee];Z.isFile()&&(M=M.then(re=>[...re,X])),Z.isDirectory()&&(M=M.then(re=>G(X).then(le=>[...re,...le])))}),M};return(await G(Y.location.fsPath)).map(D=>({path:`extension/${$.$kc(Y.location.fsPath,D)}`,localPath:D}))}async sb({added:Y,removed:G}){if(G){const B=Y&&this.D.extUri.isEqual(G.profileLocation,Y.profileLocation)?G.extensions.filter(D=>Y.extensions.every(J=>!(0,n.$Jp)(J,D))):G.extensions;for(const D of B)this.F.info("Extensions removed from another source",D.id,G.profileLocation.toString()),this.u.fire({identifier:D,profileLocation:G.profileLocation})}if(Y){const D=(await this.getInstalled(T.ExtensionType.User,Y.profileLocation)).filter(J=>Y.extensions.some(q=>(0,n.$Jp)(q,J.identifier)));this.s.fire(D.map(J=>(this.F.info("Extensions added from another source",J.identifier.id,Y.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:Y.profileLocation,operation:t.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(G=>this.tb.add(G)));const Y=await this.ib.resolve(this.eb.userExtensionsLocation);for(const G of Y.children??[])G.isDirectory&&this.tb.add(G.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(G=>this.vb(G)))}async vb(Y){if(!Y.affects(this.eb.userExtensionsLocation,U.FileChangeType.ADDED))return;const G=[];for(const B of Y.rawAdded){if(this.tb.has(B)||!this.D.extUri.isEqual(this.D.extUri.dirname(B),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(B,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(B).startsWith(".")||!(await this.ib.stat(B)).isDirectory)continue;const D=await this.ab.scanUserExtensionAtLocation(B);D&&D.installedTimestamp===void 0&&(this.tb.add(B),G.push(D))}G.length&&(await this.wb(G.map(B=>[B,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",G.map(B=>B.identifier.id)))}async wb(Y,G){const B=Y.map(D=>D[0]);await this.xb(B),await this.fb.addExtensionsToProfile(Y,G),this.s.fire(B.map(D=>({local:D,identifier:D.identifier,operation:t.InstallOperation.None,profileLocation:G})))}async xb(Y){const G=await this.ab.getUninstalledExtensions();for(const B of Y){const D=n.$Kp.create(B);G[D.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",D.id),await this.ab.setInstalled(D),this.F.info("Removed the extension from uninstalled list:",D.id))}}};e.$Wq=z,e.$Wq=z=ve([Q(0,t.$ip),Q(1,x.$9l),Q(2,K.$0j),Q(3,i.$Ki),Q(4,a.$Kq),Q(5,r.$Gq),Q(6,h.$Yo),Q(7,j.$Bi),Q(8,U.$0k),Q(9,V.$qk),Q(10,H.$Hl),Q(11,ie.$Jl)],z);let _=class extends R.$Tc{constructor(Y,G,B,D,J,q,M){super(),this.n=Y,this.s=G,this.t=B,this.u=D,this.w=J,this.y=q,this.z=M,this.h=this.B(new k.$je),this.onExtract=this.h.event,this.j=new d.$zc,this.m=new d.$zc,this.c=(0,l.$dh)(this.t.userExtensionsLocation,".obsolete"),this.g=new c.$Jh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(Y,G,B){try{const D={includeInvalid:!0,profileLocation:G,productVersion:B};let J=[];if(Y===null||Y===T.ExtensionType.System){let q=this.j.get(G);q||(q=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},D,!1).finally(()=>this.j.delete(G)),this.j.set(G,q)),J.push(...await q)}else if(Y===T.ExtensionType.User){let q=this.m.get(G);q||(q=this.t.scanUserExtensions(D).finally(()=>this.m.delete(G)),this.m.set(G,q)),J.push(...await q)}return J=Y!==null?J.filter(q=>q.type===Y):J,await Promise.all(J.map(q=>this.H(q)))}catch(D){throw(0,s.$Dq)(D,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(Y){try{const G=await this.t.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return await Promise.all(G.map(B=>this.H(B)))}catch(G){throw(0,s.$Dq)(G,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(Y){try{const G=await this.t.scanExistingExtension(Y,T.ExtensionType.User,{includeInvalid:!0});if(G)return await this.H(G)}catch(G){this.z.error(G)}return null}async extractUserExtension(Y,G,B,D,J){const q=Y.toString(),M=g.URI.file($.$ic(this.t.userExtensionsLocation.fsPath,`.${(0,w.$Yg)()}`)),Z=g.URI.file($.$ic(this.t.userExtensionsLocation.fsPath,q));let ee=await this.s.exists(Z);if(ee&&D){try{await this.D(Y.id,Z,"removeExisting")}catch{throw new t.$kp(o.localize(11290,null,Z.fsPath,Y.id),t.ExtensionManagementErrorCode.Delete)}ee=!1}if(ee)try{await this.t.updateMetadata(Z,B)}catch(X){throw this.y.publicLog2("extension:extract",{extensionId:Y.id,code:`${(0,U.$ol)(X)}`}),(0,s.$Dq)(X,t.ExtensionManagementErrorCode.UpdateExistingMetadata)}else try{if(J.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started extracting the extension from ${G} to ${Z.fsPath}`),await(0,m.$Aq)(G,M.fsPath,{sourcePath:"extension",overwrite:!0},J),this.z.info(`Extracted extension to ${Z}:`,Y.id)}catch(X){throw(0,C.$Pq)(X)}try{await this.t.updateMetadata(M,B)}catch(X){throw this.y.publicLog2("extension:extract",{extensionId:Y.id,code:`${(0,U.$ol)(X)}`}),(0,s.$Dq)(X,t.ExtensionManagementErrorCode.UpdateMetadata)}if(J.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started renaming the extension from ${M.fsPath} to ${Z.fsPath}`),await this.G(M.fsPath,Z.fsPath),this.z.info("Renamed to",Z.fsPath)}catch(X){if(X.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);try{await this.s.del(M,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$9)(X)}. Deleted from extracted location`,M),X}this.h.fire(Z)}catch(X){try{await this.s.del(M,{recursive:!0})}catch{}throw X}return this.scanLocalExtension(Z,T.ExtensionType.User)}async scanMetadata(Y,G){return G?(await this.C(Y,G))?.metadata:this.t.scanMetadata(Y.location)}async C(Y,G){return(await this.u.scanProfileExtensions(G)).find(D=>(0,n.$Jp)(D.identifier,Y.identifier))}async updateMetadata(Y,G,B){try{B?await this.u.updateMetadata([[Y,G]],B):await this.t.updateMetadata(Y.location,G)}catch(D){throw this.y.publicLog2("extension:extract",{extensionId:Y.identifier.id,code:`${(0,U.$ol)(D)}`}),(0,s.$Dq)(D,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(Y.location,Y.type,B)}async getUninstalledExtensions(){try{return await this.F()}catch(Y){throw(0,s.$Dq)(Y,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...Y){const G=Y.map(B=>n.$Kp.create(B));await this.F(B=>G.forEach(D=>{B[D.toString()]=!0,this.z.info("Marked extension as uninstalled",D.toString())}))}async setInstalled(Y){try{await this.F(G=>delete G[Y.toString()])}catch(G){throw(0,s.$Dq)(G,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(Y,G){if(this.w.extUri.isEqualOrParent(Y.location,this.t.userExtensionsLocation))return this.D(Y.identifier.id,Y.location,G)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.F(G=>delete G[n.$Kp.create(Y).toString()])}async copyExtension(Y,G,B,D){const J=await this.C(Y,G),q=await this.C(Y,B);if(D={...J?.metadata,...D},q)if(this.w.extUri.isEqual(q.location,Y.location))await this.u.updateMetadata([[Y,{...q.metadata,...D}]],B);else{const M=await this.scanLocalExtension(q.location,Y.type,B);await this.u.removeExtensionFromProfile(M,B),await this.u.addExtensionsToProfile([[Y,{...q.metadata,...D}]],B)}else await this.u.addExtensionsToProfile([[Y,D]],B);return this.scanLocalExtension(Y.location,Y.type,B)}async copyExtensions(Y,G,B){const D=await this.scanExtensions(T.ExtensionType.User,Y,B),J=await Promise.all(D.filter(q=>!q.isApplicationScoped).map(async q=>[q,await this.scanMetadata(q,Y)]));await this.u.addExtensionsToProfile(J,G)}async D(Y,G,B){this.z.trace(`Deleting ${B} extension from disk`,Y,G.fsPath);const D=this.w.extUri.joinPath(this.w.extUri.dirname(G),`${this.w.extUri.basename(G)}.${(0,b.$qj)((0,w.$Yg)()).toString(16)}${W}`);await this.G(G.fsPath,D.fsPath),await this.s.del(D,{recursive:!0}),this.z.info(`Deleted ${B} extension from disk`,Y,G.fsPath)}F(Y){return this.g.queue(async()=>{let G;try{G=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(D){if((0,U.$ol)(D)!==U.FileOperationResult.FILE_NOT_FOUND)throw D}let B={};if(G)try{B=JSON.parse(G)}catch{}return Y&&(Y(B),Object.keys(B).length?await this.s.writeFile(this.c,L.$Le.fromString(JSON.stringify(B))):await this.s.del(this.c)),B})}async G(Y,G){try{await P.Promises.rename(Y,G,2*60*1e3)}catch(B){throw(0,s.$Dq)(B,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(Y,G,B){try{if(B){const J=(await this.t.scanUserExtensions({profileLocation:B})).find(q=>this.w.extUri.isEqual(q.location,Y));if(J)return await this.H(J)}else{const D=await this.t.scanExistingExtension(Y,G,{includeInvalid:!0});if(D)return await this.H(D)}throw new t.$kp(o.localize(11291,null,Y.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(D){throw(0,s.$Dq)(D,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(Y){const G=await this.s.resolve(Y.location);let B,D;return G.children&&(B=G.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,D=G.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:B,changelogUrl:D,publisherDisplayName:Y.metadata?.publisherDisplayName,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!Y.metadata?.hasPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated,pinned:!!Y.metadata?.pinned,isWorkspaceScoped:!1,source:Y.metadata?.source??(Y.identifier.uuid?"gallery":"vsix")}}async I(){const Y=await this.getUninstalledExtensions();if(Object.keys(Y).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(Y));const G=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),B=new Set;for(const J of G)Y[n.$Kp.create(J).toString()]||B.add(J.identifier.id.toLowerCase());try{const J=(0,n.$Pp)(G,q=>q.identifier);await c.Promises.settled(J.map(async q=>{const M=q.sort((Z,ee)=>p.rcompare(Z.manifest.version,ee.manifest.version))[0];B.has(M.identifier.id.toLowerCase())||await this.n(await this.H(M))}))}catch(J){this.z.error(J)}const D=G.filter(J=>J.metadata&&Y[n.$Kp.create(J).toString()]);await Promise.allSettled(D.map(J=>this.removeUninstalledExtension(J)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let Y;try{Y=await this.s.resolve(this.t.userExtensionsLocation)}catch(G){(0,U.$ol)(G)!==U.FileOperationResult.FILE_NOT_FOUND&&this.z.error(G);return}if(Y?.children)try{await Promise.allSettled(Y.children.map(async G=>{if(!(!G.isDirectory||!G.name.endsWith(W))){this.z.trace("Deleting the temporarily deleted folder",G.resource.toString());try{await this.s.del(G.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",G.resource.toString())}catch(B){(0,U.$ol)(B)!==U.FileOperationResult.FILE_NOT_FOUND&&this.z.error(B)}}}))}catch{}}};e.$Xq=_,e.$Xq=_=ve([Q(1,U.$0k),Q(2,a.$Kq),Q(3,r.$Gq),Q(4,H.$Hl),Q(5,x.$9l),Q(6,K.$0j)],_);let ne=class extends s.$Eq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(Y,G,B,D,J,q,M,Z,ee,X,re,le){super(),this.l=Y,this.manifest=G,this.source=B,this.options=D,this.m=J,this.n=q,this.o=M,this.p=Z,this.q=ee,this.s=X,this.t=re,this.u=le,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(Y){const B=(await this.n.scanExtensions(T.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(M=>(0,n.$Jp)(M.identifier,this.identifier));B&&(this.j=t.InstallOperation.Update);const D={isApplicationScoped:this.options.isApplicationScoped||B?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||B?.isMachineScoped,isBuiltin:this.options.isBuiltin||B?.isBuiltin,isSystem:B?.type===T.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??B?.pinned,source:this.source instanceof g.URI?"vsix":"gallery"};let J;if(this.source instanceof g.URI){if(B&&this.l.equals(new n.$Kp(B.identifier,B.manifest.version)))try{await this.n.removeExtension(B,"existing")}catch{throw new Error(o.localize(11292,null,this.manifest.displayName||this.manifest.name))}const M=await this.w(this.l);if(M)try{await this.n.removeExtension(M,"existing")}catch{throw new Error(o.localize(11293,null,this.manifest.displayName||this.manifest.name))}}else{if(D.id=this.source.identifier.uuid,D.publisherId=this.source.publisherId,D.publisherDisplayName=this.source.publisherDisplayName,D.targetPlatform=this.source.properties.targetPlatform,D.updated=!!B,D.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,D.hasPreReleaseVersion=B?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,D.preRelease=(0,S.$ig)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||B?.preRelease,B&&B.type!==T.ExtensionType.System&&B.manifest.version===this.source.version)return this.n.updateMetadata(B,D,this.options.profileLocation);J=await this.w(this.l)}if(Y.isCancellationRequested)throw(0,s.$Dq)(new O.$4);if(!J){const M=await this.m(this.operation,Y);J=M.local,this.k=M.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(M){throw(0,s.$Dq)(M,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(Y.isCancellationRequested)throw(0,s.$Dq)(new O.$4);try{await this.t.addExtensionsToProfile([[J,D]],this.options.profileLocation,!J.isValid)}catch(M){throw(0,s.$Dq)(M,t.ExtensionManagementErrorCode.AddToProfile)}const q=await this.n.scanLocalExtension(J.location,T.ExtensionType.User,this.options.profileLocation);if(!q)throw new t.$kp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof g.URI&&this.x(J,Y),q}async w(Y){return(await this.n.getUninstalledExtensions())[Y.toString()]?(this.u.trace("Removing the extension from uninstalled list:",Y.id),await this.n.setInstalled(Y),this.u.info("Removed the extension from uninstalled list:",Y.id),(await this.n.scanAllUserExtensions(!0)).find(D=>n.$Kp.create(D).equals(Y))):void 0}async x(Y,G){try{let[B]=await this.p.getExtensions([{id:Y.identifier.id,version:Y.manifest.version}],G);if(B||([B]=await this.p.getExtensions([{id:Y.identifier.id}],G)),B){const D={id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,hasPreReleaseVersion:Y.hasPreReleaseVersion||B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(Y,D,this.options.profileLocation)}}catch{}}};ne=ve([Q(6,H.$Hl),Q(7,t.$ip),Q(8,ie.$Jl),Q(9,a.$Kq),Q(10,r.$Gq),Q(11,K.$0j)],ne);class ce extends s.$Eq{constructor(Y,G,B){super(),this.extension=Y,this.j=G,this.k=B}async h(Y){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(he[216],ue([0,1,10,19,28,18,52,7,15,9]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pR=void 0;let R=class extends N.$Hq{constructor(f,$,l,p,S,g){super(b.URI.file(f.extensionsPath),$,l,p,S,g)}};e.$pR=R,e.$pR=R=ve([Q(0,k.$Ki),Q(1,O.$0k),Q(2,c.$Jl),Q(3,L.$Hl),Q(4,A.$9l),Q(5,I.$0j)],R)}),define(he[217],ue([0,1,9,15,52,84,7,4,10,23,28,19]),function(oe,e,I,c,L,A,N,O,k,b,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;let f=class extends A.$Oq{constructor(l,p,S,g,w,P,m,o){super(I.URI.file(w.builtinExtensionsPath),I.URI.file(w.extensionsPath),w.userHome,l.defaultProfile,l,p,S,g,w,P,m,o)}};e.$vgc=f,e.$vgc=f=ve([Q(0,d.$Jl),Q(1,L.$Gq),Q(2,N.$0k),Q(3,k.$0j),Q(4,c.$Ki),Q(5,b.$qk),Q(6,R.$Hl),Q(7,O.$Bi)],f)}),define(he[16],ue([0,1,6,3,2,100,12,70,4,19]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$fq=e.$eq=e.$dq=void 0,e.$gq=$,e.$iq=p,e.$kq=g,e.$dq="__$__isNewStorageMarker",e.$eq="__$__targetStorageMarker",e.$fq=(0,k.$Ci)("storageService");var R;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var d;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var f;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function $(w){const P=w.get(e.$eq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class l extends L.$Tc{static{this.a=60*1e3}constructor(P={flushInterval:l.a}){super(),this.m=P,this.b=this.B(new c.$me),this.c=this.B(new c.$me),this.onDidChangeTarget=this.c.event,this.f=this.B(new c.$je),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,m,o){return c.Event.filter(this.b.event,h=>h.scope===P&&(m===void 0||h.key===m),o)}n(){this.j.value=(0,I.$Sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,m){const{key:o,external:h}=m;if(o===e.$eq){switch(P){case d.APPLICATION:this.H=void 0;break;case d.PROFILE:this.F=void 0;break;case d.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:o,target:this.J(P)[o],external:h})}w(P){this.f.fire({reason:P})}get(P,m,o){return this.P(m)?.get(P,o)}getBoolean(P,m,o){return this.P(m)?.getBoolean(P,o)}getNumber(P,m,o){return this.P(m)?.getNumber(P,o)}getObject(P,m,o){return this.P(m)?.getObject(P,o)}storeAll(P,m){this.y(()=>{for(const o of P)this.store(o.key,o.value,o.scope,o.target,m)})}store(P,m,o,h,i=!1){if((0,N.$lg)(m)){this.remove(P,o,i);return}this.y(()=>{this.z(P,o,h),this.P(o)?.set(P,m,i)})}remove(P,m,o=!1){this.y(()=>{this.z(P,m,void 0),this.P(m)?.delete(P,o)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,m){const o=[],h=this.J(P);for(const i of Object.keys(h))h[i]===m&&o.push(i);return o}z(P,m,o,h=!1){const i=this.J(m);typeof o=="number"?i[P]!==o&&(i[P]=o,this.P(m)?.set(e.$eq,JSON.stringify(i),h)):typeof i[P]=="number"&&(delete i[P],this.P(m)?.set(e.$eq,JSON.stringify(i),h))}get D(){return this.C||(this.C=this.L(d.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(d.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(d.APPLICATION)),this.H}J(P){switch(P){case d.APPLICATION:return this.I;case d.PROFILE:return this.G;default:return this.D}}L(P){const m=this.P(P);return m?$(m):Object.create(null)}isNew(P){return this.getBoolean(e.$dq,P)===!0}async flush(P=R.NONE){this.f.fire({reason:P});const m=this.P(d.APPLICATION),o=this.P(d.PROFILE),h=this.P(d.WORKSPACE);switch(P){case R.NONE:await I.Promises.settled([m?.whenFlushed()??Promise.resolve(),o?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await I.Promises.settled([m?.flush(0)??Promise.resolve(),o?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(d.APPLICATION)?.items??new Map,m=this.P(d.PROFILE)?.items??new Map,o=this.P(d.WORKSPACE)?.items??new Map;return g(P,m,o,this.Q(d.APPLICATION)??"",this.Q(d.PROFILE)??"",this.Q(d.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,m){return this.w(R.NONE),(0,b.$Il)(P)?this.R(P,m):this.S(P,m)}M(P,m){return!(P.id===m.id||p(m)&&p(P))}N(P,m,o){this.y(()=>{const h=new Set;for(const[i,s]of P)h.add(i),m.get(i)!==s&&this.u(o,{key:i,external:!0});for(const[i]of m.items)h.has(i)||this.u(o,{key:i,external:!0})})}}e.$hq=l;function p(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class S extends l{constructor(){super(),this.U=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$bq(new O.$cq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(d.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(d.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(d.APPLICATION,P)))}P(P){switch(P){case d.APPLICATION:return this.U;case d.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case d.APPLICATION:return"inMemory (application)";case d.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$jq=S;async function g(w,P,m,o,h,i){const s=E=>{try{return JSON.parse(E)}catch{return E}},t=new Map,n=new Map;w.forEach((E,T)=>{t.set(T,E),n.set(T,s(E))});const r=new Map,a=new Map;P.forEach((E,T)=>{r.set(T,E),a.set(T,s(E))});const u=new Map,y=new Map;m.forEach((E,T)=>{u.set(T,E),y.set(T,s(E))}),console.group(o!==h?`Storage: Application (path: ${o})`:`Storage: Application & Profile (path: ${o}, default profile)`);const C=[];if(t.forEach((E,T)=>{C.push({key:T,value:E})}),console.table(C),console.groupEnd(),console.log(n),o!==h){console.group(`Storage: Profile (path: ${h}, profile specific)`);const E=[];r.forEach((T,F)=>{E.push({key:F,value:T})}),console.table(E),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${i})`);const v=[];u.forEach((E,T)=>{v.push({key:T,value:E})}),console.table(v),console.groupEnd(),console.log(y)}}),define(he[118],ue([0,1,3,2,12,27,34,16]),function(oe,e,I,c,L,A,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Lb=e.$0Lb=void 0;let k=class extends c.$Tc{constructor(d,f){super(),this.a=new I.$je,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(d)),this.B(this.b.onDidChange($=>this.a.fire({extensions:$,source:"storage"}))),this.B(f.onDidInstallExtensions($=>$.forEach(({local:l,operation:p})=>{l&&p===A.InstallOperation.Migrate&&this.f(l.identifier)})))}async enableExtension(d,f){return this.f(d)?(this.a.fire({extensions:[d],source:f}),!0):!1}async disableExtension(d,f){return this.c(d)?(this.a.fire({extensions:[d],source:f}),!0):!1}getDisabledExtensions(){return this.h(A.$mp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(d){const f=this.getDisabledExtensions();return f.every($=>!(0,N.$Jp)($,d))?(f.push(d),this.g(f),!0):!1}f(d){const f=this.getDisabledExtensions();for(let $=0;$<f.length;$++){const l=f[$];if((0,N.$Jp)(l,d))return f.splice($,1),this.g(f),!0}return!1}g(d){this.j(A.$mp,d)}h(d){return this.b.get(d,O.StorageScope.PROFILE)}j(d,f){this.b.set(d,f,O.StorageScope.PROFILE)}};e.$0Lb=k,e.$0Lb=k=ve([Q(0,O.$fq),Q(1,A.$lp)],k);class b extends c.$Tc{constructor(d){super(),this.c=d,this.a=Object.create(null),this.b=this.B(new I.$je),this.onDidChange=this.b.event,this.B(d.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new c.$Sc))(f=>this.f(f)))}get(d,f){let $;return f===O.StorageScope.PROFILE?((0,L.$lg)(this.a[d])&&(this.a[d]=this.g(d,f)),$=this.a[d]):$=this.g(d,f),JSON.parse($)}set(d,f,$){const l=JSON.stringify(f.map(({id:S,uuid:g})=>({id:S,uuid:g})));this.g(d,$)!==l&&($===O.StorageScope.PROFILE&&(f.length?this.a[d]=l:delete this.a[d]),this.h(d,f.length?l:void 0,$))}f(d){if(!(0,L.$lg)(this.a[d.key])&&this.g(d.key,d.scope)!==this.a[d.key]){const $=this.get(d.key,d.scope);delete this.a[d.key];const l=this.get(d.key,d.scope),p=$.filter(g=>!l.some(w=>(0,N.$Jp)(g,w))),S=l.filter(g=>!$.some(w=>(0,N.$Jp)(w,g)));(p.length||S.length)&&this.b.fire([...p,...S])}}g(d,f){return this.c.get(d,f,"[]")}h(d,f,$){f?this.c.store(d,f,$,O.StorageTarget.MACHINE):this.c.remove(d,$)}}e.$$Lb=b}),define(he[85],ue([0,1,4,3,2,16,34,23,17,10,12]),function(oe,e,I,c,L,A,N,O,k,b,R){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=e.$nw=void 0,e.$nw=(0,I.$Ci)("IExtensionStorageService");const f=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let $=class extends L.$Tc{static{d=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,N.$Np)(p.id)}@${p.version}`}static c(p){const S=f.exec(p);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(p,S){const g=await p.getInstalled(),w=[];for(const[P,m]of d.f(S)){const o=g.find(h=>(0,N.$Jp)(h.identifier,{id:P}))?.manifest.version;for(const h of m)o!==h&&w.push(d.b({id:P,version:h}))}for(const P of w)S.remove(P,A.StorageScope.PROFILE)}static f(p){const S=new Map,g=p.keys(A.StorageScope.PROFILE,A.StorageTarget.MACHINE);for(const w of g){const P=d.c(w);if(P){let m=S.get(P.id.toLowerCase());m||S.set(P.id.toLowerCase(),m=[]),m.push(P.version)}}return S}constructor(p,S,g){super(),this.j=p,this.m=S,this.n=g,this.g=this.B(new c.$je),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=d.f(p),this.B(this.j.onDidChangeValue(A.StorageScope.PROFILE,void 0,this.B(new L.$Sc))(w=>this.r(w)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const S=d.c(p.key);if(S){if(this.j.get(p.key,A.StorageScope.PROFILE)===void 0)this.h.delete(S.id.toLowerCase());else{let g=this.h.get(S.id.toLowerCase());g||this.h.set(S.id.toLowerCase(),g=[]),g.push(S.version),this.g.fire()}return}}s(p){if((0,R.$cg)(p))return p;const S=p.manifest?p.manifest.publisher:p.publisher,g=p.manifest?p.manifest.name:p.name;return(0,N.$Mp)(S,g)}getExtensionState(p,S){const g=this.s(p),w=this.getExtensionStateRaw(p,S);if(w)try{return JSON.parse(w)}catch(P){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${S}): ${P}`)}}getExtensionStateRaw(p,S){const g=this.s(p),w=this.j.get(g,S?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE);return w&&w?.length>d.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${g}, global: ${S}): ${w.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),w}setExtensionState(p,S,g){const w=this.s(p);S===void 0?this.j.remove(w,g?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE):this.j.store(w,JSON.stringify(S),g?A.StorageScope.PROFILE:A.StorageScope.WORKSPACE,A.StorageTarget.MACHINE)}setKeysForSync(p,S){this.j.store(d.b(p),JSON.stringify(S),A.StorageScope.PROFILE,A.StorageTarget.MACHINE)}getKeysForSync(p){const S=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],g=this.j.get(d.b(p),A.StorageScope.PROFILE),w=g?JSON.parse(g):void 0;return w&&S?(0,k.$Lb)([...w,...S]):w||S}addToMigrationList(p,S){if(p!==S){const g=this.t.filter(w=>!w.includes(p)&&!w.includes(S));g.push([p,S]),this.t=g}}getSourceExtensionToMigrate(p){const S=this.t.find(([,g])=>p===g);return S?S[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",A.StorageScope.APPLICATION,"[]");try{const S=JSON.parse(p);if(Array.isArray(S))return S}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),A.StorageScope.APPLICATION,A.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",A.StorageScope.APPLICATION)}};e.$ow=$,e.$ow=$=d=ve([Q(0,A.$fq),Q(1,O.$qk),Q(2,b.$0j)],$)}),define(he[218],ue([0,1,2,27,85,196,117,10,16]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;let b=class extends I.$Tc{constructor(d,f,$,l,p,S){super(),d.cleanUp(),(0,A.$16b)(d,f,$,l,S),L.$ow.removeOutdatedExtensionVersions(d,p)}};e.$Fhc=b,e.$Fhc=b=ve([Q(0,N.$Vq),Q(1,c.$ip),Q(2,L.$nw),Q(3,c.$op),Q(4,k.$fq),Q(5,O.$0j)],b)}),define(he[219],ue([0,1,17,2,20,9,7,23,6,3,13,5,37,34,74,33,16]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=void 0;let g=class extends c.$Tc{constructor(h,i){super(),this.b=h,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,s])=>this.a.set(s.configPath,s))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const i=[];for(const[s,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const n=(await this.b.readFile((0,L.$dh)(h,s))).value.toString();for(const[r,a]of Object.entries(t.recommendations))(!a.contentPattern||new RegExp(a.contentPattern,"mig").test(n))&&i.push({extensionId:r,extensionName:a.name,configName:t.configName,important:!!a.important,isExtensionPack:!!a.isExtensionPack,whenNotInstalled:a.whenNotInstalled})}catch{}return i}};e.$Xdc=g,e.$Xdc=g=ve([Q(0,N.$0k),Q(1,O.$qk)],g);const w="extensionTips/promptedExecutableTips",P="extensionTips/lastPromptedMediumImpExeTime";class m extends g{constructor(h,i,s,t,n,r,a,u){super(a,u),this.r=h,this.s=i,this.t=s,this.u=t,this.w=n,this.z=r,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,u.exeBasedExtensionTips&&Object.entries(u.exeBasedExtensionTips).forEach(([y,C])=>{const v=[],E=[],T=[];Object.entries(C.recommendations).forEach(([F,U])=>{U.important?C.important?v.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):E.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack}):T.push({extensionId:F,extensionName:U.name,isExtensionPack:!!U.isExtensionPack})}),v.length&&this.g.set(y,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:v}),E.length&&this.h.set(y,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:E}),T.length&&this.j.set(y,{exeFriendlyName:C.friendlyName,windowsPath:C.windowsPath,recommendations:T})}),(0,k.$Eh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),i=await this.O(this.h);return[...h,...i]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),i=await this.O(this.h),s=await this.u.getInstalled();this.m=this.D(h,s),this.n=this.D(i,s)}D(h,i){const s=new Map;h.forEach(u=>s.set(u.extensionId.toLowerCase(),u));const{installed:t,uninstalled:n}=this.N([...s.keys()],i);for(const u of t){const y=s.get(u);y&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:u,exeName:y.exeName})}for(const u of n){const y=s.get(u);y&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:u,exeName:y.exeName})}const r=this.L(),a=new Map;for(const u of n){const y=s.get(u);if(y&&(!r[y.exeName]||!r[y.exeName].includes(y.extensionId))){let C=a.get(y.exeName);C||(C=[],a.set(y.exeName,C)),C.push(y)}}return a}F(){if(this.m.size===0)return;const[h,i]=[...this.m.entries()][0];this.H(i).then(s=>{switch(s){case l.RecommendationsNotificationResult.Accepted:this.M(i[0].exeName,i);break;case l.RecommendationsNotificationResult.Ignored:this.m.delete(h);break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const t=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case l.RecommendationsNotificationResult.TooMany:{const t=this.B(new c.$Uc);t.value=(0,k.$Eh)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),i=Date.now()-h,s=7*24*60*60*1e3;if(i<s){const r=this.B(new c.$Uc);r.value=(0,k.$Eh)(()=>{r.dispose(),this.G()},s-i);return}const[t,n]=[...this.n.entries()][0];this.H(n).then(r=>{switch(r){case l.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(t),this.M(n[0].exeName,n);const a=this.B(new c.$Uc);a.value=(0,k.$Eh)(()=>{a.dispose(),this.G()},s);break}case l.RecommendationsNotificationResult.Ignored:this.n.delete(t),this.G();break;case l.RecommendationsNotificationResult.IncompatibleWindow:{const a=b.Event.once(b.Event.latch(b.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(a(()=>this.G()));break}case l.RecommendationsNotificationResult.TooMany:{const a=this.B(new c.$Uc);a.value=(0,k.$Eh)(()=>{a.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const i=await this.u.getInstalled(p.ExtensionType.User),s=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(n=>i.every(r=>!(0,$.$Jp)(r.identifier,{id:n})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:s,source:l.RecommendationSource.EXE,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(P,S.StorageScope.APPLICATION);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(P,h,S.StorageScope.APPLICATION,S.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(w,S.StorageScope.APPLICATION,"{}"))}M(h,i){const s=this.L();s[h]=i.map(({extensionId:t})=>t.toLowerCase()),this.w.store(w,JSON.stringify(s),S.StorageScope.APPLICATION,S.StorageTarget.USER)}N(h,i){const s=[],t=[],n=i.reduce((r,a)=>(r.add(a.identifier.id.toLowerCase()),r),new Set);return h.forEach(r=>{n.has(r.toLowerCase())?s.push(r):t.push(r)}),{installed:s,uninstalled:t}}async O(h){const i=[],s=new Map;for(const t of h.keys()){const n=h.get(t);if(!n||!(0,I.$Kb)(n.recommendations))continue;const r=[];d.$j?n.windowsPath&&r.push(n.windowsPath.replace("%USERPROFILE%",()=>f.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>f.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>f.env.ProgramFiles).replace("%APPDATA%",()=>f.env.APPDATA).replace("%WINDIR%",()=>f.env.WINDIR)):(r.push((0,R.$ic)("/usr/local/bin",t)),r.push((0,R.$ic)("/usr/bin",t)),r.push((0,R.$ic)(this.r.fsPath,t)));for(const a of r){let u=s.get(a);if(u===void 0&&(u=await this.b.exists(A.URI.file(a)),s.set(a,u)),u)for(const{extensionId:y,extensionName:C,isExtensionPack:v,whenNotInstalled:E}of n.recommendations)i.push({extensionId:y,extensionName:C,isExtensionPack:v,exeName:t,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:E})}}return i}}e.$Ydc=m}),define(he[220],ue([0,1,27,7,23,15,74,57,16,18,219]),function(oe,e,I,c,L,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;let d=class extends R.$Ydc{constructor($,l,p,S,g,w,P,m){super($.userHome,g,l,p,S,w,P,m)}};e.$Mhc=d,e.$Mhc=d=ve([Q(0,A.$Ki),Q(1,b.$9l),Q(2,I.$lp),Q(3,k.$fq),Q(4,O.$Hfc),Q(5,N.$I6b),Q(6,c.$0k),Q(7,L.$qk)],d)}),define(he[49],ue([0,1,14,31,16]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=A;async function A(N,O,k){let b=k&&k.get("storage.serviceMachineId",L.StorageScope.APPLICATION)||null;if(b)return b;try{const d=(await O.readFile(N.serviceMachineIdResource)).value.toString();b=(0,c.$Xg)(d)?d:null}catch{b=null}if(!b){b=(0,c.$Yg)();try{await O.writeFile(N.serviceMachineIdResource,I.$Le.fromString(b))}catch{}}return k?.store("storage.serviceMachineId",b,L.StorageScope.APPLICATION,L.StorageTarget.MACHINE),b}}),define(he[221],ue([0,1,49,18,48]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=A;async function A(N,O,k,b,R,d,f){const $={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${O.nameShort})`};if((0,L.$Bp)(O,k)&&(0,L.$Dp)(b)===c.TelemetryLevel.USAGE){const l=await(0,I.$lq)(k,R,d);$["X-Market-User-Id"]=l,$["VSCode-SessionId"]=f.machineId||l}return $}}),define(he[222],ue([0,1,17,25,8,5,37,12,9,21,15,27,34,33,59,7,10,23,61,221,16,18,54]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0,e.$nq=te;const i=A.$p?$.TargetPlatform.WEB:(0,d.$ep)(A.$v,N.$dc),s="X-Market-Search-Activity-Id";var t;(function(q){q[q.None=0]="None",q[q.IncludeVersions=1]="IncludeVersions",q[q.IncludeFiles=2]="IncludeFiles",q[q.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",q[q.IncludeSharedAccounts=8]="IncludeSharedAccounts",q[q.IncludeVersionProperties=16]="IncludeVersionProperties",q[q.ExcludeNonValidated=32]="ExcludeNonValidated",q[q.IncludeInstallationTargets=64]="IncludeInstallationTargets",q[q.IncludeAssetUri=128]="IncludeAssetUri",q[q.IncludeStatistics=256]="IncludeStatistics",q[q.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",q[q.Unpublished=4096]="Unpublished",q[q.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...q){return String(q.reduce((M,Z)=>M|Z,0))}var r;(function(q){q[q.Tag=1]="Tag",q[q.ExtensionId=4]="ExtensionId",q[q.Category=5]="Category",q[q.ExtensionName=7]="ExtensionName",q[q.Target=8]="Target",q[q.Featured=9]="Featured",q[q.SearchText=10]="SearchText",q[q.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},C={pageNumber:1,pageSize:10,sortBy:d.SortBy.NoneOrRelevance,sortOrder:d.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class v{constructor(M=C){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,Z=this.d.pageSize){return new v({...this.d,pageNumber:M,pageSize:Z})}withFilter(M,...Z){const ee=[...this.d.criteria,...Z.length?Z.map(X=>({filterType:M,value:X})):[{filterType:M}]];return new v({...this.d,criteria:ee})}withSortBy(M){return new v({...this.d,sortBy:M})}withSortOrder(M){return new v({...this.d,sortOrder:M})}withFlags(...M){return new v({...this.d,flags:M.reduce((Z,ee)=>Z|ee,0)})}withAssetTypes(...M){return new v({...this.d,assetTypes:M})}withSource(M){return new v({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:Z,pageSize:ee,sortBy:X,sortOrder:re,flags:le,assetTypes:ge}=this.d;return{filters:[{criteria:M,pageNumber:Z,pageSize:ee,sortBy:X,sortOrder:re}],assetTypes:ge,flags:le}}get searchText(){const M=this.d.criteria.filter(Z=>Z.filterType===r.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(q,M){const Z=(q||[]).filter(ee=>ee.statisticName===M)[0];return Z?Z.value:0}function T(q){const M="Microsoft.VisualStudio.Code.Translation.";return q.files.filter(ee=>ee.assetType.indexOf(M)===0).reduce((ee,X)=>{const re=j(q,X.assetType);return re&&ee.push([X.assetType.substring(M.length),re]),ee},[])}function F(q){if(q.properties){const M=q.properties.filter(X=>X.key===a.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=M.filter(X=>Z.test(X.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return j(q,a.Repository)}function U(q){return{uri:`${q.fallbackAssetUri}/${a.VSIX}?redirect=true${q.targetPlatform?`&targetPlatform=${q.targetPlatform}`:""}`,fallbackUri:`${q.fallbackAssetUri}/${a.VSIX}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`}}function j(q,M){return q.files.filter(ee=>ee.assetType===M)[0]?{uri:`${q.assetUri}/${M}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`,fallbackUri:`${q.fallbackAssetUri}/${M}${q.targetPlatform?`?targetPlatform=${q.targetPlatform}`:""}`}:null}function K(q,M){const Z=q.properties?q.properties.filter(X=>X.key===M):[],ee=Z.length>0&&Z[0].value;return ee?ee.split(",").map(X=>(0,f.$Np)(X)):[]}function V(q){const M=q.properties?q.properties.filter(Z=>Z.key===u.Engine):[];return M.length>0&&M[0].value||""}function x(q){const M=q.properties?q.properties.filter(Z=>Z.key===u.PreRelease):[];return M.length>0&&M[0].value==="true"}function H(q){const M=q.properties?q.properties.filter(ee=>ee.key===u.EnabledApiProposals):[],Z=M.length>0&&M[0].value||"";return Z?Z.split(","):[]}function ie(q){const M=q.properties?q.properties.filter(ee=>ee.key===u.LocalizedLanguages):[],Z=M.length>0&&M[0].value||"";return Z?Z.split(","):[]}function W(q){return q.properties?.find(M=>M.key===u.SponsorLink)?.value}function z(q){return q.properties?.find(M=>M.key===u.SupportLink)?.value}function _(q){return q.indexOf("preview")!==-1}function ne(q){return q.targetPlatform?(0,d.$dp)(q.targetPlatform):$.TargetPlatform.UNDEFINED}function ce(q){const M=(0,I.$Lb)(q.versions.map(ne)),Z=!!q.tags?.includes(d.$0o),ee=M.indexOf($.TargetPlatform.WEB);return Z?ee===-1&&M.push($.TargetPlatform.WEB):ee!==-1&&M.splice(ee,1),M}function te(q,M){for(let Z=0;Z<q.length;Z++){const ee=q[Z];if(ee.version===q[Z-1]?.version){let X=Z;if(ne(ee)===M)for(;X>0&&q[X-1].version===ee.version;)X--;X!==Z&&(q.splice(Z,1),q.splice(X,0,ee))}}return q}function Y(q,M,Z){q.telemetryData={index:M,querySource:Z,queryActivityId:q.queryContext?.[s]}}function G(q,M,Z,ee){const X=q.versions[0],re={manifest:j(M,a.Manifest),readme:j(M,a.Details),changelog:j(M,a.Changelog),license:j(M,a.License),repository:F(M),download:U(M),icon:j(M,a.Icon),signature:j(M,a.Signature),coreTranslations:T(M)};return{type:"gallery",identifier:{id:(0,f.$Op)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},name:q.extensionName,version:M.version,displayName:q.displayName,publisherId:q.publisher.publisherId,publisher:q.publisher.publisherName,publisherDisplayName:q.publisher.displayName,publisherDomain:q.publisher.domain?{link:q.publisher.domain,verified:!!q.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(X),description:q.shortDescription??"",installCount:E(q.statistics,"install"),rating:E(q.statistics,"averagerating"),ratingCount:E(q.statistics,"ratingcount"),categories:q.categories||[],tags:q.tags||[],releaseDate:Date.parse(q.releaseDate),lastUpdated:Date.parse(q.lastUpdated),allTargetPlatforms:Z,assets:re,properties:{dependencies:K(M,u.Dependency),extensionPack:K(M,u.ExtensionPack),engine:V(M),enabledApiProposals:H(M),localizedLanguages:ie(M),targetPlatform:ne(M),isPreReleaseVersion:x(M)},hasPreReleaseVersion:x(X),hasReleaseVersion:!0,preview:_(q.flags),isSigned:!!re.signature,queryContext:ee,supportLink:z(X)}}let B=class{constructor(M,Z,ee,X,re,le,ge,pe){this.l=Z,this.n=ee,this.o=X,this.q=re,this.u=le,this.w=ge,this.x=pe;const Ee=ge.extensionsGallery,we=Ee?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=we?Ee.servicePPEUrl:Ee?.serviceUrl,this.g=we?void 0:Ee?.searchUrl,this.h=Ee?.controlUrl,this.k=ge.extensionsEnabledWithApiProposalVersion?.map(be=>be.toLowerCase())??[],this.j=(0,P.$mq)(ge.version,ge,this.o,this.x,this.u,M,this.q)}y(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,Z,ee){const X=c.CancellationToken.isCancellationToken(Z)?{}:Z,re=c.CancellationToken.isCancellationToken(Z)?Z:ee,le=[],ge=[],pe=[],Ee=[];let we=!0;for(const Ie of M){Ie.uuid?ge.push(Ie.uuid):le.push(Ie.id);const ae=!!(Ie.version||Ie.preRelease);pe.push({id:Ie.id,uuid:Ie.uuid,includePreRelease:ae}),Ie.version&&Ee.push({id:Ie.id,uuid:Ie.uuid,version:Ie.version}),we=we&&!!Ie.hasPreRelease&&!ae}if(!ge.length&&!le.length)return[];let be=new v().withPage(1,M.length);ge.length&&(be=be.withFilter(r.ExtensionId,...ge)),le.length&&(be=be.withFilter(r.ExtensionName,...le)),(X.queryAllVersions||we)&&(be=be.withFlags(be.flags,t.IncludeVersions)),X.source&&(be=be.withSource(X.source));const{extensions:Se}=await this.B(be,{targetPlatform:X.targetPlatform??i,includePreRelease:pe,versions:Ee,compatible:!!X.compatible,productVersion:X.productVersion??{version:this.w.version,date:this.w.date}},re);return X.source&&Se.forEach((Ie,ae)=>Y(Ie,ae,X.source)),Se}async getCompatibleExtension(M,Z,ee,X={version:this.w.version,date:this.w.date}){if((0,d.$fp)(M.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(M,Z,ee))return M;const re=new v().withFlags(t.IncludeVersions).withPage(1,1).withFilter(r.ExtensionId,M.identifier.uuid),{extensions:le}=await this.B(re,{targetPlatform:ee,compatible:!0,includePreRelease:Z,productVersion:X},c.CancellationToken.None);return le[0]||null}async isExtensionCompatible(M,Z,ee,X={version:this.w.version,date:this.w.date}){if(!(0,d.$gp)(M.properties.targetPlatform,M.allTargetPlatforms,ee)||!Z&&M.properties.isPreReleaseVersion)return!1;let re=M.properties.engine;if(!re){const le=await this.getManifest(M,c.CancellationToken.None);if(!le)throw new Error("Manifest was not found");re=le.engines.vscode}return!(!(0,l.$3p)(re,X.version,X.date)||!this.z(M.identifier,M.properties.enabledApiProposals))}z(M,Z){return!Z||!this.k.includes(M.id.toLowerCase())?!0:(0,l.$4p)(Z)}async A(M,Z,ee,X,re,le,ge={version:this.w.version,date:this.w.date}){if(!(0,d.$gp)(ne(Z),re,le)||ee!=="any"&&x(Z)!==(ee==="prerelease"))return!1;if(X)try{const pe=await this.G(M,Z);if(!(0,l.$3p)(pe,ge.version,ge.date))return!1}catch(pe){return this.n.error(`Error while getting the engine for the version ${Z.version}.`,(0,L.$9)(pe)),!1}return!0}async query(M,Z){let ee=M.text||"";const X=M.pageSize??50;let re=new v().withPage(1,X);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Se)=>(re=re.withFilter(r.Category,Se||be),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Se)=>(re=re.withFilter(r.Tag,Se||be),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),re=re.withFilter(r.SearchText,ee)),re=re.withSortBy(d.SortBy.NoneOrRelevance)):M.ids?re=re.withFilter(r.ExtensionId,...M.ids):M.names?re=re.withFilter(r.ExtensionName,...M.names):re=re.withSortBy(d.SortBy.InstallCount),typeof M.sortBy=="number"&&(re=re.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(re=re.withSortOrder(M.sortOrder)),M.source&&(re=re.withSource(M.source));const le=async(we,be)=>{const{extensions:Se,total:Ie}=await this.B(we,{targetPlatform:i,compatible:!1,includePreRelease:!!M.includePreRelease,productVersion:M.productVersion??{version:this.w.version,date:this.w.date}},be);return Se.forEach((ae,de)=>Y(ae,(we.pageNumber-1)*we.pageSize+de,M.source)),{extensions:Se,total:Ie}},{extensions:ge,total:pe}=await le(re,Z),Ee=async(we,be)=>{if(be.isCancellationRequested)throw new L.$4;const{extensions:Se}=await le(re.withPage(we+1),be);return Se};return{firstPage:ge,total:pe,pageSize:re.pageSize,getPage:Ee}}async B(M,Z,ee){const X=M.flags;M.flags&t.IncludeLatestVersionOnly&&M.flags&t.IncludeVersions&&(M=M.withFlags(M.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(M.flags&t.IncludeLatestVersionOnly)&&!(M.flags&t.IncludeVersions)&&(M=M.withFlags(M.flags,t.IncludeLatestVersionOnly)),Z.versions?.length&&(M=M.withFlags(M.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),M=M.withFlags(M.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:re,total:le,context:ge}=await this.D(M,ee);if(!(M.flags&t.IncludeLatestVersionOnly)){const be=[];for(const Se of re){const Ie=await this.C(Se,Z,ge);Ie&&be.push(Ie)}return{extensions:be,total:le}}const Ee=[],we=new Map;for(let be=0;be<re.length;be++){const Se=re[be],Ie={id:(0,f.$Op)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},ae=(0,O.$ig)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(me=>(0,f.$Jp)(me,Ie))?.includePreRelease;if(Z.compatible&&(0,d.$fp)(ce(Se),Z.targetPlatform))continue;const de=await this.C(Se,Z,ge);!de||de.properties.isPreReleaseVersion&&(!ae||!de.hasReleaseVersion)||!de.properties.isPreReleaseVersion&&de.properties.targetPlatform!==Z.targetPlatform&&de.hasPreReleaseVersion?we.set(Se.extensionId,be):Ee.push([be,de])}if(we.size){const be=new h.$de,Se=new v().withFlags(X&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,we.size).withFilter(r.ExtensionId,...we.keys()),{extensions:Ie}=await this.B(Se,Z,ee);this.q.publicLog2("galleryService:additionalQuery",{duration:be.elapsed(),count:we.size});for(const ae of Ie){const de=we.get(ae.identifier.uuid);Ee.push([de,ae])}}return{extensions:Ee.sort((be,Se)=>be[0]-Se[0]).map(([,be])=>be),total:le}}async C(M,Z,ee){const X={id:(0,f.$Op)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},re=Z.versions?.find(Ee=>(0,f.$Jp)(Ee,X))?.version,le=(0,O.$ig)(Z.includePreRelease)?Z.includePreRelease:!!Z.includePreRelease.find(Ee=>(0,f.$Jp)(Ee,X))?.includePreRelease,ge=ce(M),pe=te(M.versions,Z.targetPlatform);if(Z.compatible&&(0,d.$fp)(ge,Z.targetPlatform))return null;for(let Ee=0;Ee<pe.length;Ee++){const we=pe[Ee];if(!(re&&we.version!==re)){if(await this.A(X.id,we,le?"any":"release",Z.compatible,ge,Z.targetPlatform,Z.productVersion))return Z.compatible&&!this.z(X,H(we))?null:G(M,we,ge,ee);if(re&&we.version===re)return null}}return re||Z.compatible?null:G(M,M.versions[0],ge)}async D(M,Z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,t.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,n(t.Unpublished));const ee=await this.j,X=JSON.stringify(M.raw),re={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},le=new h.$de;let ge,pe,Ee=0;try{if(ge=await this.l.request({type:"POST",url:this.g&&M.criteria.some(be=>be.filterType===r.SearchText)?this.g:this.y("/extensionquery"),data:X,headers:re},Z),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Ee};const we=await(0,w.$$p)(ge);if(we){const be=we.results[0],Se=be.extensions,Ie=be.resultMetadata&&be.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return Ee=Ie&&Ie.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:Ee,context:{[s]:ge.res.headers.activityid}}}return{galleryExtensions:[],total:Ee}}catch(we){if((0,L.$3)(we))throw pe=d.ExtensionGalleryErrorCode.Cancelled,we;{const be=(0,L.$9)(we);throw pe=be.startsWith("XHR timeout")?d.ExtensionGalleryErrorCode.Timeout:d.ExtensionGalleryErrorCode.Failed,new d.$jp(be,pe)}}finally{this.q.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(X.length),duration:le.elapsed(),success:!!ge&&(0,w.$7p)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:pe,count:String(Ee)})}}async reportStatistic(M,Z,ee,X){if(!this.isEnabled())return;const re=A.$p?this.y(`/itemName/${M}.${Z}/version/${ee}/statType/${X===d.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${M}/extensions/${Z}/${ee}/stats?statType=${X}`),le=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:le};try{await this.l.request({type:"POST",url:re,headers:pe},c.CancellationToken.None)}catch{}}async download(M,Z,ee){this.n.trace("ExtensionGalleryService#download",M.identifier.id);const X=(0,f.$Rp)(M),re=new Date().getTime(),le=ee===d.InstallOperation.Install?"install":ee===d.InstallOperation.Update?"update":"",ge=le?{uri:`${M.assets.download.uri}${k.URI.parse(M.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${M.assets.download.fallbackUri}${k.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:M.assets.download,pe=M.queryContext?.[s]?{[s]:M.queryContext[s]}:void 0,Ee=await this.F(M.identifier.id,ge,a.VSIX,pe?{headers:pe}:void 0);try{await this.u.writeFile(Z,Ee.stream)}catch(we){try{await this.u.del(Z)}catch(be){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,L.$9)(be))}throw new d.$jp((0,L.$9)(we),d.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...X,duration:new Date().getTime()-re})}async downloadSignatureArchive(M,Z){if(!M.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const ee=await this.F(M.identifier.id,M.assets.signature,a.Signature);try{await this.u.writeFile(Z,ee.stream)}catch(X){try{await this.u.del(Z)}catch(re){this.n.warn(`Error while deleting the file ${Z.toString()}`,(0,L.$9)(re))}throw new d.$jp((0,L.$9)(X),d.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(M,Z){if(M.assets.readme){const ee=await this.F(M.identifier.id,M.assets.readme,a.Details,{},Z);return await(0,w.$0p)(ee)||""}return""}async getManifest(M,Z){if(M.assets.manifest){const ee=await this.F(M.identifier.id,M.assets.manifest,a.Manifest,{},Z),X=await(0,w.$0p)(ee);return X?JSON.parse(X):null}return null}async E(M,Z,ee){const X=j(Z,a.Manifest);if(!X)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},le=await this.F(M,X,a.Manifest,{headers:re});return await(0,w.$$p)(le)}async getCoreTranslation(M,Z){const ee=M.assets.coreTranslations.filter(X=>X[0]===Z.toUpperCase())[0];if(ee){const X=await this.F(M.identifier.id,ee[1],ee[0]),re=await(0,w.$0p)(X);return re?JSON.parse(re):null}return null}async getChangelog(M,Z){if(M.assets.changelog){const ee=await this.F(M.identifier.id,M.assets.changelog,a.Changelog,{},Z);return await(0,w.$0p)(ee)||""}return""}async getAllCompatibleVersions(M,Z,ee){let X=new v().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);M.uuid?X=X.withFilter(r.ExtensionId,M.uuid):X=X.withFilter(r.ExtensionName,M.id);const{galleryExtensions:re}=await this.D(X,c.CancellationToken.None);if(!re.length)return[];const le=ce(re[0]);if((0,d.$fp)(le,ee))return[];const ge=[];await Promise.all(re[0].versions.map(async we=>{try{await this.A(M.id,we,Z?"any":"release",!0,le,ee)&&this.z(M,H(we))&&ge.push(we)}catch{}}));const pe=[],Ee=new Set;for(const we of te(ge,ee))Ee.has(we.version)||(Ee.add(we.version),pe.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:x(we)}));return pe}async F(M,Z,ee,X={},re=c.CancellationToken.None){const le=await this.j,ge={type:"GET"},pe={...le,...X.headers||{}};X={...X,...ge,headers:pe};const Ee=Z.uri,we=Z.fallbackUri,be={...X,url:Ee};try{const Se=await this.l.request(be,re);if(Se.res.statusCode===200)return Se;const Ie=await(0,w.$0p)(Se);throw new Error(`Expected 200, got back ${Se.res.statusCode} instead.

${Ie}`)}catch(Se){if((0,L.$3)(Se))throw Se;const Ie=(0,L.$9)(Se);this.q.publicLog2("galleryService:cdnFallback",{extension:M,assetType:ee,message:Ie});const ae={...X,url:we};return this.l.request(ae,re)}}async G(M,Z){let ee=V(Z);if(!ee){this.q.publicLog2("galleryService:engineFallback",{extension:M,version:Z.version});const X=await this.E(M,Z,c.CancellationToken.None);if(!X)throw new Error("Manifest was not found");ee=X.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const M=await this.l.request({type:"GET",url:this.h},c.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,w.$$p)(M),ee=[],X={},re=[],le=[];if(Z){for(const ge of Z.malicious)ee.push({id:ge});if(Z.migrateToPreRelease)for(const[ge,pe]of Object.entries(Z.migrateToPreRelease))(!pe.engine||(0,l.$3p)(pe.engine,this.w.version,this.w.date))&&(X[ge.toLowerCase()]={disallowInstall:!0,extension:{id:pe.id,displayName:pe.displayName,autoMigrate:{storage:!!pe.migrateStorage},preRelease:!0}});if(Z.deprecated)for(const[ge,pe]of Object.entries(Z.deprecated))pe&&(X[ge.toLowerCase()]=(0,O.$ig)(pe)?{}:pe);if(Z.search)for(const ge of Z.search)re.push(ge);if(Array.isArray(Z.extensionsEnabledWithPreRelease))for(const ge of Z.extensionsEnabledWithPreRelease)le.push(ge.toLowerCase())}return{malicious:ee,deprecated:X,search:re,extensionsEnabledWithPreRelease:le}}};B=ve([Q(1,w.$5p),Q(2,S.$0j),Q(3,R.$Ji),Q(4,o.$9l),Q(5,p.$0k),Q(6,g.$qk),Q(7,b.$9i)],B);let D=class extends B{constructor(M,Z,ee,X,re,le,ge,pe){super(M,Z,ee,X,re,le,ge,pe)}};e.$oq=D,e.$oq=D=ve([Q(0,m.$fq),Q(1,w.$5p),Q(2,S.$0j),Q(3,R.$Ji),Q(4,o.$9l),Q(5,p.$0k),Q(6,g.$qk),Q(7,b.$9i)],D);let J=class extends B{constructor(M,Z,ee,X,re,le,ge){super(void 0,M,Z,ee,X,re,le,ge)}};e.$pq=J,e.$pq=J=ve([Q(0,w.$5p),Q(1,S.$0j),Q(2,R.$Ji),Q(3,o.$9l),Q(4,p.$0k),Q(5,g.$qk),Q(6,b.$9i)],J)}),define(he[223],ue([0,1,107,3,18,15,2,10,13,68,23,5,6,101,21,11,38,16,12,142,20]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;const o=[I.$Bhc,I.$Chc],h="remoteTunnelSession",i="remoteTunnelIsService";let s=class extends N.$Tc{constructor(a,u,y,C,v,E,T){super(),this.y=a,this.z=u,this.C=y,this.D=E,this.F=T,this.f=new c.$je,this.onDidTokenFailed=this.f.event,this.g=new c.$je,this.onDidChangeTunnelStatus=this.g.event,this.h=new c.$je,this.onDidChangeMode=this.h.event,this.n=I.$zhc,this.w=!1,this.I=(F,U)=>{U?this.j.error(F):this.j.info(F)},this.j=this.B(C.createLogger((0,m.$dh)(y.logsHome,`${I.$Dhc}.log`),{id:I.$Dhc,name:I.$Ehc})),this.t=new f.$zh(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,O.$mk)(F)))),this.B(v.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(E.onDidChangeConfiguration(F=>{o.some(U=>F.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){n(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}J(){if(!this.u){let a;d.$k?a=this.C.appRoot:a=(0,k.$lc)((0,k.$lc)(this.C.appRoot)),this.u=(0,k.$ic)(a,"bin",`${this.z.tunnelApplicationName}${d.$j?".exe":""}`)}return this.u}async startTunnel(a){if(n(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(u){this.j.error(u)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(I.$zhc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(u){this.j.error(u)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(I.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",u=!1;const y=(U,j)=>{j?this.j.error(U):a+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(I.TunnelStates.connecting((0,p.localize)(11067,null)))},C=this.O("status",["status"],y);this.r=C;try{if(await C,this.r!==C)return;let U;try{U=JSON.parse(a.trim().split(`
`).find(j=>j.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(I.TunnelStates.disconnected());return}if(u=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(I.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(I.TunnelStates.disconnected());return}finally{this.r===C&&(this.r=void 0)}const v=this.n.active?this.n.session:void 0;if(v&&v.token){const U=v.token;this.G(I.TunnelStates.connecting((0,p.localize)(11068,null,v.accountLabel,v.providerId)));const j=(V,x)=>{V=V.replaceAll(U,"*".repeat(4)),y(V,x)},K=this.O("login",["user","login","--provider",v.providerId,"--log",(0,O.$mk)(this.j.getLevel())],j,{VSCODE_CLI_ACCESS_TOKEN:U});this.r=K;try{if(await K,this.r!==K)return}catch(V){this.j.error(V),this.r=void 0,this.f.fire(v),this.G(I.TunnelStates.disconnected(v));return}}const E=this.Q();E?this.G(I.TunnelStates.connecting((0,p.localize)(11069,null,E))):this.G(I.TunnelStates.connecting((0,p.localize)(11070,null)));const T=["--accept-server-license-terms","--log",(0,O.$mk)(this.j.getLevel())];E?T.push("--name",E):T.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!u&&(F=await this.M(T)===!1),this.N(v,T,F)}async M(a){let u;try{u=await this.O("serviceInstall",["service","install",...a])}catch(y){this.j.error(y),u=1}if(u!==0){const y=(0,p.localize)(11071,null);return this.j.warn(y),this.G(I.TunnelStates.connecting(y)),!1}return!0}async N(a,u,y){u.push("--parent-process-id",String(process.pid)),this.P()&&u.push("--no-sleep");let C=!1;const v=this.O("tunnel",u,(E,T)=>{T?this.j.error(E):this.j.info(E),E.includes("Connected to an existing tunnel process")&&(C=!0);const F=E.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const U={link:F[1],domain:F[2],tunnelName:F[4],isAttached:C};this.G(I.TunnelStates.connected(U,y))}else E.match(/error refreshing token/)&&(v.cancel(),this.f.fire(a),this.G(I.TunnelStates.disconnected(a)))});this.r=v,v.finally(()=>{v===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=I.$zhc,this.G(I.TunnelStates.disconnected()))})}O(a,u,y=this.I,C){return(0,f.$ph)(v=>new Promise((E,T)=>{v.isCancellationRequested&&E(-1);let F;const U=["ignore","pipe","pipe"];if(v.onCancellationRequested(()=>{F&&(this.j.info(`${a} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${a} Spawning: cargo run -- tunnel ${u.join(" ")}
`,!1),F=(0,b.spawn)("cargo",["run","--","tunnel",...u],{cwd:(0,k.$ic)(this.C.appRoot,"cli"),stdio:U,env:{...process.env,RUST_BACKTRACE:"1",...C}});else{y(`Running tunnel CLI
`,!1);const j=this.J();y(`${a} Spawning: ${j} tunnel ${u.join(" ")}
`,!1),F=(0,b.spawn)(j,["tunnel",...u],{cwd:(0,S.homedir)(),stdio:U,env:{...process.env,...C}})}F.stdout.pipe(new P.$vX(`
`)).on("data",j=>{if(F){const K=j.toString();y(K,!1)}}),F.stderr.pipe(new P.$vX(`
`)).on("data",j=>{if(F){const K=j.toString();y(K,!0)}}),F.on("exit",j=>{F&&(y(`${a} exit(${F.pid}): + ${j} `,!1),F=void 0,E(j||0))}),F.on("error",j=>{F&&(y(`${a} error(${F.pid}): + ${j} `,!0),F=void 0,T())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(I.$Chc)}Q(){let a=this.D.getValue(I.$Bhc)||(0,S.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(h,g.StorageScope.APPLICATION),u=this.F.getBoolean(i,g.StorageScope.APPLICATION,!1);if(a){const y=JSON.parse(a);if(y&&(0,w.$cg)(y.accountLabel)&&(0,w.$cg)(y.sessionId)&&(0,w.$cg)(y.providerId))return{active:!0,session:y,asService:u};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(a){this.j.error("Problems restoring session from storage",a)}return I.$zhc}S(a){if(a.active){const u={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(h,JSON.stringify(u),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),this.F.store(i,a.asService,g.StorageScope.APPLICATION,g.StorageTarget.MACHINE)}else this.F.remove(h,g.StorageScope.APPLICATION),this.F.remove(i,g.StorageScope.APPLICATION)}};e.$Ihc=s,e.$Ihc=s=ve([Q(0,L.$9l),Q(1,R.$qk),Q(2,A.$Ki),Q(3,O.$$j),Q(4,$.$Ghc),Q(5,l.$9i),Q(6,g.$fq)],s);function t(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const n=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&t(r.session,a.session):!0}),define(he[224],ue([0,1,6,2,22,20,70,16,79,19]),function(oe,e,I,c,L,A,N,O,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;class R extends O.$hq{constructor(f,$,l,p){super(),this.bb=f,this.cb=$,this.db=l,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new c.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new c.$Sc),this.ab=this.hb(this.bb)}fb(){const f=this.B(new k.$HMb(this.db.getChannel("storage"))),$=this.B(new N.$bq(f));return this.B($.onDidChangeStorage(l=>this.u(O.StorageScope.APPLICATION,l))),$}gb(f){this.X.clear(),this.W=f;let $;if((0,O.$iq)(f))$=this.U;else{const l=this.X.add(new k.$IMb(this.db.getChannel("storage"),f));$=this.X.add(new N.$bq(l))}return this.X.add($.onDidChangeStorage(l=>this.u(O.StorageScope.PROFILE,l))),$}hb(f){this.$.clear(),this.Z=f?.id;let $;if(f){const l=this.$.add(new k.$JMb(this.db.getChannel("storage"),f));$=this.$.add(new N.$bq(l)),this.$.add($.onDidChangeStorage(p=>this.u(O.StorageScope.WORKSPACE,p)))}return $}async O(){await I.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(f){switch(f){case O.StorageScope.APPLICATION:return this.U;case O.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(f){switch(f){case O.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case O.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$dh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(O.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(f){if(!this.M(this.W,f))return;const $=this.Y,l=$.items;$!==this.U&&await $.close(),this.Y=this.gb(f),await this.Y.init(),this.N(l,this.Y,O.StorageScope.PROFILE)}async S(f,$){const l=this.ab,p=l?.items??new Map;await l?.close(),this.ab=this.hb(f),await this.ab.init(),this.N(p,this.ab,O.StorageScope.WORKSPACE)}hasScope(f){return(0,b.$Il)(f)?this.W.id===f.id:this.Z===f.id}}e.$Nhc=R}),define(he[225],ue([0,1,3,2,19,94]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=e.$wR=void 0;class N{constructor(b,R){this.a=b,this.b=R}listen(b,R){const d=this.b(b);switch(R){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,f=>({all:f.all.map($=>(0,A.$Ln)({...$},d)),added:f.added.map($=>(0,A.$Ln)({...$},d)),removed:f.removed.map($=>(0,A.$Ln)({...$},d)),updated:f.updated.map($=>(0,A.$Ln)({...$},d))}))}throw new Error(`Invalid listen ${R}`)}async call(b,R,d){const f=this.b(b);switch(R){case"createProfile":{const $=await this.a.createProfile(d[0],d[1],d[2]);return(0,A.$Ln)({...$},f)}case"updateProfile":{let $=(0,L.$Kl)((0,A.$Mn)(d[0],f),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,d[1]),(0,A.$Ln)({...$},f)}case"removeProfile":{const $=(0,L.$Kl)((0,A.$Mn)(d[0],f),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${R}`)}}e.$wR=N;class O extends c.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,R,d){super(),this.profilesHome=R,this.f=d,this.a=[],this.b=this.B(new I.$je),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(f=>(0,L.$Kl)(f,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(f=>{const $=f.added.map(S=>(0,L.$Kl)(S,this.profilesHome.scheme)),l=f.removed.map(S=>(0,L.$Kl)(S,this.profilesHome.scheme)),p=f.updated.map(S=>(0,L.$Kl)(S,this.profilesHome.scheme));this.a=f.all.map(S=>(0,L.$Kl)(S,this.profilesHome.scheme)),this.b.fire({added:$,removed:l,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,R,d){const f=await this.f.call("createNamedProfile",[b,R,d]);return(0,L.$Kl)(f,this.profilesHome.scheme)}async createProfile(b,R,d,f){const $=await this.f.call("createProfile",[b,R,d,f]);return(0,L.$Kl)($,this.profilesHome.scheme)}async createTransientProfile(b){const R=await this.f.call("createTransientProfile",[b]);return(0,L.$Kl)(R,this.profilesHome.scheme)}async setProfileForWorkspace(b,R){await this.f.call("setProfileForWorkspace",[b,R])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,R){const d=await this.f.call("updateProfile",[b,R]);return(0,L.$Kl)(d,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$xR=O}),define(he[62],ue([0,1,2,70,4,16,3,79,19]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NMb=e.$MMb=e.$LMb=void 0,e.$LMb=(0,L.$Ci)("IUserDataProfileStorageService");let b=class extends I.$Tc{constructor($,l){super(),this.b=l,$&&(this.a=this.B(new I.$3c))}async readStorageData($){return this.withProfileScopedStorageService($,async l=>this.c(l))}async updateStorageData($,l,p){return this.withProfileScopedStorageService($,async S=>this.f(S,l,p))}async withProfileScopedStorageService($,l){if(this.b.hasScope($))return l(this.b);let p=this.a?.get($.id);if(!p){p=new d(this.g($)),this.a?.set($.id,p);try{await p.initialize()}catch(S){throw this.a?.has($.id)?this.a.deleteAndDispose($.id):p.dispose(),S}}try{const S=await l(p);return await p.flush(),S}finally{this.a?.has($.id)||p.dispose()}}c($){const l=new Map,p=S=>{for(const g of $.keys(A.StorageScope.PROFILE,S))l.set(g,{value:$.get(g,A.StorageScope.PROFILE),target:S})};return p(A.StorageTarget.USER),p(A.StorageTarget.MACHINE),l}f($,l,p){$.storeAll(Array.from(l.entries()).map(([S,g])=>({key:S,value:g,scope:A.StorageScope.PROFILE,target:p})),!0)}};e.$MMb=b,e.$MMb=b=ve([Q(1,A.$fq)],b);class R extends b{constructor($,l,p,S,g){super($,S),this.j=l;const w=l.getChannel("profileStorageListener"),P=this.B(new I.$Uc);this.h=this.B(new N.$je({onWillAddFirstListener:()=>{P.value=w.listen("onDidChange")(m=>{g.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(o=>(0,k.$Kl)(o,p.profilesHome.scheme)),valueChanges:m.valueChanges.map(o=>({...o,profile:(0,k.$Kl)(o.profile,p.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>P.value=void 0})),this.onDidChange=this.h.event}async g($){const l=this.j.getChannel("storage");return(0,A.$iq)($)?new O.$HMb(l):new O.$IMb(l,$)}}e.$NMb=R;class d extends A.$hq{constructor($){super({flushInterval:100}),this.U=$}async O(){const $=await this.U,l=new c.$bq($);return this.B(l.onDidChangeStorage(p=>{this.u(A.StorageScope.PROFILE,p)})),this.B((0,I.$Rc)(()=>{l.close(),l.dispose(),(0,I.$Nc)($)&&$.dispose()})),this.s=l,this.s.init()}P($){return $===A.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(he[226],ue([0,1,16,10,19,56,62]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;let O=class extends N.$NMb{constructor(b,R,d,f){super(!0,b,R,d,f)}};e.$shc=O,e.$shc=O=ve([Q(0,A.$Zgc),Q(1,L.$Jl),Q(2,I.$fq),Q(3,c.$0j)],O)}),define(he[40],ue([0,1,17,6,14,25,3,35,2,26,12,11,21,15,7,10,49,16,18,28,24,19]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UNb=e.$TNb=e.$SNb=e.$RNb=void 0,e.$ONb=h,e.$PNb=i,e.$QNb=s;function h(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||i(u.syncData)))}function i(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}function s(u,y){return`${(0,b.$7f)(u)}${y.isDefault?"":` (${y.name})`}`}let t=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,C,v,E,T,F,U,j,K,V,x,H){super(),this.syncResource=y,this.collection=C,this.G=v,this.H=E,this.I=T,this.J=F,this.L=U,this.M=j,this.N=K,this.O=V,this.P=x,this.c=null,this.m=m.SyncStatus.Idle,this.n=this.B(new N.$je),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new N.$je),this.onDidChangeConflicts=this.t.event,this.u=this.B(new c.$Ah(50)),this.w=this.B(new N.$je),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=s(y.syncResource,y.profile),this.h=H.extUri,this.f=this.h.joinPath(E.userDataSyncHome,...(0,m.$onb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,m.$Jnb),this.y=(0,m.$pnb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,E,this.h),this.j=(0,S.$lq)(E,v,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===m.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const C=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(C)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,C={}){await this.U(y,!0,this.ob(),C)}async preview(y,C,v={}){return this.U(y,!1,C,v)}async apply(y,C={}){try{this.F={...C};const v=await this.ab(y);return this.S(v),this.c}finally{this.F={}}}async U(y,C,v,E){try{if(this.F={...E},this.status===m.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===m.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(m.SyncStatus.Syncing);let T=m.SyncStatus.Idle;try{const F=await this.getLastSyncUserData(),U=await this.X(y,F);return T=await this.Y(U,F,C,v),T===m.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T===m.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(y){const C=this.kb(y);if(!C)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(m.SyncStatus.Syncing);const v=await this.getLastSyncUserData(),E=await this.X(null,v),T=await this.W(E),F=await this.qb({ref:E.ref,syncData:C},v,T,this.ob(),A.CancellationToken.None),U=[];for(const j of F){const K=await this.sb(j,j.remoteResource,void 0,A.CancellationToken.None),{remoteChange:V}=await this.sb(j,j.previewResource,j.remoteContent,A.CancellationToken.None);U.push([j,{...K,remoteChange:V!==m.Change.None?V:m.Change.Modified}])}await this.tb(E,v,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(m.SyncStatus.Idle)}return!0}async W(y){const C=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===C}async X(y,C){if(C){const v=y?y[this.resource]:void 0;if(C.ref===v||v===void 0&&C.syncData===null)return C}return this.getRemoteUserData(C)}async Y(y,C,v,E){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$wnb((0,d.localize)(10909,null,this.resource,this.pb,y.syncData.version),m.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(y,C,v,E)}catch(T){if(T instanceof m.$wnb)switch(T.code){case m.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,C,v,E);case m.UserDataSyncErrorCode.Conflict:case m.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),C=await this.getLastSyncUserData(),this.Y(y,C,v,E)}throw T}}async Z(y,C,v,E){try{const T=await this.W(y),F=!T&&C===null&&this.gb()!==void 0,U=v&&!F;this.c||(this.c=(0,c.$ph)(K=>this.eb(y,C,T,U,E,K)));let j=await this.c;if(v&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const K of j.resourcePreviews)j=await this.accept(K.remoteResource)||j}return this.cb(j.resourcePreviews),j.resourcePreviews.some(({mergeState:K})=>K===m.MergeState.Conflict)?m.SyncStatus.HasConflicts:v?await this.ab(!1):m.SyncStatus.Syncing}catch(T){throw this.c=null,T}}async merge(y){return await this.$(y,async C=>{const v=await this.rb(C,A.CancellationToken.None);await this.G.writeFile(C.previewResource,L.$Le.fromString(v?.content||""));const E=v&&!v.hasConflicts?await this.sb(C,C.previewResource,void 0,A.CancellationToken.None):void 0;return C.acceptResult=E,C.mergeState=v.hasConflicts?m.MergeState.Conflict:E?m.MergeState.Accepted:m.MergeState.Preview,C.localChange=E?E.localChange:v.localChange,C.remoteChange=E?E.remoteChange:v.remoteChange,C}),this.c}async accept(y,C){return await this.$(y,async v=>{const E=await this.sb(v,y,C,A.CancellationToken.None);return v.acceptResult=E,v.mergeState=m.MergeState.Accepted,v.localChange=E.localChange,v.remoteChange=E.remoteChange,v}),this.c}async discard(y){return await this.$(y,async C=>{const v=await this.rb(C,A.CancellationToken.None);return await this.G.writeFile(C.previewResource,L.$Le.fromString(v.content||"")),C.acceptResult=void 0,C.mergeState=m.MergeState.Preview,C.localChange=v.localChange,C.remoteChange=v.remoteChange,C}),this.c}async $(y,C){if(!this.c)return;let v=await this.c;const E=v.resourcePreviews.findIndex(({localResource:T,remoteResource:F,previewResource:U})=>this.h.isEqual(T,y)||this.h.isEqual(F,y)||this.h.isEqual(U,y));E!==-1&&(this.c=(0,c.$ph)(async T=>{const F=[...v.resourcePreviews];return F[E]=await C(F[E]),{...v,resourcePreviews:F}}),v=await this.c,this.cb(v.resourcePreviews),v.resourcePreviews.some(({mergeState:T})=>T===m.MergeState.Conflict)?this.S(m.SyncStatus.HasConflicts):this.S(m.SyncStatus.Syncing))}async ab(y){if(!this.c)return m.SyncStatus.Idle;const C=await this.c;return C.resourcePreviews.some(({mergeState:v})=>v===m.MergeState.Conflict)?m.SyncStatus.HasConflicts:C.resourcePreviews.some(({mergeState:v})=>v!==m.MergeState.Accepted)?m.SyncStatus.Syncing:(await this.tb(C.remoteUserData,C.lastSyncUserData,C.resourcePreviews.map(v=>[v,v.acceptResult]),y),this.c=null,await this.bb(),m.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const C=y.filter(({mergeState:v})=>v===m.MergeState.Conflict);(0,I.$tb)(this.s,C,(v,E)=>this.h.isEqual(v.previewResource,E.previewResource))||(this.s=C,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const C=this.c?await this.c:null;if(C)for(const v of C.resourcePreviews){if(this.h.isEqual(v.acceptedResource,y))return v.acceptResult?v.acceptResult.content:null;if(this.h.isEqual(v.remoteResource,y))return v.remoteContent;if(this.h.isEqual(v.localResource,y))return v.localContent;if(this.h.isEqual(v.baseResource,y))return v.baseContent}return null}async resetLocal(){this.I.remove(this.z,g.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(y){(0,l.$ol)(y)!==l.FileOperationResult.FILE_NOT_FOUND&&this.O.error(y)}}async eb(y,C,v,E,T,F){const U=await this.qb(y,C,v,T,F),j=[];for(const K of U){const V=K.previewResource.with({scheme:m.$Inb,authority:"accepted"});if(K.localChange===m.Change.None&&K.remoteChange===m.Change.None)j.push({...K,acceptedResource:V,acceptResult:{content:null,localChange:m.Change.None,remoteChange:m.Change.None},mergeState:m.MergeState.Accepted});else{const x=E?await this.rb(K,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(K.previewResource,L.$Le.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(K,K.previewResource,void 0,F):void 0;j.push({...K,acceptResult:H,mergeState:x?.hasConflicts?m.MergeState.Conflict:H?m.MergeState.Accepted:m.MergeState.Preview,localChange:H?H.localChange:x?x.localChange:K.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:K.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:C,resourcePreviews:j,isLastSyncFromCurrentMachine:v}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const C=JSON.parse(y),v=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!C.version&&!!v&&C.version!==v,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${C.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;let E,T=1;for(;E===void 0&&T++<6;)try{const F=await this.hb();F&&(F.ref===C.ref?E=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof l.$sl&&F.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof m.$wnb)throw F;this.O.error(F,T)}}if(E===void 0)try{const F=await this.J.resolveResourceContent(this.resource,C.ref,this.collection,this.F);E=F===null?null:this.kb(F),await this.ib({ref:C.ref,syncData:E})}catch(F){if(F instanceof m.$wnb&&F.code===m.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return E===void 0?null:{...C,syncData:E}}async fb(y,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const v=this.M.getResourceSyncStateVersion(this.resource),E={ref:y.ref,version:v,...C};this.I.store(this.z,JSON.stringify(E),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.ib(y)}gb(){return this.I.get(this.z,g.StorageScope.APPLICATION)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const C=y?JSON.parse(y):void 0;if(h(C))return C}catch(C){this.O.error(C)}}async ib(y){await this.G.writeFile(this.y,L.$Le.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),C=JSON.parse(y.value.toString());await this.G.del(this.y),C.ref&&C.content!==void 0?(this.I.store(this.z,JSON.stringify({...C,content:void 0}),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.ib({ref:C.ref,syncData:C.content===null?null:JSON.parse(C.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,C)}catch(y){y instanceof l.$sl&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,g.StorageScope.APPLICATION)}async getRemoteUserData(y){const{ref:C,content:v}=await this.lb(y);let E=null;return v!==null&&(E=this.kb(v)),{ref:C,syncData:E}}kb(y){try{const C=JSON.parse(y);if(i(C))return C}catch(C){this.O.error(C)}throw new m.$wnb((0,d.localize)(10910,null),m.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(y){const C=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,C,this.collection,this.F)}async mb(y,C){const v=await this.j,E={version:this.pb,machineId:v,content:y};try{return C=await this.J.writeResource(this.resource,JSON.stringify(E),C,this.collection,this.F),{ref:C,syncData:E}}catch(T){throw T instanceof m.$wnb&&T.code===m.UserDataSyncErrorCode.TooLarge&&(T=new m.$wnb(T.message,T.code,this.resource)),T}}async nb(y){const C={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(C),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==m.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(m.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$jnb)}};e.$RNb=t,e.$RNb=t=ve([Q(2,l.$0k),Q(3,$.$Ji),Q(4,g.$fq),Q(5,m.$rnb),Q(6,m.$snb),Q(7,m.$Bnb),Q(8,w.$9l),Q(9,m.$Gnb),Q(10,f.$9i),Q(11,P.$Hl)],t);let n=class extends t{constructor(y,C,v,E,T,F,U,j,K,V,x,H,ie){super(C,v,E,T,F,U,j,K,V,x,H,ie),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(W=>this.yb(W)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,C,v){try{C?await this.G.writeFile(this.r,L.$Le.fromString(y),v?void 0:C):await this.G.createFile(this.r,L.$Le.fromString(y),{overwrite:v})}catch(E){throw E instanceof l.$sl&&E.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND||E instanceof l.$sl&&E.fileOperationResult===l.FileOperationResult.FILE_MODIFIED_SINCE?new m.$wnb(E.message,m.UserDataSyncErrorCode.LocalPreconditionFailed):E}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof l.$sl&&y.fileOperationResult===l.FileOperationResult.FILE_NOT_FOUND))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$SNb=n,e.$SNb=n=ve([Q(3,l.$0k),Q(4,$.$Ji),Q(5,g.$fq),Q(6,m.$rnb),Q(7,m.$snb),Q(8,m.$Bnb),Q(9,w.$9l),Q(10,m.$Gnb),Q(11,f.$9i),Q(12,P.$Hl)],n);let r=class extends n{constructor(y,C,v,E,T,F,U,j,K,V,x,H,ie,W){super(y,C,v,E,T,F,U,j,K,V,x,ie,W),this.zb=H,this.Bb=void 0}Ab(y,C){const v=[],E=(0,O.$Vn)(y,v,{allowEmptyContent:!0,allowTrailingComma:!0});return v.length>0||!(0,R.$jg)(E)&&C!==Array.isArray(E)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$TNb=r,e.$TNb=r=ve([Q(3,l.$0k),Q(4,$.$Ji),Q(5,g.$fq),Q(6,m.$rnb),Q(7,m.$snb),Q(8,m.$Bnb),Q(9,w.$9l),Q(10,m.$Gnb),Q(11,m.$Fnb),Q(12,f.$9i),Q(13,P.$Hl)],r);let a=class{constructor(y,C,v,E,T,F,U){this.resource=y,this.g=C,this.h=v,this.j=E,this.k=T,this.l=F,this.d=U.extUri,this.f=(0,m.$pnb)(void 0,this.resource,v,this.d)}async initialize({ref:y,content:C}){if(!C){this.j.info("Remote content does not exist.",this.resource);return}const v=this.m(C);if(v)try{await this.o({ref:y,syncData:v})}catch(E){this.j.error(E)}}m(y){try{const C=JSON.parse(y);if(i(C))return C}catch(C){this.j.error(C)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const v={ref:y.ref,version:void 0,...C};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(v),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE),await this.k.writeFile(this.f,L.$Le.fromString(JSON.stringify(y)))}};e.$UNb=a,e.$UNb=a=ve([Q(1,o.$Jl),Q(2,$.$Ji),Q(3,p.$0j),Q(4,l.$0k),Q(5,g.$fq),Q(6,P.$Hl)],a)}),define(he[119],ue([0,1,6,25,8,3,45,2,26,21,15,118,27,34,85,33,7,4,76,10,16,18,28,19,40,205,114,24,62]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o,h,i,s,t,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=e.$5bc=void 0,e.$3bc=y,e.$4bc=C;async function u(F,U){const j=JSON.parse(F.content);if(F.version===1||F.version===2){const K=(await U.getInstalled(p.ExtensionType.System)).filter(V=>V.isBuiltin);for(const V of j)F.version===1&&(V.enabled===!1&&(V.disabled=!0),delete V.enabled),F.version===2&&K.every(x=>!(0,$.$Jp)(x.identifier,V.identifier))&&(V.installed=!0)}return j}function y(F){return JSON.parse(F.content)}function C(F,U){return F.sort((j,K)=>!j.identifier.uuid&&K.identifier.uuid?-1:j.identifier.uuid&&!K.identifier.uuid?1:(0,k.$wf)(j.identifier.id,K.identifier.id)),U?(0,N.$6n)(F,{}):JSON.stringify(F)}let v=class extends s.$RNb{constructor(U,j,K,V,x,H,ie,W,z,_,ne,ce,te,Y,G,B,D){super({syncResource:r.SyncResource.Extensions,profile:U},j,V,K,x,H,ie,ce,te,_,ne,G),this.Cb=W,this.Db=z,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Inb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Inb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Inb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Inb,authority:"accepted"}),this.Bb=this.Eb.createInstance(E),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,J=>J.some(({local:q})=>!!q)),A.Event.filter(this.Cb.onDidUninstallExtension,J=>!J.error),A.Event.filter(B.onDidChange,J=>J.valueChanges.some(({profile:q,changes:M})=>this.syncResource.profile.id===q.id&&M.some(Z=>Z.key===f.$mp))),Y.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,j){const K=U.syncData?await u(U.syncData,this.Cb):null,V=j?.skippedExtensions??[],x=j?.builtinExtensions??null,H=j?.syncData?await u(j.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile);K?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:_}=(0,t.$2bc)(ie,K,H,V,W,x),ne={local:z,remote:_,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:_!==null?r.Change.Modified:r.Change.None},ce=this.Ob(ie,!1);return[{skippedExtensions:V,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):ce,localResource:this.yb,localContent:ce,localExtensions:ie,remoteResource:this.zb,remoteExtensions:K,remoteContent:K?this.Ob(K,!1):null,previewResource:this.wb,previewResult:ne,localChange:ne.localChange,remoteChange:ne.remoteChange,acceptedResource:this.Ab}]}async ub(U){const j=U.syncData?await u(U.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,t.$2bc)(K,j,j,U.skippedExtensions||[],V,U.builtinExtensions||[]);return x!==null}Hb(U,j,K,V){const x=[...j,...K],H=new Set,ie=W=>{H.add(W.id.toLowerCase()),W.uuid&&H.add(W.uuid)};x.forEach(({identifier:W})=>ie(W)),V.forEach(ie);for(const W of U)H.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&H.has(W.identifier.uuid)||x.push(W);return this.Ob(x,!1)}async rb(U,j){return{...U.previewResult,hasConflicts:!1}}async sb(U,j,K,V){if(this.h.isEqual(j,this.yb))return this.Kb(U);if(this.h.isEqual(j,this.zb))return this.Lb(U);if(this.h.isEqual(j,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async Kb(U){const j=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(j),V=(0,t.$2bc)(U.localExtensions,null,null,U.skippedExtensions,K,U.builtinExtensions),{local:x,remote:H}=V;return{content:U.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:H!==null?r.Change.Modified:r.Change.None}}async Lb(U){const j=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(j),V=U.remoteContent?JSON.parse(U.remoteContent):null;if(V!==null){const x=(0,t.$2bc)(U.localExtensions,V,U.localExtensions,[],K,U.builtinExtensions),{local:H,remote:ie}=x;return{content:U.remoteContent,local:H,remote:ie,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?r.Change.Modified:r.Change.None,remoteChange:ie!==null?r.Change.Modified:r.Change.None}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:r.Change.None,remoteChange:r.Change.None}}async tb(U,j,K,V){let{skippedExtensions:x,builtinExtensions:H,localExtensions:ie}=K[0][0];const{local:W,remote:z,localChange:_,remoteChange:ne}=K[0][1];if(_===r.Change.None&&ne===r.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),_!==r.Change.None&&(await this.nb(JSON.stringify(ie)),x=await this.Bb.updateLocalExtensions(W.added,W.removed,W.updated,x,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const ce=JSON.stringify(z.all);U=await this.mb(ce,V?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(te=>te.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(te=>te.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(te=>te.identifier.id))}.`:""}`)}j?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(ie,H),await this.fb(U,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ce=>ce.identifier.id))}.`:""}`))}Nb(U,j){const K=new Set,V=[];for(const x of U)K.add(x.identifier.id.toLowerCase()),x.installed||V.push(x.identifier);if(j)for(const x of j)K.has(x.id.toLowerCase())||V.push(x);return V}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const j=await this.db(U);return j&&this.Ob(JSON.parse(j),!0)}return null}Ob(U,j){return C(U,j)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(j=>j.installed||j.disabled))return!0}catch{}return!1}};e.$5bc=v,e.$5bc=v=ve([Q(2,R.$Ji),Q(3,S.$0k),Q(4,m.$fq),Q(5,r.$rnb),Q(6,r.$snb),Q(7,f.$lp),Q(8,n.$DOb),Q(9,r.$Gnb),Q(10,b.$9i),Q(11,r.$Bnb),Q(12,o.$9l),Q(13,l.$nw),Q(14,h.$Hl),Q(15,a.$LMb),Q(16,g.$Bi)],v);let E=class{constructor(U,j,K,V,x,H){this.a=U,this.b=j,this.c=K,this.d=V,this.f=x,this.g=H}async getLocalExtensions(U){const j=await this.a.getInstalled(void 0,U.extensionsResource),K=this.d.getIgnoredExtensions(j);return{localExtensions:await this.j(U,async(x,H)=>{const ie=x.getDisabledExtensions();return j.map(W=>{const{identifier:z,isBuiltin:_,manifest:ne,preRelease:ce,pinned:te,isApplicationScoped:Y}=W,G={identifier:z,preRelease:ce,version:ne.version,pinned:!!te};Y&&!(0,p.$rn)(ne)&&(G.isApplicationScoped=Y),ie.some(B=>(0,$.$Jp)(B,z))&&(G.disabled=!0),_||(G.installed=!0);try{const B=H.getKeysForSync({id:z.id,version:ne.version});if(B){const D=H.getExtensionState(W,!0)||{};G.state=Object.keys(D).reduce((J,q)=>(B.includes(q)&&(J[q]=D[q]),J),{})}}catch(B){this.g.info(`${(0,s.$QNb)(r.SyncResource.Extensions,U)}: Error while parsing extension state`,(0,L.$9)(B))}return G})}),ignoredExtensions:K}}async updateLocalExtensions(U,j,K,V,x){const H=(0,s.$QNb)(r.SyncResource.Extensions,x),ie=[],W=new Map,z=[],_=[],ne=await this.a.getInstalled(void 0,x.extensionsResource);if((U.length||K.length)&&await this.j(x,async(Y,G)=>{await I.Promises.settled([...U,...K].map(async B=>{const D=ne.find(M=>(0,$.$Jp)(M.identifier,B.identifier));if(D&&D.isBuiltin){B.state&&D.manifest.version===B.version&&this.h(B.state,D,D.manifest.version,G),Y.getDisabledExtensions().some(Z=>(0,$.$Jp)(Z,B.identifier))!==!!B.disabled&&(B.disabled?(this.g.trace(`${H}: Disabling extension...`,B.identifier.id),await Y.disableExtension(B.identifier),this.g.info(`${H}: Disabled extension`,B.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,B.identifier.id),await Y.enableExtension(B.identifier),this.g.info(`${H}: Enabled extension`,B.identifier.id))),z.push(B.identifier);return}const J=B.pinned?B.version:void 0,q=(await this.c.getExtensions([{...B.identifier,version:J,preRelease:J?void 0:B.preRelease}],c.CancellationToken.None))[0];if(B.state&&(D?D.manifest.version===B.version:q)&&this.h(B.state,D||q,D?.manifest.version,G),q)try{Y.getDisabledExtensions().some(Z=>(0,$.$Jp)(Z,B.identifier))!==!!B.disabled&&(B.disabled?(this.g.trace(`${H}: Disabling extension...`,B.identifier.id,q.version),await Y.disableExtension(q.identifier),this.g.info(`${H}: Disabled extension`,B.identifier.id,q.version)):(this.g.trace(`${H}: Enabling extension...`,B.identifier.id,q.version),await Y.enableExtension(q.identifier),this.g.info(`${H}: Enabled extension`,B.identifier.id,q.version))),(!D||D.preRelease!==B.preRelease||D.pinned!==B.pinned||J&&D.manifest.version!==J)&&(await this.a.canInstall(q)?(ie.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:B.pinned&&!!B.version,pinned:B.pinned,installPreReleaseVersion:B.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:B.isApplicationScoped,context:{[f.$$o]:!0,[f.$_o]:f.ExtensionInstallSource.SETTINGS_SYNC}}}),W.set(q.identifier.id.toLowerCase(),B)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),_.push(B)))}catch(M){_.push(B),this.g.error(M),this.g.info(`${H}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else _.push(B),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,B.identifier.id)}))}),j.length){const Y=ne.filter(({identifier:G,isBuiltin:B})=>!B&&j.some(D=>(0,$.$Jp)(G,D)));await I.Promises.settled(Y.map(async G=>{this.g.trace(`${H}: Uninstalling local extension...`,G.identifier.id),await this.a.uninstall(G,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,G.identifier.id),z.push(G.identifier)}))}const ce=await this.a.installGalleryExtensions(ie);for(const{identifier:Y,local:G,error:B,source:D}of ce){const J=D;if(G)this.g.info(`${H}: Installed extension.`,Y.id,J.version),z.push(Y);else{const q=W.get(Y.id.toLowerCase());q&&(_.push(q),this.g.info(`${H}: Skipped synchronizing extension`,J.displayName||J.identifier.id)),B instanceof f.$kp&&[f.ExtensionManagementErrorCode.Incompatible,f.ExtensionManagementErrorCode.IncompatibleApi,f.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(B.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,J.displayName||J.identifier.id):B&&this.g.error(B)}}const te=[];for(const Y of V)z.some(G=>(0,$.$Jp)(G,Y.identifier))||te.push(Y);for(const Y of _)te.some(G=>(0,$.$Jp)(G.identifier,Y.identifier))||te.push(Y);return te}h(U,j,K,V){const x=V.getExtensionState(j,!0)||{},H=K?V.getKeysForSync({id:j.identifier.id,version:K}):void 0;H?H.forEach(ie=>{x[ie]=U[ie]}):Object.keys(U).forEach(ie=>x[ie]=U[ie]),V.setExtensionState(j,x,!0)}async j(U,j){return this.b.withProfileScopedStorageService(U,async K=>{const V=new O.$Sc,x=V.add(this.f.createChild(new w.$Ai([m.$fq,K]))),H=V.add(x.createInstance(d.$0Lb)),ie=V.add(x.createInstance(l.$ow));try{return await j(H,ie)}finally{V.dispose()}})}};e.$6bc=E,e.$6bc=E=ve([Q(0,f.$lp),Q(1,a.$LMb),Q(2,f.$ip),Q(3,n.$DOb),Q(4,g.$Bi),Q(5,r.$Gnb)],E);let T=class extends s.$UNb{constructor(U,j,K,V,x,H,ie,W){super(r.SyncResource.Extensions,V,x,H,K,ie,W),this.p=U,this.q=j}async t(U){return U.syncData?await u(U.syncData,this.p):null}u(U,j){const K=[],V=[],x=[];for(const H of U){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const ie=j.find(W=>(0,$.$Jp)(W.identifier,H.identifier));ie?(K.push(ie),H.disabled&&x.push(H.identifier)):H.installed&&(V.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:K,newExtensions:V,disabledExtensions:x,remoteExtensions:U}}};e.$7bc=T,e.$7bc=T=ve([Q(0,f.$lp),Q(1,n.$DOb),Q(2,S.$0k),Q(3,i.$Jl),Q(4,R.$Ji),Q(5,P.$0j),Q(6,m.$fq),Q(7,h.$Hl)],T)}),define(he[120],ue([0,1,14,8,3,35,45,5,31,21,15,7,10,49,16,18,28,40,81,209,24,19,62,4]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o,h,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Nb=e.$ZNb=e.$YNb=e.$XNb=void 0,e.$WNb=n;const s="globalState.argv.",t=["locale"];function n(v,E){const T=v.storage?Object.keys(v.storage).sort():[],F={};return T.forEach(U=>F[U]=v.storage[U]),v.storage=F,E?(0,N.$6n)(v,{}):JSON.stringify(v)}const r=1;let a=class extends g.$RNb{constructor(E,T,F,U,j,K,V,x,H,ie,W,z,_,ne){super({syncResource:m.SyncResource.GlobalState,profile:E},T,U,x,z,j,K,H,ie,V,W,_),this.Bb=F,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$Inb,authority:"base"}),this.xb=this.vb.with({scheme:m.$Inb,authority:"local"}),this.yb=this.vb.with({scheme:m.$Inb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$Inb,authority:"accepted"}),this.Ab=ne.createInstance(u),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(U.onDidFilesChange,ce=>ce.contains(this.H.argvResource)),L.Event.filter(F.onDidChange,ce=>!!(ce.targetChanges.some(te=>this.syncResource.profile.id===te.id)||ce.valueChanges.some(({profile:te,changes:Y})=>this.syncResource.profile.id===te.id&&Y.some(G=>G.target===l.StorageTarget.USER)))))(()=>this.Q()))}async qb(E,T,F){const U=E.syncData?JSON.parse(E.syncData.content):null;T=T===null&&F?E:T;const j=T&&T.syncData?JSON.parse(T.syncData.content):null,K=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=await this.Jb(j),{local:x,remote:H}=(0,P.$VNb)(K.storage,U?U.storage:null,j?j.storage:null,V,this.O),ie={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?m.Change.Modified:m.Change.None,remoteChange:H.all!==null?m.Change.Modified:m.Change.None},W=n(K,!1);return[{baseResource:this.wb,baseContent:j?n(j,!1):W,localResource:this.xb,localContent:W,localUserData:K,remoteResource:this.yb,remoteContent:U?n(U,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:V}]}async ub(E){const T=E.syncData?JSON.parse(E.syncData.content):null;if(T===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(T),{remote:j}=(0,P.$VNb)(F.storage,T.storage,T.storage,U,this.O);return j.all!==null}async rb(E,T){return{...E.previewResult,hasConflicts:!1}}async sb(E,T,F,U){if(this.h.isEqual(T,this.xb))return this.Gb(E);if(this.h.isEqual(T,this.yb))return this.Hb(E);if(this.h.isEqual(T,this.vb))return E.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(E){return{content:E.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(E.localUserData.storage),removed:[],updated:[],all:E.localUserData.storage},localChange:m.Change.None,remoteChange:m.Change.Modified}}async Hb(E){if(E.remoteContent!==null){const T=JSON.parse(E.remoteContent),{local:F,remote:U}=(0,P.$VNb)(E.localUserData.storage,T.storage,null,E.storageKeys,this.O);return{content:E.remoteContent,local:F,remote:U,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?m.Change.Modified:m.Change.None,remoteChange:U!==null?m.Change.Modified:m.Change.None}}else return{content:E.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:m.Change.None,remoteChange:m.Change.None}}async tb(E,T,F,U){const{localUserData:j}=F[0][0],{local:K,remote:V,localChange:x,remoteChange:H}=F[0][1];if(x===m.Change.None&&H===m.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==m.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(j)),await this.Ab.writeLocalGlobalState(K,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==m.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:V.all});E=await this.mb(ie,U?null:E.ref),this.O.info(`${this.D}: Updated remote ui state.${V.added.length?` Added: ${V.added}.`:""}${V.updated.length?` Updated: ${V.updated}.`:""}${V.removed.length?` Removed: ${V.removed}.`:""}`)}T?.ref!==E.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(E),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(E){if(this.h.isEqual(this.yb,E)||this.h.isEqual(this.wb,E)||this.h.isEqual(this.xb,E)||this.h.isEqual(this.zb,E)){const T=await this.db(E);return T&&n(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:E}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(E).length>1||E[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(E){const T=await this.Bb.readStorageData(this.syncResource.profile),F=[],U=[];for(const[V,x]of T)x.target===l.StorageTarget.USER?F.push(V):x.target===l.StorageTarget.MACHINE&&U.push(V);const j=[...F,...U],K=E?.storage?Object.keys(E.storage).filter(V=>!V.startsWith(s)&&!j.includes(V)&&T.get(V)!==void 0):[];if(!O.$p){const V=[...m.$nnb.map(x=>(0,m.$Anb)(x)),m.$znb];K.push(...V),U.push(...V)}return{user:F,machine:U,unregistered:K}}};e.$XNb=a,e.$XNb=a=ve([Q(2,h.$LMb),Q(3,d.$0k),Q(4,m.$rnb),Q(5,m.$snb),Q(6,m.$Gnb),Q(7,R.$Ji),Q(8,m.$Bnb),Q(9,p.$9l),Q(10,b.$9i),Q(11,l.$fq),Q(12,S.$Hl),Q(13,i.$Bi)],a);let u=class{constructor(E,T,F,U){this.a=E,this.b=T,this.c=F,this.d=U}async getLocalGlobalState(E){const T={};if(E.isDefault){const U=await this.f(),j=(0,A.$Vn)(U);for(const K of t)j[K]!==void 0&&(T[`${s}${K}`]={version:1,value:j[K]})}const F=await this.c.readStorageData(E);for(const[U,j]of F)j.value&&j.target===l.StorageTarget.USER&&(T[U]={version:1,value:j.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const E=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),E.value.toString()}catch(E){this.d.debug((0,c.$9)(E))}return"{}"}async writeLocalGlobalState({added:E,removed:T,updated:F},U){const j=(0,g.$QNb)(m.SyncResource.GlobalState,U),K={},V=new Map,x=await this.c.readStorageData(U),H=(ie,W)=>{for(const z of ie){if(z.startsWith(s)){K[z.substring(s.length)]=W?W[z].value:void 0;continue}if(W){const _=W[z];_.value!==x.get(z)?.value&&V.set(z,_.value)}else x.get(z)!==void 0&&V.set(z,void 0)}};if(H(Object.keys(E),E),H(Object.keys(F),F),H(T),Object.keys(K).length){this.d.trace(`${j}: Updating locale...`);const ie=await this.f();let W=ie;for(const z of Object.keys(K))W=(0,w.edit)(W,[z],K[z],{});ie!==W&&(this.d.trace(`${j}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$Le.fromString(W)),this.d.info(`${j}: Updated locale.`)),this.d.info(`${j}: Updated locale`)}V.size&&(this.d.trace(`${j}: Updating global state...`),await this.c.updateStorageData(U,V,l.StorageTarget.USER),this.d.info(`${j}: Updated global state`,[...V.keys()]))}};e.$YNb=u,e.$YNb=u=ve([Q(0,d.$0k),Q(1,R.$Ji),Q(2,h.$LMb),Q(3,m.$Gnb)],u);let y=class extends g.$UNb{constructor(E,T,F,U,j,K){super(m.SyncResource.GlobalState,F,U,j,T,E,K)}async o(E){const T=E.syncData?JSON.parse(E.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},U={};for(const j of Object.keys(T.storage))j.startsWith(s)?F[j.substring(s.length)]=T.storage[j].value:this.l.get(j,l.StorageScope.PROFILE)===void 0&&(U[j]=T.storage[j].value);if(Object.keys(F).length){let j="{}";try{j=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const K of Object.keys(F))j=(0,w.edit)(j,[K],F[K],{});await this.k.writeFile(this.h.argvResource,I.$Le.fromString(j))}if(Object.keys(U).length){const j=[];for(const K of Object.keys(U))j.push({key:K,value:U[K],scope:l.StorageScope.PROFILE,target:l.StorageTarget.USER});this.l.storeAll(j,!0)}}};e.$ZNb=y,e.$ZNb=y=ve([Q(0,l.$fq),Q(1,d.$0k),Q(2,o.$Jl),Q(3,R.$Ji),Q(4,m.$Gnb),Q(5,S.$Hl)],y);let C=class{constructor(E,T,F,U,j){this.a=E,this.b=T,this.c=F,this.d=U,this.f=j}getSyncStoreType(E){return this.h(E)?.storage[m.$znb]?.value}async sync(E){const T=(0,m.$vnb)((0,k.$Yg)());try{return await this.g(E,T)}catch(F){if(F instanceof m.$wnb)switch(F.code){case m.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(E,T)}throw F}}async g(E,T){const F=await this.a.readResource(m.SyncResource.GlobalState,null,void 0,T),U=this.h(F)||{storage:{}};U.storage[m.$znb]={value:E,version:r};const j=await(0,$.$lq)(this.c,this.d,this.b),K={version:r,machineId:j,content:n(U,!1)};await this.a.writeResource(m.SyncResource.GlobalState,JSON.stringify(K),F.ref,void 0,T)}h({content:E}){if(!E)return null;const T=JSON.parse(E);if((0,g.$PNb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$1Nb=C,e.$1Nb=C=ve([Q(1,l.$fq),Q(2,R.$Ji),Q(3,d.$0k),Q(4,f.$0j)],C)}),define(he[121],ue([0,1,17,14,3,35,5,12,11,21,15,7,16,18,28,19,40,206,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0,e.$9bc=P;function P(h,i,s){try{const t=JSON.parse(h);if(!i)return(0,O.$jg)(t.all)?null:t.all;switch(N.OS){case N.OperatingSystem.Macintosh:return(0,O.$jg)(t.mac)?null:t.mac;case N.OperatingSystem.Linux:return(0,O.$jg)(t.linux)?null:t.linux;case N.OperatingSystem.Windows:return(0,O.$jg)(t.windows)?null:t.windows}}catch(t){return s.error(t),null}}let m=class extends S.$TNb{constructor(i,s,t,n,r,a,u,y,C,v,E,T,F){super(i.keybindingsResource,{syncResource:w.SyncResource.Keybindings,profile:i},s,y,C,v,t,n,u,T,r,E,a,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:w.$Inb,authority:"base"}),this.Gb=this.Eb.with({scheme:w.$Inb,authority:"local"}),this.Hb=this.Eb.with({scheme:w.$Inb,authority:"remote"}),this.Ib=this.Eb.with({scheme:w.$Inb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(i,s,t,n){const r=i.syncData?P(i.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;s=s===null&&t?i:s;const a=s?this.Ob(s):null,u=await this.vb(),y=await this.Cb();let C=null,v=!1,E=!1,T=!1;if(r){let j=u?u.value.toString():"[]";if(j=j||"[]",this.Ab(j,!0))throw new w.$wnb((0,k.localize)(10907,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!a||a!==j||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const K=await(0,g.$8bc)(j,r,a,y,this.zb);K.hasChanges&&(C=K.mergeContent,T=K.hasConflicts,v=T||K.mergeContent!==j,E=T||K.mergeContent!==r)}}else u&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),C=u.value.toString(),E=!0);const F={content:T?a:C,localChange:v?u?w.Change.Modified:w.Change.Added:w.Change.None,remoteChange:E?w.Change.Modified:w.Change.None,hasConflicts:T},U=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:U,localChange:F.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(i){const s=this.Ob(i);if(s===null)return!0;const t=await this.vb(),n=t?t.value.toString():"",r=await this.Cb(),a=await(0,g.$8bc)(n||"[]",s,s,r,this.zb);return a.hasConflicts||a.mergeContent!==s}async rb(i,s){return i.previewResult}async sb(i,s,t,n){if(this.h.isEqual(s,this.Gb))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(s,this.Hb))return{content:i.remoteContent,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(s,this.Eb))return t===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:t,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(i,s,t,n){const{fileContent:r}=t[0][0];let{content:a,localChange:u,remoteChange:y}=t[0][1];if(u===w.Change.None&&y===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new w.$wnb((0,k.localize)(10908,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==w.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,n),this.O.info(`${this.D}: Updated local keybindings`)),y!==w.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const C=this.Pb(a||"[]",i.syncData?.content);i=await this.mb(C,n?null:i.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}s?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(i,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.vb();if(i){const s=(0,A.$Vn)(i.value.toString());if((0,I.$Kb)(s))return!0}}catch(i){if(i.fileOperationResult!==d.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.Hb,i)||this.h.isEqual(this.Fb,i)||this.h.isEqual(this.Gb,i)||this.h.isEqual(this.Ib,i)?this.db(i):null}Ob(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.Qb()?null:P(i.syncData.content,this.Qb(),this.O)}Pb(i,s){let t={};try{t=JSON.parse(s||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete t.all:t.all=i,N.OS){case N.OperatingSystem.Macintosh:t.mac=i;break;case N.OperatingSystem.Linux:t.linux=i;break;case N.OperatingSystem.Windows:t.windows=i;break}return JSON.stringify(t)}Qb(){return!!this.P.getValue(w.$knb)}};e.$0bc=m,e.$0bc=m=ve([Q(2,w.$rnb),Q(3,w.$snb),Q(4,w.$Gnb),Q(5,b.$9i),Q(6,w.$Bnb),Q(7,d.$0k),Q(8,R.$Ji),Q(9,f.$fq),Q(10,w.$Fnb),Q(11,$.$9l),Q(12,l.$Hl)],m);let o=class extends S.$UNb{constructor(i,s,t,n,r,a){super(w.SyncResource.Keybindings,s,t,n,i,r,a)}async o(i){const s=i.syncData?this.p(i.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,c.$Le.fromString(s)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,A.$Vn)(i.value.toString());return!(0,I.$Kb)(s)}catch(i){return i.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND}}p(i){try{return P(i,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$$bc=o,e.$$bc=o=ve([Q(0,d.$0k),Q(1,p.$Jl),Q(2,R.$Ji),Q(3,w.$Gnb),Q(4,f.$fq),Q(5,l.$Hl)],o)}),define(he[122],ue([0,1,17,14,3,11,21,77,15,27,33,7,16,18,28,19,40,210,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0,e.$_bc=m;function P(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function m(i){const s=JSON.parse(i);return P(s)?s:{settings:i}}let o=class extends S.$TNb{constructor(s,t,n,r,a,u,y,C,v,E,T,F,U,j){super(s.settingsResource,{syncResource:w.SyncResource.Settings,profile:s},t,n,r,a,u,y,T,F,C,v,E,j),this.Eb=s,this.Fb=U,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$Inb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$Inb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$Inb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$Inb,authority:"accepted"}),this.Pb=void 0,this.Qb=void 0,this.Rb=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),n=await this.X(s,t),r=this.Mb(n),a=new O.$Mo(w.$jnb,this.O);return r?.settings&&a.parse(r.settings),a.configurationModel.getValue(w.$jnb)||{}}async qb(s,t,n){const r=await this.vb(),a=await this.Cb(),u=this.Mb(s);t=t===null&&n?s:t;const y=t?this.Mb(t):null,C=await this.Sb();let v=null,E=!1,T=!1,F=!1;if(u){let V=r?r.value.toString().trim():"{}";V=V||"{}",this.Vb(V),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,g.$sMb)(V,u.settings,y?y.settings:null,C,[],a);v=x.localContent||x.remoteContent,E=x.localContent!==null,T=x.remoteContent!==null,F=x.hasConflicts}else r&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),v=r.value.toString().trim()||"{}",this.Vb(v),T=!0);const U=r?r.value.toString():null,j=y?.settings??null,K={content:F?j:v,localChange:E?w.Change.Modified:w.Change.None,remoteChange:T?w.Change.Modified:w.Change.None,hasConflicts:F};return[{fileContent:r,baseResource:this.baseResource,baseContent:j,localResource:this.localResource,localContent:U,localChange:K.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:K.remoteChange,previewResource:this.previewResource,previewResult:K,acceptedResource:this.acceptedResource}]}async ub(s){const t=this.Mb(s);if(t===null)return!0;const n=await this.vb(),r=n?n.value.toString().trim():"",a=await this.Sb(),u=await this.Cb();return(0,g.$sMb)(r||"{}",t.settings,t.settings,a,[],u).remoteContent!==null}async rb(s,t){const n=await this.Cb(),r=await this.Sb();return{...s.previewResult,content:s.previewResult.content?(0,g.$rMb)(s.previewResult.content,"{}",r,n):null}}async sb(s,t,n,r){const a=await this.Cb(),u=await this.Sb();if(this.h.isEqual(t,this.localResource))return{content:s.fileContent?(0,g.$rMb)(s.fileContent.value.toString(),"{}",u,a):null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,g.$rMb)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,a):null,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(t,this.previewResource))return n===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:n!==null?(0,g.$rMb)(n,s.fileContent?s.fileContent.value.toString():"{}",u,a):null,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${t.toString()}`)}async tb(s,t,n,r){const{fileContent:a}=n[0][0];let{content:u,localChange:y,remoteChange:C}=n[0][1];if(y===w.Change.None&&C===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.Vb(u),y!==w.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),a&&await this.nb(JSON.stringify(this.Ob(a.value.toString()))),await this.wb(u,a,r),await this.P.reloadConfiguration(N.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),C!==w.Change.None){const v=await this.Cb(),E=this.Mb(s),T=await this.Sb(u);u=(0,g.$rMb)(u,E?E.settings:"{}",T,v),this.O.trace(`${this.D}: Updating remote settings...`),s=await this.mb(JSON.stringify(this.Ob(u)),r?null:s.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(s),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.vb();if(s)return!(0,g.$tMb)(s.value.toString())}catch(s){if(s.fileOperationResult!==d.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.db(s):null}async db(s){let t=await super.db(s);if(t){const n=await this.Cb(),r=await this.Sb();t=(0,g.$rMb)(t,"{}",r,n)}return t}Mb(s){return s.syncData?this.Nb(s.syncData.content):null}Nb(s){try{return m(s)}catch(t){this.O.error(t)}return null}Ob(s){return{settings:s}}async Sb(s){if(this.Pb||(this.Pb=this.zb.resolveDefaultCoreIgnoredSettings()),this.Qb||(this.Qb=this.Tb()),!this.Rb){this.Rb=this.Ub();const n=this.B(L.Event.any(L.Event.filter(this.Fb.onDidInstallExtensions,r=>r.some(({local:a})=>!!a)),L.Event.filter(this.Fb.onDidUninstallExtension,r=>!r.error))(()=>{n.dispose(),this.Rb=void 0}))}const t=(await Promise.all([this.Pb,this.Qb,this.Rb])).flat();return(0,g.$pMb)(t,this.P,s)}async Tb(){const s=await this.Fb.getInstalled(R.ExtensionType.System);return(0,I.$Lb)(s.map(t=>(0,w.$inb)(t.manifest)).flat())}async Ub(){const s=await this.Fb.getInstalled(R.ExtensionType.User,this.Eb.extensionsResource);return(0,I.$Lb)(s.map(t=>(0,w.$inb)(t.manifest)).flat())}Vb(s){if(this.Ab(s,!1))throw new w.$wnb((0,A.localize)(10906,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$acc=o,e.$acc=o=ve([Q(2,d.$0k),Q(3,k.$Ji),Q(4,f.$fq),Q(5,w.$rnb),Q(6,w.$snb),Q(7,w.$Gnb),Q(8,w.$Fnb),Q(9,N.$9i),Q(10,w.$Bnb),Q(11,$.$9l),Q(12,b.$lp),Q(13,l.$Hl)],o);let h=class extends S.$UNb{constructor(s,t,n,r,a,u){super(w.SyncResource.Settings,t,n,r,s,a,u)}async o(s){const t=s.syncData?this.p(s.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,c.$Le.fromString(t.settings)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,g.$tMb)(s.value.toString().trim())}catch(s){return s.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND}}p(s){try{return m(s)}catch(t){this.j.error(t)}return null}};e.$bcc=h,e.$bcc=h=ve([Q(0,d.$0k),Q(1,p.$Jl),Q(2,k.$Ji),Q(3,w.$Gnb),Q(4,f.$fq),Q(5,l.$Hl)],h)}),define(he[123],ue([0,1,14,3,29,21,15,7,16,18,28,19,40,207,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=e.$fcc=void 0,e.$ecc=p;function p(w){return JSON.parse(w.content)}let S=class extends f.$RNb{constructor(P,m,o,h,i,s,t,n,r,a,u,y){super({syncResource:l.SyncResource.Snippets,profile:P},m,h,o,i,s,t,a,u,n,r,y),this.pb=1,this.vb=P.snippetsHome,this.B(this.G.watch(o.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(c.Event.filter(this.G.onDidFilesChange,C=>C.affects(this.vb))(()=>this.Q()))}async qb(P,m,o){const h=await this.Hb(),i=this.Gb(h),s=P.syncData?this.Fb(P.syncData):null;m=m===null&&o?P:m;const t=m&&m.syncData?this.Fb(m.syncData):null;s?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,$.$ccc)(i,s,t);return this.Bb(n,h,s||{},t||{})}async ub(P){const m=P.syncData?this.Fb(P.syncData):null;if(m===null)return!0;const o=await this.Hb(),h=this.Gb(o),i=(0,$.$ccc)(h,m,m);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async rb(P,m){return P.previewResult}async sb(P,m,o,h){if(this.h.isEqualOrParent(m,this.g.with({scheme:l.$Inb,authority:"local"})))return{content:P.fileContent?P.fileContent.value.toString():null,localChange:l.Change.None,remoteChange:P.fileContent?P.remoteContent!==null?l.Change.Modified:l.Change.Added:l.Change.Deleted};if(this.h.isEqualOrParent(m,this.g.with({scheme:l.$Inb,authority:"remote"})))return{content:P.remoteContent,localChange:P.remoteContent!==null?P.fileContent?l.Change.Modified:l.Change.Added:l.Change.Deleted,remoteChange:l.Change.None};if(this.h.isEqualOrParent(m,this.g))return o===void 0?{content:P.previewResult.content,localChange:P.previewResult.localChange,remoteChange:P.previewResult.remoteChange}:{content:o,localChange:o===null?P.fileContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified,remoteChange:o===null?P.remoteContent!==null?l.Change.Deleted:l.Change.None:l.Change.Modified};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(P,m,o,h){const i=o.map(([s,t])=>({...s,acceptResult:t}));i.every(({localChange:s,remoteChange:t})=>s===l.Change.None&&t===l.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),i.some(({localChange:s})=>s!==l.Change.None)&&(await this.Cb(i),await this.Db(i,h)),i.some(({remoteChange:s})=>s!==l.Change.None)&&(P=await this.Eb(i,P,h)),m?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:s}of i)try{await this.G.del(s)}catch{}}Bb(P,m,o,h){const i=new Map;for(const s of Object.keys(P.local.added)){const t={content:P.local.added[s],hasConflicts:!1,localChange:l.Change.Added,remoteChange:l.Change.None};i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"remote"}),remoteContent:o[s],previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"accepted"})})}for(const s of Object.keys(P.local.updated)){const t={content:P.local.updated[s],hasConflicts:!1,localChange:l.Change.Modified,remoteChange:l.Change.None},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"local"}),fileContent:m[s],localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"remote"}),remoteContent:o[s],previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"accepted"})})}for(const s of P.local.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.Deleted,remoteChange:l.Change.None},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"local"}),fileContent:m[s],localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"accepted"})})}for(const s of Object.keys(P.remote.added)){const t={content:P.remote.added[s],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Added},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"local"}),fileContent:m[s],localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"accepted"})})}for(const s of Object.keys(P.remote.updated)){const t={content:P.remote.updated[s],hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Modified},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"local"}),fileContent:m[s],localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"remote"}),remoteContent:o[s],previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"accepted"})})}for(const s of P.remote.removed){const t={content:null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.Deleted};i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"remote"}),remoteContent:o[s],previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"accepted"})})}for(const s of P.conflicts){const t={content:h[s]??null,hasConflicts:!0,localChange:m[s]?l.Change.Modified:l.Change.Added,remoteChange:o[s]?l.Change.Modified:l.Change.Added},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"local"}),fileContent:m[s]||null,localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"remote"}),remoteContent:o[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"accepted"})})}for(const s of Object.keys(m))if(!i.has(s)){const t={content:m[s]?m[s].value.toString():null,hasConflicts:!1,localChange:l.Change.None,remoteChange:l.Change.None},n=m[s]?m[s].value.toString():null;i.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"base"}),baseContent:h[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"local"}),fileContent:m[s]||null,localContent:n,remoteResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"remote"}),remoteContent:o[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:l.$Inb,authority:"accepted"})})}return[...i.values()]}async resolveContent(P){return this.h.isEqualOrParent(P,this.g.with({scheme:l.$Inb,authority:"remote"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Inb,authority:"local"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Inb,authority:"base"}))||this.h.isEqualOrParent(P,this.g.with({scheme:l.$Inb,authority:"accepted"}))?this.db(P):null}async hasLocalData(){try{const P=await this.Hb();if(Object.keys(P).length)return!0}catch{}return!1}async Cb(P){const m={};for(const o of P)o.fileContent&&(m[this.h.basename(o.localResource)]=o.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(P,m){for(const{fileContent:o,acceptResult:h,localResource:i,remoteResource:s,localChange:t}of P)if(t!==l.Change.None){const n=s?this.h.basename(s):this.h.basename(i),r=this.h.joinPath(this.vb,n);t===l.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):t===l.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,I.$Le.fromString(h.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,I.$Le.fromString(h.content),m?void 0:o),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(P,m,o){const h=m.syncData?this.Fb(m.syncData):{},i=(0,L.$bo)(h);for(const{acceptResult:s,localResource:t,remoteResource:n,remoteChange:r}of P)if(r!==l.Change.None){const a=t?this.h.basename(t):this.h.basename(n);r===l.Change.Deleted?delete i[a]:i[a]=s.content}return(0,$.$dcc)(h,i)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(i),o?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(P){return p(P)}Gb(P){const m={};for(const o of Object.keys(P))m[o]=P[o].value.toString();return m}async Hb(){const P={};let m;try{m=await this.G.resolve(this.vb)}catch(o){if(o instanceof O.$sl&&o.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND)return P;throw o}for(const o of m.children||[]){const h=o.resource,i=this.h.extname(h);if(i===".json"||i===".code-snippets"){const s=this.h.relativePath(this.vb,h),t=await this.G.readFile(h);P[s]=t}}return P}};e.$fcc=S,e.$fcc=S=ve([Q(2,N.$Ji),Q(3,O.$0k),Q(4,k.$fq),Q(5,l.$rnb),Q(6,l.$snb),Q(7,l.$Gnb),Q(8,A.$9i),Q(9,l.$Bnb),Q(10,b.$9l),Q(11,R.$Hl)],S);let g=class extends f.$UNb{constructor(P,m,o,h,i,s){super(l.SyncResource.Snippets,m,o,h,P,i,s)}async o(P){const m=P.syncData?JSON.parse(P.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys(m)){const i=m[h];if(i){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,h);await this.k.createFile(s,I.$Le.fromString(i)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(P)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(P){return P.fileOperationResult===O.FileOperationResult.FILE_NOT_FOUND}}};e.$gcc=g,e.$gcc=g=ve([Q(0,O.$0k),Q(1,d.$Jl),Q(2,N.$Ji),Q(3,l.$Gnb),Q(4,k.$fq),Q(5,R.$Hl)],g)}),define(he[124],ue([0,1,14,21,15,7,16,18,28,19,40,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0,e.$hcc=f;function f(S,g){try{return JSON.parse(S).tasks??null}catch(w){return g.error(w),null}}let $=class extends R.$SNb{constructor(g,w,P,m,o,h,i,s,t,n,r,a){super(g.tasksResource,{syncResource:d.SyncResource.Tasks,profile:g},w,s,t,n,P,m,i,r,o,h,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:d.$Inb,authority:"base"}),this.Cb=this.Ab.with({scheme:d.$Inb,authority:"local"}),this.Db=this.Ab.with({scheme:d.$Inb,authority:"remote"}),this.Eb=this.Ab.with({scheme:d.$Inb,authority:"accepted"})}async qb(g,w,P,m){const o=g.syncData?f(g.syncData.content,this.O):null;w=w===null&&P?g:w;const h=w?.syncData?f(w.syncData.content,this.O):null,i=await this.vb();let s=null,t=!1,n=!1,r=!1;if(g.syncData){const y=i?i.value.toString():null;if(!h||h!==y||h!==o){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const C=p(y,o,h);s=C.content,r=C.hasConflicts,t=C.hasLocalChanged,n=C.hasRemoteChanged}}else i&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=i.value.toString(),n=!0);const a={content:r?h:s,localChange:t?i?d.Change.Modified:d.Change.Added:d.Change.None,remoteChange:n?d.Change.Modified:d.Change.None,hasConflicts:r},u=i?i.value.toString():null;return[{fileContent:i,baseResource:this.Bb,baseContent:h,localResource:this.Cb,localContent:u,localChange:a.localChange,remoteResource:this.Db,remoteContent:o,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(g){const w=g?.syncData?f(g.syncData.content,this.O):null;if(w===null)return!0;const P=await this.vb(),m=P?P.value.toString():null,o=p(m,w,w);return o.hasLocalChanged||o.hasRemoteChanged}async rb(g,w){return g.previewResult}async sb(g,w,P,m){if(this.h.isEqual(w,this.Cb))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:d.Change.None,remoteChange:d.Change.Modified};if(this.h.isEqual(w,this.Db))return{content:g.remoteContent,localChange:d.Change.Modified,remoteChange:d.Change.None};if(this.h.isEqual(w,this.Ab))return P===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:P,localChange:d.Change.Modified,remoteChange:d.Change.Modified};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(g,w,P,m){const{fileContent:o}=P[0][0],{content:h,localChange:i,remoteChange:s}=P[0][1];if(i===d.Change.None&&s===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),i!==d.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),o&&await this.nb(JSON.stringify(this.Kb(o.value.toString()))),h?await this.wb(h,o,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),s!==d.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const t=JSON.stringify(this.Kb(h));g=await this.mb(t,m?null:g.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}w?.ref!==g.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(g),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(g){return this.h.isEqual(this.Db,g)||this.h.isEqual(this.Bb,g)||this.h.isEqual(this.Cb,g)||this.h.isEqual(this.Eb,g)?this.db(g):null}Kb(g){return g?{tasks:g}:{}}};e.$icc=$,e.$icc=$=ve([Q(2,d.$rnb),Q(3,d.$snb),Q(4,d.$Gnb),Q(5,c.$9i),Q(6,d.$Bnb),Q(7,A.$0k),Q(8,L.$Ji),Q(9,N.$fq),Q(10,O.$9l),Q(11,k.$Hl)],$);let l=class extends R.$UNb{constructor(g,w,P,m,o,h){super(d.SyncResource.Tasks,w,P,m,g,o,h),this.c=this.g.defaultProfile.tasksResource}async o(g){const w=g.syncData?f(g.syncData.content,this.j):null;if(!w){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$Le.fromString(w)),await this.n(g)}async p(){return this.k.exists(this.c)}};e.$jcc=l,e.$jcc=l=ve([Q(0,A.$0k),Q(1,b.$Jl),Q(2,L.$Ji),Q(3,d.$Gnb),Q(4,N.$fq),Q(5,k.$Hl)],l);function p(S,g,w){if(S===null&&g===null&&w===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(S===g)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const P=w!==S,m=w!==g;return!P&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:P&&!m?{content:S,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!P?{content:g,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:S,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(he[125],ue([0,1,45,21,15,7,16,18,28,19,40,208,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0,e.$4dc=l,e.$5dc=p;let $=class extends R.$RNb{constructor(g,w,P,m,o,h,i,s,t,n,r,a,u){super({syncResource:f.SyncResource.Profiles,profile:g},w,m,o,h,i,s,r,a,t,n,u),this.vb=P,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:f.$Inb,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.$Inb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.$Inb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.$Inb,authority:"accepted"}),this.B(P.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const g=await this.getLastSyncUserData();return g?.syncData?p(g.syncData):null}async getRemoteSyncedProfiles(g){const w=await this.getLastSyncUserData(),P=await this.X(g,w);return P?.syncData?p(P.syncData):null}async qb(g,w,P){if(!this.vb.isEnabled())throw new f.$wnb("Cannot sync profiles because they are disabled",f.UserDataSyncErrorCode.LocalError);const m=g.syncData?p(g.syncData):null,o=w?.syncData?p(w.syncData):null,h=this.Db(),{local:i,remote:s}=(0,d.$2dc)(h,m,o,[]),t={local:i,remote:s,content:o?this.Eb(o):null,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?f.Change.Modified:f.Change.None,remoteChange:s!==null?f.Change.Modified:f.Change.None},n=l(h,!1);return[{baseResource:this.baseResource,baseContent:o?this.Eb(o):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.acceptedResource}]}async ub(g){const w=g?.syncData?p(g.syncData):null,P=this.Db(),{remote:m}=(0,d.$2dc)(P,w,w,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(g,w){return{...g.previewResult,hasConflicts:!1}}async sb(g,w,P,m){if(this.h.isEqual(w,this.localResource))return this.Ab(g);if(this.h.isEqual(w,this.remoteResource))return this.Bb(g);if(this.h.isEqual(w,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async Ab(g){const w=this.Db(),P=(0,d.$2dc)(w,null,null,[]),{local:m,remote:o}=P;return{content:g.localContent,local:m,remote:o,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?f.Change.Modified:f.Change.None,remoteChange:o!==null?f.Change.Modified:f.Change.None}}async Bb(g){const w=g.remoteContent?JSON.parse(g.remoteContent):null,P=[],m=[];for(const o of this.Db()){const h=w?.find(i=>i.id===o.id);h&&(P.push({id:o.id,name:o.name,collection:h.collection}),m.push(o))}if(w!==null){const o=(0,d.$2dc)(m,w,P,[]),{local:h,remote:i}=o;return{content:g.remoteContent,local:h,remote:i,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?f.Change.Modified:f.Change.None,remoteChange:i!==null?f.Change.Modified:f.Change.None}}else return{content:g.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:f.Change.None,remoteChange:f.Change.None}}async tb(g,w,P,m){const{local:o,remote:h,localChange:i,remoteChange:s}=P[0][1];i===f.Change.None&&s===f.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const t=P[0][0].remoteProfiles||[];if(t.length+(h?.added.length??0)-(h?.removed.length??0)>20)throw new f.$wnb("Too many profiles to sync. Please remove some profiles and try again.",f.UserDataSyncErrorCode.LocalTooManyProfiles);if(i!==f.Change.None&&(await this.nb(l(this.Db(),!1)),await Promise.all(o.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(o.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(o.updated.map(async n=>{const r=this.vb.profiles.find(a=>a.id===n.id);r?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(r,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),s!==f.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],r=t.length+(h?.added.length??0)<=20;if(r)for(const a of h?.added||[]){const u=await this.J.createCollection(this.F);n.push(u),t.push({id:a.id,name:a.name,collection:u,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of h?.removed||[])t.splice(t.findIndex(({id:u})=>a.id===u),1);for(const a of h?.updated||[]){const u=t.find(({id:y})=>a.id===y);u&&t.splice(t.indexOf(u),1,{...u,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{g=await this.updateRemoteProfiles(t,m?null:g.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&h?.added.length?` Added: ${JSON.stringify(h.added.map(a=>a.name))}.`:""}${h?.updated.length?` Updated: ${JSON.stringify(h.updated.map(a=>a.name))}.`:""}${h?.removed.length?` Removed: ${JSON.stringify(h.removed.map(a=>a.name))}.`:""}`)}catch(a){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of n)await this.J.deleteCollection(u,this.F)}throw a}for(const a of h?.removed||[])await this.J.deleteCollection(a.collection,this.F)}w?.ref!==g.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(g),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(g,w){return this.mb(this.Eb(g),w)}async hasLocalData(){return this.Db().length>0}async resolveContent(g){if(this.h.isEqual(this.remoteResource,g)||this.h.isEqual(this.baseResource,g)||this.h.isEqual(this.localResource,g)||this.h.isEqual(this.acceptedResource,g)){const w=await this.db(g);return w&&(0,I.$6n)(JSON.parse(w),{})}return null}Db(){return this.vb.profiles.filter(g=>!g.isDefault&&!g.isTransient)}Eb(g){return JSON.stringify([...g].sort((w,P)=>w.name.localeCompare(P.name)))}};e.$3dc=$,e.$3dc=$=ve([Q(2,b.$Jl),Q(3,A.$0k),Q(4,L.$Ji),Q(5,N.$fq),Q(6,f.$rnb),Q(7,f.$snb),Q(8,f.$Gnb),Q(9,c.$9i),Q(10,f.$Bnb),Q(11,O.$9l),Q(12,k.$Hl)],$);function l(S,g){const w=[...S].sort((P,m)=>P.name.localeCompare(m.name)).map(P=>({id:P.id,name:P.name}));return g?(0,I.$6n)(w,{}):JSON.stringify(w)}function p(S){return JSON.parse(S.content)}}),define(he[227],ue([0,1,3,2,5,15,16,18,24]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;const b="sync.enable";let R=class extends c.$Tc{constructor(f,$,l,p){super(),this.c=f,this.f=$,this.g=l,this.h=p,this.a=new I.$je,this.onDidChangeEnablement=this.a.event,this.b=new I.$je,this.onDidChangeResourceEnablement=this.b.event,this.B(f.onDidChangeValue(N.StorageScope.APPLICATION,void 0,this.B(new c.$Sc))(S=>this.m(S)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,N.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:f}),this.c.store(b,f,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE))}isResourceEnabled(f){return this.c.getBoolean((0,k.$Anb)(f),N.StorageScope.APPLICATION,!0)}setResourceEnablement(f,$){if(this.isResourceEnabled(f)!==$){const l=(0,k.$Anb)(f);this.j(l,$)}}getResourceSyncStateVersion(f){}j(f,$){this.c.store(f,$,N.StorageScope.APPLICATION,L.$p?N.StorageTarget.USER:N.StorageTarget.MACHINE)}m(f){if(b===f.key){this.a.fire(this.isEnabled());return}const $=k.$nnb.filter(l=>(0,k.$Anb)(l)===f.key)[0];if($){this.b.fire([$,this.isResourceEnabled($)]);return}}};e.$Pdc=R,e.$Pdc=R=ve([Q(0,N.$fq),Q(1,O.$9l),Q(2,A.$Ji),Q(3,k.$qnb)],R)}),define(he[228],ue([0,1,6,14,71,2,20,21,15,7,19,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;let f=class extends A.$Tc{constructor(l,p,S,g,w){super(),this.a=l,this.b=p,this.c=S,this.f=g,this.g=w,this.h()}async h(){for(const p of this.g.profiles)for(const S of d.$nnb)try{await this.m(this.j(S,p.isDefault?void 0:p.id))}catch(g){this.f.error(g)}let l;try{l=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,b.$ol)(p)!==b.FileOperationResult.FILE_NOT_FOUND&&this.f.error(p);return}if(l.children){for(const p of l.children)if(p.isDirectory&&!d.$nnb.includes(p.name)&&!this.g.profiles.some(S=>S.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(S){this.f.error(S)}}}async getAllResourceRefs(l,p,S){const g=this.j(l,p,S);try{const w=await this.b.resolve(g);if(w.children)return w.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(w){if((0,b.$ol)(w)!==b.FileOperationResult.FILE_NOT_FOUND)throw w}return[]}async resolveResourceContent(l,p,S,g){const w=this.j(l,S,g),P=(0,N.$dh)(w,p);try{return(await this.b.readFile(P)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource(l,p,S,g,w){const P=this.j(l,g,w),m=(0,N.$dh)(P,`${(0,L.$1m)(S).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,c.$Le.fromString(p))}catch(o){this.f.error(o)}}j(l,p,S=this.a.userDataSyncHome){return(0,N.$dh)(S,...p?[p,l]:[l])}async m(l){try{try{if(!await this.b.exists(l))return}catch{return}const p=await this.b.resolve(l);if(p.children){const S=p.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),g=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let w=S.filter(m=>Date.now()-this.n(m)>g);const P=S.length-w.length;P<10&&(w=w.slice(10-P)),await I.Promises.settled(w.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(p){this.f.error(p)}}n(l){return new Date(parseInt(l.name.substring(0,4)),parseInt(l.name.substring(4,6))-1,parseInt(l.name.substring(6,8)),parseInt(l.name.substring(9,11)),parseInt(l.name.substring(11,13)),parseInt(l.name.substring(13,15))).getTime()}};e.$1dc=f,e.$1dc=f=ve([Q(0,k.$Ji),Q(1,b.$0k),Q(2,O.$9i),Q(3,d.$Gnb),Q(4,R.$Jl)],f)}),define(he[86],ue([0,1,3,2,5,26,11,15,7,4,23,49,16,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$fnb=e.$dnb=void 0,e.$enb=o,e.$dnb=(0,b.$Ci)("IUserDataSyncMachinesService");const p="sync.currentMachineName",S="Safari",g="Chrome",w="Edge",P="Firefox",m="Android";function o(s){switch(s){case S:case g:case w:case P:case m:case(0,L.$i)(L.Platform.Web):return!0}return!1}function h(){return L.$H?S:L.$F?g:L.$I?w:L.$G?P:L.$J?m:(0,L.$i)(L.$p?L.Platform.Web:L.$v)}let i=class extends c.$Tc{static{l=this}static{this.a=1}static{this.b="machines"}constructor(t,n,r,a,u,y){super(),this.h=r,this.j=a,this.m=u,this.n=y,this.c=this.B(new I.$je),this.onDidChange=this.c.event,this.g=null,this.f=(0,d.$lq)(t,n,r)}async getMachines(t){const n=await this.f;return(await this.s(t)).machines.map(a=>({...a,isCurrent:a.id===n}))}async addCurrentMachine(t){const n=await this.f,r=await this.s(t);r.machines.some(({id:a})=>a===n)||(r.machines.push({id:n,name:this.r(r.machines),platform:h()}),await this.t(r))}async removeCurrentMachine(t){const n=await this.f,r=await this.s(t),a=r.machines.filter(({id:u})=>u!==n);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(t,n,r){const a=await this.s(r),u=a.machines.find(({id:y})=>y===t);if(u){u.name=n,await this.t(a);const y=await this.f;t===y&&this.h.store(p,n,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}}async setEnablements(t){const n=await this.s();for(const[r,a]of t){const u=n.machines.find(y=>y.id===r);u&&(u.disabled=a?void 0:!0)}await this.t(n)}r(t){const n=this.h.get(p,f.StorageScope.APPLICATION);if(n)return n;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${h()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$ff)(r)}\\s#(\\d+)`);let u=0;for(const y of t){const C=a.exec(y.name),v=C?parseInt(C[1]):0;u=v>u?v:u}return`${r} #${u+1}`}async s(t){this.g=await this.u(t);const n=this.w(this.g);if(n.version!==l.a)throw new Error((0,N.localize)(10892,null,this.n.nameLong));return n}async t(t){const n=JSON.stringify(t),r=await this.j.writeResource(l.b,n,this.g?.ref||null);this.g={ref:r,content:n},this.c.fire()}async u(t){if(this.g){const n=t&&t.latest?t.latest[l.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(l.b,this.g)}w(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.m.error(n)}return{version:l.a,machines:[]}}};e.$fnb=i,e.$fnb=i=l=ve([Q(0,O.$Ji),Q(1,k.$0k),Q(2,f.$fq),Q(3,$.$rnb),Q(4,$.$Gnb),Q(5,R.$qk)],i)}),define(he[229],ue([0,1,6,71,43,8,3,2,5,20,9,11,23,16,18,24,82,86]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;const w="sync.disableMachineEventually",P="sync.sessionId",m="sync.storeUrl",o="sync.productQuality";let h=class extends O.$Tc{get n(){const t=this.H.get(m,$.StorageScope.APPLICATION);return t?R.URI.parse(t):void 0}set n(t){t?this.H.store(m,t.toString(),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(m,$.StorageScope.APPLICATION)}get s(){return this.H.get(o,$.StorageScope.APPLICATION)}set s(t){t?this.H.store(o,t,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(o,$.StorageScope.APPLICATION)}constructor(t,n,r,a,u,y,C,v,E,T){super(),this.u=n,this.w=r,this.y=a,this.z=u,this.C=y,this.D=C,this.F=v,this.G=E,this.H=T,this.a=this.B(new O.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new N.$je),this.onError=this.h.event,this.S=[],this.f=this.B(new I.$Ah(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=t.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,b.$9g)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(C.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(u.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(N.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:t,message:n}=this.L();t?this.a.value===void 0&&(this.a.value=new i(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,c.$1m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(t,n,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(P,$.StorageScope.APPLICATION),t?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),n)this.M(!1);else throw a}}M(t){this.y.isEnabled()!==t&&(this.y.setEnablement(t),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(t){if(!t){this.b=0;return}const n=p.$wnb.toUserDataSyncError(t);n instanceof p.$ynb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===p.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===p.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===p.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===p.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===p.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===p.UserDataSyncErrorCode.UpgradeRequired||n.code===p.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===p.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===p.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===p.UserDataSyncErrorCode.ServiceChanged||n.code===p.UserDataSyncErrorCode.DefaultServiceChanged?k.$p&&n.code===p.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(w,!0,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),await(0,I.$Dh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(w,$.StorageScope.APPLICATION,!1)}R(){this.H.remove(w,$.StorageScope.APPLICATION)}async triggerSync(t,n,r){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...t),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$7dc=h,e.$7dc=h=ve([Q(0,f.$qk),Q(1,p.$qnb),Q(2,p.$rnb),Q(3,p.$Bnb),Q(4,p.$Cnb),Q(5,p.$Gnb),Q(6,S.$_Lb),Q(7,l.$9l),Q(8,g.$dnb),Q(9,$.$fq)],h);class i extends O.$Tc{static{this.a="Interval"}constructor(t,n,r,a,u,y,C,v,E){super(),this.m=t,this.n=n,this.r=r,this.s=a,this.u=u,this.w=y,this.y=C,this.z=v,this.C=E,this.b=this.B(new O.$Uc),this.c=this.B(new N.$je),this.onDidStartSync=this.c.event,this.f=this.B(new N.$je),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,O.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(i.a,!1)}D(){this.b.value=(0,I.$Eh)(()=>{this.sync(i.a,!1),this.b.value=void 0},this.n)}sync(t,n){const r=(0,I.$ph)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(u){if((0,A.$3)(u))return}return this.H(t,n,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,b.$9g)(this.m,this.r.userDataSyncStore?.url)}async G(){const t=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!t&&(!(0,b.$9g)(n.defaultUrl,t.defaultUrl)||!(0,b.$9g)(n.insidersUrl,t.insidersUrl)||!(0,b.$9g)(n.stableUrl,t.stableUrl))}async H(t,n,r){this.y.info(`Auto Sync: Triggered by ${t}`),this.c.fire();let a;try{await this.I(n,r)}catch(u){if(this.y.error(u),a=u,p.$wnb.toUserDataSyncError(u).code===p.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,r),a=void 0}catch(y){this.y.error(y),a=y}}this.f.fire(a)}async I(t,n){if(this.h=await this.u.createSyncTask(this.g,t),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$ynb((0,d.localize)(10899,null),p.UserDataSyncErrorCode.DefaultServiceChanged):new p.$ynb((0,d.localize)(10900,null),p.UserDataSyncErrorCode.ServiceChanged):new p.$ynb((0,d.localize)(10901,null),p.UserDataSyncErrorCode.TurnedOff);const r=this.C.get(P,$.StorageScope.APPLICATION);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$ynb((0,d.localize)(10902,null),p.UserDataSyncErrorCode.DefaultServiceChanged):new p.$ynb((0,d.localize)(10903,null),p.UserDataSyncErrorCode.ServiceChanged):new p.$ynb((0,d.localize)(10904,null),p.UserDataSyncErrorCode.SessionExpired);const a=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const u=a.find(C=>C.isCurrent);if(u?.disabled)throw new p.$ynb((0,d.localize)(10905,null),p.UserDataSyncErrorCode.TurnedOff);const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(C){throw new p.$ynb((0,L.$nj)(C),C instanceof p.$wnb?C.code:p.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==r&&this.C.store(P,this.g.session,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),!n.isCancellationRequested&&(u||await this.w.addCurrentMachine(this.g||void 0))}register(t){return super.B(t)}}}),define(he[230],ue([0,1,9,11,15,7,49,16,28,24,19,40,123,122,121,21,124,119,120,4,125,45,26]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o,h){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;let s=class{static{i=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,r,a,u,y,C,v,E,T,F){this.e=n,this.f=r,this.g=a,this.h=y,this.i=C,this.j=v,this.k=E,this.l=T,this.n=F,this.d=u.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(b.SyncResource.Profiles,null,void 0);if(n.content){const r=this.L(n.content,b.SyncResource.Profiles);return(0,m.$5dc)(r)}return[]}async getLocalSyncedProfiles(n){const r=await this.f.getAllResourceRefs(b.SyncResource.Profiles,void 0,n);if(r.length){const a=await this.f.resolveResourceContent(b.SyncResource.Profiles,r[0].ref,void 0,n);if(a){const u=this.L(a,b.SyncResource.Profiles);return(0,m.$5dc)(u)}}return[]}async getLocalSyncedMachines(n){const r=await this.f.getAllResourceRefs("machines",void 0,n);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,n);if(a)return JSON.parse(a).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,r){return(await this.e.getAllResourceRefs(n,r?.collection)).map(({created:u,ref:y})=>({created:u,uri:this.J({remote:!0,syncResource:n,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(n,r,a){return(await this.f.getAllResourceRefs(n,r?.collection,a)).map(({created:y,ref:C})=>({created:y,uri:this.J({remote:!1,syncResource:n,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:C,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:n}){const r=this.K(n),a=r?this.k.profiles.find(u=>u.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:n}){const r=this.K(n);if(!r)return[];const a=this.k.profiles.find(u=>u.id===r.profile);switch(r.syncResource){case b.SyncResource.Settings:return this.s(n,a);case b.SyncResource.Keybindings:return this.u(n,a);case b.SyncResource.Tasks:return this.w(n,a);case b.SyncResource.Snippets:return this.y(n,a);case b.SyncResource.GlobalState:return this.D(n,a);case b.SyncResource.Extensions:return this.A(n,a);case b.SyncResource.Profiles:return this.G(n,a);case b.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const r=this.K(n);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,N.$lq)(this.h,this.j,this.i)}}async resolveContent(n){const r=this.K(n);if(!r||r.node===i.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(n,r,a,u,y){if(n){const{content:C}=await this.M(r,u,a);return C}return this.f.resolveResourceContent(r,u,a,y)}q(n,r,a){const u=this.L(r,n);switch(n){case b.SyncResource.Settings:return this.t(u,a);case b.SyncResource.Keybindings:return this.v(u,a);case b.SyncResource.Tasks:return this.x(u,a);case b.SyncResource.Snippets:return this.z(u,a);case b.SyncResource.GlobalState:return this.E(u,a);case b.SyncResource.Extensions:return this.B(u,a);case b.SyncResource.Profiles:return this.H(u,a);case b.SyncResource.WorkspaceState:return null}}async r(n,r){const a=this.k.profiles.find(u=>u.id===r);if(!a)return null;switch(n){case b.SyncResource.GlobalState:return this.F(a);case b.SyncResource.Extensions:return this.C(a);case b.SyncResource.Profiles:return this.I(a);case b.SyncResource.Settings:return null;case b.SyncResource.Keybindings:return null;case b.SyncResource.Tasks:return null;case b.SyncResource.Snippets:return null;case b.SyncResource.WorkspaceState:return null}}s(n,r){const a=this.d.joinPath(n,"settings.json"),u=r?r.settingsResource:this.d.joinPath(n,i.a);return[{resource:a,comparableResource:u}]}t(n,r){switch(r){case"settings.json":return(0,$.$_bc)(n.content).settings}return null}u(n,r){const a=this.d.joinPath(n,"keybindings.json"),u=r?r.keybindingsResource:this.d.joinPath(n,i.a);return[{resource:a,comparableResource:u}]}v(n,r){switch(r){case"keybindings.json":return(0,l.$9bc)(n.content,!!this.l.getValue(b.$knb),this.g)}return null}w(n,r){const a=this.d.joinPath(n,"tasks.json"),u=r?r.tasksResource:this.d.joinPath(n,i.a);return[{resource:a,comparableResource:u}]}x(n,r){switch(r){case"tasks.json":return(0,S.$hcc)(n.content,this.g)}return null}async y(n,r){const a=await this.resolveContent(n);if(a){const u=this.L(a,b.SyncResource.Snippets);if(u){const y=(0,f.$ecc)(u),C=[];for(const v of Object.keys(y)){const E=this.d.joinPath(n,v),T=r?this.d.joinPath(r.snippetsHome,v):this.d.joinPath(n,i.a);C.push({resource:E,comparableResource:T})}return C}}return[]}z(n,r){return(0,f.$ecc)(n)[r]||null}A(n,r){const a=this.d.joinPath(n,"extensions.json"),u=r?this.J({remote:!1,syncResource:b.SyncResource.Extensions,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,i.a);return[{resource:a,comparableResource:u}]}B(n,r){switch(r){case"extensions.json":return(0,g.$4bc)((0,g.$3bc)(n),!0)}return null}async C(n){const{localExtensions:r}=await this.n.createInstance(g.$6bc).getLocalExtensions(n);return(0,g.$4bc)(r,!0)}D(n,r){const a=this.d.joinPath(n,"globalState.json"),u=r?this.J({remote:!1,syncResource:b.SyncResource.GlobalState,profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,i.a);return[{resource:a,comparableResource:u}]}E(n,r){switch(r){case"globalState.json":return(0,w.$WNb)(JSON.parse(n.content),!0)}return null}async F(n){const r=await this.n.createInstance(w.$YNb).getLocalGlobalState(n);return(0,w.$WNb)(r,!0)}G(n,r){const a=this.d.joinPath(n,"profiles.json"),u=this.J({remote:!1,syncResource:b.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:u}]}H(n,r){switch(r){case"profiles.json":return(0,o.$6n)(JSON.parse(n.content),{})}return null}async I(n){return(0,m.$4dc)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(n){const r=n.remote?i.b:i.c,a=[];return n.location&&(a.push(`scheme:${n.location.scheme}`),a.push(`authority:${n.location.authority}`),a.push((0,h.$jf)(n.location.path,"/"))),a.push(`syncResource:${n.syncResource}`),a.push(`profile:${n.profile}`),n.collection&&a.push(`collection:${n.collection}`),n.ref&&a.push(`ref:${n.ref}`),n.node&&a.push(n.node),this.d.joinPath(I.URI.from({scheme:b.$Inb,authority:r,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...a)}K(n){if(n.scheme!==b.$Inb)return;const r=[];for(;n.path!=="/";)r.unshift(this.d.basename(n)),n=this.d.dirname(n);if(r.length<2)return;const a=n.authority===i.b;let u,y;const C=[];let v,E,T,F,U;for(;r.length;){const j=r.shift();j.startsWith("scheme:")?u=j.substring(7):j.startsWith("authority:")?y=j.substring(10):j.startsWith("syncResource:")?v=j.substring(13):j.startsWith("profile:")?E=j.substring(8):j.startsWith("collection:")?T=j.substring(11):j.startsWith("ref:")?F=j.substring(4):v?U=j:C.push(j)}return{remote:a,syncResource:v,profile:E,collection:T,ref:F,node:U,location:u&&y!==void 0?this.d.joinPath(I.URI.from({scheme:u,authority:y,query:n.query,fragment:n.fragment,path:"/"}),...C):void 0}}L(n,r){try{const a=JSON.parse(n);if((0,d.$PNb)(a))return a}catch(a){this.g.error(a)}throw new b.$wnb((0,c.localize)(10891,null),b.UserDataSyncErrorCode.IncompatibleRemoteContent,r)}async M(n,r,a){const u=await this.e.resolveResourceContent(n,r,a);return{ref:r,content:u}}};e.$Jec=s,e.$Jec=s=i=ve([Q(0,b.$rnb),Q(1,b.$snb),Q(2,b.$Gnb),Q(3,k.$Hl),Q(4,L.$Ji),Q(5,O.$fq),Q(6,A.$0k),Q(7,R.$Jl),Q(8,p.$9i),Q(9,P.$Bi)],s)}),define(he[231],ue([0,1,17,6,25,43,3,2,20,12,31,21,27,7,4,16,18,19,119,120,121,122,123,124,125,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o,h,i,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;const n="sync.lastSyncTime";let r=class extends O.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(v,E,T,F,U,j,K,V,x,H,ie){super(),this.C=v,this.D=E,this.F=T,this.G=F,this.H=U,this.I=j,this.J=K,this.L=V,this.M=x,this.N=H,this.O=ie,this.f=t.SyncStatus.Uninitialized,this.g=this.B(new N.$je),this.onDidChangeStatus=this.g.event,this.h=this.B(new N.$je),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new N.$je),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new N.$je),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new N.$je),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new N.$je),this.onDidResetLocal=this.w.event,this.y=this.B(new N.$je),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?t.SyncStatus.Idle:t.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,p.StorageScope.APPLICATION,void 0),this.B((0,O.$Rc)(()=>this.cb())),this.B(new c.$Oh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(v,E){this.db(),this.H.info("Sync started.");const T=new Date().getTime(),F=(0,R.$Yg)();try{const V=(0,t.$vnb)(F);E&&(V["Cache-Control"]="no-cache"),v=await this.D.manifest(v,V)}catch(V){const x=t.$wnb.toUserDataSyncError(V);throw y(x,F,this.F,this.I),x}const U=!1,j=this;let K;return{manifest:v,async run(){if(U)throw new Error("Can run a task only once");K=(0,c.$ph)(V=>j.P(v,!1,F,V)),await K.finally(()=>K=void 0),j.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),j.ab()},stop(){return K?.cancel(),j.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new t.$wnb("Cannot start manual sync when sync is enabled",t.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const v=new Date().getTime(),E=(0,R.$Yg)(),T=(0,t.$vnb)(E);let F;try{F=await this.D.manifest(null,T)}catch(K){const V=t.$wnb.toUserDataSyncError(K);throw y(V,E,this.F,this.I),V}await this.resetLocal();const U=this,j=new L.$ue;return{id:E,async merge(){return U.P(F,!0,E,j.token)},async apply(){try{try{await U.R(F,E,j.token)}catch(K){if(t.$wnb.toUserDataSyncError(K).code===t.UserDataSyncErrorCode.MethodNotFound)U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(F,E,j.token);else throw K}}catch(K){throw U.H.error(K),K}U.H.info(`Sync done. Took ${new Date().getTime()-v}ms`),U.ab()},async stop(){j.cancel(),await U.U(),await U.resetLocal()}}}async P(v,E,T,F){this.n=[];try{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Syncing);const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,v,E,T,F));const j=U.enabled.find(K=>K.resource===t.SyncResource.Profiles);if(j){const K=await j.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(K,v,E,T,F)}}finally{this.status!==t.SyncStatus.HasConflicts&&this.Z(t.SyncStatus.Idle),this.r.fire(this.n)}}async Q(v,E,T,F,U){for(const j of v){if(U.isCancellationRequested)return;const K=this.M.profiles.find(x=>x.id===j.id);if(!K){this.H.error(`Profile with id:${j.id} and name: ${j.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",j.name);const V=this.getOrCreateActiveProfileSynchronizer(K,j);this.n.push(...await this.S(V,E,T,F,U))}for(const[j,K]of this.z.entries())this.M.profiles.some(V=>V.id===K[0].profile.id)||(await K[0].resetLocal(),K[1].dispose(),this.z.delete(j))}async R(v,E,T){const F=this.bb();for(const x of F){if(T.isCancellationRequested)return;await x.apply(E,T)}const U=F.find(x=>x.profile.isDefault);if(!U)return;const j=U.enabled.find(x=>x.resource===t.SyncResource.Profiles);if(!j)return;const V=(await j.getRemoteSyncedProfiles(v?.latest??null)||[]).filter(x=>F.every(H=>H.profile.id!==x.id));V.length&&await this.Q(V,v,!1,E,T)}async S(v,E,T,F,U){return(await v.sync(E,T,F,U)).map(([K,V])=>({profile:v.profile,syncResource:K,error:V}))}async U(){this.status!==t.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(v=>v.stop()))}async resolveContent(v){const E=await this.N.resolveContent(v);if(E)return E;for(const T of this.bb())for(const F of T.enabled){const U=await F.resolveContent(v);if(U)return U}return null}async replace(v){this.db();const E=this.N.resolveUserDataSyncResource(v);if(!E)return;const T=await this.resolveContent(v.uri);T&&await this.X(E.profile,async F=>{if(E.syncResource===F.resource)return await F.replace(T),!0})}async accept(v,E,T,F){this.db(),await this.X(v.profile,async U=>{if(v.syncResource===U.resource)return await U.accept(E,T),F&&await U.apply((0,b.$ig)(F)?!1:F.force,(0,t.$vnb)((0,R.$Yg)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async E=>{if(E.resource!==t.SyncResource.GlobalState&&await E.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async E=>{if(await E.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(v){this.H.error(v)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,p.StorageScope.APPLICATION);for(const[v]of this.z.values())try{await v.resetLocal()}catch(E){this.H.error(E)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const v=this.J.keys(p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),E=[];for(const F of v){if(!F.endsWith(".lastSyncUserData"))continue;const U=F.split(".");U.length===3&&E.push([F,U[0]])}if(!E.length)return;const T=new O.$Sc;try{let F=this.z.get(this.M.defaultProfile.id)?.[0];F||(F=T.add(this.G.createInstance(a,this.M.defaultProfile,void 0)));const U=F.enabled.find(V=>V.resource===t.SyncResource.Profiles);if(!U)return;const K=(await U.getLastSyncedProfiles())?.map(V=>V.collection)??[];for(const[V,x]of E)K.includes(x)||(this.H.info(`Removing last sync state for stale profile: ${x}`),this.J.remove(V,p.StorageScope.APPLICATION))}finally{T.dispose()}}async cleanUpRemoteData(){const v=await this.N.getRemoteSyncedProfiles(),E=v.map(j=>j.collection),T=await this.D.getAllCollections(),F=T.filter(j=>!E.includes(j));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(j=>this.D.deleteCollection(j))),this.H.info("Deleted redundant collections on server"));const U=v.filter(j=>T.includes(j.collection));if(U.length!==v.length){const j=this.G.createInstance(s.$3dc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await j.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await j.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{j.dispose()}}}async saveRemoteActivityData(v){this.db();const E=await this.D.getActivityData();await this.C.writeFile(v,E)}async extractActivityData(v,E){const T=(await this.C.readFile(v)).value.toString(),F=JSON.parse(T);if(F.resources)for(const U in F.resources)for(const j of F.resources[U])await this.O.writeResource(U,j.content,new Date(j.created*1e3),void 0,E);if(F.collections)for(const U in F.collections)for(const j in F.collections[U].resources)for(const K of F.collections[U].resources?.[j]??[])await this.O.writeResource(j,K.content,new Date(K.created*1e3),U,E)}async X(v,E){const T=new O.$Sc;try{const F=this.z.get(v.id);if(F){const x=await this.Y(F[0],E,T);return(0,b.$jg)(x)?null:x}if(v.isDefault){const x=T.add(this.G.createInstance(a,v,void 0)),H=await this.Y(x,E,T);return(0,b.$jg)(H)?null:H}if(this.M.isEnabled())return null;const U=T.add(this.G.createInstance(s.$3dc,v,void 0)),j=await this.D.manifest(null),V=(await U.getRemoteSyncedProfiles(j?.latest??null)||[]).find(x=>x.id===v.id);if(V){const x=T.add(this.G.createInstance(a,v,V.collection)),H=await this.Y(x,E,T);return(0,b.$jg)(H)?null:H}return null}finally{T.dispose()}}async Y(v,E,T){const F=[...v.enabled,...v.disabled.reduce((U,j)=>(j!==t.SyncResource.WorkspaceState&&U.push(T.add(v.createSynchronizer(j))),U),[])];for(const U of F){const j=await E(U);if(!(0,b.$jg)(j))return j}}Z(v){const E=this.f;this.f!==v&&(this.f=v,this.g.fire(v),E===t.SyncStatus.HasConflicts&&this.ab())}$(){const v=this.bb().map(E=>E.conflicts).flat();(0,I.$tb)(this.j,v,(E,T)=>E.profile.id===T.profile.id&&E.syncResource===T.syncResource&&(0,I.$tb)(E.conflicts,T.conflicts,(F,U)=>(0,k.$9g)(F.previewResource,U.previewResource)))||(this.j=v,this.m.fire(v))}ab(){this.status===t.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,p.StorageScope.APPLICATION,p.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(v,E){let T=this.z.get(v.id);if(T&&T[0].collection!==E?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(v.id)),!T){const F=new O.$Sc,U=F.add(this.G.createInstance(a,v,E?.collection));F.add(U.onDidChangeStatus(j=>this.Z(j))),F.add(U.onDidChangeConflicts(j=>this.$())),F.add(U.onDidChangeLocal(j=>this.h.fire(j))),this.z.set(v.id,T=[U,F])}return T[0]}bb(){const v=[];for(const[E]of this.z.values())v.push(E);return v}cb(){this.z.forEach(([,v])=>v.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$6dc=r,e.$6dc=r=ve([Q(0,$.$0k),Q(1,t.$rnb),Q(2,t.$qnb),Q(3,l.$Bi),Q(4,t.$Gnb),Q(5,S.$9l),Q(6,p.$fq),Q(7,t.$Bnb),Q(8,g.$Jl),Q(9,t.$Dnb),Q(10,t.$snb)],r);let a=class extends O.$Tc{get enabled(){return this.f.sort((v,E)=>v[1]-E[1]).map(([v])=>v)}get disabled(){return t.$nnb.filter(v=>!this.r.isResourceEnabled(v))}get status(){return this.g}get conflicts(){return this.m}constructor(v,E,T,F,U,j,K,V,x,H){super(),this.profile=v,this.collection=E,this.r=T,this.t=F,this.u=U,this.w=j,this.y=K,this.z=V,this.C=x,this.D=H,this.f=[],this.g=t.SyncStatus.Idle,this.h=this.B(new N.$je),this.onDidChangeStatus=this.h.event,this.j=this.B(new N.$je),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new N.$je),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([ie,W])=>this.F(ie,W))),this.B((0,O.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.$nnb)T.isResourceEnabled(ie)&&this.G(ie)}F(v,E){E?this.G(v):this.H(v)}G(v){if(this.f.some(([U])=>U.resource===v))return;if(v===t.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(v===t.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||v===t.SyncResource.WorkspaceState)return;if(v!==t.SyncResource.Profiles&&this.profile.useDefaultFlags?.[v]){this.z.debug(`Skipping syncing ${v} in ${this.profile.name} because it is already synced by default profile`);return}const E=new O.$Sc,T=E.add(this.createSynchronizer(v));E.add(T.onDidChangeStatus(()=>this.L())),E.add(T.onDidChangeConflicts(()=>this.M())),E.add(T.onDidChangeLocal(()=>this.j.fire(v)));const F=this.N(v);this.f.push([T,F,E])}H(v){const E=this.f.findIndex(([T])=>T.resource===v);if(E!==-1){const[[T,,F]]=this.f.splice(E,1);F.dispose(),this.L(),T.stop().then(null,U=>this.z.error(U))}}createSynchronizer(v){switch(v){case t.SyncResource.Settings:return this.t.createInstance(o.$acc,this.profile,this.collection);case t.SyncResource.Keybindings:return this.t.createInstance(m.$0bc,this.profile,this.collection);case t.SyncResource.Snippets:return this.t.createInstance(h.$fcc,this.profile,this.collection);case t.SyncResource.Tasks:return this.t.createInstance(i.$icc,this.profile,this.collection);case t.SyncResource.GlobalState:return this.t.createInstance(P.$XNb,this.profile,this.collection);case t.SyncResource.Extensions:return this.t.createInstance(w.$5bc,this.profile,this.collection);case t.SyncResource.Profiles:return this.t.createInstance(s.$3dc,this.profile,this.collection)}}async sync(v,E,T,F){if(F.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const j=[],K=(0,t.$vnb)(T),V=(this.collection?v?.collections?.[this.collection]?.latest:v?.latest)??null,x=E?await this.I(V):{};for(const H of U){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(E){const ie=await H.preview(V,x,K);if(ie)for(const W of ie.resourcePreviews)(W.localChange!==t.Change.None||W.remoteChange!==t.Change.None)&&W.mergeState===t.MergeState.Preview&&await H.merge(W.previewResource)}else await H.sync(V,K)}catch(ie){const W=t.$wnb.toUserDataSyncError(ie);if(y(W,T,this.w,this.y),u(ie))throw W;this.z.error(ie),this.z.error(`${H.resource}: ${(0,A.$nj)(ie)}`),j.push([H.resource,W])}}return j}finally{this.L()}}async apply(v,E){const T=(0,t.$vnb)(v);for(const F of this.enabled){if(E.isCancellationRequested)return;try{await F.apply(!1,T)}catch(U){const j=t.$wnb.toUserDataSyncError(U);if(y(j,v,this.w,this.y),u(U))throw j;this.z.error(U),this.z.error(`${F.resource}: ${(0,A.$nj)(U)}`)}}}async stop(){for(const v of this.enabled)try{v.status!==t.SyncStatus.Idle&&await v.stop()}catch(E){this.z.error(E)}}async resetLocal(){for(const v of this.enabled)try{await v.resetLocal()}catch(E){this.z.error(`${v.resource}: ${(0,A.$nj)(E)}`),this.z.error(E)}}async I(v){if(!this.profile.isDefault)return{};const E=this.D.getValue(t.$jnb),T=this.enabled.find(F=>F instanceof o.$acc);if(T){const F=await T.getRemoteUserDataSyncConfiguration(v);return{...E,...F}}return E}J(v){this.g!==v&&(this.g=v,this.h.fire(v))}L(){return this.M(),this.enabled.some(v=>v.status===t.SyncStatus.HasConflicts)?this.J(t.SyncStatus.HasConflicts):this.enabled.some(v=>v.status===t.SyncStatus.Syncing)?this.J(t.SyncStatus.Syncing):this.J(t.SyncStatus.Idle)}M(){const v=this.enabled.filter(E=>E.status===t.SyncStatus.HasConflicts).filter(E=>E.conflicts.conflicts.length>0).map(E=>E.conflicts);(0,I.$tb)(this.m,v,(E,T)=>E.syncResource===T.syncResource&&(0,I.$tb)(E.conflicts,T.conflicts,(F,U)=>(0,k.$9g)(F.previewResource,U.previewResource)))||(this.m=v,this.n.fire(v))}N(v){switch(v){case t.SyncResource.Settings:return 0;case t.SyncResource.Keybindings:return 1;case t.SyncResource.Snippets:return 2;case t.SyncResource.Tasks:return 3;case t.SyncResource.GlobalState:return 4;case t.SyncResource.Extensions:return 5;case t.SyncResource.Profiles:return 6;case t.SyncResource.WorkspaceState:return 7}}};a=ve([Q(2,t.$Bnb),Q(3,l.$Bi),Q(4,f.$ip),Q(5,t.$qnb),Q(6,S.$9l),Q(7,t.$Gnb),Q(8,g.$Jl),Q(9,d.$9i)],a);function u(C){if(C instanceof t.$wnb)switch(C.code){case t.UserDataSyncErrorCode.MethodNotFound:case t.UserDataSyncErrorCode.TooLarge:case t.UserDataSyncErrorCode.TooManyRequests:case t.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case t.UserDataSyncErrorCode.LocalTooManyRequests:case t.UserDataSyncErrorCode.LocalTooManyProfiles:case t.UserDataSyncErrorCode.Gone:case t.UserDataSyncErrorCode.UpgradeRequired:case t.UserDataSyncErrorCode.IncompatibleRemoteContent:case t.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function y(C,v,E,T){T.publicLog2("sync/error",{code:C.code,serverCode:C instanceof t.$xnb?String(C.serverCode):void 0,url:C instanceof t.$xnb?C.url:void 0,resource:C.resource,executionId:v,service:E.userDataSyncStore.url.toString()})}}),define(he[232],ue([0,1,3,2,9,19,24]),function(oe,e,I,c,L,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=e.$qhc=void 0;function O(f,$){return{...f,profile:(0,A.$Kl)(f.profile,$.profilesHome.scheme)}}function k(f){return{created:f.created,uri:L.URI.revive(f.uri)}}class b{constructor($,l,p){this.c=$,this.d=l,this.f=p,this.a=new Map,this.b=new I.$je}listen($,l){switch(l){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${l}`)}async call($,l,p){try{return await this.g($,l,p)}catch(S){throw this.f.error(S),S}}async g($,l,p){switch(l){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(p[0]));case"accept":return this.c.accept(O(p[0],this.d),L.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(k(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(p[0]),L.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if(l.startsWith("manualSync/")){const S=l.substring(11),g=p[0],w=this.h(g);switch(p=p.slice(1),S){case"merge":return w.merge();case"apply":return w.apply().then(()=>this.a.delete(this.j(w.id)));case"stop":return w.stop().finally(()=>this.a.delete(this.j(w.id)))}}throw new Error("Invalid call")}h($){const l=this.a.get(this.j($));if(!l)throw new Error(`Manual sync taks not found: ${$}`);return l}async i(){const $=await this.c.createManualSyncTask();return this.a.set(this.j($.id),$),$.id}j($){return`manualSyncTask-${$}`}}e.$qhc=b;let R=class extends c.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor($,l){super(),this.n=l,this.b=N.SyncStatus.Uninitialized,this.c=this.B(new I.$je),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$je),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new I.$je),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new I.$je),this.onSyncErrors=this.m.event,this.a={call(p,S,g){return $.call(p,S,g).then(null,w=>{throw N.$wnb.toUserDataSyncError(w)})},listen(p,S){return $.listen(p,S)}},this.a.call("_getInitialData").then(([p,S,g])=>{this.s(p),this.t(S),g&&this.u(g),this.B(this.a.listen("onDidChangeStatus")(w=>this.s(w))),this.B(this.a.listen("onDidChangeLastSyncTime")(w=>this.u(w)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(S=>({...S,error:N.$wnb.toUserDataSyncError(S.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const $=await this.a.call("createManualSyncTask"),l=this;return new d($,{async call(S,g,w){return l.a.call(`manualSync/${S}`,[$,...Array.isArray(g)?g:[g]],w)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept($,l,p,S){return this.a.call("accept",[$,l,p,S])}resolveContent($){return this.a.call("resolveContent",[$])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace($){return this.a.call("replace",[$])}saveRemoteActivityData($){return this.a.call("getRemoteActivityData",[$])}extractActivityData($,l){return this.a.call("extractActivityData",[$,l])}async s($){this.b=$,this.c.fire($)}async t($){this.f=$.map(l=>({syncResource:l.syncResource,profile:(0,A.$Kl)(l.profile,this.n.profilesHome.scheme),conflicts:l.conflicts.map(p=>({...p,baseResource:L.URI.revive(p.baseResource),localResource:L.URI.revive(p.localResource),remoteResource:L.URI.revive(p.remoteResource),previewResource:L.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u($){this.h!==$&&(this.h=$,this.j.fire($))}};e.$rhc=R,e.$rhc=R=ve([Q(1,A.$Jl)],R);class d extends c.$Tc{constructor($,l){super(),this.id=$,this.a=l}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(he[126],ue([0,1,6,25,8,3,2,133,5,20,12,9,31,21,15,7,23,61,49,16,24]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NNb=e.$MNb=e.$LNb=e.$KNb=e.$JNb=void 0;const o="configurationSync.store",h="sync.previous.store",i="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",n=100,r=1e3*60*5;let a=class extends N.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$znb,P.StorageScope.APPLICATION)}set c(T){this.h.store(m.$znb,T,P.StorageScope.APPLICATION,k.$p?P.StorageTarget.USER:P.StorageTarget.MACHINE)}constructor(T,F,U){super(),this.f=T,this.g=F,this.h=U,this.a=this.B(new A.$je),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const j=this.B(new N.$Sc);this.B(A.Event.filter(U.onDidChangeValue(P.StorageScope.APPLICATION,m.$znb,j),()=>this.c!==this.userDataSyncStore?.type,j)(()=>this.j()))}j(){this.b=this.m(this.f[o]),this.a.fire()}m(T){if(T&&(T=k.$p&&T.web?{...T,...T.web}:T,(0,R.$cg)(T.url)&&(0,R.$eg)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(F=>Array.isArray(T.authenticationProviders[F].scopes)))){const F=T,U=!!F.canSwitch,j=F.url===F.insidersUrl?"insiders":"stable",K=(U?this.c:void 0)||j,V=K==="insiders"?F.insidersUrl:K==="stable"?F.stableUrl:F.url;return{url:d.URI.parse(V),type:K,defaultType:j,defaultUrl:d.URI.parse(F.url),stableUrl:d.URI.parse(F.stableUrl),insidersUrl:d.URI.parse(F.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:F.authenticationProviders[H].scopes}),x),[])}}}};e.$JNb=a,e.$JNb=a=ve([Q(0,S.$qk),Q(1,$.$9i),Q(2,P.$fq)],a);let u=class extends a{constructor(T,F,U){super(T,F,U);const j=this.h.get(h,P.StorageScope.APPLICATION);j&&(this.n=JSON.parse(j));const K=this.f[o];K?this.h.store(h,JSON.stringify(K),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE):this.h.remove(h,P.StorageScope.APPLICATION)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$KNb=u,e.$KNb=u=ve([Q(0,S.$qk),Q(1,$.$9i),Q(2,P.$fq)],u);let y=class extends N.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(T,F,U,j,K,V,x){super(),this.n=U,this.r=j,this.s=x,this.g=this.B(new A.$je),this.onTokenFailed=this.g.event,this.h=this.B(new A.$je),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$je),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,w.$lq)(K,V,x).then(H=>{const ie={"X-Client-Name":`${F.applicationName}${k.$p?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.f=new v(n,r,this.n,this.r),this.u(),this.B((0,N.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,F){this.b={token:T,type:F}}t(T){this.a=T?(0,b.$dh)(T,"v1"):void 0}u(){const T=this.s.getNumber(i,P.StorageScope.APPLICATION);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(i,this.j.getTime(),P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),this.w=(0,I.$ph)(F=>(0,I.$Dh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(i,P.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$dh)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const U=await this.D(F,{type:"GET",headers:T},[],c.CancellationToken.None);return(await(0,g.$$p)(U))?.map(({id:j})=>j)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$dh)(this.a,"collection").toString();T={...T},T["Content-Type"]=O.$8s.text;const U=await this.D(F,{type:"POST",headers:T},[],c.CancellationToken.None),j=await(0,g.$0p)(U);if(!j)throw new m.$xnb("Server did not return the collection id",F,m.UserDataSyncErrorCode.NoCollection,U.res.statusCode,U.res.headers[m.$tnb]);return j}async deleteCollection(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=T?(0,b.$dh)(this.a,"collection",T).toString():(0,b.$dh)(this.a,"collection").toString();F={...F},await this.D(U,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async getAllResourceRefs(T,F){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,F,T),j={},K=await this.D(U.toString(),{type:"GET",headers:j},[],c.CancellationToken.None);return(await(0,g.$$p)(K)||[]).map(({url:x,created:H})=>({ref:(0,b.$fh)(U,U.with({path:x})),created:H*1e3}))}async resolveResourceContent(T,F,U,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,b.$dh)(this.z(this.a,U,T),F).toString();j={...j},j["Cache-Control"]="no-cache";const V=await this.D(K,{type:"GET",headers:j},[],c.CancellationToken.None);return await(0,g.$0p)(V)}async deleteResource(T,F,U){if(!this.a)throw new Error("No settings sync store url configured.");const j=F!==null?(0,b.$dh)(this.z(this.a,U,T),F).toString():this.z(this.a,U,T).toString(),K={};await this.D(j,{type:"DELETE",headers:K},[],c.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.$dh)(this.a,"resource").toString(),F={"Content-Type":O.$8s.text};await this.D(T,{type:"DELETE",headers:F},[],c.CancellationToken.None)}async readResource(T,F,U,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,b.$dh)(this.z(this.a,U,T),"latest").toString();j={...j},j["Cache-Control"]="no-cache",F&&(j["If-None-Match"]=F.ref);const V=await this.D(K,{type:"GET",headers:j},[304],c.CancellationToken.None);let x=null;if(V.res.statusCode===304&&(x=F),x===null){const H=V.res.headers.etag;if(!H)throw new m.$xnb("Server did not return the ref",K,m.UserDataSyncErrorCode.NoRef,V.res.statusCode,V.res.headers[m.$tnb]);const ie=await(0,g.$0p)(V);if(!ie&&V.res.statusCode===304)throw new m.$xnb("Empty response",K,m.UserDataSyncErrorCode.EmptyResponse,V.res.statusCode,V.res.headers[m.$tnb]);x={ref:H,content:ie}}return x}async writeResource(T,F,U,j,K={}){if(!this.a)throw new Error("No settings sync store url configured.");const V=this.z(this.a,j,T).toString();K={...K},K["Content-Type"]=O.$8s.text,U&&(K["If-Match"]=U);const x=await this.D(V,{type:"POST",data:F,headers:K},[],c.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new m.$xnb("Server did not return the ref",V,m.UserDataSyncErrorCode.NoRef,x.res.statusCode,x.res.headers[m.$tnb]);return H}async manifest(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,b.$dh)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",T&&(F["If-None-Match"]=T.ref);const j=await this.D(U,{type:"GET",headers:F},[304],c.CancellationToken.None);let K=null;if(j.res.statusCode===304&&(K=T),!K){const x=j.res.headers.etag;if(!x)throw new m.$xnb("Server did not return the ref",U,m.UserDataSyncErrorCode.NoRef,j.res.statusCode,j.res.headers[m.$tnb]);const H=await(0,g.$0p)(j);if(!H&&j.res.statusCode===304)throw new m.$xnb("Empty response",U,m.UserDataSyncErrorCode.EmptyResponse,j.res.statusCode,j.res.headers[m.$tnb]);H&&(K={...JSON.parse(H),ref:x})}const V=this.s.get(s,P.StorageScope.APPLICATION);return V&&K&&V!==K.session&&this.C(),K===null&&V&&this.C(),K&&this.s.store(s,K.session,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE),K}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.$dh)(this.a,"download").toString(),F={},U=await this.D(T,{type:"GET",headers:F},[],c.CancellationToken.None);if(!(0,g.$7p)(U))throw new m.$xnb("Server returned "+U.res.statusCode,T,m.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[m.$tnb]);if((0,g.$8p)(U))throw new m.$xnb("Empty response",T,m.UserDataSyncErrorCode.EmptyResponse,U.res.statusCode,U.res.headers[m.$tnb]);return U.stream}z(T,F,U){return F?(0,b.$dh)(T,"collection",F,"resource",U):(0,b.$dh)(T,"resource",U)}C(){this.s.remove(s,P.StorageScope.APPLICATION),this.s.remove(t,P.StorageScope.APPLICATION)}async D(T,F,U,j){if(!this.b)throw new m.$xnb("No Auth Token Available",T,m.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$xnb(`${F.type} request '${T}' failed because of too many requests (429).`,T,m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const K=await this.c;F.headers={...F.headers||{},...K,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:T,type:F.type,headers:{...F.headers,authorization:void 0}});let V;try{V=await this.f.request(T,F,j)}catch(z){if(!(z instanceof m.$xnb)){let _=m.UserDataSyncErrorCode.RequestFailed;const ne=(0,L.$9)(z).toLowerCase();ne.includes("xhr timeout")?_=m.UserDataSyncErrorCode.RequestTimeout:ne.includes("protocol")&&ne.includes("not supported")?_=m.UserDataSyncErrorCode.RequestProtocolNotSupported:ne.includes("request path contains unescaped characters")?_=m.UserDataSyncErrorCode.RequestPathNotEscaped:ne.includes("headers must be an object")?_=m.UserDataSyncErrorCode.RequestHeadersNotObject:(0,L.$3)(z)&&(_=m.UserDataSyncErrorCode.RequestCanceled),z=new m.$xnb(`Connection refused for the request '${T}'.`,T,_,void 0,void 0)}throw this.r.info("Request failed",T),z}const x=V.res.headers[m.$tnb],H={url:T,status:V.res.statusCode,"execution-id":F.headers[m.$unb],"operation-id":x},ie=(0,g.$7p)(V)||V.res.statusCode&&U.includes(V.res.statusCode);let W="";if(ie?this.r.trace("Request succeeded",H):(W=await(0,g.$9p)(V)||"",this.r.info("Request failed",H,W)),V.res.statusCode===401||V.res.statusCode===403){if(this.b=void 0,V.res.statusCode===401)throw this.g.fire(m.UserDataSyncErrorCode.Unauthorized),new m.$xnb(`${F.type} request '${T}' failed because of Unauthorized (401).`,T,m.UserDataSyncErrorCode.Unauthorized,V.res.statusCode,x);if(V.res.statusCode===403)throw this.g.fire(m.UserDataSyncErrorCode.Forbidden),new m.$xnb(`${F.type} request '${T}' failed because the access is forbidden (403).`,T,m.UserDataSyncErrorCode.Forbidden,V.res.statusCode,x)}if(this.h.fire(),V.res.statusCode===404)throw new m.$xnb(`${F.type} request '${T}' failed because the requested resource is not found (404).`,T,m.UserDataSyncErrorCode.NotFound,V.res.statusCode,x);if(V.res.statusCode===405)throw new m.$xnb(`${F.type} request '${T}' failed because the requested endpoint is not found (405). ${W}`,T,m.UserDataSyncErrorCode.MethodNotFound,V.res.statusCode,x);if(V.res.statusCode===409)throw new m.$xnb(`${F.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,m.UserDataSyncErrorCode.Conflict,V.res.statusCode,x);if(V.res.statusCode===410)throw new m.$xnb(`${F.type} request '${T}' failed because the requested resource is not longer available (410).`,T,m.UserDataSyncErrorCode.Gone,V.res.statusCode,x);if(V.res.statusCode===412)throw new m.$xnb(`${F.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,m.UserDataSyncErrorCode.PreconditionFailed,V.res.statusCode,x);if(V.res.statusCode===413)throw new m.$xnb(`${F.type} request '${T}' failed because of too large payload (413).`,T,m.UserDataSyncErrorCode.TooLarge,V.res.statusCode,x);if(V.res.statusCode===426)throw new m.$xnb(`${F.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,m.UserDataSyncErrorCode.UpgradeRequired,V.res.statusCode,x);if(V.res.statusCode===429){const z=V.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new m.$xnb(`${F.type} request '${T}' failed because of too many requests (429).`,T,m.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,V.res.statusCode,x)):new m.$xnb(`${F.type} request '${T}' failed because of too many requests (429).`,T,m.UserDataSyncErrorCode.TooManyRequests,V.res.statusCode,x)}if(!ie)throw new m.$xnb("Server returned "+V.res.statusCode,T,m.UserDataSyncErrorCode.Unknown,V.res.statusCode,x);return V}F(T){let F=this.s.get(t,P.StorageScope.APPLICATION);F===void 0&&(F=(0,f.$Yg)(),this.s.store(t,F,P.StorageScope.APPLICATION,P.StorageTarget.MACHINE)),T["X-Machine-Session-Id"]=F;const U=this.s.get(s,P.StorageScope.APPLICATION);U!==void 0&&(T["X-User-Session-Id"]=U)}};e.$LNb=y,e.$LNb=y=ve([Q(1,S.$qk),Q(2,g.$5p),Q(3,m.$Gnb),Q(4,l.$Ji),Q(5,p.$0k),Q(6,P.$fq)],y);let C=class extends y{constructor(T,F,U,j,K,V,x){super(T.userDataSyncStore?.url,F,U,j,K,V,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$MNb=C,e.$MNb=C=ve([Q(0,m.$qnb),Q(1,S.$qk),Q(2,g.$5p),Q(3,m.$Gnb),Q(4,l.$Ji),Q(5,p.$0k),Q(6,P.$fq)],C);class v{constructor(T,F,U,j){this.c=T,this.d=F,this.f=U,this.g=j,this.a=[],this.b=void 0}request(T,F,U){if(this.h()&&this.i(),F.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$xnb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,m.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(F,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$NNb=v}),define(he[233],ue([0,1,3,2,9,21,23,16,126]),function(oe,e,I,c,L,A,N,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=e.$nhc=e.$mhc=void 0;class b{constructor(l){this.a=l}listen(l,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(l,p,S){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(S)}throw new Error("Invalid call")}}e.$mhc=b;class R extends c.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(l){super(),this.c=l,this.b=this.B(new I.$je),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(S=>{this.a=S,this.b.fire(S)}))})}updateAccount(l){return this.c.call("updateAccount",l)}}e.$nhc=R;class d{constructor(l){this.a=l}listen(l,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(l,p,S){switch(p){case"switch":return this.a.switch(S[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$ohc=d;let f=class extends k.$JNb{constructor(l,p,S,g){super(p,S,g),this.n=l,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(l){return this.n.call("switch",[l])}async getPreviousUserDataSyncStore(){const l=await this.n.call("getPreviousUserDataSyncStore");return this.r(l)}r(l){return{url:L.URI.revive(l.url),type:l.type,defaultUrl:L.URI.revive(l.defaultUrl),insidersUrl:L.URI.revive(l.insidersUrl),stableUrl:L.URI.revive(l.stableUrl),canSwitch:l.canSwitch,authenticationProviders:l.authenticationProviders}}};e.$phc=f,e.$phc=f=ve([Q(1,N.$qk),Q(2,A.$9i),Q(3,O.$fq)],f)}),define(he[234],ue([0,1,3,57,23,16,18,229,24,82,86]),function(oe,e,I,c,L,A,N,O,k,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;let d=class extends O.$7dc{constructor($,l,p,S,g,w,P,m,o,h,i){super($,l,p,S,g,P,m,o,h,i),this.B(I.Event.debounce(I.Event.any(I.Event.map(w.onDidFocusMainWindow,()=>"windowFocus"),I.Event.map(w.onDidOpenMainWindow,()=>"windowOpen")),(s,t)=>s?[...s,t]:[t],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$Lhc=d,e.$Lhc=d=ve([Q(0,L.$qk),Q(1,k.$qnb),Q(2,k.$rnb),Q(3,k.$Bnb),Q(4,k.$Cnb),Q(5,c.$Hfc),Q(6,k.$Gnb),Q(7,b.$_Lb),Q(8,N.$9l),Q(9,R.$dnb),Q(10,A.$fq)],d)}),define(he[235],ue([0,1,75,22,5,20]),function(oe,e,I,c,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0,e.$8ec=N,e.$9ec=O,e.$0ec=k,e.$7ec=128/4;function N(b){function R(){let d=b.scheme===c.Schemas.file?(0,A.$4g)(b):b.toString();return L.$l||(d=d.toLowerCase()),(0,I.createHash)("md5").update(d).digest("hex")}return{id:R(),configPath:b}}function O(b,R){function d(){if(b.scheme!==c.Schemas.file)return(0,I.createHash)("md5").update(b.toString()).digest("hex");if(!R)return;let $;return L.$l?$=R.ino:L.$k?$=R.birthtime.getTime():L.$j&&(typeof R.birthtimeMs=="number"?$=Math.floor(R.birthtimeMs):$=R.birthtime.getTime()),(0,I.createHash)("md5").update(b.fsPath).update($?String($):"").digest("hex")}const f=d();if(typeof f=="string")return{id:f,uri:b}}function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(he[236],ue([0,1,6,8,2,13,30,15,10,79,115,235,57,56,22]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;let p=class extends L.$Tc{constructor(g,w,P,m){super(),this.a=g,this.b=w,this.c=P,this.f=m,this.B(new I.$Oh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const g=this.a.workspaceStorageHome.with({scheme:l.Schemas.file}).fsPath,w=await N.Promises.readdir(g),P=new b.$KMb(this.f.getChannel("storage"));await Promise.all(w.map(async m=>{const o=(0,A.$ic)(g,m);m.length===d.$7ec||m===R.$Oi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(s=>s.workspace?.id===m)||await P.isUsed(o)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await N.Promises.rm(o))}))}catch(g){(0,c.$Y)(g)}}};e.$ihc=p,e.$ihc=p=ve([Q(0,O.$Ki),Q(1,k.$0j),Q(2,f.$Hfc),Q(3,$.$Zgc)],p)}),define(he[127],ue([0,1,75,67,38,244,14,8,3,2,13,5,31,42,69]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$ti=e.$si=e.$ri=void 0,e.$ui=t,e.$vi=n,e.$xi=u,e.$yi=y;const p=3e4;class S{traceSocketEvent(v,E){l.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,E)}constructor(v,E=""){this.f=!0,this.debugLabel=E,this.socket=v,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent(l.SocketDiagnosticsEventType.Error,{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,O.$Y)(F)}},this.socket.on("error",this.a);let T;this.b=F=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Close,{hadError:F}),this.f=!1,T&&clearTimeout(T)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,T=setTimeout(()=>v.destroy(),p)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const E=T=>{this.traceSocketEvent(l.SocketDiagnosticsEventType.Read,T),v(N.$Le.wrap(T))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(v){const E=T=>{v({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:T,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(v){const E=()=>{v()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(l.SocketDiagnosticsEventType.Write,v),this.socket.write(v.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,O.$Y)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,O.$Y)(E)}}end(){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((v,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),v();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),this.traceSocketEvent(l.SocketDiagnosticsEventType.NodeDrainEnd),v()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.$ri=S;var g;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var w;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(w||(w={}));class P extends b.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,E){this.socket.traceSocketEvent(v,E)}constructor(v,E,T,F){super(),this.f=this.B(new k.$je),this.g=this.B(new k.$je),this.h=!1,this.j={state:w.PeekHeader,readLen:g.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent(l.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:T?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new m(this,E,T,F,this.f,(U,j)=>this.m(U,j))),this.B(this.a.onError(U=>{console.error(U),(0,O.$Y)(U),this.g.fire({type:l.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:U})})),this.b=new l.$mi,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let E=0;for(;E<v.byteLength;)this.a.writeMessage(v.slice(E,Math.min(E+g.MaxWebSocketMessageLength,v.byteLength)),{compressed:!0,opcode:2}),E+=g.MaxWebSocketMessageLength}m(v,{compressed:E,opcode:T}){if(this.h)return;this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,v);let F=g.MinHeaderByteSize;v.byteLength<126?F+=0:v.byteLength<2**16?F+=2:F+=8;const U=N.$Le.alloc(F),j=E?64:0,K=T&15;if(U.writeUInt8(128|j|K,0),v.byteLength<126)U.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){U.writeUInt8(126,1);let V=1;U.writeUInt8(v.byteLength>>>8&255,++V),U.writeUInt8(v.byteLength>>>0&255,++V)}else{U.writeUInt8(127,1);let V=1;U.writeUInt8(0,++V),U.writeUInt8(0,++V),U.writeUInt8(0,++V),U.writeUInt8(0,++V),U.writeUInt8(v.byteLength>>>24&255,++V),U.writeUInt8(v.byteLength>>>16&255,++V),U.writeUInt8(v.byteLength>>>8&255,++V),U.writeUInt8(v.byteLength>>>0&255,++V)}this.socket.write(N.$Le.concat([U,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const E=this.b.peek(this.j.readLen),T=E.readUInt8(0),F=(T&128)>>>7,U=(T&64)>>>6,j=T&15,K=E.readUInt8(1),V=(K&128)>>>7,x=K&127;this.j.state=w.ReadHeader,this.j.readLen=g.MinHeaderByteSize+(V?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const E=this.b.read(this.j.readLen),T=E.readUInt8(1),F=(T&128)>>>7;let U=T&127,j=1;U===126?U=E.readUInt8(++j)*2**8+E.readUInt8(++j):U===127&&(U=E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*0+E.readUInt8(++j)*2**24+E.readUInt8(++j)*2**16+E.readUInt8(++j)*2**8+E.readUInt8(++j));let K=0;F&&(K=E.readUInt8(++j)*2**24+E.readUInt8(++j)*2**16+E.readUInt8(++j)*2**8+E.readUInt8(++j)),this.j.state=w.ReadBody,this.j.readLen=U,this.j.mask=K,this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const E=this.b.read(this.j.readLen);this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,E),i(E,this.j.mask),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,E),this.j.state=w.PeekHeader,this.j.readLen=g.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(l.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$si=P;class m extends b.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:N.$Le.alloc(0)}constructor(v,E,T,F,U,j){super(),this.n=v,this.r=U,this.s=j,this.a=this.B(new k.$je),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$je),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$je),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new o(this.n,F,T,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(v,E){this.g.push({data:v,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:E}=this.g.shift();if(this.f&&E.compressed){const T=await this.w(this.f,v);this.s(T,E)}else this.s(v,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,E){return new Promise((T,F)=>{v.write(E),v.flush(U=>T(U))})}acceptFrame(v,E,T){this.h.push({data:v,isCompressed:E,isLastFrameOfMessage:T}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const E=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,E,T){return new Promise((F,U)=>{v.write(E),T&&v.write(N.$Le.fromByteArray([0,0,255,255])),v.flush(j=>F(j))})}}class o extends b.$Tc{get recordedInflateBytes(){return this.j?N.$Le.concat(this.f):N.$Le.alloc(0)}constructor(v,E,T,F){super(),this.h=v,this.j=E,this.a=this.B(new k.$je),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(F),this.b.on("error",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateError,{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateData,U),this.g.push(N.$Le.wrap(U))}),T&&(this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialWrite,T.buffer),this.b.write(T.buffer),this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateWrite,v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent(l.SocketDiagnosticsEventType.zlibInflateFlushFired);const E=N.$Le.concat(this.g);this.g.length=0,v(E)})}}class h extends b.$Tc{constructor(v,E){super(),this.g=v,this.a=this.B(new k.$je),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",T=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateError,{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateData,T),this.f.push(N.$Le.wrap(T))})}write(v){this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateWrite,v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent(l.SocketDiagnosticsEventType.zlibDeflateFlushFired);let E=N.$Le.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),v(E)})}}function i(C,v){if(v===0)return;const E=C.byteLength>>>2;for(let V=0;V<E;V++){const x=C.readUInt32BE(V*4);C.writeUInt32BE(x^v,V*4)}const T=E*4,F=C.byteLength-T,U=v>>>24&255,j=v>>>16&255,K=v>>>8&255;F>=1&&C.writeUInt8(C.readUInt8(T)^U,T),F>=2&&C.writeUInt8(C.readUInt8(T+1)^j,T+1),F>=3&&C.writeUInt8(C.readUInt8(T+2)^K,T+2)}e.$ti=process.env.XDG_RUNTIME_DIR;const s={[d.Platform.Linux]:107,[d.Platform.Mac]:103};function t(){const C=(0,f.$Yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const v=process.platform!=="darwin"&&e.$ti?e.$ti:(0,L.tmpdir)(),E=(0,R.$ic)(v,`vscode-ipc-${C}.sock`);return r(E),E}function n(C,v,E){const F=(0,I.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${E}-${v}-sock`;const U=E.substr(0,4),j=v.substr(0,6);let K;return process.platform!=="darwin"&&e.$ti&&!process.env.VSCODE_PORTABLE?K=(0,R.$ic)(e.$ti,`vscode-${F}-${U}-${j}.sock`):K=(0,R.$ic)(C,`${U}-${j}.sock`),r(K),K}function r(C){const v=s[d.$v];typeof v=="number"&&C.length>=v&&console.warn(`WARNING: IPC handle "${C}" is longer than ${v} chars, try a shorter --user-data-dir`)}class a extends $.$gi{static b(v){const E=k.Event.fromNodeEventEmitter(v,"connection");return k.Event.map(E,T=>({protocol:new l.$ni(new S(T,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(T,"close"))}))}constructor(v){super(a.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$wi=a;function u(C){return new Promise((v,E)=>{const T=(0,c.createServer)();T.on("error",E),T.listen(C,()=>{T.removeListener("error",E),v(new a(T))})})}function y(C,v){return new Promise((E,T)=>{const F=(0,c.createConnection)(C,()=>{F.removeListener("error",T),E(l.$oi.fromSocket(new S(F,`ipc-client${v}`),v))});F.once("error",T)})}}),define(he[237],ue([0,1,67,127,184]),function(oe,e,I,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0,I=ke(I),e.$Ohc=new class{supports(A){return!0}connect({host:A,port:N},O,k,b){return new Promise((R,d)=>{const f=I.createConnection({host:A,port:N},()=>{f.removeListener("error",d),f.write((0,L.$axb)(O,k,b));const $=l=>{l.toString().indexOf(`\r
\r
`)>=0&&(f.off("data",$),R(new c.$ri(f,b)))};f.on("data",$)});f.setNoDelay(!0),f.once("error",d)})}}}),define(he[238],ue([0,1,67,38,146,127,6,2,5,21,10,23,185,106,108,80,14]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0,I=ke(I),c=ke(c);async function g(h,i,s,t,n){let r;for(let a=3;a&&(r?.dispose(),r=await new w(h,i,s,t,n).waitForReady(),!(n&&L.$2g[n]||!L.$2g[r.tunnelLocalPort]));a--);return r}class w extends O.$Tc{constructor(i,s,t,n,r){super(),this.m=s,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=I.createServer(),this.c=new N.$Bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,s=(0,p.$Jw)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,L.$3g)(i,2,1e3,s),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(i){i.pause();const s=(0,p.$Hw)(this.tunnelRemoteHost)||(0,p.$Jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,f.$Zl)(this.a,s,this.tunnelRemotePort),n=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&i.write(r.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),n.end()}),i.on("close",()=>n.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),n instanceof A.$ri?n.socket.destroy():n.end()}),n instanceof A.$ri?this.t(i,n):this.s(i,n),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),n.end()})}s(i,s){s.onClose(()=>i.destroy()),s.onEnd(()=>i.end()),s.onData(t=>i.write(t.buffer)),i.on("data",t=>s.write(S.$Le.wrap(t))),i.resume()}t(i,s){const t=s.socket;t.on("end",()=>i.end()),t.on("close",()=>i.end()),t.on("error",()=>{i.destroy()}),t.pipe(i),i.pipe(t)}}e.$Qgc=w;let P=class extends p.$Mw{constructor(i,s,t,n,r){super(s,r),this.H=i,this.I=t,this.J=n}isPortPrivileged(i){return(0,p.$Kw)(i,this.t,k.OS,c.release())}F(i,s,t,n,r,a,u,y){const C=this.D(s,t);if(C)return++C.refcount,C.value;if((0,p.$Dw)(i))return this.G(i,s,t,r,a,u,y);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${t} on local port ${r}.`);const v={commit:this.J.commit,quality:this.J.quality,addressProvider:i,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},E=g(v,n,s,t,r);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(s,t,E),E}}};e.$Rgc=P,e.$Rgc=P=ve([Q(0,$.$Tl),Q(1,R.$0j),Q(2,l.$Wl),Q(3,d.$qk),Q(4,b.$9i)],P);let m=class extends P{constructor(i,s,t,n,r){super(i,s,t,n,r)}};e.$Sgc=m,e.$Sgc=m=ve([Q(0,$.$Tl),Q(1,R.$0j),Q(2,l.$Wl),Q(3,d.$qk),Q(4,b.$9i)],m);let o=class extends O.$Tc{constructor(i,s,t,n,r){super(),this.b=i,this.c=s,this.f=t,this.g=n,this.h=r,this.a=new Map}async openTunnel(i,s,t,n,r,a,u,y,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${a}.`),!this.a.has(i)){const v=new m(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(i,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(s,t,n,r,a,u,y,C)}};e.$Tgc=o,e.$Tgc=o=ve([Q(0,$.$Tl),Q(1,R.$0j),Q(2,d.$qk),Q(3,l.$Wl),Q(4,b.$9i)],o)});var it=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(he[245],ue([0,1,38,43,8,2,22,9,17,3,42,150,178,179,188,170,236,161,162,21,183,97,195,98,190,15,118,222,27,110,186,117,74,7,172,173,73,4,169,76,78,198,10,174,102,23,61,16,109,18,111,112,113,48,201,85,114,24,82,228,233,211,86,227,231,232,126,62,226,212,108,194,80,238,189,202,28,203,5,204,163,181,180,84,217,19,52,177,58,225,200,213,107,230,218,11,175,101,223,216,191,157,57,176,234,220,56,224,106,104,237,155,192,144,132,143]),function(oe,e,I,c,L,A,N,O,k,b,R,d,f,$,l,p,S,g,w,P,m,o,h,i,s,t,n,r,a,u,y,C,v,E,T,F,U,j,K,V,x,H,ie,W,z,_,ne,ce,te,Y,G,B,D,J,q,M,Z,ee,X,re,le,ge,pe,Ee,we,be,Se,Ie,ae,de,me,Pe,Oe,Fe,Ne,Le,Ue,qe,He,je,Be,ze,We,Ce,se,fe,$e,ye,Ae,Te,Me,xe,Je,Ye,Ve,_e,Qe,nt,at,Lt,Ct,Tt,Nt,Dt,Ut,Ft,yt,jt,vt,Mt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends A.$Tc{constructor(Re){super(),this.f=Re,this.a=this.B(new d.$OX(this)),this.b=void 0,this.c=this.B(new b.$je),this.g()}g(){let Re=!1;const De=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,d.$PX)(process.parentPort,ht.$4fc.exit,De)}async init(){const Re=await this.h();(0,ee.$lnb)(),Re.invokeFunction(De=>{const Ke=De.get(ie.$0j),Ge=De.get(Y.$9l),et=De.get(fe.$Jl);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,A.$Qc)(Re.createInstance(f.$ehc,this.f.codeCachePath),Re.createInstance($.$fhc),Re.createInstance(S.$ihc),Re.createInstance(p.$hhc),Re.createInstance(l.$ghc),Re.createInstance(Ve.$Fhc),Re.createInstance(xe.$xhc)))}async h(){const Re=new V.$Ai,De={_serviceBrand:void 0,...z.default};Re.set(_.$qk,De);const Ke=new R.$ki(Ze=>Ze==="main"),Ge=new yt.$1gc(this.a,Ke);Re.set(yt.$Zgc,Ge);const et=this.f.policiesData?new ye.$ugc(this.f.policiesData,Ge.getChannel("policy")):new Ae.$so;Re.set(Ae.$qo,et);const Xe=new Bt.$6m(this.f.args,De);Re.set(t.$Ki,Xe);const ot=new W.$qs(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:O.URI.revive(Ze.resource)})),Ge.getChannel("logger"));Re.set(ie.$$j,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(12030,null)})),$t=this.B(new ie.$fk(ft.getLevel())),tt=this.B(new Qe.$qR(ft,[$t]));Re.set(ie.$0j,tt),this.b=this.B(new nt.$Hhc(tt)),Re.set(nt.$Ghc,this.b);const st=this.B(new T.$Zq(tt));Re.set(E.$0k,st);const pt=this.B(new F.$qr(tt));st.registerProvider(N.Schemas.file,pt);const dt=new qe.$Rs(st);Re.set(Ue.$Hl,dt);const rt=this.B(new Te.$xR(this.f.profiles.all,O.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(fe.$Jl,rt);const wt=this.B(new je.$Ygc(N.Schemas.file,this.B(new Be.$_Q(Ge.getChannel(Be.$$Q),{pathCaseSensitive:He.$l})),N.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(N.Schemas.vscodeUserData,wt);const ct=this.B(new m.$Uo(rt.defaultProfile.settingsResource,st,et,tt));Re.set(P.$9i,ct);const bt=new jt.$Nhc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Re.set(ce.$fq,bt),this.B((0,A.$Rc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Ct.$as(Ge.getChannel("request"));Re.set(ne.$5p,It),Re.set(g.$jhc,new U.$zi(w.$khc,void 0,!1)),Re.set(We.$NG,new U.$zi(ze.$whc,void 0,!1));const Rt=new Dt.$3gc(-1,Ge);Re.set(Nt.$Hfc,Rt),Re.set(i.$Yo,new U.$zi(s.$FR,void 0,!0));const Gt=this.B(new de.$rgc(Rt)),Kt=new R.$ki(Ze=>Gt.getActiveClientId().then(mt=>Ze===mt));Re.set(v.$I6b,new Tt.$Jhc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,J.$Gp)(De,ct);if((0,J.$Bp)(De,Xe)){const Ze=new B.$ldc(tt,ot,Xe,De);if(lt.push(Ze),!(0,J.$Cp)(De,Xe)&&De.aiConfig?.ariaKey){const mt=new Me.$eR(It,Pt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,A.$Rc)(()=>mt.flush())),lt.push(mt)}gt=new D.$es({appenders:lt,commonProperties:(0,te.$sp)((0,I.release)(),(0,I.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,J.$Hp)(Xe)},ct,De)}else{gt=J.$wp;const Ze=J.$Ap;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new G.$9fc(lt)),Re.set(Y.$9l,gt);const Jt=new q.$lhc(ct,gt,tt,ot,Xe,De);Re.set(Y.$0l,Jt),Re.set($e.$Gq,new U.$zi(Lt.$pR,void 0,!0)),Re.set(Ce.$Kq,new U.$zi(se.$vgc,void 0,!0)),Re.set(u.$qq,new U.$zi(u.$sq,void 0,!0)),Re.set(C.$Vq,new U.$zi(C.$Wq,void 0,!0)),Re.set(a.$ip,new U.$zi(r.$oq,void 0,!0)),Re.set(a.$pp,new U.$zi(Ft.$Mhc,void 0,!1)),Re.set(x.$9r,new U.$zi(H.$$r,void 0,!1)),Re.set(o.$Qm,new U.$zi(h.$Ys,void 0,!1)),Re.set(X.$_Lb,new U.$zi(X.$aMb,void 0,!0)),Re.set(ee.$Gnb,new U.$zi(ge.$FOb,void 0,!0)),Re.set(ee.$Fnb,R.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Re.set(a.$op,new U.$zi(n.$0Lb,void 0,!1)),Re.set(Z.$DOb,new U.$zi(Z.$EOb,void 0,!0)),Re.set(M.$nw,new U.$zi(M.$ow)),Re.set(ee.$qnb,new U.$zi(Se.$KNb,void 0,!0)),Re.set(ee.$rnb,new U.$zi(Se.$MNb,void 0,!0)),Re.set(pe.$dnb,new U.$zi(pe.$fnb,void 0,!0)),Re.set(ee.$snb,new U.$zi(re.$1dc,void 0,!1)),Re.set(ee.$Bnb,new U.$zi(Ee.$Pdc,void 0,!0)),Re.set(ee.$Cnb,new U.$zi(we.$6dc,void 0,!1)),Re.set(Ie.$LMb,new U.$zi(ae.$shc,void 0,!0)),Re.set(ee.$Dnb,new U.$zi(Ye.$Jec,void 0,!0)),Re.set(me.$Wl,new U.$zi(Pe.$Vgc,void 0,!1));const kt=new vt.$Ul;return Re.set(vt.$Tl,kt),kt.register(Mt.RemoteConnectionType.WebSocket,qt.$Ohc),Re.set(Oe.$Cw,new U.$zi(Fe.$Tgc)),Re.set(Ne.$thc,new U.$zi(Le.$vhc)),Re.set(Je.$yhc,new U.$zi(at.$Ihc)),new K.$tr(Re)}j(Re){const De=new y.$uq(Re.get(a.$lp),()=>null);this.a.registerChannel("extensions",De);const Ke=R.ProxyChannel.fromService(Re.get(x.$9r),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=R.ProxyChannel.fromService(Re.get(o.$Qm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new y.$wq(Re.get(a.$pp));this.a.registerChannel("extensionTipsService",et);const Xe=R.ProxyChannel.fromService(Re.get(g.$jhc),this.q);this.a.registerChannel("checksum",Xe);const ot=R.ProxyChannel.fromService(Re.get(We.$NG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=R.ProxyChannel.fromService(Re.get(pe.$dnb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=R.ProxyChannel.fromService(Re.get(Y.$0l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new le.$mhc(Re.get(X.$_Lb));this.a.registerChannel("userDataSyncAccount",tt);const st=new le.$ohc(Re.get(ee.$qnb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$qhc(Re.get(ee.$Cnb),Re.get(fe.$Jl),Re.get(ie.$0j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(j.$Bi).createInstance(Ut.$Lhc));this.a.registerChannel("userDataAutoSync",R.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",R.ProxyChannel.fromService(Re.get(ee.$Dnb),this.q));const rt=R.ProxyChannel.fromService(Re.get(Ne.$thc),this.q);this.a.registerChannel(Ne.$uhc,rt);const wt=R.ProxyChannel.fromService(Re.get(Je.$yhc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",De=>(0,L.$Y)(De)),process.on("unhandledRejection",De=>(0,L.$Y)(De)),(0,L.setUnexpectedErrorHandler)(De=>{const Ke=(0,c.$nj)(De,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,De){Re.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Re,De){if(He.$l){const[Ke,Ge]=await Promise.all([(0,zt.$Zg)(De.error.bind(De)),(0,Et.$wX)(De.error.bind(De))]),et=(0,Wt.$aX)(),Xe=(0,Et.$xX)(Ge,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$6fc.response)return!1;const De=(0,k.$Nb)(Re.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$4fc.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$4fc.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/19fa52145f34c62a9b743d33279cfc8cc0552fea/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
